function X2JS(config){"use strict";function getNodeLocalName(node){var nodeLocalName=node.localName;return null==nodeLocalName&&(nodeLocalName=node.baseName),null!=nodeLocalName&&""!=nodeLocalName||(nodeLocalName=node.nodeName),nodeLocalName}function getNodePrefix(node){return node.prefix}function escapeXmlChars(str){return"string"==typeof str?str.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#x27;").replace(/\//g,"&#x2F;"):str}function unescapeXmlChars(str){return str.replace(/&amp;/g,"&").replace(/&lt;/g,"<").replace(/&gt;/g,">").replace(/&quot;/g,'"').replace(/&#x27;/g,"'").replace(/&#x2F;/g,"/")}function toArrayAccessForm(obj,childName,path){switch(config.arrayAccessForm){case"property":obj[childName]instanceof Array?obj[childName+"_asArray"]=obj[childName]:obj[childName+"_asArray"]=[obj[childName]]}if(!(obj[childName]instanceof Array)&&config.arrayAccessFormPaths.length>0){for(var idx=0;idx<config.arrayAccessFormPaths.length;idx++){var arrayPath=config.arrayAccessFormPaths[idx];if("string"==typeof arrayPath){if(arrayPath==path)break}else if(arrayPath instanceof RegExp){if(arrayPath.test(path))break}else if("function"==typeof arrayPath&&arrayPath(obj,childName,path))break}idx!=config.arrayAccessFormPaths.length&&(obj[childName]=[obj[childName]])}}function fromXmlDateTime(prop){var bits=prop.split(/[-T:+Z]/g),d=new Date(bits[0],bits[1]-1,bits[2]),secondBits=bits[5].split(".");if(d.setHours(bits[3],bits[4],secondBits[0]),secondBits.length>1&&d.setMilliseconds(secondBits[1]),bits[6]&&bits[7]){var offsetMinutes=60*bits[6]+Number(bits[7]);offsetMinutes=0+("-"==(/\d\d-\d\d:\d\d$/.test(prop)?"-":"+")?-1*offsetMinutes:offsetMinutes),d.setMinutes(d.getMinutes()-offsetMinutes-d.getTimezoneOffset())}else-1!==prop.indexOf("Z",prop.length-1)&&(d=new Date(Date.UTC(d.getFullYear(),d.getMonth(),d.getDate(),d.getHours(),d.getMinutes(),d.getSeconds(),d.getMilliseconds())));return d}function checkFromXmlDateTimePaths(value,childName,fullPath){if(config.datetimeAccessFormPaths.length>0){for(var path=fullPath.split(".#")[0],idx=0;idx<config.datetimeAccessFormPaths.length;idx++){var dtPath=config.datetimeAccessFormPaths[idx];if("string"==typeof dtPath){if(dtPath==path)break}else if(dtPath instanceof RegExp){if(dtPath.test(path))break}else if("function"==typeof dtPath&&dtPath(obj,childName,path))break}return idx!=config.datetimeAccessFormPaths.length?fromXmlDateTime(value):value}return value}function parseDOMChildren(node,path){if(node.nodeType==DOMNodeTypes.DOCUMENT_NODE){for(var result=new Object,nodeChildren=node.childNodes,cidx=0;cidx<nodeChildren.length;cidx++)(child=nodeChildren.item(cidx)).nodeType==DOMNodeTypes.ELEMENT_NODE&&(result[childName=getNodeLocalName(child)]=parseDOMChildren(child,childName));return result}if(node.nodeType==DOMNodeTypes.ELEMENT_NODE){(result=new Object).__cnt=0;for(var nodeChildren=node.childNodes,cidx=0;cidx<nodeChildren.length;cidx++){var child=nodeChildren.item(cidx),childName=getNodeLocalName(child);child.nodeType!=DOMNodeTypes.COMMENT_NODE&&(result.__cnt++,null==result[childName]?(result[childName]=parseDOMChildren(child,path+"."+childName),toArrayAccessForm(result,childName,path+"."+childName)):(null!=result[childName]&&(result[childName]instanceof Array||(result[childName]=[result[childName]],toArrayAccessForm(result,childName,path+"."+childName))),result[childName][result[childName].length]=parseDOMChildren(child,path+"."+childName)))}for(var aidx=0;aidx<node.attributes.length;aidx++){var attr=node.attributes.item(aidx);result.__cnt++,result[config.attributePrefix+attr.name]=attr.value}var nodePrefix=getNodePrefix(node);return null!=nodePrefix&&""!=nodePrefix&&(result.__cnt++,result.__prefix=nodePrefix),null!=result["#text"]&&(result.__text=result["#text"],result.__text instanceof Array&&(result.__text=result.__text.join("\n")),config.escapeMode&&(result.__text=unescapeXmlChars(result.__text)),config.stripWhitespaces&&(result.__text=result.__text.trim()),delete result["#text"],"property"==config.arrayAccessForm&&delete result["#text_asArray"],result.__text=checkFromXmlDateTimePaths(result.__text,childName,path+"."+childName)),null!=result["#cdata-section"]&&(result.__cdata=result["#cdata-section"],delete result["#cdata-section"],"property"==config.arrayAccessForm&&delete result["#cdata-section_asArray"]),1==result.__cnt&&null!=result.__text?result=result.__text:0==result.__cnt&&"text"==config.emptyNodeForm?result="":result.__cnt>1&&null!=result.__text&&config.skipEmptyTextNodesForObj&&(config.stripWhitespaces&&""==result.__text||""==result.__text.trim())&&delete result.__text,delete result.__cnt,!config.enableToStringFunc||null==result.__text&&null==result.__cdata||(result.toString=function(){return(null!=this.__text?this.__text:"")+(null!=this.__cdata?this.__cdata:"")}),result}if(node.nodeType==DOMNodeTypes.TEXT_NODE||node.nodeType==DOMNodeTypes.CDATA_SECTION_NODE)return node.nodeValue}function startTag(jsonObj,element,attrList,closed){var resultStr="<"+(null!=jsonObj&&null!=jsonObj.__prefix?jsonObj.__prefix+":":"")+element;if(null!=attrList)for(var aidx=0;aidx<attrList.length;aidx++){var attrName=attrList[aidx],attrVal=jsonObj[attrName];config.escapeMode&&(attrVal=escapeXmlChars(attrVal)),resultStr+=" "+attrName.substr(config.attributePrefix.length)+"='"+attrVal+"'"}return resultStr+=closed?"/>":">"}function endTag(jsonObj,elementName){return"</"+(null!=jsonObj.__prefix?jsonObj.__prefix+":":"")+elementName+">"}function endsWith(str,suffix){return-1!==str.indexOf(suffix,str.length-suffix.length)}function jsonXmlSpecialElem(jsonObj,jsonObjField){return!!("property"==config.arrayAccessForm&&endsWith(jsonObjField.toString(),"_asArray")||0==jsonObjField.toString().indexOf(config.attributePrefix)||0==jsonObjField.toString().indexOf("__")||jsonObj[jsonObjField]instanceof Function)}function jsonXmlElemCount(jsonObj){var elementsCnt=0;if(jsonObj instanceof Object)for(var it in jsonObj)jsonXmlSpecialElem(jsonObj,it)||elementsCnt++;return elementsCnt}function parseJSONAttributes(jsonObj){var attrList=[];if(jsonObj instanceof Object)for(var ait in jsonObj)-1==ait.toString().indexOf("__")&&0==ait.toString().indexOf(config.attributePrefix)&&attrList.push(ait);return attrList}function parseJSONTextAttrs(jsonTxtObj){var result="";return null!=jsonTxtObj.__cdata&&(result+="<![CDATA["+jsonTxtObj.__cdata+"]]>"),null!=jsonTxtObj.__text&&(config.escapeMode?result+=escapeXmlChars(jsonTxtObj.__text):result+=jsonTxtObj.__text),result}function parseJSONTextObject(jsonTxtObj){var result="";return jsonTxtObj instanceof Object?result+=parseJSONTextAttrs(jsonTxtObj):null!=jsonTxtObj&&(config.escapeMode?result+=escapeXmlChars(jsonTxtObj):result+=jsonTxtObj),result}function parseJSONArray(jsonArrRoot,jsonArrObj,attrList){var result="";if(0==jsonArrRoot.length)result+=startTag(jsonArrRoot,jsonArrObj,attrList,!0);else for(var arIdx=0;arIdx<jsonArrRoot.length;arIdx++)result+=startTag(jsonArrRoot[arIdx],jsonArrObj,parseJSONAttributes(jsonArrRoot[arIdx]),!1),result+=parseJSONObject(jsonArrRoot[arIdx]),result+=endTag(jsonArrRoot[arIdx],jsonArrObj);return result}function parseJSONObject(jsonObj){var result="";if(jsonXmlElemCount(jsonObj)>0)for(var it in jsonObj)if(!jsonXmlSpecialElem(jsonObj,it)){var subObj=jsonObj[it],attrList=parseJSONAttributes(subObj);null==subObj||void 0==subObj?result+=startTag(subObj,it,attrList,!0):subObj instanceof Object?subObj instanceof Array?result+=parseJSONArray(subObj,it,attrList):subObj instanceof Date?(result+=startTag(subObj,it,attrList,!1),result+=subObj.toISOString(),result+=endTag(subObj,it)):jsonXmlElemCount(subObj)>0||null!=subObj.__text||null!=subObj.__cdata?(result+=startTag(subObj,it,attrList,!1),result+=parseJSONObject(subObj),result+=endTag(subObj,it)):result+=startTag(subObj,it,attrList,!0):(result+=startTag(subObj,it,attrList,!1),result+=parseJSONTextObject(subObj),result+=endTag(subObj,it))}return result+=parseJSONTextObject(jsonObj)}void 0===(config=config||{}).escapeMode&&(config.escapeMode=!0),config.attributePrefix=config.attributePrefix||"_",config.arrayAccessForm=config.arrayAccessForm||"none",config.emptyNodeForm=config.emptyNodeForm||"text",void 0===config.enableToStringFunc&&(config.enableToStringFunc=!0),config.arrayAccessFormPaths=config.arrayAccessFormPaths||[],void 0===config.skipEmptyTextNodesForObj&&(config.skipEmptyTextNodesForObj=!0),void 0===config.stripWhitespaces&&(config.stripWhitespaces=!0),config.datetimeAccessFormPaths=config.datetimeAccessFormPaths||[],function(){function pad(number){var r=String(number);return 1===r.length&&(r="0"+r),r}"function"!=typeof String.prototype.trim&&(String.prototype.trim=function(){return this.replace(/^\s+|^\n+|(\s|\n)+$/g,"")}),"function"!=typeof Date.prototype.toISOString&&(Date.prototype.toISOString=function(){return this.getUTCFullYear()+"-"+pad(this.getUTCMonth()+1)+"-"+pad(this.getUTCDate())+"T"+pad(this.getUTCHours())+":"+pad(this.getUTCMinutes())+":"+pad(this.getUTCSeconds())+"."+String((this.getUTCMilliseconds()/1e3).toFixed(3)).slice(2,5)+"Z"})}();var DOMNodeTypes={ELEMENT_NODE:1,TEXT_NODE:3,CDATA_SECTION_NODE:4,COMMENT_NODE:8,DOCUMENT_NODE:9};this.parseXmlString=function(xmlDocStr){var isIEParser=window.ActiveXObject||"ActiveXObject"in window;if(void 0===xmlDocStr)return null;var xmlDoc;if(window.DOMParser){var parser=new window.DOMParser,parsererrorNS=null;if(!isIEParser)try{parsererrorNS=parser.parseFromString("INVALID","text/xml").childNodes[0].namespaceURI}catch(err){parsererrorNS=null}try{xmlDoc=parser.parseFromString(xmlDocStr,"text/xml"),null!=parsererrorNS&&xmlDoc.getElementsByTagNameNS(parsererrorNS,"parsererror").length>0&&(xmlDoc=null)}catch(err){xmlDoc=null}}else 0==xmlDocStr.indexOf("<?")&&(xmlDocStr=xmlDocStr.substr(xmlDocStr.indexOf("?>")+2)),(xmlDoc=new ActiveXObject("Microsoft.XMLDOM")).async="false",xmlDoc.loadXML(xmlDocStr);return xmlDoc},this.asArray=function(prop){return prop instanceof Array?prop:[prop]},this.toXmlDateTime=function(dt){return dt instanceof Date?dt.toISOString():"number"==typeof dt?new Date(dt).toISOString():null},this.asDateTime=function(prop){return"string"==typeof prop?fromXmlDateTime(prop):prop},this.xml2json=function(xmlDoc){return parseDOMChildren(xmlDoc)},this.xml_str2json=function(xmlDocStr){var xmlDoc=this.parseXmlString(xmlDocStr);return null!=xmlDoc?this.xml2json(xmlDoc):null},this.json2xml_str=function(jsonObj){return parseJSONObject(jsonObj)},this.json2xml=function(jsonObj){var xmlDocStr=this.json2xml_str(jsonObj);return this.parseXmlString(xmlDocStr)},this.getVersion=function(){return"1.1.5"}}function isEmptyObject(e){var t;for(t in e)return!1;return!0}function emptyObject(e){var t;for(t in e)delete e[t]}function isArray(o){return"[object Array]"===Object.prototype.toString.call(o)}!function(){function tapEventListener(type,enable,useCapture){!1!==enable?tapDoc.addEventListener(type,tapEventListeners[type],useCapture):tapDoc.removeEventListener(type,tapEventListeners[type])}function tapClick(e){var ele=tapTargetElement(tapContainingElement(e.target));if(ionic.tap.requiresNativeClick(ele)||tapPointerMoved)return!1;var c=ionic.tap.pointerCoord(e);triggerMouseEvent("click",ele,c.x,c.y),tapHandleFocus(ele)}function triggerMouseEvent(type,ele,x,y){var clickEvent=document.createEvent("MouseEvents");clickEvent.initMouseEvent(type,!0,!0,window,1,0,0,x,y,!1,!1,!1,!1,0,null),clickEvent.isIonicTap=!0,ele.dispatchEvent(clickEvent)}function tapTouchStart(e){tapIgnoreEvent(e)||(tapPointerMoved=!1,tapEnableTouchEvents(),tapPointerStart=ionic.tap.pointerCoord(e),tapEventListener(tapTouchMoveListener),ionic.activator.start(e),ionic.Platform.isIOS()&&ionic.tap.isLabelWithTextInput(e.target)&&tapTargetElement(tapContainingElement(e.target))!==tapActiveEle&&e.preventDefault())}function tapTouchEnd(e){tapIgnoreEvent(e)||(tapEnableTouchEvents(),tapHasPointerMoved(e)||(tapClick(e),isSelectOrOption(e.target.tagName)&&e.preventDefault()),tapLastTouchTarget=e.target,tapTouchCancel())}function tapTouchMove(e){if(tapHasPointerMoved(e))return tapPointerMoved=!0,tapEventListener(tapTouchMoveListener,!1),ionic.activator.end(),!1}function tapTouchCancel(){tapEventListener(tapTouchMoveListener,!1),ionic.activator.end(),tapPointerMoved=!1}function tapEnableTouchEvents(){tapEnabledTouchEvents=!0,clearTimeout(tapMouseResetTimer),tapMouseResetTimer=setTimeout(function(){tapEnabledTouchEvents=!1},600)}function tapIgnoreEvent(e){return!!e.isTapHandled||(e.isTapHandled=!0,!!ionic.tap.isElementTapDisabled(e.target)||(ionic.scroll.isScrolling&&ionic.tap.containsOrIsTextInput(e.target)?(e.preventDefault(),!0):void 0))}function tapHandleFocus(ele){tapTouchFocusedInput=null;var triggerFocusIn=!1;"SELECT"==ele.tagName?(triggerMouseEvent("mousedown",ele,0,0),ele.focus&&ele.focus(),triggerFocusIn=!0):tapActiveElement()===ele?triggerFocusIn=!0:/^(input|textarea|ion-label)$/i.test(ele.tagName)||ele.isContentEditable?(triggerFocusIn=!0,ele.focus&&ele.focus(),ele.value=ele.value,tapEnabledTouchEvents&&(tapTouchFocusedInput=ele)):tapFocusOutActive(),triggerFocusIn&&(tapActiveElement(ele),ionic.trigger("ionic.focusin",{target:ele},!0))}function tapFocusOutActive(){var ele=tapActiveElement();ele&&(/^(input|textarea|select)$/i.test(ele.tagName)||ele.isContentEditable)&&ele.blur(),tapActiveElement(null)}function tapActiveElement(ele){return arguments.length&&(tapActiveEle=ele),tapActiveEle||document.activeElement}function tapHasPointerMoved(endEvent){if(!endEvent||1!==endEvent.target.nodeType||!tapPointerStart||0===tapPointerStart.x&&0===tapPointerStart.y)return!1;var endCoordinates=ionic.tap.pointerCoord(endEvent),releaseTolerance=!(!endEvent.target.classList||!endEvent.target.classList.contains||"function"!=typeof endEvent.target.classList.contains)&&endEvent.target.classList.contains("button")?TAP_RELEASE_BUTTON_TOLERANCE:TAP_RELEASE_TOLERANCE;return Math.abs(tapPointerStart.x-endCoordinates.x)>releaseTolerance||Math.abs(tapPointerStart.y-endCoordinates.y)>releaseTolerance}function tapContainingElement(ele,allowSelf){for(var climbEle=ele,x=0;x<6&&climbEle;x++){if("LABEL"===climbEle.tagName)return climbEle;climbEle=climbEle.parentElement}if(!1!==allowSelf)return ele}function tapTargetElement(ele){if(ele&&"LABEL"===ele.tagName){if(ele.control)return ele.control;if(ele.querySelector){var control=ele.querySelector("input,textarea,select");if(control)return control}}return ele}function isSelectOrOption(tagName){return/^(select|option)$/i.test(tagName)}function keyboardInit(){ionic.keyboard.isInitialized||(keyboardHasPlugin()?(window.addEventListener("native.keyboardshow",debouncedKeyboardNativeShow),window.addEventListener("native.keyboardhide",keyboardFocusOut)):document.body.addEventListener("focusout",keyboardFocusOut),document.body.addEventListener("ionic.focusin",debouncedKeyboardFocusIn),document.body.addEventListener("focusin",debouncedKeyboardFocusIn),window.navigator.msPointerEnabled?document.removeEventListener("MSPointerDown",keyboardInit):document.removeEventListener("touchstart",keyboardInit),ionic.keyboard.isInitialized=!0)}function keyboardFocusOut(){clearTimeout(keyboardFocusOutTimer),(ionic.keyboard.isOpen||ionic.keyboard.isOpening)&&(ionic.keyboard.isClosing=!0,ionic.keyboard.isOpening=!1),keyboardFocusOutTimer=setTimeout(function(){ionic.requestAnimationFrame(function(){wasOrientationChange?keyboardWaitForResize(function(){keyboardUpdateViewportHeight(),keyboardHide()},!1):keyboardWaitForResize(keyboardHide,!1)})},50)}function keyboardOrientationChange(){ionic.keyboard.isLandscape=!ionic.keyboard.isLandscape,ionic.Platform.isIOS()&&keyboardUpdateViewportHeight(),ionic.Platform.isAndroid()&&(ionic.keyboard.isOpen&&keyboardHasPlugin()?wasOrientationChange=!0:keyboardWaitForResize(keyboardUpdateViewportHeight,!1))}function keyboardOnKeyDown(e){ionic.scroll.isScrolling&&keyboardPreventDefault(e)}function keyboardPreventDefault(e){"TEXTAREA"!==e.target.tagName&&e.preventDefault()}function keyboardWaitForResize(callback,isOpening){clearInterval(waitForResizeTimer);var maxCount,count=0,initialHeight=getViewportHeight(),viewportHeight=initialHeight;return maxCount=ionic.Platform.isAndroid()&&ionic.Platform.version()<4.4?30:ionic.Platform.isAndroid()?10:1,waitForResizeTimer=setInterval(function(){viewportHeight=getViewportHeight(),++count<maxCount&&(!isPortraitViewportHeight(viewportHeight)&&!isLandscapeViewportHeight(viewportHeight)||!ionic.keyboard.height)||(keyboardHasPlugin()||(ionic.keyboard.height=Math.abs(initialHeight-window.innerHeight)),ionic.keyboard.isOpen=isOpening,clearInterval(waitForResizeTimer),callback())},50),maxCount}function keyboardHide(){clearTimeout(keyboardFocusOutTimer),ionic.keyboard.isOpen=!1,ionic.keyboard.isClosing=!1,(keyboardActiveElement||lastKeyboardActiveElement)&&ionic.trigger("resetScrollView",{target:keyboardActiveElement||lastKeyboardActiveElement},!0),ionic.requestAnimationFrame(function(){document.body.classList.remove(KEYBOARD_OPEN_CSS)}),window.navigator.msPointerEnabled?document.removeEventListener("MSPointerMove",keyboardPreventDefault):document.removeEventListener("touchmove",keyboardPreventDefault),document.removeEventListener("keydown",keyboardOnKeyDown),ionic.Platform.isAndroid()&&(keyboardHasPlugin()&&cordova.plugins.Keyboard.close(),keyboardActiveElement&&keyboardActiveElement.blur()),keyboardActiveElement=null,lastKeyboardActiveElement=null}function keyboardShow(){ionic.keyboard.isOpen=!0,ionic.keyboard.isOpening=!1;var details={keyboardHeight:keyboardGetHeight(),viewportHeight:keyboardCurrentViewportHeight};if(keyboardActiveElement){details.target=keyboardActiveElement;var elementBounds=keyboardActiveElement.getBoundingClientRect();details.elementTop=Math.round(elementBounds.top),details.elementBottom=Math.round(elementBounds.bottom),details.windowHeight=details.viewportHeight-details.keyboardHeight,details.isElementUnderKeyboard=details.elementBottom>details.windowHeight,ionic.trigger("scrollChildIntoView",details,!0)}return setTimeout(function(){document.body.classList.add(KEYBOARD_OPEN_CSS)},400),details}function keyboardGetHeight(){if(ionic.keyboard.height)return ionic.keyboard.height;if(ionic.Platform.isAndroid()){if(ionic.Platform.isFullScreen)return 275;var contentHeight=window.innerHeight;return contentHeight<keyboardCurrentViewportHeight?keyboardCurrentViewportHeight-contentHeight:0}return ionic.Platform.isIOS()?ionic.keyboard.isLandscape?206:ionic.Platform.isWebView()?260:216:275}function isPortraitViewportHeight(viewportHeight){return!!(!ionic.keyboard.isLandscape&&keyboardPortraitViewportHeight&&Math.abs(keyboardPortraitViewportHeight-viewportHeight)<2)}function isLandscapeViewportHeight(viewportHeight){return!!(ionic.keyboard.isLandscape&&keyboardLandscapeViewportHeight&&Math.abs(keyboardLandscapeViewportHeight-viewportHeight)<2)}function keyboardUpdateViewportHeight(){wasOrientationChange=!1,keyboardCurrentViewportHeight=getViewportHeight(),ionic.keyboard.isLandscape&&!keyboardLandscapeViewportHeight?keyboardLandscapeViewportHeight=keyboardCurrentViewportHeight:ionic.keyboard.isLandscape||keyboardPortraitViewportHeight||(keyboardPortraitViewportHeight=keyboardCurrentViewportHeight),keyboardActiveElement&&ionic.trigger("resetScrollView",{target:keyboardActiveElement},!0),ionic.keyboard.isOpen&&ionic.tap.isTextInput(keyboardActiveElement)&&keyboardShow()}function keyboardInitViewportHeight(){var viewportHeight=getViewportHeight();viewportHeight/window.innerWidth<1&&(ionic.keyboard.isLandscape=!0),keyboardCurrentViewportHeight=viewportHeight,ionic.keyboard.isLandscape&&!keyboardLandscapeViewportHeight?keyboardLandscapeViewportHeight=keyboardCurrentViewportHeight:ionic.keyboard.isLandscape||keyboardPortraitViewportHeight||(keyboardPortraitViewportHeight=keyboardCurrentViewportHeight)}function getViewportHeight(){var windowHeight=window.innerHeight;return ionic.Platform.isAndroid()&&ionic.Platform.isFullScreen||!ionic.keyboard.isOpen&&!ionic.keyboard.isOpening||ionic.keyboard.isClosing?windowHeight:windowHeight+keyboardGetHeight()}function keyboardHasPlugin(){return!!(window.cordova&&cordova.plugins&&cordova.plugins.Keyboard)}function viewportLoadTag(){var x;for(x=0;x<document.head.children.length;x++)if("viewport"==document.head.children[x].name){viewportTag=document.head.children[x];break}if(viewportTag){var keyValue,props=viewportTag.content.toLowerCase().replace(/\s+/g,"").split(",");for(x=0;x<props.length;x++)props[x]&&(keyValue=props[x].split("="),viewportProperties[keyValue[0]]=keyValue.length>1?keyValue[1]:"_");viewportUpdate()}}function viewportUpdate(){var initWidth=viewportProperties.width,initHeight=viewportProperties.height,p=ionic.Platform,version=p.version(),orientation=ionic.viewport.orientation();delete viewportProperties.height,viewportProperties.width="device-width",p.isIPad()?version>7?delete viewportProperties.width:p.isWebView()?90==orientation?viewportProperties.height="0":7==version&&(viewportProperties.height="device-height"):version<7&&(viewportProperties.height="0"):p.isIOS()&&(p.isWebView()?version>7?delete viewportProperties.width:version<7?initHeight&&(viewportProperties.height="0"):7==version&&(viewportProperties.height="device-height"):version<7&&initHeight&&(viewportProperties.height="0")),initWidth===viewportProperties.width&&initHeight===viewportProperties.height||viewportTagUpdate()}function viewportTagUpdate(){var key,props=[];for(key in viewportProperties)viewportProperties[key]&&props.push(key+("_"==viewportProperties[key]?"":"="+viewportProperties[key]));viewportTag.content=props.join(", ")}window.ionic=window.ionic||{},window.ionic.views={},window.ionic.version="1.2.4",window.ionic.DelegateService=function(methodNames){function trueFn(){return!0}if(methodNames.indexOf("$getByHandle")>-1)throw new Error("Method '$getByHandle' is implicitly added to each delegate service. Do not list it as a method.");return["$log",function($log){function DelegateInstance(instances,handle){this._instances=instances,this.handle=handle}function DelegateService(){this._instances=[]}function instanceMethodCaller(methodName){return function(){var returnValue,handle=this.handle,args=arguments,foundInstancesCount=0;return this._instances.forEach(function(instance){if((!handle||handle==instance.$$delegateHandle)&&instance.$$filterFn(instance)){foundInstancesCount++;var ret=instance[methodName].apply(instance,args);1===foundInstancesCount&&(returnValue=ret)}}),!foundInstancesCount&&handle?$log.warn('Delegate for handle "'+handle+'" could not find a corresponding element with delegate-handle="'+handle+'"! '+methodName+"() was not called!\nPossible cause: If you are calling "+methodName+'() immediately, and your element with delegate-handle="'+handle+'" is a child of your controller, then your element may not be compiled yet. Put a $timeout around your call to '+methodName+"() and try again."):returnValue}}return methodNames.forEach(function(methodName){DelegateInstance.prototype[methodName]=instanceMethodCaller(methodName)}),DelegateService.prototype=DelegateInstance.prototype,DelegateService.prototype._registerInstance=function(instance,handle,filterFn){var instances=this._instances;return instance.$$delegateHandle=handle,instance.$$filterFn=filterFn||trueFn,instances.push(instance),function(){var index=instances.indexOf(instance);-1!==index&&instances.splice(index,1)}},DelegateService.prototype.$getByHandle=function(handle){return new DelegateInstance(this._instances,handle)},new DelegateService}]},function(window,document,ionic){function domReady(){isDomReady=!0;for(var x=0;x<readyCallbacks.length;x++)ionic.requestAnimationFrame(readyCallbacks[x]);readyCallbacks=[],document.removeEventListener("DOMContentLoaded",domReady)}var readyCallbacks=[],isDomReady="complete"===document.readyState||"interactive"===document.readyState;isDomReady||document.addEventListener("DOMContentLoaded",domReady),window._rAF=window.requestAnimationFrame||window.webkitRequestAnimationFrame||window.mozRequestAnimationFrame||function(callback){window.setTimeout(callback,16)};var cancelAnimationFrame=window.cancelAnimationFrame||window.webkitCancelAnimationFrame||window.mozCancelAnimationFrame||window.webkitCancelRequestAnimationFrame;ionic.DomUtil={requestAnimationFrame:function(cb){return window._rAF(cb)},cancelAnimationFrame:function(requestId){cancelAnimationFrame(requestId)},animationFrameThrottle:function(cb){var args,isQueued,context;return function(){args=arguments,context=this,isQueued||(isQueued=!0,ionic.requestAnimationFrame(function(){cb.apply(context,args),isQueued=!1}))}},contains:function(parentNode,otherNode){for(var current=otherNode;current;){if(current===parentNode)return!0;current=current.parentNode}},getPositionInParent:function(el){return{left:el.offsetLeft,top:el.offsetTop}},getOffsetTop:function(el){var curtop=0;if(el.offsetParent){do{curtop+=el.offsetTop,el=el.offsetParent}while(el);return curtop}},ready:function(cb){isDomReady?ionic.requestAnimationFrame(cb):readyCallbacks.push(cb)},getTextBounds:function(textNode){if(document.createRange){var range=document.createRange();if(range.selectNodeContents(textNode),range.getBoundingClientRect){var rect=range.getBoundingClientRect();if(rect){var sx=window.scrollX,sy=window.scrollY;return{top:rect.top+sy,left:rect.left+sx,right:rect.left+sx+rect.width,bottom:rect.top+sy+rect.height,width:rect.width,height:rect.height}}}}return null},getChildIndex:function(element,type){if(type)for(var c,ch=element.parentNode.children,i=0,k=0,j=ch.length;i<j;i++)if((c=ch[i]).nodeName&&c.nodeName.toLowerCase()==type){if(c==element)return k;k++}return Array.prototype.slice.call(element.parentNode.children).indexOf(element)},swapNodes:function(src,dest){dest.parentNode.insertBefore(src,dest)},elementIsDescendant:function(el,parent,stopAt){var current=el;do{if(current===parent)return!0;current=current.parentNode}while(current&&current!==stopAt);return!1},getParentWithClass:function(e,className,depth){for(depth=depth||10;e.parentNode&&depth--;){if(e.parentNode.classList&&e.parentNode.classList.contains(className))return e.parentNode;e=e.parentNode}return null},getParentOrSelfWithClass:function(e,className,depth){for(depth=depth||10;e&&depth--;){if(e.classList&&e.classList.contains(className))return e;e=e.parentNode}return null},rectContains:function(x,y,x1,y1,x2,y2){return!(x<x1||x>x2)&&!(y<y1||y>y2)},blurAll:function(){return document.activeElement&&document.activeElement!=document.body?(document.activeElement.blur(),document.activeElement):null},cachedAttr:function(ele,key,value){if((ele=ele&&ele.length&&ele[0]||ele)&&ele.setAttribute){var dataKey="$attr-"+key;return arguments.length>2?ele[dataKey]!==value&&(ele.setAttribute(key,value),ele[dataKey]=value):void 0===ele[dataKey]&&(ele[dataKey]=ele.getAttribute(key)),ele[dataKey]}},cachedStyles:function(ele,styles){if((ele=ele&&ele.length&&ele[0]||ele)&&ele.style)for(var prop in styles)ele["$style-"+prop]!==styles[prop]&&(ele.style[prop]=ele["$style-"+prop]=styles[prop])}},ionic.requestAnimationFrame=ionic.DomUtil.requestAnimationFrame,ionic.cancelAnimationFrame=ionic.DomUtil.cancelAnimationFrame,ionic.animationFrameThrottle=ionic.DomUtil.animationFrameThrottle}(window,document,ionic),function(ionic){ionic.CustomEvent=function(){if("function"==typeof window.CustomEvent)return CustomEvent;var customEvent=function(event,params){var evt;params=params||{bubbles:!1,cancelable:!1,detail:void 0};try{(evt=document.createEvent("CustomEvent")).initCustomEvent(event,params.bubbles,params.cancelable,params.detail)}catch(error){evt=document.createEvent("Event");for(var param in params)evt[param]=params[param];evt.initEvent(event,params.bubbles,params.cancelable)}return evt};return customEvent.prototype=window.Event.prototype,customEvent}(),ionic.EventController={VIRTUALIZED_EVENTS:["tap","swipe","swiperight","swipeleft","drag","hold","release"],trigger:function(eventType,data,bubbles,cancelable){var event=new ionic.CustomEvent(eventType,{detail:data,bubbles:!!bubbles,cancelable:!!cancelable});data&&data.target&&data.target.dispatchEvent&&data.target.dispatchEvent(event)||window.dispatchEvent(event)},on:function(type,callback,element){for(var e=element||window,i=0,j=this.VIRTUALIZED_EVENTS.length;i<j;i++)if(type==this.VIRTUALIZED_EVENTS[i]){var gesture=new ionic.Gesture(element);return gesture.on(type,callback),gesture}e.addEventListener(type,callback)},off:function(type,callback,element){element.removeEventListener(type,callback)},onGesture:function(type,callback,element,options){var gesture=new ionic.Gesture(element,options);return gesture.on(type,callback),gesture},offGesture:function(gesture,type,callback){gesture&&gesture.off(type,callback)},handlePopState:function(){}},ionic.on=function(){ionic.EventController.on.apply(ionic.EventController,arguments)},ionic.off=function(){ionic.EventController.off.apply(ionic.EventController,arguments)},ionic.trigger=ionic.EventController.trigger,ionic.onGesture=function(){return ionic.EventController.onGesture.apply(ionic.EventController.onGesture,arguments)},ionic.offGesture=function(){return ionic.EventController.offGesture.apply(ionic.EventController.offGesture,arguments)}}(window.ionic),function(ionic){function setup(){if(!ionic.Gestures.READY){ionic.Gestures.event.determineEventTypes();for(var name in ionic.Gestures.gestures)ionic.Gestures.gestures.hasOwnProperty(name)&&ionic.Gestures.detection.register(ionic.Gestures.gestures[name]);ionic.Gestures.event.onTouch(ionic.Gestures.DOCUMENT,ionic.Gestures.EVENT_MOVE,ionic.Gestures.detection.detect),ionic.Gestures.event.onTouch(ionic.Gestures.DOCUMENT,ionic.Gestures.EVENT_END,ionic.Gestures.detection.detect),ionic.Gestures.READY=!0}}ionic.Gesture=function(element,options){return new ionic.Gestures.Instance(element,options||{})},ionic.Gestures={},ionic.Gestures.defaults={stop_browser_behavior:"disable-user-behavior"},ionic.Gestures.HAS_POINTEREVENTS=window.navigator.pointerEnabled||window.navigator.msPointerEnabled,ionic.Gestures.HAS_TOUCHEVENTS="ontouchstart"in window,ionic.Gestures.MOBILE_REGEX=/mobile|tablet|ip(ad|hone|od)|android|silk/i,ionic.Gestures.NO_MOUSEEVENTS=ionic.Gestures.HAS_TOUCHEVENTS&&window.navigator.userAgent.match(ionic.Gestures.MOBILE_REGEX),ionic.Gestures.EVENT_TYPES={},ionic.Gestures.DIRECTION_DOWN="down",ionic.Gestures.DIRECTION_LEFT="left",ionic.Gestures.DIRECTION_UP="up",ionic.Gestures.DIRECTION_RIGHT="right",ionic.Gestures.POINTER_MOUSE="mouse",ionic.Gestures.POINTER_TOUCH="touch",ionic.Gestures.POINTER_PEN="pen",ionic.Gestures.EVENT_START="start",ionic.Gestures.EVENT_MOVE="move",ionic.Gestures.EVENT_END="end",ionic.Gestures.DOCUMENT=window.document,ionic.Gestures.plugins={},ionic.Gestures.READY=!1,ionic.Gestures.Instance=function(element,options){var self=this;return null===element?this:(setup(),this.element=element,this.enabled=!0,this.options=ionic.Gestures.utils.extend(ionic.Gestures.utils.extend({},ionic.Gestures.defaults),options||{}),this.options.stop_browser_behavior&&ionic.Gestures.utils.stopDefaultBrowserBehavior(this.element,this.options.stop_browser_behavior),ionic.Gestures.event.onTouch(element,ionic.Gestures.EVENT_START,function(ev){self.enabled&&ionic.Gestures.detection.startDetect(self,ev)}),this)},ionic.Gestures.Instance.prototype={on:function(gesture,handler){for(var gestures=gesture.split(" "),t=0;t<gestures.length;t++)this.element.addEventListener(gestures[t],handler,!1);return this},off:function(gesture,handler){for(var gestures=gesture.split(" "),t=0;t<gestures.length;t++)this.element.removeEventListener(gestures[t],handler,!1);return this},trigger:function(gesture,eventData){var event=ionic.Gestures.DOCUMENT.createEvent("Event");event.initEvent(gesture,!0,!0),event.gesture=eventData;var element=this.element;return ionic.Gestures.utils.hasParent(eventData.target,element)&&(element=eventData.target),element.dispatchEvent(event),this},enable:function(state){return this.enabled=state,this}};var last_move_event=null,enable_detect=!1,touch_triggered=!1;ionic.Gestures.event={bindDom:function(element,type,handler){for(var types=type.split(" "),t=0;t<types.length;t++)element.addEventListener(types[t],handler,!1)},onTouch:function(element,eventType,handler){var self=this;this.bindDom(element,ionic.Gestures.EVENT_TYPES[eventType],function(ev){var sourceEventType=ev.type.toLowerCase();if(!sourceEventType.match(/mouse/)||!touch_triggered){sourceEventType.match(/touch/)||sourceEventType.match(/pointerdown/)||sourceEventType.match(/mouse/)&&1===ev.which?enable_detect=!0:sourceEventType.match(/mouse/)&&1!==ev.which&&(enable_detect=!1),sourceEventType.match(/touch|pointer/)&&(touch_triggered=!0);var count_touches=0;enable_detect&&(ionic.Gestures.HAS_POINTEREVENTS&&eventType!=ionic.Gestures.EVENT_END?count_touches=ionic.Gestures.PointerEvent.updatePointer(eventType,ev):sourceEventType.match(/touch/)?count_touches=ev.touches.length:touch_triggered||(count_touches=sourceEventType.match(/up/)?0:1),count_touches>0&&eventType==ionic.Gestures.EVENT_END?eventType=ionic.Gestures.EVENT_MOVE:count_touches||(eventType=ionic.Gestures.EVENT_END),(count_touches||null===last_move_event)&&(last_move_event=ev),handler.call(ionic.Gestures.detection,self.collectEventData(element,eventType,self.getTouchList(last_move_event,eventType),ev)),ionic.Gestures.HAS_POINTEREVENTS&&eventType==ionic.Gestures.EVENT_END&&(count_touches=ionic.Gestures.PointerEvent.updatePointer(eventType,ev))),count_touches||(last_move_event=null,enable_detect=!1,touch_triggered=!1,ionic.Gestures.PointerEvent.reset())}})},determineEventTypes:function(){var types;types=ionic.Gestures.HAS_POINTEREVENTS?ionic.Gestures.PointerEvent.getEvents():ionic.Gestures.NO_MOUSEEVENTS?["touchstart","touchmove","touchend touchcancel"]:["touchstart mousedown","touchmove mousemove","touchend touchcancel mouseup"],ionic.Gestures.EVENT_TYPES[ionic.Gestures.EVENT_START]=types[0],ionic.Gestures.EVENT_TYPES[ionic.Gestures.EVENT_MOVE]=types[1],ionic.Gestures.EVENT_TYPES[ionic.Gestures.EVENT_END]=types[2]},getTouchList:function(ev){return ionic.Gestures.HAS_POINTEREVENTS?ionic.Gestures.PointerEvent.getTouchList():ev.touches?ev.touches:(ev.identifier=1,[ev])},collectEventData:function(element,eventType,touches,ev){var pointerType=ionic.Gestures.POINTER_TOUCH;return(ev.type.match(/mouse/)||ionic.Gestures.PointerEvent.matchType(ionic.Gestures.POINTER_MOUSE,ev))&&(pointerType=ionic.Gestures.POINTER_MOUSE),{center:ionic.Gestures.utils.getCenter(touches),timeStamp:(new Date).getTime(),target:ev.target,touches:touches,eventType:eventType,pointerType:pointerType,srcEvent:ev,preventDefault:function(){this.srcEvent.preventManipulation&&this.srcEvent.preventManipulation(),this.srcEvent.preventDefault},stopPropagation:function(){this.srcEvent.stopPropagation()},stopDetect:function(){return ionic.Gestures.detection.stopDetect()}}}},ionic.Gestures.PointerEvent={pointers:{},getTouchList:function(){var self=this,touchlist=[];return Object.keys(self.pointers).sort().forEach(function(id){touchlist.push(self.pointers[id])}),touchlist},updatePointer:function(type,pointerEvent){return type==ionic.Gestures.EVENT_END?this.pointers={}:(pointerEvent.identifier=pointerEvent.pointerId,this.pointers[pointerEvent.pointerId]=pointerEvent),Object.keys(this.pointers).length},matchType:function(pointerType,ev){if(!ev.pointerType)return!1;var types={};return types[ionic.Gestures.POINTER_MOUSE]=ev.pointerType==ev.MSPOINTER_TYPE_MOUSE||ev.pointerType==ionic.Gestures.POINTER_MOUSE,types[ionic.Gestures.POINTER_TOUCH]=ev.pointerType==ev.MSPOINTER_TYPE_TOUCH||ev.pointerType==ionic.Gestures.POINTER_TOUCH,types[ionic.Gestures.POINTER_PEN]=ev.pointerType==ev.MSPOINTER_TYPE_PEN||ev.pointerType==ionic.Gestures.POINTER_PEN,types[pointerType]},getEvents:function(){return["pointerdown MSPointerDown","pointermove MSPointerMove","pointerup pointercancel MSPointerUp MSPointerCancel"]},reset:function(){this.pointers={}}},ionic.Gestures.utils={extend:function(dest,src,merge){for(var key in src)void 0!==dest[key]&&merge||(dest[key]=src[key]);return dest},hasParent:function(node,parent){for(;node;){if(node==parent)return!0;node=node.parentNode}return!1},getCenter:function(touches){for(var valuesX=[],valuesY=[],t=0,len=touches.length;t<len;t++)valuesX.push(touches[t].pageX),valuesY.push(touches[t].pageY);return{pageX:(Math.min.apply(Math,valuesX)+Math.max.apply(Math,valuesX))/2,pageY:(Math.min.apply(Math,valuesY)+Math.max.apply(Math,valuesY))/2}},getVelocity:function(delta_time,delta_x,delta_y){return{x:Math.abs(delta_x/delta_time)||0,y:Math.abs(delta_y/delta_time)||0}},getAngle:function(touch1,touch2){var y=touch2.pageY-touch1.pageY,x=touch2.pageX-touch1.pageX;return 180*Math.atan2(y,x)/Math.PI},getDirection:function(touch1,touch2){return Math.abs(touch1.pageX-touch2.pageX)>=Math.abs(touch1.pageY-touch2.pageY)?touch1.pageX-touch2.pageX>0?ionic.Gestures.DIRECTION_LEFT:ionic.Gestures.DIRECTION_RIGHT:touch1.pageY-touch2.pageY>0?ionic.Gestures.DIRECTION_UP:ionic.Gestures.DIRECTION_DOWN},getDistance:function(touch1,touch2){var x=touch2.pageX-touch1.pageX,y=touch2.pageY-touch1.pageY;return Math.sqrt(x*x+y*y)},getScale:function(start,end){return start.length>=2&&end.length>=2?this.getDistance(end[0],end[1])/this.getDistance(start[0],start[1]):1},getRotation:function(start,end){return start.length>=2&&end.length>=2?this.getAngle(end[1],end[0])-this.getAngle(start[1],start[0]):0},isVertical:function(direction){return direction==ionic.Gestures.DIRECTION_UP||direction==ionic.Gestures.DIRECTION_DOWN},stopDefaultBrowserBehavior:function(element,css_class){element&&element.classList&&(element.classList.add(css_class),element.onselectstart=function(){return!1})}},ionic.Gestures.detection={gestures:[],current:null,previous:null,stopped:!1,startDetect:function(inst,eventData){this.current||(this.stopped=!1,this.current={inst:inst,startEvent:ionic.Gestures.utils.extend({},eventData),lastEvent:!1,name:""},this.detect(eventData))},detect:function(eventData){if(!this.current||this.stopped)return null;eventData=this.extendEventData(eventData);for(var inst_options=this.current.inst.options,g=0,len=this.gestures.length;g<len;g++){var gesture=this.gestures[g];if(!this.stopped&&!1!==inst_options[gesture.name]&&!1===gesture.handler.call(gesture,eventData,this.current.inst)){this.stopDetect();break}}return this.current&&(this.current.lastEvent=eventData),eventData.eventType==ionic.Gestures.EVENT_END&&!eventData.touches.length-1&&this.stopDetect(),eventData},stopDetect:function(){this.previous=ionic.Gestures.utils.extend({},this.current),this.current=null,this.stopped=!0},extendEventData:function(ev){var startEv=this.current.startEvent;if(startEv&&(ev.touches.length!=startEv.touches.length||ev.touches===startEv.touches)){startEv.touches=[];for(var i=0,len=ev.touches.length;i<len;i++)startEv.touches.push(ionic.Gestures.utils.extend({},ev.touches[i]))}var delta_time=ev.timeStamp-startEv.timeStamp,delta_x=ev.center.pageX-startEv.center.pageX,delta_y=ev.center.pageY-startEv.center.pageY,velocity=ionic.Gestures.utils.getVelocity(delta_time,delta_x,delta_y);return ionic.Gestures.utils.extend(ev,{deltaTime:delta_time,deltaX:delta_x,deltaY:delta_y,velocityX:velocity.x,velocityY:velocity.y,distance:ionic.Gestures.utils.getDistance(startEv.center,ev.center),angle:ionic.Gestures.utils.getAngle(startEv.center,ev.center),direction:ionic.Gestures.utils.getDirection(startEv.center,ev.center),scale:ionic.Gestures.utils.getScale(startEv.touches,ev.touches),rotation:ionic.Gestures.utils.getRotation(startEv.touches,ev.touches),startEvent:startEv}),ev},register:function(gesture){var options=gesture.defaults||{};return void 0===options[gesture.name]&&(options[gesture.name]=!0),ionic.Gestures.utils.extend(ionic.Gestures.defaults,options,!0),gesture.index=gesture.index||1e3,this.gestures.push(gesture),this.gestures.sort(function(a,b){return a.index<b.index?-1:a.index>b.index?1:0}),this.gestures}},ionic.Gestures.gestures=ionic.Gestures.gestures||{},ionic.Gestures.gestures.Hold={name:"hold",index:10,defaults:{hold_timeout:500,hold_threshold:9},timer:null,handler:function(ev,inst){switch(ev.eventType){case ionic.Gestures.EVENT_START:clearTimeout(this.timer),ionic.Gestures.detection.current.name=this.name,this.timer=setTimeout(function(){"hold"==ionic.Gestures.detection.current.name&&(ionic.tap.cancelClick(),inst.trigger("hold",ev))},inst.options.hold_timeout);break;case ionic.Gestures.EVENT_MOVE:ev.distance>inst.options.hold_threshold&&clearTimeout(this.timer);break;case ionic.Gestures.EVENT_END:clearTimeout(this.timer)}}},ionic.Gestures.gestures.Tap={name:"tap",index:100,defaults:{tap_max_touchtime:250,tap_max_distance:10,tap_always:!0,doubletap_distance:20,doubletap_interval:300},handler:function(ev,inst){if(ev.eventType==ionic.Gestures.EVENT_END&&"touchcancel"!=ev.srcEvent.type){var prev=ionic.Gestures.detection.previous,did_doubletap=!1;if(ev.deltaTime>inst.options.tap_max_touchtime||ev.distance>inst.options.tap_max_distance)return;prev&&"tap"==prev.name&&ev.timeStamp-prev.lastEvent.timeStamp<inst.options.doubletap_interval&&ev.distance<inst.options.doubletap_distance&&(inst.trigger("doubletap",ev),did_doubletap=!0),did_doubletap&&!inst.options.tap_always||(ionic.Gestures.detection.current.name="tap",inst.trigger("tap",ev))}}},ionic.Gestures.gestures.Swipe={name:"swipe",index:40,defaults:{swipe_max_touches:1,swipe_velocity:.4},handler:function(ev,inst){if(ev.eventType==ionic.Gestures.EVENT_END){if(inst.options.swipe_max_touches>0&&ev.touches.length>inst.options.swipe_max_touches)return;(ev.velocityX>inst.options.swipe_velocity||ev.velocityY>inst.options.swipe_velocity)&&(inst.trigger(this.name,ev),inst.trigger(this.name+ev.direction,ev))}}},ionic.Gestures.gestures.Drag={name:"drag",index:50,defaults:{drag_min_distance:10,correct_for_drag_min_distance:!0,drag_max_touches:1,drag_block_horizontal:!0,drag_block_vertical:!0,drag_lock_to_axis:!1,drag_lock_min_distance:25,prevent_default_directions:[]},triggered:!1,handler:function(ev,inst){if("touchstart"==ev.srcEvent.type||"touchend"==ev.srcEvent.type?this.preventedFirstMove=!1:this.preventedFirstMove||"touchmove"!=ev.srcEvent.type||(inst.options.prevent_default_directions.length>0&&-1!=inst.options.prevent_default_directions.indexOf(ev.direction)&&ev.srcEvent.preventDefault(),this.preventedFirstMove=!0),ionic.Gestures.detection.current.name!=this.name&&this.triggered)return inst.trigger(this.name+"end",ev),void(this.triggered=!1);if(!(inst.options.drag_max_touches>0&&ev.touches.length>inst.options.drag_max_touches))switch(ev.eventType){case ionic.Gestures.EVENT_START:this.triggered=!1;break;case ionic.Gestures.EVENT_MOVE:if(ev.distance<inst.options.drag_min_distance&&ionic.Gestures.detection.current.name!=this.name)return;if(ionic.Gestures.detection.current.name!=this.name&&(ionic.Gestures.detection.current.name=this.name,inst.options.correct_for_drag_min_distance)){var factor=Math.abs(inst.options.drag_min_distance/ev.distance);ionic.Gestures.detection.current.startEvent.center.pageX+=ev.deltaX*factor,ionic.Gestures.detection.current.startEvent.center.pageY+=ev.deltaY*factor,ev=ionic.Gestures.detection.extendEventData(ev)}(ionic.Gestures.detection.current.lastEvent.drag_locked_to_axis||inst.options.drag_lock_to_axis&&inst.options.drag_lock_min_distance<=ev.distance)&&(ev.drag_locked_to_axis=!0);var last_direction=ionic.Gestures.detection.current.lastEvent.direction;ev.drag_locked_to_axis&&last_direction!==ev.direction&&(ionic.Gestures.utils.isVertical(last_direction)?ev.direction=ev.deltaY<0?ionic.Gestures.DIRECTION_UP:ionic.Gestures.DIRECTION_DOWN:ev.direction=ev.deltaX<0?ionic.Gestures.DIRECTION_LEFT:ionic.Gestures.DIRECTION_RIGHT),this.triggered||(inst.trigger(this.name+"start",ev),this.triggered=!0),inst.trigger(this.name,ev),inst.trigger(this.name+ev.direction,ev),(inst.options.drag_block_vertical&&ionic.Gestures.utils.isVertical(ev.direction)||inst.options.drag_block_horizontal&&!ionic.Gestures.utils.isVertical(ev.direction))&&ev.preventDefault();break;case ionic.Gestures.EVENT_END:this.triggered&&inst.trigger(this.name+"end",ev),this.triggered=!1}}},ionic.Gestures.gestures.Transform={name:"transform",index:45,defaults:{transform_min_scale:.01,transform_min_rotation:1,transform_always_block:!1},triggered:!1,handler:function(ev,inst){if(ionic.Gestures.detection.current.name!=this.name&&this.triggered)return inst.trigger(this.name+"end",ev),void(this.triggered=!1);if(!(ev.touches.length<2))switch(inst.options.transform_always_block&&ev.preventDefault(),ev.eventType){case ionic.Gestures.EVENT_START:this.triggered=!1;break;case ionic.Gestures.EVENT_MOVE:var scale_threshold=Math.abs(1-ev.scale),rotation_threshold=Math.abs(ev.rotation);if(scale_threshold<inst.options.transform_min_scale&&rotation_threshold<inst.options.transform_min_rotation)return;ionic.Gestures.detection.current.name=this.name,this.triggered||(inst.trigger(this.name+"start",ev),this.triggered=!0),inst.trigger(this.name,ev),rotation_threshold>inst.options.transform_min_rotation&&inst.trigger("rotate",ev),scale_threshold>inst.options.transform_min_scale&&(inst.trigger("pinch",ev),inst.trigger("pinch"+(ev.scale<1?"in":"out"),ev));break;case ionic.Gestures.EVENT_END:this.triggered&&inst.trigger(this.name+"end",ev),this.triggered=!1}}},ionic.Gestures.gestures.Touch={name:"touch",index:-1/0,defaults:{prevent_default:!1,prevent_mouseevents:!1},handler:function(ev,inst){inst.options.prevent_mouseevents&&ev.pointerType==ionic.Gestures.POINTER_MOUSE?ev.stopDetect():(inst.options.prevent_default&&ev.preventDefault(),ev.eventType==ionic.Gestures.EVENT_START&&inst.trigger(this.name,ev))}},ionic.Gestures.gestures.Release={name:"release",index:1/0,handler:function(ev,inst){ev.eventType==ionic.Gestures.EVENT_END&&inst.trigger(this.name,ev)}}}(window.ionic),function(window,document,ionic){function getParameterByName(name){name=name.replace(/[\[]/,"\\[").replace(/[\]]/,"\\]");var results=new RegExp("[\\?&]"+name+"=([^&#]*)").exec(location.search);return null===results?"":decodeURIComponent(results[1].replace(/\+/g," "))}function onWindowLoad(){self.isWebView()?document.addEventListener("deviceready",onPlatformReady,!1):onPlatformReady(),windowLoadListenderAttached&&window.removeEventListener("load",onWindowLoad,!1)}function onPlatformReady(){self.isReady=!0,self.detect();for(var x=0;x<readyCallbacks.length;x++)readyCallbacks[x]();readyCallbacks=[],ionic.trigger("platformready",{target:document}),requestAnimationFrame(function(){document.body.classList.add("platform-ready")})}var windowLoadListenderAttached,requestAnimationFrame=ionic.requestAnimationFrame,self=ionic.Platform={navigator:window.navigator,isReady:!1,isFullScreen:!1,platforms:null,grade:null,ua:navigator.userAgent,ready:function(cb){self.isReady?cb():readyCallbacks.push(cb)},detect:function(){self._checkPlatforms(),requestAnimationFrame(function(){for(var i=0;i<self.platforms.length;i++)document.body.classList.add("platform-"+self.platforms[i])})},setGrade:function(grade){var oldGrade=self.grade;self.grade=grade,requestAnimationFrame(function(){oldGrade&&document.body.classList.remove("grade-"+oldGrade),document.body.classList.add("grade-"+grade)})},device:function(){return window.device||{}},_checkPlatforms:function(){self.platforms=[];var grade="a";self.isWebView()?(self.platforms.push("webview"),window.cordova||window.PhoneGap||window.phonegap?self.platforms.push("cordova"):window.forge&&self.platforms.push("trigger")):self.platforms.push("browser"),self.isIPad()&&self.platforms.push("ipad");var platform=self.platform();if(platform){self.platforms.push(platform);var version=self.version();if(version){var v=version.toString();v.indexOf(".")>0?v=v.replace(".","_"):v+="_0",self.platforms.push(platform+v.split("_")[0]),self.platforms.push(platform+v),self.isAndroid()&&version<4.4?grade=version<4?"c":"b":self.isWindowsPhone()&&(grade="b")}}self.setGrade(grade)},isWebView:function(){return!!(window.cordova||window.PhoneGap||window.phonegap||window.forge)},isIPad:function(){return!!/iPad/i.test(self.navigator.platform)||/iPad/i.test(self.ua)},isIOS:function(){return self.is("ios")},isAndroid:function(){return self.is("android")},isWindowsPhone:function(){return self.is("windowsphone")},isEdge:function(){return self.is("edge")},isCrosswalk:function(){return self.is("crosswalk")},platform:function(){return null===platformName&&self.setPlatform(self.device().platform),platformName},setPlatform:function(n){platformName=void 0!==n&&null!==n&&n.length?n.toLowerCase():getParameterByName("ionicplatform")?getParameterByName("ionicplatform"):self.ua.indexOf("Edge")>-1?"edge":self.ua.indexOf("Windows Phone")>-1?"windowsphone":self.ua.indexOf("Android")>0?"android":/iPhone|iPad|iPod/.test(self.ua)?"ios":self.navigator.platform&&navigator.platform.toLowerCase().split(" ")[0]||""},version:function(){return null===platformVersion&&self.setVersion(self.device().version),platformVersion},setVersion:function(v){if(void 0===v||null===v||(v=v.split("."),v=parseFloat(v[0]+"."+(v.length>1?v[1]:0)),isNaN(v))){platformVersion=0;var pName=self.platform(),versionMatch={android:/Android (\d+).(\d+)?/,ios:/OS (\d+)_(\d+)?/,windowsphone:/Windows Phone (\d+).(\d+)?/};versionMatch[pName]&&(v=self.ua.match(versionMatch[pName]))&&v.length>2&&(platformVersion=parseFloat(v[1]+"."+v[2]))}else platformVersion=v},is:function(type){if(type=type.toLowerCase(),self.platforms)for(var x=0;x<self.platforms.length;x++)if(self.platforms[x]===type)return!0;var pName=self.platform();return pName?pName===type.toLowerCase():self.ua.toLowerCase().indexOf(type)>=0},exitApp:function(){self.ready(function(){navigator.app&&navigator.app.exitApp&&navigator.app.exitApp()})},showStatusBar:function(val){self._showStatusBar=val,self.ready(function(){requestAnimationFrame(function(){self._showStatusBar?(window.StatusBar&&window.StatusBar.show(),document.body.classList.remove("status-bar-hide")):(window.StatusBar&&window.StatusBar.hide(),document.body.classList.add("status-bar-hide"))})})},fullScreen:function(showFullScreen,showStatusBar){self.isFullScreen=!1!==showFullScreen,ionic.DomUtil.ready(function(){requestAnimationFrame(function(){self.isFullScreen?document.body.classList.add("fullscreen"):document.body.classList.remove("fullscreen")}),self.showStatusBar(!0===showStatusBar)})}},platformName=null,platformVersion=null,readyCallbacks=[],platformReadyTimer=2e3;setTimeout(function(){!self.isReady&&self.isWebView()},platformReadyTimer),"complete"===document.readyState?onWindowLoad():(windowLoadListenderAttached=!0,window.addEventListener("load",onWindowLoad,!1))}(window,document,ionic),function(document,ionic){"use strict";ionic.CSS={},ionic.CSS.TRANSITION=[],ionic.CSS.TRANSFORM=[],ionic.EVENTS={},function(){var i,keys=["webkitTransform","transform","-webkit-transform","webkit-transform","-moz-transform","moz-transform","MozTransform","mozTransform","msTransform"];for(i=0;i<keys.length;i++)if(void 0!==document.documentElement.style[keys[i]]){ionic.CSS.TRANSFORM=keys[i];break}for(keys=["webkitTransition","mozTransition","msTransition","transition"],i=0;i<keys.length;i++)if(void 0!==document.documentElement.style[keys[i]]){ionic.CSS.TRANSITION=keys[i];break}ionic.CSS.TRANSITION=ionic.CSS.TRANSITION||"transition";var isWebkit=ionic.CSS.TRANSITION.indexOf("webkit")>-1;ionic.CSS.TRANSITION_DURATION=(isWebkit?"-webkit-":"")+"transition-duration",ionic.CSS.TRANSITIONEND=(isWebkit?"webkitTransitionEnd ":"")+"transitionend"}(),function(){var touchStartEvent="touchstart",touchMoveEvent="touchmove",touchEndEvent="touchend",touchCancelEvent="touchcancel";window.navigator.pointerEnabled?(touchStartEvent="pointerdown",touchMoveEvent="pointermove",touchEndEvent="pointerup",touchCancelEvent="pointercancel"):window.navigator.msPointerEnabled&&(touchStartEvent="MSPointerDown",touchMoveEvent="MSPointerMove",touchEndEvent="MSPointerUp",touchCancelEvent="MSPointerCancel"),ionic.EVENTS.touchstart=touchStartEvent,ionic.EVENTS.touchmove=touchMoveEvent,ionic.EVENTS.touchend=touchEndEvent,ionic.EVENTS.touchcancel=touchCancelEvent}(),"classList"in document.documentElement||!Object.defineProperty||"undefined"==typeof HTMLElement||Object.defineProperty(HTMLElement.prototype,"classList",{get:function(){function update(fn){return function(){var x,classes=self.className.split(/\s+/);for(x=0;x<arguments.length;x++)fn(classes,classes.indexOf(arguments[x]),arguments[x]);self.className=classes.join(" ")}}var self=this;return{add:update(function(classes,index,value){~index||classes.push(value)}),remove:update(function(classes,index){~index&&classes.splice(index,1)}),toggle:update(function(classes,index,value){~index?classes.splice(index,1):classes.push(value)}),contains:function(value){return!!~self.className.split(/\s+/).indexOf(value)},item:function(i){return self.className.split(/\s+/)[i]||null}}}})}(document,ionic);var tapDoc,tapActiveEle,tapEnabledTouchEvents,tapMouseResetTimer,tapPointerMoved,tapPointerStart,tapTouchFocusedInput,tapLastTouchTarget,tapTouchMoveListener="touchmove",TAP_RELEASE_TOLERANCE=12,TAP_RELEASE_BUTTON_TOLERANCE=50,tapEventListeners={click:function(e){return"submit"==e.target.type&&0===e.detail?null:ionic.scroll.isScrolling&&ionic.tap.containsOrIsTextInput(e.target)||!e.isIonicTap&&!ionic.tap.requiresNativeClick(e.target)?(e.stopPropagation(),ionic.tap.isLabelWithTextInput(e.target)||e.preventDefault(),!1):void 0},mousedown:function(e){return e.isIonicTap||tapIgnoreEvent(e)?null:tapEnabledTouchEvents?(e.stopPropagation(),ionic.Platform.isEdge()||ionic.tap.isTextInput(e.target)&&tapLastTouchTarget===e.target||isSelectOrOption(e.target.tagName)||ionic.tap.isVideo(e.target)||e.preventDefault(),!1):(tapPointerMoved=!1,tapPointerStart=ionic.tap.pointerCoord(e),tapEventListener("mousemove"),void ionic.activator.start(e))},mouseup:function(e){return tapEnabledTouchEvents?(e.stopPropagation(),e.preventDefault(),!1):!tapIgnoreEvent(e)&&!isSelectOrOption(e.target.tagName)&&(tapHasPointerMoved(e)||tapClick(e),tapEventListener("mousemove",!1),ionic.activator.end(),void(tapPointerMoved=!1))},mousemove:function(e){if(tapHasPointerMoved(e))return tapEventListener("mousemove",!1),ionic.activator.end(),tapPointerMoved=!0,!1},touchstart:tapTouchStart,touchend:tapTouchEnd,touchcancel:tapTouchCancel,touchmove:tapTouchMove,pointerdown:tapTouchStart,pointerup:tapTouchEnd,pointercancel:tapTouchCancel,pointermove:tapTouchMove,MSPointerDown:tapTouchStart,MSPointerUp:tapTouchEnd,MSPointerCancel:tapTouchCancel,MSPointerMove:tapTouchMove,focusin:function(e){tapEnabledTouchEvents&&ionic.tap.isTextInput(tapActiveElement())&&ionic.tap.isTextInput(tapTouchFocusedInput)&&tapTouchFocusedInput!==e.target&&(tapTouchFocusedInput.focus(),tapTouchFocusedInput=null),ionic.scroll.isScrolling=!1},focusout:function(){tapActiveElement(null)}};ionic.tap={register:function(ele){return tapDoc=ele,tapEventListener("click",!0,!0),tapEventListener("mouseup"),tapEventListener("mousedown"),window.navigator.pointerEnabled?(tapEventListener("pointerdown"),tapEventListener("pointerup"),tapEventListener("pointercancel"),tapTouchMoveListener="pointermove"):window.navigator.msPointerEnabled?(tapEventListener("MSPointerDown"),tapEventListener("MSPointerUp"),tapEventListener("MSPointerCancel"),tapTouchMoveListener="MSPointerMove"):(tapEventListener("touchstart"),tapEventListener("touchend"),tapEventListener("touchcancel")),tapEventListener("focusin"),tapEventListener("focusout"),function(){for(var type in tapEventListeners)tapEventListener(type,!1);tapDoc=null,tapActiveEle=null,tapEnabledTouchEvents=!1,tapPointerMoved=!1,tapPointerStart=null}},ignoreScrollStart:function(e){return e.defaultPrevented||/^(file|range)$/i.test(e.target.type)||"true"==(e.target.dataset?e.target.dataset.preventScroll:e.target.getAttribute("data-prevent-scroll"))||!!/^(object|embed)$/i.test(e.target.tagName)||ionic.tap.isElementTapDisabled(e.target)},isTextInput:function(ele){return!!ele&&("TEXTAREA"==ele.tagName||"true"===ele.contentEditable||"INPUT"==ele.tagName&&!/^(radio|checkbox|range|file|submit|reset|color|image|button)$/i.test(ele.type))},isDateInput:function(ele){return!!ele&&"INPUT"==ele.tagName&&/^(date|time|datetime-local|month|week)$/i.test(ele.type)},isVideo:function(ele){return!!ele&&"VIDEO"==ele.tagName},isKeyboardElement:function(ele){return!ionic.Platform.isIOS()||ionic.Platform.isIPad()?ionic.tap.isTextInput(ele)&&!ionic.tap.isDateInput(ele):ionic.tap.isTextInput(ele)||!!ele&&"SELECT"==ele.tagName},isLabelWithTextInput:function(ele){var container=tapContainingElement(ele,!1);return!!container&&ionic.tap.isTextInput(tapTargetElement(container))},containsOrIsTextInput:function(ele){return ionic.tap.isTextInput(ele)||ionic.tap.isLabelWithTextInput(ele)},cloneFocusedInput:function(container){ionic.tap.hasCheckedClone||(ionic.tap.hasCheckedClone=!0,ionic.requestAnimationFrame(function(){var focusInput=container.querySelector(":focus");if(ionic.tap.isTextInput(focusInput)&&!ionic.tap.isDateInput(focusInput)){var clonedInput=focusInput.cloneNode(!0);clonedInput.value=focusInput.value,clonedInput.classList.add("cloned-text-input"),clonedInput.readOnly=!0,focusInput.isContentEditable&&(clonedInput.contentEditable=focusInput.contentEditable,clonedInput.innerHTML=focusInput.innerHTML),focusInput.parentElement.insertBefore(clonedInput,focusInput),focusInput.classList.add("previous-input-focus"),clonedInput.scrollTop=focusInput.scrollTop}}))},hasCheckedClone:!1,removeClonedInputs:function(container){ionic.tap.hasCheckedClone=!1,ionic.requestAnimationFrame(function(){var x,clonedInputs=container.querySelectorAll(".cloned-text-input"),previousInputFocus=container.querySelectorAll(".previous-input-focus");for(x=0;x<clonedInputs.length;x++)clonedInputs[x].parentElement.removeChild(clonedInputs[x]);for(x=0;x<previousInputFocus.length;x++)previousInputFocus[x].classList.remove("previous-input-focus"),previousInputFocus[x].style.top="",ionic.keyboard.isOpen&&!ionic.keyboard.isClosing&&previousInputFocus[x].focus()})},requiresNativeClick:function(ele){return!(!ionic.Platform.isWindowsPhone()||"A"!=ele.tagName&&"BUTTON"!=ele.tagName&&!ele.hasAttribute("ng-click")&&("INPUT"!=ele.tagName||"button"!=ele.type&&"submit"!=ele.type))||(!!(!ele||ele.disabled||/^(file|range)$/i.test(ele.type)||/^(object|video)$/i.test(ele.tagName)||ionic.tap.isLabelContainingFileInput(ele))||ionic.tap.isElementTapDisabled(ele))},isLabelContainingFileInput:function(ele){var lbl=tapContainingElement(ele);if("LABEL"!==lbl.tagName)return!1;var fileInput=lbl.querySelector("input[type=file]");return!(!fileInput||!1!==fileInput.disabled)},isElementTapDisabled:function(ele){if(ele&&1===ele.nodeType)for(var element=ele;element;){if("true"==(element.dataset?element.dataset.tapDisabled:element.getAttribute&&element.getAttribute("data-tap-disabled")))return!0;element=element.parentElement}return!1},setTolerance:function(releaseTolerance,releaseButtonTolerance){TAP_RELEASE_TOLERANCE=releaseTolerance,TAP_RELEASE_BUTTON_TOLERANCE=releaseButtonTolerance},cancelClick:function(){tapPointerMoved=!0},pointerCoord:function(event){var c={x:0,y:0};if(event){var touches=event.touches&&event.touches.length?event.touches:[event],e=event.changedTouches&&event.changedTouches[0]||touches[0];e&&(c.x=e.clientX||e.pageX||0,c.y=e.clientY||e.pageY||0)}return c}},ionic.DomUtil.ready(function(){var ng="undefined"!=typeof angular?angular:null;(!ng||ng&&!ng.scenario)&&ionic.tap.register(document)}),function(document,ionic){"use strict";function clear(){queueElements={},ionic.requestAnimationFrame(deactivateElements)}function activateElements(){for(var key in queueElements)queueElements[key]&&(queueElements[key].classList.add(ACTIVATED_CLASS),activeElements[key]=queueElements[key]);queueElements={}}function deactivateElements(){if(ionic.transition&&ionic.transition.isActive)setTimeout(deactivateElements,400);else for(var key in activeElements)activeElements[key]&&(activeElements[key].classList.remove(ACTIVATED_CLASS),delete activeElements[key])}var queueElements={},activeElements={},keyId=0,ACTIVATED_CLASS="activated";ionic.activator={start:function(e){var hitX=ionic.tap.pointerCoord(e).x;hitX>0&&hitX<30||ionic.requestAnimationFrame(function(){if(!(ionic.scroll&&ionic.scroll.isScrolling||ionic.tap.requiresNativeClick(e.target))){for(var eleToActivate,ele=e.target,x=0;x<6&&(ele&&1===ele.nodeType);x++){if(eleToActivate&&ele.classList&&ele.classList.contains("item")){eleToActivate=ele;break}if("A"==ele.tagName||"BUTTON"==ele.tagName||ele.hasAttribute("ng-click")){eleToActivate=ele;break}if(ele.classList.contains("button")){eleToActivate=ele;break}if("ION-CONTENT"==ele.tagName||ele.classList&&ele.classList.contains("pane")||"BODY"==ele.tagName)break;ele=ele.parentElement}eleToActivate&&(queueElements[keyId]=eleToActivate,ionic.requestAnimationFrame(activateElements),keyId=keyId>29?0:keyId+1)}})},end:function(){setTimeout(clear,200)}}}(document,ionic),function(ionic){var nextId=0;ionic.Utils={arrayMove:function(arr,oldIndex,newIndex){if(newIndex>=arr.length)for(var k=newIndex-arr.length;1+k--;)arr.push(void 0);return arr.splice(newIndex,0,arr.splice(oldIndex,1)[0]),arr},proxy:function(func,context){var args=Array.prototype.slice.call(arguments,2);return function(){return func.apply(context,args.concat(Array.prototype.slice.call(arguments)))}},debounce:function(func,wait,immediate){var timeout,args,context,timestamp,result;return function(){context=this,args=arguments,timestamp=new Date;var later=function(){var last=new Date-timestamp;last<wait?timeout=setTimeout(later,wait-last):(timeout=null,immediate||(result=func.apply(context,args)))},callNow=immediate&&!timeout;return timeout||(timeout=setTimeout(later,wait)),callNow&&(result=func.apply(context,args)),result}},throttle:function(func,wait,options){var context,args,result,timeout=null,previous=0;options||(options={});var later=function(){previous=!1===options.leading?0:Date.now(),timeout=null,result=func.apply(context,args)};return function(){var now=Date.now();previous||!1!==options.leading||(previous=now);var remaining=wait-(now-previous);return context=this,args=arguments,remaining<=0?(clearTimeout(timeout),timeout=null,previous=now,result=func.apply(context,args)):timeout||!1===options.trailing||(timeout=setTimeout(later,remaining)),result}},inherit:function(protoProps,staticProps){var child,parent=this;child=protoProps&&protoProps.hasOwnProperty("constructor")?protoProps.constructor:function(){return parent.apply(this,arguments)},ionic.extend(child,parent,staticProps);var Surrogate=function(){this.constructor=child};return Surrogate.prototype=parent.prototype,child.prototype=new Surrogate,protoProps&&ionic.extend(child.prototype,protoProps),child.__super__=parent.prototype,child},extend:function(obj){for(var args=Array.prototype.slice.call(arguments,1),i=0;i<args.length;i++){var source=args[i];if(source)for(var prop in source)obj[prop]=source[prop]}return obj},nextUid:function(){return"ion"+nextId++},disconnectScope:function(scope){if(scope&&scope.$root!==scope){var parent=scope.$parent;scope.$$disconnected=!0,scope.$broadcast("$ionic.disconnectScope",scope),parent.$$childHead===scope&&(parent.$$childHead=scope.$$nextSibling),parent.$$childTail===scope&&(parent.$$childTail=scope.$$prevSibling),scope.$$prevSibling&&(scope.$$prevSibling.$$nextSibling=scope.$$nextSibling),scope.$$nextSibling&&(scope.$$nextSibling.$$prevSibling=scope.$$prevSibling),scope.$$nextSibling=scope.$$prevSibling=null}},reconnectScope:function(scope){if(scope&&scope.$root!==scope&&scope.$$disconnected){var parent=scope.$parent;scope.$$disconnected=!1,scope.$broadcast("$ionic.reconnectScope",scope),scope.$$prevSibling=parent.$$childTail,parent.$$childHead?(parent.$$childTail.$$nextSibling=scope,parent.$$childTail=scope):parent.$$childHead=parent.$$childTail=scope}},isScopeDisconnected:function(scope){for(var climbScope=scope;climbScope;){if(climbScope.$$disconnected)return!0;climbScope=climbScope.$parent}return!1}},ionic.inherit=ionic.Utils.inherit,ionic.extend=ionic.Utils.extend,ionic.throttle=ionic.Utils.throttle,ionic.proxy=ionic.Utils.proxy,ionic.debounce=ionic.Utils.debounce}(window.ionic);var keyboardActiveElement,lastKeyboardActiveElement,scrollView,waitForResizeTimer,keyboardFocusOutTimer,keyboardCurrentViewportHeight=0,keyboardPortraitViewportHeight=0,keyboardLandscapeViewportHeight=0,wasOrientationChange=!1,KEYBOARD_OPEN_CSS="keyboard-open",SCROLL_CONTAINER_CSS="scroll-content",debouncedKeyboardFocusIn=ionic.debounce(function(e){if(clearTimeout(keyboardFocusOutTimer),!e.target||e.target.readOnly||!ionic.tap.isKeyboardElement(e.target)||!(scrollView=ionic.DomUtil.getParentWithClass(e.target,SCROLL_CONTAINER_CSS)))return keyboardActiveElement&&(lastKeyboardActiveElement=keyboardActiveElement),void(keyboardActiveElement=null);keyboardActiveElement=e.target,scrollView.classList.contains("overflow-scroll")||(document.body.scrollTop=0,scrollView.scrollTop=0,ionic.requestAnimationFrame(function(){document.body.scrollTop=0,scrollView.scrollTop=0}),window.navigator.msPointerEnabled?document.addEventListener("MSPointerMove",keyboardPreventDefault,!1):document.addEventListener("touchmove",keyboardPreventDefault,!1)),ionic.keyboard.isOpen&&!ionic.keyboard.isClosing||(ionic.keyboard.isOpening=!0,ionic.keyboard.isClosing=!1),document.addEventListener("keydown",keyboardOnKeyDown,!1),ionic.keyboard.isOpen||keyboardHasPlugin()?ionic.keyboard.isOpen&&keyboardShow():keyboardWaitForResize(keyboardShow,!0)},200,!0),debouncedKeyboardNativeShow=ionic.debounce(function(e){clearTimeout(keyboardFocusOutTimer),ionic.keyboard.isOpen&&!ionic.keyboard.isClosing||(ionic.keyboard.isOpening=!0,ionic.keyboard.isClosing=!1),ionic.keyboard.height=e.keyboardHeight,wasOrientationChange?keyboardWaitForResize(keyboardUpdateViewportHeight,!0):keyboardWaitForResize(keyboardShow,!0)},100,!0);ionic.keyboard={isOpen:!1,isClosing:!1,isOpening:!1,height:0,isLandscape:!1,isInitialized:!1,hide:function(){keyboardHasPlugin()&&cordova.plugins.Keyboard.close(),keyboardActiveElement&&keyboardActiveElement.blur()},show:function(){keyboardHasPlugin()&&cordova.plugins.Keyboard.show()},disable:function(){keyboardHasPlugin()?(window.removeEventListener("native.keyboardshow",debouncedKeyboardNativeShow),window.removeEventListener("native.keyboardhide",keyboardFocusOut)):document.body.removeEventListener("focusout",keyboardFocusOut),document.body.removeEventListener("ionic.focusin",debouncedKeyboardFocusIn),document.body.removeEventListener("focusin",debouncedKeyboardFocusIn),window.removeEventListener("orientationchange",keyboardOrientationChange),window.navigator.msPointerEnabled?document.removeEventListener("MSPointerDown",keyboardInit):document.removeEventListener("touchstart",keyboardInit),ionic.keyboard.isInitialized=!1},enable:function(){keyboardInit()}},keyboardCurrentViewportHeight=getViewportHeight(),ionic.Platform.ready(function(){keyboardInitViewportHeight(),window.addEventListener("orientationchange",keyboardOrientationChange),setTimeout(keyboardInitViewportHeight,999),window.navigator.msPointerEnabled?document.addEventListener("MSPointerDown",keyboardInit,!1):document.addEventListener("touchstart",keyboardInit,!1)});var viewportTag,viewportProperties={};ionic.viewport={orientation:function(){return window.innerWidth>window.innerHeight?90:0}},ionic.Platform.ready(function(){viewportLoadTag(),window.addEventListener("orientationchange",function(){setTimeout(viewportUpdate,1e3)},!1)}),function(ionic){"use strict";ionic.views.View=function(){this.initialize.apply(this,arguments)},ionic.views.View.inherit=ionic.inherit,ionic.extend(ionic.views.View.prototype,{initialize:function(){}})}(window.ionic);var zyngaCore={effect:{}};!function(global){var time=Date.now||function(){return+new Date},running={},counter=1;zyngaCore.effect.Animate={requestAnimationFrame:function(){var requestFrame=global.requestAnimationFrame||global.webkitRequestAnimationFrame||global.mozRequestAnimationFrame||global.oRequestAnimationFrame,isNative=!!requestFrame;if(requestFrame&&!/requestAnimationFrame\(\)\s*\{\s*\[native code\]\s*\}/i.test(requestFrame.toString())&&(isNative=!1),isNative)return function(callback,root){requestFrame(callback,root)};var requests={},requestCount=0,rafHandle=1,intervalHandle=null,lastActive=+new Date;return function(callback){var callbackHandle=rafHandle++;return requests[callbackHandle]=callback,requestCount++,null===intervalHandle&&(intervalHandle=setInterval(function(){var time=+new Date,currentRequests=requests;requests={},requestCount=0;for(var key in currentRequests)currentRequests.hasOwnProperty(key)&&(currentRequests[key](time),lastActive=time);time-lastActive>2500&&(clearInterval(intervalHandle),intervalHandle=null)},1e3/60)),callbackHandle}}(),stop:function(id){var cleared=null!=running[id];return cleared&&(running[id]=null),cleared},isRunning:function(id){return null!=running[id]},start:function(stepCallback,verifyCallback,completedCallback,duration,easingMethod,root){var start=time(),lastFrame=start,percent=0,dropCounter=0,id=counter++;if(root||(root=document.body),id%20==0){var newRunning={};for(var usedId in running)newRunning[usedId]=!0;running=newRunning}var step=function(virtual){var render=!0!==virtual,now=time();if(!running[id]||verifyCallback&&!verifyCallback(id))return running[id]=null,void(completedCallback&&completedCallback(60-dropCounter/((now-start)/1e3),id,!1));if(render)for(var droppedFrames=Math.round((now-lastFrame)/(1e3/60))-1,j=0;j<Math.min(droppedFrames,4);j++)step(!0),dropCounter++;duration&&(percent=(now-start)/duration)>1&&(percent=1);var value=easingMethod?easingMethod(percent):percent;!1!==stepCallback(value,now,render)&&1!==percent||!render?render&&(lastFrame=now,zyngaCore.effect.Animate.requestAnimationFrame(step,root)):(running[id]=null,completedCallback&&completedCallback(60-dropCounter/((now-start)/1e3),id,1===percent||null==duration))};return running[id]=!0,zyngaCore.effect.Animate.requestAnimationFrame(step,root),id}}}(window),function(ionic){var NOOP=function(){},easeOutCubic=function(pos){return Math.pow(pos-1,3)+1},easeInOutCubic=function(pos){return(pos/=.5)<1?.5*Math.pow(pos,3):.5*(Math.pow(pos-2,3)+2)};ionic.views.Scroll=ionic.views.View.inherit({initialize:function(options){var self=this;self.__container=options.el,self.__content=options.el.firstElementChild,setTimeout(function(){self.__container&&self.__content&&(self.__container.scrollTop=0,self.__content.scrollTop=0)}),self.options={scrollingX:!1,scrollbarX:!0,scrollingY:!0,scrollbarY:!0,startX:0,startY:0,wheelDampen:6,minScrollbarSizeX:5,minScrollbarSizeY:5,scrollbarsFade:!0,scrollbarFadeDelay:300,scrollbarResizeFadeDelay:1e3,animating:!0,animationDuration:250,decelVelocityThreshold:4,decelVelocityThresholdPaging:4,bouncing:!0,locking:!0,paging:!1,snapping:!1,zooming:!1,minZoom:.5,maxZoom:3,speedMultiplier:1,deceleration:.97,preventDefault:!1,scrollingComplete:NOOP,penetrationDeceleration:.03,penetrationAcceleration:.08,scrollEventInterval:10,freeze:!1,getContentWidth:function(){return Math.max(self.__content.scrollWidth,self.__content.offsetWidth)},getContentHeight:function(){return Math.max(self.__content.scrollHeight,self.__content.offsetHeight+2*self.__content.offsetTop)}};for(var key in options)self.options[key]=options[key];self.hintResize=ionic.debounce(function(){self.resize()},1e3,!0),self.onScroll=function(){ionic.scroll.isScrolling?(clearTimeout(self.scrollTimer),self.scrollTimer=setTimeout(self.setScrollStop,80)):setTimeout(self.setScrollStart,50)},self.freeze=function(shouldFreeze){return arguments.length&&(self.options.freeze=shouldFreeze),self.options.freeze},self.freezeShut=self.freeze,self.setScrollStart=function(){ionic.scroll.isScrolling=Math.abs(ionic.scroll.lastTop-self.__scrollTop)>1,clearTimeout(self.scrollTimer),self.scrollTimer=setTimeout(self.setScrollStop,80)},self.setScrollStop=function(){ionic.scroll.isScrolling=!1,ionic.scroll.lastTop=self.__scrollTop},self.triggerScrollEvent=ionic.throttle(function(){self.onScroll(),ionic.trigger("scroll",{scrollTop:self.__scrollTop,scrollLeft:self.__scrollLeft,target:self.__container})},self.options.scrollEventInterval),self.triggerScrollEndEvent=function(){ionic.trigger("scrollend",{scrollTop:self.__scrollTop,scrollLeft:self.__scrollLeft,target:self.__container})},self.__scrollLeft=self.options.startX,self.__scrollTop=self.options.startY,self.__callback=self.getRenderFn(),self.__initEventHandlers(),self.__createScrollbars()},run:function(){this.resize(),this.__fadeScrollbars("out",this.options.scrollbarResizeFadeDelay)},__isSingleTouch:!1,__isTracking:!1,__didDecelerationComplete:!1,__isGesturing:!1,__isDragging:!1,__isDecelerating:!1,__isAnimating:!1,__clientLeft:0,__clientTop:0,__clientWidth:0,__clientHeight:0,__contentWidth:0,__contentHeight:0,__snapWidth:100,__snapHeight:100,__refreshHeight:null,__refreshActive:!1,__refreshActivate:null,__refreshDeactivate:null,__refreshStart:null,__zoomLevel:1,__scrollLeft:0,__scrollTop:0,__maxScrollLeft:0,__maxScrollTop:0,__scheduledLeft:0,__scheduledTop:0,__scheduledZoom:0,__lastTouchLeft:null,__lastTouchTop:null,__lastTouchMove:null,__positions:null,__minDecelerationScrollLeft:null,__minDecelerationScrollTop:null,__maxDecelerationScrollLeft:null,__maxDecelerationScrollTop:null,__decelerationVelocityX:null,__decelerationVelocityY:null,__transformProperty:null,__perspectiveProperty:null,__indicatorX:null,__indicatorY:null,__scrollbarFadeTimeout:null,__didWaitForSize:null,__sizerTimeout:null,__initEventHandlers:function(){function getEventTouches(e){return e.touches&&e.touches.length?e.touches:[{pageX:e.pageX,pageY:e.pageY}]}var scrollViewOffsetHeight,self=this,container=self.__container;if(self.scrollChildIntoView=function(e){var scrollBottomOffsetToTop=container.getBoundingClientRect().bottom;scrollViewOffsetHeight=container.offsetHeight;var alreadyShrunk=self.isShrunkForKeyboard,isInsetModal=container.parentNode.classList.contains("modal")&&window.innerWidth>=680;if(!alreadyShrunk){if(ionic.Platform.isIOS()||ionic.Platform.isFullScreen||isInsetModal){var scrollBottomOffsetToBottom=e.detail.viewportHeight-scrollBottomOffsetToTop,keyboardOffset=Math.max(0,e.detail.keyboardHeight-scrollBottomOffsetToBottom);ionic.requestAnimationFrame(function(){scrollViewOffsetHeight-=keyboardOffset,container.style.height=scrollViewOffsetHeight+"px",container.style.overflow="visible",self.resize()})}self.isShrunkForKeyboard=!0}e.detail.isElementUnderKeyboard&&ionic.requestAnimationFrame(function(){container.scrollTop=0,self.isShrunkForKeyboard&&!alreadyShrunk&&(scrollBottomOffsetToTop=container.getBoundingClientRect().bottom);var scrollMidpointOffset=.5*scrollViewOffsetHeight,scrollTop=(e.detail.elementBottom+e.detail.elementTop)/2-scrollBottomOffsetToTop+scrollMidpointOffset;scrollTop>0&&(ionic.Platform.isIOS()&&ionic.tap.cloneFocusedInput(container,self),self.scrollBy(0,scrollTop,!0),self.onScroll())}),e.stopPropagation()},self.resetScrollView=function(){self.isShrunkForKeyboard&&(self.isShrunkForKeyboard=!1,container.style.height="",container.style.overflow=""),self.resize()},container.addEventListener("scrollChildIntoView",self.scrollChildIntoView),document.addEventListener("resetScrollView",self.resetScrollView),self.touchStart=function(e){self.startCoordinates=ionic.tap.pointerCoord(e),ionic.tap.ignoreScrollStart(e)||(self.__isDown=!0,ionic.tap.containsOrIsTextInput(e.target)||"SELECT"===e.target.tagName?self.__hasStarted=!1:(self.__isSelectable=!0,self.__enableScrollY=!0,self.__hasStarted=!0,self.doTouchStart(getEventTouches(e),e.timeStamp),e.preventDefault()))},self.touchMove=function(e){if(!(self.options.freeze||!self.__isDown||!self.__isDown&&e.defaultPrevented||"TEXTAREA"===e.target.tagName&&e.target.parentElement.querySelector(":focus"))){if(!self.__hasStarted&&(ionic.tap.containsOrIsTextInput(e.target)||"SELECT"===e.target.tagName))return self.__hasStarted=!0,self.doTouchStart(getEventTouches(e),e.timeStamp),void e.preventDefault();if(self.startCoordinates){var currentCoordinates=ionic.tap.pointerCoord(e);self.__isSelectable&&ionic.tap.isTextInput(e.target)&&Math.abs(self.startCoordinates.x-currentCoordinates.x)>20&&(self.__enableScrollY=!1,self.__isSelectable=!0),self.__enableScrollY&&Math.abs(self.startCoordinates.y-currentCoordinates.y)>10&&(self.__isSelectable=!1,ionic.tap.cloneFocusedInput(container,self))}self.doTouchMove(getEventTouches(e),e.timeStamp,e.scale),self.__isDown=!0}},self.touchMoveBubble=function(e){self.__isDown&&self.options.preventDefault&&e.preventDefault()},self.touchEnd=function(e){self.__isDown&&(self.doTouchEnd(e,e.timeStamp),self.__isDown=!1,self.__hasStarted=!1,self.__isSelectable=!0,self.__enableScrollY=!0,self.__isDragging||self.__isDecelerating||self.__isAnimating||ionic.tap.removeClonedInputs(container,self))},self.mouseWheel=ionic.animationFrameThrottle(function(e){var scrollParent=ionic.DomUtil.getParentOrSelfWithClass(e.target,"ionic-scroll");self.options.freeze||scrollParent!==self.__container||(self.hintResize(),self.scrollBy((e.wheelDeltaX||e.deltaX||0)/self.options.wheelDampen,(-e.wheelDeltaY||e.deltaY||0)/self.options.wheelDampen),self.__fadeScrollbars("in"),clearTimeout(self.__wheelHideBarTimeout),self.__wheelHideBarTimeout=setTimeout(function(){self.__fadeScrollbars("out")},100))}),"ontouchstart"in window)container.addEventListener("touchstart",self.touchStart,!1),self.options.preventDefault&&container.addEventListener("touchmove",self.touchMoveBubble,!1),document.addEventListener("touchmove",self.touchMove,!1),document.addEventListener("touchend",self.touchEnd,!1),document.addEventListener("touchcancel",self.touchEnd,!1),document.addEventListener("wheel",self.mouseWheel,!1);else if(window.navigator.pointerEnabled)container.addEventListener("pointerdown",self.touchStart,!1),self.options.preventDefault&&container.addEventListener("pointermove",self.touchMoveBubble,!1),document.addEventListener("pointermove",self.touchMove,!1),document.addEventListener("pointerup",self.touchEnd,!1),document.addEventListener("pointercancel",self.touchEnd,!1),document.addEventListener("wheel",self.mouseWheel,!1);else if(window.navigator.msPointerEnabled)container.addEventListener("MSPointerDown",self.touchStart,!1),self.options.preventDefault&&container.addEventListener("MSPointerMove",self.touchMoveBubble,!1),document.addEventListener("MSPointerMove",self.touchMove,!1),document.addEventListener("MSPointerUp",self.touchEnd,!1),document.addEventListener("MSPointerCancel",self.touchEnd,!1),document.addEventListener("wheel",self.mouseWheel,!1);else{var mousedown=!1;self.mouseDown=function(e){ionic.tap.ignoreScrollStart(e)||"SELECT"===e.target.tagName||(self.doTouchStart(getEventTouches(e),e.timeStamp),ionic.tap.isTextInput(e.target)||e.preventDefault(),mousedown=!0)},self.mouseMove=function(e){self.options.freeze||!mousedown||!mousedown&&e.defaultPrevented||(self.doTouchMove(getEventTouches(e),e.timeStamp),mousedown=!0)},self.mouseMoveBubble=function(e){mousedown&&self.options.preventDefault&&e.preventDefault()},self.mouseUp=function(e){mousedown&&(self.doTouchEnd(e,e.timeStamp),mousedown=!1)},container.addEventListener("mousedown",self.mouseDown,!1),self.options.preventDefault&&container.addEventListener("mousemove",self.mouseMoveBubble,!1),document.addEventListener("mousemove",self.mouseMove,!1),document.addEventListener("mouseup",self.mouseUp,!1),document.addEventListener("mousewheel",self.mouseWheel,!1),document.addEventListener("wheel",self.mouseWheel,!1)}},__cleanup:function(){var self=this,container=self.__container;container.removeEventListener("touchstart",self.touchStart),container.removeEventListener("touchmove",self.touchMoveBubble),document.removeEventListener("touchmove",self.touchMove),document.removeEventListener("touchend",self.touchEnd),document.removeEventListener("touchcancel",self.touchEnd),container.removeEventListener("pointerdown",self.touchStart),container.removeEventListener("pointermove",self.touchMoveBubble),document.removeEventListener("pointermove",self.touchMove),document.removeEventListener("pointerup",self.touchEnd),document.removeEventListener("pointercancel",self.touchEnd),container.removeEventListener("MSPointerDown",self.touchStart),container.removeEventListener("MSPointerMove",self.touchMoveBubble),document.removeEventListener("MSPointerMove",self.touchMove),document.removeEventListener("MSPointerUp",self.touchEnd),document.removeEventListener("MSPointerCancel",self.touchEnd),container.removeEventListener("mousedown",self.mouseDown),container.removeEventListener("mousemove",self.mouseMoveBubble),document.removeEventListener("mousemove",self.mouseMove),document.removeEventListener("mouseup",self.mouseUp),document.removeEventListener("mousewheel",self.mouseWheel),document.removeEventListener("wheel",self.mouseWheel),container.removeEventListener("scrollChildIntoView",self.scrollChildIntoView),document.removeEventListener("resetScrollView",self.resetScrollView),ionic.tap.removeClonedInputs(container,self),delete self.__container,delete self.__content,delete self.__indicatorX,delete self.__indicatorY,delete self.options.el,self.__callback=self.scrollChildIntoView=self.resetScrollView=NOOP,self.mouseMove=self.mouseDown=self.mouseUp=self.mouseWheel=self.touchStart=self.touchMove=self.touchEnd=self.touchCancel=NOOP,self.resize=self.scrollTo=self.zoomTo=self.__scrollingComplete=NOOP,container=null},__createScrollbar:function(direction){var bar=document.createElement("div"),indicator=document.createElement("div");return indicator.className="scroll-bar-indicator scroll-bar-fade-out",bar.className="h"==direction?"scroll-bar scroll-bar-h":"scroll-bar scroll-bar-v",bar.appendChild(indicator),bar},__createScrollbars:function(){var indicatorX,indicatorY,self=this;self.options.scrollingX&&((indicatorX={el:self.__createScrollbar("h"),sizeRatio:1}).indicator=indicatorX.el.children[0],self.options.scrollbarX&&self.__container.appendChild(indicatorX.el),self.__indicatorX=indicatorX),self.options.scrollingY&&((indicatorY={el:self.__createScrollbar("v"),sizeRatio:1}).indicator=indicatorY.el.children[0],self.options.scrollbarY&&self.__container.appendChild(indicatorY.el),self.__indicatorY=indicatorY)},__resizeScrollbars:function(){var self=this;if(self.__indicatorX){var width=Math.max(Math.round(self.__clientWidth*self.__clientWidth/self.__contentWidth),20);width>self.__contentWidth&&(width=0),width!==self.__indicatorX.size&&ionic.requestAnimationFrame(function(){self.__indicatorX.indicator.style.width=width+"px"}),self.__indicatorX.size=width,self.__indicatorX.minScale=self.options.minScrollbarSizeX/width,self.__indicatorX.maxPos=self.__clientWidth-width,self.__indicatorX.sizeRatio=self.__maxScrollLeft?self.__indicatorX.maxPos/self.__maxScrollLeft:1}if(self.__indicatorY){var height=Math.max(Math.round(self.__clientHeight*self.__clientHeight/self.__contentHeight),20);height>self.__contentHeight&&(height=0),height!==self.__indicatorY.size&&ionic.requestAnimationFrame(function(){self.__indicatorY&&(self.__indicatorY.indicator.style.height=height+"px")}),self.__indicatorY.size=height,self.__indicatorY.minScale=self.options.minScrollbarSizeY/height,self.__indicatorY.maxPos=self.__clientHeight-height,self.__indicatorY.sizeRatio=self.__maxScrollTop?self.__indicatorY.maxPos/self.__maxScrollTop:1}},__repositionScrollbars:function(){var heightScale,widthScale,widthDiff,heightDiff,x,y,self=this,xstop=0,ystop=0;if(self.__indicatorX){self.__indicatorY&&(xstop=10),x=Math.round(self.__indicatorX.sizeRatio*self.__scrollLeft)||0,widthDiff=self.__scrollLeft-(self.__maxScrollLeft-xstop),self.__scrollLeft<0?(widthScale=Math.max(self.__indicatorX.minScale,(self.__indicatorX.size-Math.abs(self.__scrollLeft))/self.__indicatorX.size),x=0,self.__indicatorX.indicator.style[self.__transformOriginProperty]="left center"):widthDiff>0?(widthScale=Math.max(self.__indicatorX.minScale,(self.__indicatorX.size-widthDiff)/self.__indicatorX.size),x=self.__indicatorX.maxPos-xstop,self.__indicatorX.indicator.style[self.__transformOriginProperty]="right center"):(x=Math.min(self.__maxScrollLeft,Math.max(0,x)),widthScale=1);var translate3dX="translate3d("+x+"px, 0, 0) scaleX("+widthScale+")";self.__indicatorX.transformProp!==translate3dX&&(self.__indicatorX.indicator.style[self.__transformProperty]=translate3dX,self.__indicatorX.transformProp=translate3dX)}if(self.__indicatorY){y=Math.round(self.__indicatorY.sizeRatio*self.__scrollTop)||0,self.__indicatorX&&(ystop=10),heightDiff=self.__scrollTop-(self.__maxScrollTop-ystop),self.__scrollTop<0?(heightScale=Math.max(self.__indicatorY.minScale,(self.__indicatorY.size-Math.abs(self.__scrollTop))/self.__indicatorY.size),y=0,"center top"!==self.__indicatorY.originProp&&(self.__indicatorY.indicator.style[self.__transformOriginProperty]="center top",self.__indicatorY.originProp="center top")):heightDiff>0?(heightScale=Math.max(self.__indicatorY.minScale,(self.__indicatorY.size-heightDiff)/self.__indicatorY.size),y=self.__indicatorY.maxPos-ystop,"center bottom"!==self.__indicatorY.originProp&&(self.__indicatorY.indicator.style[self.__transformOriginProperty]="center bottom",self.__indicatorY.originProp="center bottom")):(y=Math.min(self.__maxScrollTop,Math.max(0,y)),heightScale=1);var translate3dY="translate3d(0,"+y+"px, 0) scaleY("+heightScale+")";self.__indicatorY.transformProp!==translate3dY&&(self.__indicatorY.indicator.style[self.__transformProperty]=translate3dY,self.__indicatorY.transformProp=translate3dY)}},__fadeScrollbars:function(direction,delay){var self=this;if(self.options.scrollbarsFade){var className="scroll-bar-fade-out";!0===self.options.scrollbarsFade&&(clearTimeout(self.__scrollbarFadeTimeout),"in"==direction?(self.__indicatorX&&self.__indicatorX.indicator.classList.remove(className),self.__indicatorY&&self.__indicatorY.indicator.classList.remove(className)):self.__scrollbarFadeTimeout=setTimeout(function(){self.__indicatorX&&self.__indicatorX.indicator.classList.add(className),self.__indicatorY&&self.__indicatorY.indicator.classList.add(className)},delay||self.options.scrollbarFadeDelay))}},__scrollingComplete:function(){this.options.scrollingComplete(),ionic.tap.removeClonedInputs(this.__container,this),this.__fadeScrollbars("out")},resize:function(continueScrolling){var self=this;self.__container&&self.options&&self.setDimensions(self.__container.clientWidth,self.__container.clientHeight,self.options.getContentWidth(),self.options.getContentHeight(),continueScrolling)},getRenderFn:function(){var engine,self=this,content=self.__content,docStyle=document.documentElement.style;"MozAppearance"in docStyle?engine="gecko":"WebkitAppearance"in docStyle?engine="webkit":"string"==typeof navigator.cpuClass&&(engine="trident");var vendorPrefix={trident:"ms",gecko:"Moz",webkit:"Webkit",presto:"O"}[engine],helperElem=document.createElement("div"),perspectiveProperty=vendorPrefix+"Perspective",transformProperty=vendorPrefix+"Transform",transformOriginProperty=vendorPrefix+"TransformOrigin";return self.__perspectiveProperty=transformProperty,self.__transformProperty=transformProperty,self.__transformOriginProperty=transformOriginProperty,void 0!==helperElem.style[perspectiveProperty]?function(left,top,zoom,wasResize){var translate3d="translate3d("+-left+"px,"+-top+"px,0) scale("+zoom+")";translate3d!==self.contentTransform&&(content.style[transformProperty]=translate3d,self.contentTransform=translate3d),self.__repositionScrollbars(),wasResize||self.triggerScrollEvent()}:void 0!==helperElem.style[transformProperty]?function(left,top,zoom,wasResize){content.style[transformProperty]="translate("+-left+"px,"+-top+"px) scale("+zoom+")",self.__repositionScrollbars(),wasResize||self.triggerScrollEvent()}:function(left,top,zoom,wasResize){content.style.marginLeft=left?-left/zoom+"px":"",content.style.marginTop=top?-top/zoom+"px":"",content.style.zoom=zoom||"",self.__repositionScrollbars(),wasResize||self.triggerScrollEvent()}},setDimensions:function(clientWidth,clientHeight,contentWidth,contentHeight,continueScrolling){var self=this;(clientWidth||clientHeight||contentWidth||contentHeight)&&(clientWidth===+clientWidth&&(self.__clientWidth=clientWidth),clientHeight===+clientHeight&&(self.__clientHeight=clientHeight),contentWidth===+contentWidth&&(self.__contentWidth=contentWidth),contentHeight===+contentHeight&&(self.__contentHeight=contentHeight),self.__computeScrollMax(),self.__resizeScrollbars(),continueScrolling||self.scrollTo(self.__scrollLeft,self.__scrollTop,!0,null,!0))},setPosition:function(left,top){this.__clientLeft=left||0,this.__clientTop=top||0},setSnapSize:function(width,height){this.__snapWidth=width,this.__snapHeight=height},activatePullToRefresh:function(height,refresherMethods){var self=this;self.__refreshHeight=height,self.__refreshActivate=function(){ionic.requestAnimationFrame(refresherMethods.activate)},self.__refreshDeactivate=function(){ionic.requestAnimationFrame(refresherMethods.deactivate)},self.__refreshStart=function(){ionic.requestAnimationFrame(refresherMethods.start)},self.__refreshShow=function(){ionic.requestAnimationFrame(refresherMethods.show)},self.__refreshHide=function(){ionic.requestAnimationFrame(refresherMethods.hide)},self.__refreshTail=function(){ionic.requestAnimationFrame(refresherMethods.tail)},self.__refreshTailTime=100,self.__minSpinTime=600},triggerPullToRefresh:function(){this.__publish(this.__scrollLeft,-this.__refreshHeight,this.__zoomLevel,!0);var d=new Date;this.refreshStartTime=d.getTime(),this.__refreshStart&&this.__refreshStart()},finishPullToRefresh:function(){var self=this,d=new Date,delay=0;self.refreshStartTime+self.__minSpinTime>d.getTime()&&(delay=self.refreshStartTime+self.__minSpinTime-d.getTime()),setTimeout(function(){self.__refreshTail&&self.__refreshTail(),setTimeout(function(){self.__refreshActive=!1,self.__refreshDeactivate&&self.__refreshDeactivate(),self.__refreshHide&&self.__refreshHide(),self.scrollTo(self.__scrollLeft,self.__scrollTop,!0)},self.__refreshTailTime)},delay)},getValues:function(){return{left:this.__scrollLeft,top:this.__scrollTop,zoom:this.__zoomLevel}},getScrollMax:function(){return{left:this.__maxScrollLeft,top:this.__maxScrollTop}},zoomTo:function(level,animate,originLeft,originTop){var self=this;if(!self.options.zooming)throw new Error("Zooming is not enabled!");self.__isDecelerating&&(zyngaCore.effect.Animate.stop(self.__isDecelerating),self.__isDecelerating=!1);var oldLevel=self.__zoomLevel;null==originLeft&&(originLeft=self.__clientWidth/2),null==originTop&&(originTop=self.__clientHeight/2),level=Math.max(Math.min(level,self.options.maxZoom),self.options.minZoom),self.__computeScrollMax(level);var left=(originLeft+self.__scrollLeft)*level/oldLevel-originLeft,top=(originTop+self.__scrollTop)*level/oldLevel-originTop;left>self.__maxScrollLeft?left=self.__maxScrollLeft:left<0&&(left=0),top>self.__maxScrollTop?top=self.__maxScrollTop:top<0&&(top=0),self.__publish(left,top,level,animate)},zoomBy:function(factor,animate,originLeft,originTop){this.zoomTo(this.__zoomLevel*factor,animate,originLeft,originTop)},scrollTo:function(left,top,animate,zoom,wasResize){var self=this;if(self.__isDecelerating&&(zyngaCore.effect.Animate.stop(self.__isDecelerating),self.__isDecelerating=!1),null!=zoom&&zoom!==self.__zoomLevel){if(!self.options.zooming)throw new Error("Zooming is not enabled!");left*=zoom,top*=zoom,self.__computeScrollMax(zoom)}else zoom=self.__zoomLevel;self.options.scrollingX?self.options.paging?left=Math.round(left/self.__clientWidth)*self.__clientWidth:self.options.snapping&&(left=Math.round(left/self.__snapWidth)*self.__snapWidth):left=self.__scrollLeft,self.options.scrollingY?self.options.paging?top=Math.round(top/self.__clientHeight)*self.__clientHeight:self.options.snapping&&(top=Math.round(top/self.__snapHeight)*self.__snapHeight):top=self.__scrollTop,left=Math.max(Math.min(self.__maxScrollLeft,left),0),top=Math.max(Math.min(self.__maxScrollTop,top),0),left===self.__scrollLeft&&top===self.__scrollTop&&(animate=!1),self.__publish(left,top,zoom,animate,wasResize)},scrollBy:function(left,top,animate){var self=this,startLeft=self.__isAnimating?self.__scheduledLeft:self.__scrollLeft,startTop=self.__isAnimating?self.__scheduledTop:self.__scrollTop;self.scrollTo(startLeft+(left||0),startTop+(top||0),animate)},doMouseZoom:function(wheelDelta,timeStamp,pageX,pageY){var change=wheelDelta>0?.97:1.03;return this.zoomTo(this.__zoomLevel*change,!1,pageX-this.__clientLeft,pageY-this.__clientTop)},doTouchStart:function(touches,timeStamp){var self=this;self.__decStopped=!(!self.__isDecelerating&&!self.__isAnimating),self.hintResize(),timeStamp instanceof Date&&(timeStamp=timeStamp.valueOf()),"number"!=typeof timeStamp&&(timeStamp=Date.now()),self.__interruptedAnimation=!0,self.__isDecelerating&&(zyngaCore.effect.Animate.stop(self.__isDecelerating),self.__isDecelerating=!1,self.__interruptedAnimation=!0),self.__isAnimating&&(zyngaCore.effect.Animate.stop(self.__isAnimating),self.__isAnimating=!1,self.__interruptedAnimation=!0);var currentTouchLeft,currentTouchTop,isSingleTouch=1===touches.length;isSingleTouch?(currentTouchLeft=touches[0].pageX,currentTouchTop=touches[0].pageY):(currentTouchLeft=Math.abs(touches[0].pageX+touches[1].pageX)/2,currentTouchTop=Math.abs(touches[0].pageY+touches[1].pageY)/2),self.__initialTouchLeft=currentTouchLeft,self.__initialTouchTop=currentTouchTop,self.__initialTouches=touches,self.__zoomLevelStart=self.__zoomLevel,self.__lastTouchLeft=currentTouchLeft,self.__lastTouchTop=currentTouchTop,self.__lastTouchMove=timeStamp,self.__lastScale=1,self.__enableScrollX=!isSingleTouch&&self.options.scrollingX,self.__enableScrollY=!isSingleTouch&&self.options.scrollingY,self.__isTracking=!0,self.__didDecelerationComplete=!1,self.__isDragging=!isSingleTouch,self.__isSingleTouch=isSingleTouch,self.__positions=[]},doTouchMove:function(touches,timeStamp,scale){timeStamp instanceof Date&&(timeStamp=timeStamp.valueOf()),"number"!=typeof timeStamp&&(timeStamp=Date.now());var self=this;if(self.__isTracking){var currentTouchLeft,currentTouchTop;2===touches.length?(currentTouchLeft=Math.abs(touches[0].pageX+touches[1].pageX)/2,currentTouchTop=Math.abs(touches[0].pageY+touches[1].pageY)/2,!scale&&self.options.zooming&&(scale=self.__getScale(self.__initialTouches,touches))):(currentTouchLeft=touches[0].pageX,currentTouchTop=touches[0].pageY);var positions=self.__positions;if(self.__isDragging){self.__decStopped=!1;var moveX=currentTouchLeft-self.__lastTouchLeft,moveY=currentTouchTop-self.__lastTouchTop,scrollLeft=self.__scrollLeft,scrollTop=self.__scrollTop,level=self.__zoomLevel;if(null!=scale&&self.options.zooming){var oldLevel=level;if(level=level/self.__lastScale*scale,level=Math.max(Math.min(level,self.options.maxZoom),self.options.minZoom),oldLevel!==level){var currentTouchLeftRel=currentTouchLeft-self.__clientLeft,currentTouchTopRel=currentTouchTop-self.__clientTop;scrollLeft=(currentTouchLeftRel+scrollLeft)*level/oldLevel-currentTouchLeftRel,scrollTop=(currentTouchTopRel+scrollTop)*level/oldLevel-currentTouchTopRel,self.__computeScrollMax(level)}}if(self.__enableScrollX){scrollLeft-=moveX*self.options.speedMultiplier;var maxScrollLeft=self.__maxScrollLeft;(scrollLeft>maxScrollLeft||scrollLeft<0)&&(self.options.bouncing?scrollLeft+=moveX/2*self.options.speedMultiplier:scrollLeft=scrollLeft>maxScrollLeft?maxScrollLeft:0)}if(self.__enableScrollY){scrollTop-=moveY*self.options.speedMultiplier;var maxScrollTop=self.__maxScrollTop;scrollTop>maxScrollTop||scrollTop<0?self.options.bouncing||self.__refreshHeight&&scrollTop<0?(scrollTop+=moveY/2*self.options.speedMultiplier,self.__enableScrollX||null==self.__refreshHeight||(scrollTop<0?(self.__refreshHidden=!1,self.__refreshShow()):(self.__refreshHide(),self.__refreshHidden=!0),!self.__refreshActive&&scrollTop<=-self.__refreshHeight?(self.__refreshActive=!0,self.__refreshActivate&&self.__refreshActivate()):self.__refreshActive&&scrollTop>-self.__refreshHeight&&(self.__refreshActive=!1,self.__refreshDeactivate&&self.__refreshDeactivate()))):scrollTop=scrollTop>maxScrollTop?maxScrollTop:0:self.__refreshHeight&&!self.__refreshHidden&&(self.__refreshHide(),self.__refreshHidden=!0)}positions.length>60&&positions.splice(0,30),positions.push(scrollLeft,scrollTop,timeStamp),self.__publish(scrollLeft,scrollTop,level)}else{var minimumTrackingForScroll=self.options.locking?3:0,distanceX=Math.abs(currentTouchLeft-self.__initialTouchLeft),distanceY=Math.abs(currentTouchTop-self.__initialTouchTop);self.__enableScrollX=self.options.scrollingX&&distanceX>=minimumTrackingForScroll,self.__enableScrollY=self.options.scrollingY&&distanceY>=minimumTrackingForScroll,positions.push(self.__scrollLeft,self.__scrollTop,timeStamp),self.__isDragging=(self.__enableScrollX||self.__enableScrollY)&&(distanceX>=5||distanceY>=5),self.__isDragging&&(self.__interruptedAnimation=!1,self.__fadeScrollbars("in"))}self.__lastTouchLeft=currentTouchLeft,self.__lastTouchTop=currentTouchTop,self.__lastTouchMove=timeStamp,self.__lastScale=scale}},doTouchEnd:function(e,timeStamp){timeStamp instanceof Date&&(timeStamp=timeStamp.valueOf()),"number"!=typeof timeStamp&&(timeStamp=Date.now());var self=this;if(self.__isTracking){if(self.__isTracking=!1,self.__isDragging)if(self.__isDragging=!1,self.__isSingleTouch&&self.options.animating&&timeStamp-self.__lastTouchMove<=100){for(var positions=self.__positions,endPos=positions.length-1,startPos=endPos,i=endPos;i>0&&positions[i]>self.__lastTouchMove-100;i-=3)startPos=i;if(startPos!==endPos){var timeOffset=positions[endPos]-positions[startPos],movedLeft=self.__scrollLeft-positions[startPos-2],movedTop=self.__scrollTop-positions[startPos-1];self.__decelerationVelocityX=movedLeft/timeOffset*(1e3/60),self.__decelerationVelocityY=movedTop/timeOffset*(1e3/60);var minVelocityToStartDeceleration=self.options.paging||self.options.snapping?self.options.decelVelocityThresholdPaging:self.options.decelVelocityThreshold;(Math.abs(self.__decelerationVelocityX)>minVelocityToStartDeceleration||Math.abs(self.__decelerationVelocityY)>minVelocityToStartDeceleration)&&(self.__refreshActive||self.__startDeceleration(timeStamp))}else self.__scrollingComplete()}else timeStamp-self.__lastTouchMove>100&&self.__scrollingComplete();else self.__decStopped&&(e.isTapHandled=!0,self.__decStopped=!1);if(!self.__isDecelerating)if(self.__refreshActive&&self.__refreshStart){self.__publish(self.__scrollLeft,-self.__refreshHeight,self.__zoomLevel,!0);var d=new Date;self.refreshStartTime=d.getTime(),self.__refreshStart&&self.__refreshStart(),ionic.Platform.isAndroid()||self.__startDeceleration()}else(self.__interruptedAnimation||self.__isDragging)&&self.__scrollingComplete(),self.scrollTo(self.__scrollLeft,self.__scrollTop,!0,self.__zoomLevel),self.__refreshActive&&(self.__refreshActive=!1,self.__refreshDeactivate&&self.__refreshDeactivate());self.__positions.length=0}},__publish:function(left,top,zoom,animate,wasResize){var self=this,wasAnimating=self.__isAnimating;if(wasAnimating&&(zyngaCore.effect.Animate.stop(wasAnimating),self.__isAnimating=!1),animate&&self.options.animating){self.__scheduledLeft=left,self.__scheduledTop=top,self.__scheduledZoom=zoom;var oldLeft=self.__scrollLeft,oldTop=self.__scrollTop,oldZoom=self.__zoomLevel,diffLeft=left-oldLeft,diffTop=top-oldTop,diffZoom=zoom-oldZoom;self.__isAnimating=zyngaCore.effect.Animate.start(function(percent,now,render){render&&(self.__scrollLeft=oldLeft+diffLeft*percent,self.__scrollTop=oldTop+diffTop*percent,self.__zoomLevel=oldZoom+diffZoom*percent,self.__callback&&self.__callback(self.__scrollLeft,self.__scrollTop,self.__zoomLevel,wasResize))},function(id){return self.__isAnimating===id},function(renderedFramesPerSecond,animationId,wasFinished){animationId===self.__isAnimating&&(self.__isAnimating=!1),(self.__didDecelerationComplete||wasFinished)&&self.__scrollingComplete(),self.options.zooming&&self.__computeScrollMax()},self.options.animationDuration,wasAnimating?easeOutCubic:easeInOutCubic)}else self.__scheduledLeft=self.__scrollLeft=left,self.__scheduledTop=self.__scrollTop=top,self.__scheduledZoom=self.__zoomLevel=zoom,self.__callback&&self.__callback(left,top,zoom,wasResize),self.options.zooming&&self.__computeScrollMax()},__computeScrollMax:function(zoomLevel){var self=this;null==zoomLevel&&(zoomLevel=self.__zoomLevel),self.__maxScrollLeft=Math.max(self.__contentWidth*zoomLevel-self.__clientWidth,0),self.__maxScrollTop=Math.max(self.__contentHeight*zoomLevel-self.__clientHeight,0),self.__didWaitForSize||self.__maxScrollLeft||self.__maxScrollTop||(self.__didWaitForSize=!0,self.__waitForSize())},__waitForSize:function(){var self=this;clearTimeout(self.__sizerTimeout);var sizer=function(){self.resize(!0)};sizer(),self.__sizerTimeout=setTimeout(sizer,500)},__startDeceleration:function(){var self=this;if(self.options.paging){var scrollLeft=Math.max(Math.min(self.__scrollLeft,self.__maxScrollLeft),0),scrollTop=Math.max(Math.min(self.__scrollTop,self.__maxScrollTop),0),clientWidth=self.__clientWidth,clientHeight=self.__clientHeight;self.__minDecelerationScrollLeft=Math.floor(scrollLeft/clientWidth)*clientWidth,self.__minDecelerationScrollTop=Math.floor(scrollTop/clientHeight)*clientHeight,self.__maxDecelerationScrollLeft=Math.ceil(scrollLeft/clientWidth)*clientWidth,self.__maxDecelerationScrollTop=Math.ceil(scrollTop/clientHeight)*clientHeight}else self.__minDecelerationScrollLeft=0,self.__minDecelerationScrollTop=0,self.__maxDecelerationScrollLeft=self.__maxScrollLeft,self.__maxDecelerationScrollTop=self.__maxScrollTop,self.__refreshActive&&(self.__minDecelerationScrollTop=-1*self.__refreshHeight);self.__minVelocityToKeepDecelerating=self.options.snapping?4:.1;self.__isDecelerating=zyngaCore.effect.Animate.start(function(percent,now,render){self.__stepThroughDeceleration(render)},function(){var shouldContinue=Math.abs(self.__decelerationVelocityX)>=self.__minVelocityToKeepDecelerating||Math.abs(self.__decelerationVelocityY)>=self.__minVelocityToKeepDecelerating;return shouldContinue||(self.__didDecelerationComplete=!0,self.options.bouncing&&!self.__refreshActive&&self.scrollTo(Math.min(Math.max(self.__scrollLeft,0),self.__maxScrollLeft),Math.min(Math.max(self.__scrollTop,0),self.__maxScrollTop),self.__refreshActive)),shouldContinue},function(){self.__isDecelerating=!1,self.__didDecelerationComplete&&self.__scrollingComplete(),self.options.paging&&self.scrollTo(self.__scrollLeft,self.__scrollTop,self.options.snapping)})},__stepThroughDeceleration:function(render){var self=this,scrollLeft=self.__scrollLeft+self.__decelerationVelocityX,scrollTop=self.__scrollTop+self.__decelerationVelocityY;if(!self.options.bouncing){var scrollLeftFixed=Math.max(Math.min(self.__maxDecelerationScrollLeft,scrollLeft),self.__minDecelerationScrollLeft);scrollLeftFixed!==scrollLeft&&(scrollLeft=scrollLeftFixed,self.__decelerationVelocityX=0);var scrollTopFixed=Math.max(Math.min(self.__maxDecelerationScrollTop,scrollTop),self.__minDecelerationScrollTop);scrollTopFixed!==scrollTop&&(scrollTop=scrollTopFixed,self.__decelerationVelocityY=0)}if(render?self.__publish(scrollLeft,scrollTop,self.__zoomLevel):(self.__scrollLeft=scrollLeft,self.__scrollTop=scrollTop),!self.options.paging){var frictionFactor=self.options.deceleration;self.__decelerationVelocityX*=frictionFactor,self.__decelerationVelocityY*=frictionFactor}if(self.options.bouncing){var scrollOutsideX=0,scrollOutsideY=0,penetrationDeceleration=self.options.penetrationDeceleration,penetrationAcceleration=self.options.penetrationAcceleration;if(scrollLeft<self.__minDecelerationScrollLeft?scrollOutsideX=self.__minDecelerationScrollLeft-scrollLeft:scrollLeft>self.__maxDecelerationScrollLeft&&(scrollOutsideX=self.__maxDecelerationScrollLeft-scrollLeft),scrollTop<self.__minDecelerationScrollTop?scrollOutsideY=self.__minDecelerationScrollTop-scrollTop:scrollTop>self.__maxDecelerationScrollTop&&(scrollOutsideY=self.__maxDecelerationScrollTop-scrollTop),0!==scrollOutsideX){var isHeadingOutwardsX=scrollOutsideX*self.__decelerationVelocityX<=self.__minDecelerationScrollLeft;isHeadingOutwardsX&&(self.__decelerationVelocityX+=scrollOutsideX*penetrationDeceleration);var isStoppedX=Math.abs(self.__decelerationVelocityX)<=self.__minVelocityToKeepDecelerating;isHeadingOutwardsX&&!isStoppedX||(self.__decelerationVelocityX=scrollOutsideX*penetrationAcceleration)}if(0!==scrollOutsideY){var isHeadingOutwardsY=scrollOutsideY*self.__decelerationVelocityY<=self.__minDecelerationScrollTop;isHeadingOutwardsY&&(self.__decelerationVelocityY+=scrollOutsideY*penetrationDeceleration);var isStoppedY=Math.abs(self.__decelerationVelocityY)<=self.__minVelocityToKeepDecelerating;isHeadingOutwardsY&&!isStoppedY||(self.__decelerationVelocityY=scrollOutsideY*penetrationAcceleration)}}},__getDistance:function(touch1,touch2){var x=touch2.pageX-touch1.pageX,y=touch2.pageY-touch1.pageY;return Math.sqrt(x*x+y*y)},__getScale:function(start,end){return start.length>=2&&end.length>=2?this.__getDistance(end[0],end[1])/this.__getDistance(start[0],start[1]):1}}),ionic.scroll={isScrolling:!1,lastTop:0}}(ionic),function(ionic){var NOOP=function(){},deprecated=function(name){};ionic.views.ScrollNative=ionic.views.View.inherit({initialize:function(options){var self=this;self.__container=self.el=options.el,self.__content=options.el.firstElementChild,self.__frozen=!1,self.isNative=!0,self.__scrollTop=self.el.scrollTop,self.__scrollLeft=self.el.scrollLeft,self.__clientHeight=self.__content.clientHeight,self.__clientWidth=self.__content.clientWidth,self.__maxScrollTop=Math.max(self.__contentHeight-self.__clientHeight,0),self.__maxScrollLeft=Math.max(self.__contentWidth-self.__clientWidth,0),(options.startY>=0||options.startX>=0)&&ionic.requestAnimationFrame(function(){self.el.scrollTop=options.startY||0,self.el.scrollLeft=options.startX||0,self.__scrollTop=self.el.scrollTop,self.__scrollLeft=self.el.scrollLeft}),self.options={freeze:!1,getContentWidth:function(){return Math.max(self.__content.scrollWidth,self.__content.offsetWidth)},getContentHeight:function(){return Math.max(self.__content.scrollHeight,self.__content.offsetHeight+2*self.__content.offsetTop)}};for(var key in options)self.options[key]=options[key];self.onScroll=function(){ionic.scroll.isScrolling||(ionic.scroll.isScrolling=!0),clearTimeout(self.scrollTimer),self.scrollTimer=setTimeout(function(){ionic.scroll.isScrolling=!1},80)},self.freeze=function(shouldFreeze){self.__frozen=shouldFreeze},self.freezeShut=function(shouldFreezeShut){self.__frozenShut=shouldFreezeShut},self.__initEventHandlers()},__callback:function(){deprecated()},zoomTo:function(){deprecated()},zoomBy:function(){deprecated()},activatePullToRefresh:function(){deprecated()},resize:function(continueScrolling){var self=this;self.__container&&self.options&&self.setDimensions(self.__container.clientWidth,self.__container.clientHeight,self.options.getContentWidth(),self.options.getContentHeight(),continueScrolling)},run:function(){this.resize()},getValues:function(){var self=this;return self.update(),{left:self.__scrollLeft,top:self.__scrollTop,zoom:1}},update:function(){var self=this;self.__scrollLeft=self.el.scrollLeft,self.__scrollTop=self.el.scrollTop},setDimensions:function(clientWidth,clientHeight,contentWidth,contentHeight){var self=this;(clientWidth||clientHeight||contentWidth||contentHeight)&&(clientWidth===+clientWidth&&(self.__clientWidth=clientWidth),clientHeight===+clientHeight&&(self.__clientHeight=clientHeight),contentWidth===+contentWidth&&(self.__contentWidth=contentWidth),contentHeight===+contentHeight&&(self.__contentHeight=contentHeight),self.__computeScrollMax())},getScrollMax:function(){return{left:this.__maxScrollLeft,top:this.__maxScrollTop}},scrollBy:function(left,top,animate){var self=this;self.update();var startLeft=self.__isAnimating?self.__scheduledLeft:self.__scrollLeft,startTop=self.__isAnimating?self.__scheduledTop:self.__scrollTop;self.scrollTo(startLeft+(left||0),startTop+(top||0),animate)},scrollTo:function(left,top,animate){var self=this;if(!animate)return self.el.scrollTop=top,self.el.scrollLeft=left,void self.resize();var oldOverflowX=self.el.style.overflowX,oldOverflowY=self.el.style.overflowY;clearTimeout(self.__scrollToCleanupTimeout),self.__scrollToCleanupTimeout=setTimeout(function(){self.el.style.overflowX=oldOverflowX,self.el.style.overflowY=oldOverflowY},500),self.el.style.overflowY="hidden",self.el.style.overflowX="hidden",function(Y,X){function easeOutCubic(t){return--t*t*t+1}function animateScrollStep(){var currentTime=Date.now(),time=Math.min(1,(currentTime-start)/duration),easedT=easeOutCubic(time);fromY!=Y&&(self.el.scrollTop=parseInt(easedT*(Y-fromY)+fromY,10)),fromX!=X&&(self.el.scrollLeft=parseInt(easedT*(X-fromX)+fromX,10)),time<1?ionic.requestAnimationFrame(animateScrollStep):(ionic.tap.removeClonedInputs(self.__container,self),self.el.style.overflowX=oldOverflowX,self.el.style.overflowY=oldOverflowY,self.resize())}var start=Date.now(),duration=250,fromY=self.el.scrollTop,fromX=self.el.scrollLeft;if(fromY===Y&&fromX===X)return self.el.style.overflowX=oldOverflowX,self.el.style.overflowY=oldOverflowY,void self.resize();ionic.requestAnimationFrame(animateScrollStep)}(top,left)},__waitForSize:function(){var self=this;clearTimeout(self.__sizerTimeout);var sizer=function(){self.resize(!0)};sizer(),self.__sizerTimeout=setTimeout(sizer,500)},__computeScrollMax:function(){var self=this;self.__maxScrollLeft=Math.max(self.__contentWidth-self.__clientWidth,0),self.__maxScrollTop=Math.max(self.__contentHeight-self.__clientHeight,0),self.__didWaitForSize||self.__maxScrollLeft||self.__maxScrollTop||(self.__didWaitForSize=!0,self.__waitForSize())},__initEventHandlers:function(){var scrollViewOffsetHeight,lastKeyboardHeight,self=this,container=self.__container;self.scrollChildIntoView=function(e){var rect=container.getBoundingClientRect();self.__originalContainerHeight||(self.__originalContainerHeight=rect.height),scrollViewOffsetHeight=self.__originalContainerHeight;var alreadyShrunk=self.isShrunkForKeyboard,isModal=container.parentNode.classList.contains("modal"),isPopover=container.parentNode.classList.contains("popover"),isInsetModal=isModal&&window.innerWidth>=680,changedKeyboardHeight=lastKeyboardHeight&&lastKeyboardHeight!==e.detail.keyboardHeight;alreadyShrunk&&!changedKeyboardHeight||(!isPopover&&(ionic.Platform.isIOS()||ionic.Platform.isFullScreen||isInsetModal)&&ionic.requestAnimationFrame(function(){scrollViewOffsetHeight=Math.max(0,Math.min(self.__originalContainerHeight,self.__originalContainerHeight-(e.detail.keyboardHeight-43))),container.style.height=scrollViewOffsetHeight+"px",container.classList.add("keyboard-up"),self.resize()}),self.isShrunkForKeyboard=!0),lastKeyboardHeight=e.detail.keyboardHeight,e.detail.isElementUnderKeyboard&&ionic.requestAnimationFrame(function(){var pos=ionic.DomUtil.getOffsetTop(e.detail.target);setTimeout(function(){ionic.Platform.isIOS()&&ionic.tap.cloneFocusedInput(container,self),self.scrollTo(0,pos-(rect.top+100),!0),self.onScroll()},32)}),e.stopPropagation()},self.resetScrollView=function(){self.isShrunkForKeyboard&&(self.isShrunkForKeyboard=!1,container.style.height="",self.__originalContainerHeight=container.getBoundingClientRect().height,ionic.Platform.isIOS()&&ionic.requestAnimationFrame(function(){container.classList.remove("keyboard-up")})),self.resize()},self.handleTouchMove=function(e){if(self.__frozenShut)return e.preventDefault(),e.stopPropagation(),!1},container.addEventListener("scroll",self.onScroll),container.addEventListener("scrollChildIntoView",self.scrollChildIntoView),container.addEventListener(ionic.EVENTS.touchstart,self.handleTouchMove),container.addEventListener(ionic.EVENTS.touchmove,self.handleTouchMove),document.addEventListener("resetScrollView",self.resetScrollView)},__cleanup:function(){var self=this,container=self.__container;container.removeEventListener("resetScrollView",self.resetScrollView),container.removeEventListener("scroll",self.onScroll),container.removeEventListener("scrollChildIntoView",self.scrollChildIntoView),container.removeEventListener("resetScrollView",self.resetScrollView),container.removeEventListener(ionic.EVENTS.touchstart,self.handleTouchMove),container.removeEventListener(ionic.EVENTS.touchmove,self.handleTouchMove),ionic.tap.removeClonedInputs(container,self),delete self.__container,delete self.__content,delete self.__indicatorX,delete self.__indicatorY,delete self.options.el,self.resize=self.scrollTo=self.onScroll=self.resetScrollView=NOOP,self.scrollChildIntoView=NOOP,container=null}})}(ionic),function(ionic){"use strict";var DragOp=function(){};DragOp.prototype={start:function(){},drag:function(){},end:function(){},isSameItem:function(){return!1}};var SlideDrag=function(opts){this.dragThresholdX=opts.dragThresholdX||10,this.el=opts.el,this.item=opts.item,this.canSwipe=opts.canSwipe};(SlideDrag.prototype=new DragOp).start=function(e){var content,buttons,offsetX,buttonsWidth;this.canSwipe()&&(content=e.target.classList.contains("item-content")?e.target:e.target.classList.contains("item")?e.target.querySelector(".item-content"):ionic.DomUtil.getParentWithClass(e.target,"item-content"))&&(content.classList.remove("item-sliding"),offsetX=parseFloat(content.style[ionic.CSS.TRANSFORM].replace("translate3d(","").split(",")[0])||0,(buttons=content.parentNode.querySelector(".item-options"))&&(buttons.classList.remove("invisible"),buttonsWidth=buttons.offsetWidth,this._currentDrag={buttons:buttons,buttonsWidth:buttonsWidth,content:content,startOffsetX:offsetX}))},SlideDrag.prototype.isSameItem=function(op){return!(!op._lastDrag||!this._currentDrag)&&this._currentDrag.content==op._lastDrag.content},SlideDrag.prototype.clean=function(isInstant){function makeInvisible(){lastDrag.buttons&&lastDrag.buttons.classList.add("invisible")}var lastDrag=this._lastDrag;lastDrag&&lastDrag.content&&(lastDrag.content.style[ionic.CSS.TRANSITION]="",lastDrag.content.style[ionic.CSS.TRANSFORM]="",isInstant?(lastDrag.content.style[ionic.CSS.TRANSITION]="none",makeInvisible(),ionic.requestAnimationFrame(function(){lastDrag.content.style[ionic.CSS.TRANSITION]=""})):ionic.requestAnimationFrame(function(){setTimeout(makeInvisible,250)}))},SlideDrag.prototype.drag=ionic.animationFrameThrottle(function(e){var buttonsWidth;if(this._currentDrag&&(!this._isDragging&&(Math.abs(e.gesture.deltaX)>this.dragThresholdX||Math.abs(this._currentDrag.startOffsetX)>0)&&(this._isDragging=!0),this._isDragging)){buttonsWidth=this._currentDrag.buttonsWidth;var newX=Math.min(0,this._currentDrag.startOffsetX+e.gesture.deltaX);newX<-buttonsWidth&&(newX=Math.min(-buttonsWidth,-buttonsWidth+.4*(e.gesture.deltaX+buttonsWidth))),this._currentDrag.content.$$ionicOptionsOpen=0!==newX,this._currentDrag.content.style[ionic.CSS.TRANSFORM]="translate3d("+newX+"px, 0, 0)",this._currentDrag.content.style[ionic.CSS.TRANSITION]="none"}}),SlideDrag.prototype.end=function(e,doneCallback){var self=this;if(self._currentDrag){var restingPoint=-self._currentDrag.buttonsWidth;e.gesture.deltaX>-self._currentDrag.buttonsWidth/2&&("left"==e.gesture.direction&&Math.abs(e.gesture.velocityX)<.3?restingPoint=0:"right"==e.gesture.direction&&(restingPoint=0)),ionic.requestAnimationFrame(function(){if(0===restingPoint){self._currentDrag.content.style[ionic.CSS.TRANSFORM]="";var buttons=self._currentDrag.buttons;setTimeout(function(){buttons&&buttons.classList.add("invisible")},250)}else self._currentDrag.content.style[ionic.CSS.TRANSFORM]="translate3d("+restingPoint+"px,0,0)";self._currentDrag.content.style[ionic.CSS.TRANSITION]="",self._lastDrag||(self._lastDrag={}),ionic.extend(self._lastDrag,self._currentDrag),self._currentDrag&&(self._currentDrag.buttons=null,self._currentDrag.content=null),self._currentDrag=null,doneCallback&&doneCallback()})}else doneCallback&&doneCallback()};var ReorderDrag=function(opts){var self=this;if(self.dragThresholdY=opts.dragThresholdY||0,self.onReorder=opts.onReorder,self.listEl=opts.listEl,self.el=self.item=opts.el,self.scrollEl=opts.scrollEl,self.scrollView=opts.scrollView,self.listElTrueTop=0,self.listEl.offsetParent){var obj=self.listEl;do{self.listElTrueTop+=obj.offsetTop,obj=obj.offsetParent}while(obj)}};(ReorderDrag.prototype=new DragOp)._moveElement=function(e){var y=e.gesture.center.pageY+this.scrollView.getValues().top-this._currentDrag.elementHeight/2-this.listElTrueTop;this.el.style[ionic.CSS.TRANSFORM]="translate3d(0, "+y+"px, 0)"},ReorderDrag.prototype.deregister=function(){this.listEl=this.el=this.scrollEl=this.scrollView=null},ReorderDrag.prototype.start=function(e){var startIndex=ionic.DomUtil.getChildIndex(this.el,this.el.nodeName.toLowerCase()),elementHeight=this.el.scrollHeight,placeholder=this.el.cloneNode(!0);placeholder.classList.add("item-placeholder"),this.el.parentNode.insertBefore(placeholder,this.el),this.el.classList.add("item-reordering"),this._currentDrag={elementHeight:elementHeight,startIndex:startIndex,placeholder:placeholder,scrollHeight:scroll,list:placeholder.parentNode},this._moveElement(e)},ReorderDrag.prototype.drag=ionic.animationFrameThrottle(function(e){var self=this;if(this._currentDrag){var scrollY=0,pageY=e.gesture.center.pageY,offset=this.listElTrueTop;if(this.scrollView){var container=this.scrollView.__container;scrollY=this.scrollView.getValues().top;var containerTop=container.offsetTop,pixelsPastTop=containerTop-pageY+this._currentDrag.elementHeight/2,pixelsPastBottom=pageY+this._currentDrag.elementHeight/2-containerTop-container.offsetHeight;e.gesture.deltaY<0&&pixelsPastTop>0&&scrollY>0&&(this.scrollView.scrollBy(null,-pixelsPastTop),ionic.requestAnimationFrame(function(){self.drag(e)})),e.gesture.deltaY>0&&pixelsPastBottom>0&&scrollY<this.scrollView.getScrollMax().top&&(this.scrollView.scrollBy(null,pixelsPastBottom),ionic.requestAnimationFrame(function(){self.drag(e)}))}!this._isDragging&&Math.abs(e.gesture.deltaY)>this.dragThresholdY&&(this._isDragging=!0),this._isDragging&&(this._moveElement(e),this._currentDrag.currentY=scrollY+pageY-offset)}}),ReorderDrag.prototype._getReorderIndex=function(){for(var el,self=this,siblings=Array.prototype.slice.call(self._currentDrag.placeholder.parentNode.children).filter(function(el){return el.nodeName===self.el.nodeName&&el!==self.el}),dragOffsetTop=self._currentDrag.currentY,i=0,len=siblings.length;i<len;i++)if(el=siblings[i],i===len-1){if(dragOffsetTop>el.offsetTop)return i}else if(0===i){if(dragOffsetTop<el.offsetTop+el.offsetHeight)return i}else if(dragOffsetTop>el.offsetTop-el.offsetHeight/2&&dragOffsetTop<el.offsetTop+el.offsetHeight)return i;return self._currentDrag.startIndex},ReorderDrag.prototype.end=function(e,doneCallback){if(this._currentDrag){var placeholder=this._currentDrag.placeholder,finalIndex=this._getReorderIndex();this.el.classList.remove("item-reordering"),this.el.style[ionic.CSS.TRANSFORM]="",placeholder.parentNode.insertBefore(this.el,placeholder),placeholder.parentNode.removeChild(placeholder),this.onReorder&&this.onReorder(this.el,this._currentDrag.startIndex,finalIndex),this._currentDrag={placeholder:null,content:null},this._currentDrag=null,doneCallback&&doneCallback()}else doneCallback&&doneCallback()},ionic.views.ListView=ionic.views.View.inherit({initialize:function(opts){var self=this;opts=ionic.extend({onReorder:function(){},virtualRemoveThreshold:-200,virtualAddThreshold:200,canSwipe:function(){return!0}},opts),ionic.extend(self,opts),!self.itemHeight&&self.listEl&&(self.itemHeight=self.listEl.children[0]&&parseInt(self.listEl.children[0].style.height,10)),self.onRefresh=opts.onRefresh||function(){},self.onRefreshOpening=opts.onRefreshOpening||function(){},self.onRefreshHolding=opts.onRefreshHolding||function(){};var gestureOpts={};ionic.DomUtil.getParentOrSelfWithClass(self.el,"overflow-scroll")&&(gestureOpts.prevent_default_directions=["left","right"]),window.ionic.onGesture("release",function(e){self._handleEndDrag(e)},self.el,gestureOpts),window.ionic.onGesture("drag",function(e){self._handleDrag(e)},self.el,gestureOpts),self._initDrag()},deregister:function(){this.el=this.listEl=this.scrollEl=this.scrollView=null,this.isScrollFreeze&&self.scrollView.freeze(!1)},stopRefreshing:function(){this.el.querySelector(".list-refresher").style.height="0"},didScroll:function(e){var self=this;if(self.isVirtual){var itemHeight=self.itemHeight,scrollHeight=e.target.scrollHeight,viewportHeight=self.el.parentNode.offsetHeight,highWater=Math.max(0,e.scrollTop+self.virtualRemoveThreshold),lowWater=Math.min(scrollHeight,Math.abs(e.scrollTop)+viewportHeight+self.virtualAddThreshold),first=parseInt(Math.abs(highWater/itemHeight),10),last=parseInt(Math.abs(lowWater/itemHeight),10);self._virtualItemsToRemove=Array.prototype.slice.call(self.listEl.children,0,first),self.renderViewport&&self.renderViewport(highWater,lowWater,first,last)}},didStopScrolling:function(){if(this.isVirtual)for(var i=0;i<this._virtualItemsToRemove.length;i++)this.didHideItem&&this.didHideItem(i)},clearDragEffects:function(isInstant){this._lastDragOp&&(this._lastDragOp.clean&&this._lastDragOp.clean(isInstant),this._lastDragOp.deregister&&this._lastDragOp.deregister(),this._lastDragOp=null)},_initDrag:function(){this._lastDragOp&&this._lastDragOp.deregister&&this._lastDragOp.deregister(),this._lastDragOp=this._dragOp,this._dragOp=null},_getItem:function(target){for(;target;){if(target.classList&&target.classList.contains("item"))return target;target=target.parentNode}return null},_startDrag:function(e){var self=this;self._isDragging=!1;var item,lastDragOp=self._lastDragOp;self._didDragUpOrDown&&lastDragOp instanceof SlideDrag&&lastDragOp.clean&&lastDragOp.clean(),!ionic.DomUtil.getParentOrSelfWithClass(e.target,"item-reorder")||"up"!=e.gesture.direction&&"down"!=e.gesture.direction?!self._didDragUpOrDown&&("left"==e.gesture.direction||"right"==e.gesture.direction)&&Math.abs(e.gesture.deltaX)>5&&(item=self._getItem(e.target))&&item.querySelector(".item-options")&&(self._dragOp=new SlideDrag({el:self.el,item:item,canSwipe:self.canSwipe}),self._dragOp.start(e),e.preventDefault(),self.isScrollFreeze=self.scrollView.freeze(!0)):(item=self._getItem(e.target))&&(self._dragOp=new ReorderDrag({listEl:self.el,el:item,scrollEl:self.scrollEl,scrollView:self.scrollView,onReorder:function(el,start,end){self.onReorder&&self.onReorder(el,start,end)}}),self._dragOp.start(e),e.preventDefault()),lastDragOp&&self._dragOp&&!self._dragOp.isSameItem(lastDragOp)&&e.defaultPrevented&&lastDragOp.clean&&lastDragOp.clean()},_handleEndDrag:function(e){var self=this;self.scrollView&&(self.isScrollFreeze=self.scrollView.freeze(!1)),self._didDragUpOrDown=!1,self._dragOp&&self._dragOp.end(e,function(){self._initDrag()})},_handleDrag:function(e){var self=this;Math.abs(e.gesture.deltaY)>5&&(self._didDragUpOrDown=!0),self.isDragging||self._dragOp||self._startDrag(e),self._dragOp&&(e.gesture.srcEvent.preventDefault(),self._dragOp.drag(e))}})}(ionic),function(ionic){"use strict";ionic.views.Modal=ionic.views.View.inherit({initialize:function(opts){opts=ionic.extend({focusFirstInput:!1,unfocusOnHide:!0,focusFirstDelay:600,backdropClickToClose:!0,hardwareBackButtonClose:!0},opts),ionic.extend(this,opts),this.el=opts.el},show:function(){var self=this;self.focusFirstInput&&window.setTimeout(function(){var input=self.el.querySelector("input, textarea");input&&input.focus&&input.focus()},self.focusFirstDelay)},hide:function(){if(this.unfocusOnHide){var inputs=this.el.querySelectorAll("input, textarea");window.setTimeout(function(){for(var i=0;i<inputs.length;i++)inputs[i].blur&&inputs[i].blur()})}}})}(ionic),function(ionic){"use strict";ionic.views.SideMenu=ionic.views.View.inherit({initialize:function(opts){this.el=opts.el,this.isEnabled=void 0===opts.isEnabled||opts.isEnabled,this.setWidth(opts.width)},getFullWidth:function(){return this.width},setWidth:function(width){this.width=width,this.el.style.width=width+"px"},setIsEnabled:function(isEnabled){this.isEnabled=isEnabled},bringUp:function(){"0"!==this.el.style.zIndex&&(this.el.style.zIndex="0")},pushDown:function(){"-1"!==this.el.style.zIndex&&(this.el.style.zIndex="-1")}}),ionic.views.SideMenuContent=ionic.views.View.inherit({initialize:function(opts){ionic.extend(this,{animationClass:"menu-animated",onDrag:function(){},onEndDrag:function(){}},opts),ionic.onGesture("drag",ionic.proxy(this._onDrag,this),this.el),ionic.onGesture("release",ionic.proxy(this._onEndDrag,this),this.el)},_onDrag:function(e){this.onDrag&&this.onDrag(e)},_onEndDrag:function(e){this.onEndDrag&&this.onEndDrag(e)},disableAnimation:function(){this.el.classList.remove(this.animationClass)},enableAnimation:function(){this.el.classList.add(this.animationClass)},getTranslateX:function(){return parseFloat(this.el.style[ionic.CSS.TRANSFORM].replace("translate3d(","").split(",")[0])},setTranslateX:ionic.animationFrameThrottle(function(x){this.el.style[ionic.CSS.TRANSFORM]="translate3d("+x+"px, 0, 0)"})})}(ionic),function(ionic){"use strict";ionic.views.Slider=ionic.views.View.inherit({initialize:function(options){function setup(){if(container.offsetWidth){slides=element.children,length=slides.length,slides.length<2&&(options.continuous=!1),browser.transitions&&options.continuous&&slides.length<3&&(element.appendChild(slides[0].cloneNode(!0)),element.appendChild(element.children[1].cloneNode(!0)),slides=element.children),slidePos=new Array(slides.length),width=container.offsetWidth||container.getBoundingClientRect().width,element.style.width=slides.length*width+"px";for(var pos=slides.length;pos--;){var slide=slides[pos];slide.style.width=width+"px",slide.setAttribute("data-index",pos),browser.transitions&&(slide.style.left=pos*-width+"px",move(pos,index>pos?-width:index<pos?width:0,0))}options.continuous&&browser.transitions&&(move(circle(index-1),-width,0),move(circle(index+1),width,0)),browser.transitions||(element.style.left=index*-width+"px"),container.style.visibility="visible",options.slidesChanged&&options.slidesChanged()}}function prev(slideSpeed){options.continuous?slide(index-1,slideSpeed):index&&slide(index-1,slideSpeed)}function next(slideSpeed){options.continuous?slide(index+1,slideSpeed):index<slides.length-1&&slide(index+1,slideSpeed)}function circle(index){return(slides.length+index%slides.length)%slides.length}function slide(to,slideSpeed){if(index!=to)if(slides){if(browser.transitions){var direction=Math.abs(index-to)/(index-to);if(options.continuous){var naturalDirection=direction;(direction=-slidePos[circle(to)]/width)!==naturalDirection&&(to=-direction*slides.length+to)}for(var diff=Math.abs(index-to)-1;diff--;)move(circle((to>index?to:index)-diff-1),width*direction,0);to=circle(to),move(index,width*direction,slideSpeed||speed),move(to,0,slideSpeed||speed),options.continuous&&move(circle(to-direction),-width*direction,0)}else to=circle(to),animate(index*-width,to*-width,slideSpeed||speed);index=to,offloadFn(options.callback&&options.callback(index,slides[index]))}else index=to}function move(index,dist,speed){translate(index,dist,speed),slidePos[index]=dist}function translate(index,dist,speed){var slide=slides[index],style=slide&&slide.style;style&&(style.webkitTransitionDuration=style.MozTransitionDuration=style.msTransitionDuration=style.OTransitionDuration=style.transitionDuration=speed+"ms",style.webkitTransform="translate("+dist+"px,0)translateZ(0)",style.msTransform=style.MozTransform=style.OTransform="translateX("+dist+"px)")}function animate(from,to,speed){if(speed)var start=+new Date,timer=setInterval(function(){var timeElap=+new Date-start;if(timeElap>speed)return element.style.left=to+"px",delay&&begin(),options.transitionEnd&&options.transitionEnd.call(event,index,slides[index]),void clearInterval(timer);element.style.left=(to-from)*(Math.floor(timeElap/speed*100)/100)+from+"px"},4);else element.style.left=to+"px"}function begin(){interval=setTimeout(next,delay)}function stop(){delay=options.auto||0,clearTimeout(interval)}var touchStartEvent,touchMoveEvent,touchEndEvent,slider=this;window.navigator.pointerEnabled?(touchStartEvent="pointerdown",touchMoveEvent="pointermove",touchEndEvent="pointerup"):window.navigator.msPointerEnabled?(touchStartEvent="MSPointerDown",touchMoveEvent="MSPointerMove",touchEndEvent="MSPointerUp"):(touchStartEvent="touchstart",touchMoveEvent="touchmove",touchEndEvent="touchend");var noop=function(){},offloadFn=function(fn){setTimeout(fn||noop,0)},browser={addEventListener:!!window.addEventListener,transitions:function(temp){var props=["transitionProperty","WebkitTransition","MozTransition","OTransition","msTransition"];for(var i in props)if(void 0!==temp.style[props[i]])return!0;return!1}(document.createElement("swipe"))},container=options.el;if(container){var slides,slidePos,width,length,element=container.children[0];options=options||{};var index=parseInt(options.startSlide,10)||0,speed=options.speed||300;options.continuous=void 0===options.continuous||options.continuous;var interval,isScrolling,delay=options.auto||0,start={},delta={},events={handleEvent:function(event){switch(!event.touches&&event.pageX&&event.pageY&&(event.touches=[{pageX:event.pageX,pageY:event.pageY}]),event.type){case touchStartEvent:case"mousedown":this.start(event);break;case touchMoveEvent:case"mousemove":this.touchmove(event);break;case touchEndEvent:case"mouseup":offloadFn(this.end(event));break;case"webkitTransitionEnd":case"msTransitionEnd":case"oTransitionEnd":case"otransitionend":case"transitionend":offloadFn(this.transitionEnd(event));break;case"resize":offloadFn(setup)}options.stopPropagation&&event.stopPropagation()},start:function(event){if(event.touches){var touches=event.touches[0];start={x:touches.pageX,y:touches.pageY,time:+new Date},isScrolling=void 0,delta={},element.addEventListener(touchMoveEvent,this,!1),element.addEventListener("mousemove",this,!1),element.addEventListener(touchEndEvent,this,!1),element.addEventListener("mouseup",this,!1),document.addEventListener(touchEndEvent,this,!1),document.addEventListener("mouseup",this,!1)}},touchmove:function(event){if(!(!event.touches||event.touches.length>1||event.scale&&1!==event.scale||slider.slideIsDisabled)){options.disableScroll&&event.preventDefault();var touches=event.touches[0];delta={x:touches.pageX-start.x,y:touches.pageY-start.y},void 0===isScrolling&&(isScrolling=!!(isScrolling||Math.abs(delta.x)<Math.abs(delta.y))),isScrolling||(event.preventDefault(),stop(),options.continuous?(translate(circle(index-1),delta.x+slidePos[circle(index-1)],0),translate(index,delta.x+slidePos[index],0),translate(circle(index+1),delta.x+slidePos[circle(index+1)],0)):(options.bouncing?delta.x=delta.x/(!index&&delta.x>0||index==slides.length-1&&delta.x<0?Math.abs(delta.x)/width+1:1):(width*index-delta.x<0&&(delta.x=Math.min(delta.x,width*index)),Math.abs(delta.x)>width*(slides.length-index-1)&&(delta.x=Math.max(-width*(slides.length-index-1),delta.x))),translate(index-1,delta.x+slidePos[index-1],0),translate(index,delta.x+slidePos[index],0),translate(index+1,delta.x+slidePos[index+1],0)),options.onDrag&&options.onDrag())}},end:function(){var duration=+new Date-start.time,isValidSlide=Number(duration)<250&&Math.abs(delta.x)>20||Math.abs(delta.x)>width/2,isPastBounds=!index&&delta.x>0||index==slides.length-1&&delta.x<0;options.continuous&&(isPastBounds=!1);var direction=delta.x<0;isScrolling||(isValidSlide&&!isPastBounds?(direction?(options.continuous?(move(circle(index-1),-width,0),move(circle(index+2),width,0)):move(index-1,-width,0),move(index,slidePos[index]-width,speed),move(circle(index+1),slidePos[circle(index+1)]-width,speed),index=circle(index+1)):(options.continuous?(move(circle(index+1),width,0),move(circle(index-2),-width,0)):move(index+1,width,0),move(index,slidePos[index]+width,speed),move(circle(index-1),slidePos[circle(index-1)]+width,speed),index=circle(index-1)),options.callback&&options.callback(index,slides[index])):options.continuous?(move(circle(index-1),-width,speed),move(index,0,speed),move(circle(index+1),width,speed)):(move(index-1,-width,speed),move(index,0,speed),move(index+1,width,speed))),element.removeEventListener(touchMoveEvent,events,!1),element.removeEventListener("mousemove",events,!1),element.removeEventListener(touchEndEvent,events,!1),element.removeEventListener("mouseup",events,!1),document.removeEventListener(touchEndEvent,events,!1),document.removeEventListener("mouseup",events,!1),options.onDragEnd&&options.onDragEnd()},transitionEnd:function(event){parseInt(event.target.getAttribute("data-index"),10)==index&&(delay&&begin(),options.transitionEnd&&options.transitionEnd.call(event,index,slides[index]))}};this.update=function(){setTimeout(setup)},this.setup=function(){setup()},this.loop=function(value){return arguments.length&&(options.continuous=!!value),options.continuous},this.enableSlide=function(shouldEnable){return arguments.length&&(this.slideIsDisabled=!shouldEnable),!this.slideIsDisabled},this.slide=this.select=function(to,speed){stop(),slide(to,speed)},this.prev=this.previous=function(){stop(),prev()},this.next=function(){stop(),next()},this.stop=function(){stop()},this.start=function(){begin()},this.autoPlay=function(newDelay){!delay||delay<0?stop():(delay=newDelay,begin())},this.currentIndex=this.selected=function(){return index},this.slidesCount=this.count=function(){return length},this.kill=function(){stop(),element.style.width="",element.style.left="",slides&&(slides=[]),browser.addEventListener?(element.removeEventListener(touchStartEvent,events,!1),element.removeEventListener("mousedown",events,!1),element.removeEventListener("webkitTransitionEnd",events,!1),element.removeEventListener("msTransitionEnd",events,!1),element.removeEventListener("oTransitionEnd",events,!1),element.removeEventListener("otransitionend",events,!1),element.removeEventListener("transitionend",events,!1),window.removeEventListener("resize",events,!1)):window.onresize=null},this.load=function(){setup(),delay&&begin(),browser.addEventListener?(element.addEventListener(touchStartEvent,events,!1),element.addEventListener("mousedown",events,!1),browser.transitions&&(element.addEventListener("webkitTransitionEnd",events,!1),element.addEventListener("msTransitionEnd",events,!1),element.addEventListener("oTransitionEnd",events,!1),element.addEventListener("otransitionend",events,!1),element.addEventListener("transitionend",events,!1)),window.addEventListener("resize",events,!1)):window.onresize=function(){setup()}}}}})}(ionic),function(){"use strict";var $,Swiper=function(container,params,_scope,$compile){function isH(){return"horizontal"===s.params.direction}function round(a){return Math.floor(a)}function autoplay(){s.autoplayTimeoutId=setTimeout(function(){s.params.loop?(s.fixLoop(),s._slideNext()):s.isEnd?params.autoplayStopOnLast?s.stopAutoplay():s._slideTo(0):s._slideNext()},s.params.autoplay)}function findElementInEvent(e,selector){var el=$(e.target);if(!el.is(selector))if("string"==typeof selector)el=el.parents(selector);else if(selector.nodeType){var found;return el.parents().each(function(index,_el){_el===selector&&(found=selector)}),found?selector:void 0}if(0!==el.length)return el[0]}function initObserver(target,options){options=options||{};var observer=new(window.MutationObserver||window.WebkitMutationObserver)(function(mutations){mutations.forEach(function(mutation){s.onResize(!0),s.emit("onObserverUpdate",s,mutation)})});observer.observe(target,{attributes:void 0===options.attributes||options.attributes,childList:void 0===options.childList||options.childList,characterData:void 0===options.characterData||options.characterData}),s.observers.push(observer)}function handleKeyboard(e){e.originalEvent&&(e=e.originalEvent);var kc=e.keyCode||e.charCode;if(!s.params.allowSwipeToNext&&(isH()&&39===kc||!isH()&&40===kc))return!1;if(!s.params.allowSwipeToPrev&&(isH()&&37===kc||!isH()&&38===kc))return!1;if(!(e.shiftKey||e.altKey||e.ctrlKey||e.metaKey||document.activeElement&&document.activeElement.nodeName&&("input"===document.activeElement.nodeName.toLowerCase()||"textarea"===document.activeElement.nodeName.toLowerCase()))){if(37===kc||39===kc||38===kc||40===kc){var inView=!1;if(s.container.parents(".swiper-slide").length>0&&0===s.container.parents(".swiper-slide-active").length)return;var windowScroll={left:window.pageXOffset,top:window.pageYOffset},windowWidth=window.innerWidth,windowHeight=window.innerHeight,swiperOffset=s.container.offset();s.rtl&&(swiperOffset.left=swiperOffset.left-s.container[0].scrollLeft);for(var swiperCoord=[[swiperOffset.left,swiperOffset.top],[swiperOffset.left+s.width,swiperOffset.top],[swiperOffset.left,swiperOffset.top+s.height],[swiperOffset.left+s.width,swiperOffset.top+s.height]],i=0;i<swiperCoord.length;i++){var point=swiperCoord[i];point[0]>=windowScroll.left&&point[0]<=windowScroll.left+windowWidth&&point[1]>=windowScroll.top&&point[1]<=windowScroll.top+windowHeight&&(inView=!0)}if(!inView)return}isH()?(37!==kc&&39!==kc||(e.preventDefault?e.preventDefault():e.returnValue=!1),(39===kc&&!s.rtl||37===kc&&s.rtl)&&s.slideNext(),(37===kc&&!s.rtl||39===kc&&s.rtl)&&s.slidePrev()):(38!==kc&&40!==kc||(e.preventDefault?e.preventDefault():e.returnValue=!1),40===kc&&s.slideNext(),38===kc&&s.slidePrev())}}function handleMousewheel(e){e.originalEvent&&(e=e.originalEvent);var we=s.mousewheel.event,delta=0,rtlFactor=s.rtl?-1:1;if(e.detail)delta=-e.detail;else if("mousewheel"===we)if(s.params.mousewheelForceToAxis)if(isH()){if(!(Math.abs(e.wheelDeltaX)>Math.abs(e.wheelDeltaY)))return;delta=e.wheelDeltaX*rtlFactor}else{if(!(Math.abs(e.wheelDeltaY)>Math.abs(e.wheelDeltaX)))return;delta=e.wheelDeltaY}else delta=Math.abs(e.wheelDeltaX)>Math.abs(e.wheelDeltaY)?-e.wheelDeltaX*rtlFactor:-e.wheelDeltaY;else if("DOMMouseScroll"===we)delta=-e.detail;else if("wheel"===we)if(s.params.mousewheelForceToAxis)if(isH()){if(!(Math.abs(e.deltaX)>Math.abs(e.deltaY)))return;delta=-e.deltaX*rtlFactor}else{if(!(Math.abs(e.deltaY)>Math.abs(e.deltaX)))return;delta=-e.deltaY}else delta=Math.abs(e.deltaX)>Math.abs(e.deltaY)?-e.deltaX*rtlFactor:-e.deltaY;if(0!==delta){if(s.params.mousewheelInvert&&(delta=-delta),s.params.freeMode){var position=s.getWrapperTranslate()+delta*s.params.mousewheelSensitivity,wasBeginning=s.isBeginning,wasEnd=s.isEnd;if(position>=s.minTranslate()&&(position=s.minTranslate()),position<=s.maxTranslate()&&(position=s.maxTranslate()),s.setWrapperTransition(0),s.setWrapperTranslate(position),s.updateProgress(),s.updateActiveIndex(),(!wasBeginning&&s.isBeginning||!wasEnd&&s.isEnd)&&s.updateClasses(),s.params.freeModeSticky&&(clearTimeout(s.mousewheel.timeout),s.mousewheel.timeout=setTimeout(function(){s.slideReset()},300)),0===position||position===s.maxTranslate())return}else{if((new window.Date).getTime()-s.mousewheel.lastScrollTime>60)if(delta<0)if(s.isEnd&&!s.params.loop||s.animating){if(s.params.mousewheelReleaseOnEdges)return!0}else s.slideNext();else if(s.isBeginning&&!s.params.loop||s.animating){if(s.params.mousewheelReleaseOnEdges)return!0}else s.slidePrev();s.mousewheel.lastScrollTime=(new window.Date).getTime()}return s.params.autoplay&&s.stopAutoplay(),e.preventDefault?e.preventDefault():e.returnValue=!1,!1}}function setParallaxTransform(el,progress){el=$(el);var p,pX,pY,rtlFactor=s.rtl?-1:1;p=el.attr("data-swiper-parallax")||"0",pX=el.attr("data-swiper-parallax-x"),pY=el.attr("data-swiper-parallax-y"),pX||pY?(pX=pX||"0",pY=pY||"0"):isH()?(pX=p,pY="0"):(pY=p,pX="0"),pX=pX.indexOf("%")>=0?parseInt(pX,10)*progress*rtlFactor+"%":pX*progress*rtlFactor+"px",pY=pY.indexOf("%")>=0?parseInt(pY,10)*progress+"%":pY*progress+"px",el.transform("translate3d("+pX+", "+pY+",0px)")}function normalizeEventName(eventName){return 0!==eventName.indexOf("on")&&(eventName=eventName[0]!==eventName[0].toUpperCase()?"on"+eventName[0].toUpperCase()+eventName.substring(1):"on"+eventName),eventName}if(!(this instanceof Swiper))return new Swiper(container,params);var defaults={direction:"horizontal",touchEventsTarget:"container",initialSlide:0,speed:300,autoplay:!1,autoplayDisableOnInteraction:!0,iOSEdgeSwipeDetection:!1,iOSEdgeSwipeThreshold:20,freeMode:!1,freeModeMomentum:!0,freeModeMomentumRatio:1,freeModeMomentumBounce:!0,freeModeMomentumBounceRatio:1,freeModeSticky:!1,freeModeMinimumVelocity:.02,autoHeight:!1,setWrapperSize:!1,virtualTranslate:!1,effect:"slide",coverflow:{rotate:50,stretch:0,depth:100,modifier:1,slideShadows:!0},cube:{slideShadows:!0,shadow:!0,shadowOffset:20,shadowScale:.94},fade:{crossFade:!1},parallax:!1,scrollbar:null,scrollbarHide:!0,scrollbarDraggable:!1,scrollbarSnapOnRelease:!1,keyboardControl:!1,mousewheelControl:!1,mousewheelReleaseOnEdges:!1,mousewheelInvert:!1,mousewheelForceToAxis:!1,mousewheelSensitivity:1,hashnav:!1,breakpoints:void 0,spaceBetween:0,slidesPerView:1,slidesPerColumn:1,slidesPerColumnFill:"column",slidesPerGroup:1,centeredSlides:!1,slidesOffsetBefore:0,slidesOffsetAfter:0,roundLengths:!1,touchRatio:1,touchAngle:45,simulateTouch:!0,shortSwipes:!0,longSwipes:!0,longSwipesRatio:.5,longSwipesMs:300,followFinger:!0,onlyExternal:!1,threshold:0,touchMoveStopPropagation:!0,pagination:null,paginationElement:"span",paginationClickable:!1,paginationHide:!1,paginationBulletRender:null,resistance:!0,resistanceRatio:.85,nextButton:null,prevButton:null,watchSlidesProgress:!1,watchSlidesVisibility:!1,grabCursor:!1,preventClicks:!0,preventClicksPropagation:!0,slideToClickedSlide:!1,lazyLoading:!1,lazyLoadingInPrevNext:!1,lazyLoadingOnTransitionStart:!1,preloadImages:!0,updateOnImagesReady:!0,loop:!1,loopAdditionalSlides:0,loopedSlides:null,control:void 0,controlInverse:!1,controlBy:"slide",allowSwipeToPrev:!0,allowSwipeToNext:!0,swipeHandler:null,noSwiping:!0,noSwipingClass:"swiper-no-swiping",slideClass:"swiper-slide",slideActiveClass:"swiper-slide-active",slideVisibleClass:"swiper-slide-visible",slideDuplicateClass:"swiper-slide-duplicate",slideNextClass:"swiper-slide-next",slidePrevClass:"swiper-slide-prev",wrapperClass:"swiper-wrapper",bulletClass:"swiper-pagination-bullet",bulletActiveClass:"swiper-pagination-bullet-active",buttonDisabledClass:"swiper-button-disabled",paginationHiddenClass:"swiper-pagination-hidden",observer:!1,observeParents:!1,a11y:!1,prevSlideMessage:"Previous slide",nextSlideMessage:"Next slide",firstSlideMessage:"This is the first slide",lastSlideMessage:"This is the last slide",paginationBulletMessage:"Go to slide {{index}}",runCallbacksOnInit:!0},initialVirtualTranslate=params&&params.virtualTranslate;params=params||{};var originalParams={};for(var param in params)if("object"!=typeof params[param]||(params[param].nodeType||params[param]===window||params[param]===document||void 0!==Dom7&&params[param]instanceof Dom7||"undefined"!=typeof jQuery&&params[param]instanceof jQuery))originalParams[param]=params[param];else{originalParams[param]={};for(var deepParam in params[param])originalParams[param][deepParam]=params[param][deepParam]}for(var def in defaults)if(void 0===params[def])params[def]=defaults[def];else if("object"==typeof params[def])for(var deepDef in defaults[def])void 0===params[def][deepDef]&&(params[def][deepDef]=defaults[def][deepDef]);var s=this;if(s.params=params,s.originalParams=originalParams,s.classNames=[],void 0!==$&&void 0!==Dom7&&($=Dom7),(void 0!==$||($=void 0===Dom7?window.Dom7||window.Zepto||window.jQuery:Dom7))&&(s.$=$,s.currentBreakpoint=void 0,s.getActiveBreakpoint=function(){if(!s.params.breakpoints)return!1;var point,breakpoint=!1,points=[];for(point in s.params.breakpoints)s.params.breakpoints.hasOwnProperty(point)&&points.push(point);points.sort(function(a,b){return parseInt(a,10)>parseInt(b,10)});for(var i=0;i<points.length;i++)(point=points[i])>=window.innerWidth&&!breakpoint&&(breakpoint=point);return breakpoint||"max"},s.setBreakpoint=function(){var breakpoint=s.getActiveBreakpoint();if(breakpoint&&s.currentBreakpoint!==breakpoint){var breakPointsParams=breakpoint in s.params.breakpoints?s.params.breakpoints[breakpoint]:s.originalParams;for(var param in breakPointsParams)s.params[param]=breakPointsParams[param];s.currentBreakpoint=breakpoint}},s.params.breakpoints&&s.setBreakpoint(),s.container=$(container),0!==s.container.length)){if(!(s.container.length>1)){s.container[0].swiper=s,s.container.data("swiper",s),s.classNames.push("swiper-container-"+s.params.direction),s.params.freeMode&&s.classNames.push("swiper-container-free-mode"),s.support.flexbox||(s.classNames.push("swiper-container-no-flexbox"),s.params.slidesPerColumn=1),s.params.autoHeight&&s.classNames.push("swiper-container-autoheight"),(s.params.parallax||s.params.watchSlidesVisibility)&&(s.params.watchSlidesProgress=!0),["cube","coverflow"].indexOf(s.params.effect)>=0&&(s.support.transforms3d?(s.params.watchSlidesProgress=!0,s.classNames.push("swiper-container-3d")):s.params.effect="slide"),"slide"!==s.params.effect&&s.classNames.push("swiper-container-"+s.params.effect),"cube"===s.params.effect&&(s.params.resistanceRatio=0,s.params.slidesPerView=1,s.params.slidesPerColumn=1,s.params.slidesPerGroup=1,s.params.centeredSlides=!1,s.params.spaceBetween=0,s.params.virtualTranslate=!0,s.params.setWrapperSize=!1),"fade"===s.params.effect&&(s.params.slidesPerView=1,s.params.slidesPerColumn=1,s.params.slidesPerGroup=1,s.params.watchSlidesProgress=!0,s.params.spaceBetween=0,void 0===initialVirtualTranslate&&(s.params.virtualTranslate=!0)),s.params.grabCursor&&s.support.touch&&(s.params.grabCursor=!1),s.wrapper=s.container.children("."+s.params.wrapperClass),s.params.pagination&&(s.paginationContainer=$(s.params.pagination),s.params.paginationClickable&&s.paginationContainer.addClass("swiper-pagination-clickable")),s.rtl=isH()&&("rtl"===s.container[0].dir.toLowerCase()||"rtl"===s.container.css("direction")),s.rtl&&s.classNames.push("swiper-container-rtl"),s.rtl&&(s.wrongRTL="-webkit-box"===s.wrapper.css("display")),s.params.slidesPerColumn>1&&s.classNames.push("swiper-container-multirow"),s.device.android&&s.classNames.push("swiper-container-android"),s.container.addClass(s.classNames.join(" ")),s.translate=0,s.progress=0,s.velocity=0,s.lockSwipeToNext=function(){s.params.allowSwipeToNext=!1},s.lockSwipeToPrev=function(){s.params.allowSwipeToPrev=!1},s.lockSwipes=function(){s.params.allowSwipeToNext=s.params.allowSwipeToPrev=!1},s.unlockSwipeToNext=function(){s.params.allowSwipeToNext=!0},s.unlockSwipeToPrev=function(){s.params.allowSwipeToPrev=!0},s.unlockSwipes=function(){s.params.allowSwipeToNext=s.params.allowSwipeToPrev=!0},s.params.grabCursor&&(s.container[0].style.cursor="move",s.container[0].style.cursor="-webkit-grab",s.container[0].style.cursor="-moz-grab",s.container[0].style.cursor="grab"),s.imagesToLoad=[],s.imagesLoaded=0,s.loadImage=function(imgElement,src,srcset,checkForComplete,callback){function onReady(){callback&&callback()}var image;imgElement.complete&&checkForComplete?onReady():src?((image=new window.Image).onload=onReady,image.onerror=onReady,srcset&&(image.srcset=srcset),src&&(image.src=src)):onReady()},s.preloadImages=function(){s.imagesToLoad=s.container.find("img");for(var i=0;i<s.imagesToLoad.length;i++)s.loadImage(s.imagesToLoad[i],s.imagesToLoad[i].currentSrc||s.imagesToLoad[i].getAttribute("src"),s.imagesToLoad[i].srcset||s.imagesToLoad[i].getAttribute("srcset"),!0,function(){void 0!==s&&null!==s&&(void 0!==s.imagesLoaded&&s.imagesLoaded++,s.imagesLoaded===s.imagesToLoad.length&&(s.params.updateOnImagesReady&&s.update(),s.emit("onImagesReady",s)))})},s.autoplayTimeoutId=void 0,s.autoplaying=!1,s.autoplayPaused=!1,s.startAutoplay=function(){return void 0===s.autoplayTimeoutId&&(!!s.params.autoplay&&(!s.autoplaying&&(s.autoplaying=!0,s.emit("onAutoplayStart",s),void autoplay())))},s.stopAutoplay=function(internal){s.autoplayTimeoutId&&(s.autoplayTimeoutId&&clearTimeout(s.autoplayTimeoutId),s.autoplaying=!1,s.autoplayTimeoutId=void 0,s.emit("onAutoplayStop",s))},s.pauseAutoplay=function(speed){s.autoplayPaused||(s.autoplayTimeoutId&&clearTimeout(s.autoplayTimeoutId),s.autoplayPaused=!0,0===speed?(s.autoplayPaused=!1,autoplay()):s.wrapper.transitionEnd(function(){s&&(s.autoplayPaused=!1,s.autoplaying?autoplay():s.stopAutoplay())}))},s.minTranslate=function(){return-s.snapGrid[0]},s.maxTranslate=function(){return-s.snapGrid[s.snapGrid.length-1]},s.updateAutoHeight=function(){s.slides.eq(s.activeIndex)[0].offsetHeight&&s.wrapper.css("height",s.slides.eq(s.activeIndex)[0].offsetHeight+"px")},s.updateContainerSize=function(){var width,height;width=void 0!==s.params.width?s.params.width:s.container[0].clientWidth,height=void 0!==s.params.height?s.params.height:s.container[0].clientHeight,0===width&&isH()||0===height&&!isH()||(width=width-parseInt(s.container.css("padding-left"),10)-parseInt(s.container.css("padding-right"),10),height=height-parseInt(s.container.css("padding-top"),10)-parseInt(s.container.css("padding-bottom"),10),s.width=width,s.height=height,s.size=isH()?s.width:s.height)},s.updateSlidesSize=function(){s.slides=s.wrapper.children("."+s.params.slideClass),s.snapGrid=[],s.slidesGrid=[],s.slidesSizesGrid=[];var i,spaceBetween=s.params.spaceBetween,slidePosition=-s.params.slidesOffsetBefore,prevSlideSize=0,index=0;"string"==typeof spaceBetween&&spaceBetween.indexOf("%")>=0&&(spaceBetween=parseFloat(spaceBetween.replace("%",""))/100*s.size),s.virtualSize=-spaceBetween,s.rtl?s.slides.css({marginLeft:"",marginTop:""}):s.slides.css({marginRight:"",marginBottom:""});var slidesNumberEvenToRows;s.params.slidesPerColumn>1&&(slidesNumberEvenToRows=Math.floor(s.slides.length/s.params.slidesPerColumn)===s.slides.length/s.params.slidesPerColumn?s.slides.length:Math.ceil(s.slides.length/s.params.slidesPerColumn)*s.params.slidesPerColumn,"auto"!==s.params.slidesPerView&&"row"===s.params.slidesPerColumnFill&&(slidesNumberEvenToRows=Math.max(slidesNumberEvenToRows,s.params.slidesPerView*s.params.slidesPerColumn)));var slideSize,slidesPerColumn=s.params.slidesPerColumn,slidesPerRow=slidesNumberEvenToRows/slidesPerColumn,numFullColumns=slidesPerRow-(s.params.slidesPerColumn*slidesPerRow-s.slides.length);for(i=0;i<s.slides.length;i++){slideSize=0;var slide=s.slides.eq(i);if(s.params.slidesPerColumn>1){var newSlideOrderIndex,column,row;"column"===s.params.slidesPerColumnFill?(row=i-(column=Math.floor(i/slidesPerColumn))*slidesPerColumn,(column>numFullColumns||column===numFullColumns&&row===slidesPerColumn-1)&&++row>=slidesPerColumn&&(row=0,column++),newSlideOrderIndex=column+row*slidesNumberEvenToRows/slidesPerColumn,slide.css({"-webkit-box-ordinal-group":newSlideOrderIndex,"-moz-box-ordinal-group":newSlideOrderIndex,"-ms-flex-order":newSlideOrderIndex,"-webkit-order":newSlideOrderIndex,order:newSlideOrderIndex})):column=i-(row=Math.floor(i/slidesPerRow))*slidesPerRow,slide.css({"margin-top":0!==row&&s.params.spaceBetween&&s.params.spaceBetween+"px"}).attr("data-swiper-column",column).attr("data-swiper-row",row)}"none"!==slide.css("display")&&("auto"===s.params.slidesPerView?(slideSize=isH()?slide.outerWidth(!0):slide.outerHeight(!0),s.params.roundLengths&&(slideSize=round(slideSize))):(slideSize=(s.size-(s.params.slidesPerView-1)*spaceBetween)/s.params.slidesPerView,s.params.roundLengths&&(slideSize=round(slideSize)),isH()?s.slides[i].style.width=slideSize+"px":s.slides[i].style.height=slideSize+"px"),s.slides[i].swiperSlideSize=slideSize,s.slidesSizesGrid.push(slideSize),s.params.centeredSlides?(slidePosition=slidePosition+slideSize/2+prevSlideSize/2+spaceBetween,0===i&&(slidePosition=slidePosition-s.size/2-spaceBetween),Math.abs(slidePosition)<.001&&(slidePosition=0),index%s.params.slidesPerGroup==0&&s.snapGrid.push(slidePosition),s.slidesGrid.push(slidePosition)):(index%s.params.slidesPerGroup==0&&s.snapGrid.push(slidePosition),s.slidesGrid.push(slidePosition),slidePosition=slidePosition+slideSize+spaceBetween),s.virtualSize+=slideSize+spaceBetween,prevSlideSize=slideSize,index++)}s.virtualSize=Math.max(s.virtualSize,s.size)+s.params.slidesOffsetAfter;var newSlidesGrid;if(s.rtl&&s.wrongRTL&&("slide"===s.params.effect||"coverflow"===s.params.effect)&&s.wrapper.css({width:s.virtualSize+s.params.spaceBetween+"px"}),s.support.flexbox&&!s.params.setWrapperSize||(isH()?s.wrapper.css({width:s.virtualSize+s.params.spaceBetween+"px"}):s.wrapper.css({height:s.virtualSize+s.params.spaceBetween+"px"})),s.params.slidesPerColumn>1&&(s.virtualSize=(slideSize+s.params.spaceBetween)*slidesNumberEvenToRows,s.virtualSize=Math.ceil(s.virtualSize/s.params.slidesPerColumn)-s.params.spaceBetween,s.wrapper.css({width:s.virtualSize+s.params.spaceBetween+"px"}),s.params.centeredSlides)){for(newSlidesGrid=[],i=0;i<s.snapGrid.length;i++)s.snapGrid[i]<s.virtualSize+s.snapGrid[0]&&newSlidesGrid.push(s.snapGrid[i]);s.snapGrid=newSlidesGrid}if(!s.params.centeredSlides){for(newSlidesGrid=[],i=0;i<s.snapGrid.length;i++)s.snapGrid[i]<=s.virtualSize-s.size&&newSlidesGrid.push(s.snapGrid[i]);s.snapGrid=newSlidesGrid,Math.floor(s.virtualSize-s.size)>Math.floor(s.snapGrid[s.snapGrid.length-1])&&s.snapGrid.push(s.virtualSize-s.size)}0===s.snapGrid.length&&(s.snapGrid=[0]),0!==s.params.spaceBetween&&(isH()?s.rtl?s.slides.css({marginLeft:spaceBetween+"px"}):s.slides.css({marginRight:spaceBetween+"px"}):s.slides.css({marginBottom:spaceBetween+"px"})),s.params.watchSlidesProgress&&s.updateSlidesOffset()},s.updateSlidesOffset=function(){for(var i=0;i<s.slides.length;i++)s.slides[i].swiperSlideOffset=isH()?s.slides[i].offsetLeft:s.slides[i].offsetTop},s.updateSlidesProgress=function(translate){if(void 0===translate&&(translate=s.translate||0),0!==s.slides.length){void 0===s.slides[0].swiperSlideOffset&&s.updateSlidesOffset();var offsetCenter=-translate;s.rtl&&(offsetCenter=translate),s.slides.removeClass(s.params.slideVisibleClass);for(var i=0;i<s.slides.length;i++){var slide=s.slides[i],slideProgress=(offsetCenter-slide.swiperSlideOffset)/(slide.swiperSlideSize+s.params.spaceBetween);if(s.params.watchSlidesVisibility){var slideBefore=-(offsetCenter-slide.swiperSlideOffset),slideAfter=slideBefore+s.slidesSizesGrid[i];(slideBefore>=0&&slideBefore<s.size||slideAfter>0&&slideAfter<=s.size||slideBefore<=0&&slideAfter>=s.size)&&s.slides.eq(i).addClass(s.params.slideVisibleClass)}slide.progress=s.rtl?-slideProgress:slideProgress}}},s.updateProgress=function(translate){void 0===translate&&(translate=s.translate||0);var translatesDiff=s.maxTranslate()-s.minTranslate(),wasBeginning=s.isBeginning,wasEnd=s.isEnd;0===translatesDiff?(s.progress=0,s.isBeginning=s.isEnd=!0):(s.progress=(translate-s.minTranslate())/translatesDiff,s.isBeginning=s.progress<=0,s.isEnd=s.progress>=1),s.isBeginning&&!wasBeginning&&s.emit("onReachBeginning",s),s.isEnd&&!wasEnd&&s.emit("onReachEnd",s),s.params.watchSlidesProgress&&s.updateSlidesProgress(translate),s.emit("onProgress",s,s.progress)},s.updateActiveIndex=function(){var newActiveIndex,i,snapIndex,translate=s.rtl?s.translate:-s.translate;for(i=0;i<s.slidesGrid.length;i++)void 0!==s.slidesGrid[i+1]?translate>=s.slidesGrid[i]&&translate<s.slidesGrid[i+1]-(s.slidesGrid[i+1]-s.slidesGrid[i])/2?newActiveIndex=i:translate>=s.slidesGrid[i]&&translate<s.slidesGrid[i+1]&&(newActiveIndex=i+1):translate>=s.slidesGrid[i]&&(newActiveIndex=i);(newActiveIndex<0||void 0===newActiveIndex)&&(newActiveIndex=0),(snapIndex=Math.floor(newActiveIndex/s.params.slidesPerGroup))>=s.snapGrid.length&&(snapIndex=s.snapGrid.length-1),newActiveIndex!==s.activeIndex&&(s.snapIndex=snapIndex,s.previousIndex=s.activeIndex,s.activeIndex=newActiveIndex,s.updateClasses())},s.updateClasses=function(){s.slides.removeClass(s.params.slideActiveClass+" "+s.params.slideNextClass+" "+s.params.slidePrevClass);var activeSlide=s.slides.eq(s.activeIndex);if(activeSlide.addClass(s.params.slideActiveClass),activeSlide.next("."+s.params.slideClass).addClass(s.params.slideNextClass),activeSlide.prev("."+s.params.slideClass).addClass(s.params.slidePrevClass),s.bullets&&s.bullets.length>0){s.bullets.removeClass(s.params.bulletActiveClass);var bulletIndex;s.params.loop?((bulletIndex=Math.ceil(s.activeIndex-s.loopedSlides)/s.params.slidesPerGroup)>s.slides.length-1-2*s.loopedSlides&&(bulletIndex-=s.slides.length-2*s.loopedSlides),bulletIndex>s.bullets.length-1&&(bulletIndex-=s.bullets.length)):bulletIndex=void 0!==s.snapIndex?s.snapIndex:s.activeIndex||0,s.paginationContainer.length>1?s.bullets.each(function(){$(this).index()===bulletIndex&&$(this).addClass(s.params.bulletActiveClass)}):s.bullets.eq(bulletIndex).addClass(s.params.bulletActiveClass)}s.params.loop||(s.params.prevButton&&(s.isBeginning?($(s.params.prevButton).addClass(s.params.buttonDisabledClass),s.params.a11y&&s.a11y&&s.a11y.disable($(s.params.prevButton))):($(s.params.prevButton).removeClass(s.params.buttonDisabledClass),s.params.a11y&&s.a11y&&s.a11y.enable($(s.params.prevButton)))),s.params.nextButton&&(s.isEnd?($(s.params.nextButton).addClass(s.params.buttonDisabledClass),s.params.a11y&&s.a11y&&s.a11y.disable($(s.params.nextButton))):($(s.params.nextButton).removeClass(s.params.buttonDisabledClass),s.params.a11y&&s.a11y&&s.a11y.enable($(s.params.nextButton)))))},s.updatePagination=function(){if(s.params.pagination&&s.paginationContainer&&s.paginationContainer.length>0){for(var bulletsHTML="",numberOfBullets=s.params.loop?Math.ceil((s.slides.length-2*s.loopedSlides)/s.params.slidesPerGroup):s.snapGrid.length,i=0;i<numberOfBullets;i++)s.params.paginationBulletRender?bulletsHTML+=s.params.paginationBulletRender(i,s.params.bulletClass):bulletsHTML+="<"+s.params.paginationElement+' class="'+s.params.bulletClass+'"></'+s.params.paginationElement+">";s.paginationContainer.html(bulletsHTML),s.bullets=s.paginationContainer.find("."+s.params.bulletClass),s.params.paginationClickable&&s.params.a11y&&s.a11y&&s.a11y.initPagination()}},s.update=function(updateTranslate){function forceSetTranslate(){newTranslate=Math.min(Math.max(s.translate,s.maxTranslate()),s.minTranslate()),s.setWrapperTranslate(newTranslate),s.updateActiveIndex(),s.updateClasses()}if(s.updateContainerSize(),s.updateSlidesSize(),s.updateProgress(),s.updatePagination(),s.updateClasses(),s.params.scrollbar&&s.scrollbar&&s.scrollbar.set(),updateTranslate){var newTranslate;s.controller&&s.controller.spline&&(s.controller.spline=void 0),s.params.freeMode?(forceSetTranslate(),s.params.autoHeight&&s.updateAutoHeight()):(("auto"===s.params.slidesPerView||s.params.slidesPerView>1)&&s.isEnd&&!s.params.centeredSlides?s.slideTo(s.slides.length-1,0,!1,!0):s.slideTo(s.activeIndex,0,!1,!0))||forceSetTranslate()}else s.params.autoHeight&&s.updateAutoHeight()},s.onResize=function(forceUpdatePagination){s.params.breakpoints&&s.setBreakpoint();var allowSwipeToPrev=s.params.allowSwipeToPrev,allowSwipeToNext=s.params.allowSwipeToNext;if(s.params.allowSwipeToPrev=s.params.allowSwipeToNext=!0,s.updateContainerSize(),s.updateSlidesSize(),("auto"===s.params.slidesPerView||s.params.freeMode||forceUpdatePagination)&&s.updatePagination(),s.params.scrollbar&&s.scrollbar&&s.scrollbar.set(),s.controller&&s.controller.spline&&(s.controller.spline=void 0),s.params.freeMode){var newTranslate=Math.min(Math.max(s.translate,s.maxTranslate()),s.minTranslate());s.setWrapperTranslate(newTranslate),s.updateActiveIndex(),s.updateClasses(),s.params.autoHeight&&s.updateAutoHeight()}else s.updateClasses(),("auto"===s.params.slidesPerView||s.params.slidesPerView>1)&&s.isEnd&&!s.params.centeredSlides?s.slideTo(s.slides.length-1,0,!1,!0):s.slideTo(s.activeIndex,0,!1,!0);s.params.allowSwipeToPrev=allowSwipeToPrev,s.params.allowSwipeToNext=allowSwipeToNext};var desktopEvents=["mousedown","mousemove","mouseup"];window.navigator.pointerEnabled?desktopEvents=["pointerdown","pointermove","pointerup"]:window.navigator.msPointerEnabled&&(desktopEvents=["MSPointerDown","MSPointerMove","MSPointerUp"]),s.touchEvents={start:s.support.touch||!s.params.simulateTouch?"touchstart":desktopEvents[0],move:s.support.touch||!s.params.simulateTouch?"touchmove":desktopEvents[1],end:s.support.touch||!s.params.simulateTouch?"touchend":desktopEvents[2]},(window.navigator.pointerEnabled||window.navigator.msPointerEnabled)&&("container"===s.params.touchEventsTarget?s.container:s.wrapper).addClass("swiper-wp8-"+s.params.direction),s.initEvents=function(detach){var actionDom=detach?"off":"on",action=detach?"removeEventListener":"addEventListener",touchEventsTarget="container"===s.params.touchEventsTarget?s.container[0]:s.wrapper[0],target=s.support.touch?touchEventsTarget:document,moveCapture=!!s.params.nested;s.browser.ie?(touchEventsTarget[action](s.touchEvents.start,s.onTouchStart,!1),target[action](s.touchEvents.move,s.onTouchMove,moveCapture),target[action](s.touchEvents.end,s.onTouchEnd,!1)):(s.support.touch&&(touchEventsTarget[action](s.touchEvents.start,s.onTouchStart,!1),touchEventsTarget[action](s.touchEvents.move,s.onTouchMove,moveCapture),touchEventsTarget[action](s.touchEvents.end,s.onTouchEnd,!1)),!params.simulateTouch||s.device.ios||s.device.android||(touchEventsTarget[action]("mousedown",s.onTouchStart,!1),document[action]("mousemove",s.onTouchMove,moveCapture),document[action]("mouseup",s.onTouchEnd,!1))),window[action]("resize",s.onResize),s.params.nextButton&&($(s.params.nextButton)[actionDom]("click",s.onClickNext),s.params.a11y&&s.a11y&&$(s.params.nextButton)[actionDom]("keydown",s.a11y.onEnterKey)),s.params.prevButton&&($(s.params.prevButton)[actionDom]("click",s.onClickPrev),s.params.a11y&&s.a11y&&$(s.params.prevButton)[actionDom]("keydown",s.a11y.onEnterKey)),s.params.pagination&&s.params.paginationClickable&&($(s.paginationContainer)[actionDom]("click","."+s.params.bulletClass,s.onClickIndex),s.params.a11y&&s.a11y&&$(s.paginationContainer)[actionDom]("keydown","."+s.params.bulletClass,s.a11y.onEnterKey)),(s.params.preventClicks||s.params.preventClicksPropagation)&&touchEventsTarget[action]("click",s.preventClicks,!0)},s.attachEvents=function(detach){s.initEvents()},s.detachEvents=function(){s.initEvents(!0)},s.allowClick=!0,s.preventClicks=function(e){s.allowClick||(s.params.preventClicks&&e.preventDefault(),s.params.preventClicksPropagation&&s.animating&&(e.stopPropagation(),e.stopImmediatePropagation()))},s.onClickNext=function(e){e.preventDefault(),s.isEnd&&!s.params.loop||s.slideNext()},s.onClickPrev=function(e){e.preventDefault(),s.isBeginning&&!s.params.loop||s.slidePrev()},s.onClickIndex=function(e){e.preventDefault();var index=$(this).index()*s.params.slidesPerGroup;s.params.loop&&(index+=s.loopedSlides),s.slideTo(index)},s.updateClickedSlide=function(e){var slide=findElementInEvent(e,"."+s.params.slideClass),slideFound=!1;if(slide)for(var i=0;i<s.slides.length;i++)s.slides[i]===slide&&(slideFound=!0);if(!slide||!slideFound)return s.clickedSlide=void 0,void(s.clickedIndex=void 0);if(s.clickedSlide=slide,s.clickedIndex=$(slide).index(),s.params.slideToClickedSlide&&void 0!==s.clickedIndex&&s.clickedIndex!==s.activeIndex){var realIndex,slideToIndex=s.clickedIndex;if(s.params.loop){if(s.animating)return;realIndex=$(s.clickedSlide).attr("data-swiper-slide-index"),s.params.centeredSlides?slideToIndex<s.loopedSlides-s.params.slidesPerView/2||slideToIndex>s.slides.length-s.loopedSlides+s.params.slidesPerView/2?(s.fixLoop(),slideToIndex=s.wrapper.children("."+s.params.slideClass+'[data-swiper-slide-index="'+realIndex+'"]:not(.swiper-slide-duplicate)').eq(0).index(),setTimeout(function(){s.slideTo(slideToIndex)},0)):s.slideTo(slideToIndex):slideToIndex>s.slides.length-s.params.slidesPerView?(s.fixLoop(),slideToIndex=s.wrapper.children("."+s.params.slideClass+'[data-swiper-slide-index="'+realIndex+'"]:not(.swiper-slide-duplicate)').eq(0).index(),setTimeout(function(){s.slideTo(slideToIndex)},0)):s.slideTo(slideToIndex)}else s.slideTo(slideToIndex)}};var isTouched,isMoved,allowTouchCallbacks,touchStartTime,isScrolling,currentTranslate,startTranslate,allowThresholdMove,clickTimeout,allowMomentumBounce,formElements="input, select, textarea, button",lastClickTime=Date.now(),velocities=[];s.animating=!1,s.touches={startX:0,startY:0,currentX:0,currentY:0,diff:0};var isTouchEvent,startMoving;if(s.onTouchStart=function(e){if(e.originalEvent&&(e=e.originalEvent),(isTouchEvent="touchstart"===e.type)||!("which"in e)||3!==e.which)if(s.params.noSwiping&&findElementInEvent(e,"."+s.params.noSwipingClass))s.allowClick=!0;else if(!s.params.swipeHandler||findElementInEvent(e,s.params.swipeHandler)){var startX=s.touches.currentX="touchstart"===e.type?e.targetTouches[0].pageX:e.pageX,startY=s.touches.currentY="touchstart"===e.type?e.targetTouches[0].pageY:e.pageY;if(!(s.device.ios&&s.params.iOSEdgeSwipeDetection&&startX<=s.params.iOSEdgeSwipeThreshold)){if(isTouched=!0,isMoved=!1,allowTouchCallbacks=!0,isScrolling=void 0,startMoving=void 0,s.touches.startX=startX,s.touches.startY=startY,touchStartTime=Date.now(),s.allowClick=!0,s.updateContainerSize(),s.swipeDirection=void 0,s.params.threshold>0&&(allowThresholdMove=!1),"touchstart"!==e.type){var preventDefault=!0;$(e.target).is(formElements)&&(preventDefault=!1),document.activeElement&&$(document.activeElement).is(formElements)&&document.activeElement.blur(),preventDefault&&e.preventDefault()}s.emit("onTouchStart",s,e)}}},s.onTouchMove=function(e){if(e.originalEvent&&(e=e.originalEvent),!(isTouchEvent&&"mousemove"===e.type||e.preventedByNestedSwiper)){if(s.params.onlyExternal)return s.allowClick=!1,void(isTouched&&(s.touches.startX=s.touches.currentX="touchmove"===e.type?e.targetTouches[0].pageX:e.pageX,s.touches.startY=s.touches.currentY="touchmove"===e.type?e.targetTouches[0].pageY:e.pageY,touchStartTime=Date.now()));if(isTouchEvent&&document.activeElement&&e.target===document.activeElement&&$(e.target).is(formElements))return isMoved=!0,void(s.allowClick=!1);if(allowTouchCallbacks&&s.emit("onTouchMove",s,e),!(e.targetTouches&&e.targetTouches.length>1)){if(s.touches.currentX="touchmove"===e.type?e.targetTouches[0].pageX:e.pageX,s.touches.currentY="touchmove"===e.type?e.targetTouches[0].pageY:e.pageY,void 0===isScrolling){var touchAngle=180*Math.atan2(Math.abs(s.touches.currentY-s.touches.startY),Math.abs(s.touches.currentX-s.touches.startX))/Math.PI;isScrolling=isH()?touchAngle>s.params.touchAngle:90-touchAngle>s.params.touchAngle}if(isScrolling&&s.emit("onTouchMoveOpposite",s,e),void 0===startMoving&&s.browser.ieTouch&&(s.touches.currentX===s.touches.startX&&s.touches.currentY===s.touches.startY||(startMoving=!0)),isTouched)if(isScrolling)isTouched=!1;else if(startMoving||!s.browser.ieTouch){s.allowClick=!1,s.emit("onSliderMove",s,e),e.preventDefault(),s.params.touchMoveStopPropagation&&!s.params.nested&&e.stopPropagation(),isMoved||(params.loop&&s.fixLoop(),startTranslate=s.getWrapperTranslate(),s.setWrapperTransition(0),s.animating&&s.wrapper.trigger("webkitTransitionEnd transitionend oTransitionEnd MSTransitionEnd msTransitionEnd"),s.params.autoplay&&s.autoplaying&&(s.params.autoplayDisableOnInteraction?s.stopAutoplay():s.pauseAutoplay()),allowMomentumBounce=!1,s.params.grabCursor&&(s.container[0].style.cursor="move",s.container[0].style.cursor="-webkit-grabbing",s.container[0].style.cursor="-moz-grabbin",s.container[0].style.cursor="grabbing")),isMoved=!0;var diff=s.touches.diff=isH()?s.touches.currentX-s.touches.startX:s.touches.currentY-s.touches.startY;diff*=s.params.touchRatio,s.rtl&&(diff=-diff),s.swipeDirection=diff>0?"prev":"next",currentTranslate=diff+startTranslate;var disableParentSwiper=!0;if(diff>0&&currentTranslate>s.minTranslate()?(disableParentSwiper=!1,s.params.resistance&&(currentTranslate=s.minTranslate()-1+Math.pow(-s.minTranslate()+startTranslate+diff,s.params.resistanceRatio))):diff<0&&currentTranslate<s.maxTranslate()&&(disableParentSwiper=!1,s.params.resistance&&(currentTranslate=s.maxTranslate()+1-Math.pow(s.maxTranslate()-startTranslate-diff,s.params.resistanceRatio))),disableParentSwiper&&(e.preventedByNestedSwiper=!0),!s.params.allowSwipeToNext&&"next"===s.swipeDirection&&currentTranslate<startTranslate&&(currentTranslate=startTranslate),!s.params.allowSwipeToPrev&&"prev"===s.swipeDirection&&currentTranslate>startTranslate&&(currentTranslate=startTranslate),s.params.followFinger){if(s.params.threshold>0){if(!(Math.abs(diff)>s.params.threshold||allowThresholdMove))return void(currentTranslate=startTranslate);if(!allowThresholdMove)return allowThresholdMove=!0,s.touches.startX=s.touches.currentX,s.touches.startY=s.touches.currentY,currentTranslate=startTranslate,void(s.touches.diff=isH()?s.touches.currentX-s.touches.startX:s.touches.currentY-s.touches.startY)}(s.params.freeMode||s.params.watchSlidesProgress)&&s.updateActiveIndex(),s.params.freeMode&&(0===velocities.length&&velocities.push({position:s.touches[isH()?"startX":"startY"],time:touchStartTime}),velocities.push({position:s.touches[isH()?"currentX":"currentY"],time:(new window.Date).getTime()})),s.updateProgress(currentTranslate),s.setWrapperTranslate(currentTranslate)}}}}},s.onTouchEnd=function(e){if(e.originalEvent&&(e=e.originalEvent),allowTouchCallbacks&&s.emit("onTouchEnd",s,e),allowTouchCallbacks=!1,isTouched){s.params.grabCursor&&isMoved&&isTouched&&(s.container[0].style.cursor="move",s.container[0].style.cursor="-webkit-grab",s.container[0].style.cursor="-moz-grab",s.container[0].style.cursor="grab");var touchEndTime=Date.now(),timeDiff=touchEndTime-touchStartTime;if(s.allowClick&&(s.updateClickedSlide(e),s.emit("onTap",s,e),timeDiff<300&&touchEndTime-lastClickTime>300&&(clickTimeout&&clearTimeout(clickTimeout),clickTimeout=setTimeout(function(){s&&(s.params.paginationHide&&s.paginationContainer.length>0&&!$(e.target).hasClass(s.params.bulletClass)&&s.paginationContainer.toggleClass(s.params.paginationHiddenClass),s.emit("onClick",s,e))},300)),timeDiff<300&&touchEndTime-lastClickTime<300&&(clickTimeout&&clearTimeout(clickTimeout),s.emit("onDoubleTap",s,e))),lastClickTime=Date.now(),setTimeout(function(){s&&(s.allowClick=!0)},0),isTouched&&isMoved&&s.swipeDirection&&0!==s.touches.diff&&currentTranslate!==startTranslate){isTouched=isMoved=!1;var currentPos;if(currentPos=s.params.followFinger?s.rtl?s.translate:-s.translate:-currentTranslate,s.params.freeMode){if(currentPos<-s.minTranslate())return void s.slideTo(s.activeIndex);if(currentPos>-s.maxTranslate())return void(s.slides.length<s.snapGrid.length?s.slideTo(s.snapGrid.length-1):s.slideTo(s.slides.length-1));if(s.params.freeModeMomentum){if(velocities.length>1){var lastMoveEvent=velocities.pop(),velocityEvent=velocities.pop(),distance=lastMoveEvent.position-velocityEvent.position,time=lastMoveEvent.time-velocityEvent.time;s.velocity=distance/time,s.velocity=s.velocity/2,Math.abs(s.velocity)<s.params.freeModeMinimumVelocity&&(s.velocity=0),(time>150||(new window.Date).getTime()-lastMoveEvent.time>300)&&(s.velocity=0)}else s.velocity=0;velocities.length=0;var momentumDuration=1e3*s.params.freeModeMomentumRatio,momentumDistance=s.velocity*momentumDuration,newPosition=s.translate+momentumDistance;s.rtl&&(newPosition=-newPosition);var afterBouncePosition,doBounce=!1,bounceAmount=20*Math.abs(s.velocity)*s.params.freeModeMomentumBounceRatio;if(newPosition<s.maxTranslate())s.params.freeModeMomentumBounce?(newPosition+s.maxTranslate()<-bounceAmount&&(newPosition=s.maxTranslate()-bounceAmount),afterBouncePosition=s.maxTranslate(),doBounce=!0,allowMomentumBounce=!0):newPosition=s.maxTranslate();else if(newPosition>s.minTranslate())s.params.freeModeMomentumBounce?(newPosition-s.minTranslate()>bounceAmount&&(newPosition=s.minTranslate()+bounceAmount),afterBouncePosition=s.minTranslate(),doBounce=!0,allowMomentumBounce=!0):newPosition=s.minTranslate();else if(s.params.freeModeSticky){var nextSlide,j=0;for(j=0;j<s.snapGrid.length;j+=1)if(s.snapGrid[j]>-newPosition){nextSlide=j;break}newPosition=Math.abs(s.snapGrid[nextSlide]-newPosition)<Math.abs(s.snapGrid[nextSlide-1]-newPosition)||"next"===s.swipeDirection?s.snapGrid[nextSlide]:s.snapGrid[nextSlide-1],s.rtl||(newPosition=-newPosition)}if(0!==s.velocity)momentumDuration=s.rtl?Math.abs((-newPosition-s.translate)/s.velocity):Math.abs((newPosition-s.translate)/s.velocity);else if(s.params.freeModeSticky)return void s.slideReset();s.params.freeModeMomentumBounce&&doBounce?(s.updateProgress(afterBouncePosition),s.setWrapperTransition(momentumDuration),s.setWrapperTranslate(newPosition),s.onTransitionStart(),s.animating=!0,s.wrapper.transitionEnd(function(){s&&allowMomentumBounce&&(s.emit("onMomentumBounce",s),s.setWrapperTransition(s.params.speed),s.setWrapperTranslate(afterBouncePosition),s.wrapper.transitionEnd(function(){s&&s.onTransitionEnd()}))})):s.velocity?(s.updateProgress(newPosition),s.setWrapperTransition(momentumDuration),s.setWrapperTranslate(newPosition),s.onTransitionStart(),s.animating||(s.animating=!0,s.wrapper.transitionEnd(function(){s&&s.onTransitionEnd()}))):s.updateProgress(newPosition),s.updateActiveIndex()}(!s.params.freeModeMomentum||timeDiff>=s.params.longSwipesMs)&&(s.updateProgress(),s.updateActiveIndex())}else{var i,stopIndex=0,groupSize=s.slidesSizesGrid[0];for(i=0;i<s.slidesGrid.length;i+=s.params.slidesPerGroup)void 0!==s.slidesGrid[i+s.params.slidesPerGroup]?currentPos>=s.slidesGrid[i]&&currentPos<s.slidesGrid[i+s.params.slidesPerGroup]&&(stopIndex=i,groupSize=s.slidesGrid[i+s.params.slidesPerGroup]-s.slidesGrid[i]):currentPos>=s.slidesGrid[i]&&(stopIndex=i,groupSize=s.slidesGrid[s.slidesGrid.length-1]-s.slidesGrid[s.slidesGrid.length-2]);var ratio=(currentPos-s.slidesGrid[stopIndex])/groupSize;if(timeDiff>s.params.longSwipesMs){if(!s.params.longSwipes)return void s.slideTo(s.activeIndex);"next"===s.swipeDirection&&(ratio>=s.params.longSwipesRatio?s.slideTo(stopIndex+s.params.slidesPerGroup):s.slideTo(stopIndex)),"prev"===s.swipeDirection&&(ratio>1-s.params.longSwipesRatio?s.slideTo(stopIndex+s.params.slidesPerGroup):s.slideTo(stopIndex))}else{if(!s.params.shortSwipes)return void s.slideTo(s.activeIndex);"next"===s.swipeDirection&&s.slideTo(stopIndex+s.params.slidesPerGroup),"prev"===s.swipeDirection&&s.slideTo(stopIndex)}}}else isTouched=isMoved=!1}},s._slideTo=function(slideIndex,speed){return s.slideTo(slideIndex,speed,!0,!0)},s.slideTo=function(slideIndex,speed,runCallbacks,internal){void 0===runCallbacks&&(runCallbacks=!0),void 0===slideIndex&&(slideIndex=0),slideIndex<0&&(slideIndex=0),s.snapIndex=Math.floor(slideIndex/s.params.slidesPerGroup),s.snapIndex>=s.snapGrid.length&&(s.snapIndex=s.snapGrid.length-1);var translate=-s.snapGrid[s.snapIndex];s.params.autoplay&&s.autoplaying&&(internal||!s.params.autoplayDisableOnInteraction?s.pauseAutoplay(speed):s.stopAutoplay()),s.updateProgress(translate);for(var i=0;i<s.slidesGrid.length;i++)-Math.floor(100*translate)>=Math.floor(100*s.slidesGrid[i])&&(slideIndex=i);return!(!s.params.allowSwipeToNext&&translate<s.translate&&translate<s.minTranslate())&&(!(!s.params.allowSwipeToPrev&&translate>s.translate&&translate>s.maxTranslate()&&(s.activeIndex||0)!==slideIndex)&&(void 0===speed&&(speed=s.params.speed),s.previousIndex=s.activeIndex||0,s.activeIndex=slideIndex,s.rtl&&-translate===s.translate||!s.rtl&&translate===s.translate?(s.params.autoHeight&&s.updateAutoHeight(),s.updateClasses(),"slide"!==s.params.effect&&s.setWrapperTranslate(translate),!1):(s.updateClasses(),s.onTransitionStart(runCallbacks),0===speed?(s.setWrapperTranslate(translate),s.setWrapperTransition(0),s.onTransitionEnd(runCallbacks)):(s.setWrapperTranslate(translate),s.setWrapperTransition(speed),s.animating||(s.animating=!0,s.wrapper.transitionEnd(function(){s&&s.onTransitionEnd(runCallbacks)}))),!0)))},s.onTransitionStart=function(runCallbacks){void 0===runCallbacks&&(runCallbacks=!0),s.params.autoHeight&&s.updateAutoHeight(),s.lazy&&s.lazy.onTransitionStart(),runCallbacks&&(s.emit("onTransitionStart",s),s.activeIndex!==s.previousIndex&&(s.emit("onSlideChangeStart",s),s.activeIndex>s.previousIndex?s.emit("onSlideNextStart",s):s.emit("onSlidePrevStart",s)))},s.onTransitionEnd=function(runCallbacks){s.animating=!1,s.setWrapperTransition(0),void 0===runCallbacks&&(runCallbacks=!0),s.lazy&&s.lazy.onTransitionEnd(),runCallbacks&&(s.emit("onTransitionEnd",s),s.activeIndex!==s.previousIndex&&(s.emit("onSlideChangeEnd",s),s.activeIndex>s.previousIndex?s.emit("onSlideNextEnd",s):s.emit("onSlidePrevEnd",s))),s.params.hashnav&&s.hashnav&&s.hashnav.setHash()},s.slideNext=function(runCallbacks,speed,internal){if(s.params.loop){if(s.animating)return!1;s.fixLoop();s.container[0].clientLeft;return s.slideTo(s.activeIndex+s.params.slidesPerGroup,speed,runCallbacks,internal)}return s.slideTo(s.activeIndex+s.params.slidesPerGroup,speed,runCallbacks,internal)},s._slideNext=function(speed){return s.slideNext(!0,speed,!0)},s.slidePrev=function(runCallbacks,speed,internal){if(s.params.loop){if(s.animating)return!1;s.fixLoop();s.container[0].clientLeft;return s.slideTo(s.activeIndex-1,speed,runCallbacks,internal)}return s.slideTo(s.activeIndex-1,speed,runCallbacks,internal)},s._slidePrev=function(speed){return s.slidePrev(!0,speed,!0)},s.slideReset=function(runCallbacks,speed,internal){return s.slideTo(s.activeIndex,speed,runCallbacks)},s.setWrapperTransition=function(duration,byController){s.wrapper.transition(duration),"slide"!==s.params.effect&&s.effects[s.params.effect]&&s.effects[s.params.effect].setTransition(duration),s.params.parallax&&s.parallax&&s.parallax.setTransition(duration),s.params.scrollbar&&s.scrollbar&&s.scrollbar.setTransition(duration),s.params.control&&s.controller&&s.controller.setTransition(duration,byController),s.emit("onSetTransition",s,duration)},s.setWrapperTranslate=function(translate,updateActiveIndex,byController){var x=0,y=0;isH()?x=s.rtl?-translate:translate:y=translate,s.params.roundLengths&&(x=round(x),y=round(y)),s.params.virtualTranslate||(s.support.transforms3d?s.wrapper.transform("translate3d("+x+"px, "+y+"px, 0px)"):s.wrapper.transform("translate("+x+"px, "+y+"px)")),s.translate=isH()?x:y;var translatesDiff=s.maxTranslate()-s.minTranslate();(0===translatesDiff?0:(translate-s.minTranslate())/translatesDiff)!==s.progress&&s.updateProgress(translate),updateActiveIndex&&s.updateActiveIndex(),"slide"!==s.params.effect&&s.effects[s.params.effect]&&s.effects[s.params.effect].setTranslate(s.translate),s.params.parallax&&s.parallax&&s.parallax.setTranslate(s.translate),s.params.scrollbar&&s.scrollbar&&s.scrollbar.setTranslate(s.translate),s.params.control&&s.controller&&s.controller.setTranslate(s.translate,byController),s.emit("onSetTranslate",s,s.translate)},s.getTranslate=function(el,axis){var matrix,curTransform,curStyle,transformMatrix;return void 0===axis&&(axis="x"),s.params.virtualTranslate?s.rtl?-s.translate:s.translate:(curStyle=window.getComputedStyle(el,null),window.WebKitCSSMatrix?((curTransform=curStyle.transform||curStyle.webkitTransform).split(",").length>6&&(curTransform=curTransform.split(", ").map(function(a){return a.replace(",",".")}).join(", ")),transformMatrix=new window.WebKitCSSMatrix("none"===curTransform?"":curTransform)):matrix=(transformMatrix=curStyle.MozTransform||curStyle.OTransform||curStyle.MsTransform||curStyle.msTransform||curStyle.transform||curStyle.getPropertyValue("transform").replace("translate(","matrix(1, 0, 0, 1,")).toString().split(","),"x"===axis&&(curTransform=window.WebKitCSSMatrix?transformMatrix.m41:16===matrix.length?parseFloat(matrix[12]):parseFloat(matrix[4])),"y"===axis&&(curTransform=window.WebKitCSSMatrix?transformMatrix.m42:16===matrix.length?parseFloat(matrix[13]):parseFloat(matrix[5])),s.rtl&&curTransform&&(curTransform=-curTransform),curTransform||0)},s.getWrapperTranslate=function(axis){return void 0===axis&&(axis=isH()?"x":"y"),s.getTranslate(s.wrapper[0],axis)},s.observers=[],s.initObservers=function(){if(s.params.observeParents)for(var containerParents=s.container.parents(),i=0;i<containerParents.length;i++)initObserver(containerParents[i]);initObserver(s.container[0],{childList:!1}),initObserver(s.wrapper[0],{attributes:!1})},s.disconnectObservers=function(){for(var i=0;i<s.observers.length;i++)s.observers[i].disconnect();s.observers=[]},s.createLoop=function(){var toRemove=s.wrapper.children("."+s.params.slideClass+"."+s.params.slideDuplicateClass);angular.element(toRemove).remove();var slides=s.wrapper.children("."+s.params.slideClass);"auto"!==s.params.slidesPerView||s.params.loopedSlides||(s.params.loopedSlides=slides.length),s.loopedSlides=parseInt(s.params.loopedSlides||s.params.slidesPerView,10),s.loopedSlides=s.loopedSlides+s.params.loopAdditionalSlides,s.loopedSlides>slides.length&&(s.loopedSlides=slides.length);var i,scope,newNode,prependSlides=[],appendSlides=[];for(slides.each(function(index,el){var slide=$(this);index<s.loopedSlides&&appendSlides.push(el),index<slides.length&&index>=slides.length-s.loopedSlides&&prependSlides.push(el),slide.attr("data-swiper-slide-index",index)}),i=0;i<appendSlides.length;i++)(newNode=angular.element(appendSlides[i]).clone().addClass(s.params.slideDuplicateClass)).removeAttr("ng-transclude"),newNode.removeAttr("ng-repeat"),scope=angular.element(appendSlides[i]).scope(),newNode=$compile(newNode)(scope),angular.element(s.wrapper).append(newNode);for(i=prependSlides.length-1;i>=0;i--)(newNode=angular.element(prependSlides[i]).clone().addClass(s.params.slideDuplicateClass)).removeAttr("ng-transclude"),newNode.removeAttr("ng-repeat"),scope=angular.element(prependSlides[i]).scope(),newNode=$compile(newNode)(scope),angular.element(s.wrapper).prepend(newNode)},s.destroyLoop=function(){s.wrapper.children("."+s.params.slideClass+"."+s.params.slideDuplicateClass).remove(),s.slides.removeAttr("data-swiper-slide-index")},s.fixLoop=function(){var newIndex;s.activeIndex<s.loopedSlides?(newIndex=s.slides.length-3*s.loopedSlides+s.activeIndex,newIndex+=s.loopedSlides,s.slideTo(newIndex,0,!1,!0)):("auto"===s.params.slidesPerView&&s.activeIndex>=2*s.loopedSlides||s.activeIndex>s.slides.length-2*s.params.slidesPerView)&&(newIndex=-s.slides.length+s.activeIndex+s.loopedSlides,newIndex+=s.loopedSlides,s.slideTo(newIndex,0,!1,!0))},s.appendSlide=function(slides){if(s.params.loop&&s.destroyLoop(),"object"==typeof slides&&slides.length)for(var i=0;i<slides.length;i++)slides[i]&&s.wrapper.append(slides[i]);else s.wrapper.append(slides);s.params.loop&&s.createLoop(),s.params.observer&&s.support.observer||s.update(!0)},s.prependSlide=function(slides){s.params.loop&&s.destroyLoop();var newActiveIndex=s.activeIndex+1;if("object"==typeof slides&&slides.length){for(var i=0;i<slides.length;i++)slides[i]&&s.wrapper.prepend(slides[i]);newActiveIndex=s.activeIndex+slides.length}else s.wrapper.prepend(slides);s.params.loop&&s.createLoop(),s.params.observer&&s.support.observer||s.update(!0),s.slideTo(newActiveIndex,0,!1)},s.removeSlide=function(slidesIndexes){s.params.loop&&(s.destroyLoop(),s.slides=s.wrapper.children("."+s.params.slideClass));var indexToRemove,newActiveIndex=s.activeIndex;if("object"==typeof slidesIndexes&&slidesIndexes.length){for(var i=0;i<slidesIndexes.length;i++)indexToRemove=slidesIndexes[i],s.slides[indexToRemove]&&s.slides.eq(indexToRemove).remove(),indexToRemove<newActiveIndex&&newActiveIndex--;newActiveIndex=Math.max(newActiveIndex,0)}else indexToRemove=slidesIndexes,s.slides[indexToRemove]&&s.slides.eq(indexToRemove).remove(),indexToRemove<newActiveIndex&&newActiveIndex--,newActiveIndex=Math.max(newActiveIndex,0);s.params.loop&&s.createLoop(),s.params.observer&&s.support.observer||s.update(!0),s.params.loop?s.slideTo(newActiveIndex+s.loopedSlides,0,!1):s.slideTo(newActiveIndex,0,!1)},s.removeAllSlides=function(){for(var slidesIndexes=[],i=0;i<s.slides.length;i++)slidesIndexes.push(i);s.removeSlide(slidesIndexes)},s.effects={fade:{setTranslate:function(){for(var i=0;i<s.slides.length;i++){var slide=s.slides.eq(i),tx=-slide[0].swiperSlideOffset;s.params.virtualTranslate||(tx-=s.translate);var ty=0;isH()||(ty=tx,tx=0);var slideOpacity=s.params.fade.crossFade?Math.max(1-Math.abs(slide[0].progress),0):1+Math.min(Math.max(slide[0].progress,-1),0);slide.css({opacity:slideOpacity}).transform("translate3d("+tx+"px, "+ty+"px, 0px)")}},setTransition:function(duration){if(s.slides.transition(duration),s.params.virtualTranslate&&0!==duration){var eventTriggered=!1;s.slides.transitionEnd(function(){if(!eventTriggered&&s){eventTriggered=!0,s.animating=!1;for(var triggerEvents=["webkitTransitionEnd","transitionend","oTransitionEnd","MSTransitionEnd","msTransitionEnd"],i=0;i<triggerEvents.length;i++)s.wrapper.trigger(triggerEvents[i])}})}}},cube:{setTranslate:function(){var cubeShadow,wrapperRotate=0;s.params.cube.shadow&&(isH()?(0===(cubeShadow=s.wrapper.find(".swiper-cube-shadow")).length&&(cubeShadow=$('<div class="swiper-cube-shadow"></div>'),s.wrapper.append(cubeShadow)),cubeShadow.css({height:s.width+"px"})):0===(cubeShadow=s.container.find(".swiper-cube-shadow")).length&&(cubeShadow=$('<div class="swiper-cube-shadow"></div>'),s.container.append(cubeShadow)));for(var i=0;i<s.slides.length;i++){var slide=s.slides.eq(i),slideAngle=90*i,round=Math.floor(slideAngle/360);s.rtl&&(slideAngle=-slideAngle,round=Math.floor(-slideAngle/360));var progress=Math.max(Math.min(slide[0].progress,1),-1),tx=0,ty=0,tz=0;i%4==0?(tx=4*-round*s.size,tz=0):(i-1)%4==0?(tx=0,tz=4*-round*s.size):(i-2)%4==0?(tx=s.size+4*round*s.size,tz=s.size):(i-3)%4==0&&(tx=-s.size,tz=3*s.size+4*s.size*round),s.rtl&&(tx=-tx),isH()||(ty=tx,tx=0);var transform="rotateX("+(isH()?0:-slideAngle)+"deg) rotateY("+(isH()?slideAngle:0)+"deg) translate3d("+tx+"px, "+ty+"px, "+tz+"px)";if(progress<=1&&progress>-1&&(wrapperRotate=90*i+90*progress,s.rtl&&(wrapperRotate=90*-i-90*progress)),slide.transform(transform),s.params.cube.slideShadows){var shadowBefore=isH()?slide.find(".swiper-slide-shadow-left"):slide.find(".swiper-slide-shadow-top"),shadowAfter=isH()?slide.find(".swiper-slide-shadow-right"):slide.find(".swiper-slide-shadow-bottom");0===shadowBefore.length&&(shadowBefore=$('<div class="swiper-slide-shadow-'+(isH()?"left":"top")+'"></div>'),slide.append(shadowBefore)),0===shadowAfter.length&&(shadowAfter=$('<div class="swiper-slide-shadow-'+(isH()?"right":"bottom")+'"></div>'),slide.append(shadowAfter));slide[0].progress;shadowBefore.length&&(shadowBefore[0].style.opacity=-slide[0].progress),shadowAfter.length&&(shadowAfter[0].style.opacity=slide[0].progress)}}if(s.wrapper.css({"-webkit-transform-origin":"50% 50% -"+s.size/2+"px","-moz-transform-origin":"50% 50% -"+s.size/2+"px","-ms-transform-origin":"50% 50% -"+s.size/2+"px","transform-origin":"50% 50% -"+s.size/2+"px"}),s.params.cube.shadow)if(isH())cubeShadow.transform("translate3d(0px, "+(s.width/2+s.params.cube.shadowOffset)+"px, "+-s.width/2+"px) rotateX(90deg) rotateZ(0deg) scale("+s.params.cube.shadowScale+")");else{var shadowAngle=Math.abs(wrapperRotate)-90*Math.floor(Math.abs(wrapperRotate)/90),multiplier=1.5-(Math.sin(2*shadowAngle*Math.PI/360)/2+Math.cos(2*shadowAngle*Math.PI/360)/2),scale1=s.params.cube.shadowScale,scale2=s.params.cube.shadowScale/multiplier,offset=s.params.cube.shadowOffset;cubeShadow.transform("scale3d("+scale1+", 1, "+scale2+") translate3d(0px, "+(s.height/2+offset)+"px, "+-s.height/2/scale2+"px) rotateX(-90deg)")}var zFactor=s.isSafari||s.isUiWebView?-s.size/2:0;s.wrapper.transform("translate3d(0px,0,"+zFactor+"px) rotateX("+(isH()?0:wrapperRotate)+"deg) rotateY("+(isH()?-wrapperRotate:0)+"deg)")},setTransition:function(duration){s.slides.transition(duration).find(".swiper-slide-shadow-top, .swiper-slide-shadow-right, .swiper-slide-shadow-bottom, .swiper-slide-shadow-left").transition(duration),s.params.cube.shadow&&!isH()&&s.container.find(".swiper-cube-shadow").transition(duration)}},coverflow:{setTranslate:function(){for(var transform=s.translate,center=isH()?-transform+s.width/2:-transform+s.height/2,rotate=isH()?s.params.coverflow.rotate:-s.params.coverflow.rotate,translate=s.params.coverflow.depth,i=0,length=s.slides.length;i<length;i++){var slide=s.slides.eq(i),slideSize=s.slidesSizesGrid[i],offsetMultiplier=(center-slide[0].swiperSlideOffset-slideSize/2)/slideSize*s.params.coverflow.modifier,rotateY=isH()?rotate*offsetMultiplier:0,rotateX=isH()?0:rotate*offsetMultiplier,translateZ=-translate*Math.abs(offsetMultiplier),translateY=isH()?0:s.params.coverflow.stretch*offsetMultiplier,translateX=isH()?s.params.coverflow.stretch*offsetMultiplier:0;Math.abs(translateX)<.001&&(translateX=0),Math.abs(translateY)<.001&&(translateY=0),Math.abs(translateZ)<.001&&(translateZ=0),Math.abs(rotateY)<.001&&(rotateY=0),Math.abs(rotateX)<.001&&(rotateX=0);var slideTransform="translate3d("+translateX+"px,"+translateY+"px,"+translateZ+"px)  rotateX("+rotateX+"deg) rotateY("+rotateY+"deg)";if(slide.transform(slideTransform),slide[0].style.zIndex=1-Math.abs(Math.round(offsetMultiplier)),s.params.coverflow.slideShadows){var shadowBefore=isH()?slide.find(".swiper-slide-shadow-left"):slide.find(".swiper-slide-shadow-top"),shadowAfter=isH()?slide.find(".swiper-slide-shadow-right"):slide.find(".swiper-slide-shadow-bottom");0===shadowBefore.length&&(shadowBefore=$('<div class="swiper-slide-shadow-'+(isH()?"left":"top")+'"></div>'),slide.append(shadowBefore)),0===shadowAfter.length&&(shadowAfter=$('<div class="swiper-slide-shadow-'+(isH()?"right":"bottom")+'"></div>'),slide.append(shadowAfter)),shadowBefore.length&&(shadowBefore[0].style.opacity=offsetMultiplier>0?offsetMultiplier:0),shadowAfter.length&&(shadowAfter[0].style.opacity=-offsetMultiplier>0?-offsetMultiplier:0)}}s.browser.ie&&(s.wrapper[0].style.perspectiveOrigin=center+"px 50%")},setTransition:function(duration){s.slides.transition(duration).find(".swiper-slide-shadow-top, .swiper-slide-shadow-right, .swiper-slide-shadow-bottom, .swiper-slide-shadow-left").transition(duration)}}},s.lazy={initialImageLoaded:!1,loadImageInSlide:function(index,loadInDuplicate){if(void 0!==index&&(void 0===loadInDuplicate&&(loadInDuplicate=!0),0!==s.slides.length)){var slide=s.slides.eq(index),img=slide.find(".swiper-lazy:not(.swiper-lazy-loaded):not(.swiper-lazy-loading)");!slide.hasClass("swiper-lazy")||slide.hasClass("swiper-lazy-loaded")||slide.hasClass("swiper-lazy-loading")||(img=img.add(slide[0])),0!==img.length&&img.each(function(){var _img=$(this);_img.addClass("swiper-lazy-loading");var background=_img.attr("data-background"),src=_img.attr("data-src"),srcset=_img.attr("data-srcset");s.loadImage(_img[0],src||background,srcset,!1,function(){if(background?(_img.css("background-image","url("+background+")"),_img.removeAttr("data-background")):(srcset&&(_img.attr("srcset",srcset),_img.removeAttr("data-srcset")),src&&(_img.attr("src",src),_img.removeAttr("data-src"))),_img.addClass("swiper-lazy-loaded").removeClass("swiper-lazy-loading"),slide.find(".swiper-lazy-preloader, .preloader").remove(),s.params.loop&&loadInDuplicate){var slideOriginalIndex=slide.attr("data-swiper-slide-index");if(slide.hasClass(s.params.slideDuplicateClass)){var originalSlide=s.wrapper.children('[data-swiper-slide-index="'+slideOriginalIndex+'"]:not(.'+s.params.slideDuplicateClass+")");s.lazy.loadImageInSlide(originalSlide.index(),!1)}else{var duplicatedSlide=s.wrapper.children("."+s.params.slideDuplicateClass+'[data-swiper-slide-index="'+slideOriginalIndex+'"]');s.lazy.loadImageInSlide(duplicatedSlide.index(),!1)}}s.emit("onLazyImageReady",s,slide[0],_img[0])}),s.emit("onLazyImageLoad",s,slide[0],_img[0])})}},load:function(){var i;if(s.params.watchSlidesVisibility)s.wrapper.children("."+s.params.slideVisibleClass).each(function(){s.lazy.loadImageInSlide($(this).index())});else if(s.params.slidesPerView>1)for(i=s.activeIndex;i<s.activeIndex+s.params.slidesPerView;i++)s.slides[i]&&s.lazy.loadImageInSlide(i);else s.lazy.loadImageInSlide(s.activeIndex);if(s.params.lazyLoadingInPrevNext)if(s.params.slidesPerView>1){for(i=s.activeIndex+s.params.slidesPerView;i<s.activeIndex+s.params.slidesPerView+s.params.slidesPerView;i++)s.slides[i]&&s.lazy.loadImageInSlide(i);for(i=s.activeIndex-s.params.slidesPerView;i<s.activeIndex;i++)s.slides[i]&&s.lazy.loadImageInSlide(i)}else{var nextSlide=s.wrapper.children("."+s.params.slideNextClass);nextSlide.length>0&&s.lazy.loadImageInSlide(nextSlide.index());var prevSlide=s.wrapper.children("."+s.params.slidePrevClass);prevSlide.length>0&&s.lazy.loadImageInSlide(prevSlide.index())}},onTransitionStart:function(){s.params.lazyLoading&&(s.params.lazyLoadingOnTransitionStart||!s.params.lazyLoadingOnTransitionStart&&!s.lazy.initialImageLoaded)&&s.lazy.load()},onTransitionEnd:function(){s.params.lazyLoading&&!s.params.lazyLoadingOnTransitionStart&&s.lazy.load()}},s.scrollbar={isTouched:!1,setDragPosition:function(e){var sb=s.scrollbar,position=(isH()?"touchstart"===e.type||"touchmove"===e.type?e.targetTouches[0].pageX:e.pageX||e.clientX:"touchstart"===e.type||"touchmove"===e.type?e.targetTouches[0].pageY:e.pageY||e.clientY)-sb.track.offset()[isH()?"left":"top"]-sb.dragSize/2,positionMin=-s.minTranslate()*sb.moveDivider,positionMax=-s.maxTranslate()*sb.moveDivider;position<positionMin?position=positionMin:position>positionMax&&(position=positionMax),position=-position/sb.moveDivider,s.updateProgress(position),s.setWrapperTranslate(position,!0)},dragStart:function(e){var sb=s.scrollbar;sb.isTouched=!0,e.preventDefault(),e.stopPropagation(),sb.setDragPosition(e),clearTimeout(sb.dragTimeout),sb.track.transition(0),s.params.scrollbarHide&&sb.track.css("opacity",1),s.wrapper.transition(100),sb.drag.transition(100),s.emit("onScrollbarDragStart",s)},dragMove:function(e){var sb=s.scrollbar;sb.isTouched&&(e.preventDefault?e.preventDefault():e.returnValue=!1,sb.setDragPosition(e),s.wrapper.transition(0),sb.track.transition(0),sb.drag.transition(0),s.emit("onScrollbarDragMove",s))},dragEnd:function(e){var sb=s.scrollbar;sb.isTouched&&(sb.isTouched=!1,s.params.scrollbarHide&&(clearTimeout(sb.dragTimeout),sb.dragTimeout=setTimeout(function(){sb.track.css("opacity",0),sb.track.transition(400)},1e3)),s.emit("onScrollbarDragEnd",s),s.params.scrollbarSnapOnRelease&&s.slideReset())},enableDraggable:function(){var sb=s.scrollbar,target=s.support.touch?sb.track:document;$(sb.track).on(s.touchEvents.start,sb.dragStart),$(target).on(s.touchEvents.move,sb.dragMove),$(target).on(s.touchEvents.end,sb.dragEnd)},disableDraggable:function(){var sb=s.scrollbar,target=s.support.touch?sb.track:document;$(sb.track).off(s.touchEvents.start,sb.dragStart),$(target).off(s.touchEvents.move,sb.dragMove),$(target).off(s.touchEvents.end,sb.dragEnd)},set:function(){if(s.params.scrollbar){var sb=s.scrollbar;sb.track=$(s.params.scrollbar),sb.drag=sb.track.find(".swiper-scrollbar-drag"),0===sb.drag.length&&(sb.drag=$('<div class="swiper-scrollbar-drag"></div>'),sb.track.append(sb.drag)),sb.drag[0].style.width="",sb.drag[0].style.height="",sb.trackSize=isH()?sb.track[0].offsetWidth:sb.track[0].offsetHeight,sb.divider=s.size/s.virtualSize,sb.moveDivider=sb.divider*(sb.trackSize/s.size),sb.dragSize=sb.trackSize*sb.divider,isH()?sb.drag[0].style.width=sb.dragSize+"px":sb.drag[0].style.height=sb.dragSize+"px",sb.divider>=1?sb.track[0].style.display="none":sb.track[0].style.display="",s.params.scrollbarHide&&(sb.track[0].style.opacity=0)}},setTranslate:function(){if(s.params.scrollbar){var newPos,sb=s.scrollbar,newSize=(s.translate,sb.dragSize);newPos=(sb.trackSize-sb.dragSize)*s.progress,s.rtl&&isH()?(newPos=-newPos)>0?(newSize=sb.dragSize-newPos,newPos=0):-newPos+sb.dragSize>sb.trackSize&&(newSize=sb.trackSize+newPos):newPos<0?(newSize=sb.dragSize+newPos,newPos=0):newPos+sb.dragSize>sb.trackSize&&(newSize=sb.trackSize-newPos),isH()?(s.support.transforms3d?sb.drag.transform("translate3d("+newPos+"px, 0, 0)"):sb.drag.transform("translateX("+newPos+"px)"),sb.drag[0].style.width=newSize+"px"):(s.support.transforms3d?sb.drag.transform("translate3d(0px, "+newPos+"px, 0)"):sb.drag.transform("translateY("+newPos+"px)"),sb.drag[0].style.height=newSize+"px"),s.params.scrollbarHide&&(clearTimeout(sb.timeout),sb.track[0].style.opacity=1,sb.timeout=setTimeout(function(){sb.track[0].style.opacity=0,sb.track.transition(400)},1e3))}},setTransition:function(duration){s.params.scrollbar&&s.scrollbar.drag.transition(duration)}},s.controller={LinearSpline:function(x,y){this.x=x,this.y=y,this.lastIndex=x.length-1;var i1,i3;this.x.length;this.interpolate=function(x2){return x2?(i3=binarySearch(this.x,x2),i1=i3-1,(x2-this.x[i1])*(this.y[i3]-this.y[i1])/(this.x[i3]-this.x[i1])+this.y[i1]):0};var binarySearch=function(){var maxIndex,minIndex,guess;return function(array,val){for(minIndex=-1,maxIndex=array.length;maxIndex-minIndex>1;)array[guess=maxIndex+minIndex>>1]<=val?minIndex=guess:maxIndex=guess;return maxIndex}}()},getInterpolateFunction:function(c){s.controller.spline||(s.controller.spline=s.params.loop?new s.controller.LinearSpline(s.slidesGrid,c.slidesGrid):new s.controller.LinearSpline(s.snapGrid,c.snapGrid))},setTranslate:function(translate,byController){function setControlledTranslate(c){translate=c.rtl&&"horizontal"===c.params.direction?-s.translate:s.translate,"slide"===s.params.controlBy&&(s.controller.getInterpolateFunction(c),controlledTranslate=-s.controller.spline.interpolate(-translate)),controlledTranslate&&"container"!==s.params.controlBy||(multiplier=(c.maxTranslate()-c.minTranslate())/(s.maxTranslate()-s.minTranslate()),controlledTranslate=(translate-s.minTranslate())*multiplier+c.minTranslate()),s.params.controlInverse&&(controlledTranslate=c.maxTranslate()-controlledTranslate),c.updateProgress(controlledTranslate),c.setWrapperTranslate(controlledTranslate,!1,s),c.updateActiveIndex()}var multiplier,controlledTranslate,controlled=s.params.control;if(s.isArray(controlled))for(var i=0;i<controlled.length;i++)controlled[i]!==byController&&controlled[i]instanceof Swiper&&setControlledTranslate(controlled[i]);else controlled instanceof Swiper&&byController!==controlled&&setControlledTranslate(controlled)},setTransition:function(duration,byController){function setControlledTransition(c){c.setWrapperTransition(duration,s),0!==duration&&(c.onTransitionStart(),c.wrapper.transitionEnd(function(){controlled&&(c.params.loop&&"slide"===s.params.controlBy&&c.fixLoop(),c.onTransitionEnd())}))}var i,controlled=s.params.control;if(s.isArray(controlled))for(i=0;i<controlled.length;i++)controlled[i]!==byController&&controlled[i]instanceof Swiper&&setControlledTransition(controlled[i]);else controlled instanceof Swiper&&byController!==controlled&&setControlledTransition(controlled)}},s.hashnav={init:function(){if(s.params.hashnav){s.hashnav.initialized=!0;var hash=document.location.hash.replace("#","");if(hash)for(var i=0,length=s.slides.length;i<length;i++){var slide=s.slides.eq(i);if(slide.attr("data-hash")===hash&&!slide.hasClass(s.params.slideDuplicateClass)){var index=slide.index();s.slideTo(index,0,s.params.runCallbacksOnInit,!0)}}}},setHash:function(){s.hashnav.initialized&&s.params.hashnav&&(document.location.hash=s.slides.eq(s.activeIndex).attr("data-hash")||"")}},s.disableKeyboardControl=function(){s.params.keyboardControl=!1,$(document).off("keydown",handleKeyboard)},s.enableKeyboardControl=function(){s.params.keyboardControl=!0,$(document).on("keydown",handleKeyboard)},s.mousewheel={event:!1,lastScrollTime:(new window.Date).getTime()},s.params.mousewheelControl){try{new window.WheelEvent("wheel"),s.mousewheel.event="wheel"}catch(e){}s.mousewheel.event||void 0===document.onmousewheel||(s.mousewheel.event="mousewheel"),s.mousewheel.event||(s.mousewheel.event="DOMMouseScroll")}s.disableMousewheelControl=function(){return!!s.mousewheel.event&&(s.container.off(s.mousewheel.event,handleMousewheel),!0)},s.enableMousewheelControl=function(){return!!s.mousewheel.event&&(s.container.on(s.mousewheel.event,handleMousewheel),!0)},s.parallax={setTranslate:function(){s.container.children("[data-swiper-parallax], [data-swiper-parallax-x], [data-swiper-parallax-y]").each(function(){setParallaxTransform(this,s.progress)}),s.slides.each(function(){var slide=$(this);slide.find("[data-swiper-parallax], [data-swiper-parallax-x], [data-swiper-parallax-y]").each(function(){setParallaxTransform(this,Math.min(Math.max(slide[0].progress,-1),1))})})},setTransition:function(duration){void 0===duration&&(duration=s.params.speed),s.container.find("[data-swiper-parallax], [data-swiper-parallax-x], [data-swiper-parallax-y]").each(function(){var el=$(this),parallaxDuration=parseInt(el.attr("data-swiper-parallax-duration"),10)||duration;0===duration&&(parallaxDuration=0),el.transition(parallaxDuration)})}},s._plugins=[];for(var plugin in s.plugins){var p=s.plugins[plugin](s,s.params[plugin]);p&&s._plugins.push(p)}return s.callPlugins=function(eventName){for(var i=0;i<s._plugins.length;i++)eventName in s._plugins[i]&&s._plugins[i][eventName](arguments[1],arguments[2],arguments[3],arguments[4],arguments[5])},s.emitterEventListeners={},s.emit=function(eventName){s.params[eventName]&&s.params[eventName](arguments[1],arguments[2],arguments[3],arguments[4],arguments[5]);var i;if(s.emitterEventListeners[eventName])for(i=0;i<s.emitterEventListeners[eventName].length;i++)s.emitterEventListeners[eventName][i](arguments[1],arguments[2],arguments[3],arguments[4],arguments[5]);s.callPlugins&&s.callPlugins(eventName,arguments[1],arguments[2],arguments[3],arguments[4],arguments[5])},s.on=function(eventName,handler){return eventName=normalizeEventName(eventName),s.emitterEventListeners[eventName]||(s.emitterEventListeners[eventName]=[]),s.emitterEventListeners[eventName].push(handler),s},s.off=function(eventName,handler){var i;if(eventName=normalizeEventName(eventName),void 0===handler)return s.emitterEventListeners[eventName]=[],s;if(s.emitterEventListeners[eventName]&&0!==s.emitterEventListeners[eventName].length){for(i=0;i<s.emitterEventListeners[eventName].length;i++)s.emitterEventListeners[eventName][i]===handler&&s.emitterEventListeners[eventName].splice(i,1);return s}},s.once=function(eventName,handler){eventName=normalizeEventName(eventName);var _handler=function(){handler(arguments[0],arguments[1],arguments[2],arguments[3],arguments[4]),s.off(eventName,_handler)};return s.on(eventName,_handler),s},s.a11y={makeFocusable:function($el){return $el.attr("tabIndex","0"),$el},addRole:function($el,role){return $el.attr("role",role),$el},addLabel:function($el,label){return $el.attr("aria-label",label),$el},disable:function($el){return $el.attr("aria-disabled",!0),$el},enable:function($el){return $el.attr("aria-disabled",!1),$el},onEnterKey:function(event){13===event.keyCode&&($(event.target).is(s.params.nextButton)?(s.onClickNext(event),s.isEnd?s.a11y.notify(s.params.lastSlideMessage):s.a11y.notify(s.params.nextSlideMessage)):$(event.target).is(s.params.prevButton)&&(s.onClickPrev(event),s.isBeginning?s.a11y.notify(s.params.firstSlideMessage):s.a11y.notify(s.params.prevSlideMessage)),$(event.target).is("."+s.params.bulletClass)&&$(event.target)[0].click())},liveRegion:$('<span class="swiper-notification" aria-live="assertive" aria-atomic="true"></span>'),notify:function(message){var notification=s.a11y.liveRegion;0!==notification.length&&(notification.html(""),notification.html(message))},init:function(){if(s.params.nextButton){var nextButton=$(s.params.nextButton);s.a11y.makeFocusable(nextButton),s.a11y.addRole(nextButton,"button"),s.a11y.addLabel(nextButton,s.params.nextSlideMessage)}if(s.params.prevButton){var prevButton=$(s.params.prevButton);s.a11y.makeFocusable(prevButton),s.a11y.addRole(prevButton,"button"),s.a11y.addLabel(prevButton,s.params.prevSlideMessage)}$(s.container).append(s.a11y.liveRegion)},initPagination:function(){s.params.pagination&&s.params.paginationClickable&&s.bullets&&s.bullets.length&&s.bullets.each(function(){var bullet=$(this);s.a11y.makeFocusable(bullet),s.a11y.addRole(bullet,"button"),s.a11y.addLabel(bullet,s.params.paginationBulletMessage.replace(/{{index}}/,bullet.index()+1))})},destroy:function(){s.a11y.liveRegion&&s.a11y.liveRegion.length>0&&s.a11y.liveRegion.remove()}},s.init=function(){s.params.loop&&s.createLoop(),s.updateContainerSize(),s.updateSlidesSize(),s.updatePagination(),s.params.scrollbar&&s.scrollbar&&(s.scrollbar.set(),s.params.scrollbarDraggable&&s.scrollbar.enableDraggable()),"slide"!==s.params.effect&&s.effects[s.params.effect]&&(s.params.loop||s.updateProgress(),s.effects[s.params.effect].setTranslate()),s.params.loop?s.slideTo(s.params.initialSlide+s.loopedSlides,0,s.params.runCallbacksOnInit):(s.slideTo(s.params.initialSlide,0,s.params.runCallbacksOnInit),0===s.params.initialSlide&&(s.parallax&&s.params.parallax&&s.parallax.setTranslate(),s.lazy&&s.params.lazyLoading&&(s.lazy.load(),s.lazy.initialImageLoaded=!0))),s.attachEvents(),s.params.observer&&s.support.observer&&s.initObservers(),s.params.preloadImages&&!s.params.lazyLoading&&s.preloadImages(),s.params.autoplay&&s.startAutoplay(),s.params.keyboardControl&&s.enableKeyboardControl&&s.enableKeyboardControl(),s.params.mousewheelControl&&s.enableMousewheelControl&&s.enableMousewheelControl(),s.params.hashnav&&s.hashnav&&s.hashnav.init(),s.params.a11y&&s.a11y&&s.a11y.init(),s.emit("onInit",s)},s.cleanupStyles=function(){s.container.removeClass(s.classNames.join(" ")).removeAttr("style"),s.wrapper.removeAttr("style"),s.slides&&s.slides.length&&s.slides.removeClass([s.params.slideVisibleClass,s.params.slideActiveClass,s.params.slideNextClass,s.params.slidePrevClass].join(" ")).removeAttr("style").removeAttr("data-swiper-column").removeAttr("data-swiper-row"),s.paginationContainer&&s.paginationContainer.length&&s.paginationContainer.removeClass(s.params.paginationHiddenClass),s.bullets&&s.bullets.length&&s.bullets.removeClass(s.params.bulletActiveClass),s.params.prevButton&&$(s.params.prevButton).removeClass(s.params.buttonDisabledClass),s.params.nextButton&&$(s.params.nextButton).removeClass(s.params.buttonDisabledClass),s.params.scrollbar&&s.scrollbar&&(s.scrollbar.track&&s.scrollbar.track.length&&s.scrollbar.track.removeAttr("style"),s.scrollbar.drag&&s.scrollbar.drag.length&&s.scrollbar.drag.removeAttr("style"))},s.destroy=function(deleteInstance,cleanupStyles){s.detachEvents(),s.stopAutoplay(),s.params.scrollbar&&s.scrollbar&&s.params.scrollbarDraggable&&s.scrollbar.disableDraggable(),s.params.loop&&s.destroyLoop(),cleanupStyles&&s.cleanupStyles(),s.disconnectObservers(),s.params.keyboardControl&&s.disableKeyboardControl&&s.disableKeyboardControl(),s.params.mousewheelControl&&s.disableMousewheelControl&&s.disableMousewheelControl(),s.params.a11y&&s.a11y&&s.a11y.destroy(),s.emit("onDestroy"),!1!==deleteInstance&&(s=null)},s.init(),s}s.container.each(function(){new Swiper(this,params)})}};Swiper.prototype={isSafari:function(){var ua=navigator.userAgent.toLowerCase();return ua.indexOf("safari")>=0&&ua.indexOf("chrome")<0&&ua.indexOf("android")<0}(),isUiWebView:/(iPhone|iPod|iPad).*AppleWebKit(?!.*Safari)/i.test(navigator.userAgent),isArray:function(arr){return"[object Array]"===Object.prototype.toString.apply(arr)},browser:{ie:window.navigator.pointerEnabled||window.navigator.msPointerEnabled,ieTouch:window.navigator.msPointerEnabled&&window.navigator.msMaxTouchPoints>1||window.navigator.pointerEnabled&&window.navigator.maxTouchPoints>1},device:function(){var ua=navigator.userAgent,android=ua.match(/(Android);?[\s\/]+([\d.]+)?/),ipad=ua.match(/(iPad).*OS\s([\d_]+)/),ipod=ua.match(/(iPod)(.*OS\s([\d_]+))?/),iphone=!ipad&&ua.match(/(iPhone\sOS)\s([\d_]+)/);return{ios:ipad||iphone||ipod,android:android}}(),support:{touch:window.Modernizr&&!0===Modernizr.touch||!!("ontouchstart"in window||window.DocumentTouch&&document instanceof DocumentTouch),transforms3d:window.Modernizr&&!0===Modernizr.csstransforms3d||function(){var div=document.createElement("div").style;return"webkitPerspective"in div||"MozPerspective"in div||"OPerspective"in div||"MsPerspective"in div||"perspective"in div}(),flexbox:function(){for(var div=document.createElement("div").style,styles="alignItems webkitAlignItems webkitBoxAlign msFlexAlign mozBoxAlign webkitFlexDirection msFlexDirection mozBoxDirection mozBoxOrient webkitBoxDirection webkitBoxOrient".split(" "),i=0;i<styles.length;i++)if(styles[i]in div)return!0}(),observer:"MutationObserver"in window||"WebkitMutationObserver"in window},plugins:{}};for(var Dom7=function(){var Dom7=function(arr){var _this=this,i=0;for(i=0;i<arr.length;i++)_this[i]=arr[i];return _this.length=arr.length,this},$=function(selector,context){var arr=[],i=0;if(selector&&!context&&selector instanceof Dom7)return selector;if(selector)if("string"==typeof selector){var els,tempParent,html=selector.trim();if(html.indexOf("<")>=0&&html.indexOf(">")>=0){var toCreate="div";for(0===html.indexOf("<li")&&(toCreate="ul"),0===html.indexOf("<tr")&&(toCreate="tbody"),0!==html.indexOf("<td")&&0!==html.indexOf("<th")||(toCreate="tr"),0===html.indexOf("<tbody")&&(toCreate="table"),0===html.indexOf("<option")&&(toCreate="select"),(tempParent=document.createElement(toCreate)).innerHTML=selector,i=0;i<tempParent.childNodes.length;i++)arr.push(tempParent.childNodes[i])}else for(els=context||"#"!==selector[0]||selector.match(/[ .<>:~]/)?(context||document).querySelectorAll(selector):[document.getElementById(selector.split("#")[1])],i=0;i<els.length;i++)els[i]&&arr.push(els[i])}else if(selector.nodeType||selector===window||selector===document)arr.push(selector);else if(selector.length>0&&selector[0].nodeType)for(i=0;i<selector.length;i++)arr.push(selector[i]);return new Dom7(arr)};return Dom7.prototype={addClass:function(className){if(void 0===className)return this;for(var classes=className.split(" "),i=0;i<classes.length;i++)for(var j=0;j<this.length;j++)this[j].classList.add(classes[i]);return this},removeClass:function(className){for(var classes=className.split(" "),i=0;i<classes.length;i++)for(var j=0;j<this.length;j++)this[j].classList.remove(classes[i]);return this},hasClass:function(className){return!!this[0]&&this[0].classList.contains(className)},toggleClass:function(className){for(var classes=className.split(" "),i=0;i<classes.length;i++)for(var j=0;j<this.length;j++)this[j].classList.toggle(classes[i]);return this},attr:function(attrs,value){if(1===arguments.length&&"string"==typeof attrs)return this[0]?this[0].getAttribute(attrs):void 0;for(var i=0;i<this.length;i++)if(2===arguments.length)this[i].setAttribute(attrs,value);else for(var attrName in attrs)this[i][attrName]=attrs[attrName],this[i].setAttribute(attrName,attrs[attrName]);return this},removeAttr:function(attr){for(var i=0;i<this.length;i++)this[i].removeAttribute(attr);return this},data:function(key,value){if(void 0!==value){for(var i=0;i<this.length;i++){var el=this[i];el.dom7ElementDataStorage||(el.dom7ElementDataStorage={}),el.dom7ElementDataStorage[key]=value}return this}if(this[0]){var dataKey=this[0].getAttribute("data-"+key);return dataKey||(this[0].dom7ElementDataStorage&&key in this[0].dom7ElementDataStorage?this[0].dom7ElementDataStorage[key]:void 0)}},transform:function(transform){for(var i=0;i<this.length;i++){var elStyle=this[i].style;elStyle.webkitTransform=elStyle.MsTransform=elStyle.msTransform=elStyle.MozTransform=elStyle.OTransform=elStyle.transform=transform}return this},transition:function(duration){"string"!=typeof duration&&(duration+="ms");for(var i=0;i<this.length;i++){var elStyle=this[i].style;elStyle.webkitTransitionDuration=elStyle.MsTransitionDuration=elStyle.msTransitionDuration=elStyle.MozTransitionDuration=elStyle.OTransitionDuration=elStyle.transitionDuration=duration}return this},on:function(eventName,targetSelector,listener,capture){function handleLiveEvent(e){var target=e.target;if($(target).is(targetSelector))listener.call(target,e);else for(var parents=$(target).parents(),k=0;k<parents.length;k++)$(parents[k]).is(targetSelector)&&listener.call(parents[k],e)}var i,j,events=eventName.split(" ");for(i=0;i<this.length;i++)if("function"==typeof targetSelector||!1===targetSelector)for("function"==typeof targetSelector&&(listener=arguments[1],capture=arguments[2]||!1),j=0;j<events.length;j++)this[i].addEventListener(events[j],listener,capture);else for(j=0;j<events.length;j++)this[i].dom7LiveListeners||(this[i].dom7LiveListeners=[]),this[i].dom7LiveListeners.push({listener:listener,liveListener:handleLiveEvent}),this[i].addEventListener(events[j],handleLiveEvent,capture);return this},off:function(eventName,targetSelector,listener,capture){for(var events=eventName.split(" "),i=0;i<events.length;i++)for(var j=0;j<this.length;j++)if("function"==typeof targetSelector||!1===targetSelector)"function"==typeof targetSelector&&(listener=arguments[1],capture=arguments[2]||!1),this[j].removeEventListener(events[i],listener,capture);else if(this[j].dom7LiveListeners)for(var k=0;k<this[j].dom7LiveListeners.length;k++)this[j].dom7LiveListeners[k].listener===listener&&this[j].removeEventListener(events[i],this[j].dom7LiveListeners[k].liveListener,capture);return this},once:function(eventName,targetSelector,listener,capture){function proxy(e){listener(e),dom.off(eventName,targetSelector,proxy,capture)}var dom=this;"function"==typeof targetSelector&&(targetSelector=!1,listener=arguments[1],capture=arguments[2]),dom.on(eventName,targetSelector,proxy,capture)},trigger:function(eventName,eventData){for(var i=0;i<this.length;i++){var evt;try{evt=new window.CustomEvent(eventName,{detail:eventData,bubbles:!0,cancelable:!0})}catch(e){(evt=document.createEvent("Event")).initEvent(eventName,!0,!0),evt.detail=eventData}this[i].dispatchEvent(evt)}return this},transitionEnd:function(callback){function fireCallBack(e){if(e.target===this)for(callback.call(this,e),i=0;i<events.length;i++)dom.off(events[i],fireCallBack)}var i,events=["webkitTransitionEnd","transitionend","oTransitionEnd","MSTransitionEnd","msTransitionEnd"],dom=this;if(callback)for(i=0;i<events.length;i++)dom.on(events[i],fireCallBack);return this},width:function(){return this[0]===window?window.innerWidth:this.length>0?parseFloat(this.css("width")):null},outerWidth:function(includeMargins){return this.length>0?includeMargins?this[0].offsetWidth+parseFloat(this.css("margin-right"))+parseFloat(this.css("margin-left")):this[0].offsetWidth:null},height:function(){return this[0]===window?window.innerHeight:this.length>0?parseFloat(this.css("height")):null},outerHeight:function(includeMargins){return this.length>0?includeMargins?this[0].offsetHeight+parseFloat(this.css("margin-top"))+parseFloat(this.css("margin-bottom")):this[0].offsetHeight:null},offset:function(){if(this.length>0){var el=this[0],box=el.getBoundingClientRect(),body=document.body,clientTop=el.clientTop||body.clientTop||0,clientLeft=el.clientLeft||body.clientLeft||0,scrollTop=window.pageYOffset||el.scrollTop,scrollLeft=window.pageXOffset||el.scrollLeft;return{top:box.top+scrollTop-clientTop,left:box.left+scrollLeft-clientLeft}}return null},css:function(props,value){var i;if(1===arguments.length){if("string"!=typeof props){for(i=0;i<this.length;i++)for(var prop in props)this[i].style[prop]=props[prop];return this}if(this[0])return window.getComputedStyle(this[0],null).getPropertyValue(props)}if(2===arguments.length&&"string"==typeof props){for(i=0;i<this.length;i++)this[i].style[props]=value;return this}return this},each:function(callback){for(var i=0;i<this.length;i++)callback.call(this[i],i,this[i]);return this},html:function(html){if(void 0===html)return this[0]?this[0].innerHTML:void 0;for(var i=0;i<this.length;i++)this[i].innerHTML=html;return this},is:function(selector){if(!this[0])return!1;var compareWith,i;if("string"==typeof selector){var el=this[0];if(el===document)return selector===document;if(el===window)return selector===window;if(el.matches)return el.matches(selector);if(el.webkitMatchesSelector)return el.webkitMatchesSelector(selector);if(el.mozMatchesSelector)return el.mozMatchesSelector(selector);if(el.msMatchesSelector)return el.msMatchesSelector(selector);for(compareWith=$(selector),i=0;i<compareWith.length;i++)if(compareWith[i]===this[0])return!0;return!1}if(selector===document)return this[0]===document;if(selector===window)return this[0]===window;if(selector.nodeType||selector instanceof Dom7){for(compareWith=selector.nodeType?[selector]:selector,i=0;i<compareWith.length;i++)if(compareWith[i]===this[0])return!0;return!1}return!1},index:function(){if(this[0]){for(var child=this[0],i=0;null!==(child=child.previousSibling);)1===child.nodeType&&i++;return i}},eq:function(index){if(void 0===index)return this;var returnIndex,length=this.length;return index>length-1?new Dom7([]):index<0?(returnIndex=length+index,new Dom7(returnIndex<0?[]:[this[returnIndex]])):new Dom7([this[index]])},append:function(newChild){var i,j;for(i=0;i<this.length;i++)if("string"==typeof newChild){var tempDiv=document.createElement("div");for(tempDiv.innerHTML=newChild;tempDiv.firstChild;)this[i].appendChild(tempDiv.firstChild)}else if(newChild instanceof Dom7)for(j=0;j<newChild.length;j++)this[i].appendChild(newChild[j]);else this[i].appendChild(newChild);return this},prepend:function(newChild){var i,j;for(i=0;i<this.length;i++)if("string"==typeof newChild){var tempDiv=document.createElement("div");for(tempDiv.innerHTML=newChild,j=tempDiv.childNodes.length-1;j>=0;j--)this[i].insertBefore(tempDiv.childNodes[j],this[i].childNodes[0])}else if(newChild instanceof Dom7)for(j=0;j<newChild.length;j++)this[i].insertBefore(newChild[j],this[i].childNodes[0]);else this[i].insertBefore(newChild,this[i].childNodes[0]);return this},insertBefore:function(selector){for(var before=$(selector),i=0;i<this.length;i++)if(1===before.length)before[0].parentNode.insertBefore(this[i],before[0]);else if(before.length>1)for(var j=0;j<before.length;j++)before[j].parentNode.insertBefore(this[i].cloneNode(!0),before[j])},insertAfter:function(selector){for(var after=$(selector),i=0;i<this.length;i++)if(1===after.length)after[0].parentNode.insertBefore(this[i],after[0].nextSibling);else if(after.length>1)for(var j=0;j<after.length;j++)after[j].parentNode.insertBefore(this[i].cloneNode(!0),after[j].nextSibling)},next:function(selector){return new Dom7(this.length>0?selector?this[0].nextElementSibling&&$(this[0].nextElementSibling).is(selector)?[this[0].nextElementSibling]:[]:this[0].nextElementSibling?[this[0].nextElementSibling]:[]:[])},nextAll:function(selector){var nextEls=[],el=this[0];if(!el)return new Dom7([]);for(;el.nextElementSibling;){var next=el.nextElementSibling;selector?$(next).is(selector)&&nextEls.push(next):nextEls.push(next),el=next}return new Dom7(nextEls)},prev:function(selector){return new Dom7(this.length>0?selector?this[0].previousElementSibling&&$(this[0].previousElementSibling).is(selector)?[this[0].previousElementSibling]:[]:this[0].previousElementSibling?[this[0].previousElementSibling]:[]:[])},prevAll:function(selector){var prevEls=[],el=this[0];if(!el)return new Dom7([]);for(;el.previousElementSibling;){var prev=el.previousElementSibling;selector?$(prev).is(selector)&&prevEls.push(prev):prevEls.push(prev),el=prev}return new Dom7(prevEls)},parent:function(selector){for(var parents=[],i=0;i<this.length;i++)selector?$(this[i].parentNode).is(selector)&&parents.push(this[i].parentNode):parents.push(this[i].parentNode);return $($.unique(parents))},parents:function(selector){for(var parents=[],i=0;i<this.length;i++)for(var parent=this[i].parentNode;parent;)selector?$(parent).is(selector)&&parents.push(parent):parents.push(parent),parent=parent.parentNode;return $($.unique(parents))},find:function(selector){for(var foundElements=[],i=0;i<this.length;i++)for(var found=this[i].querySelectorAll(selector),j=0;j<found.length;j++)foundElements.push(found[j]);return new Dom7(foundElements)},children:function(selector){for(var children=[],i=0;i<this.length;i++)for(var childNodes=this[i].childNodes,j=0;j<childNodes.length;j++)selector?1===childNodes[j].nodeType&&$(childNodes[j]).is(selector)&&children.push(childNodes[j]):1===childNodes[j].nodeType&&children.push(childNodes[j]);return new Dom7($.unique(children))},remove:function(){for(var i=0;i<this.length;i++)this[i].parentNode&&this[i].parentNode.removeChild(this[i]);return this},add:function(){var i,j,dom=this;for(i=0;i<arguments.length;i++){var toAdd=$(arguments[i]);for(j=0;j<toAdd.length;j++)dom[dom.length]=toAdd[j],dom.length++}return dom}},$.fn=Dom7.prototype,$.unique=function(arr){for(var unique=[],i=0;i<arr.length;i++)-1===unique.indexOf(arr[i])&&unique.push(arr[i]);return unique},$}(),swiperDomPlugins=["jQuery","Zepto","Dom7"],i=0;i<swiperDomPlugins.length;i++)window[swiperDomPlugins[i]]&&function(lib){lib.fn.swiper=function(params){var firstInstance;return lib(this).each(function(){var s=new Swiper(this,params);firstInstance||(firstInstance=s)}),firstInstance}}(window[swiperDomPlugins[i]]);var domLib;(domLib=void 0===Dom7?window.Dom7||window.Zepto||window.jQuery:Dom7)&&("transitionEnd"in domLib.fn||(domLib.fn.transitionEnd=function(callback){function fireCallBack(e){if(e.target===this)for(callback.call(this,e),i=0;i<events.length;i++)dom.off(events[i],fireCallBack)}var i,events=["webkitTransitionEnd","transitionend","oTransitionEnd","MSTransitionEnd","msTransitionEnd"],dom=this;if(callback)for(i=0;i<events.length;i++)dom.on(events[i],fireCallBack);return this}),"transform"in domLib.fn||(domLib.fn.transform=function(transform){for(var i=0;i<this.length;i++){var elStyle=this[i].style;elStyle.webkitTransform=elStyle.MsTransform=elStyle.msTransform=elStyle.MozTransform=elStyle.OTransform=elStyle.transform=transform}return this}),"transition"in domLib.fn||(domLib.fn.transition=function(duration){"string"!=typeof duration&&(duration+="ms");for(var i=0;i<this.length;i++){var elStyle=this[i].style;elStyle.webkitTransitionDuration=elStyle.MsTransitionDuration=elStyle.msTransitionDuration=elStyle.MozTransitionDuration=elStyle.OTransitionDuration=elStyle.transitionDuration=duration}return this})),ionic.views.Swiper=Swiper}(),function(ionic){"use strict";ionic.views.Toggle=ionic.views.View.inherit({initialize:function(opts){var self=this;this.el=opts.el,this.checkbox=opts.checkbox,this.track=opts.track,this.handle=opts.handle,this.openPercent=-1,this.onChange=opts.onChange||function(){},this.triggerThreshold=opts.triggerThreshold||20,this.dragStartHandler=function(e){self.dragStart(e)},this.dragHandler=function(e){self.drag(e)},this.holdHandler=function(e){self.hold(e)},this.releaseHandler=function(e){self.release(e)},this.dragStartGesture=ionic.onGesture("dragstart",this.dragStartHandler,this.el),this.dragGesture=ionic.onGesture("drag",this.dragHandler,this.el),this.dragHoldGesture=ionic.onGesture("hold",this.holdHandler,this.el),this.dragReleaseGesture=ionic.onGesture("release",this.releaseHandler,this.el)},destroy:function(){ionic.offGesture(this.dragStartGesture,"dragstart",this.dragStartGesture),ionic.offGesture(this.dragGesture,"drag",this.dragGesture),ionic.offGesture(this.dragHoldGesture,"hold",this.holdHandler),ionic.offGesture(this.dragReleaseGesture,"release",this.releaseHandler)},tap:function(){"disabled"!==this.el.getAttribute("disabled")&&this.val(!this.checkbox.checked)},dragStart:function(e){this.checkbox.disabled||(this._dragInfo={width:this.el.offsetWidth,left:this.el.offsetLeft,right:this.el.offsetLeft+this.el.offsetWidth,triggerX:this.el.offsetWidth/2,initialState:this.checkbox.checked},e.gesture.srcEvent.preventDefault(),this.hold(e))},drag:function(e){var self=this;this._dragInfo&&(e.gesture.srcEvent.preventDefault(),ionic.requestAnimationFrame(function(){if(self._dragInfo){var px=e.gesture.touches[0].pageX-self._dragInfo.left,mx=self._dragInfo.width-self.triggerThreshold;self._dragInfo.initialState?px<self.triggerThreshold?self.setOpenPercent(0):px>self._dragInfo.triggerX&&self.setOpenPercent(100):px<self._dragInfo.triggerX?self.setOpenPercent(0):px>mx&&self.setOpenPercent(100)}}))},endDrag:function(){this._dragInfo=null},hold:function(){this.el.classList.add("dragging")},release:function(e){this.el.classList.remove("dragging"),this.endDrag(e)},setOpenPercent:function(openPercent){if(this.openPercent<0||openPercent<this.openPercent-3||openPercent>this.openPercent+3)if(this.openPercent=openPercent,0===openPercent)this.val(!1);else if(100===openPercent)this.val(!0);else{var openPixel=Math.round(openPercent/100*this.track.offsetWidth-this.handle.offsetWidth);openPixel=openPixel<1?0:openPixel,this.handle.style[ionic.CSS.TRANSFORM]="translate3d("+openPixel+"px,0,0)"}},val:function(value){return!0!==value&&!1!==value||(""!==this.handle.style[ionic.CSS.TRANSFORM]&&(this.handle.style[ionic.CSS.TRANSFORM]=""),this.checkbox.checked=value,this.openPercent=value?100:0,this.onChange&&this.onChange()),this.checkbox.checked}})}(ionic)}(),function(window,document,undefined){"use strict";function minErr(module,ErrorConstructor){return ErrorConstructor=ErrorConstructor||Error,function(){var paramPrefix,i,templateArgs=arguments,code=templateArgs[0],message="["+(module?module+":":"")+code+"] ";for(message+=templateArgs[1].replace(/\{\d+\}/g,function(match){var shiftedIndex=+match.slice(1,-1)+2;return shiftedIndex<templateArgs.length?toDebugString(templateArgs[shiftedIndex]):match}),message+="\nhttp://errors.angularjs.org/1.4.3/"+(module?module+"/":"")+code,i=2,paramPrefix="?";i<templateArgs.length;i++,paramPrefix="&")message+=paramPrefix+"p"+(i-2)+"="+encodeURIComponent(toDebugString(templateArgs[i]));return new ErrorConstructor(message)}}function isArrayLike(obj){if(null==obj||isWindow(obj))return!1;var length="length"in Object(obj)&&obj.length;return!(obj.nodeType!==NODE_TYPE_ELEMENT||!length)||(isString(obj)||isArray(obj)||0===length||"number"==typeof length&&length>0&&length-1 in obj)}function forEach(obj,iterator,context){var key,length;if(obj)if(isFunction(obj))for(key in obj)"prototype"==key||"length"==key||"name"==key||obj.hasOwnProperty&&!obj.hasOwnProperty(key)||iterator.call(context,obj[key],key,obj);else if(isArray(obj)||isArrayLike(obj)){var isPrimitive="object"!=typeof obj;for(key=0,length=obj.length;key<length;key++)(isPrimitive||key in obj)&&iterator.call(context,obj[key],key,obj)}else if(obj.forEach&&obj.forEach!==forEach)obj.forEach(iterator,context,obj);else if(isBlankObject(obj))for(key in obj)iterator.call(context,obj[key],key,obj);else if("function"==typeof obj.hasOwnProperty)for(key in obj)obj.hasOwnProperty(key)&&iterator.call(context,obj[key],key,obj);else for(key in obj)hasOwnProperty.call(obj,key)&&iterator.call(context,obj[key],key,obj);return obj}function forEachSorted(obj,iterator,context){for(var keys=Object.keys(obj).sort(),i=0;i<keys.length;i++)iterator.call(context,obj[keys[i]],keys[i]);return keys}function reverseParams(iteratorFn){return function(value,key){iteratorFn(key,value)}}function nextUid(){return++uid}function setHashKey(obj,h){h?obj.$$hashKey=h:delete obj.$$hashKey}function baseExtend(dst,objs,deep){for(var h=dst.$$hashKey,i=0,ii=objs.length;i<ii;++i){var obj=objs[i];if(isObject(obj)||isFunction(obj))for(var keys=Object.keys(obj),j=0,jj=keys.length;j<jj;j++){var key=keys[j],src=obj[key];deep&&isObject(src)?isDate(src)?dst[key]=new Date(src.valueOf()):(isObject(dst[key])||(dst[key]=isArray(src)?[]:{}),baseExtend(dst[key],[src],!0)):dst[key]=src}}return setHashKey(dst,h),dst}function extend(dst){return baseExtend(dst,slice.call(arguments,1),!1)}function merge(dst){return baseExtend(dst,slice.call(arguments,1),!0)}function toInt(str){return parseInt(str,10)}function inherit(parent,extra){return extend(Object.create(parent),extra)}function noop(){}function identity($){return $}function valueFn(value){return function(){return value}}function hasCustomToString(obj){return isFunction(obj.toString)&&obj.toString!==Object.prototype.toString}function isUndefined(value){return void 0===value}function isDefined(value){return void 0!==value}function isObject(value){return null!==value&&"object"==typeof value}function isBlankObject(value){return null!==value&&"object"==typeof value&&!getPrototypeOf(value)}function isString(value){return"string"==typeof value}function isNumber(value){return"number"==typeof value}function isDate(value){return"[object Date]"===toString.call(value)}function isFunction(value){return"function"==typeof value}function isRegExp(value){return"[object RegExp]"===toString.call(value)}function isWindow(obj){return obj&&obj.window===obj}function isScope(obj){return obj&&obj.$evalAsync&&obj.$watch}function isFile(obj){return"[object File]"===toString.call(obj)}function isFormData(obj){return"[object FormData]"===toString.call(obj)}function isBlob(obj){return"[object Blob]"===toString.call(obj)}function isBoolean(value){return"boolean"==typeof value}function isPromiseLike(obj){return obj&&isFunction(obj.then)}function isTypedArray(value){return TYPED_ARRAY_REGEXP.test(toString.call(value))}function isElement(node){return!(!node||!(node.nodeName||node.prop&&node.attr&&node.find))}function makeMap(str){var i,obj={},items=str.split(",");for(i=0;i<items.length;i++)obj[items[i]]=!0;return obj}function nodeName_(element){return lowercase(element.nodeName||element[0]&&element[0].nodeName)}function arrayRemove(array,value){var index=array.indexOf(value);return index>=0&&array.splice(index,1),index}function copy(source,destination,stackSource,stackDest){if(isWindow(source)||isScope(source))throw ngMinErr("cpws","Can't copy! Making copies of Window or Scope instances is not supported.");if(isTypedArray(destination))throw ngMinErr("cpta","Can't copy! TypedArray destination cannot be mutated.");if(destination){if(source===destination)throw ngMinErr("cpi","Can't copy! Source and destination are identical.");stackSource=stackSource||[],stackDest=stackDest||[],isObject(source)&&(stackSource.push(source),stackDest.push(destination));var key;if(isArray(source)){destination.length=0;for(var i=0;i<source.length;i++)destination.push(copy(source[i],null,stackSource,stackDest))}else{var h=destination.$$hashKey;if(isArray(destination)?destination.length=0:forEach(destination,function(value,key){delete destination[key]}),isBlankObject(source))for(key in source)destination[key]=copy(source[key],null,stackSource,stackDest);else if(source&&"function"==typeof source.hasOwnProperty)for(key in source)source.hasOwnProperty(key)&&(destination[key]=copy(source[key],null,stackSource,stackDest));else for(key in source)hasOwnProperty.call(source,key)&&(destination[key]=copy(source[key],null,stackSource,stackDest));setHashKey(destination,h)}}else if(destination=source,isObject(source)){var index;if(stackSource&&-1!==(index=stackSource.indexOf(source)))return stackDest[index];if(isArray(source))return copy(source,[],stackSource,stackDest);if(isTypedArray(source))destination=new source.constructor(source);else if(isDate(source))destination=new Date(source.getTime());else{if(!isRegExp(source))return copy(source,Object.create(getPrototypeOf(source)),stackSource,stackDest);(destination=new RegExp(source.source,source.toString().match(/[^\/]*$/)[0])).lastIndex=source.lastIndex}stackDest&&(stackSource.push(source),stackDest.push(destination))}return destination}function shallowCopy(src,dst){if(isArray(src)){dst=dst||[];for(var i=0,ii=src.length;i<ii;i++)dst[i]=src[i]}else if(isObject(src)){dst=dst||{};for(var key in src)"$"===key.charAt(0)&&"$"===key.charAt(1)||(dst[key]=src[key])}return dst||src}function equals(o1,o2){if(o1===o2)return!0;if(null===o1||null===o2)return!1;if(o1!==o1&&o2!==o2)return!0;var length,key,keySet,t1=typeof o1;if(t1==typeof o2&&"object"==t1){if(!isArray(o1)){if(isDate(o1))return!!isDate(o2)&&equals(o1.getTime(),o2.getTime());if(isRegExp(o1))return!!isRegExp(o2)&&o1.toString()==o2.toString();if(isScope(o1)||isScope(o2)||isWindow(o1)||isWindow(o2)||isArray(o2)||isDate(o2)||isRegExp(o2))return!1;keySet=createMap();for(key in o1)if("$"!==key.charAt(0)&&!isFunction(o1[key])){if(!equals(o1[key],o2[key]))return!1;keySet[key]=!0}for(key in o2)if(!(key in keySet||"$"===key.charAt(0)||o2[key]===undefined||isFunction(o2[key])))return!1;return!0}if(!isArray(o2))return!1;if((length=o1.length)==o2.length){for(key=0;key<length;key++)if(!equals(o1[key],o2[key]))return!1;return!0}}return!1}function concat(array1,array2,index){return array1.concat(slice.call(array2,index))}function sliceArgs(args,startIndex){return slice.call(args,startIndex||0)}function bind(self,fn){var curryArgs=arguments.length>2?sliceArgs(arguments,2):[];return!isFunction(fn)||fn instanceof RegExp?fn:curryArgs.length?function(){return arguments.length?fn.apply(self,concat(curryArgs,arguments,0)):fn.apply(self,curryArgs)}:function(){return arguments.length?fn.apply(self,arguments):fn.call(self)}}function toJsonReplacer(key,value){var val=value;return"string"==typeof key&&"$"===key.charAt(0)&&"$"===key.charAt(1)?val=undefined:isWindow(value)?val="$WINDOW":value&&document===value?val="$DOCUMENT":isScope(value)&&(val="$SCOPE"),val}function toJson(obj,pretty){return void 0===obj?undefined:(isNumber(pretty)||(pretty=pretty?2:null),JSON.stringify(obj,toJsonReplacer,pretty))}function fromJson(json){return isString(json)?JSON.parse(json):json}function timezoneToOffset(timezone,fallback){var requestedTimezoneOffset=Date.parse("Jan 01, 1970 00:00:00 "+timezone)/6e4;return isNaN(requestedTimezoneOffset)?fallback:requestedTimezoneOffset}function addDateMinutes(date,minutes){return(date=new Date(date.getTime())).setMinutes(date.getMinutes()+minutes),date}function convertTimezoneToLocal(date,timezone,reverse){return addDateMinutes(date,(reverse=reverse?-1:1)*(timezoneToOffset(timezone,date.getTimezoneOffset())-date.getTimezoneOffset()))}function startingTag(element){element=jqLite(element).clone();try{element.empty()}catch(e){}var elemHtml=jqLite("<div>").append(element).html();try{return element[0].nodeType===NODE_TYPE_TEXT?lowercase(elemHtml):elemHtml.match(/^(<[^>]+>)/)[1].replace(/^<([\w\-]+)/,function(match,nodeName){return"<"+lowercase(nodeName)})}catch(e){return lowercase(elemHtml)}}function tryDecodeURIComponent(value){try{return decodeURIComponent(value)}catch(e){}}function parseKeyValue(keyValue){var key_value,key,obj={};return forEach((keyValue||"").split("&"),function(keyValue){if(keyValue&&(key_value=keyValue.replace(/\+/g,"%20").split("="),key=tryDecodeURIComponent(key_value[0]),isDefined(key))){var val=!isDefined(key_value[1])||tryDecodeURIComponent(key_value[1]);hasOwnProperty.call(obj,key)?isArray(obj[key])?obj[key].push(val):obj[key]=[obj[key],val]:obj[key]=val}}),obj}function toKeyValue(obj){var parts=[];return forEach(obj,function(value,key){isArray(value)?forEach(value,function(arrayValue){parts.push(encodeUriQuery(key,!0)+(!0===arrayValue?"":"="+encodeUriQuery(arrayValue,!0)))}):parts.push(encodeUriQuery(key,!0)+(!0===value?"":"="+encodeUriQuery(value,!0)))}),parts.length?parts.join("&"):""}function encodeUriSegment(val){return encodeUriQuery(val,!0).replace(/%26/gi,"&").replace(/%3D/gi,"=").replace(/%2B/gi,"+")}function encodeUriQuery(val,pctEncodeSpaces){return encodeURIComponent(val).replace(/%40/gi,"@").replace(/%3A/gi,":").replace(/%24/g,"$").replace(/%2C/gi,",").replace(/%3B/gi,";").replace(/%20/g,pctEncodeSpaces?"%20":"+")}function getNgAttribute(element,ngAttr){var attr,i,ii=ngAttrPrefixes.length;for(i=0;i<ii;++i)if(attr=ngAttrPrefixes[i]+ngAttr,isString(attr=element.getAttribute(attr)))return attr;return null}function angularInit(element,bootstrap){var appElement,module,config={};forEach(ngAttrPrefixes,function(prefix){var name=prefix+"app";!appElement&&element.hasAttribute&&element.hasAttribute(name)&&(appElement=element,module=element.getAttribute(name))}),forEach(ngAttrPrefixes,function(prefix){var candidate,name=prefix+"app";!appElement&&(candidate=element.querySelector("["+name.replace(":","\\:")+"]"))&&(appElement=candidate,module=candidate.getAttribute(name))}),appElement&&(config.strictDi=null!==getNgAttribute(appElement,"strict-di"),bootstrap(appElement,module?[module]:[],config))}function bootstrap(element,modules,config){isObject(config)||(config={}),config=extend({strictDi:!1},config);var doBootstrap=function(){if((element=jqLite(element)).injector()){var tag=element[0]===document?"document":startingTag(element);throw ngMinErr("btstrpd","App Already Bootstrapped with this Element '{0}'",tag.replace(/</,"&lt;").replace(/>/,"&gt;"))}(modules=modules||[]).unshift(["$provide",function($provide){$provide.value("$rootElement",element)}]),config.debugInfoEnabled&&modules.push(["$compileProvider",function($compileProvider){$compileProvider.debugInfoEnabled(!0)}]),modules.unshift("ng");var injector=createInjector(modules,config.strictDi);return injector.invoke(["$rootScope","$rootElement","$compile","$injector",function(scope,element,compile,injector){scope.$apply(function(){element.data("$injector",injector),compile(element)(scope)})}]),injector},NG_ENABLE_DEBUG_INFO=/^NG_ENABLE_DEBUG_INFO!/,NG_DEFER_BOOTSTRAP=/^NG_DEFER_BOOTSTRAP!/;if(window&&NG_ENABLE_DEBUG_INFO.test(window.name)&&(config.debugInfoEnabled=!0,window.name=window.name.replace(NG_ENABLE_DEBUG_INFO,"")),window&&!NG_DEFER_BOOTSTRAP.test(window.name))return doBootstrap();window.name=window.name.replace(NG_DEFER_BOOTSTRAP,""),angular.resumeBootstrap=function(extraModules){return forEach(extraModules,function(module){modules.push(module)}),doBootstrap()},isFunction(angular.resumeDeferredBootstrap)&&angular.resumeDeferredBootstrap()}function reloadWithDebugInfo(){window.name="NG_ENABLE_DEBUG_INFO!"+window.name,window.location.reload()}function getTestability(rootElement){var injector=angular.element(rootElement).injector();if(!injector)throw ngMinErr("test","no injector found for element argument to getTestability");return injector.get("$$testability")}function snake_case(name,separator){return separator=separator||"_",name.replace(SNAKE_CASE_REGEXP,function(letter,pos){return(pos?separator:"")+letter.toLowerCase()})}function assertArg(arg,name,reason){if(!arg)throw ngMinErr("areq","Argument '{0}' is {1}",name||"?",reason||"required");return arg}function assertArgFn(arg,name,acceptArrayAnnotation){return acceptArrayAnnotation&&isArray(arg)&&(arg=arg[arg.length-1]),assertArg(isFunction(arg),name,"not a function, got "+(arg&&"object"==typeof arg?arg.constructor.name||"Object":typeof arg)),arg}function assertNotHasOwnProperty(name,context){if("hasOwnProperty"===name)throw ngMinErr("badname","hasOwnProperty is not a valid {0} name",context)}function getter(obj,path,bindFnToScope){if(!path)return obj;for(var key,keys=path.split("."),lastInstance=obj,len=keys.length,i=0;i<len;i++)key=keys[i],obj&&(obj=(lastInstance=obj)[key]);return!bindFnToScope&&isFunction(obj)?bind(lastInstance,obj):obj}function getBlockNodes(nodes){var node=nodes[0],endNode=nodes[nodes.length-1],blockNodes=[node];do{if(!(node=node.nextSibling))break;blockNodes.push(node)}while(node!==endNode);return jqLite(blockNodes)}function createMap(){return Object.create(null)}function setupModuleLoader(window){function ensure(obj,name,factory){return obj[name]||(obj[name]=factory())}var $injectorMinErr=minErr("$injector"),ngMinErr=minErr("ng"),angular=ensure(window,"angular",Object);return angular.$$minErr=angular.$$minErr||minErr,ensure(angular,"module",function(){var modules={};return function(name,requires,configFn){return function(name,context){if("hasOwnProperty"===name)throw ngMinErr("badname","hasOwnProperty is not a valid {0} name",context)}(name,"module"),requires&&modules.hasOwnProperty(name)&&(modules[name]=null),ensure(modules,name,function(){function invokeLater(provider,method,insertMethod,queue){return queue||(queue=invokeQueue),function(){return queue[insertMethod||"push"]([provider,method,arguments]),moduleInstance}}function invokeLaterAndSetModuleName(provider,method){return function(recipeName,factoryFunction){return factoryFunction&&isFunction(factoryFunction)&&(factoryFunction.$$moduleName=name),invokeQueue.push([provider,method,arguments]),moduleInstance}}if(!requires)throw $injectorMinErr("nomod","Module '{0}' is not available! You either misspelled the module name or forgot to load it. If registering a module ensure that you specify the dependencies as the second argument.",name);var invokeQueue=[],configBlocks=[],runBlocks=[],config=invokeLater("$injector","invoke","push",configBlocks),moduleInstance={_invokeQueue:invokeQueue,_configBlocks:configBlocks,_runBlocks:runBlocks,requires:requires,name:name,provider:invokeLaterAndSetModuleName("$provide","provider"),factory:invokeLaterAndSetModuleName("$provide","factory"),service:invokeLaterAndSetModuleName("$provide","service"),value:invokeLater("$provide","value"),constant:invokeLater("$provide","constant","unshift"),decorator:invokeLaterAndSetModuleName("$provide","decorator"),animation:invokeLaterAndSetModuleName("$animateProvider","register"),filter:invokeLaterAndSetModuleName("$filterProvider","register"),controller:invokeLaterAndSetModuleName("$controllerProvider","register"),directive:invokeLaterAndSetModuleName("$compileProvider","directive"),config:config,run:function(block){return runBlocks.push(block),this}};return configFn&&config(configFn),moduleInstance})}})}function serializeObject(obj){var seen=[];return JSON.stringify(obj,function(key,val){if(val=toJsonReplacer(key,val),isObject(val)){if(seen.indexOf(val)>=0)return"<<already seen>>";seen.push(val)}return val})}function toDebugString(obj){return"function"==typeof obj?obj.toString().replace(/ \{[\s\S]*$/,""):void 0===obj?"undefined":"string"!=typeof obj?serializeObject(obj):obj}function jqNextId(){return++jqId}function camelCase(name){return name.replace(SPECIAL_CHARS_REGEXP,function(_,separator,letter,offset){return offset?letter.toUpperCase():letter}).replace(MOZ_HACK_REGEXP,"Moz$1")}function jqLiteIsTextNode(html){return!HTML_REGEXP.test(html)}function jqLiteAcceptsData(node){var nodeType=node.nodeType;return nodeType===NODE_TYPE_ELEMENT||!nodeType||nodeType===NODE_TYPE_DOCUMENT}function jqLiteBuildFragment(html,context){var tmp,tag,wrap,i,fragment=context.createDocumentFragment(),nodes=[];if(jqLiteIsTextNode(html))nodes.push(context.createTextNode(html));else{for(tmp=tmp||fragment.appendChild(context.createElement("div")),tag=(TAG_NAME_REGEXP.exec(html)||["",""])[1].toLowerCase(),wrap=wrapMap[tag]||wrapMap._default,tmp.innerHTML=wrap[1]+html.replace(XHTML_TAG_REGEXP,"<$1></$2>")+wrap[2],i=wrap[0];i--;)tmp=tmp.lastChild;nodes=concat(nodes,tmp.childNodes),(tmp=fragment.firstChild).textContent=""}return fragment.textContent="",fragment.innerHTML="",forEach(nodes,function(node){fragment.appendChild(node)}),fragment}function jqLiteParseHTML(html,context){context=context||document;var parsed;return(parsed=SINGLE_TAG_REGEXP.exec(html))?[context.createElement(parsed[1])]:(parsed=jqLiteBuildFragment(html,context))?parsed.childNodes:[]}function JQLite(element){if(element instanceof JQLite)return element;var argIsString;if(isString(element)&&(element=trim(element),argIsString=!0),!(this instanceof JQLite)){if(argIsString&&"<"!=element.charAt(0))throw jqLiteMinErr("nosel","Looking up elements via selectors is not supported by jqLite! See: http://docs.angularjs.org/api/angular.element");return new JQLite(element)}argIsString?jqLiteAddNodes(this,jqLiteParseHTML(element)):jqLiteAddNodes(this,element)}function jqLiteClone(element){return element.cloneNode(!0)}function jqLiteDealoc(element,onlyDescendants){if(onlyDescendants||jqLiteRemoveData(element),element.querySelectorAll)for(var descendants=element.querySelectorAll("*"),i=0,l=descendants.length;i<l;i++)jqLiteRemoveData(descendants[i])}function jqLiteOff(element,type,fn,unsupported){if(isDefined(unsupported))throw jqLiteMinErr("offargs","jqLite#off() does not support the `selector` argument");var expandoStore=jqLiteExpandoStore(element),events=expandoStore&&expandoStore.events,handle=expandoStore&&expandoStore.handle;if(handle)if(type)forEach(type.split(" "),function(type){if(isDefined(fn)){var listenerFns=events[type];if(arrayRemove(listenerFns||[],fn),listenerFns&&listenerFns.length>0)return}removeEventListenerFn(element,type,handle),delete events[type]});else for(type in events)"$destroy"!==type&&removeEventListenerFn(element,type,handle),delete events[type]}function jqLiteRemoveData(element,name){var expandoId=element.ng339,expandoStore=expandoId&&jqCache[expandoId];if(expandoStore){if(name)return void delete expandoStore.data[name];expandoStore.handle&&(expandoStore.events.$destroy&&expandoStore.handle({},"$destroy"),jqLiteOff(element)),delete jqCache[expandoId],element.ng339=undefined}}function jqLiteExpandoStore(element,createIfNecessary){var expandoId=element.ng339,expandoStore=expandoId&&jqCache[expandoId];return createIfNecessary&&!expandoStore&&(element.ng339=expandoId=jqNextId(),expandoStore=jqCache[expandoId]={events:{},data:{},handle:undefined}),expandoStore}function jqLiteData(element,key,value){if(jqLiteAcceptsData(element)){var isSimpleSetter=isDefined(value),isSimpleGetter=!isSimpleSetter&&key&&!isObject(key),massGetter=!key,expandoStore=jqLiteExpandoStore(element,!isSimpleGetter),data=expandoStore&&expandoStore.data;if(isSimpleSetter)data[key]=value;else{if(massGetter)return data;if(isSimpleGetter)return data&&data[key];extend(data,key)}}}function jqLiteHasClass(element,selector){return!!element.getAttribute&&(" "+(element.getAttribute("class")||"")+" ").replace(/[\n\t]/g," ").indexOf(" "+selector+" ")>-1}function jqLiteRemoveClass(element,cssClasses){cssClasses&&element.setAttribute&&forEach(cssClasses.split(" "),function(cssClass){element.setAttribute("class",trim((" "+(element.getAttribute("class")||"")+" ").replace(/[\n\t]/g," ").replace(" "+trim(cssClass)+" "," ")))})}function jqLiteAddClass(element,cssClasses){if(cssClasses&&element.setAttribute){var existingClasses=(" "+(element.getAttribute("class")||"")+" ").replace(/[\n\t]/g," ");forEach(cssClasses.split(" "),function(cssClass){cssClass=trim(cssClass),-1===existingClasses.indexOf(" "+cssClass+" ")&&(existingClasses+=cssClass+" ")}),element.setAttribute("class",trim(existingClasses))}}function jqLiteAddNodes(root,elements){if(elements)if(elements.nodeType)root[root.length++]=elements;else{var length=elements.length;if("number"==typeof length&&elements.window!==elements){if(length)for(var i=0;i<length;i++)root[root.length++]=elements[i]}else root[root.length++]=elements}}function jqLiteController(element,name){return jqLiteInheritedData(element,"$"+(name||"ngController")+"Controller")}function jqLiteInheritedData(element,name,value){element.nodeType==NODE_TYPE_DOCUMENT&&(element=element.documentElement);for(var names=isArray(name)?name:[name];element;){for(var i=0,ii=names.length;i<ii;i++)if((value=jqLite.data(element,names[i]))!==undefined)return value;element=element.parentNode||element.nodeType===NODE_TYPE_DOCUMENT_FRAGMENT&&element.host}}function jqLiteEmpty(element){for(jqLiteDealoc(element,!0);element.firstChild;)element.removeChild(element.firstChild)}function jqLiteRemove(element,keepData){keepData||jqLiteDealoc(element);var parent=element.parentNode;parent&&parent.removeChild(element)}function jqLiteDocumentLoaded(action,win){"complete"===(win=win||window).document.readyState?win.setTimeout(action):jqLite(win).on("load",action)}function getBooleanAttrName(element,name){var booleanAttr=BOOLEAN_ATTR[name.toLowerCase()];return booleanAttr&&BOOLEAN_ELEMENTS[nodeName_(element)]&&booleanAttr}function getAliasedAttrName(element,name){var nodeName=element.nodeName;return("INPUT"===nodeName||"TEXTAREA"===nodeName)&&ALIASED_ATTR[name]}function createEventHandler(element,events){var eventHandler=function(event,type){event.isDefaultPrevented=function(){return event.defaultPrevented};var eventFns=events[type||event.type],eventFnsLength=eventFns?eventFns.length:0;if(eventFnsLength){if(isUndefined(event.immediatePropagationStopped)){var originalStopImmediatePropagation=event.stopImmediatePropagation;event.stopImmediatePropagation=function(){event.immediatePropagationStopped=!0,event.stopPropagation&&event.stopPropagation(),originalStopImmediatePropagation&&originalStopImmediatePropagation.call(event)}}event.isImmediatePropagationStopped=function(){return!0===event.immediatePropagationStopped},eventFnsLength>1&&(eventFns=shallowCopy(eventFns));for(var i=0;i<eventFnsLength;i++)event.isImmediatePropagationStopped()||eventFns[i].call(element,event)}};return eventHandler.elem=element,eventHandler}function $$jqLiteProvider(){this.$get=function(){return extend(JQLite,{hasClass:function(node,classes){return node.attr&&(node=node[0]),jqLiteHasClass(node,classes)},addClass:function(node,classes){return node.attr&&(node=node[0]),jqLiteAddClass(node,classes)},removeClass:function(node,classes){return node.attr&&(node=node[0]),jqLiteRemoveClass(node,classes)}})}}function hashKey(obj,nextUidFn){var key=obj&&obj.$$hashKey;if(key)return"function"==typeof key&&(key=obj.$$hashKey()),key;var objType=typeof obj;return key="function"==objType||"object"==objType&&null!==obj?obj.$$hashKey=objType+":"+(nextUidFn||nextUid)():objType+":"+obj}function HashMap(array,isolatedUid){if(isolatedUid){var uid=0;this.nextUid=function(){return++uid}}forEach(array,this.put,this)}function anonFn(fn){var args=fn.toString().replace(STRIP_COMMENTS,"").match(FN_ARGS);return args?"function("+(args[1]||"").replace(/[\s\r\n]+/," ")+")":"fn"}function createInjector(modulesToLoad,strictDi){function supportObject(delegate){return function(key,value){if(!isObject(key))return delegate(key,value);forEach(key,reverseParams(delegate))}}function provider(name,provider_){if(assertNotHasOwnProperty(name,"service"),(isFunction(provider_)||isArray(provider_))&&(provider_=providerInjector.instantiate(provider_)),!provider_.$get)throw $injectorMinErr("pget","Provider '{0}' must define $get factory method.",name);return providerCache[name+providerSuffix]=provider_}function enforceReturnValue(name,factory){return function(){var result=instanceInjector.invoke(factory,this);if(isUndefined(result))throw $injectorMinErr("undef","Provider '{0}' must return a value from $get factory method.",name);return result}}function factory(name,factoryFn,enforce){return provider(name,{$get:!1!==enforce?enforceReturnValue(name,factoryFn):factoryFn})}function loadModules(modulesToLoad){var moduleFn,runBlocks=[];return forEach(modulesToLoad,function(module){function runInvokeQueue(queue){var i,ii;for(i=0,ii=queue.length;i<ii;i++){var invokeArgs=queue[i],provider=providerInjector.get(invokeArgs[0]);provider[invokeArgs[1]].apply(provider,invokeArgs[2])}}if(!loadedModules.get(module)){loadedModules.put(module,!0);try{isString(module)?(moduleFn=angularModule(module),runBlocks=runBlocks.concat(loadModules(moduleFn.requires)).concat(moduleFn._runBlocks),runInvokeQueue(moduleFn._invokeQueue),runInvokeQueue(moduleFn._configBlocks)):isFunction(module)?runBlocks.push(providerInjector.invoke(module)):isArray(module)?runBlocks.push(providerInjector.invoke(module)):assertArgFn(module,"module")}catch(e){throw isArray(module)&&(module=module[module.length-1]),e.message&&e.stack&&-1==e.stack.indexOf(e.message)&&(e=e.message+"\n"+e.stack),$injectorMinErr("modulerr","Failed to instantiate module {0} due to:\n{1}",module,e.stack||e.message||e)}}}),runBlocks}function createInternalInjector(cache,factory){function getService(serviceName,caller){if(cache.hasOwnProperty(serviceName)){if(cache[serviceName]===INSTANTIATING)throw $injectorMinErr("cdep","Circular dependency found: {0}",serviceName+" <- "+path.join(" <- "));return cache[serviceName]}try{return path.unshift(serviceName),cache[serviceName]=INSTANTIATING,cache[serviceName]=factory(serviceName,caller)}catch(err){throw cache[serviceName]===INSTANTIATING&&delete cache[serviceName],err}finally{path.shift()}}function invoke(fn,self,locals,serviceName){"string"==typeof locals&&(serviceName=locals,locals=null);var length,i,key,args=[],$inject=createInjector.$$annotate(fn,strictDi,serviceName);for(i=0,length=$inject.length;i<length;i++){if("string"!=typeof(key=$inject[i]))throw $injectorMinErr("itkn","Incorrect injection token! Expected service name as string, got {0}",key);args.push(locals&&locals.hasOwnProperty(key)?locals[key]:getService(key,serviceName))}return isArray(fn)&&(fn=fn[length]),fn.apply(self,args)}return{invoke:invoke,instantiate:function(Type,locals,serviceName){var instance=Object.create((isArray(Type)?Type[Type.length-1]:Type).prototype||null),returnedValue=invoke(Type,instance,locals,serviceName);return isObject(returnedValue)||isFunction(returnedValue)?returnedValue:instance},get:getService,annotate:createInjector.$$annotate,has:function(name){return providerCache.hasOwnProperty(name+providerSuffix)||cache.hasOwnProperty(name)}}}strictDi=!0===strictDi;var INSTANTIATING={},providerSuffix="Provider",path=[],loadedModules=new HashMap([],!0),providerCache={$provide:{provider:supportObject(provider),factory:supportObject(factory),service:supportObject(function(name,constructor){return factory(name,["$injector",function($injector){return $injector.instantiate(constructor)}])}),value:supportObject(function(name,val){return factory(name,valueFn(val),!1)}),constant:supportObject(function(name,value){assertNotHasOwnProperty(name,"constant"),providerCache[name]=value,instanceCache[name]=value}),decorator:function(serviceName,decorFn){var origProvider=providerInjector.get(serviceName+providerSuffix),orig$get=origProvider.$get;origProvider.$get=function(){var origInstance=instanceInjector.invoke(orig$get,origProvider);return instanceInjector.invoke(decorFn,null,{$delegate:origInstance})}}}},providerInjector=providerCache.$injector=createInternalInjector(providerCache,function(serviceName,caller){throw angular.isString(caller)&&path.push(caller),$injectorMinErr("unpr","Unknown provider: {0}",path.join(" <- "))}),instanceCache={},instanceInjector=instanceCache.$injector=createInternalInjector(instanceCache,function(serviceName,caller){var provider=providerInjector.get(serviceName+providerSuffix,caller);return instanceInjector.invoke(provider.$get,provider,undefined,serviceName)});return forEach(loadModules(modulesToLoad),function(fn){fn&&instanceInjector.invoke(fn)}),instanceInjector}function $AnchorScrollProvider(){var autoScrollingEnabled=!0;this.disableAutoScrolling=function(){autoScrollingEnabled=!1},this.$get=["$window","$location","$rootScope",function($window,$location,$rootScope){function getFirstAnchor(list){var result=null;return Array.prototype.some.call(list,function(element){if("a"===nodeName_(element))return result=element,!0}),result}function getYOffset(){var offset=scroll.yOffset;if(isFunction(offset))offset=offset();else if(isElement(offset)){var elem=offset[0];offset="fixed"!==$window.getComputedStyle(elem).position?0:elem.getBoundingClientRect().bottom}else isNumber(offset)||(offset=0);return offset}function scrollTo(elem){if(elem){elem.scrollIntoView();var offset=getYOffset();if(offset){var elemTop=elem.getBoundingClientRect().top;$window.scrollBy(0,elemTop-offset)}}else $window.scrollTo(0,0)}function scroll(hash){var elm;(hash=isString(hash)?hash:$location.hash())?(elm=document.getElementById(hash))?scrollTo(elm):(elm=getFirstAnchor(document.getElementsByName(hash)))?scrollTo(elm):"top"===hash&&scrollTo(null):scrollTo(null)}var document=$window.document;return autoScrollingEnabled&&$rootScope.$watch(function(){return $location.hash()},function(newVal,oldVal){newVal===oldVal&&""===newVal||jqLiteDocumentLoaded(function(){$rootScope.$evalAsync(scroll)})}),scroll}]}function mergeClasses(a,b){return a||b?a?b?(isArray(a)&&(a=a.join(" ")),isArray(b)&&(b=b.join(" ")),a+" "+b):a:b:""}function extractElementNode(element){for(var i=0;i<element.length;i++){var elm=element[i];if(elm.nodeType===ELEMENT_NODE)return elm}}function splitClasses(classes){isString(classes)&&(classes=classes.split(" "));var obj=createMap();return forEach(classes,function(klass){klass.length&&(obj[klass]=!0)}),obj}function prepareAnimateOptions(options){return isObject(options)?options:{}}function Browser(window,document,$log,$sniffer){function completeOutstandingRequest(fn){try{fn.apply(null,sliceArgs(arguments,1))}finally{if(0==--outstandingRequestCount)for(;outstandingRequestCallbacks.length;)try{outstandingRequestCallbacks.pop()()}catch(e){$log.error(e)}}}function getHash(url){var index=url.indexOf("#");return-1===index?"":url.substr(index)}function cacheStateAndFireUrlChange(){cacheState(),fireUrlChange()}function getCurrentState(){try{return history.state}catch(e){}}function cacheState(){cachedState=getCurrentState(),equals(cachedState=isUndefined(cachedState)?null:cachedState,lastCachedState)&&(cachedState=lastCachedState),lastCachedState=cachedState}function fireUrlChange(){lastBrowserUrl===self.url()&&lastHistoryState===cachedState||(lastBrowserUrl=self.url(),lastHistoryState=cachedState,forEach(urlChangeListeners,function(listener){listener(self.url(),cachedState)}))}var self=this,location=(document[0],window.location),history=window.history,setTimeout=window.setTimeout,clearTimeout=window.clearTimeout,pendingDeferIds={};self.isMock=!1;var outstandingRequestCount=0,outstandingRequestCallbacks=[];self.$$completeOutstandingRequest=completeOutstandingRequest,self.$$incOutstandingRequestCount=function(){outstandingRequestCount++},self.notifyWhenNoOutstandingRequests=function(callback){0===outstandingRequestCount?callback():outstandingRequestCallbacks.push(callback)};var cachedState,lastHistoryState,lastBrowserUrl=location.href,baseElement=document.find("base"),reloadLocation=null;cacheState(),lastHistoryState=cachedState,self.url=function(url,replace,state){if(isUndefined(state)&&(state=null),location!==window.location&&(location=window.location),history!==window.history&&(history=window.history),url){var sameState=lastHistoryState===state;if(lastBrowserUrl===url&&(!$sniffer.history||sameState))return self;var sameBase=lastBrowserUrl&&stripHash(lastBrowserUrl)===stripHash(url);return lastBrowserUrl=url,lastHistoryState=state,!$sniffer.history||sameBase&&sameState?(sameBase&&!reloadLocation||(reloadLocation=url),replace?location.replace(url):sameBase?location.hash=getHash(url):location.href=url):(history[replace?"replaceState":"pushState"](state,"",url),cacheState(),lastHistoryState=cachedState),self}return reloadLocation||location.href.replace(/%27/g,"'")},self.state=function(){return cachedState};var urlChangeListeners=[],urlChangeInit=!1,lastCachedState=null;self.onUrlChange=function(callback){return urlChangeInit||($sniffer.history&&jqLite(window).on("popstate",cacheStateAndFireUrlChange),jqLite(window).on("hashchange",cacheStateAndFireUrlChange),urlChangeInit=!0),urlChangeListeners.push(callback),callback},self.$$applicationDestroyed=function(){jqLite(window).off("hashchange popstate",cacheStateAndFireUrlChange)},self.$$checkUrlChange=fireUrlChange,self.baseHref=function(){var href=baseElement.attr("href");return href?href.replace(/^(https?\:)?\/\/[^\/]*/,""):""},self.defer=function(fn,delay){var timeoutId;return outstandingRequestCount++,timeoutId=setTimeout(function(){delete pendingDeferIds[timeoutId],completeOutstandingRequest(fn)},delay||0),pendingDeferIds[timeoutId]=!0,timeoutId},self.defer.cancel=function(deferId){return!!pendingDeferIds[deferId]&&(delete pendingDeferIds[deferId],clearTimeout(deferId),completeOutstandingRequest(noop),!0)}}function $BrowserProvider(){this.$get=["$window","$log","$sniffer","$document",function($window,$log,$sniffer,$document){return new Browser($window,$document,$log,$sniffer)}]}function $CacheFactoryProvider(){this.$get=function(){function cacheFactory(cacheId,options){function refresh(entry){entry!=freshEnd&&(staleEnd?staleEnd==entry&&(staleEnd=entry.n):staleEnd=entry,link(entry.n,entry.p),link(entry,freshEnd),(freshEnd=entry).n=null)}function link(nextEntry,prevEntry){nextEntry!=prevEntry&&(nextEntry&&(nextEntry.p=prevEntry),prevEntry&&(prevEntry.n=nextEntry))}if(cacheId in caches)throw minErr("$cacheFactory")("iid","CacheId '{0}' is already taken!",cacheId);var size=0,stats=extend({},options,{id:cacheId}),data={},capacity=options&&options.capacity||Number.MAX_VALUE,lruHash={},freshEnd=null,staleEnd=null;return caches[cacheId]={put:function(key,value){if(!isUndefined(value))return capacity<Number.MAX_VALUE&&refresh(lruHash[key]||(lruHash[key]={key:key})),key in data||size++,data[key]=value,size>capacity&&this.remove(staleEnd.key),value},get:function(key){if(capacity<Number.MAX_VALUE){var lruEntry=lruHash[key];if(!lruEntry)return;refresh(lruEntry)}return data[key]},remove:function(key){if(capacity<Number.MAX_VALUE){var lruEntry=lruHash[key];if(!lruEntry)return;lruEntry==freshEnd&&(freshEnd=lruEntry.p),lruEntry==staleEnd&&(staleEnd=lruEntry.n),link(lruEntry.n,lruEntry.p),delete lruHash[key]}delete data[key],size--},removeAll:function(){data={},size=0,lruHash={},freshEnd=staleEnd=null},destroy:function(){data=null,stats=null,lruHash=null,delete caches[cacheId]},info:function(){return extend({},stats,{size:size})}}}var caches={};return cacheFactory.info=function(){var info={};return forEach(caches,function(cache,cacheId){info[cacheId]=cache.info()}),info},cacheFactory.get=function(cacheId){return caches[cacheId]},cacheFactory}}function $TemplateCacheProvider(){this.$get=["$cacheFactory",function($cacheFactory){return $cacheFactory("templates")}]}function $CompileProvider($provide,$$sanitizeUriProvider){function parseIsolateBindings(scope,directiveName,isController){var LOCAL_REGEXP=/^\s*([@&]|=(\*?))(\??)\s*(\w*)\s*$/,bindings={};return forEach(scope,function(definition,scopeName){var match=definition.match(LOCAL_REGEXP);if(!match)throw $compileMinErr("iscp","Invalid {3} for directive '{0}'. Definition: {... {1}: '{2}' ...}",directiveName,scopeName,definition,isController?"controller bindings definition":"isolate scope definition");bindings[scopeName]={mode:match[1][0],collection:"*"===match[2],optional:"?"===match[3],attrName:match[4]||scopeName}}),bindings}function parseDirectiveBindings(directive,directiveName){var bindings={isolateScope:null,bindToController:null};if(isObject(directive.scope)&&(!0===directive.bindToController?(bindings.bindToController=parseIsolateBindings(directive.scope,directiveName,!0),bindings.isolateScope={}):bindings.isolateScope=parseIsolateBindings(directive.scope,directiveName,!1)),isObject(directive.bindToController)&&(bindings.bindToController=parseIsolateBindings(directive.bindToController,directiveName,!0)),isObject(bindings.bindToController)){var controller=directive.controller,controllerAs=directive.controllerAs;if(!controller)throw $compileMinErr("noctrl","Cannot bind to controller without directive '{0}'s controller.",directiveName);if(!identifierForController(controller,controllerAs))throw $compileMinErr("noident","Cannot bind to controller without identifier for directive '{0}'.",directiveName)}return bindings}function assertValidDirectiveName(name){var letter=name.charAt(0);if(!letter||letter!==lowercase(letter))throw $compileMinErr("baddir","Directive name '{0}' is invalid. The first character must be a lowercase letter",name);if(name!==name.trim())throw $compileMinErr("baddir","Directive name '{0}' is invalid. The name should not contain leading or trailing whitespaces",name)}var hasDirectives={},Suffix="Directive",COMMENT_DIRECTIVE_REGEXP=/^\s*directive\:\s*([\w\-]+)\s+(.*)$/,CLASS_DIRECTIVE_REGEXP=/(([\w\-]+)(?:\:([^;]+))?;?)/,ALL_OR_NOTHING_ATTRS=makeMap("ngSrc,ngSrcset,src,srcset"),REQUIRE_PREFIX_REGEXP=/^(?:(\^\^?)?(\?)?(\^\^?)?)?/,EVENT_HANDLER_ATTR_REGEXP=/^(on[a-z]+|formaction)$/;this.directive=function registerDirective(name,directiveFactory){return assertNotHasOwnProperty(name,"directive"),isString(name)?(assertValidDirectiveName(name),assertArg(directiveFactory,"directiveFactory"),hasDirectives.hasOwnProperty(name)||(hasDirectives[name]=[],$provide.factory(name+Suffix,["$injector","$exceptionHandler",function($injector,$exceptionHandler){var directives=[];return forEach(hasDirectives[name],function(directiveFactory,index){try{var directive=$injector.invoke(directiveFactory);isFunction(directive)?directive={compile:valueFn(directive)}:!directive.compile&&directive.link&&(directive.compile=valueFn(directive.link)),directive.priority=directive.priority||0,directive.index=index,directive.name=directive.name||name,directive.require=directive.require||directive.controller&&directive.name,directive.restrict=directive.restrict||"EA";var bindings=directive.$$bindings=parseDirectiveBindings(directive,directive.name);isObject(bindings.isolateScope)&&(directive.$$isolateBindings=bindings.isolateScope),directive.$$moduleName=directiveFactory.$$moduleName,directives.push(directive)}catch(e){$exceptionHandler(e)}}),directives}])),hasDirectives[name].push(directiveFactory)):forEach(name,reverseParams(registerDirective)),this},this.aHrefSanitizationWhitelist=function(regexp){return isDefined(regexp)?($$sanitizeUriProvider.aHrefSanitizationWhitelist(regexp),this):$$sanitizeUriProvider.aHrefSanitizationWhitelist()},this.imgSrcSanitizationWhitelist=function(regexp){return isDefined(regexp)?($$sanitizeUriProvider.imgSrcSanitizationWhitelist(regexp),this):$$sanitizeUriProvider.imgSrcSanitizationWhitelist()};var debugInfoEnabled=!0;this.debugInfoEnabled=function(enabled){return isDefined(enabled)?(debugInfoEnabled=enabled,this):debugInfoEnabled},this.$get=["$injector","$interpolate","$exceptionHandler","$templateRequest","$parse","$controller","$rootScope","$document","$sce","$animate","$$sanitizeUri",function($injector,$interpolate,$exceptionHandler,$templateRequest,$parse,$controller,$rootScope,$document,$sce,$animate,$$sanitizeUri){function safeAddClass($element,className){try{$element.addClass(className)}catch(e){}}function compile($compileNodes,transcludeFn,maxPriority,ignoreDirective,previousCompileContext){$compileNodes instanceof jqLite||($compileNodes=jqLite($compileNodes)),forEach($compileNodes,function(node,index){node.nodeType==NODE_TYPE_TEXT&&node.nodeValue.match(/\S+/)&&($compileNodes[index]=jqLite(node).wrap("<span></span>").parent()[0])});var compositeLinkFn=compileNodes($compileNodes,transcludeFn,$compileNodes,maxPriority,ignoreDirective,previousCompileContext);compile.$$addScopeClass($compileNodes);var namespace=null;return function(scope,cloneConnectFn,options){assertArg(scope,"scope");var parentBoundTranscludeFn=(options=options||{}).parentBoundTranscludeFn,transcludeControllers=options.transcludeControllers,futureParentElement=options.futureParentElement;parentBoundTranscludeFn&&parentBoundTranscludeFn.$$boundTransclude&&(parentBoundTranscludeFn=parentBoundTranscludeFn.$$boundTransclude),namespace||(namespace=detectNamespaceForChildElements(futureParentElement));var $linkNode;if($linkNode="html"!==namespace?jqLite(wrapTemplate(namespace,jqLite("<div>").append($compileNodes).html())):cloneConnectFn?JQLitePrototype.clone.call($compileNodes):$compileNodes,transcludeControllers)for(var controllerName in transcludeControllers)$linkNode.data("$"+controllerName+"Controller",transcludeControllers[controllerName].instance);return compile.$$addScopeInfo($linkNode,scope),cloneConnectFn&&cloneConnectFn($linkNode,scope),compositeLinkFn&&compositeLinkFn(scope,$linkNode,$linkNode,parentBoundTranscludeFn),$linkNode}}function detectNamespaceForChildElements(parentElement){var node=parentElement&&parentElement[0];return node&&"foreignobject"!==nodeName_(node)&&node.toString().match(/SVG/)?"svg":"html"}function compileNodes(nodeList,transcludeFn,$rootElement,maxPriority,ignoreDirective,previousCompileContext){for(var attrs,directives,nodeLinkFn,childNodes,childLinkFn,linkFnFound,nodeLinkFnFound,linkFns=[],i=0;i<nodeList.length;i++)attrs=new Attributes,(nodeLinkFn=(directives=collectDirectives(nodeList[i],[],attrs,0===i?maxPriority:undefined,ignoreDirective)).length?applyDirectivesToNode(directives,nodeList[i],attrs,transcludeFn,$rootElement,null,[],[],previousCompileContext):null)&&nodeLinkFn.scope&&compile.$$addScopeClass(attrs.$$element),childLinkFn=nodeLinkFn&&nodeLinkFn.terminal||!(childNodes=nodeList[i].childNodes)||!childNodes.length?null:compileNodes(childNodes,nodeLinkFn?(nodeLinkFn.transcludeOnThisElement||!nodeLinkFn.templateOnThisElement)&&nodeLinkFn.transclude:transcludeFn),(nodeLinkFn||childLinkFn)&&(linkFns.push(i,nodeLinkFn,childLinkFn),linkFnFound=!0,nodeLinkFnFound=nodeLinkFnFound||nodeLinkFn),previousCompileContext=null;return linkFnFound?function(scope,nodeList,$rootElement,parentBoundTranscludeFn){var nodeLinkFn,childLinkFn,node,childScope,i,ii,idx,stableNodeList;if(nodeLinkFnFound){var nodeListLength=nodeList.length;for(stableNodeList=new Array(nodeListLength),i=0;i<linkFns.length;i+=3)stableNodeList[idx=linkFns[i]]=nodeList[idx]}else stableNodeList=nodeList;for(i=0,ii=linkFns.length;i<ii;)if(node=stableNodeList[linkFns[i++]],nodeLinkFn=linkFns[i++],childLinkFn=linkFns[i++],nodeLinkFn){if(nodeLinkFn.scope){childScope=scope.$new(),compile.$$addScopeInfo(jqLite(node),childScope);var destroyBindings=nodeLinkFn.$$destroyBindings;destroyBindings&&(nodeLinkFn.$$destroyBindings=null,childScope.$on("$destroyed",destroyBindings))}else childScope=scope;nodeLinkFn(childLinkFn,childScope,node,$rootElement,nodeLinkFn.transcludeOnThisElement?createBoundTranscludeFn(scope,nodeLinkFn.transclude,parentBoundTranscludeFn):!nodeLinkFn.templateOnThisElement&&parentBoundTranscludeFn?parentBoundTranscludeFn:!parentBoundTranscludeFn&&transcludeFn?createBoundTranscludeFn(scope,transcludeFn):null,nodeLinkFn)}else childLinkFn&&childLinkFn(scope,node.childNodes,undefined,parentBoundTranscludeFn)}:null}function createBoundTranscludeFn(scope,transcludeFn,previousBoundTranscludeFn){return function(transcludedScope,cloneFn,controllers,futureParentElement,containingScope){return transcludedScope||((transcludedScope=scope.$new(!1,containingScope)).$$transcluded=!0),transcludeFn(transcludedScope,cloneFn,{parentBoundTranscludeFn:previousBoundTranscludeFn,transcludeControllers:controllers,futureParentElement:futureParentElement})}}function collectDirectives(node,directives,attrs,maxPriority,ignoreDirective){var match,className,nodeType=node.nodeType,attrsMap=attrs.$attr;switch(nodeType){case NODE_TYPE_ELEMENT:addDirective(directives,directiveNormalize(nodeName_(node)),"E",maxPriority,ignoreDirective);for(var attr,name,nName,ngAttrName,value,isNgAttr,nAttrs=node.attributes,j=0,jj=nAttrs&&nAttrs.length;j<jj;j++){var attrStartName=!1,attrEndName=!1;name=(attr=nAttrs[j]).name,value=trim(attr.value),ngAttrName=directiveNormalize(name),(isNgAttr=NG_ATTR_BINDING.test(ngAttrName))&&(name=name.replace(PREFIX_REGEXP,"").substr(8).replace(/_(.)/g,function(match,letter){return letter.toUpperCase()}));var directiveNName=ngAttrName.replace(/(Start|End)$/,"");directiveIsMultiElement(directiveNName)&&ngAttrName===directiveNName+"Start"&&(attrStartName=name,attrEndName=name.substr(0,name.length-5)+"end",name=name.substr(0,name.length-6)),attrsMap[nName=directiveNormalize(name.toLowerCase())]=name,!isNgAttr&&attrs.hasOwnProperty(nName)||(attrs[nName]=value,getBooleanAttrName(node,nName)&&(attrs[nName]=!0)),addAttrInterpolateDirective(node,directives,value,nName,isNgAttr),addDirective(directives,nName,"A",maxPriority,ignoreDirective,attrStartName,attrEndName)}if(className=node.className,isObject(className)&&(className=className.animVal),isString(className)&&""!==className)for(;match=CLASS_DIRECTIVE_REGEXP.exec(className);)addDirective(directives,nName=directiveNormalize(match[2]),"C",maxPriority,ignoreDirective)&&(attrs[nName]=trim(match[3])),className=className.substr(match.index+match[0].length);break;case NODE_TYPE_TEXT:if(11===msie)for(;node.parentNode&&node.nextSibling&&node.nextSibling.nodeType===NODE_TYPE_TEXT;)node.nodeValue=node.nodeValue+node.nextSibling.nodeValue,node.parentNode.removeChild(node.nextSibling);addTextInterpolateDirective(directives,node.nodeValue);break;case NODE_TYPE_COMMENT:try{(match=COMMENT_DIRECTIVE_REGEXP.exec(node.nodeValue))&&addDirective(directives,nName=directiveNormalize(match[1]),"M",maxPriority,ignoreDirective)&&(attrs[nName]=trim(match[2]))}catch(e){}}return directives.sort(byPriority),directives}function groupScan(node,attrStart,attrEnd){var nodes=[],depth=0;if(attrStart&&node.hasAttribute&&node.hasAttribute(attrStart))do{if(!node)throw $compileMinErr("uterdir","Unterminated attribute, found '{0}' but no matching '{1}' found.",attrStart,attrEnd);node.nodeType==NODE_TYPE_ELEMENT&&(node.hasAttribute(attrStart)&&depth++,node.hasAttribute(attrEnd)&&depth--),nodes.push(node),node=node.nextSibling}while(depth>0);else nodes.push(node);return jqLite(nodes)}function groupElementsLinkFnWrapper(linkFn,attrStart,attrEnd){return function(scope,element,attrs,controllers,transcludeFn){return element=groupScan(element[0],attrStart,attrEnd),linkFn(scope,element,attrs,controllers,transcludeFn)}}function applyDirectivesToNode(directives,compileNode,templateAttrs,transcludeFn,jqCollection,originalReplaceDirective,preLinkFns,postLinkFns,previousCompileContext){function addLinkFns(pre,post,attrStart,attrEnd){pre&&(attrStart&&(pre=groupElementsLinkFnWrapper(pre,attrStart,attrEnd)),pre.require=directive.require,pre.directiveName=directiveName,(newIsolateScopeDirective===directive||directive.$$isolateScope)&&(pre=cloneAndAnnotateFn(pre,{isolateScope:!0})),preLinkFns.push(pre)),post&&(attrStart&&(post=groupElementsLinkFnWrapper(post,attrStart,attrEnd)),post.require=directive.require,post.directiveName=directiveName,(newIsolateScopeDirective===directive||directive.$$isolateScope)&&(post=cloneAndAnnotateFn(post,{isolateScope:!0})),postLinkFns.push(post))}function getControllers(directiveName,require,$element,elementControllers){var value;if(isString(require)){var match=require.match(REQUIRE_PREFIX_REGEXP),name=require.substring(match[0].length),inheritType=match[1]||match[3],optional="?"===match[2];if("^^"===inheritType?$element=$element.parent():value=(value=elementControllers&&elementControllers[name])&&value.instance,!value){var dataName="$"+name+"Controller";value=inheritType?$element.inheritedData(dataName):$element.data(dataName)}if(!value&&!optional)throw $compileMinErr("ctreq","Controller '{0}', required by directive '{1}', can't be found!",name,directiveName)}else if(isArray(require)){value=[];for(var i=0,ii=require.length;i<ii;i++)value[i]=getControllers(directiveName,require[i],$element,elementControllers)}return value||null}function setupControllers($element,attrs,transcludeFn,controllerDirectives,isolateScope,scope){var elementControllers=createMap();for(var controllerKey in controllerDirectives){var directive=controllerDirectives[controllerKey],locals={$scope:directive===newIsolateScopeDirective||directive.$$isolateScope?isolateScope:scope,$element:$element,$attrs:attrs,$transclude:transcludeFn},controller=directive.controller;"@"==controller&&(controller=attrs[directive.name]);var controllerInstance=$controller(controller,locals,!0,directive.controllerAs);elementControllers[directive.name]=controllerInstance,hasElementTranscludeDirective||$element.data("$"+directive.name+"Controller",controllerInstance.instance)}return elementControllers}function nodeLinkFn(childLinkFn,scope,linkNode,$rootElement,boundTranscludeFn,thisLinkFn){var i,ii,linkFn,controller,isolateScope,elementControllers,transcludeFn,$element,attrs;if(compileNode===linkNode?(attrs=templateAttrs,$element=templateAttrs.$$element):($element=jqLite(linkNode),attrs=new Attributes($element,templateAttrs)),newIsolateScopeDirective&&(isolateScope=scope.$new(!0)),boundTranscludeFn&&((transcludeFn=function(scope,cloneAttachFn,futureParentElement){var transcludeControllers;return isScope(scope)||(futureParentElement=cloneAttachFn,cloneAttachFn=scope,scope=undefined),hasElementTranscludeDirective&&(transcludeControllers=elementControllers),futureParentElement||(futureParentElement=hasElementTranscludeDirective?$element.parent():$element),boundTranscludeFn(scope,cloneAttachFn,transcludeControllers,futureParentElement,scopeToChild)}).$$boundTransclude=boundTranscludeFn),controllerDirectives&&(elementControllers=setupControllers($element,attrs,transcludeFn,controllerDirectives,isolateScope,scope)),newIsolateScopeDirective&&(compile.$$addScopeInfo($element,isolateScope,!0,!(templateDirective&&(templateDirective===newIsolateScopeDirective||templateDirective===newIsolateScopeDirective.$$originalDirective))),compile.$$addScopeClass($element,!0),isolateScope.$$isolateBindings=newIsolateScopeDirective.$$isolateBindings,initializeDirectiveBindings(scope,attrs,isolateScope,isolateScope.$$isolateBindings,newIsolateScopeDirective,isolateScope)),elementControllers){var bindings,controllerForBindings,scopeDirective=newIsolateScopeDirective||newScopeDirective;scopeDirective&&elementControllers[scopeDirective.name]&&(bindings=scopeDirective.$$bindings.bindToController,(controller=elementControllers[scopeDirective.name])&&controller.identifier&&bindings&&(controllerForBindings=controller,thisLinkFn.$$destroyBindings=initializeDirectiveBindings(scope,attrs,controller.instance,bindings,scopeDirective)));for(i in elementControllers){var controllerResult=(controller=elementControllers[i])();controllerResult!==controller.instance&&(controller.instance=controllerResult,$element.data("$"+i+"Controller",controllerResult),controller===controllerForBindings&&(thisLinkFn.$$destroyBindings(),thisLinkFn.$$destroyBindings=initializeDirectiveBindings(scope,attrs,controllerResult,bindings,scopeDirective)))}}for(i=0,ii=preLinkFns.length;i<ii;i++)invokeLinkFn(linkFn=preLinkFns[i],linkFn.isolateScope?isolateScope:scope,$element,attrs,linkFn.require&&getControllers(linkFn.directiveName,linkFn.require,$element,elementControllers),transcludeFn);var scopeToChild=scope;for(newIsolateScopeDirective&&(newIsolateScopeDirective.template||null===newIsolateScopeDirective.templateUrl)&&(scopeToChild=isolateScope),childLinkFn&&childLinkFn(scopeToChild,linkNode.childNodes,undefined,boundTranscludeFn),i=postLinkFns.length-1;i>=0;i--)invokeLinkFn(linkFn=postLinkFns[i],linkFn.isolateScope?isolateScope:scope,$element,attrs,linkFn.require&&getControllers(linkFn.directiveName,linkFn.require,$element,elementControllers),transcludeFn)}previousCompileContext=previousCompileContext||{};for(var directive,directiveName,$template,linkFn,directiveValue,terminalPriority=-Number.MAX_VALUE,newScopeDirective=previousCompileContext.newScopeDirective,controllerDirectives=previousCompileContext.controllerDirectives,newIsolateScopeDirective=previousCompileContext.newIsolateScopeDirective,templateDirective=previousCompileContext.templateDirective,nonTlbTranscludeDirective=previousCompileContext.nonTlbTranscludeDirective,hasTranscludeDirective=!1,hasTemplate=!1,hasElementTranscludeDirective=previousCompileContext.hasElementTranscludeDirective,$compileNode=templateAttrs.$$element=jqLite(compileNode),replaceDirective=originalReplaceDirective,childTranscludeFn=transcludeFn,i=0,ii=directives.length;i<ii;i++){var attrStart=(directive=directives[i]).$$start,attrEnd=directive.$$end;if(attrStart&&($compileNode=groupScan(compileNode,attrStart,attrEnd)),$template=undefined,terminalPriority>directive.priority)break;if((directiveValue=directive.scope)&&(directive.templateUrl||(isObject(directiveValue)?(assertNoDuplicate("new/isolated scope",newIsolateScopeDirective||newScopeDirective,directive,$compileNode),newIsolateScopeDirective=directive):assertNoDuplicate("new/isolated scope",newIsolateScopeDirective,directive,$compileNode)),newScopeDirective=newScopeDirective||directive),directiveName=directive.name,!directive.templateUrl&&directive.controller&&(directiveValue=directive.controller,controllerDirectives=controllerDirectives||createMap(),assertNoDuplicate("'"+directiveName+"' controller",controllerDirectives[directiveName],directive,$compileNode),controllerDirectives[directiveName]=directive),(directiveValue=directive.transclude)&&(hasTranscludeDirective=!0,directive.$$tlb||(assertNoDuplicate("transclusion",nonTlbTranscludeDirective,directive,$compileNode),nonTlbTranscludeDirective=directive),"element"==directiveValue?(hasElementTranscludeDirective=!0,terminalPriority=directive.priority,$template=$compileNode,$compileNode=templateAttrs.$$element=jqLite(document.createComment(" "+directiveName+": "+templateAttrs[directiveName]+" ")),compileNode=$compileNode[0],replaceWith(jqCollection,sliceArgs($template),compileNode),childTranscludeFn=compile($template,transcludeFn,terminalPriority,replaceDirective&&replaceDirective.name,{nonTlbTranscludeDirective:nonTlbTranscludeDirective})):($template=jqLite(jqLiteClone(compileNode)).contents(),$compileNode.empty(),childTranscludeFn=compile($template,transcludeFn))),directive.template)if(hasTemplate=!0,assertNoDuplicate("template",templateDirective,directive,$compileNode),templateDirective=directive,directiveValue=isFunction(directive.template)?directive.template($compileNode,templateAttrs):directive.template,directiveValue=denormalizeTemplate(directiveValue),directive.replace){if(replaceDirective=directive,$template=jqLiteIsTextNode(directiveValue)?[]:removeComments(wrapTemplate(directive.templateNamespace,trim(directiveValue))),compileNode=$template[0],1!=$template.length||compileNode.nodeType!==NODE_TYPE_ELEMENT)throw $compileMinErr("tplrt","Template for directive '{0}' must have exactly one root element. {1}",directiveName,"");replaceWith(jqCollection,$compileNode,compileNode);var newTemplateAttrs={$attr:{}},templateDirectives=collectDirectives(compileNode,[],newTemplateAttrs),unprocessedDirectives=directives.splice(i+1,directives.length-(i+1));newIsolateScopeDirective&&markDirectivesAsIsolate(templateDirectives),directives=directives.concat(templateDirectives).concat(unprocessedDirectives),mergeTemplateAttributes(templateAttrs,newTemplateAttrs),ii=directives.length}else $compileNode.html(directiveValue);if(directive.templateUrl)hasTemplate=!0,assertNoDuplicate("template",templateDirective,directive,$compileNode),templateDirective=directive,directive.replace&&(replaceDirective=directive),nodeLinkFn=compileTemplateUrl(directives.splice(i,directives.length-i),$compileNode,templateAttrs,jqCollection,hasTranscludeDirective&&childTranscludeFn,preLinkFns,postLinkFns,{controllerDirectives:controllerDirectives,newScopeDirective:newScopeDirective!==directive&&newScopeDirective,newIsolateScopeDirective:newIsolateScopeDirective,templateDirective:templateDirective,nonTlbTranscludeDirective:nonTlbTranscludeDirective}),ii=directives.length;else if(directive.compile)try{isFunction(linkFn=directive.compile($compileNode,templateAttrs,childTranscludeFn))?addLinkFns(null,linkFn,attrStart,attrEnd):linkFn&&addLinkFns(linkFn.pre,linkFn.post,attrStart,attrEnd)}catch(e){$exceptionHandler(e,startingTag($compileNode))}directive.terminal&&(nodeLinkFn.terminal=!0,terminalPriority=Math.max(terminalPriority,directive.priority))}return nodeLinkFn.scope=newScopeDirective&&!0===newScopeDirective.scope,nodeLinkFn.transcludeOnThisElement=hasTranscludeDirective,nodeLinkFn.templateOnThisElement=hasTemplate,nodeLinkFn.transclude=childTranscludeFn,previousCompileContext.hasElementTranscludeDirective=hasElementTranscludeDirective,nodeLinkFn}function markDirectivesAsIsolate(directives){for(var j=0,jj=directives.length;j<jj;j++)directives[j]=inherit(directives[j],{$$isolateScope:!0})}function addDirective(tDirectives,name,location,maxPriority,ignoreDirective,startAttrName,endAttrName){if(name===ignoreDirective)return null;var match=null;if(hasDirectives.hasOwnProperty(name))for(var directive,directives=$injector.get(name+Suffix),i=0,ii=directives.length;i<ii;i++)try{directive=directives[i],(maxPriority===undefined||maxPriority>directive.priority)&&-1!=directive.restrict.indexOf(location)&&(startAttrName&&(directive=inherit(directive,{$$start:startAttrName,$$end:endAttrName})),tDirectives.push(directive),match=directive)}catch(e){$exceptionHandler(e)}return match}function directiveIsMultiElement(name){if(hasDirectives.hasOwnProperty(name))for(var directives=$injector.get(name+Suffix),i=0,ii=directives.length;i<ii;i++)if(directives[i].multiElement)return!0;return!1}function mergeTemplateAttributes(dst,src){var srcAttr=src.$attr,dstAttr=dst.$attr,$element=dst.$$element;forEach(dst,function(value,key){"$"!=key.charAt(0)&&(src[key]&&src[key]!==value&&(value+=("style"===key?";":" ")+src[key]),dst.$set(key,value,!0,srcAttr[key]))}),forEach(src,function(value,key){"class"==key?(safeAddClass($element,value),dst.class=(dst.class?dst.class+" ":"")+value):"style"==key?($element.attr("style",$element.attr("style")+";"+value),dst.style=(dst.style?dst.style+";":"")+value):"$"==key.charAt(0)||dst.hasOwnProperty(key)||(dst[key]=value,dstAttr[key]=srcAttr[key])})}function compileTemplateUrl(directives,$compileNode,tAttrs,$rootElement,childTranscludeFn,preLinkFns,postLinkFns,previousCompileContext){var afterTemplateNodeLinkFn,afterTemplateChildLinkFn,linkQueue=[],beforeTemplateCompileNode=$compileNode[0],origAsyncDirective=directives.shift(),derivedSyncDirective=inherit(origAsyncDirective,{templateUrl:null,transclude:null,replace:null,$$originalDirective:origAsyncDirective}),templateUrl=isFunction(origAsyncDirective.templateUrl)?origAsyncDirective.templateUrl($compileNode,tAttrs):origAsyncDirective.templateUrl,templateNamespace=origAsyncDirective.templateNamespace;return $compileNode.empty(),$templateRequest(templateUrl).then(function(content){var compileNode,tempTemplateAttrs,$template,childBoundTranscludeFn;if(content=denormalizeTemplate(content),origAsyncDirective.replace){if($template=jqLiteIsTextNode(content)?[]:removeComments(wrapTemplate(templateNamespace,trim(content))),compileNode=$template[0],1!=$template.length||compileNode.nodeType!==NODE_TYPE_ELEMENT)throw $compileMinErr("tplrt","Template for directive '{0}' must have exactly one root element. {1}",origAsyncDirective.name,templateUrl);tempTemplateAttrs={$attr:{}},replaceWith($rootElement,$compileNode,compileNode);var templateDirectives=collectDirectives(compileNode,[],tempTemplateAttrs);isObject(origAsyncDirective.scope)&&markDirectivesAsIsolate(templateDirectives),directives=templateDirectives.concat(directives),mergeTemplateAttributes(tAttrs,tempTemplateAttrs)}else compileNode=beforeTemplateCompileNode,$compileNode.html(content);for(directives.unshift(derivedSyncDirective),afterTemplateNodeLinkFn=applyDirectivesToNode(directives,compileNode,tAttrs,childTranscludeFn,$compileNode,origAsyncDirective,preLinkFns,postLinkFns,previousCompileContext),forEach($rootElement,function(node,i){node==compileNode&&($rootElement[i]=$compileNode[0])}),afterTemplateChildLinkFn=compileNodes($compileNode[0].childNodes,childTranscludeFn);linkQueue.length;){var scope=linkQueue.shift(),beforeTemplateLinkNode=linkQueue.shift(),linkRootElement=linkQueue.shift(),boundTranscludeFn=linkQueue.shift(),linkNode=$compileNode[0];if(!scope.$$destroyed){if(beforeTemplateLinkNode!==beforeTemplateCompileNode){var oldClasses=beforeTemplateLinkNode.className;previousCompileContext.hasElementTranscludeDirective&&origAsyncDirective.replace||(linkNode=jqLiteClone(compileNode)),replaceWith(linkRootElement,jqLite(beforeTemplateLinkNode),linkNode),safeAddClass(jqLite(linkNode),oldClasses)}childBoundTranscludeFn=afterTemplateNodeLinkFn.transcludeOnThisElement?createBoundTranscludeFn(scope,afterTemplateNodeLinkFn.transclude,boundTranscludeFn):boundTranscludeFn,afterTemplateNodeLinkFn(afterTemplateChildLinkFn,scope,linkNode,$rootElement,childBoundTranscludeFn,afterTemplateNodeLinkFn)}}linkQueue=null}),function(ignoreChildLinkFn,scope,node,rootElement,boundTranscludeFn){var childBoundTranscludeFn=boundTranscludeFn;scope.$$destroyed||(linkQueue?linkQueue.push(scope,node,rootElement,childBoundTranscludeFn):(afterTemplateNodeLinkFn.transcludeOnThisElement&&(childBoundTranscludeFn=createBoundTranscludeFn(scope,afterTemplateNodeLinkFn.transclude,boundTranscludeFn)),afterTemplateNodeLinkFn(afterTemplateChildLinkFn,scope,node,rootElement,childBoundTranscludeFn,afterTemplateNodeLinkFn)))}}function byPriority(a,b){var diff=b.priority-a.priority;return 0!==diff?diff:a.name!==b.name?a.name<b.name?-1:1:a.index-b.index}function assertNoDuplicate(what,previousDirective,directive,element){function wrapModuleNameIfDefined(moduleName){return moduleName?" (module: "+moduleName+")":""}if(previousDirective)throw $compileMinErr("multidir","Multiple directives [{0}{1}, {2}{3}] asking for {4} on: {5}",previousDirective.name,wrapModuleNameIfDefined(previousDirective.$$moduleName),directive.name,wrapModuleNameIfDefined(directive.$$moduleName),what,startingTag(element))}function addTextInterpolateDirective(directives,text){var interpolateFn=$interpolate(text,!0);interpolateFn&&directives.push({priority:0,compile:function(templateNode){var templateNodeParent=templateNode.parent(),hasCompileParent=!!templateNodeParent.length;return hasCompileParent&&compile.$$addBindingClass(templateNodeParent),function(scope,node){var parent=node.parent();hasCompileParent||compile.$$addBindingClass(parent),compile.$$addBindingInfo(parent,interpolateFn.expressions),scope.$watch(interpolateFn,function(value){node[0].nodeValue=value})}}})}function wrapTemplate(type,template){switch(type=lowercase(type||"html")){case"svg":case"math":var wrapper=document.createElement("div");return wrapper.innerHTML="<"+type+">"+template+"</"+type+">",wrapper.childNodes[0].childNodes;default:return template}}function getTrustedContext(node,attrNormalizedName){if("srcdoc"==attrNormalizedName)return $sce.HTML;var tag=nodeName_(node);return"xlinkHref"==attrNormalizedName||"form"==tag&&"action"==attrNormalizedName||"img"!=tag&&("src"==attrNormalizedName||"ngSrc"==attrNormalizedName)?$sce.RESOURCE_URL:void 0}function addAttrInterpolateDirective(node,directives,value,name,allOrNothing){var trustedContext=getTrustedContext(node,name);allOrNothing=ALL_OR_NOTHING_ATTRS[name]||allOrNothing;var interpolateFn=$interpolate(value,!0,trustedContext,allOrNothing);if(interpolateFn){if("multiple"===name&&"select"===nodeName_(node))throw $compileMinErr("selmulti","Binding to the 'multiple' attribute is not supported. Element: {0}",startingTag(node));directives.push({priority:100,compile:function(){return{pre:function(scope,element,attr){var $$observers=attr.$$observers||(attr.$$observers={});if(EVENT_HANDLER_ATTR_REGEXP.test(name))throw $compileMinErr("nodomevents","Interpolations for HTML DOM event attributes are disallowed.  Please use the ng- versions (such as ng-click instead of onclick) instead.");var newValue=attr[name];newValue!==value&&(interpolateFn=newValue&&$interpolate(newValue,!0,trustedContext,allOrNothing),value=newValue),interpolateFn&&(attr[name]=interpolateFn(scope),($$observers[name]||($$observers[name]=[])).$$inter=!0,(attr.$$observers&&attr.$$observers[name].$$scope||scope).$watch(interpolateFn,function(newValue,oldValue){"class"===name&&newValue!=oldValue?attr.$updateClass(newValue,oldValue):attr.$set(name,newValue)}))}}}})}}function replaceWith($rootElement,elementsToRemove,newNode){var i,ii,firstElementToRemove=elementsToRemove[0],removeCount=elementsToRemove.length,parent=firstElementToRemove.parentNode;if($rootElement)for(i=0,ii=$rootElement.length;i<ii;i++)if($rootElement[i]==firstElementToRemove){$rootElement[i++]=newNode;for(var j=i,j2=j+removeCount-1,jj=$rootElement.length;j<jj;j++,j2++)j2<jj?$rootElement[j]=$rootElement[j2]:delete $rootElement[j];$rootElement.length-=removeCount-1,$rootElement.context===firstElementToRemove&&($rootElement.context=newNode);break}parent&&parent.replaceChild(newNode,firstElementToRemove);var fragment=document.createDocumentFragment();fragment.appendChild(firstElementToRemove),jqLite.hasData(firstElementToRemove)&&(jqLite(newNode).data(jqLite(firstElementToRemove).data()),jQuery?(skipDestroyOnNextJQueryCleanData=!0,jQuery.cleanData([firstElementToRemove])):delete jqLite.cache[firstElementToRemove[jqLite.expando]]);for(var k=1,kk=elementsToRemove.length;k<kk;k++){var element=elementsToRemove[k];jqLite(element).remove(),fragment.appendChild(element),delete elementsToRemove[k]}elementsToRemove[0]=newNode,elementsToRemove.length=1}function cloneAndAnnotateFn(fn,annotation){return extend(function(){return fn.apply(null,arguments)},fn,annotation)}function invokeLinkFn(linkFn,scope,$element,attrs,controllers,transcludeFn){try{linkFn(scope,$element,attrs,controllers,transcludeFn)}catch(e){$exceptionHandler(e,startingTag($element))}}function initializeDirectiveBindings(scope,attrs,destination,bindings,directive,newScope){var onNewScopeDestroyed;forEach(bindings,function(definition,scopeName){var lastValue,parentGet,parentSet,compare,attrName=definition.attrName,optional=definition.optional,mode=definition.mode;switch(hasOwnProperty.call(attrs,attrName)||(attrs[attrName]=undefined),mode){case"@":attrs[attrName]||optional||(destination[scopeName]=undefined),attrs.$observe(attrName,function(value){destination[scopeName]=value}),attrs.$$observers[attrName].$$scope=scope,attrs[attrName]&&(destination[scopeName]=$interpolate(attrs[attrName])(scope));break;case"=":if(optional&&!attrs[attrName])return;parentGet=$parse(attrs[attrName]),compare=parentGet.literal?equals:function(a,b){return a===b||a!==a&&b!==b},parentSet=parentGet.assign||function(){throw lastValue=destination[scopeName]=parentGet(scope),$compileMinErr("nonassign","Expression '{0}' used with directive '{1}' is non-assignable!",attrs[attrName],directive.name)},lastValue=destination[scopeName]=parentGet(scope);var parentValueWatch=function(parentValue){return compare(parentValue,destination[scopeName])||(compare(parentValue,lastValue)?parentSet(scope,parentValue=destination[scopeName]):destination[scopeName]=parentValue),lastValue=parentValue};parentValueWatch.$stateful=!0;var unwatch;unwatch=definition.collection?scope.$watchCollection(attrs[attrName],parentValueWatch):scope.$watch($parse(attrs[attrName],parentValueWatch),null,parentGet.literal),(onNewScopeDestroyed=onNewScopeDestroyed||[]).push(unwatch);break;case"&":if((parentGet=$parse(attrs[attrName]))===noop&&optional)break;destination[scopeName]=function(locals){return parentGet(scope,locals)}}});var destroyBindings=onNewScopeDestroyed?function(){for(var i=0,ii=onNewScopeDestroyed.length;i<ii;++i)onNewScopeDestroyed[i]()}:noop;return newScope&&destroyBindings!==noop?(newScope.$on("$destroy",destroyBindings),noop):destroyBindings}var Attributes=function(element,attributesToCopy){if(attributesToCopy){var i,l,key,keys=Object.keys(attributesToCopy);for(i=0,l=keys.length;i<l;i++)this[key=keys[i]]=attributesToCopy[key]}else this.$attr={};this.$$element=element};Attributes.prototype={$normalize:directiveNormalize,$addClass:function(classVal){classVal&&classVal.length>0&&$animate.addClass(this.$$element,classVal)},$removeClass:function(classVal){classVal&&classVal.length>0&&$animate.removeClass(this.$$element,classVal)},$updateClass:function(newClasses,oldClasses){var toAdd=tokenDifference(newClasses,oldClasses);toAdd&&toAdd.length&&$animate.addClass(this.$$element,toAdd);var toRemove=tokenDifference(oldClasses,newClasses);toRemove&&toRemove.length&&$animate.removeClass(this.$$element,toRemove)},$set:function(key,value,writeAttr,attrName){var nodeName,node=this.$$element[0],booleanKey=getBooleanAttrName(node,key),aliasedKey=getAliasedAttrName(node,key),observer=key;if(booleanKey?(this.$$element.prop(key,value),attrName=booleanKey):aliasedKey&&(this[aliasedKey]=value,observer=aliasedKey),this[key]=value,attrName?this.$attr[key]=attrName:(attrName=this.$attr[key])||(this.$attr[key]=attrName=snake_case(key,"-")),"a"===(nodeName=nodeName_(this.$$element))&&"href"===key||"img"===nodeName&&"src"===key)this[key]=value=$$sanitizeUri(value,"src"===key);else if("img"===nodeName&&"srcset"===key){for(var result="",trimmedSrcset=trim(value),srcPattern=/(\s+\d+x\s*,|\s+\d+w\s*,|\s+,|,\s+)/,pattern=/\s/.test(trimmedSrcset)?srcPattern:/(,)/,rawUris=trimmedSrcset.split(pattern),nbrUrisWith2parts=Math.floor(rawUris.length/2),i=0;i<nbrUrisWith2parts;i++){var innerIdx=2*i;result+=$$sanitizeUri(trim(rawUris[innerIdx]),!0),result+=" "+trim(rawUris[innerIdx+1])}var lastTuple=trim(rawUris[2*i]).split(/\s/);result+=$$sanitizeUri(trim(lastTuple[0]),!0),2===lastTuple.length&&(result+=" "+trim(lastTuple[1])),this[key]=value=result}!1!==writeAttr&&(null===value||value===undefined?this.$$element.removeAttr(attrName):this.$$element.attr(attrName,value));var $$observers=this.$$observers;$$observers&&forEach($$observers[observer],function(fn){try{fn(value)}catch(e){$exceptionHandler(e)}})},$observe:function(key,fn){var attrs=this,$$observers=attrs.$$observers||(attrs.$$observers=createMap()),listeners=$$observers[key]||($$observers[key]=[]);return listeners.push(fn),$rootScope.$evalAsync(function(){!listeners.$$inter&&attrs.hasOwnProperty(key)&&fn(attrs[key])}),function(){arrayRemove(listeners,fn)}}};var startSymbol=$interpolate.startSymbol(),endSymbol=$interpolate.endSymbol(),denormalizeTemplate="{{"==startSymbol||"}}"==endSymbol?identity:function(template){return template.replace(/\{\{/g,startSymbol).replace(/}}/g,endSymbol)},NG_ATTR_BINDING=/^ngAttr[A-Z]/;return compile.$$addBindingInfo=debugInfoEnabled?function($element,binding){var bindings=$element.data("$binding")||[];isArray(binding)?bindings=bindings.concat(binding):bindings.push(binding),$element.data("$binding",bindings)}:noop,compile.$$addBindingClass=debugInfoEnabled?function($element){safeAddClass($element,"ng-binding")}:noop,compile.$$addScopeInfo=debugInfoEnabled?function($element,scope,isolated,noTemplate){var dataName=isolated?noTemplate?"$isolateScopeNoTemplate":"$isolateScope":"$scope";$element.data(dataName,scope)}:noop,compile.$$addScopeClass=debugInfoEnabled?function($element,isolated){safeAddClass($element,isolated?"ng-isolate-scope":"ng-scope")}:noop,compile}]}function directiveNormalize(name){return camelCase(name.replace(PREFIX_REGEXP,""))}function tokenDifference(str1,str2){var values="",tokens1=str1.split(/\s+/),tokens2=str2.split(/\s+/);outer:for(var i=0;i<tokens1.length;i++){for(var token=tokens1[i],j=0;j<tokens2.length;j++)if(token==tokens2[j])continue outer;values+=(values.length>0?" ":"")+token}return values}function removeComments(jqNodes){var i=(jqNodes=jqLite(jqNodes)).length;if(i<=1)return jqNodes;for(;i--;)jqNodes[i].nodeType===NODE_TYPE_COMMENT&&splice.call(jqNodes,i,1);return jqNodes}function identifierForController(controller,ident){if(ident&&isString(ident))return ident;if(isString(controller)){var match=CNTRL_REG.exec(controller);if(match)return match[3]}}function $ControllerProvider(){var controllers={},globals=!1;this.register=function(name,constructor){assertNotHasOwnProperty(name,"controller"),isObject(name)?extend(controllers,name):controllers[name]=constructor},this.allowGlobals=function(){globals=!0},this.$get=["$injector","$window",function($injector,$window){function addIdentifier(locals,identifier,instance,name){if(!locals||!isObject(locals.$scope))throw minErr("$controller")("noscp","Cannot export controller '{0}' as '{1}'! No $scope object provided via `locals`.",name,identifier);locals.$scope[identifier]=instance}return function(expression,locals,later,ident){var instance,match,constructor,identifier;if(later=!0===later,ident&&isString(ident)&&(identifier=ident),isString(expression)){if(!(match=expression.match(CNTRL_REG)))throw $controllerMinErr("ctrlfmt","Badly formed controller string '{0}'. Must match `__name__ as __id__` or `__name__`.",expression);constructor=match[1],identifier=identifier||match[3],assertArgFn(expression=controllers.hasOwnProperty(constructor)?controllers[constructor]:getter(locals.$scope,constructor,!0)||(globals?getter($window,constructor,!0):undefined),constructor,!0)}if(later){var controllerPrototype=(isArray(expression)?expression[expression.length-1]:expression).prototype;instance=Object.create(controllerPrototype||null),identifier&&addIdentifier(locals,identifier,instance,constructor||expression.name);return extend(function(){var result=$injector.invoke(expression,instance,locals,constructor);return result!==instance&&(isObject(result)||isFunction(result))&&(instance=result,identifier&&addIdentifier(locals,identifier,instance,constructor||expression.name)),instance},{instance:instance,identifier:identifier})}return instance=$injector.instantiate(expression,locals,constructor),identifier&&addIdentifier(locals,identifier,instance,constructor||expression.name),instance}}]}function $DocumentProvider(){this.$get=["$window",function(window){return jqLite(window.document)}]}function $ExceptionHandlerProvider(){this.$get=["$log",function($log){return function(exception,cause){$log.error.apply($log,arguments)}}]}function serializeValue(v){return isObject(v)?isDate(v)?v.toISOString():toJson(v):v}function $HttpParamSerializerProvider(){this.$get=function(){return function(params){if(!params)return"";var parts=[];return forEachSorted(params,function(value,key){null===value||isUndefined(value)||(isArray(value)?forEach(value,function(v,k){parts.push(encodeUriQuery(key)+"="+encodeUriQuery(serializeValue(v)))}):parts.push(encodeUriQuery(key)+"="+encodeUriQuery(serializeValue(value))))}),parts.join("&")}}}function $HttpParamSerializerJQLikeProvider(){this.$get=function(){return function(params){function serialize(toSerialize,prefix,topLevel){null===toSerialize||isUndefined(toSerialize)||(isArray(toSerialize)?forEach(toSerialize,function(value){serialize(value,prefix+"[]")}):isObject(toSerialize)&&!isDate(toSerialize)?forEachSorted(toSerialize,function(value,key){serialize(value,prefix+(topLevel?"":"[")+key+(topLevel?"":"]"))}):parts.push(encodeUriQuery(prefix)+"="+encodeUriQuery(serializeValue(toSerialize))))}if(!params)return"";var parts=[];return serialize(params,"",!0),parts.join("&")}}}function defaultHttpResponseTransform(data,headers){if(isString(data)){var tempData=data.replace(JSON_PROTECTION_PREFIX,"").trim();if(tempData){var contentType=headers("Content-Type");(contentType&&0===contentType.indexOf(APPLICATION_JSON)||isJsonLike(tempData))&&(data=fromJson(tempData))}}return data}function isJsonLike(str){var jsonStart=str.match(JSON_START);return jsonStart&&JSON_ENDS[jsonStart[0]].test(str)}function parseHeaders(headers){function fillInParsed(key,val){key&&(parsed[key]=parsed[key]?parsed[key]+", "+val:val)}var i,parsed=createMap();return isString(headers)?forEach(headers.split("\n"),function(line){i=line.indexOf(":"),fillInParsed(lowercase(trim(line.substr(0,i))),trim(line.substr(i+1)))}):isObject(headers)&&forEach(headers,function(headerVal,headerKey){fillInParsed(lowercase(headerKey),trim(headerVal))}),parsed}function headersGetter(headers){var headersObj;return function(name){if(headersObj||(headersObj=parseHeaders(headers)),name){var value=headersObj[lowercase(name)];return void 0===value&&(value=null),value}return headersObj}}function transformData(data,headers,status,fns){return isFunction(fns)?fns(data,headers,status):(forEach(fns,function(fn){data=fn(data,headers,status)}),data)}function isSuccess(status){return 200<=status&&status<300}function $HttpProvider(){var defaults=this.defaults={transformResponse:[defaultHttpResponseTransform],transformRequest:[function(d){return!isObject(d)||isFile(d)||isBlob(d)||isFormData(d)?d:toJson(d)}],headers:{common:{Accept:"application/json, text/plain, */*"},post:shallowCopy(CONTENT_TYPE_APPLICATION_JSON),put:shallowCopy(CONTENT_TYPE_APPLICATION_JSON),patch:shallowCopy(CONTENT_TYPE_APPLICATION_JSON)},xsrfCookieName:"XSRF-TOKEN",xsrfHeaderName:"X-XSRF-TOKEN",paramSerializer:"$httpParamSerializer"},useApplyAsync=!1;this.useApplyAsync=function(value){return isDefined(value)?(useApplyAsync=!!value,this):useApplyAsync};var interceptorFactories=this.interceptors=[];this.$get=["$httpBackend","$$cookieReader","$cacheFactory","$rootScope","$q","$injector",function($httpBackend,$$cookieReader,$cacheFactory,$rootScope,$q,$injector){function $http(requestConfig){function transformResponse(response){var resp=extend({},response);return response.data?resp.data=transformData(response.data,response.headers,response.status,config.transformResponse):resp.data=response.data,isSuccess(response.status)?resp:$q.reject(resp)}function executeHeaderFns(headers,config){var headerContent,processedHeaders={};return forEach(headers,function(headerFn,header){isFunction(headerFn)?null!=(headerContent=headerFn(config))&&(processedHeaders[header]=headerContent):processedHeaders[header]=headerFn}),processedHeaders}if(!angular.isObject(requestConfig))throw minErr("$http")("badreq","Http request configuration must be an object.  Received: {0}",requestConfig);var config=extend({method:"get",transformRequest:defaults.transformRequest,transformResponse:defaults.transformResponse,paramSerializer:defaults.paramSerializer},requestConfig);config.headers=function(config){var defHeaderName,lowercaseDefHeaderName,reqHeaderName,defHeaders=defaults.headers,reqHeaders=extend({},config.headers);defHeaders=extend({},defHeaders.common,defHeaders[lowercase(config.method)]);defaultHeadersIteration:for(defHeaderName in defHeaders){lowercaseDefHeaderName=lowercase(defHeaderName);for(reqHeaderName in reqHeaders)if(lowercase(reqHeaderName)===lowercaseDefHeaderName)continue defaultHeadersIteration;reqHeaders[defHeaderName]=defHeaders[defHeaderName]}return executeHeaderFns(reqHeaders,shallowCopy(config))}(requestConfig),config.method=uppercase(config.method),config.paramSerializer=isString(config.paramSerializer)?$injector.get(config.paramSerializer):config.paramSerializer;var chain=[function(config){var headers=config.headers,reqData=transformData(config.data,headersGetter(headers),undefined,config.transformRequest);return isUndefined(reqData)&&forEach(headers,function(value,header){"content-type"===lowercase(header)&&delete headers[header]}),isUndefined(config.withCredentials)&&!isUndefined(defaults.withCredentials)&&(config.withCredentials=defaults.withCredentials),sendReq(config,reqData).then(transformResponse,transformResponse)},undefined],promise=$q.when(config);for(forEach(reversedInterceptors,function(interceptor){(interceptor.request||interceptor.requestError)&&chain.unshift(interceptor.request,interceptor.requestError),(interceptor.response||interceptor.responseError)&&chain.push(interceptor.response,interceptor.responseError)});chain.length;){var thenFn=chain.shift(),rejectFn=chain.shift();promise=promise.then(thenFn,rejectFn)}return promise.success=function(fn){return assertArgFn(fn,"fn"),promise.then(function(response){fn(response.data,response.status,response.headers,config)}),promise},promise.error=function(fn){return assertArgFn(fn,"fn"),promise.then(null,function(response){fn(response.data,response.status,response.headers,config)}),promise},promise}function sendReq(config,reqData){function resolvePromise(response,status,headers,statusText){(isSuccess(status=Math.max(status,0))?deferred.resolve:deferred.reject)({data:response,status:status,headers:headersGetter(headers),config:config,statusText:statusText})}function resolvePromiseWithResult(result){resolvePromise(result.data,result.status,shallowCopy(result.headers()),result.statusText)}function removePendingReq(){var idx=$http.pendingRequests.indexOf(config);-1!==idx&&$http.pendingRequests.splice(idx,1)}var cache,cachedResp,deferred=$q.defer(),promise=deferred.promise,reqHeaders=config.headers,url=buildUrl(config.url,config.paramSerializer(config.params));if($http.pendingRequests.push(config),promise.then(removePendingReq,removePendingReq),!config.cache&&!defaults.cache||!1===config.cache||"GET"!==config.method&&"JSONP"!==config.method||(cache=isObject(config.cache)?config.cache:isObject(defaults.cache)?defaults.cache:defaultCache),cache&&(isDefined(cachedResp=cache.get(url))?isPromiseLike(cachedResp)?cachedResp.then(resolvePromiseWithResult,resolvePromiseWithResult):isArray(cachedResp)?resolvePromise(cachedResp[1],cachedResp[0],shallowCopy(cachedResp[2]),cachedResp[3]):resolvePromise(cachedResp,200,{},"OK"):cache.put(url,promise)),isUndefined(cachedResp)){var xsrfValue=urlIsSameOrigin(config.url)?$$cookieReader()[config.xsrfCookieName||defaults.xsrfCookieName]:undefined;xsrfValue&&(reqHeaders[config.xsrfHeaderName||defaults.xsrfHeaderName]=xsrfValue),$httpBackend(config.method,url,reqData,function(status,response,headersString,statusText){function resolveHttpPromise(){resolvePromise(response,status,headersString,statusText)}cache&&(isSuccess(status)?cache.put(url,[status,response,parseHeaders(headersString),statusText]):cache.remove(url)),useApplyAsync?$rootScope.$applyAsync(resolveHttpPromise):(resolveHttpPromise(),$rootScope.$$phase||$rootScope.$apply())},reqHeaders,config.timeout,config.withCredentials,config.responseType)}return promise}function buildUrl(url,serializedParams){return serializedParams.length>0&&(url+=(-1==url.indexOf("?")?"?":"&")+serializedParams),url}var defaultCache=$cacheFactory("$http");defaults.paramSerializer=isString(defaults.paramSerializer)?$injector.get(defaults.paramSerializer):defaults.paramSerializer;var reversedInterceptors=[];return forEach(interceptorFactories,function(interceptorFactory){reversedInterceptors.unshift(isString(interceptorFactory)?$injector.get(interceptorFactory):$injector.invoke(interceptorFactory))}),$http.pendingRequests=[],function(names){forEach(arguments,function(name){$http[name]=function(url,config){return $http(extend({},config||{},{method:name,url:url}))}})}("get","delete","head","jsonp"),function(name){forEach(arguments,function(name){$http[name]=function(url,data,config){return $http(extend({},config||{},{method:name,url:url,data:data}))}})}("post","put","patch"),$http.defaults=defaults,$http}]}function createXhr(){return new window.XMLHttpRequest}function $HttpBackendProvider(){this.$get=["$browser","$window","$document",function($browser,$window,$document){return createHttpBackend($browser,createXhr,$browser.defer,$window.angular.callbacks,$document[0])}]}function createHttpBackend($browser,createXhr,$browserDefer,callbacks,rawDocument){function jsonpReq(url,callbackId,done){var script=rawDocument.createElement("script"),callback=null;return script.type="text/javascript",script.src=url,script.async=!0,callback=function(event){removeEventListenerFn(script,"load",callback),removeEventListenerFn(script,"error",callback),rawDocument.body.removeChild(script),script=null;var status=-1,text="unknown";event&&("load"!==event.type||callbacks[callbackId].called||(event={type:"error"}),text=event.type,status="error"===event.type?404:200),done&&done(status,text)},addEventListenerFn(script,"load",callback),addEventListenerFn(script,"error",callback),rawDocument.body.appendChild(script),callback}return function(method,url,post,callback,headers,timeout,withCredentials,responseType){function timeoutRequest(){jsonpDone&&jsonpDone(),xhr&&xhr.abort()}function completeRequest(callback,status,response,headersString,statusText){timeoutId!==undefined&&$browserDefer.cancel(timeoutId),jsonpDone=xhr=null,callback(status,response,headersString,statusText),$browser.$$completeOutstandingRequest(noop)}if($browser.$$incOutstandingRequestCount(),url=url||$browser.url(),"jsonp"==lowercase(method)){var callbackId="_"+(callbacks.counter++).toString(36);callbacks[callbackId]=function(data){callbacks[callbackId].data=data,callbacks[callbackId].called=!0};var jsonpDone=jsonpReq(url.replace("JSON_CALLBACK","angular.callbacks."+callbackId),callbackId,function(status,text){completeRequest(callback,status,callbacks[callbackId].data,"",text),callbacks[callbackId]=noop})}else{var xhr=createXhr();xhr.open(method,url,!0),forEach(headers,function(value,key){isDefined(value)&&xhr.setRequestHeader(key,value)}),xhr.onload=function(){var statusText=xhr.statusText||"",response="response"in xhr?xhr.response:xhr.responseText,status=1223===xhr.status?204:xhr.status;0===status&&(status=response?200:"file"==urlResolve(url).protocol?404:0),completeRequest(callback,status,response,xhr.getAllResponseHeaders(),statusText)};var requestError=function(){completeRequest(callback,-1,null,null,"")};if(xhr.onerror=requestError,xhr.onabort=requestError,withCredentials&&(xhr.withCredentials=!0),responseType)try{xhr.responseType=responseType}catch(e){if("json"!==responseType)throw e}xhr.send(post)}if(timeout>0)var timeoutId=$browserDefer(timeoutRequest,timeout);else isPromiseLike(timeout)&&timeout.then(timeoutRequest)}}function $InterpolateProvider(){var startSymbol="{{",endSymbol="}}";this.startSymbol=function(value){return value?(startSymbol=value,this):startSymbol},this.endSymbol=function(value){return value?(endSymbol=value,this):endSymbol},this.$get=["$parse","$exceptionHandler","$sce",function($parse,$exceptionHandler,$sce){function escape(ch){return"\\\\\\"+ch}function unescapeText(text){return text.replace(escapedStartRegexp,startSymbol).replace(escapedEndRegexp,endSymbol)}function stringify(value){if(null==value)return"";switch(typeof value){case"string":break;case"number":value=""+value;break;default:value=toJson(value)}return value}function $interpolate(text,mustHaveExpression,trustedContext,allOrNothing){allOrNothing=!!allOrNothing;for(var startIndex,endIndex,exp,index=0,expressions=[],parseFns=[],textLength=text.length,concat=[],expressionPositions=[];index<textLength;){if(-1==(startIndex=text.indexOf(startSymbol,index))||-1==(endIndex=text.indexOf(endSymbol,startIndex+startSymbolLength))){index!==textLength&&concat.push(unescapeText(text.substring(index)));break}index!==startIndex&&concat.push(unescapeText(text.substring(index,startIndex))),exp=text.substring(startIndex+startSymbolLength,endIndex),expressions.push(exp),parseFns.push($parse(exp,function(value){try{return value=getValue(value),allOrNothing&&!isDefined(value)?value:stringify(value)}catch(err){$exceptionHandler($interpolateMinErr.interr(text,err))}})),index=endIndex+endSymbolLength,expressionPositions.push(concat.length),concat.push("")}if(trustedContext&&concat.length>1&&$interpolateMinErr.throwNoconcat(text),!mustHaveExpression||expressions.length){var compute=function(values){for(var i=0,ii=expressions.length;i<ii;i++){if(allOrNothing&&isUndefined(values[i]))return;concat[expressionPositions[i]]=values[i]}return concat.join("")},getValue=function(value){return trustedContext?$sce.getTrusted(trustedContext,value):$sce.valueOf(value)};return extend(function(context){var i=0,ii=expressions.length,values=new Array(ii);try{for(;i<ii;i++)values[i]=parseFns[i](context);return compute(values)}catch(err){$exceptionHandler($interpolateMinErr.interr(text,err))}},{exp:text,expressions:expressions,$$watchDelegate:function(scope,listener){var lastValue;return scope.$watchGroup(parseFns,function(values,oldValues){var currValue=compute(values);isFunction(listener)&&listener.call(this,currValue,values!==oldValues?lastValue:currValue,scope),lastValue=currValue})}})}}var startSymbolLength=startSymbol.length,endSymbolLength=endSymbol.length,escapedStartRegexp=new RegExp(startSymbol.replace(/./g,escape),"g"),escapedEndRegexp=new RegExp(endSymbol.replace(/./g,escape),"g");return $interpolate.startSymbol=function(){return startSymbol},$interpolate.endSymbol=function(){return endSymbol},$interpolate}]}function $IntervalProvider(){this.$get=["$rootScope","$window","$q","$$q",function($rootScope,$window,$q,$$q){function interval(fn,delay,count,invokeApply){var hasParams=arguments.length>4,args=hasParams?sliceArgs(arguments,4):[],setInterval=$window.setInterval,clearInterval=$window.clearInterval,iteration=0,skipApply=isDefined(invokeApply)&&!invokeApply,deferred=(skipApply?$$q:$q).defer(),promise=deferred.promise;return count=isDefined(count)?count:0,promise.then(null,null,hasParams?function(){fn.apply(null,args)}:fn),promise.$$intervalId=setInterval(function(){deferred.notify(iteration++),count>0&&iteration>=count&&(deferred.resolve(iteration),clearInterval(promise.$$intervalId),delete intervals[promise.$$intervalId]),skipApply||$rootScope.$apply()},delay),intervals[promise.$$intervalId]=deferred,promise}var intervals={};return interval.cancel=function(promise){return!!(promise&&promise.$$intervalId in intervals)&&(intervals[promise.$$intervalId].reject("canceled"),$window.clearInterval(promise.$$intervalId),delete intervals[promise.$$intervalId],!0)},interval}]}function $LocaleProvider(){this.$get=function(){return{id:"en-us",NUMBER_FORMATS:{DECIMAL_SEP:".",GROUP_SEP:",",PATTERNS:[{minInt:1,minFrac:0,maxFrac:3,posPre:"",posSuf:"",negPre:"-",negSuf:"",gSize:3,lgSize:3},{minInt:1,minFrac:2,maxFrac:2,posPre:"¤",posSuf:"",negPre:"(¤",negSuf:")",gSize:3,lgSize:3}],CURRENCY_SYM:"$"},DATETIME_FORMATS:{MONTH:"January,February,March,April,May,June,July,August,September,October,November,December".split(","),SHORTMONTH:"Jan,Feb,Mar,Apr,May,Jun,Jul,Aug,Sep,Oct,Nov,Dec".split(","),DAY:"Sunday,Monday,Tuesday,Wednesday,Thursday,Friday,Saturday".split(","),SHORTDAY:"Sun,Mon,Tue,Wed,Thu,Fri,Sat".split(","),AMPMS:["AM","PM"],medium:"MMM d, y h:mm:ss a",short:"M/d/yy h:mm a",fullDate:"EEEE, MMMM d, y",longDate:"MMMM d, y",mediumDate:"MMM d, y",shortDate:"M/d/yy",mediumTime:"h:mm:ss a",shortTime:"h:mm a",ERANAMES:["Before Christ","Anno Domini"],ERAS:["BC","AD"]},pluralCat:function(num){return 1===num?"one":"other"}}}}function encodePath(path){for(var segments=path.split("/"),i=segments.length;i--;)segments[i]=encodeUriSegment(segments[i]);return segments.join("/")}function parseAbsoluteUrl(absoluteUrl,locationObj){var parsedUrl=urlResolve(absoluteUrl);locationObj.$$protocol=parsedUrl.protocol,locationObj.$$host=parsedUrl.hostname,locationObj.$$port=toInt(parsedUrl.port)||DEFAULT_PORTS[parsedUrl.protocol]||null}function parseAppUrl(relativeUrl,locationObj){var prefixed="/"!==relativeUrl.charAt(0);prefixed&&(relativeUrl="/"+relativeUrl);var match=urlResolve(relativeUrl);locationObj.$$path=decodeURIComponent(prefixed&&"/"===match.pathname.charAt(0)?match.pathname.substring(1):match.pathname),locationObj.$$search=parseKeyValue(match.search),locationObj.$$hash=decodeURIComponent(match.hash),locationObj.$$path&&"/"!=locationObj.$$path.charAt(0)&&(locationObj.$$path="/"+locationObj.$$path)}function beginsWith(begin,whole){if(0===whole.indexOf(begin))return whole.substr(begin.length)}function stripHash(url){var index=url.indexOf("#");return-1==index?url:url.substr(0,index)}function trimEmptyHash(url){return url.replace(/(#.+)|#$/,"$1")}function stripFile(url){return url.substr(0,stripHash(url).lastIndexOf("/")+1)}function serverBase(url){return url.substring(0,url.indexOf("/",url.indexOf("//")+2))}function LocationHtml5Url(appBase,basePrefix){this.$$html5=!0,basePrefix=basePrefix||"";var appBaseNoFile=stripFile(appBase);parseAbsoluteUrl(appBase,this),this.$$parse=function(url){var pathUrl=beginsWith(appBaseNoFile,url);if(!isString(pathUrl))throw $locationMinErr("ipthprfx",'Invalid url "{0}", missing path prefix "{1}".',url,appBaseNoFile);parseAppUrl(pathUrl,this),this.$$path||(this.$$path="/"),this.$$compose()},this.$$compose=function(){var search=toKeyValue(this.$$search),hash=this.$$hash?"#"+encodeUriSegment(this.$$hash):"";this.$$url=encodePath(this.$$path)+(search?"?"+search:"")+hash,this.$$absUrl=appBaseNoFile+this.$$url.substr(1)},this.$$parseLinkUrl=function(url,relHref){if(relHref&&"#"===relHref[0])return this.hash(relHref.slice(1)),!0;var appUrl,prevAppUrl,rewrittenUrl;return(appUrl=beginsWith(appBase,url))!==undefined?(prevAppUrl=appUrl,rewrittenUrl=(appUrl=beginsWith(basePrefix,appUrl))!==undefined?appBaseNoFile+(beginsWith("/",appUrl)||appUrl):appBase+prevAppUrl):(appUrl=beginsWith(appBaseNoFile,url))!==undefined?rewrittenUrl=appBaseNoFile+appUrl:appBaseNoFile==url+"/"&&(rewrittenUrl=appBaseNoFile),rewrittenUrl&&this.$$parse(rewrittenUrl),!!rewrittenUrl}}function LocationHashbangUrl(appBase,hashPrefix){var appBaseNoFile=stripFile(appBase);parseAbsoluteUrl(appBase,this),this.$$parse=function(url){var withoutHashUrl,withoutBaseUrl=beginsWith(appBase,url)||beginsWith(appBaseNoFile,url);isUndefined(withoutBaseUrl)||"#"!==withoutBaseUrl.charAt(0)?this.$$html5?withoutHashUrl=withoutBaseUrl:(withoutHashUrl="",isUndefined(withoutBaseUrl)&&(appBase=url,this.replace())):isUndefined(withoutHashUrl=beginsWith(hashPrefix,withoutBaseUrl))&&(withoutHashUrl=withoutBaseUrl),parseAppUrl(withoutHashUrl,this),this.$$path=function(path,url,base){var firstPathSegmentMatch,windowsFilePathExp=/^\/[A-Z]:(\/.*)/;return 0===url.indexOf(base)&&(url=url.replace(base,"")),windowsFilePathExp.exec(url)?path:(firstPathSegmentMatch=windowsFilePathExp.exec(path))?firstPathSegmentMatch[1]:path}(this.$$path,withoutHashUrl,appBase),this.$$compose()},this.$$compose=function(){var search=toKeyValue(this.$$search),hash=this.$$hash?"#"+encodeUriSegment(this.$$hash):"";this.$$url=encodePath(this.$$path)+(search?"?"+search:"")+hash,this.$$absUrl=appBase+(this.$$url?hashPrefix+this.$$url:"")},this.$$parseLinkUrl=function(url,relHref){return stripHash(appBase)==stripHash(url)&&(this.$$parse(url),!0)}}function LocationHashbangInHtml5Url(appBase,hashPrefix){this.$$html5=!0,LocationHashbangUrl.apply(this,arguments);var appBaseNoFile=stripFile(appBase);this.$$parseLinkUrl=function(url,relHref){if(relHref&&"#"===relHref[0])return this.hash(relHref.slice(1)),!0;var rewrittenUrl,appUrl;return appBase==stripHash(url)?rewrittenUrl=url:(appUrl=beginsWith(appBaseNoFile,url))?rewrittenUrl=appBase+hashPrefix+appUrl:appBaseNoFile===url+"/"&&(rewrittenUrl=appBaseNoFile),rewrittenUrl&&this.$$parse(rewrittenUrl),!!rewrittenUrl},this.$$compose=function(){var search=toKeyValue(this.$$search),hash=this.$$hash?"#"+encodeUriSegment(this.$$hash):"";this.$$url=encodePath(this.$$path)+(search?"?"+search:"")+hash,this.$$absUrl=appBase+hashPrefix+this.$$url}}function locationGetter(property){return function(){return this[property]}}function locationGetterSetter(property,preprocess){return function(value){return isUndefined(value)?this[property]:(this[property]=preprocess(value),this.$$compose(),this)}}function $LocationProvider(){var hashPrefix="",html5Mode={enabled:!1,requireBase:!0,rewriteLinks:!0};this.hashPrefix=function(prefix){return isDefined(prefix)?(hashPrefix=prefix,this):hashPrefix},this.html5Mode=function(mode){return isBoolean(mode)?(html5Mode.enabled=mode,this):isObject(mode)?(isBoolean(mode.enabled)&&(html5Mode.enabled=mode.enabled),isBoolean(mode.requireBase)&&(html5Mode.requireBase=mode.requireBase),isBoolean(mode.rewriteLinks)&&(html5Mode.rewriteLinks=mode.rewriteLinks),this):html5Mode},this.$get=["$rootScope","$browser","$sniffer","$rootElement","$window",function($rootScope,$browser,$sniffer,$rootElement,$window){function setBrowserUrlWithFallback(url,replace,state){var oldUrl=$location.url(),oldState=$location.$$state;try{$browser.url(url,replace,state),$location.$$state=$browser.state()}catch(e){throw $location.url(oldUrl),$location.$$state=oldState,e}}function afterLocationChange(oldUrl,oldState){$rootScope.$broadcast("$locationChangeSuccess",$location.absUrl(),oldUrl,$location.$$state,oldState)}var $location,LocationMode,appBase,baseHref=$browser.baseHref(),initialUrl=$browser.url();if(html5Mode.enabled){if(!baseHref&&html5Mode.requireBase)throw $locationMinErr("nobase","$location in HTML5 mode requires a <base> tag to be present!");appBase=serverBase(initialUrl)+(baseHref||"/"),LocationMode=$sniffer.history?LocationHtml5Url:LocationHashbangInHtml5Url}else appBase=stripHash(initialUrl),LocationMode=LocationHashbangUrl;($location=new LocationMode(appBase,"#"+hashPrefix)).$$parseLinkUrl(initialUrl,initialUrl),$location.$$state=$browser.state();var IGNORE_URI_REGEXP=/^\s*(javascript|mailto):/i;$rootElement.on("click",function(event){if(html5Mode.rewriteLinks&&!event.ctrlKey&&!event.metaKey&&!event.shiftKey&&2!=event.which&&2!=event.button){for(var elm=jqLite(event.target);"a"!==nodeName_(elm[0]);)if(elm[0]===$rootElement[0]||!(elm=elm.parent())[0])return;var absHref=elm.prop("href"),relHref=elm.attr("href")||elm.attr("xlink:href");isObject(absHref)&&"[object SVGAnimatedString]"===absHref.toString()&&(absHref=urlResolve(absHref.animVal).href),IGNORE_URI_REGEXP.test(absHref)||!absHref||elm.attr("target")||event.isDefaultPrevented()||$location.$$parseLinkUrl(absHref,relHref)&&(event.preventDefault(),$location.absUrl()!=$browser.url()&&($rootScope.$apply(),$window.angular["ff-684208-preventDefault"]=!0))}}),trimEmptyHash($location.absUrl())!=trimEmptyHash(initialUrl)&&$browser.url($location.absUrl(),!0);var initializing=!0;return $browser.onUrlChange(function(newUrl,newState){$rootScope.$evalAsync(function(){var defaultPrevented,oldUrl=$location.absUrl(),oldState=$location.$$state;$location.$$parse(newUrl),$location.$$state=newState,defaultPrevented=$rootScope.$broadcast("$locationChangeStart",newUrl,oldUrl,newState,oldState).defaultPrevented,$location.absUrl()===newUrl&&(defaultPrevented?($location.$$parse(oldUrl),$location.$$state=oldState,setBrowserUrlWithFallback(oldUrl,!1,oldState)):(initializing=!1,afterLocationChange(oldUrl,oldState)))}),$rootScope.$$phase||$rootScope.$digest()}),$rootScope.$watch(function(){var oldUrl=trimEmptyHash($browser.url()),newUrl=trimEmptyHash($location.absUrl()),oldState=$browser.state(),currentReplace=$location.$$replace,urlOrStateChanged=oldUrl!==newUrl||$location.$$html5&&$sniffer.history&&oldState!==$location.$$state;(initializing||urlOrStateChanged)&&(initializing=!1,$rootScope.$evalAsync(function(){var newUrl=$location.absUrl(),defaultPrevented=$rootScope.$broadcast("$locationChangeStart",newUrl,oldUrl,$location.$$state,oldState).defaultPrevented;$location.absUrl()===newUrl&&(defaultPrevented?($location.$$parse(oldUrl),$location.$$state=oldState):(urlOrStateChanged&&setBrowserUrlWithFallback(newUrl,currentReplace,oldState===$location.$$state?null:$location.$$state),afterLocationChange(oldUrl,oldState)))})),$location.$$replace=!1}),$location}]}function $LogProvider(){var debug=!0,self=this;this.debugEnabled=function(flag){return isDefined(flag)?(debug=flag,this):debug},this.$get=["$window",function($window){function formatError(arg){return arg instanceof Error&&(arg.stack?arg=arg.message&&-1===arg.stack.indexOf(arg.message)?"Error: "+arg.message+"\n"+arg.stack:arg.stack:arg.sourceURL&&(arg=arg.message+"\n"+arg.sourceURL+":"+arg.line)),arg}function consoleLog(type){var console=$window.console||{},logFn=console[type]||console.log||noop,hasApply=!1;try{hasApply=!!logFn.apply}catch(e){}return hasApply?function(){var args=[];return forEach(arguments,function(arg){args.push(formatError(arg))}),logFn.apply(console,args)}:function(arg1,arg2){logFn(arg1,null==arg2?"":arg2)}}return{log:consoleLog("log"),info:consoleLog("info"),warn:consoleLog("warn"),error:consoleLog("error"),debug:function(){var fn=consoleLog("debug");return function(){debug&&fn.apply(self,arguments)}}()}}]}function ensureSafeMemberName(name,fullExpression){if("__defineGetter__"===name||"__defineSetter__"===name||"__lookupGetter__"===name||"__lookupSetter__"===name||"__proto__"===name)throw $parseMinErr("isecfld","Attempting to access a disallowed field in Angular expressions! Expression: {0}",fullExpression);return name}function ensureSafeObject(obj,fullExpression){if(obj){if(obj.constructor===obj)throw $parseMinErr("isecfn","Referencing Function in Angular expressions is disallowed! Expression: {0}",fullExpression);if(obj.window===obj)throw $parseMinErr("isecwindow","Referencing the Window in Angular expressions is disallowed! Expression: {0}",fullExpression);if(obj.children&&(obj.nodeName||obj.prop&&obj.attr&&obj.find))throw $parseMinErr("isecdom","Referencing DOM nodes in Angular expressions is disallowed! Expression: {0}",fullExpression);if(obj===Object)throw $parseMinErr("isecobj","Referencing Object in Angular expressions is disallowed! Expression: {0}",fullExpression)}return obj}function ensureSafeFunction(obj,fullExpression){if(obj){if(obj.constructor===obj)throw $parseMinErr("isecfn","Referencing Function in Angular expressions is disallowed! Expression: {0}",fullExpression);if(obj===CALL||obj===APPLY||obj===BIND)throw $parseMinErr("isecff","Referencing call, apply or bind in Angular expressions is disallowed! Expression: {0}",fullExpression)}}function ifDefined(v,d){return void 0!==v?v:d}function plusFn(l,r){return void 0===l?r:void 0===r?l:l+r}function isStateless($filter,filterName){return!$filter(filterName).$stateful}function findConstantAndWatchExpressions(ast,$filter){var allConstants,argsToWatch;switch(ast.type){case AST.Program:allConstants=!0,forEach(ast.body,function(expr){findConstantAndWatchExpressions(expr.expression,$filter),allConstants=allConstants&&expr.expression.constant}),ast.constant=allConstants;break;case AST.Literal:ast.constant=!0,ast.toWatch=[];break;case AST.UnaryExpression:findConstantAndWatchExpressions(ast.argument,$filter),ast.constant=ast.argument.constant,ast.toWatch=ast.argument.toWatch;break;case AST.BinaryExpression:findConstantAndWatchExpressions(ast.left,$filter),findConstantAndWatchExpressions(ast.right,$filter),ast.constant=ast.left.constant&&ast.right.constant,ast.toWatch=ast.left.toWatch.concat(ast.right.toWatch);break;case AST.LogicalExpression:findConstantAndWatchExpressions(ast.left,$filter),findConstantAndWatchExpressions(ast.right,$filter),ast.constant=ast.left.constant&&ast.right.constant,ast.toWatch=ast.constant?[]:[ast];break;case AST.ConditionalExpression:findConstantAndWatchExpressions(ast.test,$filter),findConstantAndWatchExpressions(ast.alternate,$filter),findConstantAndWatchExpressions(ast.consequent,$filter),ast.constant=ast.test.constant&&ast.alternate.constant&&ast.consequent.constant,ast.toWatch=ast.constant?[]:[ast];break;case AST.Identifier:ast.constant=!1,ast.toWatch=[ast];break;case AST.MemberExpression:findConstantAndWatchExpressions(ast.object,$filter),ast.computed&&findConstantAndWatchExpressions(ast.property,$filter),ast.constant=ast.object.constant&&(!ast.computed||ast.property.constant),ast.toWatch=[ast];break;case AST.CallExpression:allConstants=!!ast.filter&&isStateless($filter,ast.callee.name),argsToWatch=[],forEach(ast.arguments,function(expr){findConstantAndWatchExpressions(expr,$filter),allConstants=allConstants&&expr.constant,expr.constant||argsToWatch.push.apply(argsToWatch,expr.toWatch)}),ast.constant=allConstants,ast.toWatch=ast.filter&&isStateless($filter,ast.callee.name)?argsToWatch:[ast];break;case AST.AssignmentExpression:findConstantAndWatchExpressions(ast.left,$filter),findConstantAndWatchExpressions(ast.right,$filter),ast.constant=ast.left.constant&&ast.right.constant,ast.toWatch=[ast];break;case AST.ArrayExpression:allConstants=!0,argsToWatch=[],forEach(ast.elements,function(expr){findConstantAndWatchExpressions(expr,$filter),allConstants=allConstants&&expr.constant,expr.constant||argsToWatch.push.apply(argsToWatch,expr.toWatch)}),ast.constant=allConstants,ast.toWatch=argsToWatch;break;case AST.ObjectExpression:allConstants=!0,argsToWatch=[],forEach(ast.properties,function(property){findConstantAndWatchExpressions(property.value,$filter),allConstants=allConstants&&property.value.constant,property.value.constant||argsToWatch.push.apply(argsToWatch,property.value.toWatch)}),ast.constant=allConstants,ast.toWatch=argsToWatch;break;case AST.ThisExpression:ast.constant=!1,ast.toWatch=[]}}function getInputs(body){if(1==body.length){var lastExpression=body[0].expression,candidate=lastExpression.toWatch;return 1!==candidate.length?candidate:candidate[0]!==lastExpression?candidate:undefined}}function isAssignable(ast){return ast.type===AST.Identifier||ast.type===AST.MemberExpression}function assignableAST(ast){if(1===ast.body.length&&isAssignable(ast.body[0].expression))return{type:AST.AssignmentExpression,left:ast.body[0].expression,right:{type:AST.NGValueParameter},operator:"="}}function isLiteral(ast){return 0===ast.body.length||1===ast.body.length&&(ast.body[0].expression.type===AST.Literal||ast.body[0].expression.type===AST.ArrayExpression||ast.body[0].expression.type===AST.ObjectExpression)}function isConstant(ast){return ast.constant}function ASTCompiler(astBuilder,$filter){this.astBuilder=astBuilder,this.$filter=$filter}function ASTInterpreter(astBuilder,$filter){this.astBuilder=astBuilder,this.$filter=$filter}function setter(obj,path,setValue,fullExp){ensureSafeObject(obj,fullExp);for(var key,element=path.split("."),i=0;element.length>1;i++){var propertyObj=ensureSafeObject(obj[key=ensureSafeMemberName(element.shift(),fullExp)],fullExp);propertyObj||(propertyObj={},obj[key]=propertyObj),obj=propertyObj}return key=ensureSafeMemberName(element.shift(),fullExp),ensureSafeObject(obj[key],fullExp),obj[key]=setValue,setValue}function isPossiblyDangerousMemberName(name){return"constructor"==name}function getValueOf(value){return isFunction(value.valueOf)?value.valueOf():objectValueOf.call(value)}function $ParseProvider(){var cacheDefault=createMap(),cacheExpensive=createMap();this.$get=["$filter","$sniffer",function($filter,$sniffer){function expressionInputDirtyCheck(newValue,oldValueOfValue){return null==newValue||null==oldValueOfValue?newValue===oldValueOfValue:("object"!=typeof newValue||"object"!=typeof(newValue=getValueOf(newValue)))&&(newValue===oldValueOfValue||newValue!==newValue&&oldValueOfValue!==oldValueOfValue)}function inputsWatchDelegate(scope,listener,objectEquality,parsedExpression,prettyPrintExpression){var lastResult,inputExpressions=parsedExpression.inputs;if(1===inputExpressions.length){var oldInputValueOf=expressionInputDirtyCheck;return inputExpressions=inputExpressions[0],scope.$watch(function(scope){var newInputValue=inputExpressions(scope);return expressionInputDirtyCheck(newInputValue,oldInputValueOf)||(lastResult=parsedExpression(scope,undefined,undefined,[newInputValue]),oldInputValueOf=newInputValue&&getValueOf(newInputValue)),lastResult},listener,objectEquality,prettyPrintExpression)}for(var oldInputValueOfValues=[],oldInputValues=[],i=0,ii=inputExpressions.length;i<ii;i++)oldInputValueOfValues[i]=expressionInputDirtyCheck,oldInputValues[i]=null;return scope.$watch(function(scope){for(var changed=!1,i=0,ii=inputExpressions.length;i<ii;i++){var newInputValue=inputExpressions[i](scope);(changed||(changed=!expressionInputDirtyCheck(newInputValue,oldInputValueOfValues[i])))&&(oldInputValues[i]=newInputValue,oldInputValueOfValues[i]=newInputValue&&getValueOf(newInputValue))}return changed&&(lastResult=parsedExpression(scope,undefined,undefined,oldInputValues)),lastResult},listener,objectEquality,prettyPrintExpression)}function oneTimeWatchDelegate(scope,listener,objectEquality,parsedExpression){var unwatch,lastValue;return unwatch=scope.$watch(function(scope){return parsedExpression(scope)},function(value,old,scope){lastValue=value,isFunction(listener)&&listener.apply(this,arguments),isDefined(value)&&scope.$$postDigest(function(){isDefined(lastValue)&&unwatch()})},objectEquality)}function oneTimeLiteralWatchDelegate(scope,listener,objectEquality,parsedExpression){function isAllDefined(value){var allDefined=!0;return forEach(value,function(val){isDefined(val)||(allDefined=!1)}),allDefined}var unwatch,lastValue;return unwatch=scope.$watch(function(scope){return parsedExpression(scope)},function(value,old,scope){lastValue=value,isFunction(listener)&&listener.call(this,value,old,scope),isAllDefined(value)&&scope.$$postDigest(function(){isAllDefined(lastValue)&&unwatch()})},objectEquality)}function constantWatchDelegate(scope,listener,objectEquality,parsedExpression){var unwatch;return unwatch=scope.$watch(function(scope){return parsedExpression(scope)},function(value,old,scope){isFunction(listener)&&listener.apply(this,arguments),unwatch()},objectEquality)}function addInterceptor(parsedExpression,interceptorFn){if(!interceptorFn)return parsedExpression;var watchDelegate=parsedExpression.$$watchDelegate,fn=watchDelegate!==oneTimeLiteralWatchDelegate&&watchDelegate!==oneTimeWatchDelegate?function(scope,locals,assign,inputs){var value=parsedExpression(scope,locals,assign,inputs);return interceptorFn(value,scope,locals)}:function(scope,locals,assign,inputs){var value=parsedExpression(scope,locals,assign,inputs),result=interceptorFn(value,scope,locals);return isDefined(value)?result:value};return parsedExpression.$$watchDelegate&&parsedExpression.$$watchDelegate!==inputsWatchDelegate?fn.$$watchDelegate=parsedExpression.$$watchDelegate:interceptorFn.$stateful||(fn.$$watchDelegate=inputsWatchDelegate,fn.inputs=parsedExpression.inputs?parsedExpression.inputs:[parsedExpression]),fn}var $parseOptions={csp:$sniffer.csp,expensiveChecks:!1},$parseOptionsExpensive={csp:$sniffer.csp,expensiveChecks:!0};return function(exp,interceptorFn,expensiveChecks){var parsedExpression,oneTime,cacheKey;switch(typeof exp){case"string":cacheKey=exp=exp.trim();var cache=expensiveChecks?cacheExpensive:cacheDefault;if(!(parsedExpression=cache[cacheKey])){":"===exp.charAt(0)&&":"===exp.charAt(1)&&(oneTime=!0,exp=exp.substring(2));var parseOptions=expensiveChecks?$parseOptionsExpensive:$parseOptions,lexer=new Lexer(parseOptions);(parsedExpression=new Parser(lexer,$filter,parseOptions).parse(exp)).constant?parsedExpression.$$watchDelegate=constantWatchDelegate:oneTime?parsedExpression.$$watchDelegate=parsedExpression.literal?oneTimeLiteralWatchDelegate:oneTimeWatchDelegate:parsedExpression.inputs&&(parsedExpression.$$watchDelegate=inputsWatchDelegate),cache[cacheKey]=parsedExpression}return addInterceptor(parsedExpression,interceptorFn);case"function":return addInterceptor(exp,interceptorFn);default:return noop}}}]}function $QProvider(){this.$get=["$rootScope","$exceptionHandler",function($rootScope,$exceptionHandler){return qFactory(function(callback){$rootScope.$evalAsync(callback)},$exceptionHandler)}]}function $$QProvider(){this.$get=["$browser","$exceptionHandler",function($browser,$exceptionHandler){return qFactory(function(callback){$browser.defer(callback)},$exceptionHandler)}]}function qFactory(nextTick,exceptionHandler){function callOnce(self,resolveFn,rejectFn){function wrap(fn){return function(value){called||(called=!0,fn.call(self,value))}}var called=!1;return[wrap(resolveFn),wrap(rejectFn)]}function Promise(){this.$$state={status:0}}function simpleBind(context,fn){return function(value){fn.call(context,value)}}function processQueue(state){var fn,deferred,pending;pending=state.pending,state.processScheduled=!1,state.pending=undefined;for(var i=0,ii=pending.length;i<ii;++i){deferred=pending[i][0],fn=pending[i][state.status];try{isFunction(fn)?deferred.resolve(fn(state.value)):1===state.status?deferred.resolve(state.value):deferred.reject(state.value)}catch(e){deferred.reject(e),exceptionHandler(e)}}}function scheduleProcessQueue(state){!state.processScheduled&&state.pending&&(state.processScheduled=!0,nextTick(function(){processQueue(state)}))}function Deferred(){this.promise=new Promise,this.resolve=simpleBind(this,this.resolve),this.reject=simpleBind(this,this.reject),this.notify=simpleBind(this,this.notify)}var $qMinErr=minErr("$q",TypeError);Promise.prototype={then:function(onFulfilled,onRejected,progressBack){var result=new Deferred;return this.$$state.pending=this.$$state.pending||[],this.$$state.pending.push([result,onFulfilled,onRejected,progressBack]),this.$$state.status>0&&scheduleProcessQueue(this.$$state),result.promise},catch:function(callback){return this.then(null,callback)},finally:function(callback,progressBack){return this.then(function(value){return handleCallback(value,!0,callback)},function(error){return handleCallback(error,!1,callback)},progressBack)}},Deferred.prototype={resolve:function(val){this.promise.$$state.status||(val===this.promise?this.$$reject($qMinErr("qcycle","Expected promise to be resolved with value other than itself '{0}'",val)):this.$$resolve(val))},$$resolve:function(val){var then,fns;fns=callOnce(this,this.$$resolve,this.$$reject);try{(isObject(val)||isFunction(val))&&(then=val&&val.then),isFunction(then)?(this.promise.$$state.status=-1,then.call(val,fns[0],fns[1],this.notify)):(this.promise.$$state.value=val,this.promise.$$state.status=1,scheduleProcessQueue(this.promise.$$state))}catch(e){fns[1](e),exceptionHandler(e)}},reject:function(reason){this.promise.$$state.status||this.$$reject(reason)},$$reject:function(reason){this.promise.$$state.value=reason,this.promise.$$state.status=2,scheduleProcessQueue(this.promise.$$state)},notify:function(progress){var callbacks=this.promise.$$state.pending;this.promise.$$state.status<=0&&callbacks&&callbacks.length&&nextTick(function(){for(var callback,result,i=0,ii=callbacks.length;i<ii;i++){result=callbacks[i][0],callback=callbacks[i][3];try{result.notify(isFunction(callback)?callback(progress):progress)}catch(e){exceptionHandler(e)}}})}};var makePromise=function(value,resolved){var result=new Deferred;return resolved?result.resolve(value):result.reject(value),result.promise},handleCallback=function(value,isResolved,callback){var callbackOutput=null;try{isFunction(callback)&&(callbackOutput=callback())}catch(e){return makePromise(e,!1)}return isPromiseLike(callbackOutput)?callbackOutput.then(function(){return makePromise(value,isResolved)},function(error){return makePromise(error,!1)}):makePromise(value,isResolved)},when=function(value,callback,errback,progressBack){var result=new Deferred;return result.resolve(value),result.promise.then(callback,errback,progressBack)},resolve=when,$Q=function Q(resolver){if(!isFunction(resolver))throw $qMinErr("norslvr","Expected resolverFn, got '{0}'",resolver);if(!(this instanceof Q))return new Q(resolver);var deferred=new Deferred;return resolver(function(value){deferred.resolve(value)},function(reason){deferred.reject(reason)}),deferred.promise};return $Q.defer=function(){return new Deferred},$Q.reject=function(reason){var result=new Deferred;return result.reject(reason),result.promise},$Q.when=when,$Q.resolve=resolve,$Q.all=function(promises){var deferred=new Deferred,counter=0,results=isArray(promises)?[]:{};return forEach(promises,function(promise,key){counter++,when(promise).then(function(value){results.hasOwnProperty(key)||(results[key]=value,--counter||deferred.resolve(results))},function(reason){results.hasOwnProperty(key)||deferred.reject(reason)})}),0===counter&&deferred.resolve(results),deferred.promise},$Q}function $$RAFProvider(){this.$get=["$window","$timeout",function($window,$timeout){function flush(){for(var i=0;i<taskQueue.length;i++){var task=taskQueue[i];task&&(taskQueue[i]=null,task())}taskCount=taskQueue.length=0}function queueFn(asyncFn){var index=taskQueue.length;return taskCount++,taskQueue.push(asyncFn),0===index&&(cancelLastRAF=rafFn(flush)),function(){index>=0&&(taskQueue[index]=null,index=null,0==--taskCount&&cancelLastRAF&&(cancelLastRAF(),cancelLastRAF=null,taskQueue.length=0))}}var requestAnimationFrame=$window.requestAnimationFrame||$window.webkitRequestAnimationFrame,cancelAnimationFrame=$window.cancelAnimationFrame||$window.webkitCancelAnimationFrame||$window.webkitCancelRequestAnimationFrame,rafSupported=!!requestAnimationFrame,rafFn=rafSupported?function(fn){var id=requestAnimationFrame(fn);return function(){cancelAnimationFrame(id)}}:function(fn){var timer=$timeout(fn,16.66,!1);return function(){$timeout.cancel(timer)}};queueFn.supported=rafSupported;var cancelLastRAF,taskCount=0,taskQueue=[];return queueFn}]}function $RootScopeProvider(){function createChildScopeClass(parent){function ChildScope(){this.$$watchers=this.$$nextSibling=this.$$childHead=this.$$childTail=null,this.$$listeners={},this.$$listenerCount={},this.$$watchersCount=0,this.$id=nextUid(),this.$$ChildScope=null}return ChildScope.prototype=parent,ChildScope}var TTL=10,$rootScopeMinErr=minErr("$rootScope"),lastDirtyWatch=null,applyAsyncId=null;this.digestTtl=function(value){return arguments.length&&(TTL=value),TTL},this.$get=["$injector","$exceptionHandler","$parse","$browser",function($injector,$exceptionHandler,$parse,$browser){function destroyChildScope($event){$event.currentScope.$$destroyed=!0}function Scope(){this.$id=nextUid(),this.$$phase=this.$parent=this.$$watchers=this.$$nextSibling=this.$$prevSibling=this.$$childHead=this.$$childTail=null,this.$root=this,this.$$destroyed=!1,this.$$listeners={},this.$$listenerCount={},this.$$watchersCount=0,this.$$isolateBindings=null}function beginPhase(phase){if($rootScope.$$phase)throw $rootScopeMinErr("inprog","{0} already in progress",$rootScope.$$phase);$rootScope.$$phase=phase}function clearPhase(){$rootScope.$$phase=null}function incrementWatchersCount(current,count){do{current.$$watchersCount+=count}while(current=current.$parent)}function decrementListenerCount(current,count,name){do{current.$$listenerCount[name]-=count,0===current.$$listenerCount[name]&&delete current.$$listenerCount[name]}while(current=current.$parent)}function initWatchVal(){}function flushApplyAsync(){for(;applyAsyncQueue.length;)try{applyAsyncQueue.shift()()}catch(e){$exceptionHandler(e)}applyAsyncId=null}function scheduleApplyAsync(){null===applyAsyncId&&(applyAsyncId=$browser.defer(function(){$rootScope.$apply(flushApplyAsync)}))}Scope.prototype={constructor:Scope,$new:function(isolate,parent){var child;return parent=parent||this,isolate?(child=new Scope).$root=this.$root:(this.$$ChildScope||(this.$$ChildScope=createChildScopeClass(this)),child=new this.$$ChildScope),child.$parent=parent,child.$$prevSibling=parent.$$childTail,parent.$$childHead?(parent.$$childTail.$$nextSibling=child,parent.$$childTail=child):parent.$$childHead=parent.$$childTail=child,(isolate||parent!=this)&&child.$on("$destroy",destroyChildScope),child},$watch:function(watchExp,listener,objectEquality,prettyPrintExpression){var get=$parse(watchExp);if(get.$$watchDelegate)return get.$$watchDelegate(this,listener,objectEquality,get,watchExp);var scope=this,array=scope.$$watchers,watcher={fn:listener,last:initWatchVal,get:get,exp:prettyPrintExpression||watchExp,eq:!!objectEquality};return lastDirtyWatch=null,isFunction(listener)||(watcher.fn=noop),array||(array=scope.$$watchers=[]),array.unshift(watcher),incrementWatchersCount(this,1),function(){arrayRemove(array,watcher)>=0&&incrementWatchersCount(scope,-1),lastDirtyWatch=null}},$watchGroup:function(watchExpressions,listener){function watchGroupAction(){changeReactionScheduled=!1,firstRun?(firstRun=!1,listener(newValues,newValues,self)):listener(newValues,oldValues,self)}var oldValues=new Array(watchExpressions.length),newValues=new Array(watchExpressions.length),deregisterFns=[],self=this,changeReactionScheduled=!1,firstRun=!0;if(!watchExpressions.length){var shouldCall=!0;return self.$evalAsync(function(){shouldCall&&listener(newValues,newValues,self)}),function(){shouldCall=!1}}return 1===watchExpressions.length?this.$watch(watchExpressions[0],function(value,oldValue,scope){newValues[0]=value,oldValues[0]=oldValue,listener(newValues,value===oldValue?newValues:oldValues,scope)}):(forEach(watchExpressions,function(expr,i){var unwatchFn=self.$watch(expr,function(value,oldValue){newValues[i]=value,oldValues[i]=oldValue,changeReactionScheduled||(changeReactionScheduled=!0,self.$evalAsync(watchGroupAction))});deregisterFns.push(unwatchFn)}),function(){for(;deregisterFns.length;)deregisterFns.shift()()})},$watchCollection:function(obj,listener){function $watchCollectionInterceptor(_value){var newLength,key,newItem,oldItem;if(!isUndefined(newValue=_value)){if(isObject(newValue))if(isArrayLike(newValue)){oldValue!==internalArray&&(oldLength=(oldValue=internalArray).length=0,changeDetected++),newLength=newValue.length,oldLength!==newLength&&(changeDetected++,oldValue.length=oldLength=newLength);for(var i=0;i<newLength;i++)oldItem=oldValue[i],newItem=newValue[i],oldItem!==oldItem&&newItem!==newItem||oldItem===newItem||(changeDetected++,oldValue[i]=newItem)}else{oldValue!==internalObject&&(oldValue=internalObject={},oldLength=0,changeDetected++),newLength=0;for(key in newValue)newValue.hasOwnProperty(key)&&(newLength++,newItem=newValue[key],oldItem=oldValue[key],key in oldValue?oldItem!==oldItem&&newItem!==newItem||oldItem===newItem||(changeDetected++,oldValue[key]=newItem):(oldLength++,oldValue[key]=newItem,changeDetected++));if(oldLength>newLength){changeDetected++;for(key in oldValue)newValue.hasOwnProperty(key)||(oldLength--,delete oldValue[key])}}else oldValue!==newValue&&(oldValue=newValue,changeDetected++);return changeDetected}}$watchCollectionInterceptor.$stateful=!0;var newValue,oldValue,veryOldValue,self=this,trackVeryOldValue=listener.length>1,changeDetected=0,changeDetector=$parse(obj,$watchCollectionInterceptor),internalArray=[],internalObject={},initRun=!0,oldLength=0;return this.$watch(changeDetector,function(){if(initRun?(initRun=!1,listener(newValue,newValue,self)):listener(newValue,veryOldValue,self),trackVeryOldValue)if(isObject(newValue))if(isArrayLike(newValue)){veryOldValue=new Array(newValue.length);for(var i=0;i<newValue.length;i++)veryOldValue[i]=newValue[i]}else{veryOldValue={};for(var key in newValue)hasOwnProperty.call(newValue,key)&&(veryOldValue[key]=newValue[key])}else veryOldValue=newValue})},$digest:function(){var watch,value,last,watchers,length,dirty,next,current,logIdx,asyncTask,ttl=TTL,target=this,watchLog=[];beginPhase("$digest"),$browser.$$checkUrlChange(),this===$rootScope&&null!==applyAsyncId&&($browser.defer.cancel(applyAsyncId),flushApplyAsync()),lastDirtyWatch=null;do{for(dirty=!1,current=target;asyncQueue.length;){try{(asyncTask=asyncQueue.shift()).scope.$eval(asyncTask.expression,asyncTask.locals)}catch(e){$exceptionHandler(e)}lastDirtyWatch=null}traverseScopesLoop:do{if(watchers=current.$$watchers)for(length=watchers.length;length--;)try{if(watch=watchers[length])if((value=watch.get(current))===(last=watch.last)||(watch.eq?equals(value,last):"number"==typeof value&&"number"==typeof last&&isNaN(value)&&isNaN(last))){if(watch===lastDirtyWatch){dirty=!1;break traverseScopesLoop}}else dirty=!0,lastDirtyWatch=watch,watch.last=watch.eq?copy(value,null):value,watch.fn(value,last===initWatchVal?value:last,current),ttl<5&&(watchLog[logIdx=4-ttl]||(watchLog[logIdx]=[]),watchLog[logIdx].push({msg:isFunction(watch.exp)?"fn: "+(watch.exp.name||watch.exp.toString()):watch.exp,newVal:value,oldVal:last}))}catch(e){$exceptionHandler(e)}if(!(next=current.$$watchersCount&&current.$$childHead||current!==target&&current.$$nextSibling))for(;current!==target&&!(next=current.$$nextSibling);)current=current.$parent}while(current=next);if((dirty||asyncQueue.length)&&!ttl--)throw clearPhase(),$rootScopeMinErr("infdig","{0} $digest() iterations reached. Aborting!\nWatchers fired in the last 5 iterations: {1}",TTL,watchLog)}while(dirty||asyncQueue.length);for(clearPhase();postDigestQueue.length;)try{postDigestQueue.shift()()}catch(e){$exceptionHandler(e)}},$destroy:function(){if(!this.$$destroyed){var parent=this.$parent;this.$broadcast("$destroy"),this.$$destroyed=!0,this===$rootScope&&$browser.$$applicationDestroyed(),incrementWatchersCount(this,-this.$$watchersCount);for(var eventName in this.$$listenerCount)decrementListenerCount(this,this.$$listenerCount[eventName],eventName);parent&&parent.$$childHead==this&&(parent.$$childHead=this.$$nextSibling),parent&&parent.$$childTail==this&&(parent.$$childTail=this.$$prevSibling),this.$$prevSibling&&(this.$$prevSibling.$$nextSibling=this.$$nextSibling),this.$$nextSibling&&(this.$$nextSibling.$$prevSibling=this.$$prevSibling),this.$destroy=this.$digest=this.$apply=this.$evalAsync=this.$applyAsync=noop,this.$on=this.$watch=this.$watchGroup=function(){return noop},this.$$listeners={},this.$parent=this.$$nextSibling=this.$$prevSibling=this.$$childHead=this.$$childTail=this.$root=this.$$watchers=null}},$eval:function(expr,locals){return $parse(expr)(this,locals)},$evalAsync:function(expr,locals){$rootScope.$$phase||asyncQueue.length||$browser.defer(function(){asyncQueue.length&&$rootScope.$digest()}),asyncQueue.push({scope:this,expression:expr,locals:locals})},$$postDigest:function(fn){postDigestQueue.push(fn)},$apply:function(expr){try{return beginPhase("$apply"),this.$eval(expr)}catch(e){$exceptionHandler(e)}finally{clearPhase();try{$rootScope.$digest()}catch(e){throw $exceptionHandler(e),e}}},$applyAsync:function(expr){var scope=this;expr&&applyAsyncQueue.push(function(){scope.$eval(expr)}),scheduleApplyAsync()},$on:function(name,listener){var namedListeners=this.$$listeners[name];namedListeners||(this.$$listeners[name]=namedListeners=[]),namedListeners.push(listener);var current=this;do{current.$$listenerCount[name]||(current.$$listenerCount[name]=0),current.$$listenerCount[name]++}while(current=current.$parent);var self=this;return function(){var indexOfListener=namedListeners.indexOf(listener);-1!==indexOfListener&&(namedListeners[indexOfListener]=null,decrementListenerCount(self,1,name))}},$emit:function(name,args){var namedListeners,i,length,empty=[],scope=this,stopPropagation=!1,event={name:name,targetScope:scope,stopPropagation:function(){stopPropagation=!0},preventDefault:function(){event.defaultPrevented=!0},defaultPrevented:!1},listenerArgs=concat([event],arguments,1);do{for(namedListeners=scope.$$listeners[name]||empty,event.currentScope=scope,i=0,length=namedListeners.length;i<length;i++)if(namedListeners[i])try{namedListeners[i].apply(null,listenerArgs)}catch(e){$exceptionHandler(e)}else namedListeners.splice(i,1),i--,length--;if(stopPropagation)return event.currentScope=null,event;scope=scope.$parent}while(scope);return event.currentScope=null,event},$broadcast:function(name,args){var target=this,current=target,next=target,event={name:name,targetScope:target,preventDefault:function(){event.defaultPrevented=!0},defaultPrevented:!1};if(!target.$$listenerCount[name])return event;for(var listeners,i,length,listenerArgs=concat([event],arguments,1);current=next;){for(event.currentScope=current,i=0,length=(listeners=current.$$listeners[name]||[]).length;i<length;i++)if(listeners[i])try{listeners[i].apply(null,listenerArgs)}catch(e){$exceptionHandler(e)}else listeners.splice(i,1),i--,length--;if(!(next=current.$$listenerCount[name]&&current.$$childHead||current!==target&&current.$$nextSibling))for(;current!==target&&!(next=current.$$nextSibling);)current=current.$parent}return event.currentScope=null,event}};var $rootScope=new Scope,asyncQueue=$rootScope.$$asyncQueue=[],postDigestQueue=$rootScope.$$postDigestQueue=[],applyAsyncQueue=$rootScope.$$applyAsyncQueue=[];return $rootScope}]}function $$SanitizeUriProvider(){var aHrefSanitizationWhitelist=/^\s*(https?|ftp|mailto|tel|file):/,imgSrcSanitizationWhitelist=/^\s*((https?|ftp|file|blob):|data:image\/)/;this.aHrefSanitizationWhitelist=function(regexp){return isDefined(regexp)?(aHrefSanitizationWhitelist=regexp,this):aHrefSanitizationWhitelist},this.imgSrcSanitizationWhitelist=function(regexp){return isDefined(regexp)?(imgSrcSanitizationWhitelist=regexp,this):imgSrcSanitizationWhitelist},this.$get=function(){return function(uri,isImage){var normalizedVal,regex=isImage?imgSrcSanitizationWhitelist:aHrefSanitizationWhitelist;return""===(normalizedVal=urlResolve(uri).href)||normalizedVal.match(regex)?uri:"unsafe:"+normalizedVal}}}function adjustMatcher(matcher){if("self"===matcher)return matcher;if(isString(matcher)){if(matcher.indexOf("***")>-1)throw $sceMinErr("iwcard","Illegal sequence *** in string matcher.  String: {0}",matcher);return matcher=escapeForRegexp(matcher).replace("\\*\\*",".*").replace("\\*","[^:/.?&;]*"),new RegExp("^"+matcher+"$")}if(isRegExp(matcher))return new RegExp("^"+matcher.source+"$");throw $sceMinErr("imatcher",'Matchers may only be "self", string patterns or RegExp objects')}function adjustMatchers(matchers){var adjustedMatchers=[];return isDefined(matchers)&&forEach(matchers,function(matcher){adjustedMatchers.push(adjustMatcher(matcher))}),adjustedMatchers}function $SceDelegateProvider(){this.SCE_CONTEXTS=SCE_CONTEXTS;var resourceUrlWhitelist=["self"],resourceUrlBlacklist=[];this.resourceUrlWhitelist=function(value){return arguments.length&&(resourceUrlWhitelist=adjustMatchers(value)),resourceUrlWhitelist},this.resourceUrlBlacklist=function(value){return arguments.length&&(resourceUrlBlacklist=adjustMatchers(value)),resourceUrlBlacklist},this.$get=["$injector",function($injector){function matchUrl(matcher,parsedUrl){return"self"===matcher?urlIsSameOrigin(parsedUrl):!!matcher.exec(parsedUrl.href)}function isResourceUrlAllowedByPolicy(url){var i,n,parsedUrl=urlResolve(url.toString()),allowed=!1;for(i=0,n=resourceUrlWhitelist.length;i<n;i++)if(matchUrl(resourceUrlWhitelist[i],parsedUrl)){allowed=!0;break}if(allowed)for(i=0,n=resourceUrlBlacklist.length;i<n;i++)if(matchUrl(resourceUrlBlacklist[i],parsedUrl)){allowed=!1;break}return allowed}function generateHolderType(Base){var holderType=function(trustedValue){this.$$unwrapTrustedValue=function(){return trustedValue}};return Base&&(holderType.prototype=new Base),holderType.prototype.valueOf=function(){return this.$$unwrapTrustedValue()},holderType.prototype.toString=function(){return this.$$unwrapTrustedValue().toString()},holderType}var htmlSanitizer=function(html){throw $sceMinErr("unsafe","Attempting to use an unsafe value in a safe context.")};$injector.has("$sanitize")&&(htmlSanitizer=$injector.get("$sanitize"));var trustedValueHolderBase=generateHolderType(),byType={};return byType[SCE_CONTEXTS.HTML]=generateHolderType(trustedValueHolderBase),byType[SCE_CONTEXTS.CSS]=generateHolderType(trustedValueHolderBase),byType[SCE_CONTEXTS.URL]=generateHolderType(trustedValueHolderBase),byType[SCE_CONTEXTS.JS]=generateHolderType(trustedValueHolderBase),byType[SCE_CONTEXTS.RESOURCE_URL]=generateHolderType(byType[SCE_CONTEXTS.URL]),{trustAs:function(type,trustedValue){var Constructor=byType.hasOwnProperty(type)?byType[type]:null;if(!Constructor)throw $sceMinErr("icontext","Attempted to trust a value in invalid context. Context: {0}; Value: {1}",type,trustedValue);if(null===trustedValue||trustedValue===undefined||""===trustedValue)return trustedValue;if("string"!=typeof trustedValue)throw $sceMinErr("itype","Attempted to trust a non-string value in a content requiring a string: Context: {0}",type);return new Constructor(trustedValue)},getTrusted:function(type,maybeTrusted){if(null===maybeTrusted||maybeTrusted===undefined||""===maybeTrusted)return maybeTrusted;var constructor=byType.hasOwnProperty(type)?byType[type]:null;if(constructor&&maybeTrusted instanceof constructor)return maybeTrusted.$$unwrapTrustedValue();if(type===SCE_CONTEXTS.RESOURCE_URL){if(isResourceUrlAllowedByPolicy(maybeTrusted))return maybeTrusted;throw $sceMinErr("insecurl","Blocked loading resource from url not allowed by $sceDelegate policy.  URL: {0}",maybeTrusted.toString())}if(type===SCE_CONTEXTS.HTML)return htmlSanitizer(maybeTrusted);throw $sceMinErr("unsafe","Attempting to use an unsafe value in a safe context.")},valueOf:function(maybeTrusted){return maybeTrusted instanceof trustedValueHolderBase?maybeTrusted.$$unwrapTrustedValue():maybeTrusted}}}]}function $SceProvider(){var enabled=!0;this.enabled=function(value){return arguments.length&&(enabled=!!value),enabled},this.$get=["$parse","$sceDelegate",function($parse,$sceDelegate){if(enabled&&msie<8)throw $sceMinErr("iequirks","Strict Contextual Escaping does not support Internet Explorer version < 11 in quirks mode.  You can fix this by adding the text <!doctype html> to the top of your HTML document.  See http://docs.angularjs.org/api/ng.$sce for more information.");var sce=shallowCopy(SCE_CONTEXTS);sce.isEnabled=function(){return enabled},sce.trustAs=$sceDelegate.trustAs,sce.getTrusted=$sceDelegate.getTrusted,sce.valueOf=$sceDelegate.valueOf,enabled||(sce.trustAs=sce.getTrusted=function(type,value){return value},sce.valueOf=identity),sce.parseAs=function(type,expr){var parsed=$parse(expr);return parsed.literal&&parsed.constant?parsed:$parse(expr,function(value){return sce.getTrusted(type,value)})};var parse=sce.parseAs,getTrusted=sce.getTrusted,trustAs=sce.trustAs;return forEach(SCE_CONTEXTS,function(enumValue,name){var lName=lowercase(name);sce[camelCase("parse_as_"+lName)]=function(expr){return parse(enumValue,expr)},sce[camelCase("get_trusted_"+lName)]=function(value){return getTrusted(enumValue,value)},sce[camelCase("trust_as_"+lName)]=function(value){return trustAs(enumValue,value)}}),sce}]}function $SnifferProvider(){this.$get=["$window","$document",function($window,$document){var vendorPrefix,match,eventSupport={},android=toInt((/android (\d+)/.exec(lowercase(($window.navigator||{}).userAgent))||[])[1]),boxee=/Boxee/i.test(($window.navigator||{}).userAgent),document=$document[0]||{},vendorRegex=/^(Moz|webkit|ms)(?=[A-Z])/,bodyStyle=document.body&&document.body.style,transitions=!1,animations=!1;if(bodyStyle){for(var prop in bodyStyle)if(match=vendorRegex.exec(prop)){vendorPrefix=(vendorPrefix=match[0]).substr(0,1).toUpperCase()+vendorPrefix.substr(1);break}vendorPrefix||(vendorPrefix="WebkitOpacity"in bodyStyle&&"webkit"),transitions=!!("transition"in bodyStyle||vendorPrefix+"Transition"in bodyStyle),animations=!!("animation"in bodyStyle||vendorPrefix+"Animation"in bodyStyle),!android||transitions&&animations||(transitions=isString(bodyStyle.webkitTransition),animations=isString(bodyStyle.webkitAnimation))}return{history:!(!$window.history||!$window.history.pushState||android<4||boxee),hasEvent:function(event){if("input"===event&&msie<=11)return!1;if(isUndefined(eventSupport[event])){var divElm=document.createElement("div");eventSupport[event]="on"+event in divElm}return eventSupport[event]},csp:csp(),vendorPrefix:vendorPrefix,transitions:transitions,animations:animations,android:android}}]}function $TemplateRequestProvider(){this.$get=["$templateCache","$http","$q","$sce",function($templateCache,$http,$q,$sce){function handleRequestFn(tpl,ignoreRequestError){handleRequestFn.totalPendingRequests++,isString(tpl)&&$templateCache.get(tpl)||(tpl=$sce.getTrustedResourceUrl(tpl));var transformResponse=$http.defaults&&$http.defaults.transformResponse;isArray(transformResponse)?transformResponse=transformResponse.filter(function(transformer){return transformer!==defaultHttpResponseTransform}):transformResponse===defaultHttpResponseTransform&&(transformResponse=null);var httpOptions={cache:$templateCache,transformResponse:transformResponse};return $http.get(tpl,httpOptions).finally(function(){handleRequestFn.totalPendingRequests--}).then(function(response){return $templateCache.put(tpl,response.data),response.data},function(resp){if(!ignoreRequestError)throw $compileMinErr("tpload","Failed to load template: {0} (HTTP status: {1} {2})",tpl,resp.status,resp.statusText);return $q.reject(resp)})}return handleRequestFn.totalPendingRequests=0,handleRequestFn}]}function $$TestabilityProvider(){this.$get=["$rootScope","$browser","$location",function($rootScope,$browser,$location){var testability={};return testability.findBindings=function(element,expression,opt_exactMatch){var matches=[];return forEach(element.getElementsByClassName("ng-binding"),function(binding){var dataBinding=angular.element(binding).data("$binding");dataBinding&&forEach(dataBinding,function(bindingName){opt_exactMatch?new RegExp("(^|\\s)"+escapeForRegexp(expression)+"(\\s|\\||$)").test(bindingName)&&matches.push(binding):-1!=bindingName.indexOf(expression)&&matches.push(binding)})}),matches},testability.findModels=function(element,expression,opt_exactMatch){for(var prefixes=["ng-","data-ng-","ng\\:"],p=0;p<prefixes.length;++p){var attributeEquals=opt_exactMatch?"=":"*=",selector="["+prefixes[p]+"model"+attributeEquals+'"'+expression+'"]',elements=element.querySelectorAll(selector);if(elements.length)return elements}},testability.getLocation=function(){return $location.url()},testability.setLocation=function(url){url!==$location.url()&&($location.url(url),$rootScope.$digest())},testability.whenStable=function(callback){$browser.notifyWhenNoOutstandingRequests(callback)},testability}]}function $TimeoutProvider(){this.$get=["$rootScope","$browser","$q","$$q","$exceptionHandler",function($rootScope,$browser,$q,$$q,$exceptionHandler){function timeout(fn,delay,invokeApply){isFunction(fn)||(invokeApply=delay,delay=fn,fn=noop);var timeoutId,args=sliceArgs(arguments,3),skipApply=isDefined(invokeApply)&&!invokeApply,deferred=(skipApply?$$q:$q).defer(),promise=deferred.promise;return timeoutId=$browser.defer(function(){try{deferred.resolve(fn.apply(null,args))}catch(e){deferred.reject(e),$exceptionHandler(e)}finally{delete deferreds[promise.$$timeoutId]}skipApply||$rootScope.$apply()},delay),promise.$$timeoutId=timeoutId,deferreds[timeoutId]=deferred,promise}var deferreds={};return timeout.cancel=function(promise){return!!(promise&&promise.$$timeoutId in deferreds)&&(deferreds[promise.$$timeoutId].reject("canceled"),delete deferreds[promise.$$timeoutId],$browser.defer.cancel(promise.$$timeoutId))},timeout}]}function urlResolve(url){var href=url;return msie&&(urlParsingNode.setAttribute("href",href),href=urlParsingNode.href),urlParsingNode.setAttribute("href",href),{href:urlParsingNode.href,protocol:urlParsingNode.protocol?urlParsingNode.protocol.replace(/:$/,""):"",host:urlParsingNode.host,search:urlParsingNode.search?urlParsingNode.search.replace(/^\?/,""):"",hash:urlParsingNode.hash?urlParsingNode.hash.replace(/^#/,""):"",hostname:urlParsingNode.hostname,port:urlParsingNode.port,pathname:"/"===urlParsingNode.pathname.charAt(0)?urlParsingNode.pathname:"/"+urlParsingNode.pathname}}function urlIsSameOrigin(requestUrl){var parsed=isString(requestUrl)?urlResolve(requestUrl):requestUrl;return parsed.protocol===originUrl.protocol&&parsed.host===originUrl.host}function $WindowProvider(){this.$get=valueFn(window)}function $$CookieReader($document){function safeDecodeURIComponent(str){try{return decodeURIComponent(str)}catch(e){return str}}var rawDocument=$document[0]||{},lastCookies={},lastCookieString="";return function(){var cookieArray,cookie,i,index,name,currentCookieString=rawDocument.cookie||"";if(currentCookieString!==lastCookieString)for(cookieArray=(lastCookieString=currentCookieString).split("; "),lastCookies={},i=0;i<cookieArray.length;i++)(index=(cookie=cookieArray[i]).indexOf("="))>0&&(name=safeDecodeURIComponent(cookie.substring(0,index)),lastCookies[name]===undefined&&(lastCookies[name]=safeDecodeURIComponent(cookie.substring(index+1))));return lastCookies}}function $$CookieReaderProvider(){this.$get=$$CookieReader}function $FilterProvider($provide){function register(name,factory){if(isObject(name)){var filters={};return forEach(name,function(filter,key){filters[key]=register(key,filter)}),filters}return $provide.factory(name+suffix,factory)}var suffix="Filter";this.register=register,this.$get=["$injector",function($injector){return function(name){return $injector.get(name+suffix)}}],register("currency",currencyFilter),register("date",dateFilter),register("filter",filterFilter),register("json",jsonFilter),register("limitTo",limitToFilter),register("lowercase",lowercaseFilter),register("number",numberFilter),register("orderBy",orderByFilter),register("uppercase",uppercaseFilter)}function filterFilter(){return function(array,expression,comparator){if(!isArrayLike(array)){if(null==array)return array;throw minErr("filter")("notarray","Expected array but received: {0}",array)}var predicateFn,matchAgainstAnyProp;switch(getTypeForFilter(expression)){case"function":predicateFn=expression;break;case"boolean":case"null":case"number":case"string":matchAgainstAnyProp=!0;case"object":predicateFn=createPredicateFn(expression,comparator,matchAgainstAnyProp);break;default:return array}return Array.prototype.filter.call(array,predicateFn)}}function createPredicateFn(expression,comparator,matchAgainstAnyProp){var shouldMatchPrimitives=isObject(expression)&&"$"in expression;return!0===comparator?comparator=equals:isFunction(comparator)||(comparator=function(actual,expected){return!isUndefined(actual)&&(null===actual||null===expected?actual===expected:!(isObject(expected)||isObject(actual)&&!hasCustomToString(actual))&&(actual=lowercase(""+actual),expected=lowercase(""+expected),-1!==actual.indexOf(expected)))}),function(item){return shouldMatchPrimitives&&!isObject(item)?deepCompare(item,expression.$,comparator,!1):deepCompare(item,expression,comparator,matchAgainstAnyProp)}}function deepCompare(actual,expected,comparator,matchAgainstAnyProp,dontMatchWholeObject){var actualType=getTypeForFilter(actual),expectedType=getTypeForFilter(expected);if("string"===expectedType&&"!"===expected.charAt(0))return!deepCompare(actual,expected.substring(1),comparator,matchAgainstAnyProp);if(isArray(actual))return actual.some(function(item){return deepCompare(item,expected,comparator,matchAgainstAnyProp)});switch(actualType){case"object":var key;if(matchAgainstAnyProp){for(key in actual)if("$"!==key.charAt(0)&&deepCompare(actual[key],expected,comparator,!0))return!0;return!dontMatchWholeObject&&deepCompare(actual,expected,comparator,!1)}if("object"===expectedType){for(key in expected){var expectedVal=expected[key];if(!isFunction(expectedVal)&&!isUndefined(expectedVal)){var matchAnyProperty="$"===key;if(!deepCompare(matchAnyProperty?actual:actual[key],expectedVal,comparator,matchAnyProperty,matchAnyProperty))return!1}}return!0}return comparator(actual,expected);case"function":return!1;default:return comparator(actual,expected)}}function getTypeForFilter(val){return null===val?"null":typeof val}function currencyFilter($locale){var formats=$locale.NUMBER_FORMATS;return function(amount,currencySymbol,fractionSize){return isUndefined(currencySymbol)&&(currencySymbol=formats.CURRENCY_SYM),isUndefined(fractionSize)&&(fractionSize=formats.PATTERNS[1].maxFrac),null==amount?amount:formatNumber(amount,formats.PATTERNS[1],formats.GROUP_SEP,formats.DECIMAL_SEP,fractionSize).replace(/\u00A4/g,currencySymbol)}}function numberFilter($locale){var formats=$locale.NUMBER_FORMATS;return function(number,fractionSize){return null==number?number:formatNumber(number,formats.PATTERNS[0],formats.GROUP_SEP,formats.DECIMAL_SEP,fractionSize)}}function formatNumber(number,pattern,groupSep,decimalSep,fractionSize){if(isObject(number))return"";var isNegative=number<0,isInfinity=(number=Math.abs(number))===1/0;if(!isInfinity&&!isFinite(number))return"";var numStr=number+"",formatedText="",hasExponent=!1,parts=[];if(isInfinity&&(formatedText="∞"),!isInfinity&&-1!==numStr.indexOf("e")){var match=numStr.match(/([\d\.]+)e(-?)(\d+)/);match&&"-"==match[2]&&match[3]>fractionSize+1?number=0:(formatedText=numStr,hasExponent=!0)}if(isInfinity||hasExponent)fractionSize>0&&number<1&&(formatedText=number.toFixed(fractionSize),number=parseFloat(formatedText));else{var fractionLen=(numStr.split(DECIMAL_SEP)[1]||"").length;isUndefined(fractionSize)&&(fractionSize=Math.min(Math.max(pattern.minFrac,fractionLen),pattern.maxFrac));var fraction=(""+(number=+(Math.round(+(number.toString()+"e"+fractionSize)).toString()+"e"+-fractionSize))).split(DECIMAL_SEP),whole=fraction[0];fraction=fraction[1]||"";var i,pos=0,lgroup=pattern.lgSize,group=pattern.gSize;if(whole.length>=lgroup+group)for(pos=whole.length-lgroup,i=0;i<pos;i++)(pos-i)%group==0&&0!==i&&(formatedText+=groupSep),formatedText+=whole.charAt(i);for(i=pos;i<whole.length;i++)(whole.length-i)%lgroup==0&&0!==i&&(formatedText+=groupSep),formatedText+=whole.charAt(i);for(;fraction.length<fractionSize;)fraction+="0";fractionSize&&"0"!==fractionSize&&(formatedText+=decimalSep+fraction.substr(0,fractionSize))}return 0===number&&(isNegative=!1),parts.push(isNegative?pattern.negPre:pattern.posPre,formatedText,isNegative?pattern.negSuf:pattern.posSuf),parts.join("")}function padNumber(num,digits,trim){var neg="";for(num<0&&(neg="-",num=-num),num=""+num;num.length<digits;)num="0"+num;return trim&&(num=num.substr(num.length-digits)),neg+num}function dateGetter(name,size,offset,trim){return offset=offset||0,function(date){var value=date["get"+name]();return(offset>0||value>-offset)&&(value+=offset),0===value&&-12==offset&&(value=12),padNumber(value,size,trim)}}function dateStrGetter(name,shortForm){return function(date,formats){var value=date["get"+name]();return formats[uppercase(shortForm?"SHORT"+name:name)][value]}}function getFirstThursdayOfYear(year){var dayOfWeekOnFirst=new Date(year,0,1).getDay();return new Date(year,0,(dayOfWeekOnFirst<=4?5:12)-dayOfWeekOnFirst)}function getThursdayThisWeek(datetime){return new Date(datetime.getFullYear(),datetime.getMonth(),datetime.getDate()+(4-datetime.getDay()))}function weekGetter(size){return function(date){var firstThurs=getFirstThursdayOfYear(date.getFullYear()),diff=+getThursdayThisWeek(date)-+firstThurs;return padNumber(1+Math.round(diff/6048e5),size)}}function eraGetter(date,formats){return date.getFullYear()<=0?formats.ERAS[0]:formats.ERAS[1]}function dateFilter($locale){function jsonStringToDate(string){var match;if(match=string.match(R_ISO8601_STR)){var date=new Date(0),tzHour=0,tzMin=0,dateSetter=match[8]?date.setUTCFullYear:date.setFullYear,timeSetter=match[8]?date.setUTCHours:date.setHours;match[9]&&(tzHour=toInt(match[9]+match[10]),tzMin=toInt(match[9]+match[11])),dateSetter.call(date,toInt(match[1]),toInt(match[2])-1,toInt(match[3]));var h=toInt(match[4]||0)-tzHour,m=toInt(match[5]||0)-tzMin,s=toInt(match[6]||0),ms=Math.round(1e3*parseFloat("0."+(match[7]||0)));return timeSetter.call(date,h,m,s,ms),date}return string}var R_ISO8601_STR=/^(\d{4})-?(\d\d)-?(\d\d)(?:T(\d\d)(?::?(\d\d)(?::?(\d\d)(?:\.(\d+))?)?)?(Z|([+-])(\d\d):?(\d\d))?)?$/;return function(date,format,timezone){var fn,match,text="",parts=[];if(format=format||"mediumDate",format=$locale.DATETIME_FORMATS[format]||format,isString(date)&&(date=NUMBER_STRING.test(date)?toInt(date):jsonStringToDate(date)),isNumber(date)&&(date=new Date(date)),!isDate(date)||!isFinite(date.getTime()))return date;for(;format;)(match=DATE_FORMATS_SPLIT.exec(format))?format=(parts=concat(parts,match,1)).pop():(parts.push(format),format=null);var dateTimezoneOffset=date.getTimezoneOffset();return timezone&&(dateTimezoneOffset=timezoneToOffset(timezone,date.getTimezoneOffset()),date=convertTimezoneToLocal(date,timezone,!0)),forEach(parts,function(value){fn=DATE_FORMATS[value],text+=fn?fn(date,$locale.DATETIME_FORMATS,dateTimezoneOffset):value.replace(/(^'|'$)/g,"").replace(/''/g,"'")}),text}}function jsonFilter(){return function(object,spacing){return isUndefined(spacing)&&(spacing=2),toJson(object,spacing)}}function limitToFilter(){return function(input,limit,begin){return limit=Math.abs(Number(limit))===1/0?Number(limit):toInt(limit),isNaN(limit)?input:(isNumber(input)&&(input=input.toString()),isArray(input)||isString(input)?(begin=!begin||isNaN(begin)?0:toInt(begin),begin=begin<0&&begin>=-input.length?input.length+begin:begin,limit>=0?input.slice(begin,begin+limit):0===begin?input.slice(limit,input.length):input.slice(Math.max(0,begin+limit),begin)):input)}}function orderByFilter($parse){function processPredicates(sortPredicate,reverseOrder){return reverseOrder=reverseOrder?-1:1,sortPredicate.map(function(predicate){var descending=1,get=identity;if(isFunction(predicate))get=predicate;else if(isString(predicate)&&("+"!=predicate.charAt(0)&&"-"!=predicate.charAt(0)||(descending="-"==predicate.charAt(0)?-1:1,predicate=predicate.substring(1)),""!==predicate&&(get=$parse(predicate)).constant)){var key=get();get=function(value){return value[key]}}return{get:get,descending:descending*reverseOrder}})}function isPrimitive(value){switch(typeof value){case"number":case"boolean":case"string":return!0;default:return!1}}function objectValue(value,index){return"function"==typeof value.valueOf&&(value=value.valueOf(),isPrimitive(value))?value:hasCustomToString(value)&&(value=value.toString(),isPrimitive(value))?value:index}function getPredicateValue(value,index){var type=typeof value;return null===value?(type="string",value="null"):"string"===type?value=value.toLowerCase():"object"===type&&(value=objectValue(value,index)),{value:value,type:type}}function compare(v1,v2){var result=0;return v1.type===v2.type?v1.value!==v2.value&&(result=v1.value<v2.value?-1:1):result=v1.type<v2.type?-1:1,result}return function(array,sortPredicate,reverseOrder){if(!isArrayLike(array))return array;isArray(sortPredicate)||(sortPredicate=[sortPredicate]),0===sortPredicate.length&&(sortPredicate=["+"]);var predicates=processPredicates(sortPredicate,reverseOrder),compareValues=Array.prototype.map.call(array,function(value,index){return{value:value,predicateValues:predicates.map(function(predicate){return getPredicateValue(predicate.get(value),index)})}});return compareValues.sort(function(v1,v2){for(var result=0,index=0,length=predicates.length;index<length&&!(result=compare(v1.predicateValues[index],v2.predicateValues[index])*predicates[index].descending);++index);return result}),array=compareValues.map(function(item){return item.value})}}function ngDirective(directive){return isFunction(directive)&&(directive={link:directive}),directive.restrict=directive.restrict||"AC",valueFn(directive)}function FormController(element,attrs,$scope,$animate,$interpolate){var form=this,controls=[],parentForm=form.$$parentForm=element.parent().controller("form")||nullFormCtrl;form.$error={},form.$$success={},form.$pending=undefined,form.$name=$interpolate(attrs.name||attrs.ngForm||"")($scope),form.$dirty=!1,form.$pristine=!0,form.$valid=!0,form.$invalid=!1,form.$submitted=!1,parentForm.$addControl(form),form.$rollbackViewValue=function(){forEach(controls,function(control){control.$rollbackViewValue()})},form.$commitViewValue=function(){forEach(controls,function(control){control.$commitViewValue()})},form.$addControl=function(control){assertNotHasOwnProperty(control.$name,"input"),controls.push(control),control.$name&&(form[control.$name]=control)},form.$$renameControl=function(control,newName){var oldName=control.$name;form[oldName]===control&&delete form[oldName],form[newName]=control,control.$name=newName},form.$removeControl=function(control){control.$name&&form[control.$name]===control&&delete form[control.$name],forEach(form.$pending,function(value,name){form.$setValidity(name,null,control)}),forEach(form.$error,function(value,name){form.$setValidity(name,null,control)}),forEach(form.$$success,function(value,name){form.$setValidity(name,null,control)}),arrayRemove(controls,control)},addSetValidityMethod({ctrl:this,$element:element,set:function(object,property,controller){var list=object[property];list?-1===list.indexOf(controller)&&list.push(controller):object[property]=[controller]},unset:function(object,property,controller){var list=object[property];list&&(arrayRemove(list,controller),0===list.length&&delete object[property])},parentForm:parentForm,$animate:$animate}),form.$setDirty=function(){$animate.removeClass(element,PRISTINE_CLASS),$animate.addClass(element,DIRTY_CLASS),form.$dirty=!0,form.$pristine=!1,parentForm.$setDirty()},form.$setPristine=function(){$animate.setClass(element,PRISTINE_CLASS,DIRTY_CLASS+" "+SUBMITTED_CLASS),form.$dirty=!1,form.$pristine=!0,form.$submitted=!1,forEach(controls,function(control){control.$setPristine()})},form.$setUntouched=function(){forEach(controls,function(control){control.$setUntouched()})},form.$setSubmitted=function(){$animate.addClass(element,SUBMITTED_CLASS),form.$submitted=!0,parentForm.$setSubmitted()}}function stringBasedInputType(ctrl){ctrl.$formatters.push(function(value){return ctrl.$isEmpty(value)?value:value.toString()})}function baseInputType(scope,element,attr,ctrl,$sniffer,$browser){var type=lowercase(element[0].type);if(!$sniffer.android){var composing=!1;element.on("compositionstart",function(data){composing=!0}),element.on("compositionend",function(){composing=!1,listener()})}var listener=function(ev){if(timeout&&($browser.defer.cancel(timeout),timeout=null),!composing){var value=element.val(),event=ev&&ev.type;"password"===type||attr.ngTrim&&"false"===attr.ngTrim||(value=trim(value)),(ctrl.$viewValue!==value||""===value&&ctrl.$$hasNativeValidators)&&ctrl.$setViewValue(value,event)}};if($sniffer.hasEvent("input"))element.on("input",listener);else{var timeout,deferListener=function(ev,input,origValue){timeout||(timeout=$browser.defer(function(){timeout=null,input&&input.value===origValue||listener(ev)}))};element.on("keydown",function(event){var key=event.keyCode;91===key||15<key&&key<19||37<=key&&key<=40||deferListener(event,this,this.value)}),$sniffer.hasEvent("paste")&&element.on("paste cut",deferListener)}element.on("change",listener),ctrl.$render=function(){element.val(ctrl.$isEmpty(ctrl.$viewValue)?"":ctrl.$viewValue)}}function createDateParser(regexp,mapping){return function(iso,date){var parts,map;if(isDate(iso))return iso;if(isString(iso)){if('"'==iso.charAt(0)&&'"'==iso.charAt(iso.length-1)&&(iso=iso.substring(1,iso.length-1)),ISO_DATE_REGEXP.test(iso))return new Date(iso);if(regexp.lastIndex=0,parts=regexp.exec(iso))return parts.shift(),map=date?{yyyy:date.getFullYear(),MM:date.getMonth()+1,dd:date.getDate(),HH:date.getHours(),mm:date.getMinutes(),ss:date.getSeconds(),sss:date.getMilliseconds()/1e3}:{yyyy:1970,MM:1,dd:1,HH:0,mm:0,ss:0,sss:0},forEach(parts,function(part,index){index<mapping.length&&(map[mapping[index]]=+part)}),new Date(map.yyyy,map.MM-1,map.dd,map.HH,map.mm,map.ss||0,1e3*map.sss||0)}return NaN}}function createDateInputType(type,regexp,parseDate,format){return function(scope,element,attr,ctrl,$sniffer,$browser,$filter){function isValidDate(value){return value&&!(value.getTime&&value.getTime()!==value.getTime())}function parseObservedDateValue(val){return isDefined(val)?isDate(val)?val:parseDate(val):undefined}badInputChecker(scope,element,attr,ctrl),baseInputType(scope,element,attr,ctrl,$sniffer,$browser);var previousDate,timezone=ctrl&&ctrl.$options&&ctrl.$options.timezone;if(ctrl.$$parserName=type,ctrl.$parsers.push(function(value){if(ctrl.$isEmpty(value))return null;if(regexp.test(value)){var parsedDate=parseDate(value,previousDate);return timezone&&(parsedDate=convertTimezoneToLocal(parsedDate,timezone)),parsedDate}return undefined}),ctrl.$formatters.push(function(value){if(value&&!isDate(value))throw $ngModelMinErr("datefmt","Expected `{0}` to be a date",value);return isValidDate(value)?((previousDate=value)&&timezone&&(previousDate=convertTimezoneToLocal(previousDate,timezone,!0)),$filter("date")(value,format,timezone)):(previousDate=null,"")}),isDefined(attr.min)||attr.ngMin){var minVal;ctrl.$validators.min=function(value){return!isValidDate(value)||isUndefined(minVal)||parseDate(value)>=minVal},attr.$observe("min",function(val){minVal=parseObservedDateValue(val),ctrl.$validate()})}if(isDefined(attr.max)||attr.ngMax){var maxVal;ctrl.$validators.max=function(value){return!isValidDate(value)||isUndefined(maxVal)||parseDate(value)<=maxVal},attr.$observe("max",function(val){maxVal=parseObservedDateValue(val),ctrl.$validate()})}}}function badInputChecker(scope,element,attr,ctrl){var node=element[0];(ctrl.$$hasNativeValidators=isObject(node.validity))&&ctrl.$parsers.push(function(value){var validity=element.prop(VALIDITY_STATE_PROPERTY)||{};return validity.badInput&&!validity.typeMismatch?undefined:value})}function parseConstantExpr($parse,context,name,expression,fallback){var parseFn;if(isDefined(expression)){if(!(parseFn=$parse(expression)).constant)throw minErr("ngModel")("constexpr","Expected constant expression for `{0}`, but saw `{1}`.",name,expression);return parseFn(context)}return fallback}function classDirective(name,selector){return name="ngClass"+name,["$animate",function($animate){function arrayDifference(tokens1,tokens2){var values=[];outer:for(var i=0;i<tokens1.length;i++){for(var token=tokens1[i],j=0;j<tokens2.length;j++)if(token==tokens2[j])continue outer;values.push(token)}return values}function arrayClasses(classVal){var classes=[];return isArray(classVal)?(forEach(classVal,function(v){classes=classes.concat(arrayClasses(v))}),classes):isString(classVal)?classVal.split(" "):isObject(classVal)?(forEach(classVal,function(v,k){v&&(classes=classes.concat(k.split(" ")))}),classes):classVal}return{restrict:"AC",link:function(scope,element,attr){function addClasses(classes){var newClasses=digestClassCounts(classes,1);attr.$addClass(newClasses)}function removeClasses(classes){var newClasses=digestClassCounts(classes,-1);attr.$removeClass(newClasses)}function digestClassCounts(classes,count){var classCounts=element.data("$classCounts")||createMap(),classesToUpdate=[];return forEach(classes,function(className){(count>0||classCounts[className])&&(classCounts[className]=(classCounts[className]||0)+count,classCounts[className]===+(count>0)&&classesToUpdate.push(className))}),element.data("$classCounts",classCounts),classesToUpdate.join(" ")}function updateClasses(oldClasses,newClasses){var toAdd=arrayDifference(newClasses,oldClasses),toRemove=arrayDifference(oldClasses,newClasses);toAdd=digestClassCounts(toAdd,1),toRemove=digestClassCounts(toRemove,-1),toAdd&&toAdd.length&&$animate.addClass(element,toAdd),toRemove&&toRemove.length&&$animate.removeClass(element,toRemove)}function ngClassWatchAction(newVal){if(!0===selector||scope.$index%2===selector){var newClasses=arrayClasses(newVal||[]);oldVal?equals(newVal,oldVal)||updateClasses(arrayClasses(oldVal),newClasses):addClasses(newClasses)}oldVal=shallowCopy(newVal)}var oldVal;scope.$watch(attr[name],ngClassWatchAction,!0),attr.$observe("class",function(value){ngClassWatchAction(scope.$eval(attr[name]))}),"ngClass"!==name&&scope.$watch("$index",function($index,old$index){var mod=1&$index;if(mod!==(1&old$index)){var classes=arrayClasses(scope.$eval(attr[name]));mod===selector?addClasses(classes):removeClasses(classes)}})}}}]}function addSetValidityMethod(context){function createAndSet(name,value,controller){ctrl[name]||(ctrl[name]={}),set(ctrl[name],value,controller)}function unsetAndCleanup(name,value,controller){ctrl[name]&&unset(ctrl[name],value,controller),isObjectEmpty(ctrl[name])&&(ctrl[name]=undefined)}function cachedToggleClass(className,switchValue){switchValue&&!classCache[className]?($animate.addClass($element,className),classCache[className]=!0):!switchValue&&classCache[className]&&($animate.removeClass($element,className),classCache[className]=!1)}function toggleValidationCss(validationErrorKey,isValid){validationErrorKey=validationErrorKey?"-"+snake_case(validationErrorKey,"-"):"",cachedToggleClass(VALID_CLASS+validationErrorKey,!0===isValid),cachedToggleClass(INVALID_CLASS+validationErrorKey,!1===isValid)}var ctrl=context.ctrl,$element=context.$element,classCache={},set=context.set,unset=context.unset,parentForm=context.parentForm,$animate=context.$animate;classCache[INVALID_CLASS]=!(classCache[VALID_CLASS]=$element.hasClass(VALID_CLASS)),ctrl.$setValidity=function(validationErrorKey,state,controller){state===undefined?createAndSet("$pending",validationErrorKey,controller):unsetAndCleanup("$pending",validationErrorKey,controller),isBoolean(state)?state?(unset(ctrl.$error,validationErrorKey,controller),set(ctrl.$$success,validationErrorKey,controller)):(set(ctrl.$error,validationErrorKey,controller),unset(ctrl.$$success,validationErrorKey,controller)):(unset(ctrl.$error,validationErrorKey,controller),unset(ctrl.$$success,validationErrorKey,controller)),ctrl.$pending?(cachedToggleClass(PENDING_CLASS,!0),ctrl.$valid=ctrl.$invalid=undefined,toggleValidationCss("",null)):(cachedToggleClass(PENDING_CLASS,!1),ctrl.$valid=isObjectEmpty(ctrl.$error),ctrl.$invalid=!ctrl.$valid,toggleValidationCss("",ctrl.$valid));var combinedState;toggleValidationCss(validationErrorKey,combinedState=ctrl.$pending&&ctrl.$pending[validationErrorKey]?undefined:!ctrl.$error[validationErrorKey]&&(!!ctrl.$$success[validationErrorKey]||null)),parentForm.$setValidity(validationErrorKey,combinedState,ctrl)}}function isObjectEmpty(obj){if(obj)for(var prop in obj)if(obj.hasOwnProperty(prop))return!1;return!0}var REGEX_STRING_REGEXP=/^\/(.+)\/([a-z]*)$/,VALIDITY_STATE_PROPERTY="validity",lowercase=function(string){return isString(string)?string.toLowerCase():string},hasOwnProperty=Object.prototype.hasOwnProperty,uppercase=function(string){return isString(string)?string.toUpperCase():string};"i"!=="I".toLowerCase()&&(lowercase=function(s){return isString(s)?s.replace(/[A-Z]/g,function(ch){return String.fromCharCode(32|ch.charCodeAt(0))}):s},uppercase=function(s){return isString(s)?s.replace(/[a-z]/g,function(ch){return String.fromCharCode(-33&ch.charCodeAt(0))}):s});var msie,jqLite,jQuery,angularModule,slice=[].slice,splice=[].splice,push=[].push,toString=Object.prototype.toString,getPrototypeOf=Object.getPrototypeOf,ngMinErr=minErr("ng"),angular=window.angular||(window.angular={}),uid=0;msie=document.documentMode,noop.$inject=[],identity.$inject=[];var skipDestroyOnNextJQueryCleanData,isArray=Array.isArray,TYPED_ARRAY_REGEXP=/^\[object (Uint8(Clamped)?)|(Uint16)|(Uint32)|(Int8)|(Int16)|(Int32)|(Float(32)|(64))Array\]$/,trim=function(value){return isString(value)?value.trim():value},escapeForRegexp=function(s){return s.replace(/([-()\[\]{}+?*.$\^|,:#<!\\])/g,"\\$1").replace(/\x08/g,"\\x08")},csp=function(){if(isDefined(csp.isActive_))return csp.isActive_;var active=!(!document.querySelector("[ng-csp]")&&!document.querySelector("[data-ng-csp]"));if(!active)try{new Function("")}catch(e){active=!0}return csp.isActive_=active},jq=function(){if(isDefined(jq.name_))return jq.name_;var el,i,prefix,name,ii=ngAttrPrefixes.length;for(i=0;i<ii;++i)if(prefix=ngAttrPrefixes[i],el=document.querySelector("["+prefix.replace(":","\\:")+"jq]")){name=el.getAttribute(prefix+"jq");break}return jq.name_=name},ngAttrPrefixes=["ng-","data-ng-","ng:","x-ng-"],SNAKE_CASE_REGEXP=/[A-Z]/g,bindJQueryFired=!1,NODE_TYPE_ELEMENT=1,NODE_TYPE_TEXT=3,NODE_TYPE_COMMENT=8,NODE_TYPE_DOCUMENT=9,NODE_TYPE_DOCUMENT_FRAGMENT=11,version={full:"1.4.3",major:1,minor:4,dot:3,codeName:"foam-acceleration"};JQLite.expando="ng339";var jqCache=JQLite.cache={},jqId=1,addEventListenerFn=function(element,type,fn){element.addEventListener(type,fn,!1)},removeEventListenerFn=function(element,type,fn){element.removeEventListener(type,fn,!1)};JQLite._data=function(node){return this.cache[node[this.expando]]||{}};var SPECIAL_CHARS_REGEXP=/([\:\-\_]+(.))/g,MOZ_HACK_REGEXP=/^moz([A-Z])/,MOUSE_EVENT_MAP={mouseleave:"mouseout",mouseenter:"mouseover"},jqLiteMinErr=minErr("jqLite"),SINGLE_TAG_REGEXP=/^<(\w+)\s*\/?>(?:<\/\1>|)$/,HTML_REGEXP=/<|&#?\w+;/,TAG_NAME_REGEXP=/<([\w:]+)/,XHTML_TAG_REGEXP=/<(?!area|br|col|embed|hr|img|input|link|meta|param)(([\w:]+)[^>]*)\/>/gi,wrapMap={option:[1,'<select multiple="multiple">',"</select>"],thead:[1,"<table>","</table>"],col:[2,"<table><colgroup>","</colgroup></table>"],tr:[2,"<table><tbody>","</tbody></table>"],td:[3,"<table><tbody><tr>","</tr></tbody></table>"],_default:[0,"",""]};wrapMap.optgroup=wrapMap.option,wrapMap.tbody=wrapMap.tfoot=wrapMap.colgroup=wrapMap.caption=wrapMap.thead,wrapMap.th=wrapMap.td;var JQLitePrototype=JQLite.prototype={ready:function(fn){function trigger(){fired||(fired=!0,fn())}var fired=!1;"complete"===document.readyState?setTimeout(trigger):(this.on("DOMContentLoaded",trigger),JQLite(window).on("load",trigger))},toString:function(){var value=[];return forEach(this,function(e){value.push(""+e)}),"["+value.join(", ")+"]"},eq:function(index){return jqLite(index>=0?this[index]:this[this.length+index])},length:0,push:push,sort:[].sort,splice:[].splice},BOOLEAN_ATTR={};forEach("multiple,selected,checked,disabled,readOnly,required,open".split(","),function(value){BOOLEAN_ATTR[lowercase(value)]=value});var BOOLEAN_ELEMENTS={};forEach("input,select,option,textarea,button,form,details".split(","),function(value){BOOLEAN_ELEMENTS[value]=!0});var ALIASED_ATTR={ngMinlength:"minlength",ngMaxlength:"maxlength",ngMin:"min",ngMax:"max",ngPattern:"pattern"};forEach({data:jqLiteData,removeData:jqLiteRemoveData,hasData:function(node){for(var key in jqCache[node.ng339])return!0;return!1}},function(fn,name){JQLite[name]=fn}),forEach({data:jqLiteData,inheritedData:jqLiteInheritedData,scope:function(element){return jqLite.data(element,"$scope")||jqLiteInheritedData(element.parentNode||element,["$isolateScope","$scope"])},isolateScope:function(element){return jqLite.data(element,"$isolateScope")||jqLite.data(element,"$isolateScopeNoTemplate")},controller:jqLiteController,injector:function(element){return jqLiteInheritedData(element,"$injector")},removeAttr:function(element,name){element.removeAttribute(name)},hasClass:jqLiteHasClass,css:function(element,name,value){if(name=camelCase(name),!isDefined(value))return element.style[name];element.style[name]=value},attr:function(element,name,value){var nodeType=element.nodeType;if(nodeType!==NODE_TYPE_TEXT&&2!==nodeType&&nodeType!==NODE_TYPE_COMMENT){var lowercasedName=lowercase(name);if(BOOLEAN_ATTR[lowercasedName]){if(!isDefined(value))return element[name]||(element.attributes.getNamedItem(name)||noop).specified?lowercasedName:undefined;value?(element[name]=!0,element.setAttribute(name,lowercasedName)):(element[name]=!1,element.removeAttribute(lowercasedName))}else if(isDefined(value))element.setAttribute(name,value);else if(element.getAttribute){var ret=element.getAttribute(name,2);return null===ret?undefined:ret}}},prop:function(element,name,value){if(!isDefined(value))return element[name];element[name]=value},text:function(){function getText(element,value){if(isUndefined(value)){var nodeType=element.nodeType;return nodeType===NODE_TYPE_ELEMENT||nodeType===NODE_TYPE_TEXT?element.textContent:""}element.textContent=value}return getText.$dv="",getText}(),val:function(element,value){if(isUndefined(value)){if(element.multiple&&"select"===nodeName_(element)){var result=[];return forEach(element.options,function(option){option.selected&&result.push(option.value||option.text)}),0===result.length?null:result}return element.value}element.value=value},html:function(element,value){if(isUndefined(value))return element.innerHTML;jqLiteDealoc(element,!0),element.innerHTML=value},empty:jqLiteEmpty},function(fn,name){JQLite.prototype[name]=function(arg1,arg2){var i,key,nodeCount=this.length;if(fn!==jqLiteEmpty&&(2==fn.length&&fn!==jqLiteHasClass&&fn!==jqLiteController?arg1:arg2)===undefined){if(isObject(arg1)){for(i=0;i<nodeCount;i++)if(fn===jqLiteData)fn(this[i],arg1);else for(key in arg1)fn(this[i],key,arg1[key]);return this}for(var value=fn.$dv,jj=value===undefined?Math.min(nodeCount,1):nodeCount,j=0;j<jj;j++){var nodeValue=fn(this[j],arg1,arg2);value=value?value+nodeValue:nodeValue}return value}for(i=0;i<nodeCount;i++)fn(this[i],arg1,arg2);return this}}),forEach({removeData:jqLiteRemoveData,on:function jqLiteOn(element,type,fn,unsupported){if(isDefined(unsupported))throw jqLiteMinErr("onargs","jqLite#on() does not support the `selector` or `eventData` parameters");if(jqLiteAcceptsData(element)){var expandoStore=jqLiteExpandoStore(element,!0),events=expandoStore.events,handle=expandoStore.handle;handle||(handle=expandoStore.handle=createEventHandler(element,events));for(var types=type.indexOf(" ")>=0?type.split(" "):[type],i=types.length;i--;){var eventFns=events[type=types[i]];eventFns||(events[type]=[],"mouseenter"===type||"mouseleave"===type?jqLiteOn(element,MOUSE_EVENT_MAP[type],function(event){var target=this,related=event.relatedTarget;related&&(related===target||target.contains(related))||handle(event,type)}):"$destroy"!==type&&addEventListenerFn(element,type,handle),eventFns=events[type]),eventFns.push(fn)}}},off:jqLiteOff,one:function(element,type,fn){(element=jqLite(element)).on(type,function onFn(){element.off(type,fn),element.off(type,onFn)}),element.on(type,fn)},replaceWith:function(element,replaceNode){var index,parent=element.parentNode;jqLiteDealoc(element),forEach(new JQLite(replaceNode),function(node){index?parent.insertBefore(node,index.nextSibling):parent.replaceChild(node,element),index=node})},children:function(element){var children=[];return forEach(element.childNodes,function(element){element.nodeType===NODE_TYPE_ELEMENT&&children.push(element)}),children},contents:function(element){return element.contentDocument||element.childNodes||[]},append:function(element,node){var nodeType=element.nodeType;if(nodeType===NODE_TYPE_ELEMENT||nodeType===NODE_TYPE_DOCUMENT_FRAGMENT)for(var i=0,ii=(node=new JQLite(node)).length;i<ii;i++){var child=node[i];element.appendChild(child)}},prepend:function(element,node){if(element.nodeType===NODE_TYPE_ELEMENT){var index=element.firstChild;forEach(new JQLite(node),function(child){element.insertBefore(child,index)})}},wrap:function(element,wrapNode){wrapNode=jqLite(wrapNode).eq(0).clone()[0];var parent=element.parentNode;parent&&parent.replaceChild(wrapNode,element),wrapNode.appendChild(element)},remove:jqLiteRemove,detach:function(element){jqLiteRemove(element,!0)},after:function(element,newElement){for(var index=element,parent=element.parentNode,i=0,ii=(newElement=new JQLite(newElement)).length;i<ii;i++){var node=newElement[i];parent.insertBefore(node,index.nextSibling),index=node}},addClass:jqLiteAddClass,removeClass:jqLiteRemoveClass,toggleClass:function(element,selector,condition){selector&&forEach(selector.split(" "),function(className){var classCondition=condition;isUndefined(classCondition)&&(classCondition=!jqLiteHasClass(element,className)),(classCondition?jqLiteAddClass:jqLiteRemoveClass)(element,className)})},parent:function(element){var parent=element.parentNode;return parent&&parent.nodeType!==NODE_TYPE_DOCUMENT_FRAGMENT?parent:null},next:function(element){return element.nextElementSibling},find:function(element,selector){return element.getElementsByTagName?element.getElementsByTagName(selector):[]},clone:jqLiteClone,triggerHandler:function(element,event,extraParameters){var dummyEvent,eventFnsCopy,handlerArgs,eventName=event.type||event,expandoStore=jqLiteExpandoStore(element),events=expandoStore&&expandoStore.events,eventFns=events&&events[eventName];eventFns&&(dummyEvent={preventDefault:function(){this.defaultPrevented=!0},isDefaultPrevented:function(){return!0===this.defaultPrevented},stopImmediatePropagation:function(){this.immediatePropagationStopped=!0},isImmediatePropagationStopped:function(){return!0===this.immediatePropagationStopped},stopPropagation:noop,type:eventName,target:element},event.type&&(dummyEvent=extend(dummyEvent,event)),eventFnsCopy=shallowCopy(eventFns),handlerArgs=extraParameters?[dummyEvent].concat(extraParameters):[dummyEvent],forEach(eventFnsCopy,function(fn){dummyEvent.isImmediatePropagationStopped()||fn.apply(element,handlerArgs)}))}},function(fn,name){JQLite.prototype[name]=function(arg1,arg2,arg3){for(var value,i=0,ii=this.length;i<ii;i++)isUndefined(value)?isDefined(value=fn(this[i],arg1,arg2,arg3))&&(value=jqLite(value)):jqLiteAddNodes(value,fn(this[i],arg1,arg2,arg3));return isDefined(value)?value:this},JQLite.prototype.bind=JQLite.prototype.on,JQLite.prototype.unbind=JQLite.prototype.off}),HashMap.prototype={put:function(key,value){this[hashKey(key,this.nextUid)]=value},get:function(key){return this[hashKey(key,this.nextUid)]},remove:function(key){var value=this[key=hashKey(key,this.nextUid)];return delete this[key],value}};var $$HashMapProvider=[function(){this.$get=[function(){return HashMap}]}],FN_ARGS=/^function\s*[^\(]*\(\s*([^\)]*)\)/m,FN_ARG_SPLIT=/,/,FN_ARG=/^\s*(_?)(\S+?)\1\s*$/,STRIP_COMMENTS=/((\/\/.*$)|(\/\*[\s\S]*?\*\/))/gm,$injectorMinErr=minErr("$injector");createInjector.$$annotate=function(fn,strictDi,name){var $inject,last;if("function"==typeof fn){if(!($inject=fn.$inject)){if($inject=[],fn.length){if(strictDi)throw isString(name)&&name||(name=fn.name||anonFn(fn)),$injectorMinErr("strictdi","{0} is not using explicit annotation and cannot be invoked in strict mode",name);forEach(fn.toString().replace(STRIP_COMMENTS,"").match(FN_ARGS)[1].split(FN_ARG_SPLIT),function(arg){arg.replace(FN_ARG,function(all,underscore,name){$inject.push(name)})})}fn.$inject=$inject}}else isArray(fn)?(assertArgFn(fn[last=fn.length-1],"fn"),$inject=fn.slice(0,last)):assertArgFn(fn,"fn",!0);return $inject};var $animateMinErr=minErr("$animate"),ELEMENT_NODE=1,$$CoreAnimateRunnerProvider=function(){this.$get=["$q","$$rAF",function($q,$$rAF){function AnimateRunner(){}return AnimateRunner.all=noop,AnimateRunner.chain=noop,AnimateRunner.prototype={end:noop,cancel:noop,resume:noop,pause:noop,complete:noop,then:function(pass,fail){return $q(function(resolve){$$rAF(function(){resolve()})}).then(pass,fail)}},AnimateRunner}]},$$CoreAnimateQueueProvider=function(){var postDigestQueue=new HashMap,postDigestElements=[];this.$get=["$$AnimateRunner","$rootScope",function($$AnimateRunner,$rootScope){function addRemoveClassesPostDigest(element,add,remove){var data=postDigestQueue.get(element);data||(postDigestQueue.put(element,data={}),postDigestElements.push(element)),add&&forEach(add.split(" "),function(className){className&&(data[className]=!0)}),remove&&forEach(remove.split(" "),function(className){className&&(data[className]=!1)}),postDigestElements.length>1||$rootScope.$$postDigest(function(){forEach(postDigestElements,function(element){var data=postDigestQueue.get(element);if(data){var existing=splitClasses(element.attr("class")),toAdd="",toRemove="";forEach(data,function(status,className){status!==!!existing[className]&&(status?toAdd+=(toAdd.length?" ":"")+className:toRemove+=(toRemove.length?" ":"")+className)}),forEach(element,function(elm){toAdd&&jqLiteAddClass(elm,toAdd),toRemove&&jqLiteRemoveClass(elm,toRemove)}),postDigestQueue.remove(element)}}),postDigestElements.length=0})}return{enabled:noop,on:noop,off:noop,pin:noop,push:function(element,event,options,domOperation){return domOperation&&domOperation(),(options=options||{}).from&&element.css(options.from),options.to&&element.css(options.to),(options.addClass||options.removeClass)&&addRemoveClassesPostDigest(element,options.addClass,options.removeClass),new $$AnimateRunner}}}]},$AnimateProvider=["$provide",function($provide){var provider=this;this.$$registeredAnimations=Object.create(null),this.register=function(name,factory){if(name&&"."!==name.charAt(0))throw $animateMinErr("notcsel","Expecting class selector starting with '.' got '{0}'.",name);var key=name+"-animation";provider.$$registeredAnimations[name.substr(1)]=key,$provide.factory(key,factory)},this.classNameFilter=function(expression){if(1===arguments.length&&(this.$$classNameFilter=expression instanceof RegExp?expression:null,this.$$classNameFilter&&new RegExp("(\\s+|\\/)ng-animate(\\s+|\\/)").test(this.$$classNameFilter.toString())))throw $animateMinErr("nongcls",'$animateProvider.classNameFilter(regex) prohibits accepting a regex value which matches/contains the "{0}" CSS class.',"ng-animate");return this.$$classNameFilter},this.$get=["$$animateQueue",function($$animateQueue){function domInsert(element,parentElement,afterElement){if(afterElement){var afterNode=extractElementNode(afterElement);!afterNode||afterNode.parentNode||afterNode.previousElementSibling||(afterElement=null)}afterElement?afterElement.after(element):parentElement.prepend(element)}return{on:$$animateQueue.on,off:$$animateQueue.off,pin:$$animateQueue.pin,enabled:$$animateQueue.enabled,cancel:function(runner){runner.end&&runner.end()},enter:function(element,parent,after,options){return parent=parent&&jqLite(parent),after=after&&jqLite(after),parent=parent||after.parent(),domInsert(element,parent,after),$$animateQueue.push(element,"enter",prepareAnimateOptions(options))},move:function(element,parent,after,options){return parent=parent&&jqLite(parent),after=after&&jqLite(after),parent=parent||after.parent(),domInsert(element,parent,after),$$animateQueue.push(element,"move",prepareAnimateOptions(options))},leave:function(element,options){return $$animateQueue.push(element,"leave",prepareAnimateOptions(options),function(){element.remove()})},addClass:function(element,className,options){return options=prepareAnimateOptions(options),options.addClass=mergeClasses(options.addclass,className),$$animateQueue.push(element,"addClass",options)},removeClass:function(element,className,options){return options=prepareAnimateOptions(options),options.removeClass=mergeClasses(options.removeClass,className),$$animateQueue.push(element,"removeClass",options)},setClass:function(element,add,remove,options){return options=prepareAnimateOptions(options),options.addClass=mergeClasses(options.addClass,add),options.removeClass=mergeClasses(options.removeClass,remove),$$animateQueue.push(element,"setClass",options)},animate:function(element,from,to,className,options){return options=prepareAnimateOptions(options),options.from=options.from?extend(options.from,from):from,options.to=options.to?extend(options.to,to):to,className=className||"ng-inline-animate",options.tempClasses=mergeClasses(options.tempClasses,className),$$animateQueue.push(element,"animate",options)}}}]}],$compileMinErr=minErr("$compile");$CompileProvider.$inject=["$provide","$$sanitizeUriProvider"];var PREFIX_REGEXP=/^((?:x|data)[\:\-_])/i,$controllerMinErr=minErr("$controller"),CNTRL_REG=/^(\S+)(\s+as\s+(\w+))?$/,APPLICATION_JSON="application/json",CONTENT_TYPE_APPLICATION_JSON={"Content-Type":APPLICATION_JSON+";charset=utf-8"},JSON_START=/^\[|^\{(?!\{)/,JSON_ENDS={"[":/]$/,"{":/}$/},JSON_PROTECTION_PREFIX=/^\)\]\}',?\n/,$interpolateMinErr=angular.$interpolateMinErr=minErr("$interpolate");$interpolateMinErr.throwNoconcat=function(text){throw $interpolateMinErr("noconcat","Error while interpolating: {0}\nStrict Contextual Escaping disallows interpolations that concatenate multiple expressions when a trusted value is required.  See http://docs.angularjs.org/api/ng.$sce",text)},$interpolateMinErr.interr=function(text,err){return $interpolateMinErr("interr","Can't interpolate: {0}\n{1}",text,err.toString())};var PATH_MATCH=/^([^\?#]*)(\?([^#]*))?(#(.*))?$/,DEFAULT_PORTS={http:80,https:443,ftp:21},$locationMinErr=minErr("$location"),locationPrototype={$$html5:!1,$$replace:!1,absUrl:locationGetter("$$absUrl"),url:function(url){if(isUndefined(url))return this.$$url;var match=PATH_MATCH.exec(url);return(match[1]||""===url)&&this.path(decodeURIComponent(match[1])),(match[2]||match[1]||""===url)&&this.search(match[3]||""),this.hash(match[5]||""),this},protocol:locationGetter("$$protocol"),host:locationGetter("$$host"),port:locationGetter("$$port"),path:locationGetterSetter("$$path",function(path){return"/"==(path=null!==path?path.toString():"").charAt(0)?path:"/"+path}),search:function(search,paramValue){switch(arguments.length){case 0:return this.$$search;case 1:if(isString(search)||isNumber(search))search=search.toString(),this.$$search=parseKeyValue(search);else{if(!isObject(search))throw $locationMinErr("isrcharg","The first argument of the `$location#search()` call must be a string or an object.");forEach(search=copy(search,{}),function(value,key){null==value&&delete search[key]}),this.$$search=search}break;default:isUndefined(paramValue)||null===paramValue?delete this.$$search[search]:this.$$search[search]=paramValue}return this.$$compose(),this},hash:locationGetterSetter("$$hash",function(hash){return null!==hash?hash.toString():""}),replace:function(){return this.$$replace=!0,this}};forEach([LocationHashbangInHtml5Url,LocationHashbangUrl,LocationHtml5Url],function(Location){Location.prototype=Object.create(locationPrototype),Location.prototype.state=function(state){if(!arguments.length)return this.$$state;if(Location!==LocationHtml5Url||!this.$$html5)throw $locationMinErr("nostate","History API state support is available only in HTML5 mode and only in browsers supporting HTML5 History API");return this.$$state=isUndefined(state)?null:state,this}});var $parseMinErr=minErr("$parse"),CALL=Function.prototype.call,APPLY=Function.prototype.apply,BIND=Function.prototype.bind,OPERATORS=createMap();forEach("+ - * / % === !== == != < > <= >= && || ! = |".split(" "),function(operator){OPERATORS[operator]=!0});var ESCAPE={n:"\n",f:"\f",r:"\r",t:"\t",v:"\v","'":"'",'"':'"'},Lexer=function(options){this.options=options};Lexer.prototype={constructor:Lexer,lex:function(text){for(this.text=text,this.index=0,this.tokens=[];this.index<this.text.length;){var ch=this.text.charAt(this.index);if('"'===ch||"'"===ch)this.readString(ch);else if(this.isNumber(ch)||"."===ch&&this.isNumber(this.peek()))this.readNumber();else if(this.isIdent(ch))this.readIdent();else if(this.is(ch,"(){}[].,;:?"))this.tokens.push({index:this.index,text:ch}),this.index++;else if(this.isWhitespace(ch))this.index++;else{var ch2=ch+this.peek(),ch3=ch2+this.peek(2),op1=OPERATORS[ch],op2=OPERATORS[ch2],op3=OPERATORS[ch3];if(op1||op2||op3){var token=op3?ch3:op2?ch2:ch;this.tokens.push({index:this.index,text:token,operator:!0}),this.index+=token.length}else this.throwError("Unexpected next character ",this.index,this.index+1)}}return this.tokens},is:function(ch,chars){return-1!==chars.indexOf(ch)},peek:function(i){var num=i||1;return this.index+num<this.text.length&&this.text.charAt(this.index+num)},isNumber:function(ch){return"0"<=ch&&ch<="9"&&"string"==typeof ch},isWhitespace:function(ch){return" "===ch||"\r"===ch||"\t"===ch||"\n"===ch||"\v"===ch||" "===ch},isIdent:function(ch){return"a"<=ch&&ch<="z"||"A"<=ch&&ch<="Z"||"_"===ch||"$"===ch},isExpOperator:function(ch){return"-"===ch||"+"===ch||this.isNumber(ch)},throwError:function(error,start,end){end=end||this.index;var colStr=isDefined(start)?"s "+start+"-"+this.index+" ["+this.text.substring(start,end)+"]":" "+end;throw $parseMinErr("lexerr","Lexer Error: {0} at column{1} in expression [{2}].",error,colStr,this.text)},readNumber:function(){for(var number="",start=this.index;this.index<this.text.length;){var ch=lowercase(this.text.charAt(this.index));if("."==ch||this.isNumber(ch))number+=ch;else{var peekCh=this.peek();if("e"==ch&&this.isExpOperator(peekCh))number+=ch;else if(this.isExpOperator(ch)&&peekCh&&this.isNumber(peekCh)&&"e"==number.charAt(number.length-1))number+=ch;else{if(!this.isExpOperator(ch)||peekCh&&this.isNumber(peekCh)||"e"!=number.charAt(number.length-1))break;this.throwError("Invalid exponent")}}this.index++}this.tokens.push({index:start,text:number,constant:!0,value:Number(number)})},readIdent:function(){for(var start=this.index;this.index<this.text.length;){var ch=this.text.charAt(this.index);if(!this.isIdent(ch)&&!this.isNumber(ch))break;this.index++}this.tokens.push({index:start,text:this.text.slice(start,this.index),identifier:!0})},readString:function(quote){var start=this.index;this.index++;for(var string="",rawString=quote,escape=!1;this.index<this.text.length;){var ch=this.text.charAt(this.index);if(rawString+=ch,escape){if("u"===ch){var hex=this.text.substring(this.index+1,this.index+5);hex.match(/[\da-f]{4}/i)||this.throwError("Invalid unicode escape [\\u"+hex+"]"),this.index+=4,string+=String.fromCharCode(parseInt(hex,16))}else string+=ESCAPE[ch]||ch;escape=!1}else if("\\"===ch)escape=!0;else{if(ch===quote)return this.index++,void this.tokens.push({index:start,text:rawString,constant:!0,value:string});string+=ch}this.index++}this.throwError("Unterminated quote",start)}};var AST=function(lexer,options){this.lexer=lexer,this.options=options};AST.Program="Program",AST.ExpressionStatement="ExpressionStatement",AST.AssignmentExpression="AssignmentExpression",AST.ConditionalExpression="ConditionalExpression",AST.LogicalExpression="LogicalExpression",AST.BinaryExpression="BinaryExpression",AST.UnaryExpression="UnaryExpression",AST.CallExpression="CallExpression",AST.MemberExpression="MemberExpression",AST.Identifier="Identifier",AST.Literal="Literal",AST.ArrayExpression="ArrayExpression",AST.Property="Property",AST.ObjectExpression="ObjectExpression",AST.ThisExpression="ThisExpression",AST.NGValueParameter="NGValueParameter",AST.prototype={ast:function(text){this.text=text,this.tokens=this.lexer.lex(text);var value=this.program();return 0!==this.tokens.length&&this.throwError("is an unexpected token",this.tokens[0]),value},program:function(){for(var body=[];;)if(this.tokens.length>0&&!this.peek("}",")",";","]")&&body.push(this.expressionStatement()),!this.expect(";"))return{type:AST.Program,body:body}},expressionStatement:function(){return{type:AST.ExpressionStatement,expression:this.filterChain()}},filterChain:function(){for(var left=this.expression();this.expect("|");)left=this.filter(left);return left},expression:function(){return this.assignment()},assignment:function(){var result=this.ternary();return this.expect("=")&&(result={type:AST.AssignmentExpression,left:result,right:this.assignment(),operator:"="}),result},ternary:function(){var alternate,consequent,test=this.logicalOR();return this.expect("?")&&(alternate=this.expression(),this.consume(":"))?(consequent=this.expression(),{type:AST.ConditionalExpression,test:test,alternate:alternate,consequent:consequent}):test},logicalOR:function(){for(var left=this.logicalAND();this.expect("||");)left={type:AST.LogicalExpression,operator:"||",left:left,right:this.logicalAND()};return left},logicalAND:function(){for(var left=this.equality();this.expect("&&");)left={type:AST.LogicalExpression,operator:"&&",left:left,right:this.equality()};return left},equality:function(){for(var token,left=this.relational();token=this.expect("==","!=","===","!==");)left={type:AST.BinaryExpression,operator:token.text,left:left,right:this.relational()};return left},relational:function(){for(var token,left=this.additive();token=this.expect("<",">","<=",">=");)left={type:AST.BinaryExpression,operator:token.text,left:left,right:this.additive()};return left},additive:function(){for(var token,left=this.multiplicative();token=this.expect("+","-");)left={type:AST.BinaryExpression,operator:token.text,left:left,right:this.multiplicative()};return left},multiplicative:function(){for(var token,left=this.unary();token=this.expect("*","/","%");)left={type:AST.BinaryExpression,operator:token.text,left:left,right:this.unary()};return left},unary:function(){var token;return(token=this.expect("+","-","!"))?{type:AST.UnaryExpression,operator:token.text,prefix:!0,argument:this.unary()}:this.primary()},primary:function(){var primary;this.expect("(")?(primary=this.filterChain(),this.consume(")")):this.expect("[")?primary=this.arrayDeclaration():this.expect("{")?primary=this.object():this.constants.hasOwnProperty(this.peek().text)?primary=copy(this.constants[this.consume().text]):this.peek().identifier?primary=this.identifier():this.peek().constant?primary=this.constant():this.throwError("not a primary expression",this.peek());for(var next;next=this.expect("(","[",".");)"("===next.text?(primary={type:AST.CallExpression,callee:primary,arguments:this.parseArguments()},this.consume(")")):"["===next.text?(primary={type:AST.MemberExpression,object:primary,property:this.expression(),computed:!0},this.consume("]")):"."===next.text?primary={type:AST.MemberExpression,object:primary,property:this.identifier(),computed:!1}:this.throwError("IMPOSSIBLE");return primary},filter:function(baseExpression){for(var args=[baseExpression],result={type:AST.CallExpression,callee:this.identifier(),arguments:args,filter:!0};this.expect(":");)args.push(this.expression());return result},parseArguments:function(){var args=[];if(")"!==this.peekToken().text)do{args.push(this.expression())}while(this.expect(","));return args},identifier:function(){var token=this.consume();return token.identifier||this.throwError("is not a valid identifier",token),{type:AST.Identifier,name:token.text}},constant:function(){return{type:AST.Literal,value:this.consume().value}},arrayDeclaration:function(){var elements=[];if("]"!==this.peekToken().text)do{if(this.peek("]"))break;elements.push(this.expression())}while(this.expect(","));return this.consume("]"),{type:AST.ArrayExpression,elements:elements}},object:function(){var property,properties=[];if("}"!==this.peekToken().text)do{if(this.peek("}"))break;property={type:AST.Property,kind:"init"},this.peek().constant?property.key=this.constant():this.peek().identifier?property.key=this.identifier():this.throwError("invalid key",this.peek()),this.consume(":"),property.value=this.expression(),properties.push(property)}while(this.expect(","));return this.consume("}"),{type:AST.ObjectExpression,properties:properties}},throwError:function(msg,token){throw $parseMinErr("syntax","Syntax Error: Token '{0}' {1} at column {2} of the expression [{3}] starting at [{4}].",token.text,msg,token.index+1,this.text,this.text.substring(token.index))},consume:function(e1){if(0===this.tokens.length)throw $parseMinErr("ueoe","Unexpected end of expression: {0}",this.text);var token=this.expect(e1);return token||this.throwError("is unexpected, expecting ["+e1+"]",this.peek()),token},peekToken:function(){if(0===this.tokens.length)throw $parseMinErr("ueoe","Unexpected end of expression: {0}",this.text);return this.tokens[0]},peek:function(e1,e2,e3,e4){return this.peekAhead(0,e1,e2,e3,e4)},peekAhead:function(i,e1,e2,e3,e4){if(this.tokens.length>i){var token=this.tokens[i],t=token.text;if(t===e1||t===e2||t===e3||t===e4||!e1&&!e2&&!e3&&!e4)return token}return!1},expect:function(e1,e2,e3,e4){var token=this.peek(e1,e2,e3,e4);return!!token&&(this.tokens.shift(),token)},constants:{true:{type:AST.Literal,value:!0},false:{type:AST.Literal,value:!1},null:{type:AST.Literal,value:null},undefined:{type:AST.Literal,value:undefined},this:{type:AST.ThisExpression}}},ASTCompiler.prototype={compile:function(expression,expensiveChecks){var self=this,ast=this.astBuilder.ast(expression);this.state={nextId:0,filters:{},expensiveChecks:expensiveChecks,fn:{vars:[],body:[],own:{}},assign:{vars:[],body:[],own:{}},inputs:[]},findConstantAndWatchExpressions(ast,self.$filter);var assignable,extra="";if(this.stage="assign",assignable=assignableAST(ast)){this.state.computing="assign";var result=this.nextId();this.recurse(assignable,result),extra="fn.assign="+this.generateFunction("assign","s,v,l")}var toWatch=getInputs(ast.body);self.stage="inputs",forEach(toWatch,function(watch,key){var fnKey="fn"+key;self.state[fnKey]={vars:[],body:[],own:{}},self.state.computing=fnKey;var intoId=self.nextId();self.recurse(watch,intoId),self.return_(intoId),self.state.inputs.push(fnKey),watch.watchId=key}),this.state.computing="fn",this.stage="main",this.recurse(ast);var fnString='"'+this.USE+" "+this.STRICT+'";\n'+this.filterPrefix()+"var fn="+this.generateFunction("fn","s,l,a,i")+extra+this.watchFns()+"return fn;",fn=new Function("$filter","ensureSafeMemberName","ensureSafeObject","ensureSafeFunction","ifDefined","plus","text",fnString)(this.$filter,ensureSafeMemberName,ensureSafeObject,ensureSafeFunction,ifDefined,plusFn,expression);return this.state=this.stage=undefined,fn.literal=isLiteral(ast),fn.constant=isConstant(ast),fn},USE:"use",STRICT:"strict",watchFns:function(){var result=[],fns=this.state.inputs,self=this;return forEach(fns,function(name){result.push("var "+name+"="+self.generateFunction(name,"s"))}),fns.length&&result.push("fn.inputs=["+fns.join(",")+"];"),result.join("")},generateFunction:function(name,params){return"function("+params+"){"+this.varsPrefix(name)+this.body(name)+"};"},filterPrefix:function(){var parts=[],self=this;return forEach(this.state.filters,function(id,filter){parts.push(id+"=$filter("+self.escape(filter)+")")}),parts.length?"var "+parts.join(",")+";":""},varsPrefix:function(section){return this.state[section].vars.length?"var "+this.state[section].vars.join(",")+";":""},body:function(section){return this.state[section].body.join("")},recurse:function(ast,intoId,nameId,recursionFn,create,skipWatchIdCheck){var left,right,args,expression,self=this;if(recursionFn=recursionFn||noop,!skipWatchIdCheck&&isDefined(ast.watchId))return intoId=intoId||this.nextId(),void this.if_("i",this.lazyAssign(intoId,this.computedMember("i",ast.watchId)),this.lazyRecurse(ast,intoId,nameId,recursionFn,create,!0));switch(ast.type){case AST.Program:forEach(ast.body,function(expression,pos){self.recurse(expression.expression,undefined,undefined,function(expr){right=expr}),pos!==ast.body.length-1?self.current().body.push(right,";"):self.return_(right)});break;case AST.Literal:expression=this.escape(ast.value),this.assign(intoId,expression),recursionFn(expression);break;case AST.UnaryExpression:this.recurse(ast.argument,undefined,undefined,function(expr){right=expr}),expression=ast.operator+"("+this.ifDefined(right,0)+")",this.assign(intoId,expression),recursionFn(expression);break;case AST.BinaryExpression:this.recurse(ast.left,undefined,undefined,function(expr){left=expr}),this.recurse(ast.right,undefined,undefined,function(expr){right=expr}),expression="+"===ast.operator?this.plus(left,right):"-"===ast.operator?this.ifDefined(left,0)+ast.operator+this.ifDefined(right,0):"("+left+")"+ast.operator+"("+right+")",this.assign(intoId,expression),recursionFn(expression);break;case AST.LogicalExpression:intoId=intoId||this.nextId(),self.recurse(ast.left,intoId),self.if_("&&"===ast.operator?intoId:self.not(intoId),self.lazyRecurse(ast.right,intoId)),recursionFn(intoId);break;case AST.ConditionalExpression:intoId=intoId||this.nextId(),self.recurse(ast.test,intoId),self.if_(intoId,self.lazyRecurse(ast.alternate,intoId),self.lazyRecurse(ast.consequent,intoId)),recursionFn(intoId);break;case AST.Identifier:intoId=intoId||this.nextId(),nameId&&(nameId.context="inputs"===self.stage?"s":this.assign(this.nextId(),this.getHasOwnProperty("l",ast.name)+"?l:s"),nameId.computed=!1,nameId.name=ast.name),ensureSafeMemberName(ast.name),self.if_("inputs"===self.stage||self.not(self.getHasOwnProperty("l",ast.name)),function(){self.if_("inputs"===self.stage||"s",function(){create&&1!==create&&self.if_(self.not(self.nonComputedMember("s",ast.name)),self.lazyAssign(self.nonComputedMember("s",ast.name),"{}")),self.assign(intoId,self.nonComputedMember("s",ast.name))})},intoId&&self.lazyAssign(intoId,self.nonComputedMember("l",ast.name))),(self.state.expensiveChecks||isPossiblyDangerousMemberName(ast.name))&&self.addEnsureSafeObject(intoId),recursionFn(intoId);break;case AST.MemberExpression:left=nameId&&(nameId.context=this.nextId())||this.nextId(),intoId=intoId||this.nextId(),self.recurse(ast.object,left,undefined,function(){self.if_(self.notNull(left),function(){ast.computed?(right=self.nextId(),self.recurse(ast.property,right),self.addEnsureSafeMemberName(right),create&&1!==create&&self.if_(self.not(self.computedMember(left,right)),self.lazyAssign(self.computedMember(left,right),"{}")),expression=self.ensureSafeObject(self.computedMember(left,right)),self.assign(intoId,expression),nameId&&(nameId.computed=!0,nameId.name=right)):(ensureSafeMemberName(ast.property.name),create&&1!==create&&self.if_(self.not(self.nonComputedMember(left,ast.property.name)),self.lazyAssign(self.nonComputedMember(left,ast.property.name),"{}")),expression=self.nonComputedMember(left,ast.property.name),(self.state.expensiveChecks||isPossiblyDangerousMemberName(ast.property.name))&&(expression=self.ensureSafeObject(expression)),self.assign(intoId,expression),nameId&&(nameId.computed=!1,nameId.name=ast.property.name))},function(){self.assign(intoId,"undefined")}),recursionFn(intoId)},!!create);break;case AST.CallExpression:intoId=intoId||this.nextId(),ast.filter?(right=self.filter(ast.callee.name),args=[],forEach(ast.arguments,function(expr){var argument=self.nextId();self.recurse(expr,argument),args.push(argument)}),expression=right+"("+args.join(",")+")",self.assign(intoId,expression),recursionFn(intoId)):(right=self.nextId(),left={},args=[],self.recurse(ast.callee,right,left,function(){self.if_(self.notNull(right),function(){self.addEnsureSafeFunction(right),forEach(ast.arguments,function(expr){self.recurse(expr,self.nextId(),undefined,function(argument){args.push(self.ensureSafeObject(argument))})}),left.name?(self.state.expensiveChecks||self.addEnsureSafeObject(left.context),expression=self.member(left.context,left.name,left.computed)+"("+args.join(",")+")"):expression=right+"("+args.join(",")+")",expression=self.ensureSafeObject(expression),self.assign(intoId,expression)},function(){self.assign(intoId,"undefined")}),recursionFn(intoId)}));break;case AST.AssignmentExpression:if(right=this.nextId(),left={},!isAssignable(ast.left))throw $parseMinErr("lval","Trying to assing a value to a non l-value");this.recurse(ast.left,undefined,left,function(){self.if_(self.notNull(left.context),function(){self.recurse(ast.right,right),self.addEnsureSafeObject(self.member(left.context,left.name,left.computed)),expression=self.member(left.context,left.name,left.computed)+ast.operator+right,self.assign(intoId,expression),recursionFn(intoId||expression)})},1);break;case AST.ArrayExpression:args=[],forEach(ast.elements,function(expr){self.recurse(expr,self.nextId(),undefined,function(argument){args.push(argument)})}),expression="["+args.join(",")+"]",this.assign(intoId,expression),recursionFn(expression);break;case AST.ObjectExpression:args=[],forEach(ast.properties,function(property){self.recurse(property.value,self.nextId(),undefined,function(expr){args.push(self.escape(property.key.type===AST.Identifier?property.key.name:""+property.key.value)+":"+expr)})}),expression="{"+args.join(",")+"}",this.assign(intoId,expression),recursionFn(expression);break;case AST.ThisExpression:this.assign(intoId,"s"),recursionFn("s");break;case AST.NGValueParameter:this.assign(intoId,"v"),recursionFn("v")}},getHasOwnProperty:function(element,property){var key=element+"."+property,own=this.current().own;return own.hasOwnProperty(key)||(own[key]=this.nextId(!1,element+"&&("+this.escape(property)+" in "+element+")")),own[key]},assign:function(id,value){if(id)return this.current().body.push(id,"=",value,";"),id},filter:function(filterName){return this.state.filters.hasOwnProperty(filterName)||(this.state.filters[filterName]=this.nextId(!0)),this.state.filters[filterName]},ifDefined:function(id,defaultValue){return"ifDefined("+id+","+this.escape(defaultValue)+")"},plus:function(left,right){return"plus("+left+","+right+")"},return_:function(id){this.current().body.push("return ",id,";")},if_:function(test,alternate,consequent){if(!0===test)alternate();else{var body=this.current().body;body.push("if(",test,"){"),alternate(),body.push("}"),consequent&&(body.push("else{"),consequent(),body.push("}"))}},not:function(expression){return"!("+expression+")"},notNull:function(expression){return expression+"!=null"},nonComputedMember:function(left,right){return left+"."+right},computedMember:function(left,right){return left+"["+right+"]"},member:function(left,right,computed){return computed?this.computedMember(left,right):this.nonComputedMember(left,right)},addEnsureSafeObject:function(item){this.current().body.push(this.ensureSafeObject(item),";")},addEnsureSafeMemberName:function(item){this.current().body.push(this.ensureSafeMemberName(item),";")},addEnsureSafeFunction:function(item){this.current().body.push(this.ensureSafeFunction(item),";")},ensureSafeObject:function(item){return"ensureSafeObject("+item+",text)"},ensureSafeMemberName:function(item){return"ensureSafeMemberName("+item+",text)"},ensureSafeFunction:function(item){return"ensureSafeFunction("+item+",text)"},lazyRecurse:function(ast,intoId,nameId,recursionFn,create,skipWatchIdCheck){var self=this;return function(){self.recurse(ast,intoId,nameId,recursionFn,create,skipWatchIdCheck)}},lazyAssign:function(id,value){var self=this;return function(){self.assign(id,value)}},stringEscapeRegex:/[^ a-zA-Z0-9]/g,stringEscapeFn:function(c){return"\\u"+("0000"+c.charCodeAt(0).toString(16)).slice(-4)},escape:function(value){if(isString(value))return"'"+value.replace(this.stringEscapeRegex,this.stringEscapeFn)+"'";if(isNumber(value))return value.toString();if(!0===value)return"true";if(!1===value)return"false";if(null===value)return"null";if(void 0===value)return"undefined";throw $parseMinErr("esc","IMPOSSIBLE")},nextId:function(skip,init){var id="v"+this.state.nextId++;return skip||this.current().vars.push(id+(init?"="+init:"")),id},current:function(){return this.state[this.state.computing]}},ASTInterpreter.prototype={compile:function(expression,expensiveChecks){var self=this,ast=this.astBuilder.ast(expression);this.expression=expression,this.expensiveChecks=expensiveChecks,findConstantAndWatchExpressions(ast,self.$filter);var assignable,assign;(assignable=assignableAST(ast))&&(assign=this.recurse(assignable));var inputs,toWatch=getInputs(ast.body);toWatch&&(inputs=[],forEach(toWatch,function(watch,key){var input=self.recurse(watch);watch.input=input,inputs.push(input),watch.watchId=key}));var expressions=[];forEach(ast.body,function(expression){expressions.push(self.recurse(expression.expression))});var fn=0===ast.body.length?function(){}:1===ast.body.length?expressions[0]:function(scope,locals){var lastValue;return forEach(expressions,function(exp){lastValue=exp(scope,locals)}),lastValue};return assign&&(fn.assign=function(scope,value,locals){return assign(scope,locals,value)}),inputs&&(fn.inputs=inputs),fn.literal=isLiteral(ast),fn.constant=isConstant(ast),fn},recurse:function(ast,context,create){var left,right,args,self=this;if(ast.input)return this.inputs(ast.input,ast.watchId);switch(ast.type){case AST.Literal:return this.value(ast.value,context);case AST.UnaryExpression:return right=this.recurse(ast.argument),this["unary"+ast.operator](right,context);case AST.BinaryExpression:case AST.LogicalExpression:return left=this.recurse(ast.left),right=this.recurse(ast.right),this["binary"+ast.operator](left,right,context);case AST.ConditionalExpression:return this["ternary?:"](this.recurse(ast.test),this.recurse(ast.alternate),this.recurse(ast.consequent),context);case AST.Identifier:return ensureSafeMemberName(ast.name,self.expression),self.identifier(ast.name,self.expensiveChecks||isPossiblyDangerousMemberName(ast.name),context,create,self.expression);case AST.MemberExpression:return left=this.recurse(ast.object,!1,!!create),ast.computed||(ensureSafeMemberName(ast.property.name,self.expression),right=ast.property.name),ast.computed&&(right=this.recurse(ast.property)),ast.computed?this.computedMember(left,right,context,create,self.expression):this.nonComputedMember(left,right,self.expensiveChecks,context,create,self.expression);case AST.CallExpression:return args=[],forEach(ast.arguments,function(expr){args.push(self.recurse(expr))}),ast.filter&&(right=this.$filter(ast.callee.name)),ast.filter||(right=this.recurse(ast.callee,!0)),ast.filter?function(scope,locals,assign,inputs){for(var values=[],i=0;i<args.length;++i)values.push(args[i](scope,locals,assign,inputs));var value=right.apply(undefined,values,inputs);return context?{context:undefined,name:undefined,value:value}:value}:function(scope,locals,assign,inputs){var value,rhs=right(scope,locals,assign,inputs);if(null!=rhs.value){ensureSafeObject(rhs.context,self.expression),ensureSafeFunction(rhs.value,self.expression);for(var values=[],i=0;i<args.length;++i)values.push(ensureSafeObject(args[i](scope,locals,assign,inputs),self.expression));value=ensureSafeObject(rhs.value.apply(rhs.context,values),self.expression)}return context?{value:value}:value};case AST.AssignmentExpression:return left=this.recurse(ast.left,!0,1),right=this.recurse(ast.right),function(scope,locals,assign,inputs){var lhs=left(scope,locals,assign,inputs),rhs=right(scope,locals,assign,inputs);return ensureSafeObject(lhs.value,self.expression),lhs.context[lhs.name]=rhs,context?{value:rhs}:rhs};case AST.ArrayExpression:return args=[],forEach(ast.elements,function(expr){args.push(self.recurse(expr))}),function(scope,locals,assign,inputs){for(var value=[],i=0;i<args.length;++i)value.push(args[i](scope,locals,assign,inputs));return context?{value:value}:value};case AST.ObjectExpression:return args=[],forEach(ast.properties,function(property){args.push({key:property.key.type===AST.Identifier?property.key.name:""+property.key.value,value:self.recurse(property.value)})}),function(scope,locals,assign,inputs){for(var value={},i=0;i<args.length;++i)value[args[i].key]=args[i].value(scope,locals,assign,inputs);return context?{value:value}:value};case AST.ThisExpression:return function(scope){return context?{value:scope}:scope};case AST.NGValueParameter:return function(scope,locals,assign,inputs){return context?{value:assign}:assign}}},"unary+":function(argument,context){return function(scope,locals,assign,inputs){var arg=argument(scope,locals,assign,inputs);return arg=isDefined(arg)?+arg:0,context?{value:arg}:arg}},"unary-":function(argument,context){return function(scope,locals,assign,inputs){var arg=argument(scope,locals,assign,inputs);return arg=isDefined(arg)?-arg:0,context?{value:arg}:arg}},"unary!":function(argument,context){return function(scope,locals,assign,inputs){var arg=!argument(scope,locals,assign,inputs);return context?{value:arg}:arg}},"binary+":function(left,right,context){return function(scope,locals,assign,inputs){var arg=plusFn(left(scope,locals,assign,inputs),right(scope,locals,assign,inputs));return context?{value:arg}:arg}},"binary-":function(left,right,context){return function(scope,locals,assign,inputs){var lhs=left(scope,locals,assign,inputs),rhs=right(scope,locals,assign,inputs),arg=(isDefined(lhs)?lhs:0)-(isDefined(rhs)?rhs:0);return context?{value:arg}:arg}},"binary*":function(left,right,context){return function(scope,locals,assign,inputs){var arg=left(scope,locals,assign,inputs)*right(scope,locals,assign,inputs);return context?{value:arg}:arg}},"binary/":function(left,right,context){return function(scope,locals,assign,inputs){var arg=left(scope,locals,assign,inputs)/right(scope,locals,assign,inputs);return context?{value:arg}:arg}},"binary%":function(left,right,context){return function(scope,locals,assign,inputs){var arg=left(scope,locals,assign,inputs)%right(scope,locals,assign,inputs);return context?{value:arg}:arg}},"binary===":function(left,right,context){return function(scope,locals,assign,inputs){var arg=left(scope,locals,assign,inputs)===right(scope,locals,assign,inputs);return context?{value:arg}:arg}},"binary!==":function(left,right,context){return function(scope,locals,assign,inputs){var arg=left(scope,locals,assign,inputs)!==right(scope,locals,assign,inputs);return context?{value:arg}:arg}},"binary==":function(left,right,context){return function(scope,locals,assign,inputs){var arg=left(scope,locals,assign,inputs)==right(scope,locals,assign,inputs);return context?{value:arg}:arg}},"binary!=":function(left,right,context){return function(scope,locals,assign,inputs){var arg=left(scope,locals,assign,inputs)!=right(scope,locals,assign,inputs);return context?{value:arg}:arg}},"binary<":function(left,right,context){return function(scope,locals,assign,inputs){var arg=left(scope,locals,assign,inputs)<right(scope,locals,assign,inputs);return context?{value:arg}:arg}},"binary>":function(left,right,context){return function(scope,locals,assign,inputs){var arg=left(scope,locals,assign,inputs)>right(scope,locals,assign,inputs);return context?{value:arg}:arg}},"binary<=":function(left,right,context){return function(scope,locals,assign,inputs){var arg=left(scope,locals,assign,inputs)<=right(scope,locals,assign,inputs);return context?{value:arg}:arg}},"binary>=":function(left,right,context){return function(scope,locals,assign,inputs){var arg=left(scope,locals,assign,inputs)>=right(scope,locals,assign,inputs);return context?{value:arg}:arg}},"binary&&":function(left,right,context){return function(scope,locals,assign,inputs){var arg=left(scope,locals,assign,inputs)&&right(scope,locals,assign,inputs);return context?{value:arg}:arg}},"binary||":function(left,right,context){return function(scope,locals,assign,inputs){var arg=left(scope,locals,assign,inputs)||right(scope,locals,assign,inputs);return context?{value:arg}:arg}},"ternary?:":function(test,alternate,consequent,context){return function(scope,locals,assign,inputs){var arg=test(scope,locals,assign,inputs)?alternate(scope,locals,assign,inputs):consequent(scope,locals,assign,inputs);return context?{value:arg}:arg}},value:function(value,context){return function(){return context?{context:undefined,name:undefined,value:value}:value}},identifier:function(name,expensiveChecks,context,create,expression){return function(scope,locals,assign,inputs){var base=locals&&name in locals?locals:scope;create&&1!==create&&base&&!base[name]&&(base[name]={});var value=base?base[name]:undefined;return expensiveChecks&&ensureSafeObject(value,expression),context?{context:base,name:name,value:value}:value}},computedMember:function(left,right,context,create,expression){return function(scope,locals,assign,inputs){var rhs,value,lhs=left(scope,locals,assign,inputs);return null!=lhs&&(ensureSafeMemberName(rhs=right(scope,locals,assign,inputs),expression),create&&1!==create&&lhs&&!lhs[rhs]&&(lhs[rhs]={}),ensureSafeObject(value=lhs[rhs],expression)),context?{context:lhs,name:rhs,value:value}:value}},nonComputedMember:function(left,right,expensiveChecks,context,create,expression){return function(scope,locals,assign,inputs){var lhs=left(scope,locals,assign,inputs);create&&1!==create&&lhs&&!lhs[right]&&(lhs[right]={});var value=null!=lhs?lhs[right]:undefined;return(expensiveChecks||isPossiblyDangerousMemberName(right))&&ensureSafeObject(value,expression),context?{context:lhs,name:right,value:value}:value}},inputs:function(input,watchId){return function(scope,value,locals,inputs){return inputs?inputs[watchId]:input(scope,value,locals)}}};var Parser=function(lexer,$filter,options){this.lexer=lexer,this.$filter=$filter,this.options=options,this.ast=new AST(this.lexer),this.astCompiler=options.csp?new ASTInterpreter(this.ast,$filter):new ASTCompiler(this.ast,$filter)};Parser.prototype={constructor:Parser,parse:function(text){return this.astCompiler.compile(text,this.options.expensiveChecks)}};createMap(),createMap();var objectValueOf=Object.prototype.valueOf,$sceMinErr=minErr("$sce"),SCE_CONTEXTS={HTML:"html",CSS:"css",URL:"url",RESOURCE_URL:"resourceUrl",JS:"js"},$compileMinErr=minErr("$compile"),urlParsingNode=document.createElement("a"),originUrl=urlResolve(window.location.href);$$CookieReader.$inject=["$document"],$FilterProvider.$inject=["$provide"],currencyFilter.$inject=["$locale"],numberFilter.$inject=["$locale"];var DECIMAL_SEP=".",DATE_FORMATS={yyyy:dateGetter("FullYear",4),yy:dateGetter("FullYear",2,0,!0),y:dateGetter("FullYear",1),MMMM:dateStrGetter("Month"),MMM:dateStrGetter("Month",!0),MM:dateGetter("Month",2,1),M:dateGetter("Month",1,1),dd:dateGetter("Date",2),d:dateGetter("Date",1),HH:dateGetter("Hours",2),H:dateGetter("Hours",1),hh:dateGetter("Hours",2,-12),h:dateGetter("Hours",1,-12),mm:dateGetter("Minutes",2),m:dateGetter("Minutes",1),ss:dateGetter("Seconds",2),s:dateGetter("Seconds",1),sss:dateGetter("Milliseconds",3),EEEE:dateStrGetter("Day"),EEE:dateStrGetter("Day",!0),a:function(date,formats){return date.getHours()<12?formats.AMPMS[0]:formats.AMPMS[1]},Z:function(date,formats,offset){var zone=-1*offset,paddedZone=zone>=0?"+":"";return paddedZone+=padNumber(Math[zone>0?"floor":"ceil"](zone/60),2)+padNumber(Math.abs(zone%60),2)},ww:weekGetter(2),w:weekGetter(1),G:eraGetter,GG:eraGetter,GGG:eraGetter,GGGG:function(date,formats){return date.getFullYear()<=0?formats.ERANAMES[0]:formats.ERANAMES[1]}},DATE_FORMATS_SPLIT=/((?:[^yMdHhmsaZEwG']+)|(?:'(?:[^']|'')*')|(?:E+|y+|M+|d+|H+|h+|m+|s+|a|Z|G+|w+))(.*)/,NUMBER_STRING=/^\-?\d+$/;dateFilter.$inject=["$locale"];var lowercaseFilter=valueFn(lowercase),uppercaseFilter=valueFn(uppercase);orderByFilter.$inject=["$parse"];var htmlAnchorDirective=valueFn({restrict:"E",compile:function(element,attr){if(!attr.href&&!attr.xlinkHref)return function(scope,element){if("a"===element[0].nodeName.toLowerCase()){var href="[object SVGAnimatedString]"===toString.call(element.prop("href"))?"xlink:href":"href";element.on("click",function(event){element.attr(href)||event.preventDefault()})}}}}),ngAttributeAliasDirectives={};forEach(BOOLEAN_ATTR,function(propName,attrName){function defaultLinkFn(scope,element,attr){scope.$watch(attr[normalized],function(value){attr.$set(attrName,!!value)})}if("multiple"!=propName){var normalized=directiveNormalize("ng-"+attrName),linkFn=defaultLinkFn;"checked"===propName&&(linkFn=function(scope,element,attr){attr.ngModel!==attr[normalized]&&defaultLinkFn(scope,0,attr)}),ngAttributeAliasDirectives[normalized]=function(){return{restrict:"A",priority:100,link:linkFn}}}}),forEach(ALIASED_ATTR,function(htmlAttr,ngAttr){ngAttributeAliasDirectives[ngAttr]=function(){return{priority:100,link:function(scope,element,attr){if("ngPattern"===ngAttr&&"/"==attr.ngPattern.charAt(0)){var match=attr.ngPattern.match(REGEX_STRING_REGEXP);if(match)return void attr.$set("ngPattern",new RegExp(match[1],match[2]))}scope.$watch(attr[ngAttr],function(value){attr.$set(ngAttr,value)})}}}}),forEach(["src","srcset","href"],function(attrName){var normalized=directiveNormalize("ng-"+attrName);ngAttributeAliasDirectives[normalized]=function(){return{priority:99,link:function(scope,element,attr){var propName=attrName,name=attrName;"href"===attrName&&"[object SVGAnimatedString]"===toString.call(element.prop("href"))&&(name="xlinkHref",attr.$attr[name]="xlink:href",propName=null),attr.$observe(normalized,function(value){value?(attr.$set(name,value),msie&&propName&&element.prop(propName,attr[name])):"href"===attrName&&attr.$set(name,null)})}}}});var nullFormCtrl={$addControl:noop,$$renameControl:function(control,name){control.$name=name},$removeControl:noop,$setValidity:noop,$setDirty:noop,$setPristine:noop,$setSubmitted:noop},SUBMITTED_CLASS="ng-submitted";FormController.$inject=["$element","$attrs","$scope","$animate","$interpolate"];var formDirectiveFactory=function(isNgForm){return["$timeout",function($timeout){return{name:"form",restrict:isNgForm?"EAC":"E",controller:FormController,compile:function(formElement,attr){formElement.addClass(PRISTINE_CLASS).addClass(VALID_CLASS);var nameAttr=attr.name?"name":!(!isNgForm||!attr.ngForm)&&"ngForm";return{pre:function(scope,formElement,attr,controller){if(!("action"in attr)){var handleFormSubmission=function(event){scope.$apply(function(){controller.$commitViewValue(),controller.$setSubmitted()}),event.preventDefault()};addEventListenerFn(formElement[0],"submit",handleFormSubmission),formElement.on("$destroy",function(){$timeout(function(){removeEventListenerFn(formElement[0],"submit",handleFormSubmission)},0,!1)})}var parentFormCtrl=controller.$$parentForm;nameAttr&&(setter(scope,controller.$name,controller,controller.$name),attr.$observe(nameAttr,function(newValue){controller.$name!==newValue&&(setter(scope,controller.$name,undefined,controller.$name),parentFormCtrl.$$renameControl(controller,newValue),setter(scope,controller.$name,controller,controller.$name))})),formElement.on("$destroy",function(){parentFormCtrl.$removeControl(controller),nameAttr&&setter(scope,attr[nameAttr],undefined,controller.$name),extend(controller,nullFormCtrl)})}}}}}]},formDirective=formDirectiveFactory(),ngFormDirective=formDirectiveFactory(!0),ISO_DATE_REGEXP=/\d{4}-[01]\d-[0-3]\dT[0-2]\d:[0-5]\d:[0-5]\d\.\d+([+-][0-2]\d:[0-5]\d|Z)/,URL_REGEXP=/^(ftp|http|https):\/\/(\w+:{0,1}\w*@)?(\S+)(:[0-9]+)?(\/|\/([\w#!:.?+=&%@!\-\/]))?$/,EMAIL_REGEXP=/^[a-z0-9!#$%&'*+\/=?^_`{|}~.-]+@[a-z0-9]([a-z0-9-]*[a-z0-9])?(\.[a-z0-9]([a-z0-9-]*[a-z0-9])?)*$/i,NUMBER_REGEXP=/^\s*(\-|\+)?(\d+|(\d*(\.\d*)))([eE][+-]?\d+)?\s*$/,DATE_REGEXP=/^(\d{4})-(\d{2})-(\d{2})$/,DATETIMELOCAL_REGEXP=/^(\d{4})-(\d\d)-(\d\d)T(\d\d):(\d\d)(?::(\d\d)(\.\d{1,3})?)?$/,WEEK_REGEXP=/^(\d{4})-W(\d\d)$/,MONTH_REGEXP=/^(\d{4})-(\d\d)$/,TIME_REGEXP=/^(\d\d):(\d\d)(?::(\d\d)(\.\d{1,3})?)?$/,inputType={text:function(scope,element,attr,ctrl,$sniffer,$browser){baseInputType(scope,element,attr,ctrl,$sniffer,$browser),stringBasedInputType(ctrl)},date:createDateInputType("date",DATE_REGEXP,createDateParser(DATE_REGEXP,["yyyy","MM","dd"]),"yyyy-MM-dd"),"datetime-local":createDateInputType("datetimelocal",DATETIMELOCAL_REGEXP,createDateParser(DATETIMELOCAL_REGEXP,["yyyy","MM","dd","HH","mm","ss","sss"]),"yyyy-MM-ddTHH:mm:ss.sss"),time:createDateInputType("time",TIME_REGEXP,createDateParser(TIME_REGEXP,["HH","mm","ss","sss"]),"HH:mm:ss.sss"),week:createDateInputType("week",WEEK_REGEXP,function(isoWeek,existingDate){if(isDate(isoWeek))return isoWeek;if(isString(isoWeek)){WEEK_REGEXP.lastIndex=0;var parts=WEEK_REGEXP.exec(isoWeek);if(parts){var year=+parts[1],week=+parts[2],hours=0,minutes=0,seconds=0,milliseconds=0,firstThurs=getFirstThursdayOfYear(year),addDays=7*(week-1);return existingDate&&(hours=existingDate.getHours(),minutes=existingDate.getMinutes(),seconds=existingDate.getSeconds(),milliseconds=existingDate.getMilliseconds()),new Date(year,0,firstThurs.getDate()+addDays,hours,minutes,seconds,milliseconds)}}return NaN},"yyyy-Www"),month:createDateInputType("month",MONTH_REGEXP,createDateParser(MONTH_REGEXP,["yyyy","MM"]),"yyyy-MM"),number:function(scope,element,attr,ctrl,$sniffer,$browser){if(badInputChecker(scope,element,attr,ctrl),baseInputType(scope,element,attr,ctrl,$sniffer,$browser),ctrl.$$parserName="number",ctrl.$parsers.push(function(value){return ctrl.$isEmpty(value)?null:NUMBER_REGEXP.test(value)?parseFloat(value):undefined}),ctrl.$formatters.push(function(value){if(!ctrl.$isEmpty(value)){if(!isNumber(value))throw $ngModelMinErr("numfmt","Expected `{0}` to be a number",value);value=value.toString()}return value}),isDefined(attr.min)||attr.ngMin){var minVal;ctrl.$validators.min=function(value){return ctrl.$isEmpty(value)||isUndefined(minVal)||value>=minVal},attr.$observe("min",function(val){isDefined(val)&&!isNumber(val)&&(val=parseFloat(val,10)),minVal=isNumber(val)&&!isNaN(val)?val:undefined,ctrl.$validate()})}if(isDefined(attr.max)||attr.ngMax){var maxVal;ctrl.$validators.max=function(value){return ctrl.$isEmpty(value)||isUndefined(maxVal)||value<=maxVal},attr.$observe("max",function(val){isDefined(val)&&!isNumber(val)&&(val=parseFloat(val,10)),maxVal=isNumber(val)&&!isNaN(val)?val:undefined,ctrl.$validate()})}},url:function(scope,element,attr,ctrl,$sniffer,$browser){baseInputType(scope,element,attr,ctrl,$sniffer,$browser),stringBasedInputType(ctrl),ctrl.$$parserName="url",ctrl.$validators.url=function(modelValue,viewValue){var value=modelValue||viewValue;return ctrl.$isEmpty(value)||URL_REGEXP.test(value)}},email:function(scope,element,attr,ctrl,$sniffer,$browser){baseInputType(scope,element,attr,ctrl,$sniffer,$browser),stringBasedInputType(ctrl),ctrl.$$parserName="email",ctrl.$validators.email=function(modelValue,viewValue){var value=modelValue||viewValue;return ctrl.$isEmpty(value)||EMAIL_REGEXP.test(value)}},radio:function(scope,element,attr,ctrl){isUndefined(attr.name)&&element.attr("name",nextUid());element.on("click",function(ev){element[0].checked&&ctrl.$setViewValue(attr.value,ev&&ev.type)}),ctrl.$render=function(){var value=attr.value;element[0].checked=value==ctrl.$viewValue},attr.$observe("value",ctrl.$render)},checkbox:function(scope,element,attr,ctrl,$sniffer,$browser,$filter,$parse){var trueValue=parseConstantExpr($parse,scope,"ngTrueValue",attr.ngTrueValue,!0),falseValue=parseConstantExpr($parse,scope,"ngFalseValue",attr.ngFalseValue,!1);element.on("click",function(ev){ctrl.$setViewValue(element[0].checked,ev&&ev.type)}),ctrl.$render=function(){element[0].checked=ctrl.$viewValue},ctrl.$isEmpty=function(value){return!1===value},ctrl.$formatters.push(function(value){return equals(value,trueValue)}),ctrl.$parsers.push(function(value){return value?trueValue:falseValue})},hidden:noop,button:noop,submit:noop,reset:noop,file:noop},inputDirective=["$browser","$sniffer","$filter","$parse",function($browser,$sniffer,$filter,$parse){return{restrict:"E",require:["?ngModel"],link:{pre:function(scope,element,attr,ctrls){ctrls[0]&&(inputType[lowercase(attr.type)]||inputType.text)(scope,element,attr,ctrls[0],$sniffer,$browser,$filter,$parse)}}}}],CONSTANT_VALUE_REGEXP=/^(true|false|\d+)$/,ngValueDirective=function(){return{restrict:"A",priority:100,compile:function(tpl,tplAttr){return CONSTANT_VALUE_REGEXP.test(tplAttr.ngValue)?function(scope,elm,attr){attr.$set("value",scope.$eval(attr.ngValue))}:function(scope,elm,attr){scope.$watch(attr.ngValue,function(value){attr.$set("value",value)})}}}},ngBindDirective=["$compile",function($compile){return{restrict:"AC",compile:function(templateElement){return $compile.$$addBindingClass(templateElement),function(scope,element,attr){$compile.$$addBindingInfo(element,attr.ngBind),element=element[0],scope.$watch(attr.ngBind,function(value){element.textContent=value===undefined?"":value})}}}}],ngBindTemplateDirective=["$interpolate","$compile",function($interpolate,$compile){return{compile:function(templateElement){return $compile.$$addBindingClass(templateElement),function(scope,element,attr){var interpolateFn=$interpolate(element.attr(attr.$attr.ngBindTemplate));$compile.$$addBindingInfo(element,interpolateFn.expressions),element=element[0],attr.$observe("ngBindTemplate",function(value){element.textContent=value===undefined?"":value})}}}}],ngBindHtmlDirective=["$sce","$parse","$compile",function($sce,$parse,$compile){return{restrict:"A",compile:function(tElement,tAttrs){var ngBindHtmlGetter=$parse(tAttrs.ngBindHtml),ngBindHtmlWatch=$parse(tAttrs.ngBindHtml,function(value){return(value||"").toString()});return $compile.$$addBindingClass(tElement),function(scope,element,attr){$compile.$$addBindingInfo(element,attr.ngBindHtml),scope.$watch(ngBindHtmlWatch,function(){element.html($sce.getTrustedHtml(ngBindHtmlGetter(scope))||"")})}}}}],ngChangeDirective=valueFn({restrict:"A",require:"ngModel",link:function(scope,element,attr,ctrl){ctrl.$viewChangeListeners.push(function(){scope.$eval(attr.ngChange)})}}),ngClassDirective=classDirective("",!0),ngClassOddDirective=classDirective("Odd",0),ngClassEvenDirective=classDirective("Even",1),ngCloakDirective=ngDirective({compile:function(element,attr){attr.$set("ngCloak",undefined),element.removeClass("ng-cloak")}}),ngControllerDirective=[function(){return{restrict:"A",scope:!0,controller:"@",priority:500}}],ngEventDirectives={},forceAsyncEvents={blur:!0,focus:!0};forEach("click dblclick mousedown mouseup mouseover mouseout mousemove mouseenter mouseleave keydown keyup keypress submit focus blur copy cut paste".split(" "),function(eventName){var directiveName=directiveNormalize("ng-"+eventName);ngEventDirectives[directiveName]=["$parse","$rootScope",function($parse,$rootScope){return{restrict:"A",compile:function($element,attr){var fn=$parse(attr[directiveName],null,!0);return function(scope,element){element.on(eventName,function(event){var callback=function(){fn(scope,{$event:event})};forceAsyncEvents[eventName]&&$rootScope.$$phase?scope.$evalAsync(callback):scope.$apply(callback)})}}}}]});var ngIfDirective=["$animate",function($animate){return{multiElement:!0,transclude:"element",priority:600,terminal:!0,restrict:"A",$$tlb:!0,link:function($scope,$element,$attr,ctrl,$transclude){var block,childScope,previousElements;$scope.$watch($attr.ngIf,function(value){value?childScope||$transclude(function(clone,newScope){childScope=newScope,clone[clone.length++]=document.createComment(" end ngIf: "+$attr.ngIf+" "),block={clone:clone},$animate.enter(clone,$element.parent(),$element)}):(previousElements&&(previousElements.remove(),previousElements=null),childScope&&(childScope.$destroy(),childScope=null),block&&(previousElements=getBlockNodes(block.clone),$animate.leave(previousElements).then(function(){previousElements=null}),block=null))})}}}],ngIncludeDirective=["$templateRequest","$anchorScroll","$animate",function($templateRequest,$anchorScroll,$animate){return{restrict:"ECA",priority:400,terminal:!0,transclude:"element",controller:angular.noop,compile:function(element,attr){var srcExp=attr.ngInclude||attr.src,onloadExp=attr.onload||"",autoScrollExp=attr.autoscroll;return function(scope,$element,$attr,ctrl,$transclude){var currentScope,previousElement,currentElement,changeCounter=0,cleanupLastIncludeContent=function(){previousElement&&(previousElement.remove(),previousElement=null),currentScope&&(currentScope.$destroy(),currentScope=null),currentElement&&($animate.leave(currentElement).then(function(){previousElement=null}),previousElement=currentElement,currentElement=null)};scope.$watch(srcExp,function(src){var afterAnimation=function(){!isDefined(autoScrollExp)||autoScrollExp&&!scope.$eval(autoScrollExp)||$anchorScroll()},thisChangeId=++changeCounter;src?($templateRequest(src,!0).then(function(response){if(thisChangeId===changeCounter){var newScope=scope.$new();ctrl.template=response;var clone=$transclude(newScope,function(clone){cleanupLastIncludeContent(),$animate.enter(clone,null,$element).then(afterAnimation)});currentElement=clone,(currentScope=newScope).$emit("$includeContentLoaded",src),scope.$eval(onloadExp)}},function(){thisChangeId===changeCounter&&(cleanupLastIncludeContent(),scope.$emit("$includeContentError",src))}),scope.$emit("$includeContentRequested",src)):(cleanupLastIncludeContent(),ctrl.template=null)})}}}}],ngIncludeFillContentDirective=["$compile",function($compile){return{restrict:"ECA",priority:-400,require:"ngInclude",link:function(scope,$element,$attr,ctrl){if(/SVG/.test($element[0].toString()))return $element.empty(),void $compile(jqLiteBuildFragment(ctrl.template,document).childNodes)(scope,function(clone){$element.append(clone)},{futureParentElement:$element});$element.html(ctrl.template),$compile($element.contents())(scope)}}}],ngInitDirective=ngDirective({priority:450,compile:function(){return{pre:function(scope,element,attrs){scope.$eval(attrs.ngInit)}}}}),ngListDirective=function(){return{restrict:"A",priority:100,require:"ngModel",link:function(scope,element,attr,ctrl){var ngList=element.attr(attr.$attr.ngList)||", ",trimValues="false"!==attr.ngTrim,separator=trimValues?trim(ngList):ngList;ctrl.$parsers.push(function(viewValue){if(!isUndefined(viewValue)){var list=[];return viewValue&&forEach(viewValue.split(separator),function(value){value&&list.push(trimValues?trim(value):value)}),list}}),ctrl.$formatters.push(function(value){return isArray(value)?value.join(ngList):undefined}),ctrl.$isEmpty=function(value){return!value||!value.length}}}},VALID_CLASS="ng-valid",INVALID_CLASS="ng-invalid",PRISTINE_CLASS="ng-pristine",DIRTY_CLASS="ng-dirty",PENDING_CLASS="ng-pending",$ngModelMinErr=new minErr("ngModel"),NgModelController=["$scope","$exceptionHandler","$attrs","$element","$parse","$animate","$timeout","$rootScope","$q","$interpolate",function($scope,$exceptionHandler,$attr,$element,$parse,$animate,$timeout,$rootScope,$q,$interpolate){this.$viewValue=Number.NaN,this.$modelValue=Number.NaN,this.$$rawModelValue=undefined,this.$validators={},this.$asyncValidators={},this.$parsers=[],this.$formatters=[],this.$viewChangeListeners=[],this.$untouched=!0,this.$touched=!1,this.$pristine=!0,this.$dirty=!1,this.$valid=!0,this.$invalid=!1,this.$error={},this.$$success={},this.$pending=undefined,this.$name=$interpolate($attr.name||"",!1)($scope);var parserValid,parsedNgModel=$parse($attr.ngModel),parsedNgModelAssign=parsedNgModel.assign,ngModelGet=parsedNgModel,ngModelSet=parsedNgModelAssign,pendingDebounce=null,ctrl=this;this.$$setOptions=function(options){if(ctrl.$options=options,options&&options.getterSetter){var invokeModelGetter=$parse($attr.ngModel+"()"),invokeModelSetter=$parse($attr.ngModel+"($$$p)");ngModelGet=function($scope){var modelValue=parsedNgModel($scope);return isFunction(modelValue)&&(modelValue=invokeModelGetter($scope)),modelValue},ngModelSet=function($scope,newValue){isFunction(parsedNgModel($scope))?invokeModelSetter($scope,{$$$p:ctrl.$modelValue}):parsedNgModelAssign($scope,ctrl.$modelValue)}}else if(!parsedNgModel.assign)throw $ngModelMinErr("nonassign","Expression '{0}' is non-assignable. Element: {1}",$attr.ngModel,startingTag($element))},this.$render=noop,this.$isEmpty=function(value){return isUndefined(value)||""===value||null===value||value!==value};var parentForm=$element.inheritedData("$formController")||nullFormCtrl,currentValidationRunId=0;addSetValidityMethod({ctrl:this,$element:$element,set:function(object,property){object[property]=!0},unset:function(object,property){delete object[property]},parentForm:parentForm,$animate:$animate}),this.$setPristine=function(){ctrl.$dirty=!1,ctrl.$pristine=!0,$animate.removeClass($element,DIRTY_CLASS),$animate.addClass($element,PRISTINE_CLASS)},this.$setDirty=function(){ctrl.$dirty=!0,ctrl.$pristine=!1,$animate.removeClass($element,PRISTINE_CLASS),$animate.addClass($element,DIRTY_CLASS),parentForm.$setDirty()},this.$setUntouched=function(){ctrl.$touched=!1,ctrl.$untouched=!0,$animate.setClass($element,"ng-untouched","ng-touched")},this.$setTouched=function(){ctrl.$touched=!0,ctrl.$untouched=!1,$animate.setClass($element,"ng-touched","ng-untouched")},this.$rollbackViewValue=function(){$timeout.cancel(pendingDebounce),ctrl.$viewValue=ctrl.$$lastCommittedViewValue,ctrl.$render()},this.$validate=function(){if(!isNumber(ctrl.$modelValue)||!isNaN(ctrl.$modelValue)){var viewValue=ctrl.$$lastCommittedViewValue,modelValue=ctrl.$$rawModelValue,prevValid=ctrl.$valid,prevModelValue=ctrl.$modelValue,allowInvalid=ctrl.$options&&ctrl.$options.allowInvalid;ctrl.$$runValidators(modelValue,viewValue,function(allValid){allowInvalid||prevValid===allValid||(ctrl.$modelValue=allValid?modelValue:undefined,ctrl.$modelValue!==prevModelValue&&ctrl.$$writeModelToScope())})}},this.$$runValidators=function(modelValue,viewValue,doneCallback){function setValidity(name,isValid){localValidationRunId===currentValidationRunId&&ctrl.$setValidity(name,isValid)}function validationDone(allValid){localValidationRunId===currentValidationRunId&&doneCallback(allValid)}var localValidationRunId=++currentValidationRunId;!function(){var errorKey=ctrl.$$parserName||"parse";return parserValid!==undefined?(parserValid||(forEach(ctrl.$validators,function(v,name){setValidity(name,null)}),forEach(ctrl.$asyncValidators,function(v,name){setValidity(name,null)})),setValidity(errorKey,parserValid),parserValid):(setValidity(errorKey,null),!0)}()?validationDone(!1):function(){var syncValidatorsValid=!0;return forEach(ctrl.$validators,function(validator,name){var result=validator(modelValue,viewValue);syncValidatorsValid=syncValidatorsValid&&result,setValidity(name,result)}),!!syncValidatorsValid||(forEach(ctrl.$asyncValidators,function(v,name){setValidity(name,null)}),!1)}()?function(){var validatorPromises=[],allValid=!0;forEach(ctrl.$asyncValidators,function(validator,name){var promise=validator(modelValue,viewValue);if(!isPromiseLike(promise))throw $ngModelMinErr("$asyncValidators","Expected asynchronous validator to return a promise but got '{0}' instead.",promise);setValidity(name,undefined),validatorPromises.push(promise.then(function(){setValidity(name,!0)},function(error){allValid=!1,setValidity(name,!1)}))}),validatorPromises.length?$q.all(validatorPromises).then(function(){validationDone(allValid)},noop):validationDone(!0)}():validationDone(!1)},this.$commitViewValue=function(){var viewValue=ctrl.$viewValue;$timeout.cancel(pendingDebounce),(ctrl.$$lastCommittedViewValue!==viewValue||""===viewValue&&ctrl.$$hasNativeValidators)&&(ctrl.$$lastCommittedViewValue=viewValue,ctrl.$pristine&&this.$setDirty(),this.$$parseAndValidate())},this.$$parseAndValidate=function(){function writeToModelIfNeeded(){ctrl.$modelValue!==prevModelValue&&ctrl.$$writeModelToScope()}var modelValue=ctrl.$$lastCommittedViewValue;if(parserValid=!isUndefined(modelValue)||undefined)for(var i=0;i<ctrl.$parsers.length;i++)if(modelValue=ctrl.$parsers[i](modelValue),isUndefined(modelValue)){parserValid=!1;break}isNumber(ctrl.$modelValue)&&isNaN(ctrl.$modelValue)&&(ctrl.$modelValue=ngModelGet($scope));var prevModelValue=ctrl.$modelValue,allowInvalid=ctrl.$options&&ctrl.$options.allowInvalid;ctrl.$$rawModelValue=modelValue,allowInvalid&&(ctrl.$modelValue=modelValue,writeToModelIfNeeded()),ctrl.$$runValidators(modelValue,ctrl.$$lastCommittedViewValue,function(allValid){allowInvalid||(ctrl.$modelValue=allValid?modelValue:undefined,writeToModelIfNeeded())})},this.$$writeModelToScope=function(){ngModelSet($scope,ctrl.$modelValue),forEach(ctrl.$viewChangeListeners,function(listener){try{listener()}catch(e){$exceptionHandler(e)}})},this.$setViewValue=function(value,trigger){ctrl.$viewValue=value,ctrl.$options&&!ctrl.$options.updateOnDefault||ctrl.$$debounceViewValueCommit(trigger)},this.$$debounceViewValueCommit=function(trigger){var debounce,debounceDelay=0,options=ctrl.$options;options&&isDefined(options.debounce)&&(isNumber(debounce=options.debounce)?debounceDelay=debounce:isNumber(debounce[trigger])?debounceDelay=debounce[trigger]:isNumber(debounce.default)&&(debounceDelay=debounce.default)),$timeout.cancel(pendingDebounce),debounceDelay?pendingDebounce=$timeout(function(){ctrl.$commitViewValue()},debounceDelay):$rootScope.$$phase?ctrl.$commitViewValue():$scope.$apply(function(){ctrl.$commitViewValue()})},$scope.$watch(function(){var modelValue=ngModelGet($scope);if(modelValue!==ctrl.$modelValue&&(ctrl.$modelValue===ctrl.$modelValue||modelValue===modelValue)){ctrl.$modelValue=ctrl.$$rawModelValue=modelValue,parserValid=undefined;for(var formatters=ctrl.$formatters,idx=formatters.length,viewValue=modelValue;idx--;)viewValue=formatters[idx](viewValue);ctrl.$viewValue!==viewValue&&(ctrl.$viewValue=ctrl.$$lastCommittedViewValue=viewValue,ctrl.$render(),ctrl.$$runValidators(modelValue,viewValue,noop))}return modelValue})}],ngModelDirective=["$rootScope",function($rootScope){return{restrict:"A",require:["ngModel","^?form","^?ngModelOptions"],controller:NgModelController,priority:1,compile:function(element){return element.addClass(PRISTINE_CLASS).addClass("ng-untouched").addClass(VALID_CLASS),{pre:function(scope,element,attr,ctrls){var modelCtrl=ctrls[0],formCtrl=ctrls[1]||nullFormCtrl;modelCtrl.$$setOptions(ctrls[2]&&ctrls[2].$options),formCtrl.$addControl(modelCtrl),attr.$observe("name",function(newValue){modelCtrl.$name!==newValue&&formCtrl.$$renameControl(modelCtrl,newValue)}),scope.$on("$destroy",function(){formCtrl.$removeControl(modelCtrl)})},post:function(scope,element,attr,ctrls){var modelCtrl=ctrls[0];modelCtrl.$options&&modelCtrl.$options.updateOn&&element.on(modelCtrl.$options.updateOn,function(ev){modelCtrl.$$debounceViewValueCommit(ev&&ev.type)}),element.on("blur",function(ev){modelCtrl.$touched||($rootScope.$$phase?scope.$evalAsync(modelCtrl.$setTouched):scope.$apply(modelCtrl.$setTouched))})}}}}}],DEFAULT_REGEXP=/(\s+|^)default(\s+|$)/,ngModelOptionsDirective=function(){return{restrict:"A",controller:["$scope","$attrs",function($scope,$attrs){var that=this;this.$options=copy($scope.$eval($attrs.ngModelOptions)),this.$options.updateOn!==undefined?(this.$options.updateOnDefault=!1,this.$options.updateOn=trim(this.$options.updateOn.replace(DEFAULT_REGEXP,function(){return that.$options.updateOnDefault=!0," "}))):this.$options.updateOnDefault=!0}]}},ngNonBindableDirective=ngDirective({terminal:!0,priority:1e3}),ngOptionsMinErr=minErr("ngOptions"),NG_OPTIONS_REGEXP=/^\s*([\s\S]+?)(?:\s+as\s+([\s\S]+?))?(?:\s+group\s+by\s+([\s\S]+?))?(?:\s+disable\s+when\s+([\s\S]+?))?\s+for\s+(?:([\$\w][\$\w]*)|(?:\(\s*([\$\w][\$\w]*)\s*,\s*([\$\w][\$\w]*)\s*\)))\s+in\s+([\s\S]+?)(?:\s+track\s+by\s+([\s\S]+?))?$/,ngOptionsDirective=["$compile","$parse",function($compile,$parse){function parseOptionsExpression(optionsExp,selectElement,scope){function Option(selectValue,viewValue,label,group,disabled){this.selectValue=selectValue,this.viewValue=viewValue,this.label=label,this.group=group,this.disabled=disabled}function getOptionValuesKeys(optionValues){var optionValuesKeys;if(!keyName&&isArrayLike(optionValues))optionValuesKeys=optionValues;else{optionValuesKeys=[];for(var itemKey in optionValues)optionValues.hasOwnProperty(itemKey)&&"$"!==itemKey.charAt(0)&&optionValuesKeys.push(itemKey)}return optionValuesKeys}var match=optionsExp.match(NG_OPTIONS_REGEXP);if(!match)throw ngOptionsMinErr("iexp","Expected expression in form of '_select_ (as _label_)? for (_key_,)?_value_ in _collection_' but got '{0}'. Element: {1}",optionsExp,startingTag(selectElement));var valueName=match[5]||match[7],keyName=match[6],selectAs=/ as /.test(match[0])&&match[1],trackBy=match[9],valueFn=$parse(match[2]?match[1]:valueName),viewValueFn=selectAs&&$parse(selectAs)||valueFn,trackByFn=trackBy&&$parse(trackBy),getTrackByValueFn=trackBy?function(value,locals){return trackByFn(scope,locals)}:function(value){return hashKey(value)},getTrackByValue=function(value,key){return getTrackByValueFn(value,getLocals(value,key))},displayFn=$parse(match[2]||match[1]),groupByFn=$parse(match[3]||""),disableWhenFn=$parse(match[4]||""),valuesFn=$parse(match[8]),locals={},getLocals=keyName?function(value,key){return locals[keyName]=key,locals[valueName]=value,locals}:function(value){return locals[valueName]=value,locals};return{trackBy:trackBy,getTrackByValue:getTrackByValue,getWatchables:$parse(valuesFn,function(optionValues){for(var watchedArray=[],optionValuesKeys=getOptionValuesKeys(optionValues=optionValues||[]),optionValuesLength=optionValuesKeys.length,index=0;index<optionValuesLength;index++){var key=optionValues===optionValuesKeys?index:optionValuesKeys[index],locals=(optionValues[key],getLocals(optionValues[key],key)),selectValue=getTrackByValueFn(optionValues[key],locals);if(watchedArray.push(selectValue),match[2]||match[1]){var label=displayFn(scope,locals);watchedArray.push(label)}if(match[4]){var disableWhen=disableWhenFn(scope,locals);watchedArray.push(disableWhen)}}return watchedArray}),getOptions:function(){for(var optionItems=[],selectValueMap={},optionValues=valuesFn(scope)||[],optionValuesKeys=getOptionValuesKeys(optionValues),optionValuesLength=optionValuesKeys.length,index=0;index<optionValuesLength;index++){var key=optionValues===optionValuesKeys?index:optionValuesKeys[index],locals=getLocals(optionValues[key],key),viewValue=viewValueFn(scope,locals),selectValue=getTrackByValueFn(viewValue,locals),optionItem=new Option(selectValue,viewValue,displayFn(scope,locals),groupByFn(scope,locals),disableWhenFn(scope,locals));optionItems.push(optionItem),selectValueMap[selectValue]=optionItem}return{items:optionItems,selectValueMap:selectValueMap,getOptionFromViewValue:function(value){return selectValueMap[getTrackByValue(value)]},getViewValueFromOption:function(option){return trackBy?angular.copy(option.viewValue):option.viewValue}}}}}var optionTemplate=document.createElement("option"),optGroupTemplate=document.createElement("optgroup");return{restrict:"A",terminal:!0,require:["select","?ngModel"],link:function(scope,selectElement,attr,ctrls){function updateOptionElement(option,element){option.element=element,element.disabled=option.disabled,option.value!==element.value&&(element.value=option.selectValue),option.label!==element.label&&(element.label=option.label,element.textContent=option.label)}function addOrReuseElement(parent,current,type,templateElement){var element;return current&&lowercase(current.nodeName)===type?element=current:(element=templateElement.cloneNode(!1),current?parent.insertBefore(element,current):parent.appendChild(element)),element}function removeExcessElements(current){for(var next;current;)next=current.nextSibling,jqLiteRemove(current),current=next}function skipEmptyAndUnknownOptions(current){var emptyOption_=emptyOption&&emptyOption[0],unknownOption_=unknownOption&&unknownOption[0];if(emptyOption_||unknownOption_)for(;current&&(current===emptyOption_||current===unknownOption_);)current=current.nextSibling;return current}function updateOptions(){var previousValue=options&&selectCtrl.readValue();options=ngOptions.getOptions();var groupMap={},currentElement=selectElement[0].firstChild;if(providedEmptyOption&&selectElement.prepend(emptyOption),currentElement=skipEmptyAndUnknownOptions(currentElement),options.items.forEach(function(option){var group,groupElement,optionElement;option.group?((group=groupMap[option.group])||(groupElement=addOrReuseElement(selectElement[0],currentElement,"optgroup",optGroupTemplate),currentElement=groupElement.nextSibling,groupElement.label=option.group,group=groupMap[option.group]={groupElement:groupElement,currentOptionElement:groupElement.firstChild}),updateOptionElement(option,optionElement=addOrReuseElement(group.groupElement,group.currentOptionElement,"option",optionTemplate)),group.currentOptionElement=optionElement.nextSibling):(updateOptionElement(option,optionElement=addOrReuseElement(selectElement[0],currentElement,"option",optionTemplate)),currentElement=optionElement.nextSibling)}),Object.keys(groupMap).forEach(function(key){removeExcessElements(groupMap[key].currentOptionElement)}),removeExcessElements(currentElement),ngModelCtrl.$render(),!ngModelCtrl.$isEmpty(previousValue)){var nextValue=selectCtrl.readValue();(ngOptions.trackBy?equals(previousValue,nextValue):previousValue===nextValue)||(ngModelCtrl.$setViewValue(nextValue),ngModelCtrl.$render())}}var ngModelCtrl=ctrls[1];if(ngModelCtrl){for(var emptyOption,selectCtrl=ctrls[0],multiple=attr.multiple,i=0,children=selectElement.children(),ii=children.length;i<ii;i++)if(""===children[i].value){emptyOption=children.eq(i);break}var providedEmptyOption=!!emptyOption,unknownOption=jqLite(optionTemplate.cloneNode(!1));unknownOption.val("?");var options,ngOptions=parseOptionsExpression(attr.ngOptions,selectElement,scope),renderEmptyOption=function(){providedEmptyOption||selectElement.prepend(emptyOption),selectElement.val(""),emptyOption.prop("selected",!0),emptyOption.attr("selected",!0)},removeEmptyOption=function(){providedEmptyOption||emptyOption.remove()},renderUnknownOption=function(){selectElement.prepend(unknownOption),selectElement.val("?"),unknownOption.prop("selected",!0),unknownOption.attr("selected",!0)},removeUnknownOption=function(){unknownOption.remove()};multiple?(ngModelCtrl.$isEmpty=function(value){return!value||0===value.length},selectCtrl.writeValue=function(value){options.items.forEach(function(option){option.element.selected=!1}),value&&value.forEach(function(item){var option=options.getOptionFromViewValue(item);option&&!option.disabled&&(option.element.selected=!0)})},selectCtrl.readValue=function(){var selections=[];return forEach(selectElement.val()||[],function(value){var option=options.selectValueMap[value];option.disabled||selections.push(options.getViewValueFromOption(option))}),selections},ngOptions.trackBy&&scope.$watchCollection(function(){if(isArray(ngModelCtrl.$viewValue))return ngModelCtrl.$viewValue.map(function(value){return ngOptions.getTrackByValue(value)})},function(){ngModelCtrl.$render()})):(selectCtrl.writeValue=function(value){var option=options.getOptionFromViewValue(value);option&&!option.disabled?selectElement[0].value!==option.selectValue&&(removeUnknownOption(),removeEmptyOption(),selectElement[0].value=option.selectValue,option.element.selected=!0,option.element.setAttribute("selected","selected")):null===value||providedEmptyOption?(removeUnknownOption(),renderEmptyOption()):(removeEmptyOption(),renderUnknownOption())},selectCtrl.readValue=function(){var selectedOption=options.selectValueMap[selectElement.val()];return selectedOption&&!selectedOption.disabled?(removeEmptyOption(),removeUnknownOption(),options.getViewValueFromOption(selectedOption)):null},ngOptions.trackBy&&scope.$watch(function(){return ngOptions.getTrackByValue(ngModelCtrl.$viewValue)},function(){ngModelCtrl.$render()})),providedEmptyOption?(emptyOption.remove(),$compile(emptyOption)(scope),emptyOption.removeClass("ng-scope")):emptyOption=jqLite(optionTemplate.cloneNode(!1)),updateOptions(),scope.$watchCollection(ngOptions.getWatchables,updateOptions)}}}}],ngPluralizeDirective=["$locale","$interpolate","$log",function($locale,$interpolate,$log){var BRACE=/{}/g,IS_WHEN=/^when(Minus)?(.+)$/;return{link:function(scope,element,attr){function updateElementText(newText){element.text(newText||"")}var lastCount,numberExp=attr.count,whenExp=attr.$attr.when&&element.attr(attr.$attr.when),offset=attr.offset||0,whens=scope.$eval(whenExp)||{},whensExpFns={},startSymbol=$interpolate.startSymbol(),endSymbol=$interpolate.endSymbol(),braceReplacement=startSymbol+numberExp+"-"+offset+endSymbol,watchRemover=angular.noop;forEach(attr,function(expression,attributeName){var tmpMatch=IS_WHEN.exec(attributeName);if(tmpMatch){var whenKey=(tmpMatch[1]?"-":"")+lowercase(tmpMatch[2]);whens[whenKey]=element.attr(attr.$attr[attributeName])}}),forEach(whens,function(expression,key){whensExpFns[key]=$interpolate(expression.replace(BRACE,braceReplacement))}),scope.$watch(numberExp,function(newVal){var count=parseFloat(newVal),countIsNaN=isNaN(count);if(countIsNaN||count in whens||(count=$locale.pluralCat(count-offset)),count!==lastCount&&!(countIsNaN&&isNumber(lastCount)&&isNaN(lastCount))){watchRemover();var whenExpFn=whensExpFns[count];isUndefined(whenExpFn)?(null!=newVal&&$log.debug("ngPluralize: no rule defined for '"+count+"' in "+whenExp),watchRemover=noop,updateElementText()):watchRemover=scope.$watch(whenExpFn,updateElementText),lastCount=count}})}}}],ngRepeatDirective=["$parse","$animate",function($parse,$animate){var ngRepeatMinErr=minErr("ngRepeat"),updateScope=function(scope,index,valueIdentifier,value,keyIdentifier,key,arrayLength){scope[valueIdentifier]=value,keyIdentifier&&(scope[keyIdentifier]=key),scope.$index=index,scope.$first=0===index,scope.$last=index===arrayLength-1,scope.$middle=!(scope.$first||scope.$last),scope.$odd=!(scope.$even=0==(1&index))},getBlockStart=function(block){return block.clone[0]},getBlockEnd=function(block){return block.clone[block.clone.length-1]};return{restrict:"A",multiElement:!0,transclude:"element",priority:1e3,terminal:!0,$$tlb:!0,compile:function($element,$attr){var expression=$attr.ngRepeat,ngRepeatEndComment=document.createComment(" end ngRepeat: "+expression+" "),match=expression.match(/^\s*([\s\S]+?)\s+in\s+([\s\S]+?)(?:\s+as\s+([\s\S]+?))?(?:\s+track\s+by\s+([\s\S]+?))?\s*$/);if(!match)throw ngRepeatMinErr("iexp","Expected expression in form of '_item_ in _collection_[ track by _id_]' but got '{0}'.",expression);var lhs=match[1],rhs=match[2],aliasAs=match[3],trackByExp=match[4];if(!(match=lhs.match(/^(?:(\s*[\$\w]+)|\(\s*([\$\w]+)\s*,\s*([\$\w]+)\s*\))$/)))throw ngRepeatMinErr("iidexp","'_item_' in '_item_ in _collection_' should be an identifier or '(_key_, _value_)' expression, but got '{0}'.",lhs);var valueIdentifier=match[3]||match[1],keyIdentifier=match[2];if(aliasAs&&(!/^[$a-zA-Z_][$a-zA-Z0-9_]*$/.test(aliasAs)||/^(null|undefined|this|\$index|\$first|\$middle|\$last|\$even|\$odd|\$parent|\$root|\$id)$/.test(aliasAs)))throw ngRepeatMinErr("badident","alias '{0}' is invalid --- must be a valid JS identifier which is not a reserved name.",aliasAs);var trackByExpGetter,trackByIdExpFn,trackByIdArrayFn,trackByIdObjFn,hashFnLocals={$id:hashKey};return trackByExp?trackByExpGetter=$parse(trackByExp):(trackByIdArrayFn=function(key,value){return hashKey(value)},trackByIdObjFn=function(key){return key}),function($scope,$element,$attr,ctrl,$transclude){trackByExpGetter&&(trackByIdExpFn=function(key,value,index){return keyIdentifier&&(hashFnLocals[keyIdentifier]=key),hashFnLocals[valueIdentifier]=value,hashFnLocals.$index=index,trackByExpGetter($scope,hashFnLocals)});var lastBlockMap=createMap();$scope.$watchCollection(rhs,function(collection){var index,length,nextNode,collectionLength,key,value,trackById,trackByIdFn,collectionKeys,block,nextBlockOrder,elementsToRemove,previousNode=$element[0],nextBlockMap=createMap();if(aliasAs&&($scope[aliasAs]=collection),isArrayLike(collection))collectionKeys=collection,trackByIdFn=trackByIdExpFn||trackByIdArrayFn;else{trackByIdFn=trackByIdExpFn||trackByIdObjFn,collectionKeys=[];for(var itemKey in collection)collection.hasOwnProperty(itemKey)&&"$"!==itemKey.charAt(0)&&collectionKeys.push(itemKey)}for(collectionLength=collectionKeys.length,nextBlockOrder=new Array(collectionLength),index=0;index<collectionLength;index++)if(key=collection===collectionKeys?index:collectionKeys[index],value=collection[key],trackById=trackByIdFn(key,value,index),lastBlockMap[trackById])block=lastBlockMap[trackById],delete lastBlockMap[trackById],nextBlockMap[trackById]=block,nextBlockOrder[index]=block;else{if(nextBlockMap[trackById])throw forEach(nextBlockOrder,function(block){block&&block.scope&&(lastBlockMap[block.id]=block)}),ngRepeatMinErr("dupes","Duplicates in a repeater are not allowed. Use 'track by' expression to specify unique keys. Repeater: {0}, Duplicate key: {1}, Duplicate value: {2}",expression,trackById,value);nextBlockOrder[index]={id:trackById,scope:undefined,clone:undefined},nextBlockMap[trackById]=!0}for(var blockKey in lastBlockMap){if(block=lastBlockMap[blockKey],elementsToRemove=getBlockNodes(block.clone),$animate.leave(elementsToRemove),elementsToRemove[0].parentNode)for(index=0,length=elementsToRemove.length;index<length;index++)elementsToRemove[index].$$NG_REMOVED=!0;block.scope.$destroy()}for(index=0;index<collectionLength;index++)if(key=collection===collectionKeys?index:collectionKeys[index],value=collection[key],(block=nextBlockOrder[index]).scope){nextNode=previousNode;do{nextNode=nextNode.nextSibling}while(nextNode&&nextNode.$$NG_REMOVED);getBlockStart(block)!=nextNode&&$animate.move(getBlockNodes(block.clone),null,jqLite(previousNode)),previousNode=getBlockEnd(block),updateScope(block.scope,index,valueIdentifier,value,keyIdentifier,key,collectionLength)}else $transclude(function(clone,scope){block.scope=scope;var endNode=ngRepeatEndComment.cloneNode(!1);clone[clone.length++]=endNode,$animate.enter(clone,null,jqLite(previousNode)),previousNode=endNode,block.clone=clone,nextBlockMap[block.id]=block,updateScope(block.scope,index,valueIdentifier,value,keyIdentifier,key,collectionLength)});lastBlockMap=nextBlockMap})}}}}],ngShowDirective=["$animate",function($animate){return{restrict:"A",multiElement:!0,link:function(scope,element,attr){scope.$watch(attr.ngShow,function(value){$animate[value?"removeClass":"addClass"](element,"ng-hide",{tempClasses:"ng-hide-animate"})})}}}],ngHideDirective=["$animate",function($animate){return{restrict:"A",multiElement:!0,link:function(scope,element,attr){scope.$watch(attr.ngHide,function(value){$animate[value?"addClass":"removeClass"](element,"ng-hide",{tempClasses:"ng-hide-animate"})})}}}],ngStyleDirective=ngDirective(function(scope,element,attr){scope.$watch(attr.ngStyle,function(newStyles,oldStyles){oldStyles&&newStyles!==oldStyles&&forEach(oldStyles,function(val,style){element.css(style,"")}),newStyles&&element.css(newStyles)},!0)}),ngSwitchDirective=["$animate",function($animate){return{require:"ngSwitch",controller:["$scope",function(){this.cases={}}],link:function(scope,element,attr,ngSwitchController){var watchExpr=attr.ngSwitch||attr.on,selectedTranscludes=[],selectedElements=[],previousLeaveAnimations=[],selectedScopes=[],spliceFactory=function(array,index){return function(){array.splice(index,1)}};scope.$watch(watchExpr,function(value){var i,ii;for(i=0,ii=previousLeaveAnimations.length;i<ii;++i)$animate.cancel(previousLeaveAnimations[i]);for(previousLeaveAnimations.length=0,i=0,ii=selectedScopes.length;i<ii;++i){var selected=getBlockNodes(selectedElements[i].clone);selectedScopes[i].$destroy(),(previousLeaveAnimations[i]=$animate.leave(selected)).then(spliceFactory(previousLeaveAnimations,i))}selectedElements.length=0,selectedScopes.length=0,(selectedTranscludes=ngSwitchController.cases["!"+value]||ngSwitchController.cases["?"])&&forEach(selectedTranscludes,function(selectedTransclude){selectedTransclude.transclude(function(caseElement,selectedScope){selectedScopes.push(selectedScope);var anchor=selectedTransclude.element;caseElement[caseElement.length++]=document.createComment(" end ngSwitchWhen: ");var block={clone:caseElement};selectedElements.push(block),$animate.enter(caseElement,anchor.parent(),anchor)})})})}}}],ngSwitchWhenDirective=ngDirective({transclude:"element",priority:1200,require:"^ngSwitch",multiElement:!0,link:function(scope,element,attrs,ctrl,$transclude){ctrl.cases["!"+attrs.ngSwitchWhen]=ctrl.cases["!"+attrs.ngSwitchWhen]||[],ctrl.cases["!"+attrs.ngSwitchWhen].push({transclude:$transclude,element:element})}}),ngSwitchDefaultDirective=ngDirective({transclude:"element",priority:1200,require:"^ngSwitch",multiElement:!0,link:function(scope,element,attr,ctrl,$transclude){ctrl.cases["?"]=ctrl.cases["?"]||[],ctrl.cases["?"].push({transclude:$transclude,element:element})}}),ngTranscludeDirective=ngDirective({restrict:"EAC",link:function($scope,$element,$attrs,controller,$transclude){if(!$transclude)throw minErr("ngTransclude")("orphan","Illegal use of ngTransclude directive in the template! No parent directive that requires a transclusion found. Element: {0}",startingTag($element));$transclude(function(clone){$element.empty(),$element.append(clone)})}}),scriptDirective=["$templateCache",function($templateCache){return{restrict:"E",terminal:!0,compile:function(element,attr){if("text/ng-template"==attr.type){var templateUrl=attr.id,text=element[0].text;$templateCache.put(templateUrl,text)}}}}],noopNgModelController={$setViewValue:noop,$render:noop},SelectController=["$element","$scope","$attrs",function($element,$scope,$attrs){var self=this,optionsMap=new HashMap;self.ngModelCtrl=noopNgModelController,self.unknownOption=jqLite(document.createElement("option")),self.renderUnknownOption=function(val){var unknownVal="? "+hashKey(val)+" ?";self.unknownOption.val(unknownVal),$element.prepend(self.unknownOption),$element.val(unknownVal)},$scope.$on("$destroy",function(){self.renderUnknownOption=noop}),self.removeUnknownOption=function(){self.unknownOption.parent()&&self.unknownOption.remove()},self.readValue=function(){return self.removeUnknownOption(),$element.val()},self.writeValue=function(value){self.hasOption(value)?(self.removeUnknownOption(),$element.val(value),""===value&&self.emptyOption.prop("selected",!0)):null==value&&self.emptyOption?(self.removeUnknownOption(),$element.val("")):self.renderUnknownOption(value)},self.addOption=function(value,element){assertNotHasOwnProperty(value,'"option value"'),""===value&&(self.emptyOption=element);var count=optionsMap.get(value)||0;optionsMap.put(value,count+1)},self.removeOption=function(value){var count=optionsMap.get(value);count&&(1===count?(optionsMap.remove(value),""===value&&(self.emptyOption=undefined)):optionsMap.put(value,count-1))},self.hasOption=function(value){return!!optionsMap.get(value)}}],selectDirective=function(){return{restrict:"E",require:["select","?ngModel"],controller:SelectController,link:function(scope,element,attr,ctrls){var ngModelCtrl=ctrls[1];if(ngModelCtrl){var selectCtrl=ctrls[0];if(selectCtrl.ngModelCtrl=ngModelCtrl,ngModelCtrl.$render=function(){selectCtrl.writeValue(ngModelCtrl.$viewValue)},element.on("change",function(){scope.$apply(function(){ngModelCtrl.$setViewValue(selectCtrl.readValue())})}),attr.multiple){selectCtrl.readValue=function(){var array=[];return forEach(element.find("option"),function(option){option.selected&&array.push(option.value)}),array},selectCtrl.writeValue=function(value){var items=new HashMap(value);forEach(element.find("option"),function(option){option.selected=isDefined(items.get(option.value))})};var lastView,lastViewRef=NaN;scope.$watch(function(){lastViewRef!==ngModelCtrl.$viewValue||equals(lastView,ngModelCtrl.$viewValue)||(lastView=shallowCopy(ngModelCtrl.$viewValue),ngModelCtrl.$render()),lastViewRef=ngModelCtrl.$viewValue}),ngModelCtrl.$isEmpty=function(value){return!value||0===value.length}}}}}},optionDirective=["$interpolate",function($interpolate){function chromeHack(optionElement){optionElement[0].hasAttribute("selected")&&(optionElement[0].selected=!0)}return{restrict:"E",priority:100,compile:function(element,attr){if(isUndefined(attr.value)){var interpolateFn=$interpolate(element.text(),!0);interpolateFn||attr.$set("value",element.text())}return function(scope,element,attr){var parent=element.parent(),selectCtrl=parent.data("$selectController")||parent.parent().data("$selectController");selectCtrl&&selectCtrl.ngModelCtrl&&(interpolateFn?scope.$watch(interpolateFn,function(newVal,oldVal){attr.$set("value",newVal),oldVal!==newVal&&selectCtrl.removeOption(oldVal),selectCtrl.addOption(newVal,element),selectCtrl.ngModelCtrl.$render(),chromeHack(element)}):(selectCtrl.addOption(attr.value,element),selectCtrl.ngModelCtrl.$render(),chromeHack(element)),element.on("$destroy",function(){selectCtrl.removeOption(attr.value),selectCtrl.ngModelCtrl.$render()}))}}}}],styleDirective=valueFn({restrict:"E",terminal:!1}),requiredDirective=function(){return{restrict:"A",require:"?ngModel",link:function(scope,elm,attr,ctrl){ctrl&&(attr.required=!0,ctrl.$validators.required=function(modelValue,viewValue){return!attr.required||!ctrl.$isEmpty(viewValue)},attr.$observe("required",function(){ctrl.$validate()}))}}},patternDirective=function(){return{restrict:"A",require:"?ngModel",link:function(scope,elm,attr,ctrl){if(ctrl){var regexp,patternExp=attr.ngPattern||attr.pattern;attr.$observe("pattern",function(regex){if(isString(regex)&&regex.length>0&&(regex=new RegExp("^"+regex+"$")),regex&&!regex.test)throw minErr("ngPattern")("noregexp","Expected {0} to be a RegExp but was {1}. Element: {2}",patternExp,regex,startingTag(elm));regexp=regex||undefined,ctrl.$validate()}),ctrl.$validators.pattern=function(value){return ctrl.$isEmpty(value)||isUndefined(regexp)||regexp.test(value)}}}}},maxlengthDirective=function(){return{restrict:"A",require:"?ngModel",link:function(scope,elm,attr,ctrl){if(ctrl){var maxlength=-1;attr.$observe("maxlength",function(value){var intVal=toInt(value);maxlength=isNaN(intVal)?-1:intVal,ctrl.$validate()}),ctrl.$validators.maxlength=function(modelValue,viewValue){return maxlength<0||ctrl.$isEmpty(viewValue)||viewValue.length<=maxlength}}}}},minlengthDirective=function(){return{restrict:"A",require:"?ngModel",link:function(scope,elm,attr,ctrl){if(ctrl){var minlength=0;attr.$observe("minlength",function(value){minlength=toInt(value)||0,ctrl.$validate()}),ctrl.$validators.minlength=function(modelValue,viewValue){return ctrl.$isEmpty(viewValue)||viewValue.length>=minlength}}}}};window.angular.bootstrap||(!function(){var originalCleanData;if(!bindJQueryFired){var jqName=jq();jQuery=window.jQuery,isDefined(jqName)&&(jQuery=null===jqName?undefined:window[jqName]),jQuery&&jQuery.fn.on?(jqLite=jQuery,extend(jQuery.fn,{scope:JQLitePrototype.scope,isolateScope:JQLitePrototype.isolateScope,controller:JQLitePrototype.controller,injector:JQLitePrototype.injector,inheritedData:JQLitePrototype.inheritedData}),originalCleanData=jQuery.cleanData,jQuery.cleanData=function(elems){var events;if(skipDestroyOnNextJQueryCleanData)skipDestroyOnNextJQueryCleanData=!1;else for(var elem,i=0;null!=(elem=elems[i]);i++)(events=jQuery._data(elem,"events"))&&events.$destroy&&jQuery(elem).triggerHandler("$destroy");originalCleanData(elems)}):jqLite=JQLite,angular.element=jqLite,bindJQueryFired=!0}}(),function(angular){extend(angular,{bootstrap:bootstrap,copy:copy,extend:extend,merge:merge,equals:equals,element:jqLite,forEach:forEach,injector:createInjector,noop:noop,bind:bind,toJson:toJson,fromJson:fromJson,identity:identity,isUndefined:isUndefined,isDefined:isDefined,isString:isString,isFunction:isFunction,isObject:isObject,isNumber:isNumber,isElement:isElement,isArray:isArray,version:version,isDate:isDate,lowercase:lowercase,uppercase:uppercase,callbacks:{counter:0},getTestability:getTestability,$$minErr:minErr,$$csp:csp,reloadWithDebugInfo:reloadWithDebugInfo}),angularModule=setupModuleLoader(window);try{angularModule("ngLocale")}catch(e){angularModule("ngLocale",[]).provider("$locale",$LocaleProvider)}angularModule("ng",["ngLocale"],["$provide",function($provide){$provide.provider({$$sanitizeUri:$$SanitizeUriProvider}),$provide.provider("$compile",$CompileProvider).directive({a:htmlAnchorDirective,input:inputDirective,textarea:inputDirective,form:formDirective,script:scriptDirective,select:selectDirective,style:styleDirective,option:optionDirective,ngBind:ngBindDirective,ngBindHtml:ngBindHtmlDirective,ngBindTemplate:ngBindTemplateDirective,ngClass:ngClassDirective,ngClassEven:ngClassEvenDirective,ngClassOdd:ngClassOddDirective,ngCloak:ngCloakDirective,ngController:ngControllerDirective,ngForm:ngFormDirective,ngHide:ngHideDirective,ngIf:ngIfDirective,ngInclude:ngIncludeDirective,ngInit:ngInitDirective,ngNonBindable:ngNonBindableDirective,ngPluralize:ngPluralizeDirective,ngRepeat:ngRepeatDirective,ngShow:ngShowDirective,ngStyle:ngStyleDirective,ngSwitch:ngSwitchDirective,ngSwitchWhen:ngSwitchWhenDirective,ngSwitchDefault:ngSwitchDefaultDirective,ngOptions:ngOptionsDirective,ngTransclude:ngTranscludeDirective,ngModel:ngModelDirective,ngList:ngListDirective,ngChange:ngChangeDirective,pattern:patternDirective,ngPattern:patternDirective,required:requiredDirective,ngRequired:requiredDirective,minlength:minlengthDirective,ngMinlength:minlengthDirective,maxlength:maxlengthDirective,ngMaxlength:maxlengthDirective,ngValue:ngValueDirective,ngModelOptions:ngModelOptionsDirective}).directive({ngInclude:ngIncludeFillContentDirective}).directive(ngAttributeAliasDirectives).directive(ngEventDirectives),$provide.provider({$anchorScroll:$AnchorScrollProvider,$animate:$AnimateProvider,$$animateQueue:$$CoreAnimateQueueProvider,$$AnimateRunner:$$CoreAnimateRunnerProvider,$browser:$BrowserProvider,$cacheFactory:$CacheFactoryProvider,$controller:$ControllerProvider,$document:$DocumentProvider,$exceptionHandler:$ExceptionHandlerProvider,$filter:$FilterProvider,$interpolate:$InterpolateProvider,$interval:$IntervalProvider,$http:$HttpProvider,$httpParamSerializer:$HttpParamSerializerProvider,$httpParamSerializerJQLike:$HttpParamSerializerJQLikeProvider,$httpBackend:$HttpBackendProvider,$location:$LocationProvider,$log:$LogProvider,$parse:$ParseProvider,$rootScope:$RootScopeProvider,$q:$QProvider,$$q:$$QProvider,$sce:$SceProvider,$sceDelegate:$SceDelegateProvider,$sniffer:$SnifferProvider,$templateCache:$TemplateCacheProvider,$templateRequest:$TemplateRequestProvider,$$testability:$$TestabilityProvider,$timeout:$TimeoutProvider,$window:$WindowProvider,$$rAF:$$RAFProvider,$$jqLite:$$jqLiteProvider,$$HashMap:$$HashMapProvider,$$cookieReader:$$CookieReaderProvider})}])}(angular),jqLite(document).ready(function(){angularInit(document,bootstrap)}))}(window,document),!window.angular.$$csp()&&window.angular.element(document.head).prepend('<style type="text/css">@charset "UTF-8";[ng\\:cloak],[ng-cloak],[data-ng-cloak],[x-ng-cloak],.ng-cloak,.x-ng-cloak,.ng-hide:not(.ng-hide-animate){display:none !important;}ng\\:form{display:block;}.ng-animate-shim{visibility:hidden;}.ng-anchor{position:absolute;}</style>'),function(window,angular,undefined){"use strict";function assertArg(arg,name,reason){if(!arg)throw ngMinErr("areq","Argument '{0}' is {1}",name||"?",reason||"required");return arg}function mergeClasses(a,b){return a||b?a?b?(isArray(a)&&(a=a.join(" ")),isArray(b)&&(b=b.join(" ")),a+" "+b):a:b:""}function packageStyles(options){var styles={};return options&&(options.to||options.from)&&(styles.to=options.to,styles.from=options.from),styles}function pendClasses(classes,fix,isPrefix){var className="";return classes=isArray(classes)?classes:classes&&isString(classes)&&classes.length?classes.split(/\s+/):[],forEach(classes,function(klass,i){klass&&klass.length>0&&(className+=i>0?" ":"",className+=isPrefix?fix+klass:klass+fix)}),className}function removeFromArray(arr,val){var index=arr.indexOf(val);val>=0&&arr.splice(index,1)}function stripCommentsFromElement(element){if(element instanceof jqLite)switch(element.length){case 0:return[];case 1:if(element[0].nodeType===ELEMENT_NODE)return element;break;default:return jqLite(extractElementNode(element))}if(element.nodeType===ELEMENT_NODE)return jqLite(element)}function extractElementNode(element){if(!element[0])return element;for(var i=0;i<element.length;i++){var elm=element[i];if(elm.nodeType==ELEMENT_NODE)return elm}}function $$addClass($$jqLite,element,className){forEach(element,function(elm){$$jqLite.addClass(elm,className)})}function $$removeClass($$jqLite,element,className){forEach(element,function(elm){$$jqLite.removeClass(elm,className)})}function applyAnimationClassesFactory($$jqLite){return function(element,options){options.addClass&&($$addClass($$jqLite,element,options.addClass),options.addClass=null),options.removeClass&&($$removeClass($$jqLite,element,options.removeClass),options.removeClass=null)}}function prepareAnimationOptions(options){if(!(options=options||{}).$$prepared){var domOperation=options.domOperation||noop;options.domOperation=function(){options.$$domOperationFired=!0,domOperation(),domOperation=noop},options.$$prepared=!0}return options}function applyAnimationStyles(element,options){applyAnimationFromStyles(element,options),applyAnimationToStyles(element,options)}function applyAnimationFromStyles(element,options){options.from&&(element.css(options.from),options.from=null)}function applyAnimationToStyles(element,options){options.to&&(element.css(options.to),options.to=null)}function mergeAnimationOptions(element,target,newOptions){var toAdd=(target.addClass||"")+" "+(newOptions.addClass||""),toRemove=(target.removeClass||"")+" "+(newOptions.removeClass||""),classes=resolveElementClasses(element.attr("class"),toAdd,toRemove);return extend(target,newOptions),classes.addClass?target.addClass=classes.addClass:target.addClass=null,classes.removeClass?target.removeClass=classes.removeClass:target.removeClass=null,target}function resolveElementClasses(existing,toAdd,toRemove){function splitClassesToLookup(classes){isString(classes)&&(classes=classes.split(" "));var obj={};return forEach(classes,function(klass){klass.length&&(obj[klass]=!0)}),obj}var flags={};existing=splitClassesToLookup(existing),toAdd=splitClassesToLookup(toAdd),forEach(toAdd,function(value,key){flags[key]=1}),toRemove=splitClassesToLookup(toRemove),forEach(toRemove,function(value,key){flags[key]=1===flags[key]?null:-1});var classes={addClass:"",removeClass:""};return forEach(flags,function(val,klass){var prop,allow;1===val?(prop="addClass",allow=!existing[klass]):-1===val&&(prop="removeClass",allow=existing[klass]),allow&&(classes[prop].length&&(classes[prop]+=" "),classes[prop]+=klass)}),classes}function getDomNode(element){return element instanceof angular.element?element[0]:element}function computeCssStyles($window,element,properties){var styles=Object.create(null),detectedStyles=$window.getComputedStyle(element)||{};return forEach(properties,function(formalStyleName,actualStyleName){var val=detectedStyles[formalStyleName];if(val){var c=val.charAt(0);("-"===c||"+"===c||c>=0)&&(val=parseMaxTime(val)),0===val&&(val=null),styles[actualStyleName]=val}}),styles}function parseMaxTime(str){var maxValue=0,values=str.split(/\s*,\s*/);return forEach(values,function(value){"s"==value.charAt(value.length-1)&&(value=value.substring(0,value.length-1)),value=parseFloat(value)||0,maxValue=maxValue?Math.max(value,maxValue):value}),maxValue}function truthyTimingValue(val){return 0===val||null!=val}function getCssTransitionDurationStyle(duration,applyOnlyDuration){var style=TRANSITION_PROP,value=duration+"s";return applyOnlyDuration?style+=DURATION_KEY:value+=" linear all",[style,value]}function getCssKeyframeDurationStyle(duration){return[ANIMATION_DURATION_PROP,duration+"s"]}function getCssDelayStyle(delay,isKeyframeAnimation){return[isKeyframeAnimation?ANIMATION_DELAY_PROP:TRANSITION_DELAY_PROP,delay+"s"]}function blockTransitions(node,duration){var value=duration?"-"+duration+"s":"";return applyInlineStyle(node,[TRANSITION_DELAY_PROP,value]),[TRANSITION_DELAY_PROP,value]}function blockKeyframeAnimations(node,applyBlock){var value=applyBlock?"paused":"",key=ANIMATION_PROP+ANIMATION_PLAYSTATE_KEY;return applyInlineStyle(node,[key,value]),[key,value]}function applyInlineStyle(node,styleTuple){var prop=styleTuple[0],value=styleTuple[1];node.style[prop]=value}function createLocalCacheLookup(){var cache=Object.create(null);return{flush:function(){cache=Object.create(null)},count:function(key){var entry=cache[key];return entry?entry.total:0},get:function(key){var entry=cache[key];return entry&&entry.value},put:function(key,value){cache[key]?cache[key].total++:cache[key]={total:1,value:value}}}}var TRANSITION_PROP,TRANSITIONEND_EVENT,ANIMATION_PROP,ANIMATIONEND_EVENT,noop=angular.noop,extend=angular.extend,jqLite=angular.element,forEach=angular.forEach,isArray=angular.isArray,isString=angular.isString,isObject=angular.isObject,isUndefined=angular.isUndefined,isDefined=angular.isDefined,isFunction=angular.isFunction,isElement=angular.isElement,ELEMENT_NODE=1,NG_ANIMATE_CLASSNAME="ng-animate",NG_ANIMATE_CHILDREN_DATA="$$ngAnimateChildren",$$rAFSchedulerFactory=["$$rAF",function($$rAF){function scheduler(tasks){tickQueue.push([].concat(tasks)),nextTick()}function nextTick(){if(tickQueue.length){for(var updatedQueue=[],i=0;i<tickQueue.length;i++){var innerQueue=tickQueue[i];runNextTask(innerQueue),innerQueue.length&&updatedQueue.push(innerQueue)}tickQueue=updatedQueue,cancelFn||$$rAF(function(){cancelFn||nextTick()})}}function runNextTask(tasks){tasks.shift()()}var cancelFn,tickQueue=[];return scheduler.waitUntilQuiet=function(fn){cancelFn&&cancelFn(),cancelFn=$$rAF(function(){cancelFn=null,fn(),nextTick()})},scheduler}],$$AnimateChildrenDirective=[function(){return function(scope,element,attrs){var val=attrs.ngAnimateChildren;angular.isString(val)&&0===val.length?element.data(NG_ANIMATE_CHILDREN_DATA,!0):attrs.$observe("ngAnimateChildren",function(value){value="on"===value||"true"===value,element.data(NG_ANIMATE_CHILDREN_DATA,value)})}}];void 0===window.ontransitionend&&void 0!==window.onwebkittransitionend?("-webkit-",TRANSITION_PROP="WebkitTransition",TRANSITIONEND_EVENT="webkitTransitionEnd transitionend"):(TRANSITION_PROP="transition",TRANSITIONEND_EVENT="transitionend"),void 0===window.onanimationend&&void 0!==window.onwebkitanimationend?("-webkit-",ANIMATION_PROP="WebkitAnimation",ANIMATIONEND_EVENT="webkitAnimationEnd animationend"):(ANIMATION_PROP="animation",ANIMATIONEND_EVENT="animationend");var DURATION_KEY="Duration",PROPERTY_KEY="Property",TIMING_KEY="TimingFunction",ANIMATION_PLAYSTATE_KEY="PlayState",ELAPSED_TIME_MAX_DECIMAL_PLACES=3,CLOSING_TIME_BUFFER=1.5,ONE_SECOND=1e3,SAFE_FAST_FORWARD_DURATION_VALUE=9999,ANIMATION_DELAY_PROP=ANIMATION_PROP+"Delay",ANIMATION_DURATION_PROP=ANIMATION_PROP+DURATION_KEY,TRANSITION_DELAY_PROP=TRANSITION_PROP+"Delay",TRANSITION_DURATION_PROP=TRANSITION_PROP+DURATION_KEY,DETECT_CSS_PROPERTIES={transitionDuration:TRANSITION_DURATION_PROP,transitionDelay:TRANSITION_DELAY_PROP,transitionProperty:TRANSITION_PROP+PROPERTY_KEY,animationDuration:ANIMATION_DURATION_PROP,animationDelay:ANIMATION_DELAY_PROP,animationIterationCount:ANIMATION_PROP+"IterationCount"},DETECT_STAGGER_CSS_PROPERTIES={transitionDuration:TRANSITION_DURATION_PROP,transitionDelay:TRANSITION_DELAY_PROP,animationDuration:ANIMATION_DURATION_PROP,animationDelay:ANIMATION_DELAY_PROP},$AnimateCssProvider=["$animateProvider",function($animateProvider){var gcsLookup=createLocalCacheLookup(),gcsStaggerLookup=createLocalCacheLookup();this.$get=["$window","$$jqLite","$$AnimateRunner","$timeout","$document","$sniffer","$$rAFScheduler",function($window,$$jqLite,$$AnimateRunner,$timeout,$document,$sniffer,$$rAFScheduler){function gcsHashFn(node,extraClasses){var KEY="$$ngAnimateParentKey",parentNode=node.parentNode;return(parentNode[KEY]||(parentNode[KEY]=++parentCounter))+"-"+node.getAttribute("class")+"-"+extraClasses}function computeCachedCssStyles(node,className,cacheKey,properties){var timings=gcsLookup.get(cacheKey);return timings||"infinite"===(timings=computeCssStyles($window,node,properties)).animationIterationCount&&(timings.animationIterationCount=1),gcsLookup.put(cacheKey,timings),timings}function computeCachedCssStaggerStyles(node,className,cacheKey,properties){var stagger;if(gcsLookup.count(cacheKey)>0&&!(stagger=gcsStaggerLookup.get(cacheKey))){var staggerClassName=pendClasses(className,"-stagger");$$jqLite.addClass(node,staggerClassName),(stagger=computeCssStyles($window,node,properties)).animationDuration=Math.max(stagger.animationDuration,0),stagger.transitionDuration=Math.max(stagger.transitionDuration,0),$$jqLite.removeClass(node,staggerClassName),gcsStaggerLookup.put(cacheKey,stagger)}return stagger||{}}function waitUntilQuiet(callback){rafWaitQueue.push(callback),$$rAFScheduler.waitUntilQuiet(function(){gcsLookup.flush(),gcsStaggerLookup.flush();for(var width=bod.offsetWidth+1,i=0;i<rafWaitQueue.length;i++)rafWaitQueue[i](width);rafWaitQueue.length=0})}function computeTimings(node,className,cacheKey){var timings=computeCachedCssStyles(node,className,cacheKey,DETECT_CSS_PROPERTIES),aD=timings.animationDelay,tD=timings.transitionDelay;return timings.maxDelay=aD&&tD?Math.max(aD,tD):aD||tD,timings.maxDuration=Math.max(timings.animationDuration*timings.animationIterationCount,timings.transitionDuration),timings}var applyAnimationClasses=applyAnimationClassesFactory($$jqLite),parentCounter=0,bod=getDomNode($document).body,rafWaitQueue=[];return function(element,options){function endFn(){close()}function cancelFn(){close(!0)}function close(rejected){animationClosed||animationCompleted&&animationPaused||(animationClosed=!0,animationPaused=!1,$$jqLite.removeClass(element,setupClasses),$$jqLite.removeClass(element,activeClasses),blockKeyframeAnimations(node,!1),blockTransitions(node,!1),forEach(temporaryStyles,function(entry){node.style[entry[0]]=""}),applyAnimationClasses(element,options),applyAnimationStyles(element,options),options.onDone&&options.onDone(),runner&&runner.complete(!rejected))}function applyBlocking(duration){flags.blockTransition&&blockTransitions(node,duration),flags.blockKeyframeAnimation&&blockKeyframeAnimations(node,!!duration)}function closeAndReturnNoopAnimator(){return runner=new $$AnimateRunner({end:endFn,cancel:cancelFn}),close(),{$$willAnimate:!1,start:function(){return runner},end:endFn}}function start(){function triggerAnimationStart(){if(!animationClosed){if(applyBlocking(!1),forEach(temporaryStyles,function(entry){var key=entry[0],value=entry[1];node.style[key]=value}),applyAnimationClasses(element,options),$$jqLite.addClass(element,activeClasses),flags.recalculateTimingStyles){if(fullClassName=node.className+" "+setupClasses,cacheKey=gcsHashFn(node,fullClassName),timings=computeTimings(node,fullClassName,cacheKey),relativeDelay=timings.maxDelay,maxDelay=Math.max(relativeDelay,0),0===(maxDuration=timings.maxDuration))return void close();flags.hasTransitions=timings.transitionDuration>0,flags.hasAnimations=timings.animationDuration>0}if(flags.applyTransitionDelay||flags.applyAnimationDelay){relativeDelay="boolean"!=typeof options.delay&&truthyTimingValue(options.delay)?parseFloat(options.delay):relativeDelay,maxDelay=Math.max(relativeDelay,0);var delayStyle;flags.applyTransitionDelay&&(timings.transitionDelay=relativeDelay,delayStyle=getCssDelayStyle(relativeDelay),temporaryStyles.push(delayStyle),node.style[delayStyle[0]]=delayStyle[1]),flags.applyAnimationDelay&&(timings.animationDelay=relativeDelay,delayStyle=getCssDelayStyle(relativeDelay,!0),temporaryStyles.push(delayStyle),node.style[delayStyle[0]]=delayStyle[1])}if(maxDelayTime=maxDelay*ONE_SECOND,maxDurationTime=maxDuration*ONE_SECOND,options.easing){var easeProp,easeVal=options.easing;flags.hasTransitions&&(easeProp=TRANSITION_PROP+TIMING_KEY,temporaryStyles.push([easeProp,easeVal]),node.style[easeProp]=easeVal),flags.hasAnimations&&(easeProp=ANIMATION_PROP+TIMING_KEY,temporaryStyles.push([easeProp,easeVal]),node.style[easeProp]=easeVal)}timings.transitionDuration&&events.push(TRANSITIONEND_EVENT),timings.animationDuration&&events.push(ANIMATIONEND_EVENT),startTime=Date.now(),element.on(events.join(" "),onAnimationProgress),$timeout(onAnimationExpired,maxDelayTime+CLOSING_TIME_BUFFER*maxDurationTime),applyAnimationToStyles(element,options)}}function onAnimationExpired(){close()}function onAnimationProgress(event){event.stopPropagation();var ev=event.originalEvent||event,timeStamp=ev.$manualTimeStamp||ev.timeStamp||Date.now(),elapsedTime=parseFloat(ev.elapsedTime.toFixed(ELAPSED_TIME_MAX_DECIMAL_PLACES));Math.max(timeStamp-startTime,0)>=maxDelayTime&&elapsedTime>=maxDuration&&(animationCompleted=!0,close())}if(!animationClosed)if(node.parentNode){var startTime,events=[],playPause=function(playAnimation){if(animationCompleted)animationPaused&&playAnimation&&(animationPaused=!1,close());else if(animationPaused=!playAnimation,timings.animationDuration){var value=blockKeyframeAnimations(node,animationPaused);animationPaused?temporaryStyles.push(value):removeFromArray(temporaryStyles,value)}},maxStagger=itemIndex>0&&(timings.transitionDuration&&0===stagger.transitionDuration||timings.animationDuration&&0===stagger.animationDuration)&&Math.max(stagger.animationDelay,stagger.transitionDelay);maxStagger?$timeout(triggerAnimationStart,Math.floor(maxStagger*itemIndex*ONE_SECOND),!1):triggerAnimationStart(),runnerHost.resume=function(){playPause(!0)},runnerHost.pause=function(){playPause(!1)}}else close()}var node=getDomNode(element);if(!node||!node.parentNode)return closeAndReturnNoopAnimator();options=prepareAnimationOptions(options);var animationClosed,animationPaused,animationCompleted,runner,runnerHost,maxDelay,maxDelayTime,maxDuration,maxDurationTime,temporaryStyles=[],classes=element.attr("class"),styles=packageStyles(options);if(0===options.duration||!$sniffer.animations&&!$sniffer.transitions)return closeAndReturnNoopAnimator();var method=options.event&&isArray(options.event)?options.event.join(" "):options.event,structuralClassName="",addRemoveClassName="";method&&options.structural?structuralClassName=pendClasses(method,"ng-",!0):method&&(structuralClassName=method),options.addClass&&(addRemoveClassName+=pendClasses(options.addClass,"-add")),options.removeClass&&(addRemoveClassName.length&&(addRemoveClassName+=" "),addRemoveClassName+=pendClasses(options.removeClass,"-remove")),options.applyClassesEarly&&addRemoveClassName.length&&(applyAnimationClasses(element,options),addRemoveClassName="");var setupClasses=[structuralClassName,addRemoveClassName].join(" ").trim(),fullClassName=classes+" "+setupClasses,activeClasses=pendClasses(setupClasses,"-active"),hasToStyles=styles.to&&Object.keys(styles.to).length>0;if(!((options.keyframeStyle||"").length>0||hasToStyles||setupClasses))return closeAndReturnNoopAnimator();var cacheKey,stagger;if(options.stagger>0){var staggerVal=parseFloat(options.stagger);stagger={transitionDelay:staggerVal,animationDelay:staggerVal,transitionDuration:0,animationDuration:0}}else cacheKey=gcsHashFn(node,fullClassName),stagger=computeCachedCssStaggerStyles(node,setupClasses,cacheKey,DETECT_STAGGER_CSS_PROPERTIES);$$jqLite.addClass(element,setupClasses);var applyOnlyDuration;if(options.transitionStyle){var transitionStyle=[TRANSITION_PROP,options.transitionStyle];applyInlineStyle(node,transitionStyle),temporaryStyles.push(transitionStyle)}if(options.duration>=0){applyOnlyDuration=node.style[TRANSITION_PROP].length>0;var durationStyle=getCssTransitionDurationStyle(options.duration,applyOnlyDuration);applyInlineStyle(node,durationStyle),temporaryStyles.push(durationStyle)}if(options.keyframeStyle){var keyframeStyle=[ANIMATION_PROP,options.keyframeStyle];applyInlineStyle(node,keyframeStyle),temporaryStyles.push(keyframeStyle)}var itemIndex=stagger?options.staggerIndex>=0?options.staggerIndex:gcsLookup.count(cacheKey):0,isFirst=0===itemIndex;isFirst&&blockTransitions(node,SAFE_FAST_FORWARD_DURATION_VALUE);var timings=computeTimings(node,fullClassName,cacheKey),relativeDelay=timings.maxDelay;maxDelay=Math.max(relativeDelay,0),maxDuration=timings.maxDuration;var flags={};return flags.hasTransitions=timings.transitionDuration>0,flags.hasAnimations=timings.animationDuration>0,flags.hasTransitionAll=flags.hasTransitions&&"all"==timings.transitionProperty,flags.applyTransitionDuration=hasToStyles&&(flags.hasTransitions&&!flags.hasTransitionAll||flags.hasAnimations&&!flags.hasTransitions),flags.applyAnimationDuration=options.duration&&flags.hasAnimations,flags.applyTransitionDelay=truthyTimingValue(options.delay)&&(flags.applyTransitionDuration||flags.hasTransitions),flags.applyAnimationDelay=truthyTimingValue(options.delay)&&flags.hasAnimations,flags.recalculateTimingStyles=addRemoveClassName.length>0,(flags.applyTransitionDuration||flags.applyAnimationDuration)&&(maxDuration=options.duration?parseFloat(options.duration):maxDuration,flags.applyTransitionDuration&&(flags.hasTransitions=!0,timings.transitionDuration=maxDuration,applyOnlyDuration=node.style[TRANSITION_PROP+PROPERTY_KEY].length>0,temporaryStyles.push(getCssTransitionDurationStyle(maxDuration,applyOnlyDuration))),flags.applyAnimationDuration&&(flags.hasAnimations=!0,timings.animationDuration=maxDuration,temporaryStyles.push(getCssKeyframeDurationStyle(maxDuration)))),0!==maxDuration||flags.recalculateTimingStyles?(null==options.duration&&timings.transitionDuration>0&&(flags.recalculateTimingStyles=flags.recalculateTimingStyles||isFirst),maxDelayTime=maxDelay*ONE_SECOND,maxDurationTime=maxDuration*ONE_SECOND,options.skipBlocking||(flags.blockTransition=timings.transitionDuration>0,flags.blockKeyframeAnimation=timings.animationDuration>0&&stagger.animationDelay>0&&0===stagger.animationDuration),applyAnimationFromStyles(element,options),flags.blockTransition||blockTransitions(node,!1),applyBlocking(maxDuration),{$$willAnimate:!0,end:endFn,start:function(){if(!animationClosed)return runnerHost={end:endFn,cancel:cancelFn,resume:null,pause:null},runner=new $$AnimateRunner(runnerHost),waitUntilQuiet(start),runner}}):closeAndReturnNoopAnimator()}}]}],$$AnimateCssDriverProvider=["$$animationProvider",function($$animationProvider){$$animationProvider.drivers.push("$$animateCssDriver");var NG_ANIMATE_SHIM_CLASS_NAME="ng-animate-shim",NG_ANIMATE_ANCHOR_CLASS_NAME="ng-anchor",NG_OUT_ANCHOR_CLASS_NAME="ng-anchor-out",NG_IN_ANCHOR_CLASS_NAME="ng-anchor-in";this.$get=["$animateCss","$rootScope","$$AnimateRunner","$rootElement","$document","$sniffer",function($animateCss,$rootScope,$$AnimateRunner,$rootElement,$document,$sniffer){function filterCssClasses(classes){return classes.replace(/\bng-\S+\b/g,"")}function getUniqueValues(a,b){return isString(a)&&(a=a.split(" ")),isString(b)&&(b=b.split(" ")),a.filter(function(val){return-1===b.indexOf(val)}).join(" ")}function prepareAnchoredAnimation(classes,outAnchor,inAnchor){function calculateAnchorStyles(anchor){var styles={},coords=getDomNode(anchor).getBoundingClientRect();return forEach(["width","height","top","left"],function(key){var value=coords[key];switch(key){case"top":value+=bodyNode.scrollTop;break;case"left":value+=bodyNode.scrollLeft}styles[key]=Math.floor(value)+"px"}),styles}function getClassVal(element){return element.attr("class")||""}function prepareInAnimation(){var endingClasses=filterCssClasses(getClassVal(inAnchor)),toAdd=getUniqueValues(endingClasses,startingClasses),toRemove=getUniqueValues(startingClasses,endingClasses),animator=$animateCss(clone,{to:calculateAnchorStyles(inAnchor),addClass:NG_IN_ANCHOR_CLASS_NAME+" "+toAdd,removeClass:NG_OUT_ANCHOR_CLASS_NAME+" "+toRemove,delay:!0});return animator.$$willAnimate?animator:null}function end(){clone.remove(),outAnchor.removeClass(NG_ANIMATE_SHIM_CLASS_NAME),inAnchor.removeClass(NG_ANIMATE_SHIM_CLASS_NAME)}var clone=jqLite(getDomNode(outAnchor).cloneNode(!0)),startingClasses=filterCssClasses(getClassVal(clone));outAnchor.addClass(NG_ANIMATE_SHIM_CLASS_NAME),inAnchor.addClass(NG_ANIMATE_SHIM_CLASS_NAME),clone.addClass(NG_ANIMATE_ANCHOR_CLASS_NAME),rootBodyElement.append(clone);var animatorIn,animatorOut=function(){var animator=$animateCss(clone,{addClass:NG_OUT_ANCHOR_CLASS_NAME,delay:!0,from:calculateAnchorStyles(outAnchor)});return animator.$$willAnimate?animator:null}();if(!animatorOut&&!(animatorIn=prepareInAnimation()))return end();var startingAnimator=animatorOut||animatorIn;return{start:function(){function endFn(){currentAnimation&&currentAnimation.end()}var runner,currentAnimation=startingAnimator.start();return currentAnimation.done(function(){if(currentAnimation=null,!animatorIn&&(animatorIn=prepareInAnimation()))return(currentAnimation=animatorIn.start()).done(function(){currentAnimation=null,end(),runner.complete()}),currentAnimation;end(),runner.complete()}),runner=new $$AnimateRunner({end:endFn,cancel:endFn})}}}function prepareFromToAnchorAnimation(from,to,classes,anchors){var fromAnimation=prepareRegularAnimation(from),toAnimation=prepareRegularAnimation(to),anchorAnimations=[];if(forEach(anchors,function(anchor){var outElement=anchor.out,inElement=anchor.in,animator=prepareAnchoredAnimation(classes,outElement,inElement);animator&&anchorAnimations.push(animator)}),fromAnimation||toAnimation||0!==anchorAnimations.length)return{start:function(){function endFn(){forEach(animationRunners,function(runner){runner.end()})}var animationRunners=[];fromAnimation&&animationRunners.push(fromAnimation.start()),toAnimation&&animationRunners.push(toAnimation.start()),forEach(anchorAnimations,function(animation){animationRunners.push(animation.start())});var runner=new $$AnimateRunner({end:endFn,cancel:endFn});return $$AnimateRunner.all(animationRunners,function(status){runner.complete(status)}),runner}}}function prepareRegularAnimation(animationDetails){var element=animationDetails.element,options=animationDetails.options||{};animationDetails.structural?(options.structural=options.applyClassesEarly=!0,options.event=animationDetails.event,"leave"===options.event&&(options.onDone=options.domOperation)):options.event=null;var animator=$animateCss(element,options);return animator.$$willAnimate?animator:null}if(!$sniffer.animations&&!$sniffer.transitions)return noop;var bodyNode=getDomNode($document).body,rootNode=getDomNode($rootElement),rootBodyElement=jqLite(bodyNode.parentNode===rootNode?bodyNode:rootNode);return function(animationDetails){return animationDetails.from&&animationDetails.to?prepareFromToAnchorAnimation(animationDetails.from,animationDetails.to,animationDetails.classes,animationDetails.anchors):prepareRegularAnimation(animationDetails)}}]}],$$AnimateJsProvider=["$animateProvider",function($animateProvider){this.$get=["$injector","$$AnimateRunner","$$rAFMutex","$$jqLite",function($injector,$$AnimateRunner,$$rAFMutex,$$jqLite){function lookupAnimations(classes){classes=isArray(classes)?classes:classes.split(" ");for(var matches=[],flagMap={},i=0;i<classes.length;i++){var klass=classes[i],animationFactory=$animateProvider.$$registeredAnimations[klass];animationFactory&&!flagMap[klass]&&(matches.push($injector.get(animationFactory)),flagMap[klass]=!0)}return matches}var applyAnimationClasses=applyAnimationClassesFactory($$jqLite);return function(element,event,classes,options){function applyOptions(){options.domOperation(),applyAnimationClasses(element,options)}function executeAnimationFn(fn,element,event,options,onDone){var args;switch(event){case"animate":args=[element,options.from,options.to,onDone];break;case"setClass":args=[element,classesToAdd,classesToRemove,onDone];break;case"addClass":args=[element,classesToAdd,onDone];break;case"removeClass":args=[element,classesToRemove,onDone];break;default:args=[element,onDone]}args.push(options);var value=fn.apply(fn,args);if(value)if(isFunction(value.start)&&(value=value.start()),value instanceof $$AnimateRunner)value.done(onDone);else if(isFunction(value))return value;return noop}function groupEventedAnimations(element,event,options,animations,fnName){var operations=[];return forEach(animations,function(ani){var animation=ani[fnName];animation&&operations.push(function(){var runner,endProgressCb,resolved=!1,onAnimationComplete=function(rejected){resolved||(resolved=!0,(endProgressCb||noop)(rejected),runner.complete(!rejected))};return runner=new $$AnimateRunner({end:function(){onAnimationComplete()},cancel:function(){onAnimationComplete(!0)}}),endProgressCb=executeAnimationFn(animation,element,event,options,function(result){onAnimationComplete(!1===result)}),runner})}),operations}function packageAnimations(element,event,options,animations,fnName){var operations=groupEventedAnimations(element,event,options,animations,fnName);if(0===operations.length){var a,b;"beforeSetClass"===fnName?(a=groupEventedAnimations(element,"removeClass",options,animations,"beforeRemoveClass"),b=groupEventedAnimations(element,"addClass",options,animations,"beforeAddClass")):"setClass"===fnName&&(a=groupEventedAnimations(element,"removeClass",options,animations,"removeClass"),b=groupEventedAnimations(element,"addClass",options,animations,"addClass")),a&&(operations=operations.concat(a)),b&&(operations=operations.concat(b))}if(0!==operations.length)return function(callback){var runners=[];return operations.length&&forEach(operations,function(animateFn){runners.push(animateFn())}),runners.length?$$AnimateRunner.all(runners,callback):callback(),function(reject){forEach(runners,function(runner){reject?runner.cancel():runner.end()})}}}3===arguments.length&&isObject(classes)&&(options=classes,classes=null),options=prepareAnimationOptions(options),classes||(classes=element.attr("class")||"",options.addClass&&(classes+=" "+options.addClass),options.removeClass&&(classes+=" "+options.removeClass));var before,after,classesToAdd=options.addClass,classesToRemove=options.removeClass,animations=lookupAnimations(classes);if(animations.length){var afterFn,beforeFn;"leave"==event?(beforeFn="leave",afterFn="afterLeave"):(beforeFn="before"+event.charAt(0).toUpperCase()+event.substr(1),afterFn=event),"enter"!==event&&"move"!==event&&(before=packageAnimations(element,event,options,animations,beforeFn)),after=packageAnimations(element,event,options,animations,afterFn)}if(before||after)return{start:function(){function onComplete(success){animationClosed=!0,applyOptions(),applyAnimationStyles(element,options),runner.complete(success)}function endAnimations(cancelled){animationClosed||((closeActiveAnimations||noop)(cancelled),onComplete(cancelled))}var closeActiveAnimations,chain=[];before&&chain.push(function(fn){closeActiveAnimations=before(fn)}),chain.length?chain.push(function(fn){applyOptions(),fn(!0)}):applyOptions(),after&&chain.push(function(fn){closeActiveAnimations=after(fn)});var animationClosed=!1,runner=new $$AnimateRunner({end:function(){endAnimations()},cancel:function(){endAnimations(!0)}});return $$AnimateRunner.chain(chain,onComplete),runner}}}}]}],$$AnimateJsDriverProvider=["$$animationProvider",function($$animationProvider){$$animationProvider.drivers.push("$$animateJsDriver"),this.$get=["$$animateJs","$$AnimateRunner",function($$animateJs,$$AnimateRunner){function prepareAnimation(animationDetails){var element=animationDetails.element,event=animationDetails.event,options=animationDetails.options,classes=animationDetails.classes;return $$animateJs(element,event,classes,options)}return function(animationDetails){if(animationDetails.from&&animationDetails.to){var fromAnimation=prepareAnimation(animationDetails.from),toAnimation=prepareAnimation(animationDetails.to);if(!fromAnimation&&!toAnimation)return;return{start:function(){function endFnFactory(){return function(){forEach(animationRunners,function(runner){runner.end()})}}var animationRunners=[];fromAnimation&&animationRunners.push(fromAnimation.start()),toAnimation&&animationRunners.push(toAnimation.start()),$$AnimateRunner.all(animationRunners,function(status){runner.complete(status)});var runner=new $$AnimateRunner({end:endFnFactory(),cancel:endFnFactory()});return runner}}}return prepareAnimation(animationDetails)}}]}],NG_ANIMATE_ATTR_NAME="data-ng-animate",NG_ANIMATE_PIN_DATA="$ngAnimatePin",$$AnimateQueueProvider=["$animateProvider",function($animateProvider){function isAllowed(ruleType,element,currentAnimation,previousAnimation){return rules[ruleType].some(function(fn){return fn(element,currentAnimation,previousAnimation)})}function hasAnimationClasses(options,and){var a=((options=options||{}).addClass||"").length>0,b=(options.removeClass||"").length>0;return and?a&&b:a||b}var PRE_DIGEST_STATE=1,RUNNING_STATE=2,rules=this.rules={skip:[],cancel:[],join:[]};rules.join.push(function(element,newAnimation,currentAnimation){return!newAnimation.structural&&hasAnimationClasses(newAnimation.options)}),rules.skip.push(function(element,newAnimation,currentAnimation){return!newAnimation.structural&&!hasAnimationClasses(newAnimation.options)}),rules.skip.push(function(element,newAnimation,currentAnimation){return"leave"==currentAnimation.event&&newAnimation.structural}),rules.skip.push(function(element,newAnimation,currentAnimation){return currentAnimation.structural&&!newAnimation.structural}),rules.cancel.push(function(element,newAnimation,currentAnimation){return currentAnimation.structural&&newAnimation.structural}),rules.cancel.push(function(element,newAnimation,currentAnimation){return currentAnimation.state===RUNNING_STATE&&newAnimation.structural}),rules.cancel.push(function(element,newAnimation,currentAnimation){var nO=newAnimation.options,cO=currentAnimation.options;return nO.addClass&&nO.addClass===cO.removeClass||nO.removeClass&&nO.removeClass===cO.addClass}),this.$get=["$$rAF","$rootScope","$rootElement","$document","$$HashMap","$$animation","$$AnimateRunner","$templateRequest","$$jqLite",function($$rAF,$rootScope,$rootElement,$document,$$HashMap,$$animation,$$AnimateRunner,$templateRequest,$$jqLite){function normalizeAnimationOptions(element,options){return mergeAnimationOptions(element,options,{})}function findCallbacks(element,event){var targetNode=getDomNode(element),matches=[],entries=callbackRegistry[event];return entries&&forEach(entries,function(entry){entry.node.contains(targetNode)&&matches.push(entry.callback)}),matches}function triggerCallback(event,element,phase,data){$$rAF(function(){forEach(findCallbacks(element,event),function(callback){callback(element,phase,data)})})}function queueAnimation(element,event,options){function notifyProgress(runner,event,phase,data){triggerCallback(event,element,phase,data),runner.progress(event,phase,data)}function close(reject){applyAnimationClasses(element,options),applyAnimationStyles(element,options),options.domOperation(),runner.complete(!reject)}var node,parent;(element=stripCommentsFromElement(element))&&(node=getDomNode(element),parent=element.parent()),options=prepareAnimationOptions(options);var runner=new $$AnimateRunner;if(!node)return close(),runner;isArray(options.addClass)&&(options.addClass=options.addClass.join(" ")),isArray(options.removeClass)&&(options.removeClass=options.removeClass.join(" ")),options.from&&!isObject(options.from)&&(options.from=null),options.to&&!isObject(options.to)&&(options.to=null);var className=[node.className,options.addClass,options.removeClass].join(" ");if(!isAnimatableClassName(className))return close(),runner;var isStructural=["enter","move","leave"].indexOf(event)>=0,skipAnimations=!animationsEnabled||disabledElementsLookup.get(node),existingAnimation=!skipAnimations&&activeAnimationsLookup.get(node)||{},hasExistingAnimation=!!existingAnimation.state;if(skipAnimations||hasExistingAnimation&&existingAnimation.state==PRE_DIGEST_STATE||(skipAnimations=!areAnimationsAllowed(element,parent,event)),skipAnimations)return close(),runner;isStructural&&closeChildAnimations(element);var newAnimation={structural:isStructural,element:element,event:event,close:close,options:options,runner:runner};if(hasExistingAnimation){if(isAllowed("skip",element,newAnimation,existingAnimation))return existingAnimation.state===RUNNING_STATE?(close(),runner):(mergeAnimationOptions(element,existingAnimation.options,options),existingAnimation.runner);if(isAllowed("cancel",element,newAnimation,existingAnimation))existingAnimation.state===RUNNING_STATE?existingAnimation.runner.end():existingAnimation.structural?existingAnimation.close():mergeAnimationOptions(element,newAnimation.options,existingAnimation.options);else if(isAllowed("join",element,newAnimation,existingAnimation)){if(existingAnimation.state!==RUNNING_STATE)return event=newAnimation.event=existingAnimation.event,options=mergeAnimationOptions(element,existingAnimation.options,newAnimation.options),runner;normalizeAnimationOptions(element,options)}}else normalizeAnimationOptions(element,options);var isValidAnimation=newAnimation.structural;if(isValidAnimation||(isValidAnimation="animate"===newAnimation.event&&Object.keys(newAnimation.options.to||{}).length>0||hasAnimationClasses(newAnimation.options)),!isValidAnimation)return close(),clearElementAnimationState(element),runner;isStructural&&closeParentClassBasedAnimations(parent);var counter=(existingAnimation.counter||0)+1;return newAnimation.counter=counter,markElementAnimationState(element,PRE_DIGEST_STATE,newAnimation),$rootScope.$$postDigest(function(){var animationDetails=activeAnimationsLookup.get(node),animationCancelled=!animationDetails;animationDetails=animationDetails||{};var parentElement=element.parent()||[],isValidAnimation=parentElement.length>0&&("animate"===animationDetails.event||animationDetails.structural||hasAnimationClasses(animationDetails.options));if(animationCancelled||animationDetails.counter!==counter||!isValidAnimation)return animationCancelled&&(applyAnimationClasses(element,options),applyAnimationStyles(element,options)),(animationCancelled||isStructural&&animationDetails.event!==event)&&(options.domOperation(),runner.end()),void(isValidAnimation||clearElementAnimationState(element));event=!animationDetails.structural&&hasAnimationClasses(animationDetails.options,!0)?"setClass":animationDetails.event,animationDetails.structural&&closeParentClassBasedAnimations(parentElement),markElementAnimationState(element,RUNNING_STATE);var realRunner=$$animation(element,event,animationDetails.options);realRunner.done(function(status){close(!status);var animationDetails=activeAnimationsLookup.get(node);animationDetails&&animationDetails.counter===counter&&clearElementAnimationState(getDomNode(element)),notifyProgress(runner,event,"close",{})}),runner.setHost(realRunner),notifyProgress(runner,event,"start",{})}),runner}function closeChildAnimations(element){var children=getDomNode(element).querySelectorAll("["+NG_ANIMATE_ATTR_NAME+"]");forEach(children,function(child){var state=parseInt(child.getAttribute(NG_ANIMATE_ATTR_NAME)),animationDetails=activeAnimationsLookup.get(child);switch(state){case RUNNING_STATE:animationDetails.runner.end();case PRE_DIGEST_STATE:animationDetails&&activeAnimationsLookup.remove(child)}})}function clearElementAnimationState(element){var node=getDomNode(element);node.removeAttribute(NG_ANIMATE_ATTR_NAME),activeAnimationsLookup.remove(node)}function isMatchingElement(nodeOrElmA,nodeOrElmB){return getDomNode(nodeOrElmA)===getDomNode(nodeOrElmB)}function closeParentClassBasedAnimations(startingElement){for(var parentNode=getDomNode(startingElement);;){if(!parentNode||parentNode.nodeType!==ELEMENT_NODE)break;var animationDetails=activeAnimationsLookup.get(parentNode);animationDetails&&function(node,animationDetails){!animationDetails.structural&&hasAnimationClasses(animationDetails.options)&&(animationDetails.state===RUNNING_STATE&&animationDetails.runner.end(),clearElementAnimationState(node))}(parentNode,animationDetails),parentNode=parentNode.parentNode}}function areAnimationsAllowed(element,parentElement,event){var animateChildren,bodyElementDetected=!1,rootElementDetected=!1,parentAnimationDetected=!1,parentHost=element.data(NG_ANIMATE_PIN_DATA);for(parentHost&&(parentElement=parentHost);parentElement&&parentElement.length;){rootElementDetected||(rootElementDetected=isMatchingElement(parentElement,$rootElement));var parentNode=parentElement[0];if(parentNode.nodeType!==ELEMENT_NODE)break;var details=activeAnimationsLookup.get(parentNode)||{};if(parentAnimationDetected||(parentAnimationDetected=details.structural||disabledElementsLookup.get(parentNode)),isUndefined(animateChildren)||!0===animateChildren){var value=parentElement.data(NG_ANIMATE_CHILDREN_DATA);isDefined(value)&&(animateChildren=value)}if(parentAnimationDetected&&!1===animateChildren)break;rootElementDetected||(rootElementDetected=isMatchingElement(parentElement,$rootElement))||(parentHost=parentElement.data(NG_ANIMATE_PIN_DATA))&&(parentElement=parentHost),bodyElementDetected||(bodyElementDetected=isMatchingElement(parentElement,bodyElement)),parentElement=parentElement.parent()}return(!parentAnimationDetected||animateChildren)&&rootElementDetected&&bodyElementDetected}function markElementAnimationState(element,state,details){(details=details||{}).state=state;var node=getDomNode(element);node.setAttribute(NG_ANIMATE_ATTR_NAME,state);var oldValue=activeAnimationsLookup.get(node),newValue=oldValue?extend(oldValue,details):details;activeAnimationsLookup.put(node,newValue)}var activeAnimationsLookup=new $$HashMap,disabledElementsLookup=new $$HashMap,animationsEnabled=null,deregisterWatch=$rootScope.$watch(function(){return 0===$templateRequest.totalPendingRequests},function(isEmpty){isEmpty&&(deregisterWatch(),$rootScope.$$postDigest(function(){$rootScope.$$postDigest(function(){null===animationsEnabled&&(animationsEnabled=!0)})}))}),bodyElement=jqLite($document[0].body),callbackRegistry={},classNameFilter=$animateProvider.classNameFilter(),isAnimatableClassName=classNameFilter?function(className){return classNameFilter.test(className)}:function(){return!0},applyAnimationClasses=applyAnimationClassesFactory($$jqLite);return{on:function(event,container,callback){var node=extractElementNode(container);callbackRegistry[event]=callbackRegistry[event]||[],callbackRegistry[event].push({node:node,callback:callback})},off:function(event,container,callback){var entries=callbackRegistry[event];entries&&(callbackRegistry[event]=1===arguments.length?null:function(list,matchContainer,matchCallback){var containerNode=extractElementNode(matchContainer);return list.filter(function(entry){return!(entry.node===containerNode&&(!matchCallback||entry.callback===matchCallback))})}(entries,container,callback))},pin:function(element,parentElement){assertArg(isElement(element),"element","not an element"),assertArg(isElement(parentElement),"parentElement","not an element"),element.data(NG_ANIMATE_PIN_DATA,parentElement)},push:function(element,event,options,domOperation){return options=options||{},options.domOperation=domOperation,queueAnimation(element,event,options)},enabled:function(element,bool){var argCount=arguments.length;if(0===argCount)bool=!!animationsEnabled;else if(isElement(element)){var node=getDomNode(element),recordExists=disabledElementsLookup.get(node);1===argCount?bool=!recordExists:(bool=!!bool)?recordExists&&disabledElementsLookup.remove(node):disabledElementsLookup.put(node,!0)}else bool=animationsEnabled=!!element;return bool}}}]}],$$rAFMutexFactory=["$$rAF",function($$rAF){return function(){var passed=!1;return $$rAF(function(){passed=!0}),function(fn){passed?fn():$$rAF(fn)}}}],$$AnimateRunnerFactory=["$q","$$rAFMutex",function($q,$$rAFMutex){function AnimateRunner(host){this.setHost(host),this._doneCallbacks=[],this._runInAnimationFrame=$$rAFMutex(),this._state=0}return AnimateRunner.chain=function(chain,callback){function next(){index!==chain.length?chain[index](function(response){!1!==response?(index++,next()):callback(!1)}):callback(!0)}var index=0;next()},AnimateRunner.all=function(runners,callback){function onProgress(response){status=status&&response,++count===runners.length&&callback(status)}var count=0,status=!0;forEach(runners,function(runner){runner.done(onProgress)})},AnimateRunner.prototype={setHost:function(host){this.host=host||{}},done:function(fn){2===this._state?fn():this._doneCallbacks.push(fn)},progress:noop,getPromise:function(){if(!this.promise){var self=this;this.promise=$q(function(resolve,reject){self.done(function(status){!1===status?reject():resolve()})})}return this.promise},then:function(resolveHandler,rejectHandler){return this.getPromise().then(resolveHandler,rejectHandler)},catch:function(handler){return this.getPromise().catch(handler)},finally:function(handler){return this.getPromise().finally(handler)},pause:function(){this.host.pause&&this.host.pause()},resume:function(){this.host.resume&&this.host.resume()},end:function(){this.host.end&&this.host.end(),this._resolve(!0)},cancel:function(){this.host.cancel&&this.host.cancel(),this._resolve(!1)},complete:function(response){var self=this;0===self._state&&(self._state=1,self._runInAnimationFrame(function(){self._resolve(response)}))},_resolve:function(response){2!==this._state&&(forEach(this._doneCallbacks,function(fn){fn(response)}),this._doneCallbacks.length=0,this._state=2)}},AnimateRunner}],$$AnimationProvider=["$animateProvider",function($animateProvider){function setRunner(element,runner){element.data(RUNNER_STORAGE_KEY,runner)}function removeRunner(element){element.removeData(RUNNER_STORAGE_KEY)}function getRunner(element){return element.data(RUNNER_STORAGE_KEY)}var NG_ANIMATE_REF_ATTR="ng-animate-ref",drivers=this.drivers=[],RUNNER_STORAGE_KEY="$$animationRunner";this.$get=["$$jqLite","$rootScope","$injector","$$AnimateRunner","$$rAFScheduler",function($$jqLite,$rootScope,$injector,$$AnimateRunner,$$rAFScheduler){var animationQueue=[],applyAnimationClasses=applyAnimationClassesFactory($$jqLite),totalPendingClassBasedAnimations=0,totalActiveClassBasedAnimations=0,classBasedAnimationsQueue=[];return function(element,event,options){function getAnchorNodes(node){var SELECTOR="["+NG_ANIMATE_REF_ATTR+"]",items=node.hasAttribute(NG_ANIMATE_REF_ATTR)?[node]:node.querySelectorAll(SELECTOR),anchors=[];return forEach(items,function(node){var attr=node.getAttribute(NG_ANIMATE_REF_ATTR);attr&&attr.length&&anchors.push(node)}),anchors}function groupAnimations(animations){var preparedAnimations=[],refLookup={};forEach(animations,function(animation,index){var node=getDomNode(animation.element),event=animation.event,enterOrMove=["enter","move"].indexOf(event)>=0,anchorNodes=animation.structural?getAnchorNodes(node):[];if(anchorNodes.length){var direction=enterOrMove?"to":"from";forEach(anchorNodes,function(anchor){var key=anchor.getAttribute(NG_ANIMATE_REF_ATTR);refLookup[key]=refLookup[key]||{},refLookup[key][direction]={animationID:index,element:jqLite(anchor)}})}else preparedAnimations.push(animation)});var usedIndicesLookup={},anchorGroups={};return forEach(refLookup,function(operations,key){var from=operations.from,to=operations.to;if(from&&to){var fromAnimation=animations[from.animationID],toAnimation=animations[to.animationID],lookupKey=from.animationID.toString();if(!anchorGroups[lookupKey]){var group=anchorGroups[lookupKey]={structural:!0,beforeStart:function(){fromAnimation.beforeStart(),toAnimation.beforeStart()},close:function(){fromAnimation.close(),toAnimation.close()},classes:cssClassesIntersection(fromAnimation.classes,toAnimation.classes),from:fromAnimation,to:toAnimation,anchors:[]};group.classes.length?preparedAnimations.push(group):(preparedAnimations.push(fromAnimation),preparedAnimations.push(toAnimation))}anchorGroups[lookupKey].anchors.push({out:from.element,in:to.element})}else{var index=from?from.animationID:to.animationID,indexKey=index.toString();usedIndicesLookup[indexKey]||(usedIndicesLookup[indexKey]=!0,preparedAnimations.push(animations[index]))}}),preparedAnimations}function cssClassesIntersection(a,b){a=a.split(" "),b=b.split(" ");for(var matches=[],i=0;i<a.length;i++){var aa=a[i];if("ng-"!==aa.substring(0,3))for(var j=0;j<b.length;j++)if(aa===b[j]){matches.push(aa);break}}return matches.join(" ")}function invokeFirstDriver(animationDetails){for(var i=drivers.length-1;i>=0;i--){var driverName=drivers[i];if($injector.has(driverName)){var driver=$injector.get(driverName)(animationDetails);if(driver)return driver}}}function updateAnimationRunners(animation,newRunner){function update(element){getRunner(element).setHost(newRunner)}animation.from&&animation.to?(update(animation.from.element),update(animation.to.element)):update(animation.element)}function handleDestroyedElement(){var runner=getRunner(element);!runner||"leave"===event&&options.$$domOperationFired||runner.end()}function close(rejected){element.off("$destroy",handleDestroyedElement),removeRunner(element),applyAnimationClasses(element,options),applyAnimationStyles(element,options),options.domOperation(),tempClasses&&$$jqLite.removeClass(element,tempClasses),element.removeClass(NG_ANIMATE_CLASSNAME),runner.complete(!rejected)}options=prepareAnimationOptions(options);var isStructural=["enter","move","leave"].indexOf(event)>=0,runner=new $$AnimateRunner({end:function(){close()},cancel:function(){close(!0)}});if(!drivers.length)return close(),runner;setRunner(element,runner);var classes=mergeClasses(element.attr("class"),mergeClasses(options.addClass,options.removeClass)),tempClasses=options.tempClasses;tempClasses&&(classes+=" "+tempClasses,options.tempClasses=null);var classBasedIndex;return isStructural||(classBasedIndex=totalPendingClassBasedAnimations,totalPendingClassBasedAnimations+=1),animationQueue.push({element:element,classes:classes,event:event,classBasedIndex:classBasedIndex,structural:isStructural,options:options,beforeStart:function(){element.addClass(NG_ANIMATE_CLASSNAME),tempClasses&&$$jqLite.addClass(element,tempClasses)},close:close}),element.on("$destroy",handleDestroyedElement),animationQueue.length>1?runner:($rootScope.$$postDigest(function(){totalActiveClassBasedAnimations=totalPendingClassBasedAnimations,totalPendingClassBasedAnimations=0,classBasedAnimationsQueue.length=0;var animations=[];forEach(animationQueue,function(entry){getRunner(entry.element)&&animations.push(entry)}),animationQueue.length=0,forEach(groupAnimations(animations),function(animationEntry){function triggerAnimationStart(){animationEntry.beforeStart();var startAnimationFn,closeFn=animationEntry.close,targetElement=animationEntry.anchors?animationEntry.from.element||animationEntry.to.element:animationEntry.element;if(getRunner(targetElement)&&getDomNode(targetElement).parentNode){var operation=invokeFirstDriver(animationEntry);operation&&(startAnimationFn=operation.start)}if(startAnimationFn){var animationRunner=startAnimationFn();animationRunner.done(function(status){closeFn(!status)}),updateAnimationRunners(animationEntry,animationRunner)}else closeFn()}animationEntry.structural?triggerAnimationStart():(classBasedAnimationsQueue.push({node:getDomNode(animationEntry.element),fn:triggerAnimationStart}),animationEntry.classBasedIndex===totalActiveClassBasedAnimations-1&&(classBasedAnimationsQueue=classBasedAnimationsQueue.sort(function(a,b){return b.node.contains(a.node)}).map(function(entry){return entry.fn}),$$rAFScheduler(classBasedAnimationsQueue)))})}),runner)}}]}];angular.module("ngAnimate",[]).directive("ngAnimateChildren",$$AnimateChildrenDirective).factory("$$rAFMutex",$$rAFMutexFactory).factory("$$rAFScheduler",$$rAFSchedulerFactory).factory("$$AnimateRunner",$$AnimateRunnerFactory).provider("$$animateQueue",$$AnimateQueueProvider).provider("$$animation",$$AnimationProvider).provider("$animateCss",$AnimateCssProvider).provider("$$animateCssDriver",$$AnimateCssDriverProvider).provider("$$animateJs",$$AnimateJsProvider).provider("$$animateJsDriver",$$AnimateJsDriverProvider)}(window,window.angular),function(window,angular,undefined){"use strict";function sanitizeText(chars){var buf=[];return htmlSanitizeWriter(buf,angular.noop).chars(chars),buf.join("")}function makeMap(str,lowercaseKeys){var i,obj={},items=str.split(",");for(i=0;i<items.length;i++)obj[lowercaseKeys?angular.lowercase(items[i]):items[i]]=!0;return obj}function htmlParser(html,handler){function parseEndTag(tag,tagName){var i,pos=0;if(tagName=angular.lowercase(tagName))for(pos=stack.length-1;pos>=0&&stack[pos]!=tagName;pos--);if(pos>=0){for(i=stack.length-1;i>=pos;i--)handler.end&&handler.end(stack[i]);stack.length=pos}}"string"!=typeof html&&(html=null===html||void 0===html?"":""+html);var index,chars,match,text,stack=[],last=html;for(stack.last=function(){return stack[stack.length-1]};html;){if(text="",chars=!0,stack.last()&&specialElements[stack.last()]?(html=html.replace(new RegExp("([\\W\\w]*)<\\s*\\/\\s*"+stack.last()+"[^>]*>","i"),function(all,text){return text=text.replace(COMMENT_REGEXP,"$1").replace(CDATA_REGEXP,"$1"),handler.chars&&handler.chars(decodeEntities(text)),""}),parseEndTag(0,stack.last())):(0===html.indexOf("\x3c!--")?(index=html.indexOf("--",4))>=0&&html.lastIndexOf("--\x3e",index)===index&&(handler.comment&&handler.comment(html.substring(4,index)),html=html.substring(index+3),chars=!1):DOCTYPE_REGEXP.test(html)?(match=html.match(DOCTYPE_REGEXP))&&(html=html.replace(match[0],""),chars=!1):BEGING_END_TAGE_REGEXP.test(html)?(match=html.match(END_TAG_REGEXP))&&(html=html.substring(match[0].length),match[0].replace(END_TAG_REGEXP,parseEndTag),chars=!1):BEGIN_TAG_REGEXP.test(html)&&((match=html.match(START_TAG_REGEXP))?(match[4]&&(html=html.substring(match[0].length),match[0].replace(START_TAG_REGEXP,function(tag,tagName,rest,unary){if(tagName=angular.lowercase(tagName),blockElements[tagName])for(;stack.last()&&inlineElements[stack.last()];)parseEndTag(0,stack.last());optionalEndTagElements[tagName]&&stack.last()==tagName&&parseEndTag(0,tagName),(unary=voidElements[tagName]||!!unary)||stack.push(tagName);var attrs={};rest.replace(ATTR_REGEXP,function(match,name,doubleQuotedValue,singleQuotedValue,unquotedValue){var value=doubleQuotedValue||singleQuotedValue||unquotedValue||"";attrs[name]=decodeEntities(value)}),handler.start&&handler.start(tagName,attrs,unary)})),chars=!1):(text+="<",html=html.substring(1))),chars&&(text+=(index=html.indexOf("<"))<0?html:html.substring(0,index),html=index<0?"":html.substring(index),handler.chars&&handler.chars(decodeEntities(text)))),html==last)throw $sanitizeMinErr("badparse","The sanitizer was unable to parse the following block of html: {0}",html);last=html}parseEndTag()}function decodeEntities(value){return value?(hiddenPre.innerHTML=value.replace(/</g,"&lt;"),hiddenPre.textContent):""}function encodeEntities(value){return value.replace(/&/g,"&amp;").replace(SURROGATE_PAIR_REGEXP,function(value){return"&#"+(1024*(value.charCodeAt(0)-55296)+(value.charCodeAt(1)-56320)+65536)+";"}).replace(NON_ALPHANUMERIC_REGEXP,function(value){return"&#"+value.charCodeAt(0)+";"}).replace(/</g,"&lt;").replace(/>/g,"&gt;")}function htmlSanitizeWriter(buf,uriValidator){var ignore=!1,out=angular.bind(buf,buf.push);return{start:function(tag,attrs,unary){tag=angular.lowercase(tag),!ignore&&specialElements[tag]&&(ignore=tag),ignore||!0!==validElements[tag]||(out("<"),out(tag),angular.forEach(attrs,function(value,key){var lkey=angular.lowercase(key),isImage="img"===tag&&"src"===lkey||"background"===lkey;!0!==validAttrs[lkey]||!0===uriAttrs[lkey]&&!uriValidator(value,isImage)||(out(" "),out(key),out('="'),out(encodeEntities(value)),out('"'))}),out(unary?"/>":">"))},end:function(tag){tag=angular.lowercase(tag),ignore||!0!==validElements[tag]||(out("</"),out(tag),out(">")),tag==ignore&&(ignore=!1)},chars:function(chars){ignore||out(encodeEntities(chars))}}}var $sanitizeMinErr=angular.$$minErr("$sanitize"),START_TAG_REGEXP=/^<((?:[a-zA-Z])[\w:-]*)((?:\s+[\w:-]+(?:\s*=\s*(?:(?:"[^"]*")|(?:'[^']*')|[^>\s]+))?)*)\s*(\/?)\s*(>?)/,END_TAG_REGEXP=/^<\/\s*([\w:-]+)[^>]*>/,ATTR_REGEXP=/([\w:-]+)(?:\s*=\s*(?:(?:"((?:[^"])*)")|(?:'((?:[^'])*)')|([^>\s]+)))?/g,BEGIN_TAG_REGEXP=/^</,BEGING_END_TAGE_REGEXP=/^<\//,COMMENT_REGEXP=/<!--(.*?)-->/g,DOCTYPE_REGEXP=/<!DOCTYPE([^>]*?)>/i,CDATA_REGEXP=/<!\[CDATA\[(.*?)]]>/g,SURROGATE_PAIR_REGEXP=/[\uD800-\uDBFF][\uDC00-\uDFFF]/g,NON_ALPHANUMERIC_REGEXP=/([^\#-~| |!])/g,voidElements=makeMap("area,br,col,hr,img,wbr"),optionalEndTagBlockElements=makeMap("colgroup,dd,dt,li,p,tbody,td,tfoot,th,thead,tr"),optionalEndTagInlineElements=makeMap("rp,rt"),optionalEndTagElements=angular.extend({},optionalEndTagInlineElements,optionalEndTagBlockElements),blockElements=angular.extend({},optionalEndTagBlockElements,makeMap("address,article,aside,blockquote,caption,center,del,dir,div,dl,figure,figcaption,footer,h1,h2,h3,h4,h5,h6,header,hgroup,hr,ins,map,menu,nav,ol,pre,script,section,table,ul")),inlineElements=angular.extend({},optionalEndTagInlineElements,makeMap("a,abbr,acronym,b,bdi,bdo,big,br,cite,code,del,dfn,em,font,i,img,ins,kbd,label,map,mark,q,ruby,rp,rt,s,samp,small,span,strike,strong,sub,sup,time,tt,u,var")),svgElements=makeMap("circle,defs,desc,ellipse,font-face,font-face-name,font-face-src,g,glyph,hkern,image,linearGradient,line,marker,metadata,missing-glyph,mpath,path,polygon,polyline,radialGradient,rect,stop,svg,switch,text,title,tspan,use"),specialElements=makeMap("script,style"),validElements=angular.extend({},voidElements,blockElements,inlineElements,optionalEndTagElements,svgElements),uriAttrs=makeMap("background,cite,href,longdesc,src,usemap,xlink:href"),htmlAttrs=makeMap("abbr,align,alt,axis,bgcolor,border,cellpadding,cellspacing,class,clear,color,cols,colspan,compact,coords,dir,face,headers,height,hreflang,hspace,ismap,lang,language,nohref,nowrap,rel,rev,rows,rowspan,rules,scope,scrolling,shape,size,span,start,summary,tabindex,target,title,type,valign,value,vspace,width"),svgAttrs=makeMap("accent-height,accumulate,additive,alphabetic,arabic-form,ascent,baseProfile,bbox,begin,by,calcMode,cap-height,class,color,color-rendering,content,cx,cy,d,dx,dy,descent,display,dur,end,fill,fill-rule,font-family,font-size,font-stretch,font-style,font-variant,font-weight,from,fx,fy,g1,g2,glyph-name,gradientUnits,hanging,height,horiz-adv-x,horiz-origin-x,ideographic,k,keyPoints,keySplines,keyTimes,lang,marker-end,marker-mid,marker-start,markerHeight,markerUnits,markerWidth,mathematical,max,min,offset,opacity,orient,origin,overline-position,overline-thickness,panose-1,path,pathLength,points,preserveAspectRatio,r,refX,refY,repeatCount,repeatDur,requiredExtensions,requiredFeatures,restart,rotate,rx,ry,slope,stemh,stemv,stop-color,stop-opacity,strikethrough-position,strikethrough-thickness,stroke,stroke-dasharray,stroke-dashoffset,stroke-linecap,stroke-linejoin,stroke-miterlimit,stroke-opacity,stroke-width,systemLanguage,target,text-anchor,to,transform,type,u1,u2,underline-position,underline-thickness,unicode,unicode-range,units-per-em,values,version,viewBox,visibility,width,widths,x,x-height,x1,x2,xlink:actuate,xlink:arcrole,xlink:role,xlink:show,xlink:title,xlink:type,xml:base,xml:lang,xml:space,xmlns,xmlns:xlink,y,y1,y2,zoomAndPan",!0),validAttrs=angular.extend({},uriAttrs,svgAttrs,htmlAttrs),hiddenPre=document.createElement("pre");angular.module("ngSanitize",[]).provider("$sanitize",function(){this.$get=["$$sanitizeUri",function($$sanitizeUri){return function(html){var buf=[];return htmlParser(html,htmlSanitizeWriter(buf,function(uri,isImage){return!/^unsafe/.test($$sanitizeUri(uri,isImage))})),buf.join("")}}]}),angular.module("ngSanitize").filter("linky",["$sanitize",function($sanitize){var LINKY_URL_REGEXP=/((ftp|https?):\/\/|(www\.)|(mailto:)?[A-Za-z0-9._%+-]+@)\S*[^\s.;,(){}<>"”’]/i,MAILTO_REGEXP=/^mailto:/i;return function(text,target){function addText(text){text&&html.push(sanitizeText(text))}if(!text)return text;for(var match,url,i,raw=text,html=[];match=raw.match(LINKY_URL_REGEXP);)url=match[0],match[2]||match[4]||(url=(match[3]?"http://":"mailto:")+url),i=match.index,addText(raw.substr(0,i)),function(url,text){html.push("<a "),angular.isDefined(target)&&html.push('target="',target,'" '),html.push('href="',url.replace(/"/g,"&quot;"),'">'),addText(text),html.push("</a>")}(url,match[0].replace(MAILTO_REGEXP,"")),raw=raw.substring(i+match[0].length);return addText(raw),$sanitize(html.join(""))}}])}(window,window.angular),"undefined"!=typeof module&&"undefined"!=typeof exports&&module.exports===exports&&(module.exports="ui.router"),function(window,angular,undefined){"use strict";function inherit(parent,extra){return extend(new(extend(function(){},{prototype:parent})),extra)}function merge(dst){return forEach(arguments,function(obj){obj!==dst&&forEach(obj,function(value,key){dst.hasOwnProperty(key)||(dst[key]=value)})}),dst}function ancestors(first,second){var path=[];for(var n in first.path){if(first.path[n]!==second.path[n])break;path.push(first.path[n])}return path}function objectKeys(object){if(Object.keys)return Object.keys(object);var result=[];return angular.forEach(object,function(val,key){result.push(key)}),result}function indexOf(array,value){if(Array.prototype.indexOf)return array.indexOf(value,Number(arguments[2])||0);var len=array.length>>>0,from=Number(arguments[2])||0;for((from=from<0?Math.ceil(from):Math.floor(from))<0&&(from+=len);from<len;from++)if(from in array&&array[from]===value)return from;return-1}function inheritParams(currentParams,newParams,$current,$to){var parentParams,parents=ancestors($current,$to),inherited={},inheritList=[];for(var i in parents)if(parents[i].params&&(parentParams=objectKeys(parents[i].params)).length)for(var j in parentParams)indexOf(inheritList,parentParams[j])>=0||(inheritList.push(parentParams[j]),inherited[parentParams[j]]=currentParams[parentParams[j]]);return extend({},inherited,newParams)}function equalForKeys(a,b,keys){if(!keys){keys=[];for(var n in a)keys.push(n)}for(var i=0;i<keys.length;i++){var k=keys[i];if(a[k]!=b[k])return!1}return!0}function filterByKeys(keys,values){var filtered={};return forEach(keys,function(name){filtered[name]=values[name]}),filtered}function omit(obj){var copy={},keys=Array.prototype.concat.apply(Array.prototype,Array.prototype.slice.call(arguments,1));for(var key in obj)-1==indexOf(keys,key)&&(copy[key]=obj[key]);return copy}function filter(collection,callback){var array=isArray(collection),result=array?[]:{};return forEach(collection,function(val,i){callback(val,i)&&(result[array?result.length:i]=val)}),result}function map(collection,callback){var result=isArray(collection)?[]:{};return forEach(collection,function(val,i){result[i]=callback(val,i)}),result}function $Resolve($q,$injector){var VISIT_IN_PROGRESS=1,VISIT_DONE=2,NOTHING={},NO_DEPENDENCIES=[],NO_LOCALS=NOTHING,NO_PARENT=extend($q.when(NOTHING),{$$promises:NOTHING,$$values:NOTHING});this.study=function(invocables){function visit(value,key){if(visited[key]!==VISIT_DONE){if(cycle.push(key),visited[key]===VISIT_IN_PROGRESS)throw cycle.splice(0,indexOf(cycle,key)),new Error("Cyclic dependency: "+cycle.join(" -> "));if(visited[key]=VISIT_IN_PROGRESS,isString(value))plan.push(key,[function(){return $injector.get(value)}],NO_DEPENDENCIES);else{var params=$injector.annotate(value);forEach(params,function(param){param!==key&&invocables.hasOwnProperty(param)&&visit(invocables[param],param)}),plan.push(key,value,params)}cycle.pop(),visited[key]=VISIT_DONE}}function isResolve(value){return isObject(value)&&value.then&&value.$$promises}if(!isObject(invocables))throw new Error("'invocables' must be an object");var invocableKeys=objectKeys(invocables||{}),plan=[],cycle=[],visited={};return forEach(invocables,visit),invocables=cycle=visited=null,function(locals,parent,self){function done(){--wait||(merged||merge(values,parent.$$values),result.$$values=values,result.$$promises=result.$$promises||!0,delete result.$$inheritedValues,resolution.resolve(values))}function fail(reason){result.$$failure=reason,resolution.reject(reason)}if(isResolve(locals)&&self===undefined&&(self=parent,parent=locals,locals=null),locals){if(!isObject(locals))throw new Error("'locals' must be an object")}else locals=NO_LOCALS;if(parent){if(!isResolve(parent))throw new Error("'parent' must be a promise returned by $resolve.resolve()")}else parent=NO_PARENT;var resolution=$q.defer(),result=resolution.promise,promises=result.$$promises={},values=extend({},locals),wait=1+plan.length/3,merged=!1;if(isDefined(parent.$$failure))return fail(parent.$$failure),result;parent.$$inheritedValues&&merge(values,omit(parent.$$inheritedValues,invocableKeys)),extend(promises,parent.$$promises),parent.$$values?(merged=merge(values,omit(parent.$$values,invocableKeys)),result.$$inheritedValues=omit(parent.$$values,invocableKeys),done()):(parent.$$inheritedValues&&(result.$$inheritedValues=omit(parent.$$inheritedValues,invocableKeys)),parent.then(done,fail));for(var i=0,ii=plan.length;i<ii;i+=3)locals.hasOwnProperty(plan[i])?done():function(key,invocable,params){function onfailure(reason){invocation.reject(reason),fail(reason)}function proceed(){if(!isDefined(result.$$failure))try{invocation.resolve($injector.invoke(invocable,self,values)),invocation.promise.then(function(result){values[key]=result,done()},onfailure)}catch(e){onfailure(e)}}var invocation=$q.defer(),waitParams=0;forEach(params,function(dep){promises.hasOwnProperty(dep)&&!locals.hasOwnProperty(dep)&&(waitParams++,promises[dep].then(function(result){values[dep]=result,--waitParams||proceed()},onfailure))}),waitParams||proceed(),promises[key]=invocation.promise}(plan[i],plan[i+1],plan[i+2]);return result}},this.resolve=function(invocables,locals,parent,self){return this.study(invocables)(locals,parent,self)}}function $TemplateFactory($http,$templateCache,$injector){this.fromConfig=function(config,params,locals){return isDefined(config.template)?this.fromString(config.template,params):isDefined(config.templateUrl)?this.fromUrl(config.templateUrl,params):isDefined(config.templateProvider)?this.fromProvider(config.templateProvider,params,locals):null},this.fromString=function(template,params){return isFunction(template)?template(params):template},this.fromUrl=function(url,params){return isFunction(url)&&(url=url(params)),null==url?null:$http.get(url,{cache:$templateCache,headers:{Accept:"text/html"}}).then(function(response){return response.data})},this.fromProvider=function(provider,params,locals){return $injector.invoke(provider,null,locals||{params:params})}}function UrlMatcher(pattern,config,parentMatcher){function addParameter(id,type,config,location){if(paramNames.push(id),parentParams[id])return parentParams[id];if(!/^\w+(-+\w+)*(?:\[\])?$/.test(id))throw new Error("Invalid parameter name '"+id+"' in pattern '"+pattern+"'");if(params[id])throw new Error("Duplicate parameter name '"+id+"' in pattern '"+pattern+"'");return params[id]=new $$UMFP.Param(id,type,config,location),params[id]}function quoteRegExp(string,pattern,squash){var surroundPattern=["",""],result=string.replace(/[\\\[\]\^$*+?.()|{}]/g,"\\$&");if(!pattern)return result;switch(squash){case!1:surroundPattern=["(",")"];break;case!0:surroundPattern=["?(",")?"];break;default:surroundPattern=["("+squash+"|",")?"]}return result+surroundPattern[0]+pattern+surroundPattern[1]}function matchDetails(m,isSearch){var id,regexp,segment,type,cfg;return id=m[2]||m[3],cfg=config.params[id],segment=pattern.substring(last,m.index),regexp=isSearch?m[4]:m[4]||("*"==m[1]?".*":null),type=$$UMFP.type(regexp||"string")||inherit($$UMFP.type("string"),{pattern:new RegExp(regexp)}),{id:id,regexp:regexp,segment:segment,type:type,cfg:cfg}}config=extend({params:{}},isObject(config)?config:{});var m,placeholder=/([:*])([\w\[\]]+)|\{([\w\[\]]+)(?:\:((?:[^{}\\]+|\\.|\{(?:[^{}\\]+|\\.)*\})+))?\}/g,searchPlaceholder=/([:]?)([\w\[\]-]+)|\{([\w\[\]-]+)(?:\:((?:[^{}\\]+|\\.|\{(?:[^{}\\]+|\\.)*\})+))?\}/g,compiled="^",last=0,segments=this.segments=[],parentParams=parentMatcher?parentMatcher.params:{},params=this.params=parentMatcher?parentMatcher.params.$$new():new $$UMFP.ParamSet,paramNames=[];this.source=pattern;for(var p,param,segment;(m=placeholder.exec(pattern))&&!((p=matchDetails(m,!1)).segment.indexOf("?")>=0);)param=addParameter(p.id,p.type,p.cfg,"path"),compiled+=quoteRegExp(p.segment,param.type.pattern.source,param.squash),segments.push(p.segment),last=placeholder.lastIndex;var i=(segment=pattern.substring(last)).indexOf("?");if(i>=0){var search=this.sourceSearch=segment.substring(i);if(segment=segment.substring(0,i),this.sourcePath=pattern.substring(0,last+i),search.length>0)for(last=0;m=searchPlaceholder.exec(search);)param=addParameter((p=matchDetails(m,!0)).id,p.type,p.cfg,"search"),last=placeholder.lastIndex}else this.sourcePath=pattern,this.sourceSearch="";compiled+=quoteRegExp(segment)+(!1===config.strict?"/?":"")+"$",segments.push(segment),this.regexp=new RegExp(compiled,config.caseInsensitive?"i":undefined),this.prefix=segments[0],this.$$paramNames=paramNames}function Type(config){extend(this,config)}function $UrlMatcherFactory(){function valToString(val){return null!=val?val.toString().replace(/\//g,"%2F"):val}function getDefaultConfig(){return{strict:isStrictMode,caseInsensitive:isCaseInsensitive}}function isInjectable(value){return isFunction(value)||isArray(value)&&isFunction(value[value.length-1])}function flushTypeQueue(){for(;typeQueue.length;){var type=typeQueue.shift();if(type.pattern)throw new Error("You cannot override a type's .pattern at runtime.");angular.extend($types[type.name],injector.invoke(type.def))}}function ParamSet(params){extend(this,params||{})}$$UMFP=this;var injector,isCaseInsensitive=!1,isStrictMode=!0,defaultSquashPolicy=!1,$types={},enqueue=!0,typeQueue=[],defaultTypes={string:{encode:valToString,decode:function(val){return null!=val?val.toString().replace(/%2F/g,"/"):val},is:function(val){return this.pattern.test(val)},pattern:/[^/]*/},int:{encode:valToString,decode:function(val){return parseInt(val,10)},is:function(val){return isDefined(val)&&this.decode(val.toString())===val},pattern:/\d+/},bool:{encode:function(val){return val?1:0},decode:function(val){return 0!==parseInt(val,10)},is:function(val){return!0===val||!1===val},pattern:/0|1/},date:{encode:function(val){return this.is(val)?[val.getFullYear(),("0"+(val.getMonth()+1)).slice(-2),("0"+val.getDate()).slice(-2)].join("-"):undefined},decode:function(val){if(this.is(val))return val;var match=this.capture.exec(val);return match?new Date(match[1],match[2]-1,match[3]):undefined},is:function(val){return val instanceof Date&&!isNaN(val.valueOf())},equals:function(a,b){return this.is(a)&&this.is(b)&&a.toISOString()===b.toISOString()},pattern:/[0-9]{4}-(?:0[1-9]|1[0-2])-(?:0[1-9]|[1-2][0-9]|3[0-1])/,capture:/([0-9]{4})-(0[1-9]|1[0-2])-(0[1-9]|[1-2][0-9]|3[0-1])/},json:{encode:angular.toJson,decode:angular.fromJson,is:angular.isObject,equals:angular.equals,pattern:/[^/]*/},any:{encode:angular.identity,decode:angular.identity,is:angular.identity,equals:angular.equals,pattern:/.*/}};$UrlMatcherFactory.$$getDefaultValue=function(config){if(!isInjectable(config.value))return config.value;if(!injector)throw new Error("Injectable functions cannot be called at configuration time");return injector.invoke(config.value)},this.caseInsensitive=function(value){return isDefined(value)&&(isCaseInsensitive=value),isCaseInsensitive},this.strictMode=function(value){return isDefined(value)&&(isStrictMode=value),isStrictMode},this.defaultSquashPolicy=function(value){if(!isDefined(value))return defaultSquashPolicy;if(!0!==value&&!1!==value&&!isString(value))throw new Error("Invalid squash policy: "+value+". Valid policies: false, true, arbitrary-string");return defaultSquashPolicy=value,value},this.compile=function(pattern,config){return new UrlMatcher(pattern,extend(getDefaultConfig(),config))},this.isMatcher=function(o){if(!isObject(o))return!1;var result=!0;return forEach(UrlMatcher.prototype,function(val,name){isFunction(val)&&(result=result&&isDefined(o[name])&&isFunction(o[name]))}),result},this.type=function(name,definition,definitionFn){if(!isDefined(definition))return $types[name];if($types.hasOwnProperty(name))throw new Error("A type named '"+name+"' has already been defined.");return $types[name]=new Type(extend({name:name},definition)),definitionFn&&(typeQueue.push({name:name,def:definitionFn}),enqueue||flushTypeQueue()),this},forEach(defaultTypes,function(type,name){$types[name]=new Type(extend({name:name},type))}),$types=inherit($types,{}),this.$get=["$injector",function($injector){return injector=$injector,enqueue=!1,flushTypeQueue(),forEach(defaultTypes,function(type,name){$types[name]||($types[name]=new Type(type))}),this}],this.Param=function(id,type,config,location){function $$getDefaultValue(){if(!injector)throw new Error("Injectable functions cannot be called at configuration time");return injector.invoke(config.$$fn)}var self=this;config=function(config){var keys=isObject(config)?objectKeys(config):[];return-1===indexOf(keys,"value")&&-1===indexOf(keys,"type")&&-1===indexOf(keys,"squash")&&-1===indexOf(keys,"array")&&(config={value:config}),config.$$fn=isInjectable(config.value)?config.value:function(){return config.value},config}(config),type=function(config,urlType,location){if(config.type&&urlType)throw new Error("Param '"+id+"' has two type configurations.");return urlType||(config.type?config.type instanceof Type?config.type:new Type(config.type):"config"===location?$types.any:$types.string)}(config,type,location);var arrayMode=function(){var arrayDefaults={array:"search"===location&&"auto"},arrayParamNomenclature=id.match(/\[\]$/)?{array:!0}:{};return extend(arrayDefaults,arrayParamNomenclature,config).array}();"string"!==(type=arrayMode?type.$asArray(arrayMode,"search"===location):type).name||arrayMode||"path"!==location||config.value!==undefined||(config.value="");var isOptional=config.value!==undefined,squash=function(config,isOptional){var squash=config.squash;if(!isOptional||!1===squash)return!1;if(!isDefined(squash)||null==squash)return defaultSquashPolicy;if(!0===squash||isString(squash))return squash;throw new Error("Invalid squash policy: '"+squash+"'. Valid policies: false, true, or arbitrary string")}(config,isOptional),replace=function(config,arrayMode,isOptional,squash){var replace,configuredKeys,defaultPolicy=[{from:"",to:isOptional||arrayMode?undefined:""},{from:null,to:isOptional||arrayMode?undefined:""}];return replace=isArray(config.replace)?config.replace:[],isString(squash)&&replace.push({from:squash,to:undefined}),configuredKeys=map(replace,function(item){return item.from}),filter(defaultPolicy,function(item){return-1===indexOf(configuredKeys,item.from)}).concat(replace)}(config,arrayMode,isOptional,squash);extend(this,{id:id,type:type,location:location,array:arrayMode,squash:squash,replace:replace,isOptional:isOptional,value:function(value){function hasReplaceVal(val){return function(obj){return obj.from===val}}return value=function(value){var replacement=map(filter(self.replace,hasReplaceVal(value)),function(obj){return obj.to});return replacement.length?replacement[0]:value}(value),isDefined(value)?self.type.decode(value):$$getDefaultValue()},dynamic:undefined,config:config,toString:function(){return"{Param:"+id+" "+type+" squash: '"+squash+"' optional: "+isOptional+"}"}})},ParamSet.prototype={$$new:function(){return inherit(this,extend(new ParamSet,{$$parent:this}))},$$keys:function(){for(var keys=[],chain=[],parent=this,ignore=objectKeys(ParamSet.prototype);parent;)chain.push(parent),parent=parent.$$parent;return chain.reverse(),forEach(chain,function(paramset){forEach(objectKeys(paramset),function(key){-1===indexOf(keys,key)&&-1===indexOf(ignore,key)&&keys.push(key)})}),keys},$$values:function(paramValues){var values={},self=this;return forEach(self.$$keys(),function(key){values[key]=self[key].value(paramValues&&paramValues[key])}),values},$$equals:function(paramValues1,paramValues2){var equal=!0,self=this;return forEach(self.$$keys(),function(key){var left=paramValues1&&paramValues1[key],right=paramValues2&&paramValues2[key];self[key].type.equals(left,right)||(equal=!1)}),equal},$$validates:function(paramValues){var isOptional,val,param,result=!0,self=this;return forEach(this.$$keys(),function(key){param=self[key],val=paramValues[key],isOptional=!val&&param.isOptional,result=result&&(isOptional||!!param.type.is(val))}),result},$$parent:undefined},this.ParamSet=ParamSet}function $UrlRouterProvider($locationProvider,$urlMatcherFactory){function regExpPrefix(re){var prefix=/^\^((?:\\[^a-zA-Z0-9]|[^\\\[\]\^$*+?.()|{}]+)*)/.exec(re.source);return null!=prefix?prefix[1].replace(/\\(.)/g,"$1"):""}function interpolate(pattern,match){return pattern.replace(/\$(\$|\d{1,2})/,function(m,what){return match["$"===what?0:Number(what)]})}function handleIfMatch($injector,handler,match){if(!match)return!1;var result=$injector.invoke(handler,handler,{$match:match});return!isDefined(result)||result}function $get($location,$rootScope,$injector,$browser){function appendBasePath(url,isHtml5,absolute){return"/"===baseHref?url:isHtml5?baseHref.slice(0,-1)+url:absolute?baseHref.slice(1)+url:url}function update(evt){function check(rule){var handled=rule($injector,$location);return!!handled&&(isString(handled)&&$location.replace().url(handled),!0)}if(!evt||!evt.defaultPrevented){var ignoreUpdate=lastPushedUrl&&$location.url()===lastPushedUrl;if(lastPushedUrl=undefined,ignoreUpdate)return!0;var i,n=rules.length;for(i=0;i<n;i++)if(check(rules[i]))return;otherwise&&check(otherwise)}}function listen(){return listener=listener||$rootScope.$on("$locationChangeSuccess",update)}var lastPushedUrl,baseHref=$browser.baseHref(),location=$location.url();return interceptDeferred||listen(),{sync:function(){update()},listen:function(){return listen()},update:function(read){read?location=$location.url():$location.url()!==location&&($location.url(location),$location.replace())},push:function(urlMatcher,params,options){$location.url(urlMatcher.format(params||{})),lastPushedUrl=options&&options.$$avoidResync?$location.url():undefined,options&&options.replace&&$location.replace()},href:function(urlMatcher,params,options){if(!urlMatcher.validates(params))return null;var isHtml5=$locationProvider.html5Mode();angular.isObject(isHtml5)&&(isHtml5=isHtml5.enabled);var url=urlMatcher.format(params);if(options=options||{},isHtml5||null===url||(url="#"+$locationProvider.hashPrefix()+url),url=appendBasePath(url,isHtml5,options.absolute),!options.absolute||!url)return url;var slash=!isHtml5&&url?"/":"",port=$location.port();return port=80===port||443===port?"":":"+port,[$location.protocol(),"://",$location.host(),port,slash,url].join("")}}}var listener,rules=[],otherwise=null,interceptDeferred=!1;this.rule=function(rule){if(!isFunction(rule))throw new Error("'rule' must be a function");return rules.push(rule),this},this.otherwise=function(rule){if(isString(rule)){var redirect=rule;rule=function(){return redirect}}else if(!isFunction(rule))throw new Error("'rule' must be a function");return otherwise=rule,this},this.when=function(what,handler){var redirect,handlerIsString=isString(handler);if(isString(what)&&(what=$urlMatcherFactory.compile(what)),!handlerIsString&&!isFunction(handler)&&!isArray(handler))throw new Error("invalid 'handler' in when()");var strategies={matcher:function(what,handler){return handlerIsString&&(redirect=$urlMatcherFactory.compile(handler),handler=["$match",function($match){return redirect.format($match)}]),extend(function($injector,$location){return handleIfMatch($injector,handler,what.exec($location.path(),$location.search()))},{prefix:isString(what.prefix)?what.prefix:""})},regex:function(what,handler){if(what.global||what.sticky)throw new Error("when() RegExp must not be global or sticky");return handlerIsString&&(redirect=handler,handler=["$match",function($match){return interpolate(redirect,$match)}]),extend(function($injector,$location){return handleIfMatch($injector,handler,what.exec($location.path()))},{prefix:regExpPrefix(what)})}},check={matcher:$urlMatcherFactory.isMatcher(what),regex:what instanceof RegExp};for(var n in check)if(check[n])return this.rule(strategies[n](what,handler));throw new Error("invalid 'what' in when()")},this.deferIntercept=function(defer){defer===undefined&&(defer=!0),interceptDeferred=defer},this.$get=$get,$get.$inject=["$location","$rootScope","$injector","$browser"]}function $StateProvider($urlRouterProvider,$urlMatcherFactory){function isRelative(stateName){return 0===stateName.indexOf(".")||0===stateName.indexOf("^")}function findState(stateOrName,base){if(!stateOrName)return undefined;var isStr=isString(stateOrName),name=isStr?stateOrName:stateOrName.name;if(isRelative(name)){if(!base)throw new Error("No reference point given for path '"+name+"'");base=findState(base);for(var rel=name.split("."),i=0,pathLength=rel.length,current=base;i<pathLength;i++)if(""!==rel[i]||0!==i){if("^"!==rel[i])break;if(!current.parent)throw new Error("Path '"+name+"' not valid for state '"+base.name+"'");current=current.parent}else current=base;rel=rel.slice(i).join("."),name=current.name+(current.name&&rel?".":"")+rel}var state=states[name];return!state||!isStr&&(isStr||state!==stateOrName&&state.self!==stateOrName)?undefined:state}function queueState(parentName,state){queue[parentName]||(queue[parentName]=[]),queue[parentName].push(state)}function flushQueuedChildren(parentName){for(var queued=queue[parentName]||[];queued.length;)registerState(queued.shift())}function registerState(state){var name=(state=inherit(state,{self:state,resolve:state.resolve||{},toString:function(){return this.name}})).name;if(!isString(name)||name.indexOf("@")>=0)throw new Error("State must have a valid name");if(states.hasOwnProperty(name))throw new Error("State '"+name+"'' is already defined");var parentName=-1!==name.indexOf(".")?name.substring(0,name.lastIndexOf(".")):isString(state.parent)?state.parent:isObject(state.parent)&&isString(state.parent.name)?state.parent.name:"";if(parentName&&!states[parentName])return queueState(parentName,state.self);for(var key in stateBuilder)isFunction(stateBuilder[key])&&(state[key]=stateBuilder[key](state,stateBuilder.$delegates[key]));return states[name]=state,!state[abstractKey]&&state.url&&$urlRouterProvider.when(state.url,["$match","$stateParams",function($match,$stateParams){$state.$current.navigable==state&&equalForKeys($match,$stateParams)||$state.transitionTo(state,$match,{inherit:!0,location:!1})}]),flushQueuedChildren(name),state}function isGlob(text){return text.indexOf("*")>-1}function doesStateMatchGlob(glob){var globSegments=glob.split("."),segments=$state.$current.name.split(".");if("**"===globSegments[0]&&(segments=segments.slice(indexOf(segments,globSegments[1]))).unshift("**"),"**"===globSegments[globSegments.length-1]&&(segments.splice(indexOf(segments,globSegments[globSegments.length-2])+1,Number.MAX_VALUE),segments.push("**")),globSegments.length!=segments.length)return!1;for(var i=0,l=globSegments.length;i<l;i++)"*"===globSegments[i]&&(segments[i]="*");return segments.join("")===globSegments.join("")}function $get($rootScope,$q,$view,$injector,$resolve,$stateParams,$urlRouter,$location,$urlMatcherFactory){function handleRedirect(redirect,state,params,options){var evt=$rootScope.$broadcast("$stateNotFound",redirect,state,params);if(evt.defaultPrevented)return $urlRouter.update(),TransitionAborted;if(!evt.retry)return null;if(options.$retry)return $urlRouter.update(),TransitionFailed;var retryTransition=$state.transition=$q.when(evt.retry);return retryTransition.then(function(){return retryTransition!==$state.transition?TransitionSuperseded:(redirect.options.$retry=!0,$state.transitionTo(redirect.to,redirect.toParams,redirect.options))},function(){return TransitionAborted}),$urlRouter.update(),retryTransition}function resolveState(state,params,paramsAreFiltered,inherited,dst,options){var $stateParams=paramsAreFiltered?params:filterByKeys(state.params.$$keys(),params),locals={$stateParams:$stateParams};dst.resolve=$resolve.resolve(state.resolve,locals,dst.resolve,state);var promises=[dst.resolve.then(function(globals){dst.globals=globals})];return inherited&&promises.push(inherited),forEach(state.views,function(view,name){var injectables=view.resolve&&view.resolve!==state.resolve?view.resolve:{};injectables.$template=[function(){return $view.load(name,{view:view,locals:locals,params:$stateParams,notify:options.notify})||""}],promises.push($resolve.resolve(injectables,locals,dst.resolve,state).then(function(result){if(isFunction(view.controllerProvider)||isArray(view.controllerProvider)){var injectLocals=angular.extend({},injectables,locals);result.$$controller=$injector.invoke(view.controllerProvider,null,injectLocals)}else result.$$controller=view.controller;result.$$state=state,result.$$controllerAs=view.controllerAs,dst[name]=result}))}),$q.all(promises).then(function(values){return dst})}var TransitionSuperseded=$q.reject(new Error("transition superseded")),TransitionPrevented=$q.reject(new Error("transition prevented")),TransitionAborted=$q.reject(new Error("transition aborted")),TransitionFailed=$q.reject(new Error("transition failed"));return root.locals={resolve:null,globals:{$stateParams:{}}},$state={params:{},current:root.self,$current:root,transition:null},$state.reload=function(){return $state.transitionTo($state.current,$stateParams,{reload:!0,inherit:!1,notify:!0})},$state.go=function(to,params,options){return $state.transitionTo(to,params,extend({inherit:!0,relative:$state.$current},options))},$state.transitionTo=function(to,toParams,options){toParams=toParams||{},options=extend({location:!0,inherit:!1,relative:null,notify:!0,reload:!1,$retry:!1},options||{});var evt,from=$state.$current,fromParams=$state.params,fromPath=from.path,toState=findState(to,options.relative);if(!isDefined(toState)){var redirect={to:to,toParams:toParams,options:options},redirectResult=handleRedirect(redirect,from.self,fromParams,options);if(redirectResult)return redirectResult;if(to=redirect.to,toParams=redirect.toParams,options=redirect.options,toState=findState(to,options.relative),!isDefined(toState)){if(!options.relative)throw new Error("No such state '"+to+"'");throw new Error("Could not resolve '"+to+"' from state '"+options.relative+"'")}}if(toState[abstractKey])throw new Error("Cannot transition to abstract state '"+to+"'");if(options.inherit&&(toParams=inheritParams($stateParams,toParams||{},$state.$current,toState)),!toState.params.$$validates(toParams))return TransitionFailed;toParams=toState.params.$$values(toParams);var toPath=(to=toState).path,keep=0,state=toPath[keep],locals=root.locals,toLocals=[];if(!options.reload)for(;state&&state===fromPath[keep]&&state.ownParams.$$equals(toParams,fromParams);)locals=toLocals[keep]=state.locals,state=toPath[++keep];if(shouldTriggerReload(to,from,locals,options))return!1!==to.self.reloadOnSearch&&$urlRouter.update(),$state.transition=null,$q.when($state.current);if(toParams=filterByKeys(to.params.$$keys(),toParams||{}),options.notify&&$rootScope.$broadcast("$stateChangeStart",to.self,toParams,from.self,fromParams).defaultPrevented)return $urlRouter.update(),TransitionPrevented;for(var resolved=$q.when(locals),l=keep;l<toPath.length;l++,state=toPath[l])locals=toLocals[l]=inherit(locals),resolved=resolveState(state,toParams,state===to,resolved,locals,options);var transition=$state.transition=resolved.then(function(){var l,entering,exiting;if($state.transition!==transition)return TransitionSuperseded;for(l=fromPath.length-1;l>=keep;l--)(exiting=fromPath[l]).self.onExit&&$injector.invoke(exiting.self.onExit,exiting.self,exiting.locals.globals),exiting.locals=null;for(l=keep;l<toPath.length;l++)(entering=toPath[l]).locals=toLocals[l],entering.self.onEnter&&$injector.invoke(entering.self.onEnter,entering.self,entering.locals.globals);return $state.transition!==transition?TransitionSuperseded:($state.$current=to,$state.current=to.self,$state.params=toParams,copy($state.params,$stateParams),$state.transition=null,options.location&&to.navigable&&$urlRouter.push(to.navigable.url,to.navigable.locals.globals.$stateParams,{$$avoidResync:!0,replace:"replace"===options.location}),options.notify&&$rootScope.$broadcast("$stateChangeSuccess",to.self,toParams,from.self,fromParams),$urlRouter.update(!0),$state.current)},function(error){return $state.transition!==transition?TransitionSuperseded:($state.transition=null,(evt=$rootScope.$broadcast("$stateChangeError",to.self,toParams,from.self,fromParams,error)).defaultPrevented||$urlRouter.update(),$q.reject(error))});return transition},$state.is=function(stateOrName,params,options){var state=findState(stateOrName,(options=extend({relative:$state.$current},options||{})).relative);return isDefined(state)?$state.$current===state&&(!params||equalForKeys(state.params.$$values(params),$stateParams)):undefined},$state.includes=function(stateOrName,params,options){if(options=extend({relative:$state.$current},options||{}),isString(stateOrName)&&isGlob(stateOrName)){if(!doesStateMatchGlob(stateOrName))return!1;stateOrName=$state.$current.name}var state=findState(stateOrName,options.relative);return isDefined(state)?!!isDefined($state.$current.includes[state.name])&&(!params||equalForKeys(state.params.$$values(params),$stateParams,objectKeys(params))):undefined},$state.href=function(stateOrName,params,options){var state=findState(stateOrName,(options=extend({lossy:!0,inherit:!0,absolute:!1,relative:$state.$current},options||{})).relative);if(!isDefined(state))return null;options.inherit&&(params=inheritParams($stateParams,params||{},$state.$current,state));var nav=state&&options.lossy?state.navigable:state;return nav&&nav.url!==undefined&&null!==nav.url?$urlRouter.href(nav.url,filterByKeys(state.params.$$keys(),params||{}),{absolute:options.absolute}):null},$state.get=function(stateOrName,context){if(0===arguments.length)return map(objectKeys(states),function(name){return states[name].self});var state=findState(stateOrName,context||$state.$current);return state&&state.self?state.self:null},$state}function shouldTriggerReload(to,from,locals,options){if(to===from&&(locals===from.locals&&!options.reload||!1===to.self.reloadOnSearch))return!0}var root,$state,states={},queue={},abstractKey="abstract",stateBuilder={parent:function(state){if(isDefined(state.parent)&&state.parent)return findState(state.parent);var compositeName=/^(.+)\.[^.]+$/.exec(state.name);return compositeName?findState(compositeName[1]):root},data:function(state){return state.parent&&state.parent.data&&(state.data=state.self.data=extend({},state.parent.data,state.data)),state.data},url:function(state){var url=state.url,config={params:state.params||{}};if(isString(url))return"^"==url.charAt(0)?$urlMatcherFactory.compile(url.substring(1),config):(state.parent.navigable||root).url.concat(url,config);if(!url||$urlMatcherFactory.isMatcher(url))return url;throw new Error("Invalid url '"+url+"' in state '"+state+"'")},navigable:function(state){return state.url?state:state.parent?state.parent.navigable:null},ownParams:function(state){var params=state.url&&state.url.params||new $$UMFP.ParamSet;return forEach(state.params||{},function(config,id){params[id]||(params[id]=new $$UMFP.Param(id,null,config,"config"))}),params},params:function(state){return state.parent&&state.parent.params?extend(state.parent.params.$$new(),state.ownParams):new $$UMFP.ParamSet},views:function(state){var views={};return forEach(isDefined(state.views)?state.views:{"":state},function(view,name){name.indexOf("@")<0&&(name+="@"+state.parent.name),views[name]=view}),views},path:function(state){return state.parent?state.parent.path.concat(state):[]},includes:function(state){var includes=state.parent?extend({},state.parent.includes):{};return includes[state.name]=!0,includes},$delegates:{}};(root=registerState({name:"",url:"^",views:null,abstract:!0})).navigable=null,this.decorator=function(name,func){return isString(name)&&!isDefined(func)?stateBuilder[name]:isFunction(func)&&isString(name)?(stateBuilder[name]&&!stateBuilder.$delegates[name]&&(stateBuilder.$delegates[name]=stateBuilder[name]),stateBuilder[name]=func,this):this},this.state=function(name,definition){return isObject(name)?definition=name:definition.name=name,registerState(definition),this},this.$get=$get,$get.$inject=["$rootScope","$q","$view","$injector","$resolve","$stateParams","$urlRouter","$location","$urlMatcherFactory"]}function $ViewProvider(){function $get($rootScope,$templateFactory){return{load:function(name,options){var result;return(options=extend({template:null,controller:null,view:null,locals:null,notify:!0,async:!0,params:{}},options)).view&&(result=$templateFactory.fromConfig(options.view,options.params,options.locals)),result&&options.notify&&$rootScope.$broadcast("$viewContentLoading",options),result}}}this.$get=$get,$get.$inject=["$rootScope","$templateFactory"]}function $ViewDirective($state,$injector,$uiViewScroll,$interpolate){function getRenderer(attrs,scope){if($animate)return{enter:function(element,target,cb){var promise=$animate.enter(element,null,target,cb);promise&&promise.then&&promise.then(cb)},leave:function(element,cb){var promise=$animate.leave(element,cb);promise&&promise.then&&promise.then(cb)}};if($animator){var animate=$animator&&$animator(scope,attrs);return{enter:function(element,target,cb){animate.enter(element,null,target),cb()},leave:function(element,cb){animate.leave(element),cb()}}}return{enter:function(element,target,cb){target.after(element),cb()},leave:function(element,cb){element.remove(),cb()}}}var service=$injector.has?function(service){return $injector.has(service)?$injector.get(service):null}:function(service){try{return $injector.get(service)}catch(e){return null}},$animator=service("$animator"),$animate=service("$animate");return{restrict:"ECA",terminal:!0,priority:400,transclude:"element",compile:function(tElement,tAttrs,$transclude){return function(scope,$element,attrs){function cleanupLastView(){previousEl&&(previousEl.remove(),previousEl=null),currentScope&&(currentScope.$destroy(),currentScope=null),currentEl&&(renderer.leave(currentEl,function(){previousEl=null}),previousEl=currentEl,currentEl=null)}function updateView(firstTime){var newScope,name=getUiViewName(scope,attrs,$element,$interpolate),previousLocals=name&&$state.$current&&$state.$current.locals[name];if(firstTime||previousLocals!==latestLocals){newScope=scope.$new(),latestLocals=$state.$current.locals[name];var clone=$transclude(newScope,function(clone){renderer.enter(clone,$element,function(){currentScope&&currentScope.$emit("$viewContentAnimationEnded"),(angular.isDefined(autoScrollExp)&&!autoScrollExp||scope.$eval(autoScrollExp))&&$uiViewScroll(clone)}),cleanupLastView()});currentEl=clone,(currentScope=newScope).$emit("$viewContentLoaded"),currentScope.$eval(onloadExp)}}var previousEl,currentEl,currentScope,latestLocals,onloadExp=attrs.onload||"",autoScrollExp=attrs.autoscroll,renderer=getRenderer(attrs,scope);scope.$on("$stateChangeSuccess",function(){updateView(!1)}),scope.$on("$viewContentLoading",function(){updateView(!1)}),updateView(!0)}}}}function $ViewDirectiveFill($compile,$controller,$state,$interpolate){return{restrict:"ECA",priority:-400,compile:function(tElement){var initial=tElement.html();return function(scope,$element,attrs){var current=$state.$current,name=getUiViewName(scope,attrs,$element,$interpolate),locals=current&&current.locals[name];if(locals){$element.data("$uiView",{name:name,state:locals.$$state}),$element.html(locals.$template?locals.$template:initial);var link=$compile($element.contents());if(locals.$$controller){locals.$scope=scope;var controller=$controller(locals.$$controller,locals);locals.$$controllerAs&&(scope[locals.$$controllerAs]=controller),$element.data("$ngControllerController",controller),$element.children().data("$ngControllerController",controller)}link(scope)}}}}}function getUiViewName(scope,attrs,element,$interpolate){var name=$interpolate(attrs.uiView||attrs.name||"")(scope),inherited=element.inheritedData("$uiView");return name.indexOf("@")>=0?name:name+"@"+(inherited?inherited.state.name:"")}function parseStateRef(ref,current){var parsed,preparsed=ref.match(/^\s*({[^}]*})\s*$/);if(preparsed&&(ref=current+"("+preparsed[1]+")"),!(parsed=ref.replace(/\n/g," ").match(/^([^(]+?)\s*(\((.*)\))?$/))||4!==parsed.length)throw new Error("Invalid state ref '"+ref+"'");return{state:parsed[1],paramExpr:parsed[3]||null}}function stateContext(el){var stateData=el.parent().inheritedData("$uiView");if(stateData&&stateData.state&&stateData.state.name)return stateData.state}function $StateRefDirective($state,$timeout){var allowedOptions=["location","inherit","reload"];return{restrict:"A",require:["?^uiSrefActive","?^uiSrefActiveEq"],link:function(scope,element,attrs,uiSrefActive){var ref=parseStateRef(attrs.uiSref,$state.current.name),params=null,base=stateContext(element)||$state.$current,newHref=null,isAnchor="A"===element.prop("tagName"),isForm="FORM"===element[0].nodeName,attr=isForm?"action":"href",nav=!0,options={relative:base,inherit:!0},optionsOverride=scope.$eval(attrs.uiSrefOpts)||{};angular.forEach(allowedOptions,function(option){option in optionsOverride&&(options[option]=optionsOverride[option])});var update=function(newVal){if(newVal&&(params=angular.copy(newVal)),nav){newHref=$state.href(ref.state,params,options);var activeDirective=uiSrefActive[1]||uiSrefActive[0];if(activeDirective&&activeDirective.$$setStateInfo(ref.state,params),null===newHref)return nav=!1,!1;attrs.$set(attr,newHref)}};ref.paramExpr&&(scope.$watch(ref.paramExpr,function(newVal,oldVal){newVal!==params&&update(newVal)},!0),params=angular.copy(scope.$eval(ref.paramExpr))),update(),isForm||element.bind("click",function(e){if(!((e.which||e.button)>1||e.ctrlKey||e.metaKey||e.shiftKey||element.attr("target"))){var transition=$timeout(function(){$state.go(ref.state,params,options)});e.preventDefault();var ignorePreventDefaultCount=isAnchor&&!newHref?1:0;e.preventDefault=function(){ignorePreventDefaultCount--<=0&&$timeout.cancel(transition)}}})}}}function $StateRefActiveDirective($state,$stateParams,$interpolate){return{restrict:"A",controller:["$scope","$element","$attrs",function($scope,$element,$attrs){function update(){isMatch()?$element.addClass(activeClass):$element.removeClass(activeClass)}function isMatch(){return void 0!==$attrs.uiSrefActiveEq?state&&$state.is(state.name,params):state&&$state.includes(state.name,params)}var state,params,activeClass;activeClass=$interpolate($attrs.uiSrefActiveEq||$attrs.uiSrefActive||"",!1)($scope),this.$$setStateInfo=function(newState,newParams){state=$state.get(newState,stateContext($element)),params=newParams,update()},$scope.$on("$stateChangeSuccess",update)}]}}function $IsStateFilter($state){var isFilter=function(state){return $state.is(state)};return isFilter.$stateful=!0,isFilter}function $IncludedByStateFilter($state){var includesFilter=function(state){return $state.includes(state)};return includesFilter.$stateful=!0,includesFilter}var isDefined=angular.isDefined,isFunction=angular.isFunction,isString=angular.isString,isObject=angular.isObject,isArray=angular.isArray,forEach=angular.forEach,extend=angular.extend,copy=angular.copy;angular.module("ui.router.util",["ng"]),angular.module("ui.router.router",["ui.router.util"]),angular.module("ui.router.state",["ui.router.router","ui.router.util"]),angular.module("ui.router",["ui.router.state"]),angular.module("ui.router.compat",["ui.router"]),$Resolve.$inject=["$q","$injector"],angular.module("ui.router.util").service("$resolve",$Resolve),$TemplateFactory.$inject=["$http","$templateCache","$injector"],angular.module("ui.router.util").service("$templateFactory",$TemplateFactory);var $$UMFP;UrlMatcher.prototype.concat=function(pattern,config){var defaultConfig={caseInsensitive:$$UMFP.caseInsensitive(),strict:$$UMFP.strictMode(),squash:$$UMFP.defaultSquashPolicy()};return new UrlMatcher(this.sourcePath+pattern+this.sourceSearch,extend(defaultConfig,config),this)},UrlMatcher.prototype.toString=function(){return this.source},UrlMatcher.prototype.exec=function(path,searchParams){var m=this.regexp.exec(path);if(!m)return null;searchParams=searchParams||{};var i,j,paramName,paramNames=this.parameters(),nTotal=paramNames.length,nPath=this.segments.length-1,values={};if(nPath!==m.length-1)throw new Error("Unbalanced capture group in route '"+this.source+"'");for(i=0;i<nPath;i++){paramName=paramNames[i];var param=this.params[paramName],paramVal=m[i+1];for(j=0;j<param.replace;j++)param.replace[j].from===paramVal&&(paramVal=param.replace[j].to);paramVal&&!0===param.array&&(paramVal=function(string){function reverseString(str){return str.split("").reverse().join("")}return map(map(reverseString(string).split(/-(?!\\)/),reverseString),function(str){return str.replace(/\\-/,"-")}).reverse()}(paramVal)),values[paramName]=param.value(paramVal)}for(;i<nTotal;i++)values[paramName=paramNames[i]]=this.params[paramName].value(searchParams[paramName]);return values},UrlMatcher.prototype.parameters=function(param){return isDefined(param)?this.params[param]||null:this.$$paramNames},UrlMatcher.prototype.validates=function(params){return this.params.$$validates(params)},UrlMatcher.prototype.format=function(values){values=values||{};var segments=this.segments,params=this.parameters(),paramset=this.params;if(!this.validates(values))return null;var i,search=!1,nPath=segments.length-1,nTotal=params.length,result=segments[0];for(i=0;i<nTotal;i++){var isPathParam=i<nPath,name=params[i],param=paramset[name],value=param.value(values[name]),isDefaultValue=param.isOptional&&param.type.equals(param.value(),value),squash=!!isDefaultValue&&param.squash,encoded=param.type.encode(value);if(isPathParam){var nextSegment=segments[i+1];if(!1===squash)null!=encoded&&(isArray(encoded)?result+=map(encoded,function(str){return encodeURIComponent(str).replace(/-/g,function(c){return"%5C%"+c.charCodeAt(0).toString(16).toUpperCase()})}).join("-"):result+=encodeURIComponent(encoded)),result+=nextSegment;else if(!0===squash){var capture=result.match(/\/$/)?/\/?(.*)/:/(.*)/;result+=nextSegment.match(capture)[1]}else isString(squash)&&(result+=squash+nextSegment)}else{if(null==encoded||isDefaultValue&&!1!==squash)continue;isArray(encoded)||(encoded=[encoded]),encoded=map(encoded,encodeURIComponent).join("&"+name+"="),result+=(search?"&":"?")+name+"="+encoded,search=!0}}return result},Type.prototype.is=function(val,key){return!0},Type.prototype.encode=function(val,key){return val},Type.prototype.decode=function(val,key){return val},Type.prototype.equals=function(a,b){return a==b},Type.prototype.$subPattern=function(){var sub=this.pattern.toString();return sub.substr(1,sub.length-2)},Type.prototype.pattern=/.*/,Type.prototype.toString=function(){return"{Type:"+this.name+"}"},Type.prototype.$asArray=function(mode,isSearch){if(!mode)return this;if("auto"===mode&&!isSearch)throw new Error("'auto' array mode is for query parameters only");return new function(type,mode){function bindTo(type,callbackName){return function(){return type[callbackName].apply(type,arguments)}}function arrayWrap(val){return isArray(val)?val:isDefined(val)?[val]:[]}function arrayUnwrap(val){switch(val.length){case 0:return undefined;case 1:return"auto"===mode?val[0]:val;default:return val}}function falsey(val){return!val}function arrayHandler(callback,allTruthyMode){return function(val){var result=map(val=arrayWrap(val),callback);return!0===allTruthyMode?0===filter(result,falsey).length:arrayUnwrap(result)}}this.encode=arrayHandler(bindTo(type,"encode")),this.decode=arrayHandler(bindTo(type,"decode")),this.is=arrayHandler(bindTo(type,"is"),!0),this.equals=function(callback){return function(val1,val2){var left=arrayWrap(val1),right=arrayWrap(val2);if(left.length!==right.length)return!1;for(var i=0;i<left.length;i++)if(!callback(left[i],right[i]))return!1;return!0}}(bindTo(type,"equals")),this.pattern=type.pattern,this.$arrayMode=mode}(this,mode)},angular.module("ui.router.util").provider("$urlMatcherFactory",$UrlMatcherFactory),angular.module("ui.router.util").run(["$urlMatcherFactory",function($urlMatcherFactory){}]),$UrlRouterProvider.$inject=["$locationProvider","$urlMatcherFactoryProvider"],angular.module("ui.router.router").provider("$urlRouter",$UrlRouterProvider),$StateProvider.$inject=["$urlRouterProvider","$urlMatcherFactoryProvider"],angular.module("ui.router.state").value("$stateParams",{}).provider("$state",$StateProvider),$ViewProvider.$inject=[],angular.module("ui.router.state").provider("$view",$ViewProvider),angular.module("ui.router.state").provider("$uiViewScroll",function(){var useAnchorScroll=!1;this.useAnchorScroll=function(){useAnchorScroll=!0},this.$get=["$anchorScroll","$timeout",function($anchorScroll,$timeout){return useAnchorScroll?$anchorScroll:function($element){$timeout(function(){$element[0].scrollIntoView()},0,!1)}}]}),$ViewDirective.$inject=["$state","$injector","$uiViewScroll","$interpolate"],$ViewDirectiveFill.$inject=["$compile","$controller","$state","$interpolate"],angular.module("ui.router.state").directive("uiView",$ViewDirective),angular.module("ui.router.state").directive("uiView",$ViewDirectiveFill),$StateRefDirective.$inject=["$state","$timeout"],$StateRefActiveDirective.$inject=["$state","$stateParams","$interpolate"],angular.module("ui.router.state").directive("uiSref",$StateRefDirective).directive("uiSrefActive",$StateRefActiveDirective).directive("uiSrefActiveEq",$StateRefActiveDirective),$IsStateFilter.$inject=["$state"],$IncludedByStateFilter.$inject=["$state"],angular.module("ui.router.state").filter("isState",$IsStateFilter).filter("includedByState",$IncludedByStateFilter)}(window,window.angular),function(){function CollectionRepeatDirective($ionicCollectionManager,$parse,$window,$$rAF,$rootScope,$timeout){return{restrict:"A",priority:1e3,transclude:"element",$$tlb:!0,require:"^^$ionicScroll",link:function(scope,element,attr,scrollCtrl,transclude){function onResize(){changeValidator.resizeRequiresRefresh(scrollView.__clientWidth,scrollView.__clientHeight)&&refreshDimensions()}function getRepeatManager(){return repeatManager||(repeatManager=new $ionicCollectionManager({afterItemsNode:afterItemsContainer[0],containerNode:containerNode,heightData:heightData,widthData:widthData,forceRefreshImages:!(!isDefined(attr.forceRefreshImages)||"false"===attr.forceRefreshImages),keyExpression:keyExpr,renderBuffer:renderBuffer,scope:scope,scrollView:scrollCtrl.scrollView,transclude:transclude}))}function refreshDimensions(){var hasData=data.length>0;if(hasData&&(heightData.computed||widthData.computed)&&computeStyleDimensions(),hasData&&heightData.computed){if(heightData.value=computedStyleDimensions.height,!heightData.value)throw new Error('collection-repeat tried to compute the height of repeated elements "'+repeatExpr+'", but was unable to. Please provide the "item-height" attribute. http://ionicframework.com/docs/api/directive/collectionRepeat/')}else!heightData.dynamic&&heightData.getValue&&(heightData.value=heightData.getValue());if(hasData&&widthData.computed){if(widthData.value=computedStyleDimensions.width,!widthData.value)throw new Error('collection-repeat tried to compute the width of repeated elements "'+repeatExpr+'", but was unable to. Please provide the "item-width" attribute. http://ionicframework.com/docs/api/directive/collectionRepeat/')}else!widthData.dynamic&&widthData.getValue&&(widthData.value=widthData.getValue());getRepeatManager().refreshLayout()}function parseDimensionAttr(attrValue,dimensionData){if(attrValue){var parsedValue;try{parsedValue=$parse(attrValue)}catch(e){attrValue.trim().match(/\d+(px|%)$/)&&(attrValue='"'+attrValue+'"'),parsedValue=$parse(attrValue)}var constantAttrValue=attrValue.replace(/(\'|\"|px|%)/g,"").trim(),isConstant=constantAttrValue.length&&!/([a-zA-Z]|\$|:|\?)/.test(constantAttrValue);if(dimensionData.attrValue=attrValue,isConstant)if(attrValue.indexOf("%")>-1){var decimalValue=parseFloat(parsedValue())/100;dimensionData.getValue=dimensionData===heightData?function(){return Math.floor(decimalValue*scrollView.__clientHeight)}:function(){return Math.floor(decimalValue*scrollView.__clientWidth)}}else dimensionData.value=parseInt(parsedValue());else dimensionData.dynamic=!0,dimensionData.getValue=dimensionData===heightData?function(scope,locals){var result=parsedValue(scope,locals);return result.charAt&&"%"===result.charAt(result.length-1)?Math.floor(parseFloat(result)/100*scrollView.__clientHeight):parseInt(result)}:function(scope,locals){var result=parsedValue(scope,locals);return result.charAt&&"%"===result.charAt(result.length-1)?Math.floor(parseFloat(result)/100*scrollView.__clientWidth):parseInt(result)}}}function computeStyleDimensions(){computedStyleNode||transclude(computedStyleScope=scope.$new(),function(clone){clone[0].removeAttribute("collection-repeat"),computedStyleNode=clone[0]}),computedStyleScope[keyExpr]=(listGetter(scope)||[])[0],$rootScope.$$phase||computedStyleScope.$digest(),containerNode.appendChild(computedStyleNode);var style=$window.getComputedStyle(computedStyleNode);computedStyleDimensions.width=parseInt(style.width),computedStyleDimensions.height=parseInt(style.height),containerNode.removeChild(computedStyleNode)}var scrollView=scrollCtrl.scrollView,node=element[0],containerNode=angular.element('<div class="collection-repeat-container">')[0];if(node.parentNode.replaceChild(containerNode,node),scrollView.options.scrollingX&&scrollView.options.scrollingY)throw new Error("collection-repeat expected a parent x or y scrollView, not an xy scrollView.");var repeatExpr=attr.collectionRepeat,match=repeatExpr.match(/^\s*([\s\S]+?)\s+in\s+([\s\S]+?)(?:\s+track\s+by\s+([\s\S]+?))?\s*$/);if(!match)throw new Error("collection-repeat expected expression in form of '_item_ in _collection_[ track by _id_]' but got '"+attr.collectionRepeat+"'.");var repeatManager,keyExpr=match[1],listExpr=match[2],listGetter=$parse(listExpr),heightData={},widthData={},computedStyleDimensions={},data=[],renderBufferExpr=attr.itemRenderBuffer||attr.collectionBufferSize,renderBuffer=angular.isDefined(renderBufferExpr)?parseInt(renderBufferExpr):DEFAULT_RENDER_BUFFER,heightExpr=attr.itemHeight||attr.collectionItemHeight,widthExpr=attr.itemWidth||attr.collectionItemWidth,afterItemsContainer=function(){var container=angular.element(scrollView.__content.querySelector(".collection-repeat-after-container"));if(!container.length){var elementIsAfterRepeater=!1,afterNodes=[].filter.call(scrollView.__content.childNodes,function(node){return ionic.DomUtil.contains(node,containerNode)?(elementIsAfterRepeater=!0,!1):elementIsAfterRepeater});container=angular.element('<span class="collection-repeat-after-container">'),scrollView.options.scrollingX&&container.addClass("horizontal"),container.append(afterNodes),scrollView.__content.appendChild(container[0])}return container}(),changeValidator=function(){var self;return self={dataLength:0,width:0,height:0,resizeRequiresRefresh:function(newWidth,newHeight){var requiresRefresh=self.dataLength&&newWidth&&newHeight&&(newWidth!==self.width||newHeight!==self.height);return self.width=newWidth,self.height=newHeight,!!requiresRefresh},dataChangeRequiresRefresh:function(newData){var requiresRefresh=newData.length>0||newData.length<self.dataLength;return self.dataLength=newData.length,!!requiresRefresh}}}();heightExpr?parseDimensionAttr(heightExpr,heightData):heightData.computed=!0,widthExpr?parseDimensionAttr(widthExpr,widthData):widthData.computed=!0,scrollCtrl.$element.on("scroll-resize",refreshDimensions),angular.element($window).on("resize",onResize);var unlistenToExposeAside=$rootScope.$on("$ionicExposeAside",ionic.animationFrameThrottle(function(){scrollCtrl.scrollView.resize(),onResize()}));$timeout(refreshDimensions,0,!1),scope.$watchCollection(listGetter,function(newValue){if(data=newValue||(newValue=[]),!angular.isArray(newValue))throw new Error("collection-repeat expected an array for '"+listExpr+"', but got a "+typeof value);scope.$$postDigest(function(){getRepeatManager().setData(data),changeValidator.dataChangeRequiresRefresh(data)&&refreshDimensions()})}),scope.$on("$destroy",function(){angular.element($window).off("resize",onResize),unlistenToExposeAside(),scrollCtrl.$element&&scrollCtrl.$element.off("scroll-resize",refreshDimensions),computedStyleNode&&computedStyleNode.parentNode&&computedStyleNode.parentNode.removeChild(computedStyleNode),computedStyleScope&&computedStyleScope.$destroy(),computedStyleScope=computedStyleNode=null,repeatManager&&repeatManager.destroy(),repeatManager=null});var computedStyleNode,computedStyleScope}}}function RepeatManagerFactory($rootScope,$window,$$rAF){var EMPTY_DIMENSION={primaryPos:0,secondaryPos:0,primarySize:0,secondarySize:0,rowPrimarySize:0};return function(options){function forceRerender(){return render(!0)}function render(forceRerender){if(!render.destroyed){var i,ii,item,dim,scope,scrollValue=view.getScrollValue(),scrollValueEnd=scrollValue+view.scrollPrimarySize;view.updateRenderRange(scrollValue,scrollValueEnd),renderStartIndex=Math.max(0,renderStartIndex-renderBuffer),renderEndIndex=Math.min(data.length-1,renderEndIndex+renderBuffer);for(i in itemsShownMap)(i<renderStartIndex||i>renderEndIndex)&&(item=itemsShownMap[i],delete itemsShownMap[i],itemsLeaving.push(item),item.isShown=!1);for(i=renderStartIndex;i<=renderEndIndex;i++)i>=data.length||itemsShownMap[i]&&!forceRerender||(item=itemsShownMap[i]||(itemsShownMap[i]=itemsLeaving.length?itemsLeaving.pop():itemsPool.length?itemsPool.shift():new RepeatItem),itemsEntering.push(item),item.isShown=!0,(scope=item.scope).$index=i,scope[keyExpression]=data[i],scope.$first=0===i,scope.$last=i===data.length-1,scope.$middle=!(scope.$first||scope.$last),scope.$odd=!(scope.$even=0==(1&i)),scope.$$disconnected&&ionic.Utils.reconnectScope(item.scope),dim=view.getDimensions(i),item.secondaryPos===dim.secondaryPos&&item.primaryPos===dim.primaryPos||(item.node.style[ionic.CSS.TRANSFORM]=TRANSLATE_TEMPLATE_STR.replace(PRIMARY,item.primaryPos=dim.primaryPos).replace(SECONDARY,item.secondaryPos=dim.secondaryPos)),item.secondarySize===dim.secondarySize&&item.primarySize===dim.primarySize||(item.node.style.cssText=item.node.style.cssText.replace(WIDTH_HEIGHT_REGEX,WIDTH_HEIGHT_TEMPLATE_STR.replace(PRIMARY,(item.primarySize=dim.primarySize)+1).replace(SECONDARY,item.secondarySize=dim.secondarySize))));for(renderEndIndex===data.length-1&&(dim=view.getDimensions(data.length-1)||EMPTY_DIMENSION,afterItemsNode.style[ionic.CSS.TRANSFORM]=TRANSLATE_TEMPLATE_STR.replace(PRIMARY,dim.primaryPos+dim.primarySize).replace(SECONDARY,0));itemsLeaving.length;)(item=itemsLeaving.pop()).scope.$broadcast("$collectionRepeatLeave"),ionic.Utils.disconnectScope(item.scope),itemsPool.push(item),item.node.style[ionic.CSS.TRANSFORM]="translate3d(-9999px,-9999px,0)",item.primaryPos=item.secondaryPos=null;if(forceRefreshImages)for(i=0,ii=itemsEntering.length;i<ii&&(item=itemsEntering[i]);i++)if(item.images)for(var img,j=0,jj=item.images.length;j<jj&&(img=item.images[j]);j++){var src=img.src;img.src=ONE_PX_TRANSPARENT_IMG_SRC,img.src=src}if(forceRerender)for(var rootScopePhase=$rootScope.$$phase;itemsEntering.length;)item=itemsEntering.pop(),rootScopePhase||item.scope.$digest();else digestEnteringItems()}}function digestEnteringItems(){var item;digestEnteringItems.running||(digestEnteringItems.running=!0,$$rAF(function(){for(var rootScopePhase=$rootScope.$$phase;itemsEntering.length;)(item=itemsEntering.pop()).isShown&&(rootScopePhase||item.scope.$digest());digestEnteringItems.running=!1}))}function RepeatItem(){var self=this;this.scope=scope.$new(),this.id="item"+nextItemId++,transclude(this.scope,function(clone){self.element=clone,self.element.data("$$collectionRepeatItem",self),self.node=clone[0],self.node.style[ionic.CSS.TRANSFORM]="translate3d(-9999px,-9999px,0)",self.node.style.cssText+=" height: 0px; width: 0px;",ionic.Utils.disconnectScope(self.scope),containerNode.appendChild(self.node),self.images=clone[0].getElementsByTagName("img")})}var estimatedHeight,estimatedWidth,afterItemsNode=options.afterItemsNode,containerNode=options.containerNode,forceRefreshImages=options.forceRefreshImages,heightData=options.heightData,widthData=options.widthData,keyExpression=options.keyExpression,renderBuffer=options.renderBuffer,scope=options.scope,scrollView=options.scrollView,transclude=options.transclude,data=[],getterLocals={},heightFn=heightData.getValue||function(){return heightData.value},heightGetter=function(index,value){return getterLocals[keyExpression]=value,getterLocals.$index=index,heightFn(scope,getterLocals)},widthFn=widthData.getValue||function(){return widthData.value},widthGetter=function(index,value){return getterLocals[keyExpression]=value,getterLocals.$index=index,widthFn(scope,getterLocals)},isVertical=!!scrollView.options.scrollingY,isGridView=isVertical?widthData.dynamic||widthData.value!==scrollView.__clientWidth:heightData.dynamic||heightData.value!==scrollView.__clientHeight,isStaticView=!heightData.dynamic&&!widthData.dynamic,PRIMARY="PRIMARY",SECONDARY="SECONDARY",TRANSLATE_TEMPLATE_STR=isVertical?"translate3d(SECONDARYpx,PRIMARYpx,0)":"translate3d(PRIMARYpx,SECONDARYpx,0)",WIDTH_HEIGHT_TEMPLATE_STR=isVertical?"height: PRIMARYpx; width: SECONDARYpx;":"height: SECONDARYpx; width: PRIMARYpx;",repeaterBeforeSize=0,repeaterAfterSize=0,renderStartIndex=-1,renderEndIndex=-1,renderAfterBoundary=-1,renderBeforeBoundary=-1,itemsPool=[],itemsLeaving=[],itemsEntering=[],itemsShownMap={},nextItemId=0,scrollViewSetDimensions=isVertical?function(){scrollView.setDimensions(null,null,null,view.getContentSize(),!0)}:function(){scrollView.setDimensions(null,null,view.getContentSize(),null,!0)},view=isVertical?new function(){this.getItemPrimarySize=heightGetter,this.getItemSecondarySize=widthGetter,this.getScrollValue=function(){return Math.max(0,Math.min(scrollView.__scrollTop-repeaterBeforeSize,scrollView.__maxScrollTop-repeaterBeforeSize-repeaterAfterSize))},this.refreshDirection=function(){this.scrollPrimarySize=scrollView.__clientHeight,this.scrollSecondarySize=scrollView.__clientWidth,this.estimatedPrimarySize=estimatedHeight,this.estimatedSecondarySize=estimatedWidth,this.estimatedItemsAcross=isGridView&&Math.floor(scrollView.__clientWidth/estimatedWidth)||1}}:new function(){this.getItemPrimarySize=widthGetter,this.getItemSecondarySize=heightGetter,this.getScrollValue=function(){return Math.max(0,Math.min(scrollView.__scrollLeft-repeaterBeforeSize,scrollView.__maxScrollLeft-repeaterBeforeSize-repeaterAfterSize))},this.refreshDirection=function(){this.scrollPrimarySize=scrollView.__clientWidth,this.scrollSecondarySize=scrollView.__clientHeight,this.estimatedPrimarySize=estimatedWidth,this.estimatedSecondarySize=estimatedHeight,this.estimatedItemsAcross=isGridView&&Math.floor(scrollView.__clientHeight/estimatedHeight)||1}};(isGridView?function(){this.getEstimatedSecondaryPos=function(index){return index%this.estimatedItemsAcross*this.estimatedSecondarySize},this.getEstimatedPrimaryPos=function(index){return Math.floor(index/this.estimatedItemsAcross)*this.estimatedPrimarySize},this.getEstimatedIndex=function(scrollValue){return Math.floor(scrollValue/this.estimatedPrimarySize)*this.estimatedItemsAcross}}:function(){this.getEstimatedSecondaryPos=function(){return 0},this.getEstimatedPrimaryPos=function(index){return index*this.estimatedPrimarySize},this.getEstimatedIndex=function(scrollValue){return Math.floor(scrollValue/this.estimatedPrimarySize)}}).call(view),(isStaticView?function(){this.getContentSize=function(){return this.getEstimatedPrimaryPos(data.length-1)+this.estimatedPrimarySize+repeaterBeforeSize+repeaterAfterSize};var dim={};this.getDimensions=function(index){return dim.primaryPos=this.getEstimatedPrimaryPos(index),dim.secondaryPos=this.getEstimatedSecondaryPos(index),dim.primarySize=this.estimatedPrimarySize,dim.secondarySize=this.estimatedSecondarySize,dim},this.updateRenderRange=function(scrollValue,scrollValueEnd){renderStartIndex=Math.max(0,this.getEstimatedIndex(scrollValue)),renderEndIndex=Math.min(data.length-1,this.getEstimatedIndex(scrollValueEnd)+this.estimatedItemsAcross-1),renderBeforeBoundary=Math.max(0,this.getEstimatedPrimaryPos(renderStartIndex)),renderAfterBoundary=this.getEstimatedPrimaryPos(renderEndIndex)+this.estimatedPrimarySize}}:function(){var dimensionsIndex,self=this,debouncedScrollViewSetDimensions=ionic.debounce(scrollViewSetDimensions,25,!0),calculateDimensions=isGridView?function(toIndex){var i,prevDimension,dim;for(i=Math.max(dimensionsIndex,0);i<=toIndex&&(dim=dimensions[i]);i++)prevDimension=dimensions[i-1]||EMPTY_DIMENSION,dim.secondarySize=Math.min(self.getItemSecondarySize(i,data[i]),self.scrollSecondarySize),dim.secondaryPos=prevDimension.secondaryPos+prevDimension.secondarySize,0===i||dim.secondaryPos+dim.secondarySize>self.scrollSecondarySize?(dim.secondaryPos=0,dim.primarySize=self.getItemPrimarySize(i,data[i]),dim.primaryPos=prevDimension.primaryPos+prevDimension.rowPrimarySize,dim.rowStartIndex=i,dim.rowPrimarySize=dim.primarySize):(dim.primarySize=self.getItemPrimarySize(i,data[i]),dim.primaryPos=prevDimension.primaryPos,dim.rowStartIndex=prevDimension.rowStartIndex,dimensions[dim.rowStartIndex].rowPrimarySize=dim.rowPrimarySize=Math.max(dimensions[dim.rowStartIndex].rowPrimarySize,dim.primarySize),dim.rowPrimarySize=Math.max(dim.primarySize,dim.rowPrimarySize))}:function(toIndex){var i,prevDimension,dim;for(i=Math.max(0,dimensionsIndex);i<=toIndex&&(dim=dimensions[i]);i++)prevDimension=dimensions[i-1]||EMPTY_DIMENSION,dim.primarySize=self.getItemPrimarySize(i,data[i]),dim.secondarySize=self.scrollSecondarySize,dim.primaryPos=prevDimension.primaryPos+prevDimension.primarySize,dim.secondaryPos=0},dimensions=[];this.getContentSize=function(){var dim=dimensions[dimensionsIndex]||EMPTY_DIMENSION;return(dim.primaryPos+dim.primarySize||0)+this.getEstimatedPrimaryPos(data.length-dimensionsIndex-1)+repeaterBeforeSize+repeaterAfterSize},this.onDestroy=function(){dimensions.length=0},this.onRefreshData=function(){var i,ii;for(i=dimensions.length,ii=data.length;i<ii;i++)dimensions.push({});dimensionsIndex=-1},this.onRefreshLayout=function(){dimensionsIndex=-1},this.getDimensions=function(index){return index=Math.min(index,data.length-1),dimensionsIndex<index&&(index>.9*data.length?(calculateDimensions(data.length-1),dimensionsIndex=data.length-1,scrollViewSetDimensions()):(calculateDimensions(index),dimensionsIndex=index,debouncedScrollViewSetDimensions())),dimensions[index]};var oldRenderStartIndex=-1,oldScrollValue=-1;this.updateRenderRange=function(scrollValue,scrollValueEnd){var i,len,dim;if(this.getDimensions(2*this.getEstimatedIndex(scrollValueEnd)),-1===oldRenderStartIndex||0===scrollValue)i=0;else if(scrollValue>=oldScrollValue)for(i=oldRenderStartIndex,len=data.length;i<len&&!((dim=this.getDimensions(i))&&dim.primaryPos+dim.rowPrimarySize>=scrollValue);i++);else for(i=oldRenderStartIndex;i>=0;i--)if((dim=this.getDimensions(i))&&dim.primaryPos<=scrollValue){i=isGridView?dim.rowStartIndex:i;break}renderStartIndex=Math.min(Math.max(0,i),data.length-1),renderBeforeBoundary=-1!==renderStartIndex?this.getDimensions(renderStartIndex).primaryPos:-1;var lastRowDim;for(i=renderStartIndex+1,len=data.length;i<len;i++)if((dim=this.getDimensions(i))&&dim.primaryPos+dim.rowPrimarySize>scrollValueEnd){if(isGridView)for(lastRowDim=dim;i<len-1&&(dim=this.getDimensions(i+1)).primaryPos===lastRowDim.primaryPos;)i++;break}renderEndIndex=Math.min(i,data.length-1),renderAfterBoundary=-1!==renderEndIndex?(dim=this.getDimensions(renderEndIndex)).primaryPos+(dim.rowPrimarySize||dim.primarySize):-1,oldScrollValue=scrollValue,oldRenderStartIndex=renderStartIndex}}).call(view);var contentSizeStr=isVertical?"getContentHeight":"getContentWidth",originalGetContentSize=scrollView.options[contentSizeStr];scrollView.options[contentSizeStr]=angular.bind(view,view.getContentSize),scrollView.__$callback=scrollView.__callback,scrollView.__callback=function(transformLeft,transformTop,zoom,wasResize){var scrollValue=view.getScrollValue();(-1===renderStartIndex||scrollValue+view.scrollPrimarySize>renderAfterBoundary||scrollValue<renderBeforeBoundary)&&render(),scrollView.__$callback(transformLeft,transformTop,zoom,wasResize)};var isLayoutReady=!1,isDataReady=!1;this.refreshLayout=function(){data.length?(estimatedHeight=heightGetter(0,data[0]),estimatedWidth=widthGetter(0,data[0])):(estimatedHeight=100,estimatedWidth=100);var style=getComputedStyle(afterItemsNode)||{},firstStyle=afterItemsNode.firstElementChild&&getComputedStyle(afterItemsNode.firstElementChild)||{},lastStyle=afterItemsNode.lastElementChild&&getComputedStyle(afterItemsNode.lastElementChild)||{};repeaterAfterSize=(parseInt(style[isVertical?"height":"width"])||0)+(firstStyle&&parseInt(firstStyle[isVertical?"marginTop":"marginLeft"])||0)+(lastStyle&&parseInt(lastStyle[isVertical?"marginBottom":"marginRight"])||0),repeaterBeforeSize=0;var current=containerNode;do{repeaterBeforeSize+=current[isVertical?"offsetTop":"offsetLeft"]}while(ionic.DomUtil.contains(scrollView.__content,current=current.offsetParent));var containerPrevNode=containerNode.previousElementSibling,beforeStyle=containerPrevNode?$window.getComputedStyle(containerPrevNode):{},beforeMargin=parseInt(beforeStyle[isVertical?"marginBottom":"marginRight"]||0);if(containerNode.style[ionic.CSS.TRANSFORM]=TRANSLATE_TEMPLATE_STR.replace(PRIMARY,-beforeMargin).replace(SECONDARY,0),repeaterBeforeSize-=beforeMargin,scrollView.__clientHeight&&scrollView.__clientWidth||(scrollView.__clientWidth=scrollView.__container.clientWidth,scrollView.__clientHeight=scrollView.__container.clientHeight),(view.onRefreshLayout||angular.noop)(),view.refreshDirection(),scrollViewSetDimensions(),!isLayoutReady)for(var poolSize=Math.max(20,3*renderBuffer),i=0;i<poolSize;i++)itemsPool.push(new RepeatItem);(isLayoutReady=!0)&&isDataReady&&((scrollView.__scrollLeft>scrollView.__maxScrollLeft||scrollView.__scrollTop>scrollView.__maxScrollTop)&&scrollView.resize(),forceRerender())},this.setData=function(newData){data=newData,(view.onRefreshData||angular.noop)(),isDataReady=!0},this.destroy=function(){render.destroyed=!0,itemsPool.forEach(function(item){item.scope.$destroy(),item.scope=item.element=item.node=item.images=null}),itemsPool.length=itemsEntering.length=itemsLeaving.length=0,itemsShownMap={},scrollView.options[contentSizeStr]=originalGetContentSize,scrollView.__callback=scrollView.__$callback,scrollView.resize(),(view.onDestroy||angular.noop)()}}}function gestureDirective(directiveName){return["$ionicGesture","$parse",function($ionicGesture,$parse){var eventType=directiveName.substr(2).toLowerCase();return function(scope,element,attr){var fn=$parse(attr[directiveName]),listener=function(ev){scope.$apply(function(){fn(scope,{$event:ev})})},gesture=$ionicGesture.on(eventType,listener,element);scope.$on("$destroy",function(){$ionicGesture.off(gesture,eventType,listener)})}}]}function headerFooterBarDirective(isHeader){return["$document","$timeout",function($document,$timeout){return{restrict:"E",controller:"$ionicHeaderBar",compile:function(tElement){return tElement.addClass(isHeader?"bar bar-header":"bar bar-footer"),$timeout(function(){isHeader&&$document[0].getElementsByClassName("tabs-top").length&&tElement.addClass("has-tabs-top")}),{pre:function($scope,$element,$attr,ctrl){isHeader?($scope.$watch(function(){return $element[0].className},function(value){var isShown=-1===value.indexOf("ng-hide"),isSubheader=-1!==value.indexOf("bar-subheader");$scope.$hasHeader=isShown&&!isSubheader,$scope.$hasSubheader=isShown&&isSubheader,$scope.$emit("$ionicSubheader",$scope.$hasSubheader)}),$scope.$on("$destroy",function(){delete $scope.$hasHeader,delete $scope.$hasSubheader}),ctrl.align(),$scope.$on("$ionicHeader.align",function(){ionic.requestAnimationFrame(function(){ctrl.align()})})):($scope.$watch(function(){return $element[0].className},function(value){var isShown=-1===value.indexOf("ng-hide"),isSubfooter=-1!==value.indexOf("bar-subfooter");$scope.$hasFooter=isShown&&!isSubfooter,$scope.$hasSubfooter=isShown&&isSubfooter}),$scope.$on("$destroy",function(){delete $scope.$hasFooter,delete $scope.$hasSubfooter}),$scope.$watch("$hasTabs",function(val){$element.toggleClass("has-tabs",!!val)}),ctrl.align(),$scope.$on("$ionicFooter.align",function(){ionic.requestAnimationFrame(function(){ctrl.align()})}))}}}}}]}function keyboardAttachGetClientHeight(element){return element.clientHeight}function eventStopPropagation(e){e.stopPropagation()}var IonicModule=angular.module("ionic",["ngAnimate","ngSanitize","ui.router","ngIOS9UIWebViewPatch"]),extend=angular.extend,forEach=angular.forEach,isDefined=angular.isDefined,isNumber=angular.isNumber,isString=angular.isString,jqLite=angular.element,noop=angular.noop;IonicModule.factory("$ionicActionSheet",["$rootScope","$compile","$animate","$timeout","$ionicTemplateLoader","$ionicPlatform","$ionicBody","IONIC_BACK_PRIORITY",function($rootScope,$compile,$animate,$timeout,$ionicTemplateLoader,$ionicPlatform,$ionicBody,IONIC_BACK_PRIORITY){return{show:function(opts){function textForIcon(text){text&&/icon/.test(text)&&(scope.$actionSheetHasIcon=!0)}var scope=$rootScope.$new(!0);extend(scope,{cancel:noop,destructiveButtonClicked:noop,buttonClicked:noop,$deregisterBackButton:noop,buttons:[],cancelOnStateChange:!0},opts||{});for(var x=0;x<scope.buttons.length;x++)textForIcon(scope.buttons[x].text);textForIcon(scope.cancelText),textForIcon(scope.destructiveText);var element=scope.element=$compile('<ion-action-sheet ng-class="cssClass" buttons="buttons"></ion-action-sheet>')(scope),sheetEl=jqLite(element[0].querySelector(".action-sheet-wrapper")),stateChangeListenDone=scope.cancelOnStateChange?$rootScope.$on("$stateChangeSuccess",function(){scope.cancel()}):noop;return scope.removeSheet=function(done){scope.removed||(scope.removed=!0,sheetEl.removeClass("action-sheet-up"),$timeout(function(){$ionicBody.removeClass("action-sheet-open")},400),scope.$deregisterBackButton(),stateChangeListenDone(),$animate.removeClass(element,"active").then(function(){scope.$destroy(),element.remove(),scope.cancel.$scope=sheetEl=null,(done||noop)(opts.buttons)}))},scope.showSheet=function(done){scope.removed||($ionicBody.append(element).addClass("action-sheet-open"),$animate.addClass(element,"active").then(function(){scope.removed||(done||noop)()}),$timeout(function(){scope.removed||sheetEl.addClass("action-sheet-up")},20,!1))},scope.$deregisterBackButton=$ionicPlatform.registerBackButtonAction(function(){$timeout(scope.cancel)},IONIC_BACK_PRIORITY.actionSheet),scope.cancel=function(){scope.removeSheet(opts.cancel)},scope.buttonClicked=function(index){!0===opts.buttonClicked(index,opts.buttons[index])&&scope.removeSheet()},scope.destructiveButtonClicked=function(){!0===opts.destructiveButtonClicked()&&scope.removeSheet()},scope.showSheet(),scope.cancel.$scope=scope,scope.cancel}}}]),jqLite.prototype.addClass=function(cssClasses){var x,y,cssClass,el,splitClasses,existingClasses;if(cssClasses&&"ng-scope"!=cssClasses&&"ng-isolate-scope"!=cssClasses)for(x=0;x<this.length;x++)if((el=this[x]).setAttribute)if(cssClasses.indexOf(" ")<0&&el.classList.add)el.classList.add(cssClasses);else{for(existingClasses=(" "+(el.getAttribute("class")||"")+" ").replace(/[\n\t]/g," "),splitClasses=cssClasses.split(" "),y=0;y<splitClasses.length;y++)cssClass=splitClasses[y].trim(),-1===existingClasses.indexOf(" "+cssClass+" ")&&(existingClasses+=cssClass+" ");el.setAttribute("class",existingClasses.trim())}return this},jqLite.prototype.removeClass=function(cssClasses){var x,y,splitClasses,cssClass,el;if(cssClasses)for(x=0;x<this.length;x++)if((el=this[x]).getAttribute)if(cssClasses.indexOf(" ")<0&&el.classList.remove)el.classList.remove(cssClasses);else for(splitClasses=cssClasses.split(" "),y=0;y<splitClasses.length;y++)cssClass=splitClasses[y],el.setAttribute("class",(" "+(el.getAttribute("class")||"")+" ").replace(/[\n\t]/g," ").replace(" "+cssClass.trim()+" "," ").trim());return this},IonicModule.factory("$ionicBackdrop",["$document","$timeout","$$rAF","$rootScope",function($document,$timeout,$$rAF,$rootScope){var el=jqLite('<div class="backdrop">'),backdropHolds=0;return $document[0].body.appendChild(el[0]),{retain:function(){1==++backdropHolds&&(el.addClass("visible"),$rootScope.$broadcast("backdrop.shown"),$$rAF(function(){backdropHolds>=1&&el.addClass("active")}))},release:function(){1===backdropHolds&&(el.removeClass("active"),$rootScope.$broadcast("backdrop.hidden"),$timeout(function(){0===backdropHolds&&el.removeClass("visible")},400,!1)),backdropHolds=Math.max(0,backdropHolds-1)},getElement:function(){return el},_element:el}}]),IonicModule.factory("$ionicBind",["$parse","$interpolate",function($parse,$interpolate){var LOCAL_REGEXP=/^\s*([@=&])(\??)\s*(\w*)\s*$/;return function(scope,attrs,bindDefinition){forEach(bindDefinition||{},function(definition,scopeName){var parentGet,unwatch,match=definition.match(LOCAL_REGEXP)||[],attrName=match[3]||scopeName;switch(match[1]){case"@":if(!attrs[attrName])return;attrs.$observe(attrName,function(value){scope[scopeName]=value}),attrs[attrName]&&(scope[scopeName]=$interpolate(attrs[attrName])(scope));break;case"=":if(!attrs[attrName])return;unwatch=scope.$watch(attrs[attrName],function(value){scope[scopeName]=value}),scope.$on("$destroy",unwatch);break;case"&":if(attrs[attrName]&&attrs[attrName].match(RegExp(scopeName+"(.*?)")))throw new Error('& expression binding "'+scopeName+'" looks like it will recursively call "'+attrs[attrName]+'" and cause a stack overflow! Please choose a different scopeName.');parentGet=$parse(attrs[attrName]),scope[scopeName]=function(locals){return parentGet(scope,locals)}}})}}]),IonicModule.factory("$ionicBody",["$document",function($document){return{addClass:function(){for(var x=0;x<arguments.length;x++)$document[0].body.classList.add(arguments[x]);return this},removeClass:function(){for(var x=0;x<arguments.length;x++)$document[0].body.classList.remove(arguments[x]);return this},enableClass:function(shouldEnableClass){var args=Array.prototype.slice.call(arguments).slice(1);return shouldEnableClass?this.addClass.apply(this,args):this.removeClass.apply(this,args),this},append:function(ele){return $document[0].body.appendChild(ele.length?ele[0]:ele),this},get:function(){return $document[0].body}}}]),IonicModule.factory("$ionicClickBlock",["$document","$ionicBody","$timeout",function($document,$ionicBody,$timeout){function preventClick(ev){ev.preventDefault(),ev.stopPropagation()}function addClickBlock(){pendingShow&&(cbEle?cbEle.classList.remove(CSS_HIDE):((cbEle=$document[0].createElement("div")).className="click-block",$ionicBody.append(cbEle),cbEle.addEventListener("touchstart",preventClick),cbEle.addEventListener("mousedown",preventClick)),pendingShow=!1)}function removeClickBlock(){cbEle&&cbEle.classList.add(CSS_HIDE)}var cbEle,fallbackTimer,pendingShow,CSS_HIDE="click-block-hide";return{show:function(autoExpire){pendingShow=!0,$timeout.cancel(fallbackTimer),fallbackTimer=$timeout(this.hide,autoExpire||310,!1),addClickBlock()},hide:function(){pendingShow=!1,$timeout.cancel(fallbackTimer),removeClickBlock()}}}]),IonicModule.factory("$ionicGesture",[function(){return{on:function(eventType,cb,$element,options){return window.ionic.onGesture(eventType,cb,$element[0],options)},off:function(gesture,eventType,cb){return window.ionic.offGesture(gesture,eventType,cb)}}}]),IonicModule.factory("$ionicHistory",["$rootScope","$state","$location","$window","$timeout","$ionicViewSwitcher","$ionicNavViewDelegate",function($rootScope,$state,$location,$window,$timeout,$ionicViewSwitcher,$ionicNavViewDelegate){function getViewById(viewId){return viewId?viewHistory.views[viewId]:null}function getBackView(view){return view?getViewById(view.backViewId):null}function getForwardView(view){return view?getViewById(view.forwardViewId):null}function getHistoryById(historyId){return historyId?viewHistory.histories[historyId]:null}function getHistory(scope){var histObj=getParentHistoryObj(scope);return viewHistory.histories[histObj.historyId]||(viewHistory.histories[histObj.historyId]={historyId:histObj.historyId,parentHistoryId:getParentHistoryObj(histObj.scope.$parent).historyId,stack:[],cursor:-1}),getHistoryById(histObj.historyId)}function getParentHistoryObj(scope){for(var parentScope=scope;parentScope;){if(parentScope.hasOwnProperty("$historyId"))return{historyId:parentScope.$historyId,scope:parentScope};parentScope=parentScope.$parent}return{historyId:"root",scope:$rootScope}}function setNavViews(viewId){viewHistory.currentView=getViewById(viewId),viewHistory.backView=getBackView(viewHistory.currentView),viewHistory.forwardView=getForwardView(viewHistory.currentView)}function getCurrentStateId(){var id;if($state&&$state.current&&$state.current.name){if(id=$state.current.name,$state.params)for(var key in $state.params)$state.params.hasOwnProperty(key)&&$state.params[key]&&(id+="_"+key+"="+$state.params[key]);return id}return ionic.Utils.nextUid()}function getCurrentStateParams(){var rtn;if($state&&$state.params)for(var key in $state.params)$state.params.hasOwnProperty(key)&&((rtn=rtn||{})[key]=$state.params[key]);return rtn}function isAbstractTag(ele){return ele&&ele.length&&/ion-side-menus|ion-tabs/i.test(ele[0].tagName)}function canSwipeBack(ele,viewLocals){return(!viewLocals||!viewLocals.$$state||!1!==viewLocals.$$state.self.canSwipeBack)&&(!ele||"false"!==ele.attr("can-swipe-back"))}var lastStateId,nextViewOptions,deregisterStateChangeListener,nextViewExpireTimer,forcedNav,stateChangeCounter=0,viewHistory={histories:{root:{historyId:"root",parentHistoryId:null,stack:[],cursor:-1}},views:{},backView:null,forwardView:null,currentView:null},View=function(){};return View.prototype.initialize=function(data){if(data){for(var name in data)this[name]=data[name];return this}return null},View.prototype.go=function(){if(this.stateName)return $state.go(this.stateName,this.stateParams);if(this.url&&this.url!==$location.url()){if(viewHistory.backView===this)return $window.history.go(-1);if(viewHistory.forwardView===this)return $window.history.go(1);$location.url(this.url)}return null},View.prototype.destroy=function(){this.scope&&(this.scope.$destroy&&this.scope.$destroy(),this.scope=null)},{register:function(parentScope,viewLocals){var tmp,x,ele,currentStateId=getCurrentStateId(),hist=getHistory(parentScope),currentView=viewHistory.currentView,backView=viewHistory.backView,forwardView=viewHistory.forwardView,viewId=null,action=null,direction="none",historyId=hist.historyId,url=$location.url();if(lastStateId!==currentStateId&&(lastStateId=currentStateId,stateChangeCounter++),forcedNav)viewId=forcedNav.viewId,action=forcedNav.action,direction=forcedNav.direction,forcedNav=null;else if(backView&&backView.stateId===currentStateId)viewId=backView.viewId,historyId=backView.historyId,action="moveBack",backView.historyId===currentView.historyId?direction="back":currentView&&(direction="exit",(tmp=getHistoryById(backView.historyId))&&tmp.parentHistoryId===currentView.historyId?direction="enter":(tmp=getHistoryById(currentView.historyId))&&tmp.parentHistoryId===hist.parentHistoryId&&(direction="swap"));else if(forwardView&&forwardView.stateId===currentStateId)viewId=forwardView.viewId,historyId=forwardView.historyId,action="moveForward",forwardView.historyId===currentView.historyId?direction="forward":currentView&&(direction="exit",currentView.historyId===hist.parentHistoryId?direction="enter":(tmp=getHistoryById(currentView.historyId))&&tmp.parentHistoryId===hist.parentHistoryId&&(direction="swap")),tmp=getParentHistoryObj(parentScope),forwardView.historyId&&tmp.scope&&(tmp.scope.$historyId=forwardView.historyId,historyId=forwardView.historyId);else if(currentView&&currentView.historyId!==historyId&&hist.cursor>-1&&hist.stack.length>0&&hist.cursor<hist.stack.length&&hist.stack[hist.cursor].stateId===currentStateId){var switchToView=hist.stack[hist.cursor];viewId=switchToView.viewId,historyId=switchToView.historyId,action="moveBack",direction="swap",(tmp=getHistoryById(currentView.historyId))&&tmp.parentHistoryId===historyId?direction="exit":(tmp=getHistoryById(historyId))&&tmp.parentHistoryId===currentView.historyId&&(direction="enter"),(tmp=getViewById(switchToView.backViewId))&&switchToView.historyId!==tmp.historyId&&(hist.stack[hist.cursor].backViewId=currentView.viewId)}else{if(ele=$ionicViewSwitcher.createViewEle(viewLocals),this.isAbstractEle(ele,viewLocals))return{action:"abstractView",direction:"none",ele:ele};if(viewId=ionic.Utils.nextUid(),currentView){if(currentView.forwardViewId=viewId,action="newView",forwardView&&currentView.stateId!==forwardView.stateId&&currentView.historyId===forwardView.historyId&&(tmp=getHistoryById(forwardView.historyId))){for(x=tmp.stack.length-1;x>=forwardView.index;x--){var stackItem=tmp.stack[x];stackItem&&stackItem.destroy&&stackItem.destroy(),tmp.stack.splice(x)}historyId=forwardView.historyId}hist.historyId===currentView.historyId?direction="forward":currentView.historyId!==hist.historyId&&(direction="enter",(tmp=getHistoryById(currentView.historyId))&&tmp.parentHistoryId===hist.parentHistoryId?direction="swap":(tmp=getHistoryById(tmp.parentHistoryId))&&tmp.historyId===hist.historyId&&(direction="exit"))}else action="initialView";stateChangeCounter<2&&(direction="none"),viewHistory.views[viewId]=this.createView({viewId:viewId,index:hist.stack.length,historyId:hist.historyId,backViewId:currentView&&currentView.viewId?currentView.viewId:null,forwardViewId:null,stateId:currentStateId,stateName:this.currentStateName(),stateParams:getCurrentStateParams(),url:url,canSwipeBack:canSwipeBack(ele,viewLocals)}),hist.stack.push(viewHistory.views[viewId])}if(deregisterStateChangeListener&&deregisterStateChangeListener(),$timeout.cancel(nextViewExpireTimer),nextViewOptions){if(nextViewOptions.disableAnimate&&(direction="none"),nextViewOptions.disableBack&&(viewHistory.views[viewId].backViewId=null),nextViewOptions.historyRoot){for(x=0;x<hist.stack.length;x++)hist.stack[x].viewId===viewId?(hist.stack[x].index=0,hist.stack[x].backViewId=hist.stack[x].forwardViewId=null):delete viewHistory.views[hist.stack[x].viewId];hist.stack=[viewHistory.views[viewId]]}nextViewOptions=null}if(setNavViews(viewId),viewHistory.backView&&historyId==viewHistory.backView.historyId&&currentStateId==viewHistory.backView.stateId&&url==viewHistory.backView.url)for(x=0;x<hist.stack.length;x++)if(hist.stack[x].viewId==viewId){action="dupNav",direction="none",x>0&&(hist.stack[x-1].forwardViewId=null),viewHistory.forwardView=null,viewHistory.currentView.index=viewHistory.backView.index,viewHistory.currentView.backViewId=viewHistory.backView.backViewId,viewHistory.backView=getBackView(viewHistory.backView),hist.stack.splice(x,1);break}return hist.cursor=viewHistory.currentView.index,{viewId:viewId,action:action,direction:direction,historyId:historyId,enableBack:this.enabledBack(viewHistory.currentView),isHistoryRoot:0===viewHistory.currentView.index,ele:ele}},registerHistory:function(scope){scope.$historyId=ionic.Utils.nextUid()},createView:function(data){return(new View).initialize(data)},getViewById:getViewById,viewHistory:function(){return viewHistory},currentView:function(view){return arguments.length&&(viewHistory.currentView=view),viewHistory.currentView},currentHistoryId:function(){return viewHistory.currentView?viewHistory.currentView.historyId:null},currentTitle:function(val){if(viewHistory.currentView)return arguments.length&&(viewHistory.currentView.title=val),viewHistory.currentView.title},backView:function(view){return arguments.length&&(viewHistory.backView=view),viewHistory.backView},backTitle:function(view){var backView=view&&getViewById(view.backViewId)||viewHistory.backView;return backView&&backView.title},forwardView:function(view){return arguments.length&&(viewHistory.forwardView=view),viewHistory.forwardView},currentStateName:function(){return $state&&$state.current?$state.current.name:null},isCurrentStateNavView:function(navView){return!!($state&&$state.current&&$state.current.views&&$state.current.views[navView])},goToHistoryRoot:function(historyId){if(historyId){var hist=getHistoryById(historyId);if(hist&&hist.stack.length){if(viewHistory.currentView&&viewHistory.currentView.viewId===hist.stack[0].viewId)return;forcedNav={viewId:hist.stack[0].viewId,action:"moveBack",direction:"back"},hist.stack[0].go()}}},goBack:function(backCount){if(isDefined(backCount)&&-1!==backCount){if(backCount>-1)return;var currentHistory=viewHistory.histories[this.currentHistoryId()],newCursor=currentHistory.cursor+backCount+1;newCursor<1&&(newCursor=1),currentHistory.cursor=newCursor,setNavViews(currentHistory.stack[newCursor].viewId);for(var cursor=newCursor-1,clearStateIds=[],fwdView=getViewById(currentHistory.stack[cursor].forwardViewId);fwdView&&(clearStateIds.push(fwdView.stateId||fwdView.viewId),!(++cursor>=currentHistory.stack.length));)fwdView=getViewById(currentHistory.stack[cursor].forwardViewId);var self=this;clearStateIds.length&&$timeout(function(){self.clearCache(clearStateIds)},600)}viewHistory.backView&&viewHistory.backView.go()},enabledBack:function(view){var backView=getBackView(view);return!(!backView||backView.historyId!==view.historyId)},clearHistory:function(){var histories=viewHistory.histories,currentView=viewHistory.currentView;if(histories)for(var historyId in histories)histories[historyId].stack&&(histories[historyId].stack=[],histories[historyId].cursor=-1),currentView&&currentView.historyId===historyId?(currentView.backViewId=currentView.forwardViewId=null,histories[historyId].stack.push(currentView)):histories[historyId].destroy&&histories[historyId].destroy();for(var viewId in viewHistory.views)viewId!==currentView.viewId&&delete viewHistory.views[viewId];currentView&&setNavViews(currentView.viewId)},clearCache:function(stateIds){return $timeout(function(){$ionicNavViewDelegate._instances.forEach(function(instance){instance.clearCache(stateIds)})})},nextViewOptions:function(opts){return deregisterStateChangeListener&&deregisterStateChangeListener(),arguments.length&&($timeout.cancel(nextViewExpireTimer),null===opts?nextViewOptions=opts:(extend(nextViewOptions=nextViewOptions||{},opts),nextViewOptions.expire&&(deregisterStateChangeListener=$rootScope.$on("$stateChangeSuccess",function(){nextViewExpireTimer=$timeout(function(){nextViewOptions=null},nextViewOptions.expire)})))),nextViewOptions},isAbstractEle:function(ele,viewLocals){return!!(viewLocals&&viewLocals.$$state&&viewLocals.$$state.self.abstract)||!(!ele||!isAbstractTag(ele)&&!isAbstractTag(ele.children()))},isActiveScope:function(scope){if(!scope)return!1;for(var foundHistoryId,climbScope=scope,currentHistoryId=this.currentHistoryId();climbScope;){if(climbScope.$$disconnected)return!1;if(!foundHistoryId&&climbScope.hasOwnProperty("$historyId")&&(foundHistoryId=!0),currentHistoryId){if(climbScope.hasOwnProperty("$historyId")&&currentHistoryId==climbScope.$historyId)return!0;if(climbScope.hasOwnProperty("$activeHistoryId")&&currentHistoryId==climbScope.$activeHistoryId){if(climbScope.hasOwnProperty("$historyId"))return!0;if(!foundHistoryId)return!0}}foundHistoryId&&climbScope.hasOwnProperty("$activeHistoryId")&&(foundHistoryId=!1),climbScope=climbScope.$parent}return!currentHistoryId||"root"==currentHistoryId}}}]).run(["$rootScope","$state","$location","$document","$ionicPlatform","$ionicHistory","IONIC_BACK_PRIORITY",function($rootScope,$state,$location,$document,$ionicPlatform,$ionicHistory,IONIC_BACK_PRIORITY){$rootScope.$on("$ionicView.beforeEnter",function(){ionic.keyboard&&ionic.keyboard.hide&&ionic.keyboard.hide()}),$rootScope.$on("$ionicHistory.change",function(e,data){if(!data)return null;var viewHistory=$ionicHistory.viewHistory(),hist=data.historyId?viewHistory.histories[data.historyId]:null;if(hist&&hist.cursor>-1&&hist.cursor<hist.stack.length)return hist.stack[hist.cursor].go(data);!data.url&&data.uiSref&&(data.url=$state.href(data.uiSref)),data.url&&(0===data.url.indexOf("#")&&(data.url=data.url.replace("#","")),data.url!==$location.url()&&$location.url(data.url))}),$rootScope.$ionicGoBack=function(backCount){$ionicHistory.goBack(backCount)},$rootScope.$on("$ionicView.afterEnter",function(ev,data){data&&data.title&&($document[0].title=data.title)}),$ionicPlatform.registerBackButtonAction(function(e){var backView=$ionicHistory.backView();return backView?backView.go():ionic.Platform.exitApp(),e.preventDefault(),!1},IONIC_BACK_PRIORITY.view)}]),IonicModule.provider("$ionicConfig",function(){function setPlatformConfig(platformName,platformConfigs){configProperties.platform[platformName]=platformConfigs,provider.platform[platformName]={},addConfig(configProperties,configProperties.platform[platformName]),createConfig(configProperties.platform[platformName],provider.platform[platformName],"")}function addConfig(configObj,platformObj){for(var n in configObj)n!=PLATFORM&&configObj.hasOwnProperty(n)&&(angular.isObject(configObj[n])?(isDefined(platformObj[n])||(platformObj[n]={}),addConfig(configObj[n],platformObj[n])):isDefined(platformObj[n])||(platformObj[n]=null))}function createConfig(configObj,providerObj,platformPath){forEach(configObj,function(value,namespace){angular.isObject(configObj[namespace])?(providerObj[namespace]={},createConfig(configObj[namespace],providerObj[namespace],platformPath+"."+namespace)):providerObj[namespace]=function(newValue){if(arguments.length)return configObj[namespace]=newValue,providerObj;if(configObj[namespace]==PLATFORM){var platformConfig=stringObj(configProperties.platform,ionic.Platform.platform()+platformPath+"."+namespace);return platformConfig||!1===platformConfig?platformConfig:stringObj(configProperties.platform,"default"+platformPath+"."+namespace)}return configObj[namespace]}})}function stringObj(obj,str){str=str.split(".");for(var i=0;i<str.length;i++){if(!obj||!isDefined(obj[str[i]]))return null;obj=obj[str[i]]}return obj}var provider=this;provider.platform={};var PLATFORM="platform",configProperties={views:{maxCache:PLATFORM,forwardCache:PLATFORM,transition:PLATFORM,swipeBackEnabled:PLATFORM,swipeBackHitWidth:PLATFORM},navBar:{alignTitle:PLATFORM,positionPrimaryButtons:PLATFORM,positionSecondaryButtons:PLATFORM,transition:PLATFORM},backButton:{icon:PLATFORM,text:PLATFORM,previousTitleText:PLATFORM},form:{checkbox:PLATFORM,toggle:PLATFORM},scrolling:{jsScrolling:PLATFORM},spinner:{icon:PLATFORM},tabs:{style:PLATFORM,position:PLATFORM},templates:{maxPrefetch:PLATFORM},platform:{}};createConfig(configProperties,provider,""),setPlatformConfig("default",{views:{maxCache:10,forwardCache:!1,transition:"ios",swipeBackEnabled:!0,swipeBackHitWidth:45},navBar:{alignTitle:"center",positionPrimaryButtons:"left",positionSecondaryButtons:"right",transition:"view"},backButton:{icon:"ion-ios-arrow-back",text:"Back",previousTitleText:!0},form:{checkbox:"circle",toggle:"large"},scrolling:{jsScrolling:!0},spinner:{icon:"ios"},tabs:{style:"standard",position:"bottom"},templates:{maxPrefetch:30}}),setPlatformConfig("ios",{}),setPlatformConfig("android",{views:{transition:"android",swipeBackEnabled:!1},navBar:{alignTitle:"left",positionPrimaryButtons:"right",positionSecondaryButtons:"right"},backButton:{icon:"ion-android-arrow-back",text:!1,previousTitleText:!1},form:{checkbox:"square",toggle:"small"},spinner:{icon:"android"},tabs:{style:"striped",position:"top"},scrolling:{jsScrolling:!1}}),setPlatformConfig("windowsphone",{spinner:{icon:"android"}}),provider.transitions={views:{},navBar:{}},provider.transitions.views.ios=function(enteringEle,leavingEle,direction,shouldAnimate){function setStyles(ele,opacity,x,boxShadowOpacity){var css={};css[ionic.CSS.TRANSITION_DURATION]=d.shouldAnimate?"":0,css.opacity=opacity,boxShadowOpacity>-1&&(css.boxShadow="0 0 10px rgba(0,0,0,"+(d.shouldAnimate?.45*boxShadowOpacity:.3)+")"),css[ionic.CSS.TRANSFORM]="translate3d("+x+"%,0,0)",ionic.DomUtil.cachedStyles(ele,css)}var d={run:function(step){"forward"==direction?(setStyles(enteringEle,1,99*(1-step),1-step),setStyles(leavingEle,1-.1*step,-33*step,-1)):"back"==direction?(setStyles(enteringEle,1-.1*(1-step),-33*(1-step),-1),setStyles(leavingEle,1,100*step,1-step)):(setStyles(enteringEle,1,0,-1),setStyles(leavingEle,0,0,-1))},shouldAnimate:shouldAnimate&&("forward"==direction||"back"==direction)};return d},provider.transitions.navBar.ios=function(enteringHeaderBar,leavingHeaderBar,direction,shouldAnimate){function setStyles(ctrl,opacity,titleX,backTextX){var css={};css[ionic.CSS.TRANSITION_DURATION]=d.shouldAnimate?"":"0ms",css.opacity=1===opacity?"":opacity,ctrl.setCss("buttons-left",css),ctrl.setCss("buttons-right",css),ctrl.setCss("back-button",css),css[ionic.CSS.TRANSFORM]="translate3d("+backTextX+"px,0,0)",ctrl.setCss("back-text",css),css[ionic.CSS.TRANSFORM]="translate3d("+titleX+"px,0,0)",ctrl.setCss("title",css)}function enter(ctrlA,ctrlB,step){ctrlA&&ctrlB&&setStyles(ctrlA,step,(ctrlA.titleTextX()+ctrlA.titleWidth())*(1-step),ctrlB&&(ctrlB.titleTextX()-ctrlA.backButtonTextLeft())*(1-step)||0)}function leave(ctrlA,ctrlB,step){ctrlA&&ctrlB&&setStyles(ctrlA,1-step,(-(ctrlA.titleTextX()-ctrlB.backButtonTextLeft())-ctrlA.titleLeftRight())*step,0)}var d={run:function(step){var enteringHeaderCtrl=enteringHeaderBar.controller(),leavingHeaderCtrl=leavingHeaderBar&&leavingHeaderBar.controller();"back"==d.direction?(leave(enteringHeaderCtrl,leavingHeaderCtrl,1-step),enter(leavingHeaderCtrl,enteringHeaderCtrl,1-step)):(enter(enteringHeaderCtrl,leavingHeaderCtrl,step),leave(leavingHeaderCtrl,enteringHeaderCtrl,step))},direction:direction,shouldAnimate:shouldAnimate&&("forward"==direction||"back"==direction)};return d},provider.transitions.views.android=function(enteringEle,leavingEle,direction,shouldAnimate){function setStyles(ele,x){var css={};css[ionic.CSS.TRANSITION_DURATION]=d.shouldAnimate?"":0,css[ionic.CSS.TRANSFORM]="translate3d("+x+"%,0,0)",ionic.DomUtil.cachedStyles(ele,css)}var d={run:function(step){"forward"==direction?(setStyles(enteringEle,99*(1-step)),setStyles(leavingEle,-100*step)):"back"==direction?(setStyles(enteringEle,-100*(1-step)),setStyles(leavingEle,100*step)):(setStyles(enteringEle,0),setStyles(leavingEle,0))},shouldAnimate:shouldAnimate=shouldAnimate&&("forward"==direction||"back"==direction)};return d},provider.transitions.navBar.android=function(enteringHeaderBar,leavingHeaderBar,direction,shouldAnimate){function setStyles(ctrl,opacity){if(ctrl){var css={};css.opacity=1===opacity?"":opacity,ctrl.setCss("buttons-left",css),ctrl.setCss("buttons-right",css),ctrl.setCss("back-button",css),ctrl.setCss("back-text",css),ctrl.setCss("title",css)}}return{run:function(step){setStyles(enteringHeaderBar.controller(),step),setStyles(leavingHeaderBar&&leavingHeaderBar.controller(),1-step)},shouldAnimate:shouldAnimate&&("forward"==direction||"back"==direction)}},provider.transitions.views.none=function(enteringEle,leavingEle){return{run:function(step){provider.transitions.views.android(enteringEle,leavingEle,!1,!1).run(step)},shouldAnimate:!1}},provider.transitions.navBar.none=function(enteringHeaderBar,leavingHeaderBar){return{run:function(step){provider.transitions.navBar.ios(enteringHeaderBar,leavingHeaderBar,!1,!1).run(step),provider.transitions.navBar.android(enteringHeaderBar,leavingHeaderBar,!1,!1).run(step)},shouldAnimate:!1}},provider.setPlatformConfig=setPlatformConfig,provider.$get=function(){return provider}}).config(["$compileProvider",function($compileProvider){$compileProvider.aHrefSanitizationWhitelist(/^\s*(https?|sms|tel|geo|ftp|mailto|file|ghttps?|ms-appx-web|ms-appx|x-wmapp0):/),$compileProvider.imgSrcSanitizationWhitelist(/^\s*(https?|ftp|file|content|blob|ms-appx|ms-appx-web|x-wmapp0):|data:image\//)}]);var LOADING_TPL='<div class="loading-container"><div class="loading"></div></div>',LOADING_HIDE_DEPRECATED="$ionicLoading instance.hide() has been deprecated. Use $ionicLoading.hide().",LOADING_SHOW_DEPRECATED="$ionicLoading instance.show() has been deprecated. Use $ionicLoading.show().",LOADING_SET_DEPRECATED="$ionicLoading instance.setContent() has been deprecated. Use $ionicLoading.show({ template: 'my content' }).";IonicModule.constant("$ionicLoadingConfig",{template:"<ion-spinner></ion-spinner>"}).factory("$ionicLoading",["$ionicLoadingConfig","$ionicBody","$ionicTemplateLoader","$ionicBackdrop","$timeout","$q","$log","$compile","$ionicPlatform","$rootScope","IONIC_BACK_PRIORITY",function($ionicLoadingConfig,$ionicBody,$ionicTemplateLoader,$ionicBackdrop,$timeout,$q,$log,$compile,$ionicPlatform,$rootScope,IONIC_BACK_PRIORITY){function getLoader(){return loaderInstance||(loaderInstance=$ionicTemplateLoader.compile({template:LOADING_TPL,appendTo:$ionicBody.get()}).then(function(self){return self.show=function(options){var templatePromise=options.templateUrl?$ionicTemplateLoader.load(options.templateUrl):$q.when(options.template||options.content||"");self.scope=options.scope||self.scope,self.isShown||(self.hasBackdrop=!options.noBackdrop&&!1!==options.showBackdrop,self.hasBackdrop&&($ionicBackdrop.retain(),$ionicBackdrop.getElement().addClass("backdrop-loading"))),options.duration&&($timeout.cancel(self.durationTimeout),self.durationTimeout=$timeout(angular.bind(self,self.hide),+options.duration)),deregisterBackAction(),deregisterBackAction=$ionicPlatform.registerBackButtonAction(noop,IONIC_BACK_PRIORITY.loading),templatePromise.then(function(html){if(html){var loading=self.element.children();loading.html(html),$compile(loading.contents())(self.scope)}self.isShown&&(self.element.addClass("visible"),ionic.requestAnimationFrame(function(){self.isShown&&(self.element.addClass("active"),$ionicBody.addClass("loading-active"))}))}),self.isShown=!0},self.hide=function(){deregisterBackAction(),self.isShown&&(self.hasBackdrop&&($ionicBackdrop.release(),$ionicBackdrop.getElement().removeClass("backdrop-loading")),self.element.removeClass("active"),$ionicBody.removeClass("loading-active"),self.element.removeClass("visible"),ionic.requestAnimationFrame(function(){!self.isShown&&self.element.removeClass("visible")})),$timeout.cancel(self.durationTimeout),self.isShown=!1,self.element.children().html("")},self})),loaderInstance}function showLoader(options){var delay=(options=extend({},$ionicLoadingConfig||{},options||{})).delay||options.showDelay||0;return deregisterStateListener1(),deregisterStateListener2(),options.hideOnStateChange&&(deregisterStateListener1=$rootScope.$on("$stateChangeSuccess",hideLoader),deregisterStateListener2=$rootScope.$on("$stateChangeError",hideLoader)),$timeout.cancel(loadingShowDelay),(loadingShowDelay=$timeout(noop,delay)).then(getLoader).then(function(loader){return loader.show(options)}),{hide:function(){return $log.error(LOADING_HIDE_DEPRECATED),hideLoader.apply(this,arguments)},show:function(){return $log.error(LOADING_SHOW_DEPRECATED),showLoader.apply(this,arguments)},setContent:function(content){return $log.error(LOADING_SET_DEPRECATED),getLoader().then(function(loader){loader.show({template:content})})}}}function hideLoader(){deregisterStateListener1(),deregisterStateListener2(),$timeout.cancel(loadingShowDelay),getLoader().then(function(loader){loader.hide()})}var loaderInstance,deregisterBackAction=noop,deregisterStateListener1=noop,deregisterStateListener2=noop,loadingShowDelay=$q.when();return{show:showLoader,hide:hideLoader,_getLoader:getLoader}}]),IonicModule.factory("$ionicModal",["$rootScope","$ionicBody","$compile","$timeout","$ionicPlatform","$ionicTemplateLoader","$$q","$log","$ionicClickBlock","$window","IONIC_BACK_PRIORITY",function($rootScope,$ionicBody,$compile,$timeout,$ionicPlatform,$ionicTemplateLoader,$$q,$log,$ionicClickBlock,$window,IONIC_BACK_PRIORITY){var ModalView=ionic.views.Modal.inherit({initialize:function(opts){ionic.views.Modal.prototype.initialize.call(this,opts),this.animation=opts.animation||"slide-in-up"},show:function(target){var self=this;if(self.scope.$$destroyed)return $log.error("Cannot call "+self.viewType+".show() after remove(). Please create a new "+self.viewType+" instance."),$$q.when();$ionicClickBlock.show(600),stack.add(self);var modalEl=jqLite(self.modalEl);self.el.classList.remove("hide"),$timeout(function(){self._isShown&&$ionicBody.addClass(self.viewType+"-open")},400,!1),self.el.parentElement||(modalEl.addClass(self.animation),$ionicBody.append(self.el));var scrollCtrl=modalEl.data("$$ionicScrollController");return scrollCtrl&&scrollCtrl.resize(),target&&self.positionView&&(self.positionView(target,modalEl),self._onWindowResize=function(){self._isShown&&self.positionView(target,modalEl)},ionic.on("resize",self._onWindowResize,window)),modalEl.addClass("ng-enter active").removeClass("ng-leave ng-leave-active"),self._isShown=!0,self._deregisterBackButton=$ionicPlatform.registerBackButtonAction(self.hardwareBackButtonClose?angular.bind(self,self.hide):noop,IONIC_BACK_PRIORITY.modal),ionic.views.Modal.prototype.show.call(self),$timeout(function(){self._isShown&&(modalEl.addClass("ng-enter-active"),ionic.trigger("resize"),self.scope.$parent&&self.scope.$parent.$broadcast(self.viewType+".shown",self),self.el.classList.add("active"),self.scope.$broadcast("$ionicHeader.align"),self.scope.$broadcast("$ionicFooter.align"))},20),$timeout(function(){self._isShown&&(self.$el.on("touchmove",function(e){ionic.DomUtil.getParentOrSelfWithClass(e.target,"scroll")||e.preventDefault()}),self.$el.on("click",function(e){self.backdropClickToClose&&e.target===self.el&&stack.isHighest(self)&&self.hide()}))},400)},hide:function(){var self=this,modalEl=jqLite(self.modalEl);return $ionicClickBlock.show(600),stack.remove(self),self.el.classList.remove("active"),modalEl.addClass("ng-leave"),$timeout(function(){self._isShown||modalEl.addClass("ng-leave-active").removeClass("ng-enter ng-enter-active active")},20,!1),self.$el.off("click"),self._isShown=!1,self.scope.$parent&&self.scope.$parent.$broadcast(self.viewType+".hidden",self),self._deregisterBackButton&&self._deregisterBackButton(),ionic.views.Modal.prototype.hide.call(self),self.positionView&&ionic.off("resize",self._onWindowResize,window),$timeout(function(){$ionicBody.removeClass(self.viewType+"-open"),self.el.classList.add("hide")},self.hideDelay||320)},remove:function(){var self=this;return self.scope.$parent&&self.scope.$parent.$broadcast(self.viewType+".removed",self),self.hide().then(function(){self.scope.$destroy(),self.$el.remove()})},isShown:function(){return!!this._isShown}}),createModal=function(templateString,options){var scope=options.scope&&options.scope.$new()||$rootScope.$new(!0);options.viewType=options.viewType||"modal",extend(scope,{$hasHeader:!1,$hasSubheader:!1,$hasFooter:!1,$hasSubfooter:!1,$hasTabs:!1,$hasTabsTop:!1});var element=$compile("<ion-"+options.viewType+">"+templateString+"</ion-"+options.viewType+">")(scope);options.$el=element,options.el=element[0],options.modalEl=options.el.querySelector("."+options.viewType);var modal=new ModalView(options);return modal.scope=scope,options.scope||(scope[options.viewType]=modal),modal},modalStack=[],stack={add:function(modal){modalStack.push(modal)},remove:function(modal){var index=modalStack.indexOf(modal);index>-1&&index<modalStack.length&&modalStack.splice(index,1)},isHighest:function(modal){var index=modalStack.indexOf(modal);return index>-1&&index===modalStack.length-1}};return{fromTemplate:function(templateString,options){return createModal(templateString,options||{})},fromTemplateUrl:function(url,options,_){var cb;return angular.isFunction(options)&&(cb=options,options=_),$ionicTemplateLoader.load(url).then(function(templateString){var modal=createModal(templateString,options||{});return cb&&cb(modal),modal})},stack:stack}}]),IonicModule.service("$ionicNavBarDelegate",ionic.DelegateService(["align","showBackButton","showBar","title","changeTitle","setTitle","getTitle","back","getPreviousTitle"])),IonicModule.service("$ionicNavViewDelegate",ionic.DelegateService(["clearCache"])),IonicModule.constant("IONIC_BACK_PRIORITY",{view:100,sideMenu:150,modal:200,actionSheet:300,popup:400,loading:500}).provider("$ionicPlatform",function(){return{$get:["$q","$ionicScrollDelegate",function($q,$ionicScrollDelegate){var self={onHardwareBackButton:function(cb){ionic.Platform.ready(function(){document.addEventListener("backbutton",cb,!1)})},offHardwareBackButton:function(fn){ionic.Platform.ready(function(){document.removeEventListener("backbutton",fn)})},$backButtonActions:{},registerBackButtonAction:function(fn,priority,actionId){self._hasBackButtonHandler||(self.$backButtonActions={},self.onHardwareBackButton(self.hardwareBackButtonClick),self._hasBackButtonHandler=!0);var action={id:actionId||ionic.Utils.nextUid(),priority:priority||0,fn:fn};return self.$backButtonActions[action.id]=action,function(){delete self.$backButtonActions[action.id]}},hardwareBackButtonClick:function(e){var priorityAction,actionId;for(actionId in self.$backButtonActions)(!priorityAction||self.$backButtonActions[actionId].priority>=priorityAction.priority)&&(priorityAction=self.$backButtonActions[actionId]);if(priorityAction)return priorityAction.fn(e),priorityAction},is:function(type){return ionic.Platform.is(type)},on:function(type,cb){return ionic.Platform.ready(function(){document.addEventListener(type,cb,!1)}),function(){ionic.Platform.ready(function(){document.removeEventListener(type,cb)})}},ready:function(cb){var q=$q.defer();return ionic.Platform.ready(function(){q.resolve(),cb&&cb()}),q.promise}};return window.addEventListener("statusTap",function(){$ionicScrollDelegate.scrollTop(!0)}),self}]}}),IonicModule.factory("$ionicPopover",["$ionicModal","$ionicPosition","$document","$window",function($ionicModal,$ionicPosition,$document,$window){var POPOVER_BODY_PADDING=6,POPOVER_OPTIONS={viewType:"popover",hideDelay:1,animation:"none",positionView:function(target,popoverEle){var targetEle=jqLite(target.target||target),buttonOffset=$ionicPosition.offset(targetEle),popoverWidth=popoverEle.prop("offsetWidth"),popoverHeight=popoverEle.prop("offsetHeight"),bodyWidth=$window.innerWidth,bodyHeight=$window.innerHeight,popoverCSS={left:buttonOffset.left+buttonOffset.width/2-popoverWidth/2},arrowEle=jqLite(popoverEle[0].querySelector(".popover-arrow"));popoverCSS.left<POPOVER_BODY_PADDING?popoverCSS.left=POPOVER_BODY_PADDING:popoverCSS.left+popoverWidth+POPOVER_BODY_PADDING>bodyWidth&&(popoverCSS.left=bodyWidth-popoverWidth-POPOVER_BODY_PADDING),buttonOffset.top+buttonOffset.height+popoverHeight>bodyHeight&&buttonOffset.top-popoverHeight>0?(popoverCSS.top=buttonOffset.top-popoverHeight,popoverEle.addClass("popover-bottom")):(popoverCSS.top=buttonOffset.top+buttonOffset.height,popoverEle.removeClass("popover-bottom")),arrowEle.css({left:buttonOffset.left+buttonOffset.width/2-arrowEle.prop("offsetWidth")/2-popoverCSS.left+"px"}),popoverEle.css({top:popoverCSS.top+"px",left:popoverCSS.left+"px",marginLeft:"0",opacity:"1"})}};return{fromTemplate:function(templateString,options){return $ionicModal.fromTemplate(templateString,ionic.Utils.extend({},POPOVER_OPTIONS,options))},fromTemplateUrl:function(url,options){return $ionicModal.fromTemplateUrl(url,ionic.Utils.extend({},POPOVER_OPTIONS,options))}}}]);var POPUP_TPL='<div class="popup-container" ng-class="cssClass"><div class="popup"><div class="popup-head"><h3 class="popup-title" ng-bind-html="title"></h3><h5 class="popup-sub-title" ng-bind-html="subTitle" ng-if="subTitle"></h5></div><div class="popup-body"></div><div class="popup-buttons" ng-show="buttons.length"><button ng-repeat="button in buttons" ng-click="$buttonTapped(button, $event)" class="button" ng-class="button.type || \'button-default\'" ng-bind-html="button.text"></button></div></div></div>';IonicModule.factory("$ionicPopup",["$ionicTemplateLoader","$ionicBackdrop","$q","$timeout","$rootScope","$ionicBody","$compile","$ionicPlatform","$ionicModal","IONIC_BACK_PRIORITY",function($ionicTemplateLoader,$ionicBackdrop,$q,$timeout,$rootScope,$ionicBody,$compile,$ionicPlatform,$ionicModal,IONIC_BACK_PRIORITY){function onHardwareBackButton(){var last=popupStack[popupStack.length-1];last&&last.responseDeferred.resolve()}function showPopup(options){var popup=$ionicPopup._createPopup(options),showDelay=0;return popupStack.length>0?(showDelay=config.stackPushDelay,$timeout(popupStack[popupStack.length-1].hide,showDelay,!1)):($ionicBody.addClass("popup-open"),$ionicBackdrop.retain(),$ionicPopup._backButtonActionDone=$ionicPlatform.registerBackButtonAction(onHardwareBackButton,IONIC_BACK_PRIORITY.popup)),popup.responseDeferred.promise.close=function(result){popup.removed||popup.responseDeferred.resolve(result)},popup.responseDeferred.notify({close:popup.responseDeferred.close}),popupStack.push(popup),$timeout(popup.show,showDelay,!1),popup.responseDeferred.promise.then(function(result){var index=popupStack.indexOf(popup);return-1!==index&&popupStack.splice(index,1),popup.remove(),popupStack.length>0?popupStack[popupStack.length-1].show():($ionicBackdrop.release(),$timeout(function(){popupStack.length||$ionicBody.removeClass("popup-open")},400,!1),($ionicPopup._backButtonActionDone||noop)()),result}),popup.responseDeferred.promise}function focusInput(element){var focusOn=element[0].querySelector("[autofocus]");focusOn&&focusOn.focus()}var config={stackPushDelay:75},popupStack=[],$ionicPopup={show:showPopup,alert:function(opts){return showPopup(extend({buttons:[{text:opts.okText||"OK",type:opts.okType||"button-positive",onTap:function(){return!0}}]},opts||{}))},confirm:function(opts){return showPopup(extend({buttons:[{text:opts.cancelText||"Cancel",type:opts.cancelType||"button-default",onTap:function(){return!1}},{text:opts.okText||"OK",type:opts.okType||"button-positive",onTap:function(){return!0}}]},opts||{}))},prompt:function(opts){var scope=$rootScope.$new(!0);scope.data={},scope.data.fieldtype=opts.inputType?opts.inputType:"text",scope.data.response=opts.defaultText?opts.defaultText:"",scope.data.placeholder=opts.inputPlaceholder?opts.inputPlaceholder:"",scope.data.maxlength=opts.maxLength?parseInt(opts.maxLength):"";var text="";return opts.template&&!1===/<[a-z][\s\S]*>/i.test(opts.template)&&(text="<span>"+opts.template+"</span>",delete opts.template),showPopup(extend({template:text+'<input ng-model="data.response" type="{{ data.fieldtype }}"maxlength="{{ data.maxlength }}"placeholder="{{ data.placeholder }}">',scope:scope,buttons:[{text:opts.cancelText||"Cancel",type:opts.cancelType||"button-default",onTap:function(){}},{text:opts.okText||"OK",type:opts.okType||"button-positive",onTap:function(){return scope.data.response||""}}]},opts||{}))},_createPopup:function(options){options=extend({scope:null,title:"",buttons:[]},options||{});var self={};return self.scope=(options.scope||$rootScope).$new(),self.element=jqLite(POPUP_TPL),self.responseDeferred=$q.defer(),$ionicBody.get().appendChild(self.element[0]),$compile(self.element)(self.scope),extend(self.scope,{title:options.title,buttons:options.buttons,subTitle:options.subTitle,cssClass:options.cssClass,$buttonTapped:function(button,event){var result=(button.onTap||noop).apply(self,[event]);(event=event.originalEvent||event).defaultPrevented||self.responseDeferred.resolve(result)}}),$q.when(options.templateUrl?$ionicTemplateLoader.load(options.templateUrl):options.template||options.content||"").then(function(template){var popupBody=jqLite(self.element[0].querySelector(".popup-body"));template?(popupBody.html(template),$compile(popupBody.contents())(self.scope)):popupBody.remove()}),self.show=function(){self.isShown||self.removed||($ionicModal.stack.add(self),self.isShown=!0,ionic.requestAnimationFrame(function(){self.isShown&&(self.element.removeClass("popup-hidden"),self.element.addClass("popup-showing active"),focusInput(self.element))}))},self.hide=function(callback){if(callback=callback||noop,!self.isShown)return callback();$ionicModal.stack.remove(self),self.isShown=!1,self.element.removeClass("active"),self.element.addClass("popup-hidden"),$timeout(callback,250,!1)},self.remove=function(){self.removed||(self.hide(function(){self.element.remove(),self.scope.$destroy()}),self.removed=!0)},self},_popupStack:popupStack};return $ionicPopup}]),IonicModule.factory("$ionicPosition",["$document","$window",function($document,$window){function getStyle(el,cssprop){return el.currentStyle?el.currentStyle[cssprop]:$window.getComputedStyle?$window.getComputedStyle(el)[cssprop]:el.style[cssprop]}function isStaticPositioned(element){return"static"===(getStyle(element,"position")||"static")}var parentOffsetEl=function(element){for(var docDomEl=$document[0],offsetParent=element.offsetParent||docDomEl;offsetParent&&offsetParent!==docDomEl&&isStaticPositioned(offsetParent);)offsetParent=offsetParent.offsetParent;return offsetParent||docDomEl};return{position:function(element){var elBCR=this.offset(element),offsetParentBCR={top:0,left:0},offsetParentEl=parentOffsetEl(element[0]);offsetParentEl!=$document[0]&&((offsetParentBCR=this.offset(jqLite(offsetParentEl))).top+=offsetParentEl.clientTop-offsetParentEl.scrollTop,offsetParentBCR.left+=offsetParentEl.clientLeft-offsetParentEl.scrollLeft);var boundingClientRect=element[0].getBoundingClientRect();return{width:boundingClientRect.width||element.prop("offsetWidth"),height:boundingClientRect.height||element.prop("offsetHeight"),top:elBCR.top-offsetParentBCR.top,left:elBCR.left-offsetParentBCR.left}},offset:function(element){var boundingClientRect=element[0].getBoundingClientRect();return{width:boundingClientRect.width||element.prop("offsetWidth"),height:boundingClientRect.height||element.prop("offsetHeight"),top:boundingClientRect.top+($window.pageYOffset||$document[0].documentElement.scrollTop),left:boundingClientRect.left+($window.pageXOffset||$document[0].documentElement.scrollLeft)}}}}]),IonicModule.service("$ionicScrollDelegate",ionic.DelegateService(["resize","scrollTop","scrollBottom","scrollTo","scrollBy","zoomTo","zoomBy","getScrollPosition","anchorScroll","freezeScroll","freezeAllScrolls","getScrollView"])),IonicModule.service("$ionicSideMenuDelegate",ionic.DelegateService(["toggleLeft","toggleRight","getOpenRatio","isOpen","isOpenLeft","isOpenRight","canDragContent","edgeDragThreshold"])),IonicModule.service("$ionicSlideBoxDelegate",ionic.DelegateService(["update","slide","select","enableSlide","previous","next","stop","autoPlay","start","currentIndex","selected","slidesCount","count","loop"])),IonicModule.service("$ionicTabsDelegate",ionic.DelegateService(["select","selectedIndex","showBar"])),function(){var templatesToCache=[];IonicModule.factory("$ionicTemplateCache",["$http","$templateCache","$timeout",function($http,$templateCache,$timeout){function $ionicTemplateCache(templates){if(void 0===templates)return run();isString(templates)&&(templates=[templates]),forEach(templates,function(template){toCache.push(template)}),hasRun&&run()}function run(){var template;if($ionicTemplateCache._runCount++,hasRun=!0,0!==toCache.length){for(var i=0;i<4&&(template=toCache.pop());)isString(template)&&$http.get(template,{cache:$templateCache}),i++;toCache.length&&$timeout(run,1e3)}}var hasRun,toCache=templatesToCache;return $ionicTemplateCache._runCount=0,$ionicTemplateCache}]).config(["$stateProvider","$ionicConfigProvider",function($stateProvider,$ionicConfigProvider){var stateProviderState=$stateProvider.state;$stateProvider.state=function(stateName,definition){if("object"==typeof definition){var enabled=!1!==definition.prefetchTemplate&&templatesToCache.length<$ionicConfigProvider.templates.maxPrefetch();if(enabled&&isString(definition.templateUrl)&&templatesToCache.push(definition.templateUrl),angular.isObject(definition.views))for(var key in definition.views)(enabled=!1!==definition.views[key].prefetchTemplate&&templatesToCache.length<$ionicConfigProvider.templates.maxPrefetch())&&isString(definition.views[key].templateUrl)&&templatesToCache.push(definition.views[key].templateUrl)}return stateProviderState.call($stateProvider,stateName,definition)}}]).run(["$ionicTemplateCache",function($ionicTemplateCache){$ionicTemplateCache()}])}(),IonicModule.factory("$ionicTemplateLoader",["$compile","$controller","$http","$q","$rootScope","$templateCache",function($compile,$controller,$http,$q,$rootScope,$templateCache){return{load:function(url){return $http.get(url,{cache:$templateCache}).then(function(response){return response.data&&response.data.trim()})},compile:function(options){return((options=extend({template:"",templateUrl:"",scope:null,controller:null,locals:{},appendTo:null},options||{})).templateUrl?this.load(options.templateUrl):$q.when(options.template)).then(function(template){var controller,scope=options.scope||$rootScope.$new(),element=jqLite("<div>").html(template).contents();return options.controller&&(controller=$controller(options.controller,extend(options.locals,{$scope:scope})),element.children().data("$ngControllerController",controller)),options.appendTo&&jqLite(options.appendTo).append(element),$compile(element)(scope),{element:element,scope:scope}})}}}]),IonicModule.factory("$ionicViewService",["$ionicHistory","$log",function($ionicHistory,$log){function warn(oldMethod,newMethod){$log.warn("$ionicViewService"+oldMethod+" is deprecated, please use $ionicHistory"+newMethod+" instead: http://ionicframework.com/docs/nightly/api/service/$ionicHistory/")}warn("","");var methodsMap={getCurrentView:"currentView",getBackView:"backView",getForwardView:"forwardView",getCurrentStateName:"currentStateName",nextViewOptions:"nextViewOptions",clearHistory:"clearHistory"};return forEach(methodsMap,function(newMethod,oldMethod){methodsMap[oldMethod]=function(){return warn("."+oldMethod,"."+newMethod),$ionicHistory[newMethod].apply(this,arguments)}}),methodsMap}]),IonicModule.factory("$ionicViewSwitcher",["$timeout","$document","$q","$ionicClickBlock","$ionicConfig","$ionicNavBarDelegate",function($timeout,$document,$q,$ionicClickBlock,$ionicConfig,$ionicNavBarDelegate){function getViewElementIdentifier(locals,view){return viewState(locals).abstract?viewState(locals).name:view?view.stateId||view.viewId:ionic.Utils.nextUid()}function viewState(locals){return locals&&locals.$$state&&locals.$$state.self||{}}function getTransitionData(viewLocals,enteringEle,direction,view){var state=viewState(viewLocals),viewTransition=nextTransition||cachedAttr(enteringEle,"view-transition")||state.viewTransition||$ionicConfig.views.transition()||"ios",navBarTransition=$ionicConfig.navBar.transition();return direction=nextDirection||cachedAttr(enteringEle,"view-direction")||state.viewDirection||direction||"none",extend(getViewData(view),{transition:viewTransition,navBarTransition:"view"===navBarTransition?viewTransition:navBarTransition,direction:direction,shouldAnimate:"none"!==viewTransition&&"none"!==direction})}function getViewData(view){return view=view||{},{viewId:view.viewId,historyId:view.historyId,stateId:view.stateId,stateName:view.stateName,stateParams:view.stateParams}}function navViewAttr(ele,value){if(!(arguments.length>1))return cachedAttr(ele,NAV_VIEW_ATTR);cachedAttr(ele,NAV_VIEW_ATTR,value)}function destroyViewEle(ele){if(ele&&ele.length){var viewScope=ele.scope();viewScope&&(viewScope.$emit("$ionicView.unloaded",ele.data(DATA_VIEW)),viewScope.$destroy()),ele.remove()}}var nextTransition,nextDirection,TRANSITIONEND_EVENT="webkitTransitionEnd transitionend",DATA_FALLBACK_TIMER="$fallbackTimer",DATA_VIEW="$viewData",NAV_VIEW_ATTR="nav-view",VIEW_STATUS_ACTIVE="active",VIEW_STATUS_CACHED="cached",transitionCounter=0;ionic.transition=ionic.transition||{},ionic.transition.isActive=!1;var isActiveTimer,cachedAttr=ionic.DomUtil.cachedAttr,transitionPromises=[],ionicViewSwitcher={create:function(navViewCtrl,viewLocals,enteringView,leavingView,renderStart,renderEnd){var enteringEle,leavingEle,alreadyInDom,transitionId=++transitionCounter,switcher={init:function(registerData,callback){ionicViewSwitcher.isTransitioning(!0),switcher.loadViewElements(registerData),switcher.render(registerData,function(){callback&&callback()})},loadViewElements:function(registerData){var x,l,viewEle,viewElements=navViewCtrl.getViewElements(),enteringEleIdentifier=getViewElementIdentifier(viewLocals,enteringView),navViewActiveEleId=navViewCtrl.activeEleId();for(x=0,l=viewElements.length;x<l&&((viewEle=viewElements.eq(x)).data("$eleId")===enteringEleIdentifier?viewEle.data("$noCache")?(viewEle.data("$eleId",enteringEleIdentifier+ionic.Utils.nextUid()),viewEle.data("$destroyEle",!0)):enteringEle=viewEle:isDefined(navViewActiveEleId)&&viewEle.data("$eleId")===navViewActiveEleId&&(leavingEle=viewEle),!enteringEle||!leavingEle);x++);(alreadyInDom=!!enteringEle)||(enteringEle=registerData.ele||ionicViewSwitcher.createViewEle(viewLocals)).data("$eleId",enteringEleIdentifier),renderEnd&&navViewCtrl.activeEleId(enteringEleIdentifier),registerData.ele=null},render:function(registerData,callback){if(alreadyInDom)ionic.Utils.reconnectScope(enteringEle.scope());else{navViewAttr(enteringEle,"stage");var enteringData=getTransitionData(viewLocals,enteringEle,registerData.direction,enteringView);($ionicConfig.transitions.views[enteringData.transition]||$ionicConfig.transitions.views.none)(enteringEle,null,enteringData.direction,!0).run(0),enteringEle.data(DATA_VIEW,{viewId:enteringData.viewId,historyId:enteringData.historyId,stateName:enteringData.stateName,stateParams:enteringData.stateParams}),!1!==viewState(viewLocals).cache&&"false"!==viewState(viewLocals).cache&&"false"!=enteringEle.attr("cache-view")&&0!==$ionicConfig.views.maxCache()||enteringEle.data("$noCache",!0);var viewScope=navViewCtrl.appendViewElement(enteringEle,viewLocals);delete enteringData.direction,delete enteringData.transition,viewScope.$emit("$ionicView.loaded",enteringData)}enteringEle.data("$accessed",Date.now()),callback&&callback()},transition:function(direction,enableBack,allowAnimate){function onReflow(){navViewAttr(enteringEle,viewTransition.shouldAnimate?"entering":VIEW_STATUS_ACTIVE),navViewAttr(leavingEle,viewTransition.shouldAnimate?"leaving":VIEW_STATUS_CACHED),viewTransition.run(1),$ionicNavBarDelegate._instances.forEach(function(instance){instance.triggerTransitionStart(transitionId)}),viewTransition.shouldAnimate||transitionComplete()}function completeOnTransitionEnd(ev){ev.target===this&&transitionComplete()}function transitionComplete(){transitionComplete.x||(transitionComplete.x=!0,enteringEle.off(TRANSITIONEND_EVENT,completeOnTransitionEnd),$timeout.cancel(enteringEle.data(DATA_FALLBACK_TIMER)),leavingEle&&$timeout.cancel(leavingEle.data(DATA_FALLBACK_TIMER)),deferred&&deferred.resolve(navViewCtrl),transitionId===transitionCounter&&($q.all(transitionPromises).then(ionicViewSwitcher.transitionEnd),switcher.emit("after",enteringData,leavingData),switcher.cleanup(enteringData)),$ionicNavBarDelegate._instances.forEach(function(instance){instance.triggerTransitionEnd()}),nextTransition=nextDirection=enteringView=leavingView=enteringEle=leavingEle=null)}function cancelOnTransitionEnd(ev){ev.target===this&&cancelTransition()}function cancelTransition(){navViewAttr(enteringEle,VIEW_STATUS_CACHED),navViewAttr(leavingEle,VIEW_STATUS_ACTIVE),enteringEle.off(TRANSITIONEND_EVENT,cancelOnTransitionEnd),$timeout.cancel(enteringEle.data(DATA_FALLBACK_TIMER)),ionicViewSwitcher.transitionEnd([navViewCtrl])}var deferred,enteringData=getTransitionData(viewLocals,enteringEle,direction,enteringView),leavingData=extend(extend({},enteringData),getViewData(leavingView));enteringData.transitionId=leavingData.transitionId=transitionId,enteringData.fromCache=!!alreadyInDom,enteringData.enableBack=!!enableBack,enteringData.renderStart=renderStart,enteringData.renderEnd=renderEnd,cachedAttr(enteringEle.parent(),"nav-view-transition",enteringData.transition),cachedAttr(enteringEle.parent(),"nav-view-direction",enteringData.direction),$timeout.cancel(enteringEle.data(DATA_FALLBACK_TIMER));var viewTransition=($ionicConfig.transitions.views[enteringData.transition]||$ionicConfig.transitions.views.none)(enteringEle,leavingEle,enteringData.direction,enteringData.shouldAnimate&&allowAnimate&&renderEnd);if(viewTransition.shouldAnimate&&(enteringEle.on(TRANSITIONEND_EVENT,completeOnTransitionEnd),enteringEle.data(DATA_FALLBACK_TIMER,$timeout(transitionComplete,1100)),$ionicClickBlock.show(1100)),renderStart&&(switcher.emit("before",enteringData,leavingData),navViewAttr(enteringEle,"stage"),viewTransition.run(0)),renderEnd&&(deferred=$q.defer(),transitionPromises.push(deferred.promise)),renderStart&&renderEnd)$timeout(function(){ionic.requestAnimationFrame(onReflow)});else{if(!renderEnd)return navViewAttr(enteringEle,"entering"),navViewAttr(leavingEle,"leaving"),{run:viewTransition.run,cancel:function(shouldAnimate){shouldAnimate?(enteringEle.on(TRANSITIONEND_EVENT,cancelOnTransitionEnd),enteringEle.data(DATA_FALLBACK_TIMER,$timeout(cancelTransition,1100)),$ionicClickBlock.show(1100)):cancelTransition(),viewTransition.shouldAnimate=shouldAnimate,viewTransition.run(0),viewTransition=null}};renderEnd&&onReflow()}},emit:function(step,enteringData,leavingData){var enteringScope=enteringEle.scope(),leavingScope=leavingEle&&leavingEle.scope();"after"==step&&(enteringScope&&enteringScope.$emit("$ionicView.enter",enteringData),leavingScope?leavingScope.$emit("$ionicView.leave",leavingData):enteringScope&&leavingData&&leavingData.viewId&&enteringScope.$emit("$ionicNavView.leave",leavingData)),enteringScope&&enteringScope.$emit("$ionicView."+step+"Enter",enteringData),leavingScope?leavingScope.$emit("$ionicView."+step+"Leave",leavingData):enteringScope&&leavingData&&leavingData.viewId&&enteringScope.$emit("$ionicNavView."+step+"Leave",leavingData)},cleanup:function(transData){leavingEle&&"back"==transData.direction&&!$ionicConfig.views.forwardCache()&&destroyViewEle(leavingEle);var x,viewElement,removableEle,viewElements=navViewCtrl.getViewElements(),viewElementsLength=viewElements.length,removeOldestAccess=viewElementsLength-1>$ionicConfig.views.maxCache(),oldestAccess=Date.now();for(x=0;x<viewElementsLength;x++)viewElement=viewElements.eq(x),removeOldestAccess&&viewElement.data("$accessed")<oldestAccess?(oldestAccess=viewElement.data("$accessed"),removableEle=viewElements.eq(x)):viewElement.data("$destroyEle")&&navViewAttr(viewElement)!=VIEW_STATUS_ACTIVE&&destroyViewEle(viewElement);destroyViewEle(removableEle),enteringEle.data("$noCache")&&enteringEle.data("$destroyEle",!0)},enteringEle:function(){return enteringEle},leavingEle:function(){return leavingEle}};return switcher},transitionEnd:function(navViewCtrls){forEach(navViewCtrls,function(navViewCtrl){navViewCtrl.transitionEnd()}),ionicViewSwitcher.isTransitioning(!1),$ionicClickBlock.hide(),transitionPromises=[]},nextTransition:function(val){nextTransition=val},nextDirection:function(val){nextDirection=val},isTransitioning:function(val){return arguments.length&&(ionic.transition.isActive=!!val,$timeout.cancel(isActiveTimer),val&&(isActiveTimer=$timeout(function(){ionicViewSwitcher.isTransitioning(!1)},999))),ionic.transition.isActive},createViewEle:function(viewLocals){var containerEle=$document[0].createElement("div");return viewLocals&&viewLocals.$template&&(containerEle.innerHTML=viewLocals.$template,1===containerEle.children.length)?(containerEle.children[0].classList.add("pane"),jqLite(containerEle.children[0])):(containerEle.className="pane",jqLite(containerEle))},viewEleIsActive:function(viewEle,isActiveAttr){navViewAttr(viewEle,isActiveAttr?VIEW_STATUS_ACTIVE:VIEW_STATUS_CACHED)},getTransitionData:getTransitionData,navViewAttr:navViewAttr,destroyViewEle:destroyViewEle};return ionicViewSwitcher}]),angular.module("ngIOS9UIWebViewPatch",["ng"]).config(["$provide",function($provide){"use strict";$provide.decorator("$browser",["$delegate","$window",function($delegate,$window){return function(userAgent){return/(iPhone|iPad|iPod).* OS 9_\d/.test(userAgent)&&!/Version\/9\./.test(userAgent)}($window.navigator.userAgent)?function(browser){function clearPendingLocationUrl(){pendingLocationUrl=null}var pendingLocationUrl=null,originalUrlFn=browser.url;return browser.url=function(){return arguments.length?(pendingLocationUrl=arguments[0],originalUrlFn.apply(browser,arguments)):pendingLocationUrl||originalUrlFn.apply(browser,arguments)},window.addEventListener("popstate",clearPendingLocationUrl,!1),window.addEventListener("hashchange",clearPendingLocationUrl,!1),browser}($delegate):$delegate}])}]),IonicModule.config(["$provide",function($provide){$provide.decorator("$compile",["$delegate",function($compile){return $compile.$$addScopeInfo=function($element,scope,isolated,noTemplate){var dataName=isolated?noTemplate?"$isolateScopeNoTemplate":"$isolateScope":"$scope";$element.data(dataName,scope)},$compile}])}]),IonicModule.config(["$provide",function($provide){$provide.decorator("$location",["$delegate","$timeout",function($location,$timeout){return $location.__hash=$location.hash,$location.hash=function(value){return isDefined(value)&&value.length>0&&$timeout(function(){var scroll=document.querySelector(".scroll-content");scroll&&(scroll.scrollTop=0)},0,!1),$location.__hash(value)},$location}])}]),IonicModule.controller("$ionicHeaderBar",["$scope","$element","$attrs","$q","$ionicConfig","$ionicHistory",function($scope,$element,$attrs,$q,$ionicConfig,$ionicHistory){function getEle(className){return eleCache[className]||(eleCache[className]=$element[0].querySelector("."+className)),eleCache[className]}var self=this,titleText="",previousTitleText="",titleLeft=0,titleRight=0,titleCss="",isBackEnabled=!1,isBackShown=!0,isNavBackShown=!0,isBackElementShown=!1,titleTextWidth=0;self.beforeEnter=function(viewData){$scope.$broadcast("$ionicView.beforeEnter",viewData)},self.title=function(newTitleText){return arguments.length&&newTitleText!==titleText&&(getEle("title").innerHTML=newTitleText,titleText=newTitleText,titleTextWidth=0),titleText},self.enableBack=function(shouldEnable,disableReset){return arguments.length&&(isBackEnabled=shouldEnable,disableReset||self.updateBackButton()),isBackEnabled},self.showBack=function(shouldShow,disableReset){return arguments.length&&(isBackShown=shouldShow,disableReset||self.updateBackButton()),isBackShown},self.showNavBack=function(shouldShow){isNavBackShown=shouldShow,self.updateBackButton()},self.updateBackButton=function(){var ele;(isBackShown&&isNavBackShown&&isBackEnabled)!==isBackElementShown&&(isBackElementShown=isBackShown&&isNavBackShown&&isBackEnabled,(ele=getEle("back-button"))&&ele.classList[isBackElementShown?"remove":"add"]("hide")),isBackEnabled&&(ele=ele||getEle("back-button"))&&(self.backButtonIcon!==$ionicConfig.backButton.icon()&&(ele=getEle("back-button .icon"))&&(self.backButtonIcon=$ionicConfig.backButton.icon(),ele.className="icon "+self.backButtonIcon),self.backButtonText!==$ionicConfig.backButton.text()&&(ele=getEle("back-button .back-text"))&&(ele.textContent=self.backButtonText=$ionicConfig.backButton.text()))},self.titleTextWidth=function(){if(!titleTextWidth){var bounds=ionic.DomUtil.getTextBounds(getEle("title"));titleTextWidth=Math.min(bounds&&bounds.width||30)}return titleTextWidth},self.titleWidth=function(){var titleWidth=self.titleTextWidth(),offsetWidth=getEle("title").offsetWidth;return offsetWidth<titleWidth&&(titleWidth=offsetWidth+(titleLeft-titleRight-5)),titleWidth},self.titleTextX=function(){return $element[0].offsetWidth/2-self.titleWidth()/2},self.titleLeftRight=function(){return titleLeft-titleRight},self.backButtonTextLeft=function(){for(var offsetLeft=0,ele=getEle("back-text");ele;)offsetLeft+=ele.offsetLeft,ele=ele.parentElement;return offsetLeft},self.resetBackButton=function(viewData){if($ionicConfig.backButton.previousTitleText()){var previousTitleEle=getEle("previous-title");if(previousTitleEle){previousTitleEle.classList.remove("hide");var view=viewData&&$ionicHistory.getViewById(viewData.viewId),newPreviousTitleText=$ionicHistory.backTitle(view);newPreviousTitleText!==previousTitleText&&(previousTitleText=previousTitleEle.innerHTML=newPreviousTitleText)}var defaultTitleEle=getEle("default-title");defaultTitleEle&&defaultTitleEle.classList.remove("hide")}},self.align=function(textAlign){var titleEle=getEle("title");textAlign=textAlign||$attrs.alignTitle||$ionicConfig.navBar.alignTitle();var widths=self.calcWidths(textAlign,!1);if(isBackShown&&previousTitleText&&$ionicConfig.backButton.previousTitleText()){var previousTitleWidths=self.calcWidths(textAlign,!0),availableTitleWidth=$element[0].offsetWidth-previousTitleWidths.titleLeft-previousTitleWidths.titleRight;self.titleTextWidth()<=availableTitleWidth&&(widths=previousTitleWidths)}return self.updatePositions(titleEle,widths.titleLeft,widths.titleRight,widths.buttonsLeft,widths.buttonsRight,widths.css,widths.showPrevTitle)},self.calcWidths=function(textAlign,isPreviousTitle){var x,y,z,b,c,d,childSize,bounds,isCountRightOfTitle,titleEle=getEle("title"),backBtnEle=getEle("back-button"),childNodes=$element[0].childNodes,buttonsLeft=0,buttonsRight=0,updateTitleLeft=0,updateTitleRight=0,updateCss="",backButtonWidth=0;for(x=0;x<childNodes.length;x++){if(c=childNodes[x],childSize=0,1==c.nodeType){if(c===titleEle){isCountRightOfTitle=!0;continue}if(c.classList.contains("hide"))continue;if(isBackShown&&c===backBtnEle){for(y=0;y<c.childNodes.length;y++)if(1==(b=c.childNodes[y]).nodeType)if(b.classList.contains("back-text"))for(z=0;z<b.children.length;z++)if(d=b.children[z],isPreviousTitle){if(d.classList.contains("default-title"))continue;backButtonWidth+=d.offsetWidth}else{if(d.classList.contains("previous-title"))continue;backButtonWidth+=d.offsetWidth}else backButtonWidth+=b.offsetWidth;else 3==b.nodeType&&b.nodeValue.trim()&&(backButtonWidth+=(bounds=ionic.DomUtil.getTextBounds(b))&&bounds.width||0);childSize=backButtonWidth||c.offsetWidth}else childSize=c.offsetWidth}else 3==c.nodeType&&c.nodeValue.trim()&&(childSize=(bounds=ionic.DomUtil.getTextBounds(c))&&bounds.width||0);isCountRightOfTitle?buttonsRight+=childSize:buttonsLeft+=childSize}if("left"==textAlign)updateCss="title-left",buttonsLeft&&(updateTitleLeft=buttonsLeft+15),buttonsRight&&(updateTitleRight=buttonsRight+15);else if("right"==textAlign)updateCss="title-right",buttonsLeft&&(updateTitleLeft=buttonsLeft+15),buttonsRight&&(updateTitleRight=buttonsRight+15);else{var margin=Math.max(buttonsLeft,buttonsRight)+10;margin>10&&(updateTitleLeft=updateTitleRight=margin)}return{backButtonWidth:backButtonWidth,buttonsLeft:buttonsLeft,buttonsRight:buttonsRight,titleLeft:updateTitleLeft,titleRight:updateTitleRight,showPrevTitle:isPreviousTitle,css:updateCss}},self.updatePositions=function(titleEle,updateTitleLeft,updateTitleRight,buttonsLeft,buttonsRight,updateCss,showPreviousTitle){var deferred=$q.defer();if(titleEle&&(updateTitleLeft!==titleLeft&&(titleEle.style.left=updateTitleLeft?updateTitleLeft+"px":"",titleLeft=updateTitleLeft),updateTitleRight!==titleRight&&(titleEle.style.right=updateTitleRight?updateTitleRight+"px":"",titleRight=updateTitleRight),updateCss!==titleCss&&(updateCss&&titleEle.classList.add(updateCss),titleCss&&titleEle.classList.remove(titleCss),titleCss=updateCss)),$ionicConfig.backButton.previousTitleText()){var prevTitle=getEle("previous-title"),defaultTitle=getEle("default-title");prevTitle&&prevTitle.classList[showPreviousTitle?"remove":"add"]("hide"),defaultTitle&&defaultTitle.classList[showPreviousTitle?"add":"remove"]("hide")}return ionic.requestAnimationFrame(function(){if(titleEle&&titleEle.offsetWidth+10<titleEle.scrollWidth){var minRight=buttonsRight+5,testRight=$element[0].offsetWidth-titleLeft-self.titleTextWidth()-20;(updateTitleRight=testRight<minRight?minRight:testRight)!==titleRight&&(titleEle.style.right=updateTitleRight+"px",titleRight=updateTitleRight)}deferred.resolve()}),deferred.promise},self.setCss=function(elementClassname,css){ionic.DomUtil.cachedStyles(getEle(elementClassname),css)};var eleCache={};$scope.$on("$destroy",function(){for(var n in eleCache)eleCache[n]=null})}]),IonicModule.controller("$ionInfiniteScroll",["$scope","$attrs","$element","$timeout",function($scope,$attrs,$element,$timeout){function onInfinite(){ionic.requestAnimationFrame(function(){$element[0].classList.add("active")}),self.isLoading=!0,$scope.$parent&&$scope.$parent.$apply($attrs.onInfinite||"")}function finishInfiniteScroll(){ionic.requestAnimationFrame(function(){$element[0].classList.remove("active")}),$timeout(function(){self.jsScrolling&&self.scrollView.resize(),(self.jsScrolling&&self.scrollView.__container&&self.scrollView.__container.offsetHeight>0||!self.jsScrolling)&&self.checkBounds()},30,!1),self.isLoading=!1}function calculateMaxValue(maximum){var distance=($attrs.distance||"2.5%").trim();return-1!==distance.indexOf("%")?maximum*(1-parseFloat(distance)/100):maximum-parseFloat(distance)}var self=this;self.isLoading=!1,$scope.icon=function(){return isDefined($attrs.icon)?$attrs.icon:"ion-load-d"},$scope.spinner=function(){return isDefined($attrs.spinner)?$attrs.spinner:""},$scope.$on("scroll.infiniteScrollComplete",function(){finishInfiniteScroll()}),$scope.$on("$destroy",function(){self.scrollCtrl&&self.scrollCtrl.$element&&self.scrollCtrl.$element.off("scroll",self.checkBounds),self.scrollEl&&self.scrollEl.removeEventListener&&self.scrollEl.removeEventListener("scroll",self.checkBounds)}),self.checkBounds=ionic.Utils.throttle(function(){if(!self.isLoading){var maxScroll={};if(self.jsScrolling){maxScroll=self.getJSMaxScroll();var scrollValues=self.scrollView.getValues();(-1!==maxScroll.left&&scrollValues.left>=maxScroll.left||-1!==maxScroll.top&&scrollValues.top>=maxScroll.top)&&onInfinite()}else(-1!==(maxScroll=self.getNativeMaxScroll()).left&&self.scrollEl.scrollLeft>=maxScroll.left-self.scrollEl.clientWidth||-1!==maxScroll.top&&self.scrollEl.scrollTop>=maxScroll.top-self.scrollEl.clientHeight)&&onInfinite()}},300),self.getJSMaxScroll=function(){var maxValues=self.scrollView.getScrollMax();return{left:self.scrollView.options.scrollingX?calculateMaxValue(maxValues.left):-1,top:self.scrollView.options.scrollingY?calculateMaxValue(maxValues.top):-1}},self.getNativeMaxScroll=function(){var maxValues={left:self.scrollEl.scrollWidth,top:self.scrollEl.scrollHeight},computedStyle=window.getComputedStyle(self.scrollEl)||{};return{left:!maxValues.left||"scroll"!==computedStyle.overflowX&&"auto"!==computedStyle.overflowX&&"scroll"!==self.scrollEl.style["overflow-x"]?-1:calculateMaxValue(maxValues.left),top:!maxValues.top||"scroll"!==computedStyle.overflowY&&"auto"!==computedStyle.overflowY&&"scroll"!==self.scrollEl.style["overflow-y"]?-1:calculateMaxValue(maxValues.top)}},self.__finishInfiniteScroll=finishInfiniteScroll}]),IonicModule.service("$ionicListDelegate",ionic.DelegateService(["showReorder","showDelete","canSwipeItems","closeOptionButtons"])).controller("$ionicList",["$scope","$attrs","$ionicListDelegate","$ionicHistory",function($scope,$attrs,$ionicListDelegate,$ionicHistory){var self=this,isSwipeable=!0,isReorderShown=!1,isDeleteShown=!1,deregisterInstance=$ionicListDelegate._registerInstance(self,$attrs.delegateHandle,function(){return $ionicHistory.isActiveScope($scope)});$scope.$on("$destroy",deregisterInstance),self.showReorder=function(show){return arguments.length&&(isReorderShown=!!show),isReorderShown},self.showDelete=function(show){return arguments.length&&(isDeleteShown=!!show),isDeleteShown},self.canSwipeItems=function(can){return arguments.length&&(isSwipeable=!!can),isSwipeable},self.closeOptionButtons=function(){self.listView&&self.listView.clearDragEffects()}}]),IonicModule.controller("$ionicNavBar",["$scope","$element","$attrs","$compile","$timeout","$ionicNavBarDelegate","$ionicConfig","$ionicHistory",function($scope,$element,$attrs,$compile,$timeout,$ionicNavBarDelegate,$ionicConfig,$ionicHistory){function deprecatedWarning(oldMethod,newMethod){var warn=console.warn||console.log;warn&&warn.call(console,"navBarController."+oldMethod+" is deprecated, please use "+newMethod+" instead")}function createNavElement(type){if(navElementHtml[type])return jqLite(navElementHtml[type])}function getOnScreenHeaderBar(){for(var x=0;x<headerBars.length;x++)if(headerBars[x].isActive)return headerBars[x]}function getOffScreenHeaderBar(){for(var x=0;x<headerBars.length;x++)if(!headerBars[x].isActive)return headerBars[x]}function navBarAttr(ctrl,val){ctrl&&ionic.DomUtil.cachedAttr(ctrl.containerEle(),"nav-bar",val)}function navSwipeAttr(val){ionic.DomUtil.cachedAttr($element,"nav-swipe",val)}var queuedTransitionStart,queuedTransitionEnd,latestTransitionId,PRIMARY_BUTTONS="primaryButtons",SECONDARY_BUTTONS="secondaryButtons",BACK_BUTTON="backButton",ITEM_TYPES="primaryButtons secondaryButtons leftButtons rightButtons title".split(" "),self=this,headerBars=[],navElementHtml={},isVisible=!0;$element.parent().data("$ionNavBarController",self);var delegateHandle=$attrs.delegateHandle||"navBar"+ionic.Utils.nextUid(),deregisterInstance=$ionicNavBarDelegate._registerInstance(self,delegateHandle);self.init=function(){$element.addClass("nav-bar-container"),ionic.DomUtil.cachedAttr($element,"nav-bar-transition",$ionicConfig.views.transition()),self.createHeaderBar(!1),self.createHeaderBar(!0),$scope.$emit("ionNavBar.init",delegateHandle)},self.createHeaderBar=function(isActive){function positionItem(ele,itemType){ele&&("title"===itemType?titleEle.append(ele):"rightButtons"==itemType||itemType==SECONDARY_BUTTONS&&"left"!=$ionicConfig.navBar.positionSecondaryButtons()||itemType==PRIMARY_BUTTONS&&"right"==$ionicConfig.navBar.positionPrimaryButtons()?(rightButtonsEle||(rightButtonsEle=jqLite('<div class="buttons buttons-right">'),headerBarEle.append(rightButtonsEle)),itemType==SECONDARY_BUTTONS?rightButtonsEle.append(ele):rightButtonsEle.prepend(ele)):(leftButtonsEle||(leftButtonsEle=jqLite('<div class="buttons buttons-left">'),navEle[BACK_BUTTON]?navEle[BACK_BUTTON].after(leftButtonsEle):headerBarEle.prepend(leftButtonsEle)),itemType==SECONDARY_BUTTONS?leftButtonsEle.append(ele):leftButtonsEle.prepend(ele)))}var containerEle=jqLite('<div class="nav-bar-block">');ionic.DomUtil.cachedAttr(containerEle,"nav-bar",isActive?"active":"cached");var alignTitle=$attrs.alignTitle||$ionicConfig.navBar.alignTitle(),headerBarEle=jqLite("<ion-header-bar>").addClass($attrs.class).attr("align-title",alignTitle);isDefined($attrs.noTapScroll)&&headerBarEle.attr("no-tap-scroll",$attrs.noTapScroll);var leftButtonsEle,rightButtonsEle,titleEle=jqLite('<div class="title title-'+alignTitle+'">'),navEle={},lastViewItemEle={};navEle[BACK_BUTTON]=createNavElement(BACK_BUTTON),navEle[BACK_BUTTON]&&headerBarEle.append(navEle[BACK_BUTTON]),headerBarEle.append(titleEle),forEach(ITEM_TYPES,function(itemType){navEle[itemType]=createNavElement(itemType),positionItem(navEle[itemType],itemType)});for(var x=0;x<headerBarEle[0].children.length;x++)headerBarEle[0].children[x].classList.add("header-item");containerEle.append(headerBarEle),$element.append($compile(containerEle)($scope.$new()));var headerBarCtrl=headerBarEle.data("$ionHeaderBarController");headerBarCtrl.backButtonIcon=$ionicConfig.backButton.icon(),headerBarCtrl.backButtonText=$ionicConfig.backButton.text();var headerBarInstance={isActive:isActive,title:function(newTitleText){headerBarCtrl.title(newTitleText)},setItem:function(navBarItemEle,itemType){headerBarInstance.removeItem(itemType),navBarItemEle?("title"===itemType&&headerBarInstance.title(""),positionItem(navBarItemEle,itemType),navEle[itemType]&&navEle[itemType].addClass("hide"),lastViewItemEle[itemType]=navBarItemEle):navEle[itemType]&&navEle[itemType].removeClass("hide")},removeItem:function(itemType){lastViewItemEle[itemType]&&(lastViewItemEle[itemType].scope().$destroy(),lastViewItemEle[itemType].remove(),lastViewItemEle[itemType]=null)},containerEle:function(){return containerEle},headerBarEle:function(){return headerBarEle},afterLeave:function(){forEach(ITEM_TYPES,function(itemType){headerBarInstance.removeItem(itemType)}),headerBarCtrl.resetBackButton()},controller:function(){return headerBarCtrl},destroy:function(){forEach(ITEM_TYPES,function(itemType){headerBarInstance.removeItem(itemType)}),containerEle.scope().$destroy();for(var n in navEle)navEle[n]&&(navEle[n].removeData(),navEle[n]=null);leftButtonsEle&&leftButtonsEle.removeData(),rightButtonsEle&&rightButtonsEle.removeData(),titleEle.removeData(),headerBarEle.removeData(),containerEle.remove(),containerEle=headerBarEle=titleEle=leftButtonsEle=rightButtonsEle=null}};return headerBars.push(headerBarInstance),headerBarInstance},self.navElement=function(type,html){return isDefined(html)&&(navElementHtml[type]=html),navElementHtml[type]},self.update=function(viewData){var showNavBar=!viewData.hasHeaderBar&&viewData.showNavBar;viewData.transition=$ionicConfig.views.transition(),showNavBar||(viewData.direction="none"),self.enable(showNavBar);var enteringHeaderBar=self.isInitialized?getOffScreenHeaderBar():getOnScreenHeaderBar(),leavingHeaderBar=self.isInitialized?getOnScreenHeaderBar():null,enteringHeaderCtrl=enteringHeaderBar.controller();enteringHeaderCtrl.enableBack(viewData.enableBack,!0),enteringHeaderCtrl.showBack(viewData.showBack,!0),enteringHeaderCtrl.updateBackButton(),self.title(viewData.title,enteringHeaderBar),self.showBar(showNavBar),viewData.navBarItems&&forEach(ITEM_TYPES,function(itemType){enteringHeaderBar.setItem(viewData.navBarItems[itemType],itemType)}),self.transition(enteringHeaderBar,leavingHeaderBar,viewData),self.isInitialized=!0,navSwipeAttr("")},self.transition=function(enteringHeaderBar,leavingHeaderBar,viewData){function transitionEnd(){for(var x=0;x<headerBars.length;x++)headerBars[x].isActive=!1;enteringHeaderBar.isActive=!0,navBarAttr(enteringHeaderBar,"active"),navBarAttr(leavingHeaderBar,"cached"),self.activeTransition=navBarTransition=queuedTransitionEnd=null}var enteringHeaderBarCtrl=enteringHeaderBar.controller(),transitionFn=$ionicConfig.transitions.navBar[viewData.navBarTransition]||$ionicConfig.transitions.navBar.none,transitionId=viewData.transitionId;enteringHeaderBarCtrl.beforeEnter(viewData);var navBarTransition=transitionFn(enteringHeaderBar,leavingHeaderBar,viewData.direction,viewData.shouldAnimate&&self.isInitialized);ionic.DomUtil.cachedAttr($element,"nav-bar-transition",viewData.navBarTransition),ionic.DomUtil.cachedAttr($element,"nav-bar-direction",viewData.direction),navBarTransition.shouldAnimate&&viewData.renderEnd?navBarAttr(enteringHeaderBar,"stage"):(navBarAttr(enteringHeaderBar,"entering"),navBarAttr(leavingHeaderBar,"leaving")),enteringHeaderBarCtrl.resetBackButton(viewData),navBarTransition.run(0),self.activeTransition={run:function(step){navBarTransition.shouldAnimate=!1,navBarTransition.direction="back",navBarTransition.run(step)},cancel:function(shouldAnimate,speed,cancelData){navSwipeAttr(speed),navBarAttr(leavingHeaderBar,"active"),navBarAttr(enteringHeaderBar,"cached"),navBarTransition.shouldAnimate=shouldAnimate,navBarTransition.run(0),self.activeTransition=navBarTransition=null;cancelData.showBar!==self.showBar()&&self.showBar(cancelData.showBar),cancelData.showBackButton!==self.showBackButton()&&self.showBackButton(cancelData.showBackButton)},complete:function(shouldAnimate,speed){navSwipeAttr(speed),navBarTransition.shouldAnimate=shouldAnimate,navBarTransition.run(1),queuedTransitionEnd=transitionEnd}},$timeout(enteringHeaderBarCtrl.align,16),(queuedTransitionStart=function(){latestTransitionId===transitionId&&(navBarAttr(enteringHeaderBar,"entering"),navBarAttr(leavingHeaderBar,"leaving"),navBarTransition.run(1),queuedTransitionEnd=function(){latestTransitionId!=transitionId&&navBarTransition.shouldAnimate||transitionEnd()},queuedTransitionStart=null)})()},self.triggerTransitionStart=function(triggerTransitionId){latestTransitionId=triggerTransitionId,queuedTransitionStart&&queuedTransitionStart()},self.triggerTransitionEnd=function(){queuedTransitionEnd&&queuedTransitionEnd()},self.showBar=function(shouldShow){return arguments.length&&(self.visibleBar(shouldShow),$scope.$parent.$hasHeader=!!shouldShow),!!$scope.$parent.$hasHeader},self.visibleBar=function(shouldShow){shouldShow&&!isVisible?($element.removeClass("hide"),self.align()):!shouldShow&&isVisible&&$element.addClass("hide"),isVisible=shouldShow},self.enable=function(val){self.visibleBar(val);for(var x=0;x<$ionicNavBarDelegate._instances.length;x++)$ionicNavBarDelegate._instances[x]!==self&&$ionicNavBarDelegate._instances[x].visibleBar(!1)},self.showBackButton=function(shouldShow){if(arguments.length){for(var x=0;x<headerBars.length;x++)headerBars[x].controller().showNavBack(!!shouldShow);$scope.$isBackButtonShown=!!shouldShow}return $scope.$isBackButtonShown},self.showActiveBackButton=function(shouldShow){var headerBar=getOnScreenHeaderBar();if(headerBar)return arguments.length?headerBar.controller().showBack(shouldShow):headerBar.controller().showBack()},self.title=function(newTitleText,headerBar){return isDefined(newTitleText)&&(newTitleText=newTitleText||"",(headerBar=headerBar||getOnScreenHeaderBar())&&headerBar.title(newTitleText),$scope.$title=newTitleText,$ionicHistory.currentTitle(newTitleText)),$scope.$title},self.align=function(val,headerBar){(headerBar=headerBar||getOnScreenHeaderBar())&&headerBar.controller().align(val)},self.hasTabsTop=function(isTabsTop){$element[isTabsTop?"addClass":"removeClass"]("nav-bar-tabs-top")},self.hasBarSubheader=function(isBarSubheader){$element[isBarSubheader?"addClass":"removeClass"]("nav-bar-has-subheader")},self.changeTitle=function(val){deprecatedWarning("changeTitle(val)","title(val)"),self.title(val)},self.setTitle=function(val){deprecatedWarning("setTitle(val)","title(val)"),self.title(val)},self.getTitle=function(){return deprecatedWarning("getTitle()","title()"),self.title()},self.back=function(){deprecatedWarning("back()","$ionicHistory.goBack()"),$ionicHistory.goBack()},self.getPreviousTitle=function(){deprecatedWarning("getPreviousTitle()","$ionicHistory.backTitle()"),$ionicHistory.goBack()},$scope.$on("$destroy",function(){$scope.$parent.$hasHeader=!1,$element.parent().removeData("$ionNavBarController");for(var x=0;x<headerBars.length;x++)headerBars[x].destroy();$element.remove(),$element=headerBars=null,deregisterInstance()})}]),IonicModule.controller("$ionicNavView",["$scope","$element","$attrs","$compile","$controller","$ionicNavBarDelegate","$ionicNavViewDelegate","$ionicHistory","$ionicViewSwitcher","$ionicConfig","$ionicScrollDelegate",function($scope,$element,$attrs,$compile,$controller,$ionicNavBarDelegate,$ionicNavViewDelegate,$ionicHistory,$ionicViewSwitcher,$ionicConfig,$ionicScrollDelegate){function onTabsLeave(ev,data){for(var viewElement,viewScope,viewElements=$element.children(),x=0,l=viewElements.length;x<l;x++)if(viewElement=viewElements.eq(x),navViewAttr(viewElement)==VIEW_STATUS_ACTIVE){(viewScope=viewElement.scope())&&viewScope.$emit(ev.name.replace("Tabs","View"),data);break}}function navSwipeAttr(val){ionic.DomUtil.cachedAttr($element,"nav-swipe",val)}function onTabsTop(ev,isTabsTop){var associatedNavBarCtrl=getAssociatedNavBarCtrl();associatedNavBarCtrl&&associatedNavBarCtrl.hasTabsTop(isTabsTop)}function onBarSubheader(ev,isBarSubheader){var associatedNavBarCtrl=getAssociatedNavBarCtrl();associatedNavBarCtrl&&associatedNavBarCtrl.hasBarSubheader(isBarSubheader)}function getAssociatedNavBarCtrl(){if(navBarDelegate)for(var x=0;x<$ionicNavBarDelegate._instances.length;x++)if($ionicNavBarDelegate._instances[x].$$delegateHandle==navBarDelegate)return $ionicNavBarDelegate._instances[x];return $element.inheritedData("$ionNavBarController")}var direction,navBarDelegate,activeEleId,disableRenderStartViewId,disableAnimation,VIEW_STATUS_ACTIVE="active",self=this,isPrimary=!1,navViewAttr=$ionicViewSwitcher.navViewAttr;self.scope=$scope,self.element=$element,self.init=function(){var navViewName=$attrs.name||"",parent=$element.parent().inheritedData("$uiView"),parentViewName=parent&&parent.state?parent.state.name:"";navViewName.indexOf("@")<0&&(navViewName=navViewName+"@"+parentViewName);var viewData={name:navViewName,state:null};$element.data("$uiView",viewData);var deregisterInstance=$ionicNavViewDelegate._registerInstance(self,$attrs.delegateHandle);return $scope.$on("$destroy",function(){deregisterInstance(),self.isSwipeFreeze&&$ionicScrollDelegate.freezeAllScrolls(!1)}),$scope.$on("$ionicHistory.deselect",self.cacheCleanup),$scope.$on("$ionicTabs.top",onTabsTop),$scope.$on("$ionicSubheader",onBarSubheader),$scope.$on("$ionicTabs.beforeLeave",onTabsLeave),$scope.$on("$ionicTabs.afterLeave",onTabsLeave),$scope.$on("$ionicTabs.leave",onTabsLeave),ionic.Platform.ready(function(){ionic.Platform.isWebView()&&$ionicConfig.views.swipeBackEnabled()&&self.initSwipeBack()}),viewData},self.register=function(viewLocals){var leavingView=extend({},$ionicHistory.currentView()),registerData=$ionicHistory.register($scope,viewLocals);self.update(registerData);var enteringView=$ionicHistory.getViewById(registerData.viewId)||{},renderStart=disableRenderStartViewId!==registerData.viewId;self.render(registerData,viewLocals,enteringView,leavingView,renderStart,!0)},self.update=function(registerData){isPrimary=!0,direction=registerData.direction;var parentNavViewCtrl=$element.parent().inheritedData("$ionNavViewController");parentNavViewCtrl&&(parentNavViewCtrl.isPrimary(!1),"enter"!==direction&&"exit"!==direction||(parentNavViewCtrl.direction(direction),"enter"===direction&&(direction="none")))},self.render=function(registerData,viewLocals,enteringView,leavingView,renderStart,renderEnd){var switcher=$ionicViewSwitcher.create(self,viewLocals,enteringView,leavingView,renderStart,renderEnd);switcher.init(registerData,function(){switcher.transition(self.direction(),registerData.enableBack,!disableAnimation),disableRenderStartViewId=disableAnimation=null})},self.beforeEnter=function(transitionData){if(isPrimary){navBarDelegate=transitionData.navBarDelegate;var associatedNavBarCtrl=getAssociatedNavBarCtrl();associatedNavBarCtrl&&associatedNavBarCtrl.update(transitionData),navSwipeAttr("")}},self.activeEleId=function(eleId){return arguments.length&&(activeEleId=eleId),activeEleId},self.transitionEnd=function(){var x,l,viewElement,viewElements=$element.children();for(x=0,l=viewElements.length;x<l;x++)(viewElement=viewElements.eq(x)).data("$eleId")===activeEleId?navViewAttr(viewElement,VIEW_STATUS_ACTIVE):"leaving"!==navViewAttr(viewElement)&&navViewAttr(viewElement)!==VIEW_STATUS_ACTIVE&&"cached"!==navViewAttr(viewElement)||(viewElement.data("$destroyEle")||viewElement.data("$noCache")?$ionicViewSwitcher.destroyViewEle(viewElement):(navViewAttr(viewElement,"cached"),ionic.Utils.disconnectScope(viewElement.scope())));navSwipeAttr(""),self.isSwipeFreeze&&$ionicScrollDelegate.freezeAllScrolls(!1)},self.cacheCleanup=function(){for(var viewElements=$element.children(),x=0,l=viewElements.length;x<l;x++)viewElements.eq(x).data("$destroyEle")&&$ionicViewSwitcher.destroyViewEle(viewElements.eq(x))},self.clearCache=function(stateIds){var viewElement,viewScope,x,l,y,eleIdentifier,viewElements=$element.children();for(x=0,l=viewElements.length;x<l;x++)if(viewElement=viewElements.eq(x),stateIds)for(eleIdentifier=viewElement.data("$eleId"),y=0;y<stateIds.length;y++)eleIdentifier===stateIds[y]&&$ionicViewSwitcher.destroyViewEle(viewElement);else"cached"==navViewAttr(viewElement)?$ionicViewSwitcher.destroyViewEle(viewElement):navViewAttr(viewElement)==VIEW_STATUS_ACTIVE&&(viewScope=viewElement.scope())&&viewScope.$broadcast("$ionicView.clearCache")},self.getViewElements=function(){return $element.children()},self.appendViewElement=function(viewEle,viewLocals){var linkFn=$compile(viewEle);$element.append(viewEle);var viewScope=$scope.$new();if(viewLocals&&viewLocals.$$controller){viewLocals.$scope=viewScope;var controller=$controller(viewLocals.$$controller,viewLocals);viewLocals.$$controllerAs&&(viewScope[viewLocals.$$controllerAs]=controller),$element.children().data("$ngControllerController",controller)}return linkFn(viewScope),viewScope},self.title=function(val){var associatedNavBarCtrl=getAssociatedNavBarCtrl();associatedNavBarCtrl&&associatedNavBarCtrl.title(val)},self.enableBackButton=function(shouldEnable){var associatedNavBarCtrl=getAssociatedNavBarCtrl();associatedNavBarCtrl&&associatedNavBarCtrl.enableBackButton(shouldEnable)},self.showBackButton=function(shouldShow){var associatedNavBarCtrl=getAssociatedNavBarCtrl();return!associatedNavBarCtrl||(arguments.length?associatedNavBarCtrl.showActiveBackButton(shouldShow):associatedNavBarCtrl.showActiveBackButton())},self.showBar=function(val){var associatedNavBarCtrl=getAssociatedNavBarCtrl();return!associatedNavBarCtrl||(arguments.length?associatedNavBarCtrl.showBar(val):associatedNavBarCtrl.showBar())},self.isPrimary=function(val){return arguments.length&&(isPrimary=val),isPrimary},self.direction=function(val){return arguments.length&&(direction=val),direction},self.initSwipeBack=function(){function onDragStart(ev){if(isPrimary&&!((startDragX=getDragX(ev))>swipeBackHitWidth)){backView=$ionicHistory.backView();var currentView=$ionicHistory.currentView();if(backView&&backView.historyId===currentView.historyId&&!1!==currentView.canSwipeBack){windowWidth||(windowWidth=window.innerWidth),self.isSwipeFreeze=$ionicScrollDelegate.freezeAllScrolls(!0);var registerData={direction:"back"};dragPoints=[],cancelData={showBar:self.showBar(),showBackButton:self.showBackButton()};var switcher=$ionicViewSwitcher.create(self,registerData,backView,currentView,!0,!1);switcher.loadViewElements(registerData),switcher.render(registerData),viewTransition=switcher.transition("back",$ionicHistory.enabledBack(backView),!0),associatedNavBarCtrl=getAssociatedNavBarCtrl(),deregDrag=ionic.onGesture("drag",onDrag,$element[0]),deregRelease=ionic.onGesture("release",onRelease,$element[0])}}}function onDrag(ev){if(isPrimary&&viewTransition){var dragX=getDragX(ev);if(dragPoints.push({t:Date.now(),x:dragX}),dragX>=windowWidth-15)onRelease(ev);else{var step=Math.min(Math.max(getSwipeCompletion(dragX),0),1);viewTransition.run(step),associatedNavBarCtrl&&associatedNavBarCtrl.activeTransition&&associatedNavBarCtrl.activeTransition.run(step)}}}function onRelease(ev){if(isPrimary&&viewTransition&&dragPoints&&dragPoints.length>1){for(var now=Date.now(),releaseX=getDragX(ev),startDrag=dragPoints[dragPoints.length-1],x=dragPoints.length-2;x>=0&&!(now-startDrag.t>200);x--)startDrag=dragPoints[x];var isSwipingRight=releaseX>=dragPoints[dragPoints.length-2].x,releaseSwipeCompletion=getSwipeCompletion(releaseX),velocity=Math.abs(startDrag.x-releaseX)/(now-startDrag.t);if(disableRenderStartViewId=backView.viewId,disableAnimation=releaseSwipeCompletion<.03||releaseSwipeCompletion>.97,isSwipingRight&&(releaseSwipeCompletion>.5||velocity>.1)){var speed=velocity>.5||velocity<.05||releaseX>windowWidth-45?"fast":"slow";navSwipeAttr(disableAnimation?"":speed),backView.go(),associatedNavBarCtrl&&associatedNavBarCtrl.activeTransition&&associatedNavBarCtrl.activeTransition.complete(!disableAnimation,speed)}else navSwipeAttr(disableAnimation?"":"fast"),disableRenderStartViewId=null,viewTransition.cancel(!disableAnimation),associatedNavBarCtrl&&associatedNavBarCtrl.activeTransition&&associatedNavBarCtrl.activeTransition.cancel(!disableAnimation,"fast",cancelData),disableAnimation=null}ionic.offGesture(deregDrag,"drag",onDrag),ionic.offGesture(deregRelease,"release",onRelease),windowWidth=viewTransition=dragPoints=null,self.isSwipeFreeze=$ionicScrollDelegate.freezeAllScrolls(!1)}function getDragX(ev){return ionic.tap.pointerCoord(ev.gesture.srcEvent).x}function getSwipeCompletion(dragX){return(dragX-startDragX)/windowWidth}var viewTransition,associatedNavBarCtrl,backView,deregDragStart,deregDrag,deregRelease,windowWidth,startDragX,dragPoints,swipeBackHitWidth=$ionicConfig.views.swipeBackHitWidth(),cancelData={};deregDragStart=ionic.onGesture("dragstart",onDragStart,$element[0]),$scope.$on("$destroy",function(){ionic.offGesture(deregDragStart,"dragstart",onDragStart),ionic.offGesture(deregDrag,"drag",onDrag),ionic.offGesture(deregRelease,"release",onRelease),self.element=viewTransition=associatedNavBarCtrl=null})}}]),IonicModule.controller("$ionicRefresher",["$scope","$attrs","$element","$ionicBind","$timeout",function($scope,$attrs,$element,$ionicBind,$timeout){function handleMousedown(e){e.touches=e.touches||[{screenX:e.screenX,screenY:e.screenY}],startY=Math.floor(e.touches[0].screenY)}function handleTouchstart(e){e.touches=e.touches||[{screenX:e.screenX,screenY:e.screenY}],startY=e.touches[0].screenY}function handleTouchend(){startY=null,(canOverscroll||isDragging)&&(isDragging?(isDragging=!1,dragOffset=0,lastOverscroll>ptrThreshold?(start(),scrollTo(ptrThreshold,scrollTime)):(scrollTo(0,scrollTime,deactivate),isOverscrolling=!1)):(dragOffset=0,isOverscrolling=!1,setScrollLock(!1)))}function handleTouchmove(e){if(e.touches=e.touches||[{screenX:e.screenX,screenY:e.screenY}],(startY||"mousemove"!=e.type)&&canOverscroll&&!(e.touches.length>1)){if(null===startY&&(startY=e.touches[0].screenY),deltaY=e.touches[0].screenY-startY,ionic.Platform.isAndroid()&&4.4===ionic.Platform.version()&&!ionic.Platform.isCrosswalk()&&0===scrollParent.scrollTop&&deltaY>0&&(isDragging=!0,e.preventDefault()),deltaY-dragOffset<=0||0!==scrollParent.scrollTop)return isOverscrolling&&(isOverscrolling=!1,setScrollLock(!1)),isDragging&&nativescroll(scrollParent,deltaY- -1*dragOffset),void(0!==lastOverscroll&&overscroll(0));deltaY>0&&0===scrollParent.scrollTop&&!isOverscrolling&&(dragOffset=deltaY),e.preventDefault(),isOverscrolling||(isOverscrolling=!0,setScrollLock(!0)),isDragging=!0,overscroll((deltaY-dragOffset)/3),!activated&&lastOverscroll>ptrThreshold?(activated=!0,ionic.requestAnimationFrame(activate)):activated&&lastOverscroll<ptrThreshold&&(activated=!1,ionic.requestAnimationFrame(deactivate))}}function handleScroll(e){canOverscroll=0===e.target.scrollTop||isDragging}function overscroll(val){scrollChild.style[ionic.CSS.TRANSFORM]="translateY("+val+"px)",lastOverscroll=val}function nativescroll(target,newScrollTop){target.scrollTop=newScrollTop;var e=document.createEvent("UIEvents");e.initUIEvent("scroll",!0,!0,window,1),target.dispatchEvent(e)}function setScrollLock(enabled){enabled?ionic.requestAnimationFrame(function(){scrollChild.classList.add("overscroll"),show()}):ionic.requestAnimationFrame(function(){scrollChild.classList.remove("overscroll"),hide(),deactivate()})}function scrollTo(Y,duration,callback){function easeOutCubic(t){return--t*t*t+1}function scroll(){var currentTime=Date.now(),time=Math.min(1,(currentTime-start)/duration),easedT=easeOutCubic(time);overscroll(Math.floor(easedT*(Y-from)+from)),time<1?ionic.requestAnimationFrame(scroll):(Y<5&&Y>-5&&(isOverscrolling=!1,setScrollLock(!1)),callback&&callback())}var start=Date.now(),from=lastOverscroll;from!==Y?ionic.requestAnimationFrame(scroll):callback()}function destroy(){ionic.off(touchStartEvent,handleTouchstart,scrollChild),ionic.off(touchMoveEvent,handleTouchmove,scrollChild),ionic.off(touchEndEvent,handleTouchend,scrollChild),ionic.off("mousedown",handleMousedown,scrollChild),ionic.off("mousemove",handleTouchmove,scrollChild),ionic.off("mouseup",handleTouchend,scrollChild),ionic.off("scroll",handleScroll,scrollParent),scrollParent=null,scrollChild=null}function activate(){$element[0].classList.add("active"),$scope.$onPulling()}function deactivate(){$timeout(function(){$element.removeClass("active refreshing refreshing-tail"),activated&&(activated=!1)},150)}function start(){$element[0].classList.add("refreshing");var q=$scope.$onRefresh();q&&q.then&&q.finally(function(){$scope.$broadcast("scroll.refreshComplete")})}function show(){$element[0].classList.remove("invisible")}function hide(){$element[0].classList.add("invisible")}function tail(){$element[0].classList.add("refreshing-tail")}var scrollParent,scrollChild,self=this,isDragging=!1,isOverscrolling=!1,dragOffset=0,lastOverscroll=0,ptrThreshold=60,activated=!1,scrollTime=500,startY=null,deltaY=null,canOverscroll=!0;isDefined($attrs.pullingIcon)||$attrs.$set("pullingIcon","ion-android-arrow-down"),$scope.showSpinner=!isDefined($attrs.refreshingIcon)&&"none"!=$attrs.spinner,$scope.showIcon=isDefined($attrs.refreshingIcon),$ionicBind($scope,$attrs,{pullingIcon:"@",pullingText:"@",refreshingIcon:"@",refreshingText:"@",spinner:"@",disablePullingRotation:"@",$onRefresh:"&onRefresh",$onPulling:"&onPulling"}),$scope.$on("scroll.refreshComplete",function(){$timeout(function(){ionic.requestAnimationFrame(tail),scrollTo(0,scrollTime,deactivate),$timeout(function(){isOverscrolling&&(isOverscrolling=!1,setScrollLock(!1))},scrollTime)},scrollTime)});var touchStartEvent,touchMoveEvent,touchEndEvent;window.navigator.pointerEnabled?(touchStartEvent="pointerdown",touchMoveEvent="pointermove",touchEndEvent="pointerup"):window.navigator.msPointerEnabled?(touchStartEvent="MSPointerDown",touchMoveEvent="MSPointerMove",touchEndEvent="MSPointerUp"):(touchStartEvent="touchstart",touchMoveEvent="touchmove",touchEndEvent="touchend"),self.init=function(){if(scrollParent=$element.parent().parent()[0],scrollChild=$element.parent()[0],!(scrollParent&&scrollParent.classList.contains("ionic-scroll")&&scrollChild&&scrollChild.classList.contains("scroll")))throw new Error("Refresher must be immediate child of ion-content or ion-scroll");ionic.on(touchStartEvent,handleTouchstart,scrollChild),ionic.on(touchMoveEvent,handleTouchmove,scrollChild),ionic.on(touchEndEvent,handleTouchend,scrollChild),ionic.on("mousedown",handleMousedown,scrollChild),ionic.on("mousemove",handleTouchmove,scrollChild),ionic.on("mouseup",handleTouchend,scrollChild),ionic.on("scroll",handleScroll,scrollParent),$scope.$on("$destroy",destroy)},self.getRefresherDomMethods=function(){return{activate:activate,deactivate:deactivate,start:start,show:show,hide:hide,tail:tail}},self.__handleTouchmove=handleTouchmove,self.__getScrollChild=function(){return scrollChild},self.__getScrollParent=function(){return scrollParent}}]),IonicModule.controller("$ionicScroll",["$scope","scrollViewOptions","$timeout","$window","$location","$document","$ionicScrollDelegate","$ionicHistory",function($scope,scrollViewOptions,$timeout,$window,$location,$document,$ionicScrollDelegate,$ionicHistory){var self=this;self.__timeout=$timeout,self._scrollViewOptions=scrollViewOptions,self.isNative=function(){return!!scrollViewOptions.nativeScrolling};var scrollView,element=self.element=scrollViewOptions.el,$element=self.$element=jqLite(element);scrollView=self.isNative()?self.scrollView=new ionic.views.ScrollNative(scrollViewOptions):self.scrollView=new ionic.views.Scroll(scrollViewOptions),($element.parent().length?$element.parent():$element).data("$$ionicScrollController",self);var deregisterInstance=$ionicScrollDelegate._registerInstance(self,scrollViewOptions.delegateHandle,function(){return $ionicHistory.isActiveScope($scope)});isDefined(scrollViewOptions.bouncing)||ionic.Platform.ready(function(){scrollView&&scrollView.options&&(scrollView.options.bouncing=!0,ionic.Platform.isAndroid()&&(scrollView.options.bouncing=!1,scrollView.options.deceleration=.95))});var resize=angular.bind(scrollView,scrollView.resize);angular.element($window).on("resize",resize);var scrollFunc=function(e){var detail=(e.originalEvent||e).detail||{};$scope.$onScroll&&$scope.$onScroll({event:e,scrollTop:detail.scrollTop||0,scrollLeft:detail.scrollLeft||0})};$element.on("scroll",scrollFunc),$scope.$on("$destroy",function(){deregisterInstance(),scrollView&&scrollView.__cleanup&&scrollView.__cleanup(),angular.element($window).off("resize",resize),$element.off("scroll",scrollFunc),scrollView=self.scrollView=scrollViewOptions=self._scrollViewOptions=scrollViewOptions.el=self._scrollViewOptions.el=$element=self.$element=element=null}),$timeout(function(){scrollView&&scrollView.run&&scrollView.run()}),self.getScrollView=function(){return scrollView},self.getScrollPosition=function(){return scrollView.getValues()},self.resize=function(){return $timeout(resize,0,!1).then(function(){$element&&$element.triggerHandler("scroll-resize")})},self.scrollTop=function(shouldAnimate){self.resize().then(function(){scrollView&&scrollView.scrollTo(0,0,!!shouldAnimate)})},self.scrollBottom=function(shouldAnimate){self.resize().then(function(){if(scrollView){var max=scrollView.getScrollMax();scrollView.scrollTo(max.left,max.top,!!shouldAnimate)}})},self.scrollTo=function(left,top,shouldAnimate){self.resize().then(function(){scrollView&&scrollView.scrollTo(left,top,!!shouldAnimate)})},self.zoomTo=function(zoom,shouldAnimate,originLeft,originTop){self.resize().then(function(){scrollView&&scrollView.zoomTo(zoom,!!shouldAnimate,originLeft,originTop)})},self.zoomBy=function(zoom,shouldAnimate,originLeft,originTop){self.resize().then(function(){scrollView&&scrollView.zoomBy(zoom,!!shouldAnimate,originLeft,originTop)})},self.scrollBy=function(left,top,shouldAnimate){self.resize().then(function(){scrollView&&scrollView.scrollBy(left,top,!!shouldAnimate)})},self.anchorScroll=function(shouldAnimate){self.resize().then(function(){if(scrollView){var hash=$location.hash(),elm=hash&&$document[0].getElementById(hash);if(hash&&elm){var curElm=elm,scrollLeft=0,scrollTop=0;do{null!==curElm&&(scrollLeft+=curElm.offsetLeft),null!==curElm&&(scrollTop+=curElm.offsetTop),curElm=curElm.offsetParent}while(curElm.attributes!=self.element.attributes&&curElm.offsetParent);scrollView.scrollTo(scrollLeft,scrollTop,!!shouldAnimate)}else scrollView.scrollTo(0,0,!!shouldAnimate)}})},self.freezeScroll=scrollView.freeze,self.freezeScrollShut=scrollView.freezeShut,self.freezeAllScrolls=function(shouldFreeze){for(var i=0;i<$ionicScrollDelegate._instances.length;i++)$ionicScrollDelegate._instances[i].freezeScroll(shouldFreeze)},self._setRefresher=function(refresherScope,refresherElement,refresherMethods){self.refresher=refresherElement;var refresherHeight=self.refresher.clientHeight||60;scrollView.activatePullToRefresh(refresherHeight,refresherMethods)}}]),IonicModule.controller("$ionicSideMenus",["$scope","$attrs","$ionicSideMenuDelegate","$ionicPlatform","$ionicBody","$ionicHistory","$ionicScrollDelegate","IONIC_BACK_PRIORITY","$rootScope",function($scope,$attrs,$ionicSideMenuDelegate,$ionicPlatform,$ionicBody,$ionicHistory,$ionicScrollDelegate,IONIC_BACK_PRIORITY,$rootScope){var rightShowing,leftShowing,isDragging,startX,lastX,offsetX,isAsideExposed,self=this,enableMenuWithBackViews=!0;self.$scope=$scope,self.initialize=function(options){self.left=options.left,self.right=options.right,self.setContent(options.content),self.dragThresholdX=options.dragThresholdX||10,$ionicHistory.registerHistory(self.$scope)},self.setContent=function(content){content&&(self.content=content,self.content.onDrag=function(e){self._handleDrag(e)},self.content.endDrag=function(e){self._endDrag(e)})},self.isOpenLeft=function(){return self.getOpenAmount()>0},self.isOpenRight=function(){return self.getOpenAmount()<0},self.toggleLeft=function(shouldOpen){if(!isAsideExposed&&self.left.isEnabled){var openAmount=self.getOpenAmount();0===arguments.length&&(shouldOpen=openAmount<=0),self.content.enableAnimation(),shouldOpen?(self.openPercentage(100),$rootScope.$emit("$ionicSideMenuOpen","left")):(self.openPercentage(0),$rootScope.$emit("$ionicSideMenuClose","left"))}},self.toggleRight=function(shouldOpen){if(!isAsideExposed&&self.right.isEnabled){var openAmount=self.getOpenAmount();0===arguments.length&&(shouldOpen=openAmount>=0),self.content.enableAnimation(),shouldOpen?(self.openPercentage(-100),$rootScope.$emit("$ionicSideMenuOpen","right")):(self.openPercentage(0),$rootScope.$emit("$ionicSideMenuClose","right"))}},self.toggle=function(side){"right"==side?self.toggleRight():self.toggleLeft()},self.close=function(){self.openPercentage(0),$rootScope.$emit("$ionicSideMenuClose","left"),$rootScope.$emit("$ionicSideMenuClose","right")},self.getOpenAmount=function(){return self.content&&self.content.getTranslateX()||0},self.getOpenRatio=function(){var amount=self.getOpenAmount();return amount>=0?amount/self.left.width:amount/self.right.width},self.isOpen=function(){return 0!==self.getOpenAmount()},self.getOpenPercentage=function(){return 100*self.getOpenRatio()},self.openPercentage=function(percentage){var p=percentage/100;self.left&&percentage>=0?self.openAmount(self.left.width*p):self.right&&percentage<0&&self.openAmount(self.right.width*p),$ionicBody.enableClass(0!==percentage,"menu-open"),self.content.setCanScroll(0==percentage)},self.openAmount=function(amount){var maxLeft=self.left&&self.left.width||0,maxRight=self.right&&self.right.width||0;(self.left&&self.left.isEnabled||!(amount>0))&&(self.right&&self.right.isEnabled||!(amount<0))?leftShowing&&amount>maxLeft?self.content.setTranslateX(maxLeft):rightShowing&&amount<-maxRight?self.content.setTranslateX(-maxRight):(self.content.setTranslateX(amount),amount>=0?(leftShowing=!0,rightShowing=!1,amount>0&&(self.right&&self.right.pushDown&&self.right.pushDown(),self.left&&self.left.bringUp&&self.left.bringUp())):(rightShowing=!0,leftShowing=!1,self.right&&self.right.bringUp&&self.right.bringUp(),self.left&&self.left.pushDown&&self.left.pushDown())):self.content.setTranslateX(0)},self.snapToRest=function(e){self.content.enableAnimation(),isDragging=!1;var ratio=self.getOpenRatio();if(0!==ratio){var velocityX=e.gesture.velocityX,direction=e.gesture.direction;ratio>0&&ratio<.5&&"right"==direction&&velocityX<.3?self.openPercentage(0):ratio>.5&&"left"==direction&&velocityX<.3?self.openPercentage(100):ratio<0&&ratio>-.5&&"left"==direction&&velocityX<.3?self.openPercentage(0):ratio<.5&&"right"==direction&&velocityX<.3?self.openPercentage(-100):"right"==direction&&ratio>=0&&(ratio>=.5||velocityX>.3)?self.openPercentage(100):"left"==direction&&ratio<=0&&(ratio<=-.5||velocityX>.3)?self.openPercentage(-100):self.openPercentage(0)}else self.openPercentage(0)},self.enableMenuWithBackViews=function(val){return arguments.length&&(enableMenuWithBackViews=!!val),enableMenuWithBackViews},self.isAsideExposed=function(){return!!isAsideExposed},self.exposeAside=function(shouldExposeAside){(self.left&&self.left.isEnabled||self.right&&self.right.isEnabled)&&(self.close(),isAsideExposed=shouldExposeAside,self.left&&self.left.isEnabled&&self.right&&self.right.isEnabled?self.content.setMarginLeftAndRight(isAsideExposed?self.left.width:0,isAsideExposed?self.right.width:0):self.left&&self.left.isEnabled?self.content.setMarginLeft(isAsideExposed?self.left.width:0):self.right&&self.right.isEnabled&&self.content.setMarginRight(isAsideExposed?self.right.width:0),self.$scope.$emit("$ionicExposeAside",isAsideExposed))},self.activeAsideResizing=function(isResizing){$ionicBody.enableClass(isResizing,"aside-resizing")},self._endDrag=function(e){isAsideExposed||(isDragging&&self.snapToRest(e),startX=null,lastX=null,offsetX=null)},self._handleDrag=function(e){!isAsideExposed&&$scope.dragContent&&(startX?lastX=e.gesture.touches[0].pageX:(startX=e.gesture.touches[0].pageX,lastX=startX),!isDragging&&Math.abs(lastX-startX)>self.dragThresholdX&&(startX=lastX,isDragging=!0,self.content.disableAnimation(),offsetX=self.getOpenAmount()),isDragging&&self.openAmount(offsetX+(lastX-startX)))},self.canDragContent=function(canDrag){return arguments.length&&($scope.dragContent=!!canDrag),$scope.dragContent},self.edgeThreshold=25,self.edgeThresholdEnabled=!1,self.edgeDragThreshold=function(value){return arguments.length&&(isNumber(value)&&value>0?(self.edgeThreshold=value,self.edgeThresholdEnabled=!0):self.edgeThresholdEnabled=!!value),self.edgeThresholdEnabled},self.isDraggableTarget=function(e){var shouldOnlyAllowEdgeDrag=self.edgeThresholdEnabled&&!self.isOpen(),startX=e.gesture.startEvent&&e.gesture.startEvent.center&&e.gesture.startEvent.center.pageX,dragIsWithinBounds=!shouldOnlyAllowEdgeDrag||startX<=self.edgeThreshold||startX>=self.content.element.offsetWidth-self.edgeThreshold,backView=$ionicHistory.backView(),menuEnabled=!!enableMenuWithBackViews||!backView;if(!menuEnabled){var currentView=$ionicHistory.currentView()||{};return dragIsWithinBounds&&backView.historyId!==currentView.historyId}return($scope.dragContent||self.isOpen())&&dragIsWithinBounds&&!e.gesture.srcEvent.defaultPrevented&&menuEnabled&&!e.target.tagName.match(/input|textarea|select|object|embed/i)&&!e.target.isContentEditable&&!(e.target.dataset?e.target.dataset.preventScroll:"true"==e.target.getAttribute("data-prevent-scroll"))},$scope.sideMenuContentTranslateX=0;var deregisterBackButtonAction=noop,closeSideMenu=angular.bind(self,self.close);$scope.$watch(function(){return 0!==self.getOpenAmount()},function(isOpen){deregisterBackButtonAction(),isOpen&&(deregisterBackButtonAction=$ionicPlatform.registerBackButtonAction(closeSideMenu,IONIC_BACK_PRIORITY.sideMenu))});var deregisterInstance=$ionicSideMenuDelegate._registerInstance(self,$attrs.delegateHandle,function(){return $ionicHistory.isActiveScope($scope)});$scope.$on("$destroy",function(){deregisterInstance(),deregisterBackButtonAction(),self.$scope=null,self.content&&(self.content.setCanScroll(!0),self.content.element=null,self.content=null)}),self.initialize({left:{width:275},right:{width:275}})}]),function(ionic){function createSvgElement(tagName,data,parent,spinnerName){var k,x,y,ele=document.createElement(SHORTCUTS[tagName]||tagName);for(k in data)if(angular.isArray(data[k]))for(x=0;x<data[k].length;x++)if(data[k][x].fn)for(y=0;y<data[k][x].t;y++)createSvgElement(k,data[k][x].fn(y,spinnerName),ele,spinnerName);else createSvgElement(k,data[k][x],ele,spinnerName);else setSvgAttribute(ele,k,data[k]);parent.appendChild(ele)}function setSvgAttribute(ele,k,v){ele.setAttribute(SHORTCUTS[k]||k,v)}function animationValues(strValues,i){var values=strValues.split(";"),back=values.slice(i),front=values.slice(0,values.length-back.length);return(values=back.concat(front).reverse()).join(";")+";"+values[0]}function easeInOutCubic(t,c){return(t/=c/2)<1?.5*t*t*t:.5*((t-=2)*t*t+2)}var SHORTCUTS={a:"animate",an:"attributeName",at:"animateTransform",c:"circle",da:"stroke-dasharray",os:"stroke-dashoffset",f:"fill",lc:"stroke-linecap",rc:"repeatCount",sw:"stroke-width",t:"transform",v:"values"},SPIN_ANIMATION={v:"0,32,32;360,32,32",an:"transform",type:"rotate",rc:"indefinite",dur:"750ms"},IOS_SPINNER={sw:4,lc:"round",line:[{fn:function(i,spinnerName){return{y1:"ios"==spinnerName?17:12,y2:"ios"==spinnerName?29:20,t:"translate(32,32) rotate("+(30*i+(i<6?180:-180))+")",a:[{fn:function(){return{an:"stroke-opacity",dur:"750ms",v:animationValues("0;.1;.15;.25;.35;.45;.55;.65;.7;.85;1",i),rc:"indefinite"}},t:1}]}},t:12}]},spinners={android:{c:[{sw:6,da:128,os:82,r:26,cx:32,cy:32,f:"none"}]},ios:IOS_SPINNER,"ios-small":IOS_SPINNER,bubbles:{sw:0,c:[{fn:function(i){return{cx:24*Math.cos(2*Math.PI*i/8),cy:24*Math.sin(2*Math.PI*i/8),t:"translate(32,32)",a:[{fn:function(){return{an:"r",dur:"750ms",v:animationValues("1;2;3;4;5;6;7;8",i),rc:"indefinite"}},t:1}]}},t:8}]},circles:{c:[{fn:function(i){return{r:5,cx:24*Math.cos(2*Math.PI*i/8),cy:24*Math.sin(2*Math.PI*i/8),t:"translate(32,32)",sw:0,a:[{fn:function(){return{an:"fill-opacity",dur:"750ms",v:animationValues(".3;.3;.3;.4;.7;.85;.9;1",i),rc:"indefinite"}},t:1}]}},t:8}]},crescent:{c:[{sw:4,da:128,os:82,r:26,cx:32,cy:32,f:"none",at:[SPIN_ANIMATION]}]},dots:{c:[{fn:function(i){return{cx:16+16*i,cy:32,sw:0,a:[{fn:function(){return{an:"fill-opacity",dur:"750ms",v:animationValues(".5;.6;.8;1;.8;.6;.5",i),rc:"indefinite"}},t:1},{fn:function(){return{an:"r",dur:"750ms",v:animationValues("4;5;6;5;4;3;3",i),rc:"indefinite"}},t:1}]}},t:3}]},lines:{sw:7,lc:"round",line:[{fn:function(i){return{x1:10+14*i,x2:10+14*i,a:[{fn:function(){return{an:"y1",dur:"750ms",v:animationValues("16;18;28;18;16",i),rc:"indefinite"}},t:1},{fn:function(){return{an:"y2",dur:"750ms",v:animationValues("48;44;36;46;48",i),rc:"indefinite"}},t:1},{fn:function(){return{an:"stroke-opacity",dur:"750ms",v:animationValues("1;.8;.5;.4;1",i),rc:"indefinite"}},t:1}]}},t:4}]},ripple:{f:"none","fill-rule":"evenodd",sw:3,circle:[{fn:function(i){return{cx:32,cy:32,a:[{fn:function(){return{an:"r",begin:-1*i+"s",dur:"2s",v:"0;24",keyTimes:"0;1",keySplines:"0.1,0.2,0.3,1",calcMode:"spline",rc:"indefinite"}},t:1},{fn:function(){return{an:"stroke-opacity",begin:-1*i+"s",dur:"2s",v:".2;1;.2;0",rc:"indefinite"}},t:1}]}},t:2}]},spiral:{defs:[{linearGradient:[{id:"sGD",gradientUnits:"userSpaceOnUse",x1:55,y1:46,x2:2,y2:46,stop:[{offset:.1,class:"stop1"},{offset:1,class:"stop2"}]}]}],g:[{sw:4,lc:"round",f:"none",path:[{stroke:"url(#sGD)",d:"M4,32 c0,15,12,28,28,28c8,0,16-4,21-9"},{d:"M60,32 C60,16,47.464,4,32,4S4,16,4,32"}],at:[SPIN_ANIMATION]}]}},animations={android:function(ele){function run(){if(!self.stop){var v=easeInOutCubic(Date.now()-startTime,650),scaleX=1,translateX=0,dasharray=188-58*v,dashoffset=182-182*v;rIndex%2&&(scaleX=-1,translateX=-64,dasharray=128- -58*v,dashoffset=182*v);var rotateLine=[0,-101,-90,-11,-180,79,-270,-191][rIndex];setSvgAttribute(circleEle,"da",Math.max(Math.min(dasharray,188),128)),setSvgAttribute(circleEle,"os",Math.max(Math.min(dashoffset,182),0)),setSvgAttribute(circleEle,"t","scale("+scaleX+",1) translate("+translateX+",0) rotate("+rotateLine+",32,32)"),(rotateCircle+=4.1)>359&&(rotateCircle=0),setSvgAttribute(svgEle,"t","rotate("+rotateCircle+",32,32)"),v>=1&&(++rIndex>7&&(rIndex=0),startTime=Date.now()),ionic.requestAnimationFrame(run)}}var self=this;this.stop=!1;var startTime,rIndex=0,rotateCircle=0,svgEle=ele.querySelector("g"),circleEle=ele.querySelector("circle");return function(){return startTime=Date.now(),run(),self}}};IonicModule.controller("$ionicSpinner",["$element","$attrs","$ionicConfig",function($element,$attrs,$ionicConfig){var spinnerName,anim;this.init=function(){spinnerName=$attrs.icon||$ionicConfig.spinner.icon();var container=document.createElement("div");return createSvgElement("svg",{viewBox:"0 0 64 64",g:[spinners[spinnerName]]},container,spinnerName),$element.html(container.innerHTML),this.start(),spinnerName},this.start=function(){animations[spinnerName]&&(anim=animations[spinnerName]($element[0])())},this.stop=function(){animations[spinnerName]&&(anim.stop=!0)}}])}(ionic),IonicModule.controller("$ionicTab",["$scope","$ionicHistory","$attrs","$location","$state",function($scope,$ionicHistory,$attrs,$location,$state){this.$scope=$scope,this.hrefMatchesState=function(){return $attrs.href&&0===$location.path().indexOf($attrs.href.replace(/^#/,"").replace(/\/$/,""))},this.srefMatchesState=function(){return $attrs.uiSref&&$state.includes($attrs.uiSref.split("(")[0])},this.navNameMatchesState=function(){return this.navViewName&&$ionicHistory.isCurrentStateNavView(this.navViewName)},this.tabMatchesState=function(){return this.hrefMatchesState()||this.srefMatchesState()||this.navNameMatchesState()}}]),IonicModule.controller("$ionicTabs",["$scope","$element","$ionicHistory",function($scope,$element,$ionicHistory){var selectedTabIndex,self=this,selectedTab=null,previousSelectedTab=null,isVisible=!0;self.tabs=[],self.selectedIndex=function(){return self.tabs.indexOf(selectedTab)},self.selectedTab=function(){return selectedTab},self.previousSelectedTab=function(){return previousSelectedTab},self.add=function(tab){$ionicHistory.registerHistory(tab),self.tabs.push(tab)},self.remove=function(tab){var tabIndex=self.tabs.indexOf(tab);if(-1!==tabIndex){if(tab.$tabSelected)if(self.deselect(tab),1===self.tabs.length);else{var newTabIndex=tabIndex===self.tabs.length-1?tabIndex-1:tabIndex+1;self.select(self.tabs[newTabIndex])}self.tabs.splice(tabIndex,1)}},self.deselect=function(tab){tab.$tabSelected&&(previousSelectedTab=selectedTab,selectedTab=selectedTabIndex=null,tab.$tabSelected=!1,(tab.onDeselect||noop)(),tab.$broadcast&&tab.$broadcast("$ionicHistory.deselect"))},self.select=function(tab,shouldEmitEvent){var tabIndex;if(isNumber(tab)){if((tabIndex=tab)>=self.tabs.length)return;tab=self.tabs[tabIndex]}else tabIndex=self.tabs.indexOf(tab);1===arguments.length&&(shouldEmitEvent=!(!tab.navViewName&&!tab.uiSref)),selectedTab&&selectedTab.$historyId==tab.$historyId?shouldEmitEvent&&$ionicHistory.goToHistoryRoot(tab.$historyId):selectedTabIndex!==tabIndex&&(forEach(self.tabs,function(tab){self.deselect(tab)}),selectedTab=tab,selectedTabIndex=tabIndex,self.$scope&&self.$scope.$parent&&(self.$scope.$parent.$activeHistoryId=tab.$historyId),tab.$tabSelected=!0,(tab.onSelect||noop)(),shouldEmitEvent&&$scope.$emit("$ionicHistory.change",{type:"tab",tabIndex:tabIndex,historyId:tab.$historyId,navViewName:tab.navViewName,hasNavView:!!tab.navViewName,title:tab.title,url:tab.href,uiSref:tab.uiSref}))},self.hasActiveScope=function(){for(var x=0;x<self.tabs.length;x++)if($ionicHistory.isActiveScope(self.tabs[x]))return!0;return!1},self.showBar=function(show){return arguments.length&&(show?$element.removeClass("tabs-item-hide"):$element.addClass("tabs-item-hide"),isVisible=!!show),isVisible}}]),IonicModule.controller("$ionicView",["$scope","$element","$attrs","$compile","$rootScope",function($scope,$element,$attrs,$compile,$rootScope){function afterEnter(){var viewTitleAttr=isDefined($attrs.viewTitle)&&"viewTitle"||isDefined($attrs.title)&&"title";viewTitleAttr&&(titleUpdate($attrs[viewTitleAttr]),deregisters.push($attrs.$observe(viewTitleAttr,titleUpdate))),isDefined($attrs.hideBackButton)&&deregisters.push($scope.$watch($attrs.hideBackButton,function(val){navViewCtrl.showBackButton(!val)})),isDefined($attrs.hideNavBar)&&deregisters.push($scope.$watch($attrs.hideNavBar,function(val){navViewCtrl.showBar(!val)}))}function titleUpdate(newTitle){isDefined(newTitle)&&newTitle!==viewTitle&&(viewTitle=newTitle,navViewCtrl.title(viewTitle))}function deregisterFns(){for(var x=0;x<deregisters.length;x++)deregisters[x]();deregisters=[]}function generateNavBarItem(html){if(html)return $compile(html)($scope.$new())}function attrTrue(key){return!!$scope.$eval($attrs[key])}var navViewCtrl,navBarDelegateHandle,viewTitle,self=this,navElementHtml={},deregisters=[],deregIonNavBarInit=$scope.$on("ionNavBar.init",function(ev,delegateHandle){ev.stopPropagation(),navBarDelegateHandle=delegateHandle});self.init=function(){deregIonNavBarInit();var modalCtrl=$element.inheritedData("$ionModalController");(navViewCtrl=$element.inheritedData("$ionNavViewController"))&&!modalCtrl&&($scope.$on("$ionicView.beforeEnter",self.beforeEnter),$scope.$on("$ionicView.afterEnter",afterEnter),$scope.$on("$ionicView.beforeLeave",deregisterFns))},self.beforeEnter=function(ev,transData){if(transData&&!transData.viewNotified){transData.viewNotified=!0,$rootScope.$$phase||$scope.$digest(),viewTitle=isDefined($attrs.viewTitle)?$attrs.viewTitle:$attrs.title;var navBarItems={};for(var n in navElementHtml)navBarItems[n]=generateNavBarItem(navElementHtml[n]);navViewCtrl.beforeEnter(extend(transData,{title:viewTitle,showBack:!attrTrue("hideBackButton"),navBarItems:navBarItems,navBarDelegate:navBarDelegateHandle||null,showNavBar:!attrTrue("hideNavBar"),hasHeaderBar:!1})),deregisterFns()}},self.navElement=function(type,html){navElementHtml[type]=html}}]),IonicModule.directive("ionActionSheet",["$document",function($document){return{restrict:"E",scope:!0,replace:!0,link:function($scope,$element){var keyUp=function(e){27==e.which&&($scope.cancel(),$scope.$apply())};$scope.$on("$destroy",function(){$element.remove(),$document.unbind("keyup",keyUp)}),$document.bind("keyup",keyUp),$element.bind("click",function(e){e.target==$element[0]&&($scope.cancel(),$scope.$apply())})},template:'<div class="action-sheet-backdrop"><div class="action-sheet-wrapper"><div class="action-sheet" ng-class="{\'action-sheet-has-icons\': $actionSheetHasIcon}"><div class="action-sheet-group action-sheet-options"><div class="action-sheet-title" ng-if="titleText" ng-bind-html="titleText"></div><button class="button action-sheet-option" ng-click="buttonClicked($index)" ng-class="b.className" ng-repeat="b in buttons" ng-bind-html="b.text"></button><button class="button destructive action-sheet-destructive" ng-if="destructiveText" ng-click="destructiveButtonClicked()" ng-bind-html="destructiveText"></button></div><div class="action-sheet-group action-sheet-cancel" ng-if="cancelText"><button class="button" ng-click="cancel()" ng-bind-html="cancelText"></button></div></div></div></div>'}}]),IonicModule.directive("ionCheckbox",["$ionicConfig",function($ionicConfig){return{restrict:"E",replace:!0,require:"?ngModel",transclude:!0,template:'<label class="item item-checkbox"><div class="checkbox checkbox-input-hidden disable-pointer-events"><input type="checkbox"><i class="checkbox-icon"></i></div><div class="item-content disable-pointer-events" ng-transclude></div></label>',compile:function(element,attr){var input=element.find("input");forEach({name:attr.name,"ng-value":attr.ngValue,"ng-model":attr.ngModel,"ng-checked":attr.ngChecked,"ng-disabled":attr.ngDisabled,"ng-true-value":attr.ngTrueValue,"ng-false-value":attr.ngFalseValue,"ng-change":attr.ngChange,"ng-required":attr.ngRequired,required:attr.required},function(value,name){isDefined(value)&&input.attr(name,value)}),element[0].querySelector(".checkbox").classList.add("checkbox-"+$ionicConfig.form.checkbox())}}}]),IonicModule.directive("collectionRepeat",CollectionRepeatDirective).factory("$ionicCollectionManager",RepeatManagerFactory);var ONE_PX_TRANSPARENT_IMG_SRC="data:image/gif;base64,R0lGODlhAQABAIAAAAAAAP///yH5BAEAAAAALAAAAAABAAEAAAIBRAA7",WIDTH_HEIGHT_REGEX=/height:.*?px;\s*width:.*?px/,DEFAULT_RENDER_BUFFER=3;CollectionRepeatDirective.$inject=["$ionicCollectionManager","$parse","$window","$$rAF","$rootScope","$timeout"],RepeatManagerFactory.$inject=["$rootScope","$window","$$rAF"],IonicModule.directive("ionContent",["$timeout","$controller","$ionicBind","$ionicConfig",function($timeout,$controller,$ionicBind,$ionicConfig){return{restrict:"E",require:"^?ionNavView",scope:!0,priority:800,compile:function(element,attr){var innerElement,scrollCtrl;element.addClass("scroll-content ionic-scroll"),"false"!=attr.scroll?((innerElement=jqLite('<div class="scroll"></div>')).append(element.contents()),element.append(innerElement)):element.addClass("scroll-content-false");var nativeScrolling="false"!==attr.overflowScroll&&("true"===attr.overflowScroll||!$ionicConfig.scrolling.jsScrolling());return nativeScrolling&&(nativeScrolling=!element[0].querySelector("[collection-repeat]")),{pre:function($scope,$element,$attr){var parentScope=$scope.$parent;if($scope.$watch(function(){return(parentScope.$hasHeader?" has-header":"")+(parentScope.$hasSubheader?" has-subheader":"")+(parentScope.$hasFooter?" has-footer":"")+(parentScope.$hasSubfooter?" has-subfooter":"")+(parentScope.$hasTabs?" has-tabs":"")+(parentScope.$hasTabsTop?" has-tabs-top":"")},function(className,oldClassName){$element.removeClass(oldClassName),$element.addClass(className)}),$scope.$hasHeader=$scope.$hasSubheader=$scope.$hasFooter=$scope.$hasSubfooter=$scope.$hasTabs=$scope.$hasTabsTop=!1,$ionicBind($scope,$attr,{$onScroll:"&onScroll",$onScrollComplete:"&onScrollComplete",hasBouncing:"@",padding:"@",direction:"@",scrollbarX:"@",scrollbarY:"@",startX:"@",startY:"@",scrollEventInterval:"@"}),$scope.direction=$scope.direction||"y",isDefined($attr.padding)&&$scope.$watch($attr.padding,function(newVal){(innerElement||$element).toggleClass("padding",!!newVal)}),"false"===$attr.scroll);else{var scrollViewOptions={};nativeScrolling?($element.addClass("overflow-scroll"),scrollViewOptions={el:$element[0],delegateHandle:attr.delegateHandle,startX:$scope.$eval($scope.startX)||0,startY:$scope.$eval($scope.startY)||0,nativeScrolling:!0}):scrollViewOptions={el:$element[0],delegateHandle:attr.delegateHandle,locking:"true"===(attr.locking||"true"),bouncing:$scope.$eval($scope.hasBouncing),startX:$scope.$eval($scope.startX)||0,startY:$scope.$eval($scope.startY)||0,scrollbarX:!1!==$scope.$eval($scope.scrollbarX),scrollbarY:!1!==$scope.$eval($scope.scrollbarY),scrollingX:$scope.direction.indexOf("x")>=0,scrollingY:$scope.direction.indexOf("y")>=0,scrollEventInterval:parseInt($scope.scrollEventInterval,10)||10,scrollingComplete:function(){$scope.$onScrollComplete({scrollTop:scrollCtrl.scrollView.__scrollTop,scrollLeft:scrollCtrl.scrollView.__scrollLeft})}},scrollCtrl=$controller("$ionicScroll",{$scope:$scope,scrollViewOptions:scrollViewOptions}),$scope.scrollCtrl=scrollCtrl,$scope.$on("$destroy",function(){scrollViewOptions&&(scrollViewOptions.scrollingComplete=noop,delete scrollViewOptions.el),innerElement=null,$element=null,attr.$$element=null})}}}}}}]),IonicModule.directive("exposeAsideWhen",["$window",function($window){return{restrict:"A",require:"^ionSideMenus",link:function($scope,$element,$attr,sideMenuCtrl){function checkAsideExpose(){var mq="large"==$attr.exposeAsideWhen?"(min-width:768px)":$attr.exposeAsideWhen;sideMenuCtrl.exposeAside($window.matchMedia(mq).matches),sideMenuCtrl.activeAsideResizing(!1)}function onResize(){sideMenuCtrl.activeAsideResizing(!0),debouncedCheck()}var mq="large"==$attr.exposeAsideWhen?"(min-width:768px)":$attr.exposeAsideWhen;$window.matchMedia(mq).addListener(function(){onResize()});var debouncedCheck=ionic.debounce(function(){$scope.$apply(checkAsideExpose)},300,!1);$scope.$evalAsync(checkAsideExpose)}}}]),"onHold onTap onDoubleTap onTouch onRelease onDragStart onDrag onDragEnd onDragUp onDragRight onDragDown onDragLeft onSwipe onSwipeUp onSwipeRight onSwipeDown onSwipeLeft".split(" ").forEach(function(name){IonicModule.directive(name,gestureDirective(name))}),IonicModule.directive("ionHeaderBar",headerFooterBarDirective(!0)).directive("ionFooterBar",headerFooterBarDirective(!1)),IonicModule.directive("ionInfiniteScroll",["$timeout",function($timeout){return{restrict:"E",require:["?^$ionicScroll","ionInfiniteScroll"],template:function($element,$attrs){return $attrs.icon?'<i class="icon {{icon()}} icon-refreshing {{scrollingType}}"></i>':'<ion-spinner icon="{{spinner()}}"></ion-spinner>'},scope:!0,controller:"$ionInfiniteScroll",link:function($scope,$element,$attrs,ctrls){var infiniteScrollCtrl=ctrls[1],scrollCtrl=infiniteScrollCtrl.scrollCtrl=ctrls[0];if(infiniteScrollCtrl.jsScrolling=!scrollCtrl.isNative())infiniteScrollCtrl.scrollView=scrollCtrl.scrollView,$scope.scrollingType="js-scrolling",scrollCtrl.$element.on("scroll",infiniteScrollCtrl.checkBounds);else{var scrollEl=ionic.DomUtil.getParentOrSelfWithClass($element[0].parentNode,"overflow-scroll");if(infiniteScrollCtrl.scrollEl=scrollEl,!scrollEl)throw"Infinite scroll must be used inside a scrollable div";infiniteScrollCtrl.scrollEl.addEventListener("scroll",infiniteScrollCtrl.checkBounds)}(!isDefined($attrs.immediateCheck)||$scope.$eval($attrs.immediateCheck))&&$timeout(function(){infiniteScrollCtrl.checkBounds()})}}}]);var labelIds=-1;IonicModule.directive("ionInput",[function(){return{restrict:"E",controller:["$scope","$element",function($scope,$element){this.$scope=$scope,this.$element=$element,this.setInputAriaLabeledBy=function(id){var inputs=$element[0].querySelectorAll("input,textarea");inputs.length&&inputs[0].setAttribute("aria-labelledby",id)},this.focus=function(){var inputs=$element[0].querySelectorAll("input,textarea");inputs.length&&inputs[0].focus()}}]}}]),IonicModule.directive("ionLabel",[function(){return{restrict:"E",require:"?^ionInput",compile:function(){return function($scope,$element,$attrs,ionInputCtrl){var element=$element[0];$element.addClass("input-label"),$element.attr("aria-label",$element.text());var id=element.id||"_label-"+ ++labelIds;element.id||$element.attr("id",id),ionInputCtrl&&(ionInputCtrl.setInputAriaLabeledBy(id),$element.on("click",function(){ionInputCtrl.focus()}))}}}}]),IonicModule.directive("inputLabel",[function(){return{restrict:"C",require:"?^ionInput",compile:function(){return function($scope,$element,$attrs,ionInputCtrl){var element=$element[0];$element.attr("aria-label",$element.text());var id=element.id||"_label-"+ ++labelIds;element.id||$element.attr("id",id),ionInputCtrl&&ionInputCtrl.setInputAriaLabeledBy(id)}}}}]),IonicModule.directive("ionItem",["$$rAF",function($$rAF){return{restrict:"E",controller:["$scope","$element",function($scope,$element){this.$scope=$scope,this.$element=$element}],scope:!0,compile:function($element,$attrs){var isAnchor=isDefined($attrs.href)||isDefined($attrs.ngHref)||isDefined($attrs.uiSref);if(isAnchor||/ion-(delete|option|reorder)-button/i.test($element.html())){var innerElement=jqLite(isAnchor?"<a></a>":"<div></div>");innerElement.addClass("item-content"),(isDefined($attrs.href)||isDefined($attrs.ngHref))&&(innerElement.attr("ng-href","{{$href()}}"),isDefined($attrs.target)&&innerElement.attr("target","{{$target()}}")),innerElement.append($element.contents()),$element.addClass("item item-complex").append(innerElement)}else $element.addClass("item");return function($scope,$element,$attrs){$scope.$href=function(){return $attrs.href||$attrs.ngHref},$scope.$target=function(){return $attrs.target};var content=$element[0].querySelector(".item-content");content&&$scope.$on("$collectionRepeatLeave",function(){content&&content.$$ionicOptionsOpen&&(content.style[ionic.CSS.TRANSFORM]="",content.style[ionic.CSS.TRANSITION]="none",$$rAF(function(){content.style[ionic.CSS.TRANSITION]=""}),content.$$ionicOptionsOpen=!1)})}}}}]);IonicModule.directive("ionDeleteButton",function(){function stopPropagation(ev){ev.stopPropagation()}return{restrict:"E",require:["^^ionItem","^?ionList"],priority:Number.MAX_VALUE,compile:function($element,$attr){return $attr.$set("class",($attr.class||"")+" button icon button-icon",!0),function($scope,$element,$attr,ctrls){function init(){(listCtrl=listCtrl||$element.controller("ionList"))&&listCtrl.showDelete()&&container.addClass("visible active")}var itemCtrl=ctrls[0],listCtrl=ctrls[1],container=jqLite('<div class="item-left-edit item-delete enable-pointer-events"></div>');container.append($element),itemCtrl.$element.append(container).addClass("item-left-editable"),$element.on("click",stopPropagation),init(),$scope.$on("$ionic.reconnectScope",init)}}}}),IonicModule.directive("itemFloatingLabel",function(){return{restrict:"C",link:function(scope,element){var el=element[0],input=el.querySelector("input, textarea"),inputLabel=el.querySelector(".input-label");if(input&&inputLabel){var onInput=function(){input.value?inputLabel.classList.add("has-input"):inputLabel.classList.remove("has-input")};input.addEventListener("input",onInput);var ngModelCtrl=jqLite(input).controller("ngModel");ngModelCtrl&&(ngModelCtrl.$render=function(){input.value=ngModelCtrl.$viewValue||"",onInput()}),scope.$on("$destroy",function(){input.removeEventListener("input",onInput)})}}}});IonicModule.directive("ionOptionButton",[function(){function stopPropagation(e){e.stopPropagation()}return{restrict:"E",require:"^ionItem",priority:Number.MAX_VALUE,compile:function($element,$attr){return $attr.$set("class",($attr.class||"")+" button",!0),function($scope,$element,$attr,itemCtrl){itemCtrl.optionsContainer||(itemCtrl.optionsContainer=jqLite('<div class="item-options invisible"></div>'),itemCtrl.$element.append(itemCtrl.optionsContainer)),itemCtrl.optionsContainer.append($element),itemCtrl.$element.addClass("item-right-editable"),$element.on("click",stopPropagation)}}}}]);IonicModule.directive("ionReorderButton",["$parse",function($parse){return{restrict:"E",require:["^ionItem","^?ionList"],priority:Number.MAX_VALUE,compile:function($element,$attr){return $attr.$set("class",($attr.class||"")+" button icon button-icon",!0),$element[0].setAttribute("data-prevent-scroll",!0),function($scope,$element,$attr,ctrls){var itemCtrl=ctrls[0],listCtrl=ctrls[1],onReorderFn=$parse($attr.onReorder);$scope.$onReorder=function(oldIndex,newIndex){onReorderFn($scope,{$fromIndex:oldIndex,$toIndex:newIndex})},$attr.ngClick||$attr.onClick||$attr.onclick||($element[0].onclick=function(e){return e.stopPropagation(),!1});var container=jqLite('<div data-prevent-scroll="true" class="item-right-edit item-reorder enable-pointer-events"></div>');container.append($element),itemCtrl.$element.append(container).addClass("item-right-editable"),listCtrl&&listCtrl.showReorder()&&container.addClass("visible active")}}}}]),IonicModule.directive("keyboardAttach",function(){return function(scope,element){function onShow(e){if(!ionic.Platform.isAndroid()||ionic.Platform.isFullScreen){var keyboardHeight=e.keyboardHeight||e.detail&&e.detail.keyboardHeight;element.css("bottom",keyboardHeight+"px"),(scrollCtrl=element.controller("$ionicScroll"))&&(scrollCtrl.scrollView.__container.style.bottom=keyboardHeight+keyboardAttachGetClientHeight(element[0])+"px")}}function onHide(){ionic.Platform.isAndroid()&&!ionic.Platform.isFullScreen||(element.css("bottom",""),scrollCtrl&&(scrollCtrl.scrollView.__container.style.bottom=""))}ionic.on("native.keyboardshow",onShow,window),ionic.on("native.keyboardhide",onHide,window),ionic.on("native.showkeyboard",onShow,window),ionic.on("native.hidekeyboard",onHide,window);var scrollCtrl;scope.$on("$destroy",function(){ionic.off("native.keyboardshow",onShow,window),ionic.off("native.keyboardhide",onHide,window),ionic.off("native.showkeyboard",onShow,window),ionic.off("native.hidekeyboard",onHide,window)})}}),IonicModule.directive("ionList",["$timeout",function($timeout){return{restrict:"E",require:["ionList","^?$ionicScroll"],controller:"$ionicList",compile:function($element,$attr){var listEl=jqLite('<div class="list">').append($element.contents()).addClass($attr.type);return $element.append(listEl),function($scope,$element,$attrs,ctrls){var listCtrl=ctrls[0],scrollCtrl=ctrls[1];$timeout(function(){function setButtonShown(el,shown){shown()&&el.addClass("visible")||el.removeClass("active"),ionic.requestAnimationFrame(function(){shown()&&el.addClass("active")||el.removeClass("visible")})}var listView=listCtrl.listView=new ionic.views.ListView({el:$element[0],listEl:$element.children()[0],scrollEl:scrollCtrl&&scrollCtrl.element,scrollView:scrollCtrl&&scrollCtrl.scrollView,onReorder:function(el,oldIndex,newIndex){var itemScope=jqLite(el).scope();itemScope&&itemScope.$onReorder&&$timeout(function(){itemScope.$onReorder(oldIndex,newIndex)})},canSwipe:function(){return listCtrl.canSwipeItems()}});$scope.$on("$destroy",function(){listView&&(listView.deregister&&listView.deregister(),listView=null)}),isDefined($attr.canSwipe)&&$scope.$watch("!!("+$attr.canSwipe+")",function(value){listCtrl.canSwipeItems(value)}),isDefined($attr.showDelete)&&$scope.$watch("!!("+$attr.showDelete+")",function(value){listCtrl.showDelete(value)}),isDefined($attr.showReorder)&&$scope.$watch("!!("+$attr.showReorder+")",function(value){listCtrl.showReorder(value)}),$scope.$watch(function(){return listCtrl.showDelete()},function(isShown,wasShown){(isShown||wasShown)&&(isShown&&listCtrl.closeOptionButtons(),listCtrl.canSwipeItems(!isShown),$element.children().toggleClass("list-left-editing",isShown),$element.toggleClass("disable-pointer-events",isShown),setButtonShown(jqLite($element[0].getElementsByClassName("item-delete")),listCtrl.showDelete))}),$scope.$watch(function(){return listCtrl.showReorder()},function(isShown,wasShown){(isShown||wasShown)&&(isShown&&listCtrl.closeOptionButtons(),listCtrl.canSwipeItems(!isShown),$element.children().toggleClass("list-right-editing",isShown),$element.toggleClass("disable-pointer-events",isShown),setButtonShown(jqLite($element[0].getElementsByClassName("item-reorder")),listCtrl.showReorder))})})}}}}]),IonicModule.directive("menuClose",["$ionicHistory","$timeout",function($ionicHistory,$timeout){return{restrict:"AC",link:function($scope,$element){$element.bind("click",function(){var sideMenuCtrl=$element.inheritedData("$ionSideMenusController");sideMenuCtrl&&($ionicHistory.nextViewOptions({historyRoot:!0,disableAnimate:!0,expire:300}),$timeout(function(){$ionicHistory.nextViewOptions({historyRoot:!1,disableAnimate:!1})},300),sideMenuCtrl.close())})}}}]),IonicModule.directive("menuToggle",function(){return{restrict:"AC",link:function($scope,$element,$attr){$scope.$on("$ionicView.beforeEnter",function(ev,viewData){viewData.enableBack?$element.inheritedData("$ionSideMenusController").enableMenuWithBackViews()||$element.addClass("hide"):$element.removeClass("hide")}),$element.bind("click",function(){var sideMenuCtrl=$element.inheritedData("$ionSideMenusController");sideMenuCtrl&&sideMenuCtrl.toggle($attr.menuToggle)})}}}),IonicModule.directive("ionModal",[function(){return{restrict:"E",transclude:!0,replace:!0,controller:[function(){}],template:'<div class="modal-backdrop"><div class="modal-backdrop-bg"></div><div class="modal-wrapper" ng-transclude></div></div>'}}]),IonicModule.directive("ionModalView",function(){return{restrict:"E",compile:function(element){element.addClass("modal")}}}),IonicModule.directive("ionNavBackButton",["$ionicConfig","$document",function($ionicConfig,$document){return{restrict:"E",require:"^ionNavBar",compile:function(tElement,tAttrs){function hasIconClass(ele){return/ion-|icon/.test(ele.className)}var buttonEle=$document[0].createElement("button");for(var n in tAttrs.$attr)buttonEle.setAttribute(tAttrs.$attr[n],tAttrs[n]);tAttrs.ngClick||buttonEle.setAttribute("ng-click","$ionicGoBack()"),buttonEle.className="button back-button hide buttons "+(tElement.attr("class")||""),buttonEle.innerHTML=tElement.html()||"";for(var childNode,hasInnerText,hasButtonText,hasPreviousTitle,hasIcon=hasIconClass(tElement[0]),x=0;x<tElement[0].childNodes.length;x++)1===(childNode=tElement[0].childNodes[x]).nodeType?hasIconClass(childNode)?hasIcon=!0:childNode.classList.contains("default-title")?hasButtonText=!0:childNode.classList.contains("previous-title")&&(hasPreviousTitle=!0):hasInnerText||3!==childNode.nodeType||(hasInnerText=!!childNode.nodeValue.trim());var defaultIcon=$ionicConfig.backButton.icon();if(!hasIcon&&defaultIcon&&"none"!==defaultIcon&&(buttonEle.innerHTML='<i class="icon '+defaultIcon+'"></i> '+buttonEle.innerHTML,buttonEle.className+=" button-clear"),!hasInnerText){var buttonTextEle=$document[0].createElement("span");buttonTextEle.className="back-text",!hasButtonText&&$ionicConfig.backButton.text()&&(buttonTextEle.innerHTML+='<span class="default-title">'+$ionicConfig.backButton.text()+"</span>"),!hasPreviousTitle&&$ionicConfig.backButton.previousTitleText()&&(buttonTextEle.innerHTML+='<span class="previous-title"></span>'),buttonEle.appendChild(buttonTextEle)}return tElement.attr("class","hide"),tElement.empty(),{pre:function($scope,$element,$attr,navBarCtrl){navBarCtrl.navElement("backButton",buttonEle.outerHTML),buttonEle=null}}}}}]),IonicModule.directive("ionNavBar",function(){return{restrict:"E",controller:"$ionicNavBar",scope:!0,link:function($scope,$element,$attr,ctrl){ctrl.init()}}}),IonicModule.directive("ionNavButtons",["$document",function($document){return{require:"^ionNavBar",restrict:"E",compile:function(tElement,tAttrs){var side="left";/^primary|secondary|right$/i.test(tAttrs.side||"")&&(side=tAttrs.side.toLowerCase());var spanEle=$document[0].createElement("span");spanEle.className=side+"-buttons",spanEle.innerHTML=tElement.html();var navElementType=side+"Buttons";return tElement.attr("class","hide"),tElement.empty(),{pre:function($scope,$element,$attrs,navBarCtrl){var parentViewCtrl=$element.parent().data("$ionViewController");parentViewCtrl?parentViewCtrl.navElement(navElementType,spanEle.outerHTML):navBarCtrl.navElement(navElementType,spanEle.outerHTML),spanEle=null}}}}}]),IonicModule.directive("navDirection",["$ionicViewSwitcher",function($ionicViewSwitcher){return{restrict:"A",priority:1e3,link:function($scope,$element,$attr){$element.bind("click",function(){$ionicViewSwitcher.nextDirection($attr.navDirection)})}}}]),IonicModule.directive("ionNavTitle",["$document",function($document){return{require:"^ionNavBar",restrict:"E",compile:function(tElement,tAttrs){var spanEle=$document[0].createElement("span");for(var n in tAttrs.$attr)spanEle.setAttribute(tAttrs.$attr[n],tAttrs[n]);return spanEle.classList.add("nav-bar-title"),spanEle.innerHTML=tElement.html(),tElement.attr("class","hide"),tElement.empty(),{pre:function($scope,$element,$attrs,navBarCtrl){var parentViewCtrl=$element.parent().data("$ionViewController");parentViewCtrl?parentViewCtrl.navElement("title",spanEle.outerHTML):navBarCtrl.navElement("title",spanEle.outerHTML),spanEle=null}}}}}]),IonicModule.directive("navTransition",["$ionicViewSwitcher",function($ionicViewSwitcher){return{restrict:"A",priority:1e3,link:function($scope,$element,$attr){$element.bind("click",function(){$ionicViewSwitcher.nextTransition($attr.navTransition)})}}}]),IonicModule.directive("ionNavView",["$state","$ionicConfig",function($state,$ionicConfig){return{restrict:"E",terminal:!0,priority:2e3,transclude:!0,controller:"$ionicNavView",compile:function(tElement,tAttrs,transclude){return tElement.addClass("view-container"),ionic.DomUtil.cachedAttr(tElement,"nav-view-transition",$ionicConfig.views.transition()),function($scope,$element,$attr,navViewCtrl){function updateView(firstTime){var viewLocals=$state.$current&&$state.$current.locals[viewData.name];viewLocals&&(firstTime||viewLocals!==latestLocals)&&(latestLocals=viewLocals,viewData.state=viewLocals.$$state,navViewCtrl.register(viewLocals))}var latestLocals;transclude($scope,function(clone){$element.append(clone)});var viewData=navViewCtrl.init();$scope.$on("$stateChangeSuccess",function(){updateView(!1)}),$scope.$on("$viewContentLoading",function(){updateView(!1)}),updateView(!0)}}}}]),IonicModule.config(["$provide",function($provide){$provide.decorator("ngClickDirective",["$delegate",function($delegate){return $delegate.shift(),$delegate}])}]).factory("$ionicNgClick",["$parse",function($parse){return function(scope,element,clickExpr){var clickHandler=angular.isFunction(clickExpr)?clickExpr:$parse(clickExpr);element.on("click",function(event){scope.$apply(function(){clickHandler(scope,{$event:event})})}),element.onclick=noop}}]).directive("ngClick",["$ionicNgClick",function($ionicNgClick){return function(scope,element,attr){$ionicNgClick(scope,element,attr.ngClick)}}]).directive("ionStopEvent",function(){return{restrict:"A",link:function(scope,element,attr){element.bind(attr.ionStopEvent,eventStopPropagation)}}}),IonicModule.directive("ionPane",function(){return{restrict:"E",link:function(scope,element){element.addClass("pane")}}}),IonicModule.directive("ionPopover",[function(){return{restrict:"E",transclude:!0,replace:!0,controller:[function(){}],template:'<div class="popover-backdrop"><div class="popover-wrapper" ng-transclude></div></div>'}}]),IonicModule.directive("ionPopoverView",function(){return{restrict:"E",compile:function(element){element.append(jqLite('<div class="popover-arrow">')),element.addClass("popover")}}}),IonicModule.directive("ionRadio",function(){return{restrict:"E",replace:!0,require:"?ngModel",transclude:!0,template:'<label class="item item-radio"><input type="radio" name="radio-group"><div class="radio-content"><div class="item-content disable-pointer-events" ng-transclude></div><i class="radio-icon disable-pointer-events icon ion-checkmark"></i></div></label>',compile:function(element,attr){attr.icon&&element.find("i").removeClass("ion-checkmark").addClass(attr.icon);var input=element.find("input");return forEach({name:attr.name,value:attr.value,disabled:attr.disabled,"ng-value":attr.ngValue,"ng-model":attr.ngModel,"ng-disabled":attr.ngDisabled,"ng-change":attr.ngChange,"ng-required":attr.ngRequired,required:attr.required},function(value,name){isDefined(value)&&input.attr(name,value)}),function(scope,element,attr){scope.getValue=function(){return scope.ngValue||attr.value}}}}}),IonicModule.directive("ionRefresher",[function(){return{restrict:"E",replace:!0,require:["?^$ionicScroll","ionRefresher"],controller:"$ionicRefresher",template:'<div class="scroll-refresher invisible" collection-repeat-ignore><div class="ionic-refresher-content" ng-class="{\'ionic-refresher-with-text\': pullingText || refreshingText}"><div class="icon-pulling" ng-class="{\'pulling-rotation-disabled\':disablePullingRotation}"><i class="icon {{pullingIcon}}"></i></div><div class="text-pulling" ng-bind-html="pullingText"></div><div class="icon-refreshing"><ion-spinner ng-if="showSpinner" icon="{{spinner}}"></ion-spinner><i ng-if="showIcon" class="icon {{refreshingIcon}}"></i></div><div class="text-refreshing" ng-bind-html="refreshingText"></div></div></div>',link:function($scope,$element,$attrs,ctrls){var scrollCtrl=ctrls[0],refresherCtrl=ctrls[1];!scrollCtrl||scrollCtrl.isNative()?refresherCtrl.init():($element[0].classList.add("js-scrolling"),scrollCtrl._setRefresher($scope,$element[0],refresherCtrl.getRefresherDomMethods()),$scope.$on("scroll.refreshComplete",function(){$scope.$evalAsync(function(){scrollCtrl.scrollView.finishPullToRefresh()})}))}}}]),IonicModule.directive("ionScroll",["$timeout","$controller","$ionicBind","$ionicConfig",function($timeout,$controller,$ionicBind,$ionicConfig){return{restrict:"E",scope:!0,controller:function(){},compile:function(element,attr){element.addClass("scroll-view ionic-scroll");var innerElement=jqLite('<div class="scroll"></div>');innerElement.append(element.contents()),element.append(innerElement);var nativeScrolling="false"!==attr.overflowScroll&&("true"===attr.overflowScroll||!$ionicConfig.scrolling.jsScrolling());return{pre:function($scope,$element,$attr){$ionicBind($scope,$attr,{direction:"@",paging:"@",$onScroll:"&onScroll",scroll:"@",scrollbarX:"@",scrollbarY:"@",zooming:"@",minZoom:"@",maxZoom:"@"}),$scope.direction=$scope.direction||"y",isDefined($attr.padding)&&$scope.$watch($attr.padding,function(newVal){innerElement.toggleClass("padding",!!newVal)}),!0===$scope.$eval($scope.paging)&&innerElement.addClass("scroll-paging"),$scope.direction||($scope.direction="y");var isPaging=!0===$scope.$eval($scope.paging);nativeScrolling&&$element.addClass("overflow-scroll"),$element.addClass("scroll-"+$scope.direction);var scrollViewOptions={el:$element[0],delegateHandle:$attr.delegateHandle,locking:"true"===($attr.locking||"true"),bouncing:$scope.$eval($attr.hasBouncing),paging:isPaging,scrollbarX:!1!==$scope.$eval($scope.scrollbarX),scrollbarY:!1!==$scope.$eval($scope.scrollbarY),scrollingX:$scope.direction.indexOf("x")>=0,scrollingY:$scope.direction.indexOf("y")>=0,zooming:!0===$scope.$eval($scope.zooming),maxZoom:$scope.$eval($scope.maxZoom)||3,minZoom:$scope.$eval($scope.minZoom)||.5,preventDefault:!0,nativeScrolling:nativeScrolling};isPaging&&(scrollViewOptions.speedMultiplier=.8,scrollViewOptions.bouncing=!1),$controller("$ionicScroll",{$scope:$scope,scrollViewOptions:scrollViewOptions})}}}}}]),IonicModule.directive("ionSideMenu",function(){return{restrict:"E",require:"^ionSideMenus",scope:!0,compile:function(element,attr){return angular.isUndefined(attr.isEnabled)&&attr.$set("isEnabled","true"),angular.isUndefined(attr.width)&&attr.$set("width","275"),element.addClass("menu menu-"+attr.side),function($scope,$element,$attr,sideMenuCtrl){$scope.side=$attr.side||"left";var sideMenu=sideMenuCtrl[$scope.side]=new ionic.views.SideMenu({width:attr.width,el:$element[0],isEnabled:!0});$scope.$watch($attr.width,function(val){var numberVal=+val;numberVal&&numberVal==val&&sideMenu.setWidth(+val)}),$scope.$watch($attr.isEnabled,function(val){sideMenu.setIsEnabled(!!val)})}}}}),IonicModule.directive("ionSideMenuContent",["$timeout","$ionicGesture","$window",function($timeout,$ionicGesture,$window){return{restrict:"EA",require:"^ionSideMenus",scope:!0,compile:function(element,attr){return element.addClass("menu-content pane"),{pre:function($scope,$element,$attr,sideMenuCtrl){function onContentTap(gestureEvt){0!==sideMenuCtrl.getOpenAmount()?(sideMenuCtrl.close(),gestureEvt.gesture.srcEvent.preventDefault(),startCoord=null,primaryScrollAxis=null):startCoord||(startCoord=ionic.tap.pointerCoord(gestureEvt.gesture.srcEvent))}function onDragX(e){sideMenuCtrl.isDraggableTarget(e)&&"x"==getPrimaryScrollAxis(e)&&(sideMenuCtrl._handleDrag(e),e.gesture.srcEvent.preventDefault())}function onDragY(e){"x"==getPrimaryScrollAxis(e)&&e.gesture.srcEvent.preventDefault()}function onDragRelease(e){sideMenuCtrl._endDrag(e),startCoord=null,primaryScrollAxis=null}function getPrimaryScrollAxis(gestureEvt){if(primaryScrollAxis)return primaryScrollAxis;if(gestureEvt&&gestureEvt.gesture){if(startCoord){var endCoord=ionic.tap.pointerCoord(gestureEvt.gesture.srcEvent),xDistance=Math.abs(endCoord.x-startCoord.x),yDistance=Math.abs(endCoord.y-startCoord.y),scrollAxis=xDistance<yDistance?"y":"x";return Math.max(xDistance,yDistance)>30&&(primaryScrollAxis=scrollAxis),scrollAxis}startCoord=ionic.tap.pointerCoord(gestureEvt.gesture.srcEvent)}return"y"}var startCoord=null,primaryScrollAxis=null;isDefined(attr.dragContent)?$scope.$watch(attr.dragContent,function(value){sideMenuCtrl.canDragContent(value)}):sideMenuCtrl.canDragContent(!0),isDefined(attr.edgeDragThreshold)&&$scope.$watch(attr.edgeDragThreshold,function(value){sideMenuCtrl.edgeDragThreshold(value)});var content={element:element[0],onDrag:function(){},endDrag:function(){},setCanScroll:function(canScroll){var c=$element[0].querySelector(".scroll");if(c){var content=angular.element(c.parentElement);if(content){var scrollScope=content.scope();scrollScope.scrollCtrl&&scrollScope.scrollCtrl.freezeScrollShut(!canScroll)}}},getTranslateX:function(){return $scope.sideMenuContentTranslateX||0},setTranslateX:ionic.animationFrameThrottle(function(amount){var xTransform=content.offsetX+amount;$element[0].style[ionic.CSS.TRANSFORM]="translate3d("+xTransform+"px,0,0)",$timeout(function(){$scope.sideMenuContentTranslateX=amount})}),setMarginLeft:ionic.animationFrameThrottle(function(amount){amount?(amount=parseInt(amount,10),$element[0].style[ionic.CSS.TRANSFORM]="translate3d("+amount+"px,0,0)",$element[0].style.width=$window.innerWidth-amount+"px",content.offsetX=amount):($element[0].style[ionic.CSS.TRANSFORM]="translate3d(0,0,0)",$element[0].style.width="",content.offsetX=0)}),setMarginRight:ionic.animationFrameThrottle(function(amount){amount?(amount=parseInt(amount,10),$element[0].style.width=$window.innerWidth-amount+"px",content.offsetX=amount):($element[0].style.width="",content.offsetX=0),$element[0].style[ionic.CSS.TRANSFORM]="translate3d(0,0,0)"}),setMarginLeftAndRight:ionic.animationFrameThrottle(function(amountLeft,amountRight){var amount=(amountLeft=amountLeft&&parseInt(amountLeft,10)||0)+(amountRight=amountRight&&parseInt(amountRight,10)||0);amount>0?($element[0].style[ionic.CSS.TRANSFORM]="translate3d("+amountLeft+"px,0,0)",$element[0].style.width=$window.innerWidth-amount+"px",content.offsetX=amountLeft):($element[0].style[ionic.CSS.TRANSFORM]="translate3d(0,0,0)",$element[0].style.width="",content.offsetX=0)}),enableAnimation:function(){$scope.animationEnabled=!0,$element[0].classList.add("menu-animated")},disableAnimation:function(){$scope.animationEnabled=!1,$element[0].classList.remove("menu-animated")},offsetX:0};sideMenuCtrl.setContent(content);var gestureOpts={stop_browser_behavior:!1};gestureOpts.prevent_default_directions=["left","right"];var contentTapGesture=$ionicGesture.on("tap",onContentTap,$element,gestureOpts),dragRightGesture=$ionicGesture.on("dragright",onDragX,$element,gestureOpts),dragLeftGesture=$ionicGesture.on("dragleft",onDragX,$element,gestureOpts),dragUpGesture=$ionicGesture.on("dragup",onDragY,$element,gestureOpts),dragDownGesture=$ionicGesture.on("dragdown",onDragY,$element,gestureOpts),releaseGesture=$ionicGesture.on("release",onDragRelease,$element,gestureOpts);$scope.$on("$destroy",function(){content&&(content.element=null,content=null),$ionicGesture.off(dragLeftGesture,"dragleft",onDragX),$ionicGesture.off(dragRightGesture,"dragright",onDragX),$ionicGesture.off(dragUpGesture,"dragup",onDragY),$ionicGesture.off(dragDownGesture,"dragdown",onDragY),$ionicGesture.off(releaseGesture,"release",onDragRelease),$ionicGesture.off(contentTapGesture,"tap",onContentTap)})}}}}}]),IonicModule.directive("ionSideMenus",["$ionicBody",function($ionicBody){return{restrict:"ECA",controller:"$ionicSideMenus",compile:function(element,attr){return attr.$set("class",(attr.class||"")+" view"),{pre:function($scope,$element,$attrs,ctrl){ctrl.enableMenuWithBackViews($scope.$eval($attrs.enableMenuWithBackViews)),$scope.$on("$ionicExposeAside",function(evt,isAsideExposed){$scope.$exposeAside||($scope.$exposeAside={}),$scope.$exposeAside.active=isAsideExposed,$ionicBody.enableClass(isAsideExposed,"aside-open")}),$scope.$on("$ionicView.beforeEnter",function(ev,d){d.historyId&&($scope.$activeHistoryId=d.historyId)}),$scope.$on("$destroy",function(){$ionicBody.removeClass("menu-open","aside-open")})}}}}}]),IonicModule.directive("ionSlideBox",["$animate","$timeout","$compile","$ionicSlideBoxDelegate","$ionicHistory","$ionicScrollDelegate",function($animate,$timeout,$compile,$ionicSlideBoxDelegate,$ionicHistory,$ionicScrollDelegate){return{restrict:"E",replace:!0,transclude:!0,scope:{autoPlay:"=",doesContinue:"@",slideInterval:"@",showPager:"@",pagerClick:"&",disableScroll:"@",onSlideChanged:"&",activeSlide:"=?",bounce:"@"},controller:["$scope","$element","$attrs",function($scope,$element,$attrs){function freezeAllScrolls(shouldFreeze){shouldFreeze&&!_this.isScrollFreeze?$ionicScrollDelegate.freezeAllScrolls(shouldFreeze):!shouldFreeze&&_this.isScrollFreeze&&$ionicScrollDelegate.freezeAllScrolls(!1),_this.isScrollFreeze=shouldFreeze}var _this=this,continuous=!0===$scope.$eval($scope.doesContinue),bouncing=!1!==$scope.$eval($scope.bounce),slideInterval=!!isDefined($attrs.autoPlay)&&!!$scope.autoPlay?$scope.$eval($scope.slideInterval)||4e3:0,slider=new ionic.views.Slider({el:$element[0],auto:slideInterval,continuous:continuous,startSlide:$scope.activeSlide,bouncing:bouncing,slidesChanged:function(){$scope.currentSlide=slider.currentIndex(),$timeout(function(){})},callback:function(slideIndex){$scope.currentSlide=slideIndex,$scope.onSlideChanged({index:$scope.currentSlide,$index:$scope.currentSlide}),$scope.$parent.$broadcast("slideBox.slideChanged",slideIndex),$scope.activeSlide=slideIndex,$timeout(function(){})},onDrag:function(){freezeAllScrolls(!0)},onDragEnd:function(){freezeAllScrolls(!1)}});slider.enableSlide(!0!==$scope.$eval($attrs.disableScroll)),$scope.$watch("activeSlide",function(nv){isDefined(nv)&&slider.slide(nv)}),$scope.$on("slideBox.nextSlide",function(){slider.next()}),$scope.$on("slideBox.prevSlide",function(){slider.prev()}),$scope.$on("slideBox.setSlide",function(e,index){slider.slide(index)}),this.__slider=slider;var deregisterInstance=$ionicSlideBoxDelegate._registerInstance(slider,$attrs.delegateHandle,function(){return $ionicHistory.isActiveScope($scope)});$scope.$on("$destroy",function(){deregisterInstance(),slider.kill()}),this.slidesCount=function(){return slider.slidesCount()},this.onPagerClick=function(index){$scope.pagerClick({index:index})},$timeout(function(){slider.load()})}],template:'<div class="slider"><div class="slider-slides" ng-transclude></div></div>',link:function($scope,$element,$attr){function getPager(){if(!pager){var childScope=$scope.$new();pager=jqLite("<ion-pager></ion-pager>"),$element.append(pager),pager=$compile(pager)(childScope)}return pager}$animate.enabled(!1,$element),isDefined($attr.showPager)||($scope.showPager=!0,getPager().toggleClass("hide",!1)),$attr.$observe("showPager",function(show){void 0!==show&&(show=$scope.$eval(show),getPager().toggleClass("hide",!show))});var pager}}}]).directive("ionSlide",function(){return{restrict:"E",require:"?^ionSlideBox",compile:function(element){element.addClass("slider-slide")}}}).directive("ionPager",function(){return{restrict:"E",replace:!0,require:"^ionSlideBox",template:'<div class="slider-pager"><span class="slider-pager-page" ng-repeat="slide in numSlides() track by $index" ng-class="{active: $index == currentSlide}" ng-click="pagerClick($index)"><i class="icon ion-record"></i></span></div>',link:function($scope,$element,$attr,slideBox){var selectPage=function(index){for(var children=$element[0].children,length=children.length,i=0;i<length;i++)i==index?children[i].classList.add("active"):children[i].classList.remove("active")};$scope.pagerClick=function(index){slideBox.onPagerClick(index)},$scope.numSlides=function(){return new Array(slideBox.slidesCount())},$scope.$watch("currentSlide",function(v){selectPage(v)})}}}),IonicModule.directive("ionSlides",["$animate","$timeout","$compile",function($animate,$timeout,$compile){return{restrict:"E",transclude:!0,scope:{options:"=",slider:"="},template:'<div class="swiper-container"><div class="swiper-wrapper" ng-transclude></div><div ng-hide="!showPager" class="swiper-pagination"></div></div>',controller:["$scope","$element",function($scope,$element){var _this=this;this.update=function(){$timeout(function(){_this.__slider&&(_this.__slider.update(),_this._options.loop&&_this.__slider.createLoop(),_this.__slider.slides.length>10&&($scope.showPager=!1))})},this.rapidUpdate=ionic.debounce(function(){_this.update()},50),this.getSlider=function(){return _this.__slider};var options=$scope.options||{},newOptions=angular.extend({pagination:".swiper-pagination",paginationClickable:!0,lazyLoading:!0,preloadImages:!1},options);this._options=newOptions,$timeout(function(){var slider=new ionic.views.Swiper($element.children()[0],newOptions,$scope,$compile);_this.__slider=slider,$scope.slider=_this.__slider,$scope.$on("$destroy",function(){slider.destroy()})})}],link:function($scope){$scope.showPager=!0}}}]).directive("ionSlidePage",[function(){return{restrict:"E",require:"?^ionSlides",transclude:!0,replace:!0,template:'<div class="swiper-slide" ng-transclude></div>',link:function($scope,$element,$attr,ionSlidesCtrl){ionSlidesCtrl.rapidUpdate()}}}]),IonicModule.directive("ionSpinner",function(){return{restrict:"E",controller:"$ionicSpinner",link:function($scope,$element,$attrs,ctrl){var spinnerName=ctrl.init();$element.addClass("spinner spinner-"+spinnerName),$element.on("$destroy",function(){ctrl.stop()})}}}),IonicModule.directive("ionTab",["$compile","$ionicConfig","$ionicBind","$ionicViewSwitcher",function($compile,$ionicConfig,$ionicBind,$ionicViewSwitcher){function attrStr(k,v){return isDefined(v)?" "+k+'="'+v+'"':""}return{restrict:"E",require:["^ionTabs","ionTab"],controller:"$ionicTab",scope:!0,compile:function(element,attr){for(var tabNavTemplate="<ion-tab-nav"+attrStr("ng-click",attr.ngClick)+attrStr("title",attr.title)+attrStr("icon",attr.icon)+attrStr("icon-on",attr.iconOn)+attrStr("icon-off",attr.iconOff)+attrStr("badge",attr.badge)+attrStr("badge-style",attr.badgeStyle)+attrStr("hidden",attr.hidden)+attrStr("disabled",attr.disabled)+attrStr("class",attr.class)+"></ion-tab-nav>",tabContentEle=document.createElement("div"),x=0;x<element[0].children.length;x++)tabContentEle.appendChild(element[0].children[x].cloneNode(!0));var childElementCount=tabContentEle.childElementCount;element.empty();var navViewName,isNavView;return childElementCount&&("ION-NAV-VIEW"===tabContentEle.children[0].tagName&&(navViewName=tabContentEle.children[0].getAttribute("name"),tabContentEle.children[0].classList.add("view-container"),isNavView=!0),1===childElementCount&&(tabContentEle=tabContentEle.children[0]),isNavView||tabContentEle.classList.add("pane"),tabContentEle.classList.add("tab-content")),function($scope,$element,$attr,ctrls){function selectIfMatchesState(){tabCtrl.tabMatchesState()&&tabsCtrl.select($scope,!1)}function destroyTab(){childScope&&childScope.$destroy(),isTabContentAttached&&childElement&&childElement.remove(),tabContentEle.innerHTML="",isTabContentAttached=childScope=childElement=null}var childScope,childElement,tabsCtrl=ctrls[0],tabCtrl=ctrls[1],isTabContentAttached=!1;$scope.$tabSelected=!1,$ionicBind($scope,$attr,{onSelect:"&",onDeselect:"&",title:"@",uiSref:"@",href:"@"}),tabsCtrl.add($scope),$scope.$on("$destroy",function(){$scope.$tabsDestroy||tabsCtrl.remove($scope),tabNavElement.isolateScope().$destroy(),tabNavElement.remove(),tabNavElement=tabContentEle=childElement=null}),$element[0].removeAttribute("title"),navViewName&&(tabCtrl.navViewName=$scope.navViewName=navViewName),$scope.$on("$stateChangeSuccess",selectIfMatchesState),selectIfMatchesState();var tabNavElement=jqLite(tabNavTemplate);tabNavElement.data("$ionTabsController",tabsCtrl),tabNavElement.data("$ionTabController",tabCtrl),tabsCtrl.$tabsElement.append($compile(tabNavElement)($scope)),$scope.$watch("$tabSelected",function(isSelected){isSelected&&childElementCount?(isTabContentAttached||(childScope=$scope.$new(),childElement=jqLite(tabContentEle),$ionicViewSwitcher.viewEleIsActive(childElement,!0),tabsCtrl.$element.append(childElement),$compile(childElement)(childScope),isTabContentAttached=!0),$ionicViewSwitcher.viewEleIsActive(childElement,!0)):isTabContentAttached&&childElement&&($ionicConfig.views.maxCache()>0?$ionicViewSwitcher.viewEleIsActive(childElement,!1):destroyTab())}),$scope.$on("$ionicView.afterEnter",function(){$ionicViewSwitcher.viewEleIsActive(childElement,$scope.$tabSelected)}),$scope.$on("$ionicView.clearCache",function(){$scope.$tabSelected||destroyTab()})}}}}]),IonicModule.directive("ionTabNav",[function(){return{restrict:"E",replace:!0,require:["^ionTabs","^ionTab"],template:"<a ng-class=\"{'tab-item-active': isTabActive(), 'has-badge':badge, 'tab-hidden':isHidden()}\" "+' ng-disabled="disabled()" class="tab-item"><span class="badge {{badgeStyle}}" ng-if="badge">{{badge}}</span><i class="icon {{getIconOn()}}" ng-if="getIconOn() && isTabActive()"></i><i class="icon {{getIconOff()}}" ng-if="getIconOff() && !isTabActive()"></i><span class="tab-title" ng-bind-html="title"></span></a>',scope:{title:"@",icon:"@",iconOn:"@",iconOff:"@",badge:"=",hidden:"@",disabled:"&",badgeStyle:"@",class:"@"},link:function($scope,$element,$attrs,ctrls){var tabsCtrl=ctrls[0],tabCtrl=ctrls[1];$element[0].removeAttribute("title"),$scope.selectTab=function(e){e.preventDefault(),tabsCtrl.select(tabCtrl.$scope,!0)},$attrs.ngClick||$element.on("click",function(event){$scope.$apply(function(){$scope.selectTab(event)})}),$scope.isHidden=function(){return"true"===$attrs.hidden||!0===$attrs.hidden},$scope.getIconOn=function(){return $scope.iconOn||$scope.icon},$scope.getIconOff=function(){return $scope.iconOff||$scope.icon},$scope.isTabActive=function(){return tabsCtrl.selectedTab()===tabCtrl.$scope}}}}]),IonicModule.directive("ionTabs",["$ionicTabsDelegate","$ionicConfig",function($ionicTabsDelegate,$ionicConfig){return{restrict:"E",scope:!0,controller:"$ionicTabs",compile:function(tElement){var innerElement=jqLite('<div class="tab-nav tabs">');return innerElement.append(tElement.contents()),tElement.append(innerElement).addClass("tabs-"+$ionicConfig.tabs.position()+" tabs-"+$ionicConfig.tabs.style()),{pre:function($scope,$element,$attr,tabsCtrl){function emitLifecycleEvent(ev,data){ev.stopPropagation();var previousSelectedTab=tabsCtrl.previousSelectedTab();previousSelectedTab&&previousSelectedTab.$broadcast(ev.name.replace("NavView","Tabs"),data)}var deregisterInstance=$ionicTabsDelegate._registerInstance(tabsCtrl,$attr.delegateHandle,tabsCtrl.hasActiveScope);tabsCtrl.$scope=$scope,tabsCtrl.$element=$element,tabsCtrl.$tabsElement=jqLite($element[0].querySelector(".tabs")),$scope.$watch(function(){return $element[0].className},function(value){var isTabsTop=-1!==value.indexOf("tabs-top"),isHidden=-1!==value.indexOf("tabs-item-hide");$scope.$hasTabs=!isTabsTop&&!isHidden,$scope.$hasTabsTop=isTabsTop&&!isHidden,$scope.$emit("$ionicTabs.top",$scope.$hasTabsTop)}),$scope.$on("$ionicNavView.beforeLeave",emitLifecycleEvent),$scope.$on("$ionicNavView.afterLeave",emitLifecycleEvent),$scope.$on("$ionicNavView.leave",emitLifecycleEvent),$scope.$on("$destroy",function(){$scope.$tabsDestroy=!0,deregisterInstance(),tabsCtrl.$tabsElement=tabsCtrl.$element=tabsCtrl.$scope=innerElement=null,delete $scope.$hasTabs,delete $scope.$hasTabsTop})},post:function($scope,$element,$attr,tabsCtrl){tabsCtrl.selectedTab()||tabsCtrl.select(0)}}}}}]),IonicModule.directive("ionTitle",[function(){return{restrict:"E",compile:function(element){element.addClass("title")}}}]),IonicModule.directive("ionToggle",["$timeout","$ionicConfig",function($timeout,$ionicConfig){return{restrict:"E",replace:!0,require:"?ngModel",transclude:!0,template:'<div class="item item-toggle"><div ng-transclude></div><label class="toggle"><input type="checkbox"><div class="track"><div class="handle"></div></div></label></div>',compile:function(element,attr){var input=element.find("input");return forEach({name:attr.name,"ng-value":attr.ngValue,"ng-model":attr.ngModel,"ng-checked":attr.ngChecked,"ng-disabled":attr.ngDisabled,"ng-true-value":attr.ngTrueValue,"ng-false-value":attr.ngFalseValue,"ng-change":attr.ngChange,"ng-required":attr.ngRequired,required:attr.required},function(value,name){isDefined(value)&&input.attr(name,value)}),attr.toggleClass&&element[0].getElementsByTagName("label")[0].classList.add(attr.toggleClass),element.addClass("toggle-"+$ionicConfig.form.toggle()),function($scope,$element){var el=$element[0].getElementsByTagName("label")[0],checkbox=el.children[0],track=el.children[1],handle=track.children[0],ngModelController=jqLite(checkbox).controller("ngModel");$scope.toggle=new ionic.views.Toggle({el:el,track:track,checkbox:checkbox,handle:handle,onChange:function(){ngModelController&&(ngModelController.$setViewValue(checkbox.checked),$scope.$apply())}}),$scope.$on("$destroy",function(){$scope.toggle.destroy()})}}}}]),IonicModule.directive("ionView",function(){return{restrict:"EA",priority:1e3,controller:"$ionicView",compile:function(tElement){return tElement.addClass("pane"),tElement[0].removeAttribute("title"),function($scope,$element,$attrs,viewCtrl){viewCtrl.init()}}}})}(),function(a,b){var c=b.isDefined,d=b.isUndefined,e=b.isNumber,f=b.isObject,g=b.isArray,h=b.extend,i=b.toJson;b.module("LocalStorageModule",[]).provider("localStorageService",function(){this.prefix="ls",this.storageType="localStorage",this.cookie={expiry:30,path:"/",secure:!1},this.defaultToCookie=!0,this.notify={setItem:!0,removeItem:!1},this.setPrefix=function(a){return this.prefix=a,this},this.setStorageType=function(a){return this.storageType=a,this},this.setDefaultToCookie=function(a){return this.defaultToCookie=!!a,this},this.setStorageCookie=function(a,b,c){return this.cookie.expiry=a,this.cookie.path=b,this.cookie.secure=c,this},this.setStorageCookieDomain=function(a){return this.cookie.domain=a,this},this.setNotify=function(a,b){return this.notify={setItem:a,removeItem:b},this},this.$get=["$rootScope","$window","$document","$parse","$timeout",function(a,b,j,k,l){function m(c){if(c||(c=b.event),r.setItem&&v(c.key)){var d=u(c.key);l(function(){a.$broadcast("LocalStorageModule.notification.changed",{key:d,newvalue:c.newValue,storageType:o.storageType})})}}var n,o=this,p=o.prefix,q=o.cookie,r=o.notify,s=o.storageType;j?j[0]&&(j=j[0]):j=document,"."!==p.substr(-1)&&(p=p?p+".":"");var t=function(a){return p+a},u=function(a){return a.replace(new RegExp("^"+p,"g"),"")},v=function(a){return 0===a.indexOf(p)},w=function(){try{var c=s in b&&null!==b[s],d=t("__"+Math.round(1e7*Math.random()));return c&&((n=b[s]).setItem(d,""),n.removeItem(d)),c}catch(e){return o.defaultToCookie&&(s="cookie"),a.$broadcast("LocalStorageModule.notification.error",e.message),!1}},x=w(),y=function(b,c,e){if(J(e),c=d(c)?null:i(c),!x&&o.defaultToCookie||"cookie"===o.storageType)return x||a.$broadcast("LocalStorageModule.notification.warning","LOCAL_STORAGE_NOT_SUPPORTED"),r.setItem&&a.$broadcast("LocalStorageModule.notification.setitem",{key:b,newvalue:c,storageType:"cookie"}),E(b,c);try{n&&n.setItem(t(b),c),r.setItem&&a.$broadcast("LocalStorageModule.notification.setitem",{key:b,newvalue:c,storageType:o.storageType})}catch(f){return a.$broadcast("LocalStorageModule.notification.error",f.message),E(b,c)}return!0},z=function(b,c){if(J(c),!x&&o.defaultToCookie||"cookie"===o.storageType)return x||a.$broadcast("LocalStorageModule.notification.warning","LOCAL_STORAGE_NOT_SUPPORTED"),F(b);var d=n?n.getItem(t(b)):null;if(!d||"null"===d)return null;try{return JSON.parse(d)}catch(e){return d}},A=function(){var b=0;arguments.length>=1&&("localStorage"===arguments[arguments.length-1]||"sessionStorage"===arguments[arguments.length-1])&&(b=1,J(arguments[arguments.length-1]));var c,d;for(c=0;c<arguments.length-b;c++)if(d=arguments[c],!x&&o.defaultToCookie||"cookie"===o.storageType)x||a.$broadcast("LocalStorageModule.notification.warning","LOCAL_STORAGE_NOT_SUPPORTED"),r.removeItem&&a.$broadcast("LocalStorageModule.notification.removeitem",{key:d,storageType:"cookie"}),G(d);else try{n.removeItem(t(d)),r.removeItem&&a.$broadcast("LocalStorageModule.notification.removeitem",{key:d,storageType:o.storageType})}catch(e){a.$broadcast("LocalStorageModule.notification.error",e.message),G(d)}},D=function(){try{return b.navigator.cookieEnabled||"cookie"in j&&(j.cookie.length>0||(j.cookie="test").indexOf.call(j.cookie,"test")>-1)}catch(c){return a.$broadcast("LocalStorageModule.notification.error",c.message),!1}}(),E=function(b,c,h,k){if(d(c))return!1;if((g(c)||f(c))&&(c=i(c)),!D)return a.$broadcast("LocalStorageModule.notification.error","COOKIES_NOT_SUPPORTED"),!1;try{var l="",m=new Date,n="";if(null===c?(m.setTime(m.getTime()+-864e5),l="; expires="+m.toGMTString(),c=""):e(h)&&0!==h?(m.setTime(m.getTime()+24*h*60*60*1e3),l="; expires="+m.toGMTString()):0!==q.expiry&&(m.setTime(m.getTime()+24*q.expiry*60*60*1e3),l="; expires="+m.toGMTString()),b){var o="; path="+q.path;q.domain&&(n="; domain="+q.domain),"boolean"==typeof k?!0===k&&(n+="; secure"):!0===q.secure&&(n+="; secure"),j.cookie=t(b)+"="+encodeURIComponent(c)+l+o+n}}catch(p){return a.$broadcast("LocalStorageModule.notification.error",p.message),!1}return!0},F=function(b){if(!D)return a.$broadcast("LocalStorageModule.notification.error","COOKIES_NOT_SUPPORTED"),!1;for(var c=j.cookie&&j.cookie.split(";")||[],d=0;d<c.length;d++){for(var e=c[d];" "===e.charAt(0);)e=e.substring(1,e.length);if(0===e.indexOf(t(b)+"=")){var f=decodeURIComponent(e.substring(p.length+b.length+1,e.length));try{return JSON.parse(f)}catch(g){return f}}}return null},G=function(a){E(a,null)},H=function(){for(var a=null,b=p.length,c=j.cookie.split(";"),d=0;d<c.length;d++){for(a=c[d];" "===a.charAt(0);)a=a.substring(1,a.length);var e=a.substring(b,a.indexOf("="));G(e)}},J=function(a){return a&&s!==a&&(s=a,x=w()),x};x&&(b.addEventListener?(b.addEventListener("storage",m,!1),a.$on("$destroy",function(){b.removeEventListener("storage",m)})):b.attachEvent&&(b.attachEvent("onstorage",m),a.$on("$destroy",function(){b.detachEvent("onstorage",m)})));return{isSupported:x,getStorageType:function(){return s},setStorageType:J,set:y,add:y,get:z,keys:function(b){if(J(b),!x)return a.$broadcast("LocalStorageModule.notification.warning","LOCAL_STORAGE_NOT_SUPPORTED"),[];var c=p.length,d=[];for(var e in n)if(e.substr(0,c)===p)try{d.push(e.substr(c))}catch(f){return a.$broadcast("LocalStorageModule.notification.error",f.Description),[]}return d},remove:A,clearAll:function(b,c){J(c);var d=p?new RegExp("^"+p):new RegExp,e=b?new RegExp(b):new RegExp;if(!x&&o.defaultToCookie||"cookie"===o.storageType)return x||a.$broadcast("LocalStorageModule.notification.warning","LOCAL_STORAGE_NOT_SUPPORTED"),H();if(!x&&!o.defaultToCookie)return!1;var f=p.length;for(var g in n)if(d.test(g)&&e.test(g.substr(f)))try{A(g.substr(f))}catch(h){return a.$broadcast("LocalStorageModule.notification.error",h.message),H()}return!0},bind:function(a,b,d,e,g){var i=z(e=e||b,g);return null===i&&c(d)?i=d:f(i)&&f(d)&&(i=h(i,d)),k(b).assign(a,i),a.$watch(b,function(a){y(e,a,g)},f(a[b]))},deriveKey:t,underiveKey:u,length:function(a){J(a);for(var c=0,d=b[s],e=0;e<d.length;e++)0===d.key(e).indexOf(p)&&c++;return c},defaultToCookie:this.defaultToCookie,cookie:{isSupported:D,set:E,add:E,get:F,remove:G,clearAll:H}}}]})}(window,window.angular),function(a,b){"object"==typeof module&&"object"==typeof module.exports?module.exports=a.document?b(a,!0):function(a){if(!a.document)throw new Error("jQuery requires a window with a document");return b(a)}:b(a)}("undefined"!=typeof window?window:this,function(a,b){function s(a){var b=a.length,c=n.type(a);return"function"!==c&&!n.isWindow(a)&&(!(1!==a.nodeType||!b)||("array"===c||0===b||"number"==typeof b&&b>0&&b-1 in a))}function x(a,b,c){if(n.isFunction(b))return n.grep(a,function(a,d){return!!b.call(a,d,a)!==c});if(b.nodeType)return n.grep(a,function(a){return a===b!==c});if("string"==typeof b){if(w.test(b))return n.filter(b,a,c);b=n.filter(b,a)}return n.grep(a,function(a){return g.call(b,a)>=0!==c})}function D(a,b){for(;(a=a[b])&&1!==a.nodeType;);return a}function G(a){var b=F[a]={};return n.each(a.match(E)||[],function(a,c){b[c]=!0}),b}function I(){l.removeEventListener("DOMContentLoaded",I,!1),a.removeEventListener("load",I,!1),n.ready()}function K(){Object.defineProperty(this.cache={},0,{get:function(){return{}}}),this.expando=n.expando+K.uid++}function P(a,b,c){var d;if(void 0===c&&1===a.nodeType)if(d="data-"+b.replace(O,"-$1").toLowerCase(),"string"==typeof(c=a.getAttribute(d))){try{c="true"===c||"false"!==c&&("null"===c?null:+c+""===c?+c:N.test(c)?n.parseJSON(c):c)}catch(e){}M.set(a,b,c)}else c=void 0;return c}function Z(){return!0}function $(){return!1}function _(){try{return l.activeElement}catch(a){}}function jb(a,b){return n.nodeName(a,"table")&&n.nodeName(11!==b.nodeType?b:b.firstChild,"tr")?a.getElementsByTagName("tbody")[0]||a.appendChild(a.ownerDocument.createElement("tbody")):a}function kb(a){return a.type=(null!==a.getAttribute("type"))+"/"+a.type,a}function lb(a){var b=gb.exec(a.type);return b?a.type=b[1]:a.removeAttribute("type"),a}function mb(a,b){for(var c=0,d=a.length;d>c;c++)L.set(a[c],"globalEval",!b||L.get(b[c],"globalEval"))}function nb(a,b){var c,d,e,f,g,h,i,j;if(1===b.nodeType){if(L.hasData(a)&&(f=L.access(a),g=L.set(b,f),j=f.events)){delete g.handle,g.events={};for(e in j)for(c=0,d=j[e].length;d>c;c++)n.event.add(b,e,j[e][c])}M.hasData(a)&&(h=M.access(a),i=n.extend({},h),M.set(b,i))}}function ob(a,b){var c=a.getElementsByTagName?a.getElementsByTagName(b||"*"):a.querySelectorAll?a.querySelectorAll(b||"*"):[];return void 0===b||b&&n.nodeName(a,b)?n.merge([a],c):c}function pb(a,b){var c=b.nodeName.toLowerCase();"input"===c&&T.test(a.type)?b.checked=a.checked:("input"===c||"textarea"===c)&&(b.defaultValue=a.defaultValue)}function sb(b,c){var d,e=n(c.createElement(b)).appendTo(c.body),f=a.getDefaultComputedStyle&&(d=a.getDefaultComputedStyle(e[0]))?d.display:n.css(e[0],"display");return e.detach(),f}function tb(a){var b=l,c=rb[a];return c||("none"!==(c=sb(a,b))&&c||(qb=(qb||n("<iframe frameborder='0' width='0' height='0'/>")).appendTo(b.documentElement),(b=qb[0].contentDocument).write(),b.close(),c=sb(a,b),qb.detach()),rb[a]=c),c}function xb(a,b,c){var d,e,f,g,h=a.style;return(c=c||wb(a))&&(g=c.getPropertyValue(b)||c[b]),c&&(""!==g||n.contains(a.ownerDocument,a)||(g=n.style(a,b)),vb.test(g)&&ub.test(b)&&(d=h.width,e=h.minWidth,f=h.maxWidth,h.minWidth=h.maxWidth=h.width=g,g=c.width,h.width=d,h.minWidth=e,h.maxWidth=f)),void 0!==g?g+"":g}function yb(a,b){return{get:function(){return a()?void delete this.get:(this.get=b).apply(this,arguments)}}}function Fb(a,b){if(b in a)return b;for(var c=b[0].toUpperCase()+b.slice(1),d=b,e=Eb.length;e--;)if((b=Eb[e]+c)in a)return b;return d}function Gb(a,b,c){var d=Ab.exec(b);return d?Math.max(0,d[1]-(c||0))+(d[2]||"px"):b}function Hb(a,b,c,d,e){for(var f=c===(d?"border":"content")?4:"width"===b?1:0,g=0;4>f;f+=2)"margin"===c&&(g+=n.css(a,c+R[f],!0,e)),d?("content"===c&&(g-=n.css(a,"padding"+R[f],!0,e)),"margin"!==c&&(g-=n.css(a,"border"+R[f]+"Width",!0,e))):(g+=n.css(a,"padding"+R[f],!0,e),"padding"!==c&&(g+=n.css(a,"border"+R[f]+"Width",!0,e)));return g}function Ib(a,b,c){var d=!0,e="width"===b?a.offsetWidth:a.offsetHeight,f=wb(a),g="border-box"===n.css(a,"boxSizing",!1,f);if(0>=e||null==e){if((0>(e=xb(a,b,f))||null==e)&&(e=a.style[b]),vb.test(e))return e;d=g&&(k.boxSizingReliable()||e===a.style[b]),e=parseFloat(e)||0}return e+Hb(a,b,c||(g?"border":"content"),d,f)+"px"}function Jb(a,b){for(var c,d,e,f=[],g=0,h=a.length;h>g;g++)(d=a[g]).style&&(f[g]=L.get(d,"olddisplay"),c=d.style.display,b?(f[g]||"none"!==c||(d.style.display=""),""===d.style.display&&S(d)&&(f[g]=L.access(d,"olddisplay",tb(d.nodeName)))):(e=S(d),"none"===c&&e||L.set(d,"olddisplay",e?c:n.css(d,"display"))));for(g=0;h>g;g++)(d=a[g]).style&&(b&&"none"!==d.style.display&&""!==d.style.display||(d.style.display=b?f[g]||"":"none"));return a}function Kb(a,b,c,d,e){return new Kb.prototype.init(a,b,c,d,e)}function Sb(){return setTimeout(function(){Lb=void 0}),Lb=n.now()}function Tb(a,b){var c,d=0,e={height:a};for(b=b?1:0;4>d;d+=2-b)c=R[d],e["margin"+c]=e["padding"+c]=a;return b&&(e.opacity=e.width=a),e}function Ub(a,b,c){for(var d,e=(Rb[b]||[]).concat(Rb["*"]),f=0,g=e.length;g>f;f++)if(d=e[f].call(c,b,a))return d}function Wb(a,b){var c,d,e,f,g;for(c in a)if(d=n.camelCase(c),e=b[d],f=a[c],n.isArray(f)&&(e=f[1],f=a[c]=f[0]),c!==d&&(a[d]=f,delete a[c]),(g=n.cssHooks[d])&&"expand"in g){f=g.expand(f),delete a[d];for(c in f)c in a||(a[c]=f[c],b[c]=e)}else b[d]=e}function Xb(a,b,c){var d,e,f=0,g=Qb.length,h=n.Deferred().always(function(){delete i.elem}),i=function(){if(e)return!1;for(var b=Lb||Sb(),c=Math.max(0,j.startTime+j.duration-b),f=1-(c/j.duration||0),g=0,i=j.tweens.length;i>g;g++)j.tweens[g].run(f);return h.notifyWith(a,[j,f,c]),1>f&&i?c:(h.resolveWith(a,[j]),!1)},j=h.promise({elem:a,props:n.extend({},b),opts:n.extend(!0,{specialEasing:{}},c),originalProperties:b,originalOptions:c,startTime:Lb||Sb(),duration:c.duration,tweens:[],createTween:function(b,c){var d=n.Tween(a,j.opts,b,c,j.opts.specialEasing[b]||j.opts.easing);return j.tweens.push(d),d},stop:function(b){var c=0,d=b?j.tweens.length:0;if(e)return this;for(e=!0;d>c;c++)j.tweens[c].run(1);return b?h.resolveWith(a,[j,b]):h.rejectWith(a,[j,b]),this}}),k=j.props;for(Wb(k,j.opts.specialEasing);g>f;f++)if(d=Qb[f].call(j,a,k,j.opts))return d;return n.map(k,Ub,j),n.isFunction(j.opts.start)&&j.opts.start.call(a,j),n.fx.timer(n.extend(i,{elem:a,anim:j,queue:j.opts.queue})),j.progress(j.opts.progress).done(j.opts.done,j.opts.complete).fail(j.opts.fail).always(j.opts.always)}function qc(a){return function(b,c){"string"!=typeof b&&(c=b,b="*");var d,e=0,f=b.toLowerCase().match(E)||[];if(n.isFunction(c))for(;d=f[e++];)"+"===d[0]?(d=d.slice(1)||"*",(a[d]=a[d]||[]).unshift(c)):(a[d]=a[d]||[]).push(c)}}function rc(a,b,c,d){function g(h){var i;return e[h]=!0,n.each(a[h]||[],function(a,h){var j=h(b,c,d);return"string"!=typeof j||f||e[j]?f?!(i=j):void 0:(b.dataTypes.unshift(j),g(j),!1)}),i}var e={},f=a===mc;return g(b.dataTypes[0])||!e["*"]&&g("*")}function sc(a,b){var c,d,e=n.ajaxSettings.flatOptions||{};for(c in b)void 0!==b[c]&&((e[c]?a:d||(d={}))[c]=b[c]);return d&&n.extend(!0,a,d),a}function tc(a,b,c){for(var d,e,f,g,h=a.contents,i=a.dataTypes;"*"===i[0];)i.shift(),void 0===d&&(d=a.mimeType||b.getResponseHeader("Content-Type"));if(d)for(e in h)if(h[e]&&h[e].test(d)){i.unshift(e);break}if(i[0]in c)f=i[0];else{for(e in c){if(!i[0]||a.converters[e+" "+i[0]]){f=e;break}g||(g=e)}f=f||g}return f?(f!==i[0]&&i.unshift(f),c[f]):void 0}function uc(a,b,c,d){var e,f,g,h,i,j={},k=a.dataTypes.slice();if(k[1])for(g in a.converters)j[g.toLowerCase()]=a.converters[g];for(f=k.shift();f;)if(a.responseFields[f]&&(c[a.responseFields[f]]=b),!i&&d&&a.dataFilter&&(b=a.dataFilter(b,a.dataType)),i=f,f=k.shift())if("*"===f)f=i;else if("*"!==i&&i!==f){if(!(g=j[i+" "+f]||j["* "+f]))for(e in j)if((h=e.split(" "))[1]===f&&(g=j[i+" "+h[0]]||j["* "+h[0]])){!0===g?g=j[e]:!0!==j[e]&&(f=h[0],k.unshift(h[1]));break}if(!0!==g)if(g&&a.throws)b=g(b);else try{b=g(b)}catch(l){return{state:"parsererror",error:g?l:"No conversion from "+i+" to "+f}}}return{state:"success",data:b}}function Ac(a,b,c,d){var e;if(n.isArray(b))n.each(b,function(b,e){c||wc.test(a)?d(a,e):Ac(a+"["+("object"==typeof e?b:"")+"]",e,c,d)});else if(c||"object"!==n.type(b))d(a,b);else for(e in b)Ac(a+"["+e+"]",b[e],c,d)}function Jc(a){return n.isWindow(a)?a:9===a.nodeType&&a.defaultView}var c=[],d=c.slice,e=c.concat,f=c.push,g=c.indexOf,h={},i=h.toString,j=h.hasOwnProperty,k={},l=a.document,m="2.1.3",n=function(a,b){return new n.fn.init(a,b)},o=/^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g,p=/^-ms-/,q=/-([\da-z])/gi,r=function(a,b){return b.toUpperCase()};n.fn=n.prototype={jquery:m,constructor:n,selector:"",length:0,toArray:function(){return d.call(this)},get:function(a){return null!=a?0>a?this[a+this.length]:this[a]:d.call(this)},pushStack:function(a){var b=n.merge(this.constructor(),a);return b.prevObject=this,b.context=this.context,b},each:function(a,b){return n.each(this,a,b)},map:function(a){return this.pushStack(n.map(this,function(b,c){return a.call(b,c,b)}))},slice:function(){return this.pushStack(d.apply(this,arguments))},first:function(){return this.eq(0)},last:function(){return this.eq(-1)},eq:function(a){var b=this.length,c=+a+(0>a?b:0);return this.pushStack(c>=0&&b>c?[this[c]]:[])},end:function(){return this.prevObject||this.constructor(null)},push:f,sort:c.sort,splice:c.splice},n.extend=n.fn.extend=function(){var a,b,c,d,e,f,g=arguments[0]||{},h=1,i=arguments.length,j=!1;for("boolean"==typeof g&&(j=g,g=arguments[h]||{},h++),"object"==typeof g||n.isFunction(g)||(g={}),h===i&&(g=this,h--);i>h;h++)if(null!=(a=arguments[h]))for(b in a)c=g[b],d=a[b],g!==d&&(j&&d&&(n.isPlainObject(d)||(e=n.isArray(d)))?(e?(e=!1,f=c&&n.isArray(c)?c:[]):f=c&&n.isPlainObject(c)?c:{},g[b]=n.extend(j,f,d)):void 0!==d&&(g[b]=d));return g},n.extend({expando:"jQuery"+(m+Math.random()).replace(/\D/g,""),isReady:!0,error:function(a){throw new Error(a)},noop:function(){},isFunction:function(a){return"function"===n.type(a)},isArray:Array.isArray,isWindow:function(a){return null!=a&&a===a.window},isNumeric:function(a){return!n.isArray(a)&&a-parseFloat(a)+1>=0},isPlainObject:function(a){return"object"===n.type(a)&&!a.nodeType&&!n.isWindow(a)&&!(a.constructor&&!j.call(a.constructor.prototype,"isPrototypeOf"))},isEmptyObject:function(a){var b;for(b in a)return!1;return!0},type:function(a){return null==a?a+"":"object"==typeof a||"function"==typeof a?h[i.call(a)]||"object":typeof a},globalEval:function(a){var b,c=eval;(a=n.trim(a))&&(1===a.indexOf("use strict")?(b=l.createElement("script"),b.text=a,l.head.appendChild(b).parentNode.removeChild(b)):c(a))},camelCase:function(a){return a.replace(p,"ms-").replace(q,r)},nodeName:function(a,b){return a.nodeName&&a.nodeName.toLowerCase()===b.toLowerCase()},each:function(a,b,c){var e=0,f=a.length,g=s(a);if(c){if(g)for(;f>e&&!1!==b.apply(a[e],c);e++);else for(e in a)if(!1===b.apply(a[e],c))break}else if(g)for(;f>e&&!1!==b.call(a[e],e,a[e]);e++);else for(e in a)if(!1===b.call(a[e],e,a[e]))break;return a},trim:function(a){return null==a?"":(a+"").replace(o,"")},makeArray:function(a,b){var c=b||[];return null!=a&&(s(Object(a))?n.merge(c,"string"==typeof a?[a]:a):f.call(c,a)),c},inArray:function(a,b,c){return null==b?-1:g.call(b,a,c)},merge:function(a,b){for(var c=+b.length,d=0,e=a.length;c>d;d++)a[e++]=b[d];return a.length=e,a},grep:function(a,b,c){for(var e=[],f=0,g=a.length,h=!c;g>f;f++)!b(a[f],f)!==h&&e.push(a[f]);return e},map:function(a,b,c){var d,f=0,g=a.length,i=[];if(s(a))for(;g>f;f++)null!=(d=b(a[f],f,c))&&i.push(d);else for(f in a)null!=(d=b(a[f],f,c))&&i.push(d);return e.apply([],i)},guid:1,proxy:function(a,b){var c,e,f;return"string"==typeof b&&(c=a[b],b=a,a=c),n.isFunction(a)?(e=d.call(arguments,2),f=function(){return a.apply(b||this,e.concat(d.call(arguments)))},f.guid=a.guid=a.guid||n.guid++,f):void 0},now:Date.now,support:k}),n.each("Boolean Number String Function Array Date RegExp Object Error".split(" "),function(a,b){h["[object "+b+"]"]=b.toLowerCase()});var t=function(a){function gb(a,b,d,e){var f,h,j,k,l,o,r,s,w,x;if((b?b.ownerDocument||b:v)!==n&&m(b),b=b||n,d=d||[],k=b.nodeType,"string"!=typeof a||!a||1!==k&&9!==k&&11!==k)return d;if(!e&&p){if(11!==k&&(f=_.exec(a)))if(j=f[1]){if(9===k){if(!(h=b.getElementById(j))||!h.parentNode)return d;if(h.id===j)return d.push(h),d}else if(b.ownerDocument&&(h=b.ownerDocument.getElementById(j))&&t(b,h)&&h.id===j)return d.push(h),d}else{if(f[2])return H.apply(d,b.getElementsByTagName(a)),d;if((j=f[3])&&c.getElementsByClassName)return H.apply(d,b.getElementsByClassName(j)),d}if(c.qsa&&(!q||!q.test(a))){if(s=r=u,w=b,x=1!==k&&a,1===k&&"object"!==b.nodeName.toLowerCase()){for(o=g(a),(r=b.getAttribute("id"))?s=r.replace(bb,"\\$&"):b.setAttribute("id",s),s="[id='"+s+"'] ",l=o.length;l--;)o[l]=s+rb(o[l]);w=ab.test(a)&&pb(b.parentNode)||b,x=o.join(",")}if(x)try{return H.apply(d,w.querySelectorAll(x)),d}catch(y){}finally{r||b.removeAttribute("id")}}}return i(a.replace(R,"$1"),b,d,e)}function hb(){function b(c,e){return a.push(c+" ")>d.cacheLength&&delete b[a.shift()],b[c+" "]=e}var a=[];return b}function ib(a){return a[u]=!0,a}function jb(a){var b=n.createElement("div");try{return!!a(b)}catch(c){return!1}finally{b.parentNode&&b.parentNode.removeChild(b),b=null}}function kb(a,b){for(var c=a.split("|"),e=a.length;e--;)d.attrHandle[c[e]]=b}function lb(a,b){var c=b&&a,d=c&&1===a.nodeType&&1===b.nodeType&&(~b.sourceIndex||C)-(~a.sourceIndex||C);if(d)return d;if(c)for(;c=c.nextSibling;)if(c===b)return-1;return a?1:-1}function ob(a){return ib(function(b){return b=+b,ib(function(c,d){for(var e,f=a([],c.length,b),g=f.length;g--;)c[e=f[g]]&&(c[e]=!(d[e]=c[e]))})})}function pb(a){return a&&void 0!==a.getElementsByTagName&&a}function qb(){}function rb(a){for(var b=0,c=a.length,d="";c>b;b++)d+=a[b].value;return d}function sb(a,b,c){var d=b.dir,e=c&&"parentNode"===d,f=x++;return b.first?function(b,c,f){for(;b=b[d];)if(1===b.nodeType||e)return a(b,c,f)}:function(b,c,g){var h,i,j=[w,f];if(g){for(;b=b[d];)if((1===b.nodeType||e)&&a(b,c,g))return!0}else for(;b=b[d];)if(1===b.nodeType||e){if(i=b[u]||(b[u]={}),(h=i[d])&&h[0]===w&&h[1]===f)return j[2]=h[2];if(i[d]=j,j[2]=a(b,c,g))return!0}}}function tb(a){return a.length>1?function(b,c,d){for(var e=a.length;e--;)if(!a[e](b,c,d))return!1;return!0}:a[0]}function ub(a,b,c){for(var d=0,e=b.length;e>d;d++)gb(a,b[d],c);return c}function vb(a,b,c,d,e){for(var f,g=[],h=0,i=a.length,j=null!=b;i>h;h++)(f=a[h])&&(!c||c(f,d,e))&&(g.push(f),j&&b.push(h));return g}function wb(a,b,c,d,e,f){return d&&!d[u]&&(d=wb(d)),e&&!e[u]&&(e=wb(e,f)),ib(function(f,g,h,i){var j,k,l,m=[],n=[],o=g.length,p=f||ub(b||"*",h.nodeType?[h]:h,[]),q=!a||!f&&b?p:vb(p,m,a,h,i),r=c?e||(f?a:o||d)?[]:g:q;if(c&&c(q,r,h,i),d)for(j=vb(r,n),d(j,[],h,i),k=j.length;k--;)(l=j[k])&&(r[n[k]]=!(q[n[k]]=l));if(f){if(e||a){if(e){for(j=[],k=r.length;k--;)(l=r[k])&&j.push(q[k]=l);e(null,r=[],j,i)}for(k=r.length;k--;)(l=r[k])&&(j=e?J(f,l):m[k])>-1&&(f[j]=!(g[j]=l))}}else r=vb(r===g?r.splice(o,r.length):r),e?e(null,g,r,i):H.apply(g,r)})}function xb(a){for(var b,c,e,f=a.length,g=d.relative[a[0].type],h=g||d.relative[" "],i=g?1:0,k=sb(function(a){return a===b},h,!0),l=sb(function(a){return J(b,a)>-1},h,!0),m=[function(a,c,d){var e=!g&&(d||c!==j)||((b=c).nodeType?k(a,c,d):l(a,c,d));return b=null,e}];f>i;i++)if(c=d.relative[a[i].type])m=[sb(tb(m),c)];else{if((c=d.filter[a[i].type].apply(null,a[i].matches))[u]){for(e=++i;f>e&&!d.relative[a[e].type];e++);return wb(i>1&&tb(m),i>1&&rb(a.slice(0,i-1).concat({value:" "===a[i-2].type?"*":""})).replace(R,"$1"),c,e>i&&xb(a.slice(i,e)),f>e&&xb(a=a.slice(e)),f>e&&rb(a))}m.push(c)}return tb(m)}function yb(a,b){var c=b.length>0,e=a.length>0,f=function(f,g,h,i,k){var l,m,o,p=0,q="0",r=f&&[],s=[],t=j,u=f||e&&d.find.TAG("*",k),v=w+=null==t?1:Math.random()||.1,x=u.length;for(k&&(j=g!==n&&g);q!==x&&null!=(l=u[q]);q++){if(e&&l){for(m=0;o=a[m++];)if(o(l,g,h)){i.push(l);break}k&&(w=v)}c&&((l=!o&&l)&&p--,f&&r.push(l))}if(p+=q,c&&q!==p){for(m=0;o=b[m++];)o(r,s,g,h);if(f){if(p>0)for(;q--;)r[q]||s[q]||(s[q]=F.call(i));s=vb(s)}H.apply(i,s),k&&!f&&s.length>0&&p+b.length>1&&gb.uniqueSort(i)}return k&&(w=v,j=t),r};return c?ib(f):f}var b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u="sizzle"+1*new Date,v=a.document,w=0,x=0,y=hb(),z=hb(),A=hb(),B=function(a,b){return a===b&&(l=!0),0},C=1<<31,D={}.hasOwnProperty,E=[],F=E.pop,G=E.push,H=E.push,I=E.slice,J=function(a,b){for(var c=0,d=a.length;d>c;c++)if(a[c]===b)return c;return-1},K="checked|selected|async|autofocus|autoplay|controls|defer|disabled|hidden|ismap|loop|multiple|open|readonly|required|scoped",L="[\\x20\\t\\r\\n\\f]",M="(?:\\\\.|[\\w-]|[^\\x00-\\xa0])+",N=M.replace("w","w#"),O="\\["+L+"*("+M+")(?:"+L+"*([*^$|!~]?=)"+L+"*(?:'((?:\\\\.|[^\\\\'])*)'|\"((?:\\\\.|[^\\\\\"])*)\"|("+N+"))|)"+L+"*\\]",P=":("+M+")(?:\\((('((?:\\\\.|[^\\\\'])*)'|\"((?:\\\\.|[^\\\\\"])*)\")|((?:\\\\.|[^\\\\()[\\]]|"+O+")*)|.*)\\)|)",Q=new RegExp(L+"+","g"),R=new RegExp("^"+L+"+|((?:^|[^\\\\])(?:\\\\.)*)"+L+"+$","g"),S=new RegExp("^"+L+"*,"+L+"*"),T=new RegExp("^"+L+"*([>+~]|"+L+")"+L+"*"),U=new RegExp("="+L+"*([^\\]'\"]*?)"+L+"*\\]","g"),V=new RegExp(P),W=new RegExp("^"+N+"$"),X={ID:new RegExp("^#("+M+")"),CLASS:new RegExp("^\\.("+M+")"),TAG:new RegExp("^("+M.replace("w","w*")+")"),ATTR:new RegExp("^"+O),PSEUDO:new RegExp("^"+P),CHILD:new RegExp("^:(only|first|last|nth|nth-last)-(child|of-type)(?:\\("+L+"*(even|odd|(([+-]|)(\\d*)n|)"+L+"*(?:([+-]|)"+L+"*(\\d+)|))"+L+"*\\)|)","i"),bool:new RegExp("^(?:"+K+")$","i"),needsContext:new RegExp("^"+L+"*[>+~]|:(even|odd|eq|gt|lt|nth|first|last)(?:\\("+L+"*((?:-\\d)?\\d*)"+L+"*\\)|)(?=[^-]|$)","i")},Y=/^(?:input|select|textarea|button)$/i,Z=/^h\d$/i,$=/^[^{]+\{\s*\[native \w/,_=/^(?:#([\w-]+)|(\w+)|\.([\w-]+))$/,ab=/[+~]/,bb=/'|\\/g,cb=new RegExp("\\\\([\\da-f]{1,6}"+L+"?|("+L+")|.)","ig"),db=function(a,b,c){var d="0x"+b-65536;return d!==d||c?b:0>d?String.fromCharCode(d+65536):String.fromCharCode(d>>10|55296,1023&d|56320)},eb=function(){m()};try{H.apply(E=I.call(v.childNodes),v.childNodes),E[v.childNodes.length].nodeType}catch(fb){H={apply:E.length?function(a,b){G.apply(a,I.call(b))}:function(a,b){for(var c=a.length,d=0;a[c++]=b[d++];);a.length=c-1}}}c=gb.support={},f=gb.isXML=function(a){var b=a&&(a.ownerDocument||a).documentElement;return!!b&&"HTML"!==b.nodeName},m=gb.setDocument=function(a){var b,e,g=a?a.ownerDocument||a:v;return g!==n&&9===g.nodeType&&g.documentElement?(n=g,o=g.documentElement,(e=g.defaultView)&&e!==e.top&&(e.addEventListener?e.addEventListener("unload",eb,!1):e.attachEvent&&e.attachEvent("onunload",eb)),p=!f(g),c.attributes=jb(function(a){return a.className="i",!a.getAttribute("className")}),c.getElementsByTagName=jb(function(a){return a.appendChild(g.createComment("")),!a.getElementsByTagName("*").length}),c.getElementsByClassName=$.test(g.getElementsByClassName),c.getById=jb(function(a){return o.appendChild(a).id=u,!g.getElementsByName||!g.getElementsByName(u).length}),c.getById?(d.find.ID=function(a,b){if(void 0!==b.getElementById&&p){var c=b.getElementById(a);return c&&c.parentNode?[c]:[]}},d.filter.ID=function(a){var b=a.replace(cb,db);return function(a){return a.getAttribute("id")===b}}):(delete d.find.ID,d.filter.ID=function(a){var b=a.replace(cb,db);return function(a){var c=void 0!==a.getAttributeNode&&a.getAttributeNode("id");return c&&c.value===b}}),d.find.TAG=c.getElementsByTagName?function(a,b){return void 0!==b.getElementsByTagName?b.getElementsByTagName(a):c.qsa?b.querySelectorAll(a):void 0}:function(a,b){var c,d=[],e=0,f=b.getElementsByTagName(a);if("*"===a){for(;c=f[e++];)1===c.nodeType&&d.push(c);return d}return f},d.find.CLASS=c.getElementsByClassName&&function(a,b){return p?b.getElementsByClassName(a):void 0},r=[],q=[],(c.qsa=$.test(g.querySelectorAll))&&(jb(function(a){o.appendChild(a).innerHTML="<a id='"+u+"'></a><select id='"+u+"-\f]' msallowcapture=''><option selected=''></option></select>",a.querySelectorAll("[msallowcapture^='']").length&&q.push("[*^$]="+L+"*(?:''|\"\")"),a.querySelectorAll("[selected]").length||q.push("\\["+L+"*(?:value|"+K+")"),a.querySelectorAll("[id~="+u+"-]").length||q.push("~="),a.querySelectorAll(":checked").length||q.push(":checked"),a.querySelectorAll("a#"+u+"+*").length||q.push(".#.+[+~]")}),jb(function(a){var b=g.createElement("input");b.setAttribute("type","hidden"),a.appendChild(b).setAttribute("name","D"),a.querySelectorAll("[name=d]").length&&q.push("name"+L+"*[*^$|!~]?="),a.querySelectorAll(":enabled").length||q.push(":enabled",":disabled"),a.querySelectorAll("*,:x"),q.push(",.*:")})),(c.matchesSelector=$.test(s=o.matches||o.webkitMatchesSelector||o.mozMatchesSelector||o.oMatchesSelector||o.msMatchesSelector))&&jb(function(a){c.disconnectedMatch=s.call(a,"div"),s.call(a,"[s!='']:x"),r.push("!=",P)}),q=q.length&&new RegExp(q.join("|")),r=r.length&&new RegExp(r.join("|")),b=$.test(o.compareDocumentPosition),t=b||$.test(o.contains)?function(a,b){var c=9===a.nodeType?a.documentElement:a,d=b&&b.parentNode;return a===d||!(!d||1!==d.nodeType||!(c.contains?c.contains(d):a.compareDocumentPosition&&16&a.compareDocumentPosition(d)))}:function(a,b){if(b)for(;b=b.parentNode;)if(b===a)return!0;return!1},B=b?function(a,b){if(a===b)return l=!0,0;var d=!a.compareDocumentPosition-!b.compareDocumentPosition;return d||(1&(d=(a.ownerDocument||a)===(b.ownerDocument||b)?a.compareDocumentPosition(b):1)||!c.sortDetached&&b.compareDocumentPosition(a)===d?a===g||a.ownerDocument===v&&t(v,a)?-1:b===g||b.ownerDocument===v&&t(v,b)?1:k?J(k,a)-J(k,b):0:4&d?-1:1)}:function(a,b){if(a===b)return l=!0,0;var c,d=0,e=a.parentNode,f=b.parentNode,h=[a],i=[b];if(!e||!f)return a===g?-1:b===g?1:e?-1:f?1:k?J(k,a)-J(k,b):0;if(e===f)return lb(a,b);for(c=a;c=c.parentNode;)h.unshift(c);for(c=b;c=c.parentNode;)i.unshift(c);for(;h[d]===i[d];)d++;return d?lb(h[d],i[d]):h[d]===v?-1:i[d]===v?1:0},g):n},gb.matches=function(a,b){return gb(a,null,null,b)},gb.matchesSelector=function(a,b){if((a.ownerDocument||a)!==n&&m(a),b=b.replace(U,"='$1']"),!(!c.matchesSelector||!p||r&&r.test(b)||q&&q.test(b)))try{var d=s.call(a,b);if(d||c.disconnectedMatch||a.document&&11!==a.document.nodeType)return d}catch(e){}return gb(b,n,null,[a]).length>0},gb.contains=function(a,b){return(a.ownerDocument||a)!==n&&m(a),t(a,b)},gb.attr=function(a,b){(a.ownerDocument||a)!==n&&m(a);var e=d.attrHandle[b.toLowerCase()],f=e&&D.call(d.attrHandle,b.toLowerCase())?e(a,b,!p):void 0;return void 0!==f?f:c.attributes||!p?a.getAttribute(b):(f=a.getAttributeNode(b))&&f.specified?f.value:null},gb.error=function(a){throw new Error("Syntax error, unrecognized expression: "+a)},gb.uniqueSort=function(a){var b,d=[],e=0,f=0;if(l=!c.detectDuplicates,k=!c.sortStable&&a.slice(0),a.sort(B),l){for(;b=a[f++];)b===a[f]&&(e=d.push(f));for(;e--;)a.splice(d[e],1)}return k=null,a},e=gb.getText=function(a){var b,c="",d=0,f=a.nodeType;if(f){if(1===f||9===f||11===f){if("string"==typeof a.textContent)return a.textContent;for(a=a.firstChild;a;a=a.nextSibling)c+=e(a)}else if(3===f||4===f)return a.nodeValue}else for(;b=a[d++];)c+=e(b);return c},(d=gb.selectors={cacheLength:50,createPseudo:ib,match:X,attrHandle:{},find:{},relative:{">":{dir:"parentNode",first:!0}," ":{dir:"parentNode"},"+":{dir:"previousSibling",first:!0},"~":{dir:"previousSibling"}},preFilter:{ATTR:function(a){return a[1]=a[1].replace(cb,db),a[3]=(a[3]||a[4]||a[5]||"").replace(cb,db),"~="===a[2]&&(a[3]=" "+a[3]+" "),a.slice(0,4)},CHILD:function(a){return a[1]=a[1].toLowerCase(),"nth"===a[1].slice(0,3)?(a[3]||gb.error(a[0]),a[4]=+(a[4]?a[5]+(a[6]||1):2*("even"===a[3]||"odd"===a[3])),a[5]=+(a[7]+a[8]||"odd"===a[3])):a[3]&&gb.error(a[0]),a},PSEUDO:function(a){var b,c=!a[6]&&a[2];return X.CHILD.test(a[0])?null:(a[3]?a[2]=a[4]||a[5]||"":c&&V.test(c)&&(b=g(c,!0))&&(b=c.indexOf(")",c.length-b)-c.length)&&(a[0]=a[0].slice(0,b),a[2]=c.slice(0,b)),a.slice(0,3))}},filter:{TAG:function(a){var b=a.replace(cb,db).toLowerCase();return"*"===a?function(){return!0}:function(a){return a.nodeName&&a.nodeName.toLowerCase()===b}},CLASS:function(a){var b=y[a+" "];return b||(b=new RegExp("(^|"+L+")"+a+"("+L+"|$)"))&&y(a,function(a){return b.test("string"==typeof a.className&&a.className||void 0!==a.getAttribute&&a.getAttribute("class")||"")})},ATTR:function(a,b,c){return function(d){var e=gb.attr(d,a);return null==e?"!="===b:!b||(e+="","="===b?e===c:"!="===b?e!==c:"^="===b?c&&0===e.indexOf(c):"*="===b?c&&e.indexOf(c)>-1:"$="===b?c&&e.slice(-c.length)===c:"~="===b?(" "+e.replace(Q," ")+" ").indexOf(c)>-1:"|="===b&&(e===c||e.slice(0,c.length+1)===c+"-"))}},CHILD:function(a,b,c,d,e){var f="nth"!==a.slice(0,3),g="last"!==a.slice(-4),h="of-type"===b;return 1===d&&0===e?function(a){return!!a.parentNode}:function(b,c,i){var j,k,l,m,n,o,p=f!==g?"nextSibling":"previousSibling",q=b.parentNode,r=h&&b.nodeName.toLowerCase(),s=!i&&!h;if(q){if(f){for(;p;){for(l=b;l=l[p];)if(h?l.nodeName.toLowerCase()===r:1===l.nodeType)return!1;o=p="only"===a&&!o&&"nextSibling"}return!0}if(o=[g?q.firstChild:q.lastChild],g&&s){for(n=(j=(k=q[u]||(q[u]={}))[a]||[])[0]===w&&j[1],m=j[0]===w&&j[2],l=n&&q.childNodes[n];l=++n&&l&&l[p]||(m=n=0)||o.pop();)if(1===l.nodeType&&++m&&l===b){k[a]=[w,n,m];break}}else if(s&&(j=(b[u]||(b[u]={}))[a])&&j[0]===w)m=j[1];else for(;(l=++n&&l&&l[p]||(m=n=0)||o.pop())&&((h?l.nodeName.toLowerCase()!==r:1!==l.nodeType)||!++m||(s&&((l[u]||(l[u]={}))[a]=[w,m]),l!==b)););return(m-=e)===d||m%d==0&&m/d>=0}}},PSEUDO:function(a,b){var c,e=d.pseudos[a]||d.setFilters[a.toLowerCase()]||gb.error("unsupported pseudo: "+a);return e[u]?e(b):e.length>1?(c=[a,a,"",b],d.setFilters.hasOwnProperty(a.toLowerCase())?ib(function(a,c){for(var d,f=e(a,b),g=f.length;g--;)d=J(a,f[g]),a[d]=!(c[d]=f[g])}):function(a){return e(a,0,c)}):e}},pseudos:{not:ib(function(a){var b=[],c=[],d=h(a.replace(R,"$1"));return d[u]?ib(function(a,b,c,e){for(var f,g=d(a,null,e,[]),h=a.length;h--;)(f=g[h])&&(a[h]=!(b[h]=f))}):function(a,e,f){return b[0]=a,d(b,null,f,c),b[0]=null,!c.pop()}}),has:ib(function(a){return function(b){return gb(a,b).length>0}}),contains:ib(function(a){return a=a.replace(cb,db),function(b){return(b.textContent||b.innerText||e(b)).indexOf(a)>-1}}),lang:ib(function(a){return W.test(a||"")||gb.error("unsupported lang: "+a),a=a.replace(cb,db).toLowerCase(),function(b){var c;do{if(c=p?b.lang:b.getAttribute("xml:lang")||b.getAttribute("lang"))return(c=c.toLowerCase())===a||0===c.indexOf(a+"-")}while((b=b.parentNode)&&1===b.nodeType);return!1}}),target:function(b){var c=a.location&&a.location.hash;return c&&c.slice(1)===b.id},root:function(a){return a===o},focus:function(a){return a===n.activeElement&&(!n.hasFocus||n.hasFocus())&&!!(a.type||a.href||~a.tabIndex)},enabled:function(a){return!1===a.disabled},disabled:function(a){return!0===a.disabled},checked:function(a){var b=a.nodeName.toLowerCase();return"input"===b&&!!a.checked||"option"===b&&!!a.selected},selected:function(a){return a.parentNode&&a.parentNode.selectedIndex,!0===a.selected},empty:function(a){for(a=a.firstChild;a;a=a.nextSibling)if(a.nodeType<6)return!1;return!0},parent:function(a){return!d.pseudos.empty(a)},header:function(a){return Z.test(a.nodeName)},input:function(a){return Y.test(a.nodeName)},button:function(a){var b=a.nodeName.toLowerCase();return"input"===b&&"button"===a.type||"button"===b},text:function(a){var b;return"input"===a.nodeName.toLowerCase()&&"text"===a.type&&(null==(b=a.getAttribute("type"))||"text"===b.toLowerCase())},first:ob(function(){return[0]}),last:ob(function(a,b){return[b-1]}),eq:ob(function(a,b,c){return[0>c?c+b:c]}),even:ob(function(a,b){for(var c=0;b>c;c+=2)a.push(c);return a}),odd:ob(function(a,b){for(var c=1;b>c;c+=2)a.push(c);return a}),lt:ob(function(a,b,c){for(var d=0>c?c+b:c;--d>=0;)a.push(d);return a}),gt:ob(function(a,b,c){for(var d=0>c?c+b:c;++d<b;)a.push(d);return a})}}).pseudos.nth=d.pseudos.eq;for(b in{radio:!0,checkbox:!0,file:!0,password:!0,image:!0})d.pseudos[b]=function(a){return function(b){return"input"===b.nodeName.toLowerCase()&&b.type===a}}(b);for(b in{submit:!0,reset:!0})d.pseudos[b]=function(a){return function(b){var c=b.nodeName.toLowerCase();return("input"===c||"button"===c)&&b.type===a}}(b);return qb.prototype=d.filters=d.pseudos,d.setFilters=new qb,g=gb.tokenize=function(a,b){var c,e,f,g,h,i,j,k=z[a+" "];if(k)return b?0:k.slice(0);for(h=a,i=[],j=d.preFilter;h;){(!c||(e=S.exec(h)))&&(e&&(h=h.slice(e[0].length)||h),i.push(f=[])),c=!1,(e=T.exec(h))&&(c=e.shift(),f.push({value:c,type:e[0].replace(R," ")}),h=h.slice(c.length));for(g in d.filter)!(e=X[g].exec(h))||j[g]&&!(e=j[g](e))||(c=e.shift(),f.push({value:c,type:g,matches:e}),h=h.slice(c.length));if(!c)break}return b?h.length:h?gb.error(a):z(a,i).slice(0)},h=gb.compile=function(a,b){var c,d=[],e=[],f=A[a+" "];if(!f){for(b||(b=g(a)),c=b.length;c--;)(f=xb(b[c]))[u]?d.push(f):e.push(f);(f=A(a,yb(e,d))).selector=a}return f},i=gb.select=function(a,b,e,f){var i,j,k,l,m,n="function"==typeof a&&a,o=!f&&g(a=n.selector||a);if(e=e||[],1===o.length){if((j=o[0]=o[0].slice(0)).length>2&&"ID"===(k=j[0]).type&&c.getById&&9===b.nodeType&&p&&d.relative[j[1].type]){if(!(b=(d.find.ID(k.matches[0].replace(cb,db),b)||[])[0]))return e;n&&(b=b.parentNode),a=a.slice(j.shift().value.length)}for(i=X.needsContext.test(a)?0:j.length;i--&&(k=j[i],!d.relative[l=k.type]);)if((m=d.find[l])&&(f=m(k.matches[0].replace(cb,db),ab.test(j[0].type)&&pb(b.parentNode)||b))){if(j.splice(i,1),!(a=f.length&&rb(j)))return H.apply(e,f),e;break}}return(n||h(a,o))(f,b,!p,e,ab.test(a)&&pb(b.parentNode)||b),e},c.sortStable=u.split("").sort(B).join("")===u,c.detectDuplicates=!!l,m(),c.sortDetached=jb(function(a){return 1&a.compareDocumentPosition(n.createElement("div"))}),jb(function(a){return a.innerHTML="<a href='#'></a>","#"===a.firstChild.getAttribute("href")})||kb("type|href|height|width",function(a,b,c){return c?void 0:a.getAttribute(b,"type"===b.toLowerCase()?1:2)}),c.attributes&&jb(function(a){return a.innerHTML="<input/>",a.firstChild.setAttribute("value",""),""===a.firstChild.getAttribute("value")})||kb("value",function(a,b,c){return c||"input"!==a.nodeName.toLowerCase()?void 0:a.defaultValue}),jb(function(a){return null==a.getAttribute("disabled")})||kb(K,function(a,b,c){var d;return c?void 0:!0===a[b]?b.toLowerCase():(d=a.getAttributeNode(b))&&d.specified?d.value:null}),gb}(a);n.find=t,n.expr=t.selectors,n.expr[":"]=n.expr.pseudos,n.unique=t.uniqueSort,n.text=t.getText,n.isXMLDoc=t.isXML,n.contains=t.contains;var u=n.expr.match.needsContext,v=/^<(\w+)\s*\/?>(?:<\/\1>|)$/,w=/^.[^:#\[\.,]*$/;n.filter=function(a,b,c){var d=b[0];return c&&(a=":not("+a+")"),1===b.length&&1===d.nodeType?n.find.matchesSelector(d,a)?[d]:[]:n.find.matches(a,n.grep(b,function(a){return 1===a.nodeType}))},n.fn.extend({find:function(a){var b,c=this.length,d=[],e=this;if("string"!=typeof a)return this.pushStack(n(a).filter(function(){for(b=0;c>b;b++)if(n.contains(e[b],this))return!0}));for(b=0;c>b;b++)n.find(a,e[b],d);return d=this.pushStack(c>1?n.unique(d):d),d.selector=this.selector?this.selector+" "+a:a,d},filter:function(a){return this.pushStack(x(this,a||[],!1))},not:function(a){return this.pushStack(x(this,a||[],!0))},is:function(a){return!!x(this,"string"==typeof a&&u.test(a)?n(a):a||[],!1).length}});var y,z=/^(?:\s*(<[\w\W]+>)[^>]*|#([\w-]*))$/;(n.fn.init=function(a,b){var c,d;if(!a)return this;if("string"==typeof a){if(!(c="<"===a[0]&&">"===a[a.length-1]&&a.length>=3?[null,a,null]:z.exec(a))||!c[1]&&b)return!b||b.jquery?(b||y).find(a):this.constructor(b).find(a);if(c[1]){if(b=b instanceof n?b[0]:b,n.merge(this,n.parseHTML(c[1],b&&b.nodeType?b.ownerDocument||b:l,!0)),v.test(c[1])&&n.isPlainObject(b))for(c in b)n.isFunction(this[c])?this[c](b[c]):this.attr(c,b[c]);return this}return(d=l.getElementById(c[2]))&&d.parentNode&&(this.length=1,this[0]=d),this.context=l,this.selector=a,this}return a.nodeType?(this.context=this[0]=a,this.length=1,this):n.isFunction(a)?void 0!==y.ready?y.ready(a):a(n):(void 0!==a.selector&&(this.selector=a.selector,this.context=a.context),n.makeArray(a,this))}).prototype=n.fn,y=n(l);var B=/^(?:parents|prev(?:Until|All))/,C={children:!0,contents:!0,next:!0,prev:!0};n.extend({dir:function(a,b,c){for(var d=[],e=void 0!==c;(a=a[b])&&9!==a.nodeType;)if(1===a.nodeType){if(e&&n(a).is(c))break;d.push(a)}return d},sibling:function(a,b){for(var c=[];a;a=a.nextSibling)1===a.nodeType&&a!==b&&c.push(a);return c}}),n.fn.extend({has:function(a){var b=n(a,this),c=b.length;return this.filter(function(){for(var a=0;c>a;a++)if(n.contains(this,b[a]))return!0})},closest:function(a,b){for(var c,d=0,e=this.length,f=[],g=u.test(a)||"string"!=typeof a?n(a,b||this.context):0;e>d;d++)for(c=this[d];c&&c!==b;c=c.parentNode)if(c.nodeType<11&&(g?g.index(c)>-1:1===c.nodeType&&n.find.matchesSelector(c,a))){f.push(c);break}return this.pushStack(f.length>1?n.unique(f):f)},index:function(a){return a?"string"==typeof a?g.call(n(a),this[0]):g.call(this,a.jquery?a[0]:a):this[0]&&this[0].parentNode?this.first().prevAll().length:-1},add:function(a,b){return this.pushStack(n.unique(n.merge(this.get(),n(a,b))))},addBack:function(a){return this.add(null==a?this.prevObject:this.prevObject.filter(a))}}),n.each({parent:function(a){var b=a.parentNode;return b&&11!==b.nodeType?b:null},parents:function(a){return n.dir(a,"parentNode")},parentsUntil:function(a,b,c){return n.dir(a,"parentNode",c)},next:function(a){return D(a,"nextSibling")},prev:function(a){return D(a,"previousSibling")},nextAll:function(a){return n.dir(a,"nextSibling")},prevAll:function(a){return n.dir(a,"previousSibling")},nextUntil:function(a,b,c){return n.dir(a,"nextSibling",c)},prevUntil:function(a,b,c){return n.dir(a,"previousSibling",c)},siblings:function(a){return n.sibling((a.parentNode||{}).firstChild,a)},children:function(a){return n.sibling(a.firstChild)},contents:function(a){return a.contentDocument||n.merge([],a.childNodes)}},function(a,b){n.fn[a]=function(c,d){var e=n.map(this,b,c);return"Until"!==a.slice(-5)&&(d=c),d&&"string"==typeof d&&(e=n.filter(d,e)),this.length>1&&(C[a]||n.unique(e),B.test(a)&&e.reverse()),this.pushStack(e)}});var E=/\S+/g,F={};n.Callbacks=function(a){var b,c,d,e,f,g,h=[],i=!(a="string"==typeof a?F[a]||G(a):n.extend({},a)).once&&[],j=function(l){for(b=a.memory&&l,c=!0,g=e||0,e=0,f=h.length,d=!0;h&&f>g;g++)if(!1===h[g].apply(l[0],l[1])&&a.stopOnFalse){b=!1;break}d=!1,h&&(i?i.length&&j(i.shift()):b?h=[]:k.disable())},k={add:function(){if(h){var c=h.length;!function g(b){n.each(b,function(b,c){var d=n.type(c);"function"===d?a.unique&&k.has(c)||h.push(c):c&&c.length&&"string"!==d&&g(c)})}(arguments),d?f=h.length:b&&(e=c,j(b))}return this},remove:function(){return h&&n.each(arguments,function(a,b){for(var c;(c=n.inArray(b,h,c))>-1;)h.splice(c,1),d&&(f>=c&&f--,g>=c&&g--)}),this},has:function(a){return a?n.inArray(a,h)>-1:!(!h||!h.length)},empty:function(){return h=[],f=0,this},disable:function(){return h=i=b=void 0,this},disabled:function(){return!h},lock:function(){return i=void 0,b||k.disable(),this},locked:function(){return!i},fireWith:function(a,b){return!h||c&&!i||(b=b||[],b=[a,b.slice?b.slice():b],d?i.push(b):j(b)),this},fire:function(){return k.fireWith(this,arguments),this},fired:function(){return!!c}};return k},n.extend({Deferred:function(a){var b=[["resolve","done",n.Callbacks("once memory"),"resolved"],["reject","fail",n.Callbacks("once memory"),"rejected"],["notify","progress",n.Callbacks("memory")]],c="pending",d={state:function(){return c},always:function(){return e.done(arguments).fail(arguments),this},then:function(){var a=arguments;return n.Deferred(function(c){n.each(b,function(b,f){var g=n.isFunction(a[b])&&a[b];e[f[1]](function(){var a=g&&g.apply(this,arguments);a&&n.isFunction(a.promise)?a.promise().done(c.resolve).fail(c.reject).progress(c.notify):c[f[0]+"With"](this===d?c.promise():this,g?[a]:arguments)})}),a=null}).promise()},promise:function(a){return null!=a?n.extend(a,d):d}},e={};return d.pipe=d.then,n.each(b,function(a,f){var g=f[2],h=f[3];d[f[1]]=g.add,h&&g.add(function(){c=h},b[1^a][2].disable,b[2][2].lock),e[f[0]]=function(){return e[f[0]+"With"](this===e?d:this,arguments),this},e[f[0]+"With"]=g.fireWith}),d.promise(e),a&&a.call(e,e),e},when:function(a){var i,j,k,b=0,c=d.call(arguments),e=c.length,f=1!==e||a&&n.isFunction(a.promise)?e:0,g=1===f?a:n.Deferred(),h=function(a,b,c){return function(e){b[a]=this,c[a]=arguments.length>1?d.call(arguments):e,c===i?g.notifyWith(b,c):--f||g.resolveWith(b,c)}};if(e>1)for(i=new Array(e),j=new Array(e),k=new Array(e);e>b;b++)c[b]&&n.isFunction(c[b].promise)?c[b].promise().done(h(b,k,c)).fail(g.reject).progress(h(b,j,i)):--f;return f||g.resolveWith(k,c),g.promise()}});var H;n.fn.ready=function(a){return n.ready.promise().done(a),this},n.extend({isReady:!1,readyWait:1,holdReady:function(a){a?n.readyWait++:n.ready(!0)},ready:function(a){(!0===a?--n.readyWait:n.isReady)||(n.isReady=!0,!0!==a&&--n.readyWait>0||(H.resolveWith(l,[n]),n.fn.triggerHandler&&(n(l).triggerHandler("ready"),n(l).off("ready"))))}}),n.ready.promise=function(b){return H||(H=n.Deferred(),"complete"===l.readyState?setTimeout(n.ready):(l.addEventListener("DOMContentLoaded",I,!1),a.addEventListener("load",I,!1))),H.promise(b)},n.ready.promise();var J=n.access=function(a,b,c,d,e,f,g){var h=0,i=a.length,j=null==c;if("object"===n.type(c)){e=!0;for(h in c)n.access(a,b,h,c[h],!0,f,g)}else if(void 0!==d&&(e=!0,n.isFunction(d)||(g=!0),j&&(g?(b.call(a,d),b=null):(j=b,b=function(a,b,c){return j.call(n(a),c)})),b))for(;i>h;h++)b(a[h],c,g?d:d.call(a[h],h,b(a[h],c)));return e?a:j?b.call(a):i?b(a[0],c):f};n.acceptData=function(a){return 1===a.nodeType||9===a.nodeType||!+a.nodeType},K.uid=1,K.accepts=n.acceptData,K.prototype={key:function(a){if(!K.accepts(a))return 0;var b={},c=a[this.expando];if(!c){c=K.uid++;try{b[this.expando]={value:c},Object.defineProperties(a,b)}catch(d){b[this.expando]=c,n.extend(a,b)}}return this.cache[c]||(this.cache[c]={}),c},set:function(a,b,c){var d,e=this.key(a),f=this.cache[e];if("string"==typeof b)f[b]=c;else if(n.isEmptyObject(f))n.extend(this.cache[e],b);else for(d in b)f[d]=b[d];return f},get:function(a,b){var c=this.cache[this.key(a)];return void 0===b?c:c[b]},access:function(a,b,c){var d;return void 0===b||b&&"string"==typeof b&&void 0===c?void 0!==(d=this.get(a,b))?d:this.get(a,n.camelCase(b)):(this.set(a,b,c),void 0!==c?c:b)},remove:function(a,b){var c,d,e,f=this.key(a),g=this.cache[f];if(void 0===b)this.cache[f]={};else{n.isArray(b)?d=b.concat(b.map(n.camelCase)):(e=n.camelCase(b),b in g?d=[b,e]:(d=e,d=d in g?[d]:d.match(E)||[])),c=d.length;for(;c--;)delete g[d[c]]}},hasData:function(a){return!n.isEmptyObject(this.cache[a[this.expando]]||{})},discard:function(a){a[this.expando]&&delete this.cache[a[this.expando]]}};var L=new K,M=new K,N=/^(?:\{[\w\W]*\}|\[[\w\W]*\])$/,O=/([A-Z])/g;n.extend({hasData:function(a){return M.hasData(a)||L.hasData(a)},data:function(a,b,c){return M.access(a,b,c)},removeData:function(a,b){M.remove(a,b)},_data:function(a,b,c){return L.access(a,b,c)},_removeData:function(a,b){L.remove(a,b)}}),n.fn.extend({data:function(a,b){var c,d,e,f=this[0],g=f&&f.attributes;if(void 0===a){if(this.length&&(e=M.get(f),1===f.nodeType&&!L.get(f,"hasDataAttrs"))){for(c=g.length;c--;)g[c]&&0===(d=g[c].name).indexOf("data-")&&(d=n.camelCase(d.slice(5)),P(f,d,e[d]));L.set(f,"hasDataAttrs",!0)}return e}return"object"==typeof a?this.each(function(){M.set(this,a)}):J(this,function(b){var c,d=n.camelCase(a);if(f&&void 0===b){if(void 0!==(c=M.get(f,a)))return c;if(void 0!==(c=M.get(f,d)))return c;if(void 0!==(c=P(f,d,void 0)))return c}else this.each(function(){var c=M.get(this,d);M.set(this,d,b),-1!==a.indexOf("-")&&void 0!==c&&M.set(this,a,b)})},null,b,arguments.length>1,null,!0)},removeData:function(a){return this.each(function(){M.remove(this,a)})}}),n.extend({queue:function(a,b,c){var d;return a?(b=(b||"fx")+"queue",d=L.get(a,b),c&&(!d||n.isArray(c)?d=L.access(a,b,n.makeArray(c)):d.push(c)),d||[]):void 0},dequeue:function(a,b){b=b||"fx";var c=n.queue(a,b),d=c.length,e=c.shift(),f=n._queueHooks(a,b);"inprogress"===e&&(e=c.shift(),d--),e&&("fx"===b&&c.unshift("inprogress"),delete f.stop,e.call(a,function(){n.dequeue(a,b)},f)),!d&&f&&f.empty.fire()},_queueHooks:function(a,b){var c=b+"queueHooks";return L.get(a,c)||L.access(a,c,{empty:n.Callbacks("once memory").add(function(){L.remove(a,[b+"queue",c])})})}}),n.fn.extend({queue:function(a,b){var c=2;return"string"!=typeof a&&(b=a,a="fx",c--),arguments.length<c?n.queue(this[0],a):void 0===b?this:this.each(function(){var c=n.queue(this,a,b);n._queueHooks(this,a),"fx"===a&&"inprogress"!==c[0]&&n.dequeue(this,a)})},dequeue:function(a){return this.each(function(){n.dequeue(this,a)})},clearQueue:function(a){return this.queue(a||"fx",[])},promise:function(a,b){var c,d=1,e=n.Deferred(),f=this,g=this.length,h=function(){--d||e.resolveWith(f,[f])};for("string"!=typeof a&&(b=a,a=void 0),a=a||"fx";g--;)(c=L.get(f[g],a+"queueHooks"))&&c.empty&&(d++,c.empty.add(h));return h(),e.promise(b)}});var Q=/[+-]?(?:\d*\.|)\d+(?:[eE][+-]?\d+|)/.source,R=["Top","Right","Bottom","Left"],S=function(a,b){return a=b||a,"none"===n.css(a,"display")||!n.contains(a.ownerDocument,a)},T=/^(?:checkbox|radio)$/i;!function(){var b=l.createDocumentFragment().appendChild(l.createElement("div")),c=l.createElement("input");c.setAttribute("type","radio"),c.setAttribute("checked","checked"),c.setAttribute("name","t"),b.appendChild(c),k.checkClone=b.cloneNode(!0).cloneNode(!0).lastChild.checked,b.innerHTML="<textarea>x</textarea>",k.noCloneChecked=!!b.cloneNode(!0).lastChild.defaultValue}();var U="undefined";k.focusinBubbles="onfocusin"in a;var V=/^key/,W=/^(?:mouse|pointer|contextmenu)|click/,X=/^(?:focusinfocus|focusoutblur)$/,Y=/^([^.]*)(?:\.(.+)|)$/;n.event={global:{},add:function(a,b,c,d,e){var f,g,h,i,j,k,l,m,o,p,q,r=L.get(a);if(r)for(c.handler&&(f=c,c=f.handler,e=f.selector),c.guid||(c.guid=n.guid++),(i=r.events)||(i=r.events={}),(g=r.handle)||(g=r.handle=function(b){return typeof n!==U&&n.event.triggered!==b.type?n.event.dispatch.apply(a,arguments):void 0}),j=(b=(b||"").match(E)||[""]).length;j--;)h=Y.exec(b[j])||[],o=q=h[1],p=(h[2]||"").split(".").sort(),o&&(l=n.event.special[o]||{},o=(e?l.delegateType:l.bindType)||o,l=n.event.special[o]||{},k=n.extend({type:o,origType:q,data:d,handler:c,guid:c.guid,selector:e,needsContext:e&&n.expr.match.needsContext.test(e),namespace:p.join(".")},f),(m=i[o])||(m=i[o]=[],m.delegateCount=0,l.setup&&!1!==l.setup.call(a,d,p,g)||a.addEventListener&&a.addEventListener(o,g,!1)),l.add&&(l.add.call(a,k),k.handler.guid||(k.handler.guid=c.guid)),e?m.splice(m.delegateCount++,0,k):m.push(k),n.event.global[o]=!0)},remove:function(a,b,c,d,e){var f,g,h,i,j,k,l,m,o,p,q,r=L.hasData(a)&&L.get(a);if(r&&(i=r.events)){for(j=(b=(b||"").match(E)||[""]).length;j--;)if(h=Y.exec(b[j])||[],o=q=h[1],p=(h[2]||"").split(".").sort(),o){for(l=n.event.special[o]||{},m=i[o=(d?l.delegateType:l.bindType)||o]||[],h=h[2]&&new RegExp("(^|\\.)"+p.join("\\.(?:.*\\.|)")+"(\\.|$)"),g=f=m.length;f--;)k=m[f],!e&&q!==k.origType||c&&c.guid!==k.guid||h&&!h.test(k.namespace)||d&&d!==k.selector&&("**"!==d||!k.selector)||(m.splice(f,1),k.selector&&m.delegateCount--,l.remove&&l.remove.call(a,k));g&&!m.length&&(l.teardown&&!1!==l.teardown.call(a,p,r.handle)||n.removeEvent(a,o,r.handle),delete i[o])}else for(o in i)n.event.remove(a,o+b[j],c,d,!0);n.isEmptyObject(i)&&(delete r.handle,L.remove(a,"events"))}},trigger:function(b,c,d,e){var f,g,h,i,k,m,o,p=[d||l],q=j.call(b,"type")?b.type:b,r=j.call(b,"namespace")?b.namespace.split("."):[];if(g=h=d=d||l,3!==d.nodeType&&8!==d.nodeType&&!X.test(q+n.event.triggered)&&(q.indexOf(".")>=0&&(r=q.split("."),q=r.shift(),r.sort()),k=q.indexOf(":")<0&&"on"+q,b=b[n.expando]?b:new n.Event(q,"object"==typeof b&&b),b.isTrigger=e?2:3,b.namespace=r.join("."),b.namespace_re=b.namespace?new RegExp("(^|\\.)"+r.join("\\.(?:.*\\.|)")+"(\\.|$)"):null,b.result=void 0,b.target||(b.target=d),c=null==c?[b]:n.makeArray(c,[b]),o=n.event.special[q]||{},e||!o.trigger||!1!==o.trigger.apply(d,c))){if(!e&&!o.noBubble&&!n.isWindow(d)){for(i=o.delegateType||q,X.test(i+q)||(g=g.parentNode);g;g=g.parentNode)p.push(g),h=g;h===(d.ownerDocument||l)&&p.push(h.defaultView||h.parentWindow||a)}for(f=0;(g=p[f++])&&!b.isPropagationStopped();)b.type=f>1?i:o.bindType||q,(m=(L.get(g,"events")||{})[b.type]&&L.get(g,"handle"))&&m.apply(g,c),(m=k&&g[k])&&m.apply&&n.acceptData(g)&&(b.result=m.apply(g,c),!1===b.result&&b.preventDefault());return b.type=q,e||b.isDefaultPrevented()||o._default&&!1!==o._default.apply(p.pop(),c)||!n.acceptData(d)||k&&n.isFunction(d[q])&&!n.isWindow(d)&&((h=d[k])&&(d[k]=null),n.event.triggered=q,d[q](),n.event.triggered=void 0,h&&(d[k]=h)),b.result}},dispatch:function(a){a=n.event.fix(a);var b,c,e,f,g,h=[],i=d.call(arguments),j=(L.get(this,"events")||{})[a.type]||[],k=n.event.special[a.type]||{};if(i[0]=a,a.delegateTarget=this,!k.preDispatch||!1!==k.preDispatch.call(this,a)){for(h=n.event.handlers.call(this,a,j),b=0;(f=h[b++])&&!a.isPropagationStopped();)for(a.currentTarget=f.elem,c=0;(g=f.handlers[c++])&&!a.isImmediatePropagationStopped();)(!a.namespace_re||a.namespace_re.test(g.namespace))&&(a.handleObj=g,a.data=g.data,void 0!==(e=((n.event.special[g.origType]||{}).handle||g.handler).apply(f.elem,i))&&!1===(a.result=e)&&(a.preventDefault(),a.stopPropagation()));return k.postDispatch&&k.postDispatch.call(this,a),a.result}},handlers:function(a,b){var c,d,e,f,g=[],h=b.delegateCount,i=a.target;if(h&&i.nodeType&&(!a.button||"click"!==a.type))for(;i!==this;i=i.parentNode||this)if(!0!==i.disabled||"click"!==a.type){for(d=[],c=0;h>c;c++)f=b[c],e=f.selector+" ",void 0===d[e]&&(d[e]=f.needsContext?n(e,this).index(i)>=0:n.find(e,this,null,[i]).length),d[e]&&d.push(f);d.length&&g.push({elem:i,handlers:d})}return h<b.length&&g.push({elem:this,handlers:b.slice(h)}),g},props:"altKey bubbles cancelable ctrlKey currentTarget eventPhase metaKey relatedTarget shiftKey target timeStamp view which".split(" "),fixHooks:{},keyHooks:{props:"char charCode key keyCode".split(" "),filter:function(a,b){return null==a.which&&(a.which=null!=b.charCode?b.charCode:b.keyCode),a}},mouseHooks:{props:"button buttons clientX clientY offsetX offsetY pageX pageY screenX screenY toElement".split(" "),filter:function(a,b){var c,d,e,f=b.button;return null==a.pageX&&null!=b.clientX&&(c=a.target.ownerDocument||l,d=c.documentElement,e=c.body,a.pageX=b.clientX+(d&&d.scrollLeft||e&&e.scrollLeft||0)-(d&&d.clientLeft||e&&e.clientLeft||0),a.pageY=b.clientY+(d&&d.scrollTop||e&&e.scrollTop||0)-(d&&d.clientTop||e&&e.clientTop||0)),a.which||void 0===f||(a.which=1&f?1:2&f?3:4&f?2:0),a}},fix:function(a){if(a[n.expando])return a;var b,c,d,e=a.type,f=a,g=this.fixHooks[e];for(g||(this.fixHooks[e]=g=W.test(e)?this.mouseHooks:V.test(e)?this.keyHooks:{}),d=g.props?this.props.concat(g.props):this.props,a=new n.Event(f),b=d.length;b--;)c=d[b],a[c]=f[c];return a.target||(a.target=l),3===a.target.nodeType&&(a.target=a.target.parentNode),g.filter?g.filter(a,f):a},special:{load:{noBubble:!0},focus:{trigger:function(){return this!==_()&&this.focus?(this.focus(),!1):void 0},delegateType:"focusin"},blur:{trigger:function(){return this===_()&&this.blur?(this.blur(),!1):void 0},delegateType:"focusout"},click:{trigger:function(){return"checkbox"===this.type&&this.click&&n.nodeName(this,"input")?(this.click(),!1):void 0},_default:function(a){return n.nodeName(a.target,"a")}},beforeunload:{postDispatch:function(a){void 0!==a.result&&a.originalEvent&&(a.originalEvent.returnValue=a.result)}}},simulate:function(a,b,c,d){var e=n.extend(new n.Event,c,{type:a,isSimulated:!0,originalEvent:{}});d?n.event.trigger(e,null,b):n.event.dispatch.call(b,e),e.isDefaultPrevented()&&c.preventDefault()}},n.removeEvent=function(a,b,c){a.removeEventListener&&a.removeEventListener(b,c,!1)},n.Event=function(a,b){return this instanceof n.Event?(a&&a.type?(this.originalEvent=a,this.type=a.type,this.isDefaultPrevented=a.defaultPrevented||void 0===a.defaultPrevented&&!1===a.returnValue?Z:$):this.type=a,b&&n.extend(this,b),this.timeStamp=a&&a.timeStamp||n.now(),void(this[n.expando]=!0)):new n.Event(a,b)},n.Event.prototype={isDefaultPrevented:$,isPropagationStopped:$,isImmediatePropagationStopped:$,preventDefault:function(){var a=this.originalEvent;this.isDefaultPrevented=Z,a&&a.preventDefault&&a.preventDefault()},stopPropagation:function(){var a=this.originalEvent;this.isPropagationStopped=Z,a&&a.stopPropagation&&a.stopPropagation()},stopImmediatePropagation:function(){var a=this.originalEvent;this.isImmediatePropagationStopped=Z,a&&a.stopImmediatePropagation&&a.stopImmediatePropagation(),this.stopPropagation()}},n.each({mouseenter:"mouseover",mouseleave:"mouseout",pointerenter:"pointerover",pointerleave:"pointerout"},function(a,b){n.event.special[a]={delegateType:b,bindType:b,handle:function(a){var c,d=this,e=a.relatedTarget,f=a.handleObj;return(!e||e!==d&&!n.contains(d,e))&&(a.type=f.origType,c=f.handler.apply(this,arguments),a.type=b),c}}}),k.focusinBubbles||n.each({focus:"focusin",blur:"focusout"},function(a,b){var c=function(a){n.event.simulate(b,a.target,n.event.fix(a),!0)};n.event.special[b]={setup:function(){var d=this.ownerDocument||this,e=L.access(d,b);e||d.addEventListener(a,c,!0),L.access(d,b,(e||0)+1)},teardown:function(){var d=this.ownerDocument||this,e=L.access(d,b)-1;e?L.access(d,b,e):(d.removeEventListener(a,c,!0),L.remove(d,b))}}}),n.fn.extend({on:function(a,b,c,d,e){var f,g;if("object"==typeof a){"string"!=typeof b&&(c=c||b,b=void 0);for(g in a)this.on(g,b,c,a[g],e);return this}if(null==c&&null==d?(d=b,c=b=void 0):null==d&&("string"==typeof b?(d=c,c=void 0):(d=c,c=b,b=void 0)),!1===d)d=$;else if(!d)return this;return 1===e&&(f=d,d=function(a){return n().off(a),f.apply(this,arguments)},d.guid=f.guid||(f.guid=n.guid++)),this.each(function(){n.event.add(this,a,d,c,b)})},one:function(a,b,c,d){return this.on(a,b,c,d,1)},off:function(a,b,c){var d,e;if(a&&a.preventDefault&&a.handleObj)return d=a.handleObj,n(a.delegateTarget).off(d.namespace?d.origType+"."+d.namespace:d.origType,d.selector,d.handler),this;if("object"==typeof a){for(e in a)this.off(e,b,a[e]);return this}return(!1===b||"function"==typeof b)&&(c=b,b=void 0),!1===c&&(c=$),this.each(function(){n.event.remove(this,a,c,b)})},trigger:function(a,b){return this.each(function(){n.event.trigger(a,b,this)})},triggerHandler:function(a,b){var c=this[0];return c?n.event.trigger(a,b,c,!0):void 0}});var ab=/<(?!area|br|col|embed|hr|img|input|link|meta|param)(([\w:]+)[^>]*)\/>/gi,bb=/<([\w:]+)/,cb=/<|&#?\w+;/,db=/<(?:script|style|link)/i,eb=/checked\s*(?:[^=]|=\s*.checked.)/i,fb=/^$|\/(?:java|ecma)script/i,gb=/^true\/(.*)/,hb=/^\s*<!(?:\[CDATA\[|--)|(?:\]\]|--)>\s*$/g,ib={option:[1,"<select multiple='multiple'>","</select>"],thead:[1,"<table>","</table>"],col:[2,"<table><colgroup>","</colgroup></table>"],tr:[2,"<table><tbody>","</tbody></table>"],td:[3,"<table><tbody><tr>","</tr></tbody></table>"],_default:[0,"",""]};ib.optgroup=ib.option,ib.tbody=ib.tfoot=ib.colgroup=ib.caption=ib.thead,ib.th=ib.td,n.extend({clone:function(a,b,c){var d,e,f,g,h=a.cloneNode(!0),i=n.contains(a.ownerDocument,a);if(!(k.noCloneChecked||1!==a.nodeType&&11!==a.nodeType||n.isXMLDoc(a)))for(g=ob(h),f=ob(a),d=0,e=f.length;e>d;d++)pb(f[d],g[d]);if(b)if(c)for(f=f||ob(a),g=g||ob(h),d=0,e=f.length;e>d;d++)nb(f[d],g[d]);else nb(a,h);return(g=ob(h,"script")).length>0&&mb(g,!i&&ob(a,"script")),h},buildFragment:function(a,b,c,d){for(var e,f,g,h,i,j,k=b.createDocumentFragment(),l=[],m=0,o=a.length;o>m;m++)if((e=a[m])||0===e)if("object"===n.type(e))n.merge(l,e.nodeType?[e]:e);else if(cb.test(e)){for(f=f||k.appendChild(b.createElement("div")),g=(bb.exec(e)||["",""])[1].toLowerCase(),h=ib[g]||ib._default,f.innerHTML=h[1]+e.replace(ab,"<$1></$2>")+h[2],j=h[0];j--;)f=f.lastChild;n.merge(l,f.childNodes),(f=k.firstChild).textContent=""}else l.push(b.createTextNode(e));for(k.textContent="",m=0;e=l[m++];)if((!d||-1===n.inArray(e,d))&&(i=n.contains(e.ownerDocument,e),f=ob(k.appendChild(e),"script"),i&&mb(f),c))for(j=0;e=f[j++];)fb.test(e.type||"")&&c.push(e);return k},cleanData:function(a){for(var b,c,d,e,f=n.event.special,g=0;void 0!==(c=a[g]);g++){if(n.acceptData(c)&&(e=c[L.expando])&&(b=L.cache[e])){if(b.events)for(d in b.events)f[d]?n.event.remove(c,d):n.removeEvent(c,d,b.handle);L.cache[e]&&delete L.cache[e]}delete M.cache[c[M.expando]]}}}),n.fn.extend({text:function(a){return J(this,function(a){return void 0===a?n.text(this):this.empty().each(function(){(1===this.nodeType||11===this.nodeType||9===this.nodeType)&&(this.textContent=a)})},null,a,arguments.length)},append:function(){return this.domManip(arguments,function(a){1!==this.nodeType&&11!==this.nodeType&&9!==this.nodeType||jb(this,a).appendChild(a)})},prepend:function(){return this.domManip(arguments,function(a){if(1===this.nodeType||11===this.nodeType||9===this.nodeType){var b=jb(this,a);b.insertBefore(a,b.firstChild)}})},before:function(){return this.domManip(arguments,function(a){this.parentNode&&this.parentNode.insertBefore(a,this)})},after:function(){return this.domManip(arguments,function(a){this.parentNode&&this.parentNode.insertBefore(a,this.nextSibling)})},remove:function(a,b){for(var c,d=a?n.filter(a,this):this,e=0;null!=(c=d[e]);e++)b||1!==c.nodeType||n.cleanData(ob(c)),c.parentNode&&(b&&n.contains(c.ownerDocument,c)&&mb(ob(c,"script")),c.parentNode.removeChild(c));return this},empty:function(){for(var a,b=0;null!=(a=this[b]);b++)1===a.nodeType&&(n.cleanData(ob(a,!1)),a.textContent="");return this},clone:function(a,b){return a=null!=a&&a,b=null==b?a:b,this.map(function(){return n.clone(this,a,b)})},html:function(a){return J(this,function(a){var b=this[0]||{},c=0,d=this.length;if(void 0===a&&1===b.nodeType)return b.innerHTML;if("string"==typeof a&&!db.test(a)&&!ib[(bb.exec(a)||["",""])[1].toLowerCase()]){a=a.replace(ab,"<$1></$2>");try{for(;d>c;c++)1===(b=this[c]||{}).nodeType&&(n.cleanData(ob(b,!1)),b.innerHTML=a);b=0}catch(e){}}b&&this.empty().append(a)},null,a,arguments.length)},replaceWith:function(){var a=arguments[0];return this.domManip(arguments,function(b){a=this.parentNode,n.cleanData(ob(this)),a&&a.replaceChild(b,this)}),a&&(a.length||a.nodeType)?this:this.remove()},detach:function(a){return this.remove(a,!0)},domManip:function(a,b){a=e.apply([],a);var c,d,f,g,h,i,j=0,l=this.length,m=this,o=l-1,p=a[0],q=n.isFunction(p);if(q||l>1&&"string"==typeof p&&!k.checkClone&&eb.test(p))return this.each(function(c){var d=m.eq(c);q&&(a[0]=p.call(this,c,d.html())),d.domManip(a,b)});if(l&&(c=n.buildFragment(a,this[0].ownerDocument,!1,this),d=c.firstChild,1===c.childNodes.length&&(c=d),d)){for(g=(f=n.map(ob(c,"script"),kb)).length;l>j;j++)h=c,j!==o&&(h=n.clone(h,!0,!0),g&&n.merge(f,ob(h,"script"))),b.call(this[j],h,j);if(g)for(i=f[f.length-1].ownerDocument,n.map(f,lb),j=0;g>j;j++)h=f[j],fb.test(h.type||"")&&!L.access(h,"globalEval")&&n.contains(i,h)&&(h.src?n._evalUrl&&n._evalUrl(h.src):n.globalEval(h.textContent.replace(hb,"")))}return this}}),n.each({appendTo:"append",prependTo:"prepend",insertBefore:"before",insertAfter:"after",replaceAll:"replaceWith"},function(a,b){n.fn[a]=function(a){for(var c,d=[],e=n(a),g=e.length-1,h=0;g>=h;h++)c=h===g?this:this.clone(!0),n(e[h])[b](c),f.apply(d,c.get());return this.pushStack(d)}});var qb,rb={},ub=/^margin/,vb=new RegExp("^("+Q+")(?!px)[a-z%]+$","i"),wb=function(b){return b.ownerDocument.defaultView.opener?b.ownerDocument.defaultView.getComputedStyle(b,null):a.getComputedStyle(b,null)};!function(){function g(){f.style.cssText="-webkit-box-sizing:border-box;-moz-box-sizing:border-box;box-sizing:border-box;display:block;margin-top:1%;top:1%;border:1px;padding:1px;width:4px;position:absolute",f.innerHTML="",d.appendChild(e);var g=a.getComputedStyle(f,null);b="1%"!==g.top,c="4px"===g.width,d.removeChild(e)}var b,c,d=l.documentElement,e=l.createElement("div"),f=l.createElement("div");f.style&&(f.style.backgroundClip="content-box",f.cloneNode(!0).style.backgroundClip="",k.clearCloneStyle="content-box"===f.style.backgroundClip,e.style.cssText="border:0;width:0;height:0;top:0;left:-9999px;margin-top:1px;position:absolute",e.appendChild(f),a.getComputedStyle&&n.extend(k,{pixelPosition:function(){return g(),b},boxSizingReliable:function(){return null==c&&g(),c},reliableMarginRight:function(){var b,c=f.appendChild(l.createElement("div"));return c.style.cssText=f.style.cssText="-webkit-box-sizing:content-box;-moz-box-sizing:content-box;box-sizing:content-box;display:block;margin:0;border:0;padding:0",c.style.marginRight=c.style.width="0",f.style.width="1px",d.appendChild(e),b=!parseFloat(a.getComputedStyle(c,null).marginRight),d.removeChild(e),f.removeChild(c),b}}))}(),n.swap=function(a,b,c,d){var e,f,g={};for(f in b)g[f]=a.style[f],a.style[f]=b[f];e=c.apply(a,d||[]);for(f in b)a.style[f]=g[f];return e};var zb=/^(none|table(?!-c[ea]).+)/,Ab=new RegExp("^("+Q+")(.*)$","i"),Bb=new RegExp("^([+-])=("+Q+")","i"),Cb={position:"absolute",visibility:"hidden",display:"block"},Db={letterSpacing:"0",fontWeight:"400"},Eb=["Webkit","O","Moz","ms"];n.extend({cssHooks:{opacity:{get:function(a,b){if(b){var c=xb(a,"opacity");return""===c?"1":c}}}},cssNumber:{columnCount:!0,fillOpacity:!0,flexGrow:!0,flexShrink:!0,fontWeight:!0,lineHeight:!0,opacity:!0,order:!0,orphans:!0,widows:!0,zIndex:!0,zoom:!0},cssProps:{float:"cssFloat"},style:function(a,b,c,d){if(a&&3!==a.nodeType&&8!==a.nodeType&&a.style){var e,f,g,h=n.camelCase(b),i=a.style;return b=n.cssProps[h]||(n.cssProps[h]=Fb(i,h)),g=n.cssHooks[b]||n.cssHooks[h],void 0===c?g&&"get"in g&&void 0!==(e=g.get(a,!1,d))?e:i[b]:("string"===(f=typeof c)&&(e=Bb.exec(c))&&(c=(e[1]+1)*e[2]+parseFloat(n.css(a,b)),f="number"),void(null!=c&&c===c&&("number"!==f||n.cssNumber[h]||(c+="px"),k.clearCloneStyle||""!==c||0!==b.indexOf("background")||(i[b]="inherit"),g&&"set"in g&&void 0===(c=g.set(a,c,d))||(i[b]=c))))}},css:function(a,b,c,d){var e,f,g,h=n.camelCase(b);return b=n.cssProps[h]||(n.cssProps[h]=Fb(a.style,h)),(g=n.cssHooks[b]||n.cssHooks[h])&&"get"in g&&(e=g.get(a,!0,c)),void 0===e&&(e=xb(a,b,d)),"normal"===e&&b in Db&&(e=Db[b]),""===c||c?(f=parseFloat(e),!0===c||n.isNumeric(f)?f||0:e):e}}),n.each(["height","width"],function(a,b){n.cssHooks[b]={get:function(a,c,d){return c?zb.test(n.css(a,"display"))&&0===a.offsetWidth?n.swap(a,Cb,function(){return Ib(a,b,d)}):Ib(a,b,d):void 0},set:function(a,c,d){var e=d&&wb(a);return Gb(0,c,d?Hb(a,b,d,"border-box"===n.css(a,"boxSizing",!1,e),e):0)}}}),n.cssHooks.marginRight=yb(k.reliableMarginRight,function(a,b){return b?n.swap(a,{display:"inline-block"},xb,[a,"marginRight"]):void 0}),n.each({margin:"",padding:"",border:"Width"},function(a,b){n.cssHooks[a+b]={expand:function(c){for(var d=0,e={},f="string"==typeof c?c.split(" "):[c];4>d;d++)e[a+R[d]+b]=f[d]||f[d-2]||f[0];return e}},ub.test(a)||(n.cssHooks[a+b].set=Gb)}),n.fn.extend({css:function(a,b){return J(this,function(a,b,c){var d,e,f={},g=0;if(n.isArray(b)){for(d=wb(a),e=b.length;e>g;g++)f[b[g]]=n.css(a,b[g],!1,d);return f}return void 0!==c?n.style(a,b,c):n.css(a,b)},a,b,arguments.length>1)},show:function(){return Jb(this,!0)},hide:function(){return Jb(this)},toggle:function(a){return"boolean"==typeof a?a?this.show():this.hide():this.each(function(){S(this)?n(this).show():n(this).hide()})}}),n.Tween=Kb,Kb.prototype={constructor:Kb,init:function(a,b,c,d,e,f){this.elem=a,this.prop=c,this.easing=e||"swing",this.options=b,this.start=this.now=this.cur(),this.end=d,this.unit=f||(n.cssNumber[c]?"":"px")},cur:function(){var a=Kb.propHooks[this.prop];return a&&a.get?a.get(this):Kb.propHooks._default.get(this)},run:function(a){var b,c=Kb.propHooks[this.prop];return this.pos=b=this.options.duration?n.easing[this.easing](a,this.options.duration*a,0,1,this.options.duration):a,this.now=(this.end-this.start)*b+this.start,this.options.step&&this.options.step.call(this.elem,this.now,this),c&&c.set?c.set(this):Kb.propHooks._default.set(this),this}},Kb.prototype.init.prototype=Kb.prototype,Kb.propHooks={_default:{get:function(a){var b;return null==a.elem[a.prop]||a.elem.style&&null!=a.elem.style[a.prop]?(b=n.css(a.elem,a.prop,""))&&"auto"!==b?b:0:a.elem[a.prop]},set:function(a){n.fx.step[a.prop]?n.fx.step[a.prop](a):a.elem.style&&(null!=a.elem.style[n.cssProps[a.prop]]||n.cssHooks[a.prop])?n.style(a.elem,a.prop,a.now+a.unit):a.elem[a.prop]=a.now}}},Kb.propHooks.scrollTop=Kb.propHooks.scrollLeft={set:function(a){a.elem.nodeType&&a.elem.parentNode&&(a.elem[a.prop]=a.now)}},n.easing={linear:function(a){return a},swing:function(a){return.5-Math.cos(a*Math.PI)/2}},n.fx=Kb.prototype.init,n.fx.step={};var Lb,Mb,Nb=/^(?:toggle|show|hide)$/,Ob=new RegExp("^(?:([+-])=|)("+Q+")([a-z%]*)$","i"),Pb=/queueHooks$/,Qb=[function(a,b,c){var d,e,f,g,h,i,j,l=this,m={},o=a.style,p=a.nodeType&&S(a),q=L.get(a,"fxshow");c.queue||(null==(h=n._queueHooks(a,"fx")).unqueued&&(h.unqueued=0,i=h.empty.fire,h.empty.fire=function(){h.unqueued||i()}),h.unqueued++,l.always(function(){l.always(function(){h.unqueued--,n.queue(a,"fx").length||h.empty.fire()})})),1===a.nodeType&&("height"in b||"width"in b)&&(c.overflow=[o.overflow,o.overflowX,o.overflowY],"inline"===("none"===(j=n.css(a,"display"))?L.get(a,"olddisplay")||tb(a.nodeName):j)&&"none"===n.css(a,"float")&&(o.display="inline-block")),c.overflow&&(o.overflow="hidden",l.always(function(){o.overflow=c.overflow[0],o.overflowX=c.overflow[1],o.overflowY=c.overflow[2]}));for(d in b)if(e=b[d],Nb.exec(e)){if(delete b[d],f=f||"toggle"===e,e===(p?"hide":"show")){if("show"!==e||!q||void 0===q[d])continue;p=!0}m[d]=q&&q[d]||n.style(a,d)}else j=void 0;if(n.isEmptyObject(m))"inline"===("none"===j?tb(a.nodeName):j)&&(o.display=j);else{q?"hidden"in q&&(p=q.hidden):q=L.access(a,"fxshow",{}),f&&(q.hidden=!p),p?n(a).show():l.done(function(){n(a).hide()}),l.done(function(){var b;L.remove(a,"fxshow");for(b in m)n.style(a,b,m[b])});for(d in m)g=Ub(p?q[d]:0,d,l),d in q||(q[d]=g.start,p&&(g.end=g.start,g.start="width"===d||"height"===d?1:0))}}],Rb={"*":[function(a,b){var c=this.createTween(a,b),d=c.cur(),e=Ob.exec(b),f=e&&e[3]||(n.cssNumber[a]?"":"px"),g=(n.cssNumber[a]||"px"!==f&&+d)&&Ob.exec(n.css(c.elem,a)),h=1,i=20;if(g&&g[3]!==f){f=f||g[3],e=e||[],g=+d||1;do{h=h||".5",g/=h,n.style(c.elem,a,g+f)}while(h!==(h=c.cur()/d)&&1!==h&&--i)}return e&&(g=c.start=+g||+d||0,c.unit=f,c.end=e[1]?g+(e[1]+1)*e[2]:+e[2]),c}]};n.Animation=n.extend(Xb,{tweener:function(a,b){n.isFunction(a)?(b=a,a=["*"]):a=a.split(" ");for(var c,d=0,e=a.length;e>d;d++)c=a[d],Rb[c]=Rb[c]||[],Rb[c].unshift(b)},prefilter:function(a,b){b?Qb.unshift(a):Qb.push(a)}}),n.speed=function(a,b,c){var d=a&&"object"==typeof a?n.extend({},a):{complete:c||!c&&b||n.isFunction(a)&&a,duration:a,easing:c&&b||b&&!n.isFunction(b)&&b};return d.duration=n.fx.off?0:"number"==typeof d.duration?d.duration:d.duration in n.fx.speeds?n.fx.speeds[d.duration]:n.fx.speeds._default,(null==d.queue||!0===d.queue)&&(d.queue="fx"),d.old=d.complete,d.complete=function(){n.isFunction(d.old)&&d.old.call(this),d.queue&&n.dequeue(this,d.queue)},d},n.fn.extend({fadeTo:function(a,b,c,d){return this.filter(S).css("opacity",0).show().end().animate({opacity:b},a,c,d)},animate:function(a,b,c,d){var e=n.isEmptyObject(a),f=n.speed(b,c,d),g=function(){var b=Xb(this,n.extend({},a),f);(e||L.get(this,"finish"))&&b.stop(!0)};return g.finish=g,e||!1===f.queue?this.each(g):this.queue(f.queue,g)},stop:function(a,b,c){var d=function(a){var b=a.stop;delete a.stop,b(c)};return"string"!=typeof a&&(c=b,b=a,a=void 0),b&&!1!==a&&this.queue(a||"fx",[]),this.each(function(){var b=!0,e=null!=a&&a+"queueHooks",f=n.timers,g=L.get(this);if(e)g[e]&&g[e].stop&&d(g[e]);else for(e in g)g[e]&&g[e].stop&&Pb.test(e)&&d(g[e]);for(e=f.length;e--;)f[e].elem!==this||null!=a&&f[e].queue!==a||(f[e].anim.stop(c),b=!1,f.splice(e,1));(b||!c)&&n.dequeue(this,a)})},finish:function(a){return!1!==a&&(a=a||"fx"),this.each(function(){var b,c=L.get(this),d=c[a+"queue"],e=c[a+"queueHooks"],f=n.timers,g=d?d.length:0;for(c.finish=!0,n.queue(this,a,[]),e&&e.stop&&e.stop.call(this,!0),b=f.length;b--;)f[b].elem===this&&f[b].queue===a&&(f[b].anim.stop(!0),f.splice(b,1));for(b=0;g>b;b++)d[b]&&d[b].finish&&d[b].finish.call(this);delete c.finish})}}),n.each(["toggle","show","hide"],function(a,b){var c=n.fn[b];n.fn[b]=function(a,d,e){return null==a||"boolean"==typeof a?c.apply(this,arguments):this.animate(Tb(b,!0),a,d,e)}}),n.each({slideDown:Tb("show"),slideUp:Tb("hide"),slideToggle:Tb("toggle"),fadeIn:{opacity:"show"},fadeOut:{opacity:"hide"},fadeToggle:{opacity:"toggle"}},function(a,b){n.fn[a]=function(a,c,d){return this.animate(b,a,c,d)}}),n.timers=[],n.fx.tick=function(){var a,b=0,c=n.timers;for(Lb=n.now();b<c.length;b++)(a=c[b])()||c[b]!==a||c.splice(b--,1);c.length||n.fx.stop(),Lb=void 0},n.fx.timer=function(a){n.timers.push(a),a()?n.fx.start():n.timers.pop()},n.fx.interval=13,n.fx.start=function(){Mb||(Mb=setInterval(n.fx.tick,n.fx.interval))},n.fx.stop=function(){clearInterval(Mb),Mb=null},n.fx.speeds={slow:600,fast:200,_default:400},n.fn.delay=function(a,b){return a=n.fx?n.fx.speeds[a]||a:a,b=b||"fx",this.queue(b,function(b,c){var d=setTimeout(b,a);c.stop=function(){clearTimeout(d)}})},function(){var a=l.createElement("input"),b=l.createElement("select"),c=b.appendChild(l.createElement("option"));a.type="checkbox",k.checkOn=""!==a.value,k.optSelected=c.selected,b.disabled=!0,k.optDisabled=!c.disabled,(a=l.createElement("input")).value="t",a.type="radio",k.radioValue="t"===a.value}();var Zb,$b=n.expr.attrHandle;n.fn.extend({attr:function(a,b){return J(this,n.attr,a,b,arguments.length>1)},removeAttr:function(a){return this.each(function(){n.removeAttr(this,a)})}}),n.extend({attr:function(a,b,c){var d,e,f=a.nodeType;if(a&&3!==f&&8!==f&&2!==f)return typeof a.getAttribute===U?n.prop(a,b,c):(1===f&&n.isXMLDoc(a)||(b=b.toLowerCase(),d=n.attrHooks[b]||(n.expr.match.bool.test(b)?Zb:void 0)),void 0===c?d&&"get"in d&&null!==(e=d.get(a,b))?e:null==(e=n.find.attr(a,b))?void 0:e:null!==c?d&&"set"in d&&void 0!==(e=d.set(a,c,b))?e:(a.setAttribute(b,c+""),c):void n.removeAttr(a,b))},removeAttr:function(a,b){var c,d,e=0,f=b&&b.match(E);if(f&&1===a.nodeType)for(;c=f[e++];)d=n.propFix[c]||c,n.expr.match.bool.test(c)&&(a[d]=!1),a.removeAttribute(c)},attrHooks:{type:{set:function(a,b){if(!k.radioValue&&"radio"===b&&n.nodeName(a,"input")){var c=a.value;return a.setAttribute("type",b),c&&(a.value=c),b}}}}}),Zb={set:function(a,b,c){return!1===b?n.removeAttr(a,c):a.setAttribute(c,c),c}},n.each(n.expr.match.bool.source.match(/\w+/g),function(a,b){var c=$b[b]||n.find.attr;$b[b]=function(a,b,d){var e,f;return d||(f=$b[b],$b[b]=e,e=null!=c(a,b,d)?b.toLowerCase():null,$b[b]=f),e}});var _b=/^(?:input|select|textarea|button)$/i;n.fn.extend({prop:function(a,b){return J(this,n.prop,a,b,arguments.length>1)},removeProp:function(a){return this.each(function(){delete this[n.propFix[a]||a]})}}),n.extend({propFix:{for:"htmlFor",class:"className"},prop:function(a,b,c){var d,e,g=a.nodeType;if(a&&3!==g&&8!==g&&2!==g)return(1!==g||!n.isXMLDoc(a))&&(b=n.propFix[b]||b,e=n.propHooks[b]),void 0!==c?e&&"set"in e&&void 0!==(d=e.set(a,c,b))?d:a[b]=c:e&&"get"in e&&null!==(d=e.get(a,b))?d:a[b]},propHooks:{tabIndex:{get:function(a){return a.hasAttribute("tabindex")||_b.test(a.nodeName)||a.href?a.tabIndex:-1}}}}),k.optSelected||(n.propHooks.selected={get:function(a){var b=a.parentNode;return b&&b.parentNode&&b.parentNode.selectedIndex,null}}),n.each(["tabIndex","readOnly","maxLength","cellSpacing","cellPadding","rowSpan","colSpan","useMap","frameBorder","contentEditable"],function(){n.propFix[this.toLowerCase()]=this});var ac=/[\t\r\n\f]/g;n.fn.extend({addClass:function(a){var b,c,d,e,f,g,h="string"==typeof a&&a,i=0,j=this.length;if(n.isFunction(a))return this.each(function(b){n(this).addClass(a.call(this,b,this.className))});if(h)for(b=(a||"").match(E)||[];j>i;i++)if(c=this[i],d=1===c.nodeType&&(c.className?(" "+c.className+" ").replace(ac," "):" ")){for(f=0;e=b[f++];)d.indexOf(" "+e+" ")<0&&(d+=e+" ");g=n.trim(d),c.className!==g&&(c.className=g)}return this},removeClass:function(a){var b,c,d,e,f,g,h=0===arguments.length||"string"==typeof a&&a,i=0,j=this.length;if(n.isFunction(a))return this.each(function(b){n(this).removeClass(a.call(this,b,this.className))});if(h)for(b=(a||"").match(E)||[];j>i;i++)if(c=this[i],d=1===c.nodeType&&(c.className?(" "+c.className+" ").replace(ac," "):"")){for(f=0;e=b[f++];)for(;d.indexOf(" "+e+" ")>=0;)d=d.replace(" "+e+" "," ");g=a?n.trim(d):"",c.className!==g&&(c.className=g)}return this},toggleClass:function(a,b){var c=typeof a;return"boolean"==typeof b&&"string"===c?b?this.addClass(a):this.removeClass(a):this.each(n.isFunction(a)?function(c){n(this).toggleClass(a.call(this,c,this.className,b),b)}:function(){if("string"===c)for(var b,d=0,e=n(this),f=a.match(E)||[];b=f[d++];)e.hasClass(b)?e.removeClass(b):e.addClass(b);else(c===U||"boolean"===c)&&(this.className&&L.set(this,"__className__",this.className),this.className=this.className||!1===a?"":L.get(this,"__className__")||"")})},hasClass:function(a){for(var b=" "+a+" ",c=0,d=this.length;d>c;c++)if(1===this[c].nodeType&&(" "+this[c].className+" ").replace(ac," ").indexOf(b)>=0)return!0;return!1}});var bc=/\r/g;n.fn.extend({val:function(a){var b,c,d,e=this[0];return arguments.length?(d=n.isFunction(a),this.each(function(c){var e;1===this.nodeType&&(null==(e=d?a.call(this,c,n(this).val()):a)?e="":"number"==typeof e?e+="":n.isArray(e)&&(e=n.map(e,function(a){return null==a?"":a+""})),(b=n.valHooks[this.type]||n.valHooks[this.nodeName.toLowerCase()])&&"set"in b&&void 0!==b.set(this,e,"value")||(this.value=e))})):e?(b=n.valHooks[e.type]||n.valHooks[e.nodeName.toLowerCase()])&&"get"in b&&void 0!==(c=b.get(e,"value"))?c:"string"==typeof(c=e.value)?c.replace(bc,""):null==c?"":c:void 0}}),n.extend({valHooks:{option:{get:function(a){var b=n.find.attr(a,"value");return null!=b?b:n.trim(n.text(a))}},select:{get:function(a){for(var b,c,d=a.options,e=a.selectedIndex,f="select-one"===a.type||0>e,g=f?null:[],h=f?e+1:d.length,i=0>e?h:f?e:0;h>i;i++)if(!(!(c=d[i]).selected&&i!==e||(k.optDisabled?c.disabled:null!==c.getAttribute("disabled"))||c.parentNode.disabled&&n.nodeName(c.parentNode,"optgroup"))){if(b=n(c).val(),f)return b;g.push(b)}return g},set:function(a,b){for(var c,d,e=a.options,f=n.makeArray(b),g=e.length;g--;)d=e[g],(d.selected=n.inArray(d.value,f)>=0)&&(c=!0);return c||(a.selectedIndex=-1),f}}}}),n.each(["radio","checkbox"],function(){n.valHooks[this]={set:function(a,b){return n.isArray(b)?a.checked=n.inArray(n(a).val(),b)>=0:void 0}},k.checkOn||(n.valHooks[this].get=function(a){return null===a.getAttribute("value")?"on":a.value})}),n.each("blur focus focusin focusout load resize scroll unload click dblclick mousedown mouseup mousemove mouseover mouseout mouseenter mouseleave change select submit keydown keypress keyup error contextmenu".split(" "),function(a,b){n.fn[b]=function(a,c){return arguments.length>0?this.on(b,null,a,c):this.trigger(b)}}),n.fn.extend({hover:function(a,b){return this.mouseenter(a).mouseleave(b||a)},bind:function(a,b,c){return this.on(a,null,b,c)},unbind:function(a,b){return this.off(a,null,b)},delegate:function(a,b,c,d){return this.on(b,a,c,d)},undelegate:function(a,b,c){return 1===arguments.length?this.off(a,"**"):this.off(b,a||"**",c)}});var cc=n.now(),dc=/\?/;n.parseJSON=function(a){return JSON.parse(a+"")},n.parseXML=function(a){var b,c;if(!a||"string"!=typeof a)return null;try{c=new DOMParser,b=c.parseFromString(a,"text/xml")}catch(d){b=void 0}return(!b||b.getElementsByTagName("parsererror").length)&&n.error("Invalid XML: "+a),b};var ec=/#.*$/,fc=/([?&])_=[^&]*/,gc=/^(.*?):[ \t]*([^\r\n]*)$/gm,hc=/^(?:about|app|app-storage|.+-extension|file|res|widget):$/,ic=/^(?:GET|HEAD)$/,jc=/^\/\//,kc=/^([\w.+-]+:)(?:\/\/(?:[^\/?#]*@|)([^\/?#:]*)(?::(\d+)|)|)/,lc={},mc={},nc="*/".concat("*"),oc=a.location.href,pc=kc.exec(oc.toLowerCase())||[];n.extend({active:0,lastModified:{},etag:{},ajaxSettings:{url:oc,type:"GET",isLocal:hc.test(pc[1]),global:!0,processData:!0,async:!0,contentType:"application/x-www-form-urlencoded; charset=UTF-8",accepts:{"*":nc,text:"text/plain",html:"text/html",xml:"application/xml, text/xml",json:"application/json, text/javascript"},contents:{xml:/xml/,html:/html/,json:/json/},responseFields:{xml:"responseXML",text:"responseText",json:"responseJSON"},converters:{"* text":String,"text html":!0,"text json":n.parseJSON,"text xml":n.parseXML},flatOptions:{url:!0,context:!0}},ajaxSetup:function(a,b){return b?sc(sc(a,n.ajaxSettings),b):sc(n.ajaxSettings,a)},ajaxPrefilter:qc(lc),ajaxTransport:qc(mc),ajax:function(a,b){function x(a,b,f,h){var j,r,s,u,w,x=b;2!==t&&(t=2,g&&clearTimeout(g),c=void 0,e=h||"",v.readyState=a>0?4:0,j=a>=200&&300>a||304===a,f&&(u=tc(k,v,f)),u=uc(k,u,v,j),j?(k.ifModified&&((w=v.getResponseHeader("Last-Modified"))&&(n.lastModified[d]=w),(w=v.getResponseHeader("etag"))&&(n.etag[d]=w)),204===a||"HEAD"===k.type?x="nocontent":304===a?x="notmodified":(x=u.state,r=u.data,s=u.error,j=!s)):(s=x,(a||!x)&&(x="error",0>a&&(a=0))),v.status=a,v.statusText=(b||x)+"",j?o.resolveWith(l,[r,x,v]):o.rejectWith(l,[v,x,s]),v.statusCode(q),q=void 0,i&&m.trigger(j?"ajaxSuccess":"ajaxError",[v,k,j?r:s]),p.fireWith(l,[v,x]),i&&(m.trigger("ajaxComplete",[v,k]),--n.active||n.event.trigger("ajaxStop")))}"object"==typeof a&&(b=a,a=void 0),b=b||{};var c,d,e,f,g,h,i,j,k=n.ajaxSetup({},b),l=k.context||k,m=k.context&&(l.nodeType||l.jquery)?n(l):n.event,o=n.Deferred(),p=n.Callbacks("once memory"),q=k.statusCode||{},r={},s={},t=0,u="canceled",v={readyState:0,getResponseHeader:function(a){var b;if(2===t){if(!f)for(f={};b=gc.exec(e);)f[b[1].toLowerCase()]=b[2];b=f[a.toLowerCase()]}return null==b?null:b},getAllResponseHeaders:function(){return 2===t?e:null},setRequestHeader:function(a,b){var c=a.toLowerCase();return t||(a=s[c]=s[c]||a,r[a]=b),this},overrideMimeType:function(a){return t||(k.mimeType=a),this},statusCode:function(a){var b;if(a)if(2>t)for(b in a)q[b]=[q[b],a[b]];else v.always(a[v.status]);return this},abort:function(a){var b=a||u;return c&&c.abort(b),x(0,b),this}};if(o.promise(v).complete=p.add,v.success=v.done,v.error=v.fail,k.url=((a||k.url||oc)+"").replace(ec,"").replace(jc,pc[1]+"//"),k.type=b.method||b.type||k.method||k.type,k.dataTypes=n.trim(k.dataType||"*").toLowerCase().match(E)||[""],null==k.crossDomain&&(h=kc.exec(k.url.toLowerCase()),k.crossDomain=!(!h||h[1]===pc[1]&&h[2]===pc[2]&&(h[3]||("http:"===h[1]?"80":"443"))===(pc[3]||("http:"===pc[1]?"80":"443")))),k.data&&k.processData&&"string"!=typeof k.data&&(k.data=n.param(k.data,k.traditional)),rc(lc,k,b,v),2===t)return v;(i=n.event&&k.global)&&0==n.active++&&n.event.trigger("ajaxStart"),k.type=k.type.toUpperCase(),k.hasContent=!ic.test(k.type),d=k.url,k.hasContent||(k.data&&(d=k.url+=(dc.test(d)?"&":"?")+k.data,delete k.data),!1===k.cache&&(k.url=fc.test(d)?d.replace(fc,"$1_="+cc++):d+(dc.test(d)?"&":"?")+"_="+cc++)),k.ifModified&&(n.lastModified[d]&&v.setRequestHeader("If-Modified-Since",n.lastModified[d]),n.etag[d]&&v.setRequestHeader("If-None-Match",n.etag[d])),(k.data&&k.hasContent&&!1!==k.contentType||b.contentType)&&v.setRequestHeader("Content-Type",k.contentType),v.setRequestHeader("Accept",k.dataTypes[0]&&k.accepts[k.dataTypes[0]]?k.accepts[k.dataTypes[0]]+("*"!==k.dataTypes[0]?", "+nc+"; q=0.01":""):k.accepts["*"]);for(j in k.headers)v.setRequestHeader(j,k.headers[j]);if(k.beforeSend&&(!1===k.beforeSend.call(l,v,k)||2===t))return v.abort();u="abort";for(j in{success:1,error:1,complete:1})v[j](k[j]);if(c=rc(mc,k,b,v)){v.readyState=1,i&&m.trigger("ajaxSend",[v,k]),k.async&&k.timeout>0&&(g=setTimeout(function(){v.abort("timeout")},k.timeout));try{t=1,c.send(r,x)}catch(w){if(!(2>t))throw w;x(-1,w)}}else x(-1,"No Transport");return v},getJSON:function(a,b,c){return n.get(a,b,c,"json")},getScript:function(a,b){return n.get(a,void 0,b,"script")}}),n.each(["get","post"],function(a,b){n[b]=function(a,c,d,e){return n.isFunction(c)&&(e=e||d,d=c,c=void 0),n.ajax({url:a,type:b,dataType:e,data:c,success:d})}}),n._evalUrl=function(a){return n.ajax({url:a,type:"GET",dataType:"script",async:!1,global:!1,throws:!0})},n.fn.extend({wrapAll:function(a){var b;return n.isFunction(a)?this.each(function(b){n(this).wrapAll(a.call(this,b))}):(this[0]&&(b=n(a,this[0].ownerDocument).eq(0).clone(!0),this[0].parentNode&&b.insertBefore(this[0]),b.map(function(){for(var a=this;a.firstElementChild;)a=a.firstElementChild;return a}).append(this)),this)},wrapInner:function(a){return this.each(n.isFunction(a)?function(b){n(this).wrapInner(a.call(this,b))}:function(){var b=n(this),c=b.contents();c.length?c.wrapAll(a):b.append(a)})},wrap:function(a){var b=n.isFunction(a);return this.each(function(c){n(this).wrapAll(b?a.call(this,c):a)})},unwrap:function(){return this.parent().each(function(){n.nodeName(this,"body")||n(this).replaceWith(this.childNodes)}).end()}}),n.expr.filters.hidden=function(a){return a.offsetWidth<=0&&a.offsetHeight<=0},n.expr.filters.visible=function(a){return!n.expr.filters.hidden(a)};var vc=/%20/g,wc=/\[\]$/,xc=/\r?\n/g,yc=/^(?:submit|button|image|reset|file)$/i,zc=/^(?:input|select|textarea|keygen)/i;n.param=function(a,b){var c,d=[],e=function(a,b){b=n.isFunction(b)?b():null==b?"":b,d[d.length]=encodeURIComponent(a)+"="+encodeURIComponent(b)};if(void 0===b&&(b=n.ajaxSettings&&n.ajaxSettings.traditional),n.isArray(a)||a.jquery&&!n.isPlainObject(a))n.each(a,function(){e(this.name,this.value)});else for(c in a)Ac(c,a[c],b,e);return d.join("&").replace(vc,"+")},n.fn.extend({serialize:function(){return n.param(this.serializeArray())},serializeArray:function(){return this.map(function(){var a=n.prop(this,"elements");return a?n.makeArray(a):this}).filter(function(){var a=this.type;return this.name&&!n(this).is(":disabled")&&zc.test(this.nodeName)&&!yc.test(a)&&(this.checked||!T.test(a))}).map(function(a,b){var c=n(this).val();return null==c?null:n.isArray(c)?n.map(c,function(a){return{name:b.name,value:a.replace(xc,"\r\n")}}):{name:b.name,value:c.replace(xc,"\r\n")}}).get()}}),n.ajaxSettings.xhr=function(){try{return new XMLHttpRequest}catch(a){}};var Bc=0,Cc={},Dc={0:200,1223:204},Ec=n.ajaxSettings.xhr();a.attachEvent&&a.attachEvent("onunload",function(){for(var a in Cc)Cc[a]()}),k.cors=!!Ec&&"withCredentials"in Ec,k.ajax=Ec=!!Ec,n.ajaxTransport(function(a){var b;return k.cors||Ec&&!a.crossDomain?{send:function(c,d){var e,f=a.xhr(),g=++Bc;if(f.open(a.type,a.url,a.async,a.username,a.password),a.xhrFields)for(e in a.xhrFields)f[e]=a.xhrFields[e];a.mimeType&&f.overrideMimeType&&f.overrideMimeType(a.mimeType),a.crossDomain||c["X-Requested-With"]||(c["X-Requested-With"]="XMLHttpRequest");for(e in c)f.setRequestHeader(e,c[e]);b=function(a){return function(){b&&(delete Cc[g],b=f.onload=f.onerror=null,"abort"===a?f.abort():"error"===a?d(f.status,f.statusText):d(Dc[f.status]||f.status,f.statusText,"string"==typeof f.responseText?{text:f.responseText}:void 0,f.getAllResponseHeaders()))}},f.onload=b(),f.onerror=b("error"),b=Cc[g]=b("abort");try{f.send(a.hasContent&&a.data||null)}catch(h){if(b)throw h}},abort:function(){b&&b()}}:void 0}),n.ajaxSetup({accepts:{script:"text/javascript, application/javascript, application/ecmascript, application/x-ecmascript"},contents:{script:/(?:java|ecma)script/},converters:{"text script":function(a){return n.globalEval(a),a}}}),n.ajaxPrefilter("script",function(a){void 0===a.cache&&(a.cache=!1),a.crossDomain&&(a.type="GET")}),n.ajaxTransport("script",function(a){if(a.crossDomain){var b,c;return{send:function(d,e){b=n("<script>").prop({async:!0,charset:a.scriptCharset,src:a.url}).on("load error",c=function(a){b.remove(),c=null,a&&e("error"===a.type?404:200,a.type)}),l.head.appendChild(b[0])},abort:function(){c&&c()}}}});var Fc=[],Gc=/(=)\?(?=&|$)|\?\?/;n.ajaxSetup({jsonp:"callback",jsonpCallback:function(){var a=Fc.pop()||n.expando+"_"+cc++;return this[a]=!0,a}}),n.ajaxPrefilter("json jsonp",function(b,c,d){var e,f,g,h=!1!==b.jsonp&&(Gc.test(b.url)?"url":"string"==typeof b.data&&!(b.contentType||"").indexOf("application/x-www-form-urlencoded")&&Gc.test(b.data)&&"data");return h||"jsonp"===b.dataTypes[0]?(e=b.jsonpCallback=n.isFunction(b.jsonpCallback)?b.jsonpCallback():b.jsonpCallback,h?b[h]=b[h].replace(Gc,"$1"+e):!1!==b.jsonp&&(b.url+=(dc.test(b.url)?"&":"?")+b.jsonp+"="+e),b.converters["script json"]=function(){return g||n.error(e+" was not called"),g[0]},b.dataTypes[0]="json",f=a[e],a[e]=function(){g=arguments},d.always(function(){a[e]=f,b[e]&&(b.jsonpCallback=c.jsonpCallback,Fc.push(e)),g&&n.isFunction(f)&&f(g[0]),g=f=void 0}),"script"):void 0}),n.parseHTML=function(a,b,c){if(!a||"string"!=typeof a)return null;"boolean"==typeof b&&(c=b,b=!1),b=b||l;var d=v.exec(a),e=!c&&[];return d?[b.createElement(d[1])]:(d=n.buildFragment([a],b,e),e&&e.length&&n(e).remove(),n.merge([],d.childNodes))};var Hc=n.fn.load;n.fn.load=function(a,b,c){if("string"!=typeof a&&Hc)return Hc.apply(this,arguments);var d,e,f,g=this,h=a.indexOf(" ");return h>=0&&(d=n.trim(a.slice(h)),a=a.slice(0,h)),n.isFunction(b)?(c=b,b=void 0):b&&"object"==typeof b&&(e="POST"),g.length>0&&n.ajax({url:a,type:e,dataType:"html",data:b}).done(function(a){f=arguments,g.html(d?n("<div>").append(n.parseHTML(a)).find(d):a)}).complete(c&&function(a,b){g.each(c,f||[a.responseText,b,a])}),this},n.each(["ajaxStart","ajaxStop","ajaxComplete","ajaxError","ajaxSuccess","ajaxSend"],function(a,b){n.fn[b]=function(a){return this.on(b,a)}}),n.expr.filters.animated=function(a){return n.grep(n.timers,function(b){return a===b.elem}).length};var Ic=a.document.documentElement;n.offset={setOffset:function(a,b,c){var d,e,f,g,h,i,k=n.css(a,"position"),l=n(a),m={};"static"===k&&(a.style.position="relative"),h=l.offset(),f=n.css(a,"top"),i=n.css(a,"left"),("absolute"===k||"fixed"===k)&&(f+i).indexOf("auto")>-1?(d=l.position(),g=d.top,e=d.left):(g=parseFloat(f)||0,e=parseFloat(i)||0),n.isFunction(b)&&(b=b.call(a,c,h)),null!=b.top&&(m.top=b.top-h.top+g),null!=b.left&&(m.left=b.left-h.left+e),"using"in b?b.using.call(a,m):l.css(m)}},n.fn.extend({offset:function(a){if(arguments.length)return void 0===a?this:this.each(function(b){n.offset.setOffset(this,a,b)});var b,c,d=this[0],e={top:0,left:0},f=d&&d.ownerDocument;return f?(b=f.documentElement,n.contains(b,d)?(typeof d.getBoundingClientRect!==U&&(e=d.getBoundingClientRect()),c=Jc(f),{top:e.top+c.pageYOffset-b.clientTop,left:e.left+c.pageXOffset-b.clientLeft}):e):void 0},position:function(){if(this[0]){var a,b,c=this[0],d={top:0,left:0};return"fixed"===n.css(c,"position")?b=c.getBoundingClientRect():(a=this.offsetParent(),b=this.offset(),n.nodeName(a[0],"html")||(d=a.offset()),d.top+=n.css(a[0],"borderTopWidth",!0),d.left+=n.css(a[0],"borderLeftWidth",!0)),{top:b.top-d.top-n.css(c,"marginTop",!0),left:b.left-d.left-n.css(c,"marginLeft",!0)}}},offsetParent:function(){return this.map(function(){for(var a=this.offsetParent||Ic;a&&!n.nodeName(a,"html")&&"static"===n.css(a,"position");)a=a.offsetParent;return a||Ic})}}),n.each({scrollLeft:"pageXOffset",scrollTop:"pageYOffset"},function(b,c){var d="pageYOffset"===c;n.fn[b]=function(e){return J(this,function(b,e,f){var g=Jc(b);return void 0===f?g?g[c]:b[e]:void(g?g.scrollTo(d?a.pageXOffset:f,d?f:a.pageYOffset):b[e]=f)},b,e,arguments.length,null)}}),n.each(["top","left"],function(a,b){n.cssHooks[b]=yb(k.pixelPosition,function(a,c){return c?(c=xb(a,b),vb.test(c)?n(a).position()[b]+"px":c):void 0})}),n.each({Height:"height",Width:"width"},function(a,b){n.each({padding:"inner"+a,content:b,"":"outer"+a},function(c,d){n.fn[d]=function(d,e){var f=arguments.length&&(c||"boolean"!=typeof d),g=c||(!0===d||!0===e?"margin":"border");return J(this,function(b,c,d){var e;return n.isWindow(b)?b.document.documentElement["client"+a]:9===b.nodeType?(e=b.documentElement,Math.max(b.body["scroll"+a],e["scroll"+a],b.body["offset"+a],e["offset"+a],e["client"+a])):void 0===d?n.css(b,c,g):n.style(b,c,d,g)},b,f?d:void 0,f,null)}})}),n.fn.size=function(){return this.length},n.fn.andSelf=n.fn.addBack,"function"==typeof define&&define.amd&&define("jquery",[],function(){return n});var Kc=a.jQuery,Lc=a.$;return n.noConflict=function(b){return a.$===n&&(a.$=Lc),b&&a.jQuery===n&&(a.jQuery=Kc),n},typeof b===U&&(a.jQuery=a.$=n),n}),angular.module("ngCordova",["ngCordova.plugins"]),angular.module("ngCordova.plugins.actionSheet",[]).factory("$cordovaActionSheet",["$q","$window",function($q,$window){return{show:function(options){var q=$q.defer();return $window.plugins.actionsheet.show(options,function(result){q.resolve(result)}),q.promise},hide:function(){return $window.plugins.actionsheet.hide()}}}]),angular.module("ngCordova.plugins.adMob",[]).factory("$cordovaAdMob",["$q","$window",function($q,$window){return{createBannerView:function(options){var d=$q.defer();return $window.plugins.AdMob.createBannerView(options,function(){d.resolve()},function(){d.reject()}),d.promise},createInterstitialView:function(options){var d=$q.defer();return $window.plugins.AdMob.createInterstitialView(options,function(){d.resolve()},function(){d.reject()}),d.promise},requestAd:function(options){var d=$q.defer();return $window.plugins.AdMob.requestAd(options,function(){d.resolve()},function(){d.reject()}),d.promise},showAd:function(options){var d=$q.defer();return $window.plugins.AdMob.showAd(options,function(){d.resolve()},function(){d.reject()}),d.promise},requestInterstitialAd:function(options){var d=$q.defer();return $window.plugins.AdMob.requestInterstitialAd(options,function(){d.resolve()},function(){d.reject()}),d.promise}}}]),angular.module("ngCordova.plugins.appAvailability",[]).factory("$cordovaAppAvailability",["$q",function($q){return{check:function(urlScheme){var q=$q.defer();return appAvailability.check(urlScheme,function(result){q.resolve(result)},function(err){q.reject(err)}),q.promise}}}]),angular.module("ngCordova.plugins.appRate",[]).provider("$cordovaAppRate",[function(){this.setPreferences=function(defaults){defaults&&angular.isObject(defaults)&&(AppRate.preferences.useLanguage=defaults.language||null,AppRate.preferences.displayAppName=defaults.appName||"",AppRate.preferences.promptAgainForEachNewVersion=defaults.promptForNewVersion||!0,AppRate.preferences.openStoreInApp=defaults.openStoreInApp||!1,AppRate.preferences.usesUntilPrompt=defaults.usesUntilPrompt||3,AppRate.preferences.useCustomRateDialog=defaults.useCustomRateDialog||!1,AppRate.preferences.storeAppURL.ios=defaults.iosURL||null,AppRate.preferences.storeAppURL.android=defaults.androidURL||null,AppRate.preferences.storeAppURL.blackberry=defaults.blackberryURL||null,AppRate.preferences.storeAppURL.windows8=defaults.windowsURL||null)},this.setCustomLocale=function(customObj){var strings={title:"Rate %@",message:"If you enjoy using %@, would you mind taking a moment to rate it? It won’t take more than a minute. Thanks for your support!",cancelButtonLabel:"No, Thanks",laterButtonLabel:"Remind Me Later",rateButtonLabel:"Rate It Now"};strings=angular.extend(strings,customObj),AppRate.preferences.customLocale=strings},this.$get=["$q",function($q){return{promptForRating:function(immediate){var q=$q.defer(),prompt=AppRate.promptForRating(immediate);return q.resolve(prompt),q.promise},navigateToAppStore:function(){var q=$q.defer(),navigate=AppRate.navigateToAppStore();return q.resolve(navigate),q.promise},onButtonClicked:function(cb){AppRate.onButtonClicked=function(buttonIndex){cb.call(this,buttonIndex)}},onRateDialogShow:function(cb){AppRate.onRateDialogShow=cb()}}}]}]),angular.module("ngCordova.plugins.appVersion",[]).factory("$cordovaAppVersion",["$q",function($q){return{getAppName:function(){var q=$q.defer();return cordova.getAppVersion.getAppName(function(name){q.resolve(name)}),q.promise},getPackageName:function(){var q=$q.defer();return cordova.getAppVersion.getPackageName(function(pack){q.resolve(pack)}),q.promise},getVersionNumber:function(){var q=$q.defer();return cordova.getAppVersion.getVersionNumber(function(version){q.resolve(version)}),q.promise},getVersionCode:function(){var q=$q.defer();return cordova.getAppVersion.getVersionCode(function(code){q.resolve(code)}),q.promise}}}]),angular.module("ngCordova.plugins.backgroundGeolocation",[]).factory("$cordovaBackgroundGeolocation",["$q","$window",function($q,$window){return{init:function(){$window.navigator.geolocation.getCurrentPosition(function(location){return location})},configure:function(options){this.init();var q=$q.defer();return $window.plugins.backgroundGeoLocation.configure(function(result){q.notify(result),$window.plugins.backgroundGeoLocation.finish()},function(err){q.reject(err)},options),this.start(),q.promise},start:function(){var q=$q.defer();return $window.plugins.backgroundGeoLocation.start(function(result){q.resolve(result)},function(err){q.reject(err)}),q.promise},stop:function(){var q=$q.defer();return $window.plugins.backgroundGeoLocation.stop(function(result){q.resolve(result)},function(err){q.reject(err)}),q.promise}}}]),angular.module("ngCordova.plugins.badge",[]).factory("$cordovaBadge",["$q",function($q){return{hasPermission:function(){var q=$q.defer();return cordova.plugins.notification.badge.hasPermission(function(permission){permission?q.resolve(!0):q.reject("You do not have permission")}),q.promise},promptForPermission:function(){return cordova.plugins.notification.badge.promptForPermission()},set:function(badge,callback,scope){var q=$q.defer();return cordova.plugins.notification.badge.hasPermission(function(permission){permission?q.resolve(cordova.plugins.notification.badge.set(badge,callback,scope)):q.reject("You do not have permission to set Badge")}),q.promise},get:function(){var q=$q.defer();return cordova.plugins.notification.badge.hasPermission(function(permission){permission?cordova.plugins.notification.badge.get(function(badge){q.resolve(badge)}):q.reject("You do not have permission to get Badge")}),q.promise},clear:function(callback,scope){var q=$q.defer();return cordova.plugins.notification.badge.hasPermission(function(permission){permission?q.resolve(cordova.plugins.notification.badge.clear(callback,scope)):q.reject("You do not have permission to clear Badge")}),q.promise},increase:function(count,callback,scope){var q=$q.defer();return this.hasPermission().then(function(){q.resolve(cordova.plugins.notification.badge.increase(count,callback,scope))},function(){q.reject("You do not have permission to increase Badge")}),q.promise},decrease:function(count,callback,scope){var q=$q.defer();return this.hasPermission().then(function(){q.resolve(cordova.plugins.notification.badge.decrease(count,callback,scope))},function(){q.reject("You do not have permission to decrease Badge")}),q.promise},configure:function(config){return cordova.plugins.notification.badge.configure(config)}}}]),angular.module("ngCordova.plugins.barcodeScanner",[]).factory("$cordovaBarcodeScanner",["$q",function($q){return{scan:function(config){var q=$q.defer();return cordova.plugins.barcodeScanner.scan(function(result){q.resolve(result)},function(err){q.reject(err)},config),q.promise},encode:function(type,data){var q=$q.defer();return type=type||"TEXT_TYPE",cordova.plugins.barcodeScanner.encode(type,data,function(result){q.resolve(result)},function(err){q.reject(err)}),q.promise}}}]),angular.module("ngCordova.plugins.batteryStatus",[]).factory("$cordovaBatteryStatus",["$rootScope","$window","$timeout",function($rootScope,$window,$timeout){var batteryStatus=function(status){$timeout(function(){$rootScope.$broadcast("$cordovaBatteryStatus:status",status)})},batteryCritical=function(status){$timeout(function(){$rootScope.$broadcast("$cordovaBatteryStatus:critical",status)})},batteryLow=function(status){$timeout(function(){$rootScope.$broadcast("$cordovaBatteryStatus:low",status)})};return document.addEventListener("deviceready",function(){navigator.battery&&($window.addEventListener("batterystatus",batteryStatus,!1),$window.addEventListener("batterycritical",batteryCritical,!1),$window.addEventListener("batterylow",batteryLow,!1))},!1),!0}]).run(["$injector",function($injector){$injector.get("$cordovaBatteryStatus")}]),angular.module("ngCordova.plugins.beacon",[]).factory("$cordovaBeacon",["$window","$rootScope","$timeout","$q",function($window,$rootScope,$timeout,$q){var callbackDidDetermineStateForRegion=null,callbackDidStartMonitoringForRegion=null,callbackDidExitRegion=null,callbackDidEnterRegion=null,callbackDidRangeBeaconsInRegion=null,callbackPeripheralManagerDidStartAdvertising=null,callbackPeripheralManagerDidUpdateState=null,callbackDidChangeAuthorizationStatus=null;return document.addEventListener("deviceready",function(){if($window.cordova&&$window.cordova.plugins&&$window.cordova.plugins.locationManager){var delegate=new $window.cordova.plugins.locationManager.Delegate;delegate.didDetermineStateForRegion=function(pluginResult){$timeout(function(){$rootScope.$broadcast("$cordovaBeacon:didDetermineStateForRegion",pluginResult)}),callbackDidDetermineStateForRegion&&callbackDidDetermineStateForRegion(pluginResult)},delegate.didStartMonitoringForRegion=function(pluginResult){$timeout(function(){$rootScope.$broadcast("$cordovaBeacon:didStartMonitoringForRegion",pluginResult)}),callbackDidStartMonitoringForRegion&&callbackDidStartMonitoringForRegion(pluginResult)},delegate.didExitRegion=function(pluginResult){$timeout(function(){$rootScope.$broadcast("$cordovaBeacon:didExitRegion",pluginResult)}),callbackDidExitRegion&&callbackDidExitRegion(pluginResult)},delegate.didEnterRegion=function(pluginResult){$timeout(function(){$rootScope.$broadcast("$cordovaBeacon:didEnterRegion",pluginResult)}),callbackDidEnterRegion&&callbackDidEnterRegion(pluginResult)},delegate.didRangeBeaconsInRegion=function(pluginResult){$timeout(function(){$rootScope.$broadcast("$cordovaBeacon:didRangeBeaconsInRegion",pluginResult)}),callbackDidRangeBeaconsInRegion&&callbackDidRangeBeaconsInRegion(pluginResult)},delegate.peripheralManagerDidStartAdvertising=function(pluginResult){$timeout(function(){$rootScope.$broadcast("$cordovaBeacon:peripheralManagerDidStartAdvertising",pluginResult)}),callbackPeripheralManagerDidStartAdvertising&&callbackPeripheralManagerDidStartAdvertising(pluginResult)},delegate.peripheralManagerDidUpdateState=function(pluginResult){$timeout(function(){$rootScope.$broadcast("$cordovaBeacon:peripheralManagerDidUpdateState",pluginResult)}),callbackPeripheralManagerDidUpdateState&&callbackPeripheralManagerDidUpdateState(pluginResult)},delegate.didChangeAuthorizationStatus=function(status){$timeout(function(){$rootScope.$broadcast("$cordovaBeacon:didChangeAuthorizationStatus",status)}),callbackDidChangeAuthorizationStatus&&callbackDidChangeAuthorizationStatus(status)},$window.cordova.plugins.locationManager.setDelegate(delegate)}},!1),{setCallbackDidDetermineStateForRegion:function(callback){callbackDidDetermineStateForRegion=callback},setCallbackDidStartMonitoringForRegion:function(callback){callbackDidStartMonitoringForRegion=callback},setCallbackDidExitRegion:function(callback){callbackDidExitRegion=callback},setCallbackDidEnterRegion:function(callback){callbackDidEnterRegion=callback},setCallbackDidRangeBeaconsInRegion:function(callback){callbackDidRangeBeaconsInRegion=callback},setCallbackPeripheralManagerDidStartAdvertising:function(callback){callbackPeripheralManagerDidStartAdvertising=callback},setCallbackPeripheralManagerDidUpdateState:function(callback){callbackPeripheralManagerDidUpdateState=callback},setCallbackDidChangeAuthorizationStatus:function(callback){callbackDidChangeAuthorizationStatus=callback},createBeaconRegion:function(identifier,uuid,major,minor,notifyEntryStateOnDisplay){return major=major||void 0,minor=minor||void 0,new $window.cordova.plugins.locationManager.BeaconRegion(identifier,uuid,major,minor,notifyEntryStateOnDisplay)},isBluetoothEnabled:function(){return $q.when($window.cordova.plugins.locationManager.isBluetoothEnabled())},enableBluetooth:function(){return $q.when($window.cordova.plugins.locationManager.enableBluetooth())},disableBluetooth:function(){return $q.when($window.cordova.plugins.locationManager.disableBluetooth())},startMonitoringForRegion:function(region){return $q.when($window.cordova.plugins.locationManager.startMonitoringForRegion(region))},stopMonitoringForRegion:function(region){return $q.when($window.cordova.plugins.locationManager.stopMonitoringForRegion(region))},requestStateForRegion:function(region){return $q.when($window.cordova.plugins.locationManager.requestStateForRegion(region))},startRangingBeaconsInRegion:function(region){return $q.when($window.cordova.plugins.locationManager.startRangingBeaconsInRegion(region))},stopRangingBeaconsInRegion:function(region){return $q.when($window.cordova.plugins.locationManager.stopRangingBeaconsInRegion(region))},getAuthorizationStatus:function(){return $q.when($window.cordova.plugins.locationManager.getAuthorizationStatus())},requestWhenInUseAuthorization:function(){return $q.when($window.cordova.plugins.locationManager.requestWhenInUseAuthorization())},requestAlwaysAuthorization:function(){return $q.when($window.cordova.plugins.locationManager.requestAlwaysAuthorization())},getMonitoredRegions:function(){return $q.when($window.cordova.plugins.locationManager.getMonitoredRegions())},getRangedRegions:function(){return $q.when($window.cordova.plugins.locationManager.getRangedRegions())},isRangingAvailable:function(){return $q.when($window.cordova.plugins.locationManager.isRangingAvailable())},isMonitoringAvailableForClass:function(region){return $q.when($window.cordova.plugins.locationManager.isMonitoringAvailableForClass(region))},startAdvertising:function(region,measuredPower){return $q.when($window.cordova.plugins.locationManager.startAdvertising(region,measuredPower))},stopAdvertising:function(){return $q.when($window.cordova.plugins.locationManager.stopAdvertising())},isAdvertisingAvailable:function(){return $q.when($window.cordova.plugins.locationManager.isAdvertisingAvailable())},isAdvertising:function(){return $q.when($window.cordova.plugins.locationManager.isAdvertising())},disableDebugLogs:function(){return $q.when($window.cordova.plugins.locationManager.disableDebugLogs())},enableDebugNotifications:function(){return $q.when($window.cordova.plugins.locationManager.enableDebugNotifications())},disableDebugNotifications:function(){return $q.when($window.cordova.plugins.locationManager.disableDebugNotifications())},enableDebugLogs:function(){return $q.when($window.cordova.plugins.locationManager.enableDebugLogs())},appendToDeviceLog:function(message){return $q.when($window.cordova.plugins.locationManager.appendToDeviceLog(message))}}}]),angular.module("ngCordova.plugins.ble",[]).factory("$cordovaBLE",["$q","$timeout","$log",function($q,$timeout,$log){return{scan:function(services,seconds){var q=$q.defer();return ble.startScan(services,function(result){q.notify(result)},function(error){q.reject(error)}),$timeout(function(){ble.stopScan(function(){q.resolve()},function(error){q.reject(error)})},1e3*seconds),q.promise},startScan:function(services,callback,errorCallback){return ble.startScan(services,callback,errorCallback)},stopScan:function(){var q=$q.defer();return ble.stopScan(function(){q.resolve()},function(error){q.reject(error)}),q.promise},connect:function(deviceID){var q=$q.defer();return ble.connect(deviceID,function(result){q.resolve(result)},function(error){q.reject(error)}),q.promise},disconnect:function(deviceID){var q=$q.defer();return ble.disconnect(deviceID,function(result){q.resolve(result)},function(error){q.reject(error)}),q.promise},read:function(deviceID,serviceUUID,characteristicUUID){var q=$q.defer();return ble.read(deviceID,serviceUUID,characteristicUUID,function(result){q.resolve(result)},function(error){q.reject(error)}),q.promise},write:function(deviceID,serviceUUID,characteristicUUID,data){var q=$q.defer();return ble.write(deviceID,serviceUUID,characteristicUUID,data,function(result){q.resolve(result)},function(error){q.reject(error)}),q.promise},writeWithoutResponse:function(deviceID,serviceUUID,characteristicUUID,data){var q=$q.defer();return ble.writeWithoutResponse(deviceID,serviceUUID,characteristicUUID,data,function(result){q.resolve(result)},function(error){q.reject(error)}),q.promise},writeCommand:function(deviceID,serviceUUID,characteristicUUID,data){return $log.warning("writeCommand is deprecated, use writeWithoutResponse"),this.writeWithoutResponse(deviceID,serviceUUID,characteristicUUID,data)},startNotification:function(deviceID,serviceUUID,characteristicUUID,callback,errorCallback){return ble.startNotification(deviceID,serviceUUID,characteristicUUID,callback,errorCallback)},stopNotification:function(deviceID,serviceUUID,characteristicUUID){var q=$q.defer();return ble.stopNotification(deviceID,serviceUUID,characteristicUUID,function(result){q.resolve(result)},function(error){q.reject(error)}),q.promise},isConnected:function(deviceID){var q=$q.defer();return ble.isConnected(deviceID,function(result){q.resolve(result)},function(error){q.reject(error)}),q.promise},enable:function(){var q=$q.defer();return ble.enable(function(result){q.resolve(result)},function(error){q.reject(error)}),q.promise},isEnabled:function(){var q=$q.defer();return ble.isEnabled(function(result){q.resolve(result)},function(error){q.reject(error)}),q.promise}}}]),angular.module("ngCordova.plugins.bluetoothSerial",[]).factory("$cordovaBluetoothSerial",["$q","$window",function($q,$window){return{connect:function(address){var q=$q.defer(),disconnectionPromise=$q.defer(),isConnected=!1;return $window.bluetoothSerial.connect(address,function(){isConnected=!0,q.resolve(disconnectionPromise)},function(error){!1===isConnected&&disconnectionPromise.reject(error),q.reject(error)}),q.promise},connectInsecure:function(address){var q=$q.defer();return $window.bluetoothSerial.connectInsecure(address,function(){q.resolve()},function(error){q.reject(error)}),q.promise},disconnect:function(){var q=$q.defer();return $window.bluetoothSerial.disconnect(function(){q.resolve()},function(error){q.reject(error)}),q.promise},list:function(){var q=$q.defer();return $window.bluetoothSerial.list(function(data){q.resolve(data)},function(error){q.reject(error)}),q.promise},discoverUnpaired:function(){var q=$q.defer();return $window.bluetoothSerial.discoverUnpaired(function(data){q.resolve(data)},function(error){q.reject(error)}),q.promise},setDeviceDiscoveredListener:function(){var q=$q.defer();return $window.bluetoothSerial.setDeviceDiscoveredListener(function(data){q.notify(data)}),q.promise},clearDeviceDiscoveredListener:function(){$window.bluetoothSerial.clearDeviceDiscoveredListener()},showBluetoothSettings:function(){var q=$q.defer();return $window.bluetoothSerial.showBluetoothSettings(function(){q.resolve()},function(error){q.reject(error)}),q.promise},isEnabled:function(){var q=$q.defer();return $window.bluetoothSerial.isEnabled(function(){q.resolve()},function(){q.reject()}),q.promise},enable:function(){var q=$q.defer();return $window.bluetoothSerial.enable(function(){q.resolve()},function(){q.reject()}),q.promise},isConnected:function(){var q=$q.defer();return $window.bluetoothSerial.isConnected(function(){q.resolve()},function(){q.reject()}),q.promise},available:function(){var q=$q.defer();return $window.bluetoothSerial.available(function(data){q.resolve(data)},function(error){q.reject(error)}),q.promise},read:function(){var q=$q.defer();return $window.bluetoothSerial.read(function(data){q.resolve(data)},function(error){q.reject(error)}),q.promise},readUntil:function(delimiter){var q=$q.defer();return $window.bluetoothSerial.readUntil(delimiter,function(data){q.resolve(data)},function(error){q.reject(error)}),q.promise},write:function(data){var q=$q.defer();return $window.bluetoothSerial.write(data,function(){q.resolve()},function(error){q.reject(error)}),q.promise},subscribe:function(delimiter){var q=$q.defer();return $window.bluetoothSerial.subscribe(delimiter,function(data){q.notify(data)},function(error){q.reject(error)}),q.promise},subscribeRawData:function(){var q=$q.defer();return $window.bluetoothSerial.subscribeRawData(function(data){q.notify(data)},function(error){q.reject(error)}),q.promise},unsubscribe:function(){var q=$q.defer();return $window.bluetoothSerial.unsubscribe(function(){q.resolve()},function(error){q.reject(error)}),q.promise},unsubscribeRawData:function(){var q=$q.defer();return $window.bluetoothSerial.unsubscribeRawData(function(){q.resolve()},function(error){q.reject(error)}),q.promise},clear:function(){var q=$q.defer();return $window.bluetoothSerial.clear(function(){q.resolve()},function(error){q.reject(error)}),q.promise},readRSSI:function(){var q=$q.defer();return $window.bluetoothSerial.readRSSI(function(data){q.resolve(data)},function(error){q.reject(error)}),q.promise}}}]),angular.module("ngCordova.plugins.brightness",[]).factory("$cordovaBrightness",["$q","$window",function($q,$window){return{get:function(){var q=$q.defer();return $window.cordova?$window.cordova.plugins.brightness.getBrightness(function(result){q.resolve(result)},function(err){q.reject(err)}):q.reject("Not supported without cordova.js"),q.promise},set:function(data){var q=$q.defer();return $window.cordova?$window.cordova.plugins.brightness.setBrightness(data,function(result){q.resolve(result)},function(err){q.reject(err)}):q.reject("Not supported without cordova.js"),q.promise},setKeepScreenOn:function(bool){var q=$q.defer();return $window.cordova?$window.cordova.plugins.brightness.setKeepScreenOn(bool,function(result){q.resolve(result)},function(err){q.reject(err)}):q.reject("Not supported without cordova.js"),q.promise}}}]),angular.module("ngCordova.plugins.calendar",[]).factory("$cordovaCalendar",["$q","$window",function($q,$window){return{createCalendar:function(options){var d=$q.defer(),createCalOptions=$window.plugins.calendar.getCreateCalendarOptions();return"string"==typeof options?createCalOptions.calendarName=options:createCalOptions=angular.extend(createCalOptions,options),$window.plugins.calendar.createCalendar(createCalOptions,function(message){d.resolve(message)},function(error){d.reject(error)}),d.promise},deleteCalendar:function(calendarName){var d=$q.defer();return $window.plugins.calendar.deleteCalendar(calendarName,function(message){d.resolve(message)},function(error){d.reject(error)}),d.promise},createEvent:function(options){var d=$q.defer(),defaultOptions={title:null,location:null,notes:null,startDate:null,endDate:null};return defaultOptions=angular.extend(defaultOptions,options),$window.plugins.calendar.createEvent(defaultOptions.title,defaultOptions.location,defaultOptions.notes,new Date(defaultOptions.startDate),new Date(defaultOptions.endDate),function(message){d.resolve(message)},function(error){d.reject(error)}),d.promise},createEventWithOptions:function(options){var d=$q.defer(),defaultOptionKeys=[],calOptions=window.plugins.calendar.getCalendarOptions(),defaultOptions={title:null,location:null,notes:null,startDate:null,endDate:null};defaultOptionKeys=Object.keys(defaultOptions);for(var key in options)-1===defaultOptionKeys.indexOf(key)?calOptions[key]=options[key]:defaultOptions[key]=options[key];return $window.plugins.calendar.createEventWithOptions(defaultOptions.title,defaultOptions.location,defaultOptions.notes,new Date(defaultOptions.startDate),new Date(defaultOptions.endDate),calOptions,function(message){d.resolve(message)},function(error){d.reject(error)}),d.promise},createEventInteractively:function(options){var d=$q.defer(),defaultOptions={title:null,location:null,notes:null,startDate:null,endDate:null};return defaultOptions=angular.extend(defaultOptions,options),$window.plugins.calendar.createEventInteractively(defaultOptions.title,defaultOptions.location,defaultOptions.notes,new Date(defaultOptions.startDate),new Date(defaultOptions.endDate),function(message){d.resolve(message)},function(error){d.reject(error)}),d.promise},createEventInNamedCalendar:function(options){var d=$q.defer(),defaultOptions={title:null,location:null,notes:null,startDate:null,endDate:null,calendarName:null};return defaultOptions=angular.extend(defaultOptions,options),$window.plugins.calendar.createEventInNamedCalendar(defaultOptions.title,defaultOptions.location,defaultOptions.notes,new Date(defaultOptions.startDate),new Date(defaultOptions.endDate),defaultOptions.calendarName,function(message){d.resolve(message)},function(error){d.reject(error)}),d.promise},findEvent:function(options){var d=$q.defer(),defaultOptions={title:null,location:null,notes:null,startDate:null,endDate:null};return defaultOptions=angular.extend(defaultOptions,options),$window.plugins.calendar.findEvent(defaultOptions.title,defaultOptions.location,defaultOptions.notes,new Date(defaultOptions.startDate),new Date(defaultOptions.endDate),function(foundEvent){d.resolve(foundEvent)},function(error){d.reject(error)}),d.promise},listEventsInRange:function(startDate,endDate){var d=$q.defer();return $window.plugins.calendar.listEventsInRange(startDate,endDate,function(events){d.resolve(events)},function(error){d.reject(error)}),d.promise},listCalendars:function(){var d=$q.defer();return $window.plugins.calendar.listCalendars(function(calendars){d.resolve(calendars)},function(error){d.reject(error)}),d.promise},findAllEventsInNamedCalendar:function(calendarName){var d=$q.defer();return $window.plugins.calendar.findAllEventsInNamedCalendar(calendarName,function(events){d.resolve(events)},function(error){d.reject(error)}),d.promise},modifyEvent:function(options){var d=$q.defer(),defaultOptions={title:null,location:null,notes:null,startDate:null,endDate:null,newTitle:null,newLocation:null,newNotes:null,newStartDate:null,newEndDate:null};return defaultOptions=angular.extend(defaultOptions,options),$window.plugins.calendar.modifyEvent(defaultOptions.title,defaultOptions.location,defaultOptions.notes,new Date(defaultOptions.startDate),new Date(defaultOptions.endDate),defaultOptions.newTitle,defaultOptions.newLocation,defaultOptions.newNotes,new Date(defaultOptions.newStartDate),new Date(defaultOptions.newEndDate),function(message){d.resolve(message)},function(error){d.reject(error)}),d.promise},deleteEvent:function(options){var d=$q.defer(),defaultOptions={newTitle:null,location:null,notes:null,startDate:null,endDate:null};return defaultOptions=angular.extend(defaultOptions,options),$window.plugins.calendar.deleteEvent(defaultOptions.newTitle,defaultOptions.location,defaultOptions.notes,new Date(defaultOptions.startDate),new Date(defaultOptions.endDate),function(message){d.resolve(message)},function(error){d.reject(error)}),d.promise}}}]),angular.module("ngCordova.plugins.camera",[]).factory("$cordovaCamera",["$q",function($q){return{getPicture:function(options){var q=$q.defer();return navigator.camera?(navigator.camera.getPicture(function(imageData){q.resolve(imageData)},function(err){q.reject(err)},options),q.promise):(q.resolve(null),q.promise)},cleanup:function(){var q=$q.defer();return navigator.camera.cleanup(function(){q.resolve()},function(err){q.reject(err)}),q.promise}}}]),angular.module("ngCordova.plugins.capture",[]).factory("$cordovaCapture",["$q",function($q){return{captureAudio:function(options){var q=$q.defer();return navigator.device.capture?(navigator.device.capture.captureAudio(function(audioData){q.resolve(audioData)},function(err){q.reject(err)},options),q.promise):(q.resolve(null),q.promise)},captureImage:function(options){var q=$q.defer();return navigator.device.capture?(navigator.device.capture.captureImage(function(imageData){q.resolve(imageData)},function(err){q.reject(err)},options),q.promise):(q.resolve(null),q.promise)},captureVideo:function(options){var q=$q.defer();return navigator.device.capture?(navigator.device.capture.captureVideo(function(videoData){q.resolve(videoData)},function(err){q.reject(err)},options),q.promise):(q.resolve(null),q.promise)}}}]),angular.module("ngCordova.plugins.cardIO",[]).provider("$cordovaNgCardIO",[function(){var defaultRespFields=["card_type","redacted_card_number","card_number","expiry_month","expiry_year","short_expiry_year","cvv","zip"],defaultScanConfig={expiry:!0,cvv:!0,zip:!1,suppressManual:!1,suppressConfirm:!1,hideLogo:!0};this.setCardIOResponseFields=function(fields){fields&&angular.isArray(fields)&&(defaultRespFields=fields)},this.setScanerConfig=function(config){config&&angular.isObject(config)&&(defaultScanConfig.expiry=config.expiry||!0,defaultScanConfig.cvv=config.cvv||!0,defaultScanConfig.zip=config.zip||!1,defaultScanConfig.suppressManual=config.suppressManual||!1,defaultScanConfig.suppressConfirm=config.suppressConfirm||!1,defaultScanConfig.hideLogo=config.hideLogo||!0)},this.$get=["$q",function($q){return{scanCard:function(){var deferred=$q.defer();return CardIO.scan(defaultScanConfig,function(response){if(null===response)deferred.reject(null);else{for(var respData={},i=0,len=defaultRespFields.length;i<len;i++){var field=defaultRespFields[i];respData[field]="short_expiry_year"===field?String(response.expiry_year).substr(2,2)||"":response[field]||""}deferred.resolve(respData)}},function(){deferred.reject(null)}),deferred.promise}}}]}]),angular.module("ngCordova.plugins.clipboard",[]).factory("$cordovaClipboard",["$q","$window",function($q,$window){return{copy:function(text){var q=$q.defer();return $window.cordova.plugins.clipboard.copy(text,function(){q.resolve()},function(){q.reject()}),q.promise},paste:function(){var q=$q.defer();return $window.cordova.plugins.clipboard.paste(function(text){q.resolve(text)},function(){q.reject()}),q.promise}}}]),angular.module("ngCordova.plugins.contacts",[]).factory("$cordovaContacts",["$q",function($q){return{save:function(contact){var q=$q.defer();return navigator.contacts.create(contact).save(function(result){q.resolve(result)},function(err){q.reject(err)}),q.promise},remove:function(contact){var q=$q.defer();return navigator.contacts.create(contact).remove(function(result){q.resolve(result)},function(err){q.reject(err)}),q.promise},clone:function(contact){return navigator.contacts.create(contact).clone(contact)},find:function(options){var q=$q.defer(),fields=options.fields||["id","displayName"];return delete options.fields,0===Object.keys(options).length?navigator.contacts.find(fields,function(results){q.resolve(results)},function(err){q.reject(err)}):navigator.contacts.find(fields,function(results){q.resolve(results)},function(err){q.reject(err)},options),q.promise},pickContact:function(){var q=$q.defer();return navigator.contacts.pickContact(function(contact){q.resolve(contact)},function(err){q.reject(err)}),q.promise}}}]),angular.module("ngCordova.plugins.datePicker",[]).factory("$cordovaDatePicker",["$window","$q",function($window,$q){return{show:function(options){var q=$q.defer();return options=options||{date:new Date,mode:"date"},$window.datePicker.show(options,function(date){q.resolve(date)},function(error){q.reject(error)}),q.promise}}}]),angular.module("ngCordova.plugins.device",[]).factory("$cordovaDevice",[function(){return{getDevice:function(){return device},getCordova:function(){return device.cordova},getModel:function(){return device.model},getName:function(){return device.name},getPlatform:function(){return device.platform},getUUID:function(){return device.uuid},getVersion:function(){return device.version},getManufacturer:function(){return device.manufacturer}}}]),angular.module("ngCordova.plugins.deviceMotion",[]).factory("$cordovaDeviceMotion",["$q",function($q){return{getCurrentAcceleration:function(){var q=$q.defer();return angular.isUndefined(navigator.accelerometer)||!angular.isFunction(navigator.accelerometer.getCurrentAcceleration)?(q.reject("Device do not support watchAcceleration"),q.promise):(navigator.accelerometer.getCurrentAcceleration(function(result){q.resolve(result)},function(err){q.reject(err)}),q.promise)},watchAcceleration:function(options){var q=$q.defer();if(angular.isUndefined(navigator.accelerometer)||!angular.isFunction(navigator.accelerometer.watchAcceleration))return q.reject("Device do not support watchAcceleration"),q.promise;var watchID=navigator.accelerometer.watchAcceleration(function(result){q.notify(result)},function(err){q.reject(err)},options);return q.promise.cancel=function(){navigator.accelerometer.clearWatch(watchID)},q.promise.clearWatch=function(id){navigator.accelerometer.clearWatch(id||watchID)},q.promise.watchID=watchID,q.promise},clearWatch:function(watchID){return navigator.accelerometer.clearWatch(watchID)}}}]),angular.module("ngCordova.plugins.deviceOrientation",[]).factory("$cordovaDeviceOrientation",["$q",function($q){var defaultOptions={frequency:3e3};return{getCurrentHeading:function(){var q=$q.defer();return navigator.compass?(navigator.compass.getCurrentHeading(function(result){q.resolve(result)},function(err){q.reject(err)}),q.promise):(q.reject("No compass on Device"),q.promise)},watchHeading:function(options){var q=$q.defer();if(!navigator.compass)return q.reject("No compass on Device"),q.promise;var _options=angular.extend(defaultOptions,options),watchID=navigator.compass.watchHeading(function(result){q.notify(result)},function(err){q.reject(err)},_options);return q.promise.cancel=function(){navigator.compass.clearWatch(watchID)},q.promise.clearWatch=function(id){navigator.compass.clearWatch(id||watchID)},q.promise.watchID=watchID,q.promise},clearWatch:function(watchID){return navigator.compass.clearWatch(watchID)}}}]),angular.module("ngCordova.plugins.dialogs",[]).factory("$cordovaDialogs",["$q","$window",function($q,$window){return{alert:function(message,title,buttonName){var q=$q.defer();return $window.navigator.notification?navigator.notification.alert(message,function(){q.resolve()},title,buttonName):($window.alert(message),q.resolve()),q.promise},confirm:function(message,title,buttonLabels){var q=$q.defer();return $window.navigator.notification?navigator.notification.confirm(message,function(buttonIndex){q.resolve(buttonIndex)},title,buttonLabels):$window.confirm(message)?q.resolve(1):q.resolve(2),q.promise},prompt:function(message,title,buttonLabels,defaultText){var q=$q.defer();if($window.navigator.notification)navigator.notification.prompt(message,function(result){q.resolve(result)},title,buttonLabels,defaultText);else{var res=$window.prompt(message,defaultText);null!==res?q.resolve({input1:res,buttonIndex:1}):q.resolve({input1:res,buttonIndex:2})}return q.promise},beep:function(times){return navigator.notification.beep(times)},activityStart:function(message,title){var q=$q.defer();return"android"===cordova.platformId?(navigator.notification.activityStart(title,message),q.resolve()):q.reject(message,title),q.promise},activityStop:function(){var q=$q.defer();return"android"===cordova.platformId?(navigator.notification.activityStop(),q.resolve()):q.reject(),q.promise},progressStart:function(message,title){var q=$q.defer();return"android"===cordova.platformId?(navigator.notification.progressStart(title,message),q.resolve()):q.reject(message,title),q.promise},progressStop:function(){var q=$q.defer();return"android"===cordova.platformId?(navigator.notification.progressStop(),q.resolve()):q.reject(),q.promise},progressValue:function(value){var q=$q.defer();return"android"===cordova.platformId?(navigator.notification.progressValue(value),q.resolve()):q.reject(value),q.promise}}}]),angular.module("ngCordova.plugins.emailComposer",[]).factory("$cordovaEmailComposer",["$q",function($q){return{isAvailable:function(){var q=$q.defer();return cordova.plugins.email.isAvailable(function(isAvailable){isAvailable?q.resolve():q.reject()}),q.promise},open:function(properties){var q=$q.defer();return cordova.plugins.email.open(properties,function(){q.reject()}),q.promise},addAlias:function(app,schema){cordova.plugins.email.addAlias(app,schema)}}}]),angular.module("ngCordova.plugins.facebook",[]).provider("$cordovaFacebook",[function(){this.browserInit=function(id,version){this.appID=id,this.appVersion=version||"v2.0",facebookConnectPlugin.browserInit(this.appID,this.appVersion)},this.$get=["$q",function($q){return{login:function(permissions){var q=$q.defer();return facebookConnectPlugin.login(permissions,function(res){q.resolve(res)},function(res){q.reject(res)}),q.promise},showDialog:function(options){var q=$q.defer();return facebookConnectPlugin.showDialog(options,function(res){q.resolve(res)},function(err){q.reject(err)}),q.promise},api:function(path,permissions){var q=$q.defer();return facebookConnectPlugin.api(path,permissions,function(res){q.resolve(res)},function(err){q.reject(err)}),q.promise},getAccessToken:function(){var q=$q.defer();return facebookConnectPlugin.getAccessToken(function(res){q.resolve(res)},function(err){q.reject(err)}),q.promise},getLoginStatus:function(){var q=$q.defer();return facebookConnectPlugin.getLoginStatus(function(res){q.resolve(res)},function(err){q.reject(err)}),q.promise},logout:function(){var q=$q.defer();return facebookConnectPlugin.logout(function(res){q.resolve(res)},function(err){q.reject(err)}),q.promise}}}]}]),angular.module("ngCordova.plugins.facebookAds",[]).factory("$cordovaFacebookAds",["$q","$window",function($q,$window){return{setOptions:function(options){var d=$q.defer();return $window.FacebookAds.setOptions(options,function(){d.resolve()},function(){d.reject()}),d.promise},createBanner:function(options){var d=$q.defer();return $window.FacebookAds.createBanner(options,function(){d.resolve()},function(){d.reject()}),d.promise},removeBanner:function(){var d=$q.defer();return $window.FacebookAds.removeBanner(function(){d.resolve()},function(){d.reject()}),d.promise},showBanner:function(position){var d=$q.defer();return $window.FacebookAds.showBanner(position,function(){d.resolve()},function(){d.reject()}),d.promise},showBannerAtXY:function(x,y){var d=$q.defer();return $window.FacebookAds.showBannerAtXY(x,y,function(){d.resolve()},function(){d.reject()}),d.promise},hideBanner:function(){var d=$q.defer();return $window.FacebookAds.hideBanner(function(){d.resolve()},function(){d.reject()}),d.promise},prepareInterstitial:function(options){var d=$q.defer();return $window.FacebookAds.prepareInterstitial(options,function(){d.resolve()},function(){d.reject()}),d.promise},showInterstitial:function(){var d=$q.defer();return $window.FacebookAds.showInterstitial(function(){d.resolve()},function(){d.reject()}),d.promise}}}]),angular.module("ngCordova.plugins.file",[]).constant("$cordovaFileError",{1:"NOT_FOUND_ERR",2:"SECURITY_ERR",3:"ABORT_ERR",4:"NOT_READABLE_ERR",5:"ENCODING_ERR",6:"NO_MODIFICATION_ALLOWED_ERR",7:"INVALID_STATE_ERR",8:"SYNTAX_ERR",9:"INVALID_MODIFICATION_ERR",10:"QUOTA_EXCEEDED_ERR",11:"TYPE_MISMATCH_ERR",12:"PATH_EXISTS_ERR"}).provider("$cordovaFile",[function(){this.$get=["$q","$window","$cordovaFileError",function($q,$window,$cordovaFileError){return{getFreeDiskSpace:function(){var q=$q.defer();return cordova.exec(function(result){q.resolve(result)},function(error){q.reject(error)},"File","getFreeDiskSpace",[]),q.promise},checkDir:function(path,dir){var q=$q.defer();/^\//.test(dir)&&q.reject("directory cannot start with /");try{var directory=path+dir;$window.resolveLocalFileSystemURL(directory,function(fileSystem){!0===fileSystem.isDirectory?q.resolve(fileSystem):q.reject({code:13,message:"input is not a directory"})},function(error){error.message=$cordovaFileError[error.code],q.reject(error)})}catch(err){err.message=$cordovaFileError[err.code],q.reject(err)}return q.promise},checkFile:function(path,file){var q=$q.defer();/^\//.test(file)&&q.reject("directory cannot start with /");try{var directory=path+file;$window.resolveLocalFileSystemURL(directory,function(fileSystem){!0===fileSystem.isFile?q.resolve(fileSystem):q.reject({code:13,message:"input is not a file"})},function(error){error.message=$cordovaFileError[error.code],q.reject(error)})}catch(err){err.message=$cordovaFileError[err.code],q.reject(err)}return q.promise},createDir:function(path,dirName,replaceBool){var q=$q.defer();/^\//.test(dirName)&&q.reject("directory cannot start with /");var options={create:!0,exclusive:replaceBool=!replaceBool};try{$window.resolveLocalFileSystemURL(path,function(fileSystem){fileSystem.getDirectory(dirName,options,function(result){q.resolve(result)},function(error){error.message=$cordovaFileError[error.code],q.reject(error)})},function(err){err.message=$cordovaFileError[err.code],q.reject(err)})}catch(e){e.message=$cordovaFileError[e.code],q.reject(e)}return q.promise},createFile:function(path,fileName,replaceBool){var q=$q.defer();/^\//.test(fileName)&&q.reject("file-name cannot start with /");var options={create:!0,exclusive:replaceBool=!replaceBool};try{$window.resolveLocalFileSystemURL(path,function(fileSystem){fileSystem.getFile(fileName,options,function(result){q.resolve(result)},function(error){error.message=$cordovaFileError[error.code],q.reject(error)})},function(err){err.message=$cordovaFileError[err.code],q.reject(err)})}catch(e){e.message=$cordovaFileError[e.code],q.reject(e)}return q.promise},removeDir:function(path,dirName){var q=$q.defer();/^\//.test(dirName)&&q.reject("file-name cannot start with /");try{$window.resolveLocalFileSystemURL(path,function(fileSystem){fileSystem.getDirectory(dirName,{create:!1},function(dirEntry){dirEntry.remove(function(){q.resolve({success:!0,fileRemoved:dirEntry})},function(error){error.message=$cordovaFileError[error.code],q.reject(error)})},function(err){err.message=$cordovaFileError[err.code],q.reject(err)})},function(er){er.message=$cordovaFileError[er.code],q.reject(er)})}catch(e){e.message=$cordovaFileError[e.code],q.reject(e)}return q.promise},removeFile:function(path,fileName){var q=$q.defer();/^\//.test(fileName)&&q.reject("file-name cannot start with /");try{$window.resolveLocalFileSystemURL(path,function(fileSystem){fileSystem.getFile(fileName,{create:!1},function(fileEntry){fileEntry.remove(function(){q.resolve({success:!0,fileRemoved:fileEntry})},function(error){error.message=$cordovaFileError[error.code],q.reject(error)})},function(err){err.message=$cordovaFileError[err.code],q.reject(err)})},function(er){er.message=$cordovaFileError[er.code],q.reject(er)})}catch(e){e.message=$cordovaFileError[e.code],q.reject(e)}return q.promise},removeRecursively:function(path,dirName){var q=$q.defer();/^\//.test(dirName)&&q.reject("file-name cannot start with /");try{$window.resolveLocalFileSystemURL(path,function(fileSystem){fileSystem.getDirectory(dirName,{create:!1},function(dirEntry){dirEntry.removeRecursively(function(){q.resolve({success:!0,fileRemoved:dirEntry})},function(error){error.message=$cordovaFileError[error.code],q.reject(error)})},function(err){err.message=$cordovaFileError[err.code],q.reject(err)})},function(er){er.message=$cordovaFileError[er.code],q.reject(er)})}catch(e){e.message=$cordovaFileError[e.code],q.reject(e)}return q.promise},writeFile:function(path,fileName,text,replaceBool){var q=$q.defer();/^\//.test(fileName)&&q.reject("file-name cannot start with /");var options={create:!0,exclusive:replaceBool=!replaceBool};try{$window.resolveLocalFileSystemURL(path,function(fileSystem){fileSystem.getFile(fileName,options,function(fileEntry){fileEntry.createWriter(function(writer){!0===options.append&&writer.seek(writer.length),options.truncate&&writer.truncate(options.truncate),writer.onwriteend=function(evt){this.error?q.reject(this.error):q.resolve(evt)},writer.write(text),q.promise.abort=function(){writer.abort()}})},function(error){error.message=$cordovaFileError[error.code],q.reject(error)})},function(err){err.message=$cordovaFileError[err.code],q.reject(err)})}catch(e){e.message=$cordovaFileError[e.code],q.reject(e)}return q.promise},writeExistingFile:function(path,fileName,text){var q=$q.defer();/^\//.test(fileName)&&q.reject("file-name cannot start with /");try{$window.resolveLocalFileSystemURL(path,function(fileSystem){fileSystem.getFile(fileName,{create:!1},function(fileEntry){fileEntry.createWriter(function(writer){writer.seek(writer.length),writer.onwriteend=function(evt){this.error?q.reject(this.error):q.resolve(evt)},writer.write(text),q.promise.abort=function(){writer.abort()}})},function(error){error.message=$cordovaFileError[error.code],q.reject(error)})},function(err){err.message=$cordovaFileError[err.code],q.reject(err)})}catch(e){e.message=$cordovaFileError[e.code],q.reject(e)}return q.promise},readAsText:function(path,file){var q=$q.defer();/^\//.test(file)&&q.reject("file-name cannot start with /");try{$window.resolveLocalFileSystemURL(path,function(fileSystem){fileSystem.getFile(file,{create:!1},function(fileEntry){fileEntry.file(function(fileData){var reader=new FileReader;reader.onloadend=function(evt){void 0!==evt.target.result||null!==evt.target.result?q.resolve(evt.target.result):void 0!==evt.target.error||null!==evt.target.error?q.reject(evt.target.error):q.reject({code:null,message:"READER_ONLOADEND_ERR"})},reader.readAsText(fileData)})},function(error){error.message=$cordovaFileError[error.code],q.reject(error)})},function(err){err.message=$cordovaFileError[err.code],q.reject(err)})}catch(e){e.message=$cordovaFileError[e.code],q.reject(e)}return q.promise},readAsDataURL:function(path,file){var q=$q.defer();/^\//.test(file)&&q.reject("file-name cannot start with /");try{$window.resolveLocalFileSystemURL(path,function(fileSystem){fileSystem.getFile(file,{create:!1},function(fileEntry){fileEntry.file(function(fileData){var reader=new FileReader;reader.onloadend=function(evt){void 0!==evt.target.result||null!==evt.target.result?q.resolve(evt.target.result):void 0!==evt.target.error||null!==evt.target.error?q.reject(evt.target.error):q.reject({code:null,message:"READER_ONLOADEND_ERR"})},reader.readAsDataURL(fileData)})},function(error){error.message=$cordovaFileError[error.code],q.reject(error)})},function(err){err.message=$cordovaFileError[err.code],q.reject(err)})}catch(e){e.message=$cordovaFileError[e.code],q.reject(e)}return q.promise},readAsBinaryString:function(path,file){var q=$q.defer();/^\//.test(file)&&q.reject("file-name cannot start with /");try{$window.resolveLocalFileSystemURL(path,function(fileSystem){fileSystem.getFile(file,{create:!1},function(fileEntry){fileEntry.file(function(fileData){var reader=new FileReader;reader.onloadend=function(evt){void 0!==evt.target.result||null!==evt.target.result?q.resolve(evt.target.result):void 0!==evt.target.error||null!==evt.target.error?q.reject(evt.target.error):q.reject({code:null,message:"READER_ONLOADEND_ERR"})},reader.readAsBinaryString(fileData)})},function(error){error.message=$cordovaFileError[error.code],q.reject(error)})},function(err){err.message=$cordovaFileError[err.code],q.reject(err)})}catch(e){e.message=$cordovaFileError[e.code],q.reject(e)}return q.promise},readAsArrayBuffer:function(path,file){var q=$q.defer();/^\//.test(file)&&q.reject("file-name cannot start with /");try{$window.resolveLocalFileSystemURL(path,function(fileSystem){fileSystem.getFile(file,{create:!1},function(fileEntry){fileEntry.file(function(fileData){var reader=new FileReader;reader.onloadend=function(evt){void 0!==evt.target.result||null!==evt.target.result?q.resolve(evt.target.result):void 0!==evt.target.error||null!==evt.target.error?q.reject(evt.target.error):q.reject({code:null,message:"READER_ONLOADEND_ERR"})},reader.readAsArrayBuffer(fileData)})},function(error){error.message=$cordovaFileError[error.code],q.reject(error)})},function(err){err.message=$cordovaFileError[err.code],q.reject(err)})}catch(e){e.message=$cordovaFileError[e.code],q.reject(e)}return q.promise},moveFile:function(path,fileName,newPath,newFileName){var q=$q.defer();newFileName=newFileName||fileName,(/^\//.test(fileName)||/^\//.test(newFileName))&&q.reject("file-name cannot start with /");try{$window.resolveLocalFileSystemURL(path,function(fileSystem){fileSystem.getFile(fileName,{create:!1},function(fileEntry){$window.resolveLocalFileSystemURL(newPath,function(newFileEntry){fileEntry.moveTo(newFileEntry,newFileName,function(result){q.resolve(result)},function(error){q.reject(error)})},function(err){q.reject(err)})},function(err){q.reject(err)})},function(er){q.reject(er)})}catch(e){q.reject(e)}return q.promise},moveDir:function(path,dirName,newPath,newDirName){var q=$q.defer();newDirName=newDirName||dirName,(/^\//.test(dirName)||/^\//.test(newDirName))&&q.reject("file-name cannot start with /");try{$window.resolveLocalFileSystemURL(path,function(fileSystem){fileSystem.getDirectory(dirName,{create:!1},function(dirEntry){$window.resolveLocalFileSystemURL(newPath,function(newDirEntry){dirEntry.moveTo(newDirEntry,newDirName,function(result){q.resolve(result)},function(error){q.reject(error)})},function(erro){q.reject(erro)})},function(err){q.reject(err)})},function(er){q.reject(er)})}catch(e){q.reject(e)}return q.promise},copyDir:function(path,dirName,newPath,newDirName){var q=$q.defer();newDirName=newDirName||dirName,(/^\//.test(dirName)||/^\//.test(newDirName))&&q.reject("file-name cannot start with /");try{$window.resolveLocalFileSystemURL(path,function(fileSystem){fileSystem.getDirectory(dirName,{create:!1,exclusive:!1},function(dirEntry){$window.resolveLocalFileSystemURL(newPath,function(newDirEntry){dirEntry.copyTo(newDirEntry,newDirName,function(result){q.resolve(result)},function(error){error.message=$cordovaFileError[error.code],q.reject(error)})},function(erro){erro.message=$cordovaFileError[erro.code],q.reject(erro)})},function(err){err.message=$cordovaFileError[err.code],q.reject(err)})},function(er){er.message=$cordovaFileError[er.code],q.reject(er)})}catch(e){e.message=$cordovaFileError[e.code],q.reject(e)}return q.promise},copyFile:function(path,fileName,newPath,newFileName){var q=$q.defer();newFileName=newFileName||fileName,/^\//.test(fileName)&&q.reject("file-name cannot start with /");try{$window.resolveLocalFileSystemURL(path,function(fileSystem){fileSystem.getFile(fileName,{create:!1,exclusive:!1},function(fileEntry){$window.resolveLocalFileSystemURL(newPath,function(newFileEntry){fileEntry.copyTo(newFileEntry,newFileName,function(result){q.resolve(result)},function(error){error.message=$cordovaFileError[error.code],q.reject(error)})},function(erro){erro.message=$cordovaFileError[erro.code],q.reject(erro)})},function(err){err.message=$cordovaFileError[err.code],q.reject(err)})},function(er){er.message=$cordovaFileError[er.code],q.reject(er)})}catch(e){e.message=$cordovaFileError[e.code],q.reject(e)}return q.promise},readFileMetadata:function(path,file){var q=$q.defer();/^\//.test(file)&&q.reject("directory cannot start with /");try{var directory=path+file;$window.resolveLocalFileSystemURL(directory,function(fileEntry){fileEntry.file(function(result){q.resolve(result)},function(error){error.message=$cordovaFileError[error.code],q.reject(error)})},function(err){err.message=$cordovaFileError[err.code],q.reject(err)})}catch(e){e.message=$cordovaFileError[e.code],q.reject(e)}return q.promise}}}]}]),angular.module("ngCordova.plugins.fileOpener2",[]).factory("$cordovaFileOpener2",["$q",function($q){return{open:function(file,type){var q=$q.defer();return cordova.plugins.fileOpener2.open(file,type,{error:function(e){q.reject(e)},success:function(){q.resolve()}}),q.promise},uninstall:function(pack){var q=$q.defer();return cordova.plugins.fileOpener2.uninstall(pack,{error:function(e){q.reject(e)},success:function(){q.resolve()}}),q.promise},appIsInstalled:function(pack){var q=$q.defer();return cordova.plugins.fileOpener2.appIsInstalled(pack,{success:function(res){q.resolve(res)}}),q.promise}}}]),angular.module("ngCordova.plugins.fileTransfer",[]).factory("$cordovaFileTransfer",["$q","$timeout",function($q,$timeout){return{download:function(source,filePath,options,trustAllHosts){var q=$q.defer(),ft=new FileTransfer,uri=options&&!1===options.encodeURI?source:encodeURI(source);return options&&void 0!==options.timeout&&null!==options.timeout&&($timeout(function(){ft.abort()},options.timeout),options.timeout=null),ft.onprogress=function(progress){q.notify(progress)},q.promise.abort=function(){ft.abort()},ft.download(uri,filePath,q.resolve,q.reject,trustAllHosts,options),q.promise},upload:function(server,filePath,options,trustAllHosts){var q=$q.defer(),ft=new FileTransfer,uri=options&&!1===options.encodeURI?server:encodeURI(server);return options&&void 0!==options.timeout&&null!==options.timeout&&($timeout(function(){ft.abort()},options.timeout),options.timeout=null),ft.onprogress=function(progress){q.notify(progress)},q.promise.abort=function(){ft.abort()},ft.upload(filePath,uri,q.resolve,q.reject,options,trustAllHosts),q.promise}}}]),angular.module("ngCordova.plugins.flashlight",[]).factory("$cordovaFlashlight",["$q","$window",function($q,$window){return{available:function(){var q=$q.defer();return $window.plugins.flashlight.available(function(isAvailable){q.resolve(isAvailable)}),q.promise},switchOn:function(){var q=$q.defer();return $window.plugins.flashlight.switchOn(function(response){q.resolve(response)},function(error){q.reject(error)}),q.promise},switchOff:function(){var q=$q.defer();return $window.plugins.flashlight.switchOff(function(response){q.resolve(response)},function(error){q.reject(error)}),q.promise},toggle:function(){var q=$q.defer();return $window.plugins.flashlight.toggle(function(response){q.resolve(response)},function(error){q.reject(error)}),q.promise}}}]),angular.module("ngCordova.plugins.flurryAds",[]).factory("$cordovaFlurryAds",["$q","$window",function($q,$window){return{setOptions:function(options){var d=$q.defer();return $window.FlurryAds.setOptions(options,function(){d.resolve()},function(){d.reject()}),d.promise},createBanner:function(options){var d=$q.defer();return $window.FlurryAds.createBanner(options,function(){d.resolve()},function(){d.reject()}),d.promise},removeBanner:function(){var d=$q.defer();return $window.FlurryAds.removeBanner(function(){d.resolve()},function(){d.reject()}),d.promise},showBanner:function(position){var d=$q.defer();return $window.FlurryAds.showBanner(position,function(){d.resolve()},function(){d.reject()}),d.promise},showBannerAtXY:function(x,y){var d=$q.defer();return $window.FlurryAds.showBannerAtXY(x,y,function(){d.resolve()},function(){d.reject()}),d.promise},hideBanner:function(){var d=$q.defer();return $window.FlurryAds.hideBanner(function(){d.resolve()},function(){d.reject()}),d.promise},prepareInterstitial:function(options){var d=$q.defer();return $window.FlurryAds.prepareInterstitial(options,function(){d.resolve()},function(){d.reject()}),d.promise},showInterstitial:function(){var d=$q.defer();return $window.FlurryAds.showInterstitial(function(){d.resolve()},function(){d.reject()}),d.promise}}}]),angular.module("ngCordova.plugins.ga",[]).factory("$cordovaGA",["$q","$window",function($q,$window){return{init:function(id,mingap){var q=$q.defer();return mingap=mingap>=0?mingap:10,$window.plugins.gaPlugin.init(function(result){q.resolve(result)},function(error){q.reject(error)},id,mingap),q.promise},trackEvent:function(success,fail,category,eventAction,eventLabel,eventValue){var q=$q.defer();return $window.plugins.gaPlugin.trackEvent(function(result){q.resolve(result)},function(error){q.reject(error)},category,eventAction,eventLabel,eventValue),q.promise},trackPage:function(success,fail,pageURL){var q=$q.defer();return $window.plugins.gaPlugin.trackPage(function(result){q.resolve(result)},function(error){q.reject(error)},pageURL),q.promise},setVariable:function(success,fail,index,value){var q=$q.defer();return $window.plugins.gaPlugin.setVariable(function(result){q.resolve(result)},function(error){q.reject(error)},index,value),q.promise},exit:function(){var q=$q.defer();return $window.plugins.gaPlugin.exit(function(result){q.resolve(result)},function(error){q.reject(error)}),q.promise}}}]),angular.module("ngCordova.plugins.geolocation",[]).factory("$cordovaGeolocation",["$q",function($q){return{getCurrentPosition:function(options){var q=$q.defer();return navigator.geolocation.getCurrentPosition(function(result){q.resolve(result)},function(err){q.reject(err)},options),q.promise},watchPosition:function(options){var q=$q.defer(),watchID=navigator.geolocation.watchPosition(function(result){q.notify(result)},function(err){q.reject(err)},options);return q.promise.cancel=function(){navigator.geolocation.clearWatch(watchID)},q.promise.clearWatch=function(id){navigator.geolocation.clearWatch(id||watchID)},q.promise.watchID=watchID,q.promise},clearWatch:function(watchID){return navigator.geolocation.clearWatch(watchID)}}}]),angular.module("ngCordova.plugins.globalization",[]).factory("$cordovaGlobalization",["$q",function($q){return{getPreferredLanguage:function(){var q=$q.defer();return navigator.globalization.getPreferredLanguage(function(result){q.resolve(result)},function(err){q.reject(err)}),q.promise},getLocaleName:function(){var q=$q.defer();return navigator.globalization.getLocaleName(function(result){q.resolve(result)},function(err){q.reject(err)}),q.promise},getFirstDayOfWeek:function(){var q=$q.defer();return navigator.globalization.getFirstDayOfWeek(function(result){q.resolve(result)},function(err){q.reject(err)}),q.promise},dateToString:function(date,options){var q=$q.defer();return navigator.globalization.dateToString(date,function(result){q.resolve(result)},function(err){q.reject(err)},options),q.promise},stringToDate:function(dateString,options){var q=$q.defer();return navigator.globalization.stringToDate(dateString,function(result){q.resolve(result)},function(err){q.reject(err)},options),q.promise},getDatePattern:function(options){var q=$q.defer();return navigator.globalization.getDatePattern(function(result){q.resolve(result)},function(err){q.reject(err)},options),q.promise},getDateNames:function(options){var q=$q.defer();return navigator.globalization.getDateNames(function(result){q.resolve(result)},function(err){q.reject(err)},options),q.promise},isDayLightSavingsTime:function(date){var q=$q.defer();return navigator.globalization.isDayLightSavingsTime(date,function(result){q.resolve(result)},function(err){q.reject(err)}),q.promise},numberToString:function(number,options){var q=$q.defer();return navigator.globalization.numberToString(number,function(result){q.resolve(result)},function(err){q.reject(err)},options),q.promise},stringToNumber:function(numberString,options){var q=$q.defer();return navigator.globalization.stringToNumber(numberString,function(result){q.resolve(result)},function(err){q.reject(err)},options),q.promise},getNumberPattern:function(options){var q=$q.defer();return navigator.globalization.getNumberPattern(function(result){q.resolve(result)},function(err){q.reject(err)},options),q.promise},getCurrencyPattern:function(currencyCode){var q=$q.defer();return navigator.globalization.getCurrencyPattern(currencyCode,function(result){q.resolve(result)},function(err){q.reject(err)}),q.promise}}}]),angular.module("ngCordova.plugins.googleAds",[]).factory("$cordovaGoogleAds",["$q","$window",function($q,$window){return{setOptions:function(options){var d=$q.defer();return $window.AdMob.setOptions(options,function(){d.resolve()},function(){d.reject()}),d.promise},createBanner:function(options){var d=$q.defer();return $window.AdMob.createBanner(options,function(){d.resolve()},function(){d.reject()}),d.promise},removeBanner:function(){var d=$q.defer();return $window.AdMob.removeBanner(function(){d.resolve()},function(){d.reject()}),d.promise},showBanner:function(position){var d=$q.defer();return $window.AdMob.showBanner(position,function(){d.resolve()},function(){d.reject()}),d.promise},showBannerAtXY:function(x,y){var d=$q.defer();return $window.AdMob.showBannerAtXY(x,y,function(){d.resolve()},function(){d.reject()}),d.promise},hideBanner:function(){var d=$q.defer();return $window.AdMob.hideBanner(function(){d.resolve()},function(){d.reject()}),d.promise},prepareInterstitial:function(options){var d=$q.defer();return $window.AdMob.prepareInterstitial(options,function(){d.resolve()},function(){d.reject()}),d.promise},showInterstitial:function(){var d=$q.defer();return $window.AdMob.showInterstitial(function(){d.resolve()},function(){d.reject()}),d.promise}}}]),angular.module("ngCordova.plugins.googleAnalytics",[]).factory("$cordovaGoogleAnalytics",["$q","$window",function($q,$window){return{startTrackerWithId:function(id){var d=$q.defer();return $window.analytics.startTrackerWithId(id,function(response){d.resolve(response)},function(error){d.reject(error)}),d.promise},setUserId:function(id){var d=$q.defer();return $window.analytics.setUserId(id,function(response){d.resolve(response)},function(error){d.reject(error)}),d.promise},debugMode:function(){var d=$q.defer();return $window.analytics.debugMode(function(response){d.resolve(response)},function(){d.reject()}),d.promise},trackView:function(screenName){var d=$q.defer();return $window.analytics.trackView(screenName,function(response){d.resolve(response)},function(error){d.reject(error)}),d.promise},addCustomDimension:function(key,value){var d=$q.defer();return $window.analytics.addCustomDimension(key,value,function(){d.resolve()},function(error){d.reject(error)}),d.promise},trackEvent:function(category,action,label,value){var d=$q.defer();return $window.analytics.trackEvent(category,action,label,value,function(response){d.resolve(response)},function(error){d.reject(error)}),d.promise},trackException:function(description,fatal){var d=$q.defer();return $window.analytics.trackException(description,fatal,function(response){d.resolve(response)},function(error){d.reject(error)}),d.promise},trackTiming:function(category,milliseconds,variable,label){var d=$q.defer();return $window.analytics.trackTiming(category,milliseconds,variable,label,function(response){d.resolve(response)},function(error){d.reject(error)}),d.promise},addTransaction:function(transactionId,affiliation,revenue,tax,shipping,currencyCode){var d=$q.defer();return $window.analytics.addTransaction(transactionId,affiliation,revenue,tax,shipping,currencyCode,function(response){d.resolve(response)},function(error){d.reject(error)}),d.promise},addTransactionItem:function(transactionId,name,sku,category,price,quantity,currencyCode){var d=$q.defer();return $window.analytics.addTransactionItem(transactionId,name,sku,category,price,quantity,currencyCode,function(response){d.resolve(response)},function(error){d.reject(error)}),d.promise}}}]),angular.module("ngCordova.plugins.googleMap",[]).factory("$cordovaGoogleMap",["$q","$window",function($q,$window){var map=null;return{getMap:function(options){var q=$q.defer();if($window.plugin.google.maps){var div=document.getElementById("map_canvas");(map=$window.plugin.google.maps.Map.getMap(options)).setDiv(div),q.resolve(map)}else q.reject(null);return q.promise},isMapLoaded:function(){return!!map},addMarker:function(markerOptions){var q=$q.defer();return map.addMarker(markerOptions,function(marker){q.resolve(marker)}),q.promise},getMapTypeIds:function(){return $window.plugin.google.maps.mapTypeId},setVisible:function(isVisible){var q=$q.defer();return map.setVisible(isVisible),q.promise},cleanup:function(){map=null}}}]),angular.module("ngCordova.plugins.googlePlayGame",[]).factory("$cordovaGooglePlayGame",["$q",function($q){return{auth:function(){var q=$q.defer();return googleplaygame.auth(function(success){return q.resolve(success)},function(err){return q.reject(err)}),q.promise},signout:function(){var q=$q.defer();return googleplaygame.signout(function(success){return q.resolve(success)},function(err){return q.reject(err)}),q.promise},isSignedIn:function(){var q=$q.defer();return googleplaygame.isSignedIn(function(success){return q.resolve(success)},function(err){return q.reject(err)}),q.promise},showPlayer:function(){var q=$q.defer();return googleplaygame.showPlayer(function(success){return q.resolve(success)},function(err){return q.reject(err)}),q.promise},submitScore:function(data){var q=$q.defer();return googleplaygame.submitScore(data,function(success){return q.resolve(success)},function(err){return q.reject(err)}),q.promise},showAllLeaderboards:function(){var q=$q.defer();return googleplaygame.showAllLeaderboards(function(success){return q.resolve(success)},function(err){return q.reject(err)}),q.promise},showLeaderboard:function(data){var q=$q.defer();return googleplaygame.showLeaderboard(data,function(success){return q.resolve(success)},function(err){return q.reject(err)}),q.promise},unlockAchievement:function(data){var q=$q.defer();return googleplaygame.unlockAchievement(data,function(success){return q.resolve(success)},function(err){return q.reject(err)}),q.promise},incrementAchievement:function(data){var q=$q.defer();return googleplaygame.incrementAchievement(data,function(success){return q.resolve(success)},function(err){return q.reject(err)}),q.promise},showAchievements:function(){var q=$q.defer();return googleplaygame.showAchievements(function(success){return q.resolve(success)},function(err){return q.reject(err)}),q.promise}}}]),angular.module("ngCordova.plugins.googlePlus",[]).factory("$cordovaGooglePlus",["$q","$window",function($q,$window){return{login:function(iosKey){var q=$q.defer();return void 0===iosKey&&(iosKey={}),$window.plugins.googleplus.login({iOSApiKey:iosKey},function(response){q.resolve(response)},function(error){q.reject(error)}),q.promise},silentLogin:function(iosKey){var q=$q.defer();return void 0===iosKey&&(iosKey={}),$window.plugins.googleplus.trySilentLogin({iOSApiKey:iosKey},function(response){q.resolve(response)},function(error){q.reject(error)}),q.promise},logout:function(){var q=$q.defer();$window.plugins.googleplus.logout(function(response){q.resolve(response)})},disconnect:function(){var q=$q.defer();$window.plugins.googleplus.disconnect(function(response){q.resolve(response)})},isAvailable:function(){var q=$q.defer();return $window.plugins.googleplus.isAvailable(function(available){available?q.resolve(available):q.reject(available)}),q.promise}}}]),angular.module("ngCordova.plugins.healthKit",[]).factory("$cordovaHealthKit",["$q","$window",function($q,$window){return{isAvailable:function(){var q=$q.defer();return $window.plugins.healthkit.available(function(success){q.resolve(success)},function(err){q.reject(err)}),q.promise},checkAuthStatus:function(type){var q=$q.defer();return type=type||"HKQuantityTypeIdentifierHeight",$window.plugins.healthkit.checkAuthStatus({type:type},function(success){q.resolve(success)},function(err){q.reject(err)}),q.promise},requestAuthorization:function(readTypes,writeTypes){var q=$q.defer();return readTypes=readTypes||["HKCharacteristicTypeIdentifierDateOfBirth","HKQuantityTypeIdentifierActiveEnergyBurned","HKQuantityTypeIdentifierHeight"],writeTypes=writeTypes||["HKQuantityTypeIdentifierActiveEnergyBurned","HKQuantityTypeIdentifierHeight","HKQuantityTypeIdentifierDistanceCycling"],$window.plugins.healthkit.requestAuthorization({readTypes:readTypes,writeTypes:writeTypes},function(success){q.resolve(success)},function(err){q.reject(err)}),q.promise},readDateOfBirth:function(){var q=$q.defer();return $window.plugins.healthkit.readDateOfBirth(function(success){q.resolve(success)},function(err){q.resolve(err)}),q.promise},readGender:function(){var q=$q.defer();return $window.plugins.healthkit.readGender(function(success){q.resolve(success)},function(err){q.resolve(err)}),q.promise},saveWeight:function(value,units,date){var q=$q.defer();return $window.plugins.healthkit.saveWeight({unit:units||"lb",amount:value,date:date||new Date},function(success){q.resolve(success)},function(err){q.resolve(err)}),q.promise},readWeight:function(units){var q=$q.defer();return $window.plugins.healthkit.readWeight({unit:units||"lb"},function(success){q.resolve(success)},function(err){q.resolve(err)}),q.promise},saveHeight:function(value,units,date){var q=$q.defer();return $window.plugins.healthkit.saveHeight({unit:units||"in",amount:value,date:date||new Date},function(success){q.resolve(success)},function(err){q.resolve(err)}),q.promise},readHeight:function(units){var q=$q.defer();return $window.plugins.healthkit.readHeight({unit:units||"in"},function(success){q.resolve(success)},function(err){q.resolve(err)}),q.promise},findWorkouts:function(){var q=$q.defer();return $window.plugins.healthkit.findWorkouts({},function(success){q.resolve(success)},function(err){q.resolve(err)}),q.promise},saveWorkout:function(workout){var q=$q.defer();return $window.plugins.healthkit.saveWorkout(workout,function(success){q.resolve(success)},function(err){q.resolve(err)}),q.promise},querySampleType:function(sampleQuery){var q=$q.defer();return $window.plugins.healthkit.querySampleType(sampleQuery,function(success){q.resolve(success)},function(err){q.resolve(err)}),q.promise}}}]),angular.module("ngCordova.plugins.httpd",[]).factory("$cordovaHttpd",["$q",function($q){return{startServer:function(options){var d=$q.defer();return cordova.plugins.CorHttpd.startServer(options,function(){d.resolve()},function(){d.reject()}),d.promise},stopServer:function(){var d=$q.defer();return cordova.plugins.CorHttpd.stopServer(function(){d.resolve()},function(){d.reject()}),d.promise},getURL:function(){var d=$q.defer();return cordova.plugins.CorHttpd.getURL(function(url){d.resolve(url)},function(){d.reject()}),d.promise},getLocalPath:function(){var d=$q.defer();return cordova.plugins.CorHttpd.getLocalPath(function(path){d.resolve(path)},function(){d.reject()}),d.promise}}}]),angular.module("ngCordova.plugins.iAd",[]).factory("$cordovaiAd",["$q","$window",function($q,$window){return{setOptions:function(options){var d=$q.defer();return $window.iAd.setOptions(options,function(){d.resolve()},function(){d.reject()}),d.promise},createBanner:function(options){var d=$q.defer();return $window.iAd.createBanner(options,function(){d.resolve()},function(){d.reject()}),d.promise},removeBanner:function(){var d=$q.defer();return $window.iAd.removeBanner(function(){d.resolve()},function(){d.reject()}),d.promise},showBanner:function(position){var d=$q.defer();return $window.iAd.showBanner(position,function(){d.resolve()},function(){d.reject()}),d.promise},showBannerAtXY:function(x,y){var d=$q.defer();return $window.iAd.showBannerAtXY(x,y,function(){d.resolve()},function(){d.reject()}),d.promise},hideBanner:function(){var d=$q.defer();return $window.iAd.hideBanner(function(){d.resolve()},function(){d.reject()}),d.promise},prepareInterstitial:function(options){var d=$q.defer();return $window.iAd.prepareInterstitial(options,function(){d.resolve()},function(){d.reject()}),d.promise},showInterstitial:function(){var d=$q.defer();return $window.iAd.showInterstitial(function(){d.resolve()},function(){d.reject()}),d.promise}}}]),angular.module("ngCordova.plugins.imagePicker",[]).factory("$cordovaImagePicker",["$q","$window",function($q,$window){return{getPictures:function(options){var q=$q.defer();return $window.imagePicker.getPictures(function(results){q.resolve(results)},function(error){q.reject(error)},options),q.promise}}}]),angular.module("ngCordova.plugins.inAppBrowser",[]).provider("$cordovaInAppBrowser",[function(){var ref,defaultOptions=this.defaultOptions={};this.setDefaultOptions=function(config){defaultOptions=angular.extend(defaultOptions,config)},this.$get=["$rootScope","$q","$window","$timeout",function($rootScope,$q,$window,$timeout){return{open:function(url,target,requestOptions){var q=$q.defer();if(requestOptions&&!angular.isObject(requestOptions))return q.reject("options must be an object"),q.promise;var options=angular.extend({},defaultOptions,requestOptions),opt=[];angular.forEach(options,function(value,key){opt.push(key+"="+value)});var optionsString=opt.join();return(ref=$window.open(url,target,optionsString)).addEventListener("loadstart",function(event){$timeout(function(){$rootScope.$broadcast("$cordovaInAppBrowser:loadstart",event)})},!1),ref.addEventListener("loadstop",function(event){q.resolve(event),$timeout(function(){$rootScope.$broadcast("$cordovaInAppBrowser:loadstop",event)})},!1),ref.addEventListener("loaderror",function(event){q.reject(event),$timeout(function(){$rootScope.$broadcast("$cordovaInAppBrowser:loaderror",event)})},!1),ref.addEventListener("exit",function(event){$timeout(function(){$rootScope.$broadcast("$cordovaInAppBrowser:exit",event)})},!1),q.promise},close:function(){ref.close(),ref=null},show:function(){ref.show()},executeScript:function(details){var q=$q.defer();return ref.executeScript(details,function(result){q.resolve(result)}),q.promise},insertCSS:function(details){var q=$q.defer();return ref.insertCSS(details,function(result){q.resolve(result)}),q.promise}}}]}]),angular.module("ngCordova.plugins.insomnia",[]).factory("$cordovaInsomnia",["$window",function($window){return{keepAwake:function(){return $window.plugins.insomnia.keepAwake()},allowSleepAgain:function(){return $window.plugins.insomnia.allowSleepAgain()}}}]),angular.module("ngCordova.plugins.instagram",[]).factory("$cordovaInstagram",["$q",function($q){return{share:function(options){var q=$q.defer();return window.Instagram?(Instagram.share(options.image,options.caption,function(err){err?q.reject(err):q.resolve(!0)}),q.promise):(q.resolve(null),q.promise)},isInstalled:function(){var q=$q.defer();return window.Instagram?(Instagram.isInstalled(function(err,installed){err?q.reject(err):q.resolve(installed)}),q.promise):(q.resolve(null),q.promise)}}}]),angular.module("ngCordova.plugins.keyboard",[]).factory("$cordovaKeyboard",["$rootScope",function($rootScope){var keyboardShowEvent=function(){$rootScope.$evalAsync(function(){$rootScope.$broadcast("$cordovaKeyboard:show")})},keyboardHideEvent=function(){$rootScope.$evalAsync(function(){$rootScope.$broadcast("$cordovaKeyboard:hide")})};return document.addEventListener("deviceready",function(){cordova.plugins.Keyboard&&(window.addEventListener("native.keyboardshow",keyboardShowEvent,!1),window.addEventListener("native.keyboardhide",keyboardHideEvent,!1))}),{hideAccessoryBar:function(bool){return cordova.plugins.Keyboard.hideKeyboardAccessoryBar(bool)},close:function(){return cordova.plugins.Keyboard.close()},show:function(){return cordova.plugins.Keyboard.show()},disableScroll:function(bool){return cordova.plugins.Keyboard.disableScroll(bool)},isVisible:function(){return cordova.plugins.Keyboard.isVisible},clearShowWatch:function(){document.removeEventListener("native.keyboardshow",keyboardShowEvent),$rootScope.$$listeners["$cordovaKeyboard:show"]=[]},clearHideWatch:function(){document.removeEventListener("native.keyboardhide",keyboardHideEvent),$rootScope.$$listeners["$cordovaKeyboard:hide"]=[]}}}]),angular.module("ngCordova.plugins.keychain",[]).factory("$cordovaKeychain",["$q",function($q){return{getForKey:function(key,serviceName){var defer=$q.defer();return(new Keychain).getForKey(defer.resolve,defer.reject,key,serviceName),defer.promise},setForKey:function(key,serviceName,value){var defer=$q.defer();return(new Keychain).setForKey(defer.resolve,defer.reject,key,serviceName,value),defer.promise},removeForKey:function(key,serviceName){var defer=$q.defer();return(new Keychain).removeForKey(defer.resolve,defer.reject,key,serviceName),defer.promise}}}]),angular.module("ngCordova.plugins.launchNavigator",[]).factory("$cordovaLaunchNavigator",["$q",function($q){return{navigate:function(destination,start,options){var q=$q.defer();return launchnavigator.navigate(destination,start,function(){q.resolve()},function(error){q.reject(error)},options),q.promise}}}]),angular.module("ngCordova.plugins.localNotification",[]).factory("$cordovaLocalNotification",["$q","$window","$rootScope","$timeout",function($q,$window,$rootScope,$timeout){return document.addEventListener("deviceready",function(){$window.cordova&&$window.cordova.plugins&&$window.cordova.plugins.notification&&$window.cordova.plugins.notification.local&&($window.cordova.plugins.notification.local.on("schedule",function(notification,state){$timeout(function(){$rootScope.$broadcast("$cordovaLocalNotification:schedule",notification,state)})}),$window.cordova.plugins.notification.local.on("trigger",function(notification,state){$timeout(function(){$rootScope.$broadcast("$cordovaLocalNotification:trigger",notification,state)})}),$window.cordova.plugins.notification.local.on("update",function(notification,state){$timeout(function(){$rootScope.$broadcast("$cordovaLocalNotification:update",notification,state)})}),$window.cordova.plugins.notification.local.on("clear",function(notification,state){$timeout(function(){$rootScope.$broadcast("$cordovaLocalNotification:clear",notification,state)})}),$window.cordova.plugins.notification.local.on("clearall",function(state){$timeout(function(){$rootScope.$broadcast("$cordovaLocalNotification:clearall",state)})}),$window.cordova.plugins.notification.local.on("cancel",function(notification,state){$timeout(function(){$rootScope.$broadcast("$cordovaLocalNotification:cancel",notification,state)})}),$window.cordova.plugins.notification.local.on("cancelall",function(state){$timeout(function(){$rootScope.$broadcast("$cordovaLocalNotification:cancelall",state)})}),$window.cordova.plugins.notification.local.on("click",function(notification,state){$timeout(function(){$rootScope.$broadcast("$cordovaLocalNotification:click",notification,state)})}))},!1),{schedule:function(options,scope){var q=$q.defer();return scope=scope||null,$window.cordova.plugins.notification.local.schedule(options,function(result){q.resolve(result)},scope),q.promise},add:function(options,scope){var q=$q.defer();return scope=scope||null,$window.cordova.plugins.notification.local.schedule(options,function(result){q.resolve(result)},scope),q.promise},update:function(options,scope){var q=$q.defer();return scope=scope||null,$window.cordova.plugins.notification.local.update(options,function(result){q.resolve(result)},scope),q.promise},clear:function(ids,scope){var q=$q.defer();return scope=scope||null,$window.cordova.plugins.notification.local.clear(ids,function(result){q.resolve(result)},scope),q.promise},clearAll:function(scope){var q=$q.defer();return scope=scope||null,$window.cordova.plugins.notification.local.clearAll(function(result){q.resolve(result)},scope),q.promise},cancel:function(ids,scope){var q=$q.defer();return scope=scope||null,$window.cordova.plugins.notification.local.cancel(ids,function(result){q.resolve(result)},scope),q.promise},cancelAll:function(scope){var q=$q.defer();return scope=scope||null,$window.cordova.plugins.notification.local.cancelAll(function(result){q.resolve(result)},scope),q.promise},isPresent:function(id,scope){var q=$q.defer();return scope=scope||null,$window.cordova.plugins.notification.local.isPresent(id,function(result){q.resolve(result)},scope),q.promise},isScheduled:function(id,scope){var q=$q.defer();return scope=scope||null,$window.cordova.plugins.notification.local.isScheduled(id,function(result){q.resolve(result)},scope),q.promise},isTriggered:function(id,scope){var q=$q.defer();return scope=scope||null,$window.cordova.plugins.notification.local.isTriggered(id,function(result){q.resolve(result)},scope),q.promise},hasPermission:function(scope){var q=$q.defer();return scope=scope||null,$window.cordova.plugins.notification.local.hasPermission(function(result){result?q.resolve(result):q.reject(result)},scope),q.promise},registerPermission:function(scope){var q=$q.defer();return scope=scope||null,$window.cordova.plugins.notification.local.registerPermission(function(result){result?q.resolve(result):q.reject(result)},scope),q.promise},promptForPermission:function(scope){var q=$q.defer();return scope=scope||null,$window.cordova.plugins.notification.local.registerPermission(function(result){result?q.resolve(result):q.reject(result)},scope),q.promise},getAllIds:function(scope){var q=$q.defer();return scope=scope||null,$window.cordova.plugins.notification.local.getAllIds(function(result){q.resolve(result)},scope),q.promise},getIds:function(scope){var q=$q.defer();return scope=scope||null,$window.cordova.plugins.notification.local.getIds(function(result){q.resolve(result)},scope),q.promise},getScheduledIds:function(scope){var q=$q.defer();return scope=scope||null,$window.cordova.plugins.notification.local.getScheduledIds(function(result){q.resolve(result)},scope),q.promise},getTriggeredIds:function(scope){var q=$q.defer();return scope=scope||null,$window.cordova.plugins.notification.local.getTriggeredIds(function(result){q.resolve(result)},scope),q.promise},get:function(ids,scope){var q=$q.defer();return scope=scope||null,$window.cordova.plugins.notification.local.get(ids,function(result){q.resolve(result)},scope),q.promise},getAll:function(scope){var q=$q.defer();return scope=scope||null,$window.cordova.plugins.notification.local.getAll(function(result){q.resolve(result)},scope),q.promise},getScheduled:function(ids,scope){var q=$q.defer();return scope=scope||null,$window.cordova.plugins.notification.local.getScheduled(ids,function(result){q.resolve(result)},scope),q.promise},getAllScheduled:function(scope){var q=$q.defer();return scope=scope||null,$window.cordova.plugins.notification.local.getAllScheduled(function(result){q.resolve(result)},scope),q.promise},getTriggered:function(ids,scope){var q=$q.defer();return scope=scope||null,$window.cordova.plugins.notification.local.getTriggered(ids,function(result){q.resolve(result)},scope),q.promise},getAllTriggered:function(scope){var q=$q.defer();return scope=scope||null,$window.cordova.plugins.notification.local.getAllTriggered(function(result){q.resolve(result)},scope),q.promise},getDefaults:function(){return $window.cordova.plugins.notification.local.getDefaults()},setDefaults:function(Object){$window.cordova.plugins.notification.local.setDefaults(Object)}}}]),angular.module("ngCordova.plugins.mMediaAds",[]).factory("$cordovaMMediaAds",["$q","$window",function($q,$window){return{setOptions:function(options){var d=$q.defer();return $window.mMedia.setOptions(options,function(){d.resolve()},function(){d.reject()}),d.promise},createBanner:function(options){var d=$q.defer();return $window.mMedia.createBanner(options,function(){d.resolve()},function(){d.reject()}),d.promise},removeBanner:function(){var d=$q.defer();return $window.mMedia.removeBanner(function(){d.resolve()},function(){d.reject()}),d.promise},showBanner:function(position){var d=$q.defer();return $window.mMedia.showBanner(position,function(){d.resolve()},function(){d.reject()}),d.promise},showBannerAtXY:function(x,y){var d=$q.defer();return $window.mMedia.showBannerAtXY(x,y,function(){d.resolve()},function(){d.reject()}),d.promise},hideBanner:function(){var d=$q.defer();return $window.mMedia.hideBanner(function(){d.resolve()},function(){d.reject()}),d.promise},prepareInterstitial:function(options){var d=$q.defer();return $window.mMedia.prepareInterstitial(options,function(){d.resolve()},function(){d.reject()}),d.promise},showInterstitial:function(){var d=$q.defer();return $window.mMedia.showInterstitial(function(){d.resolve()},function(){d.reject()}),d.promise}}}]),angular.module("ngCordova.plugins.media",[]).service("NewMedia",["$q","$interval",function($q,$interval){function setTimer(media){angular.isDefined(mediaTimer)||(mediaTimer=$interval(function(){mediaDuration<0&&(mediaDuration=media.getDuration(),q&&mediaDuration>0&&q.notify({duration:mediaDuration})),media.getCurrentPosition(function(position){position>-1&&(mediaPosition=position)},function(e){}),q&&q.notify({position:mediaPosition})},1e3))}function clearTimer(){angular.isDefined(mediaTimer)&&($interval.cancel(mediaTimer),mediaTimer=void 0)}function resetValues(){mediaPosition=-1,mediaDuration=-1}function NewMedia(src){this.media=new Media(src,function(success){clearTimer(),resetValues(),q.resolve(success)},function(error){clearTimer(),resetValues(),q.reject(error)},function(status){mediaStatus=status,q.notify({status:mediaStatus})})}var q,q2,q3,mediaTimer,mediaStatus=null,mediaPosition=-1,mediaDuration=-1;return NewMedia.prototype.play=function(options){return q=$q.defer(),"object"!=typeof options&&(options={}),this.media.play(options),setTimer(this.media),q.promise},NewMedia.prototype.pause=function(){clearTimer(),this.media.pause()},NewMedia.prototype.stop=function(){this.media.stop()},NewMedia.prototype.release=function(){this.media.release(),this.media=void 0},NewMedia.prototype.seekTo=function(timing){this.media.seekTo(timing)},NewMedia.prototype.setVolume=function(volume){this.media.setVolume(volume)},NewMedia.prototype.startRecord=function(){this.media.startRecord()},NewMedia.prototype.stopRecord=function(){this.media.stopRecord()},NewMedia.prototype.currentTime=function(){return q2=$q.defer(),this.media.getCurrentPosition(function(position){q2.resolve(position)}),q2.promise},NewMedia.prototype.getDuration=function(){return q3=$q.defer(),this.media.getDuration(function(duration){q3.resolve(duration)}),q3.promise},NewMedia}]).factory("$cordovaMedia",["NewMedia",function(NewMedia){return{newMedia:function(src){return new NewMedia(src)}}}]),angular.module("ngCordova.plugins.mobfoxAds",[]).factory("$cordovaMobFoxAds",["$q","$window",function($q,$window){return{setOptions:function(options){var d=$q.defer();return $window.MobFox.setOptions(options,function(){d.resolve()},function(){d.reject()}),d.promise},createBanner:function(options){var d=$q.defer();return $window.MobFox.createBanner(options,function(){d.resolve()},function(){d.reject()}),d.promise},removeBanner:function(){var d=$q.defer();return $window.MobFox.removeBanner(function(){d.resolve()},function(){d.reject()}),d.promise},showBanner:function(position){var d=$q.defer();return $window.MobFox.showBanner(position,function(){d.resolve()},function(){d.reject()}),d.promise},showBannerAtXY:function(x,y){var d=$q.defer();return $window.MobFox.showBannerAtXY(x,y,function(){d.resolve()},function(){d.reject()}),d.promise},hideBanner:function(){var d=$q.defer();return $window.MobFox.hideBanner(function(){d.resolve()},function(){d.reject()}),d.promise},prepareInterstitial:function(options){var d=$q.defer();return $window.MobFox.prepareInterstitial(options,function(){d.resolve()},function(){d.reject()}),d.promise},showInterstitial:function(){var d=$q.defer();return $window.MobFox.showInterstitial(function(){d.resolve()},function(){d.reject()}),d.promise}}}]),angular.module("ngCordova.plugins",["ngCordova.plugins.actionSheet","ngCordova.plugins.adMob","ngCordova.plugins.appAvailability","ngCordova.plugins.appRate","ngCordova.plugins.appVersion","ngCordova.plugins.backgroundGeolocation","ngCordova.plugins.badge","ngCordova.plugins.barcodeScanner","ngCordova.plugins.batteryStatus","ngCordova.plugins.beacon","ngCordova.plugins.ble","ngCordova.plugins.bluetoothSerial","ngCordova.plugins.brightness","ngCordova.plugins.calendar","ngCordova.plugins.camera","ngCordova.plugins.capture","ngCordova.plugins.clipboard","ngCordova.plugins.contacts","ngCordova.plugins.datePicker","ngCordova.plugins.device","ngCordova.plugins.deviceMotion","ngCordova.plugins.deviceOrientation","ngCordova.plugins.dialogs","ngCordova.plugins.emailComposer","ngCordova.plugins.facebook","ngCordova.plugins.facebookAds","ngCordova.plugins.file","ngCordova.plugins.fileTransfer","ngCordova.plugins.fileOpener2","ngCordova.plugins.flashlight","ngCordova.plugins.flurryAds","ngCordova.plugins.ga","ngCordova.plugins.geolocation","ngCordova.plugins.globalization","ngCordova.plugins.googleAds","ngCordova.plugins.googleAnalytics","ngCordova.plugins.googleMap","ngCordova.plugins.googlePlayGame","ngCordova.plugins.googlePlus","ngCordova.plugins.healthKit","ngCordova.plugins.httpd","ngCordova.plugins.iAd","ngCordova.plugins.imagePicker","ngCordova.plugins.inAppBrowser","ngCordova.plugins.instagram","ngCordova.plugins.keyboard","ngCordova.plugins.keychain","ngCordova.plugins.launchNavigator","ngCordova.plugins.localNotification","ngCordova.plugins.media","ngCordova.plugins.mMediaAds","ngCordova.plugins.mobfoxAds","ngCordova.plugins.mopubAds","ngCordova.plugins.nativeAudio","ngCordova.plugins.network","ngCordova.plugins.pinDialog","ngCordova.plugins.preferences","ngCordova.plugins.printer","ngCordova.plugins.progressIndicator","ngCordova.plugins.push","ngCordova.plugins.push_v5","ngCordova.plugins.sms","ngCordova.plugins.socialSharing","ngCordova.plugins.spinnerDialog","ngCordova.plugins.splashscreen","ngCordova.plugins.sqlite","ngCordova.plugins.statusbar","ngCordova.plugins.toast","ngCordova.plugins.touchid","ngCordova.plugins.vibration","ngCordova.plugins.videoCapturePlus","ngCordova.plugins.zip","ngCordova.plugins.insomnia"]),angular.module("ngCordova.plugins.mopubAds",[]).factory("$cordovaMoPubAds",["$q","$window",function($q,$window){return{setOptions:function(options){var d=$q.defer();return $window.MoPub.setOptions(options,function(){d.resolve()},function(){d.reject()}),d.promise},createBanner:function(options){var d=$q.defer();return $window.MoPub.createBanner(options,function(){d.resolve()},function(){d.reject()}),d.promise},removeBanner:function(){var d=$q.defer();return $window.MoPub.removeBanner(function(){d.resolve()},function(){d.reject()}),d.promise},showBanner:function(position){var d=$q.defer();return $window.MoPub.showBanner(position,function(){d.resolve()},function(){d.reject()}),d.promise},showBannerAtXY:function(x,y){var d=$q.defer();return $window.MoPub.showBannerAtXY(x,y,function(){d.resolve()},function(){d.reject()}),d.promise},hideBanner:function(){var d=$q.defer();return $window.MoPub.hideBanner(function(){d.resolve()},function(){d.reject()}),d.promise},prepareInterstitial:function(options){var d=$q.defer();return $window.MoPub.prepareInterstitial(options,function(){d.resolve()},function(){d.reject()}),d.promise},showInterstitial:function(){var d=$q.defer();return $window.MoPub.showInterstitial(function(){d.resolve()},function(){d.reject()}),d.promise}}}]),angular.module("ngCordova.plugins.nativeAudio",[]).factory("$cordovaNativeAudio",["$q","$window",function($q,$window){return{preloadSimple:function(id,assetPath){var q=$q.defer();return $window.plugins.NativeAudio.preloadSimple(id,assetPath,function(result){q.resolve(result)},function(err){q.reject(err)}),q.promise},preloadComplex:function(id,assetPath,volume,voices,delay){var q=$q.defer();return $window.plugins.NativeAudio.preloadComplex(id,assetPath,volume,voices,delay,function(result){q.resolve(result)},function(err){q.reject(err)}),q.promise},play:function(id,completeCallback){var q=$q.defer();return $window.plugins.NativeAudio.play(id,function(result){q.resolve(result)},function(err){q.reject(err)},completeCallback),q.promise},stop:function(id){var q=$q.defer();return $window.plugins.NativeAudio.stop(id,function(result){q.resolve(result)},function(err){q.reject(err)}),q.promise},loop:function(id){var q=$q.defer();return $window.plugins.NativeAudio.loop(id,function(result){q.resolve(result)},function(err){q.reject(err)}),q.promise},unload:function(id){var q=$q.defer();return $window.plugins.NativeAudio.unload(id,function(result){q.resolve(result)},function(err){q.reject(err)}),q.promise},setVolumeForComplexAsset:function(id,volume){var q=$q.defer();return $window.plugins.NativeAudio.setVolumeForComplexAsset(id,volume,function(result){q.resolve(result)},function(err){q.reject(err)}),q.promise}}}]),angular.module("ngCordova.plugins.network",[]).factory("$cordovaNetwork",["$rootScope","$timeout",function($rootScope,$timeout){var offlineEvent=function(){var networkState=navigator.connection.type;$timeout(function(){$rootScope.$broadcast("$cordovaNetwork:offline",networkState)})},onlineEvent=function(){var networkState=navigator.connection.type;$timeout(function(){$rootScope.$broadcast("$cordovaNetwork:online",networkState)})};return document.addEventListener("deviceready",function(){navigator.connection&&(document.addEventListener("offline",offlineEvent,!1),document.addEventListener("online",onlineEvent,!1))}),{getNetwork:function(){return navigator.connection.type},isOnline:function(){var networkState=navigator.connection.type;return networkState!==Connection.UNKNOWN&&networkState!==Connection.NONE},isOffline:function(){var networkState=navigator.connection.type;return networkState===Connection.UNKNOWN||networkState===Connection.NONE},clearOfflineWatch:function(){document.removeEventListener("offline",offlineEvent),$rootScope.$$listeners["$cordovaNetwork:offline"]=[]},clearOnlineWatch:function(){document.removeEventListener("online",onlineEvent),$rootScope.$$listeners["$cordovaNetwork:online"]=[]}}}]).run(["$injector",function($injector){$injector.get("$cordovaNetwork")}]),angular.module("ngCordova.plugins.pinDialog",[]).factory("$cordovaPinDialog",["$q","$window",function($q,$window){return{prompt:function(message,title,buttons){var q=$q.defer();return $window.plugins.pinDialog.prompt(message,function(res){q.resolve(res)},title,buttons),q.promise}}}]),angular.module("ngCordova.plugins.preferences",[]).factory("$cordovaPreferences",["$window","$q",function($window,$q){return{pluginNotEnabledMessage:"Plugin not enabled",decoratePromise:function(promise){promise.success=function(fn){return promise.then(fn),promise},promise.error=function(fn){return promise.then(null,fn),promise}},store:function(key,value,dict){var deferred=$q.defer(),promise=deferred.promise;if($window.plugins){(3===arguments.length?$window.plugins.appPreferences.store(dict,key,value):$window.plugins.appPreferences.store(key,value)).then(function(value){deferred.resolve(value)},function(error){deferred.reject(new Error(error))})}else deferred.reject(new Error(this.pluginNotEnabledMessage));return this.decoratePromise(promise),promise},fetch:function(key,dict){var deferred=$q.defer(),promise=deferred.promise;if($window.plugins){(2===arguments.length?$window.plugins.appPreferences.fetch(dict,key):$window.plugins.appPreferences.fetch(key)).then(function(value){deferred.resolve(value)},function(error){deferred.reject(new Error(error))})}else deferred.reject(new Error(this.pluginNotEnabledMessage));return this.decoratePromise(promise),promise},remove:function(key,dict){var deferred=$q.defer(),promise=deferred.promise;if($window.plugins){(2===arguments.length?$window.plugins.appPreferences.remove(dict,key):$window.plugins.appPreferences.remove(key)).then(function(value){deferred.resolve(value)},function(error){deferred.reject(new Error(error))})}else deferred.reject(new Error(this.pluginNotEnabledMessage));return this.decoratePromise(promise),promise},show:function(){var deferred=$q.defer(),promise=deferred.promise;return $window.plugins?$window.plugins.appPreferences.show().then(function(value){deferred.resolve(value)},function(error){deferred.reject(new Error(error))}):deferred.reject(new Error(this.pluginNotEnabledMessage)),this.decoratePromise(promise),promise}}}]),angular.module("ngCordova.plugins.printer",[]).factory("$cordovaPrinter",["$q","$window",function($q,$window){return{isAvailable:function(){var q=$q.defer();return $window.plugin.printer.isAvailable(function(isAvailable){q.resolve(isAvailable)}),q.promise},print:function(doc,options){var q=$q.defer();return $window.plugin.printer.print(doc,options,function(){q.resolve()}),q.promise}}}]),angular.module("ngCordova.plugins.progressIndicator",[]).factory("$cordovaProgress",[function(){return{show:function(_message){var message=_message||"Please wait...";return ProgressIndicator.show(message)},showSimple:function(_dim){var dim=_dim||!1;return ProgressIndicator.showSimple(dim)},showSimpleWithLabel:function(_dim,_label){var dim=_dim||!1,label=_label||"Loading...";return ProgressIndicator.showSimpleWithLabel(dim,label)},showSimpleWithLabelDetail:function(_dim,_label,_detail){var dim=_dim||!1,label=_label||"Loading...",detail=_detail||"Please wait";return ProgressIndicator.showSimpleWithLabelDetail(dim,label,detail)},showDeterminate:function(_dim,_timeout){var dim=_dim||!1,timeout=_timeout||5e4;return ProgressIndicator.showDeterminate(dim,timeout)},showDeterminateWithLabel:function(_dim,_timeout,_label){var dim=_dim||!1,timeout=_timeout||5e4,label=_label||"Loading...";return ProgressIndicator.showDeterminateWithLabel(dim,timeout,label)},showAnnular:function(_dim,_timeout){var dim=_dim||!1,timeout=_timeout||5e4;return ProgressIndicator.showAnnular(dim,timeout)},showAnnularWithLabel:function(_dim,_timeout,_label){var dim=_dim||!1,timeout=_timeout||5e4,label=_label||"Loading...";return ProgressIndicator.showAnnularWithLabel(dim,timeout,label)},showBar:function(_dim,_timeout){var dim=_dim||!1,timeout=_timeout||5e4;return ProgressIndicator.showBar(dim,timeout)},showBarWithLabel:function(_dim,_timeout,_label){var dim=_dim||!1,timeout=_timeout||5e4,label=_label||"Loading...";return ProgressIndicator.showBarWithLabel(dim,timeout,label)},showSuccess:function(_dim,_label){var dim=_dim||!1,label=_label||"Success";return ProgressIndicator.showSuccess(dim,label)},showText:function(_dim,_text,_position){var dim=_dim||!1,text=_text||"Warning",position=_position||"center";return ProgressIndicator.showText(dim,text,position)},hide:function(){return ProgressIndicator.hide()}}}]),angular.module("ngCordova.plugins.push",[]).factory("$cordovaPush",["$q","$window","$rootScope","$timeout",function($q,$window,$rootScope,$timeout){return{onNotification:function(notification){$timeout(function(){$rootScope.$broadcast("$cordovaPush:notificationReceived",notification)})},register:function(config){var injector,q=$q.defer();return void 0!==config&&void 0===config.ecb&&(injector=null===document.querySelector("[ng-app]")?"document.body":"document.querySelector('[ng-app]')",config.ecb="angular.element("+injector+").injector().get('$cordovaPush').onNotification"),$window.plugins.pushNotification.register(function(token){q.resolve(token)},function(error){q.reject(error)},config),q.promise},unregister:function(options){var q=$q.defer();return $window.plugins.pushNotification.unregister(function(result){q.resolve(result)},function(error){q.reject(error)},options),q.promise},setBadgeNumber:function(number){var q=$q.defer();return $window.plugins.pushNotification.setApplicationIconBadgeNumber(function(result){q.resolve(result)},function(error){q.reject(error)},number),q.promise}}}]),angular.module("ngCordova.plugins.push_v5",[]).factory("$cordovaPushV5",["$q","$rootScope","$timeout",function($q,$rootScope,$timeout){var push;return{initialize:function(options){var q=$q.defer();return push=PushNotification.init(options),q.resolve(push),q.promise},onNotification:function(){$timeout(function(){push.on("notification",function(notification){$rootScope.$emit("$cordovaPushV5:notificationReceived",notification)})})},onError:function(){$timeout(function(){push.on("error",function(error){$rootScope.$emit("$cordovaPushV5:errorOccurred",error)})})},register:function(){var q=$q.defer();return void 0===push?q.reject(new Error("init must be called before any other operation")):push.on("registration",function(data){q.resolve(data.registrationId)}),q.promise},unregister:function(){var q=$q.defer();return void 0===push?q.reject(new Error("init must be called before any other operation")):push.unregister(function(success){q.resolve(success)},function(error){q.reject(error)}),q.promise},getBadgeNumber:function(){var q=$q.defer();return void 0===push?q.reject(new Error("init must be called before any other operation")):push.getApplicationIconBadgeNumber(function(success){q.resolve(success)},function(error){q.reject(error)}),q.promise},setBadgeNumber:function(number){var q=$q.defer();return void 0===push?q.reject(new Error("init must be called before any other operation")):push.setApplicationIconBadgeNumber(function(success){q.resolve(success)},function(error){q.reject(error)},number),q.promise},finish:function(){var q=$q.defer();return void 0===push?q.reject(new Error("init must be called before any other operation")):push.finish(function(success){q.resolve(success)},function(error){q.reject(error)}),q.promise}}}]),angular.module("ngCordova.plugins.screenshot",[]).factory("$cordovaScreenshot",["$q",function($q){return{captureToFile:function(opts){var options=opts||{},extension=options.extension||"jpg",quality=options.quality||"100",defer=$q.defer();return navigator.screenshot?(navigator.screenshot.save(function(error,res){error?defer.reject(error):defer.resolve(res.filePath)},extension,quality,options.filename),defer.promise):(defer.resolve(null),defer.promise)},captureToUri:function(opts){var options=opts||{},extension=options.extension||"jpg",quality=options.quality||"100",defer=$q.defer();return navigator.screenshot?(navigator.screenshot.URI(function(error,res){error?defer.reject(error):defer.resolve(res.URI)},extension,quality,options.filename),defer.promise):(defer.resolve(null),defer.promise)}}}]),angular.module("ngCordova.plugins.sms",[]).factory("$cordovaSms",["$q",function($q){return{send:function(number,message,options){var q=$q.defer();return sms.send(number,message,options,function(res){q.resolve(res)},function(err){q.reject(err)}),q.promise}}}]),angular.module("ngCordova.plugins.socialSharing",[]).factory("$cordovaSocialSharing",["$q","$window",function($q,$window){return{share:function(message,subject,file,link){var q=$q.defer();return subject=subject||null,file=file||null,link=link||null,$window.plugins.socialsharing.share(message,subject,file,link,function(){q.resolve(!0)},function(){q.reject(!1)}),q.promise},shareViaTwitter:function(message,file,link){var q=$q.defer();return file=file||null,link=link||null,$window.plugins.socialsharing.shareViaTwitter(message,file,link,function(){q.resolve(!0)},function(){q.reject(!1)}),q.promise},shareViaWhatsApp:function(message,file,link){var q=$q.defer();return file=file||null,link=link||null,$window.plugins.socialsharing.shareViaWhatsApp(message,file,link,function(){q.resolve(!0)},function(){q.reject(!1)}),q.promise},shareViaFacebook:function(message,file,link){var q=$q.defer();return message=message||null,file=file||null,link=link||null,$window.plugins.socialsharing.shareViaFacebook(message,file,link,function(){q.resolve(!0)},function(){q.reject(!1)}),q.promise},shareViaFacebookWithPasteMessageHint:function(message,file,link,pasteMessageHint){var q=$q.defer();return file=file||null,link=link||null,$window.plugins.socialsharing.shareViaFacebookWithPasteMessageHint(message,file,link,pasteMessageHint,function(){q.resolve(!0)},function(){q.reject(!1)}),q.promise},shareViaSMS:function(message,commaSeparatedPhoneNumbers){var q=$q.defer();return $window.plugins.socialsharing.shareViaSMS(message,commaSeparatedPhoneNumbers,function(){q.resolve(!0)},function(){q.reject(!1)}),q.promise},shareViaEmail:function(message,subject,toArr,ccArr,bccArr,fileArr){var q=$q.defer();return toArr=toArr||null,ccArr=ccArr||null,bccArr=bccArr||null,fileArr=fileArr||null,$window.plugins.socialsharing.shareViaEmail(message,subject,toArr,ccArr,bccArr,fileArr,function(){q.resolve(!0)},function(){q.reject(!1)}),q.promise},shareVia:function(via,message,subject,file,link){var q=$q.defer();return message=message||null,subject=subject||null,file=file||null,link=link||null,$window.plugins.socialsharing.shareVia(via,message,subject,file,link,function(){q.resolve(!0)},function(){q.reject(!1)}),q.promise},canShareViaEmail:function(){var q=$q.defer();return $window.plugins.socialsharing.canShareViaEmail(function(){q.resolve(!0)},function(){q.reject(!1)}),q.promise},canShareVia:function(via,message,subject,file,link){var q=$q.defer();return $window.plugins.socialsharing.canShareVia(via,message,subject,file,link,function(success){q.resolve(success)},function(error){q.reject(error)}),q.promise},available:function(){var q=$q.defer();return window.plugins.socialsharing.available(function(isAvailable){isAvailable?q.resolve():q.reject()}),q.promise}}}]),angular.module("ngCordova.plugins.spinnerDialog",[]).factory("$cordovaSpinnerDialog",["$window",function($window){return{show:function(title,message,fixed){return fixed=fixed||!1,$window.plugins.spinnerDialog.show(title,message,fixed)},hide:function(){return $window.plugins.spinnerDialog.hide()}}}]),angular.module("ngCordova.plugins.splashscreen",[]).factory("$cordovaSplashscreen",[function(){return{hide:function(){return navigator.splashscreen.hide()},show:function(){return navigator.splashscreen.show()}}}]),angular.module("ngCordova.plugins.sqlite",[]).factory("$cordovaSQLite",["$q","$window",function($q,$window){return{openDB:function(options,background){return angular.isObject(options)&&!angular.isString(options)?(void 0!==background&&(options.bgType=background),$window.sqlitePlugin.openDatabase(options)):$window.sqlitePlugin.openDatabase({name:options,bgType:background})},execute:function(db,query,binding){var q=$q.defer();return db.transaction(function(tx){tx.executeSql(query,binding,function(tx,result){q.resolve(result)},function(transaction,error){q.reject(error)})}),q.promise},insertCollection:function(db,query,bindings){var q=$q.defer(),coll=bindings.slice(0);return db.transaction(function(tx){!function insertOne(){var record=coll.splice(0,1)[0];try{tx.executeSql(query,record,function(tx,result){0===coll.length?q.resolve(result):insertOne()},function(transaction,error){q.reject(error)})}catch(exception){q.reject(exception)}}()}),q.promise},nestedExecute:function(db,query1,query2,binding1,binding2){var q=$q.defer();return db.transaction(function(tx){tx.executeSql(query1,binding1,function(tx,result){q.resolve(result),tx.executeSql(query2,binding2,function(tx,res){q.resolve(res)})})},function(transaction,error){q.reject(error)}),q.promise},deleteDB:function(dbName){var q=$q.defer();return $window.sqlitePlugin.deleteDatabase(dbName,function(success){q.resolve(success)},function(error){q.reject(error)}),q.promise}}}]),angular.module("ngCordova.plugins.statusbar",[]).factory("$cordovaStatusbar",[function(){return{overlaysWebView:function(bool){return StatusBar.overlaysWebView(!!bool)},STYLES:{DEFAULT:0,LIGHT_CONTENT:1,BLACK_TRANSLUCENT:2,BLACK_OPAQUE:3},style:function(style){switch(style){case 0:return StatusBar.styleDefault();case 1:return StatusBar.styleLightContent();case 2:return StatusBar.styleBlackTranslucent();case 3:return StatusBar.styleBlackOpaque();default:return StatusBar.styleDefault()}},styleColor:function(color){return StatusBar.backgroundColorByName(color)},styleHex:function(colorHex){return StatusBar.backgroundColorByHexString(colorHex)},hide:function(){return StatusBar.hide()},show:function(){return StatusBar.show()},isVisible:function(){return StatusBar.isVisible}}}]),angular.module("ngCordova.plugins.toast",[]).factory("$cordovaToast",["$q","$window",function($q,$window){return{showShortTop:function(message){var q=$q.defer();return $window.plugins.toast.showShortTop(message,function(response){q.resolve(response)},function(error){q.reject(error)}),q.promise},showShortCenter:function(message){var q=$q.defer();return $window.plugins.toast.showShortCenter(message,function(response){q.resolve(response)},function(error){q.reject(error)}),q.promise},showShortBottom:function(message){var q=$q.defer();return $window.plugins.toast.showShortBottom(message,function(response){q.resolve(response)},function(error){q.reject(error)}),q.promise},showLongTop:function(message){var q=$q.defer();return $window.plugins.toast.showLongTop(message,function(response){q.resolve(response)},function(error){q.reject(error)}),q.promise},showLongCenter:function(message){var q=$q.defer();return $window.plugins.toast.showLongCenter(message,function(response){q.resolve(response)},function(error){q.reject(error)}),q.promise},showLongBottom:function(message){var q=$q.defer();return $window.plugins.toast.showLongBottom(message,function(response){q.resolve(response)},function(error){q.reject(error)}),q.promise},show:function(message,duration,position){var q=$q.defer();return $window.plugins.toast.show(message,duration,position,function(response){q.resolve(response)},function(error){q.reject(error)}),q.promise},hide:function(){var q=$q.defer();try{$window.plugins.toast.hide(),q.resolve()}catch(error){q.reject(error&&error.message)}return q.promise}}}]),angular.module("ngCordova.plugins.touchid",[]).factory("$cordovaTouchID",["$q",function($q){return{checkSupport:function(){var defer=$q.defer();return window.cordova?touchid.checkSupport(function(value){defer.resolve(value)},function(err){defer.reject(err)}):defer.reject("Not supported without cordova.js"),defer.promise},authenticate:function(authReasonText){var defer=$q.defer();return window.cordova?touchid.authenticate(function(value){defer.resolve(value)},function(err){defer.reject(err)},authReasonText):defer.reject("Not supported without cordova.js"),defer.promise}}}]),angular.module("ngCordova.plugins.upsPush",[]).factory("$cordovaUpsPush",["$q","$window","$rootScope","$timeout",function($q,$window,$rootScope,$timeout){return{register:function(config){var q=$q.defer();return $window.push.register(function(notification){$timeout(function(){$rootScope.$broadcast("$cordovaUpsPush:notificationReceived",notification)})},function(){q.resolve()},function(error){q.reject(error)},config),q.promise},unregister:function(options){var q=$q.defer();return $window.push.unregister(function(){q.resolve()},function(error){q.reject(error)},options),q.promise},setBadgeNumber:function(number){var q=$q.defer();return $window.push.setApplicationIconBadgeNumber(function(){q.resolve()},number),q.promise}}}]),angular.module("ngCordova.plugins.vibration",[]).factory("$cordovaVibration",[function(){return{vibrate:function(times){return navigator.notification.vibrate(times)},vibrateWithPattern:function(pattern,repeat){return navigator.notification.vibrateWithPattern(pattern,repeat)},cancelVibration:function(){return navigator.notification.cancelVibration()}}}]),angular.module("ngCordova.plugins.videoCapturePlus",[]).provider("$cordovaVideoCapturePlus",[function(){var defaultOptions={};this.setLimit=function(limit){defaultOptions.limit=limit},this.setMaxDuration=function(seconds){defaultOptions.duration=seconds},this.setHighQuality=function(highquality){defaultOptions.highquality=highquality},this.useFrontCamera=function(frontcamera){defaultOptions.frontcamera=frontcamera},this.setPortraitOverlay=function(imageUrl){defaultOptions.portraitOverlay=imageUrl},this.setLandscapeOverlay=function(imageUrl){defaultOptions.landscapeOverlay=imageUrl},this.setOverlayText=function(text){defaultOptions.overlayText=text},this.$get=["$q","$window",function($q,$window){return{captureVideo:function(options){var q=$q.defer();return $window.plugins.videocaptureplus?($window.plugins.videocaptureplus.captureVideo(q.resolve,q.reject,angular.extend({},defaultOptions,options)),q.promise):(q.resolve(null),q.promise)}}}]}]),angular.module("ngCordova.plugins.zip",[]).factory("$cordovaZip",["$q","$window",function($q,$window){return{unzip:function(source,destination){var q=$q.defer();return $window.zip.unzip(source,destination,function(isError){0===isError?q.resolve():q.reject()},function(progressEvent){q.notify(progressEvent)}),q.promise}}}]),Array.prototype.distinctConcat=function(sourceArr,destArr,compareFun){for(var result=sourceArr.concat(),i=0;i<this.length;i++){var obj=this[i];sourceArr.contain(obj,compareFun)||result.push(obj)}return result},Array.prototype.distinctConcatChangeSource=function(destArr,compareFun){for(var destArrCopy=destArr.concat(),i=0;i<destArrCopy.length;i++){var obj=destArrCopy[i];this.contain(obj,compareFun)?destArr.remove(obj,compareFun):this.push(obj)}},Array.prototype.distinct=function(compareFun){for(var result=[],i=0;i<this.length;i++){var obj=this[i];result.contain(obj,compareFun)||result.push(obj)}return result},Array.prototype.contain=function(dest,compareFun){return this.contains(dest,compareFun)>-1},Array.prototype.empty=function(){return this.splice(0,this.length)},Array.prototype.remove=function(dest,compareFun){for(var i=0;i<this.length;i++){var obj=this[i];if(null===compareFun||void 0===compareFun){if(obj==dest){this.splice(i,1);break}}else if(compareFun(obj,dest)){this.splice(i,1);break}}},Array.prototype.contains=function(dest,compareFun){for(var flag=-1,i=0;i<this.length;i++){var obj=this[i];if(null===compareFun||void 0===compareFun){if(obj==dest){flag=i;break}}else if(compareFun(obj,dest)){flag=i;break}}return flag},Array.prototype.distinctRemoteData=function(destArr){this.distinctConcatChangeSource(destArr,function(obj1,obj2){return null!==obj1&&void 0!==obj1&&null!==obj2&&void 0!==obj2&&obj1.id==obj2.id})},Array.prototype.distinctPush=function(dest,compareFun){return this.contains(dest,compareFun)<=-1&&this.push(dest),this},Array.prototype.ObjectToSingle=function(key){for(var values=[],i=0;i<this.length;i++)values.push(this[i][key]);return values},angular.module("AgencyApp.constants",[]).constant("VersionConfig",{version:1,url:"http://192.168.0.222:8083/fht/v1/fht.xml"}).constant("Host","http://api.dshero.cn").constant("ImageHost","http://linggonghero.com").constant("WapHost","http://m.linggonghero.com").constant("LocalData",{currentCity:"currentCity",user:"user",token:"token",preLogin:"preLogin",recipientCustom:"recipientCustom",recipientLog:"recipientLog",guideFlag:"guideFlag",receiverLastId:"receiverLastId",inputPm:"inputPm",preCity:"preCity",jpushId:"jpushId",curCity:"curCity",locationCity:"locationCity"}).constant("localConstantData",{html:{cellphone:"^(13[0-9]|14[5|7|9]|15[0-9]|166|17[0-9]|18[0-9]|19[0-9])\\d{8}$",tel:"^\\d{7,11}$"},row:15,contactUs:"400-6390558",maxTelCount:50,curTelCount:0,userInfoChanged:!1,messageCode:{MessageError:"MessageError",PaySuccess:"PaySuccess"}}).constant("CacheStore",{clear:function(){for(var s in this)"object"==typeof this[s]&&"function"==typeof this[s].init&&this[s].init()},deleteOneInfo:function(second,third,id,compareFun){try{var index=this[second][third].contains(id,compareFun);index>-1&&this[second][third].splice(index,1)}catch(e){}},updateOneInfoState:function(second,third,id,compareFun,stateKey,afterState){try{var index=this[second][third].contains(id,compareFun);index>-1&&(this[second][third][index][stateKey]=afterState)}catch(e){}},updateManyInfoState:function(second,third,id,compareFun,states){try{var index=this[second][third].contains(id,compareFun);if(index>-1){var curOb=this[second][third][index];for(var attr in states){var value=states[attr];curOb[attr]=value}}}catch(e){}},updateManyInfoStateSelfAdd:function(second,third,id,compareFun,states){try{var index=this[second][third].contains(id,compareFun);if(index>-1){var curOb=this[second][third][index];for(var attr in states){var value=states[attr];curOb[attr]+=value}}}catch(e){}},replaceOneInfo:function(second,third,id,compareFun,newInfo){try{var index=this[second][third].contains(id,compareFun);index>-1&&this[second][third].splice(index,1,newInfo)}catch(e){}},addOneInfo:function(second,third,newInfo){try{this[second][third].splice(0,0,newInfo)}catch(e){}},transferOne:function(delSecond,delThird,delId,delCompareFun,addSecond,addThird){try{var index=this[delSecond][delThird].contains(delId,delCompareFun);if(index>-1){var transferOb=this[delSecond][delThird];this[addSecond][addThird].splice(0,0,transferOb),this[delSecond][delThird].splice(index,1)}}catch(e){}}}).constant("EmitEvent",{HttpCompletion:"httpCompletion",ViewBeforeEnter:"$ionicView.beforeEnter",ViewBeforeLeave:"$ionicView.beforeLeave",ViewLoaded:"$ionicView.loaded",ViewEnter:"$ionicView.enter",StopOrContinue:"stopOrContinue",SlidePic:"slidePic",PaySuccess:"PaySuccess"}).constant("RemoteInterface",{CommonSignin:"/v1/courier/pre/login/pass",GetPicValidate:"/v1/courier/pre/signup/code",SendMessage:"/v1/courier/pre/signup/sendMessage",AllAreas:"json/region",Register:"/v1/courier/pre/signup/valicode",ResetPwSendMess:"/v1/courier/pre/reset/message",ResetPw:"/v1/courier/pre/reset/valicode",UserInfo:"/v1/courier/info",StatisticsList:"/v1/courier/orderstat/list",StatisticsDetail:"/v1/courier/orderstat/detail/list",AllExpress:"json/express",WareHouseList:"/v11/order/courier/warehouse/list",UpdateUserInfo:"/v1/courier/update",GetStat7:"/v1/courier/orderstat/stat7",Phones:"/v11/order/courier/phone/history",DeleteOrder:"/v11/order/courier/delete",BindExpress:"/v1/courier/express/update",QueryBoundExpress:"/v1/courier/express/list",QueryBoundProxy:"/v1/courierproxy/courier/bindlist",ReadOut:"/v11/order/courier/in/list",SureIn:"/v11/order/courier/in",BatchIn:"/v11/order/courier/batchin",ChangeOrderIn:"/v11/order/courier/alter",SureOut:"/v11/order/courier/out",ToProxyOrder:"/v11/order/courier/toproxy",FailedMsgeList:"/v1/notice/courier/fail/list",GetOneSMS:"/v1/notice/info",DeleteFailSMS:"/v1/notice/delete",EmptyFailSMS:"/v1/notice/courier/deleteAll",ResendInSMS:"/v1/notice/courier/resend",ResendAllInSMS:"/v1/notice/courier/resend/failall",CountResendInSMS:"/v1/notice/courier/resend/count",ChargeListConfig:"/v1/charge/courier/balance/config",NotifyServerPaySuc:"/v1/charge/courier/complete",RequestWeChatPay:"/v1/charge/courier/wx",RequestAliPay:"/v1/charge/courier/ali",Cooperation:"/v2/cooperation/partner",GetOsVersion:"/v1/courier/version/getUse",Subaccounts:"/v1/user/courier/list",RegisterSubaccount:"/v1/user/courier/signupchild",RegSubSendMess:"/v1/user/courier/valicode",SwitchSubaccountStatus:"/v1/user/courier/changeStatus",RemoveSubaccount:"/v1/user/courier/remove",ModifySubaccountName:"/v1/user/courier/modify/name",GetNotifyMess:"/v5/order/courier/message",BlackList:"/v1/courier/black/list",AddBlackList:"/v1/courier/black/add",DelBlackList:"/v1/courier/black/delById",getReceiverByTel:"/v1/receiver/getReceiver",AddProxySendMess:"/v1/courierproxy/addproxy/valicode",AddProxy:"/v1/courierproxy/addproxy/signup",RemoveProxy:"/v1/courierproxy/courier/remove",ModifyProxy:"/v1/courierproxy/courier/alter",GetProxyList:"/v1/courierproxy/courier/list",SetProxyUseDelay:"/v1/courier/setDelay",SMSTemplates:"/v1/courier/sms/template/listall",GetDefaultSign:"/v1/courier/sms/sign/getcurrent",DelSMSTemplate:"/v1/courier/sms/template/delete",SubmitSMSTemplate:"/v1/courier/sms/template/add",UpdateSMSTemplate:"/v1/courier/sms/template/update",SetDefaultTemplate:"/v1/courier/sms/template/setDefault",GetDefaultTemplate:"/v1/courier/sms/template/getDefault",GetNoCommonSign:"/v1/courier/sms/sign/getcheck",ChangeFailuredSign:"/v1/courier/sms/sign/update",GetSignPayConfig:"/v1/charge/courier/sign/config",WXPaySign:"/v1/charge/courier/sign/wx",AliPaySign:"/v1/charge/courier/sign/ali"});var angularUtils=angular.module("angular.utils",["ngCordova","LocalStorageModule"]).config(["$httpProvider","localStorageServiceProvider","$ionicConfigProvider","$ionicNativeTransitionsProvider",function($httpProvider,localStorageServiceProvider,$ionicConfigProvider,$ionicNativeTransitionsProvider){$ionicConfigProvider.platform.ios.tabs.style("standard"),$ionicConfigProvider.platform.ios.tabs.position("bottom"),$ionicConfigProvider.platform.android.tabs.style("standard"),$ionicConfigProvider.platform.android.tabs.position("standard"),$ionicConfigProvider.platform.ios.navBar.alignTitle("center"),$ionicConfigProvider.platform.android.navBar.alignTitle("center"),$ionicConfigProvider.platform.ios.backButton.previousTitleText("").icon("ion-ios-arrow-back"),$ionicConfigProvider.platform.android.backButton.previousTitleText("").icon("ion-ios-arrow-back"),$ionicConfigProvider.platform.ios.views.transition("ios"),$ionicConfigProvider.platform.android.views.transition("android"),localStorageServiceProvider.setPrefix("expressHeroOfLGYX").setStorageType("localStorage"),$httpProvider.defaults.headers.put["Content-Type"]="application/x-www-form-urlencoded",$httpProvider.defaults.headers.post["Content-Type"]="application/x-www-form-urlencoded",$httpProvider.defaults.transformRequest=[function(data){var param=function(obj){var name,value,subName,subValue,innerObj,i,query="";for(name in obj)if((value=obj[name])instanceof Array)for(i=0;i<value.length;++i)subValue=value[i],(innerObj={})[name+"["+i+"]"]=subValue,query+=param(innerObj)+"&";else if(value instanceof Object)for(subName in value)subValue=value[subName],(innerObj={})[name+"["+subName+"]"]=subValue,query+=param(innerObj)+"&";else void 0!==value&&null!==value&&(query+=encodeURIComponent(name)+"="+encodeURIComponent(value)+"&");return query.length?query.substr(0,query.length-1):query};return angular.isObject(data)&&"[object File]"!==String(data)?param(data):data}],$ionicNativeTransitionsProvider.setDefaultOptions({type:"slide",direction:"left",duration:400,slowdownfactor:4,iosdelay:-1,androiddelay:-1,winphonedelay:-1,fixedPixelsTop:0,fixedPixelsBottom:0,triggerTransitionEvent:"$ionicView.afterEnter",backInOppositeDirection:!1})}]).run(["$ionicPlatform","$cordovaStatusbar","$rootScope","$location","$timeout","$ionicHistory","$cordovaToast","$state","$ionicPopup","LocalDatabase","HttpService",function($ionicPlatform,$cordovaStatusbar,$rootScope,$location,$timeout,$ionicHistory,$cordovaToast,$state,$ionicPopup,LocalDatabase,HttpService){$ionicPlatform.registerBackButtonAction(function(e){var backView=$ionicHistory.backView(),curPath=$location.path();return curPath.indexOf("index")>-1||"/signin"==curPath||"/register"==curPath?$rootScope.backButtonPressedOnceToExit?ionic.Platform.exitApp():($rootScope.backButtonPressedOnceToExit=!0,$cordovaToast.showShortTop("再按一次退出系统"),setTimeout(function(){$rootScope.backButtonPressedOnceToExit=!1},2e3)):backView?"guide"==backView.stateId?($ionicHistory.nextViewOptions({disableAnimate:!0,disableBack:!0,historyRoot:!0}),$state.go("index.home")):$ionicHistory.goBack():($rootScope.backButtonPressedOnceToExit=!0,$cordovaToast.showShortTop("再按一次退出系统"),setTimeout(function(){$rootScope.backButtonPressedOnceToExit=!1},2e3)),e.preventDefault(),!1},101),$ionicPlatform.on("resume",function(){$rootScope.$broadcast("correctTime")});var checkUpdate=function(){var os=cordova.platformId;if(void 0===os||null===os)return!1;if("android"!==(os=os.toLowerCase())&&"ios"!==os)return!1;var flag=!1;return cordova.getAppVersion.getVersionNumber().then(function(version){var oldVersion=version;void 0!=oldVersion&&null!==oldVersion&&""!==oldVersion&&HttpService.post(HttpService.RemoteInter.GetOsVersion,{os:os},!1).then(function(data){if(null!=data){var newVersion=data.version;if(void 0!==newVersion&&null!==newVersion&&0!==newVersion.length){var updateUrl=data.url;if(void 0!==updateUrl&&null!==updateUrl&&0!=newVersion.length){var description=data.description;void 0!==description&&null!==description&&0!=description.length&&(description=description.replace(/\n/g,"<br>"),parseInt(oldVersion.toString().replace(new RegExp(/(\.)/g),"0"))>=parseInt(newVersion.toString().replace(new RegExp(/(\.)/g),"0"))||(flag=!0,$ionicPopup.confirm({title:"版本升级："+newVersion,template:'<div style="text-align:left;">'+description+"</div>",cancelText:"取消",okText:"更新"}).then(function(res){res&&window.open(updateUrl)})))}}}})}),flag};$ionicPlatform.ready(function(){$cordovaStatusbar.overlaysWebView(!0),$cordovaStatusbar.style(1),$cordovaStatusbar.styleHex("#0ecfa8"),$cordovaStatusbar.show(),navigator&&navigator.splashscreen&&navigator.splashscreen.hide(),window.cordova&&window.cordova.plugins&&window.cordova.plugins.Keyboard&&(cordova.plugins.Keyboard.hideKeyboardAccessoryBar(!0),cordova.plugins.Keyboard.disableScroll(!0)),window.StatusBar&&StatusBar.styleDefault();try{LocalDatabase.get(LocalDatabase.guideFlag)&&checkUpdate()}catch(err){}})}]).factory("HttpService",["$http","Host","$q","$ionicPopup","RemoteInterface","LocalDatabase","$ionicLoading","$state","$ionicHistory","EmitEvent","$rootScope","CacheStore","$timeout","$location","toastTipService",function($http,Host,$q,$ionicPopup,RemoteInterface,LocalDatabase,$ionicLoading,$state,$ionicHistory,EmitEvent,$rootScope,CacheStore,$timeout,$location,toastTipService){var toParam=function(obj){var name,value,subName,subValue,innerObj,i,query="";for(name in obj)if((value=obj[name])instanceof Array)for(i=0;i<value.length;++i)subValue=value[i],(innerObj={})[name]=subValue,query+=encodeURIComponent(name)+"="+encodeURIComponent(subValue)+"&";else if(value instanceof Object)for(subName in value)subValue=value[subName],(innerObj={})[name+"["+subName+"]"]=subValue,query+=param(innerObj)+"&";else void 0!==value&&null!==value&&(query+=encodeURIComponent(name)+"="+encodeURIComponent(value)+"&");return query.length?query.substr(0,query.length-1):query},service={signoutLock:!1,remoteInter:function(){return RemoteInterface},RemoteInter:RemoteInterface,get:function(url,params,forbid){return service.httpMethod(!0,url,params,forbid)},postWithconfig:function(url,params,config){return service.httpMethod(!1,url,params,!0,config)},warpConfig:function(){return{timeout:6e4}},warpUrl:function(url){return Host+url+".json"},warpParams:function(params){var token=LocalDatabase.get(LocalDatabase.Data.token);return null!==token&&(null===params||void 0===params?params={accessToken:token}:params.accessToken=token),params},httpPost:function(url,params){return $http.post(service.warpUrl(url,params),params,service.warpConfig())},httpMethod:function(isGet,url,params,forbid,config){params=service.warpParams(params),null!==forbid&&void 0!==forbid&&forbid&&$ionicLoading.show({template:'<ion-spinner icon="android" class="spinner-calm"></ion-spinner>',noBackdrop:!0,duration:1e4});var httpPromise=null;return httpPromise=isGet?$http.get(service.warpUrl(url,params)+"?"+toParam(params),service.warpConfig()):$http.post(service.warpUrl(url,params),params,service.warpConfig()),service.resultDeal(httpPromise,forbid)},resultDeal:function(httpPromise,forbid){var deferer=$q.defer();return httpPromise.success(function(data){if(0==data.code){var token=LocalDatabase.get(LocalDatabase.Data.token);LocalDatabase.set(LocalDatabase.Data.token,null!=data.accessToken?data.accessToken:token),deferer.resolve(data.result)}else"3"==data.code?"/signin"!=$location.path()&&(service.signOut(!1),toastTipService.showShortTop(data.message)):$ionicPopup.alert({title:"提示",template:data.message}).then(function(){deferer.reject(data)})}).error(function(response,code){deferer.reject(response),0===$ionicPopup._popupStack.length&&(500==code?$ionicPopup.alert({title:"网络",template:"服务器故障"}):$ionicPopup.alert({title:"提示",template:"请检查您当前的网络环境！"}))}).finally(function(){deferer.notify(),null!==forbid&&void 0!==forbid&&forbid&&$ionicLoading.hide(),$rootScope.$emit(EmitEvent.HttpCompletion)}),deferer.promise},signOut:function(remoteSignout){service.signoutLock||(service.signoutLock=!0,LocalDatabase.remove(LocalDatabase.Data.user),CacheStore.clear(),null===remoteSignout||void 0===remoteSignout||1==remoteSignout?service.post(service.RemoteInter.SignOut,null,!0).then(function(){$state.go("signin")}):$state.go("signin"),$timeout(function(){"/signin"==$location.path()&&$ionicHistory.clearHistory(),$ionicHistory.clearCache(),service.signoutLock=!1},1500))},post:function(url,params,forbid){return service.httpMethod(!1,url,params,forbid)},httpStatic:function(url,suf){var deferer=$q.defer();return $http.get(url+(suf||".json")).success(function(data){deferer.resolve(data)}),deferer.promise},testHttp:function(data){var deferer=$q.defer();return deferer.resolve(data),deferer.promise}};return service}]).service("LocalDatabase",["LocalData","localStorageService",function(LocalData,localStorageService){return{Data:LocalData,get:function(key){var value=localStorageService.get(key);return null!==value&&void 0!==value&&value.length>0?JSON.parse(value):null},set:function(key,value){null!==value&&void 0!==value&&localStorageService.set(key,JSON.stringify(value))},remove:function(key){var value=this.get(key);return null!==value&&void 0!==value&&localStorageService.remove(key),value}}}]).factory("phoneService",["$ionicPopup",function($ionicPopup){return{dialog:function(telephone){null===telephone||void 0===telephone?$ionicPopup.alert({title:"提示",template:"暂无电话"}):phonedialer.dial(telephone,function(err){"empty"==err&&$ionicPopup.alert({title:"提示",template:"您所拨号码为空号"})})},phoneFormat:function(phone){if(null!=phone&&11==phone.length){for(var result="",counter=0,i=(phone=(phone||0).toString()).length-1;i>=0;i--)counter++,result=phone.charAt(i)+result,0==counter%4&&0!=i&&(result="-"+result);return result}return phone}}}]).factory("focusFactory",["$timeout","$window",function($timeout,$window){return function(id){$timeout(function(){var element=$window.document.getElementById(id);element&&element.focus()})}}]).factory("sendCheckCodeService",["HttpService","toastTipService","$interval",function(HttpService,toastTipService,$interval){var verifyCodeButtonTimeOut=function(curOb){var second=curOb.seconds;curOb.timePromise=void 0,curOb.timePromise=$interval(function(){second<=0?($interval.cancel(curOb.timePromise),curOb.timePromise=void 0,second=curOb.seconds,curOb.sendVerifyCodeButton.value="重发验证码",curOb.sendVerifyCodeButton.canClick=!0):(curOb.sendVerifyCodeButton.value=second+"秒后可重发",second--)},1e3)};return{sendVerifyCodeButton:{canClick:!0,value:"获取验证码",sendCount:0},initService:function(second){$interval.cancel(this.timePromise),this.timePromise=void 0,this.seconds=second||60,this.sendVerifyCodeButton.canClick=!0,this.sendVerifyCodeButton.value="获取验证码",this.sendVerifyCodeButton.sendCount=0},sendVerifyCode:function(url,param,callback,errCb){var cur=this,phone=null;for(var i in param)phone=param[i]||null;null!=phone?cur.sendVerifyCodeButton.sendCount<5?(cur.sendVerifyCodeButton.canClick=!1,HttpService.post(HttpService.RemoteInter[url],param,!0).then(function(data){verifyCodeButtonTimeOut(cur),cur.sendVerifyCodeButton.sendCount++,callback&&angular.isFunction(callback)&&callback(data)},function(){cur.initService(),angular.isFunction(errCb)&&errCb()})):toastTipService.showShortTop("已超过发送次数限制！","提示"):toastTipService.showShortTop("请输入有效的手机号码！","提示")},getPicCodeUrlNoRandom:function(phone){return HttpService.warpUrl(HttpService.RemoteInter.GetPicValidate)+"?phone="+phone+"&random="}}}]).factory("ionicPopupService",["$ionicPopup",function($ionicPopup){return{show:function(template,title,subTitle,firstButtonText,firstFunction,secondButtonText,secondFunction){$ionicPopup.show({template:template,title:title||"提示",subTitle:subTitle,buttons:[{text:"<b>"+firstButtonText+"</b>",type:"button-positive",onTap:function(e){"function"==typeof firstFunction&&firstFunction(e)}},{text:"<b>"+secondButtonText+"</b>",type:"button-default",onTap:function(e){"function"==typeof secondFunction&&secondFunction(e)}}]})},confirm:function(template,title,subTitle,sureFunction,cancelFunction,cancelText,okText){$ionicPopup.confirm({template:template,title:title||"提示",subTitle:subTitle,cancelText:cancelText||"取消",okText:okText||"确认"}).then(function(res){res?"function"==typeof sureFunction&&sureFunction():"function"==typeof cancelFunction&&cancelFunction()})},alert:function(template,title,subTitle,sureFunction){title=title||"提示",$ionicPopup.alert({template:template,title:title,subTitle:subTitle}).then(function(res){"function"==typeof sureFunction&&sureFunction()})}}}]).factory("shareService",["$cordovaToast","fileService",function($cordovaToast,fileService){return{logoUrl:"www/img/logoimg.png",shareLinkToQQ:function(scene,url,title,desc,imgUrl){var args={};args.scene=0===scene?QQSDK.Scene.QQZone:QQSDK.Scene.QQ,args.url=url,args.title=title,args.description=desc;var imageUrl=imgUrl||cordova.file.applicationDirectory+this.logoUrl;args.image=imageUrl,QQSDK.shareNews(function(){$cordovaToast.showShortTop("分享成功！")},function(reason){},args)},shareLinkToWechat:function(scene,url,title,desc,imgUrl){Wechat.share({message:{title:title,description:desc||"",thumb:imgUrl||this.logoUrl,media:{type:Wechat.Type.WEBPAGE,webpageUrl:url}},scene:0===scene?Wechat.Scene.TIMELINE:Wechat.Scene.SESSION},function(){$cordovaToast.showShortTop("分享成功！")},function(reason){})}}}]).factory("takePhotoService",["$q",function($q){var service={setOptions:function(srcType,allowEdit){return{quality:10,destinationType:Camera.DestinationType.FILE_URI,sourceType:srcType,encodingType:Camera.EncodingType.JPEG,mediaType:Camera.MediaType.PICTURE,allowEdit:allowEdit||!1,correctOrientation:!0,saveToPhotoAlbum:!1}},getPhoto:function(type,allowEdit){var deferer=$q.defer(),srcType=0===type?Camera.PictureSourceType.CAMERA:Camera.PictureSourceType.PHOTOLIBRARY,options=service.setOptions(srcType,allowEdit);return navigator.camera.getPicture(function(imageUri){deferer.resolve(imageUri)},function(error){deferer.reject()},options),deferer.promise}};return service}]).factory("toastTipService",["$cordovaToast",function($cordovaToast){return{showShortTop:function(tipWords){try{$cordovaToast.showShortTop(tipWords)}catch(error){alert(tipWords)}}}}]).factory("imagePickService",["$q",function($q){return{pickImages:function(options){var defer=$q.defer();return window.imagePicker.getPictures(function(results){defer.resolve(results)},function(error){defer.reject()},options),defer.promise}}}]).factory("cellPhoneIdentyService",[function(){return{getIdenty:function(callFun){ionic.Platform.isIOS()?"function"==typeof callFun&&callFun(device.uuid):window.plugins.imei.get(function(imei){"function"==typeof callFun&&callFun(imei)},function(){"function"==typeof callFun&&callFun(null)})}}}]).factory("ionicHistoryService",["$rootScope","$ionicHistory","$state","$ionicViewSwitcher",function($rootScope,$ionicHistory,$state,$ionicViewSwitcher){return{getBackView:function(){return $ionicHistory.backView()},judgePrePage:function(prePageState){var backView=$ionicHistory.backView();return!(!backView||backView.stateId!==prePageState)},setNextToRootPage:function(){$ionicHistory.nextViewOptions({disableAnimate:!0,disableBack:!0,historyRoot:!0})},goNextRootPage:function(stateId,param){$ionicHistory.nextViewOptions({disableAnimate:!0,disableBack:!0,historyRoot:!0}),$state.go(stateId,param)},replaceHistory:function(nextState,forwardParams){$state.go(nextState,forwardParams),$ionicHistory.currentView($ionicHistory.backView())},replaceHistoryNoForward:function(){$ionicHistory.currentView($ionicHistory.backView())},goNextPage:function(stateId,param){$state.go(stateId,param)},leavePageByRoot:function(stateId,cb){return $rootScope.$on("$stateChangeStart",function(event,toState,toParams,fromState,fromParams){fromState.name===stateId&&cb()})},leavePageByScope:function(stateId,cb,scope){return scope.$on("$stateChangeStart",function(event,toState,toParams,fromState,fromParams){fromState.name===stateId&&cb()})},clearCache:function(stateIds){$ionicHistory.clearCache(stateIds)}}}]).factory("actionSheetService",["$ionicActionSheet",function($ionicActionSheet){return{chooseAcction:function(options){$ionicActionSheet.show({buttons:options.buttons,titleText:options.titleText,cancelText:options.cancelText,cancel:function(){},buttonClicked:function(index){return options.cb&&angular.isFunction(options.cb)&&options.cb(index),!0}})}}}]).factory("datePickerService",[function(){return{showDatePicker:function(optionsParam){var options=optionsParam||{};cordova.plugins.DateTimePicker.show({mode:"date",date:options.date||new Date,allowOldDates:!0,allowFutureDates:!0,minuteInterval:options.minuteInterval||15,locale:"ZH",okText:options.okText||"确认",cancelText:options.cancelText||"取消",android:{theme:16974126,calendar:!1,is24HourView:!0},success:options.sucCb,cancel:function(){angular.isFunction(options.cancelCb)&&options.cancelCb()},error:function(err){alert(err)}})},showTimePicker:function(optionsParam){var options=optionsParam||{};cordova.plugins.DateTimePicker.show({mode:"time",date:options.date||new Date,allowOldDates:!0,allowFutureDates:!0,minuteInterval:options.minuteInterval||10,locale:"ZH",okText:options.okText||"确认",cancelText:options.cancelText||"取消",android:{theme:16974126,calendar:!1,is24HourView:!0},success:options.sucCb,cancel:function(){angular.isFunction(options.cancelCb)&&options.cancelCb()},error:function(err){alert(err)}})}}}]).factory("htmlUtilsService",[function(){var ranges=["\ud83c[\udf00-\udfff]","\ud83d[\udc00-\ude4f]","\ud83d[\ude80-\udeff]"];return{getEleById:function(id){return document.querySelector("#"+id)},focusInput:function(id){var input=document.getElementById(id);input&&input.focus()},transformPic:function(imgUrl,tranCb,finallyCb,backCb){var img=new Image;img.src=imgUrl,img.onload=function(){img.height>img.width&&(angular.isFunction(tranCb)?tranCb():angular.isFunction(backCb)&&backCb()),angular.isFunction(finallyCb)&&finallyCb()}},replaceEmoji:function(input){return input?input.replace(new RegExp(ranges.join("|"),"g"),""):""},stringRegValidate:function(originStr,pattern,flag){return!!angular.isString(originStr)&&new RegExp(pattern,flag).test(originStr)},getUUID:function(){return Math.random().toString(36).substring(3,8)},getRandomNum:function(count){return Math.random().toString().substring(3,count?count+3:8)}}}]).factory("dateTimeService",["$filter",function($filter){return{ABeforeBAfter:function(aTime,bTime){return aTime.getTime()<bTime.getTime()},getDateIgnoreHms:function(date){var apointDate=date||new Date;return new Date(apointDate.getFullYear(),apointDate.getMonth(),apointDate.getDate())},ABeforeBAfterIgnoreHms:function(aTime,bTime){var newATime=new Date(aTime.getFullYear(),aTime.getMonth(),aTime.getDate()),newBTime=new Date(bTime.getFullYear(),bTime.getMonth(),bTime.getDate());return this.ABeforeBAfter(newATime,newBTime)},dateTimeFormatToStr:function(dateTime,format){return $filter("date")(dateTime,format||"yyyy-MM-dd HH:mm:ss")},strFomatToDate:function(str,regex){var cur=regex||"-";return new Date(str.replace(new RegExp(cur,"gm"),"/"))},strFormatAddMinutesToDate:function(str,addMinute,regex){var originDate=this.strFomatToDate(str,regex);return originDate.setMinutes(originDate.getMinutes()+addMinute),originDate},strFormatAddMinutesToStrFomat:function(str,addMinute,regex){var originDate=this.strFomatToDate(str,regex);return originDate.setMinutes(originDate.getMinutes()+addMinute),this.dateTimeFormatToStr(originDate)},dateTimeAddMinutesToDate:function(addMinute,date){var originDate=date||new Date;return originDate.setMinutes(originDate.getMinutes()+addMinute),originDate},dateTimeAddDaysToDate:function(addDays,date){var originDate=new Date;return date&&(originDate=new Date(date.getTime())),originDate.setDate(originDate.getDate()+addDays),originDate},getTimeIntervalDays:function(firstTime,secondTime){var seconds=(secondTime.getTime()-firstTime.getTime())/1e3;return Math.floor(seconds/86400)},getTimeIntervalHours:function(firstTime,secondTime){var seconds=(secondTime.getTime()-firstTime.getTime())/1e3;return Math.floor(seconds/3600)},getTimeIntervalMinutes:function(firstTime,secondTime){var seconds=(secondTime.getTime()-firstTime.getTime())/1e3;return Math.floor(seconds/60)},getTimeIntervalSeconds:function(firstTime,secondTime){var seconds=(secondTime.getTime()-firstTime.getTime())/1e3;return seconds>0?Math.floor(seconds):0},getShowValueByFormat:function(seconds,format){return Math.floor(seconds/60)},getCurHour:function(){return(new Date).getHours()},dateTimeSetHourToDate:function(hour,date){var originDate=date||new Date;return originDate.setHours(hour),originDate},dateTimeSetMinuteToDate:function(minute,date){var originDate=date||new Date;return originDate.setMinutes(minute),originDate},getWeekDay:function(date,prefix){return(prefix||"周")+"日一二三四五六".charAt((date||new Date).getDay())},getWeekDayByStr:function(dateStr,prefix){return this.getWeekDay(this.strFomatToDate(dateStr),prefix)}}}]).factory("anchorScrollService",["$location","$ionicScrollDelegate",function($location,$ionicScrollDelegate){return{goLocation:function(hashLocation){$location.hash(hashLocation),$ionicScrollDelegate.anchorScroll()}}}]).factory("backButtonService",["$ionicPlatform",function($ionicPlatform){return{noHidePopup:$ionicPlatform.registerBackButtonAction(function(){},401)}}]).factory("ionicGestureEventService",["$ionicGesture",function($ionicGesture){return{setEvent:function(eleId,onEvent,cb){return $ionicGesture.on(onEvent||"dragend",function(){angular.isFunction(cb)&&cb()},angular.element(document.querySelector("#"+eleId)))},offEvent:function(promise,event){$ionicGesture.off(promise,event||"dragend")}}}]).factory("JPushService",["pushMessageService",function(pushMessageService){function warpData(origin){return ionic.Platform.isIOS()?origin:origin.extras}return{openNotificationCb:function(event){var data=warpData(event);pushMessageService.openNotify(data)},receiveNotificationCb:function(event){var data=warpData(event);pushMessageService.receiveNotify(data)}}}]).factory("JPushUtils",[function(){return{setAlia:function(alia,sucCb,errCb){try{window.plugins.jPushPlugin.setAlias({sequence:1,alias:alia},sucCb,errCb)}catch(e){}}}}]).factory("payService",["toastTipService",function(toastTipService){return{weixinPay:function(params,sucCb,errCb){params.package="Sign=WXPay",Wechat.sendPaymentRequest(params,sucCb,function(reason){toastTipService.showShortTop("支付失败：: "+reason),angular.isFunction(errCb)&&errCb()})},aliPay:function(params,sucCb,errCb){cordova.plugins.AliPay.pay(params,sucCb,function(e){toastTipService.showShortTop("支付失败"),angular.isFunction(errCb)&&errCb()})}}}]).factory("fileTransferService",[function(){function saveImageToPhone(url,success,error){var canvas,context,imageDataUrl,imageData,img=new Image;img.onload=function(){(canvas=document.createElement("canvas")).width=img.width,canvas.height=img.height,(context=canvas.getContext("2d")).drawImage(img,0,0);try{imageDataUrl=canvas.toDataURL("image/jpeg",1),imageData=imageDataUrl.replace(/data:image\/jpeg;base64,/,""),cordova.exec(success,error,"Canvas2ImagePlugin","saveImageDataToLibrary",[imageData])}catch(e){error(e.message)}};try{img.src=url}catch(e){error(e.message)}}return{downLoad:function(imgUrl,success,error){saveImageToPhone(imgUrl,success,error)}}}]).factory("mediaService",["fileService",function(fileService){return{mediaPlay:function(fileUrl,sucCb,errCb){var myMedia=new Media(fileUrl,function(){myMedia.release(),angular.isFunction(sucCb)&&sucCb()},errCb);myMedia.play({playAudioWhenScreenIsLocked:!0}),myMedia.setVolume("1.0")},getMediaPath:function(fileUrl){return ionic.Platform.isIOS()?fileUrl:fileService.getFileOfWWW(fileUrl)},mediaPlayByLocal:function(fileUrl){var path=this.getMediaPath(fileUrl);this.mediaPlay(path)}}}]).factory("fileService",["toastTipService",function(toastTipService){return{getFileOfWWW:function(fileUrl){return cordova.file.applicationDirectory+"www/"+fileUrl}}}]).factory("loadingService",["$ionicLoading",function($ionicLoading){return{show:function(template){$ionicLoading.show({template:template||'<ion-spinner icon="android" class="spinner-calm"></ion-spinner>',noBackdrop:!0,duration:1e4})},hide:function(){$ionicLoading.hide()}}}]).factory("lgyxScannerService",["toastTipService","loadingService","Host",function(toastTipService,loadingService,Host){return{scanAll:function(sucCb,errCb,options){cordova.exec(function(res){res=JSON.parse(res),angular.isFunction(sucCb)&&sucCb(res)},function(err){toastTipService.showShortTop(err),angular.isFunction(errCb)&&errCb()},"LgyxScanPlugin","onScanAll",[JSON.stringify(options)])},baseScan:function(sucCb,errCb,option,resKey){cordova.exec(function(res){res=JSON.parse(res),angular.isFunction(sucCb)&&sucCb(res[resKey])},function(err){toastTipService.showShortTop(err),angular.isFunction(errCb)&&errCb()},"LgyxScanPlugin","onScan",[JSON.stringify(option)])},scanQR:function(sucCb,errCb){this.baseScan(sucCb,errCb,{qrCode:!0},"qrCode")},scanPhone:function(sucCb,errCb){this.baseScan(sucCb,errCb,{phone:!0,hostUrl:Host},"phone")},scanBarcode:function(sucCb,errCb){this.baseScan(sucCb,errCb,{barCode:!0},"barCode")}}}]).factory("stringUtilsService",["localConstantData",function(localConstantData){return{arrJoinToStr:function(oriArr,obKey,sep){for(var sepCode=sep||"&",key=obKey||"id",str="",i=0;i<oriArr.length;i++)str+=oriArr[i][key]+sepCode;return str.substring(0,str.length-1)},regValidate:function(originStr,pattern,flag){return!!angular.isString(originStr)&&new RegExp(pattern,flag).test(originStr)},cellPhoneValidate:function(phone){return this.regValidate(phone,localConstantData.html.cellphone,"g")},numberValidate:function(str){return this.regValidate(str,"^[0-9]*$","g")}}}]),agencyApp=angular.module("AgencyApp",["ionic","ionic-native-transitions","angular.utils","AgencyApp.constants","AgencyApp.services","AgencyApp.controllers","AgencyApp.directives","AgencyApp.filters","templates"]).config(["$stateProvider","$urlRouterProvider",function($stateProvider,$urlRouterProvider){$urlRouterProvider.otherwise("/guide"),$stateProvider.state("signin",{url:"/signin",cache:!1,templateUrl:"mine/login.html",controller:"signinCtrl"}).state("guide",{url:"/guide",cache:!1,templateUrl:"mine/guide.html",controller:"guideCtrl"}).state("forgetPwds",{url:"/forgetPwds",cache:!1,templateUrl:"mine/forgetPwds.html",controller:"forgetPwdsCtrl"}).state("register",{url:"/register",cache:!1,templateUrl:"mine/register.html",resolve:{areas:["userInfoService",function(userInfoService){return userInfoService.getAllAreas()}],express:["expressService",function(expressService){return expressService.fetchAllExpress()}]},controller:"registerCtrl"}).state("updatePW",{url:"/mine/updatePW",cache:!1,templateUrl:"mine/updatePW.html"}).state("index",{url:"/index",abstract:!0,templateUrl:"tabs.html"}).state("index.home",{url:"/home",views:{homeTab:{templateUrl:"main/notify.html",resolve:{baseInfo:["userInfoService",function(userInfoService){return userInfoService.getBaseInfo()}]},controller:"homeCtrl"}}}).state("index.statistics",{url:"/statistics",cache:!1,views:{statisticsTab:{templateUrl:"main/statistics.html",resolve:{searchConditions:["warehouseService",function(warehouseService){return warehouseService.getSearchConditions()}]},controller:"statisticsCtrl"}}}).state("statisticsDetail",{url:"/statisticsDetail",cache:!1,params:{proxyId:null,expressId:null,date:null},templateUrl:"main/statisticsDetail.html",controller:"statisticsDetailCtrl"}).state("index.warehouse",{url:"/warehouse",cache:!1,views:{warehouseTab:{templateUrl:"main/warehouse.html",resolve:{searchConditions:["warehouseService",function(warehouseService){return warehouseService.getSearchConditions()}]},controller:"warehouseCtrl"}}}).state("index.mine",{url:"/mine",cache:!1,views:{mineTab:{templateUrl:"main/mine.html",resolve:{baseInfo:["userInfoService",function(userInfoService){return userInfoService.getBaseInfo()}]},controller:"mineCtrl"}}}).state("recharge",{url:"/recharge",cache:!1,templateUrl:"mine/recharge.html",resolve:{baseInfo:["userInfoService",function(userInfoService){return userInfoService.getBaseInfo()}],chargeConfig:["rechargeService",function(rechargeService){return rechargeService.getMoneyChargeConfig()}]},controller:"rechargeCtrl"}).state("paySuccess",{url:"/paySuccess",cache:!1,templateUrl:"mine/paySuccess.html",controller:"paySuccessCtrl"}).state("aboutUs",{url:"/aboutUs",cache:!1,templateUrl:"mine/aboutUs.html"}).state("contactUs",{url:"/contactUs",cache:!1,templateUrl:"mine/contactUs.html",controller:"contactUsCtrl"}).state("blacklist",{url:"/blacklist",cache:!1,templateUrl:"mine/blacklist.html",controller:"blacklistCtrl"}).state("cooperation",{url:"/cooperation",cache:!1,templateUrl:"mine/cooperation.html",controller:"cooperationCtrl"}).state("courierInformation",{url:"/courierInformation",cache:!1,templateUrl:"mine/courierInformation.html",resolve:{areas:["userInfoService",function(userInfoService){return userInfoService.getAllAreas()}],baseInfo:["userInfoService",function(userInfoService){return userInfoService.getBaseInfo()}]},controller:"courierInformationCtrl"}).state("manualInput",{url:"/manualInput",cache:!1,templateUrl:"main/manualInput.html",resolve:{baseInfo:["userInfoService",function(userInfoService){return userInfoService.getBaseInfo()}],bindExpress:["userInfoService",function(userInfoService){return userInfoService.getBindExpress(!0)}],bindProxy:["userInfoService",function(userInfoService){return userInfoService.getBindProxy(!0)}]},controller:"manualInputCtrl"}).state("batchInput",{url:"/batchInput",cache:!1,templateUrl:"main/batchInput.html",resolve:{baseInfo:["userInfoService",function(userInfoService){return userInfoService.getBaseInfo()}],bindExpress:["userInfoService",function(userInfoService){return userInfoService.getBindExpress(!0)}],bindProxy:["userInfoService",function(userInfoService){return userInfoService.getBindProxy(!0)}]},controller:"batchInputCtrl"}).state("inputPhone",{url:"/inputPhone",cache:!1,templateUrl:"main/inputPhone.html",resolve:{baseInfo:["userInfoService",function(userInfoService){return userInfoService.getBaseInfo()}],bindExpress:["userInfoService",function(userInfoService){return userInfoService.getBindExpress(!0)}],bindProxy:["userInfoService",function(userInfoService){return userInfoService.getBindProxy(!0)}]},controller:"phoneInputCtrl"}).state("custom",{url:"/custom",cache:!1,templateUrl:"main/custom.html",resolve:{custom:["userInfoService",function(userInfoService){return userInfoService.getRecipientCustom()}]},controller:"customCtrl"}).state("changeOrder",{url:"/changeOrder",cache:!1,params:{orderInfo:null},templateUrl:"modal/changeOrder.html",resolve:{orderInfo:["$stateParams",function($stateParams){return $stateParams.orderInfo}],bindExpress:["userInfoService",function(userInfoService){return userInfoService.getBindExpress(!0)}],bindProxy:["userInfoService",function(userInfoService){return userInfoService.getBindProxy(!0)}]},controller:"changeOrderCtrl"}).state("sendPieces",{url:"/sendPieces",templateUrl:"main/sendPieces.html",resolve:{searchConditions:["warehouseService",function(warehouseService){return warehouseService.getSearchConditions()}]},controller:"piecesCtrl"}).state("failedMsge",{url:"/failedMsge",cache:!1,templateUrl:"main/failedMsge.html",controller:"failedMsgeCtrl"}).state("template",{url:"/template",cache:!1,templateUrl:"mine/template.html",resolve:{signInfo:["smsTemplateService",function(smsTemplateService){return smsTemplateService.getDefaultSign()}]},controller:"smsTemplateCtrl"}).state("addTemplate",{url:"/addTemplate",cache:!1,params:{editItem:null},templateUrl:"mine/addTemplate.html",resolve:{signInfo:["smsTemplateService",function(smsTemplateService){return smsTemplateService.getDefaultSign()}]},controller:"addTemplateCtrl"}).state("payment",{url:"/payment",cache:!1,templateUrl:"mine/payment.html",resolve:{config:["smsTemplateService",function(smsTemplateService){return smsTemplateService.getSignPayConfig()}]},controller:"paymentCtrl"}).state("myteam",{url:"/myteam",cache:!1,templateUrl:"mine/myteam.html",controller:"accountCtrl"}).state("addAccount",{url:"/addAccount",cache:!1,templateUrl:"mine/addAccount.html",controller:"addAccountCtrl"}).state("reviseAccount",{url:"/reviseAccount",cache:!1,params:{account:null},templateUrl:"mine/reviseAccount.html",resolve:{account:["$stateParams",function($stateParams){return $stateParams.account}]},controller:"modifyAccountCtrl"}).state("collectionPoint",{url:"/collectionPoint",cache:!1,templateUrl:"mine/collectionPoint.html",controller:"proxyCtrl"}).state("addCollection",{url:"/addCollection",cache:!1,templateUrl:"mine/addCollection.html",controller:"addProxyCtrl"}).state("reviseCollection",{url:"/reviseCollection",cache:!1,params:{proxy:null},templateUrl:"mine/reviseCollection.html",resolve:{proxy:["$stateParams",function($stateParams){return $stateParams.proxy}]},controller:"modifyProxyCtrl"}).state("selectExpress",{url:"/selectExpress",cache:!1,params:{checkedExpress:null},templateUrl:"mine/selectExpress.html",resolve:{express:["expressService","$stateParams",function(expressService,$stateParams){return expressService.fetchAllExpress().then(function(all){return expressService.wrapExpress(all,$stateParams.checkedExpress)})}]},controller:"selectExpressCtrl"})}]);angular.module("AgencyApp.controllers",["ionic","chart.js"]).controller("testCtrl",["$scope","toastTipService",function($scope,toastTipService){$scope.localData=function(){},$scope.listenSpeak=function(){xunfeiListenSpeaking.startListen(function(data){alert("识别成功: "+data)},function(e){alert("出现错误："+e)},!1,!1)}}]).controller("forgetPwdsCtrl",["$scope","sendCheckCodeService","toastTipService","htmlUtilsService","localConstantData","userInfoService",function($scope,sendCheckCodeService,toastTipService,htmlUtilsService,localConstantData,userInfoService){var pd=$scope.pageData={},pm=$scope.param={};sendCheckCodeService.initService(),pd.picCodeUrl=userInfoService.getPicCodeUrl(),pd.sendVerifyCodeButton=sendCheckCodeService.sendVerifyCodeButton;var validatePhone=function(){var err=null,phone=pm.phone;return phone?phone&&!htmlUtilsService.stringRegValidate(phone,localConstantData.html.cellphone,"g")&&(err="请输入有效的手机号"):err="手机号不能为空",null===err||(toastTipService.showShortTop(err),!1)};$scope.sendVerifyCode=function(){validatePhone()?sendCheckCodeService.sendVerifyCode("ResetPwSendMess",{phone:pm.phone},function(data){htmlUtilsService.focusInput("resetCode")}):htmlUtilsService.focusInput("resetPhone")};var paramValidate=function(){var err=null,pw=pm.newpsd;return!!validatePhone()&&(pm.code?pw?htmlUtilsService.stringRegValidate(pw,"\\s","g")?err="密码含有非法字符！":pw&&(pw.length<6||pw.length>18)&&(err="密码长度应在6~18位之间"):err="密码不能为空":err="短信验证码不能为空",null===err||(toastTipService.showShortTop(err),!1))};$scope.goReset=function(){paramValidate()&&userInfoService.resetPw(pm).then(function(){$scope.$ionicGoBack()})},$scope.clearParam=function(param){pm[param]=null}}]).controller("signinCtrl",["$scope","LocalDatabase","userInfoService","htmlUtilsService","localConstantData","toastTipService",function($scope,LocalDatabase,userInfoService,htmlUtilsService,localConstantData,toastTipService){var pm=$scope.param={loginName:null,password:null},getLastSignin=function(){var prelogin=LocalDatabase.get(LocalDatabase.Data.preLogin);prelogin&&(pm.loginName=prelogin.loginName)};!function(){getLastSignin();var user=LocalDatabase.get(LocalDatabase.Data.user);user&&userInfoService.loggedinEvent(user.id)}();var paramValidate=function(){var err=null,name=pm.loginName,pw=pm.password;return name?name&&!htmlUtilsService.stringRegValidate(name,localConstantData.html.cellphone,"g")?err="请输入有效的手机号":pw?htmlUtilsService.stringRegValidate(pw,"\\s","g")?err="密码含有非法字符！":pw&&(pw.length<6||pw.length>18)&&(err="密码长度应在6~18位之间"):err="密码不能为空":err="手机号不能为空",null===err||(toastTipService.showShortTop(err),!1)};$scope.accountSignin=function(){paramValidate()&&userInfoService.login(pm)},$scope.clearParam=function(param){pm[param]=null}}]).controller("registerCtrl",["$scope","areas","express","sendCheckCodeService","ionicPopupService","toastTipService","htmlUtilsService","localConstantData","userInfoService",function($scope,areas,express,sendCheckCodeService,ionicPopupService,toastTipService,htmlUtilsService,localConstantData,userInfoService){var pd=$scope.pageData={},pm=$scope.param={};$scope.isiOS=!1;var setCurExp=function(exp){pm.expressId=exp.id,pd.curExpressName=exp.name};sendCheckCodeService.initService(),pd.picCodeUrl=userInfoService.getPicCodeUrl(),pd.sendVerifyCodeButton=sendCheckCodeService.sendVerifyCodeButton,pd.showProvince=!1,pd.showCity=!1,pd.provinces=areas,pd.allExp=express,pd.showExp=!1,setCurExp(express[0]),cordova.platformId&&"ios"==cordova.platformId&&($scope.isiOS=!0);var validatePhone=function(){var err=null,phone=pm.phone;return phone?phone&&!htmlUtilsService.stringRegValidate(phone,localConstantData.html.cellphone,"g")&&(err="请输入有效的手机号"):err="手机号不能为空",null===err||(toastTipService.showShortTop(err),!1)},picValidate=function(){var picUrlNoRandom=sendCheckCodeService.getPicCodeUrlNoRandom(pm.phone),random=Math.random();ionicPopupService.show('<img id="picValidate" style="width: 80px; height: 40px;" src='+picUrlNoRandom+random+"><span style=\"font-size:1rem;margin-left:15px;\" onclick=\"var rd = Math.random();document.getElementById('picValidate').src='"+picUrlNoRandom+'\'+rd;">换一张</span><br><input style="text-align: center;border:1px solid #ddd;margin:10px 10% 0;border-radius:3px;width:80%;" type="tel" id="picCode" placeholder="请输入图形验证码" maxlength="4">',null,null,"取消",null,"确认",function(e){var picCode=htmlUtilsService.getEleById("picCode").value.replace(/\s/gi,"");picCode&&4==picCode.length?sendCheckCodeService.sendVerifyCode("SendMessage",{phone:pm.phone,imageCode:picCode},function(data){pm.contacts=pm.phone,htmlUtilsService.focusInput("code")}):(toastTipService.showShortTop("请输入正确的验证码!"),e.preventDefault())})};$scope.sendVerifyCode=function(){validatePhone()?picValidate():htmlUtilsService.focusInput("registePhone")};var initCity=function(){pd.curCity=null,pm.city=null};$scope.hideArea=function(areaName){pd["show"+areaName]=!1},$scope.showArea=function(areaName){pd["show"+areaName]=!0},$scope.provinceChanged=function(area){pd.curProvince=area.regionName,initCity(),pd.cities=area.regions},$scope.cityChanged=function(area){pd.curCity=area.regionName},$scope.expChanged=function(exp){pd.curExpressName=exp.name};var paramValidate=function(){var err=null,pw=pm.password,contacts=pm.contacts;return!!validatePhone()&&(pw?htmlUtilsService.stringRegValidate(pw,"\\s","g")?err="密码含有非法字符！":pw&&(pw.length<6||pw.length>18)?err="密码长度应在6~18位之间":pm.code?pm.province?pm.city?pm.name?contacts?contacts&&!htmlUtilsService.stringRegValidate(contacts,localConstantData.html.tel,"g")&&(err="请输入有效的联系电话"):err="联系电话不能为空":err="姓名不能为空":err="请选择所在城市":err="请选择所在省份":err="短信验证码不能为空":err="密码不能为空",null===err||(toastTipService.showShortTop(err),!1))};$scope.goRegister=function(){paramValidate()&&userInfoService.register(pm)},$scope.clearParam=function(param){pm[param]=null}}]).controller("guideCtrl",["$scope","$ionicSlideBoxDelegate","LocalDatabase","ionicHistoryService","EmitEvent",function($scope,$ionicSlideBoxDelegate,LocalDatabase,ionicHistoryService,EmitEvent){var effectDelegate=null;$scope.effects=[{url:"img/guide1.png"},{url:"img/guide2.png"},{url:"img/guide3.png"}],$scope.turnAround=function(index){index>=effectDelegate.slidesCount()&&($scope.showButton=!0)},$scope.goProject=function(){LocalDatabase.set(LocalDatabase.guideFlag,!0),ionicHistoryService.goNextRootPage("signin")},$scope.$on(EmitEvent.ViewLoaded,function(){(effectDelegate=$ionicSlideBoxDelegate.$getByHandle("effectArea")).update(),effectDelegate.start(),$scope.indexEffect=0}),$scope.$on(EmitEvent.ViewBeforeEnter,function(){LocalDatabase.get(LocalDatabase.guideFlag)&&ionicHistoryService.goNextRootPage("signin")})}]).controller("homeCtrl",["$scope","$cordovaClipboard","$ionicPopup","baseInfo","dateTimeService","toastTipService","EmitEvent","userInfoService","warehouseService","deliveryService","CacheStore","stringUtilsService","ionicPopupService","phoneService","mediaService",function($scope,$cordovaClipboard,$ionicPopup,baseInfo,dateTimeService,toastTipService,EmitEvent,userInfoService,warehouseService,deliveryService,CacheStore,stringUtilsService,ionicPopupService,phoneService,mediaService){var pd=$scope.pd={},init=($scope.pm={},function(){var custom=userInfoService.getRecipientCustom();pd.custom=custom,pd.address=baseInfo.address,warehouseService.loadHomeInList().then(function(data){pd.inList=data,pd.inList.forEach(function(it){it.showPhoneAct=!1,it.showMoreAct=!1,it.canShowPhoneAct=stringUtilsService.cellPhoneValidate(it.phone)})}),userInfoService.getStat7().then(function(data){$scope.$broadcast("scroll.refreshComplete"),pd.data=data,pd.todayIn=0,pd.todayOut=0,pd.todayReturn=0,pd.inTotal=0,pd.urgeTotal=0,pd.failTotal=0,pd.series=["派件"],pd.colors=["rgb(159,204,0)"],pd.labels=[],pd.day7data=[];var now=new Date;now.setDate(now.getDate()-7);for(var i=0;i<7;++i){now.setDate(now.getDate()+1);var day1=dateTimeService.dateTimeFormatToStr(now,"MM-dd");pd.labels.push(day1);var day2=dateTimeService.dateTimeFormatToStr(now,"yyyyMMdd"),number=0;if(pd.data)for(var j=0;j<pd.data.length;++j){var it=pd.data[j];if(day2==it.statDay){number=it.totalNumber,6==i&&(pd.todayIn=it.inNumber,pd.todayOut=it.outNumber,pd.todayReturn=it.returnNumber);break}}pd.day7data.push(number)}})});$scope.freshHome=function(){init()},$scope.dialog=function(phone){phoneService.dialog(phone)},$scope.copyPhoneToClipboard=function(phone){$cordovaClipboard.copy(phone).then(function(){toastTipService.showShortTop("复制成功")},function(){toastTipService.showShortTop("复制失败")})},$scope.hideAll=function(item){pd.inList.forEach(function(it){void 0!=item&&null!=item&&it.id==item.id||(it.showPhoneAct=!1)})},$scope.deleteOrder=function(item,index){ionicPopupService.confirm("确认要删除该快递吗，删除后不能恢复?","",null,function(){deliveryService.deleteOrder(item.id).then(function(res){pd.inList.splice(index,1),toastTipService.showShortTop("订单删除成功")})})},$scope.showPhoneAction=function(item){$scope.hideAll(item),item.showPhoneAct=!item.showPhoneAct},$scope.wrapEXpImg=warehouseService.getExpImg,$scope.showMess=deliveryService.showNotifyMess,$scope.$on(EmitEvent.ViewLoaded,function(){init()})}]).controller("manualInputCtrl",["$scope","baseInfo","bindExpress","bindProxy","EmitEvent","userInfoService","manyMethodInputService","smsTemplateService","toastTipService","$timeout","stringUtilsService","deliveryService",function($scope,baseInfo,bindExpress,bindProxy,EmitEvent,userInfoService,manyMethodInputService,smsTemplateService,toastTipService,$timeout,stringUtilsService,deliveryService){var pd=$scope.pd={},pm=$scope.pm={};pd.OrderInTipOptions={},$scope.isiOS=!1,$scope.newOldType=2;var resRecipientCustom=function(){var custom=userInfoService.getRecipientCustom();pd.custom=custom,custom.nameFlag||(pm.name=null),custom.addressFlag||(pm.address=null),custom.memoFlag||(pm.memo=null)},init=function(){resRecipientCustom(),pd.showProxyList=!1,pd.showExpress=!1,userInfoService.initUserBalances(baseInfo,pd),pd.bindExpress=bindExpress,pd.bindProxy=bindProxy;var defaultProxy=null;void 0===bindProxy||null===bindProxy||bindProxy.length<=0?pd.custom.sendProxy=!1:defaultProxy=bindProxy[0],manyMethodInputService.initSharePms(pd,pm,bindExpress[0],defaultProxy),pd.showMatchPhones=!1,pd.matchPhones=[],pd.listenLoadingFlag=!1,smsTemplateService.initSMSCase(pd),manyMethodInputService.loadBlackList(),cordova.platformId&&"ios"==cordova.platformId&&($scope.isiOS=!0)};$scope.pullRefresh=function(){userInfoService.updateUserBalances().then(function(data){userInfoService.initUserBalances(data,pd),smsTemplateService.getDefaultSign(!0).then(function(sign){$scope.$broadcast("scroll.refreshComplete"),pd.sign=smsTemplateService.wrapSignFormat(sign)})})},$scope.sendProxyChanged=function(){(void 0===bindProxy||null===bindProxy||bindProxy.length<=0)&&(pd.custom.sendProxy=!1,toastTipService.showShortTop("还没有绑定代收点，无法开启派送到代收点")),userInfoService.setRecipientCustom(pd.custom)},$scope.hideExpress=function(){pd.showExpress=!1},$scope.showExpress=function(){pd.showExpress=!0},$scope.hideProxyList=function(){pd.showProxyList=!1},$scope.showProxyList=function(){pd.showProxyList=!0},$scope.expressChanged=function(item){$scope.hideExpress(),pd.express=item.name,pd.smsContent=smsTemplateService.initTemplateContentShow(pd.express,pd.proxyName)},$scope.proxyChanged=function(item){$scope.hideProxyList(),pd.proxyName=item.name,pd.smsContent=smsTemplateService.initTemplateContentShow(pd.express,pd.proxyName)},$scope.phoneChanged=function(){pd.showMatchPhones=!1,$scope.newOldType=2,4===pm.phone.length?deliveryService.fetchMatchPhones(pm.phone,function(matchResult){1==matchResult.length&&"1"!=pm.phone.substring(0,1)?$scope.choosePhone(matchResult[0]):matchResult.length>0&&(pd.matchPhones=matchResult,pd.showMatchPhones=!0)}):11===pm.phone.length&&stringUtilsService.cellPhoneValidate(pm.phone)&&deliveryService.getReceiverByTel(pm.phone).then(function(res){res?($scope.newOldType=0,pd.custom.nameFlag&&res.name&&(pm.name=res.name),pd.custom.addressFlag&&res.address&&(pm.address=res.address)):$scope.newOldType=1})},$scope.choosePhone=function(phone){pd.showMatchPhones=!1,pm.phone=phone,$scope.phoneChanged()},$scope.startScan=function(){manyMethodInputService.phoneScan(function(res){$timeout(function(){pm.phone=res,$scope.phoneChanged()})})},$scope.orderNoScan=function(){manyMethodInputService.orderNoScan(function(res){$timeout(function(){pm.orderNo=res})})},$scope.startListen=function(type){pd.listenLoadingFlag=!0,xunfeiListenSpeaking.startListen(function(data){$timeout(function(){if(pd.listenLoadingFlag=!1,"phone"==type){if(!data||data.length>11||!stringUtilsService.numberValidate(data))return void toastTipService.showShortTop("请录入正确的手机号码");pm.phone=data,$scope.phoneChanged()}else"orderno"==type?pm.orderNo=data:"name"==type?pm.name=data:"memo"==type?pm.memo=data:"address"==type&&(pm.address=data)})},function(e){$timeout(function(){pd.listenLoadingFlag=!1}),toastTipService.showShortTop("识别错误，请检查是否已开启录音权限"+e)},!0,!1)},$scope.hideListenLoading=function(){xunfeiListenSpeaking.stopListen(),pd.listenLoadingFlag=!1},$scope.goPay=function(){userInfoService.goPay(null)},$scope.manualIn=function(){manyMethodInputService.manualIn(pm,pd),$scope.newOldType=2},$scope.wrapEXpImg=userInfoService.getExpImg,$scope.$on(EmitEvent.ViewLoaded,function(){init()}),$scope.$on(EmitEvent.ViewBeforeLeave,function(){manyMethodInputService.recordSharePms(pd,pm)})}]).controller("batchInputCtrl",["$scope","baseInfo","bindExpress","bindProxy","EmitEvent","userInfoService","manyMethodInputService","deliveryService","smsTemplateService","toastTipService",function($scope,baseInfo,bindExpress,bindProxy,EmitEvent,userInfoService,manyMethodInputService,deliveryService,smsTemplateService,toastTipService){var pd=$scope.pd={},pm=$scope.pm={},ed={};pd.batchResOptions={},$scope.isiOS=!1;var resRecipientCustom=function(){var custom=userInfoService.getRecipientCustom();pd.custom=custom,ed.custom=custom,pd.noMessage=custom.noMessage},init=function(){resRecipientCustom(),pd.showProxyList=!1,pd.showExpress=!1,userInfoService.initUserBalances(baseInfo,pd),pd.bindExpress=bindExpress,pd.bindProxy=bindProxy;var defaultProxy=null;void 0===bindProxy||null===bindProxy||bindProxy.length<=0?pd.custom.sendProxy=!1:defaultProxy=bindProxy[0],manyMethodInputService.initSharePms(pd,pm,bindExpress[0],defaultProxy),smsTemplateService.initSMSCase(pd),cordova.platformId&&"ios"==cordova.platformId&&($scope.isiOS=!0)};$scope.pullRefresh=function(){userInfoService.updateUserBalances().then(function(data){userInfoService.initUserBalances(data,pd),smsTemplateService.getDefaultSign(!0).then(function(sign){$scope.$broadcast("scroll.refreshComplete"),pd.sign=smsTemplateService.wrapSignFormat(sign)})})},$scope.sendProxyChanged=function(){(void 0===bindProxy||null===bindProxy||bindProxy.length<=0)&&(pd.custom.sendProxy=!1,toastTipService.showShortTop("还没有绑定代收点，无法开启派送到代收点")),userInfoService.setRecipientCustom(pd.custom)},$scope.hideExpress=function(){pd.showExpress=!1},$scope.showExpress=function(){pd.showExpress=!0},$scope.hideProxyList=function(){pd.showProxyList=!1},$scope.showProxyList=function(){pd.showProxyList=!0},$scope.expressChanged=function(item){$scope.hideExpress(),pd.express=item.name,pd.smsContent=smsTemplateService.initTemplateContentShow(pd.express,pd.proxyName)},$scope.proxyChanged=function(item){$scope.hideProxyList(),pd.proxyName=item.name,pd.smsContent=smsTemplateService.initTemplateContentShow(pd.express,pd.proxyName)},$scope.modelIn=function(){manyMethodInputService.modelIn(!0,pm,pd,pd.custom)},$scope.goPay=function(){userInfoService.goPay(null)},$scope.wrapEXpImg=userInfoService.getExpImg,$scope.$on(EmitEvent.ViewLoaded,function(){init()}),$scope.$on(EmitEvent.ViewBeforeLeave,function(){manyMethodInputService.recordSharePms(pd,pm)})}]).controller("phoneInputCtrl",["$scope","baseInfo","bindExpress","bindProxy","EmitEvent","userInfoService","manyMethodInputService","deliveryService","toastTipService","$timeout","stringUtilsService","smsTemplateService",function($scope,baseInfo,bindExpress,bindProxy,EmitEvent,userInfoService,manyMethodInputService,deliveryService,toastTipService,$timeout,stringUtilsService,smsTemplateService){var pd=$scope.pd={},pm=$scope.pm={};pd.batchResOptions={},$scope.isiOS=!1,pd.phoneList=[];var init=function(){pd.showProxyList=!1,pd.showExpress=!1,pd.custom=userInfoService.getRecipientCustom(),userInfoService.initUserBalances(baseInfo,pd),pd.bindExpress=bindExpress,pd.bindProxy=bindProxy;var defaultProxy=null;void 0===bindProxy||null===bindProxy||bindProxy.length<=0?pd.custom.sendProxy=!1:defaultProxy=bindProxy[0],manyMethodInputService.initSharePms(pd,pm,bindExpress[0],defaultProxy),pd.showMatchPhones=!1,pd.matchPhones=[],pd.listenLoadingFlag=!1,smsTemplateService.initSMSCase(pd),manyMethodInputService.loadBlackList(),"random"!=pd.custom.codeType&&"phone4"!=pd.custom.codeType&&toastTipService.showShortTop("该模式只支持：随机5位和手机号码后4位取件码两种形式"),cordova.platformId&&"ios"==cordova.platformId&&($scope.isiOS=!0)};$scope.pullRefresh=function(){userInfoService.updateUserBalances().then(function(data){userInfoService.initUserBalances(data,pd),smsTemplateService.getDefaultSign(!0).then(function(sign){$scope.$broadcast("scroll.refreshComplete"),pd.sign=smsTemplateService.wrapSignFormat(sign)})})},$scope.hideExpress=function(){pd.showExpress=!1},$scope.showExpress=function(){pd.showExpress=!0},$scope.hideProxyList=function(){pd.showProxyList=!1},$scope.showProxyList=function(){pd.showProxyList=!0},$scope.expressChanged=function(item){$scope.hideExpress(),pd.express=item.name,pd.smsContent=smsTemplateService.initTemplateContentShow(pd.express,pd.proxyName)},$scope.proxyChanged=function(item){$scope.hideProxyList(),pd.proxyName=item.name,pd.smsContent=smsTemplateService.initTemplateContentShow(pd.express,pd.proxyName)},$scope.sendProxyChanged=function(){(void 0===bindProxy||null===bindProxy||bindProxy.length<=0)&&(pd.custom.sendProxy=!1,toastTipService.showShortTop("还没有绑定代收点，无法开启派送到代收点")),userInfoService.setRecipientCustom(pd.custom)},$scope.removePhone=function(item,index){for(var count=0,otherIndex=-1,i=0;i<pd.phoneList.length;++i)pd.phoneList[i].phone==item.phone&&(count++,i!=index&&(otherIndex=i));2==count&&(pd.phoneList[otherIndex].isRepeat=!1),pd.phoneList.splice(index,1)};var addPhone=function(phone,type,name,address){var isRepeat=!1;pd.phoneList.forEach(function(it){if(it.phone==phone)return isRepeat=!0,void(it.isRepeat=!0)});var obj={phone:phone,isRepeat:isRepeat,type:type,expressId:pm.expressId,name:name||"",address:address||""};pd.phoneList.unshift(obj)};$scope.phoneChanged=function(){pd.showMatchPhones=!1,4===pm.phone.length?deliveryService.fetchMatchPhones(pm.phone,function(matchResult){1==matchResult.length&&"1"!=pm.phone.substring(0,1)?$scope.choosePhone(matchResult[0]):matchResult.length>0&&(pd.matchPhones=matchResult,pd.showMatchPhones=!0)}):11===pm.phone.length&&(stringUtilsService.cellPhoneValidate(pm.phone)?deliveryService.getReceiverByTel(pm.phone).then(function(res){if(res){var name="",address="";res.name&&(name=res.name),res.address&&(address=res.address),addPhone(pm.phone,0,name,address)}else addPhone(pm.phone,1);pm.phone=""}):toastTipService.showShortTop("手机号码不符合规则"))},$scope.choosePhone=function(phone){pd.showMatchPhones=!1,pm.phone=phone,$scope.phoneChanged()},$scope.startScan=function(){manyMethodInputService.phoneScan(function(res){$timeout(function(){pm.phone=res,$scope.phoneChanged()})})},$scope.startListenPhone=function(){pd.listenLoadingFlag=!0,xunfeiListenSpeaking.startListen(function(data){$timeout(function(){pd.listenLoadingFlag=!1,pm.phone=data,$scope.phoneChanged()})},function(e){$timeout(function(){pd.listenLoadingFlag=!1}),toastTipService.showShortTop("识别错误，请检查是否已开启录音权限"+e)},!0,!1)},$scope.hideListenLoading=function(){xunfeiListenSpeaking.stopListen(),pd.listenLoadingFlag=!1},$scope.goPay=function(){userInfoService.goPay(null)},$scope.phoneIn=function(){pd.phoneList.length<=0?toastTipService.showShortTop("没有有效的数据入库"):"random"==pd.custom.codeType||"phone4"==pd.custom.codeType?manyMethodInputService.phoneIn(pm,pd,pd.custom):toastTipService.showShortTop("该模式只支持：随机5位和手机号码后4位取件码两种形式")},$scope.wrapEXpImg=userInfoService.getExpImg,$scope.$on(EmitEvent.ViewLoaded,function(){init()}),$scope.$on(EmitEvent.ViewBeforeLeave,function(){manyMethodInputService.recordSharePms(pd,pm)})}]).controller("smsTemplateCtrl",["$scope","signInfo","EmitEvent","CacheStore","smsTemplateService","ionicPopupService","toastTipService","localConstantData","phoneService",function($scope,signInfo,EmitEvent,CacheStore,smsTemplateService,ionicPopupService,toastTipService,localConstantData,phoneService){var pd=$scope.pd={};$scope.pm={};pd.signAgreementOptions={btType:"submit"},pd.changeSignOptions={changedCb:function(flag){toastTipService.showShortTop("已提交"),flag&&(smsTemplateService.getDefaultSign(!0).then(function(sign){pd.sign=smsTemplateService.wrapSignFormat(sign)}),smsTemplateService.getNoCommonSign().then(function(data){pd.noCommonSign=data}))}};$scope.refresh=function(){smsTemplateService.getDefaultSign(!0).then(function(sign){pd.sign=smsTemplateService.wrapSignFormat(sign),smsTemplateService.fetchTemplates(!0).then(function(){$scope.$broadcast("scroll.refreshComplete"),pd.templates=CacheStore.smsTemplate.templateList})})},$scope.goChangeForFaiure=function(){pd.changeSignOptions.showModel()},$scope.chooseSys=function(){pd.systemTemplate.isDefault?toastTipService.showShortTop("已是默认模板"):smsTemplateService.setToDefaultTemplate(pd.systemTemplate,-1).then(function(flag){flag?(pd.systemTemplate.isDefault=!0,toastTipService.showShortTop("设置成功")):toastTipService.showShortTop("设置失败")})};var callUs=function(){phoneService.dialog(localConstantData.contactUs)};$scope.chooseCur=function(item,index){if("checkfailure"===item.status)ionicPopupService.show("模板未通过审核，您提交的通知信息涉嫌违规，请改正。谢谢合作，如有疑问请拨打客服电话"+localConstantData.contactUs,"提醒",null,"取消",null,"联系客服",callUs);else if("submited"===item.status)ionicPopupService.show("模板正在审核中，请耐心等待。如有疑问请拨打客服电话"+localConstantData.contactUs,"提醒",null,"取消",null,"联系客服",callUs);else if("checked"===item.status){if(item.isDefault)return void toastTipService.showShortTop("已是默认模板");smsTemplateService.setToDefaultTemplate(item,index).then(function(flag){flag?(pd.systemTemplate.isDefault=!1,toastTipService.showShortTop("设置成功")):toastTipService.showShortTop("设置失败")})}},$scope.editOne=function(item,index){item.isDefault?ionicPopupService.confirm("修改使用中短信模板需要系统审核，审核通过才能继续使用，期间会使用系统默认模板，您确认要修改吗？",null,null,function(){smsTemplateService.goEditTemplate(item,index)}):smsTemplateService.goEditTemplate(item,index)},$scope.delOne=function(item,index){var content="确认删除当前模板?";item.isDefault&&(content="删除使用中的短信模板后，将会使用系统默认短信模板发送通知，您确认要删除吗？"),ionicPopupService.confirm(content,null,null,function(){smsTemplateService.delTemplate(item.id).then(function(){toastTipService.showShortTop("删除成功"),item.isDefault&&(smsTemplateService.setSystemToDefaultTemplate(),pd.systemTemplate.isDefault=!0),CacheStore.smsTemplate.templateList.splice(index,1)})})},$scope.changeSign=function(){pd.signAgreementOptions.showModel()},$scope.$on(EmitEvent.ViewLoaded,function(){pd.sign=smsTemplateService.wrapSignFormat(signInfo),pd.systemTemplate=smsTemplateService.getSystemTemplate(),CacheStore.smsTemplate.defaultTemplate?pd.systemTemplate.isDefault=CacheStore.smsTemplate.defaultTemplate.isSys:smsTemplateService.getDefaultTemplate().then(function(){pd.systemTemplate.isDefault=CacheStore.smsTemplate.defaultTemplate.isSys}),smsTemplateService.fetchTemplates().then(function(){pd.templates=CacheStore.smsTemplate.templateList}),smsTemplateService.getNoCommonSign().then(function(data){pd.noCommonSign=data,data&&(pd.changeSignOptions.signId=data.id,pd.changeSignOptions.sign=data.title)})})}]).controller("addTemplateCtrl",["$scope","signInfo","$stateParams","EmitEvent","CacheStore","smsTemplateService","toastTipService","$timeout",function($scope,signInfo,$stateParams,EmitEvent,CacheStore,smsTemplateService,toastTipService,$timeout){var pd=$scope.pd={},pm=$scope.pm={},ed={};pd.signAgreementOptions={btType:"submit"};var caseOps=pd.caseOptions={};$scope.refresh=function(){smsTemplateService.getDefaultSign(!0).then(function(sign){$scope.$broadcast("scroll.refreshComplete"),pd.sign=smsTemplateService.wrapSignFormat(sign)})},$scope.changeSign=function(){pd.signAgreementOptions.showModel()},$scope.chooseTag=function(tag){var ele=ed.contentEle,posRes=smsTemplateService.getCursortPosition(ele),index=posRes.caretOffset,reg=new RegExp("&nbsp;","g"),temp=ele.innerHTML.replace(reg," ");ele.innerHTML=temp.substring(0,index)+tag.html+temp.substring(index,temp.length),$timeout(function(){smsTemplateService.setCaretPositionDiv(ele,posRes.domOffset)})};var validateParams=function(showContent){var error=null,title=pm.title||null,conten=pm.content||null;return null==title?error="请输入模板名称！":null==conten?error="请输入模板内容！":showContent&&showContent.length>335&&(error="模板内容长度不应超过335个字符，当前字符数："+showContent.length),null!=error&&toastTipService.showShortTop(error),error};$scope.preShow=function(){var content=ed.contentEle.innerHTML.replace(new RegExp("&nbsp;","g")," "),showRes=smsTemplateService.tagReplace(content,"html","val");caseOps.btType="show",caseOps.showContent=pd.sign+showRes,caseOps.showModel()},$scope.submit=function(){var content=ed.contentEle.innerHTML.replace(new RegExp("&nbsp;","g")," "),showRes=smsTemplateService.tagReplace(content,"html","val");pm.content=smsTemplateService.tagReplace(content,"html","pmKey"),pm.showRes=showRes,null===validateParams(showRes)&&(caseOps.btType="submit",caseOps.showContent=pd.sign+showRes,caseOps.showModel(ed.submit))};var submitAdd=function(){smsTemplateService.submitVerify(pm).then(function(res){toastTipService.showShortTop("添加成功"),smsTemplateService.wrapTemplateItem(res,pm.showRes),CacheStore.smsTemplate.templateList.splice(0,0,res),$scope.$ionicGoBack()})},submitUpdate=function(){smsTemplateService.submitUpdate(pm).then(function(res){toastTipService.showShortTop("修改成功"),smsTemplateService.wrapTemplateItem(res,pm.showRes),$stateParams.editItem.isDefault&&!res.isDefault&&smsTemplateService.setSystemToDefaultTemplate(),CacheStore.smsTemplate.templateList[ed.positionIndex]=res,$scope.$ionicGoBack()})};$scope.$on(EmitEvent.ViewLoaded,function(){pd.tags=smsTemplateService.getTemplateTags(),pd.sign=smsTemplateService.wrapSignFormat(signInfo),ed.contentEle=document.getElementById("templateContent"),pd.title="添加",ed.submit=submitAdd,$stateParams.editItem&&(pd.title="修改",pm.id=$stateParams.editItem.id,pm.title=$stateParams.editItem.title,ed.contentEle.innerHTML=smsTemplateService.tagReplace($stateParams.editItem.content,"pmKey","html"),ed.positionIndex=$stateParams.editItem.positionIndex,ed.submit=submitUpdate)})}]).controller("changeOrderCtrl",["$scope","orderInfo","bindExpress","bindProxy","EmitEvent","userInfoService","manyMethodInputService","toastTipService","ionicPopupService",function($scope,orderInfo,bindExpress,bindProxy,EmitEvent,userInfoService,manyMethodInputService,toastTipService,ionicPopupService){var pd=$scope.pd={},pm=$scope.pm={};$scope.isiOS=!1;var init=function(){pd.showExpress=!1,pd.showProxy=!1,pd.bindExpress=bindExpress,pd.bindProxy=bindProxy,pm.sendMessage=!1,pm.id=orderInfo.id,pm.expressId=orderInfo.express.id,pm.orderNo=orderInfo.orderNo,pm.phone=orderInfo.phone,pm.name=orderInfo.name,pm.address=orderInfo.address,pm.memo=orderInfo.memo,pm.proxyId=orderInfo.proxyId,pd.express=orderInfo.express.name,pd.proxy=null,bindProxy&&orderInfo.proxyId&&bindProxy.forEach(function(it){it.id!==orderInfo.proxyId||(pd.proxy=it.name)}),cordova.platformId&&"ios"==cordova.platformId&&($scope.isiOS=!0)};$scope.hideExpress=function(){pd.showExpress=!1},$scope.showExpress=function(){pd.showExpress=!0},$scope.expressChanged=function(item){$scope.hideExpress(),pd.express=item.name},$scope.hideProxy=function(){pd.showProxy=!1},$scope.showProxy=function(){pd.showProxy=!0},$scope.proxyChanged=function(item){$scope.hideProxy(),pd.proxy=item.name},$scope.specialBack=function(){ionicPopupService.confirm("您还未对修改的信息进行保存？",null,null,function(){$scope.saveOrderInfo()},function(){$scope.$ionicGoBack()},"放弃","保存")},$scope.saveOrderInfo=function(){manyMethodInputService.saveOrderChange(pm).then(function(){toastTipService.showShortTop("保存成功"),$scope.$ionicGoBack()})},$scope.wrapEXpImg=userInfoService.getExpImg,$scope.$on(EmitEvent.ViewLoaded,function(){init()}),$scope.$on(EmitEvent.ViewBeforeLeave,function(){})}]).controller("paymentCtrl",["$scope","$stateParams","EmitEvent","config","smsTemplateService","toastTipService",function($scope,$stateParams,EmitEvent,config,smsTemplateService,toastTipService){var pd=$scope.pd={},pm=$scope.pm={};pd.signAgreementOptions={btType:"show"};$scope.showAgreement=function(){pd.signAgreementOptions.showModel()},$scope.goCharge=function(){if(pm.newSign)switch(pm.payType){case 1:smsTemplateService.requestAliPay(config.id,pm.newSign);break;case 2:smsTemplateService.requestWeChatPay(config.id,pm.newSign)}else toastTipService.showShortTop("新签名不能为空")},$scope.$on(EmitEvent.ViewLoaded,function(){pd.payMoney=config.payMoney,pm.payType=2})}]).controller("customCtrl",["$scope","custom","userInfoService","EmitEvent","customService",function($scope,custom,userInfoService,EmitEvent,customService){var pd=$scope.pageData={},initConfig=($scope.param={},function(codeType){if(codeType){var index=pd.codeTypes.contains(codeType,function(item,curType){return item.type==curType});index>-1&&(pd.curTypeName=pd.codeTypes[index].name)}else pd.curTypeName=pd.codeTypes[0].name}),initDelayConfig=function(delay){if(delay){var index=pd.delayList.contains(delay,function(item,curDelay){return item.value==curDelay});index>-1&&(pd.curDelay=pd.delayList[index].name)}else pd.curDelay=pd.delayList[0].name},init=function(){pd.showDelay=!1,pd.showType=!1,pd.delayList=customService.delayList,pd.codeTypes=customService.codeTypes,pd.custom=custom,initConfig(custom.codeType),initDelayConfig(custom.delay)};$scope.hideDelay=function(){pd.showDelay=!1},$scope.showDelay=function(){pd.showDelay=!0},$scope.hideType=function(){pd.showType=!1},$scope.showType=function(){pd.showType=!0},$scope.delayChanged=function(item){$scope.hideDelay(),pd.curDelay=item.name,$scope.customChanged(),customService.setUseDelayConfig(item.value)},$scope.typeChanged=function(item){$scope.hideType(),pd.curTypeName=item.name,$scope.customChanged()},$scope.customChanged=function(){userInfoService.setRecipientCustom(pd.custom)},$scope.$on(EmitEvent.ViewLoaded,function(){init()})}]).controller("warehouseCtrl",["$scope","$ionicHistory","$cordovaClipboard","searchConditions","EmitEvent","CacheStore","warehouseService","userInfoService","deliveryService","datePickerService","dateTimeService","stringUtilsService","ionicPopupService","toastTipService","phoneService",function($scope,$ionicHistory,$cordovaClipboard,searchConditions,EmitEvent,CacheStore,warehouseService,userInfoService,deliveryService,datePickerService,dateTimeService,stringUtilsService,ionicPopupService,toastTipService,phoneService){var pm=$scope.param={},pd=$scope.pageData={},ed={curItem:null,curItemIndex:0,days:10};$scope.orderList=CacheStore.warehouse.orderList;var initListData=function(){$scope.orderList.forEach(function(it){it.showPhoneAct=!1,it.canShowPhoneAct=stringUtilsService.cellPhoneValidate(it.phone)})},init=function(){pm.content=null,pd.listTotal=0,pd.curTabDetailIndex=0,pd.tabDetailShowFlag=!1,pd.statusConditon=searchConditions.status,pd.expressConditon=searchConditions.express,pd.proxiesConditon=searchConditions.proxies;var custom=userInfoService.getRecipientCustom();pd.custom=custom,$scope.resetDate(),initCurTab(),initParam(),$scope.initListPool(),pd.listenLoadingFlag=!1},getParams=function(){return{bgnDate:dateTimeService.dateTimeFormatToStr(pm.bgnDate,"yyyy-MM-dd HH:mm:00"),endDate:dateTimeService.dateTimeFormatToStr(pm.endDate,"yyyy-MM-dd HH:mm:59"),status:pm.status,proxyId:pm.proxyId,expressId:pm.expressId,content:pm.content}};$scope.initListPool=function(){var mpex=getParams();warehouseService.initListPool(mpex).then(function(res){$scope.$broadcast("scroll.refreshComplete"),pd.listTotal=res.total,$scope.hasMore=CacheStore.warehouse.hasMore,initListData()})};var initCurTab=function(){pd.curStatusTab=pd.statusConditon[1],pd.curProxyTab=pd.proxiesConditon&&pd.proxiesConditon.length>0?pd.proxiesConditon[0]:null,pd.curExpTab=pd.expressConditon[0]},initParam=function(){pm.status=pd.curStatusTab.key,pm.expressId=pd.curExpTab.key,pm.proxyId=pd.curProxyTab?pd.curProxyTab.key:null};$scope.startListen=function(){pd.listenLoadingFlag=!0,xunfeiListenSpeaking.startListen(function(data){$timeout(function(){pd.listenLoadingFlag=!1,pm.content=data,$scope.initListPool()})},function(e){$timeout(function(){pd.listenLoadingFlag=!1}),toastTipService.showShortTop("识别错误，请检查是否已开启录音权限"+e)},!0,!1)},$scope.setDate=function(){pd.tabDetailShowFlag=!1},$scope.resetDate=function(){var date=new Date;pm.bgnDate=dateTimeService.dateTimeAddDaysToDate(-ed.days,date),pm.bgnDate.setHours(1),pm.bgnDate.setMinutes(0),pm.endDate=date,pm.endDate.setHours(23),pm.endDate.setMinutes(59)},$scope.dialog=function(phone){phoneService.dialog(phone)},$scope.copyPhoneToClipboard=function(phone){$cordovaClipboard.copy(phone).then(function(){toastTipService.showShortTop("复制成功")},function(){})},$scope.hideAll=function(item){$scope.orderList.forEach(function(it){void 0!=item&&null!=item&&it.id==item.id||(it.showPhoneAct=!1)})},$scope.showPhoneAction=function(item){$scope.hideAll(item),item.showPhoneAct=!item.showPhoneAct},$scope.deleteOrder=function(item,index){ionicPopupService.confirm("确认要删除该快递吗，删除后不能恢复?","",null,function(){deliveryService.deleteOrder(item.id).then(function(res){$scope.orderList.splice(index,1),pd.listTotal--,toastTipService.showShortTop("订单删除成功")})})},$scope.loadMore=function(){var mpex=getParams();warehouseService.fetchMore(mpex).then(function(){$scope.$broadcast("scroll.infiniteScrollComplete"),$scope.hasMore=CacheStore.warehouse.hasMore,initListData()})},$scope.scan=function(){warehouseService.scanBarCode(function(result){$timeout(function(){pm.content=result,$scope.contentReplace()})})},$scope.clearParam=function(param){pm[param]=null},$scope.contentReplace=function(){},$scope.switchTab=function(index){index==pd.curTabDetailIndex&&pd.tabDetailShowFlag?pd.tabDetailShowFlag=!1:(pd.curTabDetailIndex=index,pd.tabDetailShowFlag=!0)},$scope.tabDetailBgEvent=function(){3!=pd.curTabDetailIndex&&(pd.tabDetailShowFlag=!1)},$scope.tabDetailChanged=function(type,item){pd["cur"+type+"Tab"]=item,$scope.initListPool()},$scope.showStartTime=function(){datePickerService.showTimePicker({date:pm.bgnDate,minuteInterval:1,sucCb:function(newDate){pm.bgnDate=newDate,$scope.initListPool()}})},$scope.showEndTime=function(){datePickerService.showTimePicker({date:pm.endDate,minuteInterval:1,sucCb:function(newDate){pm.endDate=newDate,$scope.initListPool()}})},$scope.showStartDate=function(){datePickerService.showDatePicker({date:pm.bgnDate,sucCb:function(newDate){paramValidate(newDate,pm.endDate,!0)&&$scope.initListPool()}})},$scope.showEndDate=function(){datePickerService.showDatePicker({date:pm.endDate,sucCb:function(newDate){paramValidate(pm.bgnDate,newDate,!1)&&$scope.initListPool()}})};var paramValidate=function(start,end,isStart){var err=null,curDate=dateTimeService.getDateIgnoreHms();return dateTimeService.ABeforeBAfterIgnoreHms(end,start)?isStart?(err="开始日期不能晚于结束日期",pm.bgnDate=end):(err="结束日期不能早于开始日期",pm.endDate=start):dateTimeService.ABeforeBAfterIgnoreHms(curDate,end)?(err="日期不能晚于今天",pm.endDate=curDate):dateTimeService.getTimeIntervalDays(start,curDate)>ed.days?(err="只能显示"+ed.days+"天以内的数据",pm.bgnDate=dateTimeService.dateTimeAddDaysToDate(-ed.days,curDate)):isStart?pm.bgnDate=start:pm.endDate=end,null===err||(toastTipService.showShortTop(err),!1)};$scope.wrapEXpImg=warehouseService.getExpImg,$scope.showMess=deliveryService.showNotifyMess,$scope.$on(EmitEvent.ViewLoaded,function(){init()})}]).controller("statisticsCtrl",["$scope","searchConditions","datePickerService","$timeout","toastTipService","statisticsService","dateTimeService","EmitEvent",function($scope,searchConditions,datePickerService,$timeout,toastTipService,statisticsService,dateTimeService,EmitEvent){$scope.isiOS=!1;var pd=$scope.pd={},pm=$scope.pm={},ed={days:30},init=function(){pd.curTabDetailIndex=0,pd.tabDetailShowFlag=!1,pd.expressConditon=searchConditions.express,pd.proxiesConditon=searchConditions.proxies,pd.curProxyTab=pd.proxiesConditon&&pd.proxiesConditon.length>0?pd.proxiesConditon[0]:null,pd.curExpTab=pd.expressConditon[0],pm.expressId=pd.curExpTab.key,pm.proxyId=pd.curProxyTab?pd.curProxyTab.key:null,$scope.resetDate(),$scope.query(),cordova.platformId&&"ios"==cordova.platformId&&($scope.isiOS=!0)};$scope.setDate=function(){pd.tabDetailShowFlag=!1},$scope.resetDate=function(){pm.startDate=new Date,pm.startDate.setDate(1),pm.startDate.setHours(1),pm.startDate.setMinutes(0),pm.endDate=new Date,pm.endDate.setHours(23),pm.endDate.setMinutes(59)},$scope.switchTab=function(index){index==pd.curTabDetailIndex&&pd.tabDetailShowFlag?pd.tabDetailShowFlag=!1:(pd.curTabDetailIndex=index,pd.tabDetailShowFlag=!0)},$scope.tabDetailBgEvent=function(){2!=pd.curTabDetailIndex&&(pd.tabDetailShowFlag=!1)},$scope.tabDetailChanged=function(type,item){pd["cur"+type+"Tab"]=item,$scope.query()},$scope.showStartDate=function(){datePickerService.showDatePicker({date:pm.startDate,sucCb:function(newDate){paramValidate(newDate,pm.endDate,!0)&&$scope.query()}})},$scope.showEndDate=function(){datePickerService.showDatePicker({date:pm.endDate,sucCb:function(newDate){paramValidate(pm.startDate,newDate,!1)&&$scope.query()}})};var paramValidate=function(start,end,isStart){var err=null,curDate=dateTimeService.getDateIgnoreHms();return dateTimeService.ABeforeBAfterIgnoreHms(end,start)?isStart?(err="开始时间不能晚于结束时间",pm.startDate=end):(err="结束时间不能早于开始时间",pm.endDate=start):dateTimeService.ABeforeBAfterIgnoreHms(curDate,end)?(err="时间不能晚于当前时间",pm.endDate=curDate):dateTimeService.getTimeIntervalDays(start,curDate)>ed.days?(err="只能显示"+ed.days+"天以内的数据",pm.startDate=dateTimeService.dateTimeAddDaysToDate(-ed.days,curDate)):isStart?pm.startDate=start:pm.endDate=end,null===err||(toastTipService.showShortTop(err),!1)};$scope.query=function(){statisticsService.fetchStatisticsList({proxyId:pm.proxyId,expressId:pm.expressId,startDate:dateTimeService.dateTimeFormatToStr(pm.startDate,"yyyyMMdd"),endDate:dateTimeService.dateTimeFormatToStr(pm.endDate,"yyyyMMdd")}).then(function(data){$scope.$broadcast("scroll.refreshComplete"),pd.showResult=!0,pd.sumResult=data.sumResult,pd.listData=data.list})},$scope.$on(EmitEvent.ViewEnter,function(){init()})}]).controller("statisticsDetailCtrl",["$scope","CacheStore","$stateParams","datePickerService","$timeout","toastTipService","statisticsService","dateTimeService",function($scope,CacheStore,$stateParams,datePickerService,$timeout,toastTipService,statisticsService,dateTimeService){var pd=$scope.pd={},pm=$scope.pm={};$scope.detailList=CacheStore.statistics.detailList;(function(date){pm.date=date.substring(0,4)+"-"+date.substring(4,6)+"-"+date.substring(6,8),pd.date=dateTimeService.strFomatToDate(pm.date,"yyyy-MM-dd")})($stateParams.date),pm.proxyId=$stateParams.proxyId,pm.expressId=$stateParams.expressId,pm.status="all",pd.express=$stateParams.express,pd.total=0,$scope.showDate=function(){datePickerService.showDatePicker({date:pd.date,sucCb:function(newDate){paramValidate(newDate)&&(pd.date=newDate,pm.date=dateTimeService.dateTimeFormatToStr(pd.date,"yyyy-MM-dd"),$scope.initListPool())}})};var paramValidate=function(date){var err=null;return dateTimeService.ABeforeBAfterIgnoreHms(new Date,date)?err="查询时间不能晚于当前日期":dateTimeService.getTimeIntervalDays(date,new Date)>30&&(err="只能查询30天以内的数据"),null===err||(toastTipService.showShortTop(err),!1)};$scope.initListPool=function(){statisticsService.initListPool(pm).then(function(data){$scope.$broadcast("scroll.refreshComplete"),$scope.hasMore=CacheStore.statistics.hasMore,pd.total=data.total})},$scope.loadMore=function(){statisticsService.fetchMore(pm).then(function(){$scope.$broadcast("scroll.infiniteScrollComplete"),$scope.hasMore=CacheStore.statistics.hasMore})},$scope.initListPool(),$scope.statusFormmat=statisticsService.resolveOrderStatus,$scope.wrapEXpImg=statisticsService.getExpImg}]).controller("failedMsgeCtrl",["$scope","$cordovaClipboard","CacheStore","failedMsgeService","toastTipService","ionicPopupService","userInfoService","deliveryService","phoneService",function($scope,$cordovaClipboard,CacheStore,failedMsgeService,toastTipService,ionicPopupService,userInfoService,deliveryService,phoneService){$scope.messList=CacheStore.failedMsge.orderList,$scope.initListPool=function(){failedMsgeService.initListPool().then(function(res){$scope.$broadcast("scroll.refreshComplete"),$scope.hasMore=CacheStore.failedMsge.hasMore,$scope.listTotal=res.total,$scope.messList.forEach(function(it){it.order.showPhoneAct=!1})})},$scope.loadMore=function(){failedMsgeService.fetchMore().then(function(){$scope.$broadcast("scroll.infiniteScrollComplete"),$scope.hasMore=CacheStore.failedMsge.hasMore,$scope.messList.forEach(function(it){it.order.showPhoneAct=!1})})},$scope.initListPool(),$scope.emptyAll=function(){ionicPopupService.confirm("清空纪录后信息将将无法恢复，是否确认清空？",null,null,function(){failedMsgeService.emptyFailSMS().then(function(){toastTipService.showShortTop("已清空"),CacheStore.failedMsge.orderList.empty()})})},$scope.dialog=function(phone){phoneService.dialog(phone)},$scope.hideAll=function(item){$scope.messList.forEach(function(it){void 0!=item&&null!=item&&it.id==item.id||(it.order.showPhoneAct=!1)})},$scope.copyPhoneToClipboard=function(phone){$cordovaClipboard.copy(phone).then(function(){toastTipService.showShortTop("复制成功")},function(){})},$scope.showPhoneAction=function(item){$scope.hideAll(item),item.order.showPhoneAct=!item.order.showPhoneAct},$scope.onResendAll=function(){void 0!==$scope.messList&&null!=$scope.messList&&0!=$scope.messList.length?failedMsgeService.countResend({}).then(function(res){if(res){if(res<=0)return void toastTipService.showShortTop("没有需要重发的失败短信");ionicPopupService.confirm("共有："+res+"条失败短信，是否确认重发？",null,null,function(){failedMsgeService.resendAll({}).then(function(res){res&&(toastTipService.showShortTop("共成功重发："+res+"条短信"),userInfoService.updateCanUseSMSCount(),deleteAll())})})}}):toastTipService.showShortTop("没有需要重发的失败短信")};var deleteOne=function(index){CacheStore.failedMsge.orderList.splice(index,1)},deleteAll=function(){CacheStore.failedMsge.orderList.splice(0,CacheStore.failedMsge.orderList.length)};$scope.resend=function(noticeId,index){ionicPopupService.confirm("是否确认重发？",null,null,function(){failedMsgeService.resend({noticeId:noticeId}).then(function(){toastTipService.showShortTop("已重发"),userInfoService.updateCanUseSMSCount(),deleteOne(index)})})},$scope.deleteFailSMS=function(noticeId,index){ionicPopupService.confirm("删除后记录信息将无法恢复，是否确认删除？",null,null,function(){failedMsgeService.deleteFailSMS({noticeId:noticeId}).then(function(){toastTipService.showShortTop("已删除"),deleteOne(index)})})},$scope.wrapEXpImg=userInfoService.getExpImg,$scope.showMess=function(item){item.showMess?item.showMess=!1:item.showMess=!0}}]).controller("piecesCtrl",["$scope","$ionicHistory","htmlUtilsService","searchConditions","dateTimeService","datePickerService","localConstantData","toastTipService","piecesService","userInfoService","expressService","$timeout","EmitEvent","CacheStore","ionicPopupService","stringUtilsService","mediaService","deliveryService",function($scope,$ionicHistory,htmlUtilsService,searchConditions,dateTimeService,datePickerService,localConstantData,toastTipService,piecesService,userInfoService,expressService,$timeout,EmitEvent,CacheStore,ionicPopupService,stringUtilsService,mediaService,deliveryService){var pd=$scope.pageData={},pm=$scope.param={},ed={curItem:null,curItemIndex:0};pd.inList=CacheStore.pieces.orderList,pd.proxyOption={data:searchConditions.proxies&&searchConditions.proxies.length>0?searchConditions.proxies.slice(1):[],sureCb:function(id,name,orders){var orderIds=[];orders.forEach(function(it){orderIds.push(it.id)}),piecesService.toProxyOrder({proxyId:id,orderIds:orderIds}).then(function(){for(var i=0;i<orderIds.length;++i)for(var j=0;j<pd.inList.length;++j)if(pd.inList[j].id===orderIds[i]){pd.inList[j].proxyName=name;break}toastTipService.showShortTop("已成功转移到代收点")})}};var init=function(){pm.content=null,pd.listTotal=0,pd.curTabDetailIndex=0,pd.tabDetailShowFlag=!1,pd.expressConditon=searchConditions.express,pd.proxiesConditon=searchConditions.proxies,pd.curProxyTab=pd.proxiesConditon&&pd.proxiesConditon.length>0?pd.proxiesConditon[0]:null,pd.curExpTab=pd.expressConditon[0],pm.expressId=pd.curExpTab.key,pm.proxyId=pd.curProxyTab?pd.curProxyTab.key:null,pd.listenLoadingFlag=!1,pd.isSingle=!0,$scope.resetDate(),$scope.initListPool(),cordova.platformId&&"ios"==cordova.platformId&&($scope.isiOS=!0)};$scope.goback=function(){$ionicHistory.goBack()},$scope.setDate=function(){pd.tabDetailShowFlag=!1},$scope.resetDate=function(){pm.startDate=new Date,pm.startDate.setDate(1),pm.startDate.setHours(1),pm.startDate.setMinutes(0),pm.endDate=new Date,pm.endDate.setHours(23),pm.endDate.setMinutes(59)},$scope.switchTab=function(index){index==pd.curTabDetailIndex&&pd.tabDetailShowFlag?pd.tabDetailShowFlag=!1:(pd.curTabDetailIndex=index,pd.tabDetailShowFlag=!0)},$scope.tabDetailBgEvent=function(){2!=pd.curTabDetailIndex&&(pd.tabDetailShowFlag=!1)},$scope.tabDetailChanged=function(type,item){pd["cur"+type+"Tab"]=item,$scope.initListPool()},$scope.showStartDate=function(){datePickerService.showDatePicker({date:pm.startDate,sucCb:function(newDate){paramValidate(newDate,pm.endDate,!0)&&$scope.initListPool()}})},$scope.showEndDate=function(){datePickerService.showDatePicker({date:pm.endDate,sucCb:function(newDate){paramValidate(pm.startDate,newDate,!1)&&$scope.initListPool()}})};var getParams=function(){return{bgnDate:dateTimeService.dateTimeFormatToStr(pm.startDate,"yyyy-MM-dd HH:mm:00"),endDate:dateTimeService.dateTimeFormatToStr(pm.endDate,"yyyy-MM-dd HH:mm:59"),proxyId:pm.proxyId,expressId:pm.expressId,content:pm.content}},paramValidate=function(start,end,isStart){var err=null,curDate=dateTimeService.getDateIgnoreHms();return dateTimeService.ABeforeBAfterIgnoreHms(end,start)?isStart?(err="开始时间不能晚于结束时间",pm.startDate=end):(err="结束时间不能早于开始时间",pm.endDate=start):dateTimeService.ABeforeBAfterIgnoreHms(curDate,end)?(err="时间不能晚于当前时间",pm.endDate=curDate):dateTimeService.getTimeIntervalDays(start,curDate)>ed.days?(err="只能显示"+ed.days+"天以内的数据",pm.startDate=dateTimeService.dateTimeAddDaysToDate(-ed.days,curDate)):isStart?pm.startDate=start:pm.endDate=end,null===err||(toastTipService.showShortTop(err),!1)};$scope.initListPool=function(){var pmx=getParams();piecesService.initListPool(pmx).then(function(res){$scope.$broadcast("scroll.refreshComplete"),pd.listTotal=res.total,$scope.hasMore=CacheStore.pieces.hasMore})},$scope.loadMore=function(){var pmx=getParams();piecesService.fetchMore(pmx).then(function(res){$scope.$broadcast("scroll.infiniteScrollComplete"),pd.listTotal=res.total,$scope.hasMore=CacheStore.pieces.hasMore})},$scope.startListen=function(){pd.listenLoadingFlag=!0,xunfeiListenSpeaking.startListen(function(data){$timeout(function(){pd.listenLoadingFlag=!1,pm.content=data,$scope.initListPool()})},function(e){$timeout(function(){pd.listenLoadingFlag=!1}),toastTipService.showShortTop("识别错误，请检查是否已开启录音权限"+e)},!0,!1)},$scope.scan=function(){deliveryService.scanBarCode(function(result){$timeout(function(){pm.content=result,$scope.contentReplace(),$scope.initListPool()})})},$scope.contentReplace=function(){},$scope.itemCheckedChange=function(item){if(item.checked)for(var data=pd.inList,i=0;i<data.length;i++){if(!data[i].checked){pd.allCheckedFlag=!1;break}pd.allCheckedFlag=!0}else pd.allCheckedFlag=!1},$scope.clearParam=function(param){pm[param]=null},$scope.allChanged=function(){for(var data=pd.inList,i=0;i<data.length;i++)data[i].checked=pd.allCheckedFlag};var outResDeal=function(data,index){mediaService.mediaPlayByLocal("sounds/out_ok.mp3"),piecesService.outResultResponse(data,function(){},function(){pd.inList=data},!0)};$scope.singleOut=function(item,index){ionicPopupService.confirm("请确认要派件吗？",null,null,function(){piecesService.sureOut([item],pd.remark).then(function(data){pd.inList.splice(index,1),outResDeal(data.orderInList)})})},$scope.onToProxy=function(){var checkedList=expressService.filterChecked(pd.inList);checkedList.length<=0?toastTipService.showShortTop("请选择要转出的快递记录"):pd.proxyOption.chooseAction(checkedList)},$scope.wrapEXpImg=piecesService.getExpImg;$scope.$on(EmitEvent.ViewEnter,function(){init()}),$scope.$on(EmitEvent.ViewBeforeLeave,function(){pm.content=null})}]).controller("mineCtrl",["$scope","baseInfo","userInfoService","ionicHistoryService","$rootScope","EmitEvent","$timeout",function($scope,baseInfo,userInfoService,ionicHistoryService,$rootScope,EmitEvent,$timeout){var pd=$scope.pageData={};pd.balance=baseInfo.balance,pd.phone=baseInfo.phone,$scope.freshSMSCount=function(){userInfoService.updateCanUseSMSCount().then(function(data){$scope.$broadcast("scroll.refreshComplete"),pd.balance=data.balance})},$scope.goBindExpresssPage=function(){userInfoService.changeBindExp()},$scope.signOut=userInfoService.signOut;var paySuccess=$rootScope.$on(EmitEvent.PaySuccess,function(event,data){$timeout(function(){pd.balance=data})});$scope.$on(EmitEvent.ViewBeforeLeave,function(){paySuccess()})}]).controller("rechargeCtrl",["$scope","baseInfo","chargeConfig","toastTipService","rechargeService","userInfoService",function($scope,baseInfo,chargeConfig,toastTipService,rechargeService,userInfoService){var pd=$scope.pageData={},pm=$scope.param={};pd.balance=baseInfo.balance.toFixed(2),pd.chargeList=chargeConfig.rules,pm.payType=2,$scope.freshSMSCount=function(){userInfoService.updateCanUseSMSCount().then(function(data){$scope.$broadcast("scroll.refreshComplete"),pd.balance=data.balance})},$scope.goCharge=function(){if(pm.curChargeId)switch(pm.payType){case 1:rechargeService.requestAliPay(pm.curChargeId);break;case 2:rechargeService.requestWeChatPay(pm.curChargeId)}else toastTipService.showShortTop("请选择充值额度！")}}]).controller("paySuccessCtrl",["$scope",function($scope){var clearTime=function(){timeId&&clearTimeout(timeId)},forward=function(){$scope.$ionicGoBack(-2)};$scope.finish=function(){clearTime(),forward()};var timeId=setTimeout(forward,3e3)}]).controller("courierInformationCtrl",["$scope","areas","baseInfo","stringUtilsService","localConstantData","toastTipService","userInfoService",function($scope,areas,baseInfo,stringUtilsService,localConstantData,toastTipService,userInfoService){var pd=$scope.pd={},pm=$scope.pm={};$scope.isiOS=!1;var resolveCity=function(cityId){var cityIndex=pd.cities.contains(cityId,function(item,id){return item.id==id});if(cityIndex>-1){var city=pd.cities[cityIndex];pd.curCity=city.regionName}},initAreas=function(provinceId,cityId){pm.province=provinceId,pm.city=cityId;var provinceIndex=pd.provinces.contains(provinceId,function(item,id){return item.id==id});if(provinceIndex>-1){var province=pd.provinces[provinceIndex];pd.curProvince=province.regionName,pd.cities=province.regions,resolveCity(cityId)}};pm.name=baseInfo.name,pm.contacts=baseInfo.contactPhone,pd.showProvince=!1,pd.showCity=!1,pd.provinces=areas,initAreas(baseInfo.provice,baseInfo.city),cordova.platformId&&"ios"==cordova.platformId&&($scope.isiOS=!0);var initCity=function(){pd.curCity=null,pm.city=null};$scope.hideArea=function(areaName){pd["show"+areaName]=!1},$scope.showArea=function(areaName){pd["show"+areaName]=!0},$scope.provinceChanged=function(area){pd.curProvince=area.regionName,initCity(),pd.cities=area.regions},$scope.cityChanged=function(area){pd.curCity=area.regionName,initRegion(),pd.regions=area.regions},$scope.clearParam=function(param){pm[param]=null};var paramValidate=function(){var err=null,contacts=pm.contacts;return pm.city?pm.name?contacts?contacts&&!stringUtilsService.cellPhoneValidate(contacts)&&(err="请输入有效的联系电话"):err="联系电话不能为空":err="姓名不能为空":err="请选择所在城市",null===err||(toastTipService.showShortTop(err),!1)};$scope.save=function(){paramValidate()&&userInfoService.updateUserInfo(pm).then(function(){toastTipService.showShortTop("保存成功"),$scope.$ionicGoBack()})}}]).controller("contactUsCtrl",["localConstantData","$scope","phoneService",function(localConstantData,$scope,phoneService){var pd=$scope.pageData={phone:localConstantData.contactUs};$scope.dialog=function(){phoneService.dialog(pd.phone)}}]).controller("blacklistCtrl",["$ionicModal","$scope","ionicPopupService","CacheStore","blacklistService","toastTipService","stringUtilsService",function($ionicModal,$scope,ionicPopupService,CacheStore,blacklistService,toastTipService,stringUtilsService){var pm=$scope.pm={};$scope.pageData={};$scope.blackList=CacheStore.blacklist.myList,$scope.initListPool=function(){blacklistService.initListPool().then(function(res){$scope.$broadcast("scroll.refreshComplete"),$scope.hasMore=CacheStore.blacklist.hasMore})},$scope.loadMore=function(){blacklistService.fetchMore().then(function(){$scope.$broadcast("scroll.infiniteScrollComplete"),$scope.hasMore=CacheStore.blacklist.hasMore})},$scope.initListPool(),$scope.del=function(item,index){ionicPopupService.confirm("请确认将"+item.phone+"从黑名单中删除？",null,null,function(){blacklistService.delOne(item.id,index).then(function(){toastTipService.showShortTop("删除成功")})},null,"暂不删除","确认删除")},$scope.goAdd=function(){pm.phone=null,pm.description=null,$scope.openModal()};var validateParams=function(){var error=null,phone=pm.phone||null;return phone&&stringUtilsService.cellPhoneValidate(phone)||(error="请输入有效的手机号码!"),null!=error&&toastTipService.showShortTop(error),error};$scope.add=function(){null===validateParams()&&blacklistService.addOne(pm).then(function(){toastTipService.showShortTop("添加成功"),$scope.closeModal()})},$ionicModal.fromTemplateUrl("modal/editBlackPhone.html",{scope:$scope,animation:"slide-in-up"}).then(function(modal){$scope.modal=modal}),$scope.openModal=function(){$scope.modal.show()},$scope.closeModal=function(){$scope.modal.hide()},$scope.$on("$destroy",function(){$scope.modal.remove()})}]).controller("cooperationCtrl",["toastTipService","$scope","HttpService","stringUtilsService",function(toastTipService,$scope,HttpService,stringUtilsService){var pm=$scope.param={},validateParams=function(){var error=null,name=pm.linkman||null,phone=pm.phone||null;return null==name?error="请输入联系人姓名！":null!==name&&name.length>20?error="请输入有效的联系人姓名！":phone&&stringUtilsService.cellPhoneValidate(phone)||(error="请输入有效的手机号码 ！"),null!=error&&toastTipService.showShortTop(error),error};$scope.goSubmit=function(){null===validateParams()&&HttpService.post(HttpService.RemoteInter.Cooperation,pm,!0).then(function(){toastTipService.showShortTop("提交成功"),$scope.$ionicGoBack()})}}]).controller("accountCtrl",["$scope","EmitEvent","CacheStore","htmlUtilsService","localConstantData","toastTipService","ionicPopupService","subaccountService",function($scope,EmitEvent,CacheStore,htmlUtilsService,localConstantData,toastTipService,ionicPopupService,subaccountService){$scope.param={};var pd=$scope.pd={},init=function(){pd.listTotal=0,$scope.initListPool()};$scope.initListPool=function(){subaccountService.getAccounts({}).then(function(res){$scope.$broadcast("scroll.infiniteScrollComplete"),pd.listTotal=res.length,pd.subaccounts=res})},$scope.removeAccount=function(item,index){ionicPopupService.confirm("确认要移除该队员吗？","",null,function(){subaccountService.remove({id:item.id}).then(function(res){res&&(toastTipService.showShortTop("队员移除成功"),pd.subaccounts.splice(index,1))})})},$scope.$on(EmitEvent.ViewLoaded,function(){init()})}]).controller("addAccountCtrl",["$scope","sendCheckCodeService","toastTipService","stringUtilsService","userInfoService","htmlUtilsService","ionicPopupService","subaccountService",function($scope,sendCheckCodeService,toastTipService,stringUtilsService,userInfoService,htmlUtilsService,ionicPopupService,subaccountService){var pd=$scope.pd={},pm=$scope.pm={};sendCheckCodeService.initService(),pd.picCodeUrl=userInfoService.getPicCodeUrl(),pd.sendVerifyCodeButton=sendCheckCodeService.sendVerifyCodeButton;var validatePhone=function(){var err=null,phone=pm.phone;return phone?phone&&!stringUtilsService.cellPhoneValidate(phone)&&(err="请输入有效的手机号"):err="手机号不能为空",null===err||(toastTipService.showShortTop(err),!1)},picValidate=function(){var picUrlNoRandom=sendCheckCodeService.getPicCodeUrlNoRandom(pm.phone),random=Math.random();ionicPopupService.show('<img id="subPicValidate" style="width: 80px; height: 40px;" src='+picUrlNoRandom+random+"><span style=\"font-size:1rem;margin-left:15px;\" onclick=\"var rd = Math.random();document.getElementById('subPicValidate').src='"+picUrlNoRandom+'\'+rd;">换一张</span><br><input style="text-align: center;border:1px solid #ddd;margin:10px 10% 0;border-radius:3px;width:80%;" type="tel" id="subPicCode" placeholder="请输入图形验证码">',null,null,"取消",null,"确认",function(e){var picCode=htmlUtilsService.getEleById("subPicCode").value.replace(/\s/gi,"");picCode&&4==picCode.length?sendCheckCodeService.sendVerifyCode("RegSubSendMess",{phone:pm.phone,imageCode:picCode},function(data){htmlUtilsService.focusInput("subCode")}):(toastTipService.showShortTop("请输入正确的验证码!"),e.preventDefault())})};$scope.sendVerifyCode=function(){validatePhone()?picValidate():htmlUtilsService.focusInput("subPhone")};var paramValidate=function(){var err=null,pw=pm.password;return!!validatePhone()&&(pm.code?pw?htmlUtilsService.stringRegValidate(pw,"\\s","g")?err="密码含有非法字符！":pw&&(pw.length<6||pw.length>18)?err="密码长度应在6~18位之间":pm.name||(err="请输入姓名"):err="密码不能为空":err="短信验证码不能为空",null===err||(toastTipService.showShortTop(err),!1))};$scope.addSubaccount=function(){paramValidate()&&subaccountService.register(pm).then(function(){toastTipService.showShortTop("添加成功!"),$scope.$ionicGoBack()})},$scope.clearParam=function(param){pm[param]=null}}]).controller("modifyAccountCtrl",["$scope","account","EmitEvent","subaccountService","toastTipService",function($scope,account,EmitEvent,subaccountService,toastTipService){var pd=$scope.pd={},pm=$scope.pm={},init=function(){pm.id=account.id,pd.phone=account.phone,pm.name=account.nick};$scope.clearParam=function(param){pm[param]=null},$scope.saveAccount=function(){subaccountService.modifyName(pm).then(function(){toastTipService.showShortTop("保存成功"),$scope.$ionicGoBack()})},$scope.$on(EmitEvent.ViewLoaded,function(){init()})}]).controller("proxyCtrl",["$scope","EmitEvent","CacheStore","proxyService","ionicPopupService","toastTipService",function($scope,EmitEvent,CacheStore,proxyService,ionicPopupService,toastTipService){$scope.param={};var pd=$scope.pd={},init=function(){pd.listTotal=0,$scope.initListPool()};$scope.proxyList=CacheStore.proxy.proxyList,$scope.initListPool=function(){proxyService.initListPool({}).then(function(res){$scope.$broadcast("scroll.refreshComplete"),pd.listTotal=res.total,$scope.hasMore=CacheStore.proxy.hasMore})},$scope.loadMore=function(){proxyService.fetchMore().then(function(){$scope.$broadcast("scroll.infiniteScrollComplete"),$scope.hasMore=CacheStore.proxy.hasMore})},$scope.fetchProxy=function(){$scope.initListPool()},$scope.removeProxy=function(item,index){ionicPopupService.confirm("确认要移除该代收点吗？移除将无法再查询该代收点信息","",null,function(){proxyService.removeProxy({id:item.id}).then(function(res){res&&(toastTipService.showShortTop("代收点移除成功"),$scope.proxyList.splice(index,1),userInfoService.updateBindProxy())})})},$scope.$on(EmitEvent.ViewLoaded,function(){init()})}]).controller("addProxyCtrl",["$scope","sendCheckCodeService","toastTipService","stringUtilsService","userInfoService","htmlUtilsService","ionicPopupService","proxyService",function($scope,sendCheckCodeService,toastTipService,stringUtilsService,userInfoService,htmlUtilsService,ionicPopupService,proxyService){var pd=$scope.pd={},pm=$scope.pm={};sendCheckCodeService.initService(),pd.picCodeUrl=userInfoService.getPicCodeUrl(),pd.sendVerifyCodeButton=sendCheckCodeService.sendVerifyCodeButton;var validatePhone=function(){var err=null,phone=pm.phone;return phone?phone&&!stringUtilsService.cellPhoneValidate(phone)&&(err="请输入有效的手机号"):err="手机号不能为空",null===err||(toastTipService.showShortTop(err),!1)},picValidate=function(){var picUrlNoRandom=sendCheckCodeService.getPicCodeUrlNoRandom(pm.phone),random=Math.random();ionicPopupService.show('<img id="subPicValidate" style="width: 80px; height: 40px;" src='+picUrlNoRandom+random+"><span style=\"font-size:1rem;margin-left:15px;\" onclick=\"var rd = Math.random();document.getElementById('subPicValidate').src='"+picUrlNoRandom+'\'+rd;">换一张</span><br><input style="text-align: center;border:1px solid #ddd;margin:10px 10% 0;border-radius:3px;width:80%;" type="tel" id="subPicCode" placeholder="请输入图形验证码">',null,null,"取消",null,"确认",function(e){var picCode=htmlUtilsService.getEleById("subPicCode").value.replace(/\s/gi,"");picCode&&4==picCode.length?sendCheckCodeService.sendVerifyCode("AddProxySendMess",{phone:pm.phone,imageCode:picCode},function(data){pm.name=data,htmlUtilsService.focusInput("subCode")}):(toastTipService.showShortTop("请输入正确的验证码!"),e.preventDefault())})};$scope.sendVerifyCode=function(){validatePhone()?picValidate():htmlUtilsService.focusInput("subPhone")};var paramValidate=function(){var err=null;return!!validatePhone()&&(pm.code?pm.name||(err="请输入代收点名称"):err="短信验证码不能为空",null===err||(toastTipService.showShortTop(err),!1))};$scope.addProxy=function(){paramValidate()&&proxyService.saveProxy(pm).then(function(){toastTipService.showShortTop("代收点添加成功!"),userInfoService.updateBindProxy(),$scope.$ionicGoBack()})},$scope.clearParam=function(param){pm[param]=null}}]).controller("modifyProxyCtrl",["$scope","proxy","EmitEvent","proxyService","toastTipService",function($scope,proxy,EmitEvent,proxyService,toastTipService){$scope.pd={};var pm=$scope.pm={},init=function(){pm.id=proxy.id,pm.phone=proxy.proxy.contactPhone,pm.name=proxy.name};$scope.saveProxy=function(){proxyService.modifyProxy(pm).then(function(){toastTipService.showShortTop("保存成功"),userInfoService.updateBindProxy(),$scope.$ionicGoBack()})},$scope.$on(EmitEvent.ViewLoaded,function(){init()})}]).controller("selectExpressCtrl",["$scope","express","expressService","toastTipService","userInfoService","localConstantData",function($scope,express,expressService,toastTipService,userInfoService,localConstantData){var pd=$scope.pageData={};$scope.param={};pd.express=express,$scope.finish=function(){var checkedList=expressService.filterChecked(pd.express);checkedList.length>0?expressService.bindExpress(checkedList).then(function(){toastTipService.showShortTop("绑定成功"),localConstantData.bingExpChanged=!0,userInfoService.setBindExpressLocalStore(checkedList),$scope.$ionicGoBack()}):toastTipService.showShortTop("请选择服务的快递公司")},$scope.wrapEXpImg=userInfoService.getExpImg}]),angular.module("AgencyApp.services",[]).service("countDownService",["CacheStore","$interval",function(CacheStore,$interval){CacheStore.countDown={init:function(){CacheStore.countDown.intervals={}}},CacheStore.countDown.init(),this.curCountDownData={},this.initCurCountDownData=function(originalSeconds,callback){this.curCountDownData.value=originalSeconds,this.curCountDownData.interval&&$interval.cancel(this.curCountDownData.interval),this.curCountDownData.value>0&&this.startDown(callback)},this.startDown=function(callback){var curService=this;curService.curCountDownData.interval=$interval(function(){curService.curCountDownData.value<=0?($interval.cancel(curService.curCountDownData.interval),callback&&"function"==typeof callback&&callback()):(curService.curCountDownData.showValue=curService.getShowValue(curService.curCountDownData.value),curService.curCountDownData.value--)},1e3)},this.getRemainingSeconds=function(issueTime,extraTime){return extraTime=extraTime||0,(new Date(issueTime.replace(new RegExp("-","gm"),"/")).getTime()+6e4*extraTime-(new Date).getTime())/1e3},this.getShowValue=function(input){return Math.floor(input)}}]).service("userInfoService",["HttpService","LocalDatabase","ionicHistoryService","JPushUtils","expressService","localConstantData",function(HttpService,LocalDatabase,ionicHistoryService,JPushUtils,expressService,localConstantData){var service=this;this.getUserInfo=function(userId){return HttpService.post(HttpService.RemoteInter.UserInfo,{id:userId},!1)},this.register=function(pm){HttpService.post(HttpService.RemoteInter.Register,pm,!0).then(function(data){service.getUserInfo(data.id).then(function(data){JPushUtils.setAlia(data.pushAlias),LocalDatabase.set(LocalDatabase.Data.user,data),service.goHome()})})},this.loggedinEvent=function(userId){service.getUserInfo(userId).then(function(data){JPushUtils.setAlia(data.pushAlias),LocalDatabase.set(LocalDatabase.Data.user,data),service.goHome()})},this.login=function(pm){HttpService.post(HttpService.RemoteInter.CommonSignin,pm,!0).then(function(data){LocalDatabase.set(LocalDatabase.Data.preLogin,{loginName:pm.loginName}),service.loggedinEvent(data.id)})},this.resetPw=function(pm){return HttpService.post(HttpService.RemoteInter.ResetPw,pm,!0)},this.goHome=function(){ionicHistoryService.goNextRootPage("index.home")},this.getAllAreas=function(){return HttpService.httpStatic(HttpService.RemoteInter.AllAreas)},this.getPicCodeUrl=function(phone){var random=Math.random();return HttpService.warpUrl(HttpService.RemoteInter.GetPicValidate)+"?phone="+phone+"&random="+random},this.getBaseInfo=function(){return LocalDatabase.get(LocalDatabase.Data.user)||{}},this.setBindExpressLocalStore=function(bindExpress){var user=service.getBaseInfo();user.bindExpress=bindExpress,LocalDatabase.set(LocalDatabase.Data.user,user)},this.getBindExpressLocalStore=function(){var user=service.getBaseInfo();return user&&user.bindExpress?user.bindExpress:null},this.getBindExpress=function(allFlag){var local=service.getBindExpressLocalStore();return local?HttpService.testHttp(local):HttpService.post(HttpService.RemoteInter.QueryBoundExpress,null,!1).then(function(data){return 0===data.length&&allFlag?expressService.fetchAllExpress():(service.setBindExpressLocalStore(data),data)})},this.setBindProxyLocalStore=function(bindProxy){var user=service.getBaseInfo();user.bindProxy=bindProxy,LocalDatabase.set(LocalDatabase.Data.user,user)},this.getBindProxyLocalStore=function(){var user=service.getBaseInfo();return user&&user.bindProxy?user.bindProxy:null},this.getBindProxy=function(allFlag){var local=service.getBindProxyLocalStore();return local?HttpService.testHttp(local):HttpService.post(HttpService.RemoteInter.QueryBoundProxy,null,!1).then(function(data){return service.setBindProxyLocalStore(data),data})},this.updateBindProxy=function(){return HttpService.post(HttpService.RemoteInter.QueryBoundProxy,null,!1).then(function(data){return service.setBindProxyLocalStore(data),data})},this.updateCanUseSMSCount=function(){var user=service.getBaseInfo();return service.getUserInfo(user.id).then(function(data){return user.balance=data.balance,LocalDatabase.set(LocalDatabase.Data.user,user),user})},this.signOut=HttpService.signOut,this.updateUserInfo=function(pm){return HttpService.post(HttpService.RemoteInter.UpdateUserInfo,pm,!0).then(function(){var user=service.getBaseInfo();user.name=pm.name,user.contactPhone=pm.contacts,user.provice=pm.province,user.city=pm.city,localConstantData.userInfoChanged=!0,LocalDatabase.set(LocalDatabase.Data.user,user)})},this.updateWarningTime=function(warningTime){var user=service.getBaseInfo();user.warningTime=warningTime,LocalDatabase.set(LocalDatabase.Data.user,user)},this.setRecipientCustom=function(custom){LocalDatabase.set(LocalDatabase.Data.recipientCustom,custom)},this.getRecipientCustom=function(){var custom=LocalDatabase.get(LocalDatabase.Data.recipientCustom);return custom||(custom={nameFlag:!1,addressFlag:!1,codeType:"random",noMessage:!1,memoFlag:!1,sendProxy:!1,delay:0},this.setRecipientCustom(custom)),custom},this.changeBindExp=function(){service.getBindExpress().then(function(bound){ionicHistoryService.goNextPage("selectExpress",{checkedExpress:bound})})},this.initUserBalances=function(data,pd){data&&data.balance&&(pd.balance=data.balance)},this.updateUserBalances=function(){var user=service.getBaseInfo();return service.getUserInfo(user.id).then(function(data){return data&&(user.balance=data.balance,LocalDatabase.set(LocalDatabase.Data.user,user)),user})},this.updateUserBalancesLocal=function(balance){var user=service.getBaseInfo();user.balance=user.balance-balance,LocalDatabase.set(LocalDatabase.Data.user,user)},this.goPay=function(){ionicHistoryService.goNextPage("recharge")},this.getExpImg=function(expId){return"img/express/ex_"+expId+".png"},this.getStat7=function(){return HttpService.post(HttpService.RemoteInter.GetStat7,{},!1)}}]).service("importService",["localConstantData","toastTipService","stringUtilsService","htmlUtilsService","CacheStore","loadingService","customService","HttpService",function(localConstantData,toastTipService,stringUtilsService,htmlUtilsService,CacheStore,loadingService,customService,HttpService){var service=this;CacheStore.import={init:function(){CacheStore.import.existedList=[],CacheStore.import.errList=[]}},CacheStore.import.init();var initOneItem=function(originItem,index,options){return{phone:originItem.phone,id:htmlUtilsService.getUUID()+index,repeatId:originItem.phone+","+originItem.orderNo,repeatFlag:!1,orderNo:originItem.orderNo?originItem.orderNo:"",expressId:originItem.expressId?originItem.expressId:options.edPm.expressId,name:originItem.name,address:originItem.address,memo:originItem.memo,code:customService.getCodeV2(options.customIn,originItem.phone,originItem.orderNo)}},checkIsRepeat=function(item,tels,options){var tel=item.repeatId,repeatData=options.repeatData;if(repeatData[tel]){item.repeatFlag=!0;var ids=repeatData[tel].ids;if(1==ids.length){var index=tels.contains(ids[0],function(telItem,curId){return telItem.id==curId});index>-1&&(tels[index].repeatFlag=!0)}ids.push(item.id)}else repeatData[tel]={ids:[item.id]}},joinList=function(item,tels,options){tels.splice(0,0,item)};this.resolveOneContent=function(content,resultArr,options){var item=initOneItem(content,resultArr.length,options);options.noCheckRepeat||checkIsRepeat(item,resultArr,options),joinList(item,resultArr)},this.resolveManyContent=function(readyArr,resultArr,options){for(var i=0;i<readyArr.length;i++)service.resolveOneContent(readyArr[i],resultArr,options)};var delRepeatItem=function(item,tels,options){var tel=item.repeatId,id=item.id,repeatData=options.repeatData,ids=repeatData[tel].ids;if(1==ids.length)delete repeatData[tel];else{var index=ids.contains(id);if(index>-1&&ids.splice(index,1),1==ids.length){var lastIndex=tels.contains(ids[0],function(telItem,curId){return telItem.id==curId});lastIndex>-1&&(tels[lastIndex].repeatFlag=!1)}}};this.delOne=function(item,telsIndex,tels,options){tels.splice(telsIndex,1),item.errFlag||delRepeatItem(item,tels,options),angular.isFunction(options.telDelCb)&&options.telDelCb(item,tels)};var resolveErrCode=function(code){switch(code+""){case"0":return"手机号码为空或不合法";case"1":return"快递公司不存在";case"2":return"取件码为空或不合法";case"3":return"快递单号已经录入过";case"4":return"余额不足";default:return""}},wrapBatchInFailed=function(data){if(data.failCount>0)for(var i=0;i<data.orderFails.length;i++){var cur=data.orderFails[i],errCode=cur.error,index=CacheStore.import.existedList.contains(cur.id,function(item,curId){return item.id==curId});index>-1&&((cur=CacheStore.import.existedList[index]).id=cur.id+i,cur.errFlag=!0,cur.errContent=resolveErrCode(errCode),CacheStore.import.errList.push(cur))}},wrapBatchInTip=function(data){return"提交总数："+data.totalCount+"<br>成功总数："+data.successCount+"<br>失败总数："+data.failCount};this.batchIn_base=function(pm,proxyId,sendMessage){return HttpService.post(HttpService.RemoteInter.BatchIn,{data:JSON.stringify(pm),sendMessage:sendMessage,proxyId:proxyId},!0)},this.batchIn=function(pm){return service.batchIn_base(pm).then(function(data){return wrapBatchInFailed(data),wrapBatchInTip(data)})};var resolveBatchInRes=function(data,originArr,bindExp){var res={totalCount:data.totalCount,successCount:data.successCount,failCount:data.failCount,balance:data.balance,errList:[]};if(data.failCount>0)for(var i=0;i<data.orderFails.length;i++){var cur=data.orderFails[i],errCode=cur.error,index=originArr.contains(cur.id,function(item,curId){return item.id==curId});index>-1&&((cur={orderNo:null==originArr[index].orderNo||originArr[index].orderNo.length<=0?originArr[index].phone:originArr[index].orderNo}).id=originArr[index].id,cur.errFlag=!0,cur.errContent=resolveErrCode(errCode),originArr.splice(index,1),res.errList.push(cur))}return res};this.batchIn_recipient=function(pm,proxyId,sendMessage,bindExp){return service.batchIn_base(pm,proxyId,sendMessage).then(function(data){return resolveBatchInRes(data,pm)})},this.isStartScanNow=function(){var flag=localConstantData.batchScanFlag;return flag&&(localConstantData.batchScanFlag=!1),flag}}]).service("manyMethodInputService",["HttpService","CacheStore","$timeout","userInfoService","customService","toastTipService","stringUtilsService","ionicPopupService","LocalDatabase","blacklistService","deliveryService","lgyxScannerService","importService","mediaService",function(HttpService,CacheStore,$timeout,userInfoService,customService,toastTipService,stringUtilsService,ionicPopupService,LocalDatabase,blacklistService,deliveryService,lgyxScannerService,importService,mediaService){CacheStore.manyMethodInput={init:function(){CacheStore.manyMethodInput.shareParams=null}},CacheStore.manyMethodInput.init(),this.initSharePms=function(pd,pm,defaultExp,defaultProxy){CacheStore.manyMethodInput.shareParams?(pd.express=CacheStore.manyMethodInput.shareParams.expressName,pm.expressId=CacheStore.manyMethodInput.shareParams.expressId,pd.proxyName=CacheStore.manyMethodInput.shareParams.proxyName,pm.proxyId=CacheStore.manyMethodInput.shareParams.proxyId):(pd.express=defaultExp.name,pm.expressId=defaultExp.id,defaultProxy?(pd.proxyName=defaultProxy.name,pm.proxyId=defaultProxy.id):(pd.proxyName="还没有绑定代收点",pm.proxyId=null));LocalDatabase.get(LocalDatabase.inputPm)},this.recordSharePms=function(pd,pm){CacheStore.manyMethodInput.shareParams||(CacheStore.manyMethodInput.shareParams={}),CacheStore.manyMethodInput.shareParams.expressName=pd.express,CacheStore.manyMethodInput.shareParams.expressId=pm.expressId,CacheStore.manyMethodInput.shareParams.proxyName=pd.proxyName,CacheStore.manyMethodInput.shareParams.proxyId=pm.proxyId;var m={};LocalDatabase.set(LocalDatabase.inputPm,m)},this.phoneScan=function(sucCb){lgyxScannerService.scanPhone(sucCb)},this.scanQRCode=function(sucCb){lgyxScannerService.scanQR(sucCb)},this.orderNoScan=function(sucCb){lgyxScannerService.scanBarcode(sucCb)};var baseInResResponse=function(logArr,balance,pm,pd){logArr.length>0&&(pd.balance=pd.balance-balance,userInfoService.updateUserBalancesLocal(balance),LocalDatabase.set(LocalDatabase.inputPm,{}),deliveryService.updateAllPhonesForMore(logArr))};this.loadBlackList=blacklistService.loadAllData;var validateParam=function(pm,sendMessFlag){var err=null,phone=pm.phone;return sendMessFlag?phone?phone&&!stringUtilsService.cellPhoneValidate(phone)&&(err="请输入有效的手机号"):err="手机号不能为空":phone&&!stringUtilsService.numberValidate(phone)?err="请输入有效的手机号":phone||pm.orderNo||(err="请输入手机号或订单号"),null===err||(toastTipService.showShortTop(err),!1)},sureIn=function(pm,pd){pm.code=customService.getCodeV2(pd.custom,pm.phone,pm.orderNo),pm.sendMessage=!pd.custom.noMessage;var proxyId=pm.proxyId;0==pd.custom.sendProxy&&(proxyId=null),deliveryService.sureIn(proxyId,pm).then(function(inRes){mediaService.mediaPlayByLocal("sounds/in_ok.mp3"),toastTipService.showShortTop("入库成功");var inputLog=[{phone:pm.phone}];pm.phone=null,pm.orderNo=null,pm.name=null,pm.memo=null,pm.address=null,baseInResResponse(inputLog,inRes.balance,0,pd)})};this.manualIn=function(pm,pd){validateParam(pm,!pd.custom.noMessage)&&customService.requestParamValidate(pd.custom,pm.orderNo)&&(blacklistService.isBelongBlack(pm.phone)?ionicPopupService.confirm(pm.phone+"为黑名单号码<br>是否继续录件？",null,null,function(){sureIn(pm,pd)},function(){pm.phone=null,pm.orderNo=null},"取消录件","确认录件"):sureIn(pm,pd))};var changeOrderValidateParam=function(pm){var err=null,phone=pm.phone;return pm.sendMessage?phone?phone&&!stringUtilsService.cellPhoneValidate(phone)&&(err="请输入有效的手机号"):err="手机号不能为空":phone&&!stringUtilsService.numberValidate(phone)?err="请输入有效的手机号":phone||pm.orderNo||(err="请输入手机号或订单号"),err};this.saveOrderChange=function(pm){var err=changeOrderValidateParam(pm);{if(null==err)return HttpService.post(HttpService.RemoteInter.ChangeOrderIn,{data:JSON.stringify(pm),sendMessage:pm.sendMessage},!0);toastTipService.showShortTop(err)}},this.phoneIn=function(pm,pd,custom){var dataResolveoptions={repeatData:{},edPm:{expressId:pm.expressId},customIn:custom,noCheckRepeat:!0},datas=pd.phoneList,resArr=[];if(importService.resolveManyContent(datas,resArr,dataResolveoptions),resArr.length>0){var proxyId=pm.proxyId;0==custom.sendProxy&&(proxyId=null),importService.batchIn_recipient(resArr,proxyId,!dataResolveoptions.customIn.noMessage,pd.bindExpress).then(function(inRes){$timeout(function(){baseInResResponse(resArr,inRes.balance,0,pd),pd.phoneList=[],pd.batchResOptions.showBatchRes(inRes),mediaService.mediaPlayByLocal("sounds/in_ok.mp3")})})}},this.modelIn=function(isBatch,pm,pd,custom){deliveryService.fetchAllPhones().then(function(allPhone){var dataResolveoptions={repeatData:{},edPm:{expressId:pm.expressId},customIn:custom,noCheckRepeat:!0},batchScanOptions=customService.getBatchScanOptions(custom,pm.expressId,pd.express,allPhone);batchIn(dataResolveoptions,batchScanOptions,pm,pd)})};var batchIn=function(dataResolveoptions,batchScanOptions,pm,pd){var resArr=[];lgyxScannerService.scanAll(function(res){if(importService.resolveManyContent(res,resArr,dataResolveoptions),resArr.length>0){var proxyId=pm.proxyId;0==pd.custom.sendProxy&&(proxyId=null),importService.batchIn_recipient(resArr,proxyId,!dataResolveoptions.customIn.noMessage,pd.bindExpress).then(function(inRes){$timeout(function(){baseInResResponse(resArr,inRes.balance,0,pd),pd.batchResOptions.showBatchRes(inRes),mediaService.mediaPlayByLocal("sounds/in_ok.mp3")})})}},null,batchScanOptions)}}]).service("customService",["toastTipService","htmlUtilsService","HttpService","Host",function(toastTipService,htmlUtilsService,HttpService,Host){this.codeTypes=[{type:"random",name:"随机生成5位取件码"},{type:"orderNo",name:"快递单号后5位作为取件码"},{type:"phone4",name:"手机后4位作为取件码"}],this.delayList=[{value:0,name:"不延时"},{value:10,name:"延时10分钟"},{value:30,name:"延时30分钟"},{value:60,name:"延时1小时"},{value:120,name:"延时2小时"}],this.requestParamValidate=function(custom,orderNo){if(!custom.codeType)return!0;var err=null;switch(custom.codeType){case"orderNo":orderNo||(err="请输入快递单号")}return null===err||(toastTipService.showShortTop(err),!1)},this.setUseDelayConfig=function(delay){return HttpService.post(HttpService.RemoteInter.SetProxyUseDelay,{delay:delay},!1)},this.getBatchScanOptions=function(custom,expressId,expressName,mobiles){var mobilesStr=JSON.stringify(mobiles),res={expressId:expressId,expressName:expressName,needPhone:!0,needOrderNo:!1,needName:!1,mobiles:(mobilesStr=mobilesStr.replace(/"/g,"")).substring(1,mobilesStr.length-1),hostUrl:Host,sendMessage:!custom.noMessage};switch(custom.codeType){case"orderNo":res.needOrderNo=!0}return res.displayName=custom.nameFlag,res.displayAddress=custom.addressFlag,res.displayMemo=custom.memoFlag,res},this.getCodeV2=function(custom,phone,orderNo){var code="";switch(custom.codeType){case"orderNo":code=orderNo?orderNo.substr(-5,5):"";break;case"phone4":code=phone.length<4?phone:phone.substr(-4,4);break;default:code=htmlUtilsService.getRandomNum()}return code}}]).service("smsTemplateService",["HttpService","localConstantData","CacheStore","userInfoService","ionicHistoryService","ionicPopupService","payService",function(HttpService,localConstantData,CacheStore,userInfoService,ionicHistoryService,ionicPopupService,payService){var service=this;CacheStore.smsTemplate={init:function(){CacheStore.smsTemplate.defaultSign=null,CacheStore.smsTemplate.defaultTemplate=null,CacheStore.smsTemplate.templateList=null}},CacheStore.smsTemplate.init(),this.getTemplateTags=function(){return[{name:"代收点",key:"proxy",pmKey:"{p}",html:'<img src="img/insert/insert0.png">',val:"锦绣家园快递服务站"},{name:"快递公司",key:"exp",pmKey:"{e}",html:'<img src="img/insert/insert1.png">',val:"圆通快递"},{name:"取件码",key:"code",pmKey:"{c}",html:'<img src="img/insert/insert3.png">',val:"12345"},{name:"姓名",key:"name",pmKey:"{n}",html:'<img src="img/insert/insert6.png">',val:"欧阳峰"},{name:"快递单号后五位",key:"orderNo",pmKey:"{o}",html:'<img src="img/insert/insert5.png">',val:"56789"}]},this.createMyTags=function(proxy,exp,code,orderNo,name){var res=[];return proxy&&res.push({pmKey:"{p}",val:proxy}),exp&&res.push({pmKey:"{e}",val:exp}),code&&res.push({pmKey:"{c}",val:code}),orderNo&&res.push({pmKey:"{o}",val:orderNo}),name&&res.push({pmKey:"{n}",val:name}),res},this.getCursortPosition=function(element){var sel,caretOffset=0,domOffset=0,doc=element.ownerDocument||element.document,win=doc.defaultView||doc.parentWindow;if(void 0!==win.getSelection){if((sel=win.getSelection()).rangeCount>0){var range=sel.getRangeAt(0);caretOffset=range.endOffset;var container=range.startContainer;if(container.tagName===element.tagName){caretOffset=0;for(var i=0;i<range.endOffset;i++){var curNode=container.childNodes[i];curNode.outerHTML?caretOffset+=curNode.outerHTML.length:caretOffset+=curNode.textContent.length}domOffset=range.endOffset}else for(domOffset=1;container.previousSibling;)domOffset++,container.previousSibling.outerHTML?caretOffset+=container.previousSibling.outerHTML.length:caretOffset+=container.previousSibling.textContent.length,container=container.previousSibling}}else if((sel=doc.selection)&&"Control"!=sel.type){var textRange=sel.createRange(),preCaretTextRange=doc.body.createTextRange();preCaretTextRange.moveToElementText(element),preCaretTextRange.setEndPoint("EndToEnd",textRange),caretOffset=preCaretTextRange.text.length}return{caretOffset:caretOffset,domOffset:domOffset}},this.setCaretPositionDiv=function(element,pos){var range,selection;document.createRange?((range=document.createRange()).selectNodeContents(element),element.innerHTML.length>0&&(pos+1>=element.childNodes.length?pos=element.childNodes.length:pos+=1,range.setStart(element,pos)),range.collapse(!0),(selection=window.getSelection()).removeAllRanges(),selection.addRange(range)):document.selection&&((range=document.body.createTextRange()).moveToElementText(element),range.collapse(!1),range.select())},this.tagReplace=function(origin,fromKey,tokey,tagsData){if(origin&&origin.length>5)for(var tags=tagsData||this.getTemplateTags(),i=0;i<tags.length;i++){var cur=tags[i],regexp=new RegExp(cur[fromKey],"g");origin=origin.replace(regexp,cur[tokey])}return origin},this.wrapTemplateItem=function(item,show){item.contentShow=show||service.tagReplace(item.content,"pmKey","val")},this.fetchTemplates=function(forceFresh){return!forceFresh&&CacheStore.smsTemplate.templateList?HttpService.testHttp(CacheStore.smsTemplate.templateList):HttpService.post(HttpService.RemoteInter.SMSTemplates,null,!1).then(function(data){for(var i=0;i<data.length;i++){var cur=data[i];service.wrapTemplateItem(cur)}CacheStore.smsTemplate.templateList=data})},this.goEditTemplate=function(item,index){item.positionIndex=index,ionicHistoryService.goNextPage("addTemplate",{editItem:item})},this.delTemplate=function(id){return HttpService.post(HttpService.RemoteInter.DelSMSTemplate,{id:id},!0)},this.submitVerify=function(pm){return HttpService.post(HttpService.RemoteInter.SubmitSMSTemplate,pm,!0)},this.submitUpdate=function(pm){return HttpService.post(HttpService.RemoteInter.UpdateSMSTemplate,pm,!0)},this.getSMSCount=function(length){if(length<=70)return 1;var addOne=1;return length%67==0&&(addOne=0),parseInt(length/67)+addOne};var preShowTemplate=function(showText){return'<div class="addtemp-text"><div class="addtemp-textea">'+showText+'</div><p class="colorred">当前输入'+showText.length+"字，按"+service.getSMSCount(showText.length)+"条短信计费</p> </div>"};this.showPreAlert=function(showText){ionicPopupService.alert(preShowTemplate(showText),"短信示例")},this.showPreConfirm=function(showText,sucCb){ionicPopupService.confirm(preShowTemplate(showText),"短信示例",null,sucCb)},this.getSystemTemplate=function(){var baseInfo=userInfoService.getBaseInfo();return{id:0,content:"{e}{o}入{p}电话"+baseInfo.contactPhone+"，取件码{c}",contentShow:"申通快递56789入锦绣家园快递服务站电话"+baseInfo.contactPhone+"，取件码12345",isSys:!0}},this.setSystemToDefaultTemplate=function(){CacheStore.smsTemplate.defaultTemplate=service.getSystemTemplate()},this.getDefaultTemplate=function(){return CacheStore.smsTemplate.defaultTemplate?HttpService.testHttp(CacheStore.smsTemplate.defaultTemplate):HttpService.post(HttpService.RemoteInter.GetDefaultTemplate,null,!1).then(function(data){return data?CacheStore.smsTemplate.defaultTemplate=data:service.setSystemToDefaultTemplate(),CacheStore.smsTemplate.defaultTemplate})},this.setToDefaultTemplate=function(template,itemIndex){return HttpService.post(HttpService.RemoteInter.SetDefaultTemplate,{id:template.id},!0).then(function(flag){if(flag){var index=CacheStore.smsTemplate.templateList.contains(!0,function(item,flag){return item.isDefault});index>-1&&(CacheStore.smsTemplate.templateList[index].isDefault=!1),itemIndex>-1&&(CacheStore.smsTemplate.templateList[itemIndex].isDefault=!0),CacheStore.smsTemplate.defaultTemplate=template}return flag})},this.initTemplateContentShow=function(exp,proxy){var tags=service.createMyTags(proxy||"锦绣家园快递服务站",exp||"申通快递","12345",56789,"欧阳锋");return service.tagReplace(CacheStore.smsTemplate.defaultTemplate.content,"pmKey","val",tags)},this.getNoCommonSign=function(){return HttpService.post(HttpService.RemoteInter.GetNoCommonSign,null,!1)},this.getDefaultSign=function(forceFresh){return!forceFresh&&CacheStore.smsTemplate.defaultSign?HttpService.testHttp(CacheStore.smsTemplate.defaultSign):HttpService.post(HttpService.RemoteInter.GetDefaultSign,null,!1).then(function(data){return CacheStore.smsTemplate.defaultSign=data||"代收英雄",CacheStore.smsTemplate.defaultSign})},this.wrapSignFormat=function(sign){return"【"+sign+"】"},this.changeFailuredSign=function(id,sign){return HttpService.post(HttpService.RemoteInter.ChangeFailuredSign,{id:id,sign:sign},!0)},this.goPay=function(){ionicHistoryService.goNextPage("payment")},this.getSignPayConfig=function(){return HttpService.post(HttpService.RemoteInter.GetSignPayConfig,null,!0).then(function(configs){return configs[0]})},this.dealAfterPaySuc=function(){ionicHistoryService.goNextPage("paySuccess")},this.requestWeChatPay=function(configId,sign){var promise=HttpService.post(HttpService.RemoteInter.WXPaySign,{configId:configId,sign:sign},!0);return promise.then(function(data){payService.weixinPay(data.prepay,function(){service.dealAfterPaySuc()})}),promise},this.requestAliPay=function(configId,sign){var promise=HttpService.post(HttpService.RemoteInter.AliPaySign,{configId:configId,sign:sign},!0);return promise.then(function(data){payService.aliPay(data.aliStr,function(){service.dealAfterPaySuc()})}),promise},this.smsTemplateCheckChanged=function(templateId,flag){if(CacheStore.smsTemplate.templateList){var index=CacheStore.smsTemplate.templateList.contains(templateId,function(item,id){return item.id==id});index>-1&&(CacheStore.smsTemplate.templateList[index].status=flag?"checked":"checkfailure")}},this.initSMSCase=function(pd){service.getDefaultSign().then(function(sign){pd.sign=service.wrapSignFormat(sign),service.getDefaultTemplate().then(function(){pd.smsContent=service.initTemplateContentShow(pd.express,pd.proxyName)})})}}]).service("pushMessageService",["mediaService","CacheStore","$state","localConstantData","userInfoService","$rootScope","EmitEvent","locationService",function(mediaService,CacheStore,$state,localConstantData,userInfoService,$rootScope,EmitEvent,locationService){var service=this;this.openNotify=function(data){switch(data.jpush_busniessType){case localConstantData.messageCode.MessageError:$state.go("failedMsge")}},this.receiveNotify=function(data){switch(ionic.Platform.isIOS()&&(window.JPush.resetBadge(),window.plugins.jPushPlugin.setApplicationIconBadgeNumber(0)),data.jpush_busniessType){case localConstantData.messageCode.MessageError:mediaService.mediaPlayByLocal("sounds/failedSMS.mp3"),service.messageError(data.noticeId);break;case localConstantData.messageCode.PaySuccess:mediaService.mediaPlayByLocal("sounds/paySuccess.mp3"),service.paySuccess()}},this.messageError=function(noticeId){failedMsgeService.fetchOne(noticeId).then(function(order){CacheStore.addOneInfo("failedMsge","orderList",order)}),userInfoService.updateCanUseSMSCount()},this.paySuccess=function(){userInfoService.updateCanUseSMSCount().then(function(userInfo){(locationService.likeMyState("home")||locationService.likeMyState("mine"))&&$rootScope.$broadcast(EmitEvent.PaySuccess,userInfo.balance)})}}]).service("expressService",["HttpService","$filter",function(HttpService,$filter){var service=this;this.fetchAllExpress=function(){return HttpService.httpStatic(HttpService.RemoteInter.AllExpress)},this.wrapExpress=function(all,checked){if(!checked)return all;for(var i=0;i<all.length;i++){var id=all[i].id;for(var index in checked)if(checked[index].id==id){all[i].checked=!0,delete checked[index];break}}return all},this.filterChecked=function(all){return $filter("filter")(all,{checked:!0})},this.bindExpress=function(checked){return HttpService.get(HttpService.RemoteInter.BindExpress,{expressIds:checked.ObjectToSingle("id")},!0)},this.fetchCurExpress=function(id){return service.fetchAllExpress().then(function(all){var index=all.contains(id,function(item,curId){return item.id==curId});return index>-1?all[index].name:""})}}]).factory("deliveryService",["userInfoService","LocalDatabase","CacheStore","HttpService","$q","$cordovaFile","loadingService","toastTipService","ionicPopupService","$timeout","stringUtilsService",function(userInfoService,LocalDatabase,CacheStore,HttpService,$q,$cordovaFile,loadingService,toastTipService,ionicPopupService,$timeout,stringUtilsService){var communitys=null,fileName="contacts/"+userInfoService.getBaseInfo().phone+".json",initCommunity=function(){var deferer=$q.defer();return $cordovaFile.checkFile(cordova.file.dataDirectory,fileName).then(function(success){$cordovaFile.readAsText(cordova.file.dataDirectory,fileName).then(function(data0){communitys=JSON.parse(data0),deferer.resolve()})},function(error){fetchMyContacts().then(function(){deferer.resolve()})}),deferer.promise},fetchMyContacts=function(){return HttpService.post(HttpService.RemoteInter.Phones,null,!0).then(function(data){communitys=data,saveCommunity()})},saveCommunity=function(){$cordovaFile.checkDir(cordova.file.dataDirectory,"contacts").then(function(success){writeCommunity()},function(error){$cordovaFile.createDir(cordova.file.dataDirectory,"contacts").then(function(success){writeCommunity()})})},writeCommunity=function(){$cordovaFile.writeFile(cordova.file.dataDirectory,fileName,JSON.stringify(communitys),!0)},matchPhone=function(all,matchKey){var resultArr=[];if(all)for(var i=0;i<all.length;i++){var cur=all[i];cur.substring(7,11)==matchKey&&resultArr.push(cur)}return resultArr},service={init:function(){initCommunity()},updateAllPhonesForMore:function(phones){for(var deferred=$q.defer(),saveFlag=!1,i=0;communitys&&i<phones.length;i++){var cur=phones[i].phone;cur&&stringUtilsService.cellPhoneValidate(cur)&&communitys.contains(cur)<0&&(communitys.push(cur),saveFlag=!0)}return saveFlag&&saveCommunity(),deferred.promise},sureIn_base:function(pm,proxyId,sendMessage){return HttpService.post(HttpService.RemoteInter.SureIn,{data:JSON.stringify(pm),proxyId:proxyId,sendMessage:sendMessage},!0)},sureIn:function(proxyId,pm){return pm.remark=",",service.sureIn_base(pm,proxyId,pm.sendMessage)},fetchMatchPhones:function(matchKey,sucCb){service.fetchAllPhones().then(function(all){var result=matchPhone(all,matchKey);angular.isFunction(sucCb)&&sucCb(result)})},fetchAllPhones:function(){var deferer=$q.defer();return null===communitys?initCommunity().then(function(){deferer.resolve(communitys)}):deferer.resolve(communitys),deferer.promise},getReceiverByTel:function(phone){return HttpService.post(HttpService.RemoteInter.getReceiverByTel,{phone:phone},!1)},fetchNotifyMess:function(item){return angular.isUndefined(item.notifyMess)?HttpService.post(HttpService.RemoteInter.GetNotifyMess,{id:item.id,type:item.sendType||"sms"},!0).then(function(mess){item.notifyMess=mess}):HttpService.testHttp()},showNotifyMess:function(item){item.showMess?item.showMess=!1:(item.showMess=!0,service.fetchNotifyMess(item))},deleteOrder:function(id){return HttpService.post(HttpService.RemoteInter.DeleteOrder,{orderId:id},!1)}};return service}]).service("blacklistService",["HttpService","localConstantData","CacheStore","loadingService",function(HttpService,localConstantData,CacheStore,loadingService){var service=this;CacheStore.blacklist={init:function(){CacheStore.blacklist.allData=[],CacheStore.blacklist.allDataRow=30,CacheStore.blacklist.myList=[],CacheStore.blacklist.hasMore=!1,CacheStore.blacklist.lastId=null,CacheStore.blacklist.row=localConstantData.row}},CacheStore.blacklist.init(),this.httpLoadBlackList=function(pm){return HttpService.post(HttpService.RemoteInter.BlackList,pm,!1)},this.initListPool=function(){return CacheStore.blacklist.myList.empty(),CacheStore.blacklist.lastId=null,this.fetchMore()},this.getCondition=function(lastId,row){var conditionParams={};return conditionParams.lastId=lastId,conditionParams.row=row,conditionParams},this.fetchMore=function(){var service=this,current=CacheStore.blacklist,promise=service.httpLoadBlackList(this.getCondition(CacheStore.blacklist.lastId,CacheStore.blacklist.row));return promise.then(function(data){current.myList.distinctConcatChangeSource(data,function(ob1,ob2){return ob1.id==ob2.id}),data.length>0&&(current.lastId=data[data.length-1].id),current.hasMore=service.hasMore(data.length)}),promise},this.hasMore=function(dataLength){return dataLength>=CacheStore.blacklist.row},this.addOne=function(pm){return HttpService.post(HttpService.RemoteInter.AddBlackList,pm,!0).then(function(res){CacheStore.blacklist.myList.splice(0,0,res),CacheStore.blacklist.allData.splice(0,0,res)})},this.delOne=function(id,index){return HttpService.post(HttpService.RemoteInter.DelBlackList,{blackId:id},!0).then(function(){CacheStore.blacklist.myList.splice(index,1),CacheStore.blacklist.allData.splice(index,1)})};var eachLoad=function(lastId,hasMore){hasMore&&service.httpLoadBlackList(service.getCondition(lastId,CacheStore.blacklist.allDataRow)).then(function(data){CacheStore.blacklist.allData.distinctConcatChangeSource(data,function(ob1,ob2){return ob1.id==ob2.id});var lastId=null,hasMore=!1;data.length>0&&(lastId=data[data.length-1].id),hasMore=data.length>=CacheStore.blacklist.allDataRow,eachLoad(lastId,hasMore)})};this.loadAllData=function(){null==CacheStore.blacklist.allData&&(CacheStore.blacklist.allData=[],loadingService.show("正在加载黑名单，请稍候"),eachLoad(null,!0),loadingService.hide())},this.isBelongBlack=function(phone){return CacheStore.blacklist.allData.contains(phone,function(item,cur){return item.phone==cur})>-1}}]).service("orderCommonService",["lgyxScannerService",function(lgyxScannerService){this.resolveOrderStatus=function(status){var res="";switch(status){case"Out":res="已取件";break;case"In":res="待取件";break;case"Return":res="已退件"}return res},this.scanBarCode=function(sucCb){lgyxScannerService.scanBarcode(sucCb)},this.scanQRCode=function(sucCb){lgyxScannerService.scanQR(sucCb)},this.scanPhoto=function(sucCb,needCode){lgyxScannerService.scanPhoto(sucCb,null,needCode)}}]).service("recipientLogService",["LocalDatabase","htmlUtilsService",function(LocalDatabase,htmlUtilsService){this.addOneLog=function(userId,express,phone,orderNo,code){var item={uuid:htmlUtilsService.getUUID()+phone,express:express,phone:phone,orderNo:orderNo?"("+orderNo+")":orderNo,code:code,createTime:new Date},logOb=LocalDatabase.get(LocalDatabase.Data.recipientLog),log=logOb[userId];return log.length>=20&&log.splice(19,1),log.splice(0,0,item),LocalDatabase.set(LocalDatabase.Data.recipientLog,logOb),log},this.getAllLog=function(userId){var logOb=LocalDatabase.get(LocalDatabase.Data.recipientLog),log=logOb?logOb[userId]:null;if(!log){var res={};return res[userId]=[],LocalDatabase.set(LocalDatabase.Data.recipientLog,res),[]}return log},this.clearPreUserLog=function(){},this.getCode=function(orderNo,remark,serialNo){return remark=remark?remark+"-":"",serialNo=serialNo?serialNo+"-":"",orderNo=orderNo&&orderNo.length>4?orderNo.substr(-5,5):htmlUtilsService.getRandomNum(),remark+serialNo+orderNo}}]).service("warehouseService",["localConstantData","HttpService","CacheStore","userInfoService","ionicHistoryService","orderCommonService",function(localConstantData,HttpService,CacheStore,userInfoService,ionicHistoryService,orderCommonService){var service=this;CacheStore.warehouse={init:function(){CacheStore.warehouse.restList=[],CacheStore.warehouse.orderList=[],CacheStore.warehouse.hasMore=!1,CacheStore.warehouse.lastId=null,CacheStore.warehouse.row=localConstantData.row}},CacheStore.warehouse.init(),this.initListPool=function(pm){return CacheStore.warehouse.orderList.empty(),CacheStore.warehouse.lastId=null,this.fetchMore(pm)},this.getCondition=function(conditionParams){return conditionParams.lastId=CacheStore.warehouse.lastId,conditionParams.row=CacheStore.warehouse.row,conditionParams};var wrapWareHouseData=function(originArr){userInfoService.getBindProxy(!1).then(function(proxy){for(var i=0;i<originArr.length;i++){var cur=originArr[i];if(cur.statusVal=orderCommonService.resolveOrderStatus(cur.status),cur.proxyId)for(var j=0;j<proxy.length;++j){var it=proxy[j];if(it.id===cur.proxyId){cur.proxyName=it.name;break}}cur.proxyName||(cur.proxyName="--")}})};this.baseFetchWareHouseList=function(condition){return HttpService.get(HttpService.RemoteInter.WareHouseList,condition,!1)},this.fetchMore=function(pm){var service=this,current=CacheStore.warehouse,promise=service.baseFetchWareHouseList(this.getCondition(pm));return promise.then(function(res){var data=res.rows;wrapWareHouseData(data),current.orderList.distinctConcatChangeSource(data,function(ob1,ob2){return ob1.id==ob2.id}),data.length>0&&(current.lastId=data[data.length-1].id),current.hasMore=service.hasMore(data.length)}),promise},this.hasMore=function(dataLength){return dataLength>=CacheStore.warehouse.row};var wrapExpressCondition=function(oriArr){for(var res=[{key:null,val:"全部快递"}],i=0;i<oriArr.length;i++){var cur=oriArr[i];res.push({key:cur.id,val:cur.name})}return res},wrapProxyCondition=function(oriArr){for(var res=[{key:null,val:"全部代收点"}],i=0;i<oriArr.length;i++){var cur=oriArr[i];res.push({key:cur.id,val:cur.name})}return res};this.getSearchConditions=function(){return userInfoService.getBindExpress(!0).then(function(express){return userInfoService.getBindProxy(!0).then(function(proxy){return{status:[{key:"All",val:"全部状态"},{key:"In",val:"待取件"},{key:"Out",val:"已取件"},{key:"Return",val:"已退件"}],express:wrapExpressCondition(express),proxies:proxy?wrapProxyCondition(proxy):[]}})})},this.getExpImg=userInfoService.getExpImg,this.lookRestOrder=function(){ionicHistoryService.goNextPage("delivery")},this.emptyOrderList=function(pm){return HttpService.post(HttpService.RemoteInter.EmptyOrderList,pm,!0)},this.loadHomeInList=function(){var pm={};return pm.row=localConstantData.row,pm.status="In",service.baseFetchWareHouseList(pm).then(function(res){var data=res.rows;return wrapWareHouseData(data),data})}}]).service("piecesService",["localConstantData","HttpService","CacheStore","userInfoService","ionicHistoryService","orderCommonService","ionicPopupService",function(localConstantData,HttpService,CacheStore,userInfoService,ionicHistoryService,orderCommonService,ionicPopupService){CacheStore.pieces={init:function(){CacheStore.pieces.orderList=[],CacheStore.pieces.hasMore=!1,CacheStore.pieces.lastId=null,CacheStore.pieces.row=localConstantData.row}},CacheStore.pieces.init(),this.initListPool=function(pm){return CacheStore.pieces.orderList.empty(),CacheStore.pieces.lastId=null,this.fetchMore(pm)},this.getCondition=function(conditionParams){return conditionParams.lastId=CacheStore.pieces.lastId,conditionParams.row=CacheStore.pieces.row,conditionParams};var wrapPiecesData=function(originArr){userInfoService.getBindProxy(!1).then(function(proxy){for(var i=0;i<originArr.length;i++){var cur=originArr[i];if(cur.statusVal=orderCommonService.resolveOrderStatus(cur.status),cur.proxyId)for(var j=0;j<proxy.length;++j){var it=proxy[j];if(it.id===cur.proxyId){cur.proxyName=it.name;break}}cur.proxyName||(cur.proxyName="--")}})};this.baseFetchPiecesList=function(condition){return HttpService.get(HttpService.RemoteInter.ReadOut,condition,!1)},this.fetchMore=function(pm){var service=this,current=CacheStore.pieces,promise=service.baseFetchPiecesList(this.getCondition(pm));return promise.then(function(res){var data=res.rows;wrapPiecesData(data),current.orderList.distinctConcatChangeSource(data,function(ob1,ob2){return ob1.id==ob2.id}),data.length>0&&(current.lastId=data[data.length-1].id),current.hasMore=service.hasMore(data.length)}),promise},this.hasMore=function(dataLength){return dataLength>=CacheStore.pieces.row};var resolveReadyOut=function(originArr){for(var i=0;i<originArr.length;i++)originArr[i].checked=!0};this.outResultResponse=function(readyOut,cancelCb,continueCb,isCheck){isCheck&&readyOut.length>0?ionicPopupService.confirm("该收件人还有其他快递，是否查看？","取件成功",null,function(){angular.isFunction(continueCb)&&(resolveReadyOut(readyOut),continueCb(readyOut))},cancelCb,null,"立即查看"):$timeout(function(){toastTipService.showShortTop("派件成功"),angular.isFunction(cancelCb)&&cancelCb()})},this.sureOut=function(checked,comment){return HttpService.get(HttpService.RemoteInter.SureOut,{orderIds:checked.ObjectToSingle("id"),remark:comment},!0)},this.toProxyOrder=function(pm){return HttpService.get(HttpService.RemoteInter.ToProxyOrder,pm,!0)},this.getExpImg=userInfoService.getExpImg}]).service("statisticsService",["HttpService","localConstantData","CacheStore","orderCommonService","userInfoService","dateTimeService","htmlUtilsService",function(HttpService,localConstantData,CacheStore,orderCommonService,userInfoService,dateTimeService,htmlUtilsService){var service=this;CacheStore.statistics={init:function(){CacheStore.statistics.detailList=[],CacheStore.statistics.hasMore=!1,CacheStore.statistics.lastId=null,CacheStore.statistics.row=localConstantData.row}},CacheStore.statistics.init(),this.fetchStatisticsDetail=function(pm){return HttpService.get(HttpService.RemoteInter.StatisticsDetail,pm,!0)},this.initListPool=function(pm){return CacheStore.statistics.detailList.empty(),CacheStore.statistics.lastId=null,this.fetchMore(pm)};var wrapOrderDetailData=function(originArr){userInfoService.getBindProxy(!1).then(function(proxy){for(var i=0;i<originArr.length;i++){var cur=originArr[i];if(cur.proxyId)for(var j=0;j<proxy.length;++j){var it=proxy[j];if(it.id===cur.proxyId){cur.proxyName=it.name;break}}cur.proxyName||(cur.proxyName="--")}})};this.getCondition=function(conditionParams){return conditionParams.lastId=CacheStore.statistics.lastId,conditionParams.row=CacheStore.statistics.row,conditionParams},this.fetchMore=function(pm){var service=this,current=CacheStore.statistics,promise=service.fetchStatisticsDetail(this.getCondition(pm));return promise.then(function(res){var data=res.rows;wrapOrderDetailData(data),current.detailList.distinctConcatChangeSource(data,function(ob1,ob2){return ob1.id==ob2.id}),data.length>0&&(current.lastId=data[data.length-1].id),current.hasMore=service.hasMore(data.length)}),promise},this.hasMore=function(dataLength){return dataLength>=CacheStore.statistics.row},this.resolveToDateStr=function(date){return date.substring(0,4)+"-"+date.substring(4,6)+"-"+date.substring(6,8)},this.baseFetchStatistcs=function(pm){return HttpService.get(HttpService.RemoteInter.StatisticsList,pm,!0)},this.fetchStatisticsList=function(pm){return service.baseFetchStatistcs(pm).then(function(data){for(var res={},newDataList=[],totalSum=0,inSum=0,outSum=0,returnSum=0,startDateStr=service.resolveToDateStr(pm.startDate),endDateStr=service.resolveToDateStr(pm.endDate),startDate=dateTimeService.strFomatToDate(startDateStr,"yyyy-MM-dd"),endDate=dateTimeService.strFomatToDate(endDateStr,"yyyy-MM-dd"),intervalDays=dateTimeService.getTimeIntervalDays(startDate,endDate)+1,j=0;j<intervalDays;j++){var newData={totalNumber:0,inNumber:0,outNumber:0,returnNumber:0,statDay:dateTimeService.dateTimeFormatToStr(dateTimeService.dateTimeAddDaysToDate(j,startDate),"yyyyMMdd")};if(newData.statDayFormat=newData.statDay.substring(4,6)+"/"+newData.statDay.substring(6,8),newData.id=newData.statDayFormat+htmlUtilsService.getUUID(),data.length>0){var lastIndex=data.length-1,cur=data[lastIndex];cur.statDay==newData.statDay&&(newData.totalNumber=cur.totalNumber,newData.inNumber=cur.inNumber,newData.outNumber=cur.outNumber,newData.returnNumber=cur.returnNumber,totalSum+=parseInt(cur.totalNumber),inSum+=parseInt(cur.inNumber),outSum+=parseInt(cur.outNumber),returnSum+=parseInt(cur.returnNumber),data.splice(lastIndex,1))}newDataList.splice(0,0,newData)}return res.list=newDataList,res.sumResult={totalSum:totalSum,inSum:inSum,outSum:outSum,returnSum:returnSum},res})},this.fetchHomeStatistics=function(){var pm={};return pm.beginDate=dateTimeService.dateTimeFormatToStr(new Date,"yyyyMMdd"),pm.endDate=pm.beginDate,service.baseFetchStatistcs(pm).then(function(res){if(1===res.length)return res[0]})},this.getStat7=function(){return HttpService.post(HttpService.RemoteInter.GetStat7,{},!1)},this.resolveOrderStatus=orderCommonService.resolveOrderStatus,this.getExpImg=userInfoService.getExpImg}]).service("failedMsgeService",["localConstantData","HttpService","CacheStore",function(localConstantData,HttpService,CacheStore){CacheStore.failedMsge={init:function(){CacheStore.failedMsge.orderList=[],CacheStore.failedMsge.hasMore=!1,CacheStore.failedMsge.lastId=null,CacheStore.failedMsge.row=localConstantData.row}},CacheStore.failedMsge.init(),this.initListPool=function(){return CacheStore.failedMsge.orderList.empty(),CacheStore.failedMsge.lastId=null,this.fetchMore()},this.getCondition=function(){var conditionParams={};return conditionParams.lastId=CacheStore.failedMsge.lastId,conditionParams.row=CacheStore.failedMsge.row,conditionParams},this.fetchOne=function(noticeId){return HttpService.post(HttpService.RemoteInter.GetOneSMS,{noticeId:noticeId},!1)},this.fetchMore=function(){var service=this,current=CacheStore.failedMsge,promise=HttpService.post(HttpService.RemoteInter.FailedMsgeList,this.getCondition(),!1);return promise.then(function(data){current.orderList.distinctConcatChangeSource(data,function(ob1,ob2){return ob1.id==ob2.id}),current.orderList.forEach(function(it){var order=it.order;if(void 0!==order&&null!=order&&void 0!==order.remark&&null!==order.remark){var its=order.remark.split(",");2==its.length&&(order.shelfNum=""==its[0]?null:its[0],order.serialNo=""==its[1]?null:its[1])}}),data.length>0&&(current.lastId=data[data.length-1].id),current.hasMore=service.hasMore(data.length)}),promise},this.hasMore=function(dataLength){return dataLength>=CacheStore.failedMsge.row},this.resend=function(pm){return HttpService.post(HttpService.RemoteInter.ResendInSMS,pm,!0)},this.resendAll=function(pm){return HttpService.post(HttpService.RemoteInter.ResendAllInSMS,pm,!0)},this.countResend=function(pm){return HttpService.post(HttpService.RemoteInter.CountResendInSMS,pm,!0)},this.deleteFailSMS=function(pm){return HttpService.post(HttpService.RemoteInter.DeleteFailSMS,pm,!0)},this.emptyFailSMS=function(){return HttpService.post(HttpService.RemoteInter.EmptyFailSMS,null,!0)}}]).service("rechargeService",["HttpService","CacheStore","payService","ionicHistoryService","dateTimeService","$q","userInfoService",function(HttpService,CacheStore,payService,ionicHistoryService,dateTimeService,$q,localConstantData,userInfoService){CacheStore.recharge={init:function(){CacheStore.recharge.moneyChargeConfig=null}},CacheStore.recharge.init(),this.getChargeListConfig=function(){return HttpService.post(HttpService.RemoteInter.ChargeListConfig,null,!0)},this.getMoneyChargeConfig=function(){var service=this,cacheRule=CacheStore.recharge.moneyChargeConfig;if(cacheRule&&dateTimeService.ABeforeBAfter(new Date,dateTimeService.dateTimeAddDaysToDate(7,cacheRule.cacheTime))){var defer=$q.defer();return defer.resolve(cacheRule),defer.promise}return service.getChargeListConfig().then(function(rules){var index=rules.contains(!0,function(arrOb,ob){return arrOb.light==ob}),defaultRuleId=index>-1?rules[index].id:null;return CacheStore.recharge.moneyChargeConfig={cacheTime:new Date,rules:rules,defaultRuleId:defaultRuleId},CacheStore.recharge.moneyChargeConfig})},this.dealAfterPaySuc=function(){ionicHistoryService.goNextPage("paySuccess")},this.dealAfterPayErr=function(){},this.requestWeChatPay=function(configId){var service=this,promise=HttpService.post(HttpService.RemoteInter.RequestWeChatPay,{configId:configId},!0);return promise.then(function(data){payService.weixinPay(data.prepay,function(){service.notifyServerPaySuc(data.chargeId),service.dealAfterPaySuc()},function(){service.dealAfterPayErr()})}),promise},this.requestAliPay=function(configId){var service=this,promise=HttpService.post(HttpService.RemoteInter.RequestAliPay,{configId:configId},!0);return promise.then(function(data){payService.aliPay(data.aliStr,function(){service.notifyServerPaySuc(data.chargeId),service.dealAfterPaySuc()},function(){service.dealAfterPayErr()})}),promise},this.notifyServerPaySuc=function(chargeId){HttpService.post(HttpService.RemoteInter.NotifyServerPaySuc,{chargeId:chargeId},!1)}}]).service("subaccountService",["HttpService","CacheStore",function(HttpService,CacheStore){CacheStore.subaccount={init:function(){CacheStore.subaccount.accounts=null}},CacheStore.subaccount.init(),this.getAccounts=function(){return CacheStore.subaccount.accounts?HttpService.testHttp(CacheStore.subaccount.accounts):HttpService.post(HttpService.RemoteInter.Subaccounts,null,!1).then(function(data){return CacheStore.subaccount.accounts=data,data})},this.register=function(pm){return HttpService.post(HttpService.RemoteInter.RegisterSubaccount,pm,!0).then(function(data){CacheStore.subaccount.accounts.splice(0,0,data)})},this.remove=function(pm){return HttpService.post(HttpService.RemoteInter.RemoveSubaccount,pm,!0)},this.modifyName=function(pm){return HttpService.post(HttpService.RemoteInter.ModifySubaccountName,pm,!0)},this.switchStatus=function(id,statusNum){return HttpService.post(HttpService.RemoteInter.SwitchSubaccountStatus,{id:id,status:statusNum},!0)}}]).service("proxyService",["localConstantData","HttpService","CacheStore",function(localConstantData,HttpService,CacheStore){CacheStore.proxy={init:function(){CacheStore.proxy.proxyList=[],CacheStore.proxy.hasMore=!1,CacheStore.proxy.lastId=null,CacheStore.proxy.row=localConstantData.row}},CacheStore.proxy.init(),this.initListPool=function(pm){return CacheStore.proxy.proxyList.empty(),CacheStore.proxy.lastId=null,this.fetchMore(pm)},this.getCondition=function(conditionParams){return conditionParams.lastId=CacheStore.proxy.lastId,conditionParams.row=CacheStore.proxy.row,conditionParams},this.fetchProxyList=function(pm){return HttpService.post(HttpService.RemoteInter.GetProxyList,pm,!1)},this.fetchMore=function(pm){var service=this,current=CacheStore.proxy,promise=service.fetchProxyList(this.getCondition(pm));return promise.then(function(res){var data=res.rows;current.proxyList.distinctConcatChangeSource(data,function(ob1,ob2){return ob1.id==ob2.id}),data.length>0&&(current.lastId=data[data.length-1].id),current.hasMore=service.hasMore(data.length)}),promise},this.hasMore=function(dataLength){return dataLength>=CacheStore.proxy.row},this.saveProxy=function(pm){return HttpService.post(HttpService.RemoteInter.AddProxy,pm,!0)},this.removeProxy=function(pm){return HttpService.post(HttpService.RemoteInter.RemoveProxy,pm,!0)},this.modifyProxy=function(pm){return HttpService.post(HttpService.RemoteInter.ModifyProxy,pm,!0)}}]),angular.module("AgencyApp.directives",[]).directive("dateShow",function(){return{restrict:"EAC",template:'<div ng-date="{{date}}" ng-date-form="{{dateForm}}" class="date-area"><div class="text-center date-year">{{year}}.{{month}}</div><div class="text-center date-day">{{day}}</div></div>',scope:{date:"=ngDate"},link:function(scope,el,attr){scope.dateForm="yyyy-MM-dd HH:mm:ss";var currentDate=new Date(Date.parse(scope.date.replace(/-/g,"/")));scope.year=currentDate.getFullYear(),scope.month=currentDate.getMonth()+1,scope.day=currentDate.getDate()}}}).directive("commonBackButton",function(){return{restrict:"EAC",template:'<button class="button back-button button-clear header-item" ng-click="commonBack()"><i class="icon ion-ios-arrow-back"></i></button>',controller:["$scope","$ionicHistory","$ionicScrollDelegate",function($scope,$ionicHistory,$ionicScrollDelegate){$scope.backTitle=$ionicHistory.backTitle(),$scope.commonBack=function(){$ionicScrollDelegate.scrollTop(),$scope.$ionicGoBack()}}]}}).directive("notFoundData",["$timeout",function($timeout){return{restrict:"E",scope:{data:"="},template:'<div class="nodata"><img ng-src="img/nodata.png" ng-show="noData"/><p class="nodatacon fz-14-t" ng-show="noData">没有找到相关内容</p></div>',link:function(scope,ele,attr,ctrl){scope.$on("scroll.refreshComplete",function(){scope.noData=null==scope.data||0==scope.data.length})}}}]).directive("notFoundDataV2",[function(){return{restrict:"E",priority:-1,template:'<div class="nodata"><img ng-src="img/nodata.png"/><p class="nodatacon fz-14-t">没有找到相关内容</p></div>'}}]).directive("ngEnter",function(){return function(scope,element,attrs){element.bind("keydown keypress",function(event){13===event.which&&(scope.$apply(function(){scope.$eval(attrs.ngEnter,{event:event})}),event.preventDefault())})}}).directive("headImg",["$timeout","userInfoService",function($timeout,userInfoService){return{restrict:"AE",replace:!0,template:"<img class={{pageData.className}} ng-src={{pageData.imgUrl}} >",scope:{options:"=options"},controller:["$scope",function($scope){$scope.pageData={imgUrl:"img/touxiang.jpg"}}],link:function($scope,element,attrs){var pd=$scope.pageData;$scope.$watch("options",function(so){if(so){var originUrl=so.picture||so;if(pd.className=so.className,angular.isDefined(originUrl)&&null!==originUrl){var img=new Image;img.src=userInfoService.imagePath(originUrl),img.onload=function(){$timeout(pd.imgUrl=img.src,500),img=null}}}})}}}]).directive("countDown",["EmitEvent","CacheStore","$interval","countDownService",function(EmitEvent,CacheStore,$interval,countDownService){function CountDown(origiTimes,endCallback,cbParams,activeTime,extraTime,stateId){this.cbParams=cbParams,this.curTime=origiTimes<=0?0:origiTimes,this.showValue=null,this.stateId=stateId,this.intervalId=null,this.endCallback=endCallback,this.activeTime=activeTime,this.extraTime=extraTime||0,this.startDown()}return CountDown.prototype={constructor:CountDown,startDown:function(){var cdOb=this;CacheStore.countDown.intervals[cdOb.stateId]&&cdOb.stopTime(),cdOb.intervalId=$interval(function(){if(cdOb.curTime<=1){if($interval.cancel(cdOb.intervalId),cdOb.endCallback&&"function"==typeof cdOb.endCallback)try{cdOb.endCallback(cdOb.cbParams)}catch(e){}}else cdOb.showValue=countDownService.getShowValue(cdOb.curTime),cdOb.curTime--},1e3),CacheStore.countDown.intervals[cdOb.stateId]=cdOb.intervalId},correctTime:function(){this.curTime=countDownService.getFastOrderListCountDown(this.activeTime,this.extraTime)},cancelInterval:function(){$interval.cancel(this.intervalId)},stopTime:function(){$interval.cancel(CacheStore.countDown.intervals[this.stateId]),delete CacheStore.countDown.intervals[this.stateId]}},{restrict:"AE",template:"<span>{{haha.showValue}}</span>",scope:{options:"=options"},replace:!0,controller:["$scope","$rootScope",function($scope,$rootScope){var deregister=$rootScope.$on("correctTime",function(){$scope.haha&&$scope.haha.correctTime()});$scope.$on("$destroy",function(){deregister()})}],link:function($scope,element,attrs){$scope.$watch("options",function(newValue){newValue&&newValue.activeTime&&($scope.haha=new CountDown(countDownService.getFastOrderListCountDown(newValue.activeTime,newValue.extraTime||0),newValue.endCb,newValue.params,newValue.activeTime,newValue.extraTime,newValue.stateId))}),$scope.$on(EmitEvent.StopOrContinue,function(event,data){$scope.haha&&$scope.haha.stopTime()})}}}]).directive("showBatchRes",["$timeout","$ionicModal",function($timeout,$ionicModal){return{scope:{options:"="},priority:-1,restrict:"AE",link:function(scope,element,attrs){var vm=scope.vm={},curModal=null;scope.hidePic=function(){curModal&&curModal.hide()};scope.options.showBatchRes=function(res){if(vm.res=res,curModal)return curModal.show(),!1;$ionicModal.fromTemplateUrl("modal/batchRes.html",{scope:scope,animation:"slide-in-up"}).then(function(modal){(curModal=modal).show()})},scope.$on("$destroy",function(){curModal&&curModal.remove()})}}}]).directive("changeSign",["smsTemplateService","$ionicModal","toastTipService",function(smsTemplateService,$ionicModal,toastTipService){return{scope:{options:"="},priority:-1,restrict:"AE",link:function(scope,element,attrs){var vm=scope.vm={},curModal=null;scope.closeModal=function(){curModal&&curModal.hide()},scope.goChange=function(){vm.newSign?(curModal.hide(),smsTemplateService.changeFailuredSign(scope.options.signId,vm.newSign).then(scope.options.changedCb)):toastTipService.showShortTop("签名不能为空")};scope.options.showModel=function(){if(vm.sign=scope.options.sign,curModal)return curModal.show(),!1;$ionicModal.fromTemplateUrl("modal/changeSign.html",{scope:scope,animation:"slide-in-up"}).then(function(modal){(curModal=modal).show()})},scope.$on("$destroy",function(){curModal&&curModal.remove()})}}}]).directive("smsCase",["smsTemplateService","$ionicModal","toastTipService","$timeout",function(smsTemplateService,$ionicModal,toastTipService,$timeout){return{scope:{options:"="},priority:-1,restrict:"AE",link:function(scope,element,attrs){var vm=scope.vm={},curModal=null;scope.closeModal=function(){curModal&&curModal.hide()};scope.options.showModel=function(submitCb){if(vm.btType=scope.options.btType,vm.content=scope.options.showContent,vm.smsCount=smsTemplateService.getSMSCount(vm.content.length),scope.sureSubmit=function(){scope.closeModal(),$timeout(submitCb,500)},curModal)return curModal.show(),!1;$ionicModal.fromTemplateUrl("modal/smsCase.html",{scope:scope,animation:"slide-in-up"}).then(function(modal){(curModal=modal).show()})},scope.$on("$destroy",function(){curModal&&curModal.remove()})}}}]).directive("showProxies",["$timeout","EmitEvent","$ionicModal","userInfoService","toastTipService","anchorScrollService",function($timeout,EmitEvent,$ionicModal,userInfoService,toastTipService,anchorScrollService){return{restrict:"AE",scope:{options:"="},priority:-1,link:function(scope,element,attrs){var vm=scope.vm={},so=scope.options,proxyModal=null;vm.proxyList=so.data,vm.params=null,vm.proxyIndex=-1,scope.sureSelectProxy=function(){if(-1!=vm.proxyIndex){if(angular.isFunction(so.sureCb)){var key=vm.proxyList[vm.proxyIndex].key,val=vm.proxyList[vm.proxyIndex].val;so.sureCb(key,val,vm.params)}scope.hideModel()}else toastTipService.showShortTop("请先选择代收站点")},scope.hideModel=function(){proxyModal&&(vm.proxyIndex=-1,proxyModal.hide())};so.chooseAction=function(params){if(vm.params=params,proxyModal)return proxyModal.show(),!1;$ionicModal.fromTemplateUrl("modal/showProxies.html",{scope:scope,animation:"slide-in-up"}).then(function(modal){proxyModal=modal,$timeout(function(){proxyModal.show()},150)})},scope.$on("$destroy",function(){vm.params=null,proxyModal&&proxyModal.remove()})}}}]).directive("signAgreement",["smsTemplateService","$ionicModal","toastTipService",function(smsTemplateService,$ionicModal,toastTipService){return{scope:{options:"="},priority:-1,restrict:"AE",link:function(scope,element,attrs){var curModal=null;(scope.vm={}).btType=scope.options.btType,scope.closeModal=function(){curModal&&curModal.hide()},scope.agree=function(){curModal.hide(),smsTemplateService.goPay()};scope.options.showModel=function(submitCb){if(curModal)return curModal.show(),!1;$ionicModal.fromTemplateUrl("modal/signAgreement.html",{scope:scope,animation:"slide-in-up"}).then(function(modal){(curModal=modal).show()})},scope.$on("$destroy",function(){curModal&&curModal.remove()})}}}]).directive("ngShare",[function(){return{restrict:"E",replace:!0,template:'<div class="sharebox" ng-if="showShare" ng-click="closeShare()"><div class="share"> <div class="sharenav" ng-click="shareToWechatMoments()"><span><img src="img/share2.png"></span><p>微信朋友圈</p></div> <div class="sharenav" ng-click="shareToWechatFriend()"><span><img src="img/share3.png"></span><p>微信好友</p></div> <div class="sharenav" ng-click="shareToQQ()"><span><img src="img/share4.png"></span><p>QQ好友</p></div></div> </div>',controller:["$scope","shareService",function($scope,shareService){$scope.showShare=!1,$scope.closeShare=function(){$scope.showShare=!1},$scope.shareToWechatMoments=function(){shareService.shareLinkToWechat(0,$scope.shareData.url,$scope.shareData.title,$scope.shareData.desc)},$scope.shareToWechatFriend=function(){shareService.shareLinkToWechat(1,$scope.shareData.url,$scope.shareData.title,$scope.shareData.desc)},$scope.shareToQQ=function(){shareService.shareLinkToQQ(1,$scope.shareData.url,$scope.shareData.title,$scope.shareData.desc,"http://www.linggonghero.com/logo.png")}}]}}]),angular.module("AgencyApp.filters",[]).filter("buildPrice",function(){return function(input){return input=input>1e4?parseFloat((input/1e4).toFixed(2))+"万":parseInt(input)}}).filter("phoneFormat",function(){return function(num){if(null!=num&&11==num.length){for(var result="",counter=0,i=(num=(num||0).toString()).length-1;i>=0;i--)counter++,result=num.charAt(i)+result,counter%4==0&&0!=i&&(result="-"+result);return result}return num}}).filter("sexFormat",function(){return function(num){return 1===num?"女":0===num?"男":angular.isDefined(num)&&null!==num?"不限":""}}).filter("equalSelectCondition",function(){return function(input,param1,comKey){if(isArray(param1)){if(comKey){if(param1.contains(input,function(ob,id){return ob[comKey]==id})>-1)return!0}else if(param1.contain(input))return!0}else if(input==param1)return!0;return!1}}).filter("trimFormat",function(){return function(input){return null!=input?input.toString().trim():input}}).filter("mathRound",function(){return function(input){return isNaN(input)?input:Math.round(input)}}).filter("subStringFormat",function(){return function(input,startIndex,endIndex){return null!=input&&input.length>0?input.toString().substring(startIndex,endIndex):""}}).filter("to_trusted",["$sce",function($sce){return function(text){return $sce.trustAsHtml(text)}}]).filter("messStatus",function(){return function(status){switch(status){case"Send":return"未知";case"Success":return"成功";case"Error":return"失败"}}}),angular.module("templates",[]).run(["$templateCache",function($templateCache){$templateCache.put("tabs.html",'<ion-tabs class="tabs-positive tabs-icon-top tabs-positive">\n  <ion-tab title="首页" icon-on="tabicon-home-on" icon-off="tabicon-home-off" ui-sref="index.home">\n    <ion-nav-view name="homeTab"></ion-nav-view>\n  </ion-tab>\n  <ion-tab title="仓库" icon-on="tabicon-ware-on" icon-off="tabicon-ware-off"  ui-sref="index.warehouse">\n    <ion-nav-view name="warehouseTab"></ion-nav-view>\n  </ion-tab>\n  <ion-tab title="统计" icon-on="tabicon-stats-on" icon-off="tabicon-stats-off"  ui-sref="index.statistics">\n    <ion-nav-view name="statisticsTab"></ion-nav-view>\n  </ion-tab>\n  <ion-tab title="我的" icon-on="tabicon-mine-on" icon-off="tabicon-mine-off" ui-sref="index.mine">\n    <ion-nav-view name="mineTab"></ion-nav-view>\n  </ion-tab>\n</ion-tabs>\n'),$templateCache.put("main/batchInput.html",'<ion-view view-title="批量扫描" hide-back-button="true">\n  <ion-nav-buttons side="left" >\n    <common-back-button></common-back-button>\n  </ion-nav-buttons>\n  <ion-nav-buttons side="right">\n    <span class="title-right-btn" ui-sref="custom">自定义</span>\n  </ion-nav-buttons>\n  <ion-content class="pagebg">\n    <ion-refresher pulling-text="下拉刷新" on-refresh="pullRefresh()" immediate-check="false"></ion-refresher>\n    <show-batch-res options="pd.batchResOptions"></show-batch-res>\n    <div class="">\n      <div class="jumpline">\n        <p>派到代收站点</p>\n        <div class="btn-switch">\n          <label class="toggle">\n            <input type="checkbox" ng-model="pd.custom.sendProxy" ng-change="sendProxyChanged()">\n            <div class="track">\n              <div class="handle"></div>\n            </div>\n          </label>\n        </div>\n      </div>\n      <div class="inputline" ng-click="showExpress()">\n        <div class="inputbox"><p>{{pd.express}}</p></div>\n        <div class="iconbox"><i class="ion-android-arrow-dropdown"></i></div>\n      </div>\n      <div class="inputline" ng-show="pd.custom.sendProxy" ng-click="showProxyList()">\n        <div class="inputbox"><p>{{pd.proxyName}}</p></div>\n        <div class="iconbox"><i class="ion-android-arrow-dropdown"></i></div>\n      </div>\n      <div class="home-example">\n        <div class="home-example-title"><h1>短信示例：</h1></div>\n        <div class="home-example-cont">{{pd.sign}}{{pd.smsContent}}</div>\n      </div>\n      <div class="recip-note">\n        <div class="recip-noteline">剩余金额：<span class="colororange">{{pd.balance}}</span>元<div class="recip-recharge" ng-click="goPay()">充值</div><div class="recip-recharge" ng-click="pullRefresh()">刷新</div></div>\n      </div>\n      <div class="recip-tips" ng-if="pd.custom.noMessage || (pd.custom.delay !==undefined && pd.custom.delay !== null && pd.custom.delay > 0)">通知状态：<span class="colorred" ng-if="pd.custom.noMessage">只入库，不发通知</span><span class="colorred" ng-if="pd.custom.delay !==undefined && pd.custom.delay !== null && pd.custom.delay > 0 && pd.custom.noMessage ==false">入库{{::pd.custom.delay}}分钟后发送通知</span></div>\n      <div class="btnbox mgn-top40">\n        <button class="login-button button-bg" ng-click="modelIn()">进入批量扫描</button>\n      </div>\n      <div class="recip-tips"><span class="colorred">注意：<br/>1）、短信通知每条按5分计费；<br/>2）、微信通知免费，须收件人先关注【代收英雄】公众号；<br/>3）、不发通知，每入库两次扣除一条短信通知费用</span></div>\n    </div>\n  </ion-content>\n  <div class="popselect" ng-show="pd.showExpress" ng-click="hideExpress()">\n    <div class="list" data-tap-disabled="{{isiOS}}">\n      <label class="item item-radio" ng-repeat="item in pd.bindExpress track by item.id">\n        <input type="radio" name="express" ng-model="pm.expressId" ng-value="item.id" ng-change="expressChanged(item)">\n        <div class="radio-content">\n          <div class="item-content recip-eximg">\n            <img ng-src={{::wrapEXpImg(item.id)}}><p>{{::item.name}}</p>\n          </div>\n          <i class="iconselect ion-checkmark-round" ng-class="pm.expressId === item.id ?\'displayblock\':\'\'"></i>\n        </div>\n      </label>\n    </div>\n  </div>\n  <div class="popselect" ng-show="pd.showProxyList" ng-click="hideProxyList()">\n    <div class="list" data-tap-disabled="{{isiOS}}">\n      <label class="item item-radio" ng-repeat="item in pd.bindProxy track by item.id">\n        <input type="radio" name="proxy" ng-model="pm.proxyId" ng-value="item.id" ng-change="proxyChanged(item)">\n        <div class="radio-content">\n          <div class="item-content recip-eximg">\n            <p>{{::item.name}}</p>\n          </div>\n          <i class="iconselect ion-checkmark-round" ng-class="pm.proxyId === item.id ?\'displayblock\':\'\'"></i>\n        </div>\n      </label>\n    </div>\n  </div>\n</ion-view>\n\n\n'),$templateCache.put("main/custom.html",'<ion-view title="自定义录件"  hide-back-button="true">\n  <ion-nav-buttons side="left">\n    <common-back-button></common-back-button>\n  </ion-nav-buttons>\n  <ion-content class="pagebg">\n    <div class="custom-title">信息通知<span></span>\n    </div>\n    <div class="jumpline">\n      <p>不发通知（2条入库扣一条短信费）</p>\n      <div class="btn-switch">\n        <label class="toggle">\n          <input type="checkbox" ng-model="pageData.custom.noMessage" ng-change="customChanged()">\n          <div class="track">\n            <div class="handle"></div>\n          </div>\n        </label>\n      </div>\n    </div>\n    <div class="ov-hrztline"></div>\n    <div class="jumpline" ng-click="showDelay()">\n      <p>延时发送</p>\n      <i class="ion-ios-arrow-right"></i>\n      <span>{{pageData.curDelay}}</span>\n    </div>\n    <div class="custom-title">自定义录件<span>（根据取件码形式，部分录件功能默认开启）</span>\n    </div>\n    <div class="jumpline" ng-click="showType()">\n      <p>取件码形式</p>\n      <i class="ion-ios-arrow-right"></i>\n      <span>{{pageData.curTypeName}}</span>\n    </div>\n    <div class="ov-hrztline"></div>\n    <div class="jumpline">\n      <p>收件人</p>\n      <div class="btn-switch">\n        <label class="toggle">\n          <input type="checkbox" ng-model="pageData.custom.nameFlag" ng-change="customChanged()">\n          <div class="track">\n            <div class="handle"></div>\n          </div>\n        </label>\n      </div>\n    </div>\n    <div class="ov-hrztline"></div>\n    <div class="jumpline">\n      <p>收件地址</p>\n      <div class="btn-switch">\n        <label class="toggle">\n          <input type="checkbox" ng-model="pageData.custom.addressFlag" ng-change="customChanged()">\n          <div class="track">\n            <div class="handle"></div>\n          </div>\n        </label>\n      </div>\n    </div>\n    <div class="ov-hrztline"></div>\n    <div class="jumpline">\n      <p>备注</p>\n      <div class="btn-switch">\n        <label class="toggle">\n          <input type="checkbox" ng-model="pageData.custom.memoFlag" ng-change="customChanged()">\n          <div class="track">\n            <div class="handle"></div>\n          </div>\n        </label>\n      </div>\n    </div>\n  </ion-content>\n  <div class="popselect" ng-show="pageData.showType" ng-click="hideType()">\n    <div class="list" data-tap-disabled="{{isiOS}}">\n      <label class="item item-radio" ng-repeat="item in pageData.codeTypes track by item.type">\n        <input type="radio" name="codeType" ng-model="pageData.custom.codeType" ng-value="item.type" ng-change="typeChanged(item)">\n        <div class="radio-content">\n          <div class="item-content">\n            {{::item.name}}\n          </div>\n          <i class="iconselect ion-checkmark-round" ng-class="pageData.custom.codeType === item.type ?\'displayblock\':\'\'"></i>\n        </div>\n      </label>\n    </div>\n  </div>\n  <div class="popselect" ng-show="pageData.showDelay" ng-click="hideDelay()">\n    <div class="list" data-tap-disabled="{{isiOS}}">\n      <label class="item item-radio" ng-repeat="item in pageData.delayList track by item.value">\n        <input type="radio" name="delayed" ng-model="pageData.custom.delay" ng-value="item.value" ng-change="delayChanged(item)">\n        <div class="radio-content">\n          <div class="item-content">\n            {{::item.name}}\n          </div>\n          <i class="iconselect ion-checkmark-round" ng-class="pageData.custom.delay === item.value ?\'displayblock\':\'\'"></i>\n        </div>\n      </label>\n    </div>\n  </div>\n</ion-view>\n'),$templateCache.put("main/failedMsge.html",'<ion-view title="失败短信"  hide-back-button="true">\n  <ion-nav-buttons side="left">\n    <common-back-button></common-back-button>\n  </ion-nav-buttons>\n  <ion-nav-buttons side="right">\n    <span class="title-right-btn" ng-show="messList.length" ng-click="emptyAll()">清空</span>\n  </ion-nav-buttons>\n  <ion-content class="pagebg" style="padding-top:16px;">\n    <ion-refresher pulling-text="下拉刷新" on-refresh="initListPool()" immediate-check="false"></ion-refresher>\n    <div class="failed-list" ng-repeat="item in messList track by item.id">\n      <div class="ware-title">\n        <h1>{{::item.order.proxyName}}</h1>\n      </div>\n      <div class="ware-orderno">\n        <img ng-src={{::wrapEXpImg(item.order.express.id)}}>\n        <h1>{{::item.order.express.name}}</h1>\n        <p>{{::item.order.orderNo}}</p>\n      </div>\n      <div class="ware-con" ng-switch="item.status">\n        <p style="overflow:inherit;">收<i style="padding-left:.5em"></i>件<i style="padding-left:.5em"></i>人：\n          <span class="phone-list" ng-click="showPhoneAction(item)">{{::item.order.phone}}\n              <span class="phone-listbox" ng-show="item.order.showPhoneAct">\n                <span class="phone-list-option" ng-click="dialog(item.order.phone)">致电收件人</span>\n                <span class="phone-list-option" ng-click="copyPhoneToClipboard(item.order.phone)">复制号码</span>\n                <span class="phone-list-option">取消</span>\n                <span class="phone-list-triangle"><span class="phone-list-triangle-w"></span></span>\n              </span>\n            </span>\n          <span>&nbsp;&nbsp;{{::item.order.name}}</span>\n          <span class="ware-sendout" ng-class="{\'ware-sendout-m\' : item.order.sendType == \'sms\', \'ware-sendout-n\': item.order.sendType == \'nosend\'}"></span>\n        </p>\n        <p>发送时间：<span class="colorgray">{{::item.createTime | subStringFormat:0:16}}</span></p>\n        <div class="info-conbox">\n          <div class="info-open" ng-click="showMess(item)"><span>通知消息<span class="info-con-open" ng-class="{\'info-con-close\': item.showMess}"></span></span></div>\n          <div ng-show="item.showMess">\n            <div class="ware-conline"><p>发送时间：<span>{{::item.createTime | subStringFormat:0:16}}</span></p><p>{{::item.status | messStatus}}</p></div>\n            <div class="ware-conline"><p>报告时间：<span>{{::item.updateTime | subStringFormat:0:16}}</span></p><p>{{::item.code}}</p></div>\n            <p ng-if="item.message"><span>{{::item.message}}</span></p>\n          </div>\n        </div>\n      </div>\n      <div class="failed-btnbox">\n        <button ng-click="resend(item.id, $index)">重新发送</button>\n        <button ng-click="dialog(item.phone)">致电收件人</button>\n        <button ng-click="deleteFailSMS(item.id, $index)">删除</button>\n      </div>\n    </div>\n    <not-found-data-v2 ng-show="!messList.length"></not-found-data-v2>\n    <ion-infinite-scroll\n      ng-if="hasMore"\n      icon="ion-loading-c"\n      immediate-check="false"\n      on-infinite="loadMore()"\n      distance="20%">\n    </ion-infinite-scroll>\n  </ion-content>\n</ion-view>\n'),$templateCache.put("main/inputPhone.html",'<ion-view view-title="手机批量" hide-back-button="true">\n  <ion-nav-buttons side="left" >\n    <common-back-button></common-back-button>\n  </ion-nav-buttons>\n  <ion-nav-buttons side="right">\n    <span class="title-right-btn" ui-sref="custom">自定义</span>\n  </ion-nav-buttons>\n  <ion-content class="pagebg">\n    <ion-refresher pulling-text="下拉刷新" on-refresh="pullRefresh()" immediate-check="false"></ion-refresher>\n    <show-batch-res options="pd.batchResOptions"></show-batch-res>\n    <div class="">\n      <div class="jumpline">\n        <p>派到代收站点</p>\n        <div class="btn-switch">\n          <label class="toggle">\n            <input type="checkbox" ng-model="pd.custom.sendProxy" ng-change="sendProxyChanged()">\n            <div class="track">\n              <div class="handle"></div>\n            </div>\n          </label>\n        </div>\n      </div>\n      <div class="inputline" ng-click="showExpress()">\n        <div class="inputbox"><p>{{pd.express}}</p></div>\n        <div class="iconbox"><i class="ion-android-arrow-dropdown"></i></div>\n      </div>\n      <div class="inputline" ng-show="pd.custom.sendProxy" ng-click="showProxyList()">\n        <div class="inputbox"><p>{{pd.proxyName}}</p></div>\n        <div class="iconbox"><i class="ion-android-arrow-dropdown"></i></div>\n      </div>\n      <div class="inputline" style="overflow:visible;">\n        <div class="inputbox"><input type="tel" placeholder="手机号码(或后四位自动匹配)" ng-model="pm.phone"  ng-model-options="{debounce: 200}" ng-change="phoneChanged()" maxlength="11"/></div>\n        <div class="iconbox">\n          <img src="img/scan.png" ng-click="startScan()">\n          <img src="img/voice.png" ng-click="startListenPhone()">\n        </div>\n        <div class="deli-number" ng-show="pd.showMatchPhones">\n          <p ng-click="choosePhone(item)" ng-repeat="item in pd.matchPhones track by item">{{::item}}</p>\n        </div>\n        <div style="clear:both"></div>\n      </div>\n      <div class="ware-prompt" ng-show="pd.phoneList.length > 0">共录入<span class="colorred">{{pd.phoneList.length}}</span>个手机号码</div>\n      <div class="pnipt-listbox">\n        <div class="pnipt-list" ng-repeat="item in pd.phoneList">\n          <img class="pnipt-ex" ng-src="{{::wrapEXpImg(item.expressId)}}" ng-if="item.expressId != undefined && item.expressId != null">\n          <div class="pnipt-text">{{::item.phone}}</div>\n          <img class="pnipt-img" src="img/number-old.png" ng-if="item.type == 0">\n          <img class="pnipt-img" src="img/number-new.png" ng-if="item.type == 1">\n          <img class="pnipt-img" src="img/number-repeat.png" ng-if="item.isRepeat">\n          <img class="pnipt-delete" src="img/delete.png" ng-click="removePhone(item, $index)">\n        </div>\n      </div>\n      <div class="home-example">\n        <div class="home-example-title"><h1>短信示例：</h1><p ui-sref="template">选择模版</p></div>\n        <div class="home-example-cont">{{pd.sign}}{{pd.smsContent}}</div>\n      </div>\n      <div class="recip-note">\n        <div class="recip-noteline">剩余金额：<span class="colororange">{{pd.balance}}</span>元<div class="recip-recharge" ng-click="goPay()">充值</div><div class="recip-recharge" ng-click="pullRefresh()">刷新</div></div>\n      </div>\n      <div class="recip-tips" ng-if="pd.custom.noMessage || (pd.custom.delay !==undefined && pd.custom.delay !== null && pd.custom.delay > 0)">通知状态：<span class="colorred" ng-if="pd.custom.noMessage">只入库，不发通知；</span><span class="colorred" ng-if="pd.custom.delay !==undefined && pd.custom.delay !== null && pd.custom.delay > 0 && pd.custom.noMessage ==false">入库{{::pd.custom.delay}}分钟后发送通知</span></div>\n      <div class="recip-tips"><span class="colorred">注意：<br/>1）、短信通知每条按5分计费；<br/>2）、微信通知免费，须收件人先关注【代收英雄】公众号；<br/>3）、不发通知，每入库两次扣除一条短信通知费用</span></div>\n    </div>\n  </ion-content>\n  <button class="blacklist-btn" ng-click="phoneIn()">一键发送</button>\n  <div class="popselect" ng-show="pd.showExpress" ng-click="hideExpress()">\n    <div class="list" data-tap-disabled="{{isiOS}}">\n      <label class="item item-radio" ng-repeat="item in pd.bindExpress track by item.id">\n        <input type="radio" name="express" ng-model="pm.expressId" ng-value="item.id"  ng-change="expressChanged(item)">\n        <div class="radio-content">\n          <div class="item-content recip-eximg">\n            <img ng-src={{::wrapEXpImg(item.id)}}><p>{{::item.name}}</p>\n          </div>\n          <i class="iconselect ion-checkmark-round" ng-class="pm.expressId === item.id ?\'displayblock\':\'\'"></i>\n        </div>\n      </label>\n    </div>\n  </div>\n  <div class="popselect" ng-show="pd.showProxyList" ng-click="hideProxyList()">\n    <div class="list">\n      <label class="item item-radio" ng-repeat="item in pd.bindProxy track by item.id">\n        <input type="radio" name="proxy" ng-model="pm.proxyId" ng-value="item.id" ng-change="proxyChanged(item)">\n        <div class="radio-content">\n          <div class="item-content recip-eximg">\n            <p>{{::item.name}}</p>\n          </div>\n          <i class="iconselect ion-checkmark-round" ng-class="pm.proxyId === item.id ?\'displayblock\':\'\'"></i>\n        </div>\n      </label>\n    </div>\n  </div>\n</ion-view>\n\n'),$templateCache.put("main/manualInput.html",'<ion-view view-title="手动入库" hide-back-button="true">\n  <ion-nav-buttons side="left" >\n    <common-back-button></common-back-button>\n  </ion-nav-buttons>\n  <ion-nav-buttons side="right">\n    <span class="title-right-btn" ui-sref="custom">自定义</span>\n  </ion-nav-buttons>\n  <ion-content class="pagebg">\n    <ion-refresher pulling-text="下拉刷新" on-refresh="pullRefresh()" immediate-check="false"></ion-refresher>\n    <div class="">\n      <div class="jumpline">\n        <p>派到代收站点</p>\n        <div class="btn-switch">\n          <label class="toggle">\n            <input type="checkbox" ng-model="pd.custom.sendProxy" ng-change="sendProxyChanged()">\n            <div class="track">\n              <div class="handle"></div>\n            </div>\n          </label>\n        </div>\n      </div>\n      <div class="inputline" ng-click="showExpress()">\n        <div class="inputbox"><p>{{pd.express}}</p></div>\n        <div class="iconbox"><i class="ion-android-arrow-dropdown"></i></div>\n      </div>\n      <div class="inputline" ng-show="pd.custom.sendProxy" ng-click="showProxyList()">\n        <div class="inputbox"><p>{{pd.proxyName}}</p></div>\n        <div class="iconbox"><i class="ion-android-arrow-dropdown"></i></div>\n      </div>\n      <div class="inputline">\n        <div class="inputbox"><input type="tel" placeholder="请输入快递单号" ng-model="pm.orderNo" maxlength="20"/></div>\n        <div class="iconbox"><img src="img/scan.png" ng-click="orderNoScan()"></div>\n      </div>\n      <div class="inputline" style="overflow:visible;">\n        <div class="inputbox"><input type="tel" placeholder="手机号码(或后四位自动匹配)" ng-model="pm.phone"  ng-model-options="{debounce: 200}" ng-change="phoneChanged()" maxlength="11"/></div>\n        <div class="iconbox">\n          <img src="img/scan.png" ng-click="startScan()">\n          <img src="img/voice.png" ng-click="startListen(\'phone\')">\n          <img src="img/number-old.png" ng-show="newOldType == 0">\n          <img src="img/number-new.png" ng-show="newOldType == 1">\n        </div>\n        <div class="deli-number" ng-show="pd.showMatchPhones">\n          <p ng-click="choosePhone(item)" ng-repeat="item in pd.matchPhones track by item">{{::item}}</p>\n        </div>\n        <div style="clear:both"></div>\n      </div>\n      <div class="inputline" ng-show="pd.custom.nameFlag">\n        <div class="inputprompt">收件人</div>\n        <div class="inputbox"><input type="text" placeholder="请输入收件人姓名" ng-model="pm.name" maxlength="9"/></div>\n        <div class="iconbox"><img src="img/voice.png" ng-click="startListen(\'name\')"></div>\n      </div>\n      <div class="inputline" ng-show="pd.custom.addressFlag">\n        <div class="inputprompt">地址</div>\n        <div class="inputbox"><input type="text" ng-model="pm.address" placeholder="请输入收件人地址"  maxlength="20"/></div>\n        <div class="iconbox"><img src="img/voice.png" ng-click="startListen(\'address\')"></div>\n      </div>\n      <div class="inputline" ng-show="pd.custom.memoFlag">\n        <div class="inputprompt">备注</div>\n        <div class="inputbox"><input type="text" ng-model="pm.memo" placeholder="请输入备注"  maxlength="20"/></div>\n        <div class="iconbox"><img src="img/voice.png" ng-click="startListen(\'memo\')"></div>\n      </div>\n      <div class="home-example">\n        <div class="home-example-title"><h1>短信示例：</h1><p ui-sref="template">选择模版</p></div>\n        <div class="home-example-cont">{{pd.sign}}{{pd.smsContent}}</div>\n      </div>\n      <div class="recip-note">\n        <div class="recip-noteline">剩余金额：<span class="colororange">{{pd.balance}}</span>元<div class="recip-recharge" ng-click="goPay()">充值</div><div class="recip-recharge" ng-click="pullRefresh()">刷新</div></div>\n      </div>\n      <div class="recip-tips" ng-if="pd.custom.noMessage || (pd.custom.delay !==undefined && pd.custom.delay !== null && pd.custom.delay > 0)">通知状态：<span class="colorred" ng-if="pd.custom.noMessage">只入库，不发通知；</span><span class="colorred" ng-if="pd.custom.delay !==undefined && pd.custom.delay !== null && pd.custom.delay > 0 && pd.custom.noMessage ==false">入库{{::pd.custom.delay}}分钟后发送通知</span></div>\n      <div class="btnbox mgn-top40">\n        <button class="login-button button-bg" ng-click="manualIn()">确认录入</button>\n      </div>\n      <div class="recip-tips"><span class="colorred">注意：<br/>1）、短信通知每条按5分计费；<br/>2）、微信通知免费，须收件人先关注【代收英雄】公众号；<br/>3）、不发通知，每入库两次扣除一条短信通知费用</span></div>\n    </div>\n  </ion-content>\n  <div class="popselect" ng-show="pd.showExpress" ng-click="hideExpress()">\n    <div class="list" data-tap-disabled="{{isiOS}}">\n      <label class="item item-radio" ng-repeat="item in pd.bindExpress track by item.id">\n        <input type="radio" name="express" ng-model="pm.expressId" ng-value="item.id" ng-change="expressChanged(item)">\n        <div class="radio-content">\n          <div class="item-content recip-eximg">\n            <img ng-src={{::wrapEXpImg(item.id)}}><p>{{::item.name}}</p>\n          </div>\n          <i class="iconselect ion-checkmark-round" ng-class="pm.expressId === item.id ?\'displayblock\':\'\'"></i>\n        </div>\n      </label>\n    </div>\n  </div>\n  <div class="popselect" ng-show="pd.showProxyList" ng-click="hideProxyList()">\n    <div class="list" data-tap-disabled="{{isiOS}}">\n      <label class="item item-radio" ng-repeat="item in pd.bindProxy track by item.id">\n        <input type="radio" name="proxy" ng-model="pm.proxyId" ng-value="item.id" ng-change="proxyChanged(item)">\n        <div class="radio-content">\n          <div class="item-content recip-eximg">\n            <p>{{::item.name}}</p>\n          </div>\n          <i class="iconselect ion-checkmark-round" ng-class="pm.proxyId === item.id ?\'displayblock\':\'\'"></i>\n        </div>\n      </label>\n    </div>\n  </div>\n</ion-view>\n\n'),$templateCache.put("main/mine.html",'<ion-view title="我的"  hide-back-button="true">\n  <ion-content class="pagebg">\n    <ion-refresher pulling-text="下拉刷新" on-refresh="freshSMSCount()" immediate-check="false"></ion-refresher>\n    <div class="mine-title" ui-sref="recharge">\n      <div class="mine-title-left">\n        <h1>{{::pageData.phone}}</h1>\n        <p>剩余金额：{{pageData.balance || 0}}元</p>\n      </div>\n      <div class="mine-title-right"><p>充值</p><i class="ion-ios-arrow-right"></i></div>\n    </div>\n    <div class="mine-box">\n      <div class="mine-line" ui-sref="courierInformation"><img src="img/mine-info.png"><p>我的资料</p><i class="ion-ios-arrow-right"></i></div>\n      <div class="mine-line" ng-click="goBindExpresssPage()"><img src="img/mine-ex.png"><p>服务快递</p><i class="ion-ios-arrow-right"></i></div>\n      <div class="mine-line" ui-sref="myteam"><img src="img/mine-myteam.png"><p>我的团队</p><i class="ion-ios-arrow-right"></i></div>\n      <div class="mine-line" ui-sref="collectionPoint"><img src="img/mine-collect.png"><p>代收点</p><i class="ion-ios-arrow-right"></i></div>\n      <div class="mine-line" ui-sref="blacklist"><img src="img/mine-blacklist.png"><p>黑名单</p><i class="ion-ios-arrow-right"></i></div>\n    </div>\n    <div class="mine-box">\n      <div class="mine-line" ui-sref="template"><img src="img/mine-template.png"><p>短信模版</p><i class="ion-ios-arrow-right"></i></div>\n    </div>\n    <div class="mine-box">\n      <div class="mine-line" ui-sref="contactUs"><img src="img/mine-contact.png"><p>联系我们</p><i class="ion-ios-arrow-right"></i></div>\n      <div class="mine-line" ui-sref="aboutUs"><img src="img/mine-about.png"><p>关于我们</p><i class="ion-ios-arrow-right"></i></div>\n    </div>\n    <div class="mine-btnbox"><button class="mine-btn" ng-click="signOut(false)">退出登录</button></div>\n  </ion-content>\n</ion-view>\n'),$templateCache.put("main/notify.html",'<ion-view hide-back-button="true" hide-nav-bar="true">\n  <ion-content class="pagebg">\n    <ion-refresher pulling-text="下拉刷新" on-refresh="freshHome()" immediate-check="false"></ion-refresher>\n    <return-reason options="pd.reasonsOption"></return-reason>\n    <div class="home-mainnavbox">\n      <div class="home-mainnav" ui-sref="manualInput"><img src="img/homenav/manualentry.png">\n        <p>手动入库</p></div>\n      <div class="home-mainnav" ui-sref="batchInput"><img src="img/homenav/batch.png">\n        <p>批量扫描</p></div>\n      <div class="home-mainnav" ui-sref="inputPhone"><img src="img/homenav/scan.png">\n        <p>手机批量</p></div>\n      <div class="home-mainnav" ui-sref="sendPieces"><img src="img/homenav/outgoing.png">\n        <p>派件</p></div>\n    </div>\n    <div class="home-statisbox">\n      <div class="home-statis-todaybox">\n        <div class="home-statis-today" ui-sref="index.warehouse"><p>{{pd.todayIn}}</p><h1>今日入库</h1></div>\n        <div class="home-statis-today" ui-sref="sendPieces"><p>{{pd.todayOut}}</p><h1>今日取件</h1></div>\n        <div class="home-statis-today" ui-sref="failedMsge"><p>{{pd.todayReturn}}</p><h1>今日退件</h1></div>\n      </div>\n    </div>\n    <div class="home-list">\n      <div class="stat-chartbox">\n        <div class="stat-chart-title">7天派件</div>\n        <div class="stat-chart">\n          <canvas class="chart chart-bar" chart-data="pd.day7data" chart-colors="pd.colors" chart-labels="pd.labels" chart-series="series"></canvas>\n        </div>\n      </div>\n      <div class="home-record">————最新入库————</div>\n      <div class="home-order" ng-repeat="item in pd.inList track by item.id">\n        <div class="ware-title">\n          <h1>{{::item.proxyName}}</h1>\n          <div  ng-switch="item.status">\n            <div ng-switch-when="In" class="ware-stat colororange">待取件</div>\n            <div ng-switch-when="Out" class="ware-stat colorgreen">已取件</div>\n            <div ng-switch-when="Return" class="ware-stat">已退件</div>\n          </div>\n        </div>\n        <div class="ware-orderno">\n          <img ng-src={{::wrapEXpImg(item.express.id)}}>\n          <h1>{{::item.express.name}}</h1>\n          <p>{{::item.orderNo}}</p>\n          <span class="ware-sendout" ng-class="{\'ware-sendout-m\' : item.sendType == \'sms\', \'ware-sendout-n\': item.sendType == \'nosend\'}"></span>\n        </div>\n        <div class="ware-con" ng-switch="item.status">\n          <p style="overflow:inherit;">收<i style="padding-left:.5em"></i>件<i style="padding-left:.5em"></i>人：\n            <span ng-if="!item.canShowPhoneAct">{{::item.phone}}\n            </span>\n            <span class="phone-list" ng-if="item.canShowPhoneAct" ng-click="showPhoneAction(item)">{{::item.phone}}\n              <span class="phone-listbox" ng-show="item.showPhoneAct">\n                <span class="phone-list-option" ng-click="dialog(item.phone)">致电收件人</span>\n                <span class="phone-list-option" ng-click="copyPhoneToClipboard(item.phone)">复制号码</span>\n                <span class="phone-list-option">取消</span>\n                <span class="phone-list-triangle"><span class="phone-list-triangle-w"></span></span>\n              </span>\n            </span>\n            <span>&nbsp;&nbsp;{{::item.name}}</span>\n          </p>\n          <p>入库时间：<span class="colorgray">{{::item.inTime | subStringFormat:0:16}}</span></p>\n          <p ng-if="item.address">地<i style="padding-left:2em"></i>址：<span class="colorgray">{{::item.address}}</span></p>\n          <p ng-show="item.memo !==undefined && item.memo !== null && item.memo.length > 0">备<i style="padding-left:2em"></i>注：<span class="colorred">{{::item.memo}}</span></p>\n          <div class="info-conbox" ng-if="item.sendType != \'nosend\'">\n            <div class="info-open" ng-click="showMess(item)"><span>通知消息<span class="info-con-open" ng-class="{\'info-con-close\': item.showMess}"></span></span></div>\n            <div ng-show="item.showMess">\n              <div ng-repeat="messItem in item.notifyMess track by messItem.id" class="ware-conlinebox">\n                <div class="ware-conline"><p>发送时间：<span>{{::messItem.createTime | subStringFormat:0:16}}</span></p><p>{{::messItem.status | messStatus}}</p></div>\n                <div class="ware-conline"><p>报告时间：<span>{{::messItem.reportTime | subStringFormat:0:16}}</span></p><p>{{::messItem.code}}</p></div>\n                <p ng-if="messItem.message"><span>{{::messItem.message}}</span></p>\n              </div>\n            </div>\n          </div>\n          <div class="ware-con-code colorgreen">{{::item.code}}</div>\n        </div>\n        <div class="ware-btn" ng-if="item.status === \'In\' && item.inOwner === \'Courier\'">\n          <button ui-sref="changeOrder({orderInfo:item})">修改快递</button>\n          <button ng-click="deleteOrder(item, $index)">删除快递</button>\n          <div style="clear:both;"></div>\n        </div>\n      </div>\n      <not-found-data-v2 ng-if="!pd.inList.length"></not-found-data-v2>\n    </div>\n  </ion-content>\n  <div class="home-bar"><button  ui-sref="failedMsge">失败短信</button></div>\n</ion-view>\n\n'),$templateCache.put("main/search.html",'<ion-view hide-back-button="true">\n  <ion-nav-title>\n    <ion-header-bar class="item-input-inset" style="padding-left:0;padding-right:0;">\n      <common-back-button></common-back-button>\n      <div class="item-input-wrapper search-input">\n        <input type="tel" placeholder="手机号/快递单号" ng-model="param.content" maxlength="30" ng-change="contentReplace()">\n        <div class="search-iconbox">\n          <img src="img/scan.png" ng-click="scan()">\n          <i ng-show="param.content" ng-click="clearParam(\'content\')" class="icon ion-close-circled"></i>\n        </div>\n      </div>\n      <button class="button button-clear search-btn" ng-click="initListPool()">查询</button>\n    </ion-header-bar>\n  </ion-nav-title>\n  <ion-content class="pagebg">\n    <div class="warehouse">\n      <div class="ware-list" ng-repeat="item in orderList track by item.id">\n        <div class="ware-title" ng-switch="item.status">\n          <h1>{{::item.phone}}</h1>\n          <button class="ware-btn" ng-switch-when="In" ng-click="sureSend(item.id, $index)">完成派件</button>\n          <div class="ware-imgbox" ng-switch-when="Out"></div>\n        </div>\n        <div class="ware-cont">\n          <p ng-if="item.orderNo">快递单号：<span>{{::item.orderNo}}</span></p>\n          <p ng-if="item.code">货号：<span>{{::item.code}}</span></p>\n          <p>通知：<span>{{::item.inTime | subStringFormat:0:16}}</span></p>\n          <p><span>{{::item.remark}}</span></p>\n        </div>\n      </div>\n      <not-found-data data="orderList"></not-found-data>\n    </div>\n    <ion-infinite-scroll\n      ng-if="hasMore"\n      icon="ion-loading-c"\n      immediate-check="false"\n      on-infinite="loadMore()"\n      distance="20%">\n    </ion-infinite-scroll>\n  </ion-content>\n</ion-view>\n'),$templateCache.put("main/sendPieces.html",'<ion-view title="派件" hide-back-button="true">\n  <ion-nav-title>\n    <ion-header-bar class="item-input-inset" style="padding-left:0;padding-right:0;">\n      <button class="button button-clear icon ion-ios-arrow-back" ng-click="goback()"></button>\n      <div class="item-input-wrapper search-input">\n        <input type="text" placeholder="手机号/单号/取件码/姓名" ng-model="param.content" maxlength="30" ng-change="contentReplace()">\n        <div class="search-iconbox">\n          <img src="img/scan.png" ng-click="scan()">\n          <img src="img/voice.png" ng-click="startListen()">\n          <i ng-show="param.content" ng-click="clearParam(\'content\')" class="icon ion-close-circled"></i>\n        </div>\n      </div>\n      <button class="button button-clear search-btn" ng-click="initListPool()">查询</button>\n    </ion-header-bar>\n  </ion-nav-title>\n  <ion-content class="pagebg contenttop94 contentbtm50">\n    <ion-refresher pulling-text="下拉刷新" on-refresh="initListPool()" immediate-check="false"></ion-refresher>\n    <show-proxies options="pageData.proxyOption"></show-proxies>\n    <div class="ware-prompt">已找到<span class="colororange">{{pageData.listTotal}}</span>条记录</div>\n    <div class="sendpsbox">\n      <div class="sendpsbox-userbox">\n        <ul class="list">\n          <li class="item item-checkbox sendps-user" ng-repeat="item in pageData.inList track by item.id">\n            <label class="checkbox sendps-user-input">\n              <input type="checkbox" ng-model="item.checked" ng-change="itemCheckedChange(item)">\n            </label>\n            <div class="sendps-list">\n              <div class="sendps-title">\n                <img class="sendps-title-img" ng-src={{::wrapEXpImg(item.express.id)}}>\n                <div class="sendps-ds">\n                  <h1>{{item.proxyName}}</h1>\n                  <div ng-switch="item.status">\n                    <div class="sendps-stat colororange">待取件</div>\n                  </div>\n                </div>\n                <div class="sendps-nub"><span>{{::item.express.name}}</span>&nbsp;&nbsp;<span>{{::item.orderNo}}</span>\n                </div>\n              </div>\n              <div class="sendps-con">\n                <p>收<i style="padding-left:.5em"></i>件<i style="padding-left:.5em"></i>人：<span>{{::item.phone}}\n                  </span><span>&nbsp;&nbsp;{{::item.name}}</span></p>\n                <p>入库时间：<span class="colorgray">{{::item.inTime | subStringFormat:0:16}}</span></p>\n                <p>取<i style="padding-left:.5em"></i>件<i style="padding-left:.5em"></i>码：<span class="colorgreen">{{::item.code}}</span>\n                </p>\n                <p ng-if="item.address">地<i style="padding-left:2em"></i>址：<span\n                  class="colorgray">{{::item.address}}</span></p>\n                <p ng-show="item.memo !==undefined && item.memo !== null && item.memo.length > 0">备<i\n                  style="padding-left:2em"></i>注：<span class="colorred">{{::item.memo}}</span></p>\n              </div>\n              <div class="ware-btn">\n                <button ng-click="singleOut(item, $index)">派件</button>\n                <div style="clear:both;"></div>\n              </div>\n            </div>\n          </li>\n        </ul>\n      </div>\n    </div>\n    <not-found-data-v2 ng-show="!pageData.inList.length"></not-found-data-v2>\n    <ion-infinite-scroll\n      ng-if="hasMore"\n      icon="ion-loading-c"\n      immediate-check="false"\n      on-infinite="loadMore()"\n      distance="20%">\n    </ion-infinite-scroll>\n  </ion-content>\n  <div class="sendps-btnbox" style="bottom:0px;">\n    <div class="sendps-select item item-checkbox">\n      <label class="checkbox">\n        <input type="checkbox" ng-model="pageData.allCheckedFlag" ng-change="allChanged()">\n      </label>\n      全选\n    </div>\n    <button class="sendps-btn" ng-click="onToProxy()">转移到代收点</button>\n  </div>\n  <div class="three-class">\n    <p ng-click="switchTab(0)"\n       ng-class="{\'colorblue\': (pageData.tabDetailShowFlag && pageData.curTabDetailIndex == 0)}">代收点<i\n      class="ion-arrow-down-b"\n      ng-class="{\'ion-arrow-up-b\': (pageData.tabDetailShowFlag && pageData.curTabDetailIndex == 0)}"></i></p>\n    <p ng-click="switchTab(1)"\n       ng-class="{\'colorblue\': (pageData.tabDetailShowFlag && pageData.curTabDetailIndex == 1)}">\n      {{pageData.curExpTab.val}}<i\n      class="ion-arrow-down-b"\n      ng-class="{\'ion-arrow-up-b\': (pageData.tabDetailShowFlag && pageData.curTabDetailIndex == 1)}"></i></p>\n    <p ng-click="switchTab(2)"\n       ng-class="{\'colorblue\': (pageData.tabDetailShowFlag && pageData.curTabDetailIndex == 2)}">日期<i\n      class="ion-arrow-down-b"\n      ng-class="{\'ion-arrow-up-b\': (pageData.tabDetailShowFlag && pageData.curTabDetailIndex == 2)}"></i></p>\n  </div>\n  <div class="ware-class-choicebg" ng-show="pageData.tabDetailShowFlag" ng-click="tabDetailBgEvent()">\n    <div class="ware-class-choicebox" ng-show="pageData.curTabDetailIndex == 0">\n      <label ng-repeat="item in pageData.proxiesConditon track by item.key">\n        <input ng-model="param.proxyId" ng-value="item.key" type="radio" ng-change="tabDetailChanged(\'Proxy\', item)"\n               style="display:none;">\n        <p>{{::item.val}}</p>\n      </label>\n    </div>\n    <div class="ware-class-choicebox" ng-show="pageData.curTabDetailIndex == 1">\n      <label ng-repeat="item in pageData.expressConditon track by item.key">\n        <input ng-model="param.expressId" ng-value="item.key" type="radio" ng-change="tabDetailChanged(\'Exp\', item)"\n               style="display:none;">\n        <p>{{::item.val}}</p>\n      </label>\n    </div>\n    <div style="position: relative;" ng-show="pageData.curTabDetailIndex == 2">\n      <div class="ware-class-choicebox">\n        <div class="ware-datebox">\n          <div class="stat-datebox">\n            <div class="stat-date floatl" ng-click="showStartDate()"><p>{{param.startDate | date:\'yyyy-MM-dd\'}}</p><img\n              src="img/date.png"></div>\n            <div class="stat-datetext">至</div>\n            <div class="stat-date floatr" ng-click="showEndDate()"><p>{{param.endDate | date:\'yyyy-MM-dd\'}}</p><img\n              src="img/date.png"></div>\n          </div>\n        </div>\n      </div>\n      <div class="ware-check-btnbox">\n        <button class="ware-check-btn" ng-click="resetDate()">重置</button>\n        <button class="ware-check-btn" ng-click="setDate()">确认</button>\n      </div>\n    </div>\n  </div>\n</ion-view>\n'),$templateCache.put("main/statistics.html",'<ion-view title="快递统计"  hide-back-button="true">\n  <ion-content class="pagebg stat-listbox" ng-show="pd.showResult">\n    <ion-refresher pulling-text="下拉刷新" on-refresh="query()" immediate-check="false"></ion-refresher>\n    <div class="stat-filedbox">\n      <div class="stat-exinfobox">\n        <div class="stat-exinfo">\n          <h1 class="colorblue">{{pd.sumResult.totalSum}}</h1>\n          <p>总计</p>\n        </div>\n        <div class="stat-line"></div>\n        <div class="stat-exinfo">\n          <h1 class="colorblue">{{pd.sumResult.outSum}}</h1>\n          <p>已取</p>\n        </div>\n        <div class="stat-line"></div>\n        <div class="stat-exinfo">\n          <h1 class="colorblue">{{pd.sumResult.inSum}}</h1>\n          <p>待取</p>\n        </div>\n        <div class="stat-line"></div>\n        <div class="stat-exinfo">\n          <h1 class="colorblue">{{pd.sumResult.returnSum}}</h1>\n          <p>退回</p>\n        </div>\n      </div>\n    </div>\n    <div class="stat-title">详细数据<span class="colorred floatr">数据更新频率：30分钟</span></div>\n    <div class="stat-list" ng-repeat="item in pd.listData track by item.id" ui-sref="statisticsDetail({proxyId:pm.proxyId, expressId:pm.expressId, date:item.statDay})">\n      <div class="stat-list-date">{{::item.statDayFormat}}</div>\n      <div class="stat-list-info">\n        <div class="stat-list-number">已取：{{::item.outNumber}}</div>\n        <div class="stat-list-number">待取：{{::item.inNumber}}</div>\n        <div class="stat-list-number">退回：{{::item.returnNumber}}</div>\n      </div>\n      <div class="stat-list-snumber"><p>{{::item.totalNumber}}</p><p>合计</p></div>\n      <i class="ion-ios-arrow-right stat-list-icon"></i>\n    </div>\n  </ion-content>\n  <div class="three-class">\n    <p ng-click="switchTab(0)"\n       ng-class="{\'colorblue\': (pd.tabDetailShowFlag && pd.curTabDetailIndex == 0)}">代收点<i\n      class="ion-arrow-down-b"\n      ng-class="{\'ion-arrow-up-b\': (pd.tabDetailShowFlag && pd.curTabDetailIndex == 0)}"></i></p>\n    <p ng-click="switchTab(1)"\n       ng-class="{\'colorblue\': (pd.tabDetailShowFlag && pd.curTabDetailIndex == 1)}">{{pd.curExpTab.val}}<i\n      class="ion-arrow-down-b"\n      ng-class="{\'ion-arrow-up-b\': (pd.tabDetailShowFlag && pd.curTabDetailIndex == 1)}"></i></p>\n    <p ng-click="switchTab(2)"\n       ng-class="{\'colorblue\': (pd.tabDetailShowFlag && pd.curTabDetailIndex == 2)}">日期<i\n      class="ion-arrow-down-b"\n      ng-class="{\'ion-arrow-up-b\': (pd.tabDetailShowFlag && pd.curTabDetailIndex == 2)}"></i></p>\n  </div>\n  <div class="ware-class-choicebg" ng-show="pd.tabDetailShowFlag" ng-click="tabDetailBgEvent()">\n    <div class="ware-class-choicebox" ng-show="pd.curTabDetailIndex == 0">\n      <label ng-repeat="item in pd.proxiesConditon track by item.key">\n        <input ng-model="pm.proxyId" ng-value="item.key" type="radio" ng-change="tabDetailChanged(\'Proxy\', item)"\n               style="display:none;">\n        <p>{{::item.val}}</p>\n      </label>\n    </div>\n    <div class="ware-class-choicebox" ng-show="pd.curTabDetailIndex == 1">\n      <label ng-repeat="item in pd.expressConditon track by item.key">\n        <input ng-model="pm.expressId" ng-value="item.key" type="radio" ng-change="tabDetailChanged(\'Exp\', item)"\n               style="display:none;">\n        <p>{{::item.val}}</p>\n      </label>\n    </div>\n    <div style="position: relative;" ng-show="pd.curTabDetailIndex == 2">\n      <div class="ware-class-choicebox">\n        <div class="ware-datebox">\n          <div class="stat-datebox">\n            <div class="stat-date floatl" ng-click="showStartDate()"><p>{{pm.startDate | date:\'yyyy-MM-dd\'}}</p><img src="img/date.png"></div>\n            <div class="stat-datetext">至</div>\n            <div class="stat-date floatr" ng-click="showEndDate()"><p>{{pm.endDate | date:\'yyyy-MM-dd\'}}</p><img src="img/date.png"></div>\n          </div>\n        </div>\n      </div>\n      <div class="ware-check-btnbox">\n        <button class="ware-check-btn" ng-click="resetDate()">重置</button>\n        <button class="ware-check-btn" ng-click="setDate()">确认</button>\n      </div>\n    </div>\n  </div>\n</ion-view>\n'),$templateCache.put("main/statisticsDetail.html",'<ion-view title="数据详情"  hide-back-button="true">\n  <ion-nav-buttons side="left" >\n    <common-back-button></common-back-button>\n  </ion-nav-buttons>\n  <ion-content class="pagebg statdbox">\n    <ion-refresher pulling-text="下拉刷新" on-refresh="initListPool()" immediate-check="false"></ion-refresher>\n    <div class="statd-list" ng-repeat="item in detailList track by item.id">\n      <div class="statd-title">\n        <div class="statd-ex"><span>{{::item.proxyName}}</span></div>\n      </div>\n      <div class="statd-order-no">\n        <div class="statd-ex"><img ng-src={{::wrapEXpImg(item.express.id)}}><span>{{::item.express.name}}</span></div>\n        <p>{{::item.orderNo}}</p>\n      </div>\n      <div class="statd-cont" ng-switch="item.status">\n        <p>手机号码：<span class="colorblack">{{::item.phone}}</span></p>\n        <p class="textr">入库时间：<span>{{::item.inTime | subStringFormat:0:16}}</span></p>\n        <p>快件状态：<span ng-class="{\'colororange\': item.status == \'In\', \'colorred\': item.status == \'Out\'}">{{::statusFormmat(item.status)}}</span></p>\n        <p class="textr" ng-switch-when="Out">\n        出库时间：<span>{{::item.outTime | subStringFormat:0:16}}</span>\n        </p>\n        <p class="textr" ng-switch-when="Return">\n        退件时间：<span>{{::item.outTime | subStringFormat:0:16}}</span>\n        </p>\n      </div>\n    </div>\n    <not-found-data-v2 ng-show="!detailList.length"></not-found-data-v2>\n    <ion-infinite-scroll\n      ng-if="hasMore"\n      icon="ion-loading-c"\n      immediate-check="false"\n      on-infinite="loadMore()"\n      distance="20%">\n    </ion-infinite-scroll>\n  </ion-content>\n  <div class="statd-prompt">\n    <div class="statd-record">共<span class="colorblue">{{pd.total}}</span>条记录</div>\n    <div class="statd-date" ng-click="showDate()"><span class="colorblue">{{pd.date | date:\'yyyy-MM-dd\'}}</span><i class="ion-ios-arrow-right"></i></div>\n  </div>\n</ion-view>\n'),$templateCache.put("main/warehouse.html",'<ion-view hide-back-button="true">\n  <ion-nav-title>\n    <ion-header-bar class="item-input-inset" style="padding-left:0;padding-right:0;">\n      <div class="item-input-wrapper search-input">\n        <input type="text" placeholder="手机号/单号/姓名" ng-model="param.content" maxlength="30" ng-change="contentReplace()">\n        <div class="search-iconbox">\n          <img src="img/scan.png" ng-click="scan()">\n          <img src="img/voice.png" ng-click="startListen()">\n          <i ng-show="param.content" ng-click="clearParam(\'content\')" class="icon ion-close-circled"></i>\n        </div>\n      </div>\n      <button class="button button-clear search-btn" ng-click="initListPool()">搜索</button>\n    </ion-header-bar>\n  </ion-nav-title>\n  <ion-content class="pagebg contenttop90">\n    <ion-refresher pulling-text="下拉刷新" on-refresh="initListPool()" immediate-check="false"></ion-refresher>\n    <div class="ware-prompt">已找到<span class="colororange">{{pageData.listTotal}}</span>条记录</div>\n    <div class="ware-order" ng-repeat="item in orderList track by item.id">\n      <div class="ware-title">\n        <h1>{{::item.proxyName}}</h1>\n        <div  ng-switch="item.status">\n          <div ng-switch-when="In" class="ware-stat colororange">待取件</div>\n          <div ng-switch-when="Out" class="ware-stat colorgreen">已取件</div>\n          <div ng-switch-when="Return" class="ware-stat">已退件</div>\n        </div>\n      </div>\n      <div class="ware-orderno">\n        <img ng-src={{::wrapEXpImg(item.express.id)}}>\n        <h1>{{::item.express.name}}</h1>\n        <p>{{::item.orderNo}}</p>\n        <span class="ware-sendout" ng-class="{\'ware-sendout-m\' : item.sendType == \'sms\', \'ware-sendout-n\': item.sendType == \'nosend\'}"></span>\n      </div>\n      <div class="ware-con" ng-switch="item.status">\n        <p style="overflow:inherit;">收<i style="padding-left:.5em"></i>件<i style="padding-left:.5em"></i>人：\n          <span ng-if="!item.canShowPhoneAct">{{::item.phone}}\n              </span>\n          <span class="phone-list" ng-if="item.canShowPhoneAct" ng-click="showPhoneAction(item)">{{::item.phone}}\n              <span class="phone-listbox" ng-show="item.showPhoneAct">\n                <span class="phone-list-option" ng-click="dialog(item.phone)">致电收件人</span>\n                <span class="phone-list-option" ng-click="copyPhoneToClipboard(item.phone)">复制号码</span>\n                <span class="phone-list-option">取消</span>\n                <span class="phone-list-triangle"><span class="phone-list-triangle-w"></span></span>\n              </span>\n            </span>\n          <span>&nbsp;&nbsp;{{::item.name}}</span>\n        </p>\n        <p>入库时间：<span class="colorgray">{{::item.inTime | subStringFormat:0:16}}</span></p>\n        <p ng-switch-when="Out">\n          出库时间：<span class="colorgray">{{::item.outTime | subStringFormat:0:16}}</span>\n        </p>\n        <p ng-switch-when="Return">\n          退件时间：<span class="colorgray">{{::item.outTime | subStringFormat:0:16}}</span>\n        </p>\n        <p ng-if="item.address">地<i style="padding-left:2em"></i>址：<span class="colorgray">{{::item.address}}</span></p>\n        <p ng-show="item.memo !==undefined && item.memo !== null && item.memo.length > 0">备<i style="padding-left:2em"></i>注：<span class="colorred">{{::item.memo}}</span></p>\n        <p ng-show="item.status ==\'Out\' && item.outRemark !==undefined && item.outRemark !== null && item.outRemark.length > 0">出库备注：<span class="colorgray">{{::item.outRemark}}</span></p>\n        <div class="info-conbox" ng-if="item.sendType != \'nosend\'">\n          <div class="info-open" ng-click="showMess(item)"><span>通知消息<span class="info-con-open" ng-class="{\'info-con-close\': item.showMess}"></span></span></div>\n          <div ng-show="item.showMess">\n            <div ng-repeat="messItem in item.notifyMess track by messItem.id" class="ware-conlinebox">\n              <div class="ware-conline"><p>发送时间：<span>{{::messItem.createTime | subStringFormat:0:16}}</span></p><p>{{::messItem.status | messStatus}}</p></div>\n              <div class="ware-conline"><p>报告时间：<span>{{::messItem.reportTime | subStringFormat:0:16}}</span></p><p>{{::messItem.code}}</p></div>\n              <p ng-if="messItem.message"><span>{{::messItem.message}}</span></p>\n            </div>\n          </div>\n        </div>\n        <div class="ware-con-code colorgreen">{{::item.code}}</div>\n      </div>\n      <div class="ware-btn" ng-if="item.status === \'In\' && item.inOwner === \'Courier\'">\n        <button ui-sref="changeOrder({orderInfo: item})">修改快递</button>\n        <button ng-click="deleteOrder(item, $index)">删除快递</button>\n        <div style="clear:both;"></div>\n      </div>\n    </div>\n    <not-found-data-v2 ng-if="!orderList"></not-found-data-v2>\n    <ion-infinite-scroll\n      ng-if="hasMore"\n      icon="ion-loading-c"\n      immediate-check="false"\n      on-infinite="loadMore()"\n      distance="20%">\n    </ion-infinite-scroll>\n  </ion-content>\n  <div class="ware-class">\n    <p ng-click="switchTab(0)"\n       ng-class="{\'colorblue\': (pageData.tabDetailShowFlag && pageData.curTabDetailIndex == 0)}">{{pageData.curStatusTab.val}}<i\n      class="ion-arrow-down-b"\n      ng-class="{\'ion-arrow-up-b\': (pageData.tabDetailShowFlag && pageData.curTabDetailIndex == 0)}"></i></p>\n    <p ng-click="switchTab(1)"\n       ng-class="{\'colorblue\': (pageData.tabDetailShowFlag && pageData.curTabDetailIndex == 1)}">代收点<i\n      class="ion-arrow-down-b"\n      ng-class="{\'ion-arrow-up-b\': (pageData.tabDetailShowFlag && pageData.curTabDetailIndex == 1)}"></i></p>\n    <p ng-click="switchTab(2)"\n       ng-class="{\'colorblue\': (pageData.tabDetailShowFlag && pageData.curTabDetailIndex == 2)}">{{pageData.curExpTab.val}}<i\n      class="ion-arrow-down-b"\n      ng-class="{\'ion-arrow-up-b\': (pageData.tabDetailShowFlag && pageData.curTabDetailIndex == 2)}"></i></p>\n    <p ng-click="switchTab(3)"\n       ng-class="{\'colorblue\': (pageData.tabDetailShowFlag && pageData.curTabDetailIndex == 3)}">日期<i\n      class="ion-arrow-down-b"\n      ng-class="{\'ion-arrow-up-b\': (pageData.tabDetailShowFlag && pageData.curTabDetailIndex == 3)}"></i></p>\n  </div>\n  <div class="ware-class-choicebg" ng-show="pageData.tabDetailShowFlag" ng-click="tabDetailBgEvent()">\n    <div class="ware-class-choicebox" ng-show="pageData.curTabDetailIndex == 0">\n      <label ng-repeat="item in pageData.statusConditon track by item.key">\n        <input ng-model="param.status" ng-value="item.key" type="radio" ng-change="tabDetailChanged(\'Status\', item)"\n               style="display:none;">\n        <p>{{::item.val}}</p>\n      </label>\n    </div>\n    <div class="ware-class-choicebox" ng-show="pageData.curTabDetailIndex == 1">\n      <label ng-repeat="item in pageData.proxiesConditon track by item.key">\n        <input ng-model="param.proxyId" ng-value="item.key" type="radio" ng-change="tabDetailChanged(\'Proxy\', item)"\n               style="display:none;">\n        <p>{{::item.val}}</p>\n      </label>\n    </div>\n    <div class="ware-class-choicebox" ng-show="pageData.curTabDetailIndex == 2">\n      <label ng-repeat="item in pageData.expressConditon track by item.key">\n        <input ng-model="param.expressId" ng-value="item.key" type="radio" ng-change="tabDetailChanged(\'Exp\', item)"\n               style="display:none;">\n        <p>{{::item.val}}</p>\n      </label>\n    </div>\n    <div style="position: relative;" ng-show="pageData.curTabDetailIndex == 3">\n      <div class="ware-class-choicebox">\n        <div class="ware-datebox">\n          <div class="ware-dateline">\n            <div class="ware-datetext">开始日期</div>\n            <div class="ware-date" ng-click="showStartDate()"><p>{{param.bgnDate | date:\'yyyy-MM-dd\'}}</p><img\n              src="img/date.png"></div>\n            <div class="ware-time floatr" ng-click="showStartTime()"><p>{{param.bgnDate | date:\'HH:mm\'}}</p><img\n              src="img/time.png"></div>\n          </div>\n          <div class="ware-dateline">\n            <div class="ware-datetext">结束日期</div>\n            <div class="ware-date" ng-click="showEndDate()"><p>{{param.endDate | date:\'yyyy-MM-dd\'}}</p><img\n              src="img/date.png"></div>\n            <div class="ware-time floatr" ng-click="showEndTime()"><p>{{param.endDate | date:\'HH:mm\'}}</p><img\n              src="img/time.png"></div>\n          </div>\n        </div>\n      </div>\n      <div class="ware-check-btnbox">\n        <button class="ware-check-btn" ng-click="resetDate()">重置</button>\n        <button class="ware-check-btn" ng-click="setDate()">确认</button>\n      </div>\n    </div>\n  </div>\n</ion-view>\n'),$templateCache.put("mine/aboutUs.html",'<ion-view view-title="关于我们" hide-back-button="true">\n  <ion-nav-buttons side="left" >\n    <common-back-button></common-back-button>\n  </ion-nav-buttons>\n  <ion-content>\n    <div class="aboutus-share"><img src="img/express_hero_qrcode.png"></div>\n    <div class="aboutus-text">快递英雄V2.01</div>\n    <div class="aboutus-sharetext">扫描二维码即可下载APP</div>\n    <div class="aboutus-share"><img src="img/dshero_qrcode.png"></div>\n    <div class="aboutus-text">代收英雄--代收点端</div>\n    <div class="aboutus-sharetext">扫描二维码即可下载APP</div>\n  </ion-content>\n  <div class="edition">物流最后100米软、硬件方案提供商<br><span>技术来源于天津零工英雄科技有限公司</span></div>\n</ion-view>\n'),$templateCache.put("mine/addAccount.html",'<ion-view view-title="添加成员" hide-back-button="true">\n  <ion-nav-buttons side="left" >\n    <common-back-button></common-back-button>\n  </ion-nav-buttons>\n  <ion-content>\n    <div class="login-input-ul">\n      <div class="login-input-li">\n        <input type="tel" id="subPhone"  placeholder="请输入手机号" class="login-input" ng-model="pm.phone" maxlength="11"/>\n        <i ng-show="pm.phone" ng-click="clearParam(\'phone\')" class="icon ion-close-circled"></i>\n      </div>\n      <div  class="register-code">\n        <input type="tel" id="subCode" placeholder="请输入验证码" class="code-width login-input"  ng-model="pm.code"/>\n        <input type="button" value="{{pd.sendVerifyCodeButton.value}}"  ng-class="{\'disable-bt-bg\':!pd.sendVerifyCodeButton.canClick}" ng-disabled="!pd.sendVerifyCodeButton.canClick" class="code-bt"  ng-click="sendVerifyCode()">\n      </div>\n      <div class="login-input-li">\n        <input type="password" placeholder="请输入6-18位密码" class="login-input" style="top:-3px;" ng-model="pm.password" maxlength="18"/>\n        <i ng-show="pm.password" ng-click="clearParam(\'password\')" class="icon ion-close-circled"></i>\n      </div>\n      <div class="login-input-li">\n        <input type="text" placeholder="请输入姓名" class="login-input" ng-model="pm.name" maxlength="20"/>\n        <i ng-show="pm.name" class="icon ion-close-circled"></i>\n      </div>\n      <div class="login-input-li login-div">\n        <button class="login-button button-bg" ng-click="addSubaccount()">确认添加</button>\n      </div>\n    </div>\n  </ion-content>\n</ion-view>\n'),$templateCache.put("mine/addCollection.html",'<ion-view view-title="添加代收点" hide-back-button="true">\n  <ion-nav-buttons side="left">\n    <common-back-button></common-back-button>\n  </ion-nav-buttons>\n  <ion-content>\n    <div class="dotbox">\n      <div class="login-input-li">\n        <input type="tel" ng-model="pm.phone" placeholder="请输入手机号" class="login-input"  maxlength="11"/>\n        <i ng-show="pm.phone" ng-click="clearParam(\'phone\')" class="icon ion-close-circled"></i>\n      </div>\n      <div  class="register-code">\n        <input type="tel" placeholder="请输入验证码" ng-model="pm.code" class="code-width login-input"/>\n        <input type="button" value="{{pd.sendVerifyCodeButton.value}}"  ng-class="{\'disable-bt-bg\':!pd.sendVerifyCodeButton.canClick}" ng-disabled="!pd.sendVerifyCodeButton.canClick" class="code-bt"  ng-click="sendVerifyCode()">\n      </div>\n      <div class="login-input-li">\n        <input type="text" ng-model="pm.name" placeholder="请输入代收点名称" class="login-input" style="top:-3px;"  maxlength="25" />\n        <i ng-show="pm.name" ng-click="clearParam(\'name\')" class="icon ion-close-circled"></i>\n      </div>\n    </div>\n    <div class="mine-btnbox"><button class="login-button button-bg" ng-click="addProxy()">确认添加</button></div>\n  </ion-content>\n</ion-view>\n'),$templateCache.put("mine/addTemplate.html",'<ion-view hide-back-button="true">\n  <ion-nav-title>\n    <h1 class="title">{{::pd.title}}模板</h1>\n  </ion-nav-title>\n  <ion-nav-buttons side="left" >\n    <common-back-button></common-back-button>\n  </ion-nav-buttons>\n  <ion-content class="pagebg">\n    <ion-refresher pulling-text="下拉刷新" on-refresh="refresh()" immediate-check="false"></ion-refresher>\n    <sms-case options="pd.caseOptions"></sms-case>\n    <sign-agreement options="pd.signAgreementOptions"></sign-agreement>\n    <div class="addtemp-input mgn-btm10">\n      <p>模版名称：</p>\n      <input type="text" placeholder="请输入模版名称" ng-model="pm.title" maxlength="10">\n    </div>\n    <div class="addtemp-textbox">\n      <div class="addtemp-text">\n        <div class="addtemp-textea" id=\'templateContent\' contenteditable="true" style="-webkit-user-select:text"></div>\n        \x3c!--<p class="colorred">当前输入140字，按3条短信计费</p>--\x3e\n      </div>\n    </div>\n    <div class="addtemp-insert">插入：\n      <span class="addtemp-plchd" ng-repeat="item in pd.tags track by item.key" ng-click="chooseTag(item)">{{::item.name}}</span>\n    </div>\n    <div class="btnbox mgn-top40">\n      <button class="login-button button-bg" ng-click="preShow()">预览</button>\n    </div>\n    <div class="btnbox mgn-top20">\n      <button class="login-button button-bg" ng-click="submit()">提交审核</button>\n    </div>\n  </ion-content>\n</ion-view>\n'),$templateCache.put("mine/blacklist.html",'<ion-view view-title="黑名单" hide-back-button="true">\n  <ion-nav-buttons side="left" >\n    <common-back-button></common-back-button>\n  </ion-nav-buttons>\n  <ion-content class="pagebg">\n    <ion-refresher pulling-text="下拉刷新" on-refresh="initListPool()" immediate-check="false"></ion-refresher>\n    <div class="blacklistbox">\n      <div class="blacklist"  ng-repeat="item in blackList track by item.id">\n        <div class="black-textbox">\n          <div class="black-title">{{::item.phone}}</div>\n          <div class="black-cont">{{::item.description}}</div>\n        </div>\n        <div class="black-btnbox"><img src="img/delete.png" ng-click="del(item, $index)"></div>\n      </div>\n    </div>\n    <not-found-data-v2 ng-show="!blackList.length"></not-found-data-v2>\n    <ion-infinite-scroll\n      ng-if="hasMore"\n      icon="ion-loading-c"\n      immediate-check="false"\n      on-infinite="loadMore()"\n      distance="20%">\n    </ion-infinite-scroll>\n  </ion-content>\n  <button class="blacklist-btn" ng-click="goAdd()">添加手机号到黑名单</button>\n</ion-view>\n'),$templateCache.put("mine/collectionPoint.html",'<ion-view view-title="代收点" hide-back-button="true">\n  <ion-nav-buttons side="left">\n    <common-back-button></common-back-button>\n  </ion-nav-buttons>\n  <ion-nav-buttons side="right">\n    <span class="title-right-btn" ui-sref="addCollection">添加</span>\n  </ion-nav-buttons>\n  <ion-content class="pagebg">\n    <ion-refresher pulling-text="下拉刷新" on-refresh="initListPool()" immediate-check="false"></ion-refresher>\n    <div class="ware-prompt">共关注<span class="colororange">{{pd.listTotal}}</span>个代收点</div>\n    <ion-list>\n        <ion-item item="item" class="item-remove-animate clt-line" ng-repeat="item in proxyList track by item.id">\n          <div class="clt-nub"></div>\n          <div class="clt-line-info">\n            <div class="clt-line-title">{{item.name}}</div>\n            <div class="clt-line-phone">{{item.proxy.contactPhone}}</div>\n          </div>\n          <div class="clt-btnbox">\n            <div class="clt-btn colorblue" ui-sref="reviseCollection({proxy:item})">修改</div>\n          </div>\n          <ion-option-button class="button-assertive" ng-click="removeProxy(item, $index)">\n            删除\n          </ion-option-button>\n          <ion-reorder-button class="ion-navicon" on-reorder=""></ion-reorder-button>\n        </ion-item>\n      </ion-list>\n  </ion-content>\n</ion-view>\n'),$templateCache.put("mine/contactUs.html",'<ion-view view-title="联系我们" hide-back-button="true">\n  <ion-nav-buttons side="left" >\n    <common-back-button></common-back-button>\n  </ion-nav-buttons>\n  <ion-content class="pagebg">\n    <div class="">\n    \t<div class="contactus-img"><img src="img/logoimg.png"></div>\n    \t<div class="jumpline" ng-click="dialog()"><p>联系电话</p><span class="colorblue" style="text-decoration:underline;">{{::pageData.phone}}</span></div>\n      <div class="jumpline"><p>QQ</p><span>746894798</span></div>\n      \x3c!-- <div class="jumpline"><p>微信公众号</p><span>微信搜索“零工英雄”</span></div> --\x3e\n      <div class="jumpline mgn-btm20"><p>邮箱</p><span>kf@onfreework.com</span></div>\n      <div class="jumpline" ui-sref="cooperation">\n        <p>商业合作</p><i class="ion-ios-arrow-right"></i>\n      </div>\n      \x3c!-- <div class="jumpline" ui-sref="userAgreement">\n        <p>服务协议</p><i class="ion-ios-arrow-right"></i>\n      </div>\n    \t<div class="contact-note">关注零工英雄微信，QQ，邮箱，参与讨论，即时获取零工英雄最新动态，还有机会获得奖品哦～</div> --\x3e\n    </div>\n  </ion-content>\n</ion-view>\n'),$templateCache.put("mine/cooperation.html",'<ion-view view-title="商业合作" hide-back-button="true">\n  <ion-nav-buttons side="left" >\n    <common-back-button></common-back-button>\n  </ion-nav-buttons>\n  <ion-content class="pagebg">\n    <div>\n    \t<div class="coop-line"><p>联系人</p><input type="text" placeholder="请填写联系人姓名(必填)" ng-model="param.linkman" maxlength="20" class="floatr textr"></div>\n    \t<div class="coop-line"><p>联系电话</p><input type="tel" placeholder="请填写联系人电话(必填)" ng-model="param.phone" maxlength="11" class="floatr textr"></div>\n    \t<div class="coop-line"><p>公司名称</p><input type="text" placeholder="请填写您的公司名称"  ng-model="param.company" maxlength="20" class="floatr textr"></div>\n    \t<div class="mgn-btm20 coop-line"><p>公司地址</p><input type="text" placeholder="请填写您公司的地址"  ng-model="param.address" maxlength="100" class="floatr textr"></div>\n    \t<div class="universal"><p>合作说明</p>\n      \t\t<textarea class="text_textarea" placeholder="请输入您想要合作的内容（10-500字之间）" ng-model="param.remark" maxlength="500"></textarea>\n          <p class="text-prompt">已输入{{param.remark.length || 0}}/500个字</p>\n    \t</div>\n      <div class="btnbox mgn-top40">\n        <button class="login-button button-bg" ng-click="goSubmit()">提交</button>\n      </div>\n    </div>\n  </ion-content>\n</ion-view>\n'),$templateCache.put("mine/courierInformation.html",'<ion-view title="我的资料"  hide-back-button="true">\n  <ion-nav-buttons side="left">\n    <common-back-button></common-back-button>\n  </ion-nav-buttons>\n  <ion-content>\n    <div class="courierbox">\n      <div class="register-addressbox">\n      <div class="register-address floatl" ng-click="showArea(\'Province\')"><p>{{pd.curProvince || \'请选择\'}}</p><i class="ion-android-arrow-dropdown"></i></div>\n        <div class="register-address floatr" ng-click="showArea(\'City\')"><p>{{pd.curCity || \'请选择\'}}</p><i class="ion-android-arrow-dropdown"></i></div>\n      </div>\n      <div class="login-input-li">\n        <input type="text" placeholder="请输入您的姓名" ng-model="pm.name" maxlength="18" class="login-input" style="top:-3px;"/>\n        <i ng-show="pm.name" ng-click="clearParam(\'name\')" class="icon ion-close-circled"></i>\n      </div>\n      <div class="login-input-li">\n        <input type="tel" placeholder="请输入您的联系电话" ng-model="pm.contacts" maxlength="11" class="login-input" style="top:-3px;"/>\n        <i ng-show="pm.contacts" ng-click="clearParam(\'contacts\')" class="icon ion-close-circled"></i>\n      </div>\n    </div>\n    <div class="mine-btnbox"><button class="login-button button-bg" ng-click="save()">保存</button></div>\n  </ion-content>\n  <div class="popselect" ng-show="pd.showProvince" ng-click="hideArea(\'Province\')">\n    <div class="list" data-tap-disabled="{{isiOS}}">\n      <label class="item item-radio">\n        <div class="radio-content">\n          <div class="item-content popse-title">\n            省\n          </div>\n        </div>\n      </label>\n      <label class="item item-radio" ng-repeat="item in pd.provinces track by item.id">\n        <input type="radio" ng-model="pm.province" ng-value="item.id" ng-change="provinceChanged(item)">\n        <div class="radio-content">\n          <div class="item-content">\n            {{::item.regionName}}\n          </div>\n          <i class="iconselect ion-checkmark-round" ng-class="pm.province === item.id ?\'displayblock\':\'\'"></i>\n        </div>\n      </label>\n    </div>\n  </div>\n  <div class="popselect" ng-show="pd.showCity" ng-click="hideArea(\'City\')">\n    <div class="list" data-tap-disabled="{{isiOS}}">\n      <label class="item item-radio">\n        <div class="radio-content">\n          <div class="item-content popse-title">\n            市\n          </div>\n        </div>\n      </label>\n      <label class="item item-radio" ng-repeat="item in pd.cities track by item.id">\n        <input type="radio"  ng-model="pm.city" ng-value="item.id" ng-change="cityChanged(item)">\n        <div class="radio-content">\n          <div class="item-content">\n            {{::item.regionName}}\n          </div>\n          <i class="iconselect ion-checkmark-round" ng-class="pm.city === item.id ?\'displayblock\':\'\'"></i>\n        </div>\n      </label>\n    </div>\n  </div>\n</ion-view>\n'),$templateCache.put("mine/forgetPwds.html",'<ion-view title="找回密码"  hide-back-button="true">\n  <ion-nav-buttons side="left">\n    <common-back-button></common-back-button>\n  </ion-nav-buttons>\n  <ion-nav-buttons side="right">\n    <span class="title-right-btn" ui-sref="register">注册</span>\n  </ion-nav-buttons>\n  <ion-content>\n    <div class="login-input-ul">\n      <div class="login-input-li">\n        <input type="tel" id="resetPhone" placeholder="请输入手机号" class="login-input" ng-model="param.phone" maxlength="11"/>\n        <i ng-show="param.cellphone" ng-click="clearParam(\'cellphone\')" class="icon ion-close-circled"></i>\n      </div>\n      <div  class="register-code">\n        <input type="tel" id="resetCode" placeholder="请输入验证码" class="code-width login-input" ng-model="param.code"/>\n        <input type="button" value="{{pageData.sendVerifyCodeButton.value}}"  ng-class="{\'disable-bt-bg\':!pageData.sendVerifyCodeButton.canClick}" ng-disabled="!pageData.sendVerifyCodeButton.canClick" class="code-bt" ng-click="sendVerifyCode()"/>\n      </div>\n      <div class="login-input-li">\n        <input type="password" placeholder="请输入6-18位密码" class="login-input" ng-model="param.newpsd" maxlength="18"/>\n        <i ng-show="param.newpsd" ng-click="clearParam(\'newpsd\')" class="icon ion-close-circled"></i>\n      </div>\n      <div class="login-input-li login-div">\n        <button class="login-button button-bg" ng-click="goReset()">提交</button>\n      </div>\n    </div>\n  </ion-content>\n</ion-view>\n'),$templateCache.put("mine/guide.html",'<ion-view hide-back-button="true" hide-nav-bar="true">\n  <div class="banner2" style="width:100% !important;height:100% !important;">\n    <ion-slide-box active-slide="indexEffect"  animation="slide-left-right-ios7" does-continue="false" style="height: 100%;width: 100%;">\n      <ion-slide ng-repeat="effect in effects" ng-if="$index<5">\n        <img class="guide-img" ng-src="{{effect.url}}">\n      </ion-slide>\n    </ion-slide-box>\n  </div>\n  <button class="guide-but" type="button" ng-click="goProject()">进入应用</button>\n</ion-view>\n'),$templateCache.put("mine/login.html",'<ion-view hide-nav-bar="true" hide-back-button="true">\n<div class="iostopposition"></div>\n  <ion-nav-buttons side="right">\n  </ion-nav-buttons>\n  <ion-content class="loginbox special">\n    <div class="logo"><img src="img/logoimg.png" class="logo_img"/></div>\n    <div class="toggle_bg">快递英雄</div>\n    <div>\n      <ul class="login-input-ul">\n        <li class="login-input-li">\n          <input type="tel" class="login-input" placeholder="请输入手机号" maxlength="11" ng-model="param.loginName" />\n          <i ng-show="param.loginName" ng-click="clearParam(\'loginName\')" class="icon ion-close-circled"></i>\n        </li>\n        <li class="login-input-li">\n          <input class="login-input" type="password" placeholder="请输入密码"  ng-model="param.password" maxlength="18"/>\n          <i ng-show="param.password" ng-click="clearParam(\'password\')" class="icon ion-close-circled"></i>\n        </li>\n        <div class="login-forget"><p class="forget-pw-p" ui-sref="forgetPwds">忘记密码?</p></div>\n        <div class="login-input-li login-div" style="margin-top:40px;">\n          <button class="login-button button-bg" ng-click="accountSignin()">登录</button>\n        </div>\n        <div class="login-input-li login-div" style="margin-top:20px;">\n          <button class="login-button-register" ui-sref="register">新用户注册</button>\n        </div>\n        \x3c!-- <div class="login-prompt">提供专业快递代收管理服务</div> --\x3e\n      </ul>\n    </div>\n  </ion-content>\n</ion-view>\n'),$templateCache.put("mine/messageCenter.html",'<ion-view title="消息中心"  hide-back-button="true">\n  <ion-nav-buttons side="left">\n    <common-back-button></common-back-button>\n  </ion-nav-buttons>\n  <ion-content class="pagebg">\n    <div class="messagebox">\n      <div class="message-list">\n        <div class="message-title"><h1>消息来自：代收英雄</h1><p>3-15&nbsp;10:36</p></div>\n        <div class="message-cont">恭喜您已经成功完成首充任务，获得50条短信积分</div>\n      </div>\n    </div>\n  </ion-content>\n</ion-view>\n'),$templateCache.put("mine/myteam.html",'<ion-view view-title="我的团队" hide-back-button="true">\n  <ion-nav-buttons side="left">\n    <common-back-button></common-back-button>\n  </ion-nav-buttons>\n  <ion-nav-buttons side="right">\n    <span class="title-right-btn" ui-sref="addAccount">添加</span>\n  </ion-nav-buttons>\n  <ion-content class="pagebg">\n    <ion-refresher pulling-text="下拉刷新" on-refresh="initListPool()" immediate-check="false"></ion-refresher>\n    <div class="ware-prompt">共有<span class="colororange">{{pd.listTotal}}</span>个队员</div>\n    <div class="acut-box">\n      <div class="acut-list">\n        <div class="acut-line" ng-repeat="item in pd.subaccounts track by item.id">\n          <div class="acut-nub" ng-class="{\'acut-nubpm\' : item.isMaster}"></div>\n          <div class="acut-line-title"><h1>{{::item.phone}}</h1><p>{{::item.nick}}</p></div>\n          <div class="acut-btnbox" ng-if="item.isMaster !=1"><button class="acut-btn colorblue" ui-sref="reviseAccount({account:item})">修改</button><button class="acut-btn colorred"  ng-click="removeAccount(item, $index)">删除</button></div>\n        </div>\n      </div>\n    </div>\n  </ion-content>\n</ion-view>\n'),$templateCache.put("mine/paySuccess.html",'<ion-view view-title="支付成功" hide-back-button="true">\n  <ion-content style="background-color:#fff;">\n  \t<div class="paysuccess">\n  \t\t<img src="img/pay.png">\n  \t\t<p>支付成功</p>\n  \t\t<button ng-click="finish()">完成</button>\n  \t</div>\n  </ion-content>\n</ion-view>\n'),$templateCache.put("mine/payment.html",'<ion-view title="支付费用"  hide-back-button="true">\n  <ion-nav-buttons side="left">\n    <common-back-button></common-back-button>\n  </ion-nav-buttons>\n  <ion-nav-buttons side="right">\n    <span class="title-right-btn" ng-click="showAgreement()">协议</span>\n  </ion-nav-buttons>\n  <ion-content class="pagebg">\n    <sign-agreement options="pd.signAgreementOptions"></sign-agreement>\n    <div class="pay-prompt">修改签名需支付修改费用<p>￥<span>{{::pd.payMoney}}</span></p></div>\n    <div class="addtemp-input mgn-btm10">\n      <p>修改签名：</p>\n      <input type="text" placeholder="请输入新的签名" ng-model="pm.newSign" maxlength="8">\n    </div>\n    <div class="rech-title">支付方式</div>\n    <div class="rech-mode">\n      <label>\n        <div class="sign-people">\n          <input ng-model="pm.payType" ng-value="2" type="radio">\n          <img src="img/rech-wechat.png">\n          <p>微信</p>\n          <span></span>\n        </div>\n      </label>\n      <label>\n        <div class="sign-people" >\n          <input ng-model="pm.payType" ng-value="1" type="radio">\n          <img src="img/rech-alipay.png">\n          <p>支付宝</p>\n          <span></span>\n        </div>\n      </label>\n    </div>\n    <div class="mine-btnbox"><button class="login-button button-bg" ng-click="goCharge()">去支付</button></div>\n  </ion-content>\n</ion-view>\n'),$templateCache.put("mine/recharge.html",'<ion-view title="充值"  hide-back-button="true">\n  <ion-nav-buttons side="left">\n    <common-back-button></common-back-button>\n  </ion-nav-buttons>\n  <ion-content>\n    <ion-refresher pulling-text="下拉刷新" on-refresh="freshSMSCount()" immediate-check="false"></ion-refresher>\n    <div class="rech-message">剩余金额：<span>{{pageData.balance || 0}}</span>元</div>\n    <div class="rech-price">\n      <label ng-repeat="item in pageData.chargeList track by item.id">\n        <input type="radio" name="buyType" ng-model="param.curChargeId" ng-value="item.id">\n        <span>\n          <span class="rech-price-nub">充{{::item.payMoney}}元</span>\n          <span class="rech-price-money" ng-if="item.giveMoney > 0">赠送{{::item.giveMoney}}元</span>\n          <span class="rech-price-money" ng-if="item.giveMoney <= 0">&nbsp;</span>\n        </span>\n      </label>\n    </div>\n    <div class="rech-title">支付方式</div>\n    <div class="rech-mode">\n      <label>\n        <div class="sign-people">\n          <input ng-model="param.payType" ng-value="2" type="radio">\n          <img src="img/rech-wechat.png">\n          <p>微信</p>\n          <span></span>\n        </div>\n      </label>\n      <label>\n        <div class="sign-people" >\n          <input ng-model="param.payType" ng-value="1" type="radio">\n          <img src="img/rech-alipay.png">\n          <p>支付宝</p>\n          <span></span>\n        </div>\n      </label>\n    </div>\n    <div class="mine-btnbox"><button class="login-button button-bg" ng-click="goCharge()">充值</button></div>\n  </ion-content>\n</ion-view>\n'),$templateCache.put("mine/register.html",'<ion-view title="注册"  hide-back-button="true">\n  <ion-nav-buttons side="left">\n    <common-back-button></common-back-button>\n  </ion-nav-buttons>\n  <ion-content>\n    <div class="login-input-ul">\n      <div class="login-input-li">\n        <input type="tel" id="registePhone" placeholder="请输入手机号" class="login-input" ng-model="param.phone" maxlength="11"/>\n        <i ng-show="param.cellphone" ng-click="clearParam(\'cellphone\')" class="icon ion-close-circled"></i>\n      </div>\n      <div class="login-input-li">\n        <input type="password" placeholder="请输入6-18位密码" class="login-input" style="top:-3px;" ng-model="param.password" maxlength="18"/>\n        <i ng-show="param.password" ng-click="clearParam(\'password\')" class="icon ion-close-circled"></i>\n      </div>\n      <div class="register-code">\n        <input type="tel" id="code" placeholder="请输入短信验证码" class="login-input" ng-model="param.code"/>\n        <input type="button" value="{{pageData.sendVerifyCodeButton.value}}"  ng-class="{\'disable-bt-bg\':!pageData.sendVerifyCodeButton.canClick}" ng-disabled="!pageData.sendVerifyCodeButton.canClick" class="code-bt" ng-click="sendVerifyCode()"/>\n      </div>\n      <div class="register-addressbox">\n        <div class="register-address floatl" ng-click="showArea(\'Province\')"><p>{{pageData.curProvince || \'请选择省份\'}}</p><i class="ion-android-arrow-dropdown"></i></div>\n        <div class="register-address floatr" ng-click="showArea(\'City\')"><p>{{pageData.curCity || \'请选择城市\'}}</p><i class="ion-android-arrow-dropdown"></i></div>\n      </div>\n      <div class="login-input-li register-expres" ng-click="showArea(\'Exp\')"><p class="floatl">所属快递</p><i class="ion-android-arrow-dropdown floatr"></i><span class="floatr">{{pageData.curExpressName}}</span></div>\n      <div class="login-input-li">\n        <input type="text" placeholder="请输入您的姓名" ng-model="param.name" maxlength="18" class="login-input" style="top:-3px;"/>\n        <i ng-show="param.address" ng-click="clearParam(\'name\')" class="icon ion-close-circled"></i>\n      </div>\n      <div class="login-input-li">\n        <input type="tel" placeholder="请输入您的联系电话" ng-model="param.contacts" maxlength="11" class="login-input" style="top:-3px;"/>\n        <i ng-show="param.contacts" ng-click="clearParam(\'contacts\')" class="icon ion-close-circled"></i>\n      </div>\n      <div class="login-input-li login-div" style="margin-top:20px;">\n        <button class="login-button button-bg" ng-click="goRegister()">注册</button>\n      </div>\n      \x3c!--<div class="agreement">注册即表示您已同意<span ui-sref="userAgreement">《零工英雄服务协议》</span></div>--\x3e\n    </div>\n  </ion-content>\n  <div class="popselect" ng-show="pageData.showProvince" ng-click="hideArea(\'Province\')">\n      <div class="list" data-tap-disabled="{{isiOS}}">\n        <label class="item item-radio">\n          <div class="radio-content">\n            <div class="item-content popse-title">\n              省\n            </div>\n          </div>\n        </label>\n        <label class="item item-radio" ng-repeat="item in pageData.provinces track by item.id">\n          <input type="radio" name="province" ng-model="param.province" ng-value="item.id" ng-change="provinceChanged(item)">\n          <div class="radio-content">\n            <div class="item-content">\n              {{::item.regionName}}\n            </div>\n            <i class="iconselect ion-checkmark-round" ng-class="param.province === item.id ?\'displayblock\':\'\'"></i>\n          </div>\n        </label>\n      </div>\n  </div>\n  <div class="popselect" ng-show="pageData.showCity" ng-click="hideArea(\'City\')">\n      <div class="list" data-tap-disabled="{{isiOS}}">\n        <label class="item item-radio">\n          <div class="radio-content">\n            <div class="item-content popse-title">\n              市\n            </div>\n          </div>\n        </label>\n        <label class="item item-radio" ng-repeat="item in pageData.cities track by item.id">\n          <input type="radio" name="city" ng-model="param.city" ng-value="item.id" ng-change="cityChanged(item)">\n          <div class="radio-content">\n            <div class="item-content">\n              {{::item.regionName}}\n            </div>\n            <i class="iconselect ion-checkmark-round" ng-class="param.city === item.id ?\'displayblock\':\'\'"></i>\n          </div>\n        </label>\n      </div>\n  </div>\n  <div class="popselect" ng-show="pageData.showExp" ng-click="hideArea(\'Exp\')">\n      <div class="list" data-tap-disabled="{{isiOS}}">\n        <label class="item item-radio">\n          <div class="radio-content">\n            <div class="item-content popse-title">\n              快递公司\n            </div>\n          </div>\n        </label>\n        <label class="item item-radio" ng-repeat="item in pageData.allExp track by item.id">\n          <input type="radio" name="street" ng-model="param.expressId" ng-value="item.id" ng-change="expChanged(item)">\n          <div class="radio-content">\n            <div class="item-content">\n              {{::item.name}}\n            </div>\n            <i class="iconselect ion-checkmark-round" ng-class="param.expressId === item.id ?\'displayblock\':\'\'"></i>\n          </div>\n        </label>\n      </div>\n  </div>\n</ion-view>\n'),$templateCache.put("mine/reviseAccount.html",'<ion-view view-title="修改成员" hide-back-button="true">\n  <ion-nav-buttons side="left" >\n    <common-back-button></common-back-button>\n  </ion-nav-buttons>\n  <ion-content>\n    <div class="login-input-ul">\n      <div class="login-input-li">\n        <input type="tel" ng-model="pd.phone" class="login-input" disabled="disabled" maxlength="11"/>\n        <i ng-show="pd.phone"></i>\n      </div>\n      <div class="login-input-li">\n        <input type="text" placeholder="请输入姓名" class="login-input" ng-model="pm.name" maxlength="20"/>\n        <i ng-show="pm.name" class="icon ion-close-circled" ng-click="clearParam(\'name\')"></i>\n      </div>\n      <div class="login-input-li login-div">\n        <button class="login-button button-bg" ng-click="saveAccount()">确认修改</button>\n      </div>\n    </div>\n  </ion-content>\n</ion-view>\n'),$templateCache.put("mine/reviseCollection.html",'<ion-view view-title="修改代收点" hide-back-button="true">\n  <ion-nav-buttons side="left" >\n    <common-back-button></common-back-button>\n  </ion-nav-buttons>\n  <ion-content>\n    <div class="login-input-ul">\n      <div class="login-input-li">\n        <input type="tel" ng-model="pm.phone" class="login-input" disabled="disabled" maxlength="11"/>\n      </div>\n      <div class="login-input-li">\n        <input type="text" placeholder="请输入代收点名称" class="login-input" style="top:-3px;"  maxlength="25" ng-model="pm.name"/>\n        <i ng-show="pm.name" ng-click="clearParam(\'name\')" class="icon ion-close-circled"></i>\n      </div>\n      <div class="login-input-li login-div">\n        <button class="login-button button-bg" ng-click="saveProxy()">修改</button>\n      </div>\n    </div>\n  </ion-content>\n</ion-view>\n\n'),$templateCache.put("mine/selectExpress.html",'<ion-view title="服务快递"  hide-back-button="true">\n  <ion-nav-buttons side="left">\n    <common-back-button></common-back-button>\n  </ion-nav-buttons>\n  <ion-content>\n    <div class="sele-title">服务快递列表（滚动列表可查更多）</div>\n    <div class="sele-listbox">\n      <ul class="list">\n        <li class="item item-checkbox" ng-repeat="item in pageData.express track by item.id">\n           <label class="checkbox">\n             <input type="checkbox" ng-model="item.checked">\n           </label>\n          <img ng-src={{::wrapEXpImg(item.id)}}><p>{{:: item.name }}</p>\n        </li>\n      </ul>\n    </div>\n  </ion-content>\n  <div class="sele-btn"><button class="login-button button-bg" ng-click="finish()">完成</button></div>\n</ion-view>\n'),$templateCache.put("mine/template.html",'<ion-view view-title="选择模版" hide-back-button="true">\n  <ion-nav-buttons side="left" >\n    <common-back-button></common-back-button>\n  </ion-nav-buttons>\n  <ion-nav-buttons side="right">\n    <span class="title-right-btn"  ng-click="refresh()">审核刷新</span>\n  </ion-nav-buttons>\n  <ion-content class="pagebg">\n    <ion-refresher pulling-text="下拉刷新" on-refresh="refresh()" immediate-check="false"></ion-refresher>\n    <sign-agreement options="pd.signAgreementOptions"></sign-agreement>\n    <change-sign options="pd.changeSignOptions"></change-sign>\n    <div class="refresh-down">下拉刷新模板审核状态</div>\n    <div class="temp-state" ng-if="pd.noCommonSign">\n      <h1 ng-switch="pd.noCommonSign.status">审核中签名：【{{pd.noCommonSign.title}}】\n        <span class="colororange" ng-switch-when="submited">正在审核中</span>\n        <span class="colorred" ng-switch-when="checkfailure">审核未通过</span>\n      </h1>\n      <p ng-click="goChangeForFaiure()">去修改》</p>\n    </div>\n    <div class="temp-addbox">\n      <h1>使用中签名：</h1><p>{{pd.sign}}</p><button ng-click="changeSign()">更换</button>\n    </div>\n    <div class="temp-list" ng-click="chooseSys()">\n      <div class="temp-title"><h1>系统模板</h1><span ng-if="pd.systemTemplate.isDefault">[使用中]</span></div>\n      <div class="temp-con">{{pd.sign}}{{::pd.systemTemplate.contentShow}}</div>\n    </div>\n    <div class="temp-list" ng-repeat="item in pd.templates track by item.id">\n      <div class="temp-title" ng-switch="item.status" ng-click="chooseCur(item, $index)">\n        <h1>{{::item.title}}</h1>\n        <span ng-if="item.isDefault">[使用中]</span>\n        <p class="colorgreen" ng-switch-when="checked">审核通过</p>\n        <p class="colorred" ng-switch-when="submited">待审核</p>\n        <p class="colorred" ng-switch-when="checkfailure">未通过</p>\n      </div>\n      <div class="temp-con" ng-click="chooseCur(item, $index)">{{pd.sign}}{{::item.contentShow}}</div>\n      <div class="temp-btnbox">\n        <div class="temp-btn" ng-click="editOne(item, $index)"><i class="icon ion-edit"></i>修改</div>\n        <div class="temp-btn" ng-click="delOne(item, $index)"><i class="icon ion-trash-a"></i>删除</div>\n      </div>\n    </div>\n    <div class="temp-prompt">*点击选中一个模板使用，标注为:"使用中"模板为当前使用模板</div>\n    <div class="btnbox mgn-top40">\n      <button class="login-button button-bg" ui-sref="addTemplate">添加短信模版</button>\n    </div>\n  </ion-content>\n</ion-view>\n'),$templateCache.put("mine/test1.html",'<ion-view title="测试1"  hide-back-button="true">\n  <ion-nav-buttons side="left">\n    <common-back-button></common-back-button>\n  </ion-nav-buttons>\n  <ion-content>\n    <div class="mine-btnbox"><button class="login-button button-bg" ng-click="localData()">数据本地化</button></div>\n    <div class="mine-btnbox"><button class="login-button button-bg" ng-click="listenSpeak()"  style="background-color: indianred">语音听写</button></div>\n  </ion-content>\n</ion-view>\n'),$templateCache.put("mine/updatePW.html",'<ion-view view-title="修改密码" hide-back-button="true">\n  <ion-nav-buttons side="left" >\n    <common-back-button></common-back-button>\n  </ion-nav-buttons>\n  <ion-content>\n    <div class="login-input-ul">\n      <div class="login-input-li">\n        <input type="text" placeholder="请输入旧密码" class="login-input" ng-model="password.old"/>\n        <i ng-if="param.cellphone === undefined || param.cellphone.length > 0" ng-click="clearParam(\'cellphone\')" class="icon ion-close-circled"></i>\n      </div>\n      <div  class="login-input-li">\n        <input type="text" placeholder="请输入新密码" class="code-width login-input" ng-model="password.new"/>\n        <i ng-if="param.newPwd === undefined || param.newPwd.length > 0" ng-click="clearParam(\'newPwd\')" class="icon ion-close-circled"></i>\n      </div>\n      <div class="login-input-li">\n        <input type="text" placeholder="请再次输入新密码" class="login-input" ng-model="password.newSec"/>\n        <i ng-if="param.newPwd === undefined || param.newPwd.length > 0" ng-click="clearParam(\'newPwd\')" class="icon ion-close-circled"></i>\n      </div>\n      <div class="login-input-li login-div">\n        <button class="login-button button-bg" ng-disabled="!submitFlag"  ng-click="updatePsd()">确认修改</button>\n      </div>\n    </div>\n  </ion-content>\n</ion-view>\n'),$templateCache.put("modal/batchRes.html",'<ion-modal-view style="background-color:rgba(0,0,0,0.4);">\n  <div class="popup-container popup-showing active">\n    <div class="popup popup-recip">\n      <div class="popup-head">\n        <h3 class="popup-title ng-binding">入库结果</h3>\n      </div>\n      <div class="popup-recip-nuber">\n        <p>提交总数：<span class="colororange">{{vm.res.totalCount}}</span></p>\n        <p>成功总数：<span class="colororange">{{vm.res.successCount}}</span></p>\n        <p>失败总数：<span class="colororange">{{vm.res.failCount}}</span></p>\n      </div>\n      <div class="popup-recip-listbox">\n        <div class="popup-recip-list">\n          <ul>\n            <li ng-repeat="item in vm.res.errList track by item.id"><p class="floatl">{{::item.orderNo}}</p><p class="floatr">{{::item.errContent}}</p></li>\n          </ul>\n        </div>\n      </div>\n      <div class="popup-buttons">\n        <button class="button ng-binding button-positive" ng-click="hidePic()">确定</button>\n      </div>\n    </div>\n  </div>\n</ion-modal-view>\n'),$templateCache.put("modal/changeOrder.html",'<ion-view view-title="修改快递信息" hide-back-button="true">\n  <ion-nav-buttons side="left" >\n    <button class="button back-button button-clear header-item" ng-click="specialBack()"><i class="icon ion-ios-arrow-back"></i></button>\n  </ion-nav-buttons>\n  <ion-content class="pagebg changeodbox">\n    <div class="inputline" ng-click="showExpress()">\n      <div class="inputbox"><p>{{pd.express}}</p></div>\n      <div class="iconbox"><i class="ion-android-arrow-dropdown"></i></div>\n    </div>\n    <div class="inputline" ng-click="showProxy()">\n      <div class="inputbox"><p>{{pd.proxy}}</p></div>\n      <div class="iconbox"><i class="ion-android-arrow-dropdown"></i></div>\n    </div>\n    <div class="inputline">\n      <div class="inputprompt">快递单号：</div>\n      <div class="inputbox"><input type="tel" ng-model="pm.orderNo" placeholder="请输入快递单号" maxlength="20"/></div>\n    </div>\n    <div class="inputline">\n      <div class="inputprompt">手机号码：</div>\n      <div class="inputbox"><input type="tel" ng-model="pm.phone" placeholder="手机号码(或后四位自动匹配)" maxlength="11"/></div>\n    </div>\n    <div class="inputline">\n      <div class="inputprompt">收<i style="padding-left:.5em"></i>件<i style="padding-left:.5em"></i>人：</div>\n      <div class="inputbox"><input type="text" ng-model="pm.name" placeholder="请输入收件人姓名" maxlength="9"/></div>\n    </div>\n    <div class="inputline">\n      <div class="inputprompt">地<i style="padding-left:2em"></i>址：</div>\n      <div class="inputbox"><input type="text" ng-model="pm.address" placeholder="请输入收件人地址"  maxlength="20"/></div>\n    </div>\n    <div class="inputline">\n      <div class="inputprompt">备<i style="padding-left:2em"></i>注：</div>\n      <div class="inputbox"><input type="text" ng-model="pm.memo" placeholder="请输入备注"  maxlength="20"/></div>\n    </div>\n    <div class="changeod-line">\n      <p>发送短信</p>\n      <div class="btn-switch">\n        <label class="toggle">\n          <input type="checkbox" ng-model="pm.sendMessage">\n          <div class="track">\n            <div class="handle"></div>\n          </div>\n        </label>\n      </div>\n    </div>\n    <div class="btnbox mgn-top40">\n      <button class="login-button button-bg" ng-click="saveOrderInfo()">提交</button>\n    </div>\n  </ion-content>\n  <div class="popselect" ng-show="pd.showExpress" ng-click="hideExpress()">\n    <div class="list" data-tap-disabled="{{isiOS}}">\n      <label class="item item-radio" ng-repeat="item in pd.bindExpress track by item.id">\n        <input type="radio" name="express" ng-model="pm.expressId" ng-value="item.id" ng-change="expressChanged(item)">\n        <div class="radio-content">\n          <div class="item-content recip-eximg">\n            <img ng-src={{::wrapEXpImg(item.id)}}><p>{{::item.name}}</p>\n          </div>\n          <i class="iconselect ion-checkmark-round" ng-class="pm.expressId === item.id ?\'displayblock\':\'\'"></i>\n        </div>\n      </label>\n    </div>\n  </div>\n  <div class="popselect" ng-show="pd.showProxy" ng-click="hideProxy()">\n    <div class="list" data-tap-disabled="{{isiOS}}">\n      <label class="item item-radio" ng-repeat="item in pd.bindProxy track by item.id">\n        <input type="radio" name="proxy" ng-model="pm.proxyId" ng-value="item.id" ng-change="proxyChanged(item)">\n        <div class="radio-content">\n          <div class="item-content recip-eximg">\n            <p>{{::item.name}}</p>\n          </div>\n          <i class="iconselect ion-checkmark-round" ng-class="pm.proxyId === item.id ?\'displayblock\':\'\'"></i>\n        </div>\n      </label>\n    </div>\n  </div>\n</ion-view>\n'),$templateCache.put("modal/changeSign.html",'<ion-modal-view style="background-color:rgba(0,0,0,0.4);" >\n  <div class="popup-container popup-showing active">\n    <div class="popup">\n      <div class="popup-head">\n        <h3 class="popup-title ng-binding">修改签名</h3>\n      </div>\n      <div class="popup-body">当前签名：<span class="colororange">{{vm.sign}}</span></div>\n      <div class="popup-input"><input type="text" placeholder="请输入新的签名" ng-model="vm.newSign" maxlength="8"></div>\n      <div class="popup-txt">注：发送通知时，签名自动加【】，如【{{vm.sign}}】</div>\n      <div class="popup-buttons">\n        <button class="button ng-binding button-positive" ng-click="closeModal()">取消</button>\n        <button class="button ng-binding button-positive" ng-click="goChange()">确认修改</button>\n      </div>\n    </div>\n  </div>\n</ion-modal-view>\n'),$templateCache.put("modal/editBlackPhone.html",'<ion-modal-view style="background-color:rgba(0,0,0,0.4);">\n  <div class="popup-container popup-showing active">\n    <div class="popup">\n      <div class="popup-input-black"><input type="tel" placeholder="请输入手机号码" ng-model="pm.phone" maxlength="11"></div>\n      <div class="popup-text"><textarea placeholder="备注（选填）" ng-model="pm.description" maxlength="50"></textarea></div>\n      <div class="popup-buttons">\n        <button class="button ng-binding button-positive" ng-click="closeModal()">取消</button>\n        <button class="button ng-binding button-positive" ng-click="add()">确认</button>\n      </div>\n    </div>\n  </div>\n</ion-modal-view>\n'),$templateCache.put("modal/showProxies.html",'<ion-modal-view style="background-color:rgba(0,0,0,0.4);">\n  <div class="proxies">\n    <div class="proxies-title">请选择代收站点</div>\n    <div class="proxies-list">\n      <ul class="list">\n        <li class="item item-checkbox"  ng-repeat="item in vm.proxyList track by $index">\n          <label class="checkbox">\n            <input  ng-model="vm.proxyIndex" ng-value="$index" type="radio" >\n          </label>\n          <p>{{::item.val}}</p>\n        </li>\n      </ul>\n    </div>\n    <div class="proxies-btn" ng-click="sureSelectProxy()">确认</div>\n    <div class="proxies-cancel" ng-click="hideModel()">取消</div>\n  </div>\n</ion-modal-view>\n'),$templateCache.put("modal/signAgreement.html",'<ion-modal-view style="background-color:rgba(0,0,0,0.4);">\n  <div class="popup-container popup-showing active">\n    <div class="popup popup-recip">\n      <div class="popup-head">\n        <h3 class="popup-title ng-binding">代收英雄变更短信签名服务协议</h3>\n      </div>\n      <div class="popup-agreementbox">\n        <div class="popup-agreement">\n          <ion-content>\n          <div class="popup-agreement-txt">\n            1、短信变更签名服务即：用户通知取件人的短信通知的前置签名，如：【代收英雄】；<br>\n            2、变更短信通知签名为有偿服务；<br>\n            3、每变更一次短信通知签名收取服务费100元人民币整；<br>\n            4、短信变更签名服务费收取后不退还；<br>\n            5、变更短信通知签名不限次数；<br>\n            6、变更短信签名无需加黑括号“【】”，系统会自动添加；<br>\n            7、短信签名限制在8个汉字内；<br>\n            8、由于变更签名造成短信计费条数增加由用户自己承担相关费用；<br>\n            9、变更短信签名需要经过系统审核，审核成功才可以正式使用，审核失败则不可以使用；<br>\n            10、审核成功后，系统自动替换为新的签名；<br>\n            11、审核失败的签名，用户可以再次修改签名，直到签名变更审核成功；<br>\n            12、审核成功的签名用户有永久使用权，直到下次短信签名再次变更；<br>\n            13、用户可以使用【代收英雄】，免费签名；<br>\n            14、签名内不得含有黄、赌、毒、政治、暴力等，违反国家政策和法规的内容；<br>\n            15、根据国家相关的政策和法规，“代收英雄”有权随时终止变更后的签名使用权；<br>\n            16、“代收英雄”有权随时变更以上所有条款，不再另行通知；<br>\n            17、以上所有条目解释权归“代收英雄”所有。\n          </div>\n          </ion-content>\n        </div>\n      </div>\n      <div class="popup-buttons" ng-if="vm.btType == \'show\'">\n        <button class="button ng-binding button-positive" ng-click="closeModal()">确认</button>\n      </div>\n      <div class="popup-buttons" ng-if="vm.btType == \'submit\'">\n        <button class="button ng-binding button-positive" ng-click="closeModal()">取消</button>\n        <button class="button ng-binding button-positive" ng-click="agree()">我同意</button>\n      </div>\n    </div>\n  </div>\n</ion-modal-view>\n'),$templateCache.put("modal/smsCase.html",'<ion-modal-view style="background-color:rgba(0,0,0,0.4);">\n  <div class="popup-container popup-showing active">\n    <div class="popup popup-recip">\n      <div class="popup-head">\n        <h3 class="popup-title ng-binding">短信示例</h3>\n      </div>\n      <div class="popup-addt-textbox">\n        <div class="popup-addt-text">\n          <ion-content><div class="popup-addt-txt">{{vm.content}}</div></ion-content>\n        </div>\n        <div class="colorred textr">当前输入{{vm.content.length}}个字，按{{vm.smsCount}}条短信计费</div>\n      </div>\n      <div class="popup-buttons" ng-if="vm.btType == \'show\'">\n        <button class="button ng-binding button-positive" ng-click="closeModal()">确定</button>\n      </div>\n      <div class="popup-buttons" ng-if="vm.btType == \'submit\'">\n        <button class="button ng-binding button-positive" ng-click="closeModal()">取消</button>\n        <button class="button ng-binding button-positive" ng-click="sureSubmit()">确认提交</button>\n      </div>\n    </div>\n  </div>\n</ion-modal-view>\n')}]),function(n,t){"object"==typeof exports&&"object"==typeof module?module.exports=t():"function"==typeof define&&define.amd?define(t):"object"==typeof exports?exports.ionicNativeTransitions=t():n.ionicNativeTransitions=t()}(this,function(){return function(n){function t(e){if(i[e])return i[e].exports;var a=i[e]={exports:{},id:e,loaded:!1};return n[e].call(a.exports,a,a.exports,t),a.loaded=!0,a.exports}var i={};return t.m=n,t.c=i,t.p="",t(0)}([function(n,t,i){"use strict";function e(n){return n&&n.__esModule?n:{default:n}}Object.defineProperty(t,"__esModule",{value:!0});var r=e(i(2)),s=e(i(1)),l=e(i(3)),c=angular.module("ionic-native-transitions",["ionic","ui.router"]);c.directive("nativeUiSref",s.default),c.provider("$ionicNativeTransitions",r.default),c.run(l.default),t.default=c=c.name,n.exports=t.default},function(n,t){"use strict";function i(n,t){var i,e=n.match(/^\s*({[^}]*})\s*$/);if(e&&(n=t+"("+e[1]+")"),!(i=n.replace(/\n/g," ").match(/^([^(]+?)\s*(\((.*)\))?$/))||4!==i.length)throw new Error("Invalid state ref '"+n+"'");return{state:i[1],paramExpr:i[3]||null}}Object.defineProperty(t,"__esModule",{value:!0}),t.default=["$log","$ionicNativeTransitions","$state",function(n,t,e){"ngInject";function a(n,e,a,r){var o=n.$eval(a.nativeUiSrefOpts)||{},s=null;a.$observe("nativeOptions",function(t){var i=n.$eval(t);s=angular.isObject(i)?i:{}}),e.on("click",function(e){var u=i(a.nativeUiSref,r.current.name),l=angular.copy(n.$eval(u.paramExpr));return t.isEnabled()?void t.stateGo(u.state,l,o,s):void r.go(u.state,l,o)})}return a.$inject=["$scope","$element","$attrs","$state"],{controller:a,restrict:"A",scope:!1}}],n.exports=t.default},function(n,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=function(){"ngInject";function n(){return n=arguments.length<=0||void 0===arguments[0]||arguments[0],this}function t(){return!!(window.cordova&&window.plugins&&window.plugins.nativepagetransitions)&&n}function r(i,e,a,r,f,p,m,b,h){function $(){var t=arguments.length<=0||void 0===arguments[0]||arguments[0],r=arguments.length<=1||void 0===arguments[1]||arguments[1],o=arguments.length<=2||void 0===arguments[2]?"platform":arguments[2];return!t||window.cordova&&window.plugins&&window.plugins.nativepagetransitions?(n=t,t?(i.debug("[native transition] enabling plugin"),window.plugins&&window.plugins.nativepagetransitions&&angular.extend(window.plugins.nativepagetransitions.globalOptions,_()),a.$ionicGoBack=F,C=b.registerBackButtonAction(function(n,t){return F(t)},100),j()):(i.debug("[native transition] disabling plugin"),void 0===arguments[1]&&(r=!1),a.$ionicGoBack=W,angular.isFunction(C)&&C.call(),A()),r?(i.debug("[native transition] disabling ionic transitions"),e.views.transition("none")):(i.debug("[native transition] enabling ionic transitions"),e.views.transition(o)),this):void i.debug("[native transition] is disabled or nativepagetransitions plugin is not present")}function x(){var n=h.defer();if(!t())return h.when();var e={};if(angular.isObject(arguments[0]))e=angular.extend({},g,arguments[0]);else if(angular.isString(arguments[0]))switch(arguments[0]){case"back":arguments[2]&&S(arguments[2])?e=S(arguments[2]):_().backInOppositeDirection&&arguments[1]&&E(arguments[1])?(e=E(arguments[1])).direction&&(e.direction=c[e.direction]):e=g}else e=d;e=angular.copy(e),i.debug("[native transition]",e);var r=e.type;delete e.type,a.$broadcast("ionicNativeTransitions.beforeTransition");var o=this;return window.plugins.nativepagetransitions[r](e,function(){y.bind(o,P(e))(),n.resolve()},function(){k.bind(o,P(e))(),n.reject()}),n.promise}function y(n){setTimeout(function(){return a.$broadcast("ionicNativeTransitions.success")},n)}function k(n){setTimeout(function(){return a.$broadcast("ionicNativeTransitions.error")},n)}function P(n){var t=void 0;return t=n.duration?parseInt(n.duration):parseInt(_().duration),ionic.Platform.isAndroid()?t+=n.androiddelay?parseInt(n.androiddelay):parseInt(_().androiddelay):ionic.Platform.isIOS()?t+=n.iosdelay?parseInt(n.iosdelay):parseInt(_().iosdelay):ionic.Platform.isWindowsPhone()&&(t+=n.winphonedelay?parseInt(n.winphonedelay):parseInt(_().winphonedelay)),t}function O(){window.plugins.nativepagetransitions.executePendingTransition(),B()}function I(){window.plugins&&window.plugins.nativepagetransitions&&angular.isFunction(window.plugins.nativepagetransitions.cancelPendingTransition)?(window.plugins.nativepagetransitions.cancelPendingTransition(),B()):O()}function j(){A(),B(),u=a.$on("$stateChangeError",I),l=a.$on(_().triggerTransitionEvent,O)}function B(){o||(o=a.$on("$stateChangeStart",function(n,t,e,a,r,o){var s=null;if(!n.defaultPrevented){if(G)return void(G=!1);if(null===t.nativeTransitions)return void i.debug("[native transition] transition disabled for this state",t);s=E(t),i.debug("[native transition] $stateChangeStart",t,s),x(s).then(function(){return G=!0,f.go(t,e,o)}),n.preventDefault()}}))}function S(n){return angular.isObject(n.nativeTransitionsBackIOS)&&ionic.Platform.isIOS()?angular.extend({},n.nativeTransitionsBackIOS):angular.isObject(n.nativeTransitionsBackAndroid)&&ionic.Platform.isAndroid()?angular.extend({},n.nativeTransitionsBackAndroid):angular.isObject(n.nativeTransitionsBackWindowsPhone)&&ionic.Platform.isWindowsPhone()?angular.extend({},n.nativeTransitionsBackWindowsPhone):angular.isObject(n.nativeTransitionsBack)?angular.extend({},n.nativeTransitionsBack):null}function E(n){return angular.isObject(n.nativeTransitionsIOS)&&ionic.Platform.isIOS()?angular.extend({},n.nativeTransitionsIOS):angular.isObject(n.nativeTransitionsAndroid)&&ionic.Platform.isAndroid()?angular.extend({},n.nativeTransitionsAndroid):angular.isObject(n.nativeTransitionsWindowsPhone)&&ionic.Platform.isWindowsPhone()?angular.extend({},n.nativeTransitionsWindowsPhone):angular.isObject(n.nativeTransitions)?angular.extend({},n.nativeTransitions):null}function N(){o&&angular.isFunction(o)&&(o(),o=null)}function A(){o&&angular.isFunction(o)&&(o(),o=null),s&&angular.isFunction(s)&&(s(),s=null),u&&angular.isFunction(u)&&(u(),u=null),l&&angular.isFunction(l)&&(l(),l=null)}function _(){return v}function F(n){if(m.backView()){if(!(n>=0)){var t=m.backView().stateName;if(n&&!isNaN(parseInt(n))){var a=m.viewHistory().histories[m.currentView().historyId],o=a.cursor+n;(0>o||o>a.stack.length)&&(o=0),t=a.stack[o].stateName}var s=angular.extend({},f.current),u=angular.extend({},f.get(t));return N(),null===u.nativeTransitionsBack?(i.debug("[native transition] transition disabled for this state",u),r(function(){return m.goBack(n)}).then(function(){return B()})):(i.debug("nativepagetransitions goBack",n,t,s,u),x("back",s,u).then(function(){return r(function(){return m.goBack(n)})}))}}else navigator.app&&navigator.app.exitApp()}var W=void 0,C=void 0,G=void 0;return{init:function(){return W=a.$ionicGoBack,t()?void $():void i.debug("[native transition] The plugin is either disabled or nativepagetransitions plugin by telerik is not present. If you are getting this message in a browser, this is normal behavior, native transitions only work on device.")},getDefaultOptions:_,enable:$,isEnabled:t,transition:x,registerToRouteEvents:j,unregisterToRouteEvents:A,registerToStateChangeStartEvent:B,unregisterToStateChangeStartEvent:N,disablePendingTransition:I,locationUrl:function(){var n=arguments.length<=0||void 0===arguments[0]?null:arguments[0],t=arguments.length<=1||void 0===arguments[1]?null:arguments[1];return n?(N(),x(t).then(function(){return p.url(n)})):void i.debug("[native transition] cannot change url without url...")},stateGo:function(){var n=arguments.length<=0||void 0===arguments[0]?null:arguments[0],t=arguments.length<=1||void 0===arguments[1]?{}:arguments[1],e=arguments.length<=2||void 0===arguments[2]?{}:arguments[2],a=arguments.length<=3||void 0===arguments[3]?null:arguments[3];return n?f.is(n,t)&&!e.reload?void i.debug("[native transition] same state transition are not possible"):(N(),x(a).then(function(){return r(function(){return f.go(n,t,e)})})):void i.debug("[native transition] cannot change state without a state...")},goBack:F}}r.$inject=["$log","$ionicConfig","$rootScope","$timeout","$state","$location","$ionicHistory","$ionicPlatform","$q"];var o=null,s=null,u=null,l=null,c={up:"down",down:"up",left:"right",right:"left"},d={type:"slide",direction:"left"},g={type:"slide",direction:"right"},v={duration:400,slowdownfactor:4,iosdelay:-1,androiddelay:-1,winphonedelay:-1,fixedPixelsTop:0,fixedPixelsBottom:0,triggerTransitionEvent:"$ionicView.afterEnter",backInOppositeDirection:!1};return{$get:r,enable:n,setDefaultTransition:function(){var n=arguments.length<=0||void 0===arguments[0]?{}:arguments[0];return angular.extend(d,n),this},setDefaultBackTransition:function(){var n=arguments.length<=0||void 0===arguments[0]?{}:arguments[0];return angular.extend(g,n),this},setDefaultOptions:function(){var n=arguments.length<=0||void 0===arguments[0]?{}:arguments[0];return angular.extend(v,n),this}}},n.exports=t.default},function(n,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=["$ionicNativeTransitions","$ionicPlatform","$ionicHistory","$rootScope",function(n,t,i,e){"ngInject";t.ready(function(){n.init()})}],n.exports=t.default}])}),function(t){"object"==typeof exports&&"undefined"!=typeof module?module.exports=t():"function"==typeof define&&define.amd?define([],t):("undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:this).Chart=t()}(function(){return function o(r,s,l){function u(e,t){if(!s[e]){if(!r[e]){var i="function"==typeof require&&require;if(!t&&i)return i(e,!0);if(d)return d(e,!0);var n=new Error("Cannot find module '"+e+"'");throw n.code="MODULE_NOT_FOUND",n}var a=s[e]={exports:{}};r[e][0].call(a.exports,function(t){return u(r[e][1][t]||t)},a,a.exports,o,r,s,l)}return s[e].exports}for(var d="function"==typeof require&&require,t=0;t<l.length;t++)u(l[t]);return u}({1:[function(t,e,i){},{}],2:[function(t,e,i){function n(t){if(t){var e=[0,0,0],i=1,n=t.match(/^#([a-fA-F0-9]{3})$/i);if(n){n=n[1];for(var a=0;a<e.length;a++)e[a]=parseInt(n[a]+n[a],16)}else if(n=t.match(/^#([a-fA-F0-9]{6})$/i))for(n=n[1],a=0;a<e.length;a++)e[a]=parseInt(n.slice(2*a,2*a+2),16);else if(n=t.match(/^rgba?\(\s*([+-]?\d+)\s*,\s*([+-]?\d+)\s*,\s*([+-]?\d+)\s*(?:,\s*([+-]?[\d\.]+)\s*)?\)$/i)){for(a=0;a<e.length;a++)e[a]=parseInt(n[a+1]);i=parseFloat(n[4])}else if(n=t.match(/^rgba?\(\s*([+-]?[\d\.]+)\%\s*,\s*([+-]?[\d\.]+)\%\s*,\s*([+-]?[\d\.]+)\%\s*(?:,\s*([+-]?[\d\.]+)\s*)?\)$/i)){for(a=0;a<e.length;a++)e[a]=Math.round(2.55*parseFloat(n[a+1]));i=parseFloat(n[4])}else if(n=t.match(/(\w+)/)){if("transparent"==n[1])return[0,0,0,0];if(!(e=o[n[1]]))return}for(a=0;a<e.length;a++)e[a]=d(e[a],0,255);return i=i||0==i?d(i,0,1):1,e[3]=i,e}}function a(t){if(t){var e=t.match(/^hsla?\(\s*([+-]?\d+)(?:deg)?\s*,\s*([+-]?[\d\.]+)%\s*,\s*([+-]?[\d\.]+)%\s*(?:,\s*([+-]?[\d\.]+)\s*)?\)/);if(e){var i=parseFloat(e[4]);return[d(parseInt(e[1]),0,360),d(parseFloat(e[2]),0,100),d(parseFloat(e[3]),0,100),d(isNaN(i)?1:i,0,1)]}}}function r(t){if(t){var e=t.match(/^hwb\(\s*([+-]?\d+)(?:deg)?\s*,\s*([+-]?[\d\.]+)%\s*,\s*([+-]?[\d\.]+)%\s*(?:,\s*([+-]?[\d\.]+)\s*)?\)/);if(e){var i=parseFloat(e[4]);return[d(parseInt(e[1]),0,360),d(parseFloat(e[2]),0,100),d(parseFloat(e[3]),0,100),d(isNaN(i)?1:i,0,1)]}}}function s(t,e){return void 0===e&&(e=void 0!==t[3]?t[3]:1),"rgba("+t[0]+", "+t[1]+", "+t[2]+", "+e+")"}function l(t,e){return"rgba("+Math.round(t[0]/255*100)+"%, "+Math.round(t[1]/255*100)+"%, "+Math.round(t[2]/255*100)+"%, "+(e||t[3]||1)+")"}function u(t,e){return void 0===e&&(e=void 0!==t[3]?t[3]:1),"hsla("+t[0]+", "+t[1]+"%, "+t[2]+"%, "+e+")"}function d(t,e,i){return Math.min(Math.max(e,t),i)}function c(t){var e=t.toString(16).toUpperCase();return e.length<2?"0"+e:e}var o=t(6);e.exports={getRgba:n,getHsla:a,getRgb:function(t){var e=n(t);return e&&e.slice(0,3)},getHsl:function(t){var e=a(t);return e&&e.slice(0,3)},getHwb:r,getAlpha:function(t){var e=n(t);return e?e[3]:(e=a(t))?e[3]:(e=r(t))?e[3]:void 0},hexString:function(t){return"#"+c(t[0])+c(t[1])+c(t[2])},rgbString:function(t,e){return e<1||t[3]&&t[3]<1?s(t,e):"rgb("+t[0]+", "+t[1]+", "+t[2]+")"},rgbaString:s,percentString:function(t,e){return e<1||t[3]&&t[3]<1?l(t,e):"rgb("+Math.round(t[0]/255*100)+"%, "+Math.round(t[1]/255*100)+"%, "+Math.round(t[2]/255*100)+"%)"},percentaString:l,hslString:function(t,e){return e<1||t[3]&&t[3]<1?u(t,e):"hsl("+t[0]+", "+t[1]+"%, "+t[2]+"%)"},hslaString:u,hwbString:function(t,e){return void 0===e&&(e=void 0!==t[3]?t[3]:1),"hwb("+t[0]+", "+t[1]+"%, "+t[2]+"%"+(void 0!==e&&1!==e?", "+e:"")+")"},keyword:function(t){return h[t.slice(0,3)]}};var h={};for(var f in o)h[o[f]]=f},{6:6}],3:[function(t,e,i){var d=t(5),n=t(2),r=function(t){return t instanceof r?t:this instanceof r?(this.valid=!1,this.values={rgb:[0,0,0],hsl:[0,0,0],hsv:[0,0,0],hwb:[0,0,0],cmyk:[0,0,0,0],alpha:1},void("string"==typeof t?(e=n.getRgba(t))?this.setValues("rgb",e):(e=n.getHsla(t))?this.setValues("hsl",e):(e=n.getHwb(t))&&this.setValues("hwb",e):"object"==typeof t&&(void 0!==(e=t).r||void 0!==e.red?this.setValues("rgb",e):void 0!==e.l||void 0!==e.lightness?this.setValues("hsl",e):void 0!==e.v||void 0!==e.value?this.setValues("hsv",e):void 0!==e.w||void 0!==e.whiteness?this.setValues("hwb",e):void 0===e.c&&void 0===e.cyan||this.setValues("cmyk",e)))):new r(t);var e};r.prototype={isValid:function(){return this.valid},rgb:function(){return this.setSpace("rgb",arguments)},hsl:function(){return this.setSpace("hsl",arguments)},hsv:function(){return this.setSpace("hsv",arguments)},hwb:function(){return this.setSpace("hwb",arguments)},cmyk:function(){return this.setSpace("cmyk",arguments)},rgbArray:function(){return this.values.rgb},hslArray:function(){return this.values.hsl},hsvArray:function(){return this.values.hsv},hwbArray:function(){var t=this.values;return 1!==t.alpha?t.hwb.concat([t.alpha]):t.hwb},cmykArray:function(){return this.values.cmyk},rgbaArray:function(){var t=this.values;return t.rgb.concat([t.alpha])},hslaArray:function(){var t=this.values;return t.hsl.concat([t.alpha])},alpha:function(t){return void 0===t?this.values.alpha:(this.setValues("alpha",t),this)},red:function(t){return this.setChannel("rgb",0,t)},green:function(t){return this.setChannel("rgb",1,t)},blue:function(t){return this.setChannel("rgb",2,t)},hue:function(t){return t&&(t=(t%=360)<0?360+t:t),this.setChannel("hsl",0,t)},saturation:function(t){return this.setChannel("hsl",1,t)},lightness:function(t){return this.setChannel("hsl",2,t)},saturationv:function(t){return this.setChannel("hsv",1,t)},whiteness:function(t){return this.setChannel("hwb",1,t)},blackness:function(t){return this.setChannel("hwb",2,t)},value:function(t){return this.setChannel("hsv",2,t)},cyan:function(t){return this.setChannel("cmyk",0,t)},magenta:function(t){return this.setChannel("cmyk",1,t)},yellow:function(t){return this.setChannel("cmyk",2,t)},black:function(t){return this.setChannel("cmyk",3,t)},hexString:function(){return n.hexString(this.values.rgb)},rgbString:function(){return n.rgbString(this.values.rgb,this.values.alpha)},rgbaString:function(){return n.rgbaString(this.values.rgb,this.values.alpha)},percentString:function(){return n.percentString(this.values.rgb,this.values.alpha)},hslString:function(){return n.hslString(this.values.hsl,this.values.alpha)},hslaString:function(){return n.hslaString(this.values.hsl,this.values.alpha)},hwbString:function(){return n.hwbString(this.values.hwb,this.values.alpha)},keyword:function(){return n.keyword(this.values.rgb,this.values.alpha)},rgbNumber:function(){var t=this.values.rgb;return t[0]<<16|t[1]<<8|t[2]},luminosity:function(){for(var t=this.values.rgb,e=[],i=0;i<t.length;i++){var n=t[i]/255;e[i]=n<=.03928?n/12.92:Math.pow((n+.055)/1.055,2.4)}return.2126*e[0]+.7152*e[1]+.0722*e[2]},contrast:function(t){var e=this.luminosity(),i=t.luminosity();return i<e?(e+.05)/(i+.05):(i+.05)/(e+.05)},level:function(t){var e=this.contrast(t);return 7.1<=e?"AAA":4.5<=e?"AA":""},dark:function(){var t=this.values.rgb;return(299*t[0]+587*t[1]+114*t[2])/1e3<128},light:function(){return!this.dark()},negate:function(){for(var t=[],e=0;e<3;e++)t[e]=255-this.values.rgb[e];return this.setValues("rgb",t),this},lighten:function(t){var e=this.values.hsl;return e[2]+=e[2]*t,this.setValues("hsl",e),this},darken:function(t){var e=this.values.hsl;return e[2]-=e[2]*t,this.setValues("hsl",e),this},saturate:function(t){var e=this.values.hsl;return e[1]+=e[1]*t,this.setValues("hsl",e),this},desaturate:function(t){var e=this.values.hsl;return e[1]-=e[1]*t,this.setValues("hsl",e),this},whiten:function(t){var e=this.values.hwb;return e[1]+=e[1]*t,this.setValues("hwb",e),this},blacken:function(t){var e=this.values.hwb;return e[2]+=e[2]*t,this.setValues("hwb",e),this},greyscale:function(){var t=this.values.rgb,e=.3*t[0]+.59*t[1]+.11*t[2];return this.setValues("rgb",[e,e,e]),this},clearer:function(t){var e=this.values.alpha;return this.setValues("alpha",e-e*t),this},opaquer:function(t){var e=this.values.alpha;return this.setValues("alpha",e+e*t),this},rotate:function(t){var e=this.values.hsl,i=(e[0]+t)%360;return e[0]=i<0?360+i:i,this.setValues("hsl",e),this},mix:function(t,e){var i=this,n=t,a=void 0===e?.5:e,o=2*a-1,r=i.alpha()-n.alpha(),s=((o*r==-1?o:(o+r)/(1+o*r))+1)/2,l=1-s;return this.rgb(s*i.red()+l*n.red(),s*i.green()+l*n.green(),s*i.blue()+l*n.blue()).alpha(i.alpha()*a+n.alpha()*(1-a))},toJSON:function(){return this.rgb()},clone:function(){var t,e,i=new r,n=this.values,a=i.values;for(var o in n)n.hasOwnProperty(o)&&(t=n[o],"[object Array]"===(e={}.toString.call(t))?a[o]=t.slice(0):"[object Number]"===e&&(a[o]=t));return i}},r.prototype.spaces={rgb:["red","green","blue"],hsl:["hue","saturation","lightness"],hsv:["hue","saturation","value"],hwb:["hue","whiteness","blackness"],cmyk:["cyan","magenta","yellow","black"]},r.prototype.maxes={rgb:[255,255,255],hsl:[360,100,100],hsv:[360,100,100],hwb:[360,100,100],cmyk:[100,100,100,100]},r.prototype.getValues=function(t){for(var e=this.values,i={},n=0;n<t.length;n++)i[t.charAt(n)]=e[t][n];return 1!==e.alpha&&(i.a=e.alpha),i},r.prototype.setValues=function(t,e){var i,n,a=this.values,o=this.spaces,r=this.maxes,s=1;if(this.valid=!0,"alpha"===t)s=e;else if(e.length)a[t]=e.slice(0,t.length),s=e[t.length];else if(void 0!==e[t.charAt(0)]){for(i=0;i<t.length;i++)a[t][i]=e[t.charAt(i)];s=e.a}else if(void 0!==e[o[t][0]]){var l=o[t];for(i=0;i<t.length;i++)a[t][i]=e[l[i]];s=e.alpha}if(a.alpha=Math.max(0,Math.min(1,void 0===s?a.alpha:s)),"alpha"===t)return!1;for(i=0;i<t.length;i++)n=Math.max(0,Math.min(r[t][i],a[t][i])),a[t][i]=Math.round(n);for(var u in o)u!==t&&(a[u]=d[t][u](a[t]));return!0},r.prototype.setSpace=function(t,e){var i=e[0];return void 0===i?this.getValues(t):("number"==typeof i&&(i=Array.prototype.slice.call(e)),this.setValues(t,i),this)},r.prototype.setChannel=function(t,e,i){var n=this.values[t];return void 0===i?n[e]:(i===n[e]||(n[e]=i,this.setValues(t,n)),this)},"undefined"!=typeof window&&(window.Color=r),e.exports=r},{2:2,5:5}],4:[function(t,e,i){function a(t){var e,i,n=t[0]/255,a=t[1]/255,o=t[2]/255,r=Math.min(n,a,o),s=Math.max(n,a,o),l=s-r;return s==r?e=0:n==s?e=(a-o)/l:a==s?e=2+(o-n)/l:o==s&&(e=4+(n-a)/l),(e=Math.min(60*e,360))<0&&(e+=360),i=(r+s)/2,[e,100*(s==r?0:i<=.5?l/(s+r):l/(2-s-r)),100*i]}function n(t){var e,i,n=t[0],a=t[1],o=t[2],r=Math.min(n,a,o),s=Math.max(n,a,o),l=s-r;return i=0==s?0:l/s*1e3/10,s==r?e=0:n==s?e=(a-o)/l:a==s?e=2+(o-n)/l:o==s&&(e=4+(n-a)/l),(e=Math.min(60*e,360))<0&&(e+=360),[e,i,s/255*1e3/10]}function o(t){var e=t[0],i=t[1],n=t[2];return[a(t)[0],1/255*Math.min(e,Math.min(i,n))*100,100*(n=1-1/255*Math.max(e,Math.max(i,n)))]}function s(t){var e,i=t[0]/255,n=t[1]/255,a=t[2]/255;return[100*((1-i-(e=Math.min(1-i,1-n,1-a)))/(1-e)||0),100*((1-n-e)/(1-e)||0),100*((1-a-e)/(1-e)||0),100*e]}function l(t){return S[JSON.stringify(t)]}function u(t){var e=t[0]/255,i=t[1]/255,n=t[2]/255;return[100*(.4124*(e=.04045<e?Math.pow((e+.055)/1.055,2.4):e/12.92)+.3576*(i=.04045<i?Math.pow((i+.055)/1.055,2.4):i/12.92)+.1805*(n=.04045<n?Math.pow((n+.055)/1.055,2.4):n/12.92)),100*(.2126*e+.7152*i+.0722*n),100*(.0193*e+.1192*i+.9505*n)]}function d(t){var e=u(t),i=e[0],n=e[1],a=e[2];return n/=100,a/=108.883,i=.008856<(i/=95.047)?Math.pow(i,1/3):7.787*i+16/116,[116*(n=.008856<n?Math.pow(n,1/3):7.787*n+16/116)-16,500*(i-n),200*(n-(a=.008856<a?Math.pow(a,1/3):7.787*a+16/116))]}function c(t){var e,i,n,a,o,r=t[0]/360,s=t[1]/100,l=t[2]/100;if(0==s)return[o=255*l,o,o];e=2*l-(i=l<.5?l*(1+s):l+s-l*s),a=[0,0,0];for(var u=0;u<3;u++)(n=r+1/3*-(u-1))<0&&n++,1<n&&n--,o=6*n<1?e+6*(i-e)*n:2*n<1?i:3*n<2?e+(i-e)*(2/3-n)*6:e,a[u]=255*o;return a}function h(t){var e=t[0]/60,i=t[1]/100,n=t[2]/100,a=Math.floor(e)%6,o=e-Math.floor(e),r=255*n*(1-i),s=255*n*(1-i*o),l=255*n*(1-i*(1-o));switch(n*=255,a){case 0:return[n,l,r];case 1:return[s,n,r];case 2:return[r,n,l];case 3:return[r,s,n];case 4:return[l,r,n];case 5:return[n,r,s]}}function f(t){var e,i,n,a,o=t[0]/360,s=t[1]/100,l=t[2]/100,u=s+l;switch(1<u&&(s/=u,l/=u),n=6*o-(e=Math.floor(6*o)),0!=(1&e)&&(n=1-n),a=s+n*((i=1-l)-s),e){default:case 6:case 0:r=i,g=a,b=s;break;case 1:r=a,g=i,b=s;break;case 2:r=s,g=i,b=a;break;case 3:r=s,g=a,b=i;break;case 4:r=a,g=s,b=i;break;case 5:r=i,g=s,b=a}return[255*r,255*g,255*b]}function p(t){var e=t[0]/100,i=t[1]/100,n=t[2]/100,a=t[3]/100;return[255*(1-Math.min(1,e*(1-a)+a)),255*(1-Math.min(1,i*(1-a)+a)),255*(1-Math.min(1,n*(1-a)+a))]}function m(t){var e,i,n,a=t[0]/100,o=t[1]/100,r=t[2]/100;return i=-.9689*a+1.8758*o+.0415*r,n=.0557*a+-.204*o+1.057*r,e=.0031308<(e=3.2406*a+-1.5372*o+-.4986*r)?1.055*Math.pow(e,1/2.4)-.055:e*=12.92,i=.0031308<i?1.055*Math.pow(i,1/2.4)-.055:i*=12.92,n=.0031308<n?1.055*Math.pow(n,1/2.4)-.055:n*=12.92,[255*(e=Math.min(Math.max(0,e),1)),255*(i=Math.min(Math.max(0,i),1)),255*(n=Math.min(Math.max(0,n),1))]}function v(t){var e=t[0],i=t[1],n=t[2];return i/=100,n/=108.883,e=.008856<(e/=95.047)?Math.pow(e,1/3):7.787*e+16/116,[116*(i=.008856<i?Math.pow(i,1/3):7.787*i+16/116)-16,500*(e-i),200*(i-(n=.008856<n?Math.pow(n,1/3):7.787*n+16/116))]}function x(t){var e,i,n,a,o=t[0],r=t[1],s=t[2];return a=o<=8?(i=100*o/903.3)/100*7.787+16/116:(i=100*Math.pow((o+16)/116,3),Math.pow(i/100,1/3)),[e=e/95.047<=.008856?e=95.047*(r/500+a-16/116)/7.787:95.047*Math.pow(r/500+a,3),i,n=n/108.883<=.008859?n=108.883*(a-s/200-16/116)/7.787:108.883*Math.pow(a-s/200,3)]}function y(t){var e,i=t[0],n=t[1],a=t[2];return(e=360*Math.atan2(a,n)/2/Math.PI)<0&&(e+=360),[i,Math.sqrt(n*n+a*a),e]}function k(t){return m(x(t))}function M(t){var e,i=t[0],n=t[1];return e=t[2]/360*2*Math.PI,[i,n*Math.cos(e),n*Math.sin(e)]}function w(t){return C[t]}e.exports={rgb2hsl:a,rgb2hsv:n,rgb2hwb:o,rgb2cmyk:s,rgb2keyword:l,rgb2xyz:u,rgb2lab:d,rgb2lch:function(t){return y(d(t))},hsl2rgb:c,hsl2hsv:function(t){var e=t[0],i=t[1]/100,n=t[2]/100;return 0!==n?[e,2*(i*=(n*=2)<=1?n:2-n)/(n+i)*100,(n+i)/2*100]:[0,0,0]},hsl2hwb:function(t){return o(c(t))},hsl2cmyk:function(t){return s(c(t))},hsl2keyword:function(t){return l(c(t))},hsv2rgb:h,hsv2hsl:function(t){var e,i,n=t[0],a=t[1]/100,o=t[2]/100;return e=a*o,[n,100*(e=(e/=(i=(2-a)*o)<=1?i:2-i)||0),100*(i/=2)]},hsv2hwb:function(t){return o(h(t))},hsv2cmyk:function(t){return s(h(t))},hsv2keyword:function(t){return l(h(t))},hwb2rgb:f,hwb2hsl:function(t){return a(f(t))},hwb2hsv:function(t){return n(f(t))},hwb2cmyk:function(t){return s(f(t))},hwb2keyword:function(t){return l(f(t))},cmyk2rgb:p,cmyk2hsl:function(t){return a(p(t))},cmyk2hsv:function(t){return n(p(t))},cmyk2hwb:function(t){return o(p(t))},cmyk2keyword:function(t){return l(p(t))},keyword2rgb:w,keyword2hsl:function(t){return a(w(t))},keyword2hsv:function(t){return n(w(t))},keyword2hwb:function(t){return o(w(t))},keyword2cmyk:function(t){return s(w(t))},keyword2lab:function(t){return d(w(t))},keyword2xyz:function(t){return u(w(t))},xyz2rgb:m,xyz2lab:v,xyz2lch:function(t){return y(v(t))},lab2xyz:x,lab2rgb:k,lab2lch:y,lch2lab:M,lch2xyz:function(t){return x(M(t))},lch2rgb:function(t){return k(M(t))}};var C={aliceblue:[240,248,255],antiquewhite:[250,235,215],aqua:[0,255,255],aquamarine:[127,255,212],azure:[240,255,255],beige:[245,245,220],bisque:[255,228,196],black:[0,0,0],blanchedalmond:[255,235,205],blue:[0,0,255],blueviolet:[138,43,226],brown:[165,42,42],burlywood:[222,184,135],cadetblue:[95,158,160],chartreuse:[127,255,0],chocolate:[210,105,30],coral:[255,127,80],cornflowerblue:[100,149,237],cornsilk:[255,248,220],crimson:[220,20,60],cyan:[0,255,255],darkblue:[0,0,139],darkcyan:[0,139,139],darkgoldenrod:[184,134,11],darkgray:[169,169,169],darkgreen:[0,100,0],darkgrey:[169,169,169],darkkhaki:[189,183,107],darkmagenta:[139,0,139],darkolivegreen:[85,107,47],darkorange:[255,140,0],darkorchid:[153,50,204],darkred:[139,0,0],darksalmon:[233,150,122],darkseagreen:[143,188,143],darkslateblue:[72,61,139],darkslategray:[47,79,79],darkslategrey:[47,79,79],darkturquoise:[0,206,209],darkviolet:[148,0,211],deeppink:[255,20,147],deepskyblue:[0,191,255],dimgray:[105,105,105],dimgrey:[105,105,105],dodgerblue:[30,144,255],firebrick:[178,34,34],floralwhite:[255,250,240],forestgreen:[34,139,34],fuchsia:[255,0,255],gainsboro:[220,220,220],ghostwhite:[248,248,255],gold:[255,215,0],goldenrod:[218,165,32],gray:[128,128,128],green:[0,128,0],greenyellow:[173,255,47],grey:[128,128,128],honeydew:[240,255,240],hotpink:[255,105,180],indianred:[205,92,92],indigo:[75,0,130],ivory:[255,255,240],khaki:[240,230,140],lavender:[230,230,250],lavenderblush:[255,240,245],lawngreen:[124,252,0],lemonchiffon:[255,250,205],lightblue:[173,216,230],lightcoral:[240,128,128],lightcyan:[224,255,255],lightgoldenrodyellow:[250,250,210],lightgray:[211,211,211],lightgreen:[144,238,144],lightgrey:[211,211,211],lightpink:[255,182,193],lightsalmon:[255,160,122],lightseagreen:[32,178,170],lightskyblue:[135,206,250],lightslategray:[119,136,153],lightslategrey:[119,136,153],lightsteelblue:[176,196,222],lightyellow:[255,255,224],lime:[0,255,0],limegreen:[50,205,50],linen:[250,240,230],magenta:[255,0,255],maroon:[128,0,0],mediumaquamarine:[102,205,170],mediumblue:[0,0,205],mediumorchid:[186,85,211],mediumpurple:[147,112,219],mediumseagreen:[60,179,113],mediumslateblue:[123,104,238],mediumspringgreen:[0,250,154],mediumturquoise:[72,209,204],mediumvioletred:[199,21,133],midnightblue:[25,25,112],mintcream:[245,255,250],mistyrose:[255,228,225],moccasin:[255,228,181],navajowhite:[255,222,173],navy:[0,0,128],oldlace:[253,245,230],olive:[128,128,0],olivedrab:[107,142,35],orange:[255,165,0],orangered:[255,69,0],orchid:[218,112,214],palegoldenrod:[238,232,170],palegreen:[152,251,152],paleturquoise:[175,238,238],palevioletred:[219,112,147],papayawhip:[255,239,213],peachpuff:[255,218,185],peru:[205,133,63],pink:[255,192,203],plum:[221,160,221],powderblue:[176,224,230],purple:[128,0,128],rebeccapurple:[102,51,153],red:[255,0,0],rosybrown:[188,143,143],royalblue:[65,105,225],saddlebrown:[139,69,19],salmon:[250,128,114],sandybrown:[244,164,96],seagreen:[46,139,87],seashell:[255,245,238],sienna:[160,82,45],silver:[192,192,192],skyblue:[135,206,235],slateblue:[106,90,205],slategray:[112,128,144],slategrey:[112,128,144],snow:[255,250,250],springgreen:[0,255,127],steelblue:[70,130,180],tan:[210,180,140],teal:[0,128,128],thistle:[216,191,216],tomato:[255,99,71],turquoise:[64,224,208],violet:[238,130,238],wheat:[245,222,179],white:[255,255,255],whitesmoke:[245,245,245],yellow:[255,255,0],yellowgreen:[154,205,50]},S={};for(var _ in C)S[JSON.stringify(C[_])]=_},{}],5:[function(t,e,i){var a=t(4),o=function(){return new u};for(var n in a){o[n+"Raw"]=function(e){return function(t){return"number"==typeof t&&(t=Array.prototype.slice.call(arguments)),a[e](t)}}(n);var r=/(\w+)2(\w+)/.exec(n),s=r[1],l=r[2];(o[s]=o[s]||{})[l]=o[n]=function(n){return function(t){"number"==typeof t&&(t=Array.prototype.slice.call(arguments));var e=a[n](t);if("string"==typeof e||void 0===e)return e;for(var i=0;i<e.length;i++)e[i]=Math.round(e[i]);return e}}(n)}var u=function(){this.convs={}};u.prototype.routeSpace=function(t,e){var i=e[0];return void 0===i?this.getValues(t):("number"==typeof i&&(i=Array.prototype.slice.call(e)),this.setValues(t,i))},u.prototype.setValues=function(t,e){return this.space=t,this.convs={},this.convs[t]=e,this},u.prototype.getValues=function(t){var e=this.convs[t];if(!e){var i=this.space,n=this.convs[i];e=o[i][t](n),this.convs[t]=e}return e},["rgb","hsl","hsv","cmyk","keyword"].forEach(function(e){u.prototype[e]=function(t){return this.routeSpace(e,arguments)}}),e.exports=o},{4:4}],6:[function(t,e,i){"use strict";e.exports={aliceblue:[240,248,255],antiquewhite:[250,235,215],aqua:[0,255,255],aquamarine:[127,255,212],azure:[240,255,255],beige:[245,245,220],bisque:[255,228,196],black:[0,0,0],blanchedalmond:[255,235,205],blue:[0,0,255],blueviolet:[138,43,226],brown:[165,42,42],burlywood:[222,184,135],cadetblue:[95,158,160],chartreuse:[127,255,0],chocolate:[210,105,30],coral:[255,127,80],cornflowerblue:[100,149,237],cornsilk:[255,248,220],crimson:[220,20,60],cyan:[0,255,255],darkblue:[0,0,139],darkcyan:[0,139,139],darkgoldenrod:[184,134,11],darkgray:[169,169,169],darkgreen:[0,100,0],darkgrey:[169,169,169],darkkhaki:[189,183,107],darkmagenta:[139,0,139],darkolivegreen:[85,107,47],darkorange:[255,140,0],darkorchid:[153,50,204],darkred:[139,0,0],darksalmon:[233,150,122],darkseagreen:[143,188,143],darkslateblue:[72,61,139],darkslategray:[47,79,79],darkslategrey:[47,79,79],darkturquoise:[0,206,209],darkviolet:[148,0,211],deeppink:[255,20,147],deepskyblue:[0,191,255],dimgray:[105,105,105],dimgrey:[105,105,105],dodgerblue:[30,144,255],firebrick:[178,34,34],floralwhite:[255,250,240],forestgreen:[34,139,34],fuchsia:[255,0,255],gainsboro:[220,220,220],ghostwhite:[248,248,255],gold:[255,215,0],goldenrod:[218,165,32],gray:[128,128,128],green:[0,128,0],greenyellow:[173,255,47],grey:[128,128,128],honeydew:[240,255,240],hotpink:[255,105,180],indianred:[205,92,92],indigo:[75,0,130],ivory:[255,255,240],khaki:[240,230,140],lavender:[230,230,250],lavenderblush:[255,240,245],lawngreen:[124,252,0],lemonchiffon:[255,250,205],lightblue:[173,216,230],lightcoral:[240,128,128],lightcyan:[224,255,255],lightgoldenrodyellow:[250,250,210],lightgray:[211,211,211],lightgreen:[144,238,144],lightgrey:[211,211,211],lightpink:[255,182,193],lightsalmon:[255,160,122],lightseagreen:[32,178,170],lightskyblue:[135,206,250],lightslategray:[119,136,153],lightslategrey:[119,136,153],lightsteelblue:[176,196,222],lightyellow:[255,255,224],lime:[0,255,0],limegreen:[50,205,50],linen:[250,240,230],magenta:[255,0,255],maroon:[128,0,0],mediumaquamarine:[102,205,170],mediumblue:[0,0,205],mediumorchid:[186,85,211],mediumpurple:[147,112,219],mediumseagreen:[60,179,113],mediumslateblue:[123,104,238],mediumspringgreen:[0,250,154],mediumturquoise:[72,209,204],mediumvioletred:[199,21,133],midnightblue:[25,25,112],mintcream:[245,255,250],mistyrose:[255,228,225],moccasin:[255,228,181],navajowhite:[255,222,173],navy:[0,0,128],oldlace:[253,245,230],olive:[128,128,0],olivedrab:[107,142,35],orange:[255,165,0],orangered:[255,69,0],orchid:[218,112,214],palegoldenrod:[238,232,170],palegreen:[152,251,152],paleturquoise:[175,238,238],palevioletred:[219,112,147],papayawhip:[255,239,213],peachpuff:[255,218,185],peru:[205,133,63],pink:[255,192,203],plum:[221,160,221],powderblue:[176,224,230],purple:[128,0,128],rebeccapurple:[102,51,153],red:[255,0,0],rosybrown:[188,143,143],royalblue:[65,105,225],saddlebrown:[139,69,19],salmon:[250,128,114],sandybrown:[244,164,96],seagreen:[46,139,87],seashell:[255,245,238],sienna:[160,82,45],silver:[192,192,192],skyblue:[135,206,235],slateblue:[106,90,205],slategray:[112,128,144],slategrey:[112,128,144],snow:[255,250,250],springgreen:[0,255,127],steelblue:[70,130,180],tan:[210,180,140],teal:[0,128,128],thistle:[216,191,216],tomato:[255,99,71],turquoise:[64,224,208],violet:[238,130,238],wheat:[245,222,179],white:[255,255,255],whitesmoke:[245,245,245],yellow:[255,255,0],yellowgreen:[154,205,50]}},{}],7:[function(t,e,i){var n=t(30)();n.helpers=t(46),t(28)(n),n.Animation=t(22),n.animationService=t(23),n.defaults=t(26),n.Element=t(27),n.elements=t(41),n.Interaction=t(29),n.layouts=t(31),n.platform=t(49),n.plugins=t(32),n.Scale=t(33),n.scaleService=t(34),n.Ticks=t(35),n.Tooltip=t(36),t(24)(n),t(25)(n),t(56)(n),t(54)(n),t(55)(n),t(57)(n),t(58)(n),t(59)(n),t(15)(n),t(16)(n),t(17)(n),t(18)(n),t(19)(n),t(20)(n),t(21)(n),t(8)(n),t(9)(n),t(10)(n),t(11)(n),t(12)(n),t(13)(n),t(14)(n);var a=t(50);for(var o in a)a.hasOwnProperty(o)&&n.plugins.register(a[o]);n.platform.initialize(),e.exports=n,"undefined"!=typeof window&&(window.Chart=n),n.Legend=a.legend._element,n.Title=a.title._element,n.pluginService=n.plugins,n.PluginBase=n.Element.extend({}),n.canvasHelpers=n.helpers.canvas,n.layoutService=n.layouts},{10:10,11:11,12:12,13:13,14:14,15:15,16:16,17:17,18:18,19:19,20:20,21:21,22:22,23:23,24:24,25:25,26:26,27:27,28:28,29:29,30:30,31:31,32:32,33:33,34:34,35:35,36:36,41:41,46:46,49:49,50:50,54:54,55:55,56:56,57:57,58:58,59:59,8:8,9:9}],8:[function(t,e,i){"use strict";e.exports=function(i){i.Bar=function(t,e){return e.type="bar",new i(t,e)}}},{}],9:[function(t,e,i){"use strict";e.exports=function(i){i.Bubble=function(t,e){return e.type="bubble",new i(t,e)}}},{}],10:[function(t,e,i){"use strict";e.exports=function(i){i.Doughnut=function(t,e){return e.type="doughnut",new i(t,e)}}},{}],11:[function(t,e,i){"use strict";e.exports=function(i){i.Line=function(t,e){return e.type="line",new i(t,e)}}},{}],12:[function(t,e,i){"use strict";e.exports=function(i){i.PolarArea=function(t,e){return e.type="polarArea",new i(t,e)}}},{}],13:[function(t,e,i){"use strict";e.exports=function(i){i.Radar=function(t,e){return e.type="radar",new i(t,e)}}},{}],14:[function(t,e,i){"use strict";e.exports=function(i){i.Scatter=function(t,e){return e.type="scatter",new i(t,e)}}},{}],15:[function(t,e,i){"use strict";var n=t(26),a=t(41),S=t(46);n._set("bar",{hover:{mode:"label"},scales:{xAxes:[{type:"category",categoryPercentage:.8,barPercentage:.9,offset:!0,gridLines:{offsetGridLines:!0}}],yAxes:[{type:"linear"}]}}),n._set("horizontalBar",{hover:{mode:"index",axis:"y"},scales:{xAxes:[{type:"linear",position:"bottom"}],yAxes:[{position:"left",type:"category",categoryPercentage:.8,barPercentage:.9,offset:!0,gridLines:{offsetGridLines:!0}}]},elements:{rectangle:{borderSkipped:"left"}},tooltips:{callbacks:{title:function(t,e){var i="";return 0<t.length&&(t[0].yLabel?i=t[0].yLabel:0<e.labels.length&&t[0].index<e.labels.length&&(i=e.labels[t[0].index])),i},label:function(t,e){return(e.datasets[t.datasetIndex].label||"")+": "+t.xLabel}},mode:"index",axis:"y"}}),e.exports=function(e){e.controllers.bar=e.DatasetController.extend({dataElementType:a.Rectangle,initialize:function(){var t;e.DatasetController.prototype.initialize.apply(this,arguments),(t=this.getMeta()).stack=this.getDataset().stack,t.bar=!0},update:function(t){var e,i,n=this.getMeta().data;for(this._ruler=this.getRuler(),e=0,i=n.length;e<i;++e)this.updateElement(n[e],e,t)},updateElement:function(t,e,i){var n=this,a=n.chart,o=n.getMeta(),r=n.getDataset(),s=t.custom||{},l=a.options.elements.rectangle;t._xScale=n.getScaleForId(o.xAxisID),t._yScale=n.getScaleForId(o.yAxisID),t._datasetIndex=n.index,t._index=e,t._model={datasetLabel:r.label,label:a.data.labels[e],borderSkipped:s.borderSkipped?s.borderSkipped:l.borderSkipped,backgroundColor:s.backgroundColor?s.backgroundColor:S.valueAtIndexOrDefault(r.backgroundColor,e,l.backgroundColor),borderColor:s.borderColor?s.borderColor:S.valueAtIndexOrDefault(r.borderColor,e,l.borderColor),borderWidth:s.borderWidth?s.borderWidth:S.valueAtIndexOrDefault(r.borderWidth,e,l.borderWidth)},n.updateElementGeometry(t,e,i),t.pivot()},updateElementGeometry:function(t,e,i){var n=this,a=t._model,o=n.getValueScale(),r=o.getBasePixel(),s=o.isHorizontal(),l=n._ruler||n.getRuler(),u=n.calculateBarValuePixels(n.index,e),d=n.calculateBarIndexPixels(n.index,e,l);a.horizontal=s,a.base=i?r:u.base,a.x=s?i?r:u.head:d.center,a.y=s?d.center:i?r:u.head,a.height=s?d.size:void 0,a.width=s?void 0:d.size},getValueScaleId:function(){return this.getMeta().yAxisID},getIndexScaleId:function(){return this.getMeta().xAxisID},getValueScale:function(){return this.getScaleForId(this.getValueScaleId())},getIndexScale:function(){return this.getScaleForId(this.getIndexScaleId())},_getStacks:function(t){var e,i,n=this.chart,a=this.getIndexScale().options.stacked,o=void 0===t?n.data.datasets.length:t+1,r=[];for(e=0;e<o;++e)(i=n.getDatasetMeta(e)).bar&&n.isDatasetVisible(e)&&(!1===a||!0===a&&-1===r.indexOf(i.stack)||void 0===a&&(void 0===i.stack||-1===r.indexOf(i.stack)))&&r.push(i.stack);return r},getStackCount:function(){return this._getStacks().length},getStackIndex:function(t,e){var i=this._getStacks(t),n=void 0!==e?i.indexOf(e):-1;return-1===n?i.length-1:n},getRuler:function(){var t,e,i=this.getIndexScale(),n=this.getStackCount(),a=this.index,o=i.isHorizontal(),r=o?i.left:i.top,s=r+(o?i.width:i.height),l=[];for(t=0,e=this.getMeta().data.length;t<e;++t)l.push(i.getPixelForValue(null,t,a));return{min:S.isNullOrUndef(i.options.barThickness)?function(t,e){var i,n,a,o,r=t.isHorizontal()?t.width:t.height,s=t.getTicks();for(a=1,o=e.length;a<o;++a)r=Math.min(r,e[a]-e[a-1]);for(a=0,o=s.length;a<o;++a)n=t.getPixelForTick(a),r=0<a?Math.min(r,n-i):r,i=n;return r}(i,l):-1,pixels:l,start:r,end:s,stackCount:n,scale:i}},calculateBarValuePixels:function(t,e){var i,n,a,o,r,s,l=this.chart,u=this.getMeta(),d=this.getValueScale(),c=l.data.datasets,h=d.getRightValue(c[t].data[e]),f=d.options.stacked,g=u.stack,p=0;if(f||void 0===f&&void 0!==g)for(i=0;i<t;++i)(n=l.getDatasetMeta(i)).bar&&n.stack===g&&n.controller.getValueScaleId()===d.id&&l.isDatasetVisible(i)&&(a=d.getRightValue(c[i].data[e]),(h<0&&a<0||0<=h&&0<a)&&(p+=a));return o=d.getPixelForValue(p),{size:s=((r=d.getPixelForValue(p+h))-o)/2,base:o,head:r,center:r+s/2}},calculateBarIndexPixels:function(t,e,i){var n,a,o,r,s,l,u,d,c,h,f,g,p,m,v,b,x,y=i.scale.options,k="flex"===y.barThickness?(c=e,f=y,p=(h=i).pixels,m=p[c],v=0<c?p[c-1]:null,b=c<p.length-1?p[c+1]:null,x=f.categoryPercentage,null===v&&(v=m-(null===b?h.end-m:b-m)),null===b&&(b=m+m-v),g=m-(m-v)/2*x,{chunk:(b-v)/2*x/h.stackCount,ratio:f.barPercentage,start:g}):(n=e,a=i,l=(o=y).barThickness,u=a.stackCount,d=a.pixels[n],s=S.isNullOrUndef(l)?(r=a.min*o.categoryPercentage,o.barPercentage):(r=l*u,1),{chunk:r/u,ratio:s,start:d-r/2}),M=this.getStackIndex(t,this.getMeta().stack),w=k.start+k.chunk*M+k.chunk/2,C=Math.min(S.valueOrDefault(y.maxBarThickness,1/0),k.chunk*k.ratio);return{base:w-C/2,head:w+C/2,center:w,size:C}},draw:function(){var t=this.chart,e=this.getValueScale(),i=this.getMeta().data,n=this.getDataset(),a=i.length,o=0;for(S.canvas.clipArea(t.ctx,t.chartArea);o<a;++o)isNaN(e.getRightValue(n.data[o]))||i[o].draw();S.canvas.unclipArea(t.ctx)}}),e.controllers.horizontalBar=e.controllers.bar.extend({getValueScaleId:function(){return this.getMeta().xAxisID},getIndexScaleId:function(){return this.getMeta().yAxisID}})}},{26:26,41:41,46:46}],16:[function(t,e,i){"use strict";var n=t(26),a=t(41),g=t(46);n._set("bubble",{hover:{mode:"single"},scales:{xAxes:[{type:"linear",position:"bottom",id:"x-axis-0"}],yAxes:[{type:"linear",position:"left",id:"y-axis-0"}]},tooltips:{callbacks:{title:function(){return""},label:function(t,e){var i=e.datasets[t.datasetIndex].label||"",n=e.datasets[t.datasetIndex].data[t.index];return i+": ("+t.xLabel+", "+t.yLabel+", "+n.r+")"}}}}),e.exports=function(t){t.controllers.bubble=t.DatasetController.extend({dataElementType:a.Point,update:function(i){var n=this,t=n.getMeta().data;g.each(t,function(t,e){n.updateElement(t,e,i)})},updateElement:function(t,e,i){var n=this,a=n.getMeta(),o=t.custom||{},r=n.getScaleForId(a.xAxisID),s=n.getScaleForId(a.yAxisID),l=n._resolveElementOptions(t,e),u=n.getDataset().data[e],d=n.index,c=i?r.getPixelForDecimal(.5):r.getPixelForValue("object"==typeof u?u:NaN,e,d),h=i?s.getBasePixel():s.getPixelForValue(u,e,d);t._xScale=r,t._yScale=s,t._options=l,t._datasetIndex=d,t._index=e,t._model={backgroundColor:l.backgroundColor,borderColor:l.borderColor,borderWidth:l.borderWidth,hitRadius:l.hitRadius,pointStyle:l.pointStyle,rotation:l.rotation,radius:i?0:l.radius,skip:o.skip||isNaN(c)||isNaN(h),x:c,y:h},t.pivot()},setHoverStyle:function(t){var e=t._model,i=t._options;t.$previousStyle={backgroundColor:e.backgroundColor,borderColor:e.borderColor,borderWidth:e.borderWidth,radius:e.radius},e.backgroundColor=g.valueOrDefault(i.hoverBackgroundColor,g.getHoverColor(i.backgroundColor)),e.borderColor=g.valueOrDefault(i.hoverBorderColor,g.getHoverColor(i.borderColor)),e.borderWidth=g.valueOrDefault(i.hoverBorderWidth,i.borderWidth),e.radius=i.radius+i.hoverRadius},_resolveElementOptions:function(t,e){var i,n,a,o=this.chart,r=o.data.datasets[this.index],s=t.custom||{},l=o.options.elements.point,u=g.options.resolve,d=r.data[e],c={},h={chart:o,dataIndex:e,dataset:r,datasetIndex:this.index},f=["backgroundColor","borderColor","borderWidth","hoverBackgroundColor","hoverBorderColor","hoverBorderWidth","hoverRadius","hitRadius","pointStyle","rotation"];for(i=0,n=f.length;i<n;++i)c[a=f[i]]=u([s[a],r[a],l[a]],h,e);return c.radius=u([s.radius,d?d.r:void 0,r.radius,l.radius],h,e),c}})}},{26:26,41:41,46:46}],17:[function(t,e,i){"use strict";var n=t(26),a=t(41),A=t(46);n._set("doughnut",{animation:{animateRotate:!0,animateScale:!1},hover:{mode:"single"},legendCallback:function(t){var e=[];e.push('<ul class="'+t.id+'-legend">');var i=t.data,n=i.datasets,a=i.labels;if(n.length)for(var o=0;o<n[0].data.length;++o)e.push('<li><span style="background-color:'+n[0].backgroundColor[o]+'"></span>'),a[o]&&e.push(a[o]),e.push("</li>");return e.push("</ul>"),e.join("")},legend:{labels:{generateLabels:function(l){var u=l.data;return u.labels.length&&u.datasets.length?u.labels.map(function(t,e){var i=l.getDatasetMeta(0),n=u.datasets[0],a=i.data[e],o=a&&a.custom||{},r=A.valueAtIndexOrDefault,s=l.options.elements.arc;return{text:t,fillStyle:o.backgroundColor?o.backgroundColor:r(n.backgroundColor,e,s.backgroundColor),strokeStyle:o.borderColor?o.borderColor:r(n.borderColor,e,s.borderColor),lineWidth:o.borderWidth?o.borderWidth:r(n.borderWidth,e,s.borderWidth),hidden:isNaN(n.data[e])||i.data[e].hidden,index:e}}):[]}},onClick:function(t,e){var i,n,a,o=e.index,r=this.chart;for(i=0,n=(r.data.datasets||[]).length;i<n;++i)(a=r.getDatasetMeta(i)).data[o]&&(a.data[o].hidden=!a.data[o].hidden);r.update()}},cutoutPercentage:50,rotation:-.5*Math.PI,circumference:2*Math.PI,tooltips:{callbacks:{title:function(){return""},label:function(t,e){var i=e.labels[t.index],n=": "+e.datasets[t.datasetIndex].data[t.index];return A.isArray(i)?(i=i.slice())[0]+=n:i+=n,i}}}}),n._set("pie",A.clone(n.doughnut)),n._set("pie",{cutoutPercentage:0}),e.exports=function(t){t.controllers.doughnut=t.controllers.pie=t.DatasetController.extend({dataElementType:a.Arc,linkScales:A.noop,getRingIndex:function(t){for(var e=0,i=0;i<t;++i)this.chart.isDatasetVisible(i)&&++e;return e},update:function(i){var n=this,t=n.chart,e=t.chartArea,a=t.options,o=a.elements.arc,r=e.right-e.left-o.borderWidth,s=e.bottom-e.top-o.borderWidth,l=Math.min(r,s),u={x:0,y:0},d=n.getMeta(),c=a.cutoutPercentage,h=a.circumference;if(h<2*Math.PI){var f=a.rotation%(2*Math.PI),g=(f+=2*Math.PI*(f>=Math.PI?-1:f<-Math.PI?1:0))+h,p=Math.cos(f),m=Math.sin(f),v=Math.cos(g),b=Math.sin(g),x=f<=0&&0<=g||f<=2*Math.PI&&2*Math.PI<=g,y=f<=.5*Math.PI&&.5*Math.PI<=g||f<=2.5*Math.PI&&2.5*Math.PI<=g,k=f<=-Math.PI&&-Math.PI<=g||f<=Math.PI&&Math.PI<=g,M=f<=.5*-Math.PI&&.5*-Math.PI<=g||f<=1.5*Math.PI&&1.5*Math.PI<=g,w=c/100,C=k?-1:Math.min(p*(p<0?1:w),v*(v<0?1:w)),S=M?-1:Math.min(m*(m<0?1:w),b*(b<0?1:w)),_=x?1:Math.max(p*(0<p?1:w),v*(0<v?1:w)),D=y?1:Math.max(m*(0<m?1:w),b*(0<b?1:w)),P=.5*(_-C),I=.5*(D-S);l=Math.min(r/P,s/I),u={x:-.5*(_+C),y:-.5*(D+S)}}t.borderWidth=n.getMaxBorderWidth(d.data),t.outerRadius=Math.max((l-t.borderWidth)/2,0),t.innerRadius=Math.max(c?t.outerRadius/100*c:0,0),t.radiusLength=(t.outerRadius-t.innerRadius)/t.getVisibleDatasetCount(),t.offsetX=u.x*t.outerRadius,t.offsetY=u.y*t.outerRadius,d.total=n.calculateTotal(),n.outerRadius=t.outerRadius-t.radiusLength*n.getRingIndex(n.index),n.innerRadius=Math.max(n.outerRadius-t.radiusLength,0),A.each(d.data,function(t,e){n.updateElement(t,e,i)})},updateElement:function(t,e,i){var n=this,a=n.chart,o=a.chartArea,r=a.options,s=r.animation,l=(o.left+o.right)/2,u=(o.top+o.bottom)/2,d=r.rotation,c=r.rotation,h=n.getDataset(),f=i&&s.animateRotate?0:t.hidden?0:n.calculateCircumference(h.data[e])*(r.circumference/(2*Math.PI)),g=i&&s.animateScale?0:n.innerRadius,p=i&&s.animateScale?0:n.outerRadius,m=A.valueAtIndexOrDefault;A.extend(t,{_datasetIndex:n.index,_index:e,_model:{x:l+a.offsetX,y:u+a.offsetY,startAngle:d,endAngle:c,circumference:f,outerRadius:p,innerRadius:g,label:m(h.label,e,a.data.labels[e])}});var v=t._model,b=t.custom||{},x=A.valueAtIndexOrDefault,y=this.chart.options.elements.arc;v.backgroundColor=b.backgroundColor?b.backgroundColor:x(h.backgroundColor,e,y.backgroundColor),v.borderColor=b.borderColor?b.borderColor:x(h.borderColor,e,y.borderColor),v.borderWidth=b.borderWidth?b.borderWidth:x(h.borderWidth,e,y.borderWidth),i&&s.animateRotate||(v.startAngle=0===e?r.rotation:n.getMeta().data[e-1]._model.endAngle,v.endAngle=v.startAngle+v.circumference),t.pivot()},calculateTotal:function(){var i,n=this.getDataset(),t=this.getMeta(),a=0;return A.each(t.data,function(t,e){i=n.data[e],isNaN(i)||t.hidden||(a+=Math.abs(i))}),a},calculateCircumference:function(t){var e=this.getMeta().total;return 0<e&&!isNaN(t)?2*Math.PI*(Math.abs(t)/e):0},getMaxBorderWidth:function(t){for(var e,i,n=0,a=this.index,o=t.length,r=0;r<o;r++)n=(n=n<(e=t[r]._model?t[r]._model.borderWidth:0)?e:n)<(i=t[r]._chart?t[r]._chart.config.data.datasets[a].hoverBorderWidth:0)?i:n;return n}})}},{26:26,41:41,46:46}],18:[function(t,e,i){"use strict";var n=t(26),a=t(41),g=t(46);n._set("line",{showLines:!0,spanGaps:!1,hover:{mode:"label"},scales:{xAxes:[{type:"category",id:"x-axis-0"}],yAxes:[{type:"linear",id:"y-axis-0"}]}}),e.exports=function(t){function f(t,e){return g.valueOrDefault(t.showLine,e.showLines)}t.controllers.line=t.DatasetController.extend({datasetElementType:a.Line,dataElementType:a.Point,update:function(t){var e,i,n,a=this,o=a.getMeta(),r=o.dataset,s=o.data||[],l=a.chart.options,u=l.elements.line,d=a.getScaleForId(o.yAxisID),c=a.getDataset(),h=f(c,l);for(h&&(n=r.custom||{},void 0!==c.tension&&void 0===c.lineTension&&(c.lineTension=c.tension),r._scale=d,r._datasetIndex=a.index,r._children=s,r._model={spanGaps:c.spanGaps?c.spanGaps:l.spanGaps,tension:n.tension?n.tension:g.valueOrDefault(c.lineTension,u.tension),backgroundColor:n.backgroundColor?n.backgroundColor:c.backgroundColor||u.backgroundColor,borderWidth:n.borderWidth?n.borderWidth:c.borderWidth||u.borderWidth,borderColor:n.borderColor?n.borderColor:c.borderColor||u.borderColor,borderCapStyle:n.borderCapStyle?n.borderCapStyle:c.borderCapStyle||u.borderCapStyle,borderDash:n.borderDash?n.borderDash:c.borderDash||u.borderDash,borderDashOffset:n.borderDashOffset?n.borderDashOffset:c.borderDashOffset||u.borderDashOffset,borderJoinStyle:n.borderJoinStyle?n.borderJoinStyle:c.borderJoinStyle||u.borderJoinStyle,fill:n.fill?n.fill:void 0!==c.fill?c.fill:u.fill,steppedLine:n.steppedLine?n.steppedLine:g.valueOrDefault(c.steppedLine,u.stepped),cubicInterpolationMode:n.cubicInterpolationMode?n.cubicInterpolationMode:g.valueOrDefault(c.cubicInterpolationMode,u.cubicInterpolationMode)},r.pivot()),e=0,i=s.length;e<i;++e)a.updateElement(s[e],e,t);for(h&&0!==r._model.tension&&a.updateBezierControlPoints(),e=0,i=s.length;e<i;++e)s[e].pivot()},getPointBackgroundColor:function(t,e){var i=this.chart.options.elements.point.backgroundColor,n=this.getDataset(),a=t.custom||{};return a.backgroundColor?i=a.backgroundColor:n.pointBackgroundColor?i=g.valueAtIndexOrDefault(n.pointBackgroundColor,e,i):n.backgroundColor&&(i=n.backgroundColor),i},getPointBorderColor:function(t,e){var i=this.chart.options.elements.point.borderColor,n=this.getDataset(),a=t.custom||{};return a.borderColor?i=a.borderColor:n.pointBorderColor?i=g.valueAtIndexOrDefault(n.pointBorderColor,e,i):n.borderColor&&(i=n.borderColor),i},getPointBorderWidth:function(t,e){var i=this.chart.options.elements.point.borderWidth,n=this.getDataset(),a=t.custom||{};return isNaN(a.borderWidth)?!isNaN(n.pointBorderWidth)||g.isArray(n.pointBorderWidth)?i=g.valueAtIndexOrDefault(n.pointBorderWidth,e,i):isNaN(n.borderWidth)||(i=n.borderWidth):i=a.borderWidth,i},getPointRotation:function(t,e){var i=this.chart.options.elements.point.rotation,n=this.getDataset(),a=t.custom||{};return isNaN(a.rotation)?isNaN(n.pointRotation)&&!g.isArray(n.pointRotation)||(i=g.valueAtIndexOrDefault(n.pointRotation,e,i)):i=a.rotation,i},updateElement:function(t,e,i){var n,a,o=this,r=o.getMeta(),s=t.custom||{},l=o.getDataset(),u=o.index,d=l.data[e],c=o.getScaleForId(r.yAxisID),h=o.getScaleForId(r.xAxisID),f=o.chart.options.elements.point;void 0!==l.radius&&void 0===l.pointRadius&&(l.pointRadius=l.radius),void 0!==l.hitRadius&&void 0===l.pointHitRadius&&(l.pointHitRadius=l.hitRadius),n=h.getPixelForValue("object"==typeof d?d:NaN,e,u),a=i?c.getBasePixel():o.calculatePointY(d,e,u),t._xScale=h,t._yScale=c,t._datasetIndex=u,t._index=e,t._model={x:n,y:a,skip:s.skip||isNaN(n)||isNaN(a),radius:s.radius||g.valueAtIndexOrDefault(l.pointRadius,e,f.radius),pointStyle:s.pointStyle||g.valueAtIndexOrDefault(l.pointStyle,e,f.pointStyle),rotation:o.getPointRotation(t,e),backgroundColor:o.getPointBackgroundColor(t,e),borderColor:o.getPointBorderColor(t,e),borderWidth:o.getPointBorderWidth(t,e),tension:r.dataset._model?r.dataset._model.tension:0,steppedLine:!!r.dataset._model&&r.dataset._model.steppedLine,hitRadius:s.hitRadius||g.valueAtIndexOrDefault(l.pointHitRadius,e,f.hitRadius)}},calculatePointY:function(t,e,i){var n,a,o,r=this.chart,s=this.getMeta(),l=this.getScaleForId(s.yAxisID),u=0,d=0;if(l.options.stacked){for(n=0;n<i;n++)if(a=r.data.datasets[n],"line"===(o=r.getDatasetMeta(n)).type&&o.yAxisID===l.id&&r.isDatasetVisible(n)){var c=Number(l.getRightValue(a.data[e]));c<0?d+=c||0:u+=c||0}var h=Number(l.getRightValue(t));return h<0?l.getPixelForValue(d+h):l.getPixelForValue(u+h)}return l.getPixelForValue(t)},updateBezierControlPoints:function(){function s(t,e,i){return Math.max(Math.min(t,i),e)}var t,e,i,n,a=this.getMeta(),o=this.chart.chartArea,r=a.data||[];if(a.dataset._model.spanGaps&&(r=r.filter(function(t){return!t._model.skip})),"monotone"===a.dataset._model.cubicInterpolationMode)g.splineCurveMonotone(r);else for(t=0,e=r.length;t<e;++t)i=r[t]._model,n=g.splineCurve(g.previousItem(r,t)._model,i,g.nextItem(r,t)._model,a.dataset._model.tension),i.controlPointPreviousX=n.previous.x,i.controlPointPreviousY=n.previous.y,i.controlPointNextX=n.next.x,i.controlPointNextY=n.next.y;if(this.chart.options.elements.line.capBezierPoints)for(t=0,e=r.length;t<e;++t)(i=r[t]._model).controlPointPreviousX=s(i.controlPointPreviousX,o.left,o.right),i.controlPointPreviousY=s(i.controlPointPreviousY,o.top,o.bottom),i.controlPointNextX=s(i.controlPointNextX,o.left,o.right),i.controlPointNextY=s(i.controlPointNextY,o.top,o.bottom)},draw:function(){var t,e=this.chart,i=this.getMeta(),n=i.data||[],a=e.chartArea,o=n.length,r=0;for(f(this.getDataset(),e.options)&&(t=(i.dataset._model.borderWidth||0)/2,g.canvas.clipArea(e.ctx,{left:a.left,right:a.right,top:a.top-t,bottom:a.bottom+t}),i.dataset.draw(),g.canvas.unclipArea(e.ctx));r<o;++r)n[r].draw(a)},setHoverStyle:function(t){var e=this.chart.data.datasets[t._datasetIndex],i=t._index,n=t.custom||{},a=t._model;t.$previousStyle={backgroundColor:a.backgroundColor,borderColor:a.borderColor,borderWidth:a.borderWidth,radius:a.radius},a.backgroundColor=n.hoverBackgroundColor||g.valueAtIndexOrDefault(e.pointHoverBackgroundColor,i,g.getHoverColor(a.backgroundColor)),a.borderColor=n.hoverBorderColor||g.valueAtIndexOrDefault(e.pointHoverBorderColor,i,g.getHoverColor(a.borderColor)),a.borderWidth=n.hoverBorderWidth||g.valueAtIndexOrDefault(e.pointHoverBorderWidth,i,a.borderWidth),a.radius=n.hoverRadius||g.valueAtIndexOrDefault(e.pointHoverRadius,i,this.chart.options.elements.point.hoverRadius)}})}},{26:26,41:41,46:46}],19:[function(t,e,i){"use strict";var n=t(26),a=t(41),k=t(46);n._set("polarArea",{scale:{type:"radialLinear",angleLines:{display:!1},gridLines:{circular:!0},pointLabels:{display:!1},ticks:{beginAtZero:!0}},animation:{animateRotate:!0,animateScale:!0},startAngle:-.5*Math.PI,legendCallback:function(t){var e=[];e.push('<ul class="'+t.id+'-legend">');var i=t.data,n=i.datasets,a=i.labels;if(n.length)for(var o=0;o<n[0].data.length;++o)e.push('<li><span style="background-color:'+n[0].backgroundColor[o]+'"></span>'),a[o]&&e.push(a[o]),e.push("</li>");return e.push("</ul>"),e.join("")},legend:{labels:{generateLabels:function(s){var l=s.data;return l.labels.length&&l.datasets.length?l.labels.map(function(t,e){var i=s.getDatasetMeta(0),n=l.datasets[0],a=i.data[e].custom||{},o=k.valueAtIndexOrDefault,r=s.options.elements.arc;return{text:t,fillStyle:a.backgroundColor?a.backgroundColor:o(n.backgroundColor,e,r.backgroundColor),strokeStyle:a.borderColor?a.borderColor:o(n.borderColor,e,r.borderColor),lineWidth:a.borderWidth?a.borderWidth:o(n.borderWidth,e,r.borderWidth),hidden:isNaN(n.data[e])||i.data[e].hidden,index:e}}):[]}},onClick:function(t,e){var i,n,a,o=e.index,r=this.chart;for(i=0,n=(r.data.datasets||[]).length;i<n;++i)(a=r.getDatasetMeta(i)).data[o].hidden=!a.data[o].hidden;r.update()}},tooltips:{callbacks:{title:function(){return""},label:function(t,e){return e.labels[t.index]+": "+t.yLabel}}}}),e.exports=function(t){t.controllers.polarArea=t.DatasetController.extend({dataElementType:a.Arc,linkScales:k.noop,update:function(i){var t,e,n,a=this,o=a.getDataset(),r=a.getMeta(),s=a.chart.options.startAngle||0,l=a._starts=[],u=a._angles=[];for(a._updateRadius(),r.count=a.countVisibleElements(),t=0,e=o.data.length;t<e;t++)l[t]=s,n=a._computeAngle(t),s+=u[t]=n;k.each(r.data,function(t,e){a.updateElement(t,e,i)})},_updateRadius:function(){var t=this,e=t.chart,i=e.chartArea,n=e.options,a=n.elements.arc,o=Math.min(i.right-i.left,i.bottom-i.top);e.outerRadius=Math.max((o-a.borderWidth/2)/2,0),e.innerRadius=Math.max(n.cutoutPercentage?e.outerRadius/100*n.cutoutPercentage:1,0),e.radiusLength=(e.outerRadius-e.innerRadius)/e.getVisibleDatasetCount(),t.outerRadius=e.outerRadius-e.radiusLength*t.index,t.innerRadius=t.outerRadius-e.radiusLength},updateElement:function(t,e,i){var n=this,a=n.chart,o=n.getDataset(),r=a.options,s=r.animation,l=a.scale,u=a.data.labels,d=l.xCenter,c=l.yCenter,h=r.startAngle,f=t.hidden?0:l.getDistanceFromCenterForValue(o.data[e]),g=n._starts[e],p=g+(t.hidden?0:n._angles[e]),m=s.animateScale?0:l.getDistanceFromCenterForValue(o.data[e]);k.extend(t,{_datasetIndex:n.index,_index:e,_scale:l,_model:{x:d,y:c,innerRadius:0,outerRadius:i?m:f,startAngle:i&&s.animateRotate?h:g,endAngle:i&&s.animateRotate?h:p,label:k.valueAtIndexOrDefault(u,e,u[e])}});var v=this.chart.options.elements.arc,b=t.custom||{},x=k.valueAtIndexOrDefault,y=t._model;y.backgroundColor=b.backgroundColor?b.backgroundColor:x(o.backgroundColor,e,v.backgroundColor),y.borderColor=b.borderColor?b.borderColor:x(o.borderColor,e,v.borderColor),y.borderWidth=b.borderWidth?b.borderWidth:x(o.borderWidth,e,v.borderWidth),t.pivot()},countVisibleElements:function(){var i=this.getDataset(),t=this.getMeta(),n=0;return k.each(t.data,function(t,e){isNaN(i.data[e])||t.hidden||n++}),n},_computeAngle:function(t){var e=this,i=this.getMeta().count,n=e.getDataset(),a=e.getMeta();if(isNaN(n.data[t])||a.data[t].hidden)return 0;var o={chart:e.chart,dataIndex:t,dataset:n,datasetIndex:e.index};return k.options.resolve([e.chart.options.elements.arc.angle,2*Math.PI/i],o,t)}})}},{26:26,41:41,46:46}],20:[function(t,e,i){"use strict";var n=t(26),a=t(41),u=t(46);n._set("radar",{scale:{type:"radialLinear"},elements:{line:{tension:0}}}),e.exports=function(t){t.controllers.radar=t.DatasetController.extend({datasetElementType:a.Line,dataElementType:a.Point,linkScales:u.noop,update:function(i){var n=this,t=n.getMeta(),e=t.dataset,a=t.data,o=e.custom||{},r=n.getDataset(),s=n.chart.options.elements.line,l=n.chart.scale;void 0!==r.tension&&void 0===r.lineTension&&(r.lineTension=r.tension),u.extend(t.dataset,{_datasetIndex:n.index,_scale:l,_children:a,_loop:!0,_model:{tension:o.tension?o.tension:u.valueOrDefault(r.lineTension,s.tension),backgroundColor:o.backgroundColor?o.backgroundColor:r.backgroundColor||s.backgroundColor,borderWidth:o.borderWidth?o.borderWidth:r.borderWidth||s.borderWidth,borderColor:o.borderColor?o.borderColor:r.borderColor||s.borderColor,fill:o.fill?o.fill:void 0!==r.fill?r.fill:s.fill,borderCapStyle:o.borderCapStyle?o.borderCapStyle:r.borderCapStyle||s.borderCapStyle,borderDash:o.borderDash?o.borderDash:r.borderDash||s.borderDash,borderDashOffset:o.borderDashOffset?o.borderDashOffset:r.borderDashOffset||s.borderDashOffset,borderJoinStyle:o.borderJoinStyle?o.borderJoinStyle:r.borderJoinStyle||s.borderJoinStyle}}),t.dataset.pivot(),u.each(a,function(t,e){n.updateElement(t,e,i)},n),n.updateBezierControlPoints()},updateElement:function(t,e,i){var n=this,a=t.custom||{},o=n.getDataset(),r=n.chart.scale,s=n.chart.options.elements.point,l=r.getPointPositionForValue(e,o.data[e]);void 0!==o.radius&&void 0===o.pointRadius&&(o.pointRadius=o.radius),void 0!==o.hitRadius&&void 0===o.pointHitRadius&&(o.pointHitRadius=o.hitRadius),u.extend(t,{_datasetIndex:n.index,_index:e,_scale:r,_model:{x:i?r.xCenter:l.x,y:i?r.yCenter:l.y,tension:a.tension?a.tension:u.valueOrDefault(o.lineTension,n.chart.options.elements.line.tension),radius:a.radius?a.radius:u.valueAtIndexOrDefault(o.pointRadius,e,s.radius),backgroundColor:a.backgroundColor?a.backgroundColor:u.valueAtIndexOrDefault(o.pointBackgroundColor,e,s.backgroundColor),borderColor:a.borderColor?a.borderColor:u.valueAtIndexOrDefault(o.pointBorderColor,e,s.borderColor),borderWidth:a.borderWidth?a.borderWidth:u.valueAtIndexOrDefault(o.pointBorderWidth,e,s.borderWidth),pointStyle:a.pointStyle?a.pointStyle:u.valueAtIndexOrDefault(o.pointStyle,e,s.pointStyle),rotation:a.rotation?a.rotation:u.valueAtIndexOrDefault(o.pointRotation,e,s.rotation),hitRadius:a.hitRadius?a.hitRadius:u.valueAtIndexOrDefault(o.pointHitRadius,e,s.hitRadius)}}),t._model.skip=a.skip?a.skip:isNaN(t._model.x)||isNaN(t._model.y)},updateBezierControlPoints:function(){var a=this.chart.chartArea,o=this.getMeta();u.each(o.data,function(t,e){var i=t._model,n=u.splineCurve(u.previousItem(o.data,e,!0)._model,i,u.nextItem(o.data,e,!0)._model,i.tension);i.controlPointPreviousX=Math.max(Math.min(n.previous.x,a.right),a.left),i.controlPointPreviousY=Math.max(Math.min(n.previous.y,a.bottom),a.top),i.controlPointNextX=Math.max(Math.min(n.next.x,a.right),a.left),i.controlPointNextY=Math.max(Math.min(n.next.y,a.bottom),a.top),t.pivot()})},setHoverStyle:function(t){var e=this.chart.data.datasets[t._datasetIndex],i=t.custom||{},n=t._index,a=t._model;t.$previousStyle={backgroundColor:a.backgroundColor,borderColor:a.borderColor,borderWidth:a.borderWidth,radius:a.radius},a.radius=i.hoverRadius?i.hoverRadius:u.valueAtIndexOrDefault(e.pointHoverRadius,n,this.chart.options.elements.point.hoverRadius),a.backgroundColor=i.hoverBackgroundColor?i.hoverBackgroundColor:u.valueAtIndexOrDefault(e.pointHoverBackgroundColor,n,u.getHoverColor(a.backgroundColor)),a.borderColor=i.hoverBorderColor?i.hoverBorderColor:u.valueAtIndexOrDefault(e.pointHoverBorderColor,n,u.getHoverColor(a.borderColor)),a.borderWidth=i.hoverBorderWidth?i.hoverBorderWidth:u.valueAtIndexOrDefault(e.pointHoverBorderWidth,n,a.borderWidth)}})}},{26:26,41:41,46:46}],21:[function(t,e,i){"use strict";t(26)._set("scatter",{hover:{mode:"single"},scales:{xAxes:[{id:"x-axis-1",type:"linear",position:"bottom"}],yAxes:[{id:"y-axis-1",type:"linear",position:"left"}]},showLines:!1,tooltips:{callbacks:{title:function(){return""},label:function(t){return"("+t.xLabel+", "+t.yLabel+")"}}}}),e.exports=function(t){t.controllers.scatter=t.controllers.line}},{26:26}],22:[function(t,e,i){"use strict";var n=t(27);i=e.exports=n.extend({chart:null,currentStep:0,numSteps:60,easing:"",render:null,onAnimationProgress:null,onAnimationComplete:null}),Object.defineProperty(i.prototype,"animationObject",{get:function(){return this}}),Object.defineProperty(i.prototype,"chartInstance",{get:function(){return this.chart},set:function(t){this.chart=t}})},{27:27}],23:[function(t,e,i){"use strict";var n=t(26),o=t(46);n._set("global",{animation:{duration:1e3,easing:"easeOutQuart",onProgress:o.noop,onComplete:o.noop}}),e.exports={frameDuration:17,animations:[],dropFrames:0,request:null,addAnimation:function(t,e,i,n){var a,o,r=this.animations;for(e.chart=t,n||(t.animating=!0),a=0,o=r.length;a<o;++a)if(r[a].chart===t)return void(r[a]=e);r.push(e),1===r.length&&this.requestAnimationFrame()},cancelAnimation:function(e){var t=o.findIndex(this.animations,function(t){return t.chart===e});-1!==t&&(this.animations.splice(t,1),e.animating=!1)},requestAnimationFrame:function(){var t=this;null===t.request&&(t.request=o.requestAnimFrame.call(window,function(){t.request=null,t.startDigest()}))},startDigest:function(){var t=this,e=Date.now(),i=0;1<t.dropFrames&&(i=Math.floor(t.dropFrames),t.dropFrames=t.dropFrames%1),t.advance(1+i);var n=Date.now();t.dropFrames+=(n-e)/t.frameDuration,0<t.animations.length&&t.requestAnimationFrame()},advance:function(t){for(var e,i,n=this.animations,a=0;a<n.length;)i=(e=n[a]).chart,e.currentStep=(e.currentStep||0)+t,e.currentStep=Math.min(e.currentStep,e.numSteps),o.callback(e.render,[i,e],i),o.callback(e.onAnimationProgress,[e],i),e.currentStep>=e.numSteps?(o.callback(e.onAnimationComplete,[e],i),i.animating=!1,n.splice(a,1)):++a}}},{26:26,46:46}],24:[function(t,e,i){"use strict";var s=t(22),l=t(23),c=t(26),h=t(46),a=t(29),o=t(31),f=t(49),g=t(32),p=t(34),n=t(36);e.exports=function(u){function d(t){return"top"===t||"bottom"===t}u.types={},u.instances={},u.controllers={},h.extend(u.prototype,{construct:function(t,e){var i,n,a=this;(n=(i=(i=e)||{}).data=i.data||{}).datasets=n.datasets||[],n.labels=n.labels||[],i.options=h.configMerge(c.global,c[i.type],i.options||{}),e=i;var o=f.acquireContext(t,e),r=o&&o.canvas,s=r&&r.height,l=r&&r.width;a.id=h.uid(),a.ctx=o,a.canvas=r,a.config=e,a.width=l,a.height=s,a.aspectRatio=s?l/s:null,a.options=e.options,a._bufferedRender=!1,(a.chart=a).controller=a,u.instances[a.id]=a,Object.defineProperty(a,"data",{get:function(){return a.config.data},set:function(t){a.config.data=t}}),o&&r&&(a.initialize(),a.update())},initialize:function(){var t=this;return g.notify(t,"beforeInit"),h.retinaScale(t,t.options.devicePixelRatio),t.bindEvents(),t.options.responsive&&t.resize(!0),t.ensureScalesHaveIDs(),t.buildOrUpdateScales(),t.initToolTip(),g.notify(t,"afterInit"),t},clear:function(){return h.canvas.clear(this),this},stop:function(){return l.cancelAnimation(this),this},resize:function(t){var e=this,i=e.options,n=e.canvas,a=i.maintainAspectRatio&&e.aspectRatio||null,o=Math.max(0,Math.floor(h.getMaximumWidth(n))),r=Math.max(0,Math.floor(a?o/a:h.getMaximumHeight(n)));if((e.width!==o||e.height!==r)&&(n.width=e.width=o,n.height=e.height=r,n.style.width=o+"px",n.style.height=r+"px",h.retinaScale(e,i.devicePixelRatio),!t)){var s={width:o,height:r};g.notify(e,"resize",[s]),e.options.onResize&&e.options.onResize(e,s),e.stop(),e.update({duration:e.options.responsiveAnimationDuration})}},ensureScalesHaveIDs:function(){var t=this.options,e=t.scales||{},i=t.scale;h.each(e.xAxes,function(t,e){t.id=t.id||"x-axis-"+e}),h.each(e.yAxes,function(t,e){t.id=t.id||"y-axis-"+e}),i&&(i.id=i.id||"scale")},buildOrUpdateScales:function(){var r=this,t=r.options,s=r.scales||{},e=[],l=Object.keys(s).reduce(function(t,e){return t[e]=!1,t},{});t.scales&&(e=e.concat((t.scales.xAxes||[]).map(function(t){return{options:t,dtype:"category",dposition:"bottom"}}),(t.scales.yAxes||[]).map(function(t){return{options:t,dtype:"linear",dposition:"left"}}))),t.scale&&e.push({options:t.scale,dtype:"radialLinear",isDefault:!0,dposition:"chartArea"}),h.each(e,function(t){var e=t.options,i=e.id,n=h.valueOrDefault(e.type,t.dtype);d(e.position)!==d(t.dposition)&&(e.position=t.dposition),l[i]=!0;var a=null;if(i in s&&s[i].type===n)(a=s[i]).options=e,a.ctx=r.ctx,a.chart=r;else{var o=p.getScaleConstructor(n);if(!o)return;a=new o({id:i,type:n,options:e,ctx:r.ctx,chart:r}),s[a.id]=a}a.mergeTicksOptions(),t.isDefault&&(r.scale=a)}),h.each(l,function(t,e){t||delete s[e]}),r.scales=s,p.addScalesToLayout(this)},buildOrUpdateControllers:function(){var o=this,r=[],s=[];return h.each(o.data.datasets,function(t,e){var i=o.getDatasetMeta(e),n=t.type||o.config.type;if(i.type&&i.type!==n&&(o.destroyDatasetMeta(e),i=o.getDatasetMeta(e)),i.type=n,r.push(i.type),i.controller)i.controller.updateIndex(e),i.controller.linkScales();else{var a=u.controllers[i.type];if(void 0===a)throw new Error('"'+i.type+'" is not a chart type.');i.controller=new a(o,e),s.push(i.controller)}},o),s},resetElements:function(){var i=this;h.each(i.data.datasets,function(t,e){i.getDatasetMeta(e).controller.reset()},i)},reset:function(){this.resetElements(),this.tooltip.initialize()},update:function(t){var e,i,n=this;if(t&&"object"==typeof t||(t={duration:t,lazy:arguments[1]}),i=(e=n).options,h.each(e.scales,function(t){o.removeBox(e,t)}),i=h.configMerge(u.defaults.global,u.defaults[e.config.type],i),e.options=e.config.options=i,e.ensureScalesHaveIDs(),e.buildOrUpdateScales(),e.tooltip._options=i.tooltips,e.tooltip.initialize(),g._invalidate(n),!1!==g.notify(n,"beforeUpdate")){n.tooltip._data=n.data;var a=n.buildOrUpdateControllers();h.each(n.data.datasets,function(t,e){n.getDatasetMeta(e).controller.buildOrUpdateElements()},n),n.updateLayout(),n.options.animation&&n.options.animation.duration&&h.each(a,function(t){t.reset()}),n.updateDatasets(),n.tooltip.initialize(),n.lastActive=[],g.notify(n,"afterUpdate"),n._bufferedRender?n._bufferedRequest={duration:t.duration,easing:t.easing,lazy:t.lazy}:n.render(t)}},updateLayout:function(){!1!==g.notify(this,"beforeLayout")&&(o.update(this,this.width,this.height),g.notify(this,"afterScaleUpdate"),g.notify(this,"afterLayout"))},updateDatasets:function(){if(!1!==g.notify(this,"beforeDatasetsUpdate")){for(var t=0,e=this.data.datasets.length;t<e;++t)this.updateDataset(t);g.notify(this,"afterDatasetsUpdate")}},updateDataset:function(t){var e=this.getDatasetMeta(t),i={meta:e,index:t};!1!==g.notify(this,"beforeDatasetUpdate",[i])&&(e.controller.update(),g.notify(this,"afterDatasetUpdate",[i]))},render:function(t){var e=this;t&&"object"==typeof t||(t={duration:t,lazy:arguments[1]});var i=t.duration,n=t.lazy;if(!1!==g.notify(e,"beforeRender")){var a=e.options.animation,o=function(t){g.notify(e,"afterRender"),h.callback(a&&a.onComplete,[t],e)};if(a&&(void 0!==i&&0!==i||void 0===i&&0!==a.duration)){var r=new s({numSteps:(i||a.duration)/16.66,easing:t.easing||a.easing,render:function(t,e){var i=h.easing.effects[e.easing],n=e.currentStep,a=n/e.numSteps;t.draw(i(a),a,n)},onAnimationProgress:a.onProgress,onAnimationComplete:o});l.addAnimation(e,r,i,n)}else e.draw(),o(new s({numSteps:0,chart:e}));return e}},draw:function(t){var e=this;e.clear(),h.isNullOrUndef(t)&&(t=1),e.transition(t),e.width<=0||e.height<=0||!1!==g.notify(e,"beforeDraw",[t])&&(h.each(e.boxes,function(t){t.draw(e.chartArea)},e),e.scale&&e.scale.draw(),e.drawDatasets(t),e._drawTooltip(t),g.notify(e,"afterDraw",[t]))},transition:function(t){for(var e=0,i=(this.data.datasets||[]).length;e<i;++e)this.isDatasetVisible(e)&&this.getDatasetMeta(e).controller.transition(t);this.tooltip.transition(t)},drawDatasets:function(t){var e=this;if(!1!==g.notify(e,"beforeDatasetsDraw",[t])){for(var i=(e.data.datasets||[]).length-1;0<=i;--i)e.isDatasetVisible(i)&&e.drawDataset(i,t);g.notify(e,"afterDatasetsDraw",[t])}},drawDataset:function(t,e){var i=this.getDatasetMeta(t),n={meta:i,index:t,easingValue:e};!1!==g.notify(this,"beforeDatasetDraw",[n])&&(i.controller.draw(e),g.notify(this,"afterDatasetDraw",[n]))},_drawTooltip:function(t){var e=this.tooltip,i={tooltip:e,easingValue:t};!1!==g.notify(this,"beforeTooltipDraw",[i])&&(e.draw(),g.notify(this,"afterTooltipDraw",[i]))},getElementAtEvent:function(t){return a.modes.single(this,t)},getElementsAtEvent:function(t){return a.modes.label(this,t,{intersect:!0})},getElementsAtXAxis:function(t){return a.modes["x-axis"](this,t,{intersect:!0})},getElementsAtEventForMode:function(t,e,i){var n=a.modes[e];return"function"==typeof n?n(this,t,i):[]},getDatasetAtEvent:function(t){return a.modes.dataset(this,t,{intersect:!0})},getDatasetMeta:function(t){var e=this.data.datasets[t];e._meta||(e._meta={});var i=e._meta[this.id];return i||(i=e._meta[this.id]={type:null,data:[],dataset:null,controller:null,hidden:null,xAxisID:null,yAxisID:null}),i},getVisibleDatasetCount:function(){for(var t=0,e=0,i=this.data.datasets.length;e<i;++e)this.isDatasetVisible(e)&&t++;return t},isDatasetVisible:function(t){var e=this.getDatasetMeta(t);return"boolean"==typeof e.hidden?!e.hidden:!this.data.datasets[t].hidden},generateLegend:function(){return this.options.legendCallback(this)},destroyDatasetMeta:function(t){var e=this.id,i=this.data.datasets[t],n=i._meta&&i._meta[e];n&&(n.controller.destroy(),delete i._meta[e])},destroy:function(){var t,e,i=this,n=i.canvas;for(i.stop(),t=0,e=i.data.datasets.length;t<e;++t)i.destroyDatasetMeta(t);n&&(i.unbindEvents(),h.canvas.clear(i),f.releaseContext(i.ctx),i.canvas=null,i.ctx=null),g.notify(i,"destroy"),delete u.instances[i.id]},toBase64Image:function(){return this.canvas.toDataURL.apply(this.canvas,arguments)},initToolTip:function(){var t=this;t.tooltip=new n({_chart:t,_chartInstance:t,_data:t.data,_options:t.options.tooltips},t)},bindEvents:function(){var e=this,i=e._listeners={},n=function(){e.eventHandler.apply(e,arguments)};h.each(e.options.events,function(t){f.addEventListener(e,t,n),i[t]=n}),e.options.responsive&&(n=function(){e.resize()},f.addEventListener(e,"resize",n),i.resize=n)},unbindEvents:function(){var i=this,t=i._listeners;t&&(delete i._listeners,h.each(t,function(t,e){f.removeEventListener(i,e,t)}))},updateHoverStyle:function(t,e,i){var n,a,o,r=i?"setHoverStyle":"removeHoverStyle";for(a=0,o=t.length;a<o;++a)(n=t[a])&&this.getDatasetMeta(n._datasetIndex).controller[r](n)},eventHandler:function(t){var e=this,i=e.tooltip;if(!1!==g.notify(e,"beforeEvent",[t])){e._bufferedRender=!0,e._bufferedRequest=null;var n=e.handleEvent(t);i&&(n=i._start?i.handleEvent(t):n|i.handleEvent(t)),g.notify(e,"afterEvent",[t]);var a=e._bufferedRequest;return a?e.render(a):n&&!e.animating&&(e.stop(),e.render({duration:e.options.hover.animationDuration,lazy:!0})),e._bufferedRender=!1,e._bufferedRequest=null,e}},handleEvent:function(t){var e,i=this,n=i.options||{},a=n.hover;return i.lastActive=i.lastActive||[],"mouseout"===t.type?i.active=[]:i.active=i.getElementsAtEventForMode(t,a.mode,a),h.callback(n.onHover||n.hover.onHover,[t.native,i.active],i),"mouseup"!==t.type&&"click"!==t.type||n.onClick&&n.onClick.call(i,t.native,i.active),i.lastActive.length&&i.updateHoverStyle(i.lastActive,a.mode,!1),i.active.length&&a.mode&&i.updateHoverStyle(i.active,a.mode,!0),e=!h.arrayEquals(i.active,i.lastActive),i.lastActive=i.active,e}}),u.Controller=u}},{22:22,23:23,26:26,29:29,31:31,32:32,34:34,36:36,46:46,49:49}],25:[function(t,e,i){"use strict";var s=t(46);e.exports=function(t){function r(e,t){var i=e._chartjs;if(i){var n=i.listeners,a=n.indexOf(t);-1!==a&&n.splice(a,1),0<n.length||(o.forEach(function(t){delete e[t]}),delete e._chartjs)}}var o=["push","pop","shift","splice","unshift"];t.DatasetController=function(t,e){this.initialize(t,e)},s.extend(t.DatasetController.prototype,{datasetElementType:null,dataElementType:null,initialize:function(t,e){this.chart=t,this.index=e,this.linkScales(),this.addElements()},updateIndex:function(t){this.index=t},linkScales:function(){var t=this,e=t.getMeta(),i=t.getDataset();null!==e.xAxisID&&e.xAxisID in t.chart.scales||(e.xAxisID=i.xAxisID||t.chart.options.scales.xAxes[0].id),null!==e.yAxisID&&e.yAxisID in t.chart.scales||(e.yAxisID=i.yAxisID||t.chart.options.scales.yAxes[0].id)},getDataset:function(){return this.chart.data.datasets[this.index]},getMeta:function(){return this.chart.getDatasetMeta(this.index)},getScaleForId:function(t){return this.chart.scales[t]},reset:function(){this.update(!0)},destroy:function(){this._data&&r(this._data,this)},createMetaDataset:function(){var t=this.datasetElementType;return t&&new t({_chart:this.chart,_datasetIndex:this.index})},createMetaData:function(t){var e=this.dataElementType;return e&&new e({_chart:this.chart,_datasetIndex:this.index,_index:t})},addElements:function(){var t,e,i=this.getMeta(),n=this.getDataset().data||[],a=i.data;for(t=0,e=n.length;t<e;++t)a[t]=a[t]||this.createMetaData(t);i.dataset=i.dataset||this.createMetaDataset()},addElementAndReset:function(t){var e=this.createMetaData(t);this.getMeta().data.splice(t,0,e),this.updateElement(e,t,!0)},buildOrUpdateElements:function(){var a,t,e=this,i=e.getDataset(),n=i.data||(i.data=[]);e._data!==n&&(e._data&&r(e._data,e),t=e,(a=n)._chartjs?a._chartjs.listeners.push(t):(Object.defineProperty(a,"_chartjs",{configurable:!0,enumerable:!1,value:{listeners:[t]}}),o.forEach(function(t){var i="onData"+t.charAt(0).toUpperCase()+t.slice(1),n=a[t];Object.defineProperty(a,t,{configurable:!0,enumerable:!1,value:function(){var e=Array.prototype.slice.call(arguments),t=n.apply(this,e);return s.each(a._chartjs.listeners,function(t){"function"==typeof t[i]&&t[i].apply(t,e)}),t}})})),e._data=n),e.resyncElements()},update:s.noop,transition:function(t){for(var e=this.getMeta(),i=e.data||[],n=i.length,a=0;a<n;++a)i[a].transition(t);e.dataset&&e.dataset.transition(t)},draw:function(){var t=this.getMeta(),e=t.data||[],i=e.length,n=0;for(t.dataset&&t.dataset.draw();n<i;++n)e[n].draw()},removeHoverStyle:function(t){s.merge(t._model,t.$previousStyle||{}),delete t.$previousStyle},setHoverStyle:function(t){var e=this.chart.data.datasets[t._datasetIndex],i=t._index,n=t.custom||{},a=s.valueAtIndexOrDefault,o=s.getHoverColor,r=t._model;t.$previousStyle={backgroundColor:r.backgroundColor,borderColor:r.borderColor,borderWidth:r.borderWidth},r.backgroundColor=n.hoverBackgroundColor?n.hoverBackgroundColor:a(e.hoverBackgroundColor,i,o(r.backgroundColor)),r.borderColor=n.hoverBorderColor?n.hoverBorderColor:a(e.hoverBorderColor,i,o(r.borderColor)),r.borderWidth=n.hoverBorderWidth?n.hoverBorderWidth:a(e.hoverBorderWidth,i,r.borderWidth)},resyncElements:function(){var t=this.getMeta(),e=this.getDataset().data,i=t.data.length,n=e.length;n<i?t.data.splice(n,i-n):i<n&&this.insertElements(i,n-i)},insertElements:function(t,e){for(var i=0;i<e;++i)this.addElementAndReset(t+i)},onDataPush:function(){this.insertElements(this.getDataset().data.length-1,arguments.length)},onDataPop:function(){this.getMeta().data.pop()},onDataShift:function(){this.getMeta().data.shift()},onDataSplice:function(t,e){this.getMeta().data.splice(t,e),this.insertElements(t,arguments.length-2)},onDataUnshift:function(){this.insertElements(0,arguments.length)}}),t.DatasetController.extend=s.inherits}},{46:46}],26:[function(t,e,i){"use strict";var n=t(46);e.exports={_set:function(t,e){return n.merge(this[t]||(this[t]={}),e)}}},{46:46}],27:[function(t,e,i){"use strict";var g=t(3),n=t(46),a=function(t){n.extend(this,t),this.initialize.apply(this,arguments)};n.extend(a.prototype,{initialize:function(){this.hidden=!1},pivot:function(){var t=this;return t._view||(t._view=n.clone(t._model)),t._start={},t},transition:function(t){var e=this,i=e._model,n=e._start,a=e._view;return i&&1!==t?(a||(a=e._view={}),n||(n=e._start={}),function(t,e,i,n){var a,o,r,s,l,u,d,c,h,f=Object.keys(i);for(a=0,o=f.length;a<o;++a)if(u=i[r=f[a]],e.hasOwnProperty(r)||(e[r]=u),(s=e[r])!==u&&"_"!==r[0]){if(t.hasOwnProperty(r)||(t[r]=s),(d=typeof u)==typeof(l=t[r]))if("string"===d){if((c=g(l)).valid&&(h=g(u)).valid){e[r]=h.mix(c,n).rgbString();continue}}else if("number"===d&&isFinite(l)&&isFinite(u)){e[r]=l+(u-l)*n;continue}e[r]=u}}(n,a,i,t)):(e._view=i,e._start=null),e},tooltipPosition:function(){return{x:this._model.x,y:this._model.y}},hasValue:function(){return n.isNumber(this._model.x)&&n.isNumber(this._model.y)}}),a.extend=n.inherits,e.exports=a},{3:3,46:46}],28:[function(t,e,i){"use strict";var n=t(3),a=t(26),g=t(46),l=t(34);e.exports=function(){function d(t,e,i){var n;return"string"==typeof t?(n=parseInt(t,10),-1!==t.indexOf("%")&&(n=n/100*e.parentNode[i])):n=t,n}function c(t){return null!=t&&"none"!==t}function e(t,e,i){var n=document.defaultView,a=g._getParentNode(t),o=n.getComputedStyle(t)[e],r=n.getComputedStyle(a)[e],s=c(o),l=c(r),u=Number.POSITIVE_INFINITY;return s||l?Math.min(s?d(o,t,i):u,l?d(r,a,i):u):"none"}g.configMerge=function(){return g.merge(g.clone(arguments[0]),[].slice.call(arguments,1),{merger:function(t,e,i,n){var a=e[t]||{},o=i[t];"scales"===t?e[t]=g.scaleMerge(a,o):"scale"===t?e[t]=g.merge(a,[l.getScaleDefaults(o.type),o]):g._merger(t,e,i,n)}})},g.scaleMerge=function(){return g.merge(g.clone(arguments[0]),[].slice.call(arguments,1),{merger:function(t,e,i,n){if("xAxes"===t||"yAxes"===t){var a,o,r,s=i[t].length;for(e[t]||(e[t]=[]),a=0;a<s;++a)r=i[t][a],o=g.valueOrDefault(r.type,"xAxes"===t?"category":"linear"),a>=e[t].length&&e[t].push({}),!e[t][a].type||r.type&&r.type!==e[t][a].type?g.merge(e[t][a],[l.getScaleDefaults(o),r]):g.merge(e[t][a],r)}else g._merger(t,e,i,n)}})},g.where=function(t,e){if(g.isArray(t)&&Array.prototype.filter)return t.filter(e);var i=[];return g.each(t,function(t){e(t)&&i.push(t)}),i},g.findIndex=Array.prototype.findIndex?function(t,e,i){return t.findIndex(e,i)}:function(t,e,i){i=void 0===i?t:i;for(var n=0,a=t.length;n<a;++n)if(e.call(i,t[n],n,t))return n;return-1},g.findNextWhere=function(t,e,i){g.isNullOrUndef(i)&&(i=-1);for(var n=i+1;n<t.length;n++){var a=t[n];if(e(a))return a}},g.findPreviousWhere=function(t,e,i){g.isNullOrUndef(i)&&(i=t.length);for(var n=i-1;0<=n;n--){var a=t[n];if(e(a))return a}},g.isNumber=function(t){return!isNaN(parseFloat(t))&&isFinite(t)},g.almostEquals=function(t,e,i){return Math.abs(t-e)<i},g.almostWhole=function(t,e){var i=Math.round(t);return i-e<t&&t<i+e},g.max=function(t){return t.reduce(function(t,e){return isNaN(e)?t:Math.max(t,e)},Number.NEGATIVE_INFINITY)},g.min=function(t){return t.reduce(function(t,e){return isNaN(e)?t:Math.min(t,e)},Number.POSITIVE_INFINITY)},g.sign=Math.sign?function(t){return Math.sign(t)}:function(t){return 0==(t=+t)||isNaN(t)?t:0<t?1:-1},g.log10=Math.log10?function(t){return Math.log10(t)}:function(t){var e=Math.log(t)*Math.LOG10E,i=Math.round(e);return t===Math.pow(10,i)?i:e},g.toRadians=function(t){return t*(Math.PI/180)},g.toDegrees=function(t){return t*(180/Math.PI)},g.getAngleFromPoint=function(t,e){var i=e.x-t.x,n=e.y-t.y,a=Math.sqrt(i*i+n*n),o=Math.atan2(n,i);return o<-.5*Math.PI&&(o+=2*Math.PI),{angle:o,distance:a}},g.distanceBetweenPoints=function(t,e){return Math.sqrt(Math.pow(e.x-t.x,2)+Math.pow(e.y-t.y,2))},g.aliasPixel=function(t){return t%2==0?0:.5},g.splineCurve=function(t,e,i,n){var a=t.skip?e:t,o=e,r=i.skip?e:i,s=Math.sqrt(Math.pow(o.x-a.x,2)+Math.pow(o.y-a.y,2)),l=Math.sqrt(Math.pow(r.x-o.x,2)+Math.pow(r.y-o.y,2)),u=s/(s+l),d=l/(s+l),c=n*(u=isNaN(u)?0:u),h=n*(d=isNaN(d)?0:d);return{previous:{x:o.x-c*(r.x-a.x),y:o.y-c*(r.y-a.y)},next:{x:o.x+h*(r.x-a.x),y:o.y+h*(r.y-a.y)}}},g.EPSILON=Number.EPSILON||1e-14,g.splineCurveMonotone=function(t){var e,i,n,a,o,r,s,l,u,d=(t||[]).map(function(t){return{model:t._model,deltaK:0,mK:0}}),c=d.length;for(e=0;e<c;++e)if(!(n=d[e]).model.skip){if(i=0<e?d[e-1]:null,(a=e<c-1?d[e+1]:null)&&!a.model.skip){var h=a.model.x-n.model.x;n.deltaK=0!==h?(a.model.y-n.model.y)/h:0}!i||i.model.skip?n.mK=n.deltaK:!a||a.model.skip?n.mK=i.deltaK:this.sign(i.deltaK)!==this.sign(n.deltaK)?n.mK=0:n.mK=(i.deltaK+n.deltaK)/2}for(e=0;e<c-1;++e)n=d[e],a=d[e+1],n.model.skip||a.model.skip||(g.almostEquals(n.deltaK,0,this.EPSILON)?n.mK=a.mK=0:(o=n.mK/n.deltaK,r=a.mK/n.deltaK,(l=Math.pow(o,2)+Math.pow(r,2))<=9||(s=3/Math.sqrt(l),n.mK=o*s*n.deltaK,a.mK=r*s*n.deltaK)));for(e=0;e<c;++e)(n=d[e]).model.skip||(i=0<e?d[e-1]:null,a=e<c-1?d[e+1]:null,i&&!i.model.skip&&(u=(n.model.x-i.model.x)/3,n.model.controlPointPreviousX=n.model.x-u,n.model.controlPointPreviousY=n.model.y-u*n.mK),a&&!a.model.skip&&(u=(a.model.x-n.model.x)/3,n.model.controlPointNextX=n.model.x+u,n.model.controlPointNextY=n.model.y+u*n.mK))},g.nextItem=function(t,e,i){return i?e>=t.length-1?t[0]:t[e+1]:e>=t.length-1?t[t.length-1]:t[e+1]},g.previousItem=function(t,e,i){return i?e<=0?t[t.length-1]:t[e-1]:e<=0?t[0]:t[e-1]},g.niceNum=function(t,e){var i=Math.floor(g.log10(t)),n=t/Math.pow(10,i);return(e?n<1.5?1:n<3?2:n<7?5:10:n<=1?1:n<=2?2:n<=5?5:10)*Math.pow(10,i)},g.requestAnimFrame="undefined"==typeof window?function(t){t()}:window.requestAnimationFrame||window.webkitRequestAnimationFrame||window.mozRequestAnimationFrame||window.oRequestAnimationFrame||window.msRequestAnimationFrame||function(t){return window.setTimeout(t,1e3/60)},g.getRelativePosition=function(t,e){var i,n,a=t.originalEvent||t,o=t.target||t.srcElement,r=o.getBoundingClientRect(),s=a.touches;n=s&&0<s.length?(i=s[0].clientX,s[0].clientY):(i=a.clientX,a.clientY);var l=parseFloat(g.getStyle(o,"padding-left")),u=parseFloat(g.getStyle(o,"padding-top")),d=parseFloat(g.getStyle(o,"padding-right")),c=parseFloat(g.getStyle(o,"padding-bottom")),h=r.right-r.left-l-d,f=r.bottom-r.top-u-c;return{x:i=Math.round((i-r.left-l)/h*o.width/e.currentDevicePixelRatio),y:n=Math.round((n-r.top-u)/f*o.height/e.currentDevicePixelRatio)}},g.getConstraintWidth=function(t){return e(t,"max-width","clientWidth")},g.getConstraintHeight=function(t){return e(t,"max-height","clientHeight")},g._calculatePadding=function(t,e,i){return-1<(e=g.getStyle(t,e)).indexOf("%")?i/parseInt(e,10):parseInt(e,10)},g._getParentNode=function(t){var e=t.parentNode;return e&&e.host&&(e=e.host),e},g.getMaximumWidth=function(t){var e=g._getParentNode(t);if(!e)return t.clientWidth;var i=e.clientWidth,n=i-g._calculatePadding(e,"padding-left",i)-g._calculatePadding(e,"padding-right",i),a=g.getConstraintWidth(t);return isNaN(a)?n:Math.min(n,a)},g.getMaximumHeight=function(t){var e=g._getParentNode(t);if(!e)return t.clientHeight;var i=e.clientHeight,n=i-g._calculatePadding(e,"padding-top",i)-g._calculatePadding(e,"padding-bottom",i),a=g.getConstraintHeight(t);return isNaN(a)?n:Math.min(n,a)},g.getStyle=function(t,e){return t.currentStyle?t.currentStyle[e]:document.defaultView.getComputedStyle(t,null).getPropertyValue(e)},g.retinaScale=function(t,e){var i=t.currentDevicePixelRatio=e||"undefined"!=typeof window&&window.devicePixelRatio||1;if(1!==i){var n=t.canvas,a=t.height,o=t.width;n.height=a*i,n.width=o*i,t.ctx.scale(i,i),n.style.height||n.style.width||(n.style.height=a+"px",n.style.width=o+"px")}},g.fontString=function(t,e,i){return e+" "+t+"px "+i},g.longestText=function(e,t,i,n){var a=(n=n||{}).data=n.data||{},o=n.garbageCollect=n.garbageCollect||[];n.font!==t&&(a=n.data={},o=n.garbageCollect=[],n.font=t),e.font=t;var r=0;g.each(i,function(t){null!=t&&!0!==g.isArray(t)?r=g.measureText(e,a,o,r,t):g.isArray(t)&&g.each(t,function(t){null==t||g.isArray(t)||(r=g.measureText(e,a,o,r,t))})});var s=o.length/2;if(s>i.length){for(var l=0;l<s;l++)delete a[o[l]];o.splice(0,s)}return r},g.measureText=function(t,e,i,n,a){var o=e[a];return o||(o=e[a]=t.measureText(a).width,i.push(a)),n<o&&(n=o),n},g.numberOfLabelLines=function(t){var e=1;return g.each(t,function(t){g.isArray(t)&&t.length>e&&(e=t.length)}),e},g.color=n?function(t){return t instanceof CanvasGradient&&(t=a.global.defaultColor),n(t)}:function(t){return t},g.getHoverColor=function(t){return t instanceof CanvasPattern?t:g.color(t).saturate(.5).darken(.1).rgbString()}}},{26:26,3:3,34:34,46:46}],29:[function(t,e,i){"use strict";function s(t,e){return t.native?{x:t.x,y:t.y}:n.getRelativePosition(t,e)}function l(t,e){var i,n,a,o,r;for(n=0,o=t.data.datasets.length;n<o;++n)if(t.isDatasetVisible(n))for(a=0,r=(i=t.getDatasetMeta(n)).data.length;a<r;++a){var s=i.data[a];s._view.skip||e(s)}}function u(t,e){var i=[];return l(t,function(t){t.inRange(e.x,e.y)&&i.push(t)}),i}function d(t,n,a,o){var r=Number.POSITIVE_INFINITY,s=[];return l(t,function(t){if(!a||t.inRange(n.x,n.y)){var e=t.getCenterPoint(),i=o(n,e);i<r?(s=[t],r=i):i===r&&s.push(t)}}),s}function c(t){var a=-1!==t.indexOf("x"),o=-1!==t.indexOf("y");return function(t,e){var i=a?Math.abs(t.x-e.x):0,n=o?Math.abs(t.y-e.y):0;return Math.sqrt(Math.pow(i,2)+Math.pow(n,2))}}function a(n,t,e){var i=s(t,n);e.axis=e.axis||"x";var a=c(e.axis),o=e.intersect?u(n,i):d(n,i,!1,a),r=[];return o.length?(n.data.datasets.forEach(function(t,e){if(n.isDatasetVisible(e)){var i=n.getDatasetMeta(e).data[o[0]._index];i&&!i._view.skip&&r.push(i)}}),r):[]}var n=t(46);e.exports={modes:{single:function(t,e){var i=s(e,t),n=[];return l(t,function(t){if(t.inRange(i.x,i.y))return n.push(t),n}),n.slice(0,1)},label:a,index:a,dataset:function(t,e,i){var n=s(e,t);i.axis=i.axis||"xy";var a=c(i.axis),o=i.intersect?u(t,n):d(t,n,!1,a);return 0<o.length&&(o=t.getDatasetMeta(o[0]._datasetIndex).data),o},"x-axis":function(t,e){return a(t,e,{intersect:!1})},point:function(t,e){return u(t,s(e,t))},nearest:function(t,e,i){var n=s(e,t);i.axis=i.axis||"xy";var a=c(i.axis),o=d(t,n,i.intersect,a);return 1<o.length&&o.sort(function(t,e){var i=t.getArea()-e.getArea();return 0===i&&(i=t._datasetIndex-e._datasetIndex),i}),o.slice(0,1)},x:function(t,e,i){var n=s(e,t),a=[],o=!1;return l(t,function(t){t.inXRange(n.x)&&a.push(t),t.inRange(n.x,n.y)&&(o=!0)}),i.intersect&&!o&&(a=[]),a},y:function(t,e,i){var n=s(e,t),a=[],o=!1;return l(t,function(t){t.inYRange(n.y)&&a.push(t),t.inRange(n.x,n.y)&&(o=!0)}),i.intersect&&!o&&(a=[]),a}}}},{46:46}],30:[function(t,e,i){"use strict";t(26)._set("global",{responsive:!0,responsiveAnimationDuration:0,maintainAspectRatio:!0,events:["mousemove","mouseout","click","touchstart","touchmove"],hover:{onHover:null,mode:"nearest",intersect:!0,animationDuration:400},onClick:null,defaultColor:"rgba(0,0,0,0.1)",defaultFontColor:"#666",defaultFontFamily:"'Helvetica Neue', 'Helvetica', 'Arial', sans-serif",defaultFontSize:12,defaultFontStyle:"normal",showLines:!0,elements:{},layout:{padding:{top:0,right:0,bottom:0,left:0}}}),e.exports=function(){var t=function(t,e){return this.construct(t,e),this};return t.Chart=t}},{26:26}],31:[function(t,e,i){"use strict";function W(t,e){return B.where(t,function(t){return t.position===e})}function V(t,a){t.forEach(function(t,e){return t._tmpIndex_=e,t}),t.sort(function(t,e){var i=a?e:t,n=a?t:e;return i.weight===n.weight?i._tmpIndex_-n._tmpIndex_:i.weight-n.weight}),t.forEach(function(t){delete t._tmpIndex_})}var B=t(46);e.exports={defaults:{},addBox:function(t,e){t.boxes||(t.boxes=[]),e.fullWidth=e.fullWidth||!1,e.position=e.position||"top",e.weight=e.weight||0,t.boxes.push(e)},removeBox:function(t,e){var i=t.boxes?t.boxes.indexOf(e):-1;-1!==i&&t.boxes.splice(i,1)},configure:function(t,e,i){for(var n,a=["fullWidth","position","weight"],o=a.length,r=0;r<o;++r)n=a[r],i.hasOwnProperty(n)&&(e[n]=i[n])},update:function(e,i,t){function z(e){var t=B.findNextWhere(k,function(t){return t.box===e});if(t)if(e.isHorizontal()){var i={left:Math.max(_,M),right:Math.max(D,w),top:0,bottom:0};e.update(e.fullWidth?g:x,p/2,i)}else e.update(t.minSize.width,y)}function N(t){t.isHorizontal()?(t.left=t.fullWidth?o:_,t.right=t.fullWidth?i-r:_+x,t.top=L,t.bottom=L+t.height,L=t.bottom):(t.left=R,t.right=R+t.width,t.top=P,t.bottom=P+y,R=t.right)}if(e){var n=e.options.layout||{},a=B.options.toPadding(n.padding),o=a.left,r=a.right,s=a.top,l=a.bottom,u=W(e.boxes,"left"),d=W(e.boxes,"right"),c=W(e.boxes,"top"),h=W(e.boxes,"bottom"),f=W(e.boxes,"chartArea");V(u,!0),V(d,!1),V(c,!0),V(h,!1);var g=i-o-r,p=t-s-l,m=p/2,v=(i-g/2)/(u.length+d.length),b=(t-m)/(c.length+h.length),x=g,y=p,k=[];B.each(u.concat(d,c,h),function(t){var e,i=t.isHorizontal();i?(e=t.update(t.fullWidth?g:x,b),y-=e.height):(e=t.update(v,y),x-=e.width),k.push({horizontal:i,minSize:e,box:t})});var M=0,w=0,C=0,S=0;B.each(c.concat(h),function(t){if(t.getPadding){var e=t.getPadding();M=Math.max(M,e.left),w=Math.max(w,e.right)}}),B.each(u.concat(d),function(t){if(t.getPadding){var e=t.getPadding();C=Math.max(C,e.top),S=Math.max(S,e.bottom)}});var _=o,D=r,P=s,I=l;B.each(u.concat(d),z),B.each(u,function(t){_+=t.width}),B.each(d,function(t){D+=t.width}),B.each(c.concat(h),z),B.each(c,function(t){P+=t.height}),B.each(h,function(t){I+=t.height}),B.each(u.concat(d),function(e){var t=B.findNextWhere(k,function(t){return t.box===e}),i={left:0,right:0,top:P,bottom:I};t&&e.update(t.minSize.width,y,i)}),_=o,D=r,P=s,I=l,B.each(u,function(t){_+=t.width}),B.each(d,function(t){D+=t.width}),B.each(c,function(t){P+=t.height}),B.each(h,function(t){I+=t.height});var A=Math.max(M-_,0);_+=A,D+=Math.max(w-D,0);var T=Math.max(C-P,0);P+=T,I+=Math.max(S-I,0);var F=t-P-I,O=i-_-D;O===x&&F===y||(B.each(u,function(t){t.height=F}),B.each(d,function(t){t.height=F}),B.each(c,function(t){t.fullWidth||(t.width=O)}),B.each(h,function(t){t.fullWidth||(t.width=O)}),y=F,x=O);var R=o+A,L=s+T;B.each(u.concat(c),N),R+=x,L+=y,B.each(d,N),B.each(h,N),e.chartArea={left:_,top:P,right:_+x,bottom:P+y},B.each(f,function(t){t.left=e.chartArea.left,t.top=e.chartArea.top,t.right=e.chartArea.right,t.bottom=e.chartArea.bottom,t.update(x,y)})}}}},{46:46}],32:[function(t,e,i){"use strict";var r=t(26),s=t(46);r._set("global",{plugins:{}}),e.exports={_plugins:[],_cacheId:0,register:function(t){var e=this._plugins;[].concat(t).forEach(function(t){-1===e.indexOf(t)&&e.push(t)}),this._cacheId++},unregister:function(t){var i=this._plugins;[].concat(t).forEach(function(t){var e=i.indexOf(t);-1!==e&&i.splice(e,1)}),this._cacheId++},clear:function(){this._plugins=[],this._cacheId++},count:function(){return this._plugins.length},getAll:function(){return this._plugins},notify:function(t,e,i){var n,a,o,r,s,l=this.descriptors(t),u=l.length;for(n=0;n<u;++n)if("function"==typeof(s=(o=(a=l[n]).plugin)[e])&&((r=[t].concat(i||[])).push(a.options),!1===s.apply(o,r)))return!1;return!0},descriptors:function(t){var e=t.$plugins||(t.$plugins={});if(e.id===this._cacheId)return e.descriptors;var n=[],a=[],i=t&&t.config||{},o=i.options&&i.options.plugins||{};return this._plugins.concat(i.plugins||[]).forEach(function(t){if(-1===n.indexOf(t)){var e=t.id,i=o[e];!1!==i&&(!0===i&&(i=s.clone(r.global.plugins[e])),n.push(t),a.push({plugin:t,options:i||{}}))}}),e.descriptors=a,e.id=this._cacheId,a},_invalidate:function(t){delete t.$plugins}}},{26:26,46:46}],33:[function(t,e,i){"use strict";function k(t){var e,i,n=[];for(e=0,i=t.length;e<i;++e)n.push(t[e].label);return n}function j(t,e,i){var n=t.getPixelForTick(e);return i&&(n-=0===e?(t.getPixelForTick(1)-n)/2:(n-t.getPixelForTick(e-1))/2),n}function M(t,e,i){return H.isArray(e)?H.longestText(t,i,e):t.measureText(e).width}function w(t){var e=H.valueOrDefault,i=y.global,n=e(t.fontSize,i.defaultFontSize),a=e(t.fontStyle,i.defaultFontStyle),o=e(t.fontFamily,i.defaultFontFamily);return{size:n,style:a,family:o,font:H.fontString(n,a,o)}}function C(t){return H.options.toLineHeight(H.valueOrDefault(t.lineHeight,1.2),H.valueOrDefault(t.fontSize,y.global.defaultFontSize))}var y=t(26),n=t(27),H=t(46),a=t(35);y._set("scale",{display:!0,position:"left",offset:!1,gridLines:{display:!0,color:"rgba(0, 0, 0, 0.1)",lineWidth:1,drawBorder:!0,drawOnChartArea:!0,drawTicks:!0,tickMarkLength:10,zeroLineWidth:1,zeroLineColor:"rgba(0,0,0,0.25)",zeroLineBorderDash:[],zeroLineBorderDashOffset:0,offsetGridLines:!1,borderDash:[],borderDashOffset:0},scaleLabel:{display:!1,labelString:"",lineHeight:1.2,padding:{top:4,bottom:4}},ticks:{beginAtZero:!1,minRotation:0,maxRotation:50,mirror:!1,padding:0,reverse:!1,display:!0,autoSkip:!0,autoSkipPadding:0,labelOffset:0,callback:a.formatters.values,minor:{},major:{}}}),e.exports=n.extend({getPadding:function(){return{left:this.paddingLeft||0,top:this.paddingTop||0,right:this.paddingRight||0,bottom:this.paddingBottom||0}},getTicks:function(){return this._ticks},mergeTicksOptions:function(){var t=this.options.ticks;for(var e in!1===t.minor&&(t.minor={display:!1}),!1===t.major&&(t.major={display:!1}),t)"major"!==e&&"minor"!==e&&(void 0===t.minor[e]&&(t.minor[e]=t[e]),void 0===t.major[e]&&(t.major[e]=t[e]))},beforeUpdate:function(){H.callback(this.options.beforeUpdate,[this])},update:function(t,e,i){var n,a,o,r,s,l,u=this;for(u.beforeUpdate(),u.maxWidth=t,u.maxHeight=e,u.margins=H.extend({left:0,right:0,top:0,bottom:0},i),u.longestTextCache=u.longestTextCache||{},u.beforeSetDimensions(),u.setDimensions(),u.afterSetDimensions(),u.beforeDataLimits(),u.determineDataLimits(),u.afterDataLimits(),u.beforeBuildTicks(),s=u.buildTicks()||[],u.afterBuildTicks(),u.beforeTickToLabelConversion(),o=u.convertTicksToLabels(s)||u.ticks,u.afterTickToLabelConversion(),n=0,a=(u.ticks=o).length;n<a;++n)r=o[n],(l=s[n])?l.label=r:s.push(l={label:r,major:!1});return u._ticks=s,u.beforeCalculateTickRotation(),u.calculateTickRotation(),u.afterCalculateTickRotation(),u.beforeFit(),u.fit(),u.afterFit(),u.afterUpdate(),u.minSize},afterUpdate:function(){H.callback(this.options.afterUpdate,[this])},beforeSetDimensions:function(){H.callback(this.options.beforeSetDimensions,[this])},setDimensions:function(){var t=this;t.isHorizontal()?(t.width=t.maxWidth,t.left=0,t.right=t.width):(t.height=t.maxHeight,t.top=0,t.bottom=t.height),t.paddingLeft=0,t.paddingTop=0,t.paddingRight=0,t.paddingBottom=0},afterSetDimensions:function(){H.callback(this.options.afterSetDimensions,[this])},beforeDataLimits:function(){H.callback(this.options.beforeDataLimits,[this])},determineDataLimits:H.noop,afterDataLimits:function(){H.callback(this.options.afterDataLimits,[this])},beforeBuildTicks:function(){H.callback(this.options.beforeBuildTicks,[this])},buildTicks:H.noop,afterBuildTicks:function(){H.callback(this.options.afterBuildTicks,[this])},beforeTickToLabelConversion:function(){H.callback(this.options.beforeTickToLabelConversion,[this])},convertTicksToLabels:function(){var t=this.options.ticks;this.ticks=this.ticks.map(t.userCallback||t.callback,this)},afterTickToLabelConversion:function(){H.callback(this.options.afterTickToLabelConversion,[this])},beforeCalculateTickRotation:function(){H.callback(this.options.beforeCalculateTickRotation,[this])},calculateTickRotation:function(){var t=this,e=t.ctx,i=t.options.ticks,n=k(t._ticks),a=w(i);e.font=a.font;var o=i.minRotation||0;if(n.length&&t.options.display&&t.isHorizontal())for(var r,s=H.longestText(e,a.font,n,t.longestTextCache),l=s,u=t.getPixelForTick(1)-t.getPixelForTick(0)-6;u<l&&o<i.maxRotation;){var d=H.toRadians(o);if(r=Math.cos(d),Math.sin(d)*s>t.maxHeight){o--;break}o++,l=r*s}t.labelRotation=o},afterCalculateTickRotation:function(){H.callback(this.options.afterCalculateTickRotation,[this])},beforeFit:function(){H.callback(this.options.beforeFit,[this])},fit:function(){var t=this,e=t.minSize={width:0,height:0},i=k(t._ticks),n=t.options,a=n.ticks,o=n.scaleLabel,r=n.gridLines,s=n.display,l=t.isHorizontal(),u=w(a),d=n.gridLines.tickMarkLength;if(e.width=l?t.isFullWidth()?t.maxWidth-t.margins.left-t.margins.right:t.maxWidth:s&&r.drawTicks?d:0,e.height=l?s&&r.drawTicks?d:0:t.maxHeight,o.display&&s){var c=C(o)+H.options.toPadding(o.padding).height;l?e.height+=c:e.width+=c}if(a.display&&s){var h=H.longestText(t.ctx,u.font,i,t.longestTextCache),f=H.numberOfLabelLines(i),g=.5*u.size,p=t.options.ticks.padding;if(l){t.longestLabelWidth=h;var m=H.toRadians(t.labelRotation),v=Math.cos(m),b=Math.sin(m)*h+u.size*f+g*(f-1)+g;e.height=Math.min(t.maxHeight,e.height+b+p),t.ctx.font=u.font;var x=M(t.ctx,i[0],u.font),y=M(t.ctx,i[i.length-1],u.font);0!==t.labelRotation?(t.paddingLeft="bottom"===n.position?v*x+3:v*g+3,t.paddingRight="bottom"===n.position?v*g+3:v*y+3):(t.paddingLeft=x/2+3,t.paddingRight=y/2+3)}else a.mirror?h=0:h+=p+g,e.width=Math.min(t.maxWidth,e.width+h),t.paddingTop=u.size/2,t.paddingBottom=u.size/2}t.handleMargins(),t.width=e.width,t.height=e.height},handleMargins:function(){var t=this;t.margins&&(t.paddingLeft=Math.max(t.paddingLeft-t.margins.left,0),t.paddingTop=Math.max(t.paddingTop-t.margins.top,0),t.paddingRight=Math.max(t.paddingRight-t.margins.right,0),t.paddingBottom=Math.max(t.paddingBottom-t.margins.bottom,0))},afterFit:function(){H.callback(this.options.afterFit,[this])},isHorizontal:function(){return"top"===this.options.position||"bottom"===this.options.position},isFullWidth:function(){return this.options.fullWidth},getRightValue:function(t){if(H.isNullOrUndef(t))return NaN;if("number"==typeof t&&!isFinite(t))return NaN;if(t)if(this.isHorizontal()){if(void 0!==t.x)return this.getRightValue(t.x)}else if(void 0!==t.y)return this.getRightValue(t.y);return t},getLabelForIndex:H.noop,getPixelForValue:H.noop,getValueForPixel:H.noop,getPixelForTick:function(t){var e=this,i=e.options.offset;if(e.isHorizontal()){var n=(e.width-(e.paddingLeft+e.paddingRight))/Math.max(e._ticks.length-(i?0:1),1),a=n*t+e.paddingLeft;i&&(a+=n/2);var o=e.left+Math.round(a);return o+=e.isFullWidth()?e.margins.left:0}var r=e.height-(e.paddingTop+e.paddingBottom);return e.top+t*(r/(e._ticks.length-1))},getPixelForDecimal:function(t){var e=this;if(e.isHorizontal()){var i=(e.width-(e.paddingLeft+e.paddingRight))*t+e.paddingLeft,n=e.left+Math.round(i);return n+=e.isFullWidth()?e.margins.left:0}return e.top+t*e.height},getBasePixel:function(){return this.getPixelForValue(this.getBaseValue())},getBaseValue:function(){var t=this.min,e=this.max;return this.beginAtZero?0:t<0&&e<0?e:0<t&&0<e?t:0},_autoSkip:function(t){var e,i,n,a,o=this,r=o.isHorizontal(),s=o.options.ticks.minor,l=t.length,u=H.toRadians(o.labelRotation),d=Math.cos(u),c=o.longestLabelWidth*d,h=[];for(s.maxTicksLimit&&(a=s.maxTicksLimit),r&&(e=!1,(c+s.autoSkipPadding)*l>o.width-(o.paddingLeft+o.paddingRight)&&(e=1+Math.floor((c+s.autoSkipPadding)*l/(o.width-(o.paddingLeft+o.paddingRight)))),a&&a<l&&(e=Math.max(e,Math.floor(l/a)))),i=0;i<l;i++)n=t[i],(1<e&&0<i%e||i%e==0&&l<=i+e)&&i!==l-1&&delete n.label,h.push(n);return h},draw:function(S){var _=this,D=_.options;if(D.display){var r=_.ctx,P=y.global,I=D.ticks.minor,t=D.ticks.major||I,A=D.gridLines,e=D.scaleLabel,T=0!==_.labelRotation,F=_.isHorizontal(),O=I.autoSkip?_._autoSkip(_.getTicks()):_.getTicks(),s=H.valueOrDefault(I.fontColor,P.defaultFontColor),l=w(I),u=H.valueOrDefault(t.fontColor,P.defaultFontColor),d=w(t),R=A.drawTicks?A.tickMarkLength:0,i=H.valueOrDefault(e.fontColor,P.defaultFontColor),n=w(e),a=H.options.toPadding(e.padding),L=H.toRadians(_.labelRotation),z=[],N=_.options.gridLines.lineWidth,B="right"===D.position?_.left:_.right-N-R,W="right"===D.position?_.left+R:_.right,V="bottom"===D.position?_.top+N:_.bottom-R-N,E="bottom"===D.position?_.top+N+R:_.bottom+N;if(H.each(O,function(t,e){if(!H.isNullOrUndef(t.label)){var i,n,a,o,r,s,l,u,d,c,h,f,g,p,m=t.label;o=e===_.zeroLineIndex&&D.offset===A.offsetGridLines?(i=A.zeroLineWidth,n=A.zeroLineColor,a=A.zeroLineBorderDash,A.zeroLineBorderDashOffset):(i=H.valueAtIndexOrDefault(A.lineWidth,e),n=H.valueAtIndexOrDefault(A.color,e),a=H.valueOrDefault(A.borderDash,P.borderDash),H.valueOrDefault(A.borderDashOffset,P.borderDashOffset));var v="middle",b="middle",x=I.padding;if(F){var y=R+x;p="bottom"===D.position?(b=T?"middle":"top",v=T?"right":"center",_.top+y):(b=T?"middle":"bottom",v=T?"left":"center",_.bottom-y);var k=j(_,e,A.offsetGridLines&&1<O.length);k<_.left&&(n="rgba(0,0,0,0)"),k+=H.aliasPixel(i),g=_.getPixelForTick(e)+I.labelOffset,r=l=d=h=k,s=V,u=E,c=S.top,f=S.bottom+N}else{var M,w="left"===D.position;M=I.mirror?(v=w?"left":"right",x):(v=w?"right":"left",R+x),g=w?_.right-M:_.left+M;var C=j(_,e,A.offsetGridLines&&1<O.length);C<_.top&&(n="rgba(0,0,0,0)"),C+=H.aliasPixel(i),p=_.getPixelForTick(e)+I.labelOffset,r=B,l=W,d=S.left,h=S.right+N,s=u=c=f=C}z.push({tx1:r,ty1:s,tx2:l,ty2:u,x1:d,y1:c,x2:h,y2:f,labelX:g,labelY:p,glWidth:i,glColor:n,glBorderDash:a,glBorderDashOffset:o,rotation:-1*L,label:m,major:t.major,textBaseline:b,textAlign:v})}}),H.each(z,function(t){if(A.display&&(r.save(),r.lineWidth=t.glWidth,r.strokeStyle=t.glColor,r.setLineDash&&(r.setLineDash(t.glBorderDash),r.lineDashOffset=t.glBorderDashOffset),r.beginPath(),A.drawTicks&&(r.moveTo(t.tx1,t.ty1),r.lineTo(t.tx2,t.ty2)),A.drawOnChartArea&&(r.moveTo(t.x1,t.y1),r.lineTo(t.x2,t.y2)),r.stroke(),r.restore()),I.display){r.save(),r.translate(t.labelX,t.labelY),r.rotate(t.rotation),r.font=t.major?d.font:l.font,r.fillStyle=t.major?u:s,r.textBaseline=t.textBaseline,r.textAlign=t.textAlign;var e=t.label;if(H.isArray(e))for(var i=e.length,n=1.5*l.size,a=_.isHorizontal()?0:-n*(i-1)/2,o=0;o<i;++o)r.fillText(""+e[o],0,a),a+=n;else r.fillText(e,0,0);r.restore()}}),e.display){var o,c,h=0,f=C(e)/2;if(F)o=_.left+(_.right-_.left)/2,c="bottom"===D.position?_.bottom-f-a.bottom:_.top+f+a.top;else{var g="left"===D.position;o=g?_.left+f+a.top:_.right-f-a.top,c=_.top+(_.bottom-_.top)/2,h=g?-.5*Math.PI:.5*Math.PI}r.save(),r.translate(o,c),r.rotate(h),r.textAlign="center",r.textBaseline="middle",r.fillStyle=i,r.font=n.font,r.fillText(e.labelString,0,0),r.restore()}if(A.drawBorder){r.lineWidth=H.valueAtIndexOrDefault(A.lineWidth,0),r.strokeStyle=H.valueAtIndexOrDefault(A.color,0);var p=_.left,m=_.right+N,v=_.top,b=_.bottom+N,x=H.aliasPixel(r.lineWidth);F?(v=b="top"===D.position?_.bottom:_.top,v+=x,b+=x):(p=m="left"===D.position?_.right:_.left,p+=x,m+=x),r.beginPath(),r.moveTo(p,v),r.lineTo(m,b),r.stroke()}}}})},{26:26,27:27,35:35,46:46}],34:[function(t,e,i){"use strict";var n=t(26),a=t(46),o=t(31);e.exports={constructors:{},defaults:{},registerScaleType:function(t,e,i){this.constructors[t]=e,this.defaults[t]=a.clone(i)},getScaleConstructor:function(t){return this.constructors.hasOwnProperty(t)?this.constructors[t]:void 0},getScaleDefaults:function(t){return this.defaults.hasOwnProperty(t)?a.merge({},[n.scale,this.defaults[t]]):{}},updateScaleDefaults:function(t,e){this.defaults.hasOwnProperty(t)&&(this.defaults[t]=a.extend(this.defaults[t],e))},addScalesToLayout:function(e){a.each(e.scales,function(t){t.fullWidth=t.options.fullWidth,t.position=t.options.position,t.weight=t.options.weight,o.addBox(e,t)})}}},{26:26,31:31,46:46}],35:[function(t,e,i){"use strict";var l=t(46);e.exports={formatters:{values:function(t){return l.isArray(t)?t:""+t},linear:function(t,e,i){var n=3<i.length?i[2]-i[1]:i[1]-i[0];1<Math.abs(n)&&t!==Math.floor(t)&&(n=t-Math.floor(t));var a=l.log10(Math.abs(n)),o="";if(0!==t)if(Math.max(Math.abs(i[0]),Math.abs(i[i.length-1]))<1e-4){var r=l.log10(Math.abs(t));o=t.toExponential(Math.floor(r)-Math.floor(a))}else{var s=-1*Math.floor(a);s=Math.max(Math.min(s,20),0),o=t.toFixed(s)}else o="0";return o},logarithmic:function(t,e,i){var n=t/Math.pow(10,Math.floor(l.log10(t)));return 0===t?"0":1===n||2===n||5===n||0===e||e===i.length-1?t.toExponential():""}}}},{46:46}],36:[function(t,e,i){"use strict";function h(t,e){var i=R.color(t);return i.alpha(e*i.alpha()).rgbaString()}function r(t,e){return e&&(R.isArray(e)?Array.prototype.push.apply(t,e):t.push(e)),t}function s(t){return("string"==typeof t||t instanceof String)&&-1<t.indexOf("\n")?t.split("\n"):t}function z(t){var e=n.global,i=R.valueOrDefault;return{xPadding:t.xPadding,yPadding:t.yPadding,xAlign:t.xAlign,yAlign:t.yAlign,bodyFontColor:t.bodyFontColor,_bodyFontFamily:i(t.bodyFontFamily,e.defaultFontFamily),_bodyFontStyle:i(t.bodyFontStyle,e.defaultFontStyle),_bodyAlign:t.bodyAlign,bodyFontSize:i(t.bodyFontSize,e.defaultFontSize),bodySpacing:t.bodySpacing,titleFontColor:t.titleFontColor,_titleFontFamily:i(t.titleFontFamily,e.defaultFontFamily),_titleFontStyle:i(t.titleFontStyle,e.defaultFontStyle),titleFontSize:i(t.titleFontSize,e.defaultFontSize),_titleAlign:t.titleAlign,titleSpacing:t.titleSpacing,titleMarginBottom:t.titleMarginBottom,footerFontColor:t.footerFontColor,_footerFontFamily:i(t.footerFontFamily,e.defaultFontFamily),_footerFontStyle:i(t.footerFontStyle,e.defaultFontStyle),footerFontSize:i(t.footerFontSize,e.defaultFontSize),_footerAlign:t.footerAlign,footerSpacing:t.footerSpacing,footerMarginTop:t.footerMarginTop,caretSize:t.caretSize,cornerRadius:t.cornerRadius,backgroundColor:t.backgroundColor,opacity:0,legendColorBackground:t.multiKeyBackground,displayColors:t.displayColors,borderColor:t.borderColor,borderWidth:t.borderWidth}}function o(t){return r([],s(t))}var n=t(26),a=t(27),R=t(46);n._set("global",{tooltips:{enabled:!0,custom:null,mode:"nearest",position:"average",intersect:!0,backgroundColor:"rgba(0,0,0,0.8)",titleFontStyle:"bold",titleSpacing:2,titleMarginBottom:6,titleFontColor:"#fff",titleAlign:"left",bodySpacing:2,bodyFontColor:"#fff",bodyAlign:"left",footerFontStyle:"bold",footerSpacing:2,footerMarginTop:6,footerFontColor:"#fff",footerAlign:"left",yPadding:6,xPadding:6,caretPadding:2,caretSize:5,cornerRadius:6,multiKeyBackground:"#fff",displayColors:!0,borderColor:"rgba(0,0,0,0)",borderWidth:0,callbacks:{beforeTitle:R.noop,title:function(t,e){var i="",n=e.labels,a=n?n.length:0;if(0<t.length){var o=t[0];o.xLabel?i=o.xLabel:0<a&&o.index<a&&(i=n[o.index])}return i},afterTitle:R.noop,beforeBody:R.noop,beforeLabel:R.noop,label:function(t,e){var i=e.datasets[t.datasetIndex].label||"";return i&&(i+=": "),i+=t.yLabel},labelColor:function(t,e){var i=e.getDatasetMeta(t.datasetIndex).data[t.index]._view;return{borderColor:i.borderColor,backgroundColor:i.backgroundColor}},labelTextColor:function(){return this._options.bodyFontColor},afterLabel:R.noop,afterBody:R.noop,beforeFooter:R.noop,footer:R.noop,afterFooter:R.noop}}});var L={average:function(t){if(!t.length)return!1;var e,i,n=0,a=0,o=0;for(e=0,i=t.length;e<i;++e){var r=t[e];if(r&&r.hasValue()){var s=r.tooltipPosition();n+=s.x,a+=s.y,++o}}return{x:Math.round(n/o),y:Math.round(a/o)}},nearest:function(t,e){var i,n,a,o=e.x,r=e.y,s=Number.POSITIVE_INFINITY;for(i=0,n=t.length;i<n;++i){var l=t[i];if(l&&l.hasValue()){var u=l.getCenterPoint(),d=R.distanceBetweenPoints(e,u);d<s&&(s=d,a=l)}}if(a){var c=a.tooltipPosition();o=c.x,r=c.y}return{x:o,y:r}}};(e.exports=a.extend({initialize:function(){this._model=z(this._options),this._lastActive=[]},getTitle:function(){var t=this._options.callbacks,e=t.beforeTitle.apply(this,arguments),i=t.title.apply(this,arguments),n=t.afterTitle.apply(this,arguments),a=[];return a=r(a=r(a=r(a,s(e)),s(i)),s(n))},getBeforeBody:function(){return o(this._options.callbacks.beforeBody.apply(this,arguments))},getBody:function(t,i){var n=this,a=n._options.callbacks,o=[];return R.each(t,function(t){var e={before:[],lines:[],after:[]};r(e.before,s(a.beforeLabel.call(n,t,i))),r(e.lines,a.label.call(n,t,i)),r(e.after,s(a.afterLabel.call(n,t,i))),o.push(e)}),o},getAfterBody:function(){return o(this._options.callbacks.afterBody.apply(this,arguments))},getFooter:function(){var t=this._options.callbacks,e=t.beforeFooter.apply(this,arguments),i=t.footer.apply(this,arguments),n=t.afterFooter.apply(this,arguments),a=[];return a=r(a=r(a=r(a,s(e)),s(i)),s(n))},update:function(t){var e,i,n,a,o,r,s,l,u,d,c,h,f,g,p,m,v,b,x,y,k=this,M=k._options,w=k._model,C=k._model=z(M),S=k._active,_=k._data,D={xAlign:w.xAlign,yAlign:w.yAlign},P={x:w.x,y:w.y},I={width:w.width,height:w.height},A={x:w.caretX,y:w.caretY};if(S.length){C.opacity=1;var T=[],F=[];A=L[M.position].call(k,S,k._eventPosition);var O=[];for(e=0,i=S.length;e<i;++e)O.push((m=S[e],b=v=void 0,v=m._xScale,b=m._yScale||m._scale,x=m._index,y=m._datasetIndex,{xLabel:v?v.getLabelForIndex(x,y):"",yLabel:b?b.getLabelForIndex(x,y):"",index:x,datasetIndex:y,x:m._model.x,y:m._model.y}));M.filter&&(O=O.filter(function(t){return M.filter(t,_)})),M.itemSort&&(O=O.sort(function(t,e){return M.itemSort(t,e,_)})),R.each(O,function(t){T.push(M.callbacks.labelColor.call(k,t,k._chart)),F.push(M.callbacks.labelTextColor.call(k,t,k._chart))}),C.title=k.getTitle(O,_),C.beforeBody=k.getBeforeBody(O,_),C.body=k.getBody(O,_),C.afterBody=k.getAfterBody(O,_),C.footer=k.getFooter(O,_),C.x=Math.round(A.x),C.y=Math.round(A.y),C.caretPadding=M.caretPadding,C.labelColors=T,C.labelTextColors=F,C.dataPoints=O,D=function(t,e){var i,n,a,o,r,s=t._model,l=t._chart,u=t._chart.chartArea,d="center",c="center";s.y<e.height?c="top":s.y>l.height-e.height&&(c="bottom");var h=(u.left+u.right)/2,f=(u.top+u.bottom)/2;n="center"===c?(i=function(t){return t<=h},function(t){return h<t}):(i=function(t){return t<=e.width/2},function(t){return t>=l.width-e.width/2}),a=function(t){return t+e.width+s.caretSize+s.caretPadding>l.width},o=function(t){return t-e.width-s.caretSize-s.caretPadding<0},r=function(t){return t<=f?"top":"bottom"},i(s.x)?(d="left",a(s.x)&&(d="center",c=r(s.y))):n(s.x)&&(d="right",o(s.x)&&(d="center",c=r(s.y)));var g=t._options;return{xAlign:g.xAlign?g.xAlign:d,yAlign:g.yAlign?g.yAlign:c}}(this,I=function(t,e){var i=t._chart.ctx,n=2*e.yPadding,a=0,o=e.body,r=o.reduce(function(t,e){return t+e.before.length+e.lines.length+e.after.length},0);r+=e.beforeBody.length+e.afterBody.length;var s=e.title.length,l=e.footer.length,u=e.titleFontSize,d=e.bodyFontSize,c=e.footerFontSize;n+=s*u,n+=s?(s-1)*e.titleSpacing:0,n+=s?e.titleMarginBottom:0,n+=r*d,n+=r?(r-1)*e.bodySpacing:0,n+=l?e.footerMarginTop:0,n+=l*c,n+=l?(l-1)*e.footerSpacing:0;var h=0,f=function(t){a=Math.max(a,i.measureText(t).width+h)};return i.font=R.fontString(u,e._titleFontStyle,e._titleFontFamily),R.each(e.title,f),i.font=R.fontString(d,e._bodyFontStyle,e._bodyFontFamily),R.each(e.beforeBody.concat(e.afterBody),f),h=e.displayColors?d+2:0,R.each(o,function(t){R.each(t.before,f),R.each(t.lines,f),R.each(t.after,f)}),h=0,i.font=R.fontString(c,e._footerFontStyle,e._footerFontFamily),R.each(e.footer,f),{width:a+=2*e.xPadding,height:n}}(this,C)),n=C,a=I,o=D,r=k._chart,s=n.x,l=n.y,u=n.caretSize,d=n.caretPadding,c=n.cornerRadius,h=o.xAlign,f=o.yAlign,g=u+d,p=c+d,"right"===h?s-=a.width:"center"===h&&((s-=a.width/2)+a.width>r.width&&(s=r.width-a.width),s<0&&(s=0)),"top"===f?l+=g:l-="bottom"===f?a.height+g:a.height/2,"center"===f?"left"===h?s+=g:"right"===h&&(s-=g):"left"===h?s-=p:"right"===h&&(s+=p),P={x:s,y:l}}else C.opacity=0;return C.xAlign=D.xAlign,C.yAlign=D.yAlign,C.x=P.x,C.y=P.y,C.width=I.width,C.height=I.height,C.caretX=A.x,C.caretY=A.y,k._model=C,t&&M.custom&&M.custom.call(k,C),k},drawCaret:function(t,e){var i=this._chart.ctx,n=this._view,a=this.getCaretPosition(t,e,n);i.lineTo(a.x1,a.y1),i.lineTo(a.x2,a.y2),i.lineTo(a.x3,a.y3)},getCaretPosition:function(t,e,i){var n,a,o,r,s,l,u=i.caretSize,d=i.cornerRadius,c=i.xAlign,h=i.yAlign,f=t.x,g=t.y,p=e.width,m=e.height;if("center"===h)s=g+m/2,l="left"===c?(a=(n=f)-u,o=n,r=s+u,s-u):(a=(n=f+p)+u,o=n,r=s-u,s+u);else if(n="left"===c?(a=f+d+u)-u:"right"===c?(a=f+p-d-u)-u:(a=i.caretX)-u,o=a+u,"top"===h)s=(r=g)-u,l=r;else{s=(r=g+m)+u,l=r;var v=o;o=n,n=v}return{x1:n,x2:a,x3:o,y1:r,y2:s,y3:l}},drawTitle:function(t,e,i,n){var a=e.title;if(a.length){i.textAlign=e._titleAlign,i.textBaseline="top";var o,r,s=e.titleFontSize,l=e.titleSpacing;for(i.fillStyle=h(e.titleFontColor,n),i.font=R.fontString(s,e._titleFontStyle,e._titleFontFamily),o=0,r=a.length;o<r;++o)i.fillText(a[o],t.x,t.y),t.y+=s+l,o+1===a.length&&(t.y+=e.titleMarginBottom-l)}},drawBody:function(n,a,o,r){var s=a.bodyFontSize,e=a.bodySpacing,t=a.body;o.textAlign=a._bodyAlign,o.textBaseline="top",o.font=R.fontString(s,a._bodyFontStyle,a._bodyFontFamily);var i=0,l=function(t){o.fillText(t,n.x+i,n.y),n.y+=s+e};o.fillStyle=h(a.bodyFontColor,r),R.each(a.beforeBody,l);var u=a.displayColors;i=u?s+2:0,R.each(t,function(t,e){var i=h(a.labelTextColors[e],r);o.fillStyle=i,R.each(t.before,l),R.each(t.lines,function(t){u&&(o.fillStyle=h(a.legendColorBackground,r),o.fillRect(n.x,n.y,s,s),o.lineWidth=1,o.strokeStyle=h(a.labelColors[e].borderColor,r),o.strokeRect(n.x,n.y,s,s),o.fillStyle=h(a.labelColors[e].backgroundColor,r),o.fillRect(n.x+1,n.y+1,s-2,s-2),o.fillStyle=i),l(t)}),R.each(t.after,l)}),i=0,R.each(a.afterBody,l),n.y-=e},drawFooter:function(e,i,n,t){var a=i.footer;a.length&&(e.y+=i.footerMarginTop,n.textAlign=i._footerAlign,n.textBaseline="top",n.fillStyle=h(i.footerFontColor,t),n.font=R.fontString(i.footerFontSize,i._footerFontStyle,i._footerFontFamily),R.each(a,function(t){n.fillText(t,e.x,e.y),e.y+=i.footerFontSize+i.footerSpacing}))},drawBackground:function(t,e,i,n,a){i.fillStyle=h(e.backgroundColor,a),i.strokeStyle=h(e.borderColor,a),i.lineWidth=e.borderWidth;var o=e.xAlign,r=e.yAlign,s=t.x,l=t.y,u=n.width,d=n.height,c=e.cornerRadius;i.beginPath(),i.moveTo(s+c,l),"top"===r&&this.drawCaret(t,n),i.lineTo(s+u-c,l),i.quadraticCurveTo(s+u,l,s+u,l+c),"center"===r&&"right"===o&&this.drawCaret(t,n),i.lineTo(s+u,l+d-c),i.quadraticCurveTo(s+u,l+d,s+u-c,l+d),"bottom"===r&&this.drawCaret(t,n),i.lineTo(s+c,l+d),i.quadraticCurveTo(s,l+d,s,l+d-c),"center"===r&&"left"===o&&this.drawCaret(t,n),i.lineTo(s,l+c),i.quadraticCurveTo(s,l,s+c,l),i.closePath(),i.fill(),0<e.borderWidth&&i.stroke()},draw:function(){var t=this._chart.ctx,e=this._view;if(0!==e.opacity){var i={width:e.width,height:e.height},n={x:e.x,y:e.y},a=Math.abs(e.opacity<.001)?0:e.opacity,o=e.title.length||e.beforeBody.length||e.body.length||e.afterBody.length||e.footer.length;this._options.enabled&&o&&(this.drawBackground(n,e,t,i,a),n.x+=e.xPadding,n.y+=e.yPadding,this.drawTitle(n,e,t,a),this.drawBody(n,e,t,a),this.drawFooter(n,e,t,a))}},handleEvent:function(t){var e,i=this,n=i._options;return i._lastActive=i._lastActive||[],"mouseout"===t.type?i._active=[]:i._active=i._chart.getElementsAtEventForMode(t,n.mode,n),(e=!R.arrayEquals(i._active,i._lastActive))&&(i._lastActive=i._active,(n.enabled||n.custom)&&(i._eventPosition={x:t.x,y:t.y},i.update(!0),i.pivot())),e}})).positioners=L},{26:26,27:27,46:46}],37:[function(t,e,i){"use strict";var n=t(26),a=t(27),d=t(46);n._set("global",{elements:{arc:{backgroundColor:n.global.defaultColor,borderColor:"#fff",borderWidth:2}}}),e.exports=a.extend({inLabelRange:function(t){var e=this._view;return!!e&&Math.pow(t-e.x,2)<Math.pow(e.radius+e.hoverRadius,2)},inRange:function(t,e){var i=this._view;if(i){for(var n=d.getAngleFromPoint(i,{x:t,y:e}),a=n.angle,o=n.distance,r=i.startAngle,s=i.endAngle;s<r;)s+=2*Math.PI;for(;s<a;)a-=2*Math.PI;for(;a<r;)a+=2*Math.PI;var l=r<=a&&a<=s,u=o>=i.innerRadius&&o<=i.outerRadius;return l&&u}return!1},getCenterPoint:function(){var t=this._view,e=(t.startAngle+t.endAngle)/2,i=(t.innerRadius+t.outerRadius)/2;return{x:t.x+Math.cos(e)*i,y:t.y+Math.sin(e)*i}},getArea:function(){var t=this._view;return Math.PI*((t.endAngle-t.startAngle)/(2*Math.PI))*(Math.pow(t.outerRadius,2)-Math.pow(t.innerRadius,2))},tooltipPosition:function(){var t=this._view,e=t.startAngle+(t.endAngle-t.startAngle)/2,i=(t.outerRadius-t.innerRadius)/2+t.innerRadius;return{x:t.x+Math.cos(e)*i,y:t.y+Math.sin(e)*i}},draw:function(){var t=this._chart.ctx,e=this._view,i=e.startAngle,n=e.endAngle;t.beginPath(),t.arc(e.x,e.y,e.outerRadius,i,n),t.arc(e.x,e.y,e.innerRadius,n,i,!0),t.closePath(),t.strokeStyle=e.borderColor,t.lineWidth=e.borderWidth,t.fillStyle=e.backgroundColor,t.fill(),t.lineJoin="bevel",e.borderWidth&&t.stroke()}})},{26:26,27:27,46:46}],38:[function(t,e,i){"use strict";var n=t(26),a=t(27),d=t(46),c=n.global;n._set("global",{elements:{line:{tension:.4,backgroundColor:c.defaultColor,borderWidth:3,borderColor:c.defaultColor,borderCapStyle:"butt",borderDash:[],borderDashOffset:0,borderJoinStyle:"miter",capBezierPoints:!0,fill:!0}}}),e.exports=a.extend({draw:function(){var t,e,i,n,a=this._view,o=this._chart.ctx,r=a.spanGaps,s=this._children.slice(),l=c.elements.line,u=-1;for(this._loop&&s.length&&s.push(s[0]),o.save(),o.lineCap=a.borderCapStyle||l.borderCapStyle,o.setLineDash&&o.setLineDash(a.borderDash||l.borderDash),o.lineDashOffset=a.borderDashOffset||l.borderDashOffset,o.lineJoin=a.borderJoinStyle||l.borderJoinStyle,o.lineWidth=a.borderWidth||l.borderWidth,o.strokeStyle=a.borderColor||c.defaultColor,o.beginPath(),u=-1,t=0;t<s.length;++t)e=s[t],i=d.previousItem(s,t),n=e._view,0===t?n.skip||(o.moveTo(n.x,n.y),u=t):(i=-1===u?i:s[u],n.skip||(u!==t-1&&!r||-1===u?o.moveTo(n.x,n.y):d.canvas.lineTo(o,i._view,e._view),u=t));o.stroke(),o.restore()}})},{26:26,27:27,46:46}],39:[function(t,e,i){"use strict";function a(t){var e=this._view;return!!e&&Math.abs(t-e.x)<e.radius+e.hitRadius}var u=t(26),n=t(27),d=t(46),c=u.global.defaultColor;u._set("global",{elements:{point:{radius:3,pointStyle:"circle",backgroundColor:c,borderColor:c,borderWidth:1,hitRadius:1,hoverRadius:4,hoverBorderWidth:1}}}),e.exports=n.extend({inRange:function(t,e){var i=this._view;return!!i&&Math.pow(t-i.x,2)+Math.pow(e-i.y,2)<Math.pow(i.hitRadius+i.radius,2)},inLabelRange:a,inXRange:a,inYRange:function(t){var e=this._view;return!!e&&Math.abs(t-e.y)<e.radius+e.hitRadius},getCenterPoint:function(){var t=this._view;return{x:t.x,y:t.y}},getArea:function(){return Math.PI*Math.pow(this._view.radius,2)},tooltipPosition:function(){var t=this._view;return{x:t.x,y:t.y,padding:t.radius+t.borderWidth}},draw:function(t){var e=this._view,i=this._model,n=this._chart.ctx,a=e.pointStyle,o=e.rotation,r=e.radius,s=e.x,l=e.y;e.skip||(void 0===t||i.x>=t.left&&1.01*t.right>=i.x&&i.y>=t.top&&1.01*t.bottom>=i.y)&&(n.strokeStyle=e.borderColor||c,n.lineWidth=d.valueOrDefault(e.borderWidth,u.global.elements.point.borderWidth),n.fillStyle=e.backgroundColor||c,d.canvas.drawPoint(n,a,r,s,l,o))}})},{26:26,27:27,46:46}],40:[function(t,e,i){"use strict";function l(t){return void 0!==t._view.width}function o(t){var e,i,n,a,o=t._view;if(l(t)){var r=o.width/2;e=o.x-r,i=o.x+r,n=Math.min(o.y,o.base),a=Math.max(o.y,o.base)}else{var s=o.height/2;e=Math.min(o.x,o.base),i=Math.max(o.x,o.base),n=o.y-s,a=o.y+s}return{left:e,top:n,right:i,bottom:a}}var n=t(26),a=t(27);n._set("global",{elements:{rectangle:{backgroundColor:n.global.defaultColor,borderColor:n.global.defaultColor,borderSkipped:"bottom",borderWidth:0}}}),e.exports=a.extend({draw:function(){function b(t){return m[(v+t)%4]}var t,e,i,n,a,o,r,s=this._chart.ctx,l=this._view,u=l.borderWidth;if(r=l.horizontal?(t=l.base,e=l.x,i=l.y-l.height/2,n=l.y+l.height/2,a=t<e?1:-1,o=1,l.borderSkipped||"left"):(t=l.x-l.width/2,e=l.x+l.width/2,a=1,o=(i=l.y)<(n=l.base)?1:-1,l.borderSkipped||"bottom"),u){var d=Math.min(Math.abs(t-e),Math.abs(i-n)),c=(u=d<u?d:u)/2,h=t+("left"!==r?c*a:0),f=e+("right"!==r?-c*a:0),g=i+("top"!==r?c*o:0),p=n+("bottom"!==r?-c*o:0);h!==f&&(i=g,n=p),g!==p&&(t=h,e=f)}s.beginPath(),s.fillStyle=l.backgroundColor,s.strokeStyle=l.borderColor,s.lineWidth=u;var m=[[t,n],[t,i],[e,i],[e,n]],v=["bottom","left","top","right"].indexOf(r,0);-1===v&&(v=0);var x=b(0);s.moveTo(x[0],x[1]);for(var y=1;y<4;y++)x=b(y),s.lineTo(x[0],x[1]);s.fill(),u&&s.stroke()},height:function(){var t=this._view;return t.base-t.y},inRange:function(t,e){var i=!1;if(this._view){var n=o(this);i=t>=n.left&&t<=n.right&&e>=n.top&&e<=n.bottom}return i},inLabelRange:function(t,e){if(!this._view)return!1;var i=o(this);return l(this)?t>=i.left&&t<=i.right:e>=i.top&&e<=i.bottom},inXRange:function(t){var e=o(this);return t>=e.left&&t<=e.right},inYRange:function(t){var e=o(this);return t>=e.top&&t<=e.bottom},getCenterPoint:function(){var t,e,i=this._view;return e=l(this)?(t=i.x,(i.y+i.base)/2):(t=(i.x+i.base)/2,i.y),{x:t,y:e}},getArea:function(){var t=this._view;return t.width*Math.abs(t.y-t.base)},tooltipPosition:function(){var t=this._view;return{x:t.x,y:t.y}}})},{26:26,27:27}],41:[function(t,e,i){"use strict";e.exports={},e.exports.Arc=t(37),e.exports.Line=t(38),e.exports.Point=t(39),e.exports.Rectangle=t(40)},{37:37,38:38,39:39,40:40}],42:[function(t,e,i){"use strict";var n=t(43);i=e.exports={clear:function(t){t.ctx.clearRect(0,0,t.width,t.height)},roundedRect:function(t,e,i,n,a,o){if(o){var r=Math.min(o,a/2-1e-7,n/2-1e-7);t.moveTo(e+r,i),t.lineTo(e+n-r,i),t.arcTo(e+n,i,e+n,i+r,r),t.lineTo(e+n,i+a-r),t.arcTo(e+n,i+a,e+n-r,i+a,r),t.lineTo(e+r,i+a),t.arcTo(e,i+a,e,i+a-r,r),t.lineTo(e,i+r),t.arcTo(e,i,e+r,i,r),t.closePath(),t.moveTo(e,i)}else t.rect(e,i,n,a)},drawPoint:function(t,e,i,n,a,o){var r,s,l,u,d,c;if(o=o||0,!e||"object"!=typeof e||"[object HTMLImageElement]"!==(r=e.toString())&&"[object HTMLCanvasElement]"!==r){if(!(isNaN(i)||i<=0)){switch(t.save(),t.translate(n,a),t.rotate(o*Math.PI/180),t.beginPath(),e){default:t.arc(0,0,i,0,2*Math.PI),t.closePath();break;case"triangle":d=(s=3*i/Math.sqrt(3))*Math.sqrt(3)/2,t.moveTo(-s/2,d/3),t.lineTo(s/2,d/3),t.lineTo(0,-2*d/3),t.closePath();break;case"rect":c=1/Math.SQRT2*i,t.rect(-c,-c,2*c,2*c);break;case"rectRounded":var h=i/Math.SQRT2,f=-h,g=-h,p=Math.SQRT2*i;this.roundedRect(t,f,g,p,p,.425*i);break;case"rectRot":c=1/Math.SQRT2*i,t.moveTo(-c,0),t.lineTo(0,c),t.lineTo(c,0),t.lineTo(0,-c),t.closePath();break;case"cross":t.moveTo(0,i),t.lineTo(0,-i),t.moveTo(-i,0),t.lineTo(i,0);break;case"crossRot":l=Math.cos(Math.PI/4)*i,u=Math.sin(Math.PI/4)*i,t.moveTo(-l,-u),t.lineTo(l,u),t.moveTo(-l,u),t.lineTo(l,-u);break;case"star":t.moveTo(0,i),t.lineTo(0,-i),t.moveTo(-i,0),t.lineTo(i,0),l=Math.cos(Math.PI/4)*i,u=Math.sin(Math.PI/4)*i,t.moveTo(-l,-u),t.lineTo(l,u),t.moveTo(-l,u),t.lineTo(l,-u);break;case"line":t.moveTo(-i,0),t.lineTo(i,0);break;case"dash":t.moveTo(0,0),t.lineTo(i,0)}t.fill(),t.stroke(),t.restore()}}else t.drawImage(e,n-e.width/2,a-e.height/2,e.width,e.height)},clipArea:function(t,e){t.save(),t.beginPath(),t.rect(e.left,e.top,e.right-e.left,e.bottom-e.top),t.clip()},unclipArea:function(t){t.restore()},lineTo:function(t,e,i,n){if(i.steppedLine)return"after"===i.steppedLine&&!n||"after"!==i.steppedLine&&n?t.lineTo(e.x,i.y):t.lineTo(i.x,e.y),void t.lineTo(i.x,i.y);i.tension?t.bezierCurveTo(n?e.controlPointPreviousX:e.controlPointNextX,n?e.controlPointPreviousY:e.controlPointNextY,n?i.controlPointNextX:i.controlPointPreviousX,n?i.controlPointNextY:i.controlPointPreviousY,i.x,i.y):t.lineTo(i.x,i.y)}},n.clear=i.clear,n.drawRoundedRectangle=function(t){t.beginPath(),i.roundedRect.apply(i,arguments)}},{43:43}],43:[function(t,e,i){"use strict";var n,d={noop:function(){},uid:(n=0,function(){return n++}),isNullOrUndef:function(t){return null==t},isArray:Array.isArray?Array.isArray:function(t){return"[object Array]"===Object.prototype.toString.call(t)},isObject:function(t){return null!==t&&"[object Object]"===Object.prototype.toString.call(t)},valueOrDefault:function(t,e){return void 0===t?e:t},valueAtIndexOrDefault:function(t,e,i){return d.valueOrDefault(d.isArray(t)?t[e]:t,i)},callback:function(t,e,i){if(t&&"function"==typeof t.call)return t.apply(i,e)},each:function(t,e,i,n){var a,o,r;if(d.isArray(t))if(o=t.length,n)for(a=o-1;0<=a;a--)e.call(i,t[a],a);else for(a=0;a<o;a++)e.call(i,t[a],a);else if(d.isObject(t))for(o=(r=Object.keys(t)).length,a=0;a<o;a++)e.call(i,t[r[a]],r[a])},arrayEquals:function(t,e){var i,n,a,o;if(!t||!e||t.length!==e.length)return!1;for(i=0,n=t.length;i<n;++i)if(a=t[i],o=e[i],a instanceof Array&&o instanceof Array){if(!d.arrayEquals(a,o))return!1}else if(a!==o)return!1;return!0},clone:function(t){if(d.isArray(t))return t.map(d.clone);if(d.isObject(t)){for(var e={},i=Object.keys(t),n=i.length,a=0;a<n;++a)e[i[a]]=d.clone(t[i[a]]);return e}return t},_merger:function(t,e,i,n){var a=e[t],o=i[t];d.isObject(a)&&d.isObject(o)?d.merge(a,o,n):e[t]=d.clone(o)},_mergerIf:function(t,e,i){var n=e[t],a=i[t];d.isObject(n)&&d.isObject(a)?d.mergeIf(n,a):e.hasOwnProperty(t)||(e[t]=d.clone(a))},merge:function(t,e,i){var n,a,o,r,s,l=d.isArray(e)?e:[e],u=l.length;if(!d.isObject(t))return t;for(n=(i=i||{}).merger||d._merger,a=0;a<u;++a)if(e=l[a],d.isObject(e))for(s=0,r=(o=Object.keys(e)).length;s<r;++s)n(o[s],t,e,i);return t},mergeIf:function(t,e){return d.merge(t,e,{merger:d._mergerIf})},extend:function(i){for(var e=1,n=arguments.length;e<n;++e)d.each(arguments[e],function(t,e){i[e]=t});return i},inherits:function(t){var e=this,i=t&&t.hasOwnProperty("constructor")?t.constructor:function(){return e.apply(this,arguments)},n=function(){this.constructor=i};return n.prototype=e.prototype,i.prototype=new n,i.extend=d.inherits,t&&d.extend(i.prototype,t),i.__super__=e.prototype,i}};(e.exports=d).callCallback=d.callback,d.indexOf=function(t,e,i){return Array.prototype.indexOf.call(t,e,i)},d.getValueOrDefault=d.valueOrDefault,d.getValueAtIndexOrDefault=d.valueAtIndexOrDefault},{}],44:[function(t,e,i){"use strict";var n=t(43),a={linear:function(t){return t},easeInQuad:function(t){return t*t},easeOutQuad:function(t){return-t*(t-2)},easeInOutQuad:function(t){return(t/=.5)<1?.5*t*t:-.5*(--t*(t-2)-1)},easeInCubic:function(t){return t*t*t},easeOutCubic:function(t){return(t-=1)*t*t+1},easeInOutCubic:function(t){return(t/=.5)<1?.5*t*t*t:.5*((t-=2)*t*t+2)},easeInQuart:function(t){return t*t*t*t},easeOutQuart:function(t){return-((t-=1)*t*t*t-1)},easeInOutQuart:function(t){return(t/=.5)<1?.5*t*t*t*t:-.5*((t-=2)*t*t*t-2)},easeInQuint:function(t){return t*t*t*t*t},easeOutQuint:function(t){return(t-=1)*t*t*t*t+1},easeInOutQuint:function(t){return(t/=.5)<1?.5*t*t*t*t*t:.5*((t-=2)*t*t*t*t+2)},easeInSine:function(t){return 1-Math.cos(t*(Math.PI/2))},easeOutSine:function(t){return Math.sin(t*(Math.PI/2))},easeInOutSine:function(t){return-.5*(Math.cos(Math.PI*t)-1)},easeInExpo:function(t){return 0===t?0:Math.pow(2,10*(t-1))},easeOutExpo:function(t){return 1===t?1:1-Math.pow(2,-10*t)},easeInOutExpo:function(t){return 0===t?0:1===t?1:(t/=.5)<1?.5*Math.pow(2,10*(t-1)):.5*(2-Math.pow(2,-10*--t))},easeInCirc:function(t){return 1<=t?t:-(Math.sqrt(1-t*t)-1)},easeOutCirc:function(t){return Math.sqrt(1-(t-=1)*t)},easeInOutCirc:function(t){return(t/=.5)<1?-.5*(Math.sqrt(1-t*t)-1):.5*(Math.sqrt(1-(t-=2)*t)+1)},easeInElastic:function(t){var e=1.70158,i=0,n=1;return 0===t?0:1===t?1:(i||(i=.3),e=n<1?(n=1,i/4):i/(2*Math.PI)*Math.asin(1/n),-n*Math.pow(2,10*(t-=1))*Math.sin((t-e)*(2*Math.PI)/i))},easeOutElastic:function(t){var e=1.70158,i=0,n=1;return 0===t?0:1===t?1:(i||(i=.3),e=n<1?(n=1,i/4):i/(2*Math.PI)*Math.asin(1/n),n*Math.pow(2,-10*t)*Math.sin((t-e)*(2*Math.PI)/i)+1)},easeInOutElastic:function(t){var e=1.70158,i=0,n=1;return 0===t?0:2==(t/=.5)?1:(i||(i=.45),e=n<1?(n=1,i/4):i/(2*Math.PI)*Math.asin(1/n),t<1?n*Math.pow(2,10*(t-=1))*Math.sin((t-e)*(2*Math.PI)/i)*-.5:n*Math.pow(2,-10*(t-=1))*Math.sin((t-e)*(2*Math.PI)/i)*.5+1)},easeInBack:function(t){return t*t*(2.70158*t-1.70158)},easeOutBack:function(t){return(t-=1)*t*(2.70158*t+1.70158)+1},easeInOutBack:function(t){var e=1.70158;return(t/=.5)<1?t*t*((1+(e*=1.525))*t-e)*.5:.5*((t-=2)*t*((1+(e*=1.525))*t+e)+2)},easeInBounce:function(t){return 1-a.easeOutBounce(1-t)},easeOutBounce:function(t){return t<1/2.75?7.5625*t*t:t<2/2.75?7.5625*(t-=1.5/2.75)*t+.75:t<2.5/2.75?7.5625*(t-=2.25/2.75)*t+.9375:7.5625*(t-=2.625/2.75)*t+.984375},easeInOutBounce:function(t){return t<.5?.5*a.easeInBounce(2*t):.5*a.easeOutBounce(2*t-1)+.5}};e.exports={effects:a},n.easingEffects=a},{43:43}],45:[function(t,e,i){"use strict";var r=t(43);e.exports={toLineHeight:function(t,e){var i=(""+t).match(/^(normal|(\d+(?:\.\d+)?)(px|em|%)?)$/);if(!i||"normal"===i[1])return 1.2*e;switch(t=+i[2],i[3]){case"px":return t;case"%":t/=100}return e*t},toPadding:function(t){var e,i,n,a;return r.isObject(t)?(e=+t.top||0,i=+t.right||0,n=+t.bottom||0,a=+t.left||0):e=i=n=a=+t||0,{top:e,right:i,bottom:n,left:a,height:e+n,width:a+i}},resolve:function(t,e,i){var n,a,o;for(n=0,a=t.length;n<a;++n)if(void 0!==(o=t[n])&&(void 0!==e&&"function"==typeof o&&(o=o(e)),void 0!==i&&r.isArray(o)&&(o=o[i]),void 0!==o))return o}}},{43:43}],46:[function(t,e,i){"use strict";e.exports=t(43),e.exports.easing=t(44),e.exports.canvas=t(42),e.exports.options=t(45)},{42:42,43:43,44:44,45:45}],47:[function(t,e,i){e.exports={acquireContext:function(t){return t&&t.canvas&&(t=t.canvas),t&&t.getContext("2d")||null}}},{}],48:[function(t,e,i){"use strict";function l(t,e){var i=f.getStyle(t,e),n=i&&i.match(/^(\d+)(\.\d+)?px$/);return n?Number(n[1]):void 0}function x(t,e,i){t.addEventListener(e,i,n)}function r(t,e,i){t.removeEventListener(e,i,n)}function y(t,e,i,n,a){return{type:t,chart:e,native:a||null,x:void 0!==i?i:null,y:void 0!==n?n:null}}function a(e,t,i){var n,a,o,r,s,l,u,d,c=e[g]||(e[g]={}),h=c.resizer=function(t){var e=document.createElement("div"),i=p+"size-monitor",n="position:absolute;left:0;top:0;right:0;bottom:0;overflow:hidden;pointer-events:none;visibility:hidden;z-index:-1;";e.style.cssText=n,e.className=i,e.innerHTML='<div class="'+i+'-expand" style="'+n+'"><div style="position:absolute;width:1000000px;height:1000000px;left:0;top:0"></div></div><div class="'+i+'-shrink" style="'+n+'"><div style="position:absolute;width:200%;height:200%;left:0; top:0"></div></div>';var a=e.childNodes[0],o=e.childNodes[1];e._reset=function(){a.scrollLeft=1e6,a.scrollTop=1e6,o.scrollLeft=1e6,o.scrollTop=1e6};var r=function(){e._reset(),t()};return x(a,"scroll",r.bind(a,"expand")),x(o,"scroll",r.bind(o,"shrink")),e}((o=!(n=function(){if(c.resizer)return t(y("resize",i))}),r=[],function(){r=Array.prototype.slice.call(arguments),a=a||this,o||(o=!0,f.requestAnimFrame.call(window,function(){o=!1,n.apply(a,r)}))}));l=function(){if(c.resizer){var t=e.parentNode;t&&t!==h.parentNode&&t.insertBefore(h,t.firstChild),h._reset()}},u=(s=e)[g]||(s[g]={}),d=u.renderProxy=function(t){t.animationName===v&&l()},f.each(b,function(t){x(s,t,d)}),u.reflow=!!s.offsetParent,s.classList.add(m)}function o(t){var e,i,n,a=t[g]||{},o=a.resizer;delete a.resizer,i=(e=t)[g]||{},(n=i.renderProxy)&&(f.each(b,function(t){r(e,t,n)}),delete i.renderProxy),e.classList.remove(m),o&&o.parentNode&&o.parentNode.removeChild(o)}var f=t(46),g="$chartjs",p="chartjs-",m=p+"render-monitor",v=p+"render-animation",b=["animationstart","webkitAnimationStart"],s={touchstart:"mousedown",touchmove:"mousemove",touchend:"mouseup",pointerenter:"mouseenter",pointerdown:"mousedown",pointermove:"mousemove",pointerup:"mouseup",pointerleave:"mouseout",pointerout:"mouseout"},n=!!function(){var t=!1;try{var e=Object.defineProperty({},"passive",{get:function(){t=!0}});window.addEventListener("e",null,e)}catch(t){}return t}()&&{passive:!0};e.exports={_enabled:"undefined"!=typeof window&&"undefined"!=typeof document,initialize:function(){var t,e,i,n="from{opacity:0.99}to{opacity:1}";e="@-webkit-keyframes "+v+"{"+n+"}@keyframes "+v+"{"+n+"}."+m+"{-webkit-animation:"+v+" 0.001s;animation:"+v+" 0.001s;}",i=(t=this)._style||document.createElement("style"),t._style||(e="/* Chart.js */\n"+e,(t._style=i).setAttribute("type","text/css"),document.getElementsByTagName("head")[0].appendChild(i)),i.appendChild(document.createTextNode(e))},acquireContext:function(t,e){"string"==typeof t?t=document.getElementById(t):t.length&&(t=t[0]),t&&t.canvas&&(t=t.canvas);var i=t&&t.getContext&&t.getContext("2d");return i&&i.canvas===t?(function(t,e){var i=t.style,n=t.getAttribute("height"),a=t.getAttribute("width");if(t[g]={initial:{height:n,width:a,style:{display:i.display,height:i.height,width:i.width}}},i.display=i.display||"block",null===a||""===a){var o=l(t,"width");void 0!==o&&(t.width=o)}if(null===n||""===n)if(""===t.style.height)t.height=t.width/(e.options.aspectRatio||2);else{var r=l(t,"height");void 0!==o&&(t.height=r)}}(t,e),i):null},releaseContext:function(t){var i=t.canvas;if(i[g]){var n=i[g].initial;["height","width"].forEach(function(t){var e=n[t];f.isNullOrUndef(e)?i.removeAttribute(t):i.setAttribute(t,e)}),f.each(n.style||{},function(t,e){i.style[e]=t}),i.width=i.width,delete i[g]}},addEventListener:function(o,t,r){var e=o.canvas;if("resize"!==t){var i=r[g]||(r[g]={});x(e,t,(i.proxies||(i.proxies={}))[o.id+"_"+t]=function(t){var e,i,n,a;r((i=o,n=s[(e=t).type]||e.type,a=f.getRelativePosition(e,i),y(n,i,a.x,a.y,e)))})}else a(e,r,o)},removeEventListener:function(t,e,i){var n=t.canvas;if("resize"!==e){var a=((i[g]||{}).proxies||{})[t.id+"_"+e];a&&r(n,e,a)}else o(n)}},f.addEvent=x,f.removeEvent=r},{46:46}],49:[function(t,e,i){"use strict";var n=t(46),a=t(47),o=t(48),r=o._enabled?o:a;e.exports=n.extend({initialize:function(){},acquireContext:function(){},releaseContext:function(){},addEventListener:function(){},removeEventListener:function(){}},r)},{46:46,47:47,48:48}],50:[function(t,e,i){"use strict";e.exports={},e.exports.filler=t(51),e.exports.legend=t(52),e.exports.title=t(53)},{51:51,52:52,53:53}],51:[function(t,e,i){"use strict";function g(t,e,i){var n,a=t._model||{},o=a.fill;if(void 0===o&&(o=!!a.backgroundColor),!1===o||null===o)return!1;if(!0===o)return"origin";if(n=parseFloat(o,10),isFinite(n)&&Math.floor(n)===n)return"-"!==o[0]&&"+"!==o[0]||(n=e+n),!(n===e||n<0||i<=n)&&n;switch(o){case"bottom":return"start";case"top":return"end";case"zero":return"origin";case"origin":case"start":case"end":return o;default:return!1}}function p(t){var e,i=t.el._model||{},n=t.el._scale||{},a=t.fill,o=null;if(isFinite(a))return null;if("start"===a?o=void 0===i.scaleBottom?n.bottom:i.scaleBottom:"end"===a?o=void 0===i.scaleTop?n.top:i.scaleTop:void 0!==i.scaleZero?o=i.scaleZero:n.getBasePosition?o=n.getBasePosition():n.getBasePixel&&(o=n.getBasePixel()),null!=o){if(void 0!==o.x&&void 0!==o.y)return o;if("number"==typeof o&&isFinite(o))return{x:(e=n.isHorizontal())?o:null,y:e?null:o}}return null}function m(t,e,i){var n,a=t[e].fill,o=[e];if(!i)return a;for(;!1!==a&&-1===o.indexOf(a);){if(!isFinite(a))return a;if(!(n=t[a]))return!1;if(n.visible)return a;o.push(a),a=n.fill}return!1}function x(t){return t&&!t.skip}function y(t,e,i,n,a){var o;if(n&&a){for(t.moveTo(e[0].x,e[0].y),o=1;o<n;++o)d.canvas.lineTo(t,e[o-1],e[o]);for(t.lineTo(i[a-1].x,i[a-1].y),o=a-1;0<o;--o)d.canvas.lineTo(t,i[o],i[o-1],!0)}}var u=t(26),h=t(41),d=t(46);u._set("global",{plugins:{filler:{propagate:!0}}});var f={dataset:function(t){var e=t.fill,i=t.chart,n=i.getDatasetMeta(e),a=n&&i.isDatasetVisible(e)&&n.dataset._children||[],o=a.length||0;return o?function(t,e){return e<o&&a[e]._view||null}:null},boundary:function(t){var e=t.boundary,i=e?e.x:null,n=e?e.y:null;return function(t){return{x:null===i?t.x:i,y:null===n?t.y:n}}}};e.exports={id:"filler",afterDatasetsUpdate:function(t,e){var i,n,a,o,r,s,l,u=(t.data.datasets||[]).length,d=e.propagate,c=[];for(n=0;n<u;++n)o=null,(a=(i=t.getDatasetMeta(n)).dataset)&&a._model&&a instanceof h.Line&&(o={visible:t.isDatasetVisible(n),fill:g(a,n,u),chart:t,el:a}),i.$filler=o,c.push(o);for(n=0;n<u;++n)(o=c[n])&&(o.fill=m(c,n,d),o.boundary=p(o),o.mapper=(l=void 0,s=(r=o).fill,!(l="dataset")===s?null:(isFinite(s)||(l="boundary"),f[l](r))))},beforeDatasetDraw:function(t,e){var i=e.meta.$filler;if(i){var n=t.ctx,a=i.el,o=a._view,r=a._children||[],s=i.mapper,l=o.backgroundColor||u.global.defaultColor;s&&l&&r.length&&(d.canvas.clipArea(n,t.chartArea),function(t,e,i,n,a,o){var r,s,l,u,d,c,h,f=e.length,g=n.spanGaps,p=[],m=[],v=0,b=0;for(t.beginPath(),r=0,s=f+!!o;r<s;++r)d=i(u=e[l=r%f]._view,l,n),c=x(u),h=x(d),c&&h?(v=p.push(u),b=m.push(d)):v&&b&&(g?(c&&p.push(u),h&&m.push(d)):(y(t,p,m,v,b),v=b=0,p=[],m=[]));y(t,p,m,v,b),t.closePath(),t.fillStyle=a,t.fill()}(n,r,s,o,l,a._loop),d.canvas.unclipArea(n))}}}},{26:26,41:41,46:46}],52:[function(t,e,i){"use strict";function P(t,e){return t.usePointStyle?e*Math.SQRT2:t.boxWidth}function s(t,e){var i=new r({ctx:t.ctx,options:e,chart:t});a.configure(t,i,e),a.addBox(t,i),t.legend=i}var _=t(26),n=t(27),D=t(46),a=t(31),o=D.noop;_._set("global",{legend:{display:!0,position:"top",fullWidth:!0,reverse:!1,weight:1e3,onClick:function(t,e){var i=e.datasetIndex,n=this.chart,a=n.getDatasetMeta(i);a.hidden=null===a.hidden?!n.data.datasets[i].hidden:null,n.update()},onHover:null,labels:{boxWidth:40,padding:10,generateLabels:function(i){var t=i.data;return D.isArray(t.datasets)?t.datasets.map(function(t,e){return{text:t.label,fillStyle:D.isArray(t.backgroundColor)?t.backgroundColor[0]:t.backgroundColor,hidden:!i.isDatasetVisible(e),lineCap:t.borderCapStyle,lineDash:t.borderDash,lineDashOffset:t.borderDashOffset,lineJoin:t.borderJoinStyle,lineWidth:t.borderWidth,strokeStyle:t.borderColor,pointStyle:t.pointStyle,datasetIndex:e}},this):[]}}},legendCallback:function(t){var e=[];e.push('<ul class="'+t.id+'-legend">');for(var i=0;i<t.data.datasets.length;i++)e.push('<li><span style="background-color:'+t.data.datasets[i].backgroundColor+'"></span>'),t.data.datasets[i].label&&e.push(t.data.datasets[i].label),e.push("</li>");return e.push("</ul>"),e.join("")}});var r=n.extend({initialize:function(t){D.extend(this,t),this.legendHitBoxes=[],this.doughnutMode=!1},beforeUpdate:o,update:function(t,e,i){var n=this;return n.beforeUpdate(),n.maxWidth=t,n.maxHeight=e,n.margins=i,n.beforeSetDimensions(),n.setDimensions(),n.afterSetDimensions(),n.beforeBuildLabels(),n.buildLabels(),n.afterBuildLabels(),n.beforeFit(),n.fit(),n.afterFit(),n.afterUpdate(),n.minSize},afterUpdate:o,beforeSetDimensions:o,setDimensions:function(){var t=this;t.isHorizontal()?(t.width=t.maxWidth,t.left=0,t.right=t.width):(t.height=t.maxHeight,t.top=0,t.bottom=t.height),t.paddingLeft=0,t.paddingTop=0,t.paddingRight=0,t.paddingBottom=0,t.minSize={width:0,height:0}},afterSetDimensions:o,beforeBuildLabels:o,buildLabels:function(){var e=this,i=e.options.labels||{},t=D.callback(i.generateLabels,[e.chart],e)||[];i.filter&&(t=t.filter(function(t){return i.filter(t,e.chart.data)})),e.options.reverse&&t.reverse(),e.legendItems=t},afterBuildLabels:o,beforeFit:o,fit:function(){var n=this,t=n.options,a=t.labels,e=t.display,o=n.ctx,i=_.global,r=D.valueOrDefault,s=r(a.fontSize,i.defaultFontSize),l=r(a.fontStyle,i.defaultFontStyle),u=r(a.fontFamily,i.defaultFontFamily),d=D.fontString(s,l,u),c=n.legendHitBoxes=[],h=n.minSize,f=n.isHorizontal();if(h.height=f?(h.width=n.maxWidth,e?10:0):(h.width=e?10:0,n.maxHeight),e)if(o.font=d,f){var g=n.lineWidths=[0],p=n.legendItems.length?s+a.padding:0;o.textAlign="left",o.textBaseline="top",D.each(n.legendItems,function(t,e){var i=P(a,s)+s/2+o.measureText(t.text).width;g[g.length-1]+i+a.padding>=n.width&&(p+=s+a.padding,g[g.length]=n.left),c[e]={left:0,top:0,width:i,height:s},g[g.length-1]+=i+a.padding}),h.height+=p}else{var m=a.padding,v=n.columnWidths=[],b=a.padding,x=0,y=0,k=s+m;D.each(n.legendItems,function(t,e){var i=P(a,s)+s/2+o.measureText(t.text).width;y+k>h.height&&(b+=x+a.padding,v.push(x),y=x=0),x=Math.max(x,i),y+=k,c[e]={left:0,top:0,width:i,height:s}}),b+=x,v.push(x),h.width+=b}n.width=h.width,n.height=h.height},afterFit:o,isHorizontal:function(){return"top"===this.options.position||"bottom"===this.options.position},draw:function(){var c=this,h=c.options,f=h.labels,g=_.global,p=g.elements.line,m=c.width,v=c.lineWidths;if(h.display){var b,x=c.ctx,y=D.valueOrDefault,t=y(f.fontColor,g.defaultFontColor),k=y(f.fontSize,g.defaultFontSize),e=y(f.fontStyle,g.defaultFontStyle),i=y(f.fontFamily,g.defaultFontFamily),n=D.fontString(k,e,i);x.textAlign="left",x.textBaseline="middle",x.lineWidth=.5,x.strokeStyle=t,x.fillStyle=t,x.font=n;var M=P(f,k),w=c.legendHitBoxes,C=c.isHorizontal();b=C?{x:c.left+(m-v[0])/2,y:c.top+f.padding,line:0}:{x:c.left+f.padding,y:c.top+f.padding,line:0};var S=k+f.padding;D.each(c.legendItems,function(t,e){var i,n,a,o,r,s=x.measureText(t.text).width,l=M+k/2+s,u=b.x,d=b.y;C?m<=u+l&&(d=b.y+=S,b.line++,u=b.x=c.left+(m-v[b.line])/2):d+S>c.bottom&&(u=b.x=u+c.columnWidths[b.line]+f.padding,d=b.y=c.top+f.padding,b.line++),function(t,e,i){if(!(isNaN(M)||M<=0)){x.save(),x.fillStyle=y(i.fillStyle,g.defaultColor),x.lineCap=y(i.lineCap,p.borderCapStyle),x.lineDashOffset=y(i.lineDashOffset,p.borderDashOffset),x.lineJoin=y(i.lineJoin,p.borderJoinStyle),x.lineWidth=y(i.lineWidth,p.borderWidth),x.strokeStyle=y(i.strokeStyle,g.defaultColor);var n=0===y(i.lineWidth,p.borderWidth);if(x.setLineDash&&x.setLineDash(y(i.lineDash,p.borderDash)),h.labels&&h.labels.usePointStyle){var a=k*Math.SQRT2/2,o=a/Math.SQRT2,r=t+o,s=e+o;D.canvas.drawPoint(x,i.pointStyle,a,r,s)}else n||x.strokeRect(t,e,M,k),x.fillRect(t,e,M,k);x.restore()}}(u,d,t),w[e].left=u,w[e].top=d,i=t,n=s,o=M+(a=k/2)+u,r=d+a,x.fillText(i.text,o,r),i.hidden&&(x.beginPath(),x.lineWidth=2,x.moveTo(o,r),x.lineTo(o+n,r),x.stroke()),C?b.x+=l+f.padding:b.y+=S})}},handleEvent:function(t){var e=this,i=e.options,n="mouseup"===t.type?"click":t.type,a=!1;if("mousemove"===n){if(!i.onHover)return}else{if("click"!==n)return;if(!i.onClick)return}var o=t.x,r=t.y;if(o>=e.left&&o<=e.right&&r>=e.top&&r<=e.bottom)for(var s=e.legendHitBoxes,l=0;l<s.length;++l){var u=s[l];if(o>=u.left&&o<=u.left+u.width&&r>=u.top&&r<=u.top+u.height){if("click"===n){i.onClick.call(e,t.native,e.legendItems[l]),a=!0;break}if("mousemove"===n){i.onHover.call(e,t.native,e.legendItems[l]),a=!0;break}}}return a}});e.exports={id:"legend",_element:r,beforeInit:function(t){var e=t.options.legend;e&&s(t,e)},beforeUpdate:function(t){var e=t.options.legend,i=t.legend;e?(D.mergeIf(e,_.global.legend),i?(a.configure(t,i,e),i.options=e):s(t,e)):i&&(a.removeBox(t,i),delete t.legend)},afterEvent:function(t,e){var i=t.legend;i&&i.handleEvent(e)}}},{26:26,27:27,31:31,46:46}],53:[function(t,e,i){"use strict";function s(t,e){var i=new r({ctx:t.ctx,options:e,chart:t});a.configure(t,i,e),a.addBox(t,i),t.titleBlock=i}var M=t(26),n=t(27),w=t(46),a=t(31),o=w.noop;M._set("global",{title:{display:!1,fontStyle:"bold",fullWidth:!0,lineHeight:1.2,padding:10,position:"top",text:"",weight:2e3}});var r=n.extend({initialize:function(t){w.extend(this,t),this.legendHitBoxes=[]},beforeUpdate:o,update:function(t,e,i){var n=this;return n.beforeUpdate(),n.maxWidth=t,n.maxHeight=e,n.margins=i,n.beforeSetDimensions(),n.setDimensions(),n.afterSetDimensions(),n.beforeBuildLabels(),n.buildLabels(),n.afterBuildLabels(),n.beforeFit(),n.fit(),n.afterFit(),n.afterUpdate(),n.minSize},afterUpdate:o,beforeSetDimensions:o,setDimensions:function(){var t=this;t.isHorizontal()?(t.width=t.maxWidth,t.left=0,t.right=t.width):(t.height=t.maxHeight,t.top=0,t.bottom=t.height),t.paddingLeft=0,t.paddingTop=0,t.paddingRight=0,t.paddingBottom=0,t.minSize={width:0,height:0}},afterSetDimensions:o,beforeBuildLabels:o,buildLabels:o,afterBuildLabels:o,beforeFit:o,fit:function(){var t=this,e=w.valueOrDefault,i=t.options,n=i.display,a=e(i.fontSize,M.global.defaultFontSize),o=t.minSize,r=w.isArray(i.text)?i.text.length:1,s=w.options.toLineHeight(i.lineHeight,a),l=n?r*s+2*i.padding:0;t.isHorizontal()?(o.width=t.maxWidth,o.height=l):(o.width=l,o.height=t.maxHeight),t.width=o.width,t.height=o.height},afterFit:o,isHorizontal:function(){var t=this.options.position;return"top"===t||"bottom"===t},draw:function(){var t=this,e=t.ctx,i=w.valueOrDefault,n=t.options,a=M.global;if(n.display){var o,r,s,l=i(n.fontSize,a.defaultFontSize),u=i(n.fontStyle,a.defaultFontStyle),d=i(n.fontFamily,a.defaultFontFamily),c=w.fontString(l,u,d),h=w.options.toLineHeight(n.lineHeight,l),f=h/2+n.padding,g=0,p=t.top,m=t.left,v=t.bottom,b=t.right;e.fillStyle=i(n.fontColor,a.defaultFontColor),e.font=c,t.isHorizontal()?(r=m+(b-m)/2,s=p+f,o=b-m):(r="left"===n.position?m+f:b-f,s=p+(v-p)/2,o=v-p,g=Math.PI*("left"===n.position?-.5:.5)),e.save(),e.translate(r,s),e.rotate(g),e.textAlign="center",e.textBaseline="middle";var x=n.text;if(w.isArray(x))for(var y=0,k=0;k<x.length;++k)e.fillText(x[k],0,y,o),y+=h;else e.fillText(x,0,0,o);e.restore()}}});e.exports={id:"title",_element:r,beforeInit:function(t){var e=t.options.title;e&&s(t,e)},beforeUpdate:function(t){var e=t.options.title,i=t.titleBlock;e?(w.mergeIf(e,M.global.title),i?(a.configure(t,i,e),i.options=e):s(t,e)):i&&(a.removeBox(t,i),delete t.titleBlock)}}},{26:26,27:27,31:31,46:46}],54:[function(t,e,i){"use strict";var n=t(33),a=t(34);e.exports=function(){var t=n.extend({getLabels:function(){var t=this.chart.data;return this.options.labels||(this.isHorizontal()?t.xLabels:t.yLabels)||t.labels},determineDataLimits:function(){var t,e=this,i=e.getLabels();e.minIndex=0,e.maxIndex=i.length-1,void 0!==e.options.ticks.min&&(t=i.indexOf(e.options.ticks.min),e.minIndex=-1!==t?t:e.minIndex),void 0!==e.options.ticks.max&&(t=i.indexOf(e.options.ticks.max),e.maxIndex=-1!==t?t:e.maxIndex),e.min=i[e.minIndex],e.max=i[e.maxIndex]},buildTicks:function(){var t=this,e=t.getLabels();t.ticks=0===t.minIndex&&t.maxIndex===e.length-1?e:e.slice(t.minIndex,t.maxIndex+1)},getLabelForIndex:function(t,e){var i=this,n=i.chart.data,a=i.isHorizontal();return n.yLabels&&!a?i.getRightValue(n.datasets[e].data[t]):i.ticks[t-i.minIndex]},getPixelForValue:function(t,e){var i,n=this,a=n.options.offset,o=Math.max(n.maxIndex+1-n.minIndex-(a?0:1),1);if(null!=t&&(i=n.isHorizontal()?t.x:t.y),void 0!==i||void 0!==t&&isNaN(e)){t=i||t;var r=n.getLabels().indexOf(t);e=-1!==r?r:e}if(n.isHorizontal()){var s=n.width/o,l=s*(e-n.minIndex);return a&&(l+=s/2),n.left+Math.round(l)}var u=n.height/o,d=u*(e-n.minIndex);return a&&(d+=u/2),n.top+Math.round(d)},getPixelForTick:function(t){return this.getPixelForValue(this.ticks[t],t+this.minIndex,null)},getValueForPixel:function(t){var e=this,i=e.options.offset,n=Math.max(e._ticks.length-(i?0:1),1),a=e.isHorizontal(),o=(a?e.width:e.height)/n;return t-=a?e.left:e.top,i&&(t-=o/2),(t<=0?0:Math.round(t/o))+e.minIndex},getBasePixel:function(){return this.bottom}});a.registerScaleType("category",t,{position:"bottom"})}},{33:33,34:34}],55:[function(t,e,i){"use strict";var n=t(26),c=t(46),a=t(34),o=t(35);e.exports=function(t){var e={position:"left",ticks:{callback:o.formatters.linear}},i=t.LinearScaleBase.extend({determineDataLimits:function(){function u(t){return e?t.xAxisID===r.id:t.yAxisID===r.id}var r=this,s=r.options,l=r.chart,t=l.data.datasets,e=r.isHorizontal();r.min=null,r.max=null;var n=s.stacked;if(void 0===n&&c.each(t,function(t,e){if(!n){var i=l.getDatasetMeta(e);l.isDatasetVisible(e)&&u(i)&&void 0!==i.stack&&(n=!0)}}),s.stacked||n){var d={};c.each(t,function(t,e){var n=l.getDatasetMeta(e),i=[n.type,void 0===s.stacked&&void 0===n.stack?e:"",n.stack].join(".");void 0===d[i]&&(d[i]={positiveValues:[],negativeValues:[]});var a=d[i].positiveValues,o=d[i].negativeValues;l.isDatasetVisible(e)&&u(n)&&c.each(t.data,function(t,e){var i=+r.getRightValue(t);isNaN(i)||n.data[e].hidden||(a[e]=a[e]||0,o[e]=o[e]||0,s.relativePoints?a[e]=100:i<0?o[e]+=i:a[e]+=i)})}),c.each(d,function(t){var e=t.positiveValues.concat(t.negativeValues),i=c.min(e),n=c.max(e);r.min=null===r.min?i:Math.min(r.min,i),r.max=null===r.max?n:Math.max(r.max,n)})}else c.each(t,function(t,e){var n=l.getDatasetMeta(e);l.isDatasetVisible(e)&&u(n)&&c.each(t.data,function(t,e){var i=+r.getRightValue(t);isNaN(i)||n.data[e].hidden||(null===r.min?r.min=i:i<r.min&&(r.min=i),null===r.max?r.max=i:i>r.max&&(r.max=i))})});r.min=isFinite(r.min)&&!isNaN(r.min)?r.min:0,r.max=isFinite(r.max)&&!isNaN(r.max)?r.max:1,this.handleTickRangeOptions()},getTickLimit:function(){var t,e=this.options.ticks;if(this.isHorizontal())t=Math.min(e.maxTicksLimit?e.maxTicksLimit:11,Math.ceil(this.width/50));else{var i=c.valueOrDefault(e.fontSize,n.global.defaultFontSize);t=Math.min(e.maxTicksLimit?e.maxTicksLimit:11,Math.ceil(this.height/(2*i)))}return t},handleDirectionalChanges:function(){this.isHorizontal()||this.ticks.reverse()},getLabelForIndex:function(t,e){return+this.getRightValue(this.chart.data.datasets[e].data[t])},getPixelForValue:function(t){var e=this,i=e.start,n=+e.getRightValue(t),a=e.end-i;return e.isHorizontal()?e.left+e.width/a*(n-i):e.bottom-e.height/a*(n-i)},getValueForPixel:function(t){var e=this,i=e.isHorizontal(),n=i?e.width:e.height,a=(i?t-e.left:e.bottom-t)/n;return e.start+(e.end-e.start)*a},getPixelForTick:function(t){return this.getPixelForValue(this.ticksAsNumbers[t])}});a.registerScaleType("linear",i,e)}},{26:26,34:34,35:35,46:46}],56:[function(t,e,i){"use strict";var c=t(46),n=t(33);e.exports=function(t){var e=c.noop;t.LinearScaleBase=n.extend({getRightValue:function(t){return"string"==typeof t?+t:n.prototype.getRightValue.call(this,t)},handleTickRangeOptions:function(){var t=this,e=t.options.ticks;if(e.beginAtZero){var i=c.sign(t.min),n=c.sign(t.max);i<0&&n<0?t.max=0:0<i&&0<n&&(t.min=0)}var a=void 0!==e.min||void 0!==e.suggestedMin,o=void 0!==e.max||void 0!==e.suggestedMax;void 0!==e.min?t.min=e.min:void 0!==e.suggestedMin&&(null===t.min?t.min=e.suggestedMin:t.min=Math.min(t.min,e.suggestedMin)),void 0!==e.max?t.max=e.max:void 0!==e.suggestedMax&&(null===t.max?t.max=e.suggestedMax:t.max=Math.max(t.max,e.suggestedMax)),a!==o&&t.min>=t.max&&(a?t.max=t.min+1:t.min=t.max-1),t.min===t.max&&(t.max++,e.beginAtZero||t.min--)},getTickLimit:e,handleDirectionalChanges:e,buildTicks:function(){var t=this,e=t.options.ticks,i=t.getTickLimit(),n={maxTicks:i=Math.max(2,i),min:e.min,max:e.max,precision:e.precision,stepSize:c.valueOrDefault(e.fixedStepSize,e.stepSize)},a=t.ticks=function(t,e){var i,n,a,o=[];if(t.stepSize&&0<t.stepSize)a=t.stepSize;else{var r=c.niceNum(e.max-e.min,!1);a=c.niceNum(r/(t.maxTicks-1),!0),void 0!==(n=t.precision)&&(i=Math.pow(10,n),a=Math.ceil(a*i)/i)}var s=Math.floor(e.min/a)*a,l=Math.ceil(e.max/a)*a;c.isNullOrUndef(t.min)||c.isNullOrUndef(t.max)||!t.stepSize||c.almostWhole((t.max-t.min)/t.stepSize,a/1e3)&&(s=t.min,l=t.max);var u=(l-s)/a;u=c.almostEquals(u,Math.round(u),a/1e3)?Math.round(u):Math.ceil(u),a<(n=1)&&(n=Math.pow(10,1-Math.floor(c.log10(a))),s=Math.round(s*n)/n,l=Math.round(l*n)/n),o.push(void 0!==t.min?t.min:s);for(var d=1;d<u;++d)o.push(Math.round((s+d*a)*n)/n);return o.push(void 0!==t.max?t.max:l),o}(n,t);t.handleDirectionalChanges(),t.max=c.max(a),t.min=c.min(a),e.reverse?(a.reverse(),t.start=t.max,t.end=t.min):(t.start=t.min,t.end=t.max)},convertTicksToLabels:function(){var t=this;t.ticksAsNumbers=t.ticks.slice(),t.zeroLineIndex=t.ticks.indexOf(0),n.prototype.convertTicksToLabels.call(t)}})}},{33:33,46:46}],57:[function(t,e,i){"use strict";var h=t(46),n=t(33),a=t(34),o=t(35);e.exports=function(c){var t={position:"left",ticks:{callback:o.formatters.logarithmic}},e=n.extend({determineDataLimits:function(){function l(t){return e?t.xAxisID===r.id:t.yAxisID===r.id}var r=this,i=r.options,s=r.chart,t=s.data.datasets,e=r.isHorizontal();r.min=null,r.max=null,r.minNotZero=null;var n=i.stacked;if(void 0===n&&h.each(t,function(t,e){if(!n){var i=s.getDatasetMeta(e);s.isDatasetVisible(e)&&l(i)&&void 0!==i.stack&&(n=!0)}}),i.stacked||n){var u={};h.each(t,function(t,e){var a=s.getDatasetMeta(e),o=[a.type,void 0===i.stacked&&void 0===a.stack?e:"",a.stack].join(".");s.isDatasetVisible(e)&&l(a)&&(void 0===u[o]&&(u[o]=[]),h.each(t.data,function(t,e){var i=u[o],n=+r.getRightValue(t);isNaN(n)||a.data[e].hidden||n<0||(i[e]=i[e]||0,i[e]+=n)}))}),h.each(u,function(t){if(0<t.length){var e=h.min(t),i=h.max(t);r.min=null===r.min?e:Math.min(r.min,e),r.max=null===r.max?i:Math.max(r.max,i)}})}else h.each(t,function(t,e){var n=s.getDatasetMeta(e);s.isDatasetVisible(e)&&l(n)&&h.each(t.data,function(t,e){var i=+r.getRightValue(t);isNaN(i)||n.data[e].hidden||i<0||(null===r.min?r.min=i:i<r.min&&(r.min=i),null===r.max?r.max=i:i>r.max&&(r.max=i),0!==i&&(null===r.minNotZero||i<r.minNotZero)&&(r.minNotZero=i))})});this.handleTickRangeOptions()},handleTickRangeOptions:function(){var t=this,e=t.options.ticks,i=h.valueOrDefault;t.min=i(e.min,t.min),t.max=i(e.max,t.max),t.min===t.max&&(0!==t.min&&null!==t.min?(t.min=Math.pow(10,Math.floor(h.log10(t.min))-1),t.max=Math.pow(10,Math.floor(h.log10(t.max))+1)):(t.min=1,t.max=10)),null===t.min&&(t.min=Math.pow(10,Math.floor(h.log10(t.max))-1)),null===t.max&&(t.max=0!==t.min?Math.pow(10,Math.floor(h.log10(t.min))+1):10),null===t.minNotZero&&(0<t.min?t.minNotZero=t.min:t.max<1?t.minNotZero=Math.pow(10,Math.floor(h.log10(t.max))):t.minNotZero=1)},buildTicks:function(){var t=this,e=t.options.ticks,i=!t.isHorizontal(),n={min:e.min,max:e.max},a=t.ticks=function(t,e){var i,n,a=[],o=h.valueOrDefault,r=o(t.min,Math.pow(10,Math.floor(h.log10(e.min)))),s=Math.floor(h.log10(e.max)),l=Math.ceil(e.max/Math.pow(10,s));0===r?(i=Math.floor(h.log10(e.minNotZero)),n=Math.floor(e.minNotZero/Math.pow(10,i)),a.push(r),r=n*Math.pow(10,i)):(i=Math.floor(h.log10(r)),n=Math.floor(r/Math.pow(10,i)));for(var u=i<0?Math.pow(10,Math.abs(i)):1;a.push(r),10==++n&&(n=1,u=0<=++i?1:u),r=Math.round(n*Math.pow(10,i)*u)/u,i<s||i===s&&n<l;);var d=o(t.max,r);return a.push(d),a}(n,t);t.max=h.max(a),t.min=h.min(a),e.reverse?(i=!i,t.start=t.max,t.end=t.min):(t.start=t.min,t.end=t.max),i&&a.reverse()},convertTicksToLabels:function(){this.tickValues=this.ticks.slice(),n.prototype.convertTicksToLabels.call(this)},getLabelForIndex:function(t,e){return+this.getRightValue(this.chart.data.datasets[e].data[t])},getPixelForTick:function(t){return this.getPixelForValue(this.tickValues[t])},_getFirstTickValue:function(t){var e=Math.floor(h.log10(t));return Math.floor(t/Math.pow(10,e))*Math.pow(10,e)},getPixelForValue:function(t){var e,i,n,a,o,r=this,s=r.options.ticks.reverse,l=h.log10,u=r._getFirstTickValue(r.minNotZero),d=0;return t=+r.getRightValue(t),o=s?(n=r.end,a=r.start,-1):(n=r.start,a=r.end,1),i=r.isHorizontal()?(e=r.width,s?r.right:r.left):(e=r.height,o*=-1,s?r.top:r.bottom),t!==n&&(0===n&&(e-=d=h.getValueOrDefault(r.options.ticks.fontSize,c.defaults.global.defaultFontSize),n=u),0!==t&&(d+=e/(l(a)-l(n))*(l(t)-l(n))),i+=o*d),i},getValueForPixel:function(t){var e,i,n,a,o=this,r=o.options.ticks.reverse,s=h.log10,l=o._getFirstTickValue(o.minNotZero);if(n=r?(i=o.end,o.start):(i=o.start,o.end),(a=o.isHorizontal()?(e=o.width,r?o.right-t:t-o.left):(e=o.height,r?t-o.top:o.bottom-t))!==i){if(0===i){var u=h.getValueOrDefault(o.options.ticks.fontSize,c.defaults.global.defaultFontSize);a-=u,e-=u,i=l}a*=s(n)-s(i),a/=e,a=Math.pow(10,s(i)+a)}return a}});a.registerScaleType("logarithmic",e,t)}},{33:33,34:34,35:35,46:46}],58:[function(t,e,i){"use strict";var n=t(26),k=t(46),a=t(34),o=t(35);e.exports=function(e){function b(t){var e=t.options;return e.angleLines.display||e.pointLabels.display?t.chart.data.labels.length:0}function x(t){var e=t.options.pointLabels,i=k.valueOrDefault(e.fontSize,v.defaultFontSize),n=k.valueOrDefault(e.fontStyle,v.defaultFontStyle),a=k.valueOrDefault(e.fontFamily,v.defaultFontFamily);return{size:i,style:n,family:a,font:k.fontString(i,n,a)}}function m(t,e,i,n,a){return t===n||t===a?{start:e-i/2,end:e+i/2}:t<n||a<t?{start:e-i-5,end:e}:{start:e,end:e+i+5}}function y(t,e,i,n){if(k.isArray(e))for(var a=i.y,o=1.5*n,r=0;r<e.length;++r)t.fillText(e[r],i.x,a),a+=o;else t.fillText(e,i.x,i.y)}function s(t){return k.isNumber(t)?t:0}var v=n.global,t={display:!0,animate:!0,position:"chartArea",angleLines:{display:!0,color:"rgba(0, 0, 0, 0.1)",lineWidth:1},gridLines:{circular:!1},ticks:{showLabelBackdrop:!0,backdropColor:"rgba(255,255,255,0.75)",backdropPaddingY:2,backdropPaddingX:2,callback:o.formatters.linear},pointLabels:{display:!0,fontSize:10,callback:function(t){return t}}},i=e.LinearScaleBase.extend({setDimensions:function(){var t=this,e=t.options,i=e.ticks;t.width=t.maxWidth,t.height=t.maxHeight,t.xCenter=Math.round(t.width/2),t.yCenter=Math.round(t.height/2);var n=k.min([t.height,t.width]),a=k.valueOrDefault(i.fontSize,v.defaultFontSize);t.drawingArea=e.display?n/2-(a/2+i.backdropPaddingY):n/2},determineDataLimits:function(){var a=this,i=a.chart,o=Number.POSITIVE_INFINITY,r=Number.NEGATIVE_INFINITY;k.each(i.data.datasets,function(t,e){if(i.isDatasetVisible(e)){var n=i.getDatasetMeta(e);k.each(t.data,function(t,e){var i=+a.getRightValue(t);isNaN(i)||n.data[e].hidden||(o=Math.min(i,o),r=Math.max(i,r))})}}),a.min=o===Number.POSITIVE_INFINITY?0:o,a.max=r===Number.NEGATIVE_INFINITY?0:r,a.handleTickRangeOptions()},getTickLimit:function(){var t=this.options.ticks,e=k.valueOrDefault(t.fontSize,v.defaultFontSize);return Math.min(t.maxTicksLimit?t.maxTicksLimit:11,Math.ceil(this.drawingArea/(1.5*e)))},convertTicksToLabels:function(){var t=this;e.LinearScaleBase.prototype.convertTicksToLabels.call(t),t.pointLabels=t.chart.data.labels.map(t.options.pointLabels.callback,t)},getLabelForIndex:function(t,e){return+this.getRightValue(this.chart.data.datasets[e].data[t])},fit:function(){var t,e;this.options.pointLabels.display?function(t){var e,i,n,a=x(t),o=Math.min(t.height/2,t.width/2),r={r:t.width,l:0,t:t.height,b:0},s={};t.ctx.font=a.font,t._pointLabelSizes=[];var l,u,d,c=b(t);for(e=0;e<c;e++){n=t.getPointPosition(e,o),l=t.ctx,u=a.size,d=t.pointLabels[e]||"",i=k.isArray(d)?{w:k.longestText(l,l.font,d),h:d.length*u+1.5*(d.length-1)*u}:{w:l.measureText(d).width,h:u},t._pointLabelSizes[e]=i;var h=t.getIndexAngle(e),f=k.toDegrees(h)%360,g=m(f,n.x,i.w,0,180),p=m(f,n.y,i.h,90,270);g.start<r.l&&(r.l=g.start,s.l=h),g.end>r.r&&(r.r=g.end,s.r=h),p.start<r.t&&(r.t=p.start,s.t=h),p.end>r.b&&(r.b=p.end,s.b=h)}t.setReductions(o,r,s)}(this):(t=this,e=Math.min(t.height/2,t.width/2),t.drawingArea=Math.round(e),t.setCenterPoint(0,0,0,0))},setReductions:function(t,e,i){var n=e.l/Math.sin(i.l),a=Math.max(e.r-this.width,0)/Math.sin(i.r),o=-e.t/Math.cos(i.t),r=-Math.max(e.b-this.height,0)/Math.cos(i.b);n=s(n),a=s(a),o=s(o),r=s(r),this.drawingArea=Math.min(Math.round(t-(n+a)/2),Math.round(t-(o+r)/2)),this.setCenterPoint(n,a,o,r)},setCenterPoint:function(t,e,i,n){var a=this,o=a.width-e-a.drawingArea,r=t+a.drawingArea,s=i+a.drawingArea,l=a.height-n-a.drawingArea;a.xCenter=Math.round((r+o)/2+a.left),a.yCenter=Math.round((s+l)/2+a.top)},getIndexAngle:function(t){return t*(2*Math.PI/b(this))+(this.chart.options&&this.chart.options.startAngle?this.chart.options.startAngle:0)*Math.PI*2/360},getDistanceFromCenterForValue:function(t){var e=this;if(null===t)return 0;var i=e.drawingArea/(e.max-e.min);return e.options.ticks.reverse?(e.max-t)*i:(t-e.min)*i},getPointPosition:function(t,e){var i=this.getIndexAngle(t)-Math.PI/2;return{x:Math.round(Math.cos(i)*e)+this.xCenter,y:Math.round(Math.sin(i)*e)+this.yCenter}},getPointPositionForValue:function(t,e){return this.getPointPosition(t,this.getDistanceFromCenterForValue(e))},getBasePosition:function(){var t=this.min,e=this.max;return this.getPointPositionForValue(0,this.beginAtZero?0:t<0&&e<0?e:0<t&&0<e?t:0)},draw:function(){var o=this,t=o.options,r=t.gridLines,s=t.ticks,l=k.valueOrDefault;if(t.display){var u=o.ctx,d=this.getIndexAngle(0),c=l(s.fontSize,v.defaultFontSize),e=l(s.fontStyle,v.defaultFontStyle),i=l(s.fontFamily,v.defaultFontFamily),h=k.fontString(c,e,i);k.each(o.ticks,function(t,e){if(0<e||s.reverse){var i=o.getDistanceFromCenterForValue(o.ticksAsNumbers[e]);if(r.display&&0!==e&&function(t,e,i,n){var a=t.ctx;if(a.strokeStyle=k.valueAtIndexOrDefault(e.color,n-1),a.lineWidth=k.valueAtIndexOrDefault(e.lineWidth,n-1),t.options.gridLines.circular)a.beginPath(),a.arc(t.xCenter,t.yCenter,i,0,2*Math.PI),a.closePath(),a.stroke();else{var o=b(t);if(0===o)return;a.beginPath();var r=t.getPointPosition(0,i);a.moveTo(r.x,r.y);for(var s=1;s<o;s++)r=t.getPointPosition(s,i),a.lineTo(r.x,r.y);a.closePath(),a.stroke()}}(o,r,i,e),s.display){var n=l(s.fontColor,v.defaultFontColor);if(u.font=h,u.save(),u.translate(o.xCenter,o.yCenter),u.rotate(d),s.showLabelBackdrop){var a=u.measureText(t).width;u.fillStyle=s.backdropColor,u.fillRect(-a/2-s.backdropPaddingX,-i-c/2-s.backdropPaddingY,a+2*s.backdropPaddingX,c+2*s.backdropPaddingY)}u.textAlign="center",u.textBaseline="middle",u.fillStyle=n,u.fillText(t,0,-i),u.restore()}}}),(t.angleLines.display||t.pointLabels.display)&&function(t){var e=t.ctx,i=t.options,n=i.angleLines,a=i.pointLabels;e.lineWidth=n.lineWidth,e.strokeStyle=n.color;var o,r,s,l,u=t.getDistanceFromCenterForValue(i.ticks.reverse?t.min:t.max),d=x(t);e.textBaseline="top";for(var c=b(t)-1;0<=c;c--){if(n.display){var h=t.getPointPosition(c,u);e.beginPath(),e.moveTo(t.xCenter,t.yCenter),e.lineTo(h.x,h.y),e.stroke(),e.closePath()}if(a.display){var f=t.getPointPosition(c,u+5),g=k.valueAtIndexOrDefault(a.fontColor,c,v.defaultFontColor);e.font=d.font,e.fillStyle=g;var p=t.getIndexAngle(c),m=k.toDegrees(p);e.textAlign=0===(l=m)||180===l?"center":l<180?"left":"right",o=m,r=t._pointLabelSizes[c],s=f,90===o||270===o?s.y-=r.h/2:(270<o||o<90)&&(s.y-=r.h),y(e,t.pointLabels[c]||"",f,d.size)}}}(o)}}});a.registerScaleType("radialLinear",i,t)}},{26:26,34:34,35:35,46:46}],59:[function(t,e,i){"use strict";function b(t,e){return t-e}function M(t){var e,i,n,a={},o=[];for(e=0,i=t.length;e<i;++e)a[n=t[e]]||(a[n]=!0,o.push(n));return o}function w(t,e,i,n){var a=function(t,e,i){for(var n,a,o,r=0,s=t.length-1;0<=r&&r<=s;){if(a=t[(n=r+s>>1)-1]||null,o=t[n],!a)return{lo:null,hi:o};if(o[e]<i)r=n+1;else{if(!(a[e]>i))return{lo:a,hi:o};s=n-1}}return{lo:o,hi:null}}(t,e,i),o=a.lo?a.hi?a.lo:t[t.length-2]:t[0],r=a.lo?a.hi?a.hi:t[t.length-1]:t[1],s=r[e]-o[e],l=s?(i-o[e])/s:0,u=(r[n]-o[n])*l;return o[n]+u}function C(t,e){var i=e.parser,n=e.parser||e.format;return"function"==typeof i?i(t):"string"==typeof t&&"string"==typeof n?x(t,n):(t instanceof x||(t=x(t)),t.isValid()?t:"function"==typeof n?n(t):t)}function S(t,e){if(m.isNullOrUndef(t))return null;var i=e.options.time,n=C(e.getRightValue(t),i);return n.isValid()?(i.round&&n.startOf(i.round),n.valueOf()):null}function _(t){for(var e=k.indexOf(t)+1,i=k.length;e<i;++e)if(y[k[e]].common)return k[e]}function D(t,e,i,n){var a,o=n.time,r=o.unit||function(t,e,i,n){var a,o,r,s=k.length;for(a=k.indexOf(t);a<s-1;++a)if(r=(o=y[k[a]]).steps?o.steps[o.steps.length-1]:v,o.common&&Math.ceil((i-e)/(r*o.size))<=n)return k[a];return k[s-1]}(o.minUnit,t,e,i),s=_(r),l=m.valueOrDefault(o.stepSize,o.unitStepSize),u="week"===r&&o.isoWeekday,d=n.ticks.major.enabled,c=y[r],h=x(t),f=x(e),g=[];for(l||(l=function(t,e,i,n){var a,o,r,s=e-t,l=y[i],u=l.size,d=l.steps;if(!d)return Math.ceil(s/(n*u));for(a=0,o=d.length;a<o&&(r=d[a],!(Math.ceil(s/(u*r))<=n));++a);return r}(t,e,r,i)),u&&(h=h.isoWeekday(u),f=f.isoWeekday(u)),h=h.startOf(u?"day":r),(f=f.startOf(u?"day":r))<e&&f.add(1,r),a=x(h),d&&s&&!u&&!o.round&&(a.startOf(s),a.add(~~((h-a)/(c.size*l))*l,r));a<f;a.add(l,r))g.push(+a);return g.push(+a),g}var x=t(1);x="function"==typeof x?x:window.moment;var r=t(26),m=t(46),n=t(33),a=t(34),p=Number.MIN_SAFE_INTEGER||-9007199254740991,v=Number.MAX_SAFE_INTEGER||9007199254740991,y={millisecond:{common:!0,size:1,steps:[1,2,5,10,20,50,100,250,500]},second:{common:!0,size:1e3,steps:[1,2,5,10,15,30]},minute:{common:!0,size:6e4,steps:[1,2,5,10,15,30]},hour:{common:!0,size:36e5,steps:[1,2,3,6,12]},day:{common:!0,size:864e5,steps:[1,2,5]},week:{common:!1,size:6048e5,steps:[1,2,3,4]},month:{common:!0,size:2628e6,steps:[1,2,3]},quarter:{common:!1,size:7884e6,steps:[1,2,3,4]},year:{common:!0,size:3154e7}},k=Object.keys(y);e.exports=function(){var t=n.extend({initialize:function(){if(!x)throw new Error("Chart.js - Moment.js could not be found! You must include it before Chart.js to use the time scale. Download at https://momentjs.com");this.mergeTicksOptions(),n.prototype.initialize.call(this)},update:function(){var t=this.options;return t.time&&t.time.format,n.prototype.update.apply(this,arguments)},getRightValue:function(t){return t&&void 0!==t.t&&(t=t.t),n.prototype.getRightValue.call(this,t)},determineDataLimits:function(){var t,e,i,n,a,o,r=this,s=r.chart,l=r.options.time,u=l.unit||"day",d=v,c=p,h=[],f=[],g=[];for(t=0,i=s.data.labels.length;t<i;++t)g.push(S(s.data.labels[t],r));for(t=0,i=(s.data.datasets||[]).length;t<i;++t)if(s.isDatasetVisible(t))if(a=s.data.datasets[t].data,m.isObject(a[0]))for(f[t]=[],e=0,n=a.length;e<n;++e)o=S(a[e],r),h.push(o),f[t][e]=o;else h.push.apply(h,g),f[t]=g.slice(0);else f[t]=[];g.length&&(g=M(g).sort(b),d=Math.min(d,g[0]),c=Math.max(c,g[g.length-1])),h.length&&(h=M(h).sort(b),d=Math.min(d,h[0]),c=Math.max(c,h[h.length-1])),d=S(l.min,r)||d,c=S(l.max,r)||c,d=d===v?+x().startOf(u):d,c=c===p?+x().endOf(u)+1:c,r.min=Math.min(d,c),r.max=Math.max(d+1,c),r._horizontal=r.isHorizontal(),r._table=[],r._timestamps={data:h,datasets:f,labels:g}},buildTicks:function(){var t,e,i,n,a,o,r,s,l,u,d,c,h=this,f=h.min,g=h.max,p=h.options,m=p.time,v=[],b=[];switch(p.ticks.source){case"data":v=h._timestamps.data;break;case"labels":v=h._timestamps.labels;break;case"auto":default:v=D(f,g,h.getLabelCapacity(f),p)}for("ticks"===p.bounds&&v.length&&(f=v[0],g=v[v.length-1]),f=S(m.min,h)||f,g=S(m.max,h)||g,t=0,e=v.length;t<e;++t)f<=(i=v[t])&&i<=g&&b.push(i);return h.min=f,h.max=g,h._unit=m.unit||function(t,e,i,n){var a,o,r=x.duration(x(n).diff(x(i)));for(a=k.length-1;a>=k.indexOf(e);a--)if(o=k[a],y[o].common&&r.as(o)>=t.length)return o;return k[e?k.indexOf(e):0]}(b,m.minUnit,h.min,h.max),h._majorUnit=_(h._unit),h._table=function(t,e,i,n){if("linear"===p.distribution||!t.length)return[{time:e,pos:0},{time:i,pos:1}];var a,o,r,s,l,u=[],d=[e];for(a=0,o=t.length;a<o;++a)e<(s=t[a])&&s<i&&d.push(s);for(d.push(i),a=0,o=d.length;a<o;++a)l=d[a+1],r=d[a-1],s=d[a],void 0!==r&&void 0!==l&&Math.round((l+r)/2)===s||u.push({time:s,pos:a/(o-1)});return u}(h._timestamps.data,f,g),h._offsets=(n=h._table,a=b,o=f,r=g,c=d=0,(s=p).offset&&a.length&&(s.time.min||(l=1<a.length?a[1]:r,u=a[0],d=(w(n,"time",l,"pos")-w(n,"time",u,"pos"))/2),s.time.max||(l=a[a.length-1],u=1<a.length?a[a.length-2]:o,c=(w(n,"time",l,"pos")-w(n,"time",u,"pos"))/2)),{left:d,right:c}),h._labelFormat=function(t,e){var i,n,a,o=t.length;for(i=0;i<o;i++){if(0!==(n=C(t[i],e)).millisecond())return"MMM D, YYYY h:mm:ss.SSS a";0===n.second()&&0===n.minute()&&0===n.hour()||(a=!0)}return a?"MMM D, YYYY h:mm:ss a":"MMM D, YYYY"}(h._timestamps.data,m),function(t,e){var i,n,a,o,r=[];for(i=0,n=t.length;i<n;++i)a=t[i],o=!!e&&a===+x(a).startOf(e),r.push({value:a,major:o});return r}(b,h._majorUnit)},getLabelForIndex:function(t,e){var i=this.chart.data,n=this.options.time,a=i.labels&&t<i.labels.length?i.labels[t]:"",o=i.datasets[e].data[t];return m.isObject(o)&&(a=this.getRightValue(o)),n.tooltipFormat?C(a,n).format(n.tooltipFormat):"string"==typeof a?a:C(a,n).format(this._labelFormat)},tickFormatFunction:function(t,e,i,n){var a=this.options,o=t.valueOf(),r=a.time.displayFormats,s=r[this._unit],l=this._majorUnit,u=r[l],d=t.clone().startOf(l).valueOf(),c=a.ticks.major,h=c.enabled&&l&&u&&o===d,f=t.format(n||(h?u:s)),g=h?c:a.ticks.minor,p=m.valueOrDefault(g.callback,g.userCallback);return p?p(f,e,i):f},convertTicksToLabels:function(t){var e,i,n=[];for(e=0,i=t.length;e<i;++e)n.push(this.tickFormatFunction(x(t[e].value),e,t));return n},getPixelForOffset:function(t){var e=this,i=e._horizontal?e.width:e.height,n=e._horizontal?e.left:e.top,a=w(e._table,"time",t,"pos");return n+i*(e._offsets.left+a)/(e._offsets.left+1+e._offsets.right)},getPixelForValue:function(t,e,i){var n=null;if(void 0!==e&&void 0!==i&&(n=this._timestamps.datasets[i][e]),null===n&&(n=S(t,this)),null!==n)return this.getPixelForOffset(n)},getPixelForTick:function(t){var e=this.getTicks();return 0<=t&&t<e.length?this.getPixelForOffset(e[t].value):null},getValueForPixel:function(t){var e=this,i=e._horizontal?e.width:e.height,n=e._horizontal?e.left:e.top,a=(i?(t-n)/i:0)*(e._offsets.left+1+e._offsets.left)-e._offsets.right,o=w(e._table,"pos",a,"time");return x(o)},getLabelWidth:function(t){var e=this.options.ticks,i=this.ctx.measureText(t).width,n=m.toRadians(e.maxRotation),a=Math.cos(n),o=Math.sin(n);return i*a+m.valueOrDefault(e.fontSize,r.global.defaultFontSize)*o},getLabelCapacity:function(t){var e=this.options.time.displayFormats.millisecond,i=this.tickFormatFunction(x(t),0,[],e),n=this.getLabelWidth(i),a=this.isHorizontal()?this.width:this.height,o=Math.floor(a/n);return 0<o?o:1}});a.registerScaleType("time",t,{position:"bottom",distribution:"linear",bounds:"data",time:{parser:!1,format:!1,unit:!1,round:!1,displayFormat:!1,isoWeekday:!1,minUnit:"millisecond",displayFormats:{millisecond:"h:mm:ss.SSS a",second:"h:mm:ss a",minute:"h:mm a",hour:"hA",day:"MMM D",week:"ll",month:"MMM YYYY",quarter:"[Q]Q - YYYY",year:"YYYY"}},ticks:{autoSkip:!1,source:"auto",major:{enabled:!1}}})}},{1:1,26:26,33:33,34:34,46:46}]},{},[7])(7)}),function(t){"use strict";if("object"==typeof exports)module.exports=t("undefined"!=typeof angular?angular:require("angular"),"undefined"!=typeof Chart?Chart:require("chart.js"));else if("function"==typeof define&&define.amd)define(["angular","chart"],t);else{if("undefined"==typeof angular)throw new Error("AngularJS framework needs to be included, see https://angularjs.org/");if("undefined"==typeof Chart)throw new Error("Chart.js library needs to be included, see http://jtblin.github.io/angular-chart.js/");t(angular,Chart)}}(function(t,r){"use strict";r.defaults.global.multiTooltipTemplate="<%if (datasetLabel){%><%=datasetLabel%>: <%}%><%= value %>",r.defaults.global.tooltips.mode="label",r.defaults.global.elements.line.borderWidth=2,r.defaults.global.elements.rectangle.borderWidth=2,r.defaults.global.legend.display=!1,r.defaults.global.colors=["#97BBCD","#DCDCDC","#F7464A","#46BFBD","#FDB45C","#949FB1","#4D5360"];var n="object"==typeof window.G_vmlCanvasManager&&null!==window.G_vmlCanvasManager&&"function"==typeof window.G_vmlCanvasManager.initElement;return n&&(r.defaults.global.animation=!1),t.module("chart.js",[]).provider("ChartJs",function(){var e={responsive:!0},a={Chart:r,getOptions:function(r){var a=r&&e[r]||{};return t.extend({},e,a)}};this.setOptions=function(r,n){n?e[r]=t.merge(e[r]||{},n):(n=r,e=t.merge(e,n)),t.merge(a.Chart.defaults,e)},this.$get=function(){return a}}).factory("ChartJsFactory",["ChartJs","$timeout",function(e,a){function o(t,r,a){var n=D(t,r);if(C(r)&&k(t,r,a,n)){var o=a[0],c=o.getContext("2d");r.chartGetColor=y(r);var i=b(t,r);F(r),r.chart=new e.Chart(c,{type:t,data:i,options:n}),r.$emit("chart-create",r.chart),A(o,r)}}function c(t,r){return!!(t&&r&&t.length&&r.length)&&(Array.isArray(t[0])?t.length===r.length&&t.every(function(t,e){return t.length===r[e].length}):r.reduce(i,0)>0&&t.length===r.length)}function i(t,r){return t+r}function u(r,e,a){var n={point:void 0,points:void 0};return function(o){var c=r.chart.getElementAtEvent||r.chart.getPointAtEvent,i=r.chart.getElementsAtEvent||r.chart.getPointsAtEvent;if(i){var u=i.call(r.chart,o),l=c?c.call(r.chart,o)[0]:void 0;!1!==a&&(t.equals(n.points,u)||t.equals(n.point,l))||(n.point=l,n.points=u,r[e](u,o,l))}}}function l(a,n){for(var o=t.copy(n.chartColors||e.getOptions(a).chartColors||r.defaults.global.colors),c=o.length<n.chartData.length;o.length<n.chartData.length;)o.push(n.chartGetColor());return c&&(n.chartColors=o),o.map(h)}function h(t){return"string"==typeof t&&"r"===t[0]?f(v(t)):"string"==typeof t&&"#"===t[0]?f(p(t.substr(1))):"object"==typeof t&&null!==t?t:s()}function s(){return f([d(0,255),d(0,255),d(0,255)])}function f(t){var r=t[3]||1;return t=t.slice(0,3),{backgroundColor:g(t,.2),pointBackgroundColor:g(t,r),pointHoverBackgroundColor:g(t,.8),borderColor:g(t,r),pointBorderColor:"#fff",pointHoverBorderColor:g(t,r)}}function d(t,r){return Math.floor(Math.random()*(r-t+1))+t}function g(t,r){return n?"rgb("+t.join(",")+")":"rgba("+t.concat(r).join(",")+")"}function p(t){var r=parseInt(t,16);return[r>>16&255,r>>8&255,255&r]}function v(t){var r=t.match(/^rgba?\(([\d,.]+)\)$/);if(!r)throw new Error("Cannot parse rgb value");return(t=r[1].split(",")).map(Number)}function C(t){return t.chartData&&t.chartData.length}function y(t){return"function"==typeof t.chartGetColor?t.chartGetColor:s}function b(t,r){var e=l(t,r);return Array.isArray(r.chartData[0])?m(r.chartLabels,r.chartData,r.chartSeries||[],e,r.chartDatasetOverride):w(r.chartLabels,r.chartData,e,r.chartDatasetOverride)}function m(r,e,a,n,o){return{labels:r,datasets:e.map(function(r,e){var c=t.extend({},n[e],{label:a[e],data:r});return o&&o.length>=e&&t.merge(c,o[e]),c})}}function w(r,e,a,n){var o={labels:r,datasets:[{data:e,backgroundColor:a.map(function(t){return t.pointBackgroundColor}),hoverBackgroundColor:a.map(function(t){return t.backgroundColor})}]};return n&&t.merge(o.datasets[0],n),o}function D(r,a){return t.extend({},e.getOptions(r),a.chartOptions)}function A(r,e){r.onclick=e.chartClick?u(e,"chartClick",!1):t.noop,r.onmousemove=e.chartHover?u(e,"chartHover",!0):t.noop}function B(t,r){Array.isArray(r.chartData[0])?r.chart.data.datasets.forEach(function(r,e){r.data=t[e]}):r.chart.data.datasets[0].data=t,r.chart.update(),r.$emit("chart-update",r.chart)}function $(t){return!t||Array.isArray(t)&&!t.length||"object"==typeof t&&!Object.keys(t).length}function k(t,r,e,n){return!n.responsive||0!==e[0].clientHeight||(a(function(){o(t,r,e)},50,!1),!1)}function F(t){t.chart&&(t.chart.destroy(),t.$emit("chart-destroy",t.chart))}return function(r){return{restrict:"CA",scope:{chartGetColor:"=?",chartType:"=",chartData:"=?",chartLabels:"=?",chartOptions:"=?",chartSeries:"=?",chartColors:"=?",chartClick:"=?",chartHover:"=?",chartDatasetOverride:"=?"},link:function(e,a){function u(n,c){if(!$(n)&&!t.equals(n,c)){var i=r||e.chartType;i&&o(i,e,a)}}n&&window.G_vmlCanvasManager.initElement(a[0]),e.$watch("chartData",function(t,n){if(t&&t.length&&(!Array.isArray(t[0])||t[0].length)){var i=r||e.chartType;return i?e.chart&&c(t,n)?B(t,e):void o(i,e,a):void 0}F(e)},!0),e.$watch("chartSeries",u,!0),e.$watch("chartLabels",u,!0),e.$watch("chartOptions",u,!0),e.$watch("chartColors",u,!0),e.$watch("chartDatasetOverride",u,!0),e.$watch("chartType",function(r,n){$(r)||t.equals(r,n)||o(r,e,a)},!1),e.$on("$destroy",function(){F(e)}),e.$on("$resize",function(){e.chart&&e.chart.resize()})}}}}]).directive("chartBase",["ChartJsFactory",function(t){return new t}]).directive("chartLine",["ChartJsFactory",function(t){return new t("line")}]).directive("chartBar",["ChartJsFactory",function(t){return new t("bar")}]).directive("chartHorizontalBar",["ChartJsFactory",function(t){return new t("horizontalBar")}]).directive("chartRadar",["ChartJsFactory",function(t){return new t("radar")}]).directive("chartDoughnut",["ChartJsFactory",function(t){return new t("doughnut")}]).directive("chartPie",["ChartJsFactory",function(t){return new t("pie")}]).directive("chartPolarArea",["ChartJsFactory",function(t){return new t("polarArea")}]).directive("chartBubble",["ChartJsFactory",function(t){return new t("bubble")}]).name}),angular.module("ion-affix",["ionic"]).directive("ionAffix",["$ionicPosition","$compile",function($ionicPosition,$compile){function getParentWithClass(elementSelector,parentClass){return angular.element(ionic.DomUtil.getParentWithClass(elementSelector[0],parentClass))}function throttle(theFunction){return ionic.Utils.throttle(theFunction)}function requestAnimationFrame(callback){return ionic.requestAnimationFrame(callback)}function offset(elementSelector){return $ionicPosition.offset(elementSelector)}function position(elementSelector){return $ionicPosition.position(elementSelector)}function applyTransform(element,transformString){element.style[ionic.CSS.TRANSFORM]==transformString||(element.style[ionic.CSS.TRANSFORM]=transformString)}function translateUp(element,dy,executeImmediately){var translateDyPixelsUp=0==dy?"translate3d(0px, 0px, 0px)":"translate3d(0px, -"+dy+"px, 0px)";executeImmediately?applyTransform(element,translateDyPixelsUp):requestAnimationFrame(function(){applyTransform(element,translateDyPixelsUp)})}return{restrict:"A",require:"^$ionicScroll",link:function($scope,$element,$attr,$ionicScroll){var $container;$attr.affixWithinParentWithClass?($container=getParentWithClass($element,$attr.affixWithinParentWithClass))||($container=$element.parent()):$container=$element.parent();var scrollMin=0,scrollMax=0,scrollTransition=0,calculateScrollLimits=function(scrollTop){var containerPosition=position($container),elementOffset=offset($element),containerTop=containerPosition.top,containerHeight=containerPosition.height,affixHeight=elementOffset.height;scrollTransition=(scrollMax=(scrollMin=scrollTop+containerTop)+containerHeight)-affixHeight},throttledCalculateScrollLimits=throttle(calculateScrollLimits),affixClone=null,createAffixClone=function(){var clone=$element.clone().css({position:"absolute",top:0,left:0,right:0});return $attr.affixClass&&clone.addClass($attr.affixClass),clone.removeAttr("ion-affix").removeAttr("data-ion-affix").removeAttr("x-ion-affix"),angular.element($ionicScroll.element).append(clone),$compile(clone)($scope),clone},removeAffixClone=function(){affixClone&&affixClone.remove(),affixClone=null};$scope.$on("$destroy",function(){removeAffixClone(),angular.element($ionicScroll.element).off("scroll")}),angular.element($ionicScroll.element).on("scroll",function(event){var scrollTop=(event.detail||event.originalEvent&&event.originalEvent.detail).scrollTop;if(0==scrollTop?calculateScrollLimits(scrollTop):throttledCalculateScrollLimits(scrollTop),scrollTop>=scrollMin&&scrollTop<=scrollMax){var cloneCreatedJustNow=!1;affixClone||(affixClone=createAffixClone(),cloneCreatedJustNow=!0),scrollTop>scrollTransition?translateUp(affixClone[0],Math.floor(scrollTop-scrollTransition),cloneCreatedJustNow):translateUp(affixClone[0],0,cloneCreatedJustNow)}else removeAffixClone()})}}}]),function(a,b){"function"==typeof define&&define.amd?define([],function(){return b()}):"object"==typeof exports?module.exports=b():b()}(0,function(){function a(a){"use strict";var b=a.storageKey(),c=a.storage(),d=function(){var d=a.preferredLanguage();angular.isString(d)?a.use(d):c.put(b,a.use())};d.displayName="fallbackFromIncorrectStorageValue",c?c.get(b)?a.use(c.get(b)).catch(d):d():angular.isString(a.preferredLanguage())&&a.use(a.preferredLanguage())}function c(a,b,c,d){"use strict";var e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u={},v=[],w=a,x=[],y="translate-cloak",z=!1,A=!1,B=".",C=!1,D=!1,E=0,F=!0,G="default",H={default:function(a){return(a||"").split("-").join("_")},java:function(a){var b=(a||"").split("-").join("_"),c=b.split("_");return c.length>1?c[0].toLowerCase()+"_"+c[1].toUpperCase():b},bcp47:function(a){var b=(a||"").split("_").join("-"),c=b.split("-");return c.length>1?c[0].toLowerCase()+"-"+c[1].toUpperCase():b},"iso639-1":function(a){return(a||"").split("_").join("-").split("-")[0].toLowerCase()}},J=function(){if(angular.isFunction(d.getLocale))return d.getLocale();var a,c,e=b.$get().navigator,f=["language","browserLanguage","systemLanguage","userLanguage"];if(angular.isArray(e.languages))for(a=0;a<e.languages.length;a++)if((c=e.languages[a])&&c.length)return c;for(a=0;a<f.length;a++)if((c=e[f[a]])&&c.length)return c;return null};J.displayName="angular-translate/service: getFirstBrowserLanguage";var K=function(){var a=J()||"";return H[G]&&(a=H[G](a)),a};K.displayName="angular-translate/service: getLocale";var L=function(a,b){for(var c=0,d=a.length;c<d;c++)if(a[c]===b)return c;return-1},M=function(){return this.toString().replace(/^\s+|\s+$/g,"")},N=function(a){if(a){for(var b=[],c=angular.lowercase(a),d=0,e=v.length;d<e;d++)b.push(angular.lowercase(v[d]));if(L(b,c)>-1)return a;if(f){var g;for(var h in f)if(f.hasOwnProperty(h)){var i=!1,j=Object.prototype.hasOwnProperty.call(f,h)&&angular.lowercase(h)===angular.lowercase(a);if("*"===h.slice(-1)&&(i=h.slice(0,-1)===a.slice(0,h.length-1)),(j||i)&&(g=f[h],L(b,angular.lowercase(g))>-1))return g}}var k=a.split("_");return k.length>1&&L(b,angular.lowercase(k[0]))>-1?k[0]:void 0}},O=function(a,b){if(!a&&!b)return u;if(a&&!b){if(angular.isString(a))return u[a]}else angular.isObject(u[a])||(u[a]={}),angular.extend(u[a],P(b));return this};this.translations=O,this.cloakClassName=function(a){return a?(y=a,this):y},this.nestedObjectDelimeter=function(a){return a?(B=a,this):B};var P=function(a,b,c,d){var e,f,g,h;b||(b=[]),c||(c={});for(e in a)Object.prototype.hasOwnProperty.call(a,e)&&(h=a[e],angular.isObject(h)?P(h,b.concat(e),c,e):(f=b.length?""+b.join(B)+B+e:e,b.length&&e===d&&(g=""+b.join(B),c[g]="@:"+f),c[f]=h));return c};P.displayName="flatObject",this.addInterpolation=function(a){return x.push(a),this},this.useMessageFormatInterpolation=function(){return this.useInterpolation("$translateMessageFormatInterpolation")},this.useInterpolation=function(a){return n=a,this},this.useSanitizeValueStrategy=function(a){return c.useStrategy(a),this},this.preferredLanguage=function(a){return a?(Q(a),this):e};var Q=function(a){return a&&(e=a),e};this.translationNotFoundIndicator=function(a){return this.translationNotFoundIndicatorLeft(a),this.translationNotFoundIndicatorRight(a),this},this.translationNotFoundIndicatorLeft=function(a){return a?(q=a,this):q},this.translationNotFoundIndicatorRight=function(a){return a?(r=a,this):r},this.fallbackLanguage=function(a){return R(a),this};var R=function(a){return a?(angular.isString(a)?(h=!0,g=[a]):angular.isArray(a)&&(h=!1,g=a),angular.isString(e)&&L(g,e)<0&&g.push(e),this):h?g[0]:g};this.use=function(a){if(a){if(!u[a]&&!o)throw new Error("$translateProvider couldn't find translationTable for langKey: '"+a+"'");return i=a,this}return i},this.resolveClientLocale=function(){return K()};var S=function(a){return a?(w=a,this):l?l+w:w};this.storageKey=S,this.useUrlLoader=function(a,b){return this.useLoader("$translateUrlLoader",angular.extend({url:a},b))},this.useStaticFilesLoader=function(a){return this.useLoader("$translateStaticFilesLoader",a)},this.useLoader=function(a,b){return o=a,p=b||{},this},this.useLocalStorage=function(){return this.useStorage("$translateLocalStorage")},this.useCookieStorage=function(){return this.useStorage("$translateCookieStorage")},this.useStorage=function(a){return k=a,this},this.storagePrefix=function(a){return a?(l=a,this):a},this.useMissingTranslationHandlerLog=function(){return this.useMissingTranslationHandler("$translateMissingTranslationHandlerLog")},this.useMissingTranslationHandler=function(a){return m=a,this},this.usePostCompiling=function(a){return z=!!a,this},this.forceAsyncReload=function(a){return A=!!a,this},this.uniformLanguageTag=function(a){return a?angular.isString(a)&&(a={standard:a}):a={},G=a.standard,this},this.determinePreferredLanguage=function(a){var b=a&&angular.isFunction(a)?a():K();return e=v.length?N(b)||b:b,this},this.registerAvailableLanguageKeys=function(a,b){return a?(v=a,b&&(f=b),this):v},this.useLoaderCache=function(a){return!1===a?s=void 0:!0===a?s=!0:void 0===a?s="$translationCache":a&&(s=a),this},this.directivePriority=function(a){return void 0===a?E:(E=a,this)},this.statefulFilter=function(a){return void 0===a?F:(F=a,this)},this.postProcess=function(a){return t=a||void 0,this},this.keepContent=function(a){return D=!!a,this},this.$get=["$log","$injector","$rootScope","$q",function(a,b,c,d){var f,l,G,H=b.get(n||"$translateDefaultInterpolation"),J=!1,T={},U={},V=function(a,b,c,h,j){!i&&e&&(i=e);var m=j&&j!==i?N(j)||j:i;if(j&&ka(j),angular.isArray(a)){return function(a){for(var e={},f=[],i=0,k=a.length;i<k;i++)f.push(function(a){var f=d.defer(),g=function(b){e[a]=b,f.resolve([a,b])};return V(a,b,c,h,j).then(g,g),f.promise}(a[i]));return d.all(f).then(function(){return e})}(a)}var o=d.defer();a&&(a=M.apply(a));var p=function(){var a=e?U[e]:U[m];if(l=0,k&&!a){var b=f.get(w);if(a=U[b],g&&g.length){var c=L(g,b);l=0===c?1:0,L(g,e)<0&&g.push(e)}}return a}();if(p){var q=function(){j||(m=i),ga(a,b,c,h,m).then(o.resolve,o.reject)};q.displayName="promiseResolved",p.finally(q).catch(angular.noop)}else ga(a,b,c,h,m).then(o.resolve,o.reject);return o.promise},W=function(a){return q&&(a=[q,a].join(" ")),r&&(a=[a,r].join(" ")),a},X=function(a){i=a,k&&f.put(V.storageKey(),i),c.$emit("$translateChangeSuccess",{language:a}),H.setLocale(i);var b=function(a,b){T[b].setLocale(i)};b.displayName="eachInterpolatorLocaleSetter",angular.forEach(T,b),c.$emit("$translateChangeEnd",{language:a})},Y=function(a){if(!a)throw"No language key specified for loading.";var e=d.defer();c.$emit("$translateLoadingStart",{language:a}),J=!0;var f=s;"string"==typeof f&&(f=b.get(f));var g=angular.extend({},p,{key:a,$http:angular.extend({},{cache:f},p.$http)}),h=function(b){var d={};c.$emit("$translateLoadingSuccess",{language:a}),angular.isArray(b)?angular.forEach(b,function(a){angular.extend(d,P(a))}):angular.extend(d,P(b)),J=!1,e.resolve({key:a,table:d}),c.$emit("$translateLoadingEnd",{language:a})};h.displayName="onLoaderSuccess";var i=function(a){c.$emit("$translateLoadingError",{language:a}),e.reject(a),c.$emit("$translateLoadingEnd",{language:a})};return i.displayName="onLoaderError",b.get(o)(g).then(h,i),e.promise};if(k&&(!(f=b.get(k)).get||!f.put))throw new Error("Couldn't use storage '"+k+"', missing get() or put() method!");if(x.length){var Z=function(a){var c=b.get(a);c.setLocale(e||i),T[c.getInterpolationIdentifier()]=c};Z.displayName="interpolationFactoryAdder",angular.forEach(x,Z)}var $=function(a){var b=d.defer();if(Object.prototype.hasOwnProperty.call(u,a))b.resolve(u[a]);else if(U[a]){var c=function(a){O(a.key,a.table),b.resolve(a.table)};c.displayName="translationTableResolver",U[a].then(c,b.reject)}else b.reject();return b.promise},_=function(a,b,c,e,f){var g=d.defer(),h=function(d){if(Object.prototype.hasOwnProperty.call(d,b)&&null!==d[b]){e.setLocale(a);var h=d[b];if("@:"===h.substr(0,2))_(a,h.substr(2),c,e,f).then(g.resolve,g.reject);else{var j=e.interpolate(d[b],c,"service",f,b);j=ja(b,d[b],j,c,a),g.resolve(j)}e.setLocale(i)}else g.reject()};return h.displayName="fallbackTranslationResolver",$(a).then(h,g.reject),g.promise},aa=function(a,b,c,d,e){var f,g=u[a];if(g&&Object.prototype.hasOwnProperty.call(g,b)&&null!==g[b]){if(d.setLocale(a),f=d.interpolate(g[b],c,"filter",e,b),f=ja(b,g[b],f,c,a,e),!angular.isString(f)&&angular.isFunction(f.$$unwrapTrustedValue)){var h=f.$$unwrapTrustedValue();if("@:"===h.substr(0,2))return aa(a,h.substr(2),c,d,e)}else if("@:"===f.substr(0,2))return aa(a,f.substr(2),c,d,e);d.setLocale(i)}return f},ba=function(a,c,d,e){return m?b.get(m)(a,i,c,d,e):a},ca=function(a,b,c,e,f,h){var i=d.defer();if(a<g.length){var j=g[a];_(j,b,c,e,h).then(function(a){i.resolve(a)},function(){return ca(a+1,b,c,e,f,h).then(i.resolve,i.reject)})}else if(f)i.resolve(f);else{var k=ba(b,c,f);m&&k?i.resolve(k):i.reject(W(b))}return i.promise},da=function(a,b,c,d,e){var f;if(a<g.length){var h=g[a];(f=aa(h,b,c,d,e))||""===f||(f=da(a+1,b,c,d))}return f},ea=function(a,b,c,d,e){return ca(G>0?G:l,a,b,c,d,e)},fa=function(a,b,c,d){return da(G>0?G:l,a,b,c,d)},ga=function(a,b,c,e,f,h){var i=d.defer(),j=f?u[f]:u,k=c?T[c]:H;if(j&&Object.prototype.hasOwnProperty.call(j,a)&&null!==j[a]){var l=j[a];if("@:"===l.substr(0,2))V(l.substr(2),b,c,e,f).then(i.resolve,i.reject);else{var n=k.interpolate(l,b,"service",h,a);n=ja(a,l,n,b,f),i.resolve(n)}}else{var o;m&&!J&&(o=ba(a,b,e)),f&&g&&g.length?ea(a,b,k,e,h).then(function(a){i.resolve(a)},function(a){i.reject(W(a))}):m&&!J&&o?e?i.resolve(e):i.resolve(o):e?i.resolve(e):i.reject(W(a))}return i.promise},ha=function(a,b,c,d,e){var f,h=d?u[d]:u,i=H;if(T&&Object.prototype.hasOwnProperty.call(T,c)&&(i=T[c]),h&&Object.prototype.hasOwnProperty.call(h,a)&&null!==h[a]){var j=h[a];"@:"===j.substr(0,2)?f=ha(j.substr(2),b,c,d,e):(f=i.interpolate(j,b,"filter",e,a),f=ja(a,j,f,b,d,e))}else{var k;m&&!J&&(k=ba(a,b,e)),d&&g&&g.length?(l=0,f=fa(a,b,i,e)):f=m&&!J&&k?k:W(a)}return f},ia=function(a){j===a&&(j=void 0),U[a]=void 0},ja=function(a,c,d,e,f,g){var h=t;return h&&("string"==typeof h&&(h=b.get(h)),h)?h(a,c,d,e,f,g):d},ka=function(a){u[a]||!o||U[a]||(U[a]=Y(a).then(function(a){return O(a.key,a.table),a}))};V.preferredLanguage=function(a){return a&&Q(a),e},V.cloakClassName=function(){return y},V.nestedObjectDelimeter=function(){return B},V.fallbackLanguage=function(a){if(void 0!==a&&null!==a){if(R(a),o&&g&&g.length)for(var b=0,c=g.length;b<c;b++)U[g[b]]||(U[g[b]]=Y(g[b]));V.use(V.use())}return h?g[0]:g},V.useFallbackLanguage=function(a){if(void 0!==a&&null!==a)if(a){var b=L(g,a);b>-1&&(G=b)}else G=0},V.proposedLanguage=function(){return j},V.storage=function(){return f},V.negotiateLocale=N,V.use=function(a){if(!a)return i;var b=d.defer();b.promise.then(null,angular.noop),c.$emit("$translateChangeStart",{language:a});var e=N(a);return v.length>0&&!e?d.reject(a):(e&&(a=e),j=a,!A&&u[a]||!o||U[a]?U[a]?U[a].then(function(a){return j===a.key&&X(a.key),b.resolve(a.key),a},function(a){return!i&&g&&g.length>0&&g[0]!==a?V.use(g[0]).then(b.resolve,b.reject):b.reject(a)}):(b.resolve(a),X(a)):(U[a]=Y(a).then(function(c){return O(c.key,c.table),b.resolve(c.key),j===a&&X(c.key),c},function(a){return c.$emit("$translateChangeError",{language:a}),b.reject(a),c.$emit("$translateChangeEnd",{language:a}),d.reject(a)}),U[a].finally(function(){ia(a)}).catch(angular.noop)),b.promise)},V.resolveClientLocale=function(){return K()},V.storageKey=function(){return S()},V.isPostCompilingEnabled=function(){return z},V.isForceAsyncReloadEnabled=function(){return A},V.isKeepContent=function(){return D},V.refresh=function(a){function b(a){var b=Y(a);return U[a]=b,b.then(function(b){u[a]={},O(a,b.table),f[a]=!0},angular.noop),b}if(!o)throw new Error("Couldn't refresh translation table, no loader registered!");c.$emit("$translateRefreshStart",{language:a});var e=d.defer(),f={};if(e.promise.then(function(){for(var a in u)u.hasOwnProperty(a)&&(a in f||delete u[a]);i&&X(i)},angular.noop).finally(function(){c.$emit("$translateRefreshEnd",{language:a})}),a)u[a]?b(a).then(e.resolve,e.reject):e.reject();else{var h=g&&g.slice()||[];i&&-1===h.indexOf(i)&&h.push(i),d.all(h.map(b)).then(e.resolve,e.reject)}return e.promise},V.instant=function(a,b,c,d,f){var h=d&&d!==i?N(d)||d:i;if(null===a||angular.isUndefined(a))return a;if(d&&ka(d),angular.isArray(a)){for(var j={},k=0,l=a.length;k<l;k++)j[a[k]]=V.instant(a[k],b,c,d,f);return j}if(angular.isString(a)&&a.length<1)return a;a&&(a=M.apply(a));var n,o=[];e&&o.push(e),h&&o.push(h),g&&g.length&&(o=o.concat(g));for(var p=0,s=o.length;p<s;p++){var t=o[p];if(u[t]&&void 0!==u[t][a]&&(n=ha(a,b,c,h,f)),void 0!==n)break}if(!n&&""!==n)if(q||r)n=W(a);else{n=H.interpolate(a,b,"filter",f);var v;m&&!J&&(v=ba(a,b,f)),m&&!J&&v&&(n=v)}return n},V.versionInfo=function(){return"2.15.1"},V.loaderCache=function(){return s},V.directivePriority=function(){return E},V.statefulFilter=function(){return F},V.isReady=function(){return C};var la=d.defer();la.promise.then(function(){C=!0}),V.onReady=function(a){var b=d.defer();return angular.isFunction(a)&&b.promise.then(a),C?b.resolve():la.promise.then(b.resolve),b.promise},V.getAvailableLanguageKeys=function(){return v.length>0?v:null},V.getTranslationTable=function(a){return(a=a||V.use())&&u[a]?angular.copy(u[a]):null};var ma=c.$on("$translateReady",function(){la.resolve(),ma(),ma=null}),na=c.$on("$translateChangeEnd",function(){la.resolve(),na(),na=null});if(o){if(angular.equals(u,{})&&V.use()&&V.use(V.use()),g&&g.length)for(var pa=0,qa=g.length;pa<qa;pa++){var ra=g[pa];!A&&u[ra]||(U[ra]=Y(ra).then(function(a){return O(a.key,a.table),c.$emit("$translateChangeEnd",{language:a.key}),a}))}}else c.$emit("$translateReady",{language:V.use()});return V}]}function d(a,b){"use strict";var c,d={};return d.setLocale=function(a){c=a},d.getInterpolationIdentifier=function(){return"default"},d.useSanitizeValueStrategy=function(a){return b.useStrategy(a),this},d.interpolate=function(c,d,e,f,g){d=d||{},d=b.sanitize(d,"params",f,e);var h;return angular.isNumber(c)?h=""+c:angular.isString(c)?(h=a(c)(d),h=b.sanitize(h,"text",f,e)):h="",h},d}function e(a,b,c,d,e){"use strict";var g=function(){return this.toString().replace(/^\s+|\s+$/g,"")};return{restrict:"AE",scope:!0,priority:a.directivePriority(),compile:function(h,i){var j=i.translateValues?i.translateValues:void 0,k=i.translateInterpolation?i.translateInterpolation:void 0,l=h[0].outerHTML.match(/translate-value-+/i),m="^(.*)("+b.startSymbol()+".*"+b.endSymbol()+")(.*)",n="^(.*)"+b.startSymbol()+"(.*)"+b.endSymbol()+"(.*)";return function(h,o,p){h.interpolateParams={},h.preText="",h.postText="",h.translateNamespace=f(h);var q={},s=function(a){if(angular.isFunction(s._unwatchOld)&&(s._unwatchOld(),s._unwatchOld=void 0),angular.equals(a,"")||!angular.isDefined(a)){var c=g.apply(o.text()),d=c.match(m);if(angular.isArray(d)){h.preText=d[1],h.postText=d[3],q.translate=b(d[2])(h.$parent);var e=c.match(n);angular.isArray(e)&&e[2]&&e[2].length&&(s._unwatchOld=h.$watch(e[2],function(a){q.translate=a,y()}))}else q.translate=c||void 0}else q.translate=a;y()};!function(a,b,c){if(b.translateValues&&angular.extend(a,d(b.translateValues)(h.$parent)),l)for(var e in c)Object.prototype.hasOwnProperty.call(b,e)&&"translateValue"===e.substr(0,14)&&"translateValues"!==e&&(a[angular.lowercase(e.substr(14,1))+e.substr(15)]=c[e])}(h.interpolateParams,p,i);var u=!0;p.$observe("translate",function(a){void 0===a?s(""):""===a&&u||(q.translate=a,y()),u=!1});for(var v in p)p.hasOwnProperty(v)&&"translateAttr"===v.substr(0,13)&&v.length>13&&function(a){p.$observe(a,function(b){q[a]=b,y()})}(v);if(p.$observe("translateDefault",function(a){h.defaultText=a,y()}),j&&p.$observe("translateValues",function(a){a&&h.$parent.$watch(function(){angular.extend(h.interpolateParams,d(a)(h.$parent))})}),l){for(var x in p)Object.prototype.hasOwnProperty.call(p,x)&&"translateValue"===x.substr(0,14)&&"translateValues"!==x&&function(a){p.$observe(a,function(b){var c=angular.lowercase(a.substr(14,1))+a.substr(15);h.interpolateParams[c]=b})}(x)}var y=function(){for(var a in q)q.hasOwnProperty(a)&&void 0!==q[a]&&z(a,q[a],h,h.interpolateParams,h.defaultText,h.translateNamespace)},z=function(b,c,d,e,f,g){c?(g&&"."===c.charAt(0)&&(c=g+c),a(c,e,k,f,d.translateLanguage).then(function(a){A(a,d,!0,b)},function(a){A(a,d,!1,b)})):A(c,d,!1,b)},A=function(b,d,e,f){if(e||void 0!==d.defaultText&&(b=d.defaultText),"translate"===f){(e||!e&&!a.isKeepContent()&&void 0===p.translateKeepContent)&&o.empty().append(d.preText+b+d.postText);var g=a.isPostCompilingEnabled(),h=void 0!==i.translateCompile,j=h&&"false"!==i.translateCompile;(g&&!h||j)&&c(o.contents())(d)}else{var k=p.$attr[f];"data-"===k.substr(0,5)&&(k=k.substr(5)),k=k.substr(15),o.attr(k,b)}};(j||l||p.translateDefault)&&h.$watch("interpolateParams",y,!0),h.$on("translateLanguageChanged",y);var B=e.$on("$translateChangeSuccess",y);o.text().length?s(p.translate?p.translate:""):p.translate&&s(p.translate),y(),h.$on("$destroy",B)}}}}function f(a){"use strict";return a.translateNamespace?a.translateNamespace:a.$parent?f(a.$parent):void 0}function g(a,b){"use strict";return{restrict:"A",priority:a.directivePriority(),link:function(c,d,e){var f,g,i={},j=function(){angular.forEach(f,function(b,f){b&&(i[f]=!0,c.translateNamespace&&"."===b.charAt(0)&&(b=c.translateNamespace+b),a(b,g,e.translateInterpolation,void 0,c.translateLanguage).then(function(a){d.attr(f,a)},function(a){d.attr(f,a)}))}),angular.forEach(i,function(a,b){f[b]||(d.removeAttr(b),delete i[b])})};h(c,e.translateAttr,function(a){f=a},j),h(c,e.translateValues,function(a){g=a},j),e.translateValues&&c.$watch(e.translateValues,j,!0),c.$on("translateLanguageChanged",j);var k=b.$on("$translateChangeSuccess",j);j(),c.$on("$destroy",k)}}}function h(a,b,c,d){"use strict";b&&("::"===b.substr(0,2)?b=b.substr(2):a.$watch(b,function(a){c(a),d()},!0),c(a.$eval(b)))}function i(a,b){"use strict";return{compile:function(c){var d=function(b){b.addClass(a.cloakClassName())},e=function(b){b.removeClass(a.cloakClassName())};return d(c),function(c,f,g){var h=e.bind(this,f),i=d.bind(this,f);g.translateCloak&&g.translateCloak.length?(g.$observe("translateCloak",function(b){a(b).then(h,i)}),b.$on("$translateChangeSuccess",function(){a(g.translateCloak).then(h,i)})):a.onReady(h)}}}}function j(){"use strict";return{restrict:"A",scope:!0,compile:function(){return{pre:function(a,b,c){a.translateNamespace=f(a),a.translateNamespace&&"."===c.translateNamespace.charAt(0)?a.translateNamespace+=c.translateNamespace:a.translateNamespace=c.translateNamespace}}}}}function f(a){"use strict";return a.translateNamespace?a.translateNamespace:a.$parent?f(a.$parent):void 0}function k(){"use strict";return{restrict:"A",scope:!0,compile:function(){return function(a,b,c){c.$observe("translateLanguage",function(b){a.translateLanguage=b}),a.$watch("translateLanguage",function(){a.$broadcast("translateLanguageChanged")})}}}}function l(a,b){"use strict";var c=function(c,d,e,f){if(!angular.isObject(d)){var g=this||{__SCOPE_IS_NOT_AVAILABLE:"More info at https://github.com/angular/angular.js/commit/8863b9d04c722b278fa93c5d66ad1e578ad6eb1f"};d=a(d)(g)}return b.instant(c,d,e,f)};return b.statefulFilter()&&(c.$stateful=!0),c}function m(a){"use strict";return a("translations")}return a.$inject=["a"],c.$inject=["a","b","c","d"],d.$inject=["a","b"],e.$inject=["a","b","c","d","e"],g.$inject=["a","b"],i.$inject=["a","b"],l.$inject=["a","b"],m.$inject=["a"],a.$inject=["$translate"],c.$inject=["$STORAGE_KEY","$windowProvider","$translateSanitizationProvider","pascalprechtTranslateOverrider"],d.$inject=["$interpolate","$translateSanitization"],e.$inject=["$translate","$interpolate","$compile","$parse","$rootScope"],g.$inject=["$translate","$rootScope"],i.$inject=["$translate","$rootScope"],l.$inject=["$parse","$translate"],m.$inject=["$cacheFactory"],angular.module("pascalprecht.translate",["ng"]).run(a),a.displayName="runTranslate",angular.module("pascalprecht.translate").provider("$translateSanitization",function(){"use strict";var a,b,c,d=null,e=!1,f=!1;(c={sanitize:function(a,b){return"text"===b&&(a=h(a)),a},escape:function(a,b){return"text"===b&&(a=g(a)),a},sanitizeParameters:function(a,b){return"params"===b&&(a=j(a,h)),a},escapeParameters:function(a,b){return"params"===b&&(a=j(a,g)),a},sce:function(a,b,c){return"text"===b?a=i(a):"params"===b&&"filter"!==c&&(a=j(a,g)),a},sceParameters:function(a,b){return"params"===b&&(a=j(a,i)),a}}).escaped=c.escapeParameters,this.addStrategy=function(a,b){return c[a]=b,this},this.removeStrategy=function(a){return delete c[a],this},this.useStrategy=function(a){return e=!0,d=a,this},this.$get=["$injector","$log",function(g,h){var i={},j=function(a,b,d,e){return angular.forEach(e,function(e){if(angular.isFunction(e))a=e(a,b,d);else if(angular.isFunction(c[e]))a=c[e](a,b,d);else{if(!angular.isString(c[e]))throw new Error("pascalprecht.translate.$translateSanitization: Unknown sanitization strategy: '"+e+"'");if(!i[c[e]])try{i[c[e]]=g.get(c[e])}catch(a){throw i[c[e]]=function(){},new Error("pascalprecht.translate.$translateSanitization: Unknown sanitization strategy: '"+e+"'")}a=i[c[e]](a,b,d)}}),a},k=function(){e||f||(h.warn("pascalprecht.translate.$translateSanitization: No sanitization strategy has been configured. This can have serious security implications. See http://angular-translate.github.io/docs/#/guide/19_security for details."),f=!0)};return g.has("$sanitize")&&(a=g.get("$sanitize")),g.has("$sce")&&(b=g.get("$sce")),{useStrategy:function(a){return function(b){a.useStrategy(b)}}(this),sanitize:function(a,b,c,e){if(d||k(),c||null===c||(c=d),!c)return a;e||(e="service");var f=angular.isArray(c)?c:[c];return j(a,b,e,f)}}}];var g=function(a){var b=angular.element("<div></div>");return b.text(a),b.html()},h=function(b){if(!a)throw new Error("pascalprecht.translate.$translateSanitization: Error cannot find $sanitize service. Either include the ngSanitize module (https://docs.angularjs.org/api/ngSanitize) or use a sanitization strategy which does not depend on $sanitize, such as 'escape'.");return a(b)},i=function(a){if(!b)throw new Error("pascalprecht.translate.$translateSanitization: Error cannot find $sce service.");return b.trustAsHtml(a)},j=function(a,b,c){if(angular.isDate(a))return a;if(angular.isObject(a)){var d=angular.isArray(a)?[]:{};if(c){if(c.indexOf(a)>-1)throw new Error("pascalprecht.translate.$translateSanitization: Error cannot interpolate parameter due recursive object")}else c=[];return c.push(a),angular.forEach(a,function(a,e){angular.isFunction(a)||(d[e]=j(a,b,c))}),c.splice(-1,1),d}return angular.isNumber(a)?a:angular.isUndefined(a)||null===a?a:b(a)}}),angular.module("pascalprecht.translate").constant("pascalprechtTranslateOverrider",{}).provider("$translate",c),c.displayName="displayName",angular.module("pascalprecht.translate").factory("$translateDefaultInterpolation",d),d.displayName="$translateDefaultInterpolation",angular.module("pascalprecht.translate").constant("$STORAGE_KEY","NG_TRANSLATE_LANG_KEY"),angular.module("pascalprecht.translate").directive("translate",e),e.displayName="translateDirective",angular.module("pascalprecht.translate").directive("translateAttr",g),g.displayName="translateAttrDirective",angular.module("pascalprecht.translate").directive("translateCloak",i),i.displayName="translateCloakDirective",angular.module("pascalprecht.translate").directive("translateNamespace",j),j.displayName="translateNamespaceDirective",angular.module("pascalprecht.translate").directive("translateLanguage",k),k.displayName="translateLanguageDirective",angular.module("pascalprecht.translate").filter("translate",l),l.displayName="translateFilterFactory",angular.module("pascalprecht.translate").factory("$translationCache",m),m.displayName="$translationCache","pascalprecht.translate"}),function(a,b){"function"==typeof define&&define.amd?define([],function(){return b()}):"object"==typeof exports?module.exports=b():b()}(0,function(){function a(a,b){"use strict";return function(c){if(!c||!(angular.isArray(c.files)||angular.isString(c.prefix)&&angular.isString(c.suffix)))throw new Error("Couldn't load static files, no files and prefix or suffix specified!");c.files||(c.files=[{prefix:c.prefix,suffix:c.suffix}]);for(var e=[],f=c.files.length,g=0;g<f;g++)e.push(function(d){if(!d||!angular.isString(d.prefix)||!angular.isString(d.suffix))throw new Error("Couldn't load static file, no prefix or suffix specified!");var e=[d.prefix,c.key,d.suffix].join("");return angular.isObject(c.fileMap)&&c.fileMap[e]&&(e=c.fileMap[e]),b(angular.extend({url:e,method:"GET"},c.$http)).then(function(a){return a.data},function(){return a.reject(c.key)})}({prefix:c.files[g].prefix,key:c.key,suffix:c.files[g].suffix}));return a.all(e).then(function(a){for(var b=a.length,c={},d=0;d<b;d++)for(var e in a[d])c[e]=a[d][e];return c})}}return a.$inject=["a","b"],a.$inject=["$q","$http"],angular.module("pascalprecht.translate").factory("$translateStaticFilesLoader",a),a.displayName="$translateStaticFilesLoader","pascalprecht.translate"}),function(e,t){var n=e.createElement("style");if(e.getElementsByTagName("head")[0].appendChild(n),n.styleSheet)n.styleSheet.disabled||(n.styleSheet.cssText=t);else try{n.innerHTML=t}catch(e){n.innerText=t}}(document,"/**/\n.padding_zero {\n    padding: 0;\n}\n\n.ionic_datepicker_popup .font_bold {\n    font-weight: bold;\n}\n\n.ionic_datepicker_popup .padding_top_zero {\n    padding-top: 0;\n}\n\n.ionic_datepicker_popup .padding_left_5px {\n    padding-left: 5px;\n}\n\n.ionic_datepicker_popup .padding_right_5px {\n    padding-right: 5px;\n}\n\n.ionic_datepicker_popup .month_year_section {\n    padding: 5px 0;\n}\n\n.ionic_datepicker_popup .calendar_grid {\n    height: 215px;\n}\n\n.ionic_datepicker_popup .calendar_grid .weeks_row {\n    padding: 0;\n}\n\n.ionic_datepicker_popup .today {\n    border: 1px solid #009688;\n    border-radius: 50%;\n}\n\n.ionic_datepicker_popup .selected_date {\n    background-color: #009688;\n    border-radius: 50%;\n    color: #ffffff;\n    font-weight: bold;\n}\n\n.ionic_datepicker_popup .popup-head {\n    background-color: #009688;\n    display: none;\n}\n\n.ionic_datepicker_popup .popup-head .popup-title {\n    color: #ffffff;\n}\n\n.ionic_datepicker_popup .popup-head .popup-sub-title {\n    color: #ffffff;\n}\n\n.ionic_datepicker_popup .popup-body {\n    background-color: #ffffff;\n}\n\n.ionic_datepicker_popup .popup-body .selected_date_full {\n    background-color: #009688;\n    margin: -10px -10px 0 -10px;\n    height: 45px;\n    text-align: center;\n    font-weight: bold;\n    color: #ffffff;\n    line-height: 45px;\n    font-size: 18px;\n}\n\n.ionic_datepicker_popup .popup-body .select_section {\n    padding: 1px 5px;\n}\n\n.ionic_datepicker_popup .popup-body .pointer_events_none {\n    pointer-events: none;\n    color: #aaaaaa !important;\n}\n\n.ionic_datepicker_popup .popup-body .month_select, .ionic_datepicker_popup .popup-body .year_select {\n    border: none;\n    border-bottom: 1px solid #009688;\n    padding: 0;\n}\n\n.ionic_datepicker_popup .popup-body .month_select .input-label, .ionic_datepicker_popup .popup-body .year_select .input-label {\n    padding: 2px 0;\n    width: 0;\n}\n\n.ionic_datepicker_popup .popup-body .month_select select, .ionic_datepicker_popup .popup-body .year_select select {\n    left: 10px;\n    border: none;\n    padding: 0;\n}\n\n.ionic_datepicker_popup .popup-body .month_select:after, .ionic_datepicker_popup .popup-body .year_select:after {\n    right: 5px;\n    color: #009688;\n}\n\n.ionic_datepicker_popup .popup-body .show_nav {\n    padding: 5px 0 0 0;\n}\n\n.ionic_datepicker_popup .popup-body .show_nav .prev_btn_section {\n    padding: 5px 0;\n    text-align: left;\n}\n\n.ionic_datepicker_popup .popup-body .show_nav .prev_btn_section button {\n    padding: 0;\n}\n\n.ionic_datepicker_popup .popup-body .show_nav .next_btn_section {\n    padding: 5px 0;\n    text-align: right;\n}\n\n.ionic_datepicker_popup .popup-body .show_nav .next_btn_section button {\n    padding: 0;\n}\n\n.ionic_datepicker_popup .popup-body .button-clear {\n    color: #009688;\n}\n\n.ionic_datepicker_popup .popup-buttons {\n    padding: 0;\n    min-height: 45px;\n}\n\n.ionic_datepicker_popup .popup-buttons button {\n    background-color: #009688;\n    border-radius: 0;\n    margin-right: 1px;\n    color: #ffffff;\n}\n\n.ionic_datepicker_popup .row + .row {\n    padding: 0;\n}\n\n.ionic_datepicker_modal .header, .ionic_datepicker_modal .footer {\n    background-color: #009688;\n}\n\n.ionic_datepicker_modal .header .title, .ionic_datepicker_modal .header .button, .ionic_datepicker_modal .footer .title, .ionic_datepicker_modal .footer .button {\n    color: #ffffff;\n}\n\n.ionic_datepicker_modal .footer .button-block {\n    margin: 0;\n}\n\n.ionic_datepicker_modal .today {\n    border: 1px solid #009688;\n}\n\n.ionic_datepicker_modal .selected_date {\n    background-color: #009688;\n    color: #ffffff;\n    font-weight: bold;\n}\n\n.ionic_datepicker_modal .pointer_events_none {\n    pointer-events: none;\n    color: #aaaaaa !important;\n}\n\n.ionic_datepicker_modal .select_section {\n    padding: 1px 5px;\n}\n\n.ionic_datepicker_modal .button-clear {\n    color: #009688;\n}\n\n.ionic_datepicker_modal .month_select, .ionic_datepicker_modal .year_select {\n    border: none;\n    border-bottom: 1px solid #009688;\n    padding: 0;\n}\n\n.ionic_datepicker_modal .month_select .input-label, .ionic_datepicker_modal .year_select .input-label {\n    padding: 2px 0;\n    width: 0;\n}\n\n.ionic_datepicker_modal .month_select select, .ionic_datepicker_modal .year_select select {\n    left: 10px;\n    border: none;\n    padding: 0 10px;\n}\n\n.ionic_datepicker_modal .month_select:after, .ionic_datepicker_modal .year_select:after {\n    right: 5px;\n    color: #009688;\n}\n\n.ionic_datepicker_modal .padding_left_5px {\n    padding-left: 5px;\n}\n\n.ionic_datepicker_modal .padding_right_5px {\n    padding-right: 5px;\n}\n\n.ionic_datepicker_modal .date_col {\n    height: 50px;\n    line-height: 50px;\n}\n\n.ionic_datepicker_modal .font_bold {\n    font-weight: bold;\n}\n\n.ionic_datepicker_modal .font_22px {\n    font-size: 22px;\n}\n\n.platform-android .ionic_datepicker_modal .bar .title.title-left {\n    text-align: center;\n}\n\n.platform-android .ionic_datepicker_modal select {\n    left: 25%;\n}\n\n.platform-ios .ionic_datepicker_modal select {\n    left: 5%;\n}"),function(e){try{e=angular.module("ionic-datepicker.templates")}catch(t){e=angular.module("ionic-datepicker.templates",[])}e.run(["$templateCache",function(e){e.put("ionic-datepicker-modal.html",'<ion-modal-view class=ionic_datepicker_modal><ion-header-bar class=header><h1 class=title>{{mainObj.titleLabel || selctedDateEpoch | date : mainObj.dateFormat}}</h1></ion-header-bar><ion-content class=ionic_datepicker_modal_content><div><div class="row text-center"><div class="col col-10 left_arrow" ng-click=prevMonth()><button class="button-clear font_22px" ng-class="{\'pointer_events_none\':((firstDayEpoch - 86400000) < fromDate)}"><i class="icon ion-chevron-left"></i></button></div><div class="col col-80 text-center"><div class="row select_section"><div class="col col-50 padding_right_5px"><label class="item item-input item-select month_select"><span class=input-label>&nbsp;</span><select ng-model=data.currentMonth ng-change=monthChanged(data.currentMonth)><option ng-repeat="month in monthsList" ng-selected="month == data.currentMonthSelected" value={{month}}>{{month}}</option></select></label></div><div class="col col-50 padding_left_5px"><label class="item item-input item-select year_select"><span class=input-label>&nbsp;</span><select ng-model=data.currentYear ng-change=yearChanged(data.currentYear) ng-options="year for year in yearsList"></select></label></div></div></div><div class="col col-10 right_arrow" ng-click=nextMonth()><button class="button-clear font_22px" ng-class="{\'pointer_events_none\':((lastDayEpoch + 86400000)> toDate)}"><i class="icon ion-chevron-right"></i></button></div></div><div class=calendar_grid><div class="row padding-top weeks_row"><div class="col text-center font_bold" ng-repeat="weekName in weeksList track by $index" ng-bind=weekName></div></div><div><div class="row text-center padding_top_zero" ng-repeat="row in rows track by $index"><div class="col padding_zero date_col" ng-repeat="col in cols track by $index" ng-class="{\'selected_date\': (dayList[row + $index].epoch === selctedDateEpoch), \'today\' : (dayList[row + $index].epoch == today), \'pointer_events_none\':((disabledDates.indexOf(dayList[row + $index].epoch) >= 0) || (dayList[row + $index].disabled))}" ng-click="dateSelected(dayList[row + $index])"><div class=date_cell>{{dayList[row + col].date}}</div></div></div></div></div></div></ion-content><ion-footer-bar class=footer><div class="row padding_zero"><button class="button button-clear button-block button_set" ng-if=!mainObj.closeOnSelect ng-click=setIonicDatePickerDate()>{{mainObj.setLabel}}</button> <button class="button button-clear button-block button_today" ng-if=mainObj.showTodayButton ng-click=setIonicDatePickerTodayDate()>{{mainObj.todayLabel}}</button> <button class="button button-clear button-block button_close" ng-click=closeIonicDatePickerModal()>{{mainObj.closeLabel}}</button></div></ion-footer-bar></ion-modal-view>')}])}(),function(e){try{e=angular.module("ionic-datepicker.templates")}catch(t){e=angular.module("ionic-datepicker.templates",[])}e.run(["$templateCache",function(e){e.put("ionic-datepicker-popup.html",'<div class=selected_date_full>{{mainObj.titleLabel || selctedDateEpoch | date : mainObj.dateFormat}}</div><div class=date_selection><div class="row show_nav"><div class="col col-10 prev_btn_section col-center" ng-click=prevMonth()><button class=button-clear ng-class="{\'pointer_events_none\':((firstDayEpoch - 86400000) < fromDate)}"><i class="icon ion-chevron-left"></i></button></div><div class="col col-80 month_year_section text-center"><div class="row select_section"><div class="col col-50 padding_right_5px"><label class="item item-input item-select month_select"><span class=input-label>&nbsp;</span><select ng-model=data.currentMonth ng-change=monthChanged(data.currentMonth)><option ng-repeat="month in monthsList" ng-selected="month==data.currentMonthSelected" value={{month}}>{{month}}</option></select></label></div><div class="col col-50 padding_left_5px"><label class="item item-input item-select year_select"><span class=input-label>&nbsp;</span><select ng-model=data.currentYear ng-change=yearChanged(data.currentYear) ng-options="year for year in yearsList"></select></label></div></div></div><div class="col col-10 next_btn_section col-center" ng-click=nextMonth()><button class=button-clear ng-class="{\'pointer_events_none\':((lastDayEpoch + 86400000)> toDate)}"><i class="icon ion-chevron-right"></i></button></div></div><div class=calendar_grid><div class="row weeks_row"><div class="col text-center font_bold" ng-repeat="weekName in weeksList track by $index" ng-bind=weekName></div></div><div><div class="row text-center padding_zero" ng-repeat="row in rows track by $index"><div class="col no_padding date_col" ng-repeat="col in cols track by $index" ng-class="{\'selected_date\': (dayList[row + $index].epoch === selctedDateEpoch), \'today\' : (dayList[row + $index].epoch == today), \'pointer_events_none\':((disabledDates.indexOf(dayList[row + $index].epoch) >= 0) || dayList[row + $index].disabled)}" ng-click="dateSelected(dayList[row + $index])"><div class=date_cell>{{dayList[row + col].date}}</div></div></div></div></div></div>')}])}(),angular.module("ionic-datepicker",["ionic","ionic-datepicker.service","ionic-datepicker.provider","ionic-datepicker.templates"]),angular.module("ionic-datepicker.provider",[]).provider("ionicDatePicker",function(){var e={titleLabel:null,setLabel:"Set",todayLabel:"Today",closeLabel:"Close",inputDate:new Date,mondayFirst:!0,weeksList:["S","M","T","W","T","F","S"],monthsList:["Jan","Feb","March","April","May","June","July","Aug","Sept","Oct","Nov","Dec"],templateType:"popup",showTodayButton:!1,closeOnSelect:!1,disableWeekdays:[]};this.configDatePicker=function(t){angular.extend(e,t)},this.$get=["$rootScope","$ionicPopup","$ionicModal","IonicDatepickerService",function(t,n,a,o){function i(e){return e.setHours(0),e.setMinutes(0),e.setSeconds(0),e.setMilliseconds(0),e}function c(e){e.disabledDates&&0!==e.disabledDates.length?(u.disabledDates=[],angular.forEach(e.disabledDates,function(e,t){e=i(new Date(e)),u.disabledDates.push(e.getTime())})):u.disabledDates=[]}function d(e){e=i(e),u.currentDate=angular.copy(e);var t=new Date(e.getFullYear(),e.getMonth(),1).getDate(),n=new Date(e.getFullYear(),e.getMonth()+1,0).getDate();u.monthsList=[],u.mainObj.monthsList&&12===u.mainObj.monthsList.length?u.monthsList=u.mainObj.monthsList:u.monthsList=o.monthsList,u.yearsList=o.getYearsList(u.mainObj.from,u.mainObj.to),u.dayList=[];var a,c;u.firstDayEpoch=i(new Date(e.getFullYear(),e.getMonth(),t)).getTime(),u.lastDayEpoch=i(new Date(e.getFullYear(),e.getMonth(),n)).getTime();for(var d=t;d<=n;d++)a=new Date(e.getFullYear(),e.getMonth(),d),c=a.getTime()<u.fromDate||a.getTime()>u.toDate||u.mainObj.disableWeekdays.indexOf(a.getDay())>=0,u.dayList.push({date:a.getDate(),month:a.getMonth(),year:a.getFullYear(),day:a.getDay(),epoch:a.getTime(),disabled:c});var r=u.dayList[0].day-u.mainObj.mondayFirst;r=r<0?6:r;for(var l=0;l<r;l++)u.dayList.unshift({});u.rows=[0,7,14,21,28,35],u.cols=[0,1,2,3,4,5,6],u.data.currentMonth=u.mainObj.monthsList[e.getMonth()],u.data.currentYear=e.getFullYear(),u.data.currentMonthSelected=angular.copy(u.data.currentMonth),u.currentYearSelected=angular.copy(u.data.currentYear),u.numColumns=7}function r(e){u.mainObj=angular.copy(e),u.selctedDateEpoch=i(u.mainObj.inputDate).getTime(),u.mainObj.weeksList&&7===u.mainObj.weeksList.length?u.weeksList=u.mainObj.weeksList:u.weeksList=["S","M","T","W","T","F","S"],u.mainObj.mondayFirst&&u.weeksList.push(u.mainObj.weeksList.shift()),u.disableWeekdays=u.mainObj.disableWeekdays,d(u.mainObj.inputDate),c(u.mainObj)}function l(){u.modal.show()}function p(){u.modal.hide()}var s={},u=t.$new();u.today=i(new Date).getTime(),u.disabledDates=[],u.data={},u.prevMonth=function(){1===u.currentDate.getMonth()&&u.currentDate.setFullYear(u.currentDate.getFullYear()),u.currentDate.setMonth(u.currentDate.getMonth()-1),u.data.currentMonth=u.mainObj.monthsList[u.currentDate.getMonth()],u.data.currentYear=u.currentDate.getFullYear(),d(u.currentDate),_()},u.nextMonth=function(){11===u.currentDate.getMonth()&&u.currentDate.setFullYear(u.currentDate.getFullYear()),u.currentDate.setDate(1),u.currentDate.setMonth(u.currentDate.getMonth()+1),u.data.currentMonth=u.mainObj.monthsList[u.currentDate.getMonth()],u.data.currentYear=u.currentDate.getFullYear(),u.monthChanged(u.currentDate.getMonth()),d(new Date),_()};var _=function(){var e=new Date(u.selctedDateEpoch);e.setMonth(u.currentDate.getMonth()),e.setYear(u.currentDate.getFullYear()),u.selctedDateEpoch=e.getTime(),u.mainObj.callback(u.selctedDateEpoch)};return u.dateSelected=function(e){e&&0!==Object.keys(e).length&&(u.selctedDateEpoch=e.epoch,u.mainObj.closeOnSelect&&(u.mainObj.callback(u.selctedDateEpoch),"popup"==u.mainObj.templateType.toLowerCase()?u.popup.close():p()))},u.setIonicDatePickerTodayDate=function(){var e=new Date;d(new Date),u.selctedDateEpoch=i(e).getTime(),u.mainObj.closeOnSelect&&(u.mainObj.callback(u.selctedDateEpoch),p())},u.setIonicDatePickerDate=function(){u.mainObj.callback(u.selctedDateEpoch),p()},u.monthChanged=function(e){var t=u.monthsList.indexOf(e);u.currentDate.setMonth(t),d(u.currentDate),_()},u.yearChanged=function(e){u.currentDate.setFullYear(e),d(u.currentDate),_()},a.fromTemplateUrl("ionic-datepicker-modal.html",{scope:u,animation:"slide-in-up"}).then(function(e){u.modal=e}),u.$on("$destroy",function(){u.modal.remove()}),u.closeIonicDatePickerModal=function(){p()},s.openDatePicker=function(t){var a=[];delete u.fromDate,delete u.toDate,u.mainObj=angular.extend({},e,t),u.mainObj.from&&(u.fromDate=i(new Date(u.mainObj.from)).getTime()),u.mainObj.to&&(u.toDate=i(new Date(u.mainObj.to)).getTime()),t.disableWeekdays&&e.disableWeekdays&&(u.mainObj.disableWeekdays=t.disableWeekdays.concat(e.disableWeekdays)),r(u.mainObj),u.mainObj.closeOnSelect||(a=[{text:u.mainObj.setLabel,type:"button_set",onTap:function(e){u.mainObj.callback(u.selctedDateEpoch)}}]),u.mainObj.showTodayButton&&a.push({text:u.mainObj.todayLabel,type:"button_today",onTap:function(e){var t=new Date;d(new Date),u.selctedDateEpoch=i(t).getTime(),u.mainObj.closeOnSelect||e.preventDefault()}}),a.push({text:u.mainObj.closeLabel,type:"button_close",onTap:function(e){}}),"popup"==u.mainObj.templateType.toLowerCase()?u.popup=n.show({templateUrl:"ionic-datepicker-popup.html",scope:u,cssClass:"ionic_datepicker_popup",buttons:a}):l()},s}]}),angular.module("ionic-datepicker.service",[]).service("IonicDatepickerService",function(){this.monthsList=["January","February","March","April","May","June","July","August","September","October","November","December"],this.getYearsList=function(e,t){var n=[],a=1900,o=2100;a=e?new Date(e).getFullYear():a,o=t?new Date(t).getFullYear():o;for(var i=a;i<=o;i++)n.push(i);return n}}),function(i,e){var t=i.createElement("style");if(i.getElementsByTagName("head")[0].appendChild(t),t.styleSheet)t.styleSheet.disabled||(t.styleSheet.cssText=e);else try{t.innerHTML=e}catch(n){t.innerText=e}}(document,"/*\nTo customize the look and feel of Ionic, you can override the variables\nin ionic's _variables.scss file.\nFor example, you might change some of the default colors:\n*/\n.ionic_timepicker_popup .font_28px {\n  font-size: 28px;\n}\n.ionic_timepicker_popup .margin_zero {\n  margin: 0;\n}\n.ionic_timepicker_popup .padding_zero {\n  padding: 0;\n}\n.ionic_timepicker_popup .popup {\n  background-color: #ffffff;\n}\n.ionic_timepicker_popup .popup-head {\n  display: none;\n}\n.ionic_timepicker_popup .popup-body {\n  padding: 0;\n}\n.ionic_timepicker_popup .popup-buttons {\n  padding: 0;\n  min-height: 44px;\n  height: 44px;\n}\n.ionic_timepicker_popup .popup-buttons .button:not(:last-child) {\n  margin-right: 1px;\n}\n.ionic_timepicker_popup .padding_left_15px {\n  padding-left: 15px;\n}\n.ionic_timepicker_popup .heading {\n  height: 44px;\n  background-color: #009688;\n  color: #ffffff;\n  text-align: center;\n  line-height: 44px;\n  font-size: 18px;\n  font-weight: bold;\n}\n.ionic_timepicker_popup .time_picker_colon {\n  padding-top: 45px;\n  text-align: center;\n  font-weight: bold;\n}\n.ionic_timepicker_popup .time_picker_arrows {\n  width: 100%;\n}\n.ionic_timepicker_popup .time_picker_box_text {\n  height: 40px;\n  text-align: center;\n  border: 1px solid #dddddd;\n  font-size: 16px;\n  line-height: 38px;\n}\n.ionic_timepicker_popup .overflowShow {\n  white-space: normal !important;\n}\n.ionic_timepicker_popup .button_set, .ionic_timepicker_popup .button_close {\n  background-color: #009688;\n  color: #ffffff;\n}"),function(i){try{i=angular.module("ionic-timepicker.templates")}catch(e){i=angular.module("ionic-timepicker.templates",[])}i.run(["$templateCache",function(i){i.put("ionic-timepicker.html",'<div><div class=heading>{{time.hours}} : {{time.minutes}} <span ng-show="time.format == 12">{{time.meridian}}</span></div><div class=row ng-class="{\'padding_left_15px\':time.format == 12}"><div class="col col-25" ng-class="{\'col-offset-20 col-25\':time.format == 24}"><button type=button class="button button-clear button-small button-dark time_picker_arrows" ng-click=increaseHours()><i class="icon ion-chevron-up"></i></button><div ng-bind=time.hours class=time_picker_box_text></div><button type=button class="button button-clear button-small button-dark time_picker_arrows" ng-click=decreaseHours()><i class="icon ion-chevron-down"></i></button></div><label class="col col-10 time_picker_colon">:</label><div class="col col-25" ng-class="{\'col-25\':time.format == 24}"><button type=button class="button button-clear button-small button-dark time_picker_arrows" ng-click=increaseMinutes()><i class="icon ion-chevron-up"></i></button><div ng-bind=time.minutes class=time_picker_box_text></div><button type=button class="button button-clear button-small button-dark time_picker_arrows" ng-click=decreaseMinutes()><i class="icon ion-chevron-down"></i></button></div><label class="col col-10 time_picker_colon" ng-if="time.format == 12">:</label><div class="col col-25" ng-if="time.format == 12"><button type=button class="button button-clear button-small button-dark time_picker_arrows" ng-click=changeMeridian()><i class="icon ion-chevron-up"></i></button><div ng-bind=time.meridian class=time_picker_box_text></div><button type=button class="button button-clear button-small button-dark time_picker_arrows" ng-click=changeMeridian()><i class="icon ion-chevron-down"></i></button></div></div></div>')}])}(),angular.module("ionic-timepicker",["ionic-timepicker.provider","ionic-timepicker.templates"]),angular.module("ionic-timepicker.provider",[]).provider("ionicTimePicker",function(){var i={setLabel:"Set",closeLabel:"Close",inputTime:60*(new Date).getHours()*60+60*(new Date).getMinutes(),format:12,step:15};this.configTimePicker=function(e){angular.extend(i,e)},this.$get=["$rootScope","$ionicPopup",function(e,t){function o(i,e){r.time.hours=Math.floor(i/3600);var t=i%3600;12==e&&(r.time.hours>=12?(r.time.meridian="PM",r.time.hours>12&&(r.time.hours-=12)):r.time.meridian="AM"),0===r.time.hours&&(r.time.hours=12),r.time.minutes=t/60,r.time.hours=Math.floor(r.time.hours),r.time.minutes=Math.floor(r.time.minutes),1==r.time.hours.toString().length&&(r.time.hours="0"+r.time.hours),1==r.time.minutes.toString().length&&(r.time.minutes="0"+r.time.minutes),r.time.format=r.mainObj.format}var m={},r=e.$new();return r.today=function(i){return i.setHours(0),i.setMinutes(0),i.setSeconds(0),i.setMilliseconds(0),i}(new Date).getTime(),r.time={},r.increaseHours=function(){r.time.hours=Number(r.time.hours),12==r.mainObj.format&&(12!=r.time.hours?r.time.hours+=1:r.time.hours=1),24==r.mainObj.format&&(r.time.hours=(r.time.hours+1)%24),r.time.hours=r.time.hours<10?"0"+r.time.hours:r.time.hours},r.decreaseHours=function(){r.time.hours=Number(r.time.hours),12==r.mainObj.format&&(r.time.hours>1?r.time.hours-=1:r.time.hours=12),24==r.mainObj.format&&(r.time.hours=(r.time.hours+23)%24),r.time.hours=r.time.hours<10?"0"+r.time.hours:r.time.hours},r.increaseMinutes=function(){r.time.minutes=Number(r.time.minutes),r.time.minutes=(r.time.minutes+r.mainObj.step)%60,r.time.minutes=r.time.minutes<10?"0"+r.time.minutes:r.time.minutes},r.decreaseMinutes=function(){r.time.minutes=Number(r.time.minutes),r.time.minutes=(r.time.minutes+(60-r.mainObj.step))%60,r.time.minutes=r.time.minutes<10?"0"+r.time.minutes:r.time.minutes},r.changeMeridian=function(){r.time.meridian="AM"===r.time.meridian?"PM":"AM"},m.openTimePicker=function(e){var n=[];r.mainObj=angular.extend({},i,e),o(r.mainObj.inputTime,r.mainObj.format),n.push({text:r.mainObj.setLabel,type:"button_set",onTap:function(i){var e=0;12==r.time.format?(r.time.hours=Number(r.time.hours),"PM"==r.time.meridian&&12!=r.time.hours?r.time.hours+=12:"AM"==r.time.meridian&&12==r.time.hours&&(r.time.hours-=12),e=60*r.time.hours*60+60*r.time.minutes):e=60*r.time.hours*60+60*r.time.minutes,r.mainObj.callback(e)}}),n.push({text:r.mainObj.closeLabel,type:"button_close"}),r.popup=t.show({templateUrl:"ionic-timepicker.html",scope:r,cssClass:"ionic_timepicker_popup",buttons:n})},m}]});